<?php

	/* Include the required files */
	require_once( 'aom-config.php' );
	require_once( 'inc/pagetemplate.php' );
	require_once( 'inc/head.php' );
	require_once( 'inc/topmenu.php' );
	require_once( 'inc/functions.php' );
	require_once( 'dao/asys.module.php' );
	require_once( 'dao/asys.user.php' );
	require_once( 'dao/asys.account.php' );
	require_once( 'dao/asys.company.php' );
	require_once( 'dao/asys.userledger.php' );
	require_once( 'dao/asys.userpermission.php' );
	require_once( 'dao/asys.logindb.php' );
	require_once( 'dao/asys.masterdb.php' );
	require_once( 'dao/asys.genericdb.php' );
	require_once( 'dao/asys.companydb.php' );

	$tuser		=	new asys_users();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if($tuser->getUserStatus() < ADMIN_USER) {
		echo 'Only Admin Users can view/open this Page. <a href="home.php">Click here to go back.</a>';
		exit;
	}	
	
	
	$ldb			= new logindb();
	$mdb			= new masterdb();
	$gdb			= new genericdb();
	$cdb			= new companydb();
	
	
	$uid			= "";
	$cid			= "";
	
	$pagen		= "";
	$accl			= "";
	
	extract($_REQUEST);
	
	$pagen		= addslashes($pagen);
	$accl			= addslashes($accl);
	
	if($pagen == "update") {
		$uaDet	= $ldb->getUserLedgerDetail($uid);
		
		if($uaDet->getUserID() == "") {
			$uaDet->setUserID($uid);
			$uaDet->setAccounts($accl);
			$gdb->SaveObjectToDB($uaDet);
		} else {
			$paccl	= $uaDet->getAccounts();
			$arr1		= explode(",", $paccl);
			$arr2		= explode(",", $accl);
			$arr3		= array_unique(array_merge($arr1, $arr2), SORT_REGULAR);
			$acl		= implode(",", $arr3);
			$uaDet->setAccounts($acl);
			$gdb->UpdateObjectInDB($uaDet);
		}
	}
	
	$uid			= addslashes($uid);
	$cid			= (int)$cid;
	$usrDet		= $ldb->getUserDetail($uid);
	$cmpName	= $mdb->getCompanyNameByCompanyID($cid);
	
	$mainList	= $mdb->getMainAccountList($cid);
	$motList	= $mdb->getMotherAccountList($cid);
	
	$uaDet		= $ldb->getUserLedgerDetail($uid);
	$uacc			= $uaDet->getAccounts();
	$uacList	= explode(",", $uacc);

?>

<!DOCTYPE html>
<html>

<head>
	<meta http-equiv="Content-Type" content="text/html;charset=utf-8"/>
	<title>User Ledger Wise Access</title>
	<link href="css/asys.css" type=text/css rel=stylesheet />
	<script type="text/javascript" src="js/common.js"></script>
</head>

<body topmargin="20" bottommargin="30">

	<div style="height:5px;"></div>

	<table cellspacing="1" border="0" width="980px" align="center" bgcolor="#99BBE8">
		<tr><td bgcolor="#D6E3F3" class="td_normal_large red bold" style="padding:2px;">
			Ledger Access for user <?php echo $usrDet->getUserName()?> in Company - <?php echo $cmpName?>
		</td></tr>
		<tr>
			<td bgcolor="#ffffff" class="td_normal" style="padding:4px;">	
				<div class="td_normal_large bold" style="height:35px;">
					Main Ledgers
					<input type="checkbox" class="input" name="chkMain" id="chkMain" onChange="chgMain()" />
					<br /><hr />
				</div>
				<div style="height:200px;overflow:auto;">
					<input type="hidden" name="mainCnt" id="mainCnt" value="<?php echo count($mainList)?>" />
					<?php 
						for($i=0;$i<count($mainList);$i++) {
							$acls		= $mainList[$i];
							$chk		= "NO";
							if(in_array($acls->getAccountID(), $uacList))
								$chk	= "YES";
					?>
						<input type="checkbox" id="mchk<?php echo ($i+1)?>" name="mchk<?php echo ($i+1)?>" value="<?php echo $acls->getAccountID()?>" class="input" <?php if($chk == "YES") echo 'checked';?> />
						<?php echo $acls->getAccountName()?>
						<br />
					<?php } ?>
				</div>
			</td>
		</tr>
		
		
		<tr>
			<td bgcolor="#ffffff" class="td_normal" style="padding:4px;">	
				<div class="td_normal_large bold" style="height:35px;">
					Sub Ledgers
					<input type="checkbox" class="input" name="chkSub" id="chkSub" onChange="chgSub()" />
					<br /><hr />
				</div>
				<div style="height:250px;overflow:auto;">
					<input type="hidden" name="motCnt" id="motCnt" value="<?php echo count($motList)?>" />
					<?php 
						for($i=0;$i<count($motList);$i++) {
							$acls			= $motList[$i];
							$cldList	= $mdb->getChildAccountList($acls->getAccountID(), $cid);
					?>
						<input type="checkbox" id="motchk<?php echo ($i+1)?>" name="motchk<?php echo ($i+1)?>" value="<?php echo $acls->getAccountID()?>" class="input" onChange="chgMother(<?php echo ($i+1)?>)" />
						<font class="red bold"><?php echo $acls->getAccountName()?></font>
						<br />
						<input type="hidden" name="subCnt<?php echo ($i+1)?>" id="subCnt<?php echo ($i+1)?>" value="<?php echo count($cldList)?>" />
						
						<?php
							for($j=0;$j<count($cldList);$j++) {
								$acls			= $cldList[$j];
								$chk		= "NO";
								if(in_array($acls->getAccountID(), $uacList))
									$chk	= "YES";
						?>
							&nbsp;&nbsp;&nbsp;&nbsp;<input type="checkbox" id="<?php echo ($i+1)?>schk<?php echo ($j+1)?>" name="<?php echo ($i+1)?>schk<?php echo ($j+1)?>" value="<?php echo $acls->getAccountID()?>" class="input" <?php if($chk == "YES") echo 'checked';?> />
							<?php echo $acls->getAccountName()?>
							<br />						
						<?php } ?>
						
					<?php } ?>
				</div>
			</td>
		</tr>
		
		<tr style="height:1px" bgcolor="#99BBE8"><td></td></tr>
		<tr bgcolor="#D6E3F3">
			<td align="center">
				<input type="button" id="btnS" class="red_button" value="&nbsp;Save (S)&nbsp;" AccessKey="S" onClick="saveRec()">
			</td>
		</tr>		
		
	</table>
	
	<br />
	

</body>
</html>

<script language="javaScript">

	function chgMain() {
		var cnt	= EBD('mainCnt').value;
		var yn	= EBD('chkMain').checked;
		
		for(var i=1;i<=cnt;i++) {
			if(yn)
				EBD('mchk' + i).checked	= true;
			else
				EBD('mchk' + i).checked	= false;
		}
		
	}
	
	function chgMother(n) {
		var cnt	= EBD('subCnt' + n).value;
		var yn	= EBD('motchk' + n).checked;
		
		for(var i=1;i<=cnt;i++) {
			if(yn)
				EBD(n + 'schk' + i).checked	= true;
			else
				EBD(n + 'schk' + i).checked	= false;
		}		
	}
	
	function chgSub() {
		var cnt	= EBD('motCnt').value;
		var yn	= EBD('chkSub').checked;
		
		for(var i=1;i<=cnt;i++) {
			var scnt	= EBD('subCnt' + i).value
			
			for(var j=1;j<=scnt;j++) {
				if(yn)
					EBD(i + 'schk' + j).checked	= true;
				else
					EBD(i + 'schk' + j).checked	= false;
			}
		}	
	}
	
	function saveRec() {
		var acc		= "";
		var mcnt	= EBD('mainCnt').value;
		
		for(var i=1;i<=mcnt;i++) {

			if(EBD('mchk' + i).checked	== true) {
				if(acc != "") acc = acc + ",";
				acc = acc + EBD('mchk' + i).value;
			}

		}
			
		var cnt	= EBD('motCnt').value;
		for(var i=1;i<=cnt;i++) {
			var scnt	= EBD('subCnt' + i).value
			
			for(var j=1;j<=scnt;j++) {
			
				if(EBD(i + 'schk' + j).checked	== true) {
					if(acc != "") acc = acc + ",";
					acc = acc + EBD(i + 'schk' + j).value;
				}
			
			}
		}
		
		location = "accessLedger.php?cid=<?php echo $cid?>&uid=<?php echo $uid?>&pagen=update&accl=" + acc;
	}

</script>
