<?php

	/* Include the required files */
	require_once( 'aom-config.php' );
	require_once( 'inc/pagetemplate.php' );
	require_once( 'inc/head.php' );
	require_once( 'inc/topmenu.php' );
	require_once( 'inc/functions.php' );
	require_once( 'dao/asys.module.php' );
	require_once( 'dao/asys.user.php' );
	require_once( 'dao/asys.company.php' );
	require_once( 'dao/asys.userpermission.php' );
	require_once( 'dao/asys.logindb.php' );
	require_once( 'dao/asys.masterdb.php' );
	require_once( 'dao/asys.companydb.php' );

	$tuser		=	new asys_users();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if($tuser->getUserStatus() < ADMIN_USER) {
		echo 'Only Admin Users can view/open this Page. <a href="home.php">Click here to go back.</a>';
		exit;
	}	
	
	
	$ldb			= new logindb();
	$mdb			= new masterdb();
	$cdb			= new companydb();
	$usrList	= $ldb->getUserList();
	$cmpList	= $cdb->getCompanyList();
	
	$uid			= "";
	
	extract($_REQUEST);
	
	$uid			= addslashes($uid);
	$usrDet		= $ldb->getUserDetail($uid);

?>

<!DOCTYPE html>
<html>

<head>
	<meta http-equiv="Content-Type" content="text/html;charset=utf-8"/>
	<title>User Access Report</title>
	<link href="css/asys.css" type="text/css" rel="stylesheet">
</head>

<body topmargin="20" bottommargin="30">

	<br />

	<table cellspacing="1" border="0" width="980px" align="center" bgcolor="#99BBE8">
		<tr><td bgcolor="#D6E3F3" class="td_normal_large red bold" style="padding:2px;">
			Permission chart of <?php echo $usrDet->getUserName()?> for Generic modules (common to all Companies)
		</td></tr>
		<tr>
			<td bgcolor="#ffffff" class="td_normal" style="padding:4px;">	
				<table cellspacing="1" border="0" width="980px" align="center" bgcolor="#CCCCCC">
					<tr bgcolor="#E4E4E4">
						<td class="td_normal_large" align="left" width="580px">Module Name</td>
						<td class="td_normal_large" align="center" width="100px">Create</td>
						<td class="td_normal_large" align="center" width="100px">Edit</td>
						<td class="td_normal_large" align="center" width="100px">Delete</td>
						<td class="td_normal_large" align="center" width="100px">View</td>
					</tr>
					<?php 
						$cid			= 0;
						$modList	= $mdb->getCompanyWiseModuleList($cid);
						for($i=0;$i<count($modList);$i++) { 
							$mcls	=	$modList[$i];
					?>
					<tr bgcolor="#FFFFFF" style="height:25px;">
						<td class="td_normal">
							<?php echo $mcls->getModuleName()?> (<?php echo $mcls->getModuleType()?>)
						</td>
						<td title="<?php echo $mcls->getModuleName()?>" class="td_normal_large" align="center"><?php if($ldb->getCreatePermission($uid, $mcls->getModuleID(), $cid) == "YES") echo '<font class="green">&#10003;</font>'; else echo '<font class="red">&#10005;</font>' ?></td>
						<td title="<?php echo $mcls->getModuleName()?>" class="td_normal_large" align="center"><?php if($ldb->getEditPermission($uid, $mcls->getModuleID(), $cid) == "YES") echo '<font class="green">&#10003;</font>'; else echo '<font class="red">&#10005;</font>' ?></td>
						<td title="<?php echo $mcls->getModuleName()?>" class="td_normal_large" align="center"><?php if($ldb->getDeletePermission($uid, $mcls->getModuleID(), $cid) == "YES") echo '<font class="green">&#10003;</font>'; else echo '<font class="red">&#10005;</font>' ?></td>
						<td title="<?php echo $mcls->getModuleName()?>" class="td_normal_large" align="center"><?php if($ldb->getViewPermission($uid, $mcls->getModuleID(), $cid) == "YES") echo '<font class="green">&#10003;</font>'; else echo '<font class="red">&#10005;</font>' ?></td>
					</tr>					
					<?php } ?>
					
				</table>
			</td>
		</tr>
	</table>
	
	<br />
	
	<?php
		for($j=0;$j<count($cmpList);$j++) { 
			$cmpDet	=	$cmpList[$j];
			$cid		= $cmpDet->getCompanyID();
	?>
	<table cellspacing="1" border="0" width="980px" align="center" bgcolor="#99BBE8">
		<tr><td bgcolor="#D6E3F3" class="td_normal_large red bold" style="padding:2px;">
			Permission chart of <?php echo $usrDet->getUserName()?> for <?php echo $cmpDet->getCompanyName(); ?>
		</td></tr>
		<tr>
			<td bgcolor="#ffffff" class="td_normal" style="padding:4px;">	
				<table cellspacing="1" border="0" width="980px" align="center" bgcolor="#CCCCCC">
					<tr bgcolor="#E4E4E4">
						<td class="td_normal_large" align="left" width="580px">Module Name</td>
						<td class="td_normal_large" align="center" width="100px">Create</td>
						<td class="td_normal_large" align="center" width="100px">Edit</td>
						<td class="td_normal_large" align="center" width="100px">Delete</td>
						<td class="td_normal_large" align="center" width="100px">View</td>
					</tr>
					<?php 
						$modList	= $mdb->getCompanyWiseModuleList($cid);
						for($i=0;$i<count($modList);$i++) { 
							$mcls	=	$modList[$i];
					?>
					<tr bgcolor="#FFFFFF" style="height:25px;">
						<td class="td_normal">
							<?php echo $mcls->getModuleName()?> (<?php echo $mcls->getModuleType()?>)
						</td>
						<td title="<?php echo $mcls->getModuleName()?>" class="td_normal_large" align="center"><?php if($ldb->getCreatePermission($uid, $mcls->getModuleID(), $cid) == "YES") echo '<font class="green">&#10003;</font>'; else echo '<font class="red">&#10005;</font>' ?></td>
						<td title="<?php echo $mcls->getModuleName()?>" class="td_normal_large" align="center"><?php if($ldb->getEditPermission($uid, $mcls->getModuleID(), $cid) == "YES") echo '<font class="green">&#10003;</font>'; else echo '<font class="red">&#10005;</font>' ?></td>
						<td title="<?php echo $mcls->getModuleName()?>" class="td_normal_large" align="center"><?php if($ldb->getDeletePermission($uid, $mcls->getModuleID(), $cid) == "YES") echo '<font class="green">&#10003;</font>'; else echo '<font class="red">&#10005;</font>' ?></td>
						<td title="<?php echo $mcls->getModuleName()?>" class="td_normal_large" align="center"><?php if($ldb->getViewPermission($uid, $mcls->getModuleID(), $cid) == "YES") echo '<font class="green">&#10003;</font>'; else echo '<font class="red">&#10005;</font>' ?></td>
					</tr>					
					<?php } ?>
					
				</table>
			</td>
		</tr>
	</table>
	
	<br />	
	<?php } ?>

</body>
</html>