<?php

	require_once( 'aom-config.php' );
	require_once( 'inc/pagetemplate.php' );
	require_once( 'inc/head.php' );
	require_once( 'inc/topmenu.php' );
	require_once( 'inc/functions.php' );
	require_once( 'dao/asys.user.php' );
	require_once( 'dao/asys.company.php' );
	require_once( 'dao/asys.logindb.php' );
	require_once( 'dao/asys.genericdb.php' );
	require_once( 'dao/asys.log.php' );

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}	

	$ldb				=	new logindb();
	$gdb				=	new genericdb();

	$msg			=	"";
	$epwd			=	"";
	$npwd			=	"";
	$rpwd			=	"";
	$process	=	"";
	$pc				=	"";

	extract($_REQUEST);

	if($process == "cpwd") {
		$lstat	= $ldb->verifyUser($tuser->getUserID(), $epwd);
		if($lstat != 1)
			$msg	=	$msg."Current password do not match, try again";
		if(strlen($npwd) < 6)
			$msg	=	$msg."<br />Password too small, use at least 6 characters";
		if($rpwd != $npwd)
			$msg	=	$msg."<br />Please re-type password properly";

		if($msg == "") {
			if($ldb->updatePassword($tuser->getUserID(),$npwd)){
				$log	=	new asys_user_log();
				$log->setLogID($gdb->getNextID("asys_user_log", "LogID"));
				$log->setUserID($tuser->getUserID());
				$log->setActivity("Password Changed for User - ".$tuser->getUserID());
				$log->setClassName('asys_users');
				$log->setModuleSnapshot(serialize($tuser));
				$gdb->SaveObjectToDB($log);
				$msg	=	5;
			} else {
				$msg	=	"Fail to change password";
			}
		}
	}


	$iPage	=	new asys_pages(APP_TITLE);
	$iPage->startPage();
	$iPage->startHeader();
	$iPage->addLink("css/asys.css");
	$iPage->addLink("css/menu.css");
	$iPage->addScript("js/common.js");	
	$iPage->endHeader();
	$iPage->startBody();
	
	
	if($tcmp->getCompanyID() > 0) {
		outputHeader($tuser, $tcmp);
		outputMenu($tuser);	
	} else {
		outputHeader($tuser, '');
		include('inc/menuHome.php');
	}

?>

	<div id="pagehead">&nbsp;CHANGE PASSWORD</div><div>&nbsp;</div>

	<?php if($msg != "" && $msg != 5) { ?>
		<div class="td_error"><?php echo $msg?></div><br /><br />
	<?php } ?>

	<div class="loginbox">
		<div style="text-align:right;height:45px;"><img src="images/keys.gif" /><br /></div>
		<form id="hFrm" action="cpwd.php" method="post">
		<input type="hidden" name="process" value="cpwd" />
		<table style="border:0px;" cellpadding="2" cellspacing="0" align="center">
			<tr>
				<td class="td_normal">Current Password</td>
				<td class="td_normal">:</td>
				<td><input class="input" type="password" name="epwd" id="epwd" value="" onFocus="this.className='input_focus'" onBlur="this.className='input'" />&nbsp;&nbsp;</td>
			</tr>
			<tr>
				<td class="td_normal">New Password</td>
				<td class="td_normal">:</td>
				<td><input class="input" type="password" name="npwd" id="npwd" value="" onFocus="this.className='input_focus'" onBlur="this.className='input'" />&nbsp;&nbsp;</td>
			</tr>
			<tr>
				<td class="td_normal">Retype Password</td>
				<td class="td_normal">:</td>
				<td><input class="input" type="password" name="rpwd" id="rpwd" value="" onFocus="this.className='input_focus'" onBlur="this.className='input'" />&nbsp;&nbsp;</td>
			</tr>
			<tr style="height:10px;"><td></td></tr>
			<tr>
				<td colspan="3" align="center">
					<input type="button" value=" Update &raquo; " class="red_button"  onClick="submitForm('hFrm')" />
				</td>
			</tr>
			<tr><td></td></tr>
		</table>
		</form>

	</div>

<?php

	$iPage->endBody();
	$iPage->endPage();

?>

<script language="javaScript">

	var msg	=	"<?php echo $msg?>";

	window.onload	=	function() {
		if(msg == "5") {
			alert("Password changed, please re-login");
			location	=	"logout.php";
		}
		EBD('epwd').focus();
	};

</script>