<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Oct 02, 2017
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class asys_accounts {
		/**
		 * @Field		AccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $AccountID = 0;

		/**
		 * @Field		CompanyID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyID = 0;

		/**
		 * @Field		CompanyName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyName = "";

		/**
		 * @Field		GroupID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $GroupID = 0;

		/**
		 * @Field		GroupName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $GroupName = "";

		/**
		 * @Field		BGID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $BGID = 0;

		/**
		 * @Field		BGName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $BGName = "";

		/**
		 * @Field		SubgroupID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $SubgroupID = 0;

		/**
		 * @Field		SubgroupName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $SubgroupName = "";

		/**
		 * @Field		MotherAccount
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $MotherAccount = 0;
		
		/**
		 * @Field		MotherAccountName
		 * @Type		varchar(200)
		 * @Access	Protected
		 */
		protected $MotherAccountName = "";		

		/**
		 * @Field		ContainsSubLedger
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $ContainsSubLedger = "NO";

		/**
		 * @Field		AccountName
		 * @Type		varchar(250)
		 * @Access	Protected
		 */
		protected $AccountName = "";

		/**
		 * @Field		PrnName
		 * @Type		varchar(250)
		 * @Access	Protected
		 */
		protected $PrnName = "";

		/**
		 * @Field		Address1
		 * @Type		varchar(200)
		 * @Access	Protected
		 */
		protected $Address1 = "";

		/**
		 * @Field		Address2
		 * @Type		varchar(200)
		 * @Access	Protected
		 */
		protected $Address2 = "";

		/**
		 * @Field		City
		 * @Type		varchar(40)
		 * @Access	Protected
		 */
		protected $City = "";

		/**
		 * @Field		PIN
		 * @Type		varchar(6)
		 * @Access	Protected
		 */
		protected $PIN = "";

		/**
		 * @Field		State
		 * @Type		varchar(30)
		 * @Access	Protected
		 */
		protected $State = "";

		/**
		 * @Field		Country
		 * @Type		varchar(50)
		 * @Access	Protected
		 */
		protected $Country = "";

		/**
		 * @Field		Phone
		 * @Type		varchar(30)
		 * @Access	Protected
		 */
		protected $Phone = "";

		/**
		 * @Field		Mobile
		 * @Type		varchar(30)
		 * @Access	Protected
		 */
		protected $Mobile = "";

		/**
		 * @Field		AlternateMobile
		 * @Type		varchar(30)
		 * @Access	Protected
		 */
		protected $AlternateMobile = "";

		/**
		 * @Field		Email
		 * @Type		varchar(45)
		 * @Access	Protected
		 */
		protected $Email = "";

		/**
		 * @Field		AlternateEmail
		 * @Type		varchar(100)
		 * @Access	Protected
		 */
		protected $AlternateEmail = "";

		/**
		 * @Field		PAN
		 * @Type		varchar(20)
		 * @Access	Protected
		 */
		protected $PAN = "";

		/**
		 * @Field		GST
		 * @Type		varchar(30)
		 * @Access	Protected
		 */
		protected $GST = "";

		/**
		 * @Field		SEZ
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $SEZ = "NO";

		/**
		 * @Field		CompScheme
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $CompScheme = "NO";

		/**
		 * @Field		DeemedExporter
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $DeemedExporter = "NO";

		/**
		 * @Field		OBalType
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $OBalType = 0;

		/**
		 * @Field		OBal
		 * @Type		double
		 * @Access	Protected
		 */
		protected $OBal = 0;

		/**
		 * @Field		CreditLimit
		 * @Type		double
		 * @Access	Protected
		 */
		protected $CreditLimit = 0;

		/**
		 * @Field		Remarks
		 * @Type		text
		 * @Access	Protected
		 */
		protected $Remarks = "";

		/**
		 * @Field		RelateToBill
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $RelateToBill = "NO";
		
		/**
		 * @Field		UIN
		 * @Type		varchar(30)
		 * @Access	Protected
		 */
		protected $UIN = "";		

		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->AccountID = (int)$this->AccountID;
			$this->CompanyID = (int)$this->CompanyID;
			$this->GroupID = (int)$this->GroupID;
			$this->BGID = (int)$this->BGID;
			$this->SubgroupID = (int)$this->SubgroupID;
			$this->MotherAccount = (int)$this->MotherAccount;
			$this->ContainsSubLedger = addslashes($this->ContainsSubLedger);
			$this->AccountName = addslashes($this->AccountName);
			$this->PrnName = addslashes($this->PrnName);
			$this->Address1 = addslashes($this->Address1);
			$this->Address2 = addslashes($this->Address2);
			$this->City = addslashes($this->City);
			$this->PIN = addslashes($this->PIN);
			$this->State = addslashes($this->State);
			$this->Country = addslashes($this->Country);
			$this->Phone = addslashes($this->Phone);
			$this->Mobile = addslashes($this->Mobile);
			$this->AlternateMobile = addslashes($this->AlternateMobile);
			$this->Email = addslashes($this->Email);
			$this->AlternateEmail = addslashes($this->AlternateEmail);
			$this->PAN = addslashes($this->PAN);
			$this->GST = addslashes($this->GST);
			$this->SEZ = addslashes($this->SEZ);
			$this->CompScheme = addslashes($this->CompScheme);
			$this->DeemedExporter = addslashes($this->DeemedExporter);
			$this->OBalType = (int)$this->OBalType;
			$this->OBal = (double)$this->OBal;
			$this->CreditLimit = (double)$this->CreditLimit;
			$this->Remarks = addslashes($this->Remarks);
			$this->RelateToBill = addslashes($this->RelateToBill);
			$this->UIN = addslashes($this->UIN);
		}

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->AccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->AccountID;
			} else {
				return $this->AccountID;
			}
		}

		public function getCompanyID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CompanyID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CompanyID;
			} else {
				return $this->CompanyID;
			}
		}

		public function getCompanyName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CompanyName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CompanyName;
			} else {
				return stripslashes($this->CompanyName);
			}
		}

		public function getGroupID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->GroupID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->GroupID;
			} else {
				return $this->GroupID;
			}
		}

		public function getGroupName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->GroupName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->GroupName;
			} else {
				return stripslashes($this->GroupName);
			}
		}

		public function getBGID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->BGID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->BGID;
			} else {
				return $this->BGID;
			}
		}

		public function getBGName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->BGName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->BGName;
			} else {
				return stripslashes($this->BGName);
			}
		}

		public function getSubgroupID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->SubgroupID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->SubgroupID;
			} else {
				return $this->SubgroupID;
			}
		}

		public function getSubgroupName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->SubgroupName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->SubgroupName;
			} else {
				return stripslashes($this->SubgroupName);
			}
		}

		public function getMotherAccount($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->MotherAccount,2,'.',',');
			} else if($formatted=='asis') {
				return $this->MotherAccount;
			} else {
				return $this->MotherAccount;
			}
		}
		
		public function getMotherAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->MotherAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->MotherAccountName;
			} else {
				return stripslashes($this->MotherAccountName);
			}
		}		

		public function getContainsSubLedger($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ContainsSubLedger),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ContainsSubLedger;
			} else {
				return stripslashes($this->ContainsSubLedger);
			}
		}

		public function getAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->AccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->AccountName;
			} else {
				return stripslashes($this->AccountName);
			}
		}

		public function getPrnName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->PrnName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->PrnName;
			} else {
				return stripslashes($this->PrnName);
			}
		}

		public function getAddress1($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Address1),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Address1;
			} else {
				return stripslashes($this->Address1);
			}
		}

		public function getAddress2($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Address2),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Address2;
			} else {
				return stripslashes($this->Address2);
			}
		}

		public function getCity($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->City),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->City;
			} else {
				return stripslashes($this->City);
			}
		}

		public function getPIN($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->PIN),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->PIN;
			} else {
				return stripslashes($this->PIN);
			}
		}

		public function getState($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->State),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->State;
			} else {
				return stripslashes($this->State);
			}
		}

		public function getCountry($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Country),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Country;
			} else {
				return stripslashes($this->Country);
			}
		}

		public function getPhone($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Phone),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Phone;
			} else {
				return stripslashes($this->Phone);
			}
		}

		public function getMobile($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Mobile),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Mobile;
			} else {
				return stripslashes($this->Mobile);
			}
		}

		public function getAlternateMobile($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->AlternateMobile),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->AlternateMobile;
			} else {
				return stripslashes($this->AlternateMobile);
			}
		}

		public function getEmail($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Email),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Email;
			} else {
				return stripslashes($this->Email);
			}
		}

		public function getAlternateEmail($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->AlternateEmail),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->AlternateEmail;
			} else {
				return stripslashes($this->AlternateEmail);
			}
		}

		public function getPAN($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->PAN),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->PAN;
			} else {
				return stripslashes($this->PAN);
			}
		}

		public function getGST($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->GST),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->GST;
			} else {
				return stripslashes($this->GST);
			}
		}

		public function getSEZ($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->SEZ),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->SEZ;
			} else {
				return stripslashes($this->SEZ);
			}
		}

		public function getCompScheme($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CompScheme),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CompScheme;
			} else {
				return stripslashes($this->CompScheme);
			}
		}

		public function getDeemedExporter($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DeemedExporter),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DeemedExporter;
			} else {
				return stripslashes($this->DeemedExporter);
			}
		}

		public function getOBalType($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->OBalType,2,'.',',');
			} else if($formatted=='asis') {
				return $this->OBalType;
			} else {
				return $this->OBalType;
			}
		}

		public function getOBal($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->OBal,2,'.',',');
			} else if($formatted=='asis') {
				return $this->OBal;
			} else {
				return $this->OBal;
			}
		}

		public function getCreditLimit($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CreditLimit,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CreditLimit;
			} else {
				return $this->CreditLimit;
			}
		}

		public function getRemarks($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Remarks),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Remarks;
			} else {
				return stripslashes($this->Remarks);
			}
		}

		public function getRelateToBill($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->RelateToBill),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->RelateToBill;
			} else {
				return stripslashes($this->RelateToBill);
			}
		}
		
		public function getUIN($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->UIN),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->UIN;
			} else {
				return stripslashes($this->UIN);
			}
		}		

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setAccountID($arg) {
			$this->AccountID = (int)$arg;
		}

		public function setCompanyID($arg) {
			$this->CompanyID = (int)$arg;
		}

		public function setCompanyName($arg) {
			$this->CompanyName = addslashes($arg);
		}

		public function setGroupID($arg) {
			$this->GroupID = (int)$arg;
		}

		public function setGroupName($arg) {
			$this->GroupName = addslashes($arg);
		}

		public function setBGID($arg) {
			$this->BGID = (int)$arg;
		}

		public function setBGName($arg) {
			$this->BGName = addslashes($arg);
		}

		public function setSubgroupID($arg) {
			$this->SubgroupID = (int)$arg;
		}

		public function setSubgroupName($arg) {
			$this->SubgroupName = addslashes($arg);
		}

		public function setMotherAccount($arg) {
			$this->MotherAccount = (int)$arg;
		}
		
		public function setMotherAccountName($arg) {
			$this->MotherAccountName = addslashes($arg);
		}		

		public function setContainsSubLedger($arg) {
			$this->ContainsSubLedger = addslashes($arg);
		}

		public function setAccountName($arg) {
			$this->AccountName = addslashes($arg);
		}

		public function setPrnName($arg) {
			$this->PrnName = addslashes($arg);
		}

		public function setAddress1($arg) {
			$this->Address1 = addslashes($arg);
		}

		public function setAddress2($arg) {
			$this->Address2 = addslashes($arg);
		}

		public function setCity($arg) {
			$this->City = addslashes($arg);
		}

		public function setPIN($arg) {
			$this->PIN = addslashes($arg);
		}

		public function setState($arg) {
			$this->State = addslashes($arg);
		}

		public function setCountry($arg) {
			$this->Country = addslashes($arg);
		}

		public function setPhone($arg) {
			$this->Phone = addslashes($arg);
		}

		public function setMobile($arg) {
			$this->Mobile = addslashes($arg);
		}

		public function setAlternateMobile($arg) {
			$this->AlternateMobile = addslashes($arg);
		}

		public function setEmail($arg) {
			$this->Email = addslashes($arg);
		}

		public function setAlternateEmail($arg) {
			$this->AlternateEmail = addslashes($arg);
		}

		public function setPAN($arg) {
			$this->PAN = addslashes($arg);
		}

		public function setGST($arg) {
			$this->GST = addslashes($arg);
		}

		public function setSEZ($arg) {
			$this->SEZ = addslashes($arg);
		}

		public function setCompScheme($arg) {
			$this->CompScheme = addslashes($arg);
		}

		public function setDeemedExporter($arg) {
			$this->DeemedExporter = addslashes($arg);
		}

		public function setOBalType($arg) {
			$this->OBalType = (int)$arg;
		}

		public function setOBal($arg) {
			$this->OBal = (double)$arg;
		}

		public function setCreditLimit($arg) {
			$this->CreditLimit = (double)$arg;
		}

		public function setRemarks($arg) {
			$this->Remarks = addslashes($arg);
		}

		public function setRelateToBill($arg) {
			$this->RelateToBill = addslashes($arg);
		}
		
		public function setUIN($arg) {
			$this->UIN = addslashes($arg);
		}		

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `asys_accounts` (`AccountID`, `CompanyID`, `GroupID`, `BGID`, `SubgroupID`, `MotherAccount`, `ContainsSubLedger`, `AccountName`, `PrnName`, `Address1`, `Address2`, `City`, `PIN`, `State`, `Country`, `Phone`, `Mobile`, `AlternateMobile`, `Email`, `AlternateEmail`, `PAN`, `GST`, `SEZ`, `CompScheme`, `DeemedExporter`, `OBalType`, `OBal`, `CreditLimit`, `Remarks`, `RelateToBill`, `UIN`) VALUES(";
			$sql	=	$sql."'".$this->getAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."'".$this->getGroupID('asis')."', ";
			$sql	=	$sql."'".$this->getBGID('asis')."', ";
			$sql	=	$sql."'".$this->getSubgroupID('asis')."', ";
			$sql	=	$sql."'".$this->getMotherAccount('asis')."', ";
			$sql	=	$sql."'".$this->getContainsSubLedger('asis')."', ";
			$sql	=	$sql."'".$this->getAccountName('asis')."', ";
			$sql	=	$sql."'".$this->getPrnName('asis')."', ";
			$sql	=	$sql."'".$this->getAddress1('asis')."', ";
			$sql	=	$sql."'".$this->getAddress2('asis')."', ";
			$sql	=	$sql."'".$this->getCity('asis')."', ";
			$sql	=	$sql."'".$this->getPIN('asis')."', ";
			$sql	=	$sql."'".$this->getState('asis')."', ";
			$sql	=	$sql."'".$this->getCountry('asis')."', ";
			$sql	=	$sql."'".$this->getPhone('asis')."', ";
			$sql	=	$sql."'".$this->getMobile('asis')."', ";
			$sql	=	$sql."'".$this->getAlternateMobile('asis')."', ";
			$sql	=	$sql."'".$this->getEmail('asis')."', ";
			$sql	=	$sql."'".$this->getAlternateEmail('asis')."', ";
			$sql	=	$sql."'".$this->getPAN('asis')."', ";
			$sql	=	$sql."'".$this->getGST('asis')."', ";
			$sql	=	$sql."'".$this->getSEZ('asis')."', ";
			$sql	=	$sql."'".$this->getCompScheme('asis')."', ";
			$sql	=	$sql."'".$this->getDeemedExporter('asis')."', ";
			$sql	=	$sql."'".$this->getOBalType('asis')."', ";
			$sql	=	$sql."'".$this->getOBal('asis')."', ";
			$sql	=	$sql."'".$this->getCreditLimit('asis')."', ";
			$sql	=	$sql."'".$this->getRemarks('asis')."', ";
			$sql	=	$sql."'".$this->getRelateToBill('asis')."', ";
			$sql	=	$sql."'".$this->getUIN('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `asys_accounts` SET ";
			$sql	=	$sql."`CompanyID` = '".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."`GroupID` = '".$this->getGroupID('asis')."', ";
			$sql	=	$sql."`BGID` = '".$this->getBGID('asis')."', ";
			$sql	=	$sql."`SubgroupID` = '".$this->getSubgroupID('asis')."', ";
			$sql	=	$sql."`MotherAccount` = '".$this->getMotherAccount('asis')."', ";
			$sql	=	$sql."`ContainsSubLedger` = '".$this->getContainsSubLedger('asis')."', ";
			$sql	=	$sql."`AccountName` = '".$this->getAccountName('asis')."', ";
			$sql	=	$sql."`PrnName` = '".$this->getPrnName('asis')."', ";
			$sql	=	$sql."`Address1` = '".$this->getAddress1('asis')."', ";
			$sql	=	$sql."`Address2` = '".$this->getAddress2('asis')."', ";
			$sql	=	$sql."`City` = '".$this->getCity('asis')."', ";
			$sql	=	$sql."`PIN` = '".$this->getPIN('asis')."', ";
			$sql	=	$sql."`State` = '".$this->getState('asis')."', ";
			$sql	=	$sql."`Country` = '".$this->getCountry('asis')."', ";
			$sql	=	$sql."`Phone` = '".$this->getPhone('asis')."', ";
			$sql	=	$sql."`Mobile` = '".$this->getMobile('asis')."', ";
			$sql	=	$sql."`AlternateMobile` = '".$this->getAlternateMobile('asis')."', ";
			$sql	=	$sql."`Email` = '".$this->getEmail('asis')."', ";
			$sql	=	$sql."`AlternateEmail` = '".$this->getAlternateEmail('asis')."', ";
			$sql	=	$sql."`PAN` = '".$this->getPAN('asis')."', ";
			$sql	=	$sql."`GST` = '".$this->getGST('asis')."', ";
			$sql	=	$sql."`SEZ` = '".$this->getSEZ('asis')."', ";
			$sql	=	$sql."`CompScheme` = '".$this->getCompScheme('asis')."', ";
			$sql	=	$sql."`DeemedExporter` = '".$this->getDeemedExporter('asis')."', ";
			$sql	=	$sql."`OBalType` = '".$this->getOBalType('asis')."', ";
			$sql	=	$sql."`OBal` = '".$this->getOBal('asis')."', ";
			$sql	=	$sql."`CreditLimit` = '".$this->getCreditLimit('asis')."', ";
			$sql	=	$sql."`Remarks` = '".$this->getRemarks('asis')."', ";
			$sql	=	$sql."`RelateToBill` = '".$this->getRelateToBill('asis')."', ";
			$sql	=	$sql."`UIN` = '".$this->getUIN('asis')."' ";
			$sql	=	$sql." WHERE `AccountID` = '".$this->getAccountID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `asys_accounts` ";
			$sql	=	$sql." WHERE `AccountID` = '".$this->getAccountID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$AccountID <= 0) $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">Account#</div>
				<div style="float:left;">: '.$this->getAccountID().'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Company</div>
				<div style="float:left;">: '.$this->getCompanyName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Group</div>
				<div style="float:left;">: '.$this->getGroupName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Base Group</div>
				<div style="float:left;">: '.$this->getBGName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Subgroup</div>
				<div style="float:left;">: '.$this->getSubgroupName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Mother Account</div>
				<div style="float:left;">: '.$this->getMotherAccountName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Contains SubLedger</div>
				<div style="float:left;">: '.$this->getContainsSubLedger('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Account Name</div>
				<div style="float:left;">: '.$this->getAccountName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Printable Name</div>
				<div style="float:left;">: '.$this->getPrnName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Address 1</div>
				<div style="float:left;">: '.$this->getAddress1('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Address 2</div>
				<div style="float:left;">: '.$this->getAddress2('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">City</div>
				<div style="float:left;">: '.$this->getCity('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">PIN</div>
				<div style="float:left;">: '.$this->getPIN('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">State</div>
				<div style="float:left;">: '.$this->getState('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Country</div>
				<div style="float:left;">: '.$this->getCountry('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Phone</div>
				<div style="float:left;">: '.$this->getPhone('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Mobile</div>
				<div style="float:left;">: '.$this->getMobile('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Alternate Mobile</div>
				<div style="float:left;">: '.$this->getAlternateMobile('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Email</div>
				<div style="float:left;">: '.$this->getEmail('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Alternate Email</div>
				<div style="float:left;">: '.$this->getAlternateEmail('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">PAN</div>
				<div style="float:left;">: '.$this->getPAN('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">GST</div>
				<div style="float:left;">: '.$this->getGST('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Under SEZ</div>
				<div style="float:left;">: '.$this->getSEZ('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Under Comp Scheme</div>
				<div style="float:left;">: '.$this->getCompScheme('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Deemed Exporter?</div>
				<div style="float:left;">: '.$this->getDeemedExporter('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Opening Bal Type</div>
				<div style="float:left;">: '.$this->getOBalType('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Opening Bal</div>
				<div style="float:left;">: '.$this->getOBal('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Credit Limit</div>
				<div style="float:left;">: '.$this->getCreditLimit('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Remarks</div>
				<div style="float:left;">: '.$this->getRemarks('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Relate To Bill?</div>
				<div style="float:left;">: '.$this->getRelateToBill('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">UIN</div>
				<div style="float:left;">: '.$this->getUIN('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>