<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Oct 25, 2014
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class asys_adminusers {
		/**
		 * @Field		UserID
		 * @Type		varchar(60)
		 * @Access	Protected
		 */
		protected $UserID = "";

		/**
		 * @Field		Password
		 * @Type		varchar(60)
		 * @Access	Protected
		 */
		protected $Password = "";

		/**
		 * @Field		UserName
		 * @Type		varchar(200)
		 * @Access	Protected
		 */
		protected $UserName = "";

		/**
		 * @Field		UserStatus
		 * @Type		tinyint(4)
		 * @Access	Protected
		 */
		protected $UserStatus = 0;

		/**
		 * @Field		Created
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $Created = 0;

		/**
		 * @Field		Access
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $Access = 0;

		/**
		 * @Field		LastLogin
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $LastLogin = 0;

		/**
		 * @Field		LastLoginIP
		 * @Type		varchar(25)
		 * @Access	Protected
		 */
		protected $LastLoginIP = "";

		/**
		 * @Field		IsEnabled
		 * @Type		enum('YES','NO')
		 * @Access	Protected
		 */
		protected $IsEnabled = "YES";
		
		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->UserID = addslashes($this->UserID);
			$this->Password = addslashes($this->Password);
			$this->UserName = addslashes($this->UserName);
			$this->UserStatus = (int)$this->UserStatus;
			$this->Created = (int)$this->Created;
			$this->Access = (int)$this->Access;
			$this->LastLogin = (int)$this->LastLogin;
			$this->LastLoginIP = addslashes($this->LastLoginIP);
			$this->IsEnabled = addslashes($this->IsEnabled);
		}		

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getUserID($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->UserID),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->UserID;
			} else {
				return stripslashes($this->UserID);
			}
		}

		public function getPassword($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Password),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Password;
			} else {
				return stripslashes($this->Password);
			}
		}

		public function getUserName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->UserName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->UserName;
			} else {
				return stripslashes($this->UserName);
			}
		}

		public function getUserStatus($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->UserStatus,2,'.',',');
			} else if($formatted=='asis') {
				return $this->UserStatus;
			} else {
				return $this->UserStatus;
			}
		}

		public function getCreated($formatted='no') {
			if($formatted == 'yes') {
				return getDateFromTime($this->Created);
			} else if($formatted=='asis') {
				return $this->Created;
			} else {
				return $this->Created;
			}
		}

		public function getAccess($formatted='no') {
			if($formatted == 'yes') {
				return getDateFromTime($this->Access);
			} else if($formatted=='asis') {
				return $this->Access;
			} else {
				return $this->Access;
			}
		}

		public function getLastLogin($formatted='no') {
			if($formatted == 'yes') {
				return getDateFromTime($this->LastLogin);
			} else if($formatted=='asis') {
				return $this->LastLogin;
			} else {
				return $this->LastLogin;
			}
		}

		public function getLastLoginIP($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->LastLoginIP),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->LastLoginIP;
			} else {
				return stripslashes($this->LastLoginIP);
			}
		}

		public function getIsEnabled($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->IsEnabled),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->IsEnabled;
			} else {
				return stripslashes($this->IsEnabled);
			}
		}

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setUserID($arg) {
			$this->UserID = addslashes($arg);
		}

		public function setPassword($arg) {
			$this->Password = addslashes($arg);
		}

		public function setUserName($arg) {
			$this->UserName = addslashes($arg);
		}

		public function setUserStatus($arg) {
			$this->UserStatus = (int)$arg;
		}

		public function setCreated($arg) {
			$this->Created = (int)$arg;
		}

		public function setAccess($arg) {
			$this->Access = (int)$arg;
		}

		public function setLastLogin($arg) {
			$this->LastLogin = (int)$arg;
		}

		public function setLastLoginIP($arg) {
			$this->LastLoginIP = addslashes($arg);
		}

		public function setIsEnabled($arg) {
			$this->IsEnabled = addslashes($arg);
		}

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `asys_adminusers` (`UserID`, `Password`, `UserName`, `UserStatus`, `Created`, `Access`, `LastLogin`, `LastLoginIP`, `IsEnabled`) VALUES(";
			$sql	=	$sql."'".$this->getUserID('asis')."', ";
			$sql	=	$sql."'".$this->getPassword('asis')."', ";
			$sql	=	$sql."'".$this->getUserName('asis')."', ";
			$sql	=	$sql."'".$this->getUserStatus('asis')."', ";
			$sql	=	$sql."'".$this->getCreated('asis')."', ";
			$sql	=	$sql."'".$this->getAccess('asis')."', ";
			$sql	=	$sql."'".$this->getLastLogin('asis')."', ";
			$sql	=	$sql."'".$this->getLastLoginIP('asis')."', ";
			$sql	=	$sql."'".$this->getIsEnabled('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `asys_adminusers` SET ";
			if($this->getPassword('asis') != "")
				$sql	=	$sql."`Password` = '".$this->getPassword('asis')."', ";
			$sql	=	$sql."`UserName` = '".$this->getUserName('asis')."', ";
			$sql	=	$sql."`UserStatus` = '".$this->getUserStatus('asis')."', ";
			$sql	=	$sql."`LastLogin` = '".$this->getLastLogin('asis')."', ";
			$sql	=	$sql."`LastLoginIP` = '".$this->getLastLoginIP('asis')."', ";
			$sql	=	$sql."`IsEnabled` = '".$this->getIsEnabled('asis')."' ";
			$sql	=	$sql." WHERE `UserID` = '".$this->getUserID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `asys_adminusers` ";
			$sql	=	$sql." WHERE `UserID` = '".$this->getUserID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if(trim($UserID) == "") $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div>'.$this->getUserID('formatted').'</div>
				<div>'.$this->getPassword('formatted').'</div>
				<div>'.$this->getUserName('formatted').'</div>
				<div>'.$this->getUserStatus('formatted').'</div>
				<div>'.$this->getCreated('formatted').'</div>
				<div>'.$this->getAccess('formatted').'</div>
				<div>'.$this->getLastLogin('formatted').'</div>
				<div>'.$this->getLastLoginIP('formatted').'</div>
				<div>'.$this->getIsEnabled('formatted').'</div>
			';

			return $str;
		}
	};

?>