<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Nov 06, 2015
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class asys_base_subgroup {
		/**
		 * @Field		SubgroupID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $SubgroupID = 0;

		/**
		 * @Field		BGID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $BGID = 0;

		/**
		 * @Field		BGName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $BGName = "";

		/**
		 * @Field		SubgroupName
		 * @Type		varchar(100)
		 * @Access	Protected
		 */
		protected $SubgroupName = "";
		
		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->SubgroupID = (int)$this->SubgroupID;
			$this->BGID = (int)$this->BGID;
			$this->SubgroupName = addslashes($this->SubgroupName);
		}		

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getSubgroupID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->SubgroupID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->SubgroupID;
			} else {
				return $this->SubgroupID;
			}
		}

		public function getBGID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->BGID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->BGID;
			} else {
				return $this->BGID;
			}
		}

		public function getBGName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->BGName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->BGName;
			} else {
				return stripslashes($this->BGName);
			}
		}

		public function getSubgroupName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->SubgroupName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->SubgroupName;
			} else {
				return stripslashes($this->SubgroupName);
			}
		}

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setSubgroupID($arg) {
			$this->SubgroupID = (int)$arg;
		}

		public function setBGID($arg) {
			$this->BGID = (int)$arg;
		}

		public function setBGName($arg) {
			$this->BGName = addslashes($arg);
		}

		public function setSubgroupName($arg) {
			$this->SubgroupName = addslashes($arg);
		}

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `asys_base_subgroup` (`SubgroupID`, `BGID`, `SubgroupName`) VALUES(";
			$sql	=	$sql."'".$this->getSubgroupID('asis')."', ";
			$sql	=	$sql."'".$this->getBGID('asis')."', ";
			$sql	=	$sql."'".$this->getSubgroupName('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `asys_base_subgroup` SET ";
			$sql	=	$sql."`BGID` = '".$this->getBGID('asis')."', ";
			$sql	=	$sql."`SubgroupName` = '".$this->getSubgroupName('asis')."' ";
			$sql	=	$sql." WHERE `SubgroupID` = '".$this->getSubgroupID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `asys_base_subgroup` ";
			$sql	=	$sql." WHERE `SubgroupID` = '".$this->getSubgroupID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$SubgroupID <= 0) $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">SubgroupID</div>
				<div style="float:left;">: '.$this->getSubgroupID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">BGID</div>
				<div style="float:left;">: '.$this->getBGID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">SubgroupName</div>
				<div style="float:left;">: '.$this->getSubgroupName('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>