<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Jul 25, 2017
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class asys_closing_balances {
		/**
		 * @Field		ClosingID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $ClosingID = 0;

		/**
		 * @Field		ClosingDate
		 * @Type		date
		 * @Access	Protected
		 */
		protected $ClosingDate = "1900-01-01";

		/**
		 * @Field		CompanyID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyID = 0;

		/**
		 * @Field		CompanyName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyName = "";

		/**
		 * @Field		GroupID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $GroupID = 0;

		/**
		 * @Field		GroupName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $GroupName = "";

		/**
		 * @Field		BGID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $BGID = 0;

		/**
		 * @Field		BGName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $BGName = "";

		/**
		 * @Field		SubgroupID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $SubgroupID = 0;

		/**
		 * @Field		SubgroupName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $SubgroupName = "";

		/**
		 * @Field		MotherAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $MotherAccountID = 0;

		/**
		 * @Field		MotherAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $MotherAccountName = "";

		/**
		 * @Field		AccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $AccountID = 0;

		/**
		 * @Field		AccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $AccountName = "";

		/**
		 * @Field		CBal
		 * @Type		decimal(15,2)
		 * @Access	Protected
		 */
		protected $CBal = 0;

		/**
		 * @Field		CBalType
		 * @Type		tinyint(4)
		 * @Access	Protected
		 */
		protected $CBalType = 0;

		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->ClosingID = (int)$this->ClosingID;
			$this->CompanyID = (int)$this->CompanyID;
			$this->GroupID = (int)$this->GroupID;
			$this->BGID = (int)$this->BGID;
			$this->SubgroupID = (int)$this->SubgroupID;
			$this->MotherAccountID = (int)$this->MotherAccountID;
			$this->AccountID = (int)$this->AccountID;
			$this->CBal = (double)$this->CBal;
			$this->CBalType = (int)$this->CBalType;
		}

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getClosingID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ClosingID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ClosingID;
			} else {
				return $this->ClosingID;
			}
		}

		public function getClosingDate($formatted='no') {
			if($formatted == 'yes') {
				return FormatSQLDateToIndianDate($this->ClosingDate);
			} else if($formatted=='asis') {
				return $this->ClosingDate;
			} else {
				return stripslashes($this->ClosingDate);
			}
		}

		public function getCompanyID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CompanyID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CompanyID;
			} else {
				return $this->CompanyID;
			}
		}

		public function getCompanyName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CompanyName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CompanyName;
			} else {
				return stripslashes($this->CompanyName);
			}
		}

		public function getGroupID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->GroupID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->GroupID;
			} else {
				return $this->GroupID;
			}
		}

		public function getGroupName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->GroupName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->GroupName;
			} else {
				return stripslashes($this->GroupName);
			}
		}

		public function getBGID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->BGID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->BGID;
			} else {
				return $this->BGID;
			}
		}

		public function getBGName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->BGName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->BGName;
			} else {
				return stripslashes($this->BGName);
			}
		}

		public function getSubgroupID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->SubgroupID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->SubgroupID;
			} else {
				return $this->SubgroupID;
			}
		}

		public function getSubgroupName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->SubgroupName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->SubgroupName;
			} else {
				return stripslashes($this->SubgroupName);
			}
		}

		public function getMotherAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->MotherAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->MotherAccountID;
			} else {
				return $this->MotherAccountID;
			}
		}

		public function getMotherAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->MotherAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->MotherAccountName;
			} else {
				return stripslashes($this->MotherAccountName);
			}
		}

		public function getAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->AccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->AccountID;
			} else {
				return $this->AccountID;
			}
		}

		public function getAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->AccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->AccountName;
			} else {
				return stripslashes($this->AccountName);
			}
		}

		public function getCBal($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CBal,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CBal;
			} else {
				return $this->CBal;
			}
		}

		public function getCBalType($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CBalType,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CBalType;
			} else {
				return $this->CBalType;
			}
		}

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setClosingID($arg) {
			$this->ClosingID = (int)$arg;
		}

		public function setClosingDate($arg) {
			$this->ClosingDate = FormatIndianDateToSQLDate($arg);
		}

		public function setCompanyID($arg) {
			$this->CompanyID = (int)$arg;
		}

		public function setCompanyName($arg) {
			$this->CompanyName = addslashes($arg);
		}

		public function setGroupID($arg) {
			$this->GroupID = (int)$arg;
		}

		public function setGroupName($arg) {
			$this->GroupName = addslashes($arg);
		}

		public function setBGID($arg) {
			$this->BGID = (int)$arg;
		}

		public function setBGName($arg) {
			$this->BGName = addslashes($arg);
		}

		public function setSubgroupID($arg) {
			$this->SubgroupID = (int)$arg;
		}

		public function setSubgroupName($arg) {
			$this->SubgroupName = addslashes($arg);
		}

		public function setMotherAccountID($arg) {
			$this->MotherAccountID = (int)$arg;
		}

		public function setMotherAccountName($arg) {
			$this->MotherAccountName = addslashes($arg);
		}

		public function setAccountID($arg) {
			$this->AccountID = (int)$arg;
		}

		public function setAccountName($arg) {
			$this->AccountName = addslashes($arg);
		}

		public function setCBal($arg) {
			$this->CBal = (double)$arg;
		}

		public function setCBalType($arg) {
			$this->CBalType = (int)$arg;
		}

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `asys_closing_balances` (`ClosingID`, `ClosingDate`, `CompanyID`, `GroupID`, `BGID`, `SubgroupID`, `MotherAccountID`, `AccountID`, `CBal`, `CBalType`) VALUES(";
			$sql	=	$sql."'".$this->getClosingID('asis')."', ";
			$sql	=	$sql."'".$this->getClosingDate('asis')."', ";
			$sql	=	$sql."'".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."'".$this->getGroupID('asis')."', ";
			$sql	=	$sql."'".$this->getBGID('asis')."', ";
			$sql	=	$sql."'".$this->getSubgroupID('asis')."', ";
			$sql	=	$sql."'".$this->getMotherAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getCBal('asis')."', ";
			$sql	=	$sql."'".$this->getCBalType('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `asys_closing_balances` SET ";
			$sql	=	$sql."`ClosingDate` = '".$this->getClosingDate('asis')."', ";
			$sql	=	$sql."`CompanyID` = '".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."`GroupID` = '".$this->getGroupID('asis')."', ";
			$sql	=	$sql."`BGID` = '".$this->getBGID('asis')."', ";
			$sql	=	$sql."`SubgroupID` = '".$this->getSubgroupID('asis')."', ";
			$sql	=	$sql."`MotherAccountID` = '".$this->getMotherAccountID('asis')."', ";
			$sql	=	$sql."`AccountID` = '".$this->getAccountID('asis')."', ";
			$sql	=	$sql."`CBal` = '".$this->getCBal('asis')."', ";
			$sql	=	$sql."`CBalType` = '".$this->getCBalType('asis')."' ";
			$sql	=	$sql." WHERE `ClosingID` = '".$this->getClosingID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `asys_closing_balances` ";
			$sql	=	$sql." WHERE `ClosingID` = '".$this->getClosingID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$ClosingID <= 0) $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">ClosingID</div>
				<div style="float:left;">: '.$this->getClosingID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ClosingDate</div>
				<div style="float:left;">: '.$this->getClosingDate('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">CompanyID</div>
				<div style="float:left;">: '.$this->getCompanyID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">GroupID</div>
				<div style="float:left;">: '.$this->getGroupID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">BGID</div>
				<div style="float:left;">: '.$this->getBGID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">SubgroupID</div>
				<div style="float:left;">: '.$this->getSubgroupID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">MotherAccountID</div>
				<div style="float:left;">: '.$this->getMotherAccountID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">AccountID</div>
				<div style="float:left;">: '.$this->getAccountID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">CBal</div>
				<div style="float:left;">: '.$this->getCBal('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">CBalType</div>
				<div style="float:left;">: '.$this->getCBalType('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>