<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Jun 29, 2017
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class asys_companies {
		/**
		 * @Field		CompanyID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyID = 0;

		/**
		 * @Field		MotherCompanyID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $MotherCompanyID = 0;

		/**
		 * @Field		MotherCompanyName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $MotherCompanyName = "";

		/**
		 * @Field		CompanyName
		 * @Type		varchar(200)
		 * @Access	Protected
		 */
		protected $CompanyName = "";

		/**
		 * @Field		CompanyAddress
		 * @Type		varchar(500)
		 * @Access	Protected
		 */
		protected $CompanyAddress = "";

		/**
		 * @Field		CompanyType
		 * @Type		varchar(30)
		 * @Access	Protected
		 */
		protected $CompanyType = "";

		/**
		 * @Field		CompanyCode
		 * @Type		varchar(20)
		 * @Access	Protected
		 */
		protected $CompanyCode = "";

		/**
		 * @Field		CompanyLogo
		 * @Type		varchar(50)
		 * @Access	Protected
		 */
		protected $CompanyLogo = "";

		/**
		 * @Field		CPVFooter
		 * @Type		text
		 * @Access	Protected
		 */
		protected $CPVFooter = "";

		/**
		 * @Field		CRVFooter
		 * @Type		text
		 * @Access	Protected
		 */
		protected $CRVFooter = "";

		/**
		 * @Field		BPVFooter
		 * @Type		text
		 * @Access	Protected
		 */
		protected $BPVFooter = "";

		/**
		 * @Field		BRVFooter
		 * @Type		text
		 * @Access	Protected
		 */
		protected $BRVFooter = "";

		/**
		 * @Field		JRNFooter
		 * @Type		text
		 * @Access	Protected
		 */
		protected $JRNFooter = "";

		/**
		 * @Field		CONFooter
		 * @Type		text
		 * @Access	Protected
		 */
		protected $CONFooter = "";

		/**
		 * @Field		DBNFooter
		 * @Type		text
		 * @Access	Protected
		 */
		protected $DBNFooter = "";

		/**
		 * @Field		CDNFooter
		 * @Type		text
		 * @Access	Protected
		 */
		protected $CDNFooter = "";

		/**
		 * @Field		VAT
		 * @Type		varchar(30)
		 * @Access	Protected
		 */
		protected $VAT = "";

		/**
		 * @Field		GST
		 * @Type		varchar(30)
		 * @Access	Protected
		 */
		protected $GST = "";

		/**
		 * @Field		PAN
		 * @Type		varchar(30)
		 * @Access	Protected
		 */
		protected $PAN = "";

		/**
		 * @Field		BRN
		 * @Type		varchar(30)
		 * @Access	Protected
		 */
		protected $BRN = "";

		/**
		 * @Field		IEC
		 * @Type		varchar(30)
		 * @Access	Protected
		 */
		protected $IEC = "";

		/**
		 * @Field		Country
		 * @Type		varchar(50)
		 * @Access	Protected
		 */
		protected $Country = "";

		/**
		 * @Field		State
		 * @Type		varchar(30)
		 * @Access	Protected
		 */
		protected $State = "";

		/**
		 * @Field		City
		 * @Type		varchar(40)
		 * @Access	Protected
		 */
		protected $City = "";

		/**
		 * @Field		PIN
		 * @Type		varchar(6)
		 * @Access	Protected
		 */
		protected $PIN = "";
		
		/**
		 * @Field		TxnDateFrom
		 * @Type		date
		 * @Access	Protected
		 */
		protected $TxnDateFrom = "1900-01-01";

		/**
		 * @Field		TxnDateTo
		 * @Type		date
		 * @Access	Protected
		 */
		protected $TxnDateTo = "1900-01-01";
		
		/**
		 * @Field		IGSTAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $IGSTAccountID = 0;

		/**
		 * @Field		IGSTAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $IGSTAccountName = "";

		/**
		 * @Field		CGSTAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CGSTAccountID = 0;

		/**
		 * @Field		CGSTAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CGSTAccountName = "";

		/**
		 * @Field		SGSTAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $SGSTAccountID = 0;

		/**
		 * @Field		SGSTAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $SGSTAccountName = "";
		
		/**
		 * @Field		UGSTAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $UGSTAccountID = 0;

		/**
		 * @Field		UGSTAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $UGSTAccountName = "";

		/**
		 * @Field		BankDetail
		 * @Type		text
		 * @Access	Protected
		 */
		protected $BankDetail = "";
		
		/**
		 * @Field		StockEntry
		 * @Type		enum('GRN','PURCHASE')
		 * @Access	Protected
		 */
		protected $StockEntry = "GRN";
		
		/**
		 * @Field		Inventory
		 * @Type		enum('YES','NO')
		 * @Access	Protected
		 */
		protected $Inventory = "YES";		

		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->CompanyID = (int)$this->CompanyID;
			$this->MotherCompanyID = (int)$this->MotherCompanyID;
			$this->CompanyName = addslashes($this->CompanyName);
			$this->CompanyAddress = addslashes($this->CompanyAddress);
			$this->CompanyType = addslashes($this->CompanyType);
			$this->CompanyCode = addslashes($this->CompanyCode);
			$this->CompanyLogo = addslashes($this->CompanyLogo);
			$this->CPVFooter = addslashes($this->CPVFooter);
			$this->CRVFooter = addslashes($this->CRVFooter);
			$this->BPVFooter = addslashes($this->BPVFooter);
			$this->BRVFooter = addslashes($this->BRVFooter);
			$this->JRNFooter = addslashes($this->JRNFooter);
			$this->CONFooter = addslashes($this->CONFooter);
			$this->DBNFooter = addslashes($this->DBNFooter);
			$this->CDNFooter = addslashes($this->CDNFooter);
			$this->VAT = addslashes($this->VAT);
			$this->GST = addslashes($this->GST);
			$this->PAN = addslashes($this->PAN);
			$this->BRN = addslashes($this->BRN);
			$this->IEC = addslashes($this->IEC);
			$this->Country = addslashes($this->Country);
			$this->State = addslashes($this->State);
			$this->City = addslashes($this->City);
			$this->PIN = addslashes($this->PIN);
			$this->City = addslashes($this->City);
			$this->PIN = addslashes($this->PIN);
			$this->IGSTAccountID = (int)$this->IGSTAccountID;
			$this->CGSTAccountID = (int)$this->CGSTAccountID;
			$this->SGSTAccountID = (int)$this->SGSTAccountID;
			$this->UGSTAccountID = (int)$this->UGSTAccountID;
			$this->BankDetail = addslashes($this->BankDetail);
			$this->StockEntry = addslashes($this->StockEntry);
			$this->Inventory = addslashes($this->Inventory);
		}

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getCompanyID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CompanyID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CompanyID;
			} else {
				return $this->CompanyID;
			}
		}

		public function getMotherCompanyID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->MotherCompanyID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->MotherCompanyID;
			} else {
				return $this->MotherCompanyID;
			}
		}

		public function getMotherCompanyName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->MotherCompanyName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->MotherCompanyName;
			} else {
				return stripslashes($this->MotherCompanyName);
			}
		}

		public function getCompanyName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CompanyName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CompanyName;
			} else {
				return stripslashes($this->CompanyName);
			}
		}

		public function getCompanyAddress($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CompanyAddress),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CompanyAddress;
			} else {
				return stripslashes($this->CompanyAddress);
			}
		}

		public function getCompanyType($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CompanyType),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CompanyType;
			} else {
				return stripslashes($this->CompanyType);
			}
		}

		public function getCompanyCode($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CompanyCode),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CompanyCode;
			} else {
				return stripslashes($this->CompanyCode);
			}
		}

		public function getCompanyLogo($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CompanyLogo),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CompanyLogo;
			} else {
				return stripslashes($this->CompanyLogo);
			}
		}

		public function getCPVFooter($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CPVFooter),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CPVFooter;
			} else {
				return stripslashes($this->CPVFooter);
			}
		}

		public function getCRVFooter($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CRVFooter),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CRVFooter;
			} else {
				return stripslashes($this->CRVFooter);
			}
		}

		public function getBPVFooter($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->BPVFooter),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->BPVFooter;
			} else {
				return stripslashes($this->BPVFooter);
			}
		}

		public function getBRVFooter($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->BRVFooter),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->BRVFooter;
			} else {
				return stripslashes($this->BRVFooter);
			}
		}

		public function getJRNFooter($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->JRNFooter),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->JRNFooter;
			} else {
				return stripslashes($this->JRNFooter);
			}
		}

		public function getCONFooter($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CONFooter),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CONFooter;
			} else {
				return stripslashes($this->CONFooter);
			}
		}

		public function getDBNFooter($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DBNFooter),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DBNFooter;
			} else {
				return stripslashes($this->DBNFooter);
			}
		}

		public function getCDNFooter($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CDNFooter),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CDNFooter;
			} else {
				return stripslashes($this->CDNFooter);
			}
		}

		public function getVAT($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->VAT),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->VAT;
			} else {
				return stripslashes($this->VAT);
			}
		}

		public function getGST($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->GST),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->GST;
			} else {
				return stripslashes($this->GST);
			}
		}

		public function getPAN($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->PAN),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->PAN;
			} else {
				return stripslashes($this->PAN);
			}
		}

		public function getBRN($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->BRN),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->BRN;
			} else {
				return stripslashes($this->BRN);
			}
		}

		public function getIEC($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->IEC),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->IEC;
			} else {
				return stripslashes($this->IEC);
			}
		}

		public function getCountry($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Country),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Country;
			} else {
				return stripslashes($this->Country);
			}
		}

		public function getState($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->State),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->State;
			} else {
				return stripslashes($this->State);
			}
		}

		public function getCity($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->City),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->City;
			} else {
				return stripslashes($this->City);
			}
		}

		public function getPIN($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->PIN),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->PIN;
			} else {
				return stripslashes($this->PIN);
			}
		}
		
		public function getTxnDateFrom($formatted='no') {
			if($formatted == 'yes') {
				return FormatSQLDateToIndianDate($this->TxnDateFrom);
			} else if($formatted=='asis') {
				return $this->TxnDateFrom;
			} else {
				return stripslashes($this->TxnDateFrom);
			}
		}

		public function getTxnDateTo($formatted='no') {
			if($formatted == 'yes') {
				return FormatSQLDateToIndianDate($this->TxnDateTo);
			} else if($formatted=='asis') {
				return $this->TxnDateTo;
			} else {
				return stripslashes($this->TxnDateTo);
			}
		}
		
		public function getIGSTAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->IGSTAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->IGSTAccountID;
			} else {
				return $this->IGSTAccountID;
			}
		}

		public function getIGSTAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->IGSTAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->IGSTAccountName;
			} else {
				return stripslashes($this->IGSTAccountName);
			}
		}

		public function getCGSTAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CGSTAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CGSTAccountID;
			} else {
				return $this->CGSTAccountID;
			}
		}

		public function getCGSTAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CGSTAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CGSTAccountName;
			} else {
				return stripslashes($this->CGSTAccountName);
			}
		}

		public function getSGSTAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->SGSTAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->SGSTAccountID;
			} else {
				return $this->SGSTAccountID;
			}
		}

		public function getSGSTAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->SGSTAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->SGSTAccountName;
			} else {
				return stripslashes($this->SGSTAccountName);
			}
		}
		
		public function getUGSTAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->UGSTAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->UGSTAccountID;
			} else {
				return $this->UGSTAccountID;
			}
		}

		public function getUGSTAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->UGSTAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->UGSTAccountName;
			} else {
				return stripslashes($this->UGSTAccountName);
			}
		}

		public function getBankDetail($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->BankDetail),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->BankDetail;
			} else {
				return stripslashes($this->BankDetail);
			}
		}
		
		public function getStockEntry($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->StockEntry),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->StockEntry;
			} else {
				return stripslashes($this->StockEntry);
			}
		}
		
		public function getInventory($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Inventory),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Inventory;
			} else {
				return stripslashes($this->Inventory);
			}
		}		

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setCompanyID($arg) {
			$this->CompanyID = (int)$arg;
		}

		public function setMotherCompanyID($arg) {
			$this->MotherCompanyID = (int)$arg;
		}

		public function setMotherCompanyName($arg) {
			$this->MotherCompanyName = addslashes($arg);
		}

		public function setCompanyName($arg) {
			$this->CompanyName = addslashes($arg);
		}

		public function setCompanyAddress($arg) {
			$this->CompanyAddress = addslashes($arg);
		}

		public function setCompanyType($arg) {
			$this->CompanyType = addslashes($arg);
		}

		public function setCompanyCode($arg) {
			$this->CompanyCode = addslashes($arg);
		}

		public function setCompanyLogo($arg) {
			$this->CompanyLogo = addslashes($arg);
		}

		public function setCPVFooter($arg) {
			$this->CPVFooter = addslashes($arg);
		}

		public function setCRVFooter($arg) {
			$this->CRVFooter = addslashes($arg);
		}

		public function setBPVFooter($arg) {
			$this->BPVFooter = addslashes($arg);
		}

		public function setBRVFooter($arg) {
			$this->BRVFooter = addslashes($arg);
		}

		public function setJRNFooter($arg) {
			$this->JRNFooter = addslashes($arg);
		}

		public function setCONFooter($arg) {
			$this->CONFooter = addslashes($arg);
		}

		public function setDBNFooter($arg) {
			$this->DBNFooter = addslashes($arg);
		}

		public function setCDNFooter($arg) {
			$this->CDNFooter = addslashes($arg);
		}

		public function setVAT($arg) {
			$this->VAT = addslashes($arg);
		}

		public function setGST($arg) {
			$this->GST = addslashes($arg);
		}

		public function setPAN($arg) {
			$this->PAN = addslashes($arg);
		}

		public function setBRN($arg) {
			$this->BRN = addslashes($arg);
		}

		public function setIEC($arg) {
			$this->IEC = addslashes($arg);
		}

		public function setCountry($arg) {
			$this->Country = addslashes($arg);
		}

		public function setState($arg) {
			$this->State = addslashes($arg);
		}

		public function setCity($arg) {
			$this->City = addslashes($arg);
		}

		public function setPIN($arg) {
			$this->PIN = addslashes($arg);
		}
		
		public function setTxnDateFrom($arg) {
			$this->TxnDateFrom = FormatIndianDateToSQLDate($arg);
		}

		public function setTxnDateTo($arg) {
			$this->TxnDateTo = FormatIndianDateToSQLDate($arg);
		}
		
		public function setIGSTAccountID($arg) {
			$this->IGSTAccountID = (int)$arg;
		}

		public function setIGSTAccountName($arg) {
			$this->IGSTAccountName = addslashes($arg);
		}

		public function setCGSTAccountID($arg) {
			$this->CGSTAccountID = (int)$arg;
		}

		public function setCGSTAccountName($arg) {
			$this->CGSTAccountName = addslashes($arg);
		}

		public function setSGSTAccountID($arg) {
			$this->SGSTAccountID = (int)$arg;
		}

		public function setSGSTAccountName($arg) {
			$this->SGSTAccountName = addslashes($arg);
		}
		
		public function setUGSTAccountID($arg) {
			$this->UGSTAccountID = (int)$arg;
		}

		public function setUGSTAccountName($arg) {
			$this->UGSTAccountName = addslashes($arg);
		}

		public function setBankDetail($arg) {
			$this->BankDetail = addslashes($arg);
		}
		
		public function setStockEntry($arg) {
			$this->StockEntry = addslashes($arg);
		}
		
		public function setInventory($arg) {
			$this->Inventory = addslashes($arg);
		}		

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `asys_companies` (`CompanyID`, `MotherCompanyID`, `CompanyName`, `CompanyAddress`, `CompanyType`, `CompanyCode`, `CompanyLogo`, `CPVFooter`, `CRVFooter`, `BPVFooter`, `BRVFooter`, `JRNFooter`, `CONFooter`, `DBNFooter`, `CDNFooter`, `VAT`, `GST`, `PAN`, `BRN`, `IEC`, `Country`, `State`, `City`, `PIN`, `TxnDateFrom`, `TxnDateTo`, `IGSTAccountID`, `CGSTAccountID`, `SGSTAccountID`, `UGSTAccountID`, `BankDetail`, `StockEntry`, `Inventory`) VALUES(";
			$sql	=	$sql."'".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."'".$this->getMotherCompanyID('asis')."', ";
			$sql	=	$sql."'".$this->getCompanyName('asis')."', ";
			$sql	=	$sql."'".$this->getCompanyAddress('asis')."', ";
			$sql	=	$sql."'".$this->getCompanyType('asis')."', ";
			$sql	=	$sql."'".$this->getCompanyCode('asis')."', ";
			$sql	=	$sql."'".$this->getCompanyLogo('asis')."', ";
			$sql	=	$sql."'".$this->getCPVFooter('asis')."', ";
			$sql	=	$sql."'".$this->getCRVFooter('asis')."', ";
			$sql	=	$sql."'".$this->getBPVFooter('asis')."', ";
			$sql	=	$sql."'".$this->getBRVFooter('asis')."', ";
			$sql	=	$sql."'".$this->getJRNFooter('asis')."', ";
			$sql	=	$sql."'".$this->getCONFooter('asis')."', ";
			$sql	=	$sql."'".$this->getDBNFooter('asis')."', ";
			$sql	=	$sql."'".$this->getCDNFooter('asis')."', ";
			$sql	=	$sql."'".$this->getVAT('asis')."', ";
			$sql	=	$sql."'".$this->getGST('asis')."', ";
			$sql	=	$sql."'".$this->getPAN('asis')."', ";
			$sql	=	$sql."'".$this->getBRN('asis')."', ";
			$sql	=	$sql."'".$this->getIEC('asis')."', ";
			$sql	=	$sql."'".$this->getCountry('asis')."', ";
			$sql	=	$sql."'".$this->getState('asis')."', ";
			$sql	=	$sql."'".$this->getCity('asis')."', ";
			$sql	=	$sql."'".$this->getPIN('asis')."', ";
			$sql	=	$sql."'".$this->getTxnDateFrom('asis')."', ";
			$sql	=	$sql."'".$this->getTxnDateTo('asis')."', ";
			$sql	=	$sql."'".$this->getIGSTAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getCGSTAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getSGSTAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getUGSTAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getBankDetail('asis')."', ";
			$sql	=	$sql."'".$this->getStockEntry('asis')."', ";
			$sql	=	$sql."'".$this->getInventory('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `asys_companies` SET ";
			$sql	=	$sql."`MotherCompanyID` = '".$this->getMotherCompanyID('asis')."', ";
			$sql	=	$sql."`CompanyName` = '".$this->getCompanyName('asis')."', ";
			$sql	=	$sql."`CompanyAddress` = '".$this->getCompanyAddress('asis')."', ";
			$sql	=	$sql."`CompanyType` = '".$this->getCompanyType('asis')."', ";
			$sql	=	$sql."`CompanyCode` = '".$this->getCompanyCode('asis')."', ";
			if($this->getCompanyLogo('asis') != "")
				$sql	=	$sql."`CompanyLogo` = '".$this->getCompanyLogo('asis')."', ";
			$sql	=	$sql."`CPVFooter` = '".$this->getCPVFooter('asis')."', ";
			$sql	=	$sql."`CRVFooter` = '".$this->getCRVFooter('asis')."', ";
			$sql	=	$sql."`BPVFooter` = '".$this->getBPVFooter('asis')."', ";
			$sql	=	$sql."`BRVFooter` = '".$this->getBRVFooter('asis')."', ";
			$sql	=	$sql."`JRNFooter` = '".$this->getJRNFooter('asis')."', ";
			$sql	=	$sql."`CONFooter` = '".$this->getCONFooter('asis')."', ";
			$sql	=	$sql."`DBNFooter` = '".$this->getDBNFooter('asis')."', ";
			$sql	=	$sql."`CDNFooter` = '".$this->getCDNFooter('asis')."', ";
			$sql	=	$sql."`VAT` = '".$this->getVAT('asis')."', ";
			$sql	=	$sql."`GST` = '".$this->getGST('asis')."', ";
			$sql	=	$sql."`PAN` = '".$this->getPAN('asis')."', ";
			$sql	=	$sql."`BRN` = '".$this->getBRN('asis')."', ";
			$sql	=	$sql."`IEC` = '".$this->getIEC('asis')."', ";
			$sql	=	$sql."`Country` = '".$this->getCountry('asis')."', ";
			$sql	=	$sql."`State` = '".$this->getState('asis')."', ";
			$sql	=	$sql."`City` = '".$this->getCity('asis')."', ";
			$sql	=	$sql."`PIN` = '".$this->getPIN('asis')."', ";
			$sql	=	$sql."`TxnDateFrom` = '".$this->getTxnDateFrom('asis')."', ";
			$sql	=	$sql."`TxnDateTo` = '".$this->getTxnDateTo('asis')."', ";
			$sql	=	$sql."`IGSTAccountID` = '".$this->getIGSTAccountID('asis')."', ";
			$sql	=	$sql."`CGSTAccountID` = '".$this->getCGSTAccountID('asis')."', ";
			$sql	=	$sql."`SGSTAccountID` = '".$this->getSGSTAccountID('asis')."', ";
			$sql	=	$sql."`UGSTAccountID` = '".$this->getUGSTAccountID('asis')."', ";
			$sql	=	$sql."`BankDetail` = '".$this->getBankDetail('asis')."', ";
			$sql	=	$sql."`StockEntry` = '".$this->getStockEntry('asis')."', ";
			$sql	=	$sql."`Inventory` = '".$this->getInventory('asis')."' ";
			$sql	=	$sql." WHERE `CompanyID` = '".$this->getCompanyID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `asys_companies` ";
			$sql	=	$sql." WHERE `CompanyID` = '".$this->getCompanyID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$CompanyID <= 0) $chk	=	false;
			if(trim($CompanyName) == "") $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">Company#</div>
				<div style="float:left;">: '.$this->getCompanyID().'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Mother Company</div>
				<div style="float:left;">: '.$this->getMotherCompanyName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Company Name</div>
				<div style="float:left;">: '.$this->getCompanyName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Company Address</div>
				<div style="float:left;">: '.$this->getCompanyAddress('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Company Type</div>
				<div style="float:left;">: '.$this->getCompanyType('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Company Code</div>
				<div style="float:left;">: '.$this->getCompanyCode('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Company Logo</div>
				<div style="float:left;">: '.$this->getCompanyLogo('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">CPV Footer</div>
				<div style="float:left;">: '.$this->getCPVFooter('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">CRV Footer</div>
				<div style="float:left;">: '.$this->getCRVFooter('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">BPV Footer</div>
				<div style="float:left;">: '.$this->getBPVFooter('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">BRV Footer</div>
				<div style="float:left;">: '.$this->getBRVFooter('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">JRN Footer</div>
				<div style="float:left;">: '.$this->getJRNFooter('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">CON Footer</div>
				<div style="float:left;">: '.$this->getCONFooter('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DBN Footer</div>
				<div style="float:left;">: '.$this->getDBNFooter('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">CDN Footer</div>
				<div style="float:left;">: '.$this->getCDNFooter('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">VAT</div>
				<div style="float:left;">: '.$this->getVAT('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">GST</div>
				<div style="float:left;">: '.$this->getGST('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">PAN</div>
				<div style="float:left;">: '.$this->getPAN('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">BRN</div>
				<div style="float:left;">: '.$this->getBRN('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">IEC</div>
				<div style="float:left;">: '.$this->getIEC('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Country</div>
				<div style="float:left;">: '.$this->getCountry('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">State</div>
				<div style="float:left;">: '.$this->getState('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">City</div>
				<div style="float:left;">: '.$this->getCity('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">PIN</div>
				<div style="float:left;">: '.$this->getPIN('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>