<?php

	class companydb {

		protected $host			= SS_DB_HOST;
		protected $user			= SS_DB_USER;
		protected $password	= SS_DB_PASSWORD;
		protected $dbname		= SS_DB_DBNAME;
		protected $conn			= null;

		public function __construct($dbType = '') {
			
			if (!extension_loaded('pdo')) {
				die (SS_DB_ERR_101);
			}
			
			if($dbType == "REPORT") {
				$this->user 		= SS_RPT_USER;
				$this->password	= SS_RPT_PASSWORD;
			} else if($dbType == "DATA") {
				$this->user 		= SS_DBA_USER;
				$this->password	= SS_DBA_PASSWORD;			
			}
			
			try {
				$this->conn = new PDO("mysql:host=".$this->host.";dbname=".$this->dbname, $this->user, $this->password);
				$this->conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
			} catch(PDOException $e) {
				die('DB connection error '.$e->getMessage());
			}			
				
		}
		
		public function __destruct() {
			$this->conn	= null;
		}		
		
		private function ExecuteQuery($sql00) {
		
			$res	= false;

			try {
				
				$res	= $this->conn->query($sql00);
				
			} catch(PDOException $e) {
				$err	= 'companydb ExecuteQuery ('.$sql00.') '.$e->getMessage();
				_errorLog($err);
			}
			
			return $res;
			
		}

		private function getRecordsetExecutingQuery($sql00) {
		
			$rows		= array();
		
			try {
				
				$result	= $this->conn->query($sql00);
				while($row = $result->fetch()) {
					$rows[]	=	$row;
				}
				
			} catch(PDOException $e) {
				$err	= 'companydb getRecordsetExecutingQuery ('.$sql00.') '.$e->getMessage();
				_errorLog($err);
			}
		
			return $rows;
			
		}
		
		private function getResultExecutingQuery($sql00) {

			$res		= "";
		
			try {
				
				$result	= $this->conn->query($sql00);
				if($row = $result->fetch()) {
					$res	=	$row[0];
				}
				
			} catch(PDOException $e) {
				$err	= 'companydb getResultExecutingQuery ('.$sql00.') '.$e->getMessage();
				_errorLog($err);
			}
		
			return $res;
			
		}
		
		public function getNextID($tblName, $colName) {
			if(strpos($tblName, "'") !== false) return false;
			if(strpos($colName, "'") !== false) return false;
			
			if(strpos($tblName, '"') !== false) return false;
			if(strpos($colName, '"') !== false) return false;
			
			$maxid			=	0;
			$sql				=	"SELECT MAX(`$colName`) FROM `$tblName`";

			try {
				
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch())
					$maxid 	= $row[0];
					
			} catch(PDOException $e) {
				$err	= 'companydb getNextID '.$e->getMessage();
				_errorLog($err);
			}

			$maxid++;
			return $maxid;
			
		}
		
		function getAccountNameByAccountID($AccountID) {
			$AccountID	= (int)$AccountID;
			$sql		=	"SELECT `AccountName` FROM `asys_accounts` WHERE `AccountID`='$AccountID'";
			return $this->getResultExecutingQuery($sql);
		}

			
		/*--------------------------------------------------------------*/
		/*********************** COMPANY METHODS ***********************/

		function getCompanyDetail($CompanyID) {
			$CompanyID	= (int)$CompanyID;
			$cclass			=	new asys_companies();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_companies` WHERE `CompanyID`='$CompanyID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_companies');
				if($row 	= $result->fetch()) { 
					$row->setMotherCompanyName( $this->getCompanyNameByCompanyID( $row->getMotherCompanyID()));
					$row->setIGSTAccountName($this->getAccountNameByAccountID($row->getIGSTAccountID()));
					$row->setCGSTAccountName($this->getAccountNameByAccountID($row->getCGSTAccountID()));
					$row->setSGSTAccountName($this->getAccountNameByAccountID($row->getSGSTAccountID()));
					$row->setUGSTAccountName($this->getAccountNameByAccountID($row->getUGSTAccountID()));
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'companydb getCompanyDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getCompanyList() {
			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_companies` ORDER BY `CompanyName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_companies');
				while($row = $result->fetch()) {
					$row->setMotherCompanyName( $this->getCompanyNameByCompanyID( $row->getMotherCompanyID()));
					$row->setIGSTAccountName($this->getAccountNameByAccountID($row->getIGSTAccountID()));
					$row->setCGSTAccountName($this->getAccountNameByAccountID($row->getCGSTAccountID()));
					$row->setSGSTAccountName($this->getAccountNameByAccountID($row->getSGSTAccountID()));
					$row->setUGSTAccountName($this->getAccountNameByAccountID($row->getUGSTAccountID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'companydb getCompanyList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getSubCompanyList($MotherCompanyID) {
			$MotherCompanyID	= (int)$MotherCompanyID;
			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_companies` WHERE `MotherCompanyID`='$MotherCompanyID' ORDER BY `CompanyName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_companies');
				while($row = $result->fetch()) {
					$row->setMotherCompanyName( $this->getCompanyNameByCompanyID( $row->getMotherCompanyID()));
					$row->setIGSTAccountName($this->getAccountNameByAccountID($row->getIGSTAccountID()));
					$row->setCGSTAccountName($this->getAccountNameByAccountID($row->getCGSTAccountID()));
					$row->setSGSTAccountName($this->getAccountNameByAccountID($row->getSGSTAccountID()));
					$row->setUGSTAccountName($this->getAccountNameByAccountID($row->getUGSTAccountID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'companydb getSubCompanyList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getCompanyListByType($CompanyType) {
			$CompanyType	= addslashes($CompanyType);
			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_companies` WHERE `CompanyType`='$CompanyType' ORDER BY `CompanyName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_companies');
				while($row = $result->fetch()) {
					$row->setMotherCompanyName( $this->getCompanyNameByCompanyID( $row->getMotherCompanyID()));
					$row->setIGSTAccountName($this->getAccountNameByAccountID($row->getIGSTAccountID()));
					$row->setCGSTAccountName($this->getAccountNameByAccountID($row->getCGSTAccountID()));
					$row->setSGSTAccountName($this->getAccountNameByAccountID($row->getSGSTAccountID()));
					$row->setUGSTAccountName($this->getAccountNameByAccountID($row->getUGSTAccountID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'companydb getCompanyListByType '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getCompanyListJSON($CompanyType = ''){
			$CompanyType	= addslashes($CompanyType);
			$sql		= "SELECT `CompanyID`, `CompanyName` FROM `asys_companies` ORDER BY `CompanyName`";
			if($CompanyType != "")
				$sql		= "SELECT `CompanyID`, `CompanyName` FROM `asys_companies` WHERE `CompanyType`='$CompanyType' ORDER BY `CompanyName`";
			return $this->getRecordsetExecutingQuery($sql);
		
		}
		
		function getNumberOfCompany($schStr) {
			$schStr		= addslashes($schStr);
			if($schStr == "")
				$sql	=	"SELECT COUNT(*) FROM `asys_companies`";
			else
				$sql	=	"SELECT COUNT(*) FROM `asys_companies` WHERE `CompanyName` LIKE '%$schStr%'";
			
			return $this->getResultExecutingQuery($sql);
		}

		function getCompanyListPaged($sRec, $nRec, $schStr) {
			$sRec			= (int)$sRec;
			$nRec			= (int)$nRec;
			$schStr		= addslashes($schStr);
			if($schStr == "")
				$sql			=	"SELECT * FROM `asys_companies` ORDER BY `CompanyName` LIMIT $sRec, $nRec";
			else
				$sql			=	"SELECT * FROM `asys_companies` WHERE `CompanyName` LIKE '%$schStr%' ORDER BY `CompanyName` LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_companies');
				while($row = $result->fetch()) {
					$row->setMotherCompanyName( $this->getCompanyNameByCompanyID( $row->getMotherCompanyID()));
					$row->setIGSTAccountName($this->getAccountNameByAccountID($row->getIGSTAccountID()));
					$row->setCGSTAccountName($this->getAccountNameByAccountID($row->getCGSTAccountID()));
					$row->setSGSTAccountName($this->getAccountNameByAccountID($row->getSGSTAccountID()));
					$row->setUGSTAccountName($this->getAccountNameByAccountID($row->getUGSTAccountID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'companydb getCompanyListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function getCompanyNameByCompanyID($CompanyID) {
			$CompanyID		= (int)$CompanyID;
			$sql		=	"SELECT `CompanyName` FROM `asys_companies` WHERE `CompanyID`='$CompanyID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function CreateCompany($ccls) {
			$cid		= $this->getNextID('asys_companies', 'CompanyID');
			$aid		= $this->getNextID("asys_accounts", "AccountID");
			
				
			try {
			
				$this->conn->beginTransaction();
				
				$sql	= $ccls->getInsertSQL();
				$this->conn->exec($sql);
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'companydb CreateCompany '.$er->getMessage();
				_errorLog($err);
				$cid	= -1;
				
			}

				
			return $cid;
		}

		function deleteCompany($lcls) {
		
			$pkey				= $lcls->getCompanyID();
			$ret				= true;
			$chk				= 0;
		

			$sql			=	"SELECT * FROM `asys_modules` WHERE `CompanyID`='$pkey'";
			$result		= $this->conn->query($sql);
			if($row 	= $result->fetch()) {
				$chk		= 1;
			}
			$sql			=	"SELECT * FROM `asys_accounts` WHERE `CompanyID`='$pkey'";
			$result		= $this->conn->query($sql);
			if($row 	= $result->fetch()) {
				$chk		= 1;
			}
			$sql			=	"SELECT * FROM `asys_stock_voucher` WHERE `CompanyID`='$pkey'";
			$result		= $this->conn->query($sql);
			if($row 	= $result->fetch()) {
				$chk		= 1;
			}
			$sql			=	"SELECT * FROM `asys_voucher_entry` WHERE `CompanyID`='$pkey'";
			$result		= $this->conn->query($sql);
			if($row 	= $result->fetch()) {
				$chk		= 1;
			}
			
			if($chk == 0) {
			
				try {
			
					$this->conn->beginTransaction();
				
					$sql		= $lcls->getDeleteSQL();
					$ret		= $this->conn->query($sql);
			
					$this->conn->commit();
				
				} catch(Exception $er) {
					$err	= 'companydb deleteCompany '.$er->getMessage();
					_errorLog($err);
					$ret	= false;
					$this->conn->rollBack();
				
				}
							
			} else {
				$ret	= false;
			}
				
		
			return $ret;
		}
		
		function UpdateCompany($ccls) {
			$cid		= $ccls->getCompanyID();
			
				
			try {
			
				$this->conn->beginTransaction();
				
				$sql	= $ccls->getUpdateSQL();
				$this->conn->exec($sql);
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'companydb UpdateCompany '.$er->getMessage();
				_errorLog($err);
				$cid	= -1;
				
			}

			
			return $cid;
		}
		


		/*------------------------------------------------------------------*/
		/*********************** USER-COMPANY METHODS ***********************/

		function getUserCompanyStat($UserID, $CompanyID) {
			$UserID			= addslashes($UserID);
			$CompanyID	= (int)$CompanyID;
				
			$sql			=	"SELECT `UserID` FROM `asys_user_companies` WHERE `UserID`='$UserID' AND `CompanyID`='$CompanyID'";
			$ret				= false;
		
			try {

				$result		= $this->conn->query($sql, PDO::FETCH_NUM);
				if($row 	= $result->fetch())	{
					$ret				= true;
				}
				
			} catch(PDOException $e) {
				$err	= 'companydb getUserCompanyStat '.$e->getMessage();
				_errorLog($err);
			}
		
			return $ret;
		}

		function setUserCompany($UserID, $CompanyID) {
			$UserID			= addslashes($UserID);
			$CompanyID	= (int)$CompanyID;
			
			$ret				= false;
		
			try {
				
				$sql			=	"SELECT `UserID` FROM `asys_user_companies` WHERE `UserID`='$UserID' AND `CompanyID`='$CompanyID'";
				$result		= $this->conn->query($sql, PDO::FETCH_NUM);
				if($row 	= $result->fetch())	{
					$sql			=	"DELETE FROM `asys_user_companies` WHERE `UserID`='$UserID' AND `CompanyID`='$CompanyID' LIMIT 1";
				}	else {
					$sql	=	"INSERT INTO `asys_user_companies` (`UserID`, `CompanyID`) VALUES(";
					$sql	=	$sql."'".$UserID."', ";
					$sql	=	$sql."'".$CompanyID."')";
				}
				
				$ret		= $this->conn->query($sql);
				
			} catch(PDOException $e) {
				$err	= 'companydb setUserCompany '.$e->getMessage();
				_errorLog($err);
			}
		
			return $ret;

		}



		/*------------------------------------------------------------*/
		/*********************** CONFIG METHODS ***********************/

		function getConfigDetail($ConfigID) {
			$ConfigID	= (int)$ConfigID;
			$cclass			=	new asys_config();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_config` WHERE `ConfigID`='$ConfigID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_config');
				if($row 	= $result->fetch()) { 
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));	
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'companydb getConfigDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getConfigList() {
			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_config` ORDER BY `ConfigName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_config');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'companydb getConfigList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getCompanyWiseConfigList($CompanyID) {
			$CompanyID	= (int)$CompanyID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_config` WHERE `CompanyID`='$CompanyID' ORDER BY `ConfigName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_config');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'companydb getCompanyWiseConfigList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getConfigListJSON(){
		
			$sql		= "SELECT `ConfigID`, `ConfigName` FROM `asys_config` ORDER BY `ConfigName`";
			return $this->getRecordsetExecutingQuery($sql);
		
		}
		
		function getNumberOfConfig($schStr) {
			if($schStr == "")
				$sql	=	"SELECT COUNT(*) FROM `asys_config`";
			else
				$sql	=	"SELECT COUNT(*) FROM `asys_config` WHERE `ConfigName` LIKE '%$schStr%'";
			
			return $this->getResultExecutingQuery($sql);
		}

		function getConfigListPaged($sRec, $nRec, $schStr) {

			if($schStr == "")
				$sql			=	"SELECT * FROM `asys_config` ORDER BY `ConfigName` LIMIT $sRec, $nRec";
			else
				$sql			=	"SELECT * FROM `asys_config` WHERE `ConfigName` LIKE '%$schStr%' ORDER BY `ConfigName` LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_config');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$arr[]	= $row;
				}

			} catch(PDOException $e) {
				$err	= 'companydb getConfigListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function getConfigNameByConfigID($ConfigID) {
			$sql		=	"SELECT `ConfigName` FROM `asys_config` WHERE `ConfigID`='$ConfigID'";
			return $this->getResultExecutingQuery($sql);
		}

		function deleteConfig($lcls) {
		
			$pkey	= $lcls->getConfigID();
			$ret				= false;
		
			try {
				
				$sql		= $lcls->getDeleteSQL();
				$ret		= $this->conn->query($sql);
				
			} catch(PDOException $e) {
				$err	= 'companydb deleteConfig '.$e->getMessage();
				_errorLog($err);
			}
		
			return $ret;
		}

		
	};

?>