<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - May 14, 2015
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class asys_config {
		/**
		 * @Field		CompanyID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyID = 0;
		
		/**
		 * @Field		CompanyName
		 * @Type		varchar(200)
		 * @Access	Protected
		 */
		protected $CompanyName = "";		

		/**
		 * @Field		ConfigID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ConfigID = 0;

		/**
		 * @Field		ConfigName
		 * @Type		varchar(50)
		 * @Access	Protected
		 */
		protected $ConfigName = "";

		/**
		 * @Field		ConfigValue
		 * @Type		varchar(100)
		 * @Access	Protected
		 */
		protected $ConfigValue = "";
		
		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->CompanyID = (int)$this->CompanyID;
			$this->ConfigID = (int)$this->ConfigID;
			$this->ConfigName = addslashes($this->ConfigName);
			$this->ConfigValue = addslashes($this->ConfigValue);
		}		

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getCompanyID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CompanyID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CompanyID;
			} else {
				return $this->CompanyID;
			}
		}
		
		public function getCompanyName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CompanyName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CompanyName;
			} else {
				return stripslashes($this->CompanyName);
			}
		}		

		public function getConfigID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ConfigID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ConfigID;
			} else {
				return $this->ConfigID;
			}
		}

		public function getConfigName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ConfigName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ConfigName;
			} else {
				return stripslashes($this->ConfigName);
			}
		}

		public function getConfigValue($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ConfigValue),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ConfigValue;
			} else {
				return stripslashes($this->ConfigValue);
			}
		}

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setCompanyID($arg) {
			$this->CompanyID = (int)$arg;
		}
		
		public function setCompanyName($arg) {
			$this->CompanyName = addslashes($arg);
		}		

		public function setConfigID($arg) {
			$this->ConfigID = (int)$arg;
		}

		public function setConfigName($arg) {
			$this->ConfigName = addslashes($arg);
		}

		public function setConfigValue($arg) {
			$this->ConfigValue = addslashes($arg);
		}

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `asys_config` (`CompanyID`, `ConfigID`, `ConfigName`, `ConfigValue`) VALUES(";
			$sql	=	$sql."'".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."'".$this->getConfigID('asis')."', ";
			$sql	=	$sql."'".$this->getConfigName('asis')."', ";
			$sql	=	$sql."'".$this->getConfigValue('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `asys_config` SET ";
			$sql	=	$sql."`CompanyID` = '".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."`ConfigName` = '".$this->getConfigName('asis')."', ";
			$sql	=	$sql."`ConfigValue` = '".$this->getConfigValue('asis')."' ";
			$sql	=	$sql." WHERE `ConfigID` = '".$this->getConfigID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `asys_config` ";
			$sql	=	$sql." AND `ConfigID` = '".$this->getConfigID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$ConfigID <= 0) $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">CompanyID</div>
				<div style="float:left;">: '.$this->getCompanyID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ConfigID</div>
				<div style="float:left;">: '.$this->getConfigID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ConfigName</div>
				<div style="float:left;">: '.$this->getConfigName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ConfigValue</div>
				<div style="float:left;">: '.$this->getConfigValue('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>