<?php

	class GenericDB {
	
		protected $host			= SS_DB_HOST;
		protected $user			= SS_DB_USER;
		protected $password	= SS_DB_PASSWORD;
		protected $dbname		= SS_DB_DBNAME;
		protected $conn			= null;

		public function __construct($dbType = '') {
			
			if (!extension_loaded('pdo')) {
				die (SS_DB_ERR_101);
			}
			
			if($dbType == "REPORT") {
				$this->user 		= SS_RPT_USER;
				$this->password	= SS_RPT_PASSWORD;
			} else if($dbType == "DATA") {
				$this->user 		= SS_DBA_USER;
				$this->password	= SS_DBA_PASSWORD;			
			}
			
			try {
				$this->conn = new PDO("mysql:host=".$this->host.";dbname=".$this->dbname.";charset=utf8", $this->user, $this->password);
				$this->conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
			} catch(PDOException $e) {
				die('DB connection error '.$e->getMessage());
			}			
				
		}
		
		public function __destruct() {
			$this->conn	= null;
		}

		private function ExecuteQuery($sql00) {
		
			$res	= false;

			try {
				
				$res	= $this->conn->query($sql00);

			} catch(PDOException $e) {
				$err	= 'genericdb ExecuteQuery ('.$sql00.') '.$e->getMessage();
				_errorLog($err);
			}
			
			return $res;
			
		}

		private function getRecordsetExecutingQuery($sql00) {
		
			$rows		= array();
		
			try {
				
				$result	= $this->conn->query($sql00);
				while($row = $result->fetch()) {
					$rows[]	=	$row;
				}
				
			} catch(PDOException $e) {
				$err	= 'genericdb getRecordsetExecutingQuery ('.$sql00.') '.$e->getMessage();
				_errorLog($err);
			}		
		
			return $rows;
			
		}

		public function getNextID($tblName, $colName) {
			if(strpos($tblName, "'") !== false) return false;
			if(strpos($colName, "'") !== false) return false;
			
			if(strpos($tblName, '"') !== false) return false;
			if(strpos($colName, '"') !== false) return false;			
			
			$maxid			=	0;
			$sql				=	"SELECT MAX(`$colName`) FROM `$tblName`";

			try {
				
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch())
					$maxid 	= $row[0];

			} catch(PDOException $e) {
				$err	= 'genericdb getNextID '.$e->getMessage();
				_errorLog($err);
			}			

			$maxid++;
			return $maxid;
			
		}
		
		public function SaveObjectToDB($ocls) {
			$sql		= $ocls->getInsertSQL();
			return $this->ExecuteQuery($sql);
		}
		
		public function UpdateObjectInDB($ocls) {
			$sql		= $ocls->getUpdateSQL();
			return $this->ExecuteQuery($sql);
		}
		
		public function RemoveObjectFromDB($ocls) {
			$sql		= $ocls->getDeleteSQL();
			return $this->ExecuteQuery($sql);
		}
		
		function getDataForJSON($tblName, $fld1, $fld2, $fld3 = '', $condn) {
			$tblName	= addslashes($tblName);
			$fld1			= addslashes($fld1);
			$fld2			= addslashes($fld2);
			$fld3			= addslashes($fld3);
	
			$iarr			= array();
			if($condn != '') {
				$tmp		= explode(",", $condn);
				for($i=0; $i<count($tmp); $i++) {
					$iarr[]	= addcslashes($tmp[$i], '"\\/');
				}
			}
	
			$sql			= "SELECT `$fld1`, `$fld2` FROM `$tblName` WHERE 1";
			if($fld3 != '')
				$sql		= "SELECT `$fld1`, `$fld2`, `$fld3` FROM `$tblName` WHERE 1";
			
			for($i=0; $i<count($iarr); $i++) {
				$sql		= $sql." AND ".$iarr[$i];
			}

			return $this->getRecordsetExecutingQuery($sql);
		}

	};

?>