<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Nov 20, 2014
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class asys_user_log {
		/**
		 * @Field		LogID
		 * @Type		bigint(20)
		 * @Access	Protected
		 */
		protected $LogID = 0;
			
		/**
		 * @Field		UserID
		 * @Type		varchar(60)
		 * @Access	Protected
		 */
		protected $UserID = "";

		/**
		 * @Field		LDate
		 * @Type		date
		 * @Access	Protected
		 */
		protected $LDate = "1900-01-01";

		/**
		 * @Field		LTime
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $LTime = 0;
		
		/**
		 * @Field		UserIP
		 * @Type		varchar(30)
		 * @Access	Protected
		 */
		protected $UserIP = "";
		
		/**
		 * @Field		CompanyID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyID = 0;

		/**
		 * @Field		CompanyName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyName = "";				

		/**
		 * @Field		ModuleID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $ModuleID = 0;

		/**
		 * @Field		RelatedID
		 * @Type		varchar(30)
		 * @Access	Protected
		 */
		protected $RelatedID = "";

		/**
		 * @Field		Activity
		 * @Type		varchar(500)
		 * @Access	Protected
		 */
		protected $Activity = "";
		
		/**
		 * @Field		ClassName
		 * @Type		varchar(100)
		 * @Access	Protected
		 */
		protected $ClassName = "";		

		/**
		 * @Field		ModuleSnapshot
		 * @Type		text
		 * @Access	Protected
		 */
		protected $ModuleSnapshot = "";
		
		/**
		 * @Field		PageURL
		 * @Type		varchar(500)
		 * @Access	Protected
		 */
		protected $PageURL = "";		

		
		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->LogID 					= (int)$this->LogID;
			$this->UserID 				= addslashes($this->UserID);
			$this->LDate 					= date('Y-m-d');
			$this->LTime 					= time();
			$this->UserIP 				= getClientIP();
			$this->CompanyID 			= (int)$this->CompanyID;
			$this->ModuleID 			= (int)$this->ModuleID;
			$this->RelatedID 			= addslashes($this->RelatedID);
			$this->Activity 			= addslashes($this->Activity);
			$this->ClassName 			= addslashes($this->ClassName);
			$this->ModuleSnapshot = addslashes($this->ModuleSnapshot);
			$this->PageURL 				= addslashes($this->PageURL);
		}		

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getLogID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->LogID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->LogID;
			} else {
				return $this->LogID;
			}
		}
				 
		public function getUserID($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->UserID),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->UserID;
			} else {
				return stripslashes($this->UserID);
			}
		}

		public function getLDate($formatted='no') {
			if($formatted == 'yes') {
				return FormatSQLDateToIndianDate($this->LDate);
			} else if($formatted=='asis') {
				return $this->LDate;
			} else {
				return stripslashes($this->LDate);
			}
		}

		public function getLTime($formatted='no') {
			if($formatted == 'yes') {
				return getDateFromTime($this->LTime);
			} else if($formatted=='asis') {
				return $this->LTime;
			} else {
				return $this->LTime;
			}
		}
		
		public function getUserIP($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->UserIP),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->UserIP;
			} else {
				return stripslashes($this->UserIP);
			}
		}
		
		public function getCompanyID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CompanyID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CompanyID;
			} else {
				return $this->CompanyID;
			}
		}

		public function getCompanyName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CompanyName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CompanyName;
			} else {
				return stripslashes($this->CompanyName);
			}
		}				

		public function getModuleID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ModuleID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ModuleID;
			} else {
				return $this->ModuleID;
			}
		}

		public function getRelatedID($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->RelatedID),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->RelatedID;
			} else {
				return stripslashes($this->RelatedID);
			}
		}

		public function getActivity($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Activity),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Activity;
			} else {
				return stripslashes($this->Activity);
			}
		}
		
		public function getClassName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ClassName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ClassName;
			} else {
				return stripslashes($this->ClassName);
			}
		}		

		public function getModuleSnapshot($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ModuleSnapshot),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ModuleSnapshot;
			} else {
				return stripslashes($this->ModuleSnapshot);
			}
		}
		
		public function getPageURL($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->PageURL),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->PageURL;
			} else {
				return stripslashes($this->PageURL);
			}
		}		

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setLogID($arg) {
			$this->LogID = (int)$arg;
		}
				 
		public function setUserID($arg) {
			$this->UserID = addslashes($arg);
		}

		public function setLDate($arg) {
			$this->LDate = FormatIndianDateToSQLDate($arg);
		}

		public function setLTime($arg) {
			$this->LTime = (int)$arg;
		}
		
		public function setUserIP($arg) {
			$this->UserIP = addslashes($arg);
		}	
		
		public function setCompanyID($arg) {
			$this->CompanyID = (int)$arg;
		}

		public function setCompanyName($arg) {
			$this->CompanyName = addslashes($arg);
		}			

		public function setModuleID($arg) {
			$this->ModuleID = (int)$arg;
		}

		public function setRelatedID($arg) {
			$this->RelatedID = addslashes($arg);
		}

		public function setActivity($arg) {
			$this->Activity = addslashes($arg);
		}
		
		public function setClassName($arg) {
			$this->ClassName = addslashes($arg);
		}		

		public function setModuleSnapshot($arg) {
			$this->ModuleSnapshot = addslashes($arg);
		}
		
		public function setPageURL($arg) {
			$this->PageURL = addslashes($arg);
		}		

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `asys_user_log` (`LogID`, `UserID`, `LDate`, `LTime`, `UserIP`, `CompanyID`, `ModuleID`, `RelatedID`, `Activity`, `ClassName`, `ModuleSnapshot`, `PageURL`) VALUES(";
			$sql	=	$sql."'".$this->getLogID('asis')."', ";
			$sql	=	$sql."'".$this->getUserID('asis')."', ";
			$sql	=	$sql."'".$this->getLDate('asis')."', ";
			$sql	=	$sql."'".$this->getLTime('asis')."', ";
			$sql	=	$sql."'".$this->getUserIP('asis')."', ";
			$sql	=	$sql."'".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."'".$this->getModuleID('asis')."', ";
			$sql	=	$sql."'".$this->getRelatedID('asis')."', ";
			$sql	=	$sql."'".$this->getActivity('asis')."', ";
			$sql	=	$sql."'".$this->getClassName('asis')."', ";
			$sql	=	$sql."'".$this->getModuleSnapshot('asis')."', ";
			$sql	=	$sql."'".$this->getPageURL('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `asys_user_log` SET ";
			$sql	=	$sql."`UserID` = '".$this->getUserID('asis')."', ";
			$sql	=	$sql."`LDate` = '".$this->getLDate('asis')."', ";
			$sql	=	$sql."`LTime` = '".$this->getLTime('asis')."', ";
			$sql	=	$sql."`UserIP` = '".$this->getUserIP('asis')."', ";
			$sql	=	$sql."`CompanyID` = '".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."`ModuleID` = '".$this->getModuleID('asis')."', ";
			$sql	=	$sql."`RelatedID` = '".$this->getRelatedID('asis')."', ";
			$sql	=	$sql."`Activity` = '".$this->getActivity('asis')."', ";
			$sql	=	$sql."`ClassName` = '".$this->getClassName('asis')."', ";
			$sql	=	$sql."`ModuleSnapshot` = '".$this->getModuleSnapshot('asis')."', ";
			$sql	=	$sql."`PageURL` = '".$this->getPageURL('asis')."' ";
			$sql	=	$sql." WHERE `LogID` = '".$this->getLogID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `asys_user_log` ";
			$sql	=	$sql." WHERE `LogID` = '".$this->getLogID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div>'.$this->getUserID('yes').'</div>
				<div>'.$this->getLDate('yes').'</div>
				<div>'.$this->getLTime('yes').'</div>
				<div>'.$this->getModuleID('yes').'</div>
				<div>'.$this->getRelatedID('yes').'</div>
				<div>'.$this->getActivity('yes').'</div>
				<div>'.$this->getClassName('yes').'</div>
				<div>'.$this->getModuleSnapshot('yes').'</div>
			';

			return $str;
		}
	};

?>