<?php

	class logindb {

		protected $host			= SS_DB_HOST;
		protected $user			= SS_DB_USER;
		protected $password	= SS_DB_PASSWORD;
		protected $dbname		= SS_DB_DBNAME;
		protected $conn			= null;

		public function __construct($dbType = '') {
			
			if (!extension_loaded('pdo')) {
				die (SS_DB_ERR_101);
			}
			
			if($dbType == "REPORT") {
				$this->user 		= SS_RPT_USER;
				$this->password	= SS_RPT_PASSWORD;
			} else if($dbType == "DATA") {
				$this->user 		= SS_DBA_USER;
				$this->password	= SS_DBA_PASSWORD;			
			}
			
			try {
				$this->conn = new PDO("mysql:host=".$this->host.";dbname=".$this->dbname, $this->user, $this->password);
				$this->conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
			} catch(PDOException $e) {
				die('DB connection error '.$e->getMessage());
			}			
				
		}
		
		public function __destruct() {
			$this->conn	= null;
		}		
		
		private function getResultExecutingQuery($sql00) {

			$res		= "";
		
			try {
				
				$result	= $this->conn->query($sql00);
				if($row = $result->fetch()) {
					$res	=	$row[0];
				}
				
			} catch(PDOException $e) {
				$err	= 'logindb getResultExecutingQuery ('.$sql00.') '.$e->getMessage();
				_errorLog($err);
			}		
		
			return $res;
			
		}

		private function getRecordsetExecutingQuery($sql00) {
		
			$rows		= array();
		
			try {
				
				$result	= $this->conn->query($sql00);
				while($row = $result->fetch()) {
					$rows[]	=	$row;
				}
				
			} catch(PDOException $e) {
				$err	= 'logindb getRecordsetExecutingQuery ('.$sql00.') '.$e->getMessage();
				_errorLog($err);
			}
		
			return $rows;
			
		}		
		
		function getCompanyNameByCompanyID($CompanyID) {
			$CompanyID		= (int)$CompanyID;
			$sql		=	"SELECT `CompanyName` FROM `asys_companies` WHERE `CompanyID`='$CompanyID'";
			return $this->getResultExecutingQuery($sql);
		}				

		function verifyAdminUser($UserID, $Password) {
		
			$retVal		= 0;
			$orgPas		= "";		
		
			try {
				
				$sql		= "SELECT * FROM `asys_adminusers` WHERE `UserID`=? ";
				$pds		= $this->conn->prepare($sql);
				$pds->bindParam(1, $UserID);
				$pds->execute();
				if($row = $pds->fetch()) {
					$Password	=	md5($Password);
					$orgPas		= $row['Password'];
					if($orgPas == $Password)
						$retVal	= 1;
				}	else {
					$retVal		= -1;
				}
				
			} catch(PDOException $e) {
				$err	= 'logindb verifyAdminUser '.$e->getMessage();
				_errorLog($err);
			}
			
			return $retVal;		

		}
		
		function updateAdminPassword($UserID, $Password) {
			
			$Password	=	md5($Password);
			$rst			= false;
			
			try {
				
				$sql		= "UPDATE `asys_adminusers` SET `Password`=? WHERE `UserID`=? LIMIT 1";
				$pds		= $this->conn->prepare($sql);
				$pds->bindParam(1, $Password);
				$pds->bindParam(2, $UserID);
				$rst 		= $pds->execute();				
				
			} catch(PDOException $e) {
				$err	= 'logindb updateAdminPassword '.$e->getMessage();
				_errorLog($err);
			}
			
			return $rst;			

		}		
		
		function verifyUser($UserID, $Password) {
		
			$retVal		= 0;
			$orgPas		= "";		
		
			try {
				
				$sql		= "SELECT * FROM `asys_users` WHERE `UserID`=? ";
				$pds		= $this->conn->prepare($sql);
				$pds->bindParam(1, $UserID);
				$pds->execute();
				if($row = $pds->fetch()) {
					$Password	=	md5($Password);
					$orgPas		= $row['Password'];
					if($orgPas == $Password)
						$retVal	= 1;
				}	else {
					$retVal		= -1;
				}
				
			} catch(PDOException $e) {
				$err	= 'logindb verifyUser '.$e->getMessage();
				_errorLog($err);
			}
			
			return $retVal;		

		}		
		
		function updatePassword($UserID, $Password) {
			
			$Password	=	md5($Password);
			$rst			= false;
			
			try {
				
				$sql		= "UPDATE `asys_users` SET `Password`=? WHERE `UserID`=? LIMIT 1";
				$pds		= $this->conn->prepare($sql);
				$pds->bindParam(1, $Password);
				$pds->bindParam(2, $UserID);
				$rst		= $pds->execute();				
				
			} catch(PDOException $e) {
				$err	= 'logindb updatePassword '.$e->getMessage();
				_errorLog($err);
			}
			
			return $rst;			

		}
		
		function updateLoginInfo($UserID, $IP) {
		
			$tt		=	time();
		
			try {
				
				$sql	=	"UPDATE `asys_users` SET `LastLogin`=?, `LastLoginIP`=? WHERE `UserID`=? LIMIT 1";
				$pds		= $this->conn->prepare($sql);
				$pds->bindParam(1, $tt);
				$pds->bindParam(2, $IP);
				$pds->bindParam(3, $UserID);
				$pds->execute();				
				
			} catch(PDOException $e) {
				$err	= 'logindb updateLoginInfo '.$e->getMessage();
				_errorLog($err);
			}	

		}				

		/*----------------------------------------------------------------*/
		/*********************** ADMIN USER METHODS ***********************/

		function getAdminUserDetail($UserID) {
			
			if(strpos($UserID, "'") !== false) $UserID = addslashes($UserID);
			$cclass			=	new asys_adminusers();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_adminusers` WHERE `UserID`='$UserID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_adminusers');
				if($row 	= $result->fetch())
					$cclass	= $row;
				
			} catch(PDOException $e) {
				$err	= 'logindb getAdminUserDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getAdminUserList() {
			
			$userVector	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_adminusers` ORDER BY `UserName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_adminusers');
				while($row = $result->fetch())
					$userVector[]	= $row;
				
			} catch(PDOException $e) {
				$err	= 'logindb getAdminUserList '.$e->getMessage();
				_errorLog($err);
			}

			return $userVector;
		}

		function doAdminUserExists($UserID) {
		
			if(strpos($UserID, "'") !== false) $UserID = addslashes($UserID);
			$rst				=	false;
			
			try {
				
				$sql			=	"SELECT * FROM `asys_adminusers` WHERE `UserID`='$UserID'";
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch())
					$rst		= true;
				
			} catch(PDOException $e) {
				$err	= 'logindb doAdminUserExists '.$e->getMessage();
				_errorLog($err);
			}		

			return $rst;
		}

		function deleteAdminUser($ucls) {
			
			$rst				= false;
			$sql				= $ucls->getDeleteSQL();
			
			try {
				
				$rst			= $this->conn->query($sql);
				
			} catch(PDOException $e) {
				$err	= 'logindb deleteAdminUser '.$e->getMessage();
				_errorLog($err);
			}	
			
			return $rst;		

		}
		
		
		/*----------------------------------------------------------*/
		/*********************** USER METHODS ***********************/

		function getUserDetail($UserID) {
			
			if(strpos($UserID, "'") !== false) $UserID = addslashes($UserID);
			$cclass			=	new asys_users();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_users` WHERE `UserID`='$UserID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_users');
				if($row 	= $result->fetch())
					$cclass	= $row;
				
			} catch(PDOException $e) {
				$err	= 'logindb getUserDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getUserList() {
			
			$userVector	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_users` ORDER BY `UserName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_users');
				while($row = $result->fetch())
					$userVector[]	= $row;
				
			} catch(PDOException $e) {
				$err	= 'logindb getUserList '.$e->getMessage();
				_errorLog($err);
			}

			return $userVector;
		}
		
		function getUserList2() {
			
			$userVector	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_users` WHERE `UserStatus` != 4 ORDER BY `UserName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_users');
				while($row = $result->fetch())
					$userVector[]	= $row;
				
			} catch(PDOException $e) {
				$err	= 'logindb getUserList '.$e->getMessage();
				_errorLog($err);
			}

			return $userVector;
		}
		
		function getUserListJSON(){
			$sql		= "SELECT `UserID`, `UserName` FROM `asys_users` ORDER BY `UserName`";
			return $this->getRecordsetExecutingQuery($sql);
		}		
		
		function getUserNameByUserID($UserID) {
			$UserID	= addslashes($UserID);
			$sql		=	"SELECT `UserName` FROM `asys_users` WHERE `UserID`='$UserID'";
			return $this->getResultExecutingQuery($sql);
		}		

		function doUserExists($UserID) {
		
			if(strpos($UserID, "'") !== false) $UserID = addslashes($UserID);
			$rst				=	false;
			
			try {
				
				$sql			=	"SELECT * FROM `asys_users` WHERE `UserID`='$UserID'";
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch())
					$rst		= true;
				
			} catch(PDOException $e) {
				$err	= 'logindb doUserExists '.$e->getMessage();
				_errorLog($err);
			}		

			return $rst;
		}

		function deleteUser($ucls) {
			
			$rst				= false;
			$sql				= $ucls->getDeleteSQL();
			

			try {
			
				$this->conn->beginTransaction();
				
				$sql		= "DELETE FROM `asys_user_permission` WHERE `UserID`='".$ucls->getUserID()."'";
				$this->conn->exec($sql);
				$sql		= "DELETE FROM `asys_user_companies` WHERE `UserID`='".$ucls->getUserID()."'";
				$this->conn->exec($sql);
				$sql		= $ucls->getDeleteSQL();
				$rst		= $this->conn->exec($sql);
			
				$this->conn->commit();
			
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				
			}
	
			
			return $rst;		

		}	
		
		function enableUser($UserID) {
			
			if(strpos($UserID, "'") !== false) $UserID = addslashes($UserID);
			$rst		= false;
			$sql		=	"UPDATE `asys_users` SET `IsEnabled` = 'YES' WHERE `UserID` = '$UserID'";
			
			try {
				
				$rst	= $this->conn->query($sql);
				
			} catch(PDOException $e) {
				$err	= 'logindb enableUser '.$e->getMessage();
				_errorLog($err);
			}	
			
			return $rst;		

		}
		
		function disableUser($UserID) {
			
			if(strpos($UserID, "'") !== false) $UserID = addslashes($UserID);
			$rst		= false;
			$sql		=	"UPDATE `asys_users` SET `IsEnabled` = 'NO' WHERE `UserID` = '$UserID'";
			
			try {
				
				$rst	= $this->conn->query($sql);

			} catch(PDOException $e) {
				$err	= 'logindb disableUser '.$e->getMessage();
				_errorLog($err);
			}	
			
			return $rst;		

		}					
		
		
		/*---------------------------------------------------------*/
		/*********************** LOG METHODS ***********************/
		
		function getLogDetail($LogID) {
			
			$cclass				=	new asys_user_log();
			
			try {
				
				$sql				= "SELECT * FROM `asys_user_log` WHERE `LogID`='$LogID'";
				
				$result			= $this->conn->query($sql, PDO::FETCH_ASSOC);
				if($row 	= $result->fetch()) {
					$cclass->setLogID($row["LogID"]);
					$cclass->setUserID($row["UserID"]);
					$cclass->setLDate($row["LDate"]);
					$cclass->setLTime($row["LTime"]);
					$cclass->setUserIP($row["UserIP"]);
					$cclass->setCompanyID($row["CompanyID"]);
					$cclass->setCompanyName($this->getCompanyNameByCompanyID($row["CompanyID"]));
					$cclass->setModuleID($row["ModuleID"]);
					$cclass->setRelatedID($row["RelatedID"]);
					$cclass->setActivity($row["Activity"]);
					$cclass->setClassName($row["ClassName"]);
					$cclass->setModuleSnapshot($row["ModuleSnapshot"]);
					$cclass->setPageURL($row["PageURL"]);
				}

			} catch(PDOException $e) {
				$err	= 'logindb getLogDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}		
		
		function getLogListBySQL($sql) {
			
			$arr					=	array();
			
			try {
				
				$result			= $this->conn->query($sql, PDO::FETCH_ASSOC);
				while($row 	= $result->fetch()) {
					$cclass		= new asys_user_log();
					$cclass->setLogID($row["LogID"]);
					$cclass->setUserID($row["UserID"]);
					$cclass->setLDate($row["LDate"]);
					$cclass->setLTime($row["LTime"]);
					$cclass->setUserIP($row["UserIP"]);
					$cclass->setCompanyID($row["CompanyID"]);
					$cclass->setCompanyName($this->getCompanyNameByCompanyID($row["CompanyID"]));
					$cclass->setModuleID($row["ModuleID"]);
					$cclass->setRelatedID($row["RelatedID"]);
					$cclass->setActivity($row["Activity"]);
					$cclass->setClassName($row["ClassName"]);
					$cclass->setModuleSnapshot($row["ModuleSnapshot"]);
					$cclass->setPageURL($row["PageURL"]);
					$arr[]		= $cclass;
				}
				
			} catch(PDOException $e) {
				$err	= 'logindb getLogListBySQL '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getLastUserByModuleRelatedID($ModuleID, $RelatedID) {
			$ModuleID			= (int)$ModuleID;
			$RelatedID		= (int)$RelatedID;
			$user					=	"";
			$sql					= "SELECT `UserID` FROM `asys_user_log` WHERE `ModuleID`='$ModuleID' AND `RelatedID`='$RelatedID' ORDER BY `LTime` DESC";
			
			try {
				$conn 			= new PDO("mysql:host=".$this->host.";dbname=".$this->dbname, $this->user, $this->password);
				$conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
				
				$result			= $conn->query($sql, PDO::FETCH_ASSOC);
				while($row 	= $result->fetch()) {

					$user			= $row["UserID"];
					break;

				}
				
				$conn				= null;
			} catch(PDOException $e) {
				$err	= 'logindb getLogListBySQL (line 451) '.$e->getMessage();
				_errorLog($err);
			}

			return $user;
		}		
		
		function getLogStringByModuleRelatedID($CompanyID, $ModuleID, $RelatedID) {
			
			$sql					= "SELECT * FROM `asys_user_log` WHERE `CompanyID`='$CompanyID' AND `ModuleID`='$ModuleID' AND `RelatedID`='$RelatedID'";
			$sstr					= "";
			
			try {
				
				$result			= $this->conn->query($sql, PDO::FETCH_ASSOC);
				while($row 	= $result->fetch()) {
					if($sstr != "") $sstr	=	$sstr.", ";
					$sstr			= $sstr.$row["UserID"].'-'.getIndianDateFromTime($row["LTime"]);
				}
				
			} catch(PDOException $e) {
				$err	= 'logindb getLogStringByModuleRelatedID '.$e->getMessage();
				_errorLog($err);
			}

			return $sstr;
		}
		
		function getLogStringByModuleRelatedID2($CompanyID, $ModuleID, $RelatedID) {
			
			$sql					= "SELECT `UserID` FROM `asys_user_log` WHERE `CompanyID`='$CompanyID' AND `ModuleID`='$ModuleID' AND `RelatedID`='$RelatedID'";
			$this->getResultExecutingQuery($sql);
			
		}		
		
		

		/*---------------------------------------------------------------------*/
		/*********************** USER PERMISSION METHODS ***********************/

		function getUserPermissionDetail($UserID, $CompanyID) {
			$UserID			= addslashes($UserID);
			$CompanyID	= (int)$CompanyID;
			$cclass			=	new asys_user_permission();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_user_permission` WHERE `CompanyID`='$CompanyID' AND `UserID`='$UserID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_user_permission');
				if($row 	= $result->fetch()) { 
					$row->setModuleName($this->getModuleNameByModuleID($row->getModuleID()));	
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'logindb getUserPermissionDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getUserPermissionList($UserID, $CompanyID) {
			$UserID			= addslashes($UserID);
			$CompanyID	= (int)$CompanyID;		
			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_user_permission` WHERE `CompanyID`='$CompanyID' AND `UserID`='$UserID' ORDER BY `ModuleID`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_user_permission');
				while($row = $result->fetch()) {
					$row->setModuleName($this->getModuleNameByModuleID($row->getModuleID()));
					$arr[]	= $row;				
				}
				
			} catch(PDOException $e) {
				$err	= 'logindb getUserPermissionList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function deleteUserPermission($lcls) {
		
			$pkey	= $lcls->getUserID();
			$ret				= false;
		
			try {
				
				$sql			=	"SELECT * FROM `gen_rooms` WHERE `UserID`='$pkey'";
				$result		= $this->conn->query($sql);
				if(!$row 	= $result->fetch()) {
					$sql		= $lcls->getDeleteSQL();
					
					$ret		= $this->conn->query($sql);
				}
				
			} catch(PDOException $e) {
				$err	= 'logindb deleteUserPermission '.$e->getMessage();
				_errorLog($err);
			}			
		
			return $ret;
		}

		function getCreatePermission($UserID, $ModuleID, $CompanyID) {
			$UserID			= addslashes($UserID);
			$ModuleID		= (int)$ModuleID;
			$CompanyID	= (int)$CompanyID;		
		
			$sql			=	"SELECT `DoCreate` FROM `asys_user_permission` WHERE `UserID`='$UserID' AND `ModuleID`='$ModuleID' AND `CompanyID`='$CompanyID'";
			return $this->getResultExecutingQuery($sql);

		}	
		
		function getEditPermission($UserID, $ModuleID, $CompanyID) {
			$UserID			= addslashes($UserID);
			$ModuleID		= (int)$ModuleID;
			$CompanyID	= (int)$CompanyID;		
		
			$sql			=	"SELECT `DoEdit` FROM `asys_user_permission` WHERE `UserID`='$UserID' AND `ModuleID`='$ModuleID' AND `CompanyID`='$CompanyID'";
			return $this->getResultExecutingQuery($sql);

		}	
		
		function getDeletePermission($UserID, $ModuleID, $CompanyID) {
			$UserID			= addslashes($UserID);
			$ModuleID		= (int)$ModuleID;
			$CompanyID	= (int)$CompanyID;		
		
			$sql			=	"SELECT `DoDelete` FROM `asys_user_permission` WHERE `UserID`='$UserID' AND `ModuleID`='$ModuleID' AND `CompanyID`='$CompanyID'";
			return $this->getResultExecutingQuery($sql);

		}
		
		function getViewPermission($UserID, $ModuleID, $CompanyID) {
			$UserID			= addslashes($UserID);
			$ModuleID		= (int)$ModuleID;
			$CompanyID	= (int)$CompanyID;		
		
			$sql			=	"SELECT `DoView` FROM `asys_user_permission` WHERE `UserID`='$UserID' AND `ModuleID`='$ModuleID' AND `CompanyID`='$CompanyID'";
			return $this->getResultExecutingQuery($sql);

		}
		
		function setUserCompanies($UserID, $CompanyID) {
			$UserID			= addslashes($UserID);
			$CompanyID	= (int)$CompanyID;				
			
			$ret				= false;
		
			try {
				
				$sql			=	"SELECT `UserID` FROM `asys_user_permission` WHERE `UserID`='$UserID' AND `CompanyID`='$CompanyID'";
				$result		= $this->conn->query($sql, PDO::FETCH_NUM);
				if($row 	= $result->fetch())	{
					$sql			=	"UPDATE `asys_user_permission` SET `DoCreate`='$Permission' WHERE `UserID`='$UserID' AND `ModuleID`='$ModuleID' AND `CompanyID`='$CompanyID' LIMIT 1";
				}	else {
					$sql	=	"INSERT INTO `asys_user_permission` (`CompanyID`, `UserID`, `ModuleID`, `DoCreate`, `DoEdit`, `DoDelete`, `DoView`) VALUES(";
					$sql	=	$sql."'".$CompanyID."', ";
					$sql	=	$sql."'".$UserID."', ";
					$sql	=	$sql."'".$ModuleID."', ";
					$sql	=	$sql."'".$Permission."', ";
					$sql	=	$sql."'NO', ";
					$sql	=	$sql."'NO', ";
					$sql	=	$sql."'NO')";
				}	
				
				$ret		= $this->conn->query($sql);
				
			} catch(PDOException $e) {
				$err	= 'logindb setUserCompanies '.$e->getMessage();
				_errorLog($err);
			}			
		
			return $ret;

		}
		
		function setCreatePermission($UserID, $ModuleID, $CompanyID, $Permission) {		
			$UserID			= addslashes($UserID);
			$ModuleID		= (int)$ModuleID;
			$CompanyID	= (int)$CompanyID;			
			$ret				= false;
		
			try {
				
				$sql			=	"SELECT `DoCreate` FROM `asys_user_permission` WHERE `UserID`='$UserID' AND `ModuleID`='$ModuleID' AND `CompanyID`='$CompanyID'";
				$result		= $this->conn->query($sql, PDO::FETCH_NUM);
				if($row 	= $result->fetch())	{
					$sql			=	"UPDATE `asys_user_permission` SET `DoCreate`='$Permission' WHERE `UserID`='$UserID' AND `ModuleID`='$ModuleID' AND `CompanyID`='$CompanyID' LIMIT 1";
				}	else {
					$sql	=	"INSERT INTO `asys_user_permission` (`CompanyID`, `UserID`, `ModuleID`, `DoCreate`, `DoEdit`, `DoDelete`, `DoView`) VALUES(";
					$sql	=	$sql."'".$CompanyID."', ";
					$sql	=	$sql."'".$UserID."', ";
					$sql	=	$sql."'".$ModuleID."', ";
					$sql	=	$sql."'".$Permission."', ";
					$sql	=	$sql."'NO', ";
					$sql	=	$sql."'NO', ";
					$sql	=	$sql."'NO')";
				}	
				
				$ret		= $this->conn->query($sql);
				
			} catch(PDOException $e) {
				$err	= 'logindb setCreatePermission '.$e->getMessage();
				_errorLog($err);
			}			
		
			return $ret;

		}				
		
		function setEditPermission($UserID, $ModuleID, $CompanyID, $Permission) {
			$UserID			= addslashes($UserID);
			$ModuleID		= (int)$ModuleID;
			$CompanyID	= (int)$CompanyID;		
		
			$ret				= false;
		
			try {
				
				$sql			=	"SELECT `DoEdit` FROM `asys_user_permission` WHERE `UserID`='$UserID' AND `ModuleID`='$ModuleID' AND `CompanyID`='$CompanyID'";
				$result		= $this->conn->query($sql, PDO::FETCH_NUM);
				if($row 	= $result->fetch())	{
					$sql			=	"UPDATE `asys_user_permission` SET `DoEdit`='$Permission' WHERE `UserID`='$UserID' AND `ModuleID`='$ModuleID' AND `CompanyID`='$CompanyID' LIMIT 1";
				}	else {
					$sql	=	"INSERT INTO `asys_user_permission` (`CompanyID`, `UserID`, `ModuleID`, `DoCreate`, `DoEdit`, `DoDelete`, `DoView`) VALUES(";
					$sql	=	$sql."'".$CompanyID."', ";
					$sql	=	$sql."'".$UserID."', ";
					$sql	=	$sql."'".$ModuleID."', ";
					$sql	=	$sql."'NO', ";
					$sql	=	$sql."'".$Permission."', ";
					$sql	=	$sql."'NO', ";
					$sql	=	$sql."'NO')";
				}	
				
				$ret		= $this->conn->query($sql);
				
			} catch(PDOException $e) {
				$err	= 'logindb setEditPermission '.$e->getMessage();
				_errorLog($err);
			}			
		
			return $ret;

		}	
		
		function setDeletePermission($UserID, $ModuleID, $CompanyID, $Permission) {
			$UserID			= addslashes($UserID);
			$ModuleID		= (int)$ModuleID;
			$CompanyID	= (int)$CompanyID;		
		
			$ret				= false;
		
			try {
				
				$sql			=	"SELECT `DoDelete` FROM `asys_user_permission` WHERE `UserID`='$UserID' AND `ModuleID`='$ModuleID' AND `CompanyID`='$CompanyID'";
				$result		= $this->conn->query($sql, PDO::FETCH_NUM);
				if($row 	= $result->fetch())	{
					$sql			=	"UPDATE `asys_user_permission` SET `DoDelete`='$Permission' WHERE `UserID`='$UserID' AND `ModuleID`='$ModuleID' AND `CompanyID`='$CompanyID' LIMIT 1";
				}	else {
					$sql	=	"INSERT INTO `asys_user_permission` (`CompanyID`, `UserID`, `ModuleID`, `DoCreate`, `DoEdit`, `DoDelete`, `DoView`) VALUES(";
					$sql	=	$sql."'".$CompanyID."', ";
					$sql	=	$sql."'".$UserID."', ";
					$sql	=	$sql."'".$ModuleID."', ";
					$sql	=	$sql."'NO', ";
					$sql	=	$sql."'NO', ";
					$sql	=	$sql."'".$Permission."', ";
					$sql	=	$sql."'NO')";
				}	
				
				$ret		= $this->conn->query($sql);
				
			} catch(PDOException $e) {
				$err	= 'logindb setDeletePermission '.$e->getMessage();
				_errorLog($err);
			}			
		
			return $ret;

		}
		
		function setViewPermission($UserID, $ModuleID, $CompanyID, $Permission) {
			$UserID			= addslashes($UserID);
			$ModuleID		= (int)$ModuleID;
			$CompanyID	= (int)$CompanyID;		
		
			$ret				= false;
		
			try {
				
				$sql			=	"SELECT `DoView` FROM `asys_user_permission` WHERE `UserID`='$UserID' AND `ModuleID`='$ModuleID' AND `CompanyID`='$CompanyID'";
				$result		= $this->conn->query($sql, PDO::FETCH_NUM);
				if($row 	= $result->fetch())	{
					$sql			=	"UPDATE `asys_user_permission` SET `DoView`='$Permission' WHERE `UserID`='$UserID' AND `ModuleID`='$ModuleID' AND `CompanyID`='$CompanyID' LIMIT 1";
				}	else {
					$sql	=	"INSERT INTO `asys_user_permission` (`CompanyID`, `UserID`, `ModuleID`, `DoCreate`, `DoEdit`, `DoDelete`, `DoView`) VALUES(";
					$sql	=	$sql."'".$CompanyID."', ";
					$sql	=	$sql."'".$UserID."', ";
					$sql	=	$sql."'".$ModuleID."', ";
					$sql	=	$sql."'NO', ";
					$sql	=	$sql."'NO', ";
					$sql	=	$sql."'NO', ";
					$sql	=	$sql."'".$Permission."')";
				}	
				
				$ret		= $this->conn->query($sql);
				
			} catch(PDOException $e) {
				$err	= 'logindb setViewPermission '.$e->getMessage();
				_errorLog($err);
			}			
		
			return $ret;

		}
		
		
		
		/*-----------------------------------------------------------------*/
		/*********************** USER LEDGER METHODS ***********************/

		function getUserLedgerDetail($UserID) {
			$UserID			= addslashes($UserID);
			$cclass			=	new asys_user_ledger();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_user_ledger` WHERE `UserID`='$UserID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_user_ledger');
				if($row 	= $result->fetch()) { 	
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'logindb getUserLedgerDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getUserLedgerList() {
			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_user_ledger` ORDER BY `UserID`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_user_ledger');
				while($row = $result->fetch()) {
					$arr[]	= $row;				
				}
				
			} catch(PDOException $e) {
				$err	= 'logindb getUserLedgerList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getCompanyIDByModuleID($ModuleID) {
			$ModuleID	= (int)$ModuleID;
			$sql			=	"SELECT `CompanyID` FROM `asys_modules` WHERE `ModuleID`='$ModuleID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getModuleNameByModuleID($ModuleID) {
			$ModuleID	= (int)$ModuleID;
			$sql			=	"SELECT `ModuleName` FROM `asys_modules` WHERE `ModuleID`='$ModuleID'";
			return $this->getResultExecutingQuery($sql);
		}		
				
		
	};

?>