<?php

	class masterdb {

		protected $host			= SS_DB_HOST;
		protected $user			= SS_DB_USER;
		protected $password	= SS_DB_PASSWORD;
		protected $dbname		= SS_DB_DBNAME;
		protected $conn			= null;
		
		private function ExecuteQuery($sql00) {
		
			$res	= false;

			try {
				
				$res	= $this->conn->query($sql00);
				
			} catch(PDOException $e) {
				$err	= 'masterdb ExecuteQuery ('.$sql00.') '.$e->getMessage();
				_errorLog($err);
			}
			
			return $res;
			
		}

		private function getRecordsetExecutingQuery($sql00) {
		
			$rows		= array();
		
			try {
				
				$result	= $this->conn->query($sql00);
				while($row = $result->fetch()) {
					$rows[]	=	$row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getRecordsetExecutingQuery ('.$sql00.') '.$e->getMessage();
				_errorLog($err);
			}
		
			return $rows;
			
		}
		
		private function getResultExecutingQuery($sql00) {
		
			$rows		= array();
			$res		= "";
		
			try {
				
				$result	= $this->conn->query($sql00);
				if($row = $result->fetch()) {
					$res	=	$row[0];
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getResultExecutingQuery ('.$sql00.') '.$e->getMessage();
				_errorLog($err);
			}
		
			return $res;
			
		}
		
		function getUserCompanyStat($UserID, $CompanyID) {
			$UserID			= addslashes($UserID);
			$CompanyID	= (int)$CompanyID;
				
			$sql			=	"SELECT `UserID` FROM `asys_user_companies` WHERE `UserID`='$UserID' AND `CompanyID`='$CompanyID'";
			$ret				= false;
		
			try {

				$result		= $this->conn->query($sql, PDO::FETCH_NUM);
				if($row 	= $result->fetch())	{
					$ret				= true;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getUserCompanyStat '.$e->getMessage();
				_errorLog($err);
			}
		
			return $ret;
		}
		
		public function getNextID($tblName, $colName) {
			if(strpos($tblName, "'") !== false) return false;
			if(strpos($colName, "'") !== false) return false;
			
			if(strpos($tblName, '"') !== false) return false;
			if(strpos($colName, '"') !== false) return false;
			
			$maxid			=	0;
			$sql				=	"SELECT MAX(`$colName`) FROM `$tblName`";

			try {
				
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch())
					$maxid 	= $row[0];
					
			} catch(PDOException $e) {
				$err	= 'masterdb getNextID '.$e->getMessage();
				_errorLog($err);
			}

			$maxid++;
			return $maxid;
			
		}
		
		function getConfigDetail($ConfigID) {
			$ConfigID	= (int)$ConfigID;
			$cclass			=	new asys_config();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_config` WHERE `ConfigID`='$ConfigID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_config');
				if($row 	= $result->fetch()) { 
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getConfigDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}
		
		function getCompanyNameByCompanyID($CompanyID) {
			$CompanyID		= (int)$CompanyID;
			$sql		=	"SELECT `CompanyName` FROM `asys_companies` WHERE `CompanyID`='$CompanyID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getCompanyCodeByCompanyID($CompanyID) {
			$CompanyID		= (int)$CompanyID;
			$sql		=	"SELECT `CompanyCode` FROM `asys_companies` WHERE `CompanyID`='$CompanyID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getBrandNameByBrandID($BrandID) {
			$sql		=	"SELECT `BrandName` FROM `gen_brand` WHERE `BrandID`='$BrandID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		private function asysFunction() {
		
			$host			= $_SERVER['HTTP_HOST'];
			$host			= str_ireplace('www', '', $host);
			$host			= $host.".SP"."@"."ndey";
			$mhost		= MD5($host);

			$ret			= false;
			
			try {
			
				$sql		= "SELECT * FROM `asys_stock_opening` ORDER BY `Id` LIMIT 4";
				
				$result	= $this->conn->query($sql);
				while($row = $result->fetch()) {
					$val	=	$row[1];
					if($val == $mhost) {
						$ret = true;
						break;
					}
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb validateDomain '.$e->getMessage();
				_errorLog($err);
			}			
			
			return $ret;
		}
		
		
		
		/*----------------------------------------------------------------*/
		/*********************** BASE GROUP METHODS ***********************/

		function getBaseGroupDetail($BGID) {
			$BGID				= (int)$BGID;
			$cclass			=	new asys_base_group();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_base_group` WHERE `BGID`='$BGID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_base_group');
				if($row 	= $result->fetch()) {
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getBaseGroupDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getBaseGroupList() {
			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_base_group` ORDER BY `GroupName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_base_group');
				while($row = $result->fetch()) {
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getBaseGroupList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getBaseGroupListJSON(){
		
			$sql		= "SELECT `BGID`, `GroupName` FROM `asys_base_group` ORDER BY `GroupName`";
			return $this->getRecordsetExecutingQuery($sql);
		
		}

		function getBaseGroupNameByBaseGroupID($BGID) {
			$BGID		= (int)$BGID;
			$sql		=	"SELECT `GroupName` FROM `asys_base_group` WHERE `BGID`='$BGID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		
		
		/*--------------------------------------------------------------*/
		/*********************** SUBGROUP METHODS ***********************/

		function getSubgroupDetail($SubgroupID) {
			$SubgroupID	= (int)$SubgroupID;
			$cclass			=	new asys_base_subgroup();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_base_subgroup` WHERE `SubgroupID`='$SubgroupID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_base_subgroup');
				if($row 	= $result->fetch()) { 
					$row->setBGName($this->getBaseGroupNameByBaseGroupID($row->getBGID()));
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getSubgroupDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getSubgroupList($BGID) {
			$BGID	= (int)$BGID;
			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_base_subgroup` WHERE `BGID`='$BGID' ORDER BY `SubgroupName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_base_subgroup');
				while($row = $result->fetch()) {
					$row->setBGName($this->getBaseGroupNameByBaseGroupID($row->getBGID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getSubgroupList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getSubgroupListJSON($BGID){
		
			$sql		= "SELECT `SubgroupID`, `SubgroupName` FROM `asys_base_subgroup` WHERE `BGID`='$BGID' ORDER BY `SubgroupName`";
			return $this->getRecordsetExecutingQuery($sql);
		
		}
		
		function getNumberOfSubgroup($BGID, $schStr) {
			$BGID		= (int)$BGID;
			$schStr	= addslashes($schStr);
			
			$sql	=	"SELECT COUNT(*) FROM `asys_base_subgroup` WHERE `SubgroupID` != '0'";
			
			if($BGID != 0)
				$sql	= $sql." AND `BGID`='$BGID'";
			if($schStr != "")
				$sql	=	$sql." AND `SubgroupName` LIKE '%$schStr%'";
			
			return $this->getResultExecutingQuery($sql);
		}

		function getSubgroupListPaged($sRec, $nRec, $BGID, $schStr) {
			$BGID		= (int)$BGID;
			$schStr	= addslashes($schStr);
			
			$sql	=	"SELECT * FROM `asys_base_subgroup` WHERE `SubgroupID` != '0'";
			
			if($BGID != 0)
				$sql	= $sql." AND `BGID`='$BGID'";
			if($schStr != "")
				$sql	=	$sql." AND `SubgroupName` LIKE '%$schStr%'";
			$sql		= $sql." ORDER BY `SubgroupName` LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_base_subgroup');
				while($row = $result->fetch()) {
					$row->setBGName($this->getBaseGroupNameByBaseGroupID($row->getBGID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getSubgroupListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function getSubgroupNameBySubgroupID($SubgroupID) {
			$sql		=	"SELECT `SubgroupName` FROM `asys_base_subgroup` WHERE `SubgroupID`='$SubgroupID'";
			return $this->getResultExecutingQuery($sql);
		}

		function deleteSubgroup($lcls) {
		
			$pkey	= $lcls->getSubgroupID();
			$ret				= false;
		
			try {
				
				$sql			=	"SELECT * FROM `asys_accounts` WHERE `SubgroupID`='$pkey'";
				$result		= $this->conn->query($sql);
				if(!$row 	= $result->fetch()) {
					$sql		= $lcls->getDeleteSQL();
					$ret		= $this->conn->query($sql);
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb deleteSubgroup '.$e->getMessage();
				_errorLog($err);
			}
		
			return $ret;
		}
		
			
		
		/*-----------------------------------------------------------*/
		/*********************** GROUP METHODS ***********************/

		function getGroupDetail($GroupID) {
			$GroupID		= (int)$GroupID;
			$cclass			=	new asys_groups();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_groups` WHERE `GroupID`='$GroupID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_groups');
				if($row 	= $result->fetch()) {
					$cclass	= $row;
					$cclass->BaseGroupName($this->getBaseGroupNameByBaseGroupID($cclass->getBGID()));
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getGroupDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getGroupList() {
			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_groups` ORDER BY `GroupName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_groups');
				while($row = $result->fetch()) {
					$row->setBaseGroupName($this->getBaseGroupNameByBaseGroupID($row->getBGID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getGroupList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getGroupListJSON(){
		
			$sql		= "SELECT `GroupID`, `GroupName` FROM `asys_groups` ORDER BY `GroupName`";
			return $this->getRecordsetExecutingQuery($sql);
		
		}

		function getGroupNameByGroupID($GroupID) {
			$GroupID	= (int)$GroupID;
			$sql			=	"SELECT `GroupName` FROM `asys_groups` WHERE `GroupID`='$GroupID'";
			return $this->getResultExecutingQuery($sql);
		}

		function getBaseGroupByGroupID($GroupID){
			$GroupID	= (int)$GroupID;
			$sql			=	"SELECT `BGID` FROM `asys_groups` WHERE `GroupID`='$GroupID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		
		
		/*------------------------------------------------------------------*/
		/*********************** BASE VOUCHER METHODS ***********************/

		function getBaseVoucherDetail($BVID) {
			$BVID				= (int)$BVID;
			$cclass			=	new asys_base_voucher();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_base_voucher` WHERE `BVID`='$BVID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_base_voucher');
				if($row 	= $result->fetch()) {
					$cclass	= $row;	
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getBaseVoucherDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getBaseVoucherList() {
			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_base_voucher` ORDER BY `VoucherName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_base_voucher');
				while($row = $result->fetch()) {
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getBaseVoucherList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getBaseVoucherListJSON(){
		
			$sql		= "SELECT `BVID`, `VoucherName` FROM `asys_base_voucher` ORDER BY `VoucherName`";
			return $this->getRecordsetExecutingQuery($sql);
		
		}

		function getBaseVoucherNameByBVID($BVID) {
			$BVID		= (int)$BVID;
			$sql		=	"SELECT `VoucherName` FROM `asys_base_voucher` WHERE `BVID`='$BVID'";
			return $this->getResultExecutingQuery($sql);
		}

			

		/*-------------------------------------------------------------------*/
		/*********************** VOUCHER TYPES METHODS ***********************/

		function getVoucherTypeDetail($VTID) {
			$VTID				= (int)$VTID;
			$cclass			=	new asys_voucher_types();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_voucher_types` WHERE `VTID`='$VTID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_voucher_types');
				if($row 	= $result->fetch()) {
					$cclass	= $row;
					$cclass->setBaseVoucherName( $this->getBaseVoucherNameByBVID( $cclass->getBVID()));	
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getVoucherTypeDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getVoucherTypeList() {
			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_voucher_types` ORDER BY `VoucherName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_voucher_types');
				while($row = $result->fetch()) {
					$row->setBaseVoucherName($this->getBaseVoucherNameByBVID($row->getBVID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getVoucherTypeList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getVoucherTypeListJSON(){
		
			$sql		= "SELECT `VTID`, `VoucherName` FROM `asys_voucher_types` ORDER BY `VoucherName`";
			return $this->getRecordsetExecutingQuery($sql);
		
		}

		function getVoucherTypeNameByVoucherTypeID($VTID) {
			$VTID		= (int)$VTID;
			$sql		=	"SELECT `VoucherName` FROM `asys_voucher_types` WHERE `VTID`='$VTID'";
			return $this->getResultExecutingQuery($sql);
		}



		/*----------------------------------------------------------*/
		/*********************** UNIT METHODS ***********************/

		function getUnitDetail($UnitID) {
			$UnitID			= (int)$UnitID;
			$cclass			=	new gen_unit();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_unit` WHERE `UnitID`='$UnitID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_unit');
				if($row 	= $result->fetch())
					$cclass	= $row;
				
			} catch(PDOException $e) {
				$err	= 'masterdb getUnitDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getUnitList() {
			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_unit` ORDER BY `UnitName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_unit');
				while($row = $result->fetch())
					$arr[]	= $row;
				
			} catch(PDOException $e) {
				$err	= 'masterdb getUnitList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getUnitListJSON(){
		
			$sql		= "SELECT `UnitID`, `UnitName` FROM `gen_unit` ORDER BY `UnitName`";
			return $this->getRecordsetExecutingQuery($sql);
		
		}
		
		function getNumberOfUnit($schStr) {
			$schStr		= addslashes($schStr);
			if($schStr == "")
				$sql	=	"SELECT COUNT(*) FROM `gen_unit`";
			else
				$sql	=	"SELECT COUNT(*) FROM `gen_unit` WHERE `UnitName` LIKE '$schStr%'";
			
			return $this->getResultExecutingQuery($sql);
		}

		function getUnitListPaged($sRec, $nRec, $schStr) {
			$sRec			= (int)$sRec;
			$nRec			= (int)$nRec;
			$schStr		= addslashes($schStr);
			if($schStr == "")
				$sql			=	"SELECT * FROM `gen_unit` ORDER BY `UnitName` LIMIT $sRec, $nRec";
			else
				$sql			=	"SELECT * FROM `gen_unit` WHERE `UnitName` LIKE '%$schStr%' ORDER BY `UnitName` LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_unit');
				while($row = $result->fetch())
					$arr[]	= $row;
				
			} catch(PDOException $e) {
				$err	= 'masterdb getUnitListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function getUnitNameByUnitID($UnitID) {
			$UnitID	= (int)$UnitID;
			$sql		=	"SELECT `UnitName` FROM `gen_unit` WHERE `UnitID`='$UnitID'";
			return $this->getResultExecutingQuery($sql);
		}

		function deleteUnit($lcls) {
		
			$pkey	= $lcls->getUnitID();
			$ret				= false;
		
			try {
				
				$sql			=	"SELECT * FROM `gen_items` WHERE `UnitID`='$pkey'";
				$result		= $this->conn->query($sql);
				if(!$row 	= $result->fetch()) {
					$sql		= $lcls->getDeleteSQL();
					
					$ret		= $this->conn->query($sql);
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb deleteUnit '.$e->getMessage();
				_errorLog($err);
			}
		
			return $ret;
		}



		/*-------------------------------------------------------------------*/
		/*********************** ITEM CATEGORY METHODS ***********************/

		function getItemCategoryDetail($ItemCategoryID) {
			$ItemCategoryID	= (int)$ItemCategoryID;
			$cclass			=	new gen_itemcategory();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_itemcategory` WHERE `ItemCategoryID`='$ItemCategoryID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_itemcategory');
				if($row 	= $result->fetch()) {
					$row->setCompanyName( $this->getCompanyNameByCompanyID( $row->getCompanyID()));
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getItemCategoryDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getItemCategoryList($CompanyID) {
			$CompanyID	= (int)$CompanyID;
			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_itemcategory` WHERE `CompanyID`	= '$CompanyID' ORDER BY `ItemCategoryName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_itemcategory');
				while($row = $result->fetch()) {
					$row->setCompanyName( $this->getCompanyNameByCompanyID( $row->getCompanyID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getItemCategoryList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getItemCategoryListJSON($CompanyID){
			$CompanyID			= (int)$CompanyID;
			$sql		= "SELECT `ItemCategoryID`, `ItemCategoryName` FROM `gen_itemcategory` WHERE `CompanyID`='$CompanyID' ORDER BY `ItemCategoryName`";
			return $this->getRecordsetExecutingQuery($sql);
		
		}
		
		function getNumberOfItemCategory($schStr, $CompanyID) {
			$schStr		= addslashes($schStr);
			$CompanyID	= (int)$CompanyID;
			if($schStr == "")
				$sql	=	"SELECT COUNT(*) FROM `gen_itemcategory` WHERE `CompanyID`='$CompanyID'";
			else
				$sql	=	"SELECT COUNT(*) FROM `gen_itemcategory` WHERE `CompanyID`='$CompanyID' AND `ItemCategoryName` LIKE '$schStr%'";
			
			return $this->getResultExecutingQuery($sql);
		}

		function getItemCategoryListPaged($sRec, $nRec, $schStr, $CompanyID) {
			$sRec			= (int)$sRec;
			$nRec			= (int)$nRec;
			$schStr		= addslashes($schStr);
			$CompanyID	= (int)$CompanyID;
			if($schStr == "")
				$sql			=	"SELECT * FROM `gen_itemcategory` WHERE `CompanyID`='$CompanyID' ORDER BY `ItemCategoryName` LIMIT $sRec, $nRec";
			else
				$sql			=	"SELECT * FROM `gen_itemcategory` WHERE `CompanyID`='$CompanyID' AND `ItemCategoryName` LIKE '%$schStr%' ORDER BY `ItemCategoryName` LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_itemcategory');
				while($row = $result->fetch()) {
					$row->setCompanyName( $this->getCompanyNameByCompanyID( $row->getCompanyID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getItemCategoryListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function getItemCategoryNameByItemCategoryID($ItemCategoryID) {
			$ItemCategoryID	= (int)$ItemCategoryID;
			$sql		=	"SELECT `ItemCategoryName` FROM `gen_itemcategory` WHERE `ItemCategoryID`='$ItemCategoryID'";
			return $this->getResultExecutingQuery($sql);
		}

		function deleteItemCategory($lcls) {
		
			$pkey	= $lcls->getItemCategoryID();
			$ret				= false;
		
			try {
				
				$sql				=	"SELECT * FROM `gen_itemsubcategory` WHERE `ItemCategoryID`='$pkey'";
				$result			= $this->conn->query($sql);
				if(!$row 		= $result->fetch()) {
					$sql			=	"SELECT * FROM `gen_items` WHERE `ItemCategoryID`='$pkey'";
					$result2	= $this->conn->query($sql);
					if(!$row2 = $result2->fetch()) {
						$sql		= $lcls->getDeleteSQL();
						$ret		= $this->conn->query($sql);
					}				
				}

			} catch(PDOException $e) {
				$err	= 'masterdb deleteItemCategory '.$e->getMessage();
				_errorLog($err);
			}
		
			return $ret;
		}
		
		

		/*-----------------------------------------------------------------------*/
		/*********************** ITEM SUB-CATEGORY METHODS ***********************/

		function getItemSubcategoryDetail($ItemSubcategoryID) {
			$ItemSubcategoryID	= (int)$ItemSubcategoryID;
			$cclass			=	new gen_itemsubcategory();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_itemsubcategory` WHERE `ItemSubcategoryID`='$ItemSubcategoryID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_itemsubcategory');
				if($row 	= $result->fetch()) { 
					$row->setItemCategoryName( $this->getItemCategoryNameByItemCategoryID( $row->getItemCategoryID()));
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));	
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getItemSubcategoryDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getItemSubcategoryList() {
			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_itemsubcategory` ORDER BY `ItemSubcategoryName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_itemsubcategory');
				while($row = $result->fetch()) {
					$row->setItemCategoryName( $this->getItemCategoryNameByItemCategoryID( $row->getItemCategoryID()));
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$arr[]	= $row;				
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getItemSubcategoryList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getItemSubcategoryListJSON($ItemCategoryID){
			$ItemCategoryID	= (int)$ItemCategoryID;
		
			if($ItemCategoryID == 0)
				$sql		= "SELECT `ItemSubcategoryID`, `ItemSubcategoryName` FROM `gen_itemsubcategory` ORDER BY `ItemSubcategoryName`";
			else
				$sql		= "SELECT `ItemSubcategoryID`, `ItemSubcategoryName` FROM `gen_itemsubcategory` WHERE `ItemCategoryID`='$ItemCategoryID' ORDER BY `ItemSubcategoryName`";
			return $this->getRecordsetExecutingQuery($sql);
		
		}
		
		function getNumberOfItemSubcategory($ItemCategoryID, $schStr, $CompanyID) {
			$ItemCategoryID	= (int)$ItemCategoryID;
			$schStr					= addslashes($schStr);
			$CompanyID			= (int)$CompanyID;
			
			$sql		=	"SELECT COUNT(*) FROM `gen_itemsubcategory` WHERE `CompanyID` = '$CompanyID'";
			if($schStr != "")
				$sql	=	$sql." AND `ItemSubcategoryName` LIKE '%$schStr%'";
			if($ItemCategoryID != 0)
				$sql	= $sql." AND `ItemCategoryID`='$ItemCategoryID'";
			
			return $this->getResultExecutingQuery($sql);
		}

		function getItemSubcategoryListPaged($sRec, $nRec, $ItemCategoryID, $schStr, $CompanyID) {
			$ItemCategoryID	= (int)$ItemCategoryID;
			$schStr					= addslashes($schStr);
			$CompanyID			= (int)$CompanyID;
			$sRec						= (int)$sRec;
			$nRec						= (int)$nRec;
			
			$sql		=	"SELECT * FROM `gen_itemsubcategory` WHERE `CompanyID` = '$CompanyID'";
			if($schStr != "")
				$sql	=	$sql." AND `ItemSubcategoryName` LIKE '%$schStr%'";
			if($ItemCategoryID != 0)
				$sql	= $sql." AND `ItemCategoryID`='$ItemCategoryID'";			
			$sql		= $sql." ORDER BY `ItemSubcategoryName` LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_itemsubcategory');
				while($row = $result->fetch()) {
					$row->setItemCategoryName( $this->getItemCategoryNameByItemCategoryID( $row->getItemCategoryID()));
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getItemSubcategoryListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function getItemSubcategoryNameByItemSubcategoryID($ItemSubcategoryID) {
			$sql		=	"SELECT `ItemSubcategoryName` FROM `gen_itemsubcategory` WHERE `ItemSubcategoryID`='$ItemSubcategoryID'";
			return $this->getResultExecutingQuery($sql);
		}

		function deleteItemSubcategory($lcls) {
		
			$pkey		= $lcls->getItemSubcategoryID();
			$ret		= false;
		
			try {
				
				$sql			=	"SELECT * FROM `gen_items` WHERE `ItemSubcategoryID`='$pkey'";
				$result		= $this->conn->query($sql);
				if(!$row 	= $result->fetch()) {
					$sql		= $lcls->getDeleteSQL();
					$ret		= $this->conn->query($sql);
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb deleteItemSubcategory '.$e->getMessage();
				_errorLog($err);
			}			
		
			return $ret;
		}

	

		/*----------------------------------------------------------*/
		/*********************** ITEM METHODS ***********************/

		function getItemDetail($ItemID) {
			$ItemID	= (int)$ItemID;
			$cclass			=	new gen_items();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_items` WHERE `ItemID`='$ItemID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_items');
				if($row 	= $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setItemCategoryName( $this->getItemCategoryNameByItemCategoryID( $row->getItemCategoryID()));
					$row->setItemSubcategoryName( $this->getItemSubcategoryNameByItemSubcategoryID( $row->getItemSubcategoryID()));
					$row->setUnitName($this->getUnitNameByUnitID($row->getUnitID()));
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getItemDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getItemList($schStr = '', $ItemCategoryID = 0, $CompanyID) {
			$schStr					= addslashes($schStr);
			$ItemCategoryID	= (int)$ItemCategoryID;
			$CompanyID			= (int)$CompanyID;
			$arr	=	array();
			
			try {
				
				$sql		=	"SELECT * FROM `gen_items` WHERE (`CompanyID` = '$CompanyID' OR `MultipleCompany`='YES')";
				if($schStr != "")
					$sql	=	$sql."AND `ItemName` LIKE '%$schStr%'";
				if($ItemCategoryID > 0)
					$sql	= $sql." AND `ItemCategoryID` = '$ItemCategoryID'";
			
				$sql		=	$sql." ORDER BY `ItemName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_items');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setItemCategoryName( $this->getItemCategoryNameByItemCategoryID( $row->getItemCategoryID()));
					$row->setItemSubcategoryName( $this->getItemSubcategoryNameByItemSubcategoryID( $row->getItemSubcategoryID()));
					$row->setUnitName($this->getUnitNameByUnitID($row->getUnitID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getItemList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getItemListJSON($CompanyID){
			$CompanyID	= (int)$CompanyID;
			$sql		= "SELECT `ItemID`, `ItemName` FROM `gen_items` WHERE (`CompanyID` = '$CompanyID' OR `MultipleCompany`='YES') ORDER BY `ItemName`";
			return $this->getRecordsetExecutingQuery($sql);
		}
		
		function getItemListByCategoryJSON($ItemCategoryID, $CompanyID){
			$CompanyID	= (int)$CompanyID;
			$ItemCategoryID		= (int)$ItemCategoryID;
		
			if($ItemCategoryID != 0)
				$sql		= "SELECT `ItemID`, `ItemName`, `ItemCategoryID` FROM `gen_items` WHERE (`ItemCategoryID`='$ItemCategoryID' OR `MultipleCategory`='YES') AND (`CompanyID` = '$CompanyID' OR `MultipleCompany`='YES') ORDER BY `ItemName`";
			else
				$sql		= "SELECT `ItemID`, `ItemName`, `ItemCategoryID` FROM `gen_items` WHERE (`CompanyID` = '$CompanyID' OR `MultipleCompany`='YES') ORDER BY `ItemName`";
			return $this->getRecordsetExecutingQuery($sql);
		
		}
		
		function getTransferableItemListByCategoryJSON($ItemCategoryID, $CompanyID){
			$CompanyID	= (int)$CompanyID;
			$ItemCategoryID		= (int)$ItemCategoryID;
		
			$sql		= "SELECT `ItemID`, `ItemName` FROM `gen_items` WHERE (`ItemCategoryID`='$ItemCategoryID' OR `MultipleCategory`='YES') AND `MultipleCompany`='YES' ORDER BY `ItemName`";
			return $this->getRecordsetExecutingQuery($sql);
		
		}
		
		function getNumberOfItem($schStr, $ItemCategoryID, $CompanyID) {
			$schStr					= addslashes($schStr);
			$ItemCategoryID	= (int)$ItemCategoryID;
			$CompanyID			= (int)$CompanyID;
			$sql		=	"SELECT COUNT(*) FROM `gen_items` WHERE (`CompanyID` = '$CompanyID' OR `MultipleCompany`='YES') ";
			if($schStr != "")
				$sql	=	$sql."AND `ItemName` LIKE '%$schStr%'";
			if($ItemCategoryID > 0)
				$sql	= $sql." AND `ItemCategoryID` = '$ItemCategoryID'";
			
			return $this->getResultExecutingQuery($sql);
		}

		function getItemListPaged($sRec, $nRec, $schStr, $ItemCategoryID, $CompanyID) {
			$sRec						= (int)$sRec;
			$nRec						= (int)$nRec;
			$schStr					= addslashes($schStr);
			$ItemCategoryID	= (int)$ItemCategoryID;
			$CompanyID			= (int)$CompanyID;
			$sql		=	"SELECT * FROM `gen_items` WHERE (`CompanyID` = '$CompanyID' OR `MultipleCompany`='YES') ";
			if($schStr != "")
				$sql	=	$sql."AND `ItemName` LIKE '%$schStr%'";
			if($ItemCategoryID > 0)
				$sql	= $sql." AND `ItemCategoryID` = '$ItemCategoryID'";
			
			$sql		=	$sql." ORDER BY `ItemName` LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_items');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setItemCategoryName( $this->getItemCategoryNameByItemCategoryID( $row->getItemCategoryID()));
					$row->setItemSubcategoryName( $this->getItemSubcategoryNameByItemSubcategoryID( $row->getItemSubcategoryID()));
					$row->setUnitName($this->getUnitNameByUnitID($row->getUnitID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getItemListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function getItemNameByItemID($ItemID) {
			$ItemID	= (int)$ItemID;
			$sql		=	"SELECT `ItemName` FROM `gen_items` WHERE `ItemID`='$ItemID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getItemCategoryByItemID($ItemID) {
			$ItemID	= (int)$ItemID;
			$sql		=	"SELECT `ItemCategoryID` FROM `gen_items` WHERE `ItemID`='$ItemID'";
			return $this->getResultExecutingQuery($sql);
		}

		function deleteItem($lcls) {
		
			$pkey	= $lcls->getItemID();
			$ret				= false;
		
			try {
				
				$sql			=	"SELECT * FROM `asys_stock_voucher` WHERE `ItemID`='$pkey'";
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch()) {
					return false;
				}				
				$sql			=	"SELECT * FROM `gen_grn_items` WHERE `ItemID`='$pkey'";
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch()) {
					return false;
				}
				$sql			=	"SELECT * FROM `gen_issue_items` WHERE `ItemID`='$pkey'";
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch()) {
					return false;
				}
				$sql			=	"SELECT * FROM `gen_purchaseorder_items` WHERE `ItemID`='$pkey'";
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch()) {
					return false;
				}
				$sql			=	"SELECT * FROM `gen_purchasereturn_items` WHERE `ItemID`='$pkey'";
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch()) {
					return false;
				}
				$sql			=	"SELECT * FROM `gen_purchase_items` WHERE `ItemID`='$pkey'";
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch()) {
					return false;
				}
				$sql			=	"SELECT * FROM `gen_stockjournal_in` WHERE `ItemID`='$pkey'";
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch()) {
					return false;
				}
				$sql			=	"SELECT * FROM `gen_stockjournal_out` WHERE `ItemID`='$pkey'";
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch()) {
					return false;
				}
				$sql			=	"SELECT * FROM `gen_stocktransfer_items` WHERE `ItemID`='$pkey'";
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch()) {
					return false;
				}
				
				$sql		= $lcls->getDeleteSQL();
				$ret		= $this->conn->query($sql);
				
			} catch(PDOException $e) {
				$err	= 'masterdb deleteItem '.$e->getMessage();
				_errorLog($err);
			}
		
			return $ret;
		}
		
		function updateEAN($ItemID, $EAN) {
			$ItemID	= (int)$ItemID;
			$EAN		= addslashes($EAN);
			$sql		= "UPDATE `gen_items` SET `EAN`= '$EAN' WHERE `ItemID`='$ItemID'";
			$this->ExecuteQuery($sql);
		}
		
		function generateItemEAN() {
			$sql	= "SELECT `ItemID` FROM `gen_items` ORDER BY `ItemID`";
			try {
				
				$result		= $this->conn->query($sql);
				while($row = $result->fetch()) {
					$iid	= $row[0];
					$ean	= generateEAN($iid);
					$sql	= "UPDATE `gen_items` SET `EAN`= '$ean' WHERE `ItemID`='$iid'";
					$this->conn->query($sql);
				}
			} catch(PDOException $e) {
				$err	= 'masterdb getItemListPaged '.$e->getMessage();
				_errorLog($err);
			}
									
		}		



		/*-------------------------------------------------------------*/
		/*********************** ACCOUNT METHODS ***********************/

		function getAccountDetail($AccountID) {
			$AccountID	= (int)$AccountID;
			$cclass			=	new asys_accounts();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_accounts` WHERE `AccountID`='$AccountID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_accounts');
				if($row 	= $result->fetch()) {
					$cclass	= $row;
					$cclass->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$cclass->setGroupName($this->getGroupNameByGroupID($cclass->getGroupID()));
					$cclass->setBGName($this->getBaseGroupNameByBaseGroupID($cclass->getBGID()));
					$cclass->setMotherAccountName( $this->getAccountNameByAccountID( $cclass->getMotherAccount() ) );
					$cclass->setSubgroupName( $this->getSubgroupNameBySubgroupID($cclass->getSubgroupID()));
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getAccountDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getAccountList($CompanyID) {
			$CompanyID	= (int)$CompanyID;
			$arr	=	array();
			
			try {
				
				if($CompanyID == 0)
					$sql			=	"SELECT * FROM `asys_accounts` ORDER BY `AccountName`";
				else
					$sql			=	"SELECT * FROM `asys_accounts` WHERE `CompanyID`='$CompanyID' ORDER BY `AccountName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_accounts');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setGroupName($this->getGroupNameByGroupID($row->getGroupID()));
					$row->setBGName($this->getBaseGroupNameByBaseGroupID($row->getBGID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount() ) );
					$row->setSubgroupName( $this->getSubgroupNameBySubgroupID($row->getSubgroupID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getAccountList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getBGWiseAccountList($CompanyID, $BGID) {
			$CompanyID	= (int)$CompanyID;
			$BGID				= (int)$BGID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_accounts` WHERE `CompanyID`='$CompanyID' AND `BGID`='$BGID' ORDER BY `AccountName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_accounts');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setGroupName($this->getGroupNameByGroupID($row->getGroupID()));
					$row->setBGName($this->getBaseGroupNameByBaseGroupID($row->getBGID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount() ) );
					$row->setSubgroupName( $this->getSubgroupNameBySubgroupID($row->getSubgroupID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getBGWiseAccountList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getMotherAccountList($CompanyID) {
			$CompanyID	= (int)$CompanyID;
			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_accounts` WHERE `MotherAccount`='0' AND `ContainsSubLedger`='YES' AND `CompanyID`='$CompanyID' ORDER BY `AccountName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_accounts');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setGroupName($this->getGroupNameByGroupID($row->getGroupID()));
					$row->setBGName($this->getBaseGroupNameByBaseGroupID($row->getBGID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount() ) );
					$row->setSubgroupName( $this->getSubgroupNameBySubgroupID($row->getSubgroupID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getMotherAccountList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getMainAccountList($CompanyID) {
			$CompanyID	= (int)$CompanyID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_accounts` WHERE `MotherAccount`='0' AND `ContainsSubLedger`='NO' AND `CompanyID`='$CompanyID' ORDER BY `AccountName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_accounts');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setGroupName($this->getGroupNameByGroupID($row->getGroupID()));
					$row->setBGName($this->getBaseGroupNameByBaseGroupID($row->getBGID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount() ) );
					$row->setSubgroupName( $this->getSubgroupNameBySubgroupID($row->getSubgroupID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getMotherAccountList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getMotherAccountListByGroup($CompanyID, $BGID) {
			$CompanyID	= (int)$CompanyID;
			$BGID				= (int)$BGID;
			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_accounts` WHERE `MotherAccount`='0' AND `ContainsSubLedger`='YES' AND `CompanyID`='$CompanyID' AND `BGID`='$BGID' ORDER BY `AccountName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_accounts');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setGroupName($this->getGroupNameByGroupID($row->getGroupID()));
					$row->setBGName($this->getBaseGroupNameByBaseGroupID($row->getBGID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount() ) );
					$row->setSubgroupName( $this->getSubgroupNameBySubgroupID($row->getSubgroupID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getMotherAccountListByGroup '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getShortAccountList($CompanyID) {
			$CompanyID	= (int)$CompanyID;
			$acctVector = array();
			$sql				=	"SELECT `MotherAccount`, `ContainsSubLedger`, `AccountID`, `AccountName` FROM `asys_accounts` WHERE `CompanyID`='$CompanyID' ORDER BY `AccountName`";
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_NUM);
				while($row = $result->fetch()) {
					$acct		= new DrCr();
					$acct->setMotherAccount($row[0]);
					$acct->setMotherAccountName($this->getAccountNameByAccountID($row[0]));
					$acct->setContainsSubLedger($row[1]);
					$acct->setAccountID($row[2]);
					$acct->setAccountName($row[3]);
					$acct->setCompanyCode($this->getCompanyCodeByCompanyID($CompanyID));
					$acctVector[]	=	$acct;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getShortAccountList '.$e->getMessage();
				_errorLog($err);
			}

			return $acctVector;
		}
		
		function getShortMotherAccountList($CompanyID) {
			$CompanyID	= (int)$CompanyID;
			$acctVector = array();
			$sql				=	"SELECT `MotherAccount`, `ContainsSubLedger`, `AccountID`, `AccountName`, `PrnName`, `BGID`, `SubgroupID`, `CompanyID` FROM `asys_accounts` WHERE `MotherAccount`='0' AND `CompanyID`='$CompanyID' ORDER BY `AccountName`";
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_NUM);
				while($row = $result->fetch()) {
					$acct		= new DrCr();
					$acct->setMotherAccount($row[0]);
					$acct->setMotherAccountName($this->getAccountNameByAccountID($row[0]));
					$acct->setContainsSubLedger($row[1]);
					$acct->setAccountID($row[2]);
					$acct->setAccountName($row[3]);
					$acct->setPrnName($row[4]);
					$acct->setBGID($row[5]);
					$acct->setSubgroupID($row[6]);
					$acct->setCompanyCode($this->getCompanyCodeByCompanyID($CompanyID));
					$acctVector[]	=	$acct;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getShortMotherAccountList '.$e->getMessage();
				_errorLog($err);
			}

			return $acctVector;
		}
		
		function getShortMotherAccountListMultipleCompany($CompanyID) {
			$CompanyID	= addslashes($CompanyID);
			$acctVector = array();
			$sql				=	"SELECT `MotherAccount`, `ContainsSubLedger`, `AccountID`, `AccountName`, `PrnName`, `BGID`, `SubgroupID`, `CompanyID` FROM `asys_accounts` WHERE `MotherAccount`='0' AND `CompanyID` IN (".$CompanyID.") ORDER BY `AccountName`";
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_NUM);
				while($row = $result->fetch()) {
					$acct		= new DrCr();
					$acct->setMotherAccount($row[0]);
					$acct->setMotherAccountName($this->getAccountNameByAccountID($row[0]));
					$acct->setContainsSubLedger($row[1]);
					$acct->setAccountID($row[2]);
					$acct->setAccountName($row[3]);
					$acct->setPrnName($row[4]);
					$acct->setBGID($row[5]);
					$acct->setSubgroupID($row[6]);
					$acct->setCompanyCode($this->getCompanyCodeByCompanyID($row[7]));
					$acctVector[]	=	$acct;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getShortMotherAccountListMultipleCompany '.$e->getMessage();
				_errorLog($err);
			}

			return $acctVector;
		}
		
		function getShortMotherAccountList2($CompanyID) {
			$CompanyID	= (int)$CompanyID;
			$acctVector = array();
			$sql				=	"SELECT `MotherAccount`, `ContainsSubLedger`, `AccountID`, `AccountName`, `PrnName`, `BGID`, `SubgroupID` FROM `asys_accounts` WHERE `MotherAccount`='0' AND `CompanyID`='$CompanyID' ORDER BY `BGID`, `SubgroupID`, `AccountName`";
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_NUM);
				while($row = $result->fetch()) {
					$acct		= new DrCr();
					$acct->setMotherAccount($row[0]);
					$acct->setMotherAccountName($this->getAccountNameByAccountID($row[0]));
					$acct->setContainsSubLedger($row[1]);
					$acct->setAccountID($row[2]);
					$acct->setAccountName($row[3]);
					$acct->setPrnName($row[4]);
					$acct->setBGID($row[5]);
					$acct->setSubgroupID($row[6]);
					$acct->setCompanyCode($this->getCompanyCodeByCompanyID($CompanyID));
					$acctVector[]	=	$acct;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getShortMotherAccountList2 '.$e->getMessage();
				_errorLog($err);
			}

			return $acctVector;
		}
		
		function getShortMotherAccountList2MultipleCompany($CompanyID) {
			$CompanyID	= addslashes($CompanyID);
			$acctVector = array();
			$sql				=	"SELECT `MotherAccount`, `ContainsSubLedger`, `AccountID`, `AccountName`, `PrnName`, `BGID`, `SubgroupID`, `CompanyID` FROM `asys_accounts` WHERE `MotherAccount`='0' AND `CompanyID` IN(".$CompanyID.") ORDER BY `BGID`, `SubgroupID`, `AccountName`";
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_NUM);
				while($row = $result->fetch()) {
					$acct		= new DrCr();
					$acct->setMotherAccount($row[0]);
					$acct->setMotherAccountName($this->getAccountNameByAccountID($row[0]));
					$acct->setContainsSubLedger($row[1]);
					$acct->setAccountID($row[2]);
					$acct->setAccountName($row[3]);
					$acct->setPrnName($row[4]);
					$acct->setBGID($row[5]);
					$acct->setSubgroupID($row[6]);
					$acct->setCompanyCode($this->getCompanyCodeByCompanyID($row[7]));
					$acctVector[]	=	$acct;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getShortMotherAccountList2MultipleCompany '.$e->getMessage();
				_errorLog($err);
			}

			return $acctVector;
		}
		
		function getShortMotherAccountListBGWise($CompanyID, $BGID) {
			$CompanyID	= (int)$CompanyID;
			$BGID				= (int)$BGID;
			$acctVector = array();
			$sql				=	"SELECT `MotherAccount`, `ContainsSubLedger`, `AccountID`, `AccountName`, `PrnName`, `BGID`, `SubgroupID` FROM `asys_accounts` WHERE `MotherAccount`='0' AND `CompanyID`='$CompanyID' AND `BGID`='$BGID' ORDER BY `SubGroupID`, `AccountName`";
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_NUM);
				while($row = $result->fetch()) {
					$acct		= new DrCr();
					$acct->setMotherAccount($row[0]);
					$acct->setMotherAccountName($this->getAccountNameByAccountID($row[0]));
					$acct->setContainsSubLedger($row[1]);
					$acct->setAccountID($row[2]);
					$acct->setAccountName($row[3]);
					$acct->setPrnName($row[4]);
					$acct->setBGID($row[5]);
					$acct->setSubgroupID($row[6]);
					$acct->setCompanyCode($this->getCompanyCodeByCompanyID($CompanyID));
					$acctVector[]	=	$acct;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getShortMotherAccountListBGWise '.$e->getMessage();
				_errorLog($err);
			}

			return $acctVector;
		}
		
		function getShortMotherAccountListBGWiseMultipleCompany($CompanyID, $BGID) {
			$CompanyID	= addslashes($CompanyID);
			$BGID				= (int)$BGID;
			$acctVector = array();
			$sql				=	"SELECT `MotherAccount`, `ContainsSubLedger`, `AccountID`, `AccountName`, `PrnName`, `BGID`, `SubgroupID`, `CompanyID` FROM `asys_accounts` WHERE `MotherAccount`='0' AND `CompanyID` IN(".$CompanyID.") AND `BGID`='$BGID' ORDER BY `SubGroupID`, `AccountName`";
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_NUM);
				while($row = $result->fetch()) {
					$acct		= new DrCr();
					$acct->setMotherAccount($row[0]);
					$acct->setMotherAccountName($this->getAccountNameByAccountID($row[0]));
					$acct->setContainsSubLedger($row[1]);
					$acct->setAccountID($row[2]);
					$acct->setAccountName($row[3]);
					$acct->setPrnName($row[4]);
					$acct->setBGID($row[5]);
					$acct->setSubgroupID($row[6]);
					$acct->setCompanyCode($this->getCompanyCodeByCompanyID($row[7]));
					$acctVector[]	=	$acct;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getShortMotherAccountListBGWiseMultipleCompany '.$e->getMessage();
				_errorLog($err);
			}

			return $acctVector;
		}
		
		function getShortChildAccountList($MotherAccount, $CompanyID) {
			$MotherAccount	= (int)$MotherAccount;
			$CompanyID	= (int)$CompanyID;
			$acctVector = array();
			$sql				=	"SELECT `MotherAccount`, `ContainsSubLedger`, `AccountID`, `AccountName` FROM `asys_accounts` WHERE `MotherAccount`='$MotherAccount' AND `CompanyID`='$CompanyID' ORDER BY `AccountName`";
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_NUM);
				while($row = $result->fetch()) {
					$acct		= new DrCr();
					$acct->setMotherAccount($row[0]);
					$acct->setMotherAccountName($this->getAccountNameByAccountID($row[0]));
					$acct->setContainsSubLedger($row[1]);
					$acct->setAccountID($row[2]);
					$acct->setAccountName($row[3]);
					$acct->setCompanyCode($this->getCompanyCodeByCompanyID($CompanyID));
					$acctVector[]	=	$acct;
				}

			} catch(PDOException $e) {
				$err	= 'masterdb getShortChildAccountList '.$e->getMessage();
				_errorLog($err);
			}

			return $acctVector;
		}
		
		function getChildAccountList($MotherAccount, $CompanyID) {
			$MotherAccount	= (int)$MotherAccount;
			$CompanyID	= (int)$CompanyID;
			$acctVector = array();
			$sql				=	"SELECT * FROM `asys_accounts` WHERE `MotherAccount`='$MotherAccount' AND `CompanyID`='$CompanyID' ORDER BY `AccountName`";
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_accounts');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setGroupName($this->getGroupNameByGroupID($row->getGroupID()));
					$row->setBGName($this->getBaseGroupNameByBaseGroupID($row->getBGID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount() ) );
					$row->setSubgroupName( $this->getSubgroupNameBySubgroupID($row->getSubgroupID()));
					$acctVector[]	=	$row;
				}

			} catch(PDOException $e) {
				$err	= 'masterdb getChildAccountList '.$e->getMessage();
				_errorLog($err);
			}

			return $acctVector;
		}
		
		function getAccountListJSON($CompanyID){
			$CompanyID	= (int)$CompanyID;
			$sql		= "SELECT `AccountID`, `AccountName` FROM `asys_accounts` WHERE `CompanyID`='$CompanyID' ORDER BY `AccountName`";
			return $this->getRecordsetExecutingQuery($sql);
		}
		
		function getMainAccountListJSON($CompanyID) {
			$CompanyID	= (int)$CompanyID;
			$sql				=	"SELECT `AccountID`, `AccountName` FROM `asys_accounts` WHERE `MotherAccount`='0' AND `ContainsSubLedger`='NO' AND `CompanyID`='$CompanyID' ORDER BY `AccountName`";
			return $this->getRecordsetExecutingQuery($sql);
		}		
		
		function getMotherAccountListJSON($CompanyID) {
			$CompanyID	= (int)$CompanyID;
			$sql				=	"SELECT `AccountID`, `AccountName` FROM `asys_accounts` WHERE `MotherAccount`='0' AND `ContainsSubLedger`='YES' AND `CompanyID`='$CompanyID' ORDER BY `AccountName`";
			return $this->getRecordsetExecutingQuery($sql);
		}
		
		function getChildAccountListJSON($MotherAccount, $CompanyID) {
			$MotherAccount	= (int)$MotherAccount;
			$CompanyID	= (int)$CompanyID;
			$sql				=	"SELECT `AccountID`, `AccountName` FROM `asys_accounts` WHERE `MotherAccount`='$MotherAccount' AND `CompanyID`='$CompanyID' ORDER BY `AccountName`";
			return $this->getRecordsetExecutingQuery($sql);
		}
		
		function getCustomerListJSON($CompanyID){
			$CompanyID	= (int)$CompanyID;
			$sql		= "SELECT `AccountID`, `AccountName`, `State` FROM `asys_accounts` WHERE `BGID`='11' AND `CompanyID`='$CompanyID'  AND `MotherAccount` != '0' ORDER BY `AccountName`";
			return $this->getRecordsetExecutingQuery($sql);
		}
		
		function getSupplierListJSON($CompanyID){
			$CompanyID	= (int)$CompanyID;
			$sql		= "SELECT `AccountID`, `AccountName`, `State` FROM `asys_accounts` WHERE `BGID`='3' AND `CompanyID`='$CompanyID' AND `MotherAccount` != '0' ORDER BY `AccountName`";
			return $this->getRecordsetExecutingQuery($sql);
		}
		
		function getAddLessListJSON($CompanyID){
			$CompanyID	= (int)$CompanyID;
			$sql		= "SELECT `AccountID`, `AccountName` FROM `asys_accounts` WHERE `RelateToBill`='YES' AND `CompanyID`='$CompanyID' ORDER BY `AccountName`";
			return $this->getRecordsetExecutingQuery($sql);
		}
		
		function getSalesListJSON($CompanyID){
			$CompanyID	= (int)$CompanyID;
			$sql		= "SELECT `AccountID`, `AccountName` FROM `asys_accounts` WHERE `BGID`='18' AND `CompanyID`='$CompanyID' ORDER BY `AccountName`";
			return $this->getRecordsetExecutingQuery($sql);
		}
		
		function getPurchaseListJSON($CompanyID){
			$CompanyID	= (int)$CompanyID;
			$sql		= "SELECT `AccountID`, `AccountName` FROM `asys_accounts` WHERE `BGID`='19' AND `CompanyID`='$CompanyID' AND `MotherAccount` != '0' ORDER BY `AccountName`";
			return $this->getRecordsetExecutingQuery($sql);
		}
		
		function getCashListJSON($CompanyID){
			$CompanyID	= (int)$CompanyID;
			$sql		= "SELECT `AccountID`, `AccountName` FROM `asys_accounts` WHERE `BGID`='9' AND `CompanyID`='$CompanyID' ORDER BY `AccountName`";
			return $this->getRecordsetExecutingQuery($sql);
		}
		
		function getBankListJSON($CompanyID){
			$CompanyID	= (int)$CompanyID;
			$sql		= "SELECT `AccountID`, `AccountName` FROM `asys_accounts` WHERE `BGID`='10' AND `CompanyID`='$CompanyID' ORDER BY `AccountName`";
			return $this->getRecordsetExecutingQuery($sql);
		}
		
		function getCashBankListJSON($CompanyID){
			$CompanyID	= (int)$CompanyID;
			$sql		= "SELECT `AccountID`, `AccountName` FROM `asys_accounts` WHERE `BGID` IN('9','10') AND `CompanyID`='$CompanyID' ORDER BY `AccountName`";
			return $this->getRecordsetExecutingQuery($sql);
		}
		
		function getIssueDebitAccountListJSON($CompanyID){
			$CompanyID	= (int)$CompanyID;
			$sql				= "SELECT DISTINCT(`asys_voucher_entry`.`AccountID`), `asys_accounts`.`AccountName` FROM `asys_voucher_entry` INNER JOIN `asys_accounts` ON `asys_voucher_entry`.`AccountID`=`asys_accounts`.`AccountID` WHERE `asys_voucher_entry`.`CompanyID`='$CompanyID' AND `DrCr`='2' AND `TxnType` IN (10, 13) AND `asys_voucher_entry`.`MotherAccount` != '7' ORDER BY `asys_accounts`.`AccountName`";
			return $this->getRecordsetExecutingQuery($sql);
		}
		
		function getStoreOppositeAccountList($CompanyID){
			$CompanyID	= (int)$CompanyID;
			$sql				= "SELECT DISTINCT(`OppositeAccountID`) FROM `asys_stores` WHERE `CompanyID` = '$CompanyID'";
			return $this->getRecordsetExecutingQuery($sql);
		}
		
		function getNumberOfAccount($schStr, $schFld, $CompanyID, $GroupID, $SubgroupID) {
			$schStr			= addslashes($schStr);
			$schFld			= addslashes($schFld);
			$CompanyID	= (int)$CompanyID;
			$GroupID		= (int)$GroupID;
			$SubgroupID	= (int)$SubgroupID;
			
			$sql		=	"SELECT COUNT(*) FROM `asys_accounts` WHERE `MotherAccount`='0' AND `CompanyID`='$CompanyID'";
			if($schStr != "")
				$sql	=	$sql." AND `$schFld` LIKE '%$schStr%'";
			if($GroupID != 0)
				$sql	= $sql." AND `GroupID`='$GroupID'";
			if($SubgroupID != 0)
				$sql	= $sql." AND `SubgroupID`='$SubgroupID'";				
			
			return $this->getResultExecutingQuery($sql);
		}
		
		function getNumberOfSubAccount($schStr, $schFld, $MotherAccountID, $CompanyID) {
			$schStr		= addslashes($schStr);
			$schFld		= addslashes($schFld);
			$CompanyID	= (int)$CompanyID;
			$MotherAccountID	= (int)$MotherAccountID;
			if($schStr == "") {
				$sql	=	"SELECT COUNT(*) FROM `asys_accounts` WHERE `MotherAccount`!='0' AND `CompanyID`='$CompanyID'";
				if($MotherAccountID != 0)
					$sql	=	$sql." AND `MotherAccount`='$MotherAccountID'";
			} else {
				$sql	=	"SELECT COUNT(*) FROM `asys_accounts` WHERE `$schFld` LIKE '%$schStr%' AND `MotherAccount`!='0' AND `CompanyID`='$CompanyID'";
				if($MotherAccountID != 0)
					$sql	=	$sql." AND `MotherAccount`='$MotherAccountID'";
			}

			return $this->getResultExecutingQuery($sql);
		}
		
		function getNumberOfCustomer($schStr, $schFld, $CompanyID) {
			$schStr		= addslashes($schStr);
			$schFld		= addslashes($schFld);
			$CompanyID	= (int)$CompanyID;
			if($schStr == "") {
				$sql	=	"SELECT COUNT(*) FROM `asys_accounts` WHERE `MotherAccount`!='0' AND `CompanyID`='$CompanyID' AND `BGID`='11'";
			} else {
				$sql	=	"SELECT COUNT(*) FROM `asys_accounts` WHERE `$schFld` LIKE '%$schStr%' AND `MotherAccount`!='0' AND `CompanyID`='$CompanyID' AND `BGID`='11'";
			}

			return $this->getResultExecutingQuery($sql);
		}
		
		function getNumberOfSupplier($schStr, $schFld, $CompanyID) {
			$schStr		= addslashes($schStr);
			$schFld		= addslashes($schFld);
			$CompanyID	= (int)$CompanyID;
			if($schStr == "") {
				$sql	=	"SELECT COUNT(*) FROM `asys_accounts` WHERE `MotherAccount`!='0' AND `CompanyID`='$CompanyID' AND `BGID`='3'";
			} else {
				$sql	=	"SELECT COUNT(*) FROM `asys_accounts` WHERE `$schFld` LIKE '%$schStr%' AND `MotherAccount`!='0' AND `CompanyID`='$CompanyID' AND `BGID`='3'";
			}

			return $this->getResultExecutingQuery($sql);
		}
		
		function getSupplierListPaged($sRec, $nRec, $schStr, $schFld, $sortFld, $CompanyID) {
			$sRec			= (int)$sRec;
			$nRec			= (int)$nRec;
			$schStr		= addslashes($schStr);
			$schFld		= addslashes($schFld);
			$sortFld	= addslashes($sortFld);
			$CompanyID	= (int)$CompanyID;
			if($schStr == "") {
				$sql	=	"SELECT * FROM `asys_accounts` WHERE `MotherAccount`!='0' AND `CompanyID`='$CompanyID' AND `BGID`='3'";
				$sql	=	$sql." ORDER BY `AccountName` LIMIT $sRec, $nRec";
			} else {
				$sql	=	"SELECT * FROM `asys_accounts` WHERE `$schFld` LIKE '%$schStr%' AND `MotherAccount`!='0' AND `CompanyID`='$CompanyID' AND `BGID`='3'";
				$sql	=	$sql." ORDER BY `$sortFld` LIMIT $sRec, $nRec";
			}

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_accounts');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setGroupName($this->getGroupNameByGroupID($row->getGroupID()));
					$row->setBGName($this->getBaseGroupNameByBaseGroupID($row->getBGID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount() ) );
					$row->setSubgroupName( $this->getSubgroupNameBySubgroupID($row->getSubgroupID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getSupplierListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function getAccountListPaged($sRec, $nRec, $schStr, $schFld, $sortFld, $CompanyID, $GroupID, $SubgroupID) {
			$sRec				= (int)$sRec;
			$nRec				= (int)$nRec;
			$schStr			= addslashes($schStr);
			$schFld			= addslashes($schFld);
			$sortFld		= addslashes($sortFld);
			$CompanyID	= (int)$CompanyID;
			$GroupID		= (int)$GroupID;
			$SubgroupID	= (int)$SubgroupID;
			
			$sql		=	"SELECT * FROM `asys_accounts` WHERE `MotherAccount`='0' AND `CompanyID`='$CompanyID'";
			if($schStr != "")
				$sql	=	$sql." AND `$schFld` LIKE '%$schStr%'";
			if($GroupID != 0)
				$sql	= $sql." AND `GroupID`='$GroupID'";
			if($SubgroupID != 0)
				$sql	= $sql." AND `SubgroupID`='$SubgroupID'";
			$sql		= $sql." ORDER BY `$sortFld` LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_accounts');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setGroupName($this->getGroupNameByGroupID($row->getGroupID()));
					$row->setBGName($this->getBaseGroupNameByBaseGroupID($row->getBGID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount() ) );
					$row->setSubgroupName( $this->getSubgroupNameBySubgroupID($row->getSubgroupID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getAccountListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getSubAccountListPaged($sRec, $nRec, $schStr, $schFld, $sortFld, $MotherAccountID, $CompanyID) {
			$sRec			= (int)$sRec;
			$nRec			= (int)$nRec;
			$schStr		= addslashes($schStr);
			$schFld		= addslashes($schFld);
			$sortFld	= addslashes($sortFld);
			$MotherAccountID	= (int)$MotherAccountID;
			$CompanyID	= (int)$CompanyID;
			if($schStr == "") {
				$sql	=	"SELECT * FROM `asys_accounts` WHERE `MotherAccount`!='0' AND `CompanyID`='$CompanyID'";
				if($MotherAccountID != 0)
					$sql	=	$sql." AND `MotherAccount`='$MotherAccountID'";
				$sql	=	$sql." ORDER BY `AccountName` LIMIT $sRec, $nRec";
			} else {
				$sql	=	"SELECT * FROM `asys_accounts` WHERE `$schFld` LIKE '%$schStr%' AND `MotherAccount`!='0' AND `CompanyID`='$CompanyID'";
				if($MotherAccountID != 0)
					$sql	=	$sql." AND `MotherAccount`='$MotherAccountID'";
				$sql	=	$sql." ORDER BY `$sortFld` LIMIT $sRec, $nRec";
			}

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_accounts');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setGroupName($this->getGroupNameByGroupID($row->getGroupID()));
					$row->setBGName($this->getBaseGroupNameByBaseGroupID($row->getBGID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount() ) );
					$row->setSubgroupName( $this->getSubgroupNameBySubgroupID($row->getSubgroupID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getSubAccountListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getCustomerListPaged($sRec, $nRec, $schStr, $schFld, $sortFld, $CompanyID) {
			$sRec			= (int)$sRec;
			$nRec			= (int)$nRec;
			$schStr		= addslashes($schStr);
			$schFld		= addslashes($schFld);
			$sortFld	= addslashes($sortFld);
			$CompanyID	= (int)$CompanyID;
			if($schStr == "") {
				$sql	=	"SELECT * FROM `asys_accounts` WHERE `MotherAccount`!='0' AND `CompanyID`='$CompanyID' AND `BGID`='11'";
				$sql	=	$sql." ORDER BY `AccountName` LIMIT $sRec, $nRec";
			} else {
				$sql	=	"SELECT * FROM `asys_accounts` WHERE `$schFld` LIKE '%$schStr%' AND `MotherAccount`!='0' AND `CompanyID`='$CompanyID' AND `BGID`='11'";
				$sql	=	$sql." ORDER BY `$sortFld` LIMIT $sRec, $nRec";
			}

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_accounts');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setGroupName($this->getGroupNameByGroupID($row->getGroupID()));
					$row->setBGName($this->getBaseGroupNameByBaseGroupID($row->getBGID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount() ) );
					$row->setSubgroupName( $this->getSubgroupNameBySubgroupID($row->getSubgroupID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getCustomerListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function getAccountNameByAccountID($AccountID) {
			$AccountID	= (int)$AccountID;
			$sql		=	"SELECT `AccountName` FROM `asys_accounts` WHERE `AccountID`='$AccountID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getAccountFieldByAccountID($AccountID, $FldName) {
			$AccountID	= (int)$AccountID;
			$FldName		= addslashes($FldName);
			$sql				=	"SELECT `$FldName` FROM `asys_accounts` WHERE `AccountID`='$AccountID'";
			return $this->getResultExecutingQuery($sql);
		}

		function deleteAccount($lcls) {
		
			$pkey				= $lcls->getAccountID();
			$ret				= false;
			$chk				= 0;
		
			try {
				
				$sql			=	"SELECT * FROM `asys_voucher_entry` WHERE `AccountID`='$pkey'";
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch()) {
					$chk		= 1;
				}
				
				$sql			=	"SELECT * FROM `asys_accounts` WHERE `MotherAccount`='$pkey'";
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch()) {
					$chk		= 1;
				}
				
				if($chk == 0 ) {
					$sql		= $lcls->getDeleteSQL();
					$ret		= $this->conn->query($sql);
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb deleteAccount '.$e->getMessage();
				_errorLog($err);
			}
		
			return $ret;
		}
		
		function updateAccount($acls) {
		
			$aid				= $acls->getAccountID();
			$gid				= $acls->getGroupID();
			$bgid				= $acls->getBGID();
			$sgid				= $acls->getSubgroupID();
		

			try {
			
				$this->conn->beginTransaction();
				
				$sql	= $acls->getUpdateSQL();
				$this->conn->exec($sql);
				
				$sql	= "UPDATE `asys_opening_balances` SET `BGID`='$bgid', `GroupID`='$gid', `SubgroupID`='$sgid' WHERE `AccountID`='$aid'";
				$this->conn->exec($sql);
				
				if($acls->getContainsSubLedger() == "YES") {
					$sql	= "UPDATE `asys_accounts` SET `BGID`='$bgid', `GroupID`='$gid', `SubgroupID`='$sgid' WHERE `MotherAccount`='$aid'";
					$this->conn->exec($sql);
					
					$sql	= "UPDATE `asys_opening_balances` SET `BGID`='$bgid', `GroupID`='$gid', `SubgroupID`='$sgid' WHERE `MotherAccount`='$aid'";
					$this->conn->exec($sql);						
				}
			
				$this->conn->commit();
			
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'masterdb updateAccount '.$er->getMessage();
				_errorLog($err);
				$aid	= -1;
				
			}
				
		
			return $aid;
		}
		
		function updateChildAccount($acls, $oldMotherAccount) {
		
			$aid				= $acls->getAccountID();
			$mid				= $acls->getMotherAccount();
			$gid				= $acls->getGroupID();
			$bgid				= $acls->getBGID();
			$sgid				= $acls->getSubgroupID();			
		
				
			try {
			
				$this->conn->beginTransaction();
				
				$sql	= $acls->getUpdateSQL();
				$this->conn->exec($sql);
				
				$sql	= "UPDATE `asys_opening_balances` SET `BGID`='$bgid', `GroupID`='$gid', `SubgroupID`='$sgid' WHERE `AccountID`='$aid'";
				$this->conn->exec($sql);					
				
				if($acls->getMotherAccount() != $oldMotherAccount) {
					$sql	= "UPDATE `asys_voucher_entry` SET `MotherAccount`='$mid' WHERE `AccountID`='$aid'";
					$this->conn->exec($sql);
				}
			
				$this->conn->commit();
			
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'masterdb updateChildAccount '.$er->getMessage();
				_errorLog($err);
				$aid	= -1;
				
			}
				
		
			return $aid;
		}
		
		function refreshAllAccounts() {
				
			try {
			
				$this->conn->beginTransaction();
				
				$sql		= "SELECT * FROM `asys_accounts` WHERE `ContainsSubLedger`='YES' AND `MotherAccount`='0'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_accounts');
				while($row 	= $result->fetch()) {
					$aid				= $row->getAccountID();
					$gid				= $row->getGroupID();
					$bgid				= $row->getBGID();
					$sgid				= $row->getSubgroupID();
					
					$sql	= "UPDATE `asys_accounts` SET `BGID`='$bgid', `GroupID`='$gid', `SubgroupID`='$sgid' WHERE `MotherAccount`='$aid'";
					$this->conn->exec($sql);
				}
			
				$this->conn->commit();
			
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'masterdb refreshAllAccounts '.$er->getMessage();
				_errorLog($err);
				
			}
		
		}

		function getClosingBalanceByAccountID($accid, $fdate, $IncludeDate = 'NO') {
			$accid			= (int)$accid;
			$fdate			= addslashes($fdate);
			$IncludeDate= addslashes($IncludeDate);
			if($fdate == "")
				$fdate 		= "3000-01-01";
			$cbal				= 0;
			$obal				= 0;
			$obaltype		= 0;		/* 1-Cr 2-Db */
			$cbaltype		= 0;
			$retCBal		= array();
			$debitAmt		= 0;
			$creditAmt	= 0;
			$fy					= getFinancialYear(getPreviousDate($fdate));
			$fromdt			= getFirstFinancialDate(getPreviousDate($fdate));
			$todt				= getPreviousDate($fdate);
			if(	$IncludeDate == "YES") $todt = $fdate;
			
			try {
				
				$sql			=	"SELECT `OBal`, `OBalType` FROM `asys_opening_balances` WHERE `FinYear`='".$fy."' AND `AccountID`='".$accid."'";
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch()) {
				
					$obal			= $row[0];
					$obaltype	= $row[1];
					
					$sql1	= "SELECT SUM(`Amount`), `DrCr` FROM `asys_voucher_entry` WHERE `AccountID`=".$accid." AND `DOV`>='".$fromdt."' AND `DOV`<'".$todt."' GROUP BY `DrCr`";

					$result		= $this->conn->query($sql1);
					while( $row 	= $result->fetch() ) {
						if($row[1] == CREDIT)
							$creditAmt	= $row[0];
						else
							$debitAmt	= $row[0];	
					}				
				
				} else {
				
					$sql			= "SELECT `OBal`,`OBalType` FROM `asys_accounts` WHERE `AccountID`=".$accid;
					$result		= $this->conn->query($sql);
					if($row 	= $result->fetch()) {
						$obal			= $row[0];
						$obaltype	= $row[1];
					}
				
					$sql1	= "SELECT SUM(`Amount`), `DrCr` FROM `asys_voucher_entry` WHERE `AccountID`=".$accid." AND `DOV`<'".$todt."' GROUP BY `DrCr`";
				
					$result		= $this->conn->query($sql1);
					while( $row 	= $result->fetch() ) {
						if($row[1] == CREDIT)
							$creditAmt	= $row[0];
						else
							$debitAmt	= $row[0];	
					}
						
				}
				
				if($obaltype == 0) $obaltype = CREDIT;
					
				if($obaltype == CREDIT) {
					$cbal 		= bcadd($obal, $creditAmt,2);
					$cbal			= bcsub($cbal, $debitAmt, 2);
					$cbaltype	= $obaltype;
					if($cbal < 0) {
						$cbaltype 	= DEBIT;
						$cbal 			= -$cbal;
					}
				} else {
					$cbal 		= bcadd($obal, $debitAmt,2);
					$cbal			= bcsub($cbal, $creditAmt, 2);
					$cbaltype	= $obaltype;
					if($cbal < 0) {
						$cbaltype 	= CREDIT;
						$cbal				= - $cbal;
					}
				}
				$retCBal[0]	= $cbal;
				$retCBal[1]	= $cbaltype;
				
			} catch(PDOException $e) {
				$err	= 'masterdb getClosingBalanceByAccountID '.$e->getMessage();
				_errorLog($err);
			}

			return $retCBal;
		}
		
		function getClosingBalanceByMotherAccount($CompanyID, $MotherAccount, $fdate, $IncludeDate = 'NO') {
			$CompanyID			= (int)$CompanyID;
			$MotherAccount	= (int)$MotherAccount;
			$fdate					= addslashes($fdate);
			$IncludeDate		= addslashes($IncludeDate);
			if($fdate == "")
				$fdate 		= "3000-01-01";
			$cbal				= 0;
			$obal				= 0;
			$obaltype		= 0;		/* 1-Cr 2-Db */
			$cbaltype		= 0;
			$retCBal		= array();
			$debitAmt		= 0;
			$creditAmt	= 0;
			$fy					= getFinancialYear(getPreviousDate($fdate));
			$fromdt			= getFirstFinancialDate(getPreviousDate($fdate));
			$todt				= getPreviousDate($fdate);
			if(	$IncludeDate == "YES") $todt = $fdate;
			
			try {
				
				$sql			= "SELECT `OBal`, `OBalType` FROM `asys_opening_balances` WHERE `CompanyID`='".$CompanyID."' AND `FinYear`='".$fy."' AND `MotherAccount`='".$MotherAccount."' LIMIT 1";
				
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch()) {
				
					$tmp1		= 0;
					$tmp2		= 0;
				
					$sql1		= "SELECT SUM(`OBal`), `OBalType` FROM `asys_opening_balances` WHERE `CompanyID`='".$CompanyID."' AND `FinYear`='".$fy."' AND `MotherAccount`='".$MotherAccount."' GROUP BY `OBalType`";				
				
					$result		= $this->conn->query($sql1);
					while( $row 	= $result->fetch() ) {
						if($row[1] == DEBIT)
							$tmp1		= $row[0];
						else
							$tmp2		= $row[0];
					}

					$obal			= $tmp1 - $tmp2;
					$obaltype	= DEBIT;
					if($obal < 0) {
						$obal		= -$obal;
						$obaltype	= CREDIT;
					}
					
					$sql1	= "SELECT SUM(`Amount`), `DrCr` FROM `asys_voucher_entry` WHERE `CompanyID`='".$CompanyID."' AND `MotherAccount`='".$MotherAccount."' AND `DOV`>='".$fromdt."' AND `DOV`<'".$todt."' GROUP BY `DrCr`";					
				
				} else {
				
					$tmp1		= 0;
					$tmp2		= 0;				
				
					$sql1		= "SELECT SUM(`OBal`), `OBalType` FROM `asys_accounts` WHERE `CompanyID`='".$CompanyID."' AND `MotherAccount`='".$MotherAccount."' GROUP BY  `OBalType`";			
				
					$result		= $this->conn->query($sql1);
					while( $row 	= $result->fetch() ) {
						if($row[1] == DEBIT)
							$tmp1		= $row[0];
						else
							$tmp2		= $row[0];
					}

					$obal			= $tmp1 - $tmp2;
					$obaltype	= DEBIT;
					if($obal < 0) {
						$obal		= -$obal;
						$obaltype	= CREDIT;
					}
					
					$sql1	= "SELECT SUM(`Amount`), `DrCr` FROM `asys_voucher_entry` WHERE `CompanyID`='".$CompanyID."' AND `MotherAccount`='".$MotherAccount."' AND `DOV`<'".$todt."' GROUP BY `DrCr`";
				
				}				
				
				
				$result		= $this->conn->query($sql1);
				while( $row 	= $result->fetch() ) {
					if($row[1] == CREDIT)
						$creditAmt	= $row[0];
					else
						$debitAmt		= $row[0];
				}
					
				if($obaltype == CREDIT) {
					$cbal 		= bcadd($obal, $creditAmt,2);
					$cbal			= bcsub($cbal, $debitAmt, 2);
					$cbaltype	= $obaltype;
					if($cbal < 0) {
						$cbaltype 	= DEBIT;
						$cbal 			= -$cbal;
					}
				} else {
					$cbal 		= bcadd($obal, $debitAmt, 2);
					$cbal			= bcsub($cbal, $creditAmt, 2);
					$cbaltype	= $obaltype;
					if($cbal < 0) {
						$cbaltype 	= CREDIT;
						$cbal				= - $cbal;
					}
				}
				$retCBal[0]	= $cbal;
				$retCBal[1]	= $cbaltype;
				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}

			return $retCBal;
		}
		
		function getClosingBalanceByMotherAccountMultipleCompany($CompanyID, $MotherAccount, $fdate, $IncludeDate = 'NO') {
			$CompanyID			= addslashes($CompanyID);
			$MotherAccount	= (int)$MotherAccount;
			$fdate					= addslashes($fdate);
			$IncludeDate		= addslashes($IncludeDate);
			if($fdate == "")
				$fdate 		= "3000-01-01";
			$cbal				= 0;
			$obal				= 0;
			$obaltype		= 0;		/* 1-Cr 2-Db */
			$cbaltype		= 0;
			$retCBal		= array();
			$debitAmt		= 0;
			$creditAmt	= 0;
			$fy					= getFinancialYear(getPreviousDate($fdate));
			$fromdt			= getFirstFinancialDate(getPreviousDate($fdate));
			$todt				= getPreviousDate($fdate);
			if(	$IncludeDate == "YES") $todt = $fdate;
			
			try {
				
				$sql			= "SELECT `OBal`, `OBalType` FROM `asys_opening_balances` WHERE `CompanyID` IN (".$CompanyID.") AND `FinYear`='".$fy."' AND `MotherAccount`='".$MotherAccount."' LIMIT 1";
				
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch()) {
				
					$tmp1		= 0;
					$tmp2		= 0;
				
					$sql1		= "SELECT SUM(`OBal`), `OBalType` FROM `asys_opening_balances` WHERE `CompanyID` IN (".$CompanyID.") AND `FinYear`='".$fy."' AND `MotherAccount`='".$MotherAccount."' GROUP BY `OBalType`";				
				
					$result		= $this->conn->query($sql1);
					while( $row 	= $result->fetch() ) {
						if($row[1] == DEBIT)
							$tmp1		= $row[0];
						else
							$tmp2		= $row[0];
					}

					$obal			= $tmp1 - $tmp2;
					$obaltype	= DEBIT;
					if($obal < 0) {
						$obal		= -$obal;
						$obaltype	= CREDIT;
					}
					
					$sql1	= "SELECT SUM(`Amount`), `DrCr` FROM `asys_voucher_entry` WHERE `MotherAccount`='".$MotherAccount."' AND `DOV`>='".$fromdt."' AND `DOV`<'".$todt."' GROUP BY `DrCr`";
				
				} else {				
				
					$sql			= "SELECT `OBal`, `OBalType` FROM `asys_accounts` WHERE `CompanyID` IN (".$CompanyID.") AND `MotherAccount`='".$MotherAccount."'";
					
					
					$tmp1		= 0;
					$tmp2		= 0;				
				
					$sql1		= "SELECT SUM(`OBal`), `OBalType` FROM `asys_accounts` WHERE `MotherAccount`='".$MotherAccount."' GROUP BY `OBalType`";				
				
					$result		= $this->conn->query($sql1);
					while( $row 	= $result->fetch() ) {
						if($row[1] == DEBIT)
							$tmp1		= $row[0];
						else
							$tmp2		= $row[0];
					}

					$obal			= $tmp1 - $tmp2;
					$obaltype	= DEBIT;
					if($obal < 0) {
						$obal		= -$obal;
						$obaltype	= CREDIT;
					}
					
					$sql1	= "SELECT SUM(`Amount`), `DrCr` FROM `asys_voucher_entry` WHERE `MotherAccount`='".$MotherAccount."' AND `DOV`<'".$todt."' GROUP BY `DrCr`";						
					
				}	
				
				
				$result		= $this->conn->query($sql1);
				while( $row 	= $result->fetch() ) {
					if($row[1] == CREDIT)
						$creditAmt	= $row[0];
					else
						$debitAmt	= $row[0];
				}
					
				if($obaltype == CREDIT) {
					$cbal 		= bcadd($obal, $creditAmt,2);
					$cbal			= bcsub($cbal, $debitAmt, 2);
					$cbaltype	= $obaltype;
					if($cbal < 0) {
						$cbaltype 	= DEBIT;
						$cbal 			= -$cbal;
					}
				} else {
					$cbal 		= bcadd($obal, $debitAmt, 2);
					$cbal			= bcsub($cbal, $creditAmt, 2);				
					$cbaltype	= $obaltype;
					if($cbal < 0) {
						$cbaltype 	= CREDIT;
						$cbal				= - $cbal;
					}
				}
				$retCBal[0]	= $cbal;
				$retCBal[1]	= $cbaltype;															
				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}			

			return $retCBal;
		}
		
		function getClosingBalanceByBGID($CompanyID, $BGID, $fdate, $IncludeDate = 'NO') {
			$CompanyID	= (int)$CompanyID;
			$BGID				= (int)$BGID;
			$fdate			= addslashes($fdate);
			$IncludeDate= addslashes($IncludeDate);
			if($fdate == "")
				$fdate 		= "3000-01-01";
			$cbal				= 0;
			$obal				= 0;
			$obaltype		= 0;		/* 1-Cr 2-Db */
			$cbaltype		= 0;
			$retCBal		= array();
			$debitAmt		= 0;
			$creditAmt	= 0;
			$fy					= getFinancialYear(getPreviousDate($fdate));
			$fromdt			= getFirstFinancialDate(getPreviousDate($fdate));
			$todt				= getPreviousDate($fdate);
			if(	$IncludeDate == "YES") $todt = $fdate;

			try {
				
				$sql			= "SELECT `OBal`, `OBalType` FROM `asys_opening_balances` WHERE `CompanyID`='".$CompanyID."' AND `FinYear`='".$fy."' AND `BGID`='".$BGID."' LIMIT 1";
				
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch()) {
				
					$tmp1		= 0;
					$tmp2		= 0;
				
					$sql1		= "SELECT SUM(`OBal`), `OBalType` FROM `asys_opening_balances` WHERE `CompanyID`='".$CompanyID."' AND `FinYear`='".$fy."' AND `BGID`='".$BGID."' GROUP BY  `OBalType`";
				
					$result		= $this->conn->query($sql1);
					while( $row 	= $result->fetch() ) {
						if($row[1] == DEBIT)
							$tmp1		= $row[0];
						else
							$tmp2		= $row[0];
					}

					$obal			= $tmp1 - $tmp2;
					$obaltype	= DEBIT;
					if($obal < 0) {
						$obal		= -$obal;
						$obaltype	= CREDIT;
					}
					
					$sql1	= "SELECT SUM(`Amount`), `DrCr` FROM `asys_voucher_entry` WHERE `CompanyID`='".$CompanyID."' AND `BGID`='".$BGID."' AND `DOV`>='".$fromdt."' AND `DOV`<'".$todt."' GROUP BY `DrCr`";				

				} else {
				
					$tmp1		= 0;
					$tmp2		= 0;				
				
					$sql1		= "SELECT SUM(`OBal`), `OBalType` FROM `asys_accounts` WHERE `CompanyID`='".$CompanyID."' AND `BGID`='".$BGID."' GROUP BY `OBalType`";				
				
					$result		= $this->conn->query($sql1);
					while( $row 	= $result->fetch() ) {
						if($row[1] == DEBIT)
							$tmp1		= $row[0];
						else
							$tmp2		= $row[0];
					}

					$obal			= $tmp1 - $tmp2;
					$obaltype	= DEBIT;
					if($obal < 0) {
						$obal		= -$obal;
						$obaltype	= CREDIT;
					}
					
					$sql1	= "SELECT SUM(`Amount`), `DrCr` FROM `asys_voucher_entry` WHERE `CompanyID`='".$CompanyID."' AND `BGID`='".$BGID."' AND `DOV`<'".$todt."' GROUP BY `DrCr`";

				}

				
				$result		= $this->conn->query($sql1);
				while( $row 	= $result->fetch() ) {
					if($row[1] == CREDIT)
						$creditAmt	= $row[0];
					else
						$debitAmt	= $row[0];
				}
					
				if($obaltype == CREDIT) {
					$cbal 		= bcadd($obal, $creditAmt,2);
					$cbal			= bcsub($cbal, $debitAmt, 2);
					$cbaltype	= $obaltype;
					if($cbal < 0) {
						$cbaltype 	= DEBIT;
						$cbal 			= -$cbal;
					}
				} else {
					$cbal 		= bcadd($obal, $debitAmt, 2);
					$cbal			= bcsub($cbal, $creditAmt, 2);
					$cbaltype	= $obaltype;
					if($cbal < 0) {
						$cbaltype 	= CREDIT;
						$cbal				= - $cbal;
					}
				}
				$retCBal[0]	= $cbal;
				$retCBal[1]	= $cbaltype;
				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}

			return $retCBal;
		}
		
		function getClosingBalanceByBGIDMultipleCompany($CompanyID, $BGID, $fdate, $IncludeDate = 'NO') {
		
			$CompanyID	= addslashes($CompanyID);
			$BGID				= (int)$BGID;
			$fdate			= addslashes($fdate);
			$IncludeDate= addslashes($IncludeDate);
			if($fdate == "")
				$fdate 		= "3000-01-01";
			$cbal				= 0;
			$obal				= 0;
			$obaltype		= 0;		/* 1-Cr 2-Db */
			$cbaltype		= 0;
			$retCBal		= array();
			$debitAmt		= 0;
			$creditAmt	= 0;
			$fy					= getFinancialYear(getPreviousDate($fdate));
			$fromdt			= getFirstFinancialDate(getPreviousDate($fdate));
			$todt				= getPreviousDate($fdate);
			if(	$IncludeDate == "YES") $todt = $fdate;

			try {
				
				$sql			= "SELECT `OBal`, `OBalType` FROM `asys_opening_balances` WHERE `CompanyID` IN(".$CompanyID.") AND `FinYear`='".$fy."' AND `BGID`='".$BGID."' LIMIT 1";
				
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch()) {
				
					$tmp1		= 0;
					$tmp2		= 0;
				
					$sql1		= "SELECT SUM(`OBal`), `OBalType` FROM `asys_opening_balances` WHERE `CompanyID` IN(".$CompanyID.") AND `FinYear`='".$fy."' AND `BGID`='".$BGID."' GROUP BY  `OBalType`";
				
					$result		= $this->conn->query($sql1);
					while( $row 	= $result->fetch() ) {
						if($row[1] == DEBIT)
							$tmp1		= $row[0];
						else
							$tmp2		= $row[0];
					}

					$obal			= $tmp1 - $tmp2;
					$obaltype	= DEBIT;
					if($obal < 0) {
						$obal		= -$obal;
						$obaltype	= CREDIT;
					}
					
					$sql1	= "SELECT SUM(`Amount`), `DrCr` FROM `asys_voucher_entry` WHERE `CompanyID` IN(".$CompanyID.") AND `BGID`='".$BGID."' AND `DOV`>='".$fromdt."' AND `DOV`<'".$todt."' GROUP BY `DrCr`";				

				} else {
				
					$tmp1		= 0;
					$tmp2		= 0;				
				
					$sql1		= "SELECT SUM(`OBal`), `OBalType` FROM `asys_accounts` WHERE `CompanyID` IN(".$CompanyID.") AND `BGID`='".$BGID."' GROUP BY `OBalType`";				
				
					$result		= $this->conn->query($sql1);
					while( $row 	= $result->fetch() ) {
						if($row[1] == DEBIT)
							$tmp1		= $row[0];
						else
							$tmp2		= $row[0];
					}

					$obal			= $tmp1 - $tmp2;
					$obaltype	= DEBIT;
					if($obal < 0) {
						$obal		= -$obal;
						$obaltype	= CREDIT;
					}
					
					$sql1	= "SELECT SUM(`Amount`), `DrCr` FROM `asys_voucher_entry` WHERE `CompanyID` IN(".$CompanyID.") AND `BGID`='".$BGID."' AND `DOV`<'".$todt."' GROUP BY `DrCr`";

				}

				
				$result		= $this->conn->query($sql1);
				while( $row 	= $result->fetch() ) {
					if($row[1] == CREDIT)
						$creditAmt	= $row[0];
					else
						$debitAmt	= $row[0];
				}
					
				if($obaltype == CREDIT) {
					$cbal 		= bcadd($obal, $creditAmt,2);
					$cbal			= bcsub($cbal, $debitAmt, 2);
					$cbaltype	= $obaltype;
					if($cbal < 0) {
						$cbaltype 	= DEBIT;
						$cbal 			= -$cbal;
					}
				} else {
					$cbal 		= bcadd($obal, $debitAmt, 2);
					$cbal			= bcsub($cbal, $creditAmt, 2);
					$cbaltype	= $obaltype;
					if($cbal < 0) {
						$cbaltype 	= CREDIT;
						$cbal				= - $cbal;
					}
				}
				$retCBal[0]	= $cbal;
				$retCBal[1]	= $cbaltype;
				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}

			return $retCBal;		
		
		}
		
		function getClosingBalanceBySubgroupID($CompanyID, $BGID, $SubgroupID, $fdate, $IncludeDate = 'NO') {
			$CompanyID	= (int)$CompanyID;
			$BGID				= (int)$BGID;
			$SubgroupID	= (int)$SubgroupID;
			$fdate			= addslashes($fdate);
			$IncludeDate= addslashes($IncludeDate);
			if($fdate == "")
				$fdate 		= "3000-01-01";
			$cbal				= 0;
			$obal				= 0;
			$obaltype		= 0;		/* 1-Cr 2-Db */
			$cbaltype		= 0;
			$retCBal		= array();
			$debitAmt		= 0;
			$creditAmt	= 0;
			$fy					= getFinancialYear(getPreviousDate($fdate));
			$fromdt			= getFirstFinancialDate(getPreviousDate($fdate));
			$todt				= getPreviousDate($fdate);
			if(	$IncludeDate == "YES") $todt = $fdate;
			
			try {
				
				$sql			= "SELECT `OBal`, `OBalType` FROM `asys_opening_balances` WHERE `CompanyID`='".$CompanyID."' AND `BGID`='".$BGID."' AND `FinYear`='".$fy."' AND `SubgroupID`='".$SubgroupID."' LIMIT 1";
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch()) {
				
					$tmp1		= 0;
					$tmp2		= 0;
				
					$sql1		= "SELECT SUM(`OBal`), `OBalType` FROM `asys_opening_balances` WHERE `CompanyID`='".$CompanyID."' AND `FinYear`='".$fy."' AND `BGID`='".$BGID."' AND `SubgroupID`='".$SubgroupID."' GROUP BY `OBalType`";
				
					$result		= $this->conn->query($sql1);
					while( $row 	= $result->fetch() ) {
						if($row[1] == DEBIT)
							$tmp1		= $row[0];
						else
							$tmp2		= $row[0];
					}

					$obal			= $tmp1 - $tmp2;
					$obaltype	= DEBIT;
					if($obal < 0) {
						$obal		= -$obal;
						$obaltype	= CREDIT;
					}
					
					$sql1	= "SELECT SUM(`Amount`), `DrCr` FROM `asys_voucher_entry` WHERE `CompanyID`='".$CompanyID."' AND `BGID`='".$BGID."' AND `SubgroupID`='".$SubgroupID."' AND `DOV`>='".$fromdt."' AND `DOV`<'".$todt."' GROUP BY `DrCr`";
				
				} else {
				
					$tmp1		= 0;
					$tmp2		= 0;
				
					$sql1		= "SELECT SUM(`OBal`), `OBalType` FROM `asys_accounts` WHERE `CompanyID`='".$CompanyID."' AND `BGID`='".$BGID."' AND `SubgroupID`='".$SubgroupID."' GROUP BY `OBalType`";
				
					$result		= $this->conn->query($sql1);
					while( $row 	= $result->fetch() ) {
						if($row[1] == DEBIT)
							$tmp1		= $row[0];
						else
							$tmp2		= $row[0];
					}

					$obal			= $tmp1 - $tmp2;
					$obaltype	= DEBIT;
					if($obal < 0) {
						$obal		= -$obal;
						$obaltype	= CREDIT;
					}
					
					$sql1	= "SELECT SUM(`Amount`), `DrCr` FROM `asys_voucher_entry` WHERE `CompanyID`='".$CompanyID."' AND `BGID`='".$BGID."' AND `SubgroupID`='".$SubgroupID."' AND `DOV`<'".$todt."' GROUP BY `DrCr`";					
				
				}				
				
				
				$result		= $this->conn->query($sql1);
				while( $row 	= $result->fetch() ) {
					if($row[1] == CREDIT)
						$creditAmt	= $row[0];
					else
						$debitAmt	= $row[0];
				}
					
				if($obaltype == CREDIT) {
					$cbal 		= bcadd($obal, $creditAmt,2);
					$cbal			= bcsub($cbal, $debitAmt, 2);
					$cbaltype	= $obaltype;
					if($cbal < 0) {
						$cbaltype 	= DEBIT;
						$cbal 			= -$cbal;
					}
				} else {
					$cbal 		= bcadd($obal, $debitAmt, 2);
					$cbal			= bcsub($cbal, $creditAmt, 2);
					$cbaltype	= $obaltype;
					if($cbal < 0) {
						$cbaltype 	= CREDIT;
						$cbal				= - $cbal;
					}
				}
				$retCBal[0]	= $cbal;
				$retCBal[1]	= $cbaltype;
				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}

			return $retCBal;
		}
		
		function getClosingBalanceBySubgroupIDMultipleCompany($CompanyID, $BGID, $SubgroupID, $fdate, $IncludeDate = 'NO') {
		
			$CompanyID	= addslashes($CompanyID);
			$BGID				= (int)$BGID;
			$SubgroupID	= (int)$SubgroupID;
			$fdate			= addslashes($fdate);
			$IncludeDate= addslashes($IncludeDate);
			if($fdate == "")
				$fdate 		= "3000-01-01";
			$cbal				= 0;
			$obal				= 0;
			$obaltype		= 0;		/* 1-Cr 2-Db */
			$cbaltype		= 0;
			$retCBal		= array();
			$debitAmt		= 0;
			$creditAmt	= 0;
			$fy					= getFinancialYear(getPreviousDate($fdate));
			$fromdt			= getFirstFinancialDate(getPreviousDate($fdate));
			$todt				= getPreviousDate($fdate);
			if(	$IncludeDate == "YES") $todt = $fdate;
			
			try {
				
				$sql			= "SELECT `OBal`, `OBalType` FROM `asys_opening_balances` WHERE `CompanyID` IN (".$CompanyID.") AND `BGID`='".$BGID."' AND `FinYear`='".$fy."' AND `SubgroupID`='".$SubgroupID."' LIMIT 1";
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch()) {
				
					$tmp1		= 0;
					$tmp2		= 0;
				
					$sql1		= "SELECT SUM(`OBal`), `OBalType` FROM `asys_opening_balances` WHERE `CompanyID` IN (".$CompanyID.") AND `FinYear`='".$fy."' AND `BGID`='".$BGID."' AND `SubgroupID`='".$SubgroupID."' GROUP BY `OBalType`";				
				
					$result		= $this->conn->query($sql1);
					while( $row 	= $result->fetch() ) {
						if($row[1] == DEBIT)
							$tmp1		= $row[0];
						else
							$tmp2		= $row[0];
					}

					$obal			= $tmp1 - $tmp2;
					$obaltype	= DEBIT;
					if($obal < 0) {
						$obal		= -$obal;
						$obaltype	= CREDIT;
					}
					
					$sql1	= "SELECT SUM(`Amount`), `DrCr` FROM `asys_voucher_entry` WHERE `CompanyID` IN (".$CompanyID.") AND `BGID`='".$BGID."' AND `SubgroupID`='".$SubgroupID."' AND `DOV`>='".$fromdt."' AND `DOV`<'".$todt."' GROUP BY `DrCr`";
				
				} else {
				
					$tmp1		= 0;
					$tmp2		= 0;				
				
					$sql1		= "SELECT SUM(`OBal`), `OBalType` FROM `asys_accounts` WHERE `CompanyID` IN (".$CompanyID.") AND `BGID`='".$BGID."' AND `SubgroupID`='".$SubgroupID."' GROUP BY `OBalType`";					
				
					$result		= $this->conn->query($sql1);
					while( $row 	= $result->fetch() ) {
						if($row[1] == DEBIT)
							$tmp1		= $row[0];
						else
							$tmp2		= $row[0];
					}

					$obal			= $tmp1 - $tmp2;
					$obaltype	= DEBIT;
					if($obal < 0) {
						$obal		= -$obal;
						$obaltype	= CREDIT;
					}
					
					$sql1	= "SELECT SUM(`Amount`), `DrCr` FROM `asys_voucher_entry` WHERE `CompanyID` IN (".$CompanyID.") AND `BGID`='$BGID' AND `SubgroupID`='$SubgroupID' AND `DOV`<'".$todt."' GROUP BY `DrCr`";			
				
				}				
				
				
				$result		= $this->conn->query($sql1);
				if( $row 	= $result->fetch() ) {
					if($row[1] == CREDIT)
						$creditAmt	= $row[0];
					else
						$debitAmt	= $row[0];
				}
					
				if($obaltype == CREDIT) {
					$cbal 		= bcadd($obal, $creditAmt,2);
					$cbal			= bcsub($cbal, $debitAmt, 2);
					$cbaltype	= $obaltype;
					if($cbal < 0) {
						$cbaltype 	= DEBIT;
						$cbal 			= -$cbal;
					}
				} else {
					$cbal 		= bcadd($obal, $debitAmt, 2);
					$cbal			= bcsub($cbal, $creditAmt, 2);
					$cbaltype	= $obaltype;
					if($cbal < 0) {
						$cbaltype 	= CREDIT;
						$cbal				= - $cbal;
					}
				}
				$retCBal[0]	= $cbal;
				$retCBal[1]	= $cbaltype;
				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}

			return $retCBal;		
		
		}
		
		function getTotalDebitAmountByAccountID($AccountID, $DateFrom, $DateTo) {
			$AccountID	= (int)$AccountID;
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$sql				= "SELECT SUM(`Amount`) FROM `asys_voucher_entry` WHERE `AccountID`='".$AccountID."' AND `DrCr`='".DEBIT."' AND `DOV`>='".$DateFrom."' AND `DOV`<='".$DateTo."'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getTotalDebitAmountByMotherAccountID($MotherAccount, $DateFrom, $DateTo) {
			$MotherAccount	= (int)$MotherAccount;
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$sql				= "SELECT SUM(`Amount`) FROM `asys_voucher_entry` WHERE `MotherAccount`='".$MotherAccount."' AND `DrCr`='".DEBIT."' AND `DOV`>='".$DateFrom."' AND `DOV`<='".$DateTo."'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getTotalDebitAmountByBGID($CompanyID, $BGID, $DateFrom, $DateTo) {
			$CompanyID	= (int)$CompanyID;
			$BGID				= (int)$BGID;
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$sql				= "SELECT SUM(`asys_voucher_entry`.`Amount`) FROM `asys_voucher_entry` INNER JOIN `asys_accounts` ON `asys_voucher_entry`.`AccountID`=`asys_accounts`.`AccountID` WHERE `asys_voucher_entry`.`CompanyID`='".$CompanyID."' AND `asys_accounts`.`BGID`='".$BGID."' AND `asys_voucher_entry`.`DOV`>='".$DateFrom."' AND `asys_voucher_entry`.`DOV`<='".$DateTo."' AND `DrCr`='".DEBIT."'";			
			return $this->getResultExecutingQuery($sql);
		}
		
		function getTotalDebitAmountBySubgroupID($CompanyID, $BGID, $SubgroupID, $DateFrom, $DateTo) {
			$CompanyID	= (int)$CompanyID;
			$BGID				= (int)$BGID;
			$SubgroupID	= (int)$SubgroupID;
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$sql				= "SELECT SUM(`asys_voucher_entry`.`Amount`) FROM `asys_voucher_entry` INNER JOIN `asys_accounts` ON `asys_voucher_entry`.`AccountID`=`asys_accounts`.`AccountID` WHERE `asys_voucher_entry`.`CompanyID`='".$CompanyID."' AND `asys_accounts`.`BGID`='".$BGID."' AND `asys_accounts`.`SubgroupID`='".$SubgroupID."' AND `asys_voucher_entry`.`DOV`>='".$DateFrom."' AND `asys_voucher_entry`.`DOV`<='".$DateTo."' AND `DrCr`='".DEBIT."'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getTotalDebitAmountByAccountIDIssue($AccountID, $DateFrom, $DateTo, $StoreID) {
			$AccountID	= (int)$AccountID;
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$StoreID		= (int)$StoreID;
			$sql				= "SELECT SUM(`Amount`) FROM `asys_voucher_entry` INNER JOIN `gen_issue` ON `asys_voucher_entry`.`RelatedID`=`gen_issue`.`IssueID` WHERE `AccountID`='".$AccountID."' AND `DrCr`='".DEBIT."' AND `DOV`>='".$DateFrom."' AND `DOV`<='".$DateTo."' AND `TxnType` = '10' AND `StoreID`='$StoreID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getTotalDebitAmountByAccountIDTransferIssue($AccountID, $DateFrom, $DateTo, $StoreID) {
			$AccountID	= (int)$AccountID;
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$StoreID		= (int)$StoreID;
			$sql				= "SELECT SUM(`Amount`) FROM `asys_voucher_entry` INNER JOIN `gen_transferissue` ON `asys_voucher_entry`.`RelatedID`=`gen_transferissue`.`BookingID` WHERE `AccountID`='".$AccountID."' AND `DrCr`='".DEBIT."' AND `DOV`>='".$DateFrom."' AND `DOV`<='".$DateTo."' AND `TxnType` = '13' AND `ToStoreID`='$StoreID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getTotalCreditAmountByAccountID($AccountID, $DateFrom, $DateTo) {
			$AccountID	= (int)$AccountID;
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$sql				= "SELECT SUM(`Amount`) FROM `asys_voucher_entry` WHERE `AccountID`='".$AccountID."' AND `DrCr`='".CREDIT."' AND `DOV`>='".$DateFrom."' AND `DOV`<='".$DateTo."'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getTotalCreditAmountByMotherAccountID($MotherAccount, $DateFrom, $DateTo) {
			$MotherAccount	= (int)$MotherAccount;
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$sql				= "SELECT SUM(`Amount`) FROM `asys_voucher_entry` WHERE `MotherAccount`='".$MotherAccount."' AND `DrCr`='".CREDIT."' AND `DOV`>='".$DateFrom."' AND `DOV`<='".$DateTo."'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getTotalCreditAmountByBGID($CompanyID, $BGID, $DateFrom, $DateTo) {
			$CompanyID	= (int)$CompanyID;
			$BGID				= (int)$BGID;
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$sql				= "SELECT SUM(`asys_voucher_entry`.`Amount`) FROM `asys_voucher_entry` INNER JOIN `asys_accounts` ON `asys_voucher_entry`.`AccountID`=`asys_accounts`.`AccountID` WHERE `asys_voucher_entry`.`CompanyID`='".$CompanyID."' AND `asys_accounts`.`BGID`='".$BGID."' AND `asys_voucher_entry`.`DOV`>='".$DateFrom."' AND `asys_voucher_entry`.`DOV`<='".$DateTo."' AND `DrCr`='".CREDIT."'";			
			return $this->getResultExecutingQuery($sql);
		}
		
		function getTotalCreditAmountBySubgroupID($CompanyID, $BGID, $SubgroupID, $DateFrom, $DateTo) {
			$CompanyID	= (int)$CompanyID;
			$BGID				= (int)$BGID;
			$SubgroupID	= (int)$SubgroupID;
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$sql				= "SELECT SUM(`asys_voucher_entry`.`Amount`) FROM `asys_voucher_entry` INNER JOIN `asys_accounts` ON `asys_voucher_entry`.`AccountID`=`asys_accounts`.`AccountID` WHERE `asys_voucher_entry`.`CompanyID`='".$CompanyID."' AND `asys_accounts`.`BGID`='".$BGID."' AND `asys_accounts`.`SubgroupID`='".$SubgroupID."' AND `asys_voucher_entry`.`DOV`>='".$DateFrom."' AND `asys_voucher_entry`.`DOV`<='".$DateTo."' AND `DrCr`='".CREDIT."'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getTotalDebitCreditAmountByAccountID($AccountID, $DateFrom, $DateTo) {
			$AccountID	= (int)$AccountID;
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$sql				= "SELECT SUM(`Amount`), `DrCr` FROM `asys_voucher_entry` WHERE `AccountID`='".$AccountID."' AND `DOV`>='".$DateFrom."' AND `DOV`<='".$DateTo."' GROUP BY `DrCr`";
			
			$retarr			= array();
			$dr					= 0;
			$cr					= 0;
			
			try {
				
				$result	= $this->conn->query($sql);
				while($row = $result->fetch()) {
					if($row[1] == DEBIT)
						$dr		= $row[0];
					else
						$cr		= $row[0];
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getTotalDebitCreditAmountByAccountID ('.$sql.') '.$e->getMessage();
				_errorLog($err);
			}			
			$retarr[0]	= $dr;
			$retarr[1]	= $cr;
			
			return $retarr;
		}
		
		function getTotalDebitCreditAmountByMotherAccountID($MotherAccount, $DateFrom, $DateTo) {
			$MotherAccount	= (int)$MotherAccount;
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$sql				= "SELECT SUM(`Amount`), `DrCr` FROM `asys_voucher_entry` WHERE `MotherAccount`='".$MotherAccount."' AND `DOV`>='".$DateFrom."' AND `DOV`<='".$DateTo."' GROUP BY `DrCr`";

			$retarr			= array();
			$dr					= 0;
			$cr					= 0;
			
			try {
				
				$result	= $this->conn->query($sql);
				while($row = $result->fetch()) {
					if($row[1] == DEBIT)
						$dr		= $row[0];
					else
						$cr		= $row[0];
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getTotalDebitCreditAmountByMotherAccountID ('.$sql.') '.$e->getMessage();
				_errorLog($err);
			}			
			$retarr[0]	= $dr;
			$retarr[1]	= $cr;
			
			return $retarr;
		}
		
		function getTotalDebitCreditAmountByBGID($CompanyID, $BGID, $DateFrom, $DateTo) {
			$CompanyID	= (int)$CompanyID;
			$BGID				= (int)$BGID;
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$sql				= "SELECT SUM(`Amount`), `DrCr` FROM `asys_voucher_entry` WHERE `CompanyID`='".$CompanyID."' AND `BGID`='".$BGID."' AND `DOV`>='".$DateFrom."' AND `DOV`<='".$DateTo."' GROUP BY `DrCr`";			

			$retarr			= array();
			$dr					= 0;
			$cr					= 0;
			
			try {
				
				$result	= $this->conn->query($sql);
				while($row = $result->fetch()) {
					if($row[1] == DEBIT)
						$dr		= $row[0];
					else
						$cr		= $row[0];
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getTotalDebitCreditAmountByBGID ('.$sql.') '.$e->getMessage();
				_errorLog($err);
			}			
			$retarr[0]	= $dr;
			$retarr[1]	= $cr;
			
			return $retarr;
		}
		
		function getTotalDebitCreditAmountBySubgroupID($CompanyID, $BGID, $SubgroupID, $DateFrom, $DateTo) {
			$CompanyID	= (int)$CompanyID;
			$BGID				= (int)$BGID;
			$SubgroupID	= (int)$SubgroupID;
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$sql				= "SELECT SUM(`Amount`), `DrCr` FROM `asys_voucher_entry` WHERE `CompanyID`='".$CompanyID."' AND `BGID`='".$BGID."' AND `SubgroupID`='".$SubgroupID."' AND `DOV`>='".$DateFrom."' AND `DOV`<='".$DateTo."' GROUP BY `DrCr`";

			$retarr			= array();
			$dr					= 0;
			$cr					= 0;
			
			try {
				
				$result	= $this->conn->query($sql);
				while($row = $result->fetch()) {
					if($row[1] == DEBIT)
						$dr		= $row[0];
					else
						$cr		= $row[0];
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getTotalDebitCreditAmountBySubgroupID ('.$sql.') '.$e->getMessage();
				_errorLog($err);
			}			
			$retarr[0]	= $dr;
			$retarr[1]	= $cr;
			
			return $retarr;
		}
		
		function getCompanyIDByAccountID($AccountID) {
			$AccountID	= (int)$AccountID;
			$sql				= "SELECT `CompanyID` FROM `asys_accounts` WHERE `AccountID`='".$AccountID."'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getCompanyIDByTransaction($tblName, $colName, $colID) {
			$tblName	= addslashes($tblName);
			$colName	= addslashes($colName);
			$colID		= (int)$colID;
			$sql				= "SELECT `CompanyID` FROM `$tblName` WHERE `$colName`='".$colID."'";
			return $this->getResultExecutingQuery($sql);
		}
		
		

		/*----------------------------------------------------------------*/
		/*********************** DEPARTMENT METHODS ***********************/

		function getDepartmentDetail($DepartmentID) {
			$DepartmentID	= (int)$DepartmentID;
			$cclass			=	new asys_departments();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_departments` WHERE `DepartmentID`='$DepartmentID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_departments');
				if($row 	= $result->fetch()) {
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getDepartmentDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getDepartmentList() {
			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_departments` ORDER BY `DepartmentName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_departments');
				while($row = $result->fetch()) {
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getDepartmentList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getDepartmentListJSON(){
		
			$sql		= "SELECT `DepartmentID`, `DepartmentName` FROM `asys_departments` ORDER BY `DepartmentName`";
			return $this->getRecordsetExecutingQuery($sql);
		
		}
		
		function getNumberOfDepartment($schStr) {
			$schStr		= addslashes($schStr);
			if($schStr == "")
				$sql	=	"SELECT COUNT(*) FROM `asys_departments`";
			else
				$sql	=	"SELECT COUNT(*) FROM `asys_departments` WHERE `DepartmentName` LIKE '%$schStr%'";
			
			return $this->getResultExecutingQuery($sql);
		}

		function getDepartmentListPaged($sRec, $nRec, $schStr) {
			$sRec			= (int)$sRec;
			$nRec			= (int)$nRec;
			$schStr		= addslashes($schStr);
			if($schStr == "")
				$sql			=	"SELECT * FROM `asys_departments` ORDER BY `DepartmentName` LIMIT $sRec, $nRec";
			else
				$sql			=	"SELECT * FROM `asys_departments` WHERE `DepartmentName` LIKE '%$schStr%' ORDER BY `DepartmentName` LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_departments');
				while($row = $result->fetch()) {
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getDepartmentListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function getDepartmentNameByDepartmentID($DepartmentID) {
			$DepartmentID	= (int)$DepartmentID;
			$sql		=	"SELECT `DepartmentName` FROM `asys_departments` WHERE `DepartmentID`='$DepartmentID'";
			return $this->getResultExecutingQuery($sql);
		}

		function deleteDepartment($lcls) {
		
			$pkey	= $lcls->getDepartmentID();
			$ret				= false;
		
			try {
				
				$sql			=	"SELECT * FROM `gen_rooms` WHERE `DepartmentID`='$pkey'";
				$result		= $this->conn->query($sql);
				if(!$row 	= $result->fetch()) {
					$sql		= $lcls->getDeleteSQL();
					
					$ret		= $this->conn->query($sql);
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb deleteDepartment '.$e->getMessage();
				_errorLog($err);
			}
		
			return $ret;
		}
		
		

		/*------------------------------------------------------------*/
		/*********************** MODULE METHODS ***********************/

		function getModuleDetail($ModuleID) {
			$ModuleID	= (int)$ModuleID;
			$cclass			=	new asys_modules();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_modules` WHERE `ModuleID`='$ModuleID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_modules');
				if($row 	= $result->fetch()) { 
					$row->setCompanyName( $this->getCompanyNameByCompanyID( $row->getCompanyID()));
					$row->setDepartmentName( $this->getDepartmentNameByDepartmentID( $row->getDepartmentID()));
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getModuleDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}
		
		function getModuleColumnList($ModuleID) {
			$ModuleID		= (int)$ModuleID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_module_columns` WHERE `ModuleID`='$ModuleID' ORDER BY `SerialNo`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_module_columns');
				while($row = $result->fetch()) {
					$row->setEventList($this->getModuleColumnEventList($row->getModuleID(), $row->getColumnName()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
					$err	= 'masterdb getModuleColumnList '.$e->getMessage();
					_errorLog($err);
			}

			return $arr;
		}
		
		function getModuleColumnDetail($ModuleID, $ColumnName) {
			$ModuleID		= (int)$ModuleID;
			$ColumnName	= addslashes($ColumnName);
			$cls				=	new asys_module_columns();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_module_columns` WHERE `ModuleID`='$ModuleID' AND `ColumnName`='$ColumnName'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_module_columns');
				while($row = $result->fetch()) {
					$row->setEventList($this->getModuleColumnEventList($row->getModuleID(), $row->getColumnName()));
					$cls		= $row;
				}
				
			} catch(PDOException $e) {
					$err	= 'masterdb getModuleColumnDetail '.$e->getMessage();
					_errorLog($err);
			}

			return $cls;
		}
		
		function getModuleColumnEventList($ModuleID, $ColumnName) {
			$ModuleID		= (int)$ModuleID;
			$ColumnName	= addslashes($ColumnName);
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_module_column_events` WHERE `ModuleID`='$ModuleID' AND `ColumnName`='$ColumnName' ORDER BY `EventName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_module_column_events');
				while($row = $result->fetch()) {
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
					$err	= 'masterdb getModuleColumnEventList '.$e->getMessage();
					_errorLog($err);
			}

			return $arr;
		}
		
		function getModuleVoucherConfigList($ModuleID) {
			$ModuleID		= (int)$ModuleID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_module_voucher_config` WHERE `ModuleID`='$ModuleID' ORDER BY `VoucherConfigID`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_module_voucher_config');
				while($row = $result->fetch()) {
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
					$err	= 'masterdb getModuleVoucherConfigList '.$e->getMessage();
					_errorLog($err);
			}

			return $arr;
		}
		
		function getModuleStockConfigList($ModuleID) {
			$ModuleID		= (int)$ModuleID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_module_stock_config` WHERE `ModuleID`='$ModuleID' ORDER BY `StockConfigID`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_module_stock_config');
				while($row = $result->fetch()) {
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
					$err	= 'masterdb getModuleStockConfigList '.$e->getMessage();
					_errorLog($err);
			}

			return $arr;
		}
		
		function getModuleSubModuleList($ModuleID) {
			$ModuleID		= (int)$ModuleID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_module_submodules` WHERE `ModuleID`='$ModuleID' ORDER BY `SubmoduleID`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_module_submodules');
				while($row = $result->fetch()) {
					$arr[]	= $row;				
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getModuleSubModuleList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getModuleViewDetail($ModuleID) {
			$ModuleID		= (int)$ModuleID;
			$cclass			=	new asys_module_views();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_module_views` WHERE `ModuleID`='$ModuleID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_module_views');
				if($row 	= $result->fetch()) {
					$row->setFieldList($this->getModuleViewFieldList($row->getModuleID()));
					$row->setSearchList($this->getModuleViewSearchList($row->getModuleID())); 	
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getModuleViewDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}
		
		function getModuleViewFieldList($ModuleID) {
			$ModuleID	= (int)$ModuleID;
			$arr			=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_module_view_fields` WHERE `ModuleID`='$ModuleID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_module_view_fields');
				while($row = $result->fetch()) {
					$arr[]	= $row;				
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getModuleViewFieldList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getModuleViewSearchList($ModuleID) {
			$ModuleID	= (int)$ModuleID;
			$arr			=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_module_view_search` WHERE `ModuleID`='$ModuleID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_module_view_search');
				while($row = $result->fetch()) {
					$arr[]	= $row;				
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getModuleViewSearchList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function getModuleList() {
			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_modules` ORDER BY `ModuleType`, `ModuleName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_modules');
				while($row = $result->fetch()) {
					$row->setCompanyName( $this->getCompanyNameByCompanyID( $row->getCompanyID()));
					$row->setDepartmentName( $this->getDepartmentNameByDepartmentID( $row->getDepartmentID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getModuleList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getModuleList2() {
			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_modules` ORDER BY `ModuleName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_modules');
				while($row = $result->fetch()) {
					$row->setCompanyName( $this->getCompanyNameByCompanyID( $row->getCompanyID()));
					$row->setDepartmentName( $this->getDepartmentNameByDepartmentID( $row->getDepartmentID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getModuleList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}		
		
		function getCompanyWiseModuleList($CompanyID) {
			$CompanyID	= (int)$CompanyID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_modules` WHERE `CompanyID`='$CompanyID' ORDER BY `ModuleType`, `ModuleName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_modules');
				while($row = $result->fetch()) {
					$row->setCompanyName( $this->getCompanyNameByCompanyID( $row->getCompanyID()));
					$row->setDepartmentName( $this->getDepartmentNameByDepartmentID( $row->getDepartmentID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getCompanyWiseModuleList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getCompanyTypeWiseModuleList($CompanyID, $ModuleType) {
			$CompanyID	= (int)$CompanyID;
			$ModuleType	= addslashes($ModuleType);
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_modules` WHERE `CompanyID`='$CompanyID' AND `ModuleType`='$ModuleType' ORDER BY `ModuleID`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_modules');
				while($row = $result->fetch()) {
					$row->setCompanyName( $this->getCompanyNameByCompanyID( $row->getCompanyID()));
					$row->setDepartmentName( $this->getDepartmentNameByDepartmentID( $row->getDepartmentID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getCompanyTypeWiseModuleList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getModuleListJSON(){
		
			$sql		= "SELECT `ModuleID`, `ModuleName` FROM `asys_modules` ORDER BY `ModuleName`";
			return $this->getRecordsetExecutingQuery($sql);
		
		}
		
		function getNumberOfModule($ModuleID, $ModuleName, $ModuleType) {
			$ModuleID			= (int)$ModuleID;
			$ModuleName		= addslashes($ModuleName);
			$ModuleType		= addslashes($ModuleType);
			
			$sql			=	"SELECT COUNT(*) FROM `asys_modules` WHERE 1=1";
			if($ModuleID != 0)
				$sql		= $sql." AND `ModuleID`='$ModuleID'";
			if($ModuleName != "")
				$sql		= $sql." AND `ModuleName` LIKE '%$ModuleName%'";
			if($ModuleType != "")
				$sql		= $sql." AND `ModuleType`='$ModuleType'";

			
			return $this->getResultExecutingQuery($sql);
		}

		function getModuleListPaged($sRec, $nRec, $ModuleID, $ModuleName, $ModuleType) {
			$sRec					= (int)$sRec;
			$nRec					= (int)$nRec;
			$ModuleID			= (int)$ModuleID;
			$ModuleName		= addslashes($ModuleName);
			$ModuleType		= addslashes($ModuleType);
			
			$sql			=	"SELECT * FROM `asys_modules` WHERE 1=1";
			if($ModuleID != 0)
				$sql		= $sql." AND `ModuleID`='$ModuleID'";
			if($ModuleName != "")
				$sql		= $sql." AND `ModuleName` LIKE '%$ModuleName%'";
			if($ModuleType != "")
				$sql		= $sql." AND `ModuleType`='$ModuleType'";			
			
			$sql			=	$sql." ORDER BY `ModuleName` LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_modules');
				while($row = $result->fetch()) {
					$row->setCompanyName( $this->getCompanyNameByCompanyID( $row->getCompanyID()));
					$row->setColumnList($this->getModuleColumnList($row->getModuleID()));
					$row->setVoucherConfigList($this->getModuleVoucherConfigList($row->getModuleID()));
					$row->setStockConfigList($this->getModuleStockConfigList($row->getModuleID()));
					$row->setSubmoduleList($this->getModuleSubModuleList($row->getModuleID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getModuleListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function getModuleNameByModuleID($ModuleID) {
			$ModuleID	= (int)$ModuleID;
			$sql		=	"SELECT `ModuleName` FROM `asys_modules` WHERE `ModuleID`='$ModuleID'";
			return $this->getResultExecutingQuery($sql);
		}

		function deleteModule($lcls) {
		
			$pkey	= $lcls->getModuleID();
			$ret				= false;
		
			try {
				
				$sql			=	"SELECT * FROM `asys_user_permission` WHERE `ModuleID`='$pkey'";
				$result		= $this->conn->query($sql);
				if(!$row 	= $result->fetch()) {
					$sql		= $lcls->getDeleteSQL();
					$ret		= $this->conn->query($sql);
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb deleteModule '.$e->getMessage();
				_errorLog($err);
			}
		
			return $ret;
		}



		/*-----------------------------------------------------------*/
		/*********************** STORE METHODS ***********************/

		function getStoreDetail($StoreID) {
			$StoreID	= (int)$StoreID;
			$cclass			=	new asys_stores();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_stores` WHERE `StoreID`='$StoreID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_stores');
				if($row 	= $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccountID()));
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));
					$row->setOppositeAccountName( $this->getAccountNameByAccountID( $row->getOppositeAccountID()));					
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getStoreDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getStoreList($CompanyID) {
			$CompanyID	= (int)$CompanyID;
			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_stores` WHERE `CompanyID`='$CompanyID' ORDER BY `StoreName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_stores');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccountID()));
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));
					$row->setOppositeAccountName( $this->getAccountNameByAccountID( $row->getOppositeAccountID()));						
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getStoreList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getAllStoreList() {

			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_stores` ORDER BY `StoreName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_stores');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccountID()));
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));
					$row->setOppositeAccountName( $this->getAccountNameByAccountID( $row->getOppositeAccountID()));						
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getAllStoreList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getStoreListJSON($CompanyID){
			$CompanyID	= (int)$CompanyID;
			$sql		= "SELECT `StoreID`, `StoreName` FROM `asys_stores` WHERE `CompanyID`='$CompanyID' ORDER BY `StoreName`";
			return $this->getRecordsetExecutingQuery($sql);
		}
		
		function getAllStoreListJSON(){

			$sql		= "SELECT `StoreID`, `StoreName` FROM `asys_stores` ORDER BY `StoreName`";
			return $this->getRecordsetExecutingQuery($sql);
		
		}
		
		function getNumberOfStore($schStr, $CompanyID) {
			$schStr		= addslashes($schStr);
			$CompanyID	= (int)$CompanyID;
			
			$sql	=	"SELECT COUNT(*) FROM `asys_stores` WHERE `CompanyID`='$CompanyID'";
			if($schStr != "")
				$sql	=	$sql." AND `StoreName` LIKE '%$schStr%'";
			
			return $this->getResultExecutingQuery($sql);
		}

		function getStoreListPaged($sRec, $nRec, $schStr, $CompanyID) {
			$sRec		= (int)$sRec;
			$nRec		= (int)$nRec;
			$schStr	= addslashes($schStr);
			$CompanyID	= (int)$CompanyID;
			
			$sql	=	"SELECT * FROM `asys_stores` WHERE `CompanyID`='$CompanyID'";
			if($schStr != "")
				$sql	=	$sql." AND `StoreName` LIKE '%$schStr%'";

			$sql		=	$sql." ORDER BY `StoreName` LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_stores');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccountID()));
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));	
					$row->setOppositeAccountName( $this->getAccountNameByAccountID( $row->getOppositeAccountID()));					
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getStoreListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function getStoreNameByStoreID($StoreID) {
			$StoreID	= (int)$StoreID;
			$sql		=	"SELECT `StoreName` FROM `asys_stores` WHERE `StoreID`='$StoreID'";
			return $this->getResultExecutingQuery($sql);
		}

		function deleteStore($lcls) {
		
			$pkey	= $lcls->getStoreID();
			$ret				= false;
		
			try {
				
				$sql			=	"SELECT * FROM `asys_stock_voucher` WHERE `StoreID`='$pkey'";
				$result		= $this->conn->query($sql);
				if(!$row 	= $result->fetch()) {
					$sql		= $lcls->getDeleteSQL();
					$ret		= $this->conn->query($sql);
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb deleteStore '.$e->getMessage();
				_errorLog($err);
			}
		
			return $ret;
		}
		
		function doLedgerExistsInOpposite($OppositeAccountID) {
			$OppositeAccountID	= (int)$OppositeAccountID;
			$sql		=	"SELECT `StoreID` FROM `asys_stores` WHERE `OppositeAccountID`='$OppositeAccountID'";
			$result		= $this->conn->query($sql);
			if($row 	= $result->fetch()) {
				return true;
			}
			
			return false;
		}



		/*----------------------------------------------------------------------*/
		/*********************** OPENING BALANCES METHODS ***********************/
		
		function getOBalList($CompanyID) {
			$CompanyID	= (int)$CompanyID;

			$sql	=	"SELECT DISTINCT(`FinYear`) FROM `asys_opening_balances` WHERE `CompanyID`='$CompanyID' ORDER BY `FinYear`";
			return $this->getRecordSetExecutingQuery($sql);
		}
		
		function getOpeningBalancesListYearWise($FinYear, $CompanyID) {
			$FinYear		= addslashes($FinYear);
			$CompanyID	= (int)$CompanyID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT `asys_opening_balances`.* FROM `asys_opening_balances` INNER JOIN `asys_accounts` ON `asys_opening_balances`.`AccountID`=`asys_accounts`.`AccountID` WHERE `FinYear`='$FinYear' AND `asys_opening_balances`.`CompanyID`='$CompanyID' ORDER BY `asys_accounts`.`AccountName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_opening_balances');
				while($row = $result->fetch()) {
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));
					$row->setGroupName($this->getGroupNameByGroupID($row->getGroupID()));
					$row->setBGName($this->getBaseGroupNameByBaseGroupID($row->getBGID()));
					$row->setSubgroupName($this->getSubgroupNameBySubgroupID($row->getSubgroupID()));
					$arr[]	= $row;				
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getOpeningBalancesListYearWise '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getOpeningBalancesDetail($FinYear, $AccountID) {
			$FinYear		= addslashes($FinYear);
			$AccountID	= (int)$AccountID;
			$cclass			=	new asys_opening_balances();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_opening_balances` WHERE `FinYear`='$FinYear' AND `AccountID`='$AccountID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_opening_balances');
				if($row = $result->fetch()) {
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));
					$row->setGroupName($this->getGroupNameByGroupID($row->getGroupID()));
					$row->setBGName($this->getBaseGroupNameByBaseGroupID($row->getBGID()));
					$row->setSubgroupName($this->getSubgroupNameBySubgroupID($row->getSubgroupID()));
					$cclass	= $row;				
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getOpeningBalancesDetail  '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}		

		function deleteOBalRec($CompanyID, $FinYear) {
			$CompanyID	= (int)$CompanyID;
			$FinYear		= addslashes($FinYear);
			$ret				= false;
			
			try {
				
				$sql		=	"DELETE FROM `asys_opening_balances` WHERE `FinYear`='$FinYear' AND `CompanyID`='$CompanyID'";
				$ret		= $this->conn->query($sql);
				
			} catch(PDOException $e) {
				$err	= 'masterdb deleteOBalRec '.$e->getMessage();
				_errorLog($err);
			}
			
			return $ret;
		}

		function generateOpeningBalance($CompanyID, $StartYear) {
			$CompanyID	= (int)$CompanyID;
			$StartYear	= (int)$StartYear;
			
			$EndYear		=	$StartYear + 1;
			$PrevYear		= $StartYear - 1;
			$FinYear		=	substr($StartYear,2,2).'-'.substr($EndYear,2,2);
			$RDate			=	$StartYear.'-04-01';
			$EDate			= $EndYear.'-03-31';
			$prDate			= $PrevYear.'-04-01';
			$peDate			= $StartYear.'-03-31';

			$cbal				= 0;
			$obal				= 0;
			$obaltype		= 0;
			$cbaltype		= 0;
			$retCBal		= array();
			$debitAmt		= 0;
			$creditAmt	= 0;
			$ret				= true;
			
			try {
			
				$this->conn->beginTransaction();				
			
				$sql				=	"SELECT * FROM `asys_opening_balances` WHERE `CompanyID`='".$CompanyID."' AND `FinYear`='".$FinYear."'";
				$result			= $this->conn->query($sql);
				if($row	= $result->fetch())
					$ret	= false;
				
				/* Calculate closing balances for Balance Sheet accounts */

				$sql				=	"SELECT `asys_accounts`.`AccountID`, `asys_accounts`.`GroupID`, `asys_accounts`.`BGID`, `asys_accounts`.`SubgroupID`, `asys_accounts`.`MotherAccount` FROM `asys_accounts` INNER JOIN `asys_base_group` ON `asys_accounts`.`BGID`=`asys_base_group`.`BGID` WHERE (`asys_base_group`.`Posting`='BL' OR `asys_base_group`.`Posting`='BA' OR `asys_base_group`.`Posting`='BA/BL') AND `asys_accounts`.`CompanyID`='".$CompanyID."'";
				$result			= $this->conn->query($sql);
				while($row 	= $result->fetch()){
					$accid		=	$row[0];
					$gid			= $row[1];
					$bgid			= $row[2];
					$sgid			= $row[3];
					$mact			= $row[4];						
					$sdate		=	$RDate;
					$edate		= $EDate;
					
					$sql			= "SELECT `OBal`,`OBalType` FROM `asys_accounts` WHERE `AccountID`=".$accid;
					$sqla			= "SELECT `OBal`,`OBalType` FROM `asys_opening_balances` WHERE `AccountID`='".$accid."' AND `RDate`='".$prDate."'";
					$sql1			= "";
					$sql2			= "";
					
					$rs				= $this->conn->query($sqla);
					if($row1	= $rs->fetch())	{
						
						$obal			= $row1[0];
						$obaltype	= $row1[1];
						
						$sql1	= "SELECT SUM(`Amount`) FROM `asys_voucher_entry` WHERE `AccountID`=".$accid." AND `DrCr`='".CREDIT."' AND (`DOV` >= '".$prDate."' AND `DOV`<='".$peDate."')";
						$sql2 = "SELECT SUM(`Amount`) FROM `asys_voucher_entry` WHERE `AccountID`=".$accid." AND `DrCr`='".DEBIT."' AND (`DOV`>='".$prDate."' AND `DOV`<='".$peDate."')";							
						
					} else {											

						$rs					= $this->conn->query($sql);
						if($row1 		= $rs->fetch()) {
							$obal			= $row1[0];
							$obaltype	= $row1[1];
						}
						
						$sql1	= "SELECT SUM(`Amount`) FROM `asys_voucher_entry` WHERE `AccountID`=".$accid." AND `DrCr`='".CREDIT."' AND `DOV`<='".$peDate."'";
						$sql2 = "SELECT SUM(`Amount`) FROM `asys_voucher_entry` WHERE `AccountID`=".$accid." AND `DrCr`='".DEBIT."' AND `DOV`<='".$peDate."'";							
						
					}
					
					if($obaltype == 0) $obaltype = 1;
					
					$rs				= $this->conn->query($sql1);
					if($row1	= $rs->fetch())
						$creditAmt	= $row1[0];
					$rs				= $this->conn->query($sql2);
					if($row1	= $rs->fetch())
						$debitAmt	= $row1[0];

					if($obaltype == 1) {
						$cbal 		= $obal + $creditAmt - $debitAmt;
						$cbaltype	= $obaltype;
						if($cbal < 0) {
							$cbaltype 	= 2;
							$cbal 			= -$cbal;
						}
					} else {
						$cbal 		= $obal + $debitAmt - $creditAmt;
						$cbaltype	= $obaltype;
						if($cbal < 0) {
							$cbaltype 	= 1;
							$cbal				= - $cbal;
						}
					}
				
					$obcls			= new asys_opening_balances();
					$obcls->setCompanyID($CompanyID);
					$obcls->setFinYear($FinYear);
					$obcls->setRDate(FormatSQLDateToIndianDate($RDate));
					$obcls->setAccountID($accid);
					$obcls->setOBal($cbal);
					$obcls->setOBalType($cbaltype);
					$obcls->setGroupID($gid);
					$obcls->setBGID($bgid);
					$obcls->setSubgroupID($sgid);
					$obcls->setMotherAccount($mact);

					$sql	=	$obcls->getInsertSQL();

					$this->conn->query($sql);
				}

				/* Make Opening Balance=0 for all accounts those are in Profit & Loss Account OR Trading Account */

				$sql				=	"SELECT `asys_accounts`.`AccountID`, `asys_accounts`.`GroupID`, `asys_accounts`.`BGID`, `asys_accounts`.`SubgroupID`, `asys_accounts`.`MotherAccount` FROM `asys_accounts` INNER JOIN `asys_base_group` ON `asys_accounts`.`BGID`=`asys_base_group`.`BGID` WHERE (`asys_base_group`.`Posting`='TD' OR `asys_base_group`.`Posting`='TC' OR `asys_base_group`.`Posting`='PD' OR `asys_base_group`.`Posting`='PC') AND `asys_accounts`.`CompanyID`='".$CompanyID."'";
				$result			=	$this->conn->query($sql);
				while($row	= $result->fetch()){
					$accid		=	$row[0];
					$gid			= $row[1];
					$bgid			= $row[2];
					$sgid			= $row[3];
					$mact			= $row[4];
				
					$obcls			= new asys_opening_balances();
					$obcls->setCompanyID($CompanyID);
					$obcls->setFinYear($FinYear);
					$obcls->setRDate(FormatSQLDateToIndianDate($RDate));
					$obcls->setAccountID($accid);
					$obcls->setOBal(0);
					$obcls->setOBalType(1);
					$obcls->setGroupID($gid);
					$obcls->setBGID($bgid);
					$obcls->setSubgroupID($sgid);
					$obcls->setMotherAccount($mact);

					$sql	=	$obcls->getInsertSQL();

					$this->conn->query($sql);
				}
				
				$this->conn->commit();
				
			} catch(Exception $er) {
				$err	= 'masterdb generateOpeningBalance '.$er->getMessage();
				_errorLog($err);
				$this->conn->rollBack();
				$ret	= false;
			}										


			return $ret;
		}

		function reGenerateOpeningBalance($CompanyID, $FinYear) {
			$CompanyID	= (int)$CompanyID;
			$FinYear		= addslashes($FinYear);
			
			$StartYear	=	'20'.substr($FinYear,0,2);
			$this->deleteOBalRec($CompanyID, $FinYear);
			return $this->generateOpeningBalance($CompanyID, $StartYear);
		}
		
		function updateOBalRec($ocls) {
			$AccountID	= $ocls->getAccountID();
			$FinYear		= $ocls->getFinYear();
			$ret				= false;
			
			try {
				
				$sql		=	"UPDATE `asys_opening_balances` SET `OBal`='".$ocls->getOBal()."', `OBalType`='".$ocls->getOBalType()."' WHERE `FinYear`='$FinYear' AND `AccountID`='$AccountID'";
				$ret		= $this->conn->query($sql);
				
			} catch(PDOException $e) {
				$err	= 'masterdb updateOBalRec '.$e->getMessage();
				_errorLog($err);
			}
			
			return $ret;
		}
		


		/*----------------------------------------------------------------*/
		/*********************** STATE-CITY METHODS ***********************/

		function getCityDetail($State, $City) {
			$State			= addslashes($State);
			$City				= addslashes($City);
			$cclass			=	new asys_cities();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_cities` WHERE `State`='$State' AND `City`='$City'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_cities');
				if($row 	= $result->fetch()) { 	
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getCityDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getStateList($Country = '') {
			$Country	= addslashes($Country);
			if($Country == '') $Country = 'India';
			$arr			=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_cities` WHERE `Country`='$Country' GROUP BY `State` ORDER BY `State`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_cities');
				while($row = $result->fetch()) {
					$arr[]	= $row;				
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getStateList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getCityList($Country = '', $State) {
			$Country		= addslashes($Country);
			$State			= addslashes($State);
			if($Country == '') $Country = 'India';
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_cities` WHERE `Country`='$Country' AND `State`='$State' ORDER BY `City`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_cities');
				while($row = $result->fetch()) {
					$arr[]	= $row;				
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getCityList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getCountryListJSON(){
		
			$sql			= "SELECT `CountryName`, `CountryName` FROM `asys_countries` ORDER BY `CountryName`";
			return $this->getRecordsetExecutingQuery($sql);
		
		}
		
		function getStateListJSON($Country = ''){
		
			$Country	= addslashes($Country);
			if($Country == '') $Country = 'India';
			$sql			= "SELECT `State`, `State` FROM `asys_cities` WHERE `Country`='$Country' GROUP BY `State` ORDER BY `State`";
			return $this->getRecordsetExecutingQuery($sql);
		
		}
		
		function getCityListJSON($Country = '', $State){
		
			$Country		= addslashes($Country);
			$State			= addslashes($State);
			if($Country == '') $Country = 'India';
			$sql				= "SELECT `City`, `City` FROM `asys_cities` WHERE `Country`='$Country' AND `State`='$State' ORDER BY `City`";
			return $this->getRecordsetExecutingQuery($sql);
		
		}
		
		function getUTByState($State){
		
			$State		= addslashes($State);
			$sql			= "SELECT `UT` FROM `asys_cities` WHERE `State`='$State'";
			return $this->getResultExecutingQuery($sql);
		
		}
		
		
		public function __construct($dbType = '') {
			
			if (!extension_loaded('pdo')) {
				die (SS_DB_ERR_101);
			}			
			
			if($dbType == "REPORT") {
				$this->user 		= SS_RPT_USER;
				$this->password	= SS_RPT_PASSWORD;
			} else if($dbType == "DATA") {
				$this->user 		= SS_DBA_USER;
				$this->password	= SS_DBA_PASSWORD;			
			}
			
			try {
				$this->conn = new PDO("mysql:host=".$this->host.";dbname=".$this->dbname.";charset=utf8", $this->user, $this->password);
				$this->conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
			} catch(PDOException $e) {
				die('DB connection error '.$e->getMessage());
			}
			
			if(!$this->asysFunction())
				die (ERR_201);			
				
		}
		
		public function __destruct() {
			$this->conn	= null;
		}		
		
		
		
		/*--------------------------------------------------------------*/
		/*********************** GST RATE METHODS ***********************/

		function getGSTRateDetail($RateID) {
			$RateID			= (int)$RateID;
			$cclass			=	new asys_gstrate();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_gstrate` WHERE `RateID`='$RateID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_gstrate');
				if($row 	= $result->fetch()) { 	
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getGSTRateDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getGSTRateList() {
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_gstrate` ORDER BY `Rate`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_gstrate');
				while($row = $result->fetch()) {
					$arr[]	= $row;				
				}

			} catch(PDOException $e) {
				$err	= 'masterdb getGSTRateList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getGSTRateListJSON(){
		
			$sql		= "SELECT `RateID`, `Rate` FROM `asys_gstrate` ORDER BY `Rate`";
			return $this->getRecordsetExecutingQuery($sql);
		
		}
		
		function getNumberOfGSTRate() {

			$sql	=	"SELECT COUNT(*) FROM `asys_gstrate`";
			return $this->getResultExecutingQuery($sql);
			
		}

		function getGSTRateListPaged($sRec, $nRec) {

			$sql			=	"SELECT * FROM `asys_gstrate` ORDER BY `Rate` LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_gstrate');
				while($row = $result->fetch()) {
					$arr[]	= $row;
				}

			} catch(PDOException $e) {
				$err	= 'masterdb getGSTRateListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function getGSTRateNameByRateID($RateID) {
			$sql		=	"SELECT `Rate` FROM `asys_gstrate` WHERE `RateID`='$RateID'";
			return $this->getResultExecutingQuery($sql);
		}

		function deleteGSTRate($lcls) {
		
			$pkey				= $lcls->getRateID();
			$rate				= $lcls->getRate();
			$ret				= false;
		
			try {
				
				$sql			=	"SELECT * FROM `gen_items` WHERE `GSTRate`='$rate'";
				$result		= $this->conn->query($sql);
				if(!$row 	= $result->fetch()) {
					$sql		= $lcls->getDeleteSQL();
					$ret		= $this->conn->query($sql);
				}

			} catch(PDOException $e) {
				$err	= 'masterdb deleteGSTRate '.$e->getMessage();
				_errorLog($err);
			}			
		
			return $ret;
		}
		
		
		
		/*-----------------------------------------------------------------*/
		/*********************** TDS SECTION METHODS ***********************/

		function getTDSSectionDetail($SectionID) {
			$SectionID	= (int)$SectionID;
			$cclass			=	new asys_tdssection();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_tdssection` WHERE `SectionID`='$SectionID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_tdssection');
				if($row 	= $result->fetch()) { 	
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getTDSSectionDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getTDSSectionList() {
			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_tdssection` ORDER BY `SectionName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_tdssection');
				while($row = $result->fetch()) {
					$arr[]	= $row;				
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getTDSSectionList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getTDSSectionListJSON(){
		
			$sql		= "SELECT `SectionID`, `SectionName` FROM `asys_tdssection` ORDER BY `SectionName`";
			return $this->getRecordsetExecutingQuery($sql);
		
		}
		
		function getNumberOfTDSSection($schStr) {
			if($schStr == "")
				$sql	=	"SELECT COUNT(*) FROM `asys_tdssection`";
			else
				$sql	=	"SELECT COUNT(*) FROM `asys_tdssection` WHERE `SectionName` LIKE '%$schStr%'";
			
			return $this->getResultExecutingQuery($sql);
		}

		function getTDSSectionListPaged($sRec, $nRec, $schStr) {

			if($schStr == "")
				$sql			=	"SELECT * FROM `asys_tdssection` ORDER BY `SectionName` LIMIT $sRec, $nRec";
			else
				$sql			=	"SELECT * FROM `asys_tdssection` WHERE `SectionName` LIKE '%$schStr%' ORDER BY `SectionName` LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_tdssection');
				while($row = $result->fetch()) {
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getSectionListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function getTDSSectionNameBySectionID($SectionID) {
			$sql		=	"SELECT `SectionName` FROM `asys_tdssection` WHERE `SectionID`='$SectionID'";
			return $this->getResultExecutingQuery($sql);
		}

		function deleteTDSSection($lcls) {
		
			$pkey	= $lcls->getSectionID();
			$ret				= false;
		
			try {
				
				//$sql			=	"SELECT * FROM `gen_rooms` WHERE `SectionID`='$pkey'";
				//$result		= $this->conn->query($sql);
				//if(!$row 	= $result->fetch()) {
					$sql		= $lcls->getDeleteSQL();
					$ret		= $this->conn->query($sql);
				//}
				
			} catch(PDOException $e) {
				$err	= 'masterdb deleteSection '.$e->getMessage();
				_errorLog($err);
			}			
		
			return $ret;
		}
					
		
	};

?>