<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Sep 20, 2016
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class asys_modules {
		/**
		 * @Field		ModuleID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $ModuleID = 0;

		/**
		 * @Field		ModuleName
		 * @Type		varchar(250)
		 * @Access	Protected
		 */
		protected $ModuleName = "";

		/**
		 * @Field		MenuText
		 * @Type		varchar(30)
		 * @Access	Protected
		 */
		protected $MenuText = "";

		/**
		 * @Field		ShowInMenu
		 * @Type		enum('YES','NO')
		 * @Access	Protected
		 */
		protected $ShowInMenu = "YES";

		/**
		 * @Field		CompanyID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyID = 0;

		/**
		 * @Field		CompanyName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyName = "";

		/**
		 * @Field		DepartmentID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $DepartmentID = 0;

		/**
		 * @Field		DepartmentName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $DepartmentName = "";

		/**
		 * @Field		ModuleType
		 * @Type		enum('Master','Transaction','Report','Submodule','None')
		 * @Access	Protected
		 */
		protected $ModuleType = "Master";

		/**
		 * @Field		CreationTime
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CreationTime = 0;

		/**
		 * @Field		CreatedBy
		 * @Type		varchar(60)
		 * @Access	Protected
		 */
		protected $CreatedBy = "";

		/**
		 * @Field		Modifications
		 * @Type		text
		 * @Access	Protected
		 */
		protected $Modifications = "";

		/**
		 * @Field		Published
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $Published = "NO";

		/**
		 * @Field		StockFlow
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $StockFlow = "NO";

		/**
		 * @Field		AccountVoucher
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $AccountVoucher = "NO";
		
		/**
		 * @Field		TableName
		 * @Type		varchar(100)
		 * @Access	Protected
		 */
		protected $TableName = "";		
		
		/**
		 * @Field		ColumnList
		 * @Type		Array()
		 * @Access	Private
		 */
		var $ColumnList = array();
		
		/**
		 * @Field		VoucherConfigList
		 * @Type		Array()
		 * @Access	Private
		 */
		var $VoucherConfigList = array();
		
		/**
		 * @Field		StockConfigList
		 * @Type		Array()
		 * @Access	Private
		 */
		var $StockConfigList = array();
		
		/**
		 * @Field		SubmoduleList
		 * @Type		Array()
		 * @Access	Private
		 */
		var $SubmoduleList = array();
		
		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->ModuleID = (int)$this->ModuleID;
			$this->ModuleName = addslashes($this->ModuleName);
			$this->MenuText = addslashes($this->MenuText);
			$this->ShowInMenu = addslashes($this->ShowInMenu);
			$this->CompanyID = (int)$this->CompanyID;
			$this->DepartmentID = (int)$this->DepartmentID;
			$this->ModuleType = addslashes($this->ModuleType);
			$this->CreationTime = (int)$this->CreationTime;
			$this->CreatedBy = addslashes($this->CreatedBy);
			$this->Modifications = addslashes($this->Modifications);
			$this->Published = addslashes($this->Published);
			$this->StockFlow = addslashes($this->StockFlow);
			$this->AccountVoucher = addslashes($this->AccountVoucher);
			$this->TableName = addslashes($this->TableName);
		}

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getModuleID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ModuleID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ModuleID;
			} else {
				return $this->ModuleID;
			}
		}

		public function getModuleName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ModuleName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ModuleName;
			} else {
				return stripslashes($this->ModuleName);
			}
		}

		public function getMenuText($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->MenuText),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->MenuText;
			} else {
				return stripslashes($this->MenuText);
			}
		}

		public function getShowInMenu($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ShowInMenu),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ShowInMenu;
			} else {
				return stripslashes($this->ShowInMenu);
			}
		}

		public function getCompanyID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CompanyID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CompanyID;
			} else {
				return $this->CompanyID;
			}
		}

		public function getCompanyName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CompanyName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CompanyName;
			} else {
				return stripslashes($this->CompanyName);
			}
		}

		public function getDepartmentID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->DepartmentID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->DepartmentID;
			} else {
				return $this->DepartmentID;
			}
		}

		public function getDepartmentName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DepartmentName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DepartmentName;
			} else {
				return stripslashes($this->DepartmentName);
			}
		}

		public function getModuleType($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ModuleType),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ModuleType;
			} else {
				return stripslashes($this->ModuleType);
			}
		}

		public function getCreationTime($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CreationTime,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CreationTime;
			} else {
				return $this->CreationTime;
			}
		}

		public function getCreatedBy($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CreatedBy),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CreatedBy;
			} else {
				return stripslashes($this->CreatedBy);
			}
		}

		public function getModifications($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Modifications),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Modifications;
			} else {
				return stripslashes($this->Modifications);
			}
		}

		public function getPublished($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Published),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Published;
			} else {
				return stripslashes($this->Published);
			}
		}

		public function getStockFlow($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->StockFlow),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->StockFlow;
			} else {
				return stripslashes($this->StockFlow);
			}
		}

		public function getAccountVoucher($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->AccountVoucher),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->AccountVoucher;
			} else {
				return stripslashes($this->AccountVoucher);
			}
		}
		
		public function getTableName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->TableName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->TableName;
			} else {
				return stripslashes($this->TableName);
			}
		}		
		
		function getColumnList() {
			return $this->ColumnList;
		}
		
		function getVoucherConfigList() {
			return $this->VoucherConfigList;
		}
		
		function getStockConfigList() {
			return $this->StockConfigList;
		}
		
		function getSubmoduleList() {
			return $this->SubmoduleList;
		}		

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setModuleID($arg) {
			$this->ModuleID = (int)$arg;
		}

		public function setModuleName($arg) {
			$this->ModuleName = addslashes($arg);
		}

		public function setMenuText($arg) {
			$this->MenuText = addslashes($arg);
		}

		public function setShowInMenu($arg) {
			$this->ShowInMenu = addslashes($arg);
		}

		public function setCompanyID($arg) {
			$this->CompanyID = (int)$arg;
		}

		public function setCompanyName($arg) {
			$this->CompanyName = addslashes($arg);
		}

		public function setDepartmentID($arg) {
			$this->DepartmentID = (int)$arg;
		}

		public function setDepartmentName($arg) {
			$this->DepartmentName = addslashes($arg);
		}

		public function setModuleType($arg) {
			$this->ModuleType = addslashes($arg);
		}

		public function setCreationTime($arg) {
			$this->CreationTime = (int)$arg;
		}

		public function setCreatedBy($arg) {
			$this->CreatedBy = addslashes($arg);
		}

		public function setModifications($arg) {
			$this->Modifications = addslashes($arg);
		}

		public function setPublished($arg) {
			$this->Published = addslashes($arg);
		}

		public function setStockFlow($arg) {
			$this->StockFlow = addslashes($arg);
		}

		public function setAccountVoucher($arg) {
			$this->AccountVoucher = addslashes($arg);
		}
		
		public function setTableName($arg) {
			$this->TableName = addslashes($arg);
		}		
		
		function setColumnList($arg) {
			$this->ColumnList = $arg;
		}
		
		function setVoucherConfigList($arg) {
			$this->VoucherConfigList = $arg;
		}
		
		function setStockConfigList($arg) {
			$this->StockConfigList = $arg;
		}
		
		function setSubmoduleList($arg) {
			$this->SubmoduleList = $arg;
		}		

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `asys_modules` (`ModuleID`, `ModuleName`, `MenuText`, `ShowInMenu`, `CompanyID`, `DepartmentID`, `ModuleType`, `CreationTime`, `CreatedBy`, `Modifications`, `Published`, `StockFlow`, `AccountVoucher`, `TableName`) VALUES(";
			$sql	=	$sql."'".$this->getModuleID('asis')."', ";
			$sql	=	$sql."'".$this->getModuleName('asis')."', ";
			$sql	=	$sql."'".$this->getMenuText('asis')."', ";
			$sql	=	$sql."'".$this->getShowInMenu('asis')."', ";
			$sql	=	$sql."'".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."'".$this->getDepartmentID('asis')."', ";
			$sql	=	$sql."'".$this->getModuleType('asis')."', ";
			$sql	=	$sql."'".$this->getCreationTime('asis')."', ";
			$sql	=	$sql."'".$this->getCreatedBy('asis')."', ";
			$sql	=	$sql."'".$this->getModifications('asis')."', ";
			$sql	=	$sql."'".$this->getPublished('asis')."', ";
			$sql	=	$sql."'".$this->getStockFlow('asis')."', ";
			$sql	=	$sql."'".$this->getAccountVoucher('asis')."', ";
			$sql	=	$sql."'".$this->getTableName('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `asys_modules` SET ";
			$sql	=	$sql."`ModuleName` = '".$this->getModuleName('asis')."', ";
			$sql	=	$sql."`MenuText` = '".$this->getMenuText('asis')."', ";
			$sql	=	$sql."`ShowInMenu` = '".$this->getShowInMenu('asis')."', ";
			$sql	=	$sql."`CompanyID` = '".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."`DepartmentID` = '".$this->getDepartmentID('asis')."', ";
			$sql	=	$sql."`ModuleType` = '".$this->getModuleType('asis')."', ";
			$sql	=	$sql."`CreationTime` = '".$this->getCreationTime('asis')."', ";
			$sql	=	$sql."`CreatedBy` = '".$this->getCreatedBy('asis')."', ";
			$sql	=	$sql."`Modifications` = '".$this->getModifications('asis')."', ";
			$sql	=	$sql."`Published` = '".$this->getPublished('asis')."', ";
			$sql	=	$sql."`StockFlow` = '".$this->getStockFlow('asis')."', ";
			$sql	=	$sql."`AccountVoucher` = '".$this->getAccountVoucher('asis')."', ";
			$sql	=	$sql."`TableName` = '".$this->getTableName('asis')."' ";
			$sql	=	$sql." WHERE `ModuleID` = '".$this->getModuleID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `asys_modules` ";
			$sql	=	$sql." WHERE `ModuleID` = '".$this->getModuleID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$ModuleID <= 0) $chk	=	false;
			if(trim($ModuleName) == "") $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">ModuleID</div>
				<div style="float:left;">: '.$this->getModuleID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ModuleName</div>
				<div style="float:left;">: '.$this->getModuleName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">MenuText</div>
				<div style="float:left;">: '.$this->getMenuText('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ShowInMenu</div>
				<div style="float:left;">: '.$this->getShowInMenu('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">CompanyID</div>
				<div style="float:left;">: '.$this->getCompanyID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DepartmentID</div>
				<div style="float:left;">: '.$this->getDepartmentID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ModuleType</div>
				<div style="float:left;">: '.$this->getModuleType('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">CreationTime</div>
				<div style="float:left;">: '.$this->getCreationTime('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">CreatedBy</div>
				<div style="float:left;">: '.$this->getCreatedBy('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Modifications</div>
				<div style="float:left;">: '.$this->getModifications('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Published</div>
				<div style="float:left;">: '.$this->getPublished('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">StockFlow</div>
				<div style="float:left;">: '.$this->getStockFlow('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">AccountVoucher</div>
				<div style="float:left;">: '.$this->getAccountVoucher('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>