<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Sep 21, 2016
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class asys_module_columns {
		/**
		 * @Field		ModuleID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $ModuleID = 0;

		/**
		 * @Field		ColumnName
		 * @Type		varchar(50)
		 * @Access	Protected
		 */
		protected $ColumnName = "";

		/**
		 * @Field		ColumnLabel
		 * @Type		varchar(200)
		 * @Access	Protected
		 */
		protected $ColumnLabel = "";

		/**
		 * @Field		ColumnDataType
		 * @Type		varchar(50)
		 * @Access	Protected
		 */
		protected $ColumnDataType = "";

		/**
		 * @Field		ColumnLength
		 * @Type		varchar(20)
		 * @Access	Protected
		 */
		protected $ColumnLength = "";

		/**
		 * @Field		InputType
		 * @Type		varchar(30)
		 * @Access	Protected
		 */
		protected $InputType = "";

		/**
		 * @Field		InputLength
		 * @Type		varchar(30)
		 * @Access	Protected
		 */
		protected $InputLength = "";

		/**
		 * @Field		SelectValues
		 * @Type		text
		 * @Access	Protected
		 */
		protected $SelectValues = "";

		/**
		 * @Field		IsMandatory
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $IsMandatory = "NO";

		/**
		 * @Field		RelatedTable
		 * @Type		varchar(50)
		 * @Access	Protected
		 */
		protected $RelatedTable = "";

		/**
		 * @Field		ValueField
		 * @Type		varchar(50)
		 * @Access	Protected
		 */
		protected $ValueField = "";

		/**
		 * @Field		DisplayFields
		 * @Type		varchar(300)
		 * @Access	Protected
		 */
		protected $DisplayFields = "";

		/**
		 * @Field		DataFetchSQL
		 * @Type		text
		 * @Access	Protected
		 */
		protected $DataFetchSQL = "";

		/**
		 * @Field		Incremental
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $Incremental = "NO";

		/**
		 * @Field		SetFinancialYear
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $SetFinancialYear = "NO";

		/**
		 * @Field		FYDateField
		 * @Type		varchar(50)
		 * @Access	Protected
		 */
		protected $FYDateField = "";

		/**
		 * @Field		SetMaxFYBasis
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $SetMaxFYBasis = "NO";
		
		/**
		 * @Field		SerialNo
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $SerialNo = 0;
		
		/**
		 * @Field		DisplayInForm
		 * @Type		enum('YES','NO')
		 * @Access	Protected
		 */
		protected $DisplayInForm = "YES";
		
		/**
		 * @Field		PrimaryKey
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $PrimaryKey = "NO";

		/**
		 * @Field		UniqueKey
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $UniqueKey = "NO";
		
		/**
		 * @Field		IndexKey
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $IndexKey = "NO";
		
		/**
		 * @Field		DBField
		 * @Type		enum('YES','NO')
		 * @Access	Protected
		 */
		protected $DBField = "YES";
		
		/**
		 * @Field		MainSubCombo
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $MainSubCombo = "NO";		
		
		/**
		 * @Field		EventList
		 * @Type		Array()
		 * @Access	Private
		 */
		var $EventList = array();
		
		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->ModuleID = (int)$this->ModuleID;
			$this->ColumnName = addslashes($this->ColumnName);
			$this->ColumnLabel = addslashes($this->ColumnLabel);
			$this->ColumnDataType = addslashes($this->ColumnDataType);
			$this->ColumnLength = addslashes($this->ColumnLength);
			$this->InputType = addslashes($this->InputType);
			$this->InputLength = addslashes($this->InputLength);
			$this->SelectValues = addslashes($this->SelectValues);
			$this->IsMandatory = addslashes($this->IsMandatory);
			$this->RelatedTable = addslashes($this->RelatedTable);
			$this->ValueField = addslashes($this->ValueField);
			$this->DisplayFields = addslashes($this->DisplayFields);
			$this->DataFetchSQL = addslashes($this->DataFetchSQL);
			$this->Incremental = addslashes($this->Incremental);
			$this->SetFinancialYear = addslashes($this->SetFinancialYear);
			$this->FYDateField = addslashes($this->FYDateField);
			$this->SetMaxFYBasis = addslashes($this->SetMaxFYBasis);
			$this->SerialNo = (int)$this->SerialNo;
			$this->DisplayInForm = addslashes($this->DisplayInForm);
			$this->PrimaryKey = addslashes($this->PrimaryKey);
			$this->UniqueKey = addslashes($this->UniqueKey);
			$this->IndexKey = addslashes($this->IndexKey);
			$this->DBField = addslashes($this->DBField);
			$this->MainSubCombo = addslashes($this->MainSubCombo);
		}		

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getModuleID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ModuleID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ModuleID;
			} else {
				return $this->ModuleID;
			}
		}

		public function getColumnName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ColumnName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ColumnName;
			} else {
				return stripslashes($this->ColumnName);
			}
		}

		public function getColumnLabel($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ColumnLabel),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ColumnLabel;
			} else {
				return stripslashes($this->ColumnLabel);
			}
		}

		public function getColumnDataType($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ColumnDataType),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ColumnDataType;
			} else {
				return stripslashes($this->ColumnDataType);
			}
		}

		public function getColumnLength($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ColumnLength),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ColumnLength;
			} else {
				return stripslashes($this->ColumnLength);
			}
		}

		public function getInputType($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->InputType),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->InputType;
			} else {
				return stripslashes($this->InputType);
			}
		}

		public function getInputLength($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->InputLength),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->InputLength;
			} else {
				return stripslashes($this->InputLength);
			}
		}

		public function getSelectValues($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->SelectValues),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->SelectValues;
			} else {
				return stripslashes($this->SelectValues);
			}
		}

		public function getIsMandatory($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->IsMandatory),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->IsMandatory;
			} else {
				return stripslashes($this->IsMandatory);
			}
		}

		public function getRelatedTable($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->RelatedTable),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->RelatedTable;
			} else {
				return stripslashes($this->RelatedTable);
			}
		}

		public function getValueField($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ValueField),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ValueField;
			} else {
				return stripslashes($this->ValueField);
			}
		}

		public function getDisplayFields($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DisplayFields),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DisplayFields;
			} else {
				return stripslashes($this->DisplayFields);
			}
		}

		public function getDataFetchSQL($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DataFetchSQL),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DataFetchSQL;
			} else {
				return stripslashes($this->DataFetchSQL);
			}
		}

		public function getIncremental($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Incremental),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Incremental;
			} else {
				return stripslashes($this->Incremental);
			}
		}

		public function getSetFinancialYear($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->SetFinancialYear),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->SetFinancialYear;
			} else {
				return stripslashes($this->SetFinancialYear);
			}
		}

		public function getFYDateField($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->FYDateField),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->FYDateField;
			} else {
				return stripslashes($this->FYDateField);
			}
		}

		public function getSetMaxFYBasis($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->SetMaxFYBasis),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->SetMaxFYBasis;
			} else {
				return stripslashes($this->SetMaxFYBasis);
			}
		}
		
		public function getSerialNo($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->SerialNo,2,'.',',');
			} else if($formatted=='asis') {
				return $this->SerialNo;
			} else {
				return $this->SerialNo;
			}
		}
		
		public function getDisplayInForm($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DisplayInForm),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DisplayInForm;
			} else {
				return stripslashes($this->DisplayInForm);
			}
		}
		
		public function getPrimaryKey($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->PrimaryKey),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->PrimaryKey;
			} else {
				return stripslashes($this->PrimaryKey);
			}
		}

		public function getUniqueKey($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->UniqueKey),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->UniqueKey;
			} else {
				return stripslashes($this->UniqueKey);
			}
		}
		
		public function getIndexKey($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->IndexKey),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->IndexKey;
			} else {
				return stripslashes($this->IndexKey);
			}
		}
		
		public function getDBField($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DBField),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DBField;
			} else {
				return stripslashes($this->DBField);
			}
		}
		
		public function getMainSubCombo($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->MainSubCombo),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->MainSubCombo;
			} else {
				return stripslashes($this->MainSubCombo);
			}
		}		
		
		function getEventList() {
			return $this->EventList;
		}		

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setModuleID($arg) {
			$this->ModuleID = (int)$arg;
		}

		public function setColumnName($arg) {
			$this->ColumnName = addslashes($arg);
		}

		public function setColumnLabel($arg) {
			$this->ColumnLabel = addslashes($arg);
		}

		public function setColumnDataType($arg) {
			$this->ColumnDataType = addslashes($arg);
		}

		public function setColumnLength($arg) {
			$this->ColumnLength = addslashes($arg);
		}

		public function setInputType($arg) {
			$this->InputType = addslashes($arg);
		}

		public function setInputLength($arg) {
			$this->InputLength = addslashes($arg);
		}

		public function setSelectValues($arg) {
			$this->SelectValues = addslashes($arg);
		}

		public function setIsMandatory($arg) {
			$this->IsMandatory = addslashes($arg);
		}

		public function setRelatedTable($arg) {
			$this->RelatedTable = addslashes($arg);
		}

		public function setValueField($arg) {
			$this->ValueField = addslashes($arg);
		}

		public function setDisplayFields($arg) {
			$this->DisplayFields = addslashes($arg);
		}

		public function setDataFetchSQL($arg) {
			$this->DataFetchSQL = addslashes($arg);
		}

		public function setIncremental($arg) {
			$this->Incremental = addslashes($arg);
		}

		public function setSetFinancialYear($arg) {
			$this->SetFinancialYear = addslashes($arg);
		}

		public function setFYDateField($arg) {
			$this->FYDateField = addslashes($arg);
		}

		public function setSetMaxFYBasis($arg) {
			$this->SetMaxFYBasis = addslashes($arg);
		}
		
		public function setSerialNo($arg) {
			$this->SerialNo = (int)$arg;
		}
		
		public function setDisplayInForm($arg) {
			$this->DisplayInForm = addslashes($arg);
		}
		
		public function setPrimaryKey($arg) {
			$this->PrimaryKey = addslashes($arg);
		}

		public function setUniqueKey($arg) {
			$this->UniqueKey = addslashes($arg);
		}
		
		public function setIndexKey($arg) {
			$this->IndexKey = addslashes($arg);
		}
		
		public function setDBField($arg) {
			$this->DBField = addslashes($arg);
		}
		
		public function setMainSubCombo($arg) {
			$this->MainSubCombo = addslashes($arg);
		}
		
		function setEventList($arg) {
			$this->EventList = $arg;
		}		

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `asys_module_columns` (`ModuleID`, `ColumnName`, `ColumnLabel`, `ColumnDataType`, `ColumnLength`, `InputType`, `InputLength`, `SelectValues`, `IsMandatory`, `RelatedTable`, `ValueField`, `DisplayFields`, `DataFetchSQL`, `Incremental`, `SetFinancialYear`, `FYDateField`, `SetMaxFYBasis`, `SerialNo`, `DisplayInForm`, `PrimaryKey`, `UniqueKey`, `IndexKey`, `DBField`, `MainSubCombo`) VALUES(";
			$sql	=	$sql."'".$this->getModuleID('asis')."', ";
			$sql	=	$sql."'".$this->getColumnName('asis')."', ";
			$sql	=	$sql."'".$this->getColumnLabel('asis')."', ";
			$sql	=	$sql."'".$this->getColumnDataType('asis')."', ";
			$sql	=	$sql."'".$this->getColumnLength('asis')."', ";
			$sql	=	$sql."'".$this->getInputType('asis')."', ";
			$sql	=	$sql."'".$this->getInputLength('asis')."', ";
			$sql	=	$sql."'".$this->getSelectValues('asis')."', ";
			$sql	=	$sql."'".$this->getIsMandatory('asis')."', ";
			$sql	=	$sql."'".$this->getRelatedTable('asis')."', ";
			$sql	=	$sql."'".$this->getValueField('asis')."', ";
			$sql	=	$sql."'".$this->getDisplayFields('asis')."', ";
			$sql	=	$sql."'".$this->getDataFetchSQL('asis')."', ";
			$sql	=	$sql."'".$this->getIncremental('asis')."', ";
			$sql	=	$sql."'".$this->getSetFinancialYear('asis')."', ";
			$sql	=	$sql."'".$this->getFYDateField('asis')."', ";
			$sql	=	$sql."'".$this->getSetMaxFYBasis('asis')."', ";
			$sql	=	$sql."'".$this->getSerialNo('asis')."', ";
			$sql	=	$sql."'".$this->getDisplayInForm('asis')."', ";
			$sql	=	$sql."'".$this->getPrimaryKey('asis')."', ";
			$sql	=	$sql."'".$this->getUniqueKey('asis')."', ";
			$sql	=	$sql."'".$this->getIndexKey('asis')."', ";
			$sql	=	$sql."'".$this->getDBField('asis')."', ";
			$sql	=	$sql."'".$this->getMainSubCombo('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `asys_module_columns` SET ";
			$sql	=	$sql."`ColumnLabel` = '".$this->getColumnLabel('asis')."', ";
			$sql	=	$sql."`ColumnDataType` = '".$this->getColumnDataType('asis')."', ";
			$sql	=	$sql."`ColumnLength` = '".$this->getColumnLength('asis')."', ";
			$sql	=	$sql."`InputType` = '".$this->getInputType('asis')."', ";
			$sql	=	$sql."`InputLength` = '".$this->getInputLength('asis')."', ";
			$sql	=	$sql."`SelectValues` = '".$this->getSelectValues('asis')."', ";
			$sql	=	$sql."`IsMandatory` = '".$this->getIsMandatory('asis')."', ";
			$sql	=	$sql."`RelatedTable` = '".$this->getRelatedTable('asis')."', ";
			$sql	=	$sql."`ValueField` = '".$this->getValueField('asis')."', ";
			$sql	=	$sql."`DisplayFields` = '".$this->getDisplayFields('asis')."', ";
			$sql	=	$sql."`DataFetchSQL` = '".$this->getDataFetchSQL('asis')."', ";
			$sql	=	$sql."`Incremental` = '".$this->getIncremental('asis')."', ";
			$sql	=	$sql."`SetFinancialYear` = '".$this->getSetFinancialYear('asis')."', ";
			$sql	=	$sql."`FYDateField` = '".$this->getFYDateField('asis')."', ";
			$sql	=	$sql."`SetMaxFYBasis` = '".$this->getSetMaxFYBasis('asis')."', ";
			$sql	=	$sql."`SerialNo` = '".$this->getSerialNo('asis')."', ";
			$sql	=	$sql."`DisplayInForm` = '".$this->getDisplayInForm('asis')."', ";
			$sql	=	$sql."`PrimaryKey` = '".$this->getPrimaryKey('asis')."', ";
			$sql	=	$sql."`UniqueKey` = '".$this->getUniqueKey('asis')."', ";
			$sql	=	$sql."`IndexKey` = '".$this->getIndexKey('asis')."', ";
			$sql	=	$sql."`DBField` = '".$this->getDBField('asis')."', ";
			$sql	=	$sql."`MainSubCombo` = '".$this->getMainSubCombo('asis')."' ";
			$sql	=	$sql." WHERE `ModuleID` = '".$this->getModuleID('asis')."'";
			$sql	=	$sql." AND `ColumnName` = '".$this->getColumnName('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `asys_module_columns` ";
			$sql	=	$sql." WHERE `ModuleID` = '".$this->getModuleID('asis')."'";
			$sql	=	$sql." AND `ColumnName` = '".$this->getColumnName('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$ModuleID <= 0) $chk	=	false;
			if(trim($ColumnName) == "") $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">ModuleID</div>
				<div style="float:left;">: '.$this->getModuleID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ColumnName</div>
				<div style="float:left;">: '.$this->getColumnName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ColumnLabel</div>
				<div style="float:left;">: '.$this->getColumnLabel('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ColumnDataType</div>
				<div style="float:left;">: '.$this->getColumnDataType('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ColumnLength</div>
				<div style="float:left;">: '.$this->getColumnLength('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">InputType</div>
				<div style="float:left;">: '.$this->getInputType('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">InputLength</div>
				<div style="float:left;">: '.$this->getInputLength('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">SelectValues</div>
				<div style="float:left;">: '.$this->getSelectValues('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">IsMandatory</div>
				<div style="float:left;">: '.$this->getIsMandatory('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">RelatedTable</div>
				<div style="float:left;">: '.$this->getRelatedTable('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ValueField</div>
				<div style="float:left;">: '.$this->getValueField('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DisplayFields</div>
				<div style="float:left;">: '.$this->getDisplayFields('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DataFetchSQL</div>
				<div style="float:left;">: '.$this->getDataFetchSQL('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Incremental</div>
				<div style="float:left;">: '.$this->getIncremental('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">SetFinancialYear</div>
				<div style="float:left;">: '.$this->getSetFinancialYear('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">FYDateField</div>
				<div style="float:left;">: '.$this->getFYDateField('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">SetMaxFYBasis</div>
				<div style="float:left;">: '.$this->getSetMaxFYBasis('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>