<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Sep 21, 2016
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class asys_module_column_events {
		/**
		 * @Field		ModuleID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $ModuleID = 0;

		/**
		 * @Field		ColumnName
		 * @Type		varchar(50)
		 * @Access	Protected
		 */
		protected $ColumnName = "";

		/**
		 * @Field		EventName
		 * @Type		varchar(50)
		 * @Access	Protected
		 */
		protected $EventName = "";

		/**
		 * @Field		JavaScriptFunction
		 * @Type		varchar(50)
		 * @Access	Protected
		 */
		protected $JavaScriptFunction = "";

		/**
		 * @Field		JSFDetail
		 * @Type		text
		 * @Access	Protected
		 */
		protected $JSFDetail = "";
		
		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->ModuleID = (int)$this->ModuleID;
			$this->ColumnName = addslashes($this->ColumnName);
			$this->EventName = addslashes($this->EventName);
			$this->JavaScriptFunction = addslashes($this->JavaScriptFunction);
			$this->JSFDetail = addslashes($this->JSFDetail);
		}		

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getModuleID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ModuleID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ModuleID;
			} else {
				return $this->ModuleID;
			}
		}

		public function getColumnName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ColumnName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ColumnName;
			} else {
				return stripslashes($this->ColumnName);
			}
		}

		public function getEventName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->EventName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->EventName;
			} else {
				return stripslashes($this->EventName);
			}
		}

		public function getJavaScriptFunction($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->JavaScriptFunction),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->JavaScriptFunction;
			} else {
				return stripslashes($this->JavaScriptFunction);
			}
		}

		public function getJSFDetail($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->JSFDetail),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->JSFDetail;
			} else {
				return stripslashes($this->JSFDetail);
			}
		}

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setModuleID($arg) {
			$this->ModuleID = (int)$arg;
		}

		public function setColumnName($arg) {
			$this->ColumnName = addslashes($arg);
		}

		public function setEventName($arg) {
			$this->EventName = addslashes($arg);
		}

		public function setJavaScriptFunction($arg) {
			$this->JavaScriptFunction = addslashes($arg);
		}

		public function setJSFDetail($arg) {
			$this->JSFDetail = addslashes($arg);
		}

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `asys_module_column_events` (`ModuleID`, `ColumnName`, `EventName`, `JavaScriptFunction`, `JSFDetail`) VALUES(";
			$sql	=	$sql."'".$this->getModuleID('asis')."', ";
			$sql	=	$sql."'".$this->getColumnName('asis')."', ";
			$sql	=	$sql."'".$this->getEventName('asis')."', ";
			$sql	=	$sql."'".$this->getJavaScriptFunction('asis')."', ";
			$sql	=	$sql."'".$this->getJSFDetail('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `asys_module_column_events` SET ";
			$sql	=	$sql."`JavaScriptFunction` = '".$this->getJavaScriptFunction('asis')."', ";
			$sql	=	$sql."`JSFDetail` = '".$this->getJSFDetail('asis')."' ";
			$sql	=	$sql." WHERE `ModuleID` = '".$this->getModuleID('asis')."'";
			$sql	=	$sql." AND `ColumnName` = '".$this->getColumnName('asis')."'";
			$sql	=	$sql." AND `EventName` = '".$this->getEventName('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `asys_module_column_events` ";
			$sql	=	$sql." WHERE `ModuleID` = '".$this->getModuleID('asis')."'";
			$sql	=	$sql." AND `ColumnName` = '".$this->getColumnName('asis')."'";
			$sql	=	$sql." AND `EventName` = '".$this->getEventName('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$ModuleID <= 0) $chk	=	false;
			if(trim($ColumnName) == "") $chk	=	false;
			if(trim($EventName) == "") $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">ModuleID</div>
				<div style="float:left;">: '.$this->getModuleID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ColumnName</div>
				<div style="float:left;">: '.$this->getColumnName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">EventName</div>
				<div style="float:left;">: '.$this->getEventName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">JavaScriptFunction</div>
				<div style="float:left;">: '.$this->getJavaScriptFunction('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">JSFDetail</div>
				<div style="float:left;">: '.$this->getJSFDetail('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>