<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Sep 06, 2018
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class asys_module_stock_config {
		/**
		 * @Field		ModuleID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $ModuleID = 0;

		/**
		 * @Field		StockConfigID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $StockConfigID = 0;

		/**
		 * @Field		StockConfigName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $StockConfigName = "";

		/**
		 * @Field		DateField
		 * @Type		varchar(50)
		 * @Access	Protected
		 */
		protected $DateField = "";

		/**
		 * @Field		ItemField
		 * @Type		varchar(50)
		 * @Access	Protected
		 */
		protected $ItemField = "";

		/**
		 * @Field		QuantityField
		 * @Type		varchar(50)
		 * @Access	Protected
		 */
		protected $QuantityField = "";

		/**
		 * @Field		RateField
		 * @Type		varchar(50)
		 * @Access	Protected
		 */
		protected $RateField = "";

		/**
		 * @Field		StoreIN
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $StoreIN = 0;

		/**
		 * @Field		RunTimeStockIN
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $RunTimeStockIN = "NO";

		/**
		 * @Field		InColumnName
		 * @Type		varchar(50)
		 * @Access	Protected
		 */
		protected $InColumnName = "";

		/**
		 * @Field		StoreOUT
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $StoreOUT = 0;

		/**
		 * @Field		RunTimeStockOUT
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $RunTimeStockOUT = "NO";

		/**
		 * @Field		OutColumnName
		 * @Type		varchar(50)
		 * @Access	Protected
		 */
		protected $OutColumnName = "";

		/**
		 * @Field		DateFieldFromMother
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $DateFieldFromMother = "NO";

		/**
		 * @Field		MotherDateField
		 * @Type		varchar(50)
		 * @Access	Protected
		 */
		protected $MotherDateField = "";

		/**
		 * @Field		StoreINFromMother
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $StoreINFromMother = "NO";

		/**
		 * @Field		MotherStoreIN
		 * @Type		varchar(50)
		 * @Access	Protected
		 */
		protected $MotherStoreIN = "";

		/**
		 * @Field		StoreOUTFromMother
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $StoreOUTFromMother = "NO";

		/**
		 * @Field		MotherStoreOUT
		 * @Type		varchar(50)
		 * @Access	Protected
		 */
		protected $MotherStoreOUT = "";
		
		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->ModuleID = (int)$this->ModuleID;
			$this->StockConfigID = (int)$this->StockConfigID;
			$this->ItemField = addslashes($this->ItemField);
			$this->QuantityField = addslashes($this->QuantityField);
			$this->StoreIN = (int)$this->StoreIN;
			$this->RunTimeStockIN = addslashes($this->RunTimeStockIN);
			$this->InColumnName = addslashes($this->InColumnName);
			$this->StoreOUT = (int)$this->StoreOUT;
			$this->RunTimeStockOUT = addslashes($this->RunTimeStockOUT);
			$this->OutColumnName = addslashes($this->OutColumnName);
		}		

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getModuleID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ModuleID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ModuleID;
			} else {
				return $this->ModuleID;
			}
		}

		public function getStockConfigID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->StockConfigID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->StockConfigID;
			} else {
				return $this->StockConfigID;
			}
		}

		public function getStockConfigName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->StockConfigName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->StockConfigName;
			} else {
				return stripslashes($this->StockConfigName);
			}
		}

		public function getDateField($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DateField),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DateField;
			} else {
				return stripslashes($this->DateField);
			}
		}

		public function getItemField($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ItemField),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ItemField;
			} else {
				return stripslashes($this->ItemField);
			}
		}

		public function getQuantityField($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->QuantityField),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->QuantityField;
			} else {
				return stripslashes($this->QuantityField);
			}
		}

		public function getRateField($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->RateField),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->RateField;
			} else {
				return stripslashes($this->RateField);
			}
		}

		public function getStoreIN($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->StoreIN,2,'.',',');
			} else if($formatted=='asis') {
				return $this->StoreIN;
			} else {
				return $this->StoreIN;
			}
		}

		public function getRunTimeStockIN($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->RunTimeStockIN),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->RunTimeStockIN;
			} else {
				return stripslashes($this->RunTimeStockIN);
			}
		}

		public function getInColumnName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->InColumnName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->InColumnName;
			} else {
				return stripslashes($this->InColumnName);
			}
		}

		public function getStoreOUT($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->StoreOUT,2,'.',',');
			} else if($formatted=='asis') {
				return $this->StoreOUT;
			} else {
				return $this->StoreOUT;
			}
		}

		public function getRunTimeStockOUT($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->RunTimeStockOUT),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->RunTimeStockOUT;
			} else {
				return stripslashes($this->RunTimeStockOUT);
			}
		}

		public function getOutColumnName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->OutColumnName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->OutColumnName;
			} else {
				return stripslashes($this->OutColumnName);
			}
		}

		public function getDateFieldFromMother($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DateFieldFromMother),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DateFieldFromMother;
			} else {
				return stripslashes($this->DateFieldFromMother);
			}
		}

		public function getMotherDateField($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->MotherDateField),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->MotherDateField;
			} else {
				return stripslashes($this->MotherDateField);
			}
		}

		public function getStoreINFromMother($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->StoreINFromMother),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->StoreINFromMother;
			} else {
				return stripslashes($this->StoreINFromMother);
			}
		}

		public function getMotherStoreIN($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->MotherStoreIN),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->MotherStoreIN;
			} else {
				return stripslashes($this->MotherStoreIN);
			}
		}

		public function getStoreOUTFromMother($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->StoreOUTFromMother),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->StoreOUTFromMother;
			} else {
				return stripslashes($this->StoreOUTFromMother);
			}
		}

		public function getMotherStoreOUT($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->MotherStoreOUT),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->MotherStoreOUT;
			} else {
				return stripslashes($this->MotherStoreOUT);
			}
		}

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setModuleID($arg) {
			$this->ModuleID = (int)$arg;
		}

		public function setStockConfigID($arg) {
			$this->StockConfigID = (int)$arg;
		}

		public function setStockConfigName($arg) {
			$this->StockConfigName = addslashes($arg);
		}

		public function setDateField($arg) {
			$this->DateField = addslashes($arg);
		}

		public function setItemField($arg) {
			$this->ItemField = addslashes($arg);
		}

		public function setQuantityField($arg) {
			$this->QuantityField = addslashes($arg);
		}

		public function setRateField($arg) {
			$this->RateField = addslashes($arg);
		}

		public function setStoreIN($arg) {
			$this->StoreIN = (int)$arg;
		}

		public function setRunTimeStockIN($arg) {
			$this->RunTimeStockIN = addslashes($arg);
		}

		public function setInColumnName($arg) {
			$this->InColumnName = addslashes($arg);
		}

		public function setStoreOUT($arg) {
			$this->StoreOUT = (int)$arg;
		}

		public function setRunTimeStockOUT($arg) {
			$this->RunTimeStockOUT = addslashes($arg);
		}

		public function setOutColumnName($arg) {
			$this->OutColumnName = addslashes($arg);
		}

		public function setDateFieldFromMother($arg) {
			$this->DateFieldFromMother = addslashes($arg);
		}

		public function setMotherDateField($arg) {
			$this->MotherDateField = addslashes($arg);
		}

		public function setStoreINFromMother($arg) {
			$this->StoreINFromMother = addslashes($arg);
		}

		public function setMotherStoreIN($arg) {
			$this->MotherStoreIN = addslashes($arg);
		}

		public function setStoreOUTFromMother($arg) {
			$this->StoreOUTFromMother = addslashes($arg);
		}

		public function setMotherStoreOUT($arg) {
			$this->MotherStoreOUT = addslashes($arg);
		}

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `asys_module_stock_config` (`ModuleID`, `StockConfigID`, `DateField`, `ItemField`, `QuantityField`, `RateField`, `StoreIN`, `RunTimeStockIN`, `InColumnName`, `StoreOUT`, `RunTimeStockOUT`, `OutColumnName`, `DateFieldFromMother`, `MotherDateField`, `StoreINFromMother`, `MotherStoreIN`, `StoreOUTFromMother`, `MotherStoreOUT`) VALUES(";
			$sql	=	$sql."'".$this->getModuleID('asis')."', ";
			$sql	=	$sql."'".$this->getStockConfigID('asis')."', ";
			$sql	=	$sql."'".$this->getDateField('asis')."', ";
			$sql	=	$sql."'".$this->getItemField('asis')."', ";
			$sql	=	$sql."'".$this->getQuantityField('asis')."', ";
			$sql	=	$sql."'".$this->getRateField('asis')."', ";
			$sql	=	$sql."'".$this->getStoreIN('asis')."', ";
			$sql	=	$sql."'".$this->getRunTimeStockIN('asis')."', ";
			$sql	=	$sql."'".$this->getInColumnName('asis')."', ";
			$sql	=	$sql."'".$this->getStoreOUT('asis')."', ";
			$sql	=	$sql."'".$this->getRunTimeStockOUT('asis')."', ";
			$sql	=	$sql."'".$this->getOutColumnName('asis')."', ";
			$sql	=	$sql."'".$this->getDateFieldFromMother('asis')."', ";
			$sql	=	$sql."'".$this->getMotherDateField('asis')."', ";
			$sql	=	$sql."'".$this->getStoreINFromMother('asis')."', ";
			$sql	=	$sql."'".$this->getMotherStoreIN('asis')."', ";
			$sql	=	$sql."'".$this->getStoreOUTFromMother('asis')."', ";
			$sql	=	$sql."'".$this->getMotherStoreOUT('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `asys_module_stock_config` SET ";
			$sql	=	$sql."`DateField` = '".$this->getDateField('asis')."', ";
			$sql	=	$sql."`ItemField` = '".$this->getItemField('asis')."', ";
			$sql	=	$sql."`QuantityField` = '".$this->getQuantityField('asis')."', ";
			$sql	=	$sql."`RateField` = '".$this->getRateField('asis')."', ";
			$sql	=	$sql."`StoreIN` = '".$this->getStoreIN('asis')."', ";
			$sql	=	$sql."`RunTimeStockIN` = '".$this->getRunTimeStockIN('asis')."', ";
			$sql	=	$sql."`InColumnName` = '".$this->getInColumnName('asis')."', ";
			$sql	=	$sql."`StoreOUT` = '".$this->getStoreOUT('asis')."', ";
			$sql	=	$sql."`RunTimeStockOUT` = '".$this->getRunTimeStockOUT('asis')."', ";
			$sql	=	$sql."`OutColumnName` = '".$this->getOutColumnName('asis')."', ";
			$sql	=	$sql."`DateFieldFromMother` = '".$this->getDateFieldFromMother('asis')."', ";
			$sql	=	$sql."`MotherDateField` = '".$this->getMotherDateField('asis')."', ";
			$sql	=	$sql."`StoreINFromMother` = '".$this->getStoreINFromMother('asis')."', ";
			$sql	=	$sql."`MotherStoreIN` = '".$this->getMotherStoreIN('asis')."', ";
			$sql	=	$sql."`StoreOUTFromMother` = '".$this->getStoreOUTFromMother('asis')."', ";
			$sql	=	$sql."`MotherStoreOUT` = '".$this->getMotherStoreOUT('asis')."' ";
			$sql	=	$sql." WHERE `ModuleID` = '".$this->getModuleID('asis')."'";
			$sql	=	$sql." AND `StockConfigID` = '".$this->getStockConfigID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `asys_module_stock_config` ";
			$sql	=	$sql." WHERE `ModuleID` = '".$this->getModuleID('asis')."'";
			$sql	=	$sql." AND `StockConfigID` = '".$this->getStockConfigID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$ModuleID <= 0) $chk	=	false;
			if((int)$StockConfigID <= 0) $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">ModuleID</div>
				<div style="float:left;">: '.$this->getModuleID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">StockConfigID</div>
				<div style="float:left;">: '.$this->getStockConfigID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DateField</div>
				<div style="float:left;">: '.$this->getDateField('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ItemField</div>
				<div style="float:left;">: '.$this->getItemField('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">QuantityField</div>
				<div style="float:left;">: '.$this->getQuantityField('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">RateField</div>
				<div style="float:left;">: '.$this->getRateField('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">StoreIN</div>
				<div style="float:left;">: '.$this->getStoreIN('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">RunTimeStockIN</div>
				<div style="float:left;">: '.$this->getRunTimeStockIN('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">InColumnName</div>
				<div style="float:left;">: '.$this->getInColumnName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">StoreOUT</div>
				<div style="float:left;">: '.$this->getStoreOUT('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">RunTimeStockOUT</div>
				<div style="float:left;">: '.$this->getRunTimeStockOUT('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">OutColumnName</div>
				<div style="float:left;">: '.$this->getOutColumnName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DateFieldFromMother</div>
				<div style="float:left;">: '.$this->getDateFieldFromMother('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">MotherDateField</div>
				<div style="float:left;">: '.$this->getMotherDateField('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">StoreINFromMother</div>
				<div style="float:left;">: '.$this->getStoreINFromMother('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">MotherStoreIN</div>
				<div style="float:left;">: '.$this->getMotherStoreIN('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">StoreOUTFromMother</div>
				<div style="float:left;">: '.$this->getStoreOUTFromMother('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">MotherStoreOUT</div>
				<div style="float:left;">: '.$this->getMotherStoreOUT('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>