<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Sep 21, 2016
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class asys_module_submodules {
		/**
		 * @Field		ModuleID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $ModuleID = 0;

		/**
		 * @Field		SubmoduleID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $SubmoduleID = 0;

		/**
		 * @Field		SubmoduleName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $SubmoduleName = "";

		/**
		 * @Field		MultipleRow
		 * @Type		enum('YES','NO')
		 * @Access	Protected
		 */
		protected $MultipleRow = "YES";
		
		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->ModuleID = (int)$this->ModuleID;
			$this->SubmoduleID = (int)$this->SubmoduleID;
			$this->MultipleRow = addslashes($this->MultipleRow);
		}		

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getModuleID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ModuleID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ModuleID;
			} else {
				return $this->ModuleID;
			}
		}

		public function getSubmoduleID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->SubmoduleID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->SubmoduleID;
			} else {
				return $this->SubmoduleID;
			}
		}

		public function getSubmoduleName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->SubmoduleName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->SubmoduleName;
			} else {
				return stripslashes($this->SubmoduleName);
			}
		}

		public function getMultipleRow($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->MultipleRow),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->MultipleRow;
			} else {
				return stripslashes($this->MultipleRow);
			}
		}

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setModuleID($arg) {
			$this->ModuleID = (int)$arg;
		}

		public function setSubmoduleID($arg) {
			$this->SubmoduleID = (int)$arg;
		}

		public function setSubmoduleName($arg) {
			$this->SubmoduleName = addslashes($arg);
		}

		public function setMultipleRow($arg) {
			$this->MultipleRow = addslashes($arg);
		}

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `asys_module_submodules` (`ModuleID`, `SubmoduleID`, `MultipleRow`) VALUES(";
			$sql	=	$sql."'".$this->getModuleID('asis')."', ";
			$sql	=	$sql."'".$this->getSubmoduleID('asis')."', ";
			$sql	=	$sql."'".$this->getMultipleRow('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `asys_module_submodules` SET ";
			$sql	=	$sql."`MultipleRow` = '".$this->getMultipleRow('asis')."' ";
			$sql	=	$sql." WHERE `ModuleID` = '".$this->getModuleID('asis')."'";
			$sql	=	$sql." AND `SubmoduleID` = '".$this->getSubmoduleID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `asys_module_submodules` ";
			$sql	=	$sql." WHERE `ModuleID` = '".$this->getModuleID('asis')."'";
			$sql	=	$sql." AND `SubmoduleID` = '".$this->getSubmoduleID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$ModuleID <= 0) $chk	=	false;
			if((int)$SubmoduleID <= 0) $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">ModuleID</div>
				<div style="float:left;">: '.$this->getModuleID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">SubmoduleID</div>
				<div style="float:left;">: '.$this->getSubmoduleID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">MultipleRow</div>
				<div style="float:left;">: '.$this->getMultipleRow('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>