<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Sep 21, 2016
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class asys_module_views {
		/**
		 * @Field		ModuleID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $ModuleID = 0;

		/**
		 * @Field		TableHeight
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $TableHeight = 0;

		/**
		 * @Field		TableWidth
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $TableWidth = 0;

		/**
		 * @Field		NoR
		 * @Type		tinyint(4)
		 * @Access	Protected
		 */
		protected $NoR = 0;

		/**
		 * @Field		PageHeading
		 * @Type		varchar(300)
		 * @Access	Protected
		 */
		protected $PageHeading = "";

		/**
		 * @Field		IncludeFiles
		 * @Type		varchar(500)
		 * @Access	Protected
		 */
		protected $IncludeFiles = "";

		/**
		 * @Field		SortColumn1
		 * @Type		varchar(100)
		 * @Access	Protected
		 */
		protected $SortColumn1 = "";

		/**
		 * @Field		SortColumn2
		 * @Type		varchar(100)
		 * @Access	Protected
		 */
		protected $SortColumn2 = "";

		/**
		 * @Field		MEdit
		 * @Type		enum('YES','NO')
		 * @Access	Protected
		 */
		protected $MEdit = "YES";

		/**
		 * @Field		MDelete
		 * @Type		enum('YES','NO')
		 * @Access	Protected
		 */
		protected $MDelete = "YES";

		/**
		 * @Field		MView
		 * @Type		enum('YES','NO')
		 * @Access	Protected
		 */
		protected $MView = "YES";

		/**
		 * @Field		MPrint
		 * @Type		enum('YES','NO')
		 * @Access	Protected
		 */
		protected $MPrint = "YES";
		
		/**
		 * @Field		FieldList
		 * @Type		Array()
		 * @Access	Private
		 */
		var $FieldList = array();
		
		/**
		 * @Field		SearchList
		 * @Type		Array()
		 * @Access	Private
		 */
		var $SearchList = array();
		
		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->ModuleID = (int)$this->ModuleID;
			$this->TableHeight = (int)$this->TableHeight;
			$this->TableWidth = (int)$this->TableWidth;
			$this->NoR = (int)$this->NoR;
			$this->PageHeading = addslashes($this->PageHeading);
			$this->IncludeFiles = addslashes($this->IncludeFiles);
			$this->SortColumn1 = addslashes($this->SortColumn1);
			$this->SortColumn2 = addslashes($this->SortColumn2);
			$this->MEdit = addslashes($this->MEdit);
			$this->MDelete = addslashes($this->MDelete);
			$this->MView = addslashes($this->MView);
			$this->MPrint = addslashes($this->MPrint);
		}		

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getModuleID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ModuleID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ModuleID;
			} else {
				return $this->ModuleID;
			}
		}

		public function getTableHeight($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->TableHeight,2,'.',',');
			} else if($formatted=='asis') {
				return $this->TableHeight;
			} else {
				return $this->TableHeight;
			}
		}

		public function getTableWidth($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->TableWidth,2,'.',',');
			} else if($formatted=='asis') {
				return $this->TableWidth;
			} else {
				return $this->TableWidth;
			}
		}

		public function getNoR($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->NoR,2,'.',',');
			} else if($formatted=='asis') {
				return $this->NoR;
			} else {
				return $this->NoR;
			}
		}

		public function getPageHeading($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->PageHeading),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->PageHeading;
			} else {
				return stripslashes($this->PageHeading);
			}
		}

		public function getIncludeFiles($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->IncludeFiles),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->IncludeFiles;
			} else {
				return stripslashes($this->IncludeFiles);
			}
		}

		public function getSortColumn1($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->SortColumn1),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->SortColumn1;
			} else {
				return stripslashes($this->SortColumn1);
			}
		}

		public function getSortColumn2($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->SortColumn2),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->SortColumn2;
			} else {
				return stripslashes($this->SortColumn2);
			}
		}

		public function getMEdit($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->MEdit),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->MEdit;
			} else {
				return stripslashes($this->MEdit);
			}
		}

		public function getMDelete($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->MDelete),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->MDelete;
			} else {
				return stripslashes($this->MDelete);
			}
		}

		public function getMView($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->MView),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->MView;
			} else {
				return stripslashes($this->MView);
			}
		}

		public function getMPrint($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->MPrint),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->MPrint;
			} else {
				return stripslashes($this->MPrint);
			}
		}
		
		function getFieldList() {
			return $this->FieldList;
		}
		
		function getSearchList() {
			return $this->SearchList;
		}		

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setModuleID($arg) {
			$this->ModuleID = (int)$arg;
		}

		public function setTableHeight($arg) {
			$this->TableHeight = (int)$arg;
		}

		public function setTableWidth($arg) {
			$this->TableWidth = (int)$arg;
		}

		public function setNoR($arg) {
			$this->NoR = (int)$arg;
		}

		public function setPageHeading($arg) {
			$this->PageHeading = addslashes($arg);
		}

		public function setIncludeFiles($arg) {
			$this->IncludeFiles = addslashes($arg);
		}

		public function setSortColumn1($arg) {
			$this->SortColumn1 = addslashes($arg);
		}

		public function setSortColumn2($arg) {
			$this->SortColumn2 = addslashes($arg);
		}

		public function setMEdit($arg) {
			$this->MEdit = addslashes($arg);
		}

		public function setMDelete($arg) {
			$this->MDelete = addslashes($arg);
		}

		public function setMView($arg) {
			$this->MView = addslashes($arg);
		}

		public function setMPrint($arg) {
			$this->MPrint = addslashes($arg);
		}
		
		function setFieldList($arg) {
			$this->FieldList = $arg;
		}
		
		function setSearchList($arg) {
			$this->SearchList = $arg;
		}		

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `asys_module_views` (`ModuleID`, `TableHeight`, `TableWidth`, `NoR`, `PageHeading`, `IncludeFiles`, `SortColumn1`, `SortColumn2`, `MEdit`, `MDelete`, `MView`, `MPrint`) VALUES(";
			$sql	=	$sql."'".$this->getModuleID('asis')."', ";
			$sql	=	$sql."'".$this->getTableHeight('asis')."', ";
			$sql	=	$sql."'".$this->getTableWidth('asis')."', ";
			$sql	=	$sql."'".$this->getNoR('asis')."', ";
			$sql	=	$sql."'".$this->getPageHeading('asis')."', ";
			$sql	=	$sql."'".$this->getIncludeFiles('asis')."', ";
			$sql	=	$sql."'".$this->getSortColumn1('asis')."', ";
			$sql	=	$sql."'".$this->getSortColumn2('asis')."', ";
			$sql	=	$sql."'".$this->getMEdit('asis')."', ";
			$sql	=	$sql."'".$this->getMDelete('asis')."', ";
			$sql	=	$sql."'".$this->getMView('asis')."', ";
			$sql	=	$sql."'".$this->getMPrint('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `asys_module_views` SET ";
			$sql	=	$sql."`TableHeight` = '".$this->getTableHeight('asis')."', ";
			$sql	=	$sql."`TableWidth` = '".$this->getTableWidth('asis')."', ";
			$sql	=	$sql."`NoR` = '".$this->getNoR('asis')."', ";
			$sql	=	$sql."`PageHeading` = '".$this->getPageHeading('asis')."', ";
			$sql	=	$sql."`IncludeFiles` = '".$this->getIncludeFiles('asis')."', ";
			$sql	=	$sql."`SortColumn1` = '".$this->getSortColumn1('asis')."', ";
			$sql	=	$sql."`SortColumn2` = '".$this->getSortColumn2('asis')."', ";
			$sql	=	$sql."`MEdit` = '".$this->getMEdit('asis')."', ";
			$sql	=	$sql."`MDelete` = '".$this->getMDelete('asis')."', ";
			$sql	=	$sql."`MView` = '".$this->getMView('asis')."', ";
			$sql	=	$sql."`MPrint` = '".$this->getMPrint('asis')."' ";
			$sql	=	$sql." WHERE `ModuleID` = '".$this->getModuleID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `asys_module_views` ";
			$sql	=	$sql." WHERE `ModuleID` = '".$this->getModuleID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$ModuleID <= 0) $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">ModuleID</div>
				<div style="float:left;">: '.$this->getModuleID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">TableHeight</div>
				<div style="float:left;">: '.$this->getTableHeight('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">TableWidth</div>
				<div style="float:left;">: '.$this->getTableWidth('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">NoR</div>
				<div style="float:left;">: '.$this->getNoR('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">PageHeading</div>
				<div style="float:left;">: '.$this->getPageHeading('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">IncludeFiles</div>
				<div style="float:left;">: '.$this->getIncludeFiles('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">SortColumn1</div>
				<div style="float:left;">: '.$this->getSortColumn1('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">SortColumn2</div>
				<div style="float:left;">: '.$this->getSortColumn2('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">MEdit</div>
				<div style="float:left;">: '.$this->getMEdit('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">MDelete</div>
				<div style="float:left;">: '.$this->getMDelete('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">MView</div>
				<div style="float:left;">: '.$this->getMView('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">MPrint</div>
				<div style="float:left;">: '.$this->getMPrint('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>