<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Sep 21, 2016
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class asys_module_view_fields {
		/**
		 * @Field		ModuleID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $ModuleID = 0;

		/**
		 * @Field		ColumnName
		 * @Type		varchar(100)
		 * @Access	Protected
		 */
		protected $ColumnName = "";

		/**
		 * @Field		CWidth
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $CWidth = 0;

		/**
		 * @Field		CAlign
		 * @Type		varchar(30)
		 * @Access	Protected
		 */
		protected $CAlign = "";

		/**
		 * @Field		Sortable
		 * @Type		varchar(10)
		 * @Access	Protected
		 */
		protected $Sortable = "";

		/**
		 * @Field		AutoExpand
		 * @Type		varchar(10)
		 * @Access	Protected
		 */
		protected $AutoExpand = "";
		
		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->ModuleID = (int)$this->ModuleID;
			$this->ColumnName = addslashes($this->ColumnName);
			$this->CWidth = (int)$this->CWidth;
			$this->CAlign = addslashes($this->CAlign);
			$this->Sortable = addslashes($this->Sortable);
			$this->AutoExpand = addslashes($this->AutoExpand);
		}		

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getModuleID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ModuleID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ModuleID;
			} else {
				return $this->ModuleID;
			}
		}

		public function getColumnName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ColumnName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ColumnName;
			} else {
				return stripslashes($this->ColumnName);
			}
		}

		public function getCWidth($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CWidth,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CWidth;
			} else {
				return $this->CWidth;
			}
		}

		public function getCAlign($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CAlign),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CAlign;
			} else {
				return stripslashes($this->CAlign);
			}
		}

		public function getSortable($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Sortable),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Sortable;
			} else {
				return stripslashes($this->Sortable);
			}
		}

		public function getAutoExpand($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->AutoExpand),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->AutoExpand;
			} else {
				return stripslashes($this->AutoExpand);
			}
		}

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setModuleID($arg) {
			$this->ModuleID = (int)$arg;
		}

		public function setColumnName($arg) {
			$this->ColumnName = addslashes($arg);
		}

		public function setCWidth($arg) {
			$this->CWidth = (int)$arg;
		}

		public function setCAlign($arg) {
			$this->CAlign = addslashes($arg);
		}

		public function setSortable($arg) {
			$this->Sortable = addslashes($arg);
		}

		public function setAutoExpand($arg) {
			$this->AutoExpand = addslashes($arg);
		}

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `asys_module_view_fields` (`ModuleID`, `ColumnName`, `CWidth`, `CAlign`, `Sortable`, `AutoExpand`) VALUES(";
			$sql	=	$sql."'".$this->getModuleID('asis')."', ";
			$sql	=	$sql."'".$this->getColumnName('asis')."', ";
			$sql	=	$sql."'".$this->getCWidth('asis')."', ";
			$sql	=	$sql."'".$this->getCAlign('asis')."', ";
			$sql	=	$sql."'".$this->getSortable('asis')."', ";
			$sql	=	$sql."'".$this->getAutoExpand('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `asys_module_view_fields` SET ";
			$sql	=	$sql."`CWidth` = '".$this->getCWidth('asis')."', ";
			$sql	=	$sql."`CAlign` = '".$this->getCAlign('asis')."', ";
			$sql	=	$sql."`Sortable` = '".$this->getSortable('asis')."', ";
			$sql	=	$sql."`AutoExpand` = '".$this->getAutoExpand('asis')."' ";
			$sql	=	$sql." WHERE `ModuleID` = '".$this->getModuleID('asis')."'";
			$sql	=	$sql." AND `ColumnName` = '".$this->getColumnName('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `asys_module_view_fields` ";
			$sql	=	$sql." WHERE `ModuleID` = '".$this->getModuleID('asis')."'";
			$sql	=	$sql." AND `ColumnName` = '".$this->getColumnName('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$ModuleID <= 0) $chk	=	false;
			if(trim($ColumnName) == "") $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">ModuleID</div>
				<div style="float:left;">: '.$this->getModuleID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ColumnName</div>
				<div style="float:left;">: '.$this->getColumnName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">CWidth</div>
				<div style="float:left;">: '.$this->getCWidth('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">CAlign</div>
				<div style="float:left;">: '.$this->getCAlign('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Sortable</div>
				<div style="float:left;">: '.$this->getSortable('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">AutoExpand</div>
				<div style="float:left;">: '.$this->getAutoExpand('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>