<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Nov 26, 2016
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class asys_module_view_search {
		/**
		 * @Field		ModuleID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $ModuleID = 0;

		/**
		 * @Field		ColumnName
		 * @Type		varchar(200)
		 * @Access	Protected
		 */
		protected $ColumnName = "";

		/**
		 * @Field		SearchCondition
		 * @Type		varchar(30)
		 * @Access	Protected
		 */
		protected $SearchCondition = "";

		/**
		 * @Field		SearchData
		 * @Type		varchar(200)
		 * @Access	Protected
		 */
		protected $SearchData = "";

		/**
		 * @Field		SearchValues
		 * @Type		varchar(500)
		 * @Access	Protected
		 */
		protected $SearchValues = "";

		/**
		 * @Field		TableName
		 * @Type		varchar(100)
		 * @Access	Protected
		 */
		protected $TableName = "";

		/**
		 * @Field		TableMatchingColumn
		 * @Type		varchar(200)
		 * @Access	Protected
		 */
		protected $TableMatchingColumn = "";

		/**
		 * @Field		JoinType
		 * @Type		varchar(30)
		 * @Access	Protected
		 */
		protected $JoinType = "";

		/**
		 * @Field		DisplayColumn
		 * @Type		varchar(200)
		 * @Access	Protected
		 */
		protected $DisplayColumn = "";

		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->ModuleID = (int)$this->ModuleID;
			$this->ColumnName = addslashes($this->ColumnName);
			$this->SearchCondition = addslashes($this->SearchCondition);
			$this->SearchData = addslashes($this->SearchData);
			$this->SearchValues = addslashes($this->SearchValues);
			$this->TableName = addslashes($this->TableName);
			$this->TableMatchingColumn = addslashes($this->TableMatchingColumn);
			$this->JoinType = addslashes($this->JoinType);
			$this->DisplayColumn = addslashes($this->DisplayColumn);
		}

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getModuleID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ModuleID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ModuleID;
			} else {
				return $this->ModuleID;
			}
		}

		public function getColumnName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ColumnName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ColumnName;
			} else {
				return stripslashes($this->ColumnName);
			}
		}

		public function getSearchCondition($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->SearchCondition),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->SearchCondition;
			} else {
				return stripslashes($this->SearchCondition);
			}
		}

		public function getSearchData($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->SearchData),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->SearchData;
			} else {
				return stripslashes($this->SearchData);
			}
		}

		public function getSearchValues($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->SearchValues),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->SearchValues;
			} else {
				return stripslashes($this->SearchValues);
			}
		}

		public function getTableName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->TableName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->TableName;
			} else {
				return stripslashes($this->TableName);
			}
		}

		public function getTableMatchingColumn($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->TableMatchingColumn),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->TableMatchingColumn;
			} else {
				return stripslashes($this->TableMatchingColumn);
			}
		}

		public function getJoinType($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->JoinType),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->JoinType;
			} else {
				return stripslashes($this->JoinType);
			}
		}

		public function getDisplayColumn($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DisplayColumn),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DisplayColumn;
			} else {
				return stripslashes($this->DisplayColumn);
			}
		}

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setModuleID($arg) {
			$this->ModuleID = (int)$arg;
		}

		public function setColumnName($arg) {
			$this->ColumnName = addslashes($arg);
		}

		public function setSearchCondition($arg) {
			$this->SearchCondition = addslashes($arg);
		}

		public function setSearchData($arg) {
			$this->SearchData = addslashes($arg);
		}

		public function setSearchValues($arg) {
			$this->SearchValues = addslashes($arg);
		}

		public function setTableName($arg) {
			$this->TableName = addslashes($arg);
		}

		public function setTableMatchingColumn($arg) {
			$this->TableMatchingColumn = addslashes($arg);
		}

		public function setJoinType($arg) {
			$this->JoinType = addslashes($arg);
		}

		public function setDisplayColumn($arg) {
			$this->DisplayColumn = addslashes($arg);
		}

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `asys_module_view_search` (`ModuleID`, `ColumnName`, `SearchCondition`, `SearchData`, `SearchValues`, `TableName`, `TableMatchingColumn`, `JoinType`, `DisplayColumn`) VALUES(";
			$sql	=	$sql."'".$this->getModuleID('asis')."', ";
			$sql	=	$sql."'".$this->getColumnName('asis')."', ";
			$sql	=	$sql."'".$this->getSearchCondition('asis')."', ";
			$sql	=	$sql."'".$this->getSearchData('asis')."', ";
			$sql	=	$sql."'".$this->getSearchValues('asis')."', ";
			$sql	=	$sql."'".$this->getTableName('asis')."', ";
			$sql	=	$sql."'".$this->getTableMatchingColumn('asis')."', ";
			$sql	=	$sql."'".$this->getJoinType('asis')."', ";
			$sql	=	$sql."'".$this->getDisplayColumn('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `asys_module_view_search` SET ";
			$sql	=	$sql."`ModuleID` = '".$this->getModuleID('asis')."', ";
			$sql	=	$sql."`ColumnName` = '".$this->getColumnName('asis')."', ";
			$sql	=	$sql."`SearchCondition` = '".$this->getSearchCondition('asis')."', ";
			$sql	=	$sql."`SearchData` = '".$this->getSearchData('asis')."', ";
			$sql	=	$sql."`SearchValues` = '".$this->getSearchValues('asis')."', ";
			$sql	=	$sql."`TableName` = '".$this->getTableName('asis')."', ";
			$sql	=	$sql."`TableMatchingColumn` = '".$this->getTableMatchingColumn('asis')."', ";
			$sql	=	$sql."`JoinType` = '".$this->getJoinType('asis')."', ";
			$sql	=	$sql."`DisplayColumn` = '".$this->getDisplayColumn('asis')."' ";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `asys_module_view_search` ";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">ModuleID</div>
				<div style="float:left;">: '.$this->getModuleID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ColumnName</div>
				<div style="float:left;">: '.$this->getColumnName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">SearchCondition</div>
				<div style="float:left;">: '.$this->getSearchCondition('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">SearchData</div>
				<div style="float:left;">: '.$this->getSearchData('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">SearchValues</div>
				<div style="float:left;">: '.$this->getSearchValues('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">TableName</div>
				<div style="float:left;">: '.$this->getTableName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">TableMatchingColumn</div>
				<div style="float:left;">: '.$this->getTableMatchingColumn('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">JoinType</div>
				<div style="float:left;">: '.$this->getJoinType('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DisplayColumn</div>
				<div style="float:left;">: '.$this->getDisplayColumn('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>