<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Aug 08, 2018
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class asys_module_voucher_config {
		/**
		 * @Field		ModuleID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $ModuleID = 0;

		/**
		 * @Field		VoucherConfigID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $VoucherConfigID = 0;

		/**
		 * @Field		VoucherConfigName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $VoucherConfigName = "";

		/**
		 * @Field		VoucherType
		 * @Type		varchar(30)
		 * @Access	Protected
		 */
		protected $VoucherType = "";

		/**
		 * @Field		DateField
		 * @Type		varchar(50)
		 * @Access	Protected
		 */
		protected $DateField = "";

		/**
		 * @Field		AmountField
		 * @Type		varchar(50)
		 * @Access	Protected
		 */
		protected $AmountField = "";

		/**
		 * @Field		CreditMotherAccount
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CreditMotherAccount = 0;

		/**
		 * @Field		CreditAccount
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CreditAccount = 0;

		/**
		 * @Field		RunTimeCreditAccount
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $RunTimeCreditAccount = "NO";

		/**
		 * @Field		CrColumnName
		 * @Type		varchar(100)
		 * @Access	Protected
		 */
		protected $CrColumnName = "";

		/**
		 * @Field		DebitMotherAccount
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $DebitMotherAccount = 0;

		/**
		 * @Field		DebitAccount
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $DebitAccount = 0;

		/**
		 * @Field		RunTimeDebitAccount
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $RunTimeDebitAccount = "NO";

		/**
		 * @Field		DrColumnName
		 * @Type		varchar(50)
		 * @Access	Protected
		 */
		protected $DrColumnName = "";

		/**
		 * @Field		EntryCondition
		 * @Type		varchar(300)
		 * @Access	Protected
		 */
		protected $EntryCondition = "";

		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->ModuleID = (int)$this->ModuleID;
			$this->VoucherConfigID = (int)$this->VoucherConfigID;
			$this->VoucherType = addslashes($this->VoucherType);
			$this->DateField = addslashes($this->DateField);
			$this->AmountField = (int)$this->AmountField;
			$this->CreditMotherAccount = (int)$this->CreditMotherAccount;
			$this->CreditAccount = (int)$this->CreditAccount;
			$this->RunTimeCreditAccount = addslashes($this->RunTimeCreditAccount);
			$this->CrColumnName = addslashes($this->CrColumnName);
			$this->DebitMotherAccount = (int)$this->DebitMotherAccount;
			$this->DebitAccount = (int)$this->DebitAccount;
			$this->RunTimeDebitAccount = addslashes($this->RunTimeDebitAccount);
			$this->DrColumnName = addslashes($this->DrColumnName);
			$this->EntryCondition = addslashes($this->EntryCondition);
		}		

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getModuleID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ModuleID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ModuleID;
			} else {
				return $this->ModuleID;
			}
		}

		public function getVoucherConfigID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->VoucherConfigID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->VoucherConfigID;
			} else {
				return $this->VoucherConfigID;
			}
		}

		public function getVoucherConfigName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->VoucherConfigName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->VoucherConfigName;
			} else {
				return stripslashes($this->VoucherConfigName);
			}
		}

		public function getVoucherType($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->VoucherType),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->VoucherType;
			} else {
				return stripslashes($this->VoucherType);
			}
		}

		public function getDateField($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DateField),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DateField;
			} else {
				return stripslashes($this->DateField);
			}
		}

		public function getAmountField($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->AmountField),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->AmountField;
			} else {
				return stripslashes($this->AmountField);
			}
		}

		public function getCreditMotherAccount($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CreditMotherAccount,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CreditMotherAccount;
			} else {
				return $this->CreditMotherAccount;
			}
		}

		public function getCreditAccount($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CreditAccount,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CreditAccount;
			} else {
				return $this->CreditAccount;
			}
		}

		public function getRunTimeCreditAccount($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->RunTimeCreditAccount),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->RunTimeCreditAccount;
			} else {
				return stripslashes($this->RunTimeCreditAccount);
			}
		}

		public function getCrColumnName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CrColumnName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CrColumnName;
			} else {
				return stripslashes($this->CrColumnName);
			}
		}

		public function getDebitMotherAccount($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->DebitMotherAccount,2,'.',',');
			} else if($formatted=='asis') {
				return $this->DebitMotherAccount;
			} else {
				return $this->DebitMotherAccount;
			}
		}

		public function getDebitAccount($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->DebitAccount,2,'.',',');
			} else if($formatted=='asis') {
				return $this->DebitAccount;
			} else {
				return $this->DebitAccount;
			}
		}

		public function getRunTimeDebitAccount($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->RunTimeDebitAccount),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->RunTimeDebitAccount;
			} else {
				return stripslashes($this->RunTimeDebitAccount);
			}
		}

		public function getDrColumnName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DrColumnName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DrColumnName;
			} else {
				return stripslashes($this->DrColumnName);
			}
		}

		public function getEntryCondition($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->EntryCondition),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->EntryCondition;
			} else {
				return stripslashes($this->EntryCondition);
			}
		}

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setModuleID($arg) {
			$this->ModuleID = (int)$arg;
		}

		public function setVoucherConfigID($arg) {
			$this->VoucherConfigID = (int)$arg;
		}

		public function setVoucherConfigName($arg) {
			$this->VoucherConfigName = addslashes($arg);
		}

		public function setVoucherType($arg) {
			$this->VoucherType = addslashes($arg);
		}

		public function setDateField($arg) {
			$this->DateField = addslashes($arg);
		}

		public function setAmountField($arg) {
			$this->AmountField = addslashes($arg);
		}

		public function setCreditMotherAccount($arg) {
			$this->CreditMotherAccount = (int)$arg;
		}

		public function setCreditAccount($arg) {
			$this->CreditAccount = (int)$arg;
		}

		public function setRunTimeCreditAccount($arg) {
			$this->RunTimeCreditAccount = addslashes($arg);
		}

		public function setCrColumnName($arg) {
			$this->CrColumnName = addslashes($arg);
		}

		public function setDebitMotherAccount($arg) {
			$this->DebitMotherAccount = (int)$arg;
		}

		public function setDebitAccount($arg) {
			$this->DebitAccount = (int)$arg;
		}

		public function setRunTimeDebitAccount($arg) {
			$this->RunTimeDebitAccount = addslashes($arg);
		}

		public function setDrColumnName($arg) {
			$this->DrColumnName = addslashes($arg);
		}

		public function setEntryCondition($arg) {
			$this->EntryCondition = addslashes($arg);
		}

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `asys_module_voucher_config` (`ModuleID`, `VoucherConfigID`, `VoucherType`, `DateField`, `AmountField`, `CreditMotherAccount`, `CreditAccount`, `RunTimeCreditAccount`, `CrColumnName`, `DebitMotherAccount`, `DebitAccount`, `RunTimeDebitAccount`, `DrColumnName`, `EntryCondition`) VALUES(";
			$sql	=	$sql."'".$this->getModuleID('asis')."', ";
			$sql	=	$sql."'".$this->getVoucherConfigID('asis')."', ";
			$sql	=	$sql."'".$this->getVoucherType('asis')."', ";
			$sql	=	$sql."'".$this->getDateField('asis')."', ";
			$sql	=	$sql."'".$this->getAmountField('asis')."', ";
			$sql	=	$sql."'".$this->getCreditMotherAccount('asis')."', ";
			$sql	=	$sql."'".$this->getCreditAccount('asis')."', ";
			$sql	=	$sql."'".$this->getRunTimeCreditAccount('asis')."', ";
			$sql	=	$sql."'".$this->getCrColumnName('asis')."', ";
			$sql	=	$sql."'".$this->getDebitMotherAccount('asis')."', ";
			$sql	=	$sql."'".$this->getDebitAccount('asis')."', ";
			$sql	=	$sql."'".$this->getRunTimeDebitAccount('asis')."', ";
			$sql	=	$sql."'".$this->getDrColumnName('asis')."', ";
			$sql	=	$sql."'".$this->getEntryCondition('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `asys_module_voucher_config` SET ";
			$sql	=	$sql."`VoucherType` = '".$this->getVoucherType('asis')."', ";
			$sql	=	$sql."`DateField` = '".$this->getDateField('asis')."', ";
			$sql	=	$sql."`AmountField` = '".$this->getAmountField('asis')."', ";
			$sql	=	$sql."`CreditMotherAccount` = '".$this->getCreditMotherAccount('asis')."', ";
			$sql	=	$sql."`CreditAccount` = '".$this->getCreditAccount('asis')."', ";
			$sql	=	$sql."`RunTimeCreditAccount` = '".$this->getRunTimeCreditAccount('asis')."', ";
			$sql	=	$sql."`CrColumnName` = '".$this->getCrColumnName('asis')."', ";
			$sql	=	$sql."`DebitMotherAccount` = '".$this->getDebitMotherAccount('asis')."', ";
			$sql	=	$sql."`DebitAccount` = '".$this->getDebitAccount('asis')."', ";
			$sql	=	$sql."`RunTimeDebitAccount` = '".$this->getRunTimeDebitAccount('asis')."', ";
			$sql	=	$sql."`DrColumnName` = '".$this->getDrColumnName('asis')."', ";
			$sql	=	$sql."`EntryCondition` = '".$this->getEntryCondition('asis')."' ";
			$sql	=	$sql." WHERE `ModuleID` = '".$this->getModuleID('asis')."'";
			$sql	=	$sql." AND `VoucherConfigID` = '".$this->getVoucherConfigID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `asys_module_voucher_config` ";
			$sql	=	$sql." WHERE `ModuleID` = '".$this->getModuleID('asis')."'";
			$sql	=	$sql." AND `VoucherConfigID` = '".$this->getVoucherConfigID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$ModuleID <= 0) $chk	=	false;
			if((int)$VoucherConfigID <= 0) $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">ModuleID</div>
				<div style="float:left;">: '.$this->getModuleID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">VoucherConfigID</div>
				<div style="float:left;">: '.$this->getVoucherConfigID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">VoucherType</div>
				<div style="float:left;">: '.$this->getVoucherType('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DateField</div>
				<div style="float:left;">: '.$this->getDateField('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">AmountField</div>
				<div style="float:left;">: '.$this->getAmountField('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">CreditMotherAccount</div>
				<div style="float:left;">: '.$this->getCreditMotherAccount('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">CreditAccount</div>
				<div style="float:left;">: '.$this->getCreditAccount('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">RunTimeCreditAccount</div>
				<div style="float:left;">: '.$this->getRunTimeCreditAccount('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">CrColumnName</div>
				<div style="float:left;">: '.$this->getCrColumnName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DebitMotherAccount</div>
				<div style="float:left;">: '.$this->getDebitMotherAccount('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DebitAccount</div>
				<div style="float:left;">: '.$this->getDebitAccount('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">RunTimeDebitAccount</div>
				<div style="float:left;">: '.$this->getRunTimeDebitAccount('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DrColumnName</div>
				<div style="float:left;">: '.$this->getDrColumnName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">EntryCondition</div>
				<div style="float:left;">: '.$this->getEntryCondition('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>