<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Jun 15, 2016
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class asys_opening_balances {
		/**
		 * @Field		CompanyID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyID = 0;
		
		/**
		 * @Field		CompanyName
		 * @Type		varchar(200)
		 * @Access	Protected
		 */
		protected $CompanyName = "";		

		/**
		 * @Field		FinYear
		 * @Type		varchar(5)
		 * @Access	Protected
		 */
		protected $FinYear = "";

		/**
		 * @Field		RDate
		 * @Type		date
		 * @Access	Protected
		 */
		protected $RDate = "1900-01-01";

		/**
		 * @Field		AccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $AccountID = 0;

		/**
		 * @Field		AccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $AccountName = "";

		/**
		 * @Field		OBal
		 * @Type		decimal(15,2)
		 * @Access	Protected
		 */
		protected $OBal = 0;

		/**
		 * @Field		OBalType
		 * @Type		tinyint(4)
		 * @Access	Protected
		 */
		protected $OBalType = 0;

		/**
		 * @Field		GroupID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $GroupID = 0;

		/**
		 * @Field		GroupName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $GroupName = "";

		/**
		 * @Field		BGID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $BGID = 0;

		/**
		 * @Field		BGName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $BGName = "";

		/**
		 * @Field		SubgroupID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $SubgroupID = 0;

		/**
		 * @Field		SubgroupName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $SubgroupName = "";

		/**
		 * @Field		MotherAccount
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $MotherAccount = 0;

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getCompanyID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CompanyID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CompanyID;
			} else {
				return $this->CompanyID;
			}
		}
		
		public function getCompanyName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CompanyName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CompanyName;
			} else {
				return stripslashes($this->CompanyName);
			}
		}		

		public function getFinYear($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->FinYear),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->FinYear;
			} else {
				return stripslashes($this->FinYear);
			}
		}

		public function getRDate($formatted='no') {
			if($formatted == 'yes') {
				return FormatSQLDateToIndianDate($this->RDate);
			} else if($formatted=='asis') {
				return $this->RDate;
			} else {
				return stripslashes($this->RDate);
			}
		}

		public function getAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->AccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->AccountID;
			} else {
				return $this->AccountID;
			}
		}

		public function getAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->AccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->AccountName;
			} else {
				return stripslashes($this->AccountName);
			}
		}

		public function getOBal($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->OBal,2,'.',',');
			} else if($formatted=='asis') {
				return $this->OBal;
			} else {
				return $this->OBal;
			}
		}

		public function getOBalType($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->OBalType,2,'.',',');
			} else if($formatted=='asis') {
				return $this->OBalType;
			} else {
				return $this->OBalType;
			}
		}

		public function getGroupID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->GroupID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->GroupID;
			} else {
				return $this->GroupID;
			}
		}

		public function getGroupName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->GroupName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->GroupName;
			} else {
				return stripslashes($this->GroupName);
			}
		}

		public function getBGID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->BGID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->BGID;
			} else {
				return $this->BGID;
			}
		}

		public function getBGName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->BGName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->BGName;
			} else {
				return stripslashes($this->BGName);
			}
		}

		public function getSubgroupID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->SubgroupID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->SubgroupID;
			} else {
				return $this->SubgroupID;
			}
		}

		public function getSubgroupName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->SubgroupName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->SubgroupName;
			} else {
				return stripslashes($this->SubgroupName);
			}
		}

		public function getMotherAccount($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->MotherAccount,2,'.',',');
			} else if($formatted=='asis') {
				return $this->MotherAccount;
			} else {
				return $this->MotherAccount;
			}
		}

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setCompanyID($arg) {
			$this->CompanyID = (int)$arg;
		}
		
		public function setCompanyName($arg) {
			$this->CompanyName = addslashes($arg);
		}		

		public function setFinYear($arg) {
			$this->FinYear = addslashes($arg);
		}

		public function setRDate($arg) {
			$this->RDate = FormatIndianDateToSQLDate($arg);
		}

		public function setAccountID($arg) {
			$this->AccountID = (int)$arg;
		}

		public function setAccountName($arg) {
			$this->AccountName = addslashes($arg);
		}

		public function setOBal($arg) {
			$this->OBal = (double)$arg;
		}

		public function setOBalType($arg) {
			$this->OBalType = (int)$arg;
		}

		public function setGroupID($arg) {
			$this->GroupID = (int)$arg;
		}

		public function setGroupName($arg) {
			$this->GroupName = addslashes($arg);
		}

		public function setBGID($arg) {
			$this->BGID = (int)$arg;
		}

		public function setBGName($arg) {
			$this->BGName = addslashes($arg);
		}

		public function setSubgroupID($arg) {
			$this->SubgroupID = (int)$arg;
		}

		public function setSubgroupName($arg) {
			$this->SubgroupName = addslashes($arg);
		}

		public function setMotherAccount($arg) {
			$this->MotherAccount = (int)$arg;
		}

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `asys_opening_balances` (`CompanyID`, `FinYear`, `RDate`, `AccountID`, `OBal`, `OBalType`, `GroupID`, `BGID`, `SubgroupID`, `MotherAccount`) VALUES(";
			$sql	=	$sql."'".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."'".$this->getFinYear('asis')."', ";
			$sql	=	$sql."'".$this->getRDate('asis')."', ";
			$sql	=	$sql."'".$this->getAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getOBal('asis')."', ";
			$sql	=	$sql."'".$this->getOBalType('asis')."', ";
			$sql	=	$sql."'".$this->getGroupID('asis')."', ";
			$sql	=	$sql."'".$this->getBGID('asis')."', ";
			$sql	=	$sql."'".$this->getSubgroupID('asis')."', ";
			$sql	=	$sql."'".$this->getMotherAccount('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `asys_opening_balances` SET ";
			$sql	=	$sql."`CompanyID` = '".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."`FinYear` = '".$this->getFinYear('asis')."', ";
			$sql	=	$sql."`RDate` = '".$this->getRDate('asis')."', ";
			$sql	=	$sql."`AccountID` = '".$this->getAccountID('asis')."', ";
			$sql	=	$sql."`OBal` = '".$this->getOBal('asis')."', ";
			$sql	=	$sql."`OBalType` = '".$this->getOBalType('asis')."', ";
			$sql	=	$sql."`GroupID` = '".$this->getGroupID('asis')."', ";
			$sql	=	$sql."`BGID` = '".$this->getBGID('asis')."', ";
			$sql	=	$sql."`SubgroupID` = '".$this->getSubgroupID('asis')."', ";
			$sql	=	$sql."`MotherAccount` = '".$this->getMotherAccount('asis')."' ";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `asys_opening_balances` ";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">CompanyID</div>
				<div style="float:left;">: '.$this->getCompanyID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">FinYear</div>
				<div style="float:left;">: '.$this->getFinYear('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">RDate</div>
				<div style="float:left;">: '.$this->getRDate('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">AccountID</div>
				<div style="float:left;">: '.$this->getAccountID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">OBal</div>
				<div style="float:left;">: '.$this->getOBal('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">OBalType</div>
				<div style="float:left;">: '.$this->getOBalType('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">GroupID</div>
				<div style="float:left;">: '.$this->getGroupID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">BGID</div>
				<div style="float:left;">: '.$this->getBGID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">SubgroupID</div>
				<div style="float:left;">: '.$this->getSubgroupID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">MotherAccount</div>
				<div style="float:left;">: '.$this->getMotherAccount('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>