<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Jul 15, 2015
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class asys_stock_voucher {
		/**
		 * @Field		SVoucherID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $SVoucherID = 0;

		/**
		 * @Field		CompanyID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyID = 0;

		/**
		 * @Field		CompanyName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyName = "";

		/**
		 * @Field		StoreID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $StoreID = 0;

		/**
		 * @Field		StoreName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $StoreName = "";

		/**
		 * @Field		ModuleID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $ModuleID = 0;

		/**
		 * @Field		ModuleName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $ModuleName = "";

		/**
		 * @Field		FinYear
		 * @Type		varchar(10)
		 * @Access	Protected
		 */
		protected $FinYear = "";

		/**
		 * @Field		RelatedID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $RelatedID = 0;

		/**
		 * @Field		RelatedName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $RelatedName = "";

		/**
		 * @Field		DOT
		 * @Type		date
		 * @Access	Protected
		 */
		protected $DOT = "1900-01-01";
		
		/**
		 * @Field		TOT
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $TOT = 0;		

		/**
		 * @Field		ItemID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $ItemID = 0;

		/**
		 * @Field		ItemName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $ItemName = "";
		
		/**
		 * @Field		ItemCategoryID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ItemCategoryID = 0;

		/**
		 * @Field		ItemCategoryName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ItemCategoryName = "";		

		/**
		 * @Field		Quantity
		 * @Type		decimal(10,3)
		 * @Access	Protected
		 */
		protected $Quantity = 0;

		/**
		 * @Field		UnitPrice
		 * @Type		decimal(10,5)
		 * @Access	Protected
		 */
		protected $UnitPrice = 0;

		/**
		 * @Field		StockInOut
		 * @Type		tinyint(4)
		 * @Access	Protected
		 */
		protected $StockInOut = 0;
		
		/**
		 * @Field		ClosingQty
		 * @Type		decimal(13,3)
		 * @Access	Protected
		 */
		protected $ClosingQty = 0;

		/**
		 * @Field		ClosingValue
		 * @Type		decimal(15,2)
		 * @Access	Protected
		 */
		protected $ClosingValue = 0;		

		/**
		 * @Field		BatchNo
		 * @Type		varchar(50)
		 * @Access	Protected
		 */
		protected $BatchNo = "";

		/**
		 * @Field		Narration
		 * @Type		varchar(250)
		 * @Access	Protected
		 */
		protected $Narration = "";
		
		/**
		 * @Field		BalanceDetail
		 * @Type		text
		 * @Access	Protected
		 */
		protected $BalanceDetail = "";		
		
		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->SVoucherID = (int)$this->SVoucherID;
			$this->CompanyID = (int)$this->CompanyID;
			$this->StoreID = (int)$this->StoreID;
			$this->ModuleID = (int)$this->ModuleID;
			$this->FinYear = addslashes($this->FinYear);
			$this->RelatedID = (int)$this->RelatedID;
			$this->TOT = (int)$this->TOT;
			$this->ItemID = (int)$this->ItemID;
			$this->ItemCategoryID = (int)$this->ItemCategoryID;
			$this->Quantity = (double)$this->Quantity;
			$this->UnitPrice = (double)$this->UnitPrice;
			$this->StockInOut = (int)$this->StockInOut;
			$this->ClosingQty = (double)$this->ClosingQty;
			$this->ClosingValue = (double)$this->ClosingValue;
			$this->BatchNo = addslashes($this->BatchNo);
			$this->Narration = addslashes($this->Narration);
			$this->BalanceDetail = addslashes($this->BalanceDetail);
		}		

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getSVoucherID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->SVoucherID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->SVoucherID;
			} else {
				return $this->SVoucherID;
			}
		}

		public function getCompanyID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CompanyID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CompanyID;
			} else {
				return $this->CompanyID;
			}
		}

		public function getCompanyName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CompanyName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CompanyName;
			} else {
				return stripslashes($this->CompanyName);
			}
		}

		public function getStoreID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->StoreID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->StoreID;
			} else {
				return $this->StoreID;
			}
		}

		public function getStoreName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->StoreName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->StoreName;
			} else {
				return stripslashes($this->StoreName);
			}
		}

		public function getModuleID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ModuleID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ModuleID;
			} else {
				return $this->ModuleID;
			}
		}

		public function getModuleName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ModuleName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ModuleName;
			} else {
				return stripslashes($this->ModuleName);
			}
		}

		public function getFinYear($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->FinYear),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->FinYear;
			} else {
				return stripslashes($this->FinYear);
			}
		}

		public function getRelatedID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->RelatedID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->RelatedID;
			} else {
				return $this->RelatedID;
			}
		}

		public function getRelatedName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->RelatedName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->RelatedName;
			} else {
				return stripslashes($this->RelatedName);
			}
		}

		public function getDOT($formatted='no') {
			if($formatted == 'yes') {
				return FormatSQLDateToIndianDate($this->DOT);
			} else if($formatted=='asis') {
				return $this->DOT;
			} else {
				return stripslashes($this->DOT);
			}
		}
		
		public function getTOT($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->TOT,2,'.',',');
			} else if($formatted=='asis') {
				return $this->TOT;
			} else {
				return $this->TOT;
			}
		}		

		public function getItemID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ItemID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ItemID;
			} else {
				return $this->ItemID;
			}
		}

		public function getItemName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ItemName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ItemName;
			} else {
				return stripslashes($this->ItemName);
			}
		}
		
		public function getItemCategoryID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ItemCategoryID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ItemCategoryID;
			} else {
				return $this->ItemCategoryID;
			}
		}

		public function getItemCategoryName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ItemCategoryName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ItemCategoryName;
			} else {
				return stripslashes($this->ItemCategoryName);
			}
		}		

		public function getQuantity($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->Quantity,2,'.',',');
			} else if($formatted=='asis') {
				return $this->Quantity;
			} else {
				return $this->Quantity;
			}
		}

		public function getUnitPrice($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->UnitPrice,2,'.',',');
			} else if($formatted=='asis') {
				return $this->UnitPrice;
			} else {
				return $this->UnitPrice;
			}
		}

		public function getStockInOut($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->StockInOut,2,'.',',');
			} else if($formatted=='asis') {
				return $this->StockInOut;
			} else {
				return $this->StockInOut;
			}
		}
		
		public function getClosingQty($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ClosingQty,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ClosingQty;
			} else {
				return $this->ClosingQty;
			}
		}

		public function getClosingValue($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ClosingValue,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ClosingValue;
			} else {
				return $this->ClosingValue;
			}
		}		

		public function getBatchNo($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->BatchNo),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->BatchNo;
			} else {
				return stripslashes($this->BatchNo);
			}
		}

		public function getNarration($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Narration),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Narration;
			} else {
				return stripslashes($this->Narration);
			}
		}
		
		public function getBalanceDetail($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->BalanceDetail),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->BalanceDetail;
			} else {
				return stripslashes($this->BalanceDetail);
			}
		}		

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setSVoucherID($arg) {
			$this->SVoucherID = (int)$arg;
		}

		public function setCompanyID($arg) {
			$this->CompanyID = (int)$arg;
		}

		public function setCompanyName($arg) {
			$this->CompanyName = addslashes($arg);
		}

		public function setStoreID($arg) {
			$this->StoreID = (int)$arg;
		}

		public function setStoreName($arg) {
			$this->StoreName = addslashes($arg);
		}

		public function setModuleID($arg) {
			$this->ModuleID = (int)$arg;
		}

		public function setModuleName($arg) {
			$this->ModuleName = addslashes($arg);
		}

		public function setFinYear($arg) {
			$this->FinYear = addslashes($arg);
		}

		public function setRelatedID($arg) {
			$this->RelatedID = (int)$arg;
		}

		public function setRelatedName($arg) {
			$this->RelatedName = addslashes($arg);
		}

		public function setDOT($arg) {
			$this->DOT = FormatIndianDateToSQLDate($arg);
		}
		
		public function setTOT($arg) {
			$this->TOT = (int)$arg;
		}		

		public function setItemID($arg) {
			$this->ItemID = (int)$arg;
		}

		public function setItemName($arg) {
			$this->ItemName = addslashes($arg);
		}
		
		public function setItemCategoryID($arg) {
			$this->ItemCategoryID = (int)$arg;
		}

		public function setItemCategoryName($arg) {
			$this->ItemCategoryName = addslashes($arg);
		}		

		public function setQuantity($arg) {
			$this->Quantity = (double)$arg;
		}

		public function setUnitPrice($arg) {
			$this->UnitPrice = (double)$arg;
		}

		public function setStockInOut($arg) {
			$this->StockInOut = (int)$arg;
		}
		
		public function setClosingQty($arg) {
			$this->ClosingQty = (double)$arg;
		}

		public function setClosingValue($arg) {
			$this->ClosingValue = (double)$arg;
		}		

		public function setBatchNo($arg) {
			$this->BatchNo = addslashes($arg);
		}

		public function setNarration($arg) {
			$this->Narration = addslashes($arg);
		}
		
		public function setBalanceDetail($arg) {
			$this->BalanceDetail = addslashes($arg);
		}		

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `asys_stock_voucher` (`SVoucherID`, `CompanyID`, `StoreID`, `ModuleID`, `FinYear`, `RelatedID`, `DOT`, `TOT`, `ItemID`, `ItemCategoryID`, `Quantity`, `UnitPrice`, `StockInOut`, `ClosingQty`, `ClosingValue`, `BatchNo`, `Narration`, `BalanceDetail`) VALUES(";
			$sql	=	$sql."'".$this->getSVoucherID('asis')."', ";
			$sql	=	$sql."'".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."'".$this->getStoreID('asis')."', ";
			$sql	=	$sql."'".$this->getModuleID('asis')."', ";
			$sql	=	$sql."'".$this->getFinYear('asis')."', ";
			$sql	=	$sql."'".$this->getRelatedID('asis')."', ";
			$sql	=	$sql."'".$this->getDOT('asis')."', ";
			$sql	=	$sql."'".$this->getTOT('asis')."', ";
			$sql	=	$sql."'".$this->getItemID('asis')."', ";
			$sql	=	$sql."'".$this->getItemCategoryID('asis')."', ";
			$sql	=	$sql."'".$this->getQuantity('asis')."', ";
			$sql	=	$sql."'".$this->getUnitPrice('asis')."', ";
			$sql	=	$sql."'".$this->getStockInOut('asis')."', ";
			$sql	=	$sql."'".$this->getClosingQty('asis')."', ";
			$sql	=	$sql."'".$this->getClosingValue('asis')."', ";
			$sql	=	$sql."'".$this->getBatchNo('asis')."', ";
			$sql	=	$sql."'".$this->getNarration('asis')."', ";
			$sql	=	$sql."'".$this->getBalanceDetail('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `asys_stock_voucher` SET ";
			$sql	=	$sql."`CompanyID` = '".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."`StoreID` = '".$this->getStoreID('asis')."', ";
			$sql	=	$sql."`ModuleID` = '".$this->getModuleID('asis')."', ";
			$sql	=	$sql."`FinYear` = '".$this->getFinYear('asis')."', ";
			$sql	=	$sql."`RelatedID` = '".$this->getRelatedID('asis')."', ";
			$sql	=	$sql."`DOT` = '".$this->getDOT('asis')."', ";
			$sql	=	$sql."`TOT` = '".$this->getTOT('asis')."', ";
			$sql	=	$sql."`ItemID` = '".$this->getItemID('asis')."', ";
			$sql	=	$sql."`ItemCategoryID` = '".$this->getItemCategoryID('asis')."', ";
			$sql	=	$sql."`Quantity` = '".$this->getQuantity('asis')."', ";
			$sql	=	$sql."`UnitPrice` = '".$this->getUnitPrice('asis')."', ";
			$sql	=	$sql."`StockInOut` = '".$this->getStockInOut('asis')."', ";
			$sql	=	$sql."`ClosingQty` = '".$this->getClosingQty('asis')."', ";
			$sql	=	$sql."`ClosingValue` = '".$this->getClosingValue('asis')."', ";
			$sql	=	$sql."`BatchNo` = '".$this->getBatchNo('asis')."', ";
			$sql	=	$sql."`Narration` = '".$this->getNarration('asis')."', ";
			$sql	=	$sql."`BalanceDetail` = '".$this->getBalanceDetail('asis')."' ";
			$sql	=	$sql." WHERE `SVoucherID` = '".$this->getSVoucherID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `asys_stock_voucher` ";
			$sql	=	$sql." WHERE `SVoucherID` = '".$this->getSVoucherID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$SVoucherID <= 0) $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">SVoucherID</div>
				<div style="float:left;">: '.$this->getSVoucherID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">CompanyID</div>
				<div style="float:left;">: '.$this->getCompanyID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">StoreID</div>
				<div style="float:left;">: '.$this->getStoreID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ModuleID</div>
				<div style="float:left;">: '.$this->getModuleID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">FinYear</div>
				<div style="float:left;">: '.$this->getFinYear('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">RelatedID</div>
				<div style="float:left;">: '.$this->getRelatedID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DOT</div>
				<div style="float:left;">: '.$this->getDOT('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ItemID</div>
				<div style="float:left;">: '.$this->getItemID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Quantity</div>
				<div style="float:left;">: '.$this->getQuantity('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">UnitPrice</div>
				<div style="float:left;">: '.$this->getUnitPrice('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">StockInOut</div>
				<div style="float:left;">: '.$this->getStockInOut('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">BatchNo</div>
				<div style="float:left;">: '.$this->getBatchNo('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Narration</div>
				<div style="float:left;">: '.$this->getNarration('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>