<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Apr 24, 2017
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class asys_stores {
		/**
		 * @Field		StoreID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $StoreID = 0;

		/**
		 * @Field		CompanyID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyID = 0;

		/**
		 * @Field		CompanyName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyName = "";

		/**
		 * @Field		StoreName
		 * @Type		varchar(200)
		 * @Access	Protected
		 */
		protected $StoreName = "";
		
		/**
		 * @Field		MotherAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $MotherAccountID = 0;

		/**
		 * @Field		MotherAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $MotherAccountName = "";

		/**
		 * @Field		AccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $AccountID = 0;

		/**
		 * @Field		AccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $AccountName = "";
		
		/**
		 * @Field		OppositeAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $OppositeAccountID = 0;

		/**
		 * @Field		OppositeAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $OppositeAccountName = "";		

		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->StoreID = (int)$this->StoreID;
			$this->CompanyID = (int)$this->CompanyID;
			$this->StoreName = addslashes($this->StoreName);
			$this->MotherAccountID = (int)$this->MotherAccountID;
			$this->AccountID = (int)$this->AccountID;
			$this->OppositeAccountID = (int)$this->OppositeAccountID;
		}

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getStoreID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->StoreID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->StoreID;
			} else {
				return $this->StoreID;
			}
		}

		public function getCompanyID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CompanyID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CompanyID;
			} else {
				return $this->CompanyID;
			}
		}

		public function getCompanyName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CompanyName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CompanyName;
			} else {
				return stripslashes($this->CompanyName);
			}
		}

		public function getStoreName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->StoreName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->StoreName;
			} else {
				return stripslashes($this->StoreName);
			}
		}
		
		public function getMotherAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->MotherAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->MotherAccountID;
			} else {
				return $this->MotherAccountID;
			}
		}

		public function getMotherAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->MotherAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->MotherAccountName;
			} else {
				return stripslashes($this->MotherAccountName);
			}
		}

		public function getAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->AccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->AccountID;
			} else {
				return $this->AccountID;
			}
		}

		public function getAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->AccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->AccountName;
			} else {
				return stripslashes($this->AccountName);
			}
		}
		
		public function getOppositeAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->OppositeAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->OppositeAccountID;
			} else {
				return $this->OppositeAccountID;
			}
		}

		public function getOppositeAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->OppositeAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->OppositeAccountName;
			} else {
				return stripslashes($this->OppositeAccountName);
			}
		}		

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setStoreID($arg) {
			$this->StoreID = (int)$arg;
		}

		public function setCompanyID($arg) {
			$this->CompanyID = (int)$arg;
		}

		public function setCompanyName($arg) {
			$this->CompanyName = addslashes($arg);
		}

		public function setStoreName($arg) {
			$this->StoreName = addslashes($arg);
		}
		
		public function setMotherAccountID($arg) {
			$this->MotherAccountID = (int)$arg;
		}

		public function setMotherAccountName($arg) {
			$this->MotherAccountName = addslashes($arg);
		}

		public function setAccountID($arg) {
			$this->AccountID = (int)$arg;
		}

		public function setAccountName($arg) {
			$this->AccountName = addslashes($arg);
		}
		
		public function setOppositeAccountID($arg) {
			$this->OppositeAccountID = (int)$arg;
		}

		public function setOppositeAccountName($arg) {
			$this->OppositeAccountName = addslashes($arg);
		}		

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `asys_stores` (`StoreID`, `CompanyID`, `StoreName`, `MotherAccountID`, `AccountID`, `OppositeAccountID`) VALUES(";
			$sql	=	$sql."'".$this->getStoreID('asis')."', ";
			$sql	=	$sql."'".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."'".$this->getStoreName('asis')."', ";
			$sql	=	$sql."'".$this->getMotherAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getOppositeAccountID('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `asys_stores` SET ";
			$sql	=	$sql."`CompanyID` = '".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."`StoreName` = '".$this->getStoreName('asis')."', ";
			$sql	=	$sql."`MotherAccountID` = '".$this->getMotherAccountID('asis')."', ";
			$sql	=	$sql."`AccountID` = '".$this->getAccountID('asis')."', ";
			$sql	=	$sql."`OppositeAccountID` = '".$this->getOppositeAccountID('asis')."' ";
			$sql	=	$sql." WHERE `StoreID` = '".$this->getStoreID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `asys_stores` ";
			$sql	=	$sql." WHERE `StoreID` = '".$this->getStoreID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$StoreID <= 0) $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">Store#</div>
				<div style="float:left;">: '.$this->getStoreID().'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Company</div>
				<div style="float:left;">: '.$this->getCompanyName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Store Name</div>
				<div style="float:left;">: '.$this->getStoreName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Mother Account</div>
				<div style="float:left;">: '.$this->getMotherAccountName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Account</div>
				<div style="float:left;">: '.$this->getAccountName('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>