<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Jan 24, 2019
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class asys_tdssection {
		/**
		 * @Field		SectionID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $SectionID = 0;

		/**
		 * @Field		SectionName
		 * @Type		varchar(30)
		 * @Access	Protected
		 */
		protected $SectionName = "";

		/**
		 * @Field		Detail
		 * @Type		text
		 * @Access	Protected
		 */
		protected $Detail = "";

		/**
		 * @Field		Percentage
		 * @Type		decimal(5,2)
		 * @Access	Protected
		 */
		protected $Percentage = 0;

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getSectionID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->SectionID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->SectionID;
			} else {
				return $this->SectionID;
			}
		}

		public function getSectionName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->SectionName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->SectionName;
			} else {
				return stripslashes($this->SectionName);
			}
		}

		public function getDetail($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Detail),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Detail;
			} else {
				return stripslashes($this->Detail);
			}
		}

		public function getPercentage($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->Percentage,2,'.',',');
			} else if($formatted=='asis') {
				return $this->Percentage;
			} else {
				return $this->Percentage;
			}
		}

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setSectionID($arg) {
			$this->SectionID = (int)$arg;
		}

		public function setSectionName($arg) {
			$this->SectionName = addslashes($arg);
		}

		public function setDetail($arg) {
			$this->Detail = addslashes($arg);
		}

		public function setPercentage($arg) {
			$this->Percentage = (double)$arg;
		}

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `asys_tdssection` (`SectionID`, `SectionName`, `Detail`, `Percentage`) VALUES(";
			$sql	=	$sql."'".$this->getSectionID('asis')."', ";
			$sql	=	$sql."'".$this->getSectionName('asis')."', ";
			$sql	=	$sql."'".$this->getDetail('asis')."', ";
			$sql	=	$sql."'".$this->getPercentage('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `asys_tdssection` SET ";
			$sql	=	$sql."`SectionName` = '".$this->getSectionName('asis')."', ";
			$sql	=	$sql."`Detail` = '".$this->getDetail('asis')."', ";
			$sql	=	$sql."`Percentage` = '".$this->getPercentage('asis')."' ";
			$sql	=	$sql." WHERE `SectionID` = '".$this->getSectionID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `asys_tdssection` ";
			$sql	=	$sql." WHERE `SectionID` = '".$this->getSectionID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$SectionID <= 0) $chk	=	false;
			if(trim($SectionName) == "") $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">SectionID</div>
				<div style="float:left;">: '.$this->getSectionID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">SectionName</div>
				<div style="float:left;">: '.$this->getSectionName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Detail</div>
				<div style="float:left;">: '.$this->getDetail('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Percentage</div>
				<div style="float:left;">: '.$this->getPercentage('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>