<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Aug 05, 2014
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class asys_users {
		/**
		 * @Field		UserID
		 * @Type		varchar(60)
		 * @Access	Protected
		 */
		protected $UserID = "";

		/**
		 * @Field		Password
		 * @Type		varchar(60)
		 * @Access	Protected
		 */
		protected $Password = "";

		/**
		 * @Field		UserName
		 * @Type		varchar(200)
		 * @Access	Protected
		 */
		protected $UserName = "";

		/**
		 * @Field		UserStatus
		 * @Type		tinyint(4)
		 * @Access	Protected
		 */
		protected $UserStatus = 0;

		/**
		 * @Field		Created
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $Created = 0;

		/**
		 * @Field		Access
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $Access = 0;

		/**
		 * @Field		LastLogin
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $LastLogin = 0;

		/**
		 * @Field		LastLoginIP
		 * @Type		varchar(25)
		 * @Access	Protected
		 */
		protected $LastLoginIP = "";

		/**
		 * @Field		IsEnabled
		 * @Type		enum('YES','NO')
		 * @Access	Protected
		 */
		protected $IsEnabled = "YES";

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getUserID($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->UserID),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->UserID;
			} else {
				return stripslashes($this->UserID);
			}
		}

		public function getPassword($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Password),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Password;
			} else {
				return stripslashes($this->Password);
			}
		}

		public function getUserName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->UserName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->UserName;
			} else {
				return stripslashes($this->UserName);
			}
		}

		public function getUserStatus($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->UserStatus,2,'.',',');
			} else if($formatted=='asis') {
				return $this->UserStatus;
			} else {
				return $this->UserStatus;
			}
		}

		public function getCreated($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->Created,2,'.',',');
			} else if($formatted=='asis') {
				return $this->Created;
			} else {
				return $this->Created;
			}
		}

		public function getAccess($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->Access,2,'.',',');
			} else if($formatted=='asis') {
				return $this->Access;
			} else {
				return $this->Access;
			}
		}

		public function getLastLogin($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->LastLogin,2,'.',',');
			} else if($formatted=='asis') {
				return $this->LastLogin;
			} else {
				return $this->LastLogin;
			}
		}

		public function getLastLoginIP($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->LastLoginIP),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->LastLoginIP;
			} else {
				return stripslashes($this->LastLoginIP);
			}
		}

		public function getIsEnabled($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->IsEnabled),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->IsEnabled;
			} else {
				return stripslashes($this->IsEnabled);
			}
		}

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setUserID($arg) {
			$this->UserID = addslashes($arg);
		}

		public function setPassword($arg) {
			$this->Password = addslashes($arg);
		}

		public function setUserName($arg) {
			$this->UserName = addslashes($arg);
		}

		public function setUserStatus($arg) {
			$this->UserStatus = (int)$arg;
		}

		public function setCreated($arg) {
			$this->Created = (int)$arg;
		}

		public function setAccess($arg) {
			$this->Access = (int)$arg;
		}

		public function setLastLogin($arg) {
			$this->LastLogin = (int)$arg;
		}

		public function setLastLoginIP($arg) {
			$this->LastLoginIP = addslashes($arg);
		}

		public function setIsEnabled($arg) {
			$this->IsEnabled = addslashes($arg);
		}

		public function getInsertSQL() {
		
			$this->setPassword(MD5($this->getPassword('asis')));

			$sql	=	"INSERT INTO `asys_users` (`UserID`, `Password`, `UserName`, `UserStatus`, `Created`, `Access`, `LastLogin`, `LastLoginIP`, `IsEnabled`) VALUES(";
			$sql	=	$sql."'".$this->getUserID('asis')."', ";
			$sql	=	$sql."'".$this->getPassword('asis')."', ";
			$sql	=	$sql."'".$this->getUserName('asis')."', ";
			$sql	=	$sql."'".$this->getUserStatus('asis')."', ";
			$sql	=	$sql."'".$this->getCreated('asis')."', ";
			$sql	=	$sql."'".$this->getAccess('asis')."', ";
			$sql	=	$sql."'".$this->getLastLogin('asis')."', ";
			$sql	=	$sql."'".$this->getLastLoginIP('asis')."', ";
			$sql	=	$sql."'".$this->getIsEnabled('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {			

			$sql	=	"UPDATE `asys_users` SET ";
			if($this->getPassword('asis') != "")
				$sql	=	$sql."`Password` = '".MD5($this->getPassword('asis'))."', ";
			$sql	=	$sql."`UserName` = '".$this->getUserName('asis')."', ";
			$sql	=	$sql."`UserStatus` = '".$this->getUserStatus('asis')."', ";
			$sql	=	$sql."`Created` = '".$this->getCreated('asis')."', ";
			$sql	=	$sql."`Access` = '".$this->getAccess('asis')."', ";
			$sql	=	$sql."`LastLogin` = '".$this->getLastLogin('asis')."', ";
			$sql	=	$sql."`LastLoginIP` = '".$this->getLastLoginIP('asis')."', ";
			$sql	=	$sql."`IsEnabled` = '".$this->getIsEnabled('asis')."' ";
			$sql	=	$sql." WHERE `UserID` = '".$this->getUserID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `asys_users` ";
			$sql	=	$sql." WHERE `UserID` = '".$this->getUserID('asis')."'";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			
			if(trim($UserID) == "") $chk		=	false;
			if(trim($Password) == "") $chk	=	false;
			if(int($UserStatus) <= 0) $chk	=	false;
			if(trim($UserName) == "") $chk	=	false;

			return $chk;
		}
		
		public function validateFieldsIgnoringPassword() {		

			$chk	=	true;
			
			if(trim($UserID) == "") $chk		=	false;
			if(int($UserStatus) <= 0) $chk	=	false;
			if(trim($UserName) == "") $chk	=	false;

			return $chk;
		}		
	};

?>