<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - May 12, 2015
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class asys_user_permission {
		/**
		 * @Field		CompanyID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyID = 0;

		/**
		 * @Field		UserID
		 * @Type		varchar(60)
		 * @Access	Protected
		 */
		protected $UserID = "";

		/**
		 * @Field		UserName
		 * @Type		varchar(60)
		 * @Access	Protected
		 */
		protected $UserName = "";

		/**
		 * @Field		ModuleID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $ModuleID = 0;

		/**
		 * @Field		ModuleName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $ModuleName = "";

		/**
		 * @Field		DoCreate
		 * @Type		enum('YES','NO')
		 * @Access	Protected
		 */
		protected $DoCreate = "YES";

		/**
		 * @Field		DoEdit
		 * @Type		enum('YES','NO')
		 * @Access	Protected
		 */
		protected $DoEdit = "YES";

		/**
		 * @Field		DoDelete
		 * @Type		enum('YES','NO')
		 * @Access	Protected
		 */
		protected $DoDelete = "YES";

		/**
		 * @Field		DoView
		 * @Type		enum('YES','NO')
		 * @Access	Protected
		 */
		protected $DoView = "YES";

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getCompanyID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CompanyID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CompanyID;
			} else {
				return $this->CompanyID;
			}
		}

		public function getUserID($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->UserID),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->UserID;
			} else {
				return stripslashes($this->UserID);
			}
		}

		public function getUserName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->UserName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->UserName;
			} else {
				return stripslashes($this->UserName);
			}
		}

		public function getModuleID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ModuleID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ModuleID;
			} else {
				return $this->ModuleID;
			}
		}

		public function getModuleName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ModuleName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ModuleName;
			} else {
				return stripslashes($this->ModuleName);
			}
		}

		public function getDoCreate($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DoCreate),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DoCreate;
			} else {
				return stripslashes($this->DoCreate);
			}
		}

		public function getDoEdit($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DoEdit),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DoEdit;
			} else {
				return stripslashes($this->DoEdit);
			}
		}

		public function getDoDelete($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DoDelete),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DoDelete;
			} else {
				return stripslashes($this->DoDelete);
			}
		}

		public function getDoView($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DoView),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DoView;
			} else {
				return stripslashes($this->DoView);
			}
		}

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setCompanyID($arg) {
			$this->CompanyID = (int)$arg;
		}

		public function setUserID($arg) {
			$this->UserID = addslashes($arg);
		}

		public function setUserName($arg) {
			$this->UserName = addslashes($arg);
		}

		public function setModuleID($arg) {
			$this->ModuleID = (int)$arg;
		}

		public function setModuleName($arg) {
			$this->ModuleName = addslashes($arg);
		}

		public function setDoCreate($arg) {
			$this->DoCreate = addslashes($arg);
		}

		public function setDoEdit($arg) {
			$this->DoEdit = addslashes($arg);
		}

		public function setDoDelete($arg) {
			$this->DoDelete = addslashes($arg);
		}

		public function setDoView($arg) {
			$this->DoView = addslashes($arg);
		}

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `asys_user_permission` (`CompanyID`, `UserID`, `ModuleID`, `DoCreate`, `DoEdit`, `DoDelete`, `DoView`) VALUES(";
			$sql	=	$sql."'".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."'".$this->getUserID('asis')."', ";
			$sql	=	$sql."'".$this->getModuleID('asis')."', ";
			$sql	=	$sql."'".$this->getDoCreate('asis')."', ";
			$sql	=	$sql."'".$this->getDoEdit('asis')."', ";
			$sql	=	$sql."'".$this->getDoDelete('asis')."', ";
			$sql	=	$sql."'".$this->getDoView('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `asys_user_permission` SET ";
			$sql	=	$sql."`DoCreate` = '".$this->getDoCreate('asis')."', ";
			$sql	=	$sql."`DoEdit` = '".$this->getDoEdit('asis')."', ";
			$sql	=	$sql."`DoDelete` = '".$this->getDoDelete('asis')."', ";
			$sql	=	$sql."`DoView` = '".$this->getDoView('asis')."' ";
			$sql	=	$sql." WHERE `CompanyID` = '".$this->getCompanyID('asis')."'";
			$sql	=	$sql." AND `UserID` = '".$this->getUserID('asis')."'";
			$sql	=	$sql." AND `ModuleID` = '".$this->getModuleID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `asys_user_permission` ";
			$sql	=	$sql." WHERE `CompanyID` = '".$this->getCompanyID('asis')."'";
			$sql	=	$sql." AND `UserID` = '".$this->getUserID('asis')."'";
			$sql	=	$sql." AND `ModuleID` = '".$this->getModuleID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$CompanyID <= 0) $chk	=	false;
			if(trim($UserID) == "") $chk	=	false;
			if((int)$ModuleID <= 0) $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">CompanyID</div>
				<div style="float:left;">: '.$this->getCompanyID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">UserID</div>
				<div style="float:left;">: '.$this->getUserID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ModuleID</div>
				<div style="float:left;">: '.$this->getModuleID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DoCreate</div>
				<div style="float:left;">: '.$this->getDoCreate('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DoEdit</div>
				<div style="float:left;">: '.$this->getDoEdit('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DoDelete</div>
				<div style="float:left;">: '.$this->getDoDelete('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DoView</div>
				<div style="float:left;">: '.$this->getDoView('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>