<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - May 14, 2015
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class asys_voucher_entry {
		/**
		 * @Field		VoucherID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $VoucherID = 0;

		/**
		 * @Field		SerialID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $SerialID = 0;

		/**
		 * @Field		CompanyID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyID = 0;

		/**
		 * @Field		CompanyName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyName = "";

		/**
		 * @Field		VoucherType
		 * @Type		tinyint(4)
		 * @Access	Protected
		 */
		protected $VoucherType = 0;

		/**
		 * @Field		FinYear
		 * @Type		varchar(5)
		 * @Access	Protected
		 */
		protected $FinYear = "";

		/**
		 * @Field		VoucherNo
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $VoucherNo = 0;

		/**
		 * @Field		DayWiseNo
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $DayWiseNo = 0;

		/**
		 * @Field		DOV
		 * @Type		date
		 * @Access	Protected
		 */
		protected $DOV = "1900-01-01";

		/**
		 * @Field		MotherAccount
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $MotherAccount = 0;
		
		/**
		 * @Field		MotherAccountName
		 * @Type		varchar(100)
		 * @Access	Private
		 */
		var $MotherAccountName = "";		

		/**
		 * @Field		AccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $AccountID = 0;

		/**
		 * @Field		AccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $AccountName = "";

		/**
		 * @Field		RelatedID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $RelatedID = 0;

		/**
		 * @Field		TxnType
		 * @Type		tinyint(4)
		 * @Access	Protected
		 */
		protected $TxnType = 0;

		/**
		 * @Field		DrCr
		 * @Type		tinyint(4)
		 * @Access	Protected
		 */
		protected $DrCr = 0;

		/**
		 * @Field		Amount
		 * @Type		decimal(10,2)
		 * @Access	Protected
		 */
		protected $Amount = 0;

		/**
		 * @Field		Narration
		 * @Type		text
		 * @Access	Protected
		 */
		protected $Narration = "";

		/**
		 * @Field		UserID
		 * @Type		varchar(60)
		 * @Access	Protected
		 */
		protected $UserID = "0";

		/**
		 * @Field		DOE
		 * @Type		date
		 * @Access	Protected
		 */
		protected $DOE = "1900-01-01";

		/**
		 * @Field		ChequeNo
		 * @Type		varchar(6)
		 * @Access	Protected
		 */
		protected $ChequeNo = "";

		/**
		 * @Field		ChqDate
		 * @Type		date
		 * @Access	Protected
		 */
		protected $ChqDate = "1900-01-01";

		/**
		 * @Field		BankName
		 * @Type		varchar(100)
		 * @Access	Protected
		 */
		protected $BankName = "";

		/**
		 * @Field		ClearedOn
		 * @Type		date
		 * @Access	Protected
		 */
		protected $ClearedOn = "1900-01-01";
		
		/**
		 * @Field		MergeIgnore
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $MergeIgnore = "NO";

		/**
		 * @Field		GroupID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $GroupID = 0;

		/**
		 * @Field		GroupName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $GroupName = "";

		/**
		 * @Field		BGID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $BGID = 0;

		/**
		 * @Field		BGName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $BGName = "";

		/**
		 * @Field		SubgroupID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $SubgroupID = 0;

		/**
		 * @Field		SubgroupName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $SubgroupName = "";

		/**
		 * @Field		GST
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $GST = "NO";

		/**
		 * @Field		HSN
		 * @Type		varchar(30)
		 * @Access	Protected
		 */
		protected $HSN = "";

		/**
		 * @Field		GSTRate
		 * @Type		decimal(4,2)
		 * @Access	Protected
		 */
		protected $GSTRate = 0;

		/**
		 * @Field		RCM
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $RCM = "NO";
		
		/**
		 * @Field		GSTBase
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $GSTBase = "NO";		
		
		/**
		 * @Field		TagList
		 * @Type		Array()
		 * @Access	Private
		 */
		var $TagList = array();
		
		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->VoucherID = (int)$this->VoucherID;
			$this->SerialID = (int)$this->SerialID;
			$this->CompanyID = (int)$this->CompanyID;
			$this->VoucherType = (int)$this->VoucherType;
			$this->FinYear = addslashes($this->FinYear);
			$this->VoucherNo = (int)$this->VoucherNo;
			$this->DayWiseNo = (int)$this->DayWiseNo;
			$this->MotherAccount = (int)$this->MotherAccount;
			$this->AccountID = (int)$this->AccountID;
			$this->RelatedID = (int)$this->RelatedID;
			$this->TxnType = (int)$this->TxnType;
			$this->DrCr = (int)$this->DrCr;
			$this->Amount = (double)$this->Amount;
			$this->Narration = addslashes($this->Narration);
			$this->UserID = addslashes($this->UserID);
			$this->ChequeNo = addslashes($this->ChequeNo);
			$this->BankName = addslashes($this->BankName);
			$this->MergeIgnore = addslashes($this->MergeIgnore);
			$this->GroupID = (int)$this->GroupID;
			$this->BGID = (int)$this->BGID;
			$this->SubgroupID = (int)$this->SubgroupID;
			$this->GST = addslashes($this->GST);
			$this->HSN = addslashes($this->HSN);
			$this->GSTRate = (double)$this->GSTRate;
			$this->RCM = addslashes($this->RCM);
			$this->GSTBase = addslashes($this->GSTBase);
		}		

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getVoucherID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->VoucherID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->VoucherID;
			} else {
				return $this->VoucherID;
			}
		}

		public function getSerialID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->SerialID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->SerialID;
			} else {
				return $this->SerialID;
			}
		}

		public function getCompanyID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CompanyID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CompanyID;
			} else {
				return $this->CompanyID;
			}
		}

		public function getCompanyName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CompanyName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CompanyName;
			} else {
				return stripslashes($this->CompanyName);
			}
		}

		public function getVoucherType($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->VoucherType,2,'.',',');
			} else if($formatted=='asis') {
				return $this->VoucherType;
			} else {
				return $this->VoucherType;
			}
		}

		public function getFinYear($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->FinYear),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->FinYear;
			} else {
				return stripslashes($this->FinYear);
			}
		}

		public function getVoucherNo($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->VoucherNo,2,'.',',');
			} else if($formatted=='asis') {
				return $this->VoucherNo;
			} else {
				return $this->VoucherNo;
			}
		}

		public function getDayWiseNo($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->DayWiseNo,2,'.',',');
			} else if($formatted=='asis') {
				return $this->DayWiseNo;
			} else {
				return $this->DayWiseNo;
			}
		}

		public function getDOV($formatted='no') {
			if($formatted == 'yes') {
				return FormatSQLDateToIndianDate($this->DOV);
			} else if($formatted=='asis') {
				return $this->DOV;
			} else {
				return stripslashes($this->DOV);
			}
		}

		public function getMotherAccount($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->MotherAccount,2,'.',',');
			} else if($formatted=='asis') {
				return $this->MotherAccount;
			} else {
				return $this->MotherAccount;
			}
		}
		
		function getMotherAccountName($formatted='no') {
			if($formatted=='yes') {
				return htmlspecialchars(stripslashes($this->MotherAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->MotherAccountName;
			} else {
				return stripslashes($this->MotherAccountName);
			}
		}		

		public function getAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->AccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->AccountID;
			} else {
				return $this->AccountID;
			}
		}

		public function getAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->AccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->AccountName;
			} else {
				return stripslashes($this->AccountName);
			}
		}

		public function getRelatedID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->RelatedID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->RelatedID;
			} else {
				return $this->RelatedID;
			}
		}

		public function getTxnType($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->TxnType,2,'.',',');
			} else if($formatted=='asis') {
				return $this->TxnType;
			} else {
				return $this->TxnType;
			}
		}

		public function getDrCr($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->DrCr,2,'.',',');
			} else if($formatted=='asis') {
				return $this->DrCr;
			} else {
				return $this->DrCr;
			}
		}

		public function getAmount($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->Amount,2,'.',',');
			} else if($formatted=='asis') {
				return $this->Amount;
			} else {
				return $this->Amount;
			}
		}

		public function getNarration($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Narration),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Narration;
			} else {
				return stripslashes($this->Narration);
			}
		}

		public function getUserID($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->UserID),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->UserID;
			} else {
				return stripslashes($this->UserID);
			}
		}

		public function getDOE($formatted='no') {
			if($formatted == 'yes') {
				return FormatSQLDateToIndianDate($this->DOE);
			} else if($formatted=='asis') {
				return $this->DOE;
			} else {
				return stripslashes($this->DOE);
			}
		}

		public function getChequeNo($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ChequeNo),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ChequeNo;
			} else {
				return stripslashes($this->ChequeNo);
			}
		}

		public function getChqDate($formatted='no') {
			if($formatted == 'yes') {
				return FormatSQLDateToIndianDate($this->ChqDate);
			} else if($formatted=='asis') {
				return $this->ChqDate;
			} else {
				return stripslashes($this->ChqDate);
			}
		}

		public function getBankName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->BankName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->BankName;
			} else {
				return stripslashes($this->BankName);
			}
		}

		public function getClearedOn($formatted='no') {
			if($formatted == 'yes') {
				return FormatSQLDateToIndianDate($this->ClearedOn);
			} else if($formatted=='asis') {
				return $this->ClearedOn;
			} else {
				return stripslashes($this->ClearedOn);
			}
		}
		
		public function getMergeIgnore($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->MergeIgnore),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->MergeIgnore;
			} else {
				return stripslashes($this->MergeIgnore);
			}
		}

		public function getGroupID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->GroupID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->GroupID;
			} else {
				return $this->GroupID;
			}
		}

		public function getGroupName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->GroupName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->GroupName;
			} else {
				return stripslashes($this->GroupName);
			}
		}

		public function getBGID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->BGID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->BGID;
			} else {
				return $this->BGID;
			}
		}

		public function getBGName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->BGName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->BGName;
			} else {
				return stripslashes($this->BGName);
			}
		}

		public function getSubgroupID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->SubgroupID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->SubgroupID;
			} else {
				return $this->SubgroupID;
			}
		}

		public function getSubgroupName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->SubgroupName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->SubgroupName;
			} else {
				return stripslashes($this->SubgroupName);
			}
		}

		public function getGST($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->GST),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->GST;
			} else {
				return stripslashes($this->GST);
			}
		}

		public function getHSN($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->HSN),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->HSN;
			} else {
				return stripslashes($this->HSN);
			}
		}

		public function getGSTRate($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->GSTRate,2,'.',',');
			} else if($formatted=='asis') {
				return $this->GSTRate;
			} else {
				return $this->GSTRate;
			}
		}

		public function getRCM($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->RCM),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->RCM;
			} else {
				return stripslashes($this->RCM);
			}
		}
		
		public function getGSTBase($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->GSTBase),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->GSTBase;
			} else {
				return stripslashes($this->GSTBase);
			}
		}		
		
		function getTagList() {
			return $this->TagList;
		}		

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setVoucherID($arg) {
			$this->VoucherID = (int)$arg;
		}

		public function setSerialID($arg) {
			$this->SerialID = (int)$arg;
		}

		public function setCompanyID($arg) {
			$this->CompanyID = (int)$arg;
		}

		public function setCompanyName($arg) {
			$this->CompanyName = addslashes($arg);
		}

		public function setVoucherType($arg) {
			$this->VoucherType = (int)$arg;
		}

		public function setFinYear($arg) {
			$this->FinYear = addslashes($arg);
		}

		public function setVoucherNo($arg) {
			$this->VoucherNo = (int)$arg;
		}

		public function setDayWiseNo($arg) {
			$this->DayWiseNo = (int)$arg;
		}

		public function setDOV($arg) {
			$this->DOV = FormatIndianDateToSQLDate($arg);
		}

		public function setMotherAccount($arg) {
			$this->MotherAccount = (int)$arg;
		}
		
		function setMotherAccountName($arg) {
			$this->MotherAccountName = addslashes($arg);
		}		

		public function setAccountID($arg) {
			$this->AccountID = (int)$arg;
		}

		public function setAccountName($arg) {
			$this->AccountName = addslashes($arg);
		}

		public function setRelatedID($arg) {
			$this->RelatedID = (int)$arg;
		}

		public function setTxnType($arg) {
			$this->TxnType = (int)$arg;
		}

		public function setDrCr($arg) {
			$this->DrCr = (int)$arg;
		}

		public function setAmount($arg) {
			$this->Amount = (double)$arg;
		}

		public function setNarration($arg) {
			$this->Narration = addslashes($arg);
		}

		public function setUserID($arg) {
			$this->UserID = addslashes($arg);
		}

		public function setDOE($arg) {
			$this->DOE = FormatIndianDateToSQLDate($arg);
		}

		public function setChequeNo($arg) {
			$this->ChequeNo = addslashes($arg);
		}

		public function setChqDate($arg) {
			$this->ChqDate = FormatIndianDateToSQLDate($arg);
		}

		public function setBankName($arg) {
			$this->BankName = addslashes($arg);
		}

		public function setClearedOn($arg) {
			$this->ClearedOn = FormatIndianDateToSQLDate($arg);
		}
		
		public function setMergeIgnore($arg) {
			$this->MergeIgnore = addslashes($arg);
		}

		public function setGroupID($arg) {
			$this->GroupID = (int)$arg;
		}

		public function setGroupName($arg) {
			$this->GroupName = addslashes($arg);
		}

		public function setBGID($arg) {
			$this->BGID = (int)$arg;
		}

		public function setBGName($arg) {
			$this->BGName = addslashes($arg);
		}

		public function setSubgroupID($arg) {
			$this->SubgroupID = (int)$arg;
		}

		public function setSubgroupName($arg) {
			$this->SubgroupName = addslashes($arg);
		}

		public function setGST($arg) {
			$this->GST = addslashes($arg);
		}

		public function setHSN($arg) {
			$this->HSN = addslashes($arg);
		}

		public function setGSTRate($arg) {
			$this->GSTRate = (double)$arg;
		}

		public function setRCM($arg) {
			$this->RCM = addslashes($arg);
		}
		
		public function setGSTBase($arg) {
			$this->GSTBase = addslashes($arg);
		}		
		
		function setTagList($arg) {
			$this->TagList = $arg;
		}		

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `asys_voucher_entry` (`VoucherID`, `SerialID`, `CompanyID`, `VoucherType`, `FinYear`, `VoucherNo`, `DayWiseNo`, `DOV`, `MotherAccount`, `AccountID`, `RelatedID`, `TxnType`, `DrCr`, `Amount`, `Narration`, `UserID`, `DOE`, `ChequeNo`, `ChqDate`, `BankName`, `ClearedOn`, `MergeIgnore`, `GroupID`, `BGID`, `SubgroupID`, `GST`, `HSN`, `GSTRate`, `RCM`, `GSTBase`) VALUES(";
			$sql	=	$sql."'".$this->getVoucherID('asis')."', ";
			$sql	=	$sql."'".$this->getSerialID('asis')."', ";
			$sql	=	$sql."'".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."'".$this->getVoucherType('asis')."', ";
			$sql	=	$sql."'".$this->getFinYear('asis')."', ";
			$sql	=	$sql."'".$this->getVoucherNo('asis')."', ";
			$sql	=	$sql."'".$this->getDayWiseNo('asis')."', ";
			$sql	=	$sql."'".$this->getDOV('asis')."', ";
			$sql	=	$sql."'".$this->getMotherAccount('asis')."', ";
			$sql	=	$sql."'".$this->getAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getRelatedID('asis')."', ";
			$sql	=	$sql."'".$this->getTxnType('asis')."', ";
			$sql	=	$sql."'".$this->getDrCr('asis')."', ";
			$sql	=	$sql."'".$this->getAmount('asis')."', ";
			$sql	=	$sql."'".$this->getNarration('asis')."', ";
			$sql	=	$sql."'".$this->getUserID('asis')."', ";
			$sql	=	$sql."'".$this->getDOE('asis')."', ";
			$sql	=	$sql."'".$this->getChequeNo('asis')."', ";
			$sql	=	$sql."'".$this->getChqDate('asis')."', ";
			$sql	=	$sql."'".$this->getBankName('asis')."', ";
			$sql	=	$sql."'".$this->getClearedOn('asis')."', ";
			$sql	=	$sql."'".$this->getMergeIgnore('asis')."', ";
			$sql	=	$sql."'".$this->getGroupID('asis')."', ";
			$sql	=	$sql."'".$this->getBGID('asis')."', ";
			$sql	=	$sql."'".$this->getSubgroupID('asis')."', ";
			$sql	=	$sql."'".$this->getGST('asis')."', ";
			$sql	=	$sql."'".$this->getHSN('asis')."', ";
			$sql	=	$sql."'".$this->getGSTRate('asis')."', ";
			$sql	=	$sql."'".$this->getRCM('asis')."', ";
			$sql	=	$sql."'".$this->getGSTBase('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `asys_voucher_entry` SET ";
			$sql	=	$sql."`CompanyID` = '".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."`VoucherType` = '".$this->getVoucherType('asis')."', ";
			$sql	=	$sql."`FinYear` = '".$this->getFinYear('asis')."', ";
			$sql	=	$sql."`VoucherNo` = '".$this->getVoucherNo('asis')."', ";
			$sql	=	$sql."`DayWiseNo` = '".$this->getDayWiseNo('asis')."', ";
			$sql	=	$sql."`DOV` = '".$this->getDOV('asis')."', ";
			$sql	=	$sql."`MotherAccount` = '".$this->getMotherAccount('asis')."', ";
			$sql	=	$sql."`AccountID` = '".$this->getAccountID('asis')."', ";
			$sql	=	$sql."`RelatedID` = '".$this->getRelatedID('asis')."', ";
			$sql	=	$sql."`TxnType` = '".$this->getTxnType('asis')."', ";
			$sql	=	$sql."`DrCr` = '".$this->getDrCr('asis')."', ";
			$sql	=	$sql."`Amount` = '".$this->getAmount('asis')."', ";
			$sql	=	$sql."`Narration` = '".$this->getNarration('asis')."', ";
			$sql	=	$sql."`UserID` = '".$this->getUserID('asis')."', ";
			$sql	=	$sql."`DOE` = '".$this->getDOE('asis')."', ";
			$sql	=	$sql."`ChequeNo` = '".$this->getChequeNo('asis')."', ";
			$sql	=	$sql."`ChqDate` = '".$this->getChqDate('asis')."', ";
			$sql	=	$sql."`BankName` = '".$this->getBankName('asis')."', ";
			$sql	=	$sql."`ClearedOn` = '".$this->getClearedOn('asis')."', ";
			$sql	=	$sql."`MergeIgnore` = '".$this->getMergeIgnore('asis')."', ";
			$sql	=	$sql."`GroupID` = '".$this->getGroupID('asis')."', ";
			$sql	=	$sql."`BGID` = '".$this->getBGID('asis')."', ";
			$sql	=	$sql."`SubgroupID` = '".$this->getSubgroupID('asis')."', ";
			$sql	=	$sql."`GST` = '".$this->getGST('asis')."', ";
			$sql	=	$sql."`HSN` = '".$this->getHSN('asis')."', ";
			$sql	=	$sql."`GSTRate` = '".$this->getGSTRate('asis')."', ";
			$sql	=	$sql."`RCM` = '".$this->getRCM('asis')."', ";
			$sql	=	$sql."`GSTBase` = '".$this->getGSTBase('asis')."' ";
			$sql	=	$sql." WHERE `VoucherID` = '".$this->getVoucherID('asis')."'";
			$sql	=	$sql." AND `SerialID` = '".$this->getSerialID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `asys_voucher_entry` ";
			$sql	=	$sql." WHERE `VoucherID` = '".$this->getVoucherID('asis')."'";
			$sql	=	$sql." AND `SerialID` = '".$this->getSerialID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$VoucherID <= 0) $chk	=	false;
			if((int)$SerialID <= 0) $chk	=	false;
			if((int)$VoucherType <= 0) $chk	=	false;
			if(trim($FinYear) == "") $chk	=	false;			

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">VoucherID</div>
				<div style="float:left;">: '.$this->getVoucherID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">SerialID</div>
				<div style="float:left;">: '.$this->getSerialID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">CompanyID</div>
				<div style="float:left;">: '.$this->getCompanyID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">VoucherType</div>
				<div style="float:left;">: '.$this->getVoucherType('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">FinYear</div>
				<div style="float:left;">: '.$this->getFinYear('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">VoucherNo</div>
				<div style="float:left;">: '.$this->getVoucherNo('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DayWiseNo</div>
				<div style="float:left;">: '.$this->getDayWiseNo('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DOV</div>
				<div style="float:left;">: '.$this->getDOV('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">MotherAccount</div>
				<div style="float:left;">: '.$this->getMotherAccount('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">AccountID</div>
				<div style="float:left;">: '.$this->getAccountID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">RelatedID</div>
				<div style="float:left;">: '.$this->getRelatedID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">TxnType</div>
				<div style="float:left;">: '.$this->getTxnType('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DrCr</div>
				<div style="float:left;">: '.$this->getDrCr('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Amount</div>
				<div style="float:left;">: '.$this->getAmount('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Narration</div>
				<div style="float:left;">: '.$this->getNarration('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">UserID</div>
				<div style="float:left;">: '.$this->getUserID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DOE</div>
				<div style="float:left;">: '.$this->getDOE('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ChequeNo</div>
				<div style="float:left;">: '.$this->getChequeNo('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ChqDate</div>
				<div style="float:left;">: '.$this->getChqDate('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">BankName</div>
				<div style="float:left;">: '.$this->getBankName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ClearedOn</div>
				<div style="float:left;">: '.$this->getClearedOn('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>