<?php

	/* Class begins here */
	class voucherdb {

		protected $host			= SS_DB_HOST;
		protected $user			= SS_DB_USER;
		protected $password	= SS_DB_PASSWORD;
		protected $dbname		= SS_DB_DBNAME;
		protected $conn			= null;

		public function __construct($dbType = '') {
			
			if (!extension_loaded('pdo')) {
				die (SS_DB_ERR_101);
			}
			
			if($dbType == "REPORT") {
				$this->user 		= SS_RPT_USER;
				$this->password	= SS_RPT_PASSWORD;
			} else if($dbType == "DATA") {
				$this->user 		= SS_DBA_USER;
				$this->password	= SS_DBA_PASSWORD;			
			}
			
			try {
				$this->conn = new PDO("mysql:host=".$this->host.";dbname=".$this->dbname, $this->user, $this->password);
				$this->conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
			} catch(PDOException $e) {
				die('DB connection error '.$e->getMessage());
			}			
				
		}
		
		public function __destruct() {
			$this->conn	= null;
		}		
		
		private function ExecuteQuery($sql00) {
		
			$res	= false;

			try {
				
				$res	= $this->conn->query($sql00);
				
			} catch(PDOException $e) {
				$err	= 'voucherdb ExecuteQuery ('.$sql00.') '.$e->getMessage();
				_errorLog($err);
			}
			
			return $res;
			
		}

		private function getRecordsetExecutingQuery($sql00) {
		
			$rows		= array();
		
			try {
				
				$result	= $this->conn->query($sql00);
				while($row = $result->fetch()) {
					$rows[]	=	$row;
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getRecordsetExecutingQuery ('.$sql00.') '.$e->getMessage();
				_errorLog($err);
			}
		
			return $rows;
			
		}
		
		private function getResultExecutingQuery($sql00) {
		
			$rows		= array();
			$res		= "";
		
			try {
				
				$result	= $this->conn->query($sql00);
				if($row = $result->fetch()) {
					$res	=	$row[0];
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getResultExecutingQuery ('.$sql00.') '.$e->getMessage();
				_errorLog($err);
			}
		
			return $res;
			
		}
		
		public function getNextID($tblName, $colName) {
			
			if(strpos($tblName, "'") !== false) return false;
			if(strpos($colName, "'") !== false) return false;
			
			if(strpos($tblName, '"') !== false) return false;
			if(strpos($colName, '"') !== false) return false;
			
			$maxid			=	1;
			$sql				=	"SELECT `MaxID` FROM `asys_tablemaxrows` WHERE `TableName`='$tblName' ORDER BY `MaxID` DESC LIMIT 1";
			$usql				= "UPDATE `asys_tablemaxrows` SET `MaxID`=`MaxID`+1 WHERE `TableName`='$tblName'";

			try {
				
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch()) {
					$maxid 	= $row[0];
					$this->conn->exec($usql);
				} else {
					$sql		= "INSERT INTO `asys_tablemaxrows` (`TableName`, `MaxID`) VALUES ('$tblName', '2');";
					$this->conn->exec($sql);
				}
					
			} catch(PDOException $e) {
				$err	= 'voucherdb getNextID '.$e->getMessage();
				_errorLog($err);
			}

			return $maxid;
			
		}
		
		function getCompanyNameByCompanyID($CompanyID) {
			$CompanyID	= (int)$CompanyID;
			$sql		=	"SELECT `CompanyName` FROM `asys_companies` WHERE `CompanyID`='$CompanyID'";
			return $this->getResultExecutingQuery($sql);
		}

		function getAccountNameByAccountID($AccountID) {
			
			$AccountID	= (int)$AccountID;
			$sql				=	"SELECT `AccountName` FROM `asys_accounts` WHERE `AccountID`='$AccountID'";
			return $this->getResultExecutingQuery($sql);
			
		}
		
		function getBaseGroupNameByBaseGroupID($BGID) {
			$BGID		= (int)$BGID;
			$sql		=	"SELECT `GroupName` FROM `asys_base_group` WHERE `BGID`='$BGID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getSubgroupNameBySubgroupID($SubgroupID) {
			$sql		=	"SELECT `SubgroupName` FROM `asys_base_subgroup` WHERE `SubgroupID`='$SubgroupID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getGroupNameByGroupID($GroupID) {
			$GroupID	= (int)$GroupID;
			$sql			=	"SELECT `GroupName` FROM `asys_groups` WHERE `GroupID`='$GroupID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getAccountDetail($AccountID) {
			$AccountID	= (int)$AccountID;
			$cclass			=	new asys_accounts();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_accounts` WHERE `AccountID`='$AccountID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_accounts');
				if($row 	= $result->fetch()) {
					$cclass	= $row;
					$cclass->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$cclass->setGroupName($this->getGroupNameByGroupID($cclass->getGroupID()));
					$cclass->setBGName($this->getBaseGroupNameByBaseGroupID($cclass->getBGID()));
					$cclass->setMotherAccountName( $this->getAccountNameByAccountID( $cclass->getMotherAccount() ) );
					$cclass->setSubgroupName( $this->getSubgroupNameBySubgroupID($cclass->getSubgroupID()));
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getAccountDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}		

		function getFinYearList() {
			$sql				=	"SELECT DISTINCT(`FinYear`) FROM `asys_voucher_entry` ORDER BY `FinYear`";
			return $this->getRecordsetExecutingQuery($sql);
		}

		function getCreditList($VoucherType, $CompanyID) {
			$CompanyID		= (int)$CompanyID;
			$VoucherType	= (int)$VoucherType;
			$sql				=	"SELECT `MotherAccount`, `ContainsSubLedger`, `AccountID`, `AccountName` FROM `asys_accounts` INNER JOIN `asys_gv_dr` ON `asys_accounts`.`BGID`=`asys_gv_dr`.`BGID` WHERE `asys_gv_dr`.`BVID`='".$VoucherType."' AND `asys_accounts`.`CompanyID`='".$CompanyID."' ORDER BY `AccountName`";
			
			$arr = array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'DrCr');
				while($row = $result->fetch()) {
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount() ) );
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getCreditList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function getDebitList($VoucherType, $CompanyID) {
			$CompanyID		= (int)$CompanyID;
			$VoucherType	= (int)$VoucherType;
			$sql					=	"SELECT `MotherAccount`, `ContainsSubLedger`, `AccountID`, `AccountName` FROM `asys_accounts` INNER JOIN `asys_gv_cr` ON `asys_accounts`.`BGID`=`asys_gv_cr`.`BGID` WHERE `asys_gv_cr`.`BVID`='".$VoucherType."' AND `asys_accounts`.`CompanyID`='".$CompanyID."' ORDER BY `AccountName`";
			
			$arr = array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'DrCr');
				while($row = $result->fetch()) {
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount() ) );
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getDebitList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function getCashList($CompanyID) {
			$CompanyID	= (int)$CompanyID;
			$sql				=	"SELECT `MotherAccount`, `ContainsSubLedger`, `AccountID`, `AccountName` FROM `asys_accounts` WHERE `BGID`='9' AND `CompanyID`='$CompanyID' ORDER BY `AccountName`";
			
			$arr = array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'DrCr');
				while($row = $result->fetch()) {
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount() ) );
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getCashList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function getBankList($CompanyID) {
			$CompanyID	= (int)$CompanyID;
			$sql				=	"SELECT `MotherAccount`, `ContainsSubLedger`, `AccountID`, `AccountName` FROM `asys_accounts` WHERE `BGID`='10' AND `CompanyID`='$CompanyID' ORDER BY `AccountName`";
			
			$arr = array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'DrCr');
				while($row = $result->fetch()) {
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getBankList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function getMaxVoucherNo($VoucherType, $FinYear, $CompanyID) {
			$CompanyID		= (int)$CompanyID;
			$VoucherType	= (int)$VoucherType;
			$FinYear			= addslashes($FinYear);
			$maxid				=	0;
			$sql					=	"SELECT MAX(`VoucherNo`) FROM `asys_voucher_entry` WHERE `VoucherType`='$VoucherType' AND `FinYear`='$FinYear' AND `CompanyID`='$CompanyID'";
			$maxid				= $this->getResultExecutingQuery($sql);
			$maxid++;
			return $maxid;
			
		}
		
		function getMaxDayWiseVoucherNo($VoucherType, $DOV, $CompanyID) {
			$CompanyID		= (int)$CompanyID;
			$VoucherType	= (int)$VoucherType;
			$DOV					= addslashes($DOV);
			$maxid				=	0;
			$sql					=	"SELECT MAX(`DayWiseNo`) FROM `asys_voucher_entry` WHERE `VoucherType`='$VoucherType' AND `DOV`='$DOV' AND `CompanyID`='$CompanyID'";
			$maxid				= $this->getResultExecutingQuery($sql);
			$maxid++;
			return $maxid;
			
		}

		function getLastDOV($AccountID) {
			
			$AccountID	= (int)$AccountID;
			$sql				=	"SELECT `DOV` FROM `asys_voucher_entry` WHERE `AccountID`='$AccountID' ORDER BY `DOV` DESC LIMIT 1";
			return $this->getResultExecutingQuery($sql);
			
		}

		function CreateTotalVoucher($vList) {

			if(count($vList) == 0)
				return -1;
				
			$veb				=	$vList[0];
			$FinYear		=	getFinancialYear($veb->getDOV());
				
			try {
			
				$this->conn->beginTransaction();
				
				$VoucherID	= $this->getNextID("asys_voucher_entry", "VoucherID");
				
				$VoucherNo	=	$this->getMaxVoucherNo($veb->getVoucherType(), $FinYear, $veb->getCompanyID());
				$DayWiseNo	= $this->getMaxDayWiseVoucherNo($veb->getVoucherType(), $veb->getDOV(), $veb->getCompanyID());
				for($i=0;$i<count($vList);$i++) {
					$veb	=	$vList[$i];
					$veb->setVoucherID($VoucherID);
					$veb->setSerialID($i+1);
					$veb->setFinYear($FinYear);
					$veb->setVoucherNo($VoucherNo);
					$veb->setDayWiseNo($DayWiseNo);
					
					$sql	= $veb->getInsertSQL();
					$this->conn->exec($sql);
					
					$tagList	= $veb->getTagList();
					for($ii=0;$ii<count($tagList);$ii++) {
						$tcls		= $tagList[$ii];
						$tcls->setTagID($this->getNextID("asys_voucher_tags", "TagID"));
						$tcls->setVoucherID($VoucherID);
						$tcls->setSerialID($ii+1);
						
						$sql	= $tcls->getInsertSQL();
						$this->conn->exec($sql);
					}
											
				}
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				$err	= 'voucherdb CreateTotalVoucher '.$er->getMessage();
				_errorLog($err);
				$this->conn->rollBack();
				$VoucherID = -1;
			}

			return $VoucherID;
		}

		function getVoucherList($VoucherID) {

			$VoucherID		= (int)$VoucherID;
						
			$sql		=	"SELECT * FROM `asys_voucher_entry` WHERE `VoucherID`='".$VoucherID."' ORDER BY `SerialID`";
			
			$arr 		= array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_voucher_entry');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setAccountName( $this->getAccountNameByAccountID($row->getAccountID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount()));
					$row->setTagList($this->getTagList($row->getCompanyID(), $row->getVoucherID(), $row->getSerialID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getVoucherList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
			
		}
		
		function getVoucherDetail($VoucherID, $AccountID) {

			$VoucherID		= (int)$VoucherID;
			$AccountID		= (int)$AccountID;
						
			$sql		=	"SELECT * FROM `asys_voucher_entry` WHERE `VoucherID`='".$VoucherID."' AND `AccountID`='$AccountID' ORDER BY `SerialID`";
			
			$cls 		= new asys_voucher_entry();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_voucher_entry');
				if($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setAccountName( $this->getAccountNameByAccountID($row->getAccountID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount()));
					$row->setTagList($this->getTagList($row->getCompanyID(), $row->getVoucherID(), $row->getSerialID()));
					$cls	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getVoucherList (line 341) '.$e->getMessage();
				_errorLog($err);
			}

			return $cls;
			
		}		
		
		function getJournalVoucherList($DateFrom, $DateTo, $CompanyID) {
			$CompanyID		= (int)$CompanyID;
			$DateFrom			= addslashes($DateFrom);
			$DateTo				= addslashes($DateTo);
						
			$sql		=	"SELECT * FROM `asys_voucher_entry` WHERE `VoucherType`='".JOURNAL_VOUCHER."'  AND `DOV`>='".$DateFrom."' AND `DOV`<='".$DateTo."' AND `CompanyID`='".$CompanyID."' ORDER BY `DOV`, `DayWiseNo`, `SerialID`";
			
			$arr 		= array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_voucher_entry');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount()));
					$row->setTagList($this->getTagList($row->getCompanyID(), $row->getVoucherID(), $row->getSerialID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getJournalVoucherList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
			
		}
		
		function getAllVoucherList($DOV, $CompanyID) {
			$CompanyID	= (int)$CompanyID;
			$DOV				= addslashes($DOV);
						
			$sql		=	"SELECT * FROM `asys_voucher_entry` WHERE `DOV`='".$DOV."' AND `CompanyID`='".$CompanyID."' ORDER BY `VoucherType`, `DayWiseNo`, `SerialID`";
			
			$arr 		= array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_voucher_entry');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount()));
					$row->setTagList($this->getTagList($row->getCompanyID(), $row->getVoucherID(), $row->getSerialID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getAllVoucherList '.$e->getMessage();
				_errorLog($err);
			}			

			return $arr;
			
		}
		
		function getJournalVoucherListConsolidated($DateFrom, $DateTo) {
		
			$DateFrom			= addslashes($DateFrom);
			$DateTo				= addslashes($DateTo);
						
			$sql		=	"SELECT `MotherAccount`, `AccountID`, `DrCr`, SUM(`Amount`) AS `Amount` FROM `asys_voucher_entry` WHERE `VoucherType`='".JOURNAL_VOUCHER."'  AND `DOV`>='".$DateFrom."' AND `DOV`<='".$DateTo."' GROUP BY `AccountID`, `DrCr`";

			$arr 		= array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_ASSOC);
				while($row = $result->fetch()) {
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getJournalVoucherListConsolidated '.$e->getMessage();
				_errorLog($err);
			}			

			return $arr;		
			
		}
		
		function getStockIssueTransferVoucherList($DateFrom, $DateTo, $AccountID) {
		
			$DateFrom			= addslashes($DateFrom);
			$DateTo				= addslashes($DateTo);
			$AccountID		= (int)$AccountID;
			
			$sql					= "SELECT `v`.* FROM `asys_voucher_entry` `v`
			INNER JOIN
			(
				SELECT * FROM `asys_voucher_entry` 
			) `v2` ON `v`.`VoucherType` = `v2`.`VoucherType` AND `v`.`FinYear`=`v2`.`FinYear` AND `v`.`VoucherID`=`v2`.`VoucherID`
			WHERE `v2`.`AccountID`='".$AccountID."' AND `v`.`DOV`>='".$DateFrom."' AND `v`.`DOV`<='".$DateTo."' AND `v`.`TxnType` IN(".ISSUE.", ".STOCK_TRANSFER.") AND `v`.`DrCr`='".DEBIT."' ORDER BY `v`.`AccountID`, `v`.`DOV`, `v`.`DayWiseNo`, `v`.`SerialID` ";
			
			$arr 		= array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_voucher_entry');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount()));
					$row->setTagList($this->getTagList($row->getCompanyID(), $row->getVoucherID(), $row->getSerialID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getStockIssueTransferVoucherList '.$e->getMessage();
				_errorLog($err);
			}			

			return $arr;		
			
		}		
		
		function getUnclearedBPVList($DateTo, $CompanyID, $AccountID) {
			$CompanyID		= (int)$CompanyID;
			$DateTo				= addslashes($DateTo);
			$AccountID		= (int)$AccountID;
						
			$sql		=	"SELECT * FROM `asys_voucher_entry` WHERE `VoucherType`='".BANK_PAYMENT_VOUCHER."'  AND `DOV`<='".$DateTo."' AND `CompanyID`='".$CompanyID."' AND `AccountID`='".$AccountID."' AND (`ClearedOn`='1900-01-01' OR `ClearedOn`>'".$DateTo."') ORDER BY `DOV`, `DayWiseNo`, `SerialID`";
			
			$arr 		= array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_voucher_entry');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount()));
					$row->setTagList($this->getTagList($row->getCompanyID(), $row->getVoucherID(), $row->getSerialID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getUnclearedBPVList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
			
		}
		
		function getUnclearedBRVList($DateTo, $CompanyID, $AccountID) {
			$CompanyID		= (int)$CompanyID;
			$DateTo				= addslashes($DateTo);
			$AccountID		= (int)$AccountID;
						
			$sql		=	"SELECT * FROM `asys_voucher_entry` WHERE `VoucherType`='".BANK_RECEIPT_VOUCHER."'  AND `DOV`<='".$DateTo."' AND `CompanyID`='".$CompanyID."' AND `AccountID`='".$AccountID."' AND (`ClearedOn`='1900-01-01' OR `ClearedOn`>'".$DateTo."') ORDER BY `DOV`, `DayWiseNo`, `SerialID`";
			
			$arr 		= array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_voucher_entry');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount()));
					$row->setTagList($this->getTagList($row->getCompanyID(), $row->getVoucherID(), $row->getSerialID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getUnclearedBRVList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
			
		}

		function getNumberOfVoucher($VoucherType, $DateFrom, $DateTo, $AccountID, $CompanyID) {
		
			$VoucherType	= (int)$VoucherType;
			$DateFrom			= addslashes($DateFrom);
			$DateTo				= addslashes($DateTo);
			$AccountID		= (int)$AccountID;
			$CompanyID		= (int)$CompanyID;
		
			$nov		=	0;
			$sql		=	"SELECT COUNT(*) FROM `asys_voucher_entry` WHERE `VoucherType`='$VoucherType' AND `CompanyID`='$CompanyID' AND `TxnType`='0'";
			if($DateFrom != "1900-01-01")
				$sql	=	$sql." AND `DOV`>='$DateFrom'";
			if($DateTo != "1900-01-01")
				$sql	=	$sql." AND `DOV`<='$DateTo'";
			if($AccountID != 0)
				$sql	=	$sql." AND `AccountID`='$AccountID'";
			
			try {
				
				$result		= $this->conn->query($sql);
				if($row = $result->fetch()) {
					$nov	= $row[0];
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getNumberOfVoucher '.$e->getMessage();
				_errorLog($err);
			}

			return $nov;
		}

		function getVoucherListPaged($VoucherType, $DateFrom, $DateTo, $AccountID, $CompanyID, $sRec, $nRec) {
		
			$VoucherType	= (int)$VoucherType;
			$DateFrom			= addslashes($DateFrom);
			$DateTo				= addslashes($DateTo);
			$AccountID		= (int)$AccountID;
			$CompanyID		= (int)$CompanyID;
			$sRec					= (int)$sRec;
			$nRec					= (int)$nRec;
		
			$vList	= array();
			$sql		=	"SELECT * FROM `asys_voucher_entry` WHERE `VoucherType`='$VoucherType' AND `CompanyID`='$CompanyID' AND `TxnType`='0'";
			if($DateFrom != "1900-01-01")
				$sql	=	$sql." AND `DOV`>='$DateFrom'";
			if($DateTo != "1900-01-01")
				$sql	=	$sql." AND `DOV`<='$DateTo'";
			if($AccountID != 0)
				$sql	=	$sql." AND `AccountID`='$AccountID'";
			$sql	=	$sql." ORDER BY `DOV` DESC, `DayWiseNo` DESC, `SerialID` LIMIT $sRec, $nRec";
			
			$arr 		= array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_voucher_entry');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount()));
					$row->setTagList($this->getTagList($row->getCompanyID(), $row->getVoucherID(), $row->getSerialID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getVoucherListPaged '.$e->getMessage();
				_errorLog($err);
			}			

			return $arr;
		}

		function deleteVoucher($VoucherID) {
			$VoucherID	= (int)$VoucherID;
			$ret		= false;
		
			try {
			
				$this->conn->beginTransaction();
				
				$sql	=	"DELETE FROM `asys_voucher_entry` WHERE `VoucherID`='$VoucherID'";
				$ret		= $this->conn->query($sql);
				
				$sql	=	"DELETE FROM `asys_voucher_tags` WHERE `VoucherID`='$VoucherID'";
				$ret		= $this->conn->query($sql);
				
				$this->conn->commit();
				
			} catch(PDOException $e) {
				$this->conn->rollBack();
				$err	= 'voucherdb deleteVoucher '.$e->getMessage();
				_errorLog($err);
			}
		
			return $ret;
			
		}
		
		function getVoucherDate($VoucherID) {
			$VoucherID	= (int)$VoucherID;
			$sql				= "SELECT `DOV` FROM `asys_voucher_entry` WHERE `VoucherID`='$VoucherID' AND `SerialID`='1'";
			return $this->getResultExecutingQuery($sql);
		}

		function UpdateTotalVoucher($vList, $oldDate) {
		
			if(count($vList) == 0)
				return -1;
			$veb				=	$vList[0];
			$prevFY			=	$veb->getFinYear();
			$FinYear		=	getFinancialYear($veb->getDOV());
			if($prevFY != $FinYear)
				return -2;
			$VoucherNo	= $veb->getVoucherNo();
			$DayWiseNo	= 0;
			if($veb->getDOV() == $oldDate)
				$DayWiseNo	= $veb->getDayWiseNo();
			else
				$DayWiseNo	= $this->getMaxDayWiseVoucherNo($veb->getVoucherType(), $veb->getDOV(), $veb->getCompanyID());
			
			$VoucherID		= 0;
				
			try {
			
				$this->conn->beginTransaction();
				
				if($this->getVoucherDate($veb->getVoucherID()) != $veb->getDOV()) {
					$VoucherNo	=	$this->getMaxVoucherNo($veb->getVoucherType(), $FinYear, $veb->getCompanyID());
					$DayWiseNo	= $this->getMaxDayWiseVoucherNo($veb->getVoucherType(), $veb->getDOV(), $veb->getCompanyID());
				}				
				
				$sql	=	"DELETE FROM `asys_voucher_entry` WHERE `VoucherID`='".$veb->getVoucherID()."'";
				$this->conn->exec($sql);
				
				$VoucherID	=	$this->getNextID("asys_voucher_entry", "VoucherID");
				
				for($i=0;$i<count($vList);$i++) {
					$veb	=	$vList[$i];
					$veb->setVoucherID($VoucherID);
					$veb->setSerialID($i+1);
					$veb->setVoucherNo($VoucherNo);
					$veb->setDayWiseNo($DayWiseNo);
					
					$sql	= $veb->getInsertSQL();
					$this->conn->exec($sql);
					
					$tagList	= $veb->getTagList();
					for($ii=0;$ii<count($tagList);$ii++) {
						$tcls		= $tagList[$ii];
						$tcls->setTagID($this->getNextID("asys_voucher_tags", "TagID"));
						$tcls->setVoucherID($VoucherID);
						$tcls->setSerialID($ii+1);
						
						$sql	= $tcls->getInsertSQL();
						$this->conn->exec($sql);
					}					
				}
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				$err	= 'voucherdb UpdateTotalVoucher '.$er->getMessage();
				_errorLog($err);
				$this->conn->rollBack();
				$VoucherID = -1;
			}
				

			return $VoucherID;
			
		}
		
		function updateClearingDate($VoucherID, $SerialID, $ClearedOn) {
			$VoucherID	= (int)$VoucherID;
			$SerialID		= (int)$SerialID;
			$ClearedOn	= addslashes($ClearedOn);
			$fid				= 1;
			
				
			try {
			
				$this->conn->beginTransaction();
				
				$sql		= "SELECT `VoucherType` FROM `asys_voucher_entry` WHERE `VoucherID`='".$VoucherID."'";
				$vtype	= $this->getResultExecutingQuery($sql);
				
				$sql		= "UPDATE `asys_voucher_entry` SET";
				$sql		= $sql." `ClearedOn`='".$ClearedOn."' ";
				$sql		= $sql." WHERE";
				$sql		= $sql." `VoucherID`='".$VoucherID."' AND `SerialID`='".$SerialID."' LIMIT 1";
				$this->conn->exec($sql);
				
				if($vtype == BANK_PAYMENT_VOUCHER) {
					$sql		= "UPDATE `asys_voucher_entry` SET";
					$sql		= $sql." `ClearedOn`='".$ClearedOn."' ";
					$sql		= $sql." WHERE";
					$sql		= $sql." `VoucherID`='".$VoucherID."' AND `DrCr`='".CREDIT."' LIMIT 1";
					$this->conn->exec($sql);
				}
				
				if($vtype == BANK_RECEIPT_VOUCHER) {
					$sql		= "UPDATE `asys_voucher_entry` SET";
					$sql		= $sql." `ClearedOn`='".$ClearedOn."' ";
					$sql		= $sql." WHERE";
					$sql		= $sql." `VoucherID`='".$VoucherID."' AND `DrCr`='".DEBIT."' LIMIT 1";
					$this->conn->exec($sql);
				}
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				$err	= 'voucherdb updateClearingDate '.$er->getMessage();
				_errorLog($err);
				$this->conn->rollBack();
				$fid	= -1;
				
			}
				

			return $fid;
		}

		function getAccountVoucher($AccountID, $fdate, $tdate) {
		
			$AccountID		= (int)$AccountID;
			$fdate				= addslashes($fdate);
			$tdate				= addslashes($tdate);
			
			if($fdate == '')
				$fdate	=	'2000-01-01';
			if($tdate == '')
				$tdate	=	'3000-01-01';

			$sql		=	"SELECT * FROM `asys_voucher_entry` WHERE `AccountID`='$AccountID' AND `DOV`>='$fdate' AND `DOV`<='$tdate' ORDER BY `DOV`, `VoucherType`, `DayWiseNo`";
			
			$arr 		= array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_voucher_entry');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount()));
					$row->setTagList($this->getTagList($row->getCompanyID(), $row->getVoucherID(), $row->getSerialID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getAccountVoucher '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;

		}
		
		function getConsolidatedAccountVoucher($AccountID, $fdate, $tdate) {
		
			$AccountID		= (int)$AccountID;
			$fdate				= addslashes($fdate);
			$tdate				= addslashes($tdate);
			
			if($fdate == '')
				$fdate	=	'2000-01-01';
			if($tdate == '')
				$tdate	=	'3000-01-01';

			$sql		=	"SELECT SUM(`Amount`) AS `Amount`, `DOV`, `TxnType`, `DrCr`, `VoucherType`, `ChequeNo` FROM `asys_voucher_entry` WHERE `AccountID`='$AccountID' AND `DOV`>='$fdate' AND `DOV`<='$tdate' GROUP BY `DOV`, `DrCr`, `TxnType`, `VoucherType` ORDER BY `DOV`, `VoucherType`";
			
			$arr 		= array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_ASSOC);
				while($row = $result->fetch()) {
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getConsolidatedAccountVoucher '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;

		}
		
		function getConsolidatedAccountVoucher2($AccountID, $fdate, $tdate) {
		
			$AccountID		= (int)$AccountID;
			$fdate				= addslashes($fdate);
			$tdate				= addslashes($tdate);
			
			if($fdate == '')
				$fdate	=	'2000-01-01';
			if($tdate == '')
				$tdate	=	'3000-01-01';

			$sql		=	"SELECT SUM(`Amount`) AS `Amount`, `DOV`, `TxnType`, `DrCr`, `VoucherType`, `ChequeNo` FROM `asys_voucher_entry` WHERE `AccountID`='$AccountID' AND `DOV`>='$fdate' AND `DOV`<='$tdate' GROUP BY `DrCr`, `TxnType`, `VoucherType` ORDER BY `DOV`, `VoucherType`";
			
			$arr 		= array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_ASSOC);
				while($row = $result->fetch()) {
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getConsolidatedAccountVoucher2 '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;

		}		
		
		function getAccountVoucherTransactionWise($AccountID, $TxnType, $fdate, $tdate) {
		
			$AccountID		= (int)$AccountID;
			$TxnType			= (int)$TxnType;
			$fdate				= addslashes($fdate);
			$tdate				= addslashes($tdate);		
			
			if($fdate == '')
				$fdate	=	'2000-01-01';
			if($tdate == '')
				$tdate	=	'3000-01-01';

			$sql		=	"SELECT * FROM `asys_voucher_entry` WHERE `AccountID`='$AccountID' AND `TxnType`='$TxnType' AND `DOV`>='$fdate' AND `DOV`<='$tdate' ORDER BY `DOV`, `VoucherType`, `DayWiseNo`";
			
			$arr 		= array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_voucher_entry');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount()));
					$row->setTagList($this->getTagList($row->getCompanyID(), $row->getVoucherID(), $row->getSerialID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getAccountVoucherTransactionWise '.$e->getMessage();
				_errorLog($err);
			}			

			return $arr;			

		}
		
		function getAccountVoucherTypeWise($AccountID, $VoucherType, $fdate, $tdate) {
		
			$AccountID		= (int)$AccountID;
			$VoucherType	= (int)$VoucherType;
			$fdate				= addslashes($fdate);
			$tdate				= addslashes($tdate);		
			
			if($fdate == '')
				$fdate	=	'2000-01-01';
			if($tdate == '')
				$tdate	=	'3000-01-01';

			$sql		=	"SELECT * FROM `asys_voucher_entry` WHERE `AccountID`='$AccountID' AND `VoucherType`='$VoucherType' AND `DOV`>='$fdate' AND `DOV`<='$tdate' AND `TxnType`='0' ORDER BY `DOV`, `VoucherType`, `DayWiseNo`";
			
			$arr 		= array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_voucher_entry');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount()));
					$row->setTagList($this->getTagList($row->getCompanyID(), $row->getVoucherID(), $row->getSerialID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getAccountVoucherTypeWise '.$e->getMessage();
				_errorLog($err);
			}			

			return $arr;			

		}		

		function getALLAccountVoucher($AccountID) {
		
			$AccountID		= (int)$AccountID;
			
			$sql		=	"SELECT * FROM `asys_voucher_entry` WHERE `AccountID`='$AccountID' ORDER BY `DOV`,`VoucherType`,`VoucherID`";
			
			$arr 		= array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_voucher_entry');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount()));
					$row->setTagList($this->getTagList($row->getCompanyID(), $row->getVoucherID(), $row->getSerialID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getALLAccountVoucher '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function getOppositeVoucher($VoucherID, $AccountID) {

			$VoucherID		= (int)$VoucherID;
			$AccountID		= (int)$AccountID;

			$sql		=	"SELECT * FROM `asys_voucher_entry` WHERE `VoucherID`='$VoucherID' AND `AccountID`!='$AccountID'";
			
			$arr 		= array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_voucher_entry');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount()));
					$row->setTagList($this->getTagList($row->getCompanyID(), $row->getVoucherID(), $row->getSerialID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getOppositeVoucher '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getBGWiseAmount($CompanyID, $BGID, $DOV1, $DOV2) {
			$CompanyID	= (int)$CompanyID;
			$BGID				= (int)$BGID;
			$DOV1				= addslashes($DOV1);
			$DOV2				= addslashes($DOV2);
			
			$sql	= "SELECT SUM(`asys_voucher_entry`.`Amount`) FROM `asys_voucher_entry` INNER JOIN `asys_accounts` ON `asys_voucher_entry`.`AccountID`=`asys_accounts`.`AccountID` WHERE `asys_voucher_entry`.`CompanyID`='$CompanyID' AND `asys_accounts`.`BGID`='$BGID' AND `asys_voucher_entry`.`DOV`>='$DOV1' AND `asys_voucher_entry`.`DOV`<='$DOV2'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getAccountWiseAmount($AccountID, $DOV1, $DOV2) {
			$AccountID	= (int)$AccountID;
			$DOV1				= addslashes($DOV1);
			$DOV2				= addslashes($DOV2);
			
			$sql	= "SELECT SUM(`asys_voucher_entry`.`Amount`) FROM `asys_voucher_entry` WHERE `asys_voucher_entry`.`AccountID`='$AccountID' AND `asys_voucher_entry`.`DOV`>='$DOV1' AND `asys_voucher_entry`.`DOV`<='$DOV2'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getMonthlyInFlow($CompanyID, $DOV1, $DOV2) {
			$CompanyID	= (int)$CompanyID;
			$DOV1				= addslashes($DOV1);
			$DOV2				= addslashes($DOV2);
			
			$sql	= "SELECT SUM(`asys_voucher_entry`.`Amount`) FROM `asys_voucher_entry` WHERE `asys_voucher_entry`.`CompanyID`='".$CompanyID."' AND `asys_voucher_entry`.`DrCr`='".DEBIT."' AND `asys_voucher_entry`.`DOV`>='".$DOV1."' AND `asys_voucher_entry`.`DOV`<='".$DOV2."' AND (`VoucherType`='".CASH_RECEIPT_VOUCHER."' OR `VoucherType`='".BANK_RECEIPT_VOUCHER."')";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getMonthlyOutFlow($CompanyID, $DOV1, $DOV2) {
			$CompanyID	= (int)$CompanyID;
			$DOV1				= addslashes($DOV1);
			$DOV2				= addslashes($DOV2);
			
			$sql	= "SELECT SUM(`asys_voucher_entry`.`Amount`) FROM `asys_voucher_entry` WHERE `asys_voucher_entry`.`CompanyID`='".$CompanyID."' AND `asys_voucher_entry`.`DrCr`='".DEBIT."' AND `asys_voucher_entry`.`DOV`>='".$DOV1."' AND `asys_voucher_entry`.`DOV`<='".$DOV2."' AND (`VoucherType`='".CASH_PAYMENT_VOUCHER."' OR `VoucherType`='".BANK_PAYMENT_VOUCHER."')";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getDistinctInFlowGroup($CompanyID, $DOV1, $DOV2) {
			$CompanyID	= (int)$CompanyID;
			$DOV1				= addslashes($DOV1);
			$DOV2				= addslashes($DOV2);
					
			$sql				=	"SELECT DISTINCT(`BGID`) FROM `asys_accounts` INNER JOIN `asys_voucher_entry` ON `asys_accounts`.`AccountID`=`asys_voucher_entry`.`AccountID`  WHERE `asys_voucher_entry`.`CompanyID`='".$CompanyID."' AND `asys_voucher_entry`.`DrCr`='".CREDIT."' AND `asys_voucher_entry`.`DOV`>='".$DOV1."' AND `asys_voucher_entry`.`DOV`<='".$DOV2."' AND (`VoucherType`='".CASH_RECEIPT_VOUCHER."' OR `VoucherType`='".BANK_RECEIPT_VOUCHER."')";
			return $this->getRecordsetExecutingQuery($sql);
		}
		
		function getDistinctOutFlowGroup($CompanyID, $DOV1, $DOV2) {
			$CompanyID	= (int)$CompanyID;
			$DOV1				= addslashes($DOV1);
			$DOV2				= addslashes($DOV2);
					
			$sql				=	"SELECT DISTINCT(`BGID`) FROM `asys_accounts` INNER JOIN `asys_voucher_entry` ON `asys_accounts`.`AccountID`=`asys_voucher_entry`.`AccountID`  WHERE `asys_voucher_entry`.`CompanyID`='".$CompanyID."' AND `asys_voucher_entry`.`DrCr`='".DEBIT."' AND `asys_voucher_entry`.`DOV`>='".$DOV1."' AND `asys_voucher_entry`.`DOV`<='".$DOV2."' AND (`VoucherType`='".CASH_PAYMENT_VOUCHER."' OR `VoucherType`='".BANK_PAYMENT_VOUCHER."')";
			return $this->getRecordsetExecutingQuery($sql);
		}
		
		function getGroupWiseMonthlyInFlow($CompanyID, $DOV1, $DOV2, $BGID) {
			$CompanyID	= (int)$CompanyID;
			$DOV1				= addslashes($DOV1);
			$DOV2				= addslashes($DOV2);
			$BGID				= (int)$BGID;
			
			$sql	= "SELECT SUM(`asys_voucher_entry`.`Amount`) FROM `asys_voucher_entry` INNER JOIN `asys_accounts` ON `asys_voucher_entry`.`AccountID`=`asys_accounts`.`AccountID` WHERE `asys_voucher_entry`.`CompanyID`='".$CompanyID."' AND `asys_accounts`.`BGID`='".$BGID."' AND `asys_voucher_entry`.`DOV`>='".$DOV1."' AND `asys_voucher_entry`.`DOV`<='".$DOV2."' AND (`VoucherType`='".CASH_RECEIPT_VOUCHER."' OR `VoucherType`='".BANK_RECEIPT_VOUCHER."')";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getGroupWiseMonthlyOutFlow($CompanyID, $DOV1, $DOV2, $BGID) {
			$CompanyID	= (int)$CompanyID;
			$DOV1				= addslashes($DOV1);
			$DOV2				= addslashes($DOV2);
			$BGID				= (int)$BGID;
			
			$sql	= "SELECT SUM(`asys_voucher_entry`.`Amount`) FROM `asys_voucher_entry` INNER JOIN `asys_accounts` ON `asys_voucher_entry`.`AccountID`=`asys_accounts`.`AccountID` WHERE `asys_voucher_entry`.`CompanyID`='".$CompanyID."' AND `asys_accounts`.`BGID`='".$BGID."' AND `asys_voucher_entry`.`DOV`>='".$DOV1."' AND `asys_voucher_entry`.`DOV`<='".$DOV2."' AND (`VoucherType`='".CASH_PAYMENT_VOUCHER."' OR `VoucherType`='".BANK_PAYMENT_VOUCHER."')";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getDayWiseNoByVoucherID($VoucherID){
			$VoucherID	= (int)$VoucherID;
		
			$sql				= "SELECT `DayWiseNo` FROM `asys_voucher_entry` WHERE `VoucherID`='$VoucherID' ";
			return $this->getResultExecutingQuery($sql);
		
		}		
		
		

		/*---------------------------------------------------------*/
		/*********************** TAG METHODS ***********************/

		function getTagDetail($TagID) {
			$TagID			= (int)$TagID;
			$cclass			=	new asys_voucher_tags();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_voucher_tags` WHERE `TagID`='$TagID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_voucher_tags');
				if($row 	= $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));
					$cclass	= $row;
				}

			} catch(PDOException $e) {
				$err	= 'voucherdb getTagDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getTagList($CompanyID, $VoucherID, $SerialID) {
			$CompanyID	= (int)$CompanyID;
			$VoucherID	= (int)$VoucherID;
			$SerialID		= (int)$SerialID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_voucher_tags` WHERE `CompanyID`='$CompanyID' AND `VoucherID`='$VoucherID' AND `SerialID`='$SerialID' ORDER BY `TagID`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_voucher_tags');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getTagList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getModuleWiseTagList($CompanyID, $ModuleID, $RelatedID = 0, $AccountID = 0) {
			$CompanyID	= (int)$CompanyID;
			$ModuleID		= (int)$ModuleID;
			$RelatedID	= (int)$RelatedID;
			$AccountID		= (int)$AccountID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_voucher_tags` WHERE `CompanyID`='$CompanyID' AND `ModuleID`='$ModuleID' AND `AccountID`='$AccountID'";
				if($RelatedID != 0)
					$sql		=	$sql." AND `RelatedID`='$RelatedID'";
				if($AccountID != 0)
					$sql		=	$sql." AND `AccountID`='$AccountID'";

				$sql			=	$sql." ORDER BY `TagID`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_voucher_tags');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getModuleWiseTagList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getModuleWiseVoucherTypeWiseTagList($CompanyID, $ModuleID, $RelatedID = 0, $VoucherType, $AccountID) {
			$CompanyID		= (int)$CompanyID;
			$ModuleID			= (int)$ModuleID;
			$RelatedID		= (int)$RelatedID;
			$VoucherType	= (int)$VoucherType;
			$AccountID		= (int)$AccountID;
			$arr					=	array();
			
			try {
				
				if($RelatedID != 0)
					$sql			=	"SELECT `asys_voucher_tags`.* FROM `asys_voucher_tags` INNER JOIN `asys_voucher_entry` `a1` ON `asys_voucher_tags`.`VoucherID`=`a1`.`VoucherID` WHERE `asys_voucher_tags`.`CompanyID`='$CompanyID' AND `asys_voucher_tags`.`ModuleID`='$ModuleID' AND `asys_voucher_tags`.`RelatedID`='$RelatedID' AND `asys_voucher_tags`.`AccountID`='$AccountID' AND `a1`.`VoucherType`='$VoucherType' GROUP BY `TagID` ORDER BY `TagID`";
				else
					$sql			=	"SELECT `asys_voucher_tags`.* FROM `asys_voucher_tags` INNER JOIN `asys_voucher_entry` `a1` ON `asys_voucher_tags`.`VoucherID`=`a1`.`VoucherID` WHERE `asys_voucher_tags`.`CompanyID`='$CompanyID' AND `asys_voucher_tags`.`ModuleID`='$ModuleID' AND `asys_voucher_tags`.`AccountID`='$AccountID' AND `a1`.`VoucherType`='$VoucherType' GROUP BY `TagID` ORDER BY `TagID`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_voucher_tags');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getModuleWiseVoucherTypeWiseTagList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}		
		
		function getAccountWiseTagList($CompanyID, $AccountID) {
			$CompanyID	= (int)$CompanyID;
			$AccountID	= (int)$AccountID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_voucher_tags` WHERE `CompanyID`='$CompanyID' AND `AccountID`='$AccountID' ORDER BY `ModuleID`, `RelatedID`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_voucher_tags');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getAccountWiseTagList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}		
		
		function getTagListJSON(){
		
			$sql		= "SELECT `TagID`, `TagName` FROM `asys_voucher_tags` ORDER BY `TagName`";
			return $this->getRecordsetExecutingQuery($sql);
		
		}

		function deleteTag($lcls) {
		
			$pkey				= $lcls->getTagID();
			$ret				= false;
		
			try {
				
				$sql		= $lcls->getDeleteSQL();
				$ret		= $this->conn->query($sql);
				
			} catch(PDOException $e) {
				$err	= 'voucherdb deleteTag '.$e->getMessage();
				_errorLog($err);
			}			
		
			return $ret;
		}
		
		function deleteAllVoucherTag($CompanyID, $VoucherID) {
			$CompanyID	= (int)$CompanyID;
			$VoucherID	= (int)$VoucherID;
			$ret				= false;
		
			try {

				$sql	=	"DELETE FROM `asys_voucher_tags` WHERE `CompanyID`='$CompanyID' AND `VoucherID`='".$VoucherID."'";
				$ret	= $this->conn->exec($sql);
				
			} catch(PDOException $e) {
				$err	= 'voucherdb deleteAllVoucherTag '.$e->getMessage();
				_errorLog($err);
			}
		
			return $ret;
		}
		
		
		
		/*-------------------------------------------------------------*/
		/*********************** GENERAL METHODS ***********************/
				
		function getTotalAmountByMuduleBill($CompanyID, $ModuleID, $RelatedID) {
			
			$CompanyID	= (int)$CompanyID;
			$ModuleID		= (int)$ModuleID;
			$RelatedID	= (int)$RelatedID;
			$sql				=	"SELECT SUM(`AdjustedAmount`) FROM `asys_voucher_tags` WHERE `CompanyID`='$CompanyID' AND `ModuleID`='$ModuleID' AND `RelatedID`='$RelatedID'";
			return $this->getResultExecutingQuery($sql);
			
		}
		
		function updateGroupSubgroup() {
			try {
			
				$this->conn->beginTransaction();
				
				$sql	= "
					UPDATE `asys_voucher_entry` `a`
					INNER JOIN `asys_accounts` `b`
					ON `a`.`AccountID`=`b`.`AccountID`
					SET
					`a`.`MotherAccount`=`b`.`MotherAccount`,
					`a`.`GroupID`=`b`.`GroupID`,
					`a`.`BGID`=`b`.`BGID`,
					`a`.`SubgroupID`=`b`.`SubgroupID`	
					WHERE 
					(`a`.`GroupID`!=`b`.`GroupID` OR `a`.`BGID`!=`b`.`BGID` OR `a`.`SubgroupID`!=`b`.`SubgroupID` OR `a`.`MotherAccount`!=`b`.`MotherAccount`)			
				";
				
				$this->conn->exec($sql);				
				
				$sql	= "
					UPDATE `asys_opening_balances` `a`
					INNER JOIN `asys_accounts` `b`
					ON `a`.`AccountID`=`b`.`AccountID`
					SET
					`a`.`MotherAccount`=`b`.`MotherAccount`,
					`a`.`GroupID`=`b`.`GroupID`,
					`a`.`BGID`=`b`.`BGID`,
					`a`.`SubgroupID`=`b`.`SubgroupID`	
					WHERE 
					(`a`.`GroupID`!=`b`.`GroupID` OR `a`.`BGID`!=`b`.`BGID` OR `a`.`SubgroupID`!=`b`.`SubgroupID` OR `a`.`MotherAccount`!=`b`.`MotherAccount`)
				";
				
				$this->conn->exec($sql);				
				
				$this->conn->commit();
				
			} catch(Exception $er) {
				$err	= 'voucherdb updateGroupSubgroup '.$er->getMessage();
				_errorLog($err);
				$this->conn->rollBack();
			}							
		}
		
		function getAccountList($CompanyID) {
			$CompanyID	= (int)$CompanyID;
			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_accounts` WHERE `CompanyID`='$CompanyID' AND `ContainsSubLedger`='NO' ORDER BY `AccountName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_accounts');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setGroupName($this->getGroupNameByGroupID($row->getGroupID()));
					$row->setBGName($this->getBaseGroupNameByBaseGroupID($row->getBGID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount() ) );
					$row->setSubgroupName( $this->getSubgroupNameBySubgroupID($row->getSubgroupID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getAccountList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getClosingBalanceByAccountID($accid, $fdate, $IncludeDate = 'NO') {
			$accid			= (int)$accid;
			$fdate			= addslashes($fdate);
			$IncludeDate= addslashes($IncludeDate);
			if($fdate == "")
				$fdate 		= "3000-01-01";
			$cbal				= 0;
			$obal				= 0;
			$obaltype		= 0;		/* 1-Cr 2-Db */
			$cbaltype		= 0;
			$retCBal		= array();
			$debitAmt		= 0;
			$creditAmt	= 0;
			$fy					= getFinancialYear(getPreviousDate($fdate));
			$fromdt			= getFirstFinancialDate(getPreviousDate($fdate));
			$todt				= getPreviousDate($fdate);
			if(	$IncludeDate == "YES") $todt = $fdate;
			
			try {
				
				$sql			=	"SELECT `OBal`, `OBalType` FROM `asys_opening_balances` WHERE `FinYear`='$fy' AND `AccountID`='$accid'";
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch()) {
				
					$obal			= $row[0];
					$obaltype	= $row[1];
					
					$sql1	= "SELECT SUM(`Amount`) FROM `asys_voucher_entry` WHERE `AccountID`=".$accid." AND `DrCr`='".CREDIT."' AND `DOV`>='".$fromdt."' AND `DOV`<'".$todt."'";
					$sql2 = "SELECT SUM(`Amount`) FROM `asys_voucher_entry` WHERE `AccountID`=".$accid." AND `DrCr`='".DEBIT."' AND `DOV`>='".$fromdt."' AND `DOV`<'".$todt."'";

					$result		= $this->conn->query($sql1);
					if( $row 	= $result->fetch() )
						$creditAmt	= $row[0];
					$result		= $this->conn->query($sql2);
					if( $row 	= $result->fetch() )
						$debitAmt	= $row[0];					
				
				} else {
				
					$sql			= "SELECT `OBal`,`OBalType` FROM `asys_accounts` WHERE `AccountID`=".$accid;
					$result		= $this->conn->query($sql);
					if($row 	= $result->fetch()) {
						$obal			= $row[0];
						$obaltype	= $row[1];
					}
				
					$sql1	= "SELECT SUM(`Amount`) FROM `asys_voucher_entry` WHERE `AccountID`=".$accid." AND `DrCr`='".CREDIT."' AND `DOV`<'".$todt."'";
					$sql2 = "SELECT SUM(`Amount`) FROM `asys_voucher_entry` WHERE `AccountID`=".$accid." AND `DrCr`='".DEBIT."' AND `DOV`<'".$todt."'";
				
					$result		= $this->conn->query($sql1);
					if( $row 	= $result->fetch() )
						$creditAmt	= $row[0];
					$result		= $this->conn->query($sql2);
					if( $row 	= $result->fetch() )
						$debitAmt	= $row[0];
						
				}
				
				if($obaltype == 0) $obaltype = CREDIT;
					
				if($obaltype == CREDIT) {
					$cbal 		= bcadd($obal, $creditAmt,2);
					$cbal			= bcsub($cbal, $debitAmt, 2);
					$cbaltype	= $obaltype;
					if($cbal < 0) {
						$cbaltype 	= DEBIT;
						$cbal 			= -$cbal;
					}
				} else {
					$cbal 		= bcadd($obal, $debitAmt,2);
					$cbal			= bcsub($cbal, $creditAmt, 2);
					$cbaltype	= $obaltype;
					if($cbal < 0) {
						$cbaltype 	= CREDIT;
						$cbal				= - $cbal;
					}
				}
				$retCBal[0]	= $cbal;
				$retCBal[1]	= $cbaltype;
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getClosingBalanceByAccountID '.$e->getMessage();
				_errorLog($err);
			}

			return $retCBal;
		}
		
		function getClosingBalanceByAccountIDCached($accid, $fdate) {
			$accid			= (int)$accid;
			$fdate			= addslashes($fdate);
			$cbal				= 0;
			$cbaltype		= 0;
			$retCBal		= array();

			try {
				
				$sql	= "SELECT `CBal`, `CBalType` FROM `asys_closing_balances` WHERE `ClosingDate`='".$fdate."' AND `AccountID`='".$accid."'";
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch()) {
				
					$cbal			= $row[0];
					$cbaltype	= $row[1];					
				
				}

				$retCBal[0]	= $cbal;
				$retCBal[1]	= $cbaltype;
				
			} catch(PDOException $e) {
				$err	= 'masterdb getClosingBalanceByAccountIDCached '.$e->getMessage();
				_errorLog($err);
			}

			return $retCBal;
		}
		
		function getClosingBalanceByMotherAccountCached($accid, $fdate) {
			$accid			= (int)$accid;
			$fdate			= addslashes($fdate);
			$cbal				= 0;
			$cbaltype		= 0;
			$retCBal		= array();
			$debitAmt		= 0;
			$creditAmt	= 0;

			try {
				
				$sql	= "SELECT SUM(`CBal`), `CBalType` FROM `asys_closing_balances` WHERE `ClosingDate`='".$fdate."' AND `MotherAccountID`='".$accid."' GROUP BY `CBalType`";
				$result		= $this->conn->query($sql);
				while($row 	= $result->fetch()) {
				
					if($row[1] == DEBIT)
						$debitAmt	= $row[0];
					else
						$creditAmt = $row[0];					
				
				}
				
				$cbal				= bcsub($creditAmt, $debitAmt, 2);
				$cbaltype		= CREDIT;
				if($cbal < 0) {
					$cbaltype = DEBIT;
					$cbal 		= -$cbal;				
				}

				$retCBal[0]	= $cbal;
				$retCBal[1]	= $cbaltype;
				
			} catch(PDOException $e) {
				$err	= 'masterdb getClosingBalanceByMotherAccountCached '.$e->getMessage();
				_errorLog($err);
			}

			return $retCBal;		

		}	
		
		function getClosingBalanceByBGIDCached($CompanyID, $BGID, $fdate) {
			$CompanyID	= (int)$CompanyID;
			$BGID				= (int)$BGID;
			$fdate			= addslashes($fdate);
			$cbal				= 0;
			$cbaltype		= 0;
			$retCBal		= array();
			$debitAmt		= 0;
			$creditAmt	= 0;

			try {
				
				$sql	= "SELECT SUM(`CBal`), `CBalType` FROM `asys_closing_balances` WHERE `ClosingDate`='".$fdate."' AND `BGID`='".$BGID."' AND `CompanyID`='".$CompanyID."' GROUP BY `CBalType`";
				$result		= $this->conn->query($sql);
				while($row 	= $result->fetch()) {
				
					if($row[1] == DEBIT)
						$debitAmt	= $row[0];
					else
						$creditAmt = $row[0];					
				
				}
				
				$cbal				= bcsub($creditAmt, $debitAmt, 2);
				$cbaltype		= CREDIT;
				if($cbal < 0) {
					$cbaltype = DEBIT;
					$cbal 		= -$cbal;				
				}

				$retCBal[0]	= $cbal;
				$retCBal[1]	= $cbaltype;
				
			} catch(PDOException $e) {
				$err	= 'masterdb getClosingBalanceByBGIDCached '.$e->getMessage();
				_errorLog($err);
			}

			return $retCBal;
		}
		
		function getClosingBalanceByBGIDMultipleCompanyCached($CompanyID, $BGID, $fdate) {
			$CompanyID	= addslashes($CompanyID);
			$BGID				= (int)$BGID;
			$fdate			= addslashes($fdate);
			$cbal				= 0;
			$cbaltype		= 0;
			$retCBal		= array();
			$debitAmt		= 0;
			$creditAmt	= 0;

			try {
				
				$sql	= "SELECT SUM(`CBal`), `CBalType` FROM `asys_closing_balances` WHERE `ClosingDate`='".$fdate."' AND `BGID`='".$BGID."' AND `CompanyID` IN(".$CompanyID.") GROUP BY `CBalType`";
				$result		= $this->conn->query($sql);
				while($row 	= $result->fetch()) {
				
					if($row[1] == DEBIT)
						$debitAmt	= $row[0];
					else
						$creditAmt = $row[0];					
				
				}
				
				$cbal				= bcsub($creditAmt, $debitAmt, 2);
				$cbaltype		= CREDIT;
				if($cbal < 0) {
					$cbaltype = DEBIT;
					$cbal 		= -$cbal;				
				}

				$retCBal[0]	= $cbal;
				$retCBal[1]	= $cbaltype;
				
			} catch(PDOException $e) {
				$err	= 'masterdb getClosingBalanceByBGIDMultipleCompanyCached '.$e->getMessage();
				_errorLog($err);
			}

			return $retCBal;
		}		
		
		function getClosingBalanceBySubgroupIDCached($CompanyID, $BGID, $SubgroupID, $fdate) {
			$CompanyID	= (int)$CompanyID;
			$BGID				= (int)$BGID;
			$SubgroupID	= (int)$SubgroupID;
			$fdate			= addslashes($fdate);
			$cbal				= 0;
			$cbaltype		= 0;
			$retCBal		= array();
			$debitAmt		= 0;
			$creditAmt	= 0;

			try {
				
				$sql	= "SELECT SUM(`CBal`), `CBalType` FROM `asys_closing_balances` WHERE `ClosingDate`='".$fdate."' AND `BGID`='".$BGID."' AND `SubgroupID`='".$SubgroupID."' AND `CompanyID`='".$CompanyID."' GROUP BY `CBalType`";
				$result		= $this->conn->query($sql);
				while($row 	= $result->fetch()) {
				
					if($row[1] == DEBIT)
						$debitAmt	= $row[0];
					else
						$creditAmt = $row[0];					
				
				}
				
				$cbal				= bcsub($creditAmt, $debitAmt, 2);
				$cbaltype		= CREDIT;
				if($cbal < 0) {
					$cbaltype = DEBIT;
					$cbal 		= -$cbal;				
				}

				$retCBal[0]	= $cbal;
				$retCBal[1]	= $cbaltype;
				
			} catch(PDOException $e) {
				$err	= 'masterdb getClosingBalanceBySubgroupIDCached '.$e->getMessage();
				_errorLog($err);
			}

			return $retCBal;
		}
		
		function getClosingBalanceBySubgroupIDMultipleCompanyCached($CompanyID, $BGID, $SubgroupID, $fdate) {
			$CompanyID	= (int)$CompanyID;
			$BGID				= (int)$BGID;
			$SubgroupID	= (int)$SubgroupID;
			$fdate			= addslashes($fdate);
			$cbal				= 0;
			$cbaltype		= 0;
			$retCBal		= array();
			$debitAmt		= 0;
			$creditAmt	= 0;

			try {
				
				$sql	= "SELECT SUM(`CBal`), `CBalType` FROM `asys_closing_balances` WHERE `ClosingDate`='".$fdate."' AND `BGID`='".$BGID."' AND `SubgroupID`='".$SubgroupID."' AND `CompanyID` IN(".$CompanyID.") GROUP BY `CBalType`";
				$result		= $this->conn->query($sql);
				while($row 	= $result->fetch()) {
				
					if($row[1] == DEBIT)
						$debitAmt	= $row[0];
					else
						$creditAmt = $row[0];					
				
				}
				
				$cbal				= bcsub($creditAmt, $debitAmt, 2);
				$cbaltype		= CREDIT;
				if($cbal < 0) {
					$cbaltype = DEBIT;
					$cbal 		= -$cbal;				
				}

				$retCBal[0]	= $cbal;
				$retCBal[1]	= $cbaltype;
				
			} catch(PDOException $e) {
				$err	= 'masterdb getClosingBalanceBySubgroupIDMultipleCompanyCached '.$e->getMessage();
				_errorLog($err);
			}

			return $retCBal;
		}
		
		
		
		/*-------------------------------------------------------------------*/
		/*********************** CLOSING/CACHE METHODS ***********************/		
		
		function updateClosingBalances($CompanyID, $DOV1, $DOV2) {
			$CompanyID	= (int)$CompanyID;
			$DOV1				= addslashes($DOV1);
			$DOV2				= addslashes($DOV2);
			$accList		=	array();
			
			try {
			
				$sql			=	"SELECT * FROM `asys_accounts` WHERE `CompanyID`='$CompanyID' AND `ContainsSubLedger`='NO' ORDER BY `AccountName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_accounts');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setGroupName($this->getGroupNameByGroupID($row->getGroupID()));
					$row->setBGName($this->getBaseGroupNameByBaseGroupID($row->getBGID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount() ) );
					$row->setSubgroupName( $this->getSubgroupNameBySubgroupID($row->getSubgroupID()));
					$accList[]	= $row;
				}
			
				$maxid			=	0;
				$sql				=	"SELECT MAX(`ClosingID`) FROM `asys_closing_balances`";
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch())
					$maxid 	= $row[0];
				$maxid++;				
				
				$df		= $DOV1;
				$dt		= $DOV2;
				while(true) {
				
					/* added for bulk insert */
					$insertSql	= "INSERT INTO `asys_closing_balances` (`ClosingID`, `ClosingDate`, `CompanyID`, `GroupID`, `BGID`, `SubgroupID`, `MotherAccountID`, `AccountID`, `CBal`, `CBalType`) VALUES";
					$chk			= 0;
				
					for($i=0;$i<count($accList);$i++) {
						$acc		=	$accList[$i];
						$accid	= $acc->getAccountID();
						
						$cbal				= 0;
						$cbaltype		= 0;

						$dd			= getNextDate($df);
						
						
						$pdt	= getPreviousDate($df);
						$sql	= "SELECT `CBal`, `CBalType` FROM `asys_closing_balances` WHERE `ClosingDate`='".$pdt."' AND `AccountID`='".$accid."'";
						$result		= $this->conn->query($sql);
						if($row 	= $result->fetch()) {
							$cbal		= $row[0];
							$cbaltype	= $row[1];
							$debitAmt		= 0;
							$creditAmt	= 0;								
							
							$sql1	= "SELECT `DrCr`, SUM(`Amount`) AS `Amount` FROM `asys_voucher_entry` WHERE `AccountID`=".$accid." AND `DOV`='".$df."' GROUP BY `DrCr`";

							$res		= $this->conn->query($sql1);
							while( $rr = $res->fetch() ) {
								if($rr[0] == DEBIT)
									$debitAmt	= $rr[1];
								else
									$creditAmt = $rr[1];
							}
							
							if($cbaltype == CREDIT) {
								$cbal 		= bcadd($cbal, $creditAmt,2);
								$cbal			= bcsub($cbal, $debitAmt, 2);
								if($cbal < 0) {
									$cbaltype 	= DEBIT;
									$cbal 	= -$cbal;
								}
							} else {
								$cbal 		= bcadd($cbal, $debitAmt,2);
								$cbal			= bcsub($cbal, $creditAmt, 2);
								if($cbal < 0) {
									$cbaltype 	= CREDIT;
									$cbal		= - $cbal;
								}
							}
						} else {

							$clbal	=	$this->getClosingBalanceByAccountID($accid, $dd, 'YES');
							$cbal		=	$clbal[0];
							$cbaltype	=	$clbal[1];
							
						}
						
						
						/* DB update */
						$cbcls	= new asys_closing_balances();
						$cbcls->setClosingID($maxid);
						$cbcls->setClosingDate(FormatSQLDateToIndianDate($df));
						$cbcls->setCompanyID($CompanyID);
						$cbcls->setGroupID($acc->getGroupID());
						$cbcls->setBGID($acc->getBGID());
						$cbcls->setSubgroupID($acc->getSubgroupID());
						$cbcls->setMotherAccountID($acc->getMotherAccount());
						$cbcls->setAccountID($acc->getAccountID());
						$cbcls->setCBal($cbal);
						$cbcls->setCBalType($cbaltype);
						
						$sql	= "SELECT `ClosingID` FROM `asys_closing_balances` WHERE `ClosingDate`='".$df."' AND `AccountID`='".$acc->getAccountID()."'";
						$result		= $this->conn->query($sql);
						if($row 	= $result->fetch()) {
							$clid		= $row[0];
							$cbcls->setClosingID($clid);
							$sql		= $cbcls->getUpdateSQL();
							$this->conn->exec($sql);
						} else {
							if($i > 0) $insertSql = $insertSql.",";
							$insertSql	= $insertSql."('".$cbcls->getClosingID('asis')."', '".$cbcls->getClosingDate('asis')."', '".$cbcls->getCompanyID('asis')."', '".$cbcls->getGroupID('asis')."', '".$cbcls->getBGID('asis')."', '".$cbcls->getSubgroupID('asis')."', '".$cbcls->getMotherAccountID('asis')."', '".$cbcls->getAccountID('asis')."', '".$cbcls->getCBal('asis')."', '".$cbcls->getCBalType('asis')."')";
							$maxid++;
							$chk++;
						}
					
					} /* for loop ends */
					
					if($chk > 0)
						$this->conn->exec($insertSql);
					
					/* Break condition */
					$df		= getNextDate($df);
					if($df > $dt) break;
					
				} /* while loop ends */
				
				
			} catch(Exception $er) {
				$err	= 'voucherdb updateClosingBalances '.$er->getMessage();
				_errorLog($err);
			}
		}
		
		function updateClosingBalancesAllCompany($DOV1, $DOV2) {

			$DOV1				= addslashes($DOV1);
			$DOV2				= addslashes($DOV2);
			$accList		=	array();
			
			try {
			
				$sql			=	"SELECT * FROM `asys_accounts` WHERE `ContainsSubLedger`='NO' ORDER BY `AccountName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_accounts');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setGroupName($this->getGroupNameByGroupID($row->getGroupID()));
					$row->setBGName($this->getBaseGroupNameByBaseGroupID($row->getBGID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccount() ) );
					$row->setSubgroupName( $this->getSubgroupNameBySubgroupID($row->getSubgroupID()));
					$accList[]	= $row;
				}
			
				$maxid		=	0;
				$sql			=	"SELECT MAX(`ClosingID`) FROM `asys_closing_balances`";
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch())
					$maxid 	= $row[0];
				$maxid++;
				
				$df		= $DOV1;
				$dt		= $DOV2;
				while(true) {
				
					/* added for bulk insert */
					$insertSql	= "INSERT INTO `asys_closing_balances` (`ClosingID`, `ClosingDate`, `CompanyID`, `GroupID`, `BGID`, `SubgroupID`, `MotherAccountID`, `AccountID`, `CBal`, `CBalType`) VALUES";
					$chk			= 0;
				
					for($i=0;$i<count($accList);$i++) {
						$acc		=	$accList[$i];
						$accid	= $acc->getAccountID();
						
						$cbal				= 0;
						$cbaltype		= 0;

						$dd			= getNextDate($df);
						
						
						$pdt	= getPreviousDate($df);
						$sql	= "SELECT `CBal`, `CBalType` FROM `asys_closing_balances` WHERE `ClosingDate`='".$pdt."' AND `AccountID`='".$accid."'";
						$result		= $this->conn->query($sql);
						if($row 	= $result->fetch()) {
							$cbal		= $row[0];
							$cbaltype	= $row[1];
							$debitAmt		= 0;
							$creditAmt	= 0;								
							
							$sql1	= "SELECT `DrCr`, SUM(`Amount`) AS `Amount` FROM `asys_voucher_entry` WHERE `AccountID`=".$accid." AND `DOV`='".$df."' GROUP BY `DrCr`";

							$res		= $this->conn->query($sql1);
							while( $rr = $res->fetch() ) {
								if($rr[0] == DEBIT)
									$debitAmt	= $rr[1];
								else
									$creditAmt = $rr[1];
							}
							
							if($cbaltype == CREDIT) {
								$cbal 		= bcadd($cbal, $creditAmt,2);
								$cbal			= bcsub($cbal, $debitAmt, 2);
								if($cbal < 0) {
									$cbaltype 	= DEBIT;
									$cbal 	= -$cbal;
								}
							} else {
								$cbal 		= bcadd($cbal, $debitAmt,2);
								$cbal			= bcsub($cbal, $creditAmt, 2);
								if($cbal < 0) {
									$cbaltype 	= CREDIT;
									$cbal		= - $cbal;
								}
							}
						} else {

							$clbal	=	$this->getClosingBalanceByAccountID($accid, $dd, 'YES');
							$cbal		=	$clbal[0];
							$cbaltype	=	$clbal[1];
							
						}
						
						
						/* DB update */
						$cbcls	= new asys_closing_balances();
						$cbcls->setClosingID($maxid);
						$cbcls->setClosingDate(FormatSQLDateToIndianDate($df));
						$cbcls->setCompanyID($acc->getCompanyID());
						$cbcls->setGroupID($acc->getGroupID());
						$cbcls->setBGID($acc->getBGID());
						$cbcls->setSubgroupID($acc->getSubgroupID());
						$cbcls->setMotherAccountID($acc->getMotherAccount());
						$cbcls->setAccountID($acc->getAccountID());
						$cbcls->setCBal($cbal);
						$cbcls->setCBalType($cbaltype);
						
						$sql	= "SELECT `ClosingID` FROM `asys_closing_balances` WHERE `ClosingDate`='".$df."' AND `AccountID`='".$acc->getAccountID()."'";
						$result		= $this->conn->query($sql);
						if($row 	= $result->fetch()) {
							$clid		= $row[0];
							$cbcls->setClosingID($clid);
							$sql		= $cbcls->getUpdateSQL();
							$this->conn->exec($sql);
						} else {
							if($i > 0) $insertSql = $insertSql.",";
							$insertSql	= $insertSql."('".$cbcls->getClosingID('asis')."', '".$cbcls->getClosingDate('asis')."', '".$cbcls->getCompanyID('asis')."', '".$cbcls->getGroupID('asis')."', '".$cbcls->getBGID('asis')."', '".$cbcls->getSubgroupID('asis')."', '".$cbcls->getMotherAccountID('asis')."', '".$cbcls->getAccountID('asis')."', '".$cbcls->getCBal('asis')."', '".$cbcls->getCBalType('asis')."')";
							$maxid++;
							$chk++;
						}
					
					} /* for loop ends */
					
					if($chk > 0)
						$this->conn->exec($insertSql);
					
					/* Break condition */
					$df		= getNextDate($df);
					if($df > $dt) break;
					
				} /* while loop ends */
				
				
			} catch(Exception $er) {
				$err	= 'voucherdb updateClosingBalances '.$er->getMessage();
				_errorLog($err);
			}
		}
		
		function updateClosingBalanceByAccount($CompanyID, $AccountID, $DOV1, $DOV2) {
			$CompanyID	= (int)$CompanyID;
			$AccountID	= (int)$AccountID;
			$DOV1				= addslashes($DOV1);
			$DOV2				= addslashes($DOV2);
			$accList		=	array();
			
			try {
			
				$maxid			=	0;
				$sql				=	"SELECT MAX(`ClosingID`) FROM `asys_closing_balances`";
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch())
					$maxid 	= $row[0];
				$maxid++;
				
				$acc			= $this->getAccountDetail($AccountID);
				
				/* added for bulk insert */
				$insertSql	= "INSERT INTO `asys_closing_balances` (`ClosingID`, `ClosingDate`, `CompanyID`, `GroupID`, `BGID`, `SubgroupID`, `MotherAccountID`, `AccountID`, `CBal`, `CBalType`) VALUES";
				$chk			= 0;
				
				$df		= $DOV1;
				$dt		= $DOV2;
				while(true) {

					$accid	= $AccountID;
					
					$cbal				= 0;
					$cbaltype		= 0;

					$dd			= getNextDate($df);
					
					$pdt	= getPreviousDate($df);
					$sql	= "SELECT `CBal`, `CBalType` FROM `asys_closing_balances` WHERE `ClosingDate`='".$pdt."' AND `AccountID`='".$accid."'";
					$result		= $this->conn->query($sql);
					if($row 	= $result->fetch()) {
						$cbal		= $row[0];
						$cbaltype	= $row[1];
						$debitAmt		= 0;
						$creditAmt	= 0;								
						
						$sql1	= "SELECT `DrCr`, SUM(`Amount`) AS `Amount` FROM `asys_voucher_entry` WHERE `AccountID`=".$accid." AND `DOV`='".$df."' GROUP BY `DrCr`";

						$res		= $this->conn->query($sql1);
						while( $rr = $res->fetch() ) {
							if($rr[0] == DEBIT)
								$debitAmt	= $rr[1];
							else
								$creditAmt = $rr[1];
						}
						
						if($cbaltype == CREDIT) {
							$cbal 		= bcadd($cbal, $creditAmt,2);
							$cbal			= bcsub($cbal, $debitAmt, 2);
							if($cbal < 0) {
								$cbaltype 	= DEBIT;
								$cbal 	= -$cbal;
							}
						} else {
							$cbal 		= bcadd($cbal, $debitAmt,2);
							$cbal			= bcsub($cbal, $creditAmt, 2);
							if($cbal < 0) {
								$cbaltype 	= CREDIT;
								$cbal		= - $cbal;
							}
						}
					} else {

						$clbal	=	$this->getClosingBalanceByAccountID($accid, $dd, 'YES');
						$cbal		=	$clbal[0];
						$cbaltype	=	$clbal[1];
						
					}
					
					
					/* DB update */
					$cbcls	= new asys_closing_balances();
					$cbcls->setClosingID($maxid);
					$cbcls->setClosingDate(FormatSQLDateToIndianDate($df));
					$cbcls->setCompanyID($CompanyID);
					$cbcls->setGroupID($acc->getGroupID());
					$cbcls->setBGID($acc->getBGID());
					$cbcls->setSubgroupID($acc->getSubgroupID());
					$cbcls->setMotherAccountID($acc->getMotherAccount());
					$cbcls->setAccountID($acc->getAccountID());
					$cbcls->setCBal($cbal);
					$cbcls->setCBalType($cbaltype);
					
					$sql	= "SELECT `ClosingID` FROM `asys_closing_balances` WHERE `ClosingDate`='".$df."' AND `AccountID`='".$acc->getAccountID()."'";
					$result		= $this->conn->query($sql);
					if($row 	= $result->fetch()) {
						$clid		= $row[0];
						$cbcls->setClosingID($clid);
						$sql		= $cbcls->getUpdateSQL();
						$this->conn->exec($sql);
					} else {
						if($chk > 0) $insertSql = $insertSql.",";
						$insertSql	= $insertSql."('".$cbcls->getClosingID('asis')."', '".$cbcls->getClosingDate('asis')."', '".$cbcls->getCompanyID('asis')."', '".$cbcls->getGroupID('asis')."', '".$cbcls->getBGID('asis')."', '".$cbcls->getSubgroupID('asis')."', '".$cbcls->getMotherAccountID('asis')."', '".$cbcls->getAccountID('asis')."', '".$cbcls->getCBal('asis')."', '".$cbcls->getCBalType('asis')."')";
						$maxid++;
						$chk++;
					}
					
					/* Break condition */
					$df		= getNextDate($df);
					if($df > $dt) break;
					
				} /* while loop ends */
				
				if($chk > 0)
					$this->conn->exec($insertSql);
				
			} catch(Exception $er) {
				$err	= 'voucherdb updateClosingBalances '.$er->getMessage();
				_errorLog($err);
			}
		}
		
		function getDistinctAccountIDFromTriggerLog($LogDate) {
			
			$LogDate	= addslashes($LogDate);
			$sql			=	"SELECT DISTINCT(`AccountID`) FROM `asys_voucherentry_triggerlog` WHERE `LogDate`='$LogDate' ";
			return $this->getRecordsetExecutingQuery($sql);
	
		}
		
		function getStartDateFromTriggerLog($AccountID, $LogDate) {
			
			$AccountID	= (int)$AccountID;
			$LogDate		= addslashes($LogDate);
			$sql				=	"SELECT MIN(`VoucherDate`) FROM `asys_voucherentry_triggerlog` WHERE `AccountID`='$AccountID' AND `LogDate`='$LogDate' ";
			return $this->getResultExecutingQuery($sql);
			
		}
		
		function getEndDateFromTriggerLog($AccountID, $LogDate) {
			
			$AccountID	= (int)$AccountID;
			$LogDate		= addslashes($LogDate);
			$sql				=	"SELECT MAX(`VoucherDate`) FROM `asys_voucherentry_triggerlog` WHERE `AccountID`='$AccountID' AN `LogDate`='$LogDate' ";
			return $this->getResultExecutingQuery($sql);
			
		}
		
		function updateClosingBalanceByAccountByPreviousClosing($AccountID, $LogDate) {
			$AccountID	= (int)$AccountID;
			$LogDate		= addslashes($LogDate);
			
			try {
			
				$maxid			=	0;
				$sql				=	"SELECT MAX(`ClosingID`) FROM `asys_closing_balances`";
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch())
					$maxid 	= $row[0];
				$maxid++;			
			
				$sql			= "SELECT * FROM `asys_closing_balances` WHERE `AccountID`='$AccountID' AND `ClosingDate` < '$LogDate' ORDER BY `ClosingDate` DESC LIMIT 1";
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch()) { 
					$cdt		= $row[1];
					$cid		= $row[2];
					$gid		= $row[3];
					$bgid		= $row[4];
					$sgid		= $row[5];
					$maid		= $row[6];
					$aid		= $row[7];
					$cbal		= $row[8];
					$ctyp		= $row[9];
					
					$cdt		= getNextDate($cdt);
					
					while(true) {
				
						$cbcls	= new asys_closing_balances();
						$cbcls->setClosingID($maxid++);
						$cbcls->setClosingDate(FormatSQLDateToIndianDate($cdt));
						$cbcls->setCompanyID($cid);
						$cbcls->setGroupID($gid);
						$cbcls->setBGID($bgid);
						$cbcls->setSubgroupID($sgid);
						$cbcls->setMotherAccountID($maid);
						$cbcls->setAccountID($aid);
						$cbcls->setCBal($cbal);
						$cbcls->setCBalType($ctyp);
					
						$sql		= $cbcls->getInsertSQL();
						$this->conn->exec($sql);
						
						$cdt		= getNextDate($cdt);
						if($cdt > $LogDate) break;
						
					}
				
				}
				
			} catch(Exception $er) {
				$err	= 'voucherdb updateClosingBalances '.$er->getMessage();
				_errorLog($err);
			}
							
		}
		
		function updateClosingBalanceIntelligently($LogDate) {
			$LogDate		= addslashes($LogDate);
			
			$acclist	= $this->getDistinctAccountIDFromTriggerLog($LogDate);
			for($i=0;$i<count($acclist);$i++) {
				$row		= $acclist[$i];
				$aid		= $row[0];
				$accdet	= $this->getAccountDetail($aid);
				
				$sdt		= $this->getStartDateFromTriggerLog($aid, $LogDate);
				$edt		= $this->getEndDateFromTriggerLog($aid, $LogDate);
				
				$this->updateClosingBalanceByAccount($accdet->getCompanyID(), $aid, $sdt, $edt);
			}
			
			$sql			=	"SELECT `AccountID` FROM `asys_accounts` WHERE `ContainsSubLedger`='NO' AND `AccountID` NOT IN(SELECT `AccountID` FROM `asys_voucherentry_triggerlog` WHERE `LogDate`='$LogDate' GROUP BY `AccountID`) ORDER BY `AccountName`";
			$racclist	= $this->getRecordsetExecutingQuery($sql);
			for($i=0;$i<count($racclist);$i++) {
				$row		= $racclist[$i];
				$aid		= $row[0];
				$this->updateClosingBalanceByAccountByPreviousClosing($aid, $LogDate);
			}
		}
		


		/*------------------------------------------------------------------------*/
		/*********************** COMPANY TO COMPANY VOUCHER ***********************/		
		
		function getC2CDetail($BookingID) {
		
			$BookingID	= (int)$BookingID;
			$cclass			=	new gen_branchjournal();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_branchjournal` WHERE `BookingID`='$BookingID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_branchjournal');
				if($row 	= $result->fetch()) {
					$row->setCompanyName( $this->getCompanyNameByCompanyID( $row->getCompanyID()));
					$row->setDebitMotherAccountName( $this->getAccountNameByAccountID( $row->getDebitMotherAccountID()));
					$row->setDebitAccountName( $this->getAccountNameByAccountID( $row->getDebitAccountID()));
					$row->setCreditMotherAccountName( $this->getAccountNameByAccountID( $row->getCreditMotherAccountID()));
					$row->setCreditAccountName( $this->getAccountNameByAccountID( $row->getCreditAccountID()));
					$row->setToCompanyName( $this->getCompanyNameByCompanyID( $row->getToCompanyID()));
					$row->setBranchDebitMotherAccountName( $this->getAccountNameByAccountID( $row->getBranchDebitMotherAccountID()));
					$row->setBranchDebitAccountName( $this->getAccountNameByAccountID( $row->getBranchDebitAccountID()));
					$row->setBranchCreditMotherAccountName( $this->getAccountNameByAccountID( $row->getBranchCreditMotherAccountID()));
					$row->setBranchCreditAccountName( $this->getAccountNameByAccountID( $row->getBranchCreditAccountID()));					
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getC2CDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}
		
		function getC2CList($CompanyID) {	
			$CompanyID	= (int)$CompanyID;
			$arr				=	array();
			
			try {
				
				$sql				=	"SELECT * FROM `gen_branchjournal` ORDER BY `FinYear` DESC, `BookingNo` DESC";
				$result			= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_branchjournal');
				while($row 	= $result->fetch()) {
					$row->setCompanyName( $this->getCompanyNameByCompanyID( $row->getCompanyID()));
					$row->setDebitMotherAccountName( $this->getAccountNameByAccountID( $row->getDebitMotherAccountID()));
					$row->setDebitAccountName( $this->getAccountNameByAccountID( $row->getDebitAccountID()));
					$row->setCreditMotherAccountName( $this->getAccountNameByAccountID( $row->getCreditMotherAccountID()));
					$row->setCreditAccountName( $this->getAccountNameByAccountID( $row->getCreditAccountID()));
					$row->setToCompanyName( $this->getCompanyNameByCompanyID( $row->getToCompanyID()));
					$row->setBranchDebitMotherAccountName( $this->getAccountNameByAccountID( $row->getBranchDebitMotherAccountID()));
					$row->setBranchDebitAccountName( $this->getAccountNameByAccountID( $row->getBranchDebitAccountID()));
					$row->setBranchCreditMotherAccountName( $this->getAccountNameByAccountID( $row->getBranchCreditMotherAccountID()));
					$row->setBranchCreditAccountName( $this->getAccountNameByAccountID( $row->getBranchCreditAccountID()));				
					$arr[]		= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getC2CList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getNumberOfC2C($CompanyID, $DateFrom, $DateTo) {
			$CompanyID	= (int)$CompanyID;
			$DateFrom	= addslashes($DateFrom);
			$DateTo		= addslashes($DateTo);
			$sql		=	"SELECT COUNT(*) FROM `gen_branchjournal` WHERE `CompanyID` = '$CompanyID'";
			if($DateFrom != "" && $DateFrom != "1900-01-01")
				$sql	= $sql." AND  `BookingDate` >= '$DateFrom'";
			if($DateTo != "" && $DateTo != "1900-01-01")
				$sql	= $sql." AND  `BookingDate` <= '$DateTo'";

			return $this->getResultExecutingQuery($sql);
		}

		function getC2CListPaged($sRec, $nRec, $CompanyID, $DateFrom, $DateTo) {
			$sRec			= (int)$sRec;
			$nRec			= (int)$nRec;
			$CompanyID= (int)$CompanyID;
			$DateFrom	= addslashes($DateFrom);
			$DateTo		= addslashes($DateTo);
			$sql	=	"SELECT * FROM `gen_branchjournal` WHERE `CompanyID` = '$CompanyID'";
			if($DateFrom != "" && $DateFrom != "1900-01-01")
				$sql	= $sql." AND  `BookingDate` >= '$DateFrom'";
			if($DateTo != "" && $DateTo != "1900-01-01")
				$sql	= $sql." AND  `BookingDate` <= '$DateTo'";
			
			$sql		=	$sql." ORDER BY `FinYear` DESC, `BookingNo` DESC LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_branchjournal');
				while($row = $result->fetch()) {
					$row->setCompanyName( $this->getCompanyNameByCompanyID( $row->getCompanyID()));
					$row->setDebitMotherAccountName( $this->getAccountNameByAccountID( $row->getDebitMotherAccountID()));
					$row->setDebitAccountName( $this->getAccountNameByAccountID( $row->getDebitAccountID()));
					$row->setCreditMotherAccountName( $this->getAccountNameByAccountID( $row->getCreditMotherAccountID()));
					$row->setCreditAccountName( $this->getAccountNameByAccountID( $row->getCreditAccountID()));
					$row->setToCompanyName( $this->getCompanyNameByCompanyID( $row->getToCompanyID()));
					$row->setBranchDebitMotherAccountName( $this->getAccountNameByAccountID( $row->getBranchDebitMotherAccountID()));
					$row->setBranchDebitAccountName( $this->getAccountNameByAccountID( $row->getBranchDebitAccountID()));
					$row->setBranchCreditMotherAccountName( $this->getAccountNameByAccountID( $row->getBranchCreditMotherAccountID()));
					$row->setBranchCreditAccountName( $this->getAccountNameByAccountID( $row->getBranchCreditAccountID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'voucherdb getC2CListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function createC2C($ecls) {
		
			$bid		= 0;
			
			try {
				
				$this->conn->beginTransaction();
				
				$ecls->setBookingID($this->getNextID("gen_branchjournal","BookingID"));
				$bid	= $ecls->getBookingID();
				$ecls->setFinYear(getFinancialYear($ecls->getBookingDate()));
				$ecls->setBookingNo($this->getNextNo('gen_branchjournal', 'BookingNo', $ecls->getFinYear(), $ecls->getCompanyID()));					
				
				$tcmp				=	unserialize($_SESSION["ssECmp"]);
				$tuser			=	unserialize($_SESSION["ssEUser"]);
				$finyr			= getFinancialYear($ecls->getBookingDate());
				$cmpid			= $tcmp->getCompanyID();
				$vdt				= $ecls->getBookingDate();
				$vdtf				= $ecls->getBookingDate('yes');
				
				
				/* Voucher entries */
				
				$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
				$VoucherNo	=	$this->getMaxVoucherNo(JOURNAL_VOUCHER, $finyr, $cmpid);
				$DayWiseNo	= $this->getMaxDayWiseVoucherNo(JOURNAL_VOUCHER, $vdt, $cmpid);
				
				if($ecls->getCreditAccountID() != 0)
					$aDet		= $this->getAccountDetail($ecls->getCreditAccountID());
				else
					$aDet		= $this->getAccountDetail($ecls->getCreditMotherAccountID());
				
				$vcls	=	new asys_voucher_entry();
				$vcls->setVoucherID($vid);
				$vcls->setSerialID(1);
				$vcls->setCompanyID($cmpid);
				$vcls->setVoucherType(JOURNAL_VOUCHER);
				$vcls->setFinYear($finyr);
				$vcls->setVoucherNo($VoucherNo);
				$vcls->setDayWiseNo($DayWiseNo);
				$vcls->setDOV($vdtf);
				$vcls->setMotherAccount($aDet->getMotherAccount());
				$vcls->setAccountID($aDet->getAccountID());
				$vcls->setRelatedID($bid);
				$vcls->setTxnType(COMPANY_JOURNAL);
				$vcls->setDrCr(CREDIT);
				$vcls->setAmount($ecls->getAmount());
				$vcls->setNarration("Company Journal# ".$ecls->getNarration());
				$vcls->setUserID($tuser->getUserID());
				$vcls->setDOE(date('d-m-Y'));
				
				$this->conn->exec($vcls->getInsertSQL());
				
				if($ecls->getDebitAccountID() != 0)
					$aDet		= $this->getAccountDetail($ecls->getDebitAccountID());
				else
					$aDet		= $this->getAccountDetail($ecls->getDebitMotherAccountID());
				
				$vcls	=	new asys_voucher_entry();
				$vcls->setVoucherID($vid);
				$vcls->setSerialID(2);
				$vcls->setCompanyID($cmpid);
				$vcls->setVoucherType(JOURNAL_VOUCHER);
				$vcls->setFinYear($finyr);
				$vcls->setVoucherNo($VoucherNo);
				$vcls->setDayWiseNo($DayWiseNo);
				$vcls->setDOV($vdtf);
				$vcls->setMotherAccount($aDet->getMotherAccount());
				$vcls->setAccountID($aDet->getAccountID());
				$vcls->setRelatedID($bid);
				$vcls->setTxnType(COMPANY_JOURNAL);
				$vcls->setDrCr(DEBIT);
				$vcls->setAmount($ecls->getAmount());
				$vcls->setNarration("Company Journal# ".$ecls->getNarration());
				$vcls->setUserID($tuser->getUserID());
				$vcls->setDOE(date('d-m-Y'));
				
				$this->conn->exec($vcls->getInsertSQL());
				
				/* Branch vouchers */
				$cid				= $ecls->getToCompanyID();
				$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
				$VoucherNo	=	$this->getMaxVoucherNo(JOURNAL_VOUCHER, $finyr, $cid);
				$DayWiseNo	= $this->getMaxDayWiseVoucherNo(JOURNAL_VOUCHER, $vdt, $cid);
				
				if($ecls->getBranchCreditAccountID() != 0)
					$aDet		= $this->getAccountDetail($ecls->getBranchCreditAccountID());
				else
					$aDet		= $this->getAccountDetail($ecls->getBranchCreditMotherAccountID());
				
				$vcls	=	new asys_voucher_entry();
				$vcls->setVoucherID($vid);
				$vcls->setSerialID(1);
				$vcls->setCompanyID($cid);
				$vcls->setVoucherType(JOURNAL_VOUCHER);
				$vcls->setFinYear($finyr);
				$vcls->setVoucherNo($VoucherNo);
				$vcls->setDayWiseNo($DayWiseNo);
				$vcls->setDOV($vdtf);
				$vcls->setMotherAccount($aDet->getMotherAccount());
				$vcls->setAccountID($aDet->getAccountID());
				$vcls->setRelatedID($bid);
				$vcls->setTxnType(COMPANY_JOURNAL);
				$vcls->setDrCr(CREDIT);
				$vcls->setAmount($ecls->getAmount());
				$vcls->setNarration("Company Journal# ".$ecls->getNarration());
				$vcls->setUserID($tuser->getUserID());
				$vcls->setDOE(date('d-m-Y'));
				
				$this->conn->exec($vcls->getInsertSQL());
				
				if($ecls->getBranchDebitAccountID() != 0)
					$aDet		= $this->getAccountDetail($ecls->getBranchDebitAccountID());
				else
					$aDet		= $this->getAccountDetail($ecls->getBranchDebitMotherAccountID());
				
				$vcls	=	new asys_voucher_entry();
				$vcls->setVoucherID($vid);
				$vcls->setSerialID(2);
				$vcls->setCompanyID($cid);
				$vcls->setVoucherType(JOURNAL_VOUCHER);
				$vcls->setFinYear($finyr);
				$vcls->setVoucherNo($VoucherNo);
				$vcls->setDayWiseNo($DayWiseNo);
				$vcls->setDOV($vdtf);
				$vcls->setMotherAccount($aDet->getMotherAccount());
				$vcls->setAccountID($aDet->getAccountID());
				$vcls->setRelatedID($bid);
				$vcls->setTxnType(COMPANY_JOURNAL);
				$vcls->setDrCr(DEBIT);
				$vcls->setAmount($ecls->getAmount());
				$vcls->setNarration("Company Journal# ".$ecls->getNarration());
				$vcls->setUserID($tuser->getUserID());
				$vcls->setDOE(date('d-m-Y'));
				
				$this->conn->exec($vcls->getInsertSQL());				
				
				/* Voucher entry ends here */			
				
				
				$sql	= $ecls->getInsertSQL();
				$this->conn->exec($sql);
				
				$this->conn->commit();
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'voucherdb createC2C '.$er->getMessage();
				_errorLog($err);
				$bid	= -1;
				
			}
			
			return $bid;
		}
		
		function updateC2C($ecls) {
		
			$bid		= $ecls->getBookingID();
			
			try {
				
				$this->conn->beginTransaction();
				
				$this->conn->exec("DELETE FROM `asys_voucher_entry` WHERE `RelatedID`='$bid' AND `TxnType`='".COMPANY_JOURNAL."'");			
				
				$tcmp				=	unserialize($_SESSION["ssECmp"]);
				$tuser			=	unserialize($_SESSION["ssEUser"]);
				$finyr			= getFinancialYear($ecls->getBookingDate());
				$cmpid			= $tcmp->getCompanyID();
				$vdt				= $ecls->getBookingDate();
				$vdtf				= $ecls->getBookingDate('yes');
				
				
				/* Voucher entries */
				
				$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
				$VoucherNo	=	$this->getMaxVoucherNo(JOURNAL_VOUCHER, $finyr, $cmpid);
				$DayWiseNo	= $this->getMaxDayWiseVoucherNo(JOURNAL_VOUCHER, $vdt, $cmpid);
				
				if($ecls->getCreditAccountID() != 0)
					$aDet		= $this->getAccountDetail($ecls->getCreditAccountID());
				else
					$aDet		= $this->getAccountDetail($ecls->getCreditMotherAccountID());
				
				$vcls	=	new asys_voucher_entry();
				$vcls->setVoucherID($vid);
				$vcls->setSerialID(1);
				$vcls->setCompanyID($cmpid);
				$vcls->setVoucherType(JOURNAL_VOUCHER);
				$vcls->setFinYear($finyr);
				$vcls->setVoucherNo($VoucherNo);
				$vcls->setDayWiseNo($DayWiseNo);
				$vcls->setDOV($vdtf);
				$vcls->setMotherAccount($aDet->getMotherAccount());
				$vcls->setAccountID($aDet->getAccountID());
				$vcls->setRelatedID($bid);
				$vcls->setTxnType(COMPANY_JOURNAL);
				$vcls->setDrCr(CREDIT);
				$vcls->setAmount($ecls->getAmount());
				$vcls->setNarration("Company Journal# ".$ecls->getNarration());
				$vcls->setUserID($tuser->getUserID());
				$vcls->setDOE(date('d-m-Y'));
				
				$this->conn->exec($vcls->getInsertSQL());
				
				if($ecls->getDebitAccountID() != 0)
					$aDet		= $this->getAccountDetail($ecls->getDebitAccountID());
				else
					$aDet		= $this->getAccountDetail($ecls->getDebitMotherAccountID());
				
				$vcls	=	new asys_voucher_entry();
				$vcls->setVoucherID($vid);
				$vcls->setSerialID(2);
				$vcls->setCompanyID($cmpid);
				$vcls->setVoucherType(JOURNAL_VOUCHER);
				$vcls->setFinYear($finyr);
				$vcls->setVoucherNo($VoucherNo);
				$vcls->setDayWiseNo($DayWiseNo);
				$vcls->setDOV($vdtf);
				$vcls->setMotherAccount($aDet->getMotherAccount());
				$vcls->setAccountID($aDet->getAccountID());
				$vcls->setRelatedID($bid);
				$vcls->setTxnType(COMPANY_JOURNAL);
				$vcls->setDrCr(DEBIT);
				$vcls->setAmount($ecls->getAmount());
				$vcls->setNarration("Company Journal# ".$ecls->getNarration());
				$vcls->setUserID($tuser->getUserID());
				$vcls->setDOE(date('d-m-Y'));
				
				$this->conn->exec($vcls->getInsertSQL());
				
				/* Branch vouchers */
				$cid				= $ecls->getToCompanyID();
				$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
				$VoucherNo	=	$this->getMaxVoucherNo(JOURNAL_VOUCHER, $finyr, $cid);
				$DayWiseNo	= $this->getMaxDayWiseVoucherNo(JOURNAL_VOUCHER, $vdt, $cid);
				
				if($ecls->getBranchCreditAccountID() != 0)
					$aDet		= $this->getAccountDetail($ecls->getBranchCreditAccountID());
				else
					$aDet		= $this->getAccountDetail($ecls->getBranchCreditMotherAccountID());
				
				$vcls	=	new asys_voucher_entry();
				$vcls->setVoucherID($vid);
				$vcls->setSerialID(1);
				$vcls->setCompanyID($cid);
				$vcls->setVoucherType(JOURNAL_VOUCHER);
				$vcls->setFinYear($finyr);
				$vcls->setVoucherNo($VoucherNo);
				$vcls->setDayWiseNo($DayWiseNo);
				$vcls->setDOV($vdtf);
				$vcls->setMotherAccount($aDet->getMotherAccount());
				$vcls->setAccountID($aDet->getAccountID());
				$vcls->setRelatedID($bid);
				$vcls->setTxnType(COMPANY_JOURNAL);
				$vcls->setDrCr(CREDIT);
				$vcls->setAmount($ecls->getAmount());
				$vcls->setNarration("Company Journal# ".$ecls->getNarration());
				$vcls->setUserID($tuser->getUserID());
				$vcls->setDOE(date('d-m-Y'));
				
				$this->conn->exec($vcls->getInsertSQL());
				
				if($ecls->getBranchDebitAccountID() != 0)
					$aDet		= $this->getAccountDetail($ecls->getBranchDebitAccountID());
				else
					$aDet		= $this->getAccountDetail($ecls->getBranchDebitMotherAccountID());
				
				$vcls	=	new asys_voucher_entry();
				$vcls->setVoucherID($vid);
				$vcls->setSerialID(2);
				$vcls->setCompanyID($cid);
				$vcls->setVoucherType(JOURNAL_VOUCHER);
				$vcls->setFinYear($finyr);
				$vcls->setVoucherNo($VoucherNo);
				$vcls->setDayWiseNo($DayWiseNo);
				$vcls->setDOV($vdtf);
				$vcls->setMotherAccount($aDet->getMotherAccount());
				$vcls->setAccountID($aDet->getAccountID());
				$vcls->setRelatedID($bid);
				$vcls->setTxnType(COMPANY_JOURNAL);
				$vcls->setDrCr(DEBIT);
				$vcls->setAmount($ecls->getAmount());
				$vcls->setNarration("Company Journal# ".$ecls->getNarration());
				$vcls->setUserID($tuser->getUserID());
				$vcls->setDOE(date('d-m-Y'));
				
				$this->conn->exec($vcls->getInsertSQL());				
				
				/* Voucher entry ends here */			
				
				
				$sql	= $ecls->getUpdateSQL();
				$this->conn->exec($sql);
				
				$this->conn->commit();
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'voucherdb updateC2C '.$er->getMessage();
				_errorLog($err);
				$bid	= -1;
				
			}
			
			return $bid;
		}		

		function deleteC2C($lcls) {
		
			$pkey				= $lcls->getBookingID();
			$ret				= false;
				
			try {
			
				$this->conn->beginTransaction();	
				
				$this->conn->exec("DELETE FROM `asys_voucher_entry` WHERE `RelatedID`='$pkey' AND `TxnType`='".COMPANY_JOURNAL."'");
				
				$sql	= $lcls->getDeleteSQL();
				$this->conn->exec($sql);
			
				$this->conn->commit();
				
			} catch(Exception $er) {

				$ret	= false;
				$this->conn->rollBack();
				$err	= 'voucherdb deleteC2C '.$er->getMessage();
				_errorLog($err);				
				
			}			
		
			return $ret;
		}		
		
	};

?>