<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - May 09, 2017
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class asys_voucher_tags {
		/**
		 * @Field		TagID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $TagID = 0;

		/**
		 * @Field		VoucherID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $VoucherID = 0;

		/**
		 * @Field		SerialID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $SerialID = 0;
		
		/**
		 * @Field		CompanyID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyID = 0;

		/**
		 * @Field		CompanyName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyName = "";		

		/**
		 * @Field		DOV
		 * @Type		date
		 * @Access	Protected
		 */
		protected $DOV = "1900-01-01";

		/**
		 * @Field		AccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $AccountID = 0;

		/**
		 * @Field		AccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $AccountName = "";

		/**
		 * @Field		ModuleID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ModuleID = 0;

		/**
		 * @Field		RelatedID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $RelatedID = 0;

		/**
		 * @Field		VoucherAmount
		 * @Type		decimal(15,2)
		 * @Access	Protected
		 */
		protected $VoucherAmount = 0;

		/**
		 * @Field		BillAmount
		 * @Type		decimal(15,2)
		 * @Access	Protected
		 */
		protected $BillAmount = 0;

		/**
		 * @Field		AdjustedAmount
		 * @Type		decimal(15,2)
		 * @Access	Protected
		 */
		protected $AdjustedAmount = 0;

		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->TagID = (int)$this->TagID;
			$this->VoucherID = (int)$this->VoucherID;
			$this->SerialID = (int)$this->SerialID;
			$this->CompanyID = (int)$this->CompanyID;
			$this->AccountID = (int)$this->AccountID;
			$this->ModuleID = (int)$this->ModuleID;
			$this->RelatedID = (int)$this->RelatedID;
			$this->VoucherAmount = (double)$this->VoucherAmount;
			$this->BillAmount = (double)$this->BillAmount;
			$this->AdjustedAmount = (double)$this->AdjustedAmount;
		}

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getTagID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->TagID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->TagID;
			} else {
				return $this->TagID;
			}
		}

		public function getVoucherID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->VoucherID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->VoucherID;
			} else {
				return $this->VoucherID;
			}
		}

		public function getSerialID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->SerialID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->SerialID;
			} else {
				return $this->SerialID;
			}
		}
		
		public function getCompanyID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CompanyID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CompanyID;
			} else {
				return $this->CompanyID;
			}
		}

		public function getCompanyName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CompanyName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CompanyName;
			} else {
				return stripslashes($this->CompanyName);
			}
		}		

		public function getDOV($formatted='no') {
			if($formatted == 'yes') {
				return FormatSQLDateToIndianDate($this->DOV);
			} else if($formatted=='asis') {
				return $this->DOV;
			} else {
				return stripslashes($this->DOV);
			}
		}

		public function getAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->AccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->AccountID;
			} else {
				return $this->AccountID;
			}
		}

		public function getAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->AccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->AccountName;
			} else {
				return stripslashes($this->AccountName);
			}
		}

		public function getModuleID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ModuleID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ModuleID;
			} else {
				return $this->ModuleID;
			}
		}

		public function getRelatedID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->RelatedID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->RelatedID;
			} else {
				return $this->RelatedID;
			}
		}

		public function getVoucherAmount($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->VoucherAmount,2,'.',',');
			} else if($formatted=='asis') {
				return $this->VoucherAmount;
			} else {
				return $this->VoucherAmount;
			}
		}

		public function getBillAmount($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->BillAmount,2,'.',',');
			} else if($formatted=='asis') {
				return $this->BillAmount;
			} else {
				return $this->BillAmount;
			}
		}

		public function getAdjustedAmount($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->AdjustedAmount,2,'.',',');
			} else if($formatted=='asis') {
				return $this->AdjustedAmount;
			} else {
				return $this->AdjustedAmount;
			}
		}

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setTagID($arg) {
			$this->TagID = (int)$arg;
		}

		public function setVoucherID($arg) {
			$this->VoucherID = (int)$arg;
		}

		public function setSerialID($arg) {
			$this->SerialID = (int)$arg;
		}
		
		public function setCompanyID($arg) {
			$this->CompanyID = (int)$arg;
		}

		public function setCompanyName($arg) {
			$this->CompanyName = addslashes($arg);
		}		

		public function setDOV($arg) {
			$this->DOV = FormatIndianDateToSQLDate($arg);
		}

		public function setAccountID($arg) {
			$this->AccountID = (int)$arg;
		}

		public function setAccountName($arg) {
			$this->AccountName = addslashes($arg);
		}

		public function setModuleID($arg) {
			$this->ModuleID = (int)$arg;
		}

		public function setRelatedID($arg) {
			$this->RelatedID = (int)$arg;
		}

		public function setVoucherAmount($arg) {
			$this->VoucherAmount = (double)$arg;
		}

		public function setBillAmount($arg) {
			$this->BillAmount = (double)$arg;
		}

		public function setAdjustedAmount($arg) {
			$this->AdjustedAmount = (double)$arg;
		}

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `asys_voucher_tags` (`TagID`, `VoucherID`, `SerialID`, `CompanyID`, `DOV`, `AccountID`, `ModuleID`, `RelatedID`, `VoucherAmount`, `BillAmount`, `AdjustedAmount`) VALUES(";
			$sql	=	$sql."'".$this->getTagID('asis')."', ";
			$sql	=	$sql."'".$this->getVoucherID('asis')."', ";
			$sql	=	$sql."'".$this->getSerialID('asis')."', ";
			$sql	=	$sql."'".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."'".$this->getDOV('asis')."', ";
			$sql	=	$sql."'".$this->getAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getModuleID('asis')."', ";
			$sql	=	$sql."'".$this->getRelatedID('asis')."', ";
			$sql	=	$sql."'".$this->getVoucherAmount('asis')."', ";
			$sql	=	$sql."'".$this->getBillAmount('asis')."', ";
			$sql	=	$sql."'".$this->getAdjustedAmount('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `asys_voucher_tags` SET ";
			$sql	=	$sql."`VoucherID` = '".$this->getVoucherID('asis')."', ";
			$sql	=	$sql."`SerialID` = '".$this->getSerialID('asis')."', ";
			$sql	=	$sql."`CompanyID` = '".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."`DOV` = '".$this->getDOV('asis')."', ";
			$sql	=	$sql."`AccountID` = '".$this->getAccountID('asis')."', ";
			$sql	=	$sql."`ModuleID` = '".$this->getModuleID('asis')."', ";
			$sql	=	$sql."`RelatedID` = '".$this->getRelatedID('asis')."', ";
			$sql	=	$sql."`VoucherAmount` = '".$this->getVoucherAmount('asis')."', ";
			$sql	=	$sql."`BillAmount` = '".$this->getBillAmount('asis')."', ";
			$sql	=	$sql."`AdjustedAmount` = '".$this->getAdjustedAmount('asis')."' ";
			$sql	=	$sql." WHERE `TagID` = '".$this->getTagID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `asys_voucher_tags` ";
			$sql	=	$sql." WHERE `TagID` = '".$this->getTagID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$TagID <= 0) $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">TagID</div>
				<div style="float:left;">: '.$this->getTagID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">VoucherID</div>
				<div style="float:left;">: '.$this->getVoucherID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">SerialID</div>
				<div style="float:left;">: '.$this->getSerialID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Company</div>
				<div style="float:left;">: '.$this->getCompanyName('yes').'</div>
				<div style="clear:both;"></div>				
				<div style="float:left;width:150px;">DOV</div>
				<div style="float:left;">: '.$this->getDOV('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">AccountID</div>
				<div style="float:left;">: '.$this->getAccountID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ModuleID</div>
				<div style="float:left;">: '.$this->getModuleID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">RelatedID</div>
				<div style="float:left;">: '.$this->getRelatedID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">VoucherAmount</div>
				<div style="float:left;">: '.$this->getVoucherAmount('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">BillAmount</div>
				<div style="float:left;">: '.$this->getBillAmount('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">AdjustedAmount</div>
				<div style="float:left;">: '.$this->getAdjustedAmount('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>