<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Sep 13, 2017
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class gen_branchjournal {
		/**
		 * @Field		BookingID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $BookingID = 0;
		
		/**
		 * @Field		CompanyID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $CompanyID = 0;

		/**
		 * @Field		CompanyName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $CompanyName = "";		

		/**
		 * @Field		BookingDate
		 * @Type		date
		 * @Access	Protected
		 */
		protected $BookingDate = "1900-01-01";

		/**
		 * @Field		FinYear
		 * @Type		varchar(10)
		 * @Access	Protected
		 */
		protected $FinYear = "";

		/**
		 * @Field		BookingNo
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $BookingNo = 0;

		/**
		 * @Field		Narration
		 * @Type		varchar(200)
		 * @Access	Protected
		 */
		protected $Narration = "";

		/**
		 * @Field		Amount
		 * @Type		decimal(12,2)
		 * @Access	Protected
		 */
		protected $Amount = 0;

		/**
		 * @Field		DebitMotherAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $DebitMotherAccountID = 0;

		/**
		 * @Field		DebitMotherAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $DebitMotherAccountName = "";

		/**
		 * @Field		DebitAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $DebitAccountID = 0;

		/**
		 * @Field		DebitAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $DebitAccountName = "";

		/**
		 * @Field		CreditMotherAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CreditMotherAccountID = 0;

		/**
		 * @Field		CreditMotherAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CreditMotherAccountName = "";

		/**
		 * @Field		CreditAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CreditAccountID = 0;

		/**
		 * @Field		CreditAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CreditAccountName = "";

		/**
		 * @Field		ToCompanyID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ToCompanyID = 0;

		/**
		 * @Field		ToCompanyName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ToCompanyName = "";

		/**
		 * @Field		BranchDebitMotherAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $BranchDebitMotherAccountID = 0;

		/**
		 * @Field		BranchDebitMotherAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $BranchDebitMotherAccountName = "";

		/**
		 * @Field		BranchDebitAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $BranchDebitAccountID = 0;

		/**
		 * @Field		BranchDebitAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $BranchDebitAccountName = "";

		/**
		 * @Field		BranchCreditMotherAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $BranchCreditMotherAccountID = 0;

		/**
		 * @Field		BranchCreditMotherAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $BranchCreditMotherAccountName = "";

		/**
		 * @Field		BranchCreditAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $BranchCreditAccountID = 0;

		/**
		 * @Field		BranchCreditAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $BranchCreditAccountName = "";

		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->BookingID = (int)$this->BookingID;
			$this->CompanyID = (int)$this->CompanyID;
			$this->FinYear = addslashes($this->FinYear);
			$this->BookingNo = (int)$this->BookingNo;
			$this->Narration = addslashes($this->Narration);
			$this->Amount = (double)$this->Amount;
			$this->DebitMotherAccountID = (int)$this->DebitMotherAccountID;
			$this->DebitAccountID = (int)$this->DebitAccountID;
			$this->CreditMotherAccountID = (int)$this->CreditMotherAccountID;
			$this->CreditAccountID = (int)$this->CreditAccountID;
			$this->ToCompanyID = (int)$this->ToCompanyID;
			$this->BranchDebitMotherAccountID = (int)$this->BranchDebitMotherAccountID;
			$this->BranchDebitAccountID = (int)$this->BranchDebitAccountID;
			$this->BranchCreditMotherAccountID = (int)$this->BranchCreditMotherAccountID;
			$this->BranchCreditAccountID = (int)$this->BranchCreditAccountID;
		}

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getBookingID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->BookingID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->BookingID;
			} else {
				return $this->BookingID;
			}
		}
		
		public function getCompanyID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CompanyID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CompanyID;
			} else {
				return $this->CompanyID;
			}
		}

		public function getCompanyName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CompanyName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CompanyName;
			} else {
				return stripslashes($this->CompanyName);
			}
		}		

		public function getBookingDate($formatted='no') {
			if($formatted == 'yes') {
				return FormatSQLDateToIndianDate($this->BookingDate);
			} else if($formatted=='asis') {
				return $this->BookingDate;
			} else {
				return stripslashes($this->BookingDate);
			}
		}

		public function getFinYear($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->FinYear),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->FinYear;
			} else {
				return stripslashes($this->FinYear);
			}
		}

		public function getBookingNo($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->BookingNo,2,'.',',');
			} else if($formatted=='asis') {
				return $this->BookingNo;
			} else {
				return $this->BookingNo;
			}
		}

		public function getNarration($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Narration),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Narration;
			} else {
				return stripslashes($this->Narration);
			}
		}

		public function getAmount($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->Amount,2,'.',',');
			} else if($formatted=='asis') {
				return $this->Amount;
			} else {
				return $this->Amount;
			}
		}

		public function getDebitMotherAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->DebitMotherAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->DebitMotherAccountID;
			} else {
				return $this->DebitMotherAccountID;
			}
		}

		public function getDebitMotherAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DebitMotherAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DebitMotherAccountName;
			} else {
				return stripslashes($this->DebitMotherAccountName);
			}
		}

		public function getDebitAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->DebitAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->DebitAccountID;
			} else {
				return $this->DebitAccountID;
			}
		}

		public function getDebitAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DebitAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DebitAccountName;
			} else {
				return stripslashes($this->DebitAccountName);
			}
		}

		public function getCreditMotherAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CreditMotherAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CreditMotherAccountID;
			} else {
				return $this->CreditMotherAccountID;
			}
		}

		public function getCreditMotherAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CreditMotherAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CreditMotherAccountName;
			} else {
				return stripslashes($this->CreditMotherAccountName);
			}
		}

		public function getCreditAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CreditAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CreditAccountID;
			} else {
				return $this->CreditAccountID;
			}
		}

		public function getCreditAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CreditAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CreditAccountName;
			} else {
				return stripslashes($this->CreditAccountName);
			}
		}

		public function getToCompanyID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ToCompanyID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ToCompanyID;
			} else {
				return $this->ToCompanyID;
			}
		}

		public function getToCompanyName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ToCompanyName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ToCompanyName;
			} else {
				return stripslashes($this->ToCompanyName);
			}
		}

		public function getBranchDebitMotherAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->BranchDebitMotherAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->BranchDebitMotherAccountID;
			} else {
				return $this->BranchDebitMotherAccountID;
			}
		}

		public function getBranchDebitMotherAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->BranchDebitMotherAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->BranchDebitMotherAccountName;
			} else {
				return stripslashes($this->BranchDebitMotherAccountName);
			}
		}

		public function getBranchDebitAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->BranchDebitAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->BranchDebitAccountID;
			} else {
				return $this->BranchDebitAccountID;
			}
		}

		public function getBranchDebitAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->BranchDebitAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->BranchDebitAccountName;
			} else {
				return stripslashes($this->BranchDebitAccountName);
			}
		}

		public function getBranchCreditMotherAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->BranchCreditMotherAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->BranchCreditMotherAccountID;
			} else {
				return $this->BranchCreditMotherAccountID;
			}
		}

		public function getBranchCreditMotherAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->BranchCreditMotherAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->BranchCreditMotherAccountName;
			} else {
				return stripslashes($this->BranchCreditMotherAccountName);
			}
		}

		public function getBranchCreditAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->BranchCreditAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->BranchCreditAccountID;
			} else {
				return $this->BranchCreditAccountID;
			}
		}

		public function getBranchCreditAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->BranchCreditAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->BranchCreditAccountName;
			} else {
				return stripslashes($this->BranchCreditAccountName);
			}
		}

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setBookingID($arg) {
			$this->BookingID = (int)$arg;
		}
		
		public function setCompanyID($arg) {
			$this->CompanyID = (int)$arg;
		}

		public function setCompanyName($arg) {
			$this->CompanyName = addslashes($arg);
		}		

		public function setBookingDate($arg) {
			$this->BookingDate = FormatIndianDateToSQLDate($arg);
		}

		public function setFinYear($arg) {
			$this->FinYear = addslashes($arg);
		}

		public function setBookingNo($arg) {
			$this->BookingNo = (int)$arg;
		}

		public function setNarration($arg) {
			$this->Narration = addslashes($arg);
		}

		public function setAmount($arg) {
			$this->Amount = (double)$arg;
		}

		public function setDebitMotherAccountID($arg) {
			$this->DebitMotherAccountID = (int)$arg;
		}

		public function setDebitMotherAccountName($arg) {
			$this->DebitMotherAccountName = addslashes($arg);
		}

		public function setDebitAccountID($arg) {
			$this->DebitAccountID = (int)$arg;
		}

		public function setDebitAccountName($arg) {
			$this->DebitAccountName = addslashes($arg);
		}

		public function setCreditMotherAccountID($arg) {
			$this->CreditMotherAccountID = (int)$arg;
		}

		public function setCreditMotherAccountName($arg) {
			$this->CreditMotherAccountName = addslashes($arg);
		}

		public function setCreditAccountID($arg) {
			$this->CreditAccountID = (int)$arg;
		}

		public function setCreditAccountName($arg) {
			$this->CreditAccountName = addslashes($arg);
		}

		public function setToCompanyID($arg) {
			$this->ToCompanyID = (int)$arg;
		}

		public function setToCompanyName($arg) {
			$this->ToCompanyName = addslashes($arg);
		}

		public function setBranchDebitMotherAccountID($arg) {
			$this->BranchDebitMotherAccountID = (int)$arg;
		}

		public function setBranchDebitMotherAccountName($arg) {
			$this->BranchDebitMotherAccountName = addslashes($arg);
		}

		public function setBranchDebitAccountID($arg) {
			$this->BranchDebitAccountID = (int)$arg;
		}

		public function setBranchDebitAccountName($arg) {
			$this->BranchDebitAccountName = addslashes($arg);
		}

		public function setBranchCreditMotherAccountID($arg) {
			$this->BranchCreditMotherAccountID = (int)$arg;
		}

		public function setBranchCreditMotherAccountName($arg) {
			$this->BranchCreditMotherAccountName = addslashes($arg);
		}

		public function setBranchCreditAccountID($arg) {
			$this->BranchCreditAccountID = (int)$arg;
		}

		public function setBranchCreditAccountName($arg) {
			$this->BranchCreditAccountName = addslashes($arg);
		}

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `gen_branchjournal` (`BookingID`, `CompanyID`, `BookingDate`, `FinYear`, `BookingNo`, `Narration`, `Amount`, `DebitMotherAccountID`, `DebitAccountID`, `CreditMotherAccountID`, `CreditAccountID`, `ToCompanyID`, `BranchDebitMotherAccountID`, `BranchDebitAccountID`, `BranchCreditMotherAccountID`, `BranchCreditAccountID`) VALUES(";
			$sql	=	$sql."'".$this->getBookingID('asis')."', ";
			$sql	=	$sql."'".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."'".$this->getBookingDate('asis')."', ";
			$sql	=	$sql."'".$this->getFinYear('asis')."', ";
			$sql	=	$sql."'".$this->getBookingNo('asis')."', ";
			$sql	=	$sql."'".$this->getNarration('asis')."', ";
			$sql	=	$sql."'".$this->getAmount('asis')."', ";
			$sql	=	$sql."'".$this->getDebitMotherAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getDebitAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getCreditMotherAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getCreditAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getToCompanyID('asis')."', ";
			$sql	=	$sql."'".$this->getBranchDebitMotherAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getBranchDebitAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getBranchCreditMotherAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getBranchCreditAccountID('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `gen_branchjournal` SET ";
			$sql	=	$sql."`CompanyID` = '".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."`BookingDate` = '".$this->getBookingDate('asis')."', ";
			$sql	=	$sql."`FinYear` = '".$this->getFinYear('asis')."', ";
			$sql	=	$sql."`BookingNo` = '".$this->getBookingNo('asis')."', ";
			$sql	=	$sql."`Narration` = '".$this->getNarration('asis')."', ";
			$sql	=	$sql."`Amount` = '".$this->getAmount('asis')."', ";
			$sql	=	$sql."`DebitMotherAccountID` = '".$this->getDebitMotherAccountID('asis')."', ";
			$sql	=	$sql."`DebitAccountID` = '".$this->getDebitAccountID('asis')."', ";
			$sql	=	$sql."`CreditMotherAccountID` = '".$this->getCreditMotherAccountID('asis')."', ";
			$sql	=	$sql."`CreditAccountID` = '".$this->getCreditAccountID('asis')."', ";
			$sql	=	$sql."`ToCompanyID` = '".$this->getToCompanyID('asis')."', ";
			$sql	=	$sql."`BranchDebitMotherAccountID` = '".$this->getBranchDebitMotherAccountID('asis')."', ";
			$sql	=	$sql."`BranchDebitAccountID` = '".$this->getBranchDebitAccountID('asis')."', ";
			$sql	=	$sql."`BranchCreditMotherAccountID` = '".$this->getBranchCreditMotherAccountID('asis')."', ";
			$sql	=	$sql."`BranchCreditAccountID` = '".$this->getBranchCreditAccountID('asis')."' ";
			$sql	=	$sql." WHERE `BookingID` = '".$this->getBookingID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `gen_branchjournal` ";
			$sql	=	$sql." WHERE `BookingID` = '".$this->getBookingID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$BookingID <= 0) $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">BookingID</div>
				<div style="float:left;">: '.$this->getBookingID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">BookingDate</div>
				<div style="float:left;">: '.$this->getBookingDate('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">FinYear</div>
				<div style="float:left;">: '.$this->getFinYear('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">BookingNo</div>
				<div style="float:left;">: '.$this->getBookingNo('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Narration</div>
				<div style="float:left;">: '.$this->getNarration('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Amount</div>
				<div style="float:left;">: '.$this->getAmount('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DebitMotherAccountID</div>
				<div style="float:left;">: '.$this->getDebitMotherAccountID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DebitAccountID</div>
				<div style="float:left;">: '.$this->getDebitAccountID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">CreditMotherAccountID</div>
				<div style="float:left;">: '.$this->getCreditMotherAccountID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">CreditAccountID</div>
				<div style="float:left;">: '.$this->getCreditAccountID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">CompanyID</div>
				<div style="float:left;">: '.$this->getCompanyID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">BranchDebitMotherAccountID</div>
				<div style="float:left;">: '.$this->getBranchDebitMotherAccountID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">BranchDebitAccountID</div>
				<div style="float:left;">: '.$this->getBranchDebitAccountID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">BranchCreditMotherAccountID</div>
				<div style="float:left;">: '.$this->getBranchCreditMotherAccountID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">BranchCreditAccountID</div>
				<div style="float:left;">: '.$this->getBranchCreditAccountID('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>