<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Mar 17, 2015
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class gen_grn {
		/**
		 * @Field		GRNID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $GRNID = 0;
		
		/**
		 * @Field		CompanyID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyID = 0;

		/**
		 * @Field		CompanyName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyName = "";		

		/**
		 * @Field		GRNDate
		 * @Type		date
		 * @Access	Protected
		 */
		protected $GRNDate = "1900-01-01";

		/**
		 * @Field		FinYear
		 * @Type		varchar(5)
		 * @Access	Protected
		 */
		protected $FinYear = "";

		/**
		 * @Field		GRNNo
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $GRNNo = 0;

		/**
		 * @Field		SupplierID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $SupplierID = 0;

		/**
		 * @Field		SupplierName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $SupplierName = "";

		/**
		 * @Field		StoreID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $StoreID = 0;

		/**
		 * @Field		StoreName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $StoreName = "";

		/**
		 * @Field		ItemCategoryID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ItemCategoryID = 0;

		/**
		 * @Field		ItemCategoryName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ItemCategoryName = "";

		/**
		 * @Field		DOE
		 * @Type		text
		 * @Access	Protected
		 */
		protected $DOE = "";
		
		/**
		 * @Field		ItemTotal
		 * @Type		decimal(10,2)
		 * @Access	Protected
		 */
		protected $ItemTotal = 0;
		
		/**
		 * @Field		ChallanNo
		 * @Type		varchar(30)
		 * @Access	Protected
		 */
		protected $ChallanNo = "";

		/**
		 * @Field		ChallanDate
		 * @Type		date
		 * @Access	Protected
		 */
		protected $ChallanDate = "1900-01-01";		
		
		/**
		 * @Field		ItemList
		 * @Type		Array()
		 * @Access	Private
		 */
		var $ItemList = array();		

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getGRNID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->GRNID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->GRNID;
			} else {
				return $this->GRNID;
			}
		}
		
		public function getCompanyID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CompanyID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CompanyID;
			} else {
				return $this->CompanyID;
			}
		}

		public function getCompanyName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CompanyName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CompanyName;
			} else {
				return stripslashes($this->CompanyName);
			}
		}		

		public function getGRNDate($formatted='no') {
			if($formatted == 'yes') {
				return FormatSQLDateToIndianDate($this->GRNDate);
			} else if($formatted=='asis') {
				return $this->GRNDate;
			} else {
				return stripslashes($this->GRNDate);
			}
		}

		public function getFinYear($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->FinYear),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->FinYear;
			} else {
				return stripslashes($this->FinYear);
			}
		}

		public function getGRNNo($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->GRNNo,2,'.',',');
			} else if($formatted=='asis') {
				return $this->GRNNo;
			} else {
				return $this->GRNNo;
			}
		}

		public function getSupplierID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->SupplierID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->SupplierID;
			} else {
				return $this->SupplierID;
			}
		}

		public function getSupplierName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->SupplierName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->SupplierName;
			} else {
				return stripslashes($this->SupplierName);
			}
		}

		public function getStoreID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->StoreID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->StoreID;
			} else {
				return $this->StoreID;
			}
		}

		public function getStoreName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->StoreName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->StoreName;
			} else {
				return stripslashes($this->StoreName);
			}
		}

		public function getItemCategoryID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ItemCategoryID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ItemCategoryID;
			} else {
				return $this->ItemCategoryID;
			}
		}

		public function getItemCategoryName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ItemCategoryName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ItemCategoryName;
			} else {
				return stripslashes($this->ItemCategoryName);
			}
		}

		public function getDOE($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DOE),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DOE;
			} else {
				return stripslashes($this->DOE);
			}
		}
		
		public function getItemTotal($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ItemTotal,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ItemTotal;
			} else {
				return $this->ItemTotal;
			}
		}
		
		public function getChallanNo($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ChallanNo),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ChallanNo;
			} else {
				return stripslashes($this->ChallanNo);
			}
		}

		public function getChallanDate($formatted='no') {
			if($formatted == 'yes') {
				return FormatSQLDateToIndianDate($this->ChallanDate);
			} else if($formatted=='asis') {
				return $this->ChallanDate;
			} else {
				return stripslashes($this->ChallanDate);
			}
		}		
		
		function getItemList() {
			return $this->ItemList;
		}		

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setGRNID($arg) {
			$this->GRNID = (int)$arg;
		}
		
		public function setCompanyID($arg) {
			$this->CompanyID = (int)$arg;
		}

		public function setCompanyName($arg) {
			$this->CompanyName = addslashes($arg);
		}		

		public function setGRNDate($arg) {
			$this->GRNDate = FormatIndianDateToSQLDate($arg);
		}

		public function setFinYear($arg) {
			$this->FinYear = addslashes($arg);
		}

		public function setGRNNo($arg) {
			$this->GRNNo = (int)$arg;
		}

		public function setSupplierID($arg) {
			$this->SupplierID = (int)$arg;
		}

		public function setSupplierName($arg) {
			$this->SupplierName = addslashes($arg);
		}

		public function setStoreID($arg) {
			$this->StoreID = (int)$arg;
		}

		public function setStoreName($arg) {
			$this->StoreName = addslashes($arg);
		}

		public function setItemCategoryID($arg) {
			$this->ItemCategoryID = (int)$arg;
		}

		public function setItemCategoryName($arg) {
			$this->ItemCategoryName = addslashes($arg);
		}

		public function setDOE($arg) {
			$this->DOE = addslashes($arg);
		}
		
		public function setItemTotal($arg) {
			$this->ItemTotal = (double)$arg;
		}
		
		public function setChallanNo($arg) {
			$this->ChallanNo = addslashes($arg);
		}

		public function setChallanDate($arg) {
			$this->ChallanDate = FormatIndianDateToSQLDate($arg);
		}		
		
		function setItemList($arg) {
			$this->ItemList = $arg;
		}		

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `gen_grn` (`GRNID`, `CompanyID`, `GRNDate`, `FinYear`, `GRNNo`, `SupplierID`, `StoreID`, `ItemCategoryID`, `DOE`, `ItemTotal`, `ChallanNo`, `ChallanDate`) VALUES(";
			$sql	=	$sql."'".$this->getGRNID('asis')."', ";
			$sql	=	$sql."'".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."'".$this->getGRNDate('asis')."', ";
			$sql	=	$sql."'".$this->getFinYear('asis')."', ";
			$sql	=	$sql."'".$this->getGRNNo('asis')."', ";
			$sql	=	$sql."'".$this->getSupplierID('asis')."', ";
			$sql	=	$sql."'".$this->getStoreID('asis')."', ";
			$sql	=	$sql."'".$this->getItemCategoryID('asis')."', ";
			$sql	=	$sql."'".$this->getDOE('asis')."', ";
			$sql	=	$sql."'".$this->getItemTotal('asis')."', ";
			$sql	=	$sql."'".$this->getChallanNo('asis')."', ";
			$sql	=	$sql."'".$this->getChallanDate('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `gen_grn` SET ";
			$sql	=	$sql."`CompanyID` = '".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."`GRNDate` = '".$this->getGRNDate('asis')."', ";
			$sql	=	$sql."`FinYear` = '".$this->getFinYear('asis')."', ";
			$sql	=	$sql."`GRNNo` = '".$this->getGRNNo('asis')."', ";
			$sql	=	$sql."`SupplierID` = '".$this->getSupplierID('asis')."', ";
			$sql	=	$sql."`StoreID` = '".$this->getStoreID('asis')."', ";
			$sql	=	$sql."`ItemCategoryID` = '".$this->getItemCategoryID('asis')."', ";
			$sql	=	$sql."`DOE` = '".$this->getDOE('asis')."', ";
			$sql	=	$sql."`ItemTotal` = '".$this->getItemTotal('asis')."', ";
			$sql	=	$sql."`ChallanNo` = '".$this->getChallanNo('asis')."', ";
			$sql	=	$sql."`ChallanDate` = '".$this->getChallanDate('asis')."' ";
			$sql	=	$sql." WHERE `GRNID` = '".$this->getGRNID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `gen_grn` ";
			$sql	=	$sql." WHERE `GRNID` = '".$this->getGRNID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$GRNID <= 0) $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">GRNID</div>
				<div style="float:left;">: '.$this->getGRNID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">GRNDate</div>
				<div style="float:left;">: '.$this->getGRNDate('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">FinYear</div>
				<div style="float:left;">: '.$this->getFinYear('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">GRNNo</div>
				<div style="float:left;">: '.$this->getGRNNo('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">SupplierID</div>
				<div style="float:left;">: '.$this->getSupplierID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">StoreID</div>
				<div style="float:left;">: '.$this->getStoreID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ItemCategoryID</div>
				<div style="float:left;">: '.$this->getItemCategoryID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DOE</div>
				<div style="float:left;">: '.$this->getDOE('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>