<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Jan 01, 2016
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class gen_grn_items {
		/**
		 * @Field		GRNID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $GRNID = 0;

		/**
		 * @Field		ItemID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $ItemID = 0;

		/**
		 * @Field		ItemName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $ItemName = "";

		/**
		 * @Field		SerialNo
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $SerialNo = 0;

		/**
		 * @Field		Quantity
		 * @Type		double
		 * @Access	Protected
		 */
		protected $Quantity = 0;

		/**
		 * @Field		Rate
		 * @Type		decimal(15,5)
		 * @Access	Protected
		 */
		protected $Rate = 0;

		/**
		 * @Field		Amount
		 * @Type		decimal(12,2)
		 * @Access	Protected
		 */
		protected $Amount = 0;

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getGRNID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->GRNID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->GRNID;
			} else {
				return $this->GRNID;
			}
		}

		public function getItemID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ItemID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ItemID;
			} else {
				return $this->ItemID;
			}
		}

		public function getItemName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ItemName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ItemName;
			} else {
				return stripslashes($this->ItemName);
			}
		}

		public function getSerialNo($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->SerialNo,2,'.',',');
			} else if($formatted=='asis') {
				return $this->SerialNo;
			} else {
				return $this->SerialNo;
			}
		}

		public function getQuantity($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->Quantity,2,'.',',');
			} else if($formatted=='asis') {
				return $this->Quantity;
			} else {
				return $this->Quantity;
			}
		}

		public function getRate($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->Rate,2,'.',',');
			} else if($formatted=='asis') {
				return $this->Rate;
			} else {
				return $this->Rate;
			}
		}

		public function getAmount($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->Amount,2,'.',',');
			} else if($formatted=='asis') {
				return $this->Amount;
			} else {
				return $this->Amount;
			}
		}

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setGRNID($arg) {
			$this->GRNID = (int)$arg;
		}

		public function setItemID($arg) {
			$this->ItemID = (int)$arg;
		}

		public function setItemName($arg) {
			$this->ItemName = addslashes($arg);
		}

		public function setSerialNo($arg) {
			$this->SerialNo = (int)$arg;
		}

		public function setQuantity($arg) {
			$this->Quantity = (double)$arg;
		}

		public function setRate($arg) {
			$this->Rate = (double)$arg;
		}

		public function setAmount($arg) {
			$this->Amount = (double)$arg;
		}

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `gen_grn_items` (`GRNID`, `ItemID`, `SerialNo`, `Quantity`, `Rate`, `Amount`) VALUES(";
			$sql	=	$sql."'".$this->getGRNID('asis')."', ";
			$sql	=	$sql."'".$this->getItemID('asis')."', ";
			$sql	=	$sql."'".$this->getSerialNo('asis')."', ";
			$sql	=	$sql."'".$this->getQuantity('asis')."', ";
			$sql	=	$sql."'".$this->getRate('asis')."', ";
			$sql	=	$sql."'".$this->getAmount('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `gen_grn_items` SET ";
			$sql	=	$sql."`SerialNo` = '".$this->getSerialNo('asis')."', ";
			$sql	=	$sql."`Quantity` = '".$this->getQuantity('asis')."', ";
			$sql	=	$sql."`Rate` = '".$this->getRate('asis')."', ";
			$sql	=	$sql."`Amount` = '".$this->getAmount('asis')."' ";
			$sql	=	$sql." WHERE `GRNID` = '".$this->getGRNID('asis')."'";
			$sql	=	$sql." AND `ItemID` = '".$this->getItemID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `gen_grn_items` ";
			$sql	=	$sql." WHERE `GRNID` = '".$this->getGRNID('asis')."'";
			$sql	=	$sql." AND `ItemID` = '".$this->getItemID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$GRNID <= 0) $chk	=	false;
			if((int)$ItemID <= 0) $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">GRNID</div>
				<div style="float:left;">: '.$this->getGRNID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ItemID</div>
				<div style="float:left;">: '.$this->getItemID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">SerialNo</div>
				<div style="float:left;">: '.$this->getSerialNo('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Quantity</div>
				<div style="float:left;">: '.$this->getQuantity('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Rate</div>
				<div style="float:left;">: '.$this->getRate('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Amount</div>
				<div style="float:left;">: '.$this->getAmount('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>