<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Apr 06, 2015
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class gen_issue {
		/**
		 * @Field		IssueID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $IssueID = 0;
		
		/**
		 * @Field		CompanyID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyID = 0;

		/**
		 * @Field		CompanyName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyName = "";		

		/**
		 * @Field		IssueDate
		 * @Type		date
		 * @Access	Protected
		 */
		protected $IssueDate = "1900-01-01";

		/**
		 * @Field		FinYear
		 * @Type		varchar(5)
		 * @Access	Protected
		 */
		protected $FinYear = "";

		/**
		 * @Field		IssueNo
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $IssueNo = 0;

		/**
		 * @Field		StoreID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $StoreID = 0;

		/**
		 * @Field		StoreName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $StoreName = "";

		/**
		 * @Field		ItemCategoryID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ItemCategoryID = 0;

		/**
		 * @Field		ItemCategoryName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ItemCategoryName = "";
		
		/**
		 * @Field		DebitMotherAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $DebitMotherAccountID = 0;

		/**
		 * @Field		DebitMotherAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $DebitMotherAccountName = "";

		/**
		 * @Field		DebitAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $DebitAccountID = 0;

		/**
		 * @Field		DebitAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $DebitAccountName = "";
		
		/**
		 * @Field		CreditMotherAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $rCeditMotherAccountID = 0;

		/**
		 * @Field		CreditMotherAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CreditMotherAccountName = "";

		/**
		 * @Field		CreditAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CreditAccountID = 0;

		/**
		 * @Field		CreditAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CreditAccountName = "";				

		/**
		 * @Field		purpose
		 * @Type		varchar(200)
		 * @Access	Protected
		 */
		protected $purpose = "";

		/**
		 * @Field		DOE
		 * @Type		text
		 * @Access	Protected
		 */
		protected $DOE = "";
		
		/**
		 * @Field		RelatedID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $RelatedID = 0;		
		
		/**
		 * @Field		ItemList
		 * @Type		Array()
		 * @Access	Private
		 */
		var $ItemList = array();		

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getIssueID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->IssueID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->IssueID;
			} else {
				return $this->IssueID;
			}
		}
		
		public function getCompanyID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CompanyID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CompanyID;
			} else {
				return $this->CompanyID;
			}
		}

		public function getCompanyName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CompanyName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CompanyName;
			} else {
				return stripslashes($this->CompanyName);
			}
		}		

		public function getIssueDate($formatted='no') {
			if($formatted == 'yes') {
				return FormatSQLDateToIndianDate($this->IssueDate);
			} else if($formatted=='asis') {
				return $this->IssueDate;
			} else {
				return stripslashes($this->IssueDate);
			}
		}

		public function getFinYear($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->FinYear),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->FinYear;
			} else {
				return stripslashes($this->FinYear);
			}
		}

		public function getIssueNo($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->IssueNo,2,'.',',');
			} else if($formatted=='asis') {
				return $this->IssueNo;
			} else {
				return $this->IssueNo;
			}
		}

		public function getStoreID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->StoreID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->StoreID;
			} else {
				return $this->StoreID;
			}
		}

		public function getStoreName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->StoreName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->StoreName;
			} else {
				return stripslashes($this->StoreName);
			}
		}

		public function getItemCategoryID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ItemCategoryID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ItemCategoryID;
			} else {
				return $this->ItemCategoryID;
			}
		}

		public function getItemCategoryName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ItemCategoryName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ItemCategoryName;
			} else {
				return stripslashes($this->ItemCategoryName);
			}
		}
		
		public function getDebitMotherAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->DebitMotherAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->DebitMotherAccountID;
			} else {
				return $this->DebitMotherAccountID;
			}
		}

		public function getDebitMotherAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DebitMotherAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DebitMotherAccountName;
			} else {
				return stripslashes($this->DebitMotherAccountName);
			}
		}

		public function getDebitAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->DebitAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->DebitAccountID;
			} else {
				return $this->DebitAccountID;
			}
		}

		public function getDebitAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DebitAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DebitAccountName;
			} else {
				return stripslashes($this->DebitAccountName);
			}
		}
		
		public function getCreditMotherAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CreditMotherAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CreditMotherAccountID;
			} else {
				return $this->CreditMotherAccountID;
			}
		}

		public function getCreditMotherAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CreditMotherAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CreditMotherAccountName;
			} else {
				return stripslashes($this->CreditMotherAccountName);
			}
		}

		public function getCreditAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CreditAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CreditAccountID;
			} else {
				return $this->CreditAccountID;
			}
		}

		public function getCreditAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CreditAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CreditAccountName;
			} else {
				return stripslashes($this->CreditAccountName);
			}
		}				

		public function getpurpose($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->purpose),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->purpose;
			} else {
				return stripslashes($this->purpose);
			}
		}

		public function getDOE($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DOE),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DOE;
			} else {
				return stripslashes($this->DOE);
			}
		}
		
		public function getRelatedID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->RelatedID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->RelatedID;
			} else {
				return $this->RelatedID;
			}
		}		
		
		function getItemList() {
			return $this->ItemList;
		}		

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setIssueID($arg) {
			$this->IssueID = (int)$arg;
		}
		
		public function setCompanyID($arg) {
			$this->CompanyID = (int)$arg;
		}

		public function setCompanyName($arg) {
			$this->CompanyName = addslashes($arg);
		}		

		public function setIssueDate($arg) {
			$this->IssueDate = FormatIndianDateToSQLDate($arg);
		}

		public function setFinYear($arg) {
			$this->FinYear = addslashes($arg);
		}

		public function setIssueNo($arg) {
			$this->IssueNo = (int)$arg;
		}

		public function setStoreID($arg) {
			$this->StoreID = (int)$arg;
		}

		public function setStoreName($arg) {
			$this->StoreName = addslashes($arg);
		}

		public function setItemCategoryID($arg) {
			$this->ItemCategoryID = (int)$arg;
		}

		public function setItemCategoryName($arg) {
			$this->ItemCategoryName = addslashes($arg);
		}
		
		public function setDebitMotherAccountID($arg) {
			$this->DebitMotherAccountID = (int)$arg;
		}

		public function setDebitMotherAccountName($arg) {
			$this->DebitMotherAccountName = addslashes($arg);
		}

		public function setDebitAccountID($arg) {
			$this->DebitAccountID = (int)$arg;
		}

		public function setDebitAccountName($arg) {
			$this->DebitAccountName = addslashes($arg);
		}

		public function setCreditMotherAccountID($arg) {
			$this->CreditMotherAccountID = (int)$arg;
		}

		public function setCreditMotherAccountName($arg) {
			$this->CreditMotherAccountName = addslashes($arg);
		}

		public function setCreditAccountID($arg) {
			$this->CreditAccountID = (int)$arg;
		}

		public function setCreditAccountName($arg) {
			$this->CreditAccountName = addslashes($arg);
		}		

		public function setpurpose($arg) {
			$this->purpose = addslashes($arg);
		}

		public function setDOE($arg) {
			$this->DOE = addslashes($arg);
		}
		
		public function setRelatedID($arg) {
			$this->RelatedID = (int)$arg;
		}		
		
		function setItemList($arg) {
			$this->ItemList = $arg;
		}		

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `gen_issue` (`IssueID`, `CompanyID`, `IssueDate`, `FinYear`, `IssueNo`, `StoreID`, `ItemCategoryID`, `DebitMotherAccountID`, `DebitAccountID`, `CreditMotherAccountID`, `CreditAccountID`, `purpose`, `DOE`, `RelatedID`) VALUES(";
			$sql	=	$sql."'".$this->getIssueID('asis')."', ";
			$sql	=	$sql."'".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."'".$this->getIssueDate('asis')."', ";
			$sql	=	$sql."'".$this->getFinYear('asis')."', ";
			$sql	=	$sql."'".$this->getIssueNo('asis')."', ";
			$sql	=	$sql."'".$this->getStoreID('asis')."', ";
			$sql	=	$sql."'".$this->getItemCategoryID('asis')."', ";
			$sql	=	$sql."'".$this->getDebitMotherAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getDebitAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getCreditMotherAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getCreditAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getpurpose('asis')."', ";
			$sql	=	$sql."'".$this->getDOE('asis')."', ";
			$sql	=	$sql."'".$this->getRelatedID('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `gen_issue` SET ";
			$sql	=	$sql."`CompanyID` = '".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."`IssueDate` = '".$this->getIssueDate('asis')."', ";
			$sql	=	$sql."`FinYear` = '".$this->getFinYear('asis')."', ";
			$sql	=	$sql."`IssueNo` = '".$this->getIssueNo('asis')."', ";
			$sql	=	$sql."`StoreID` = '".$this->getStoreID('asis')."', ";
			$sql	=	$sql."`ItemCategoryID` = '".$this->getItemCategoryID('asis')."', ";
			$sql	=	$sql."`DebitMotherAccountID` = '".$this->getDebitMotherAccountID('asis')."', ";
			$sql	=	$sql."`DebitAccountID` = '".$this->getDebitAccountID('asis')."', ";
			$sql	=	$sql."`CreditMotherAccountID` = '".$this->getCreditMotherAccountID('asis')."', ";
			$sql	=	$sql."`CreditAccountID` = '".$this->getCreditAccountID('asis')."', ";
			$sql	=	$sql."`purpose` = '".$this->getpurpose('asis')."', ";
			$sql	=	$sql."`DOE` = '".$this->getDOE('asis')."', ";
			$sql	=	$sql."`RelatedID` = '".$this->getRelatedID('asis')."' ";
			$sql	=	$sql." WHERE `IssueID` = '".$this->getIssueID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `gen_issue` ";
			$sql	=	$sql." WHERE `IssueID` = '".$this->getIssueID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$IssueID <= 0) $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">IssueID</div>
				<div style="float:left;">: '.$this->getIssueID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">IssueDate</div>
				<div style="float:left;">: '.$this->getIssueDate('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">FinYear</div>
				<div style="float:left;">: '.$this->getFinYear('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">IssueNo</div>
				<div style="float:left;">: '.$this->getIssueNo('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">StoreID</div>
				<div style="float:left;">: '.$this->getStoreID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ItemCategoryID</div>
				<div style="float:left;">: '.$this->getItemCategoryID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">purpose</div>
				<div style="float:left;">: '.$this->getpurpose('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DOE</div>
				<div style="float:left;">: '.$this->getDOE('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>