<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Apr 06, 2015
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class gen_issue_items {
		/**
		 * @Field		IssueID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $IssueID = 0;

		/**
		 * @Field		ItemID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $ItemID = 0;

		/**
		 * @Field		ItemName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $ItemName = "";

		/**
		 * @Field		Quantity
		 * @Type		double
		 * @Access	Protected
		 */
		protected $Quantity = 0;

		/**
		 * @Field		Remark
		 * @Type		varchar(200)
		 * @Access	Protected
		 */
		protected $Remark = "";

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getIssueID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->IssueID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->IssueID;
			} else {
				return $this->IssueID;
			}
		}

		public function getItemID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ItemID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ItemID;
			} else {
				return $this->ItemID;
			}
		}

		public function getItemName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ItemName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ItemName;
			} else {
				return stripslashes($this->ItemName);
			}
		}

		public function getQuantity($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->Quantity,2,'.',',');
			} else if($formatted=='asis') {
				return $this->Quantity;
			} else {
				return $this->Quantity;
			}
		}

		public function getRemark($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Remark),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Remark;
			} else {
				return stripslashes($this->Remark);
			}
		}

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setIssueID($arg) {
			$this->IssueID = (int)$arg;
		}

		public function setItemID($arg) {
			$this->ItemID = (int)$arg;
		}

		public function setItemName($arg) {
			$this->ItemName = addslashes($arg);
		}

		public function setQuantity($arg) {
			$this->Quantity = (double)$arg;
		}

		public function setRemark($arg) {
			$this->Remark = addslashes($arg);
		}

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `gen_issue_items` (`IssueID`, `ItemID`, `Quantity`, `Remark`) VALUES(";
			$sql	=	$sql."'".$this->getIssueID('asis')."', ";
			$sql	=	$sql."'".$this->getItemID('asis')."', ";
			$sql	=	$sql."'".$this->getQuantity('asis')."', ";
			$sql	=	$sql."'".$this->getRemark('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `gen_issue_items` SET ";
			$sql	=	$sql."`Quantity` = '".$this->getQuantity('asis')."', ";
			$sql	=	$sql."`Remark` = '".$this->getRemark('asis')."' ";
			$sql	=	$sql." WHERE `IssueID` = '".$this->getIssueID('asis')."'";
			$sql	=	$sql." AND `ItemID` = '".$this->getItemID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `gen_issue_items` ";
			$sql	=	$sql." WHERE `IssueID` = '".$this->getIssueID('asis')."'";
			$sql	=	$sql." AND `ItemID` = '".$this->getItemID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$IssueID <= 0) $chk	=	false;
			if((int)$ItemID <= 0) $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">IssueID</div>
				<div style="float:left;">: '.$this->getIssueID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ItemID</div>
				<div style="float:left;">: '.$this->getItemID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Quantity</div>
				<div style="float:left;">: '.$this->getQuantity('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Remark</div>
				<div style="float:left;">: '.$this->getRemark('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>