<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Dec 29, 2015
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class gen_itemcategory {
		/**
		 * @Field		ItemCategoryID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ItemCategoryID = 0;

		/**
		 * @Field		CompanyID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyID = 0;

		/**
		 * @Field		CompanyName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyName = "";

		/**
		 * @Field		ItemCategoryName
		 * @Type		varchar(200)
		 * @Access	Protected
		 */
		protected $ItemCategoryName = "";

		/**
		 * @Field		FixedAsset
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $FixedAsset = "NO";

		/**
		 * @Field		DRate
		 * @Type		decimal(10,2)
		 * @Access	Protected
		 */
		protected $DRate = 0;
		
		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->ItemCategoryID = (int)$this->ItemCategoryID;
			$this->CompanyID = (int)$this->CompanyID;
			$this->ItemCategoryName = addslashes($this->ItemCategoryName);
			$this->FixedAsset = addslashes($this->FixedAsset);
			$this->DRate = (double)$this->DRate;
		}		

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getItemCategoryID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ItemCategoryID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ItemCategoryID;
			} else {
				return $this->ItemCategoryID;
			}
		}

		public function getCompanyID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CompanyID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CompanyID;
			} else {
				return $this->CompanyID;
			}
		}

		public function getCompanyName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CompanyName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CompanyName;
			} else {
				return stripslashes($this->CompanyName);
			}
		}

		public function getItemCategoryName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ItemCategoryName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ItemCategoryName;
			} else {
				return stripslashes($this->ItemCategoryName);
			}
		}

		public function getFixedAsset($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->FixedAsset),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->FixedAsset;
			} else {
				return stripslashes($this->FixedAsset);
			}
		}

		public function getDRate($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->DRate,2,'.',',');
			} else if($formatted=='asis') {
				return $this->DRate;
			} else {
				return $this->DRate;
			}
		}

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setItemCategoryID($arg) {
			$this->ItemCategoryID = (int)$arg;
		}

		public function setCompanyID($arg) {
			$this->CompanyID = (int)$arg;
		}

		public function setCompanyName($arg) {
			$this->CompanyName = addslashes($arg);
		}

		public function setItemCategoryName($arg) {
			$this->ItemCategoryName = addslashes($arg);
		}

		public function setFixedAsset($arg) {
			$this->FixedAsset = addslashes($arg);
		}

		public function setDRate($arg) {
			$this->DRate = (double)$arg;
		}

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `gen_itemcategory` (`ItemCategoryID`, `CompanyID`, `ItemCategoryName`, `FixedAsset`, `DRate`) VALUES(";
			$sql	=	$sql."'".$this->getItemCategoryID('asis')."', ";
			$sql	=	$sql."'".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."'".$this->getItemCategoryName('asis')."', ";
			$sql	=	$sql."'".$this->getFixedAsset('asis')."', ";
			$sql	=	$sql."'".$this->getDRate('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `gen_itemcategory` SET ";
			$sql	=	$sql."`CompanyID` = '".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."`ItemCategoryName` = '".$this->getItemCategoryName('asis')."', ";
			$sql	=	$sql."`FixedAsset` = '".$this->getFixedAsset('asis')."', ";
			$sql	=	$sql."`DRate` = '".$this->getDRate('asis')."' ";
			$sql	=	$sql." WHERE `ItemCategoryID` = '".$this->getItemCategoryID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `gen_itemcategory` ";
			$sql	=	$sql." WHERE `ItemCategoryID` = '".$this->getItemCategoryID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$ItemCategoryID <= 0) $chk	=	false;
			if(trim($ItemCategoryName) == "") $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">Item Category#</div>
				<div style="float:left;">: '.$this->getItemCategoryID().'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Company</div>
				<div style="float:left;">: '.$this->getCompanyName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Item Category Name</div>
				<div style="float:left;">: '.$this->getItemCategoryName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Fixed Asset?</div>
				<div style="float:left;">: '.$this->getFixedAsset('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Depreciation Rate</div>
				<div style="float:left;">: '.$this->getDRate('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>