<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Dec 29, 2015
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class gen_items {
		/**
		 * @Field		ItemID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $ItemID = 0;

		/**
		 * @Field		CompanyID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyID = 0;

		/**
		 * @Field		CompanyName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyName = "";

		/**
		 * @Field		MultipleCompany
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $MultipleCompany = "NO";

		/**
		 * @Field		ItemCategoryID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ItemCategoryID = 0;

		/**
		 * @Field		ItemCategoryName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ItemCategoryName = "";

		/**
		 * @Field		MultipleCategory
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $MultipleCategory = "NO";
		
		/**
		 * @Field		ItemSubcategoryID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ItemSubcategoryID = 0;

		/**
		 * @Field		ItemSubcategoryName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ItemSubcategoryName = "";		

		/**
		 * @Field		UnitID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $UnitID = 0;

		/**
		 * @Field		UnitName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $UnitName = "";
		
		/**
		 * @Field		Unit2
		 * @Type		varchar(100)
		 * @Access	Protected
		 */
		protected $Unit2 = "";		

		/**
		 * @Field		ItemName
		 * @Type		varchar(200)
		 * @Access	Protected
		 */
		protected $ItemName = "";

		/**
		 * @Field		ItemNo
		 * @Type		varchar(30)
		 * @Access	Protected
		 */
		protected $ItemNo = "";

		/**
		 * @Field		Rate
		 * @Type		decimal(10,2)
		 * @Access	Protected
		 */
		protected $Rate = 0;

		/**
		 * @Field		WDV
		 * @Type		decimal(10,2)
		 * @Access	Protected
		 */
		protected $WDV = 0;

		/**
		 * @Field		WDVDate
		 * @Type		date
		 * @Access	Protected
		 */
		protected $WDVDate = "1900-01-01";
		
		/**
		 * @Field		HSN
		 * @Type		varchar(30)
		 * @Access	Protected
		 */
		protected $HSN = "";

		/**
		 * @Field		GSTRate
		 * @Type		decimal(5,2)
		 * @Access	Protected
		 */
		protected $GSTRate = 0;
		
		/**
		 * @Field		GSTCategory
		 * @Type		varchar(50)
		 * @Access	Protected
		 */
		protected $GSTCategory = "";
		
		/**
		 * @Field		NilRated
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $NilRated = "NO";
		
		/**
		 * @Field		NonGST
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $NonGST = "NO";
		
		/**
		 * @Field		EAN
		 * @Type		varchar(13)
		 * @Access	Protected
		 */
		protected $EAN = "";		
		
		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->ItemID = (int)$this->ItemID;
			$this->CompanyID = (int)$this->CompanyID;
			$this->MultipleCompany = addslashes($this->MultipleCompany);
			$this->ItemCategoryID = (int)$this->ItemCategoryID;
			$this->MultipleCategory = addslashes($this->MultipleCategory);
			$this->ItemSubcategoryID = (int)$this->ItemSubcategoryID;
			$this->UnitID = (int)$this->UnitID;
			$this->Unit2 = addslashes($this->Unit2);
			$this->ItemName = addslashes($this->ItemName);
			$this->ItemNo = addslashes($this->ItemNo);
			$this->Rate = (double)$this->Rate;
			$this->WDV = (double)$this->WDV;
			$this->HSN = addslashes($this->HSN);
			$this->GSTRate = (double)$this->GSTRate;
			$this->GSTCategory = addslashes($this->GSTCategory);
			$this->NilRated = addslashes($this->NilRated);
			$this->NonGST = addslashes($this->NonGST);
			$this->EAN = addslashes($this->EAN);
		}		

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getItemID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ItemID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ItemID;
			} else {
				return $this->ItemID;
			}
		}

		public function getCompanyID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CompanyID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CompanyID;
			} else {
				return $this->CompanyID;
			}
		}

		public function getCompanyName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CompanyName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CompanyName;
			} else {
				return stripslashes($this->CompanyName);
			}
		}

		public function getMultipleCompany($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->MultipleCompany),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->MultipleCompany;
			} else {
				return stripslashes($this->MultipleCompany);
			}
		}

		public function getItemCategoryID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ItemCategoryID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ItemCategoryID;
			} else {
				return $this->ItemCategoryID;
			}
		}

		public function getItemCategoryName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ItemCategoryName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ItemCategoryName;
			} else {
				return stripslashes($this->ItemCategoryName);
			}
		}

		public function getMultipleCategory($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->MultipleCategory),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->MultipleCategory;
			} else {
				return stripslashes($this->MultipleCategory);
			}
		}
		
		public function getItemSubcategoryID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ItemSubcategoryID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ItemSubcategoryID;
			} else {
				return $this->ItemSubcategoryID;
			}
		}

		public function getItemSubcategoryName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ItemSubcategoryName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ItemSubcategoryName;
			} else {
				return stripslashes($this->ItemSubcategoryName);
			}
		}		

		public function getUnitID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->UnitID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->UnitID;
			} else {
				return $this->UnitID;
			}
		}
		
		public function getUnit2($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Unit2),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Unit2;
			} else {
				return stripslashes($this->Unit2);
			}
		}		

		public function getUnitName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->UnitName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->UnitName;
			} else {
				return stripslashes($this->UnitName);
			}
		}

		public function getItemName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ItemName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ItemName;
			} else {
				return stripslashes($this->ItemName);
			}
		}

		public function getItemNo($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ItemNo),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ItemNo;
			} else {
				return stripslashes($this->ItemNo);
			}
		}

		public function getRate($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->Rate,2,'.',',');
			} else if($formatted=='asis') {
				return $this->Rate;
			} else {
				return $this->Rate;
			}
		}

		public function getWDV($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->WDV,2,'.',',');
			} else if($formatted=='asis') {
				return $this->WDV;
			} else {
				return $this->WDV;
			}
		}

		public function getWDVDate($formatted='no') {
			if($formatted == 'yes') {
				return FormatSQLDateToIndianDate($this->WDVDate);
			} else if($formatted=='asis') {
				return $this->WDVDate;
			} else {
				return stripslashes($this->WDVDate);
			}
		}
		
		public function getHSN($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->HSN),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->HSN;
			} else {
				return stripslashes($this->HSN);
			}
		}

		public function getGSTRate($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->GSTRate,2,'.',',');
			} else if($formatted=='asis') {
				return $this->GSTRate;
			} else {
				return $this->GSTRate;
			}
		}
		
		public function getGSTCategory($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->GSTCategory),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->GSTCategory;
			} else {
				return stripslashes($this->GSTCategory);
			}
		}
		
		public function getNilRated($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->NilRated),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->NilRated;
			} else {
				return stripslashes($this->NilRated);
			}
		}
		
		public function getNonGST($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->NonGST),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->NonGST;
			} else {
				return stripslashes($this->NonGST);
			}
		}
		
		public function getEAN($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->EAN),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->EAN;
			} else {
				return stripslashes($this->EAN);
			}
		}		

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setItemID($arg) {
			$this->ItemID = (int)$arg;
		}

		public function setCompanyID($arg) {
			$this->CompanyID = (int)$arg;
		}

		public function setCompanyName($arg) {
			$this->CompanyName = addslashes($arg);
		}

		public function setMultipleCompany($arg) {
			$this->MultipleCompany = addslashes($arg);
		}

		public function setItemCategoryID($arg) {
			$this->ItemCategoryID = (int)$arg;
		}

		public function setItemCategoryName($arg) {
			$this->ItemCategoryName = addslashes($arg);
		}

		public function setMultipleCategory($arg) {
			$this->MultipleCategory = addslashes($arg);
		}
		
		public function setItemSubcategoryID($arg) {
			$this->ItemSubcategoryID = (int)$arg;
		}

		public function setItemSubcategoryName($arg) {
			$this->ItemSubcategoryName = addslashes($arg);
		}		

		public function setUnitID($arg) {
			$this->UnitID = (int)$arg;
		}

		public function setUnitName($arg) {
			$this->UnitName = addslashes($arg);
		}
		
		public function setUnit2($arg) {
			$this->Unit2 = addslashes($arg);
		}		

		public function setItemName($arg) {
			$this->ItemName = addslashes($arg);
		}

		public function setItemNo($arg) {
			$this->ItemNo = addslashes($arg);
		}

		public function setRate($arg) {
			$this->Rate = (double)$arg;
		}

		public function setWDV($arg) {
			$this->WDV = (double)$arg;
		}

		public function setWDVDate($arg) {
			$this->WDVDate = FormatIndianDateToSQLDate($arg);
		}
		
		public function setHSN($arg) {
			$this->HSN = addslashes($arg);
		}

		public function setGSTRate($arg) {
			$this->GSTRate = (double)$arg;
		}
		
		public function setGSTCategory($arg) {
			$this->GSTCategory = addslashes($arg);
		}
		
		public function setNilRated($arg) {
			$this->NilRated = addslashes($arg);
		}
		
		public function setNonGST($arg) {
			$this->NonGST = addslashes($arg);
		}
		
		public function setEAN($arg) {
			$this->EAN = addslashes($arg);
		}		

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `gen_items` (`ItemID`, `CompanyID`, `MultipleCompany`, `ItemCategoryID`, `MultipleCategory`, `ItemSubcategoryID`, `UnitID`, `Unit2`, `ItemName`, `ItemNo`, `Rate`, `WDV`, `WDVDate`, `HSN`, `GSTRate`, `GSTCategory`, `NilRated`, `NonGST`, `EAN`) VALUES(";
			$sql	=	$sql."'".$this->getItemID('asis')."', ";
			$sql	=	$sql."'".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."'".$this->getMultipleCompany('asis')."', ";
			$sql	=	$sql."'".$this->getItemCategoryID('asis')."', ";
			$sql	=	$sql."'".$this->getMultipleCategory('asis')."', ";
			$sql	=	$sql."'".$this->getItemSubcategoryID('asis')."', ";
			$sql	=	$sql."'".$this->getUnitID('asis')."', ";
			$sql	=	$sql."'".$this->getUnit2('asis')."', ";
			$sql	=	$sql."'".$this->getItemName('asis')."', ";
			$sql	=	$sql."'".$this->getItemNo('asis')."', ";
			$sql	=	$sql."'".$this->getRate('asis')."', ";
			$sql	=	$sql."'".$this->getWDV('asis')."', ";
			$sql	=	$sql."'".$this->getWDVDate('asis')."', ";
			$sql	=	$sql."'".$this->getHSN('asis')."', ";
			$sql	=	$sql."'".$this->getGSTRate('asis')."', ";
			$sql	=	$sql."'".$this->getGSTCategory('asis')."', ";
			$sql	=	$sql."'".$this->getNilRated('asis')."', ";
			$sql	=	$sql."'".$this->getNonGST('asis')."', ";
			$sql	=	$sql."'".$this->getEAN('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `gen_items` SET ";
			$sql	=	$sql."`CompanyID` = '".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."`MultipleCompany` = '".$this->getMultipleCompany('asis')."', ";
			$sql	=	$sql."`ItemCategoryID` = '".$this->getItemCategoryID('asis')."', ";
			$sql	=	$sql."`MultipleCategory` = '".$this->getMultipleCategory('asis')."', ";
			$sql	=	$sql."`ItemSubcategoryID` = '".$this->getItemSubcategoryID('asis')."', ";
			$sql	=	$sql."`UnitID` = '".$this->getUnitID('asis')."', ";
			$sql	=	$sql."`Unit2` = '".$this->getUnit2('asis')."', ";
			$sql	=	$sql."`ItemName` = '".$this->getItemName('asis')."', ";
			$sql	=	$sql."`ItemNo` = '".$this->getItemNo('asis')."', ";
			$sql	=	$sql."`Rate` = '".$this->getRate('asis')."', ";
			$sql	=	$sql."`WDV` = '".$this->getWDV('asis')."', ";
			$sql	=	$sql."`WDVDate` = '".$this->getWDVDate('asis')."', ";
			$sql	=	$sql."`HSN` = '".$this->getHSN('asis')."', ";
			$sql	=	$sql."`GSTRate` = '".$this->getGSTRate('asis')."', ";
			$sql	=	$sql."`GSTCategory` = '".$this->getGSTCategory('asis')."', ";
			$sql	=	$sql."`NilRated` = '".$this->getNilRated('asis')."', ";
			$sql	=	$sql."`NonGST` = '".$this->getNonGST('asis')."', ";
			$sql	=	$sql."`EAN` = '".$this->getEAN('asis')."' ";
			$sql	=	$sql." WHERE `ItemID` = '".$this->getItemID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `gen_items` ";
			$sql	=	$sql." WHERE `ItemID` = '".$this->getItemID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$ItemID <= 0) $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">Item#</div>
				<div style="float:left;">: '.$this->getItemID().'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Company</div>
				<div style="float:left;">: '.$this->getCompanyName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Multiple Company?</div>
				<div style="float:left;">: '.$this->getMultipleCompany('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Item Category</div>
				<div style="float:left;">: '.$this->getItemCategoryName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Multiple Category?</div>
				<div style="float:left;">: '.$this->getMultipleCategory('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Unit</div>
				<div style="float:left;">: '.$this->getUnitName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ItemName</div>
				<div style="float:left;">: '.$this->getItemName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Item No</div>
				<div style="float:left;">: '.$this->getItemNo('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Sale Rate</div>
				<div style="float:left;">: '.$this->getRate('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">HSN</div>
				<div style="float:left;">: '.$this->getHSN('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">GST Rate</div>
				<div style="float:left;">: '.$this->getGSTRate('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Nil Rated?</div>
				<div style="float:left;">: '.$this->getNilRated('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Non GST?</div>
				<div style="float:left;">: '.$this->getNonGST('yes').'</div>
				<div style="clear:both;"></div>				
			';

			return $str;
		}
	};

?>