<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Jan 24, 2017
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class gen_itemsubcategory {
		/**
		 * @Field		ItemSubcategoryID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ItemSubcategoryID = 0;

		/**
		 * @Field		ItemCategoryID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ItemCategoryID = 0;

		/**
		 * @Field		ItemCategoryName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ItemCategoryName = "";

		/**
		 * @Field		CompanyID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyID = 0;

		/**
		 * @Field		CompanyName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyName = "";

		/**
		 * @Field		ItemSubcategoryName
		 * @Type		varchar(200)
		 * @Access	Protected
		 */
		protected $ItemSubcategoryName = "";

		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->ItemSubcategoryID = (int)$this->ItemSubcategoryID;
			$this->ItemCategoryID = (int)$this->ItemCategoryID;
			$this->CompanyID = (int)$this->CompanyID;
			$this->ItemSubcategoryName = addslashes($this->ItemSubcategoryName);
		}

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getItemSubcategoryID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ItemSubcategoryID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ItemSubcategoryID;
			} else {
				return $this->ItemSubcategoryID;
			}
		}

		public function getItemCategoryID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ItemCategoryID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ItemCategoryID;
			} else {
				return $this->ItemCategoryID;
			}
		}

		public function getItemCategoryName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ItemCategoryName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ItemCategoryName;
			} else {
				return stripslashes($this->ItemCategoryName);
			}
		}

		public function getCompanyID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CompanyID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CompanyID;
			} else {
				return $this->CompanyID;
			}
		}

		public function getCompanyName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CompanyName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CompanyName;
			} else {
				return stripslashes($this->CompanyName);
			}
		}

		public function getItemSubcategoryName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ItemSubcategoryName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ItemSubcategoryName;
			} else {
				return stripslashes($this->ItemSubcategoryName);
			}
		}

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setItemSubcategoryID($arg) {
			$this->ItemSubcategoryID = (int)$arg;
		}

		public function setItemCategoryID($arg) {
			$this->ItemCategoryID = (int)$arg;
		}

		public function setItemCategoryName($arg) {
			$this->ItemCategoryName = addslashes($arg);
		}

		public function setCompanyID($arg) {
			$this->CompanyID = (int)$arg;
		}

		public function setCompanyName($arg) {
			$this->CompanyName = addslashes($arg);
		}

		public function setItemSubcategoryName($arg) {
			$this->ItemSubcategoryName = addslashes($arg);
		}

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `gen_itemsubcategory` (`ItemSubcategoryID`, `ItemCategoryID`, `CompanyID`, `ItemSubcategoryName`) VALUES(";
			$sql	=	$sql."'".$this->getItemSubcategoryID('asis')."', ";
			$sql	=	$sql."'".$this->getItemCategoryID('asis')."', ";
			$sql	=	$sql."'".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."'".$this->getItemSubcategoryName('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `gen_itemsubcategory` SET ";
			$sql	=	$sql."`ItemCategoryID` = '".$this->getItemCategoryID('asis')."', ";
			$sql	=	$sql."`CompanyID` = '".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."`ItemSubcategoryName` = '".$this->getItemSubcategoryName('asis')."' ";
			$sql	=	$sql." WHERE `ItemSubcategoryID` = '".$this->getItemSubcategoryID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `gen_itemsubcategory` ";
			$sql	=	$sql." WHERE `ItemSubcategoryID` = '".$this->getItemSubcategoryID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$ItemSubcategoryID <= 0) $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">Item Subcategory#</div>
				<div style="float:left;">: '.$this->getItemSubcategoryID().'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Item Category</div>
				<div style="float:left;">: '.$this->getItemCategoryName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Company</div>
				<div style="float:left;">: '.$this->getCompanyName('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Item Subcategory Name</div>
				<div style="float:left;">: '.$this->getItemSubcategoryName('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>