<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Jan 01, 2016
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class gen_purchase_addless {
		/**
		 * @Field		PurchaseID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $PurchaseID = 0;

		/**
		 * @Field		AccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $AccountID = 0;

		/**
		 * @Field		AccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $AccountName = "";

		/**
		 * @Field		SerialNo
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $SerialNo = 0;

		/**
		 * @Field		AddLess
		 * @Type		enum('ADD','LESS')
		 * @Access	Protected
		 */
		protected $AddLess = "ADD";

		/**
		 * @Field		CalcPercent
		 * @Type		decimal(10,2)
		 * @Access	Protected
		 */
		protected $CalcPercent = 0;

		/**
		 * @Field		CalcAmount
		 * @Type		decimal(12,2)
		 * @Access	Protected
		 */
		protected $CalcAmount = 0;

		/**
		 * @Field		Amount
		 * @Type		decimal(12,2)
		 * @Access	Protected
		 */
		protected $Amount = 0;

		/**
		 * @Field		Narration
		 * @Type		varchar(500)
		 * @Access	Protected
		 */
		protected $Narration = "";

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getPurchaseID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->PurchaseID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->PurchaseID;
			} else {
				return $this->PurchaseID;
			}
		}

		public function getAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->AccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->AccountID;
			} else {
				return $this->AccountID;
			}
		}

		public function getAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->AccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->AccountName;
			} else {
				return stripslashes($this->AccountName);
			}
		}

		public function getSerialNo($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->SerialNo,2,'.',',');
			} else if($formatted=='asis') {
				return $this->SerialNo;
			} else {
				return $this->SerialNo;
			}
		}

		public function getAddLess($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->AddLess),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->AddLess;
			} else {
				return stripslashes($this->AddLess);
			}
		}

		public function getCalcPercent($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CalcPercent,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CalcPercent;
			} else {
				return $this->CalcPercent;
			}
		}

		public function getCalcAmount($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CalcAmount,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CalcAmount;
			} else {
				return $this->CalcAmount;
			}
		}

		public function getAmount($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->Amount,2,'.',',');
			} else if($formatted=='asis') {
				return $this->Amount;
			} else {
				return $this->Amount;
			}
		}

		public function getNarration($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Narration),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Narration;
			} else {
				return stripslashes($this->Narration);
			}
		}

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setPurchaseID($arg) {
			$this->PurchaseID = (int)$arg;
		}

		public function setAccountID($arg) {
			$this->AccountID = (int)$arg;
		}

		public function setAccountName($arg) {
			$this->AccountName = addslashes($arg);
		}

		public function setSerialNo($arg) {
			$this->SerialNo = (int)$arg;
		}

		public function setAddLess($arg) {
			$this->AddLess = addslashes($arg);
		}

		public function setCalcPercent($arg) {
			$this->CalcPercent = (double)$arg;
		}

		public function setCalcAmount($arg) {
			$this->CalcAmount = (double)$arg;
		}

		public function setAmount($arg) {
			$this->Amount = (double)$arg;
		}

		public function setNarration($arg) {
			$this->Narration = addslashes($arg);
		}

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `gen_purchase_addless` (`PurchaseID`, `AccountID`, `SerialNo`, `AddLess`, `CalcPercent`, `CalcAmount`, `Amount`, `Narration`) VALUES(";
			$sql	=	$sql."'".$this->getPurchaseID('asis')."', ";
			$sql	=	$sql."'".$this->getAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getSerialNo('asis')."', ";
			$sql	=	$sql."'".$this->getAddLess('asis')."', ";
			$sql	=	$sql."'".$this->getCalcPercent('asis')."', ";
			$sql	=	$sql."'".$this->getCalcAmount('asis')."', ";
			$sql	=	$sql."'".$this->getAmount('asis')."', ";
			$sql	=	$sql."'".$this->getNarration('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `gen_purchase_addless` SET ";
			$sql	=	$sql."`SerialNo` = '".$this->getSerialNo('asis')."', ";
			$sql	=	$sql."`AddLess` = '".$this->getAddLess('asis')."', ";
			$sql	=	$sql."`CalcPercent` = '".$this->getCalcPercent('asis')."', ";
			$sql	=	$sql."`CalcAmount` = '".$this->getCalcAmount('asis')."', ";
			$sql	=	$sql."`Amount` = '".$this->getAmount('asis')."', ";
			$sql	=	$sql."`Narration` = '".$this->getNarration('asis')."' ";
			$sql	=	$sql." WHERE `PurchaseID` = '".$this->getPurchaseID('asis')."'";
			$sql	=	$sql." AND `AccountID` = '".$this->getAccountID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `gen_purchase_addless` ";
			$sql	=	$sql." WHERE `PurchaseID` = '".$this->getPurchaseID('asis')."'";
			$sql	=	$sql." AND `AccountID` = '".$this->getAccountID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$PurchaseID <= 0) $chk	=	false;
			if((int)$AccountID <= 0) $chk	=	false;

			return $chk;
		}

		public function displayFull() {	
		
			$tmp	=	$this->getCalcPercent("yes").' % of '.$this->getCalcAmount("yes");
			$str	=	'
				<tr bgcolor="#ffffff">
					<td class="td_normal">'.$this->getSerialNo("no").'</td>
					<td class="td_normal">'.$this->getAccountName("yes").'</td>
					<td class="td_normal">'.$this->getNarration("yes").'</td>
					<td class="td_normal">'.$this->getAddLess("yes").'</td>
					<td class="td_normal">'.($this->getCalcPercent("no")!=0?$tmp:'NA').'</td>
					<td class="td_normal" align="right">'.$this->getAmount("yes").'</td>
				</tr>';

			return $str;
		}
	};

?>