<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Dec 14, 2017
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class gen_purchaseorder {
		/**
		 * @Field		OrderID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $OrderID = 0;

		/**
		 * @Field		CompanyID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyID = 0;

		/**
		 * @Field		CompanyName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyName = "";

		/**
		 * @Field		PurchaseDate
		 * @Type		date
		 * @Access	Protected
		 */
		protected $PurchaseDate = "1900-01-01";

		/**
		 * @Field		FinYear
		 * @Type		varchar(10)
		 * @Access	Protected
		 */
		protected $FinYear = "";

		/**
		 * @Field		PurchaseNo
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $PurchaseNo = 0;

		/**
		 * @Field		PMotherAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $PMotherAccountID = 0;

		/**
		 * @Field		PMotherAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $PMotherAccountName = "";

		/**
		 * @Field		PAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $PAccountID = 0;

		/**
		 * @Field		PAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $PAccountName = "";

		/**
		 * @Field		SMotherAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $SMotherAccountID = 0;

		/**
		 * @Field		SMotherAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $SMotherAccountName = "";

		/**
		 * @Field		SupplierID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $SupplierID = 0;

		/**
		 * @Field		SupplierName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $SupplierName = "";

		/**
		 * @Field		StoreID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $StoreID = 0;

		/**
		 * @Field		StoreName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $StoreName = "";

		/**
		 * @Field		ItemCategoryID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ItemCategoryID = 0;

		/**
		 * @Field		ItemCategoryName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ItemCategoryName = "";

		/**
		 * @Field		SupplierBillNo
		 * @Type		varchar(50)
		 * @Access	Protected
		 */
		protected $SupplierBillNo = "";

		/**
		 * @Field		SupplierBillDate
		 * @Type		date
		 * @Access	Protected
		 */
		protected $SupplierBillDate = "1900-01-01";

		/**
		 * @Field		ItemTotal
		 * @Type		decimal(12,2)
		 * @Access	Protected
		 */
		protected $ItemTotal = 0;

		/**
		 * @Field		IGST
		 * @Type		decimal(12,2)
		 * @Access	Protected
		 */
		protected $IGST = 0;

		/**
		 * @Field		CGST
		 * @Type		decimal(12,2)
		 * @Access	Protected
		 */
		protected $CGST = 0;

		/**
		 * @Field		SGST
		 * @Type		decimal(12,2)
		 * @Access	Protected
		 */
		protected $SGST = 0;

		/**
		 * @Field		DiscountTotal
		 * @Type		decimal(12,2)
		 * @Access	Protected
		 */
		protected $DiscountTotal = 0;

		/**
		 * @Field		AddLessTotal
		 * @Type		decimal(12,2)
		 * @Access	Protected
		 */
		protected $AddLessTotal = 0;

		/**
		 * @Field		NetTotal
		 * @Type		decimal(12,2)
		 * @Access	Protected
		 */
		protected $NetTotal = 0;

		/**
		 * @Field		DOE
		 * @Type		text
		 * @Access	Protected
		 */
		protected $DOE = "";

		/**
		 * @Field		JVAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $JVAccountID = 0;

		/**
		 * @Field		JVAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $JVAccountName = "";

		/**
		 * @Field		JVAddLess
		 * @Type		enum('ADD','LESS')
		 * @Access	Protected
		 */
		protected $JVAddLess = "";

		/**
		 * @Field		JVAmount
		 * @Type		decimal(12,2)
		 * @Access	Protected
		 */
		protected $JVAmount = 0;

		/**
		 * @Field		Purpose
		 * @Type		varchar(200)
		 * @Access	Protected
		 */
		protected $Purpose = "";

		/**
		 * @Field		Narration
		 * @Type		varchar(300)
		 * @Access	Protected
		 */
		protected $Narration = "";
		
		/**
		 * @Field		Import
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $Import = "NO";

		/**
		 * @Field		Currency
		 * @Type		varchar(10)
		 * @Access	Protected
		 */
		protected $Currency = "";

		/**
		 * @Field		Conversion
		 * @Type		double
		 * @Access	Protected
		 */
		protected $Conversion = 0;

		/**
		 * @Field		CashSale
		 * @Type		enum('NO','YES')
		 * @Access	Protected
		 */
		protected $CashSale = "NO";		
		
		/**
		 * @Field		ItemList
		 * @Type		Array()
		 * @Access	Private
		 */
		var $ItemList = array();
		
		/**
		 * @Field		AddLessList
		 * @Type		Array()
		 * @Access	Private
		 */
		var $AddLessList = array();		

		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->OrderID = (int)$this->OrderID;
			$this->CompanyID = (int)$this->CompanyID;
			$this->FinYear = addslashes($this->FinYear);
			$this->PurchaseNo = (int)$this->PurchaseNo;
			$this->PMotherAccountID = (int)$this->PMotherAccountID;
			$this->PAccountID = (int)$this->PAccountID;
			$this->SMotherAccountID = (int)$this->SMotherAccountID;
			$this->SupplierID = (int)$this->SupplierID;
			$this->StoreID = (int)$this->StoreID;
			$this->ItemCategoryID = (int)$this->ItemCategoryID;
			$this->SupplierBillNo = addslashes($this->SupplierBillNo);
			$this->ItemTotal = (double)$this->ItemTotal;
			$this->IGST = (double)$this->IGST;
			$this->CGST = (double)$this->CGST;
			$this->SGST = (double)$this->SGST;
			$this->DiscountTotal = (double)$this->DiscountTotal;
			$this->AddLessTotal = (double)$this->AddLessTotal;
			$this->NetTotal = (double)$this->NetTotal;
			$this->DOE = addslashes($this->DOE);
			$this->JVAccountID = (int)$this->JVAccountID;
			$this->JVAddLess = addslashes($this->JVAddLess);
			$this->JVAmount = (double)$this->JVAmount;
			$this->Purpose = addslashes($this->Purpose);
			$this->Narration = addslashes($this->Narration);
			$this->Import = addslashes($this->Import);
			$this->Currency = addslashes($this->Currency);
			$this->Conversion = (double)$this->Conversion;
			$this->CashSale = addslashes($this->CashSale);			
		}

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getOrderID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->OrderID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->OrderID;
			} else {
				return $this->OrderID;
			}
		}

		public function getCompanyID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CompanyID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CompanyID;
			} else {
				return $this->CompanyID;
			}
		}

		public function getCompanyName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CompanyName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CompanyName;
			} else {
				return stripslashes($this->CompanyName);
			}
		}

		public function getPurchaseDate($formatted='no') {
			if($formatted == 'yes') {
				return FormatSQLDateToIndianDate($this->PurchaseDate);
			} else if($formatted=='asis') {
				return $this->PurchaseDate;
			} else {
				return stripslashes($this->PurchaseDate);
			}
		}

		public function getFinYear($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->FinYear),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->FinYear;
			} else {
				return stripslashes($this->FinYear);
			}
		}

		public function getPurchaseNo($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->PurchaseNo,2,'.',',');
			} else if($formatted=='asis') {
				return $this->PurchaseNo;
			} else {
				return $this->PurchaseNo;
			}
		}

		public function getPMotherAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->PMotherAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->PMotherAccountID;
			} else {
				return $this->PMotherAccountID;
			}
		}

		public function getPMotherAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->PMotherAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->PMotherAccountName;
			} else {
				return stripslashes($this->PMotherAccountName);
			}
		}

		public function getPAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->PAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->PAccountID;
			} else {
				return $this->PAccountID;
			}
		}

		public function getPAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->PAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->PAccountName;
			} else {
				return stripslashes($this->PAccountName);
			}
		}

		public function getSMotherAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->SMotherAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->SMotherAccountID;
			} else {
				return $this->SMotherAccountID;
			}
		}

		public function getSMotherAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->SMotherAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->SMotherAccountName;
			} else {
				return stripslashes($this->SMotherAccountName);
			}
		}

		public function getSupplierID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->SupplierID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->SupplierID;
			} else {
				return $this->SupplierID;
			}
		}

		public function getSupplierName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->SupplierName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->SupplierName;
			} else {
				return stripslashes($this->SupplierName);
			}
		}

		public function getStoreID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->StoreID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->StoreID;
			} else {
				return $this->StoreID;
			}
		}

		public function getStoreName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->StoreName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->StoreName;
			} else {
				return stripslashes($this->StoreName);
			}
		}

		public function getItemCategoryID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ItemCategoryID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ItemCategoryID;
			} else {
				return $this->ItemCategoryID;
			}
		}

		public function getItemCategoryName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ItemCategoryName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ItemCategoryName;
			} else {
				return stripslashes($this->ItemCategoryName);
			}
		}

		public function getSupplierBillNo($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->SupplierBillNo),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->SupplierBillNo;
			} else {
				return stripslashes($this->SupplierBillNo);
			}
		}

		public function getSupplierBillDate($formatted='no') {
			if($formatted == 'yes') {
				return FormatSQLDateToIndianDate($this->SupplierBillDate);
			} else if($formatted=='asis') {
				return $this->SupplierBillDate;
			} else {
				return stripslashes($this->SupplierBillDate);
			}
		}

		public function getItemTotal($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ItemTotal,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ItemTotal;
			} else {
				return $this->ItemTotal;
			}
		}

		public function getIGST($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->IGST,2,'.',',');
			} else if($formatted=='asis') {
				return $this->IGST;
			} else {
				return $this->IGST;
			}
		}

		public function getCGST($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CGST,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CGST;
			} else {
				return $this->CGST;
			}
		}

		public function getSGST($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->SGST,2,'.',',');
			} else if($formatted=='asis') {
				return $this->SGST;
			} else {
				return $this->SGST;
			}
		}

		public function getDiscountTotal($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->DiscountTotal,2,'.',',');
			} else if($formatted=='asis') {
				return $this->DiscountTotal;
			} else {
				return $this->DiscountTotal;
			}
		}

		public function getAddLessTotal($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->AddLessTotal,2,'.',',');
			} else if($formatted=='asis') {
				return $this->AddLessTotal;
			} else {
				return $this->AddLessTotal;
			}
		}

		public function getNetTotal($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->NetTotal,2,'.',',');
			} else if($formatted=='asis') {
				return $this->NetTotal;
			} else {
				return $this->NetTotal;
			}
		}

		public function getDOE($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DOE),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DOE;
			} else {
				return stripslashes($this->DOE);
			}
		}

		public function getJVAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->JVAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->JVAccountID;
			} else {
				return $this->JVAccountID;
			}
		}

		public function getJVAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->JVAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->JVAccountName;
			} else {
				return stripslashes($this->JVAccountName);
			}
		}

		public function getJVAddLess($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->JVAddLess),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->JVAddLess;
			} else {
				return stripslashes($this->JVAddLess);
			}
		}

		public function getJVAmount($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->JVAmount,2,'.',',');
			} else if($formatted=='asis') {
				return $this->JVAmount;
			} else {
				return $this->JVAmount;
			}
		}

		public function getPurpose($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Purpose),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Purpose;
			} else {
				return stripslashes($this->Purpose);
			}
		}

		public function getNarration($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Narration),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Narration;
			} else {
				return stripslashes($this->Narration);
			}
		}
		
		public function getImport($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Import),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Import;
			} else {
				return stripslashes($this->Import);
			}
		}

		public function getCurrency($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Currency),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Currency;
			} else {
				return stripslashes($this->Currency);
			}
		}

		public function getConversion($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->Conversion,2,'.',',');
			} else if($formatted=='asis') {
				return $this->Conversion;
			} else {
				return $this->Conversion;
			}
		}

		public function getCashSale($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CashSale),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CashSale;
			} else {
				return stripslashes($this->CashSale);
			}
		}		
		
		function getItemList() {
			return $this->ItemList;
		}
		
		function getAddLessList() {
			return $this->AddLessList;
		}		

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setOrderID($arg) {
			$this->OrderID = (int)$arg;
		}

		public function setCompanyID($arg) {
			$this->CompanyID = (int)$arg;
		}

		public function setCompanyName($arg) {
			$this->CompanyName = addslashes($arg);
		}

		public function setPurchaseDate($arg) {
			$this->PurchaseDate = FormatIndianDateToSQLDate($arg);
		}

		public function setFinYear($arg) {
			$this->FinYear = addslashes($arg);
		}

		public function setPurchaseNo($arg) {
			$this->PurchaseNo = (int)$arg;
		}

		public function setPMotherAccountID($arg) {
			$this->PMotherAccountID = (int)$arg;
		}

		public function setPMotherAccountName($arg) {
			$this->PMotherAccountName = addslashes($arg);
		}

		public function setPAccountID($arg) {
			$this->PAccountID = (int)$arg;
		}

		public function setPAccountName($arg) {
			$this->PAccountName = addslashes($arg);
		}

		public function setSMotherAccountID($arg) {
			$this->SMotherAccountID = (int)$arg;
		}

		public function setSMotherAccountName($arg) {
			$this->SMotherAccountName = addslashes($arg);
		}

		public function setSupplierID($arg) {
			$this->SupplierID = (int)$arg;
		}

		public function setSupplierName($arg) {
			$this->SupplierName = addslashes($arg);
		}

		public function setStoreID($arg) {
			$this->StoreID = (int)$arg;
		}

		public function setStoreName($arg) {
			$this->StoreName = addslashes($arg);
		}

		public function setItemCategoryID($arg) {
			$this->ItemCategoryID = (int)$arg;
		}

		public function setItemCategoryName($arg) {
			$this->ItemCategoryName = addslashes($arg);
		}

		public function setSupplierBillNo($arg) {
			$this->SupplierBillNo = addslashes($arg);
		}

		public function setSupplierBillDate($arg) {
			$this->SupplierBillDate = FormatIndianDateToSQLDate($arg);
		}

		public function setItemTotal($arg) {
			$this->ItemTotal = (double)$arg;
		}

		public function setIGST($arg) {
			$this->IGST = (double)$arg;
		}

		public function setCGST($arg) {
			$this->CGST = (double)$arg;
		}

		public function setSGST($arg) {
			$this->SGST = (double)$arg;
		}

		public function setDiscountTotal($arg) {
			$this->DiscountTotal = (double)$arg;
		}

		public function setAddLessTotal($arg) {
			$this->AddLessTotal = (double)$arg;
		}

		public function setNetTotal($arg) {
			$this->NetTotal = (double)$arg;
		}

		public function setDOE($arg) {
			$this->DOE = addslashes($arg);
		}

		public function setJVAccountID($arg) {
			$this->JVAccountID = (int)$arg;
		}

		public function setJVAccountName($arg) {
			$this->JVAccountName = addslashes($arg);
		}

		public function setJVAddLess($arg) {
			$this->JVAddLess = addslashes($arg);
		}

		public function setJVAmount($arg) {
			$this->JVAmount = (double)$arg;
		}

		public function setPurpose($arg) {
			$this->Purpose = addslashes($arg);
		}

		public function setNarration($arg) {
			$this->Narration = addslashes($arg);
		}
		
		public function setImport($arg) {
			$this->Import = addslashes($arg);
		}

		public function setCurrency($arg) {
			$this->Currency = addslashes($arg);
		}

		public function setConversion($arg) {
			$this->Conversion = (double)$arg;
		}

		public function setCashSale($arg) {
			$this->CashSale = addslashes($arg);
		}		
		
		function setItemList($arg) {
			$this->ItemList = $arg;
		}
		
		function setAddLessList($arg) {
			$this->AddLessList = $arg;
		}		

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `gen_purchaseorder` (`OrderID`, `CompanyID`, `PurchaseDate`, `FinYear`, `PurchaseNo`, `PMotherAccountID`, `PAccountID`, `SMotherAccountID`, `SupplierID`, `StoreID`, `ItemCategoryID`, `SupplierBillNo`, `SupplierBillDate`, `ItemTotal`, `IGST`, `CGST`, `SGST`, `DiscountTotal`, `AddLessTotal`, `NetTotal`, `DOE`, `JVAccountID`, `JVAddLess`, `JVAmount`, `Purpose`, `Narration`, `Import`, `Currency`, `Conversion`, `CashSale`) VALUES(";
			$sql	=	$sql."'".$this->getOrderID('asis')."', ";
			$sql	=	$sql."'".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."'".$this->getPurchaseDate('asis')."', ";
			$sql	=	$sql."'".$this->getFinYear('asis')."', ";
			$sql	=	$sql."'".$this->getPurchaseNo('asis')."', ";
			$sql	=	$sql."'".$this->getPMotherAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getPAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getSMotherAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getSupplierID('asis')."', ";
			$sql	=	$sql."'".$this->getStoreID('asis')."', ";
			$sql	=	$sql."'".$this->getItemCategoryID('asis')."', ";
			$sql	=	$sql."'".$this->getSupplierBillNo('asis')."', ";
			$sql	=	$sql."'".$this->getSupplierBillDate('asis')."', ";
			$sql	=	$sql."'".$this->getItemTotal('asis')."', ";
			$sql	=	$sql."'".$this->getIGST('asis')."', ";
			$sql	=	$sql."'".$this->getCGST('asis')."', ";
			$sql	=	$sql."'".$this->getSGST('asis')."', ";
			$sql	=	$sql."'".$this->getDiscountTotal('asis')."', ";
			$sql	=	$sql."'".$this->getAddLessTotal('asis')."', ";
			$sql	=	$sql."'".$this->getNetTotal('asis')."', ";
			$sql	=	$sql."'".$this->getDOE('asis')."', ";
			$sql	=	$sql."'".$this->getJVAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getJVAddLess('asis')."', ";
			$sql	=	$sql."'".$this->getJVAmount('asis')."', ";
			$sql	=	$sql."'".$this->getPurpose('asis')."', ";
			$sql	=	$sql."'".$this->getNarration('asis')."', ";
			$sql	=	$sql."'".$this->getImport('asis')."', ";
			$sql	=	$sql."'".$this->getCurrency('asis')."', ";
			$sql	=	$sql."'".$this->getConversion('asis')."', ";
			$sql	=	$sql."'".$this->getCashSale('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `gen_purchaseorder` SET ";
			$sql	=	$sql."`CompanyID` = '".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."`PurchaseDate` = '".$this->getPurchaseDate('asis')."', ";
			$sql	=	$sql."`FinYear` = '".$this->getFinYear('asis')."', ";
			$sql	=	$sql."`PurchaseNo` = '".$this->getPurchaseNo('asis')."', ";
			$sql	=	$sql."`PMotherAccountID` = '".$this->getPMotherAccountID('asis')."', ";
			$sql	=	$sql."`PAccountID` = '".$this->getPAccountID('asis')."', ";
			$sql	=	$sql."`SMotherAccountID` = '".$this->getSMotherAccountID('asis')."', ";
			$sql	=	$sql."`SupplierID` = '".$this->getSupplierID('asis')."', ";
			$sql	=	$sql."`StoreID` = '".$this->getStoreID('asis')."', ";
			$sql	=	$sql."`ItemCategoryID` = '".$this->getItemCategoryID('asis')."', ";
			$sql	=	$sql."`SupplierBillNo` = '".$this->getSupplierBillNo('asis')."', ";
			$sql	=	$sql."`SupplierBillDate` = '".$this->getSupplierBillDate('asis')."', ";
			$sql	=	$sql."`ItemTotal` = '".$this->getItemTotal('asis')."', ";
			$sql	=	$sql."`IGST` = '".$this->getIGST('asis')."', ";
			$sql	=	$sql."`CGST` = '".$this->getCGST('asis')."', ";
			$sql	=	$sql."`SGST` = '".$this->getSGST('asis')."', ";
			$sql	=	$sql."`DiscountTotal` = '".$this->getDiscountTotal('asis')."', ";
			$sql	=	$sql."`AddLessTotal` = '".$this->getAddLessTotal('asis')."', ";
			$sql	=	$sql."`NetTotal` = '".$this->getNetTotal('asis')."', ";
			$sql	=	$sql."`DOE` = '".$this->getDOE('asis')."', ";
			$sql	=	$sql."`JVAccountID` = '".$this->getJVAccountID('asis')."', ";
			$sql	=	$sql."`JVAddLess` = '".$this->getJVAddLess('asis')."', ";
			$sql	=	$sql."`JVAmount` = '".$this->getJVAmount('asis')."', ";
			$sql	=	$sql."`Purpose` = '".$this->getPurpose('asis')."', ";
			$sql	=	$sql."`Narration` = '".$this->getNarration('asis')."', ";
			$sql	=	$sql."`Import` = '".$this->getImport('asis')."', ";
			$sql	=	$sql."`Currency` = '".$this->getCurrency('asis')."', ";
			$sql	=	$sql."`Conversion` = '".$this->getConversion('asis')."', ";
			$sql	=	$sql."`CashSale` = '".$this->getCashSale('asis')."' ";
			$sql	=	$sql." WHERE `OrderID` = '".$this->getOrderID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `gen_purchaseorder` ";
			$sql	=	$sql." WHERE `OrderID` = '".$this->getOrderID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;

			return $chk;
		}

		public function displayFull() {
		
			$str	=	'<br />
			<table cellpadding="4" cellspacing="1" bgcolor="#cccccc" width="96%" align="center">
				<tr bgcolor="#f4f4f4">
					<td class="td_normal_large" width="150px">PURCHASE DETAIL</td>
					<td class="td_normal_large" align="right"></td>
				</tr>
				<tr bgcolor="#ffffff">
					<td class="td_normal">Purchase Order#</td>
					<td class="td_normal">'.$this->getPurchaseNo("no").'/'.$this->getFinYear("yes").'</td>
				</tr>
				<tr bgcolor="#ffffff">
					<td class="td_normal">Order Date</td>
					<td class="td_normal">'.$this->getPurchaseDate('yes').'</td>
				</tr>
				<tr bgcolor="#ffffff">
					<td class="td_normal">Purchase Account</td>
					<td class="td_normal">'.$this->getPAccountName("yes").'</td>
				</tr>
				<tr bgcolor="#ffffff">
					<td class="td_normal">Supplier</td>
					<td class="td_normal">'.$this->getSupplierName("yes").'</td>
				</tr>
				<tr bgcolor="#ffffff">
					<td class="td_normal">Store</td>
					<td class="td_normal">'.$this->getStoreName("yes").'</td>
				</tr>
				<tr bgcolor="#ffffff">
					<td class="td_normal">Supplier Invoice#</td>
					<td class="td_normal">'.$this->getSupplierBillNo("yes").' dated '.$this->getSupplierBillDate("yes").'</td>
				</tr>
				<tr bgcolor="#ffffff">
					<td class="td_normal">Discount Total</td>
					<td class="td_normal">'.$this->getDiscountTotal("yes").'</td>
				</tr>				
				<tr bgcolor="#ffffff">
					<td class="td_normal">Item Total</td>
					<td class="td_normal">'.$this->getItemTotal("yes").'</td>
				</tr>
				<tr bgcolor="#ffffff">
					<td class="td_normal">IGST</td>
					<td class="td_normal">'.$this->getIGST("yes").'</td>
				</tr>
				<tr bgcolor="#ffffff">
					<td class="td_normal">CGST</td>
					<td class="td_normal">'.$this->getCGST("yes").'</td>
				</tr>
				<tr bgcolor="#ffffff">
					<td class="td_normal">SGST/UGST</td>
					<td class="td_normal">'.$this->getSGST("yes").'</td>
				</tr>												
				<tr bgcolor="#ffffff">
					<td class="td_normal">Add/Less Total</td>
					<td class="td_normal">'.$this->getAddLessTotal("yes").'</td>
				</tr>
				<tr bgcolor="#ffffff">
					<td class="td_normal">Net Total</td>
					<td class="td_normal">'.$this->getNetTotal("yes").'</td>
				</tr>';
				if(count($this->ItemList)>0) {
					$str	=	$str.'<tr>
						<td colspan="2">
							<table cellpadding="4" cellspacing="1" bgcolor="#cccccc" width="100%" align="center">
								<tr><td colspan="13" class="td_normal_large" bgcolor="#f4f4f4">PRODUCTS PURCHASED</td></tr>
								<tr bgcolor="#D6E3F3">
									<td class="td_normal" width="20%"><b>Item</b></td>
									<td class="td_normal" width="6%" align="center"><b>Quantity</b></td>
									<td class="td_normal" width="6%" align="center"><b>Rate</b></td>
									<td class="td_normal" width="6%" align="center"><b>Disc%</b></td>
									<td class="td_normal" width="8%" align="center"><b>Discount</b></td>
									<td class="td_normal" width="8%" align="right"><b>Amount</b></td>
									<td class="td_normal" width="6%" align="center"><b>IGST%</b></td>
									<td class="td_normal" width="6%" align="right"><b>IGST</b></td>
									<td class="td_normal" width="6%" align="center"><b>CGST%</b></td>
									<td class="td_normal" width="6%" align="right"><b>CGST</b></td>
									<td class="td_normal" width="6%" align="center"><b>SGST%</b></td>
									<td class="td_normal" width="6%" align="right"><b>SGST</b></td>
									<td class="td_normal" width="10%" align="right"><b>Net Amount</b></td>
								</tr>';
								for($i=0;$i<count($this->ItemList);$i++) {
									$row	=	$this->ItemList[$i];
									$str	=	$str.$row->displayFull();
								}
							$str	=	$str.'</table>
						</td>
					</tr>';
				}
				if(count($this->AddLessList)>0) {
					$str	=	$str.'<tr>
						<td colspan="2">
							<table cellpadding="4" cellspacing="1" bgcolor="#cccccc" width="100%" align="center">
								<tr><td colspan="7" class="td_normal_large" bgcolor="#f4f4f4">ADD/LESS LIST</td></tr>
								<tr bgcolor="#D6E3F3">
									<td class="td_normal" width="10%"><b>Serial</b></td>
									<td class="td_normal" width="20%"><b>Account Name</b></td>
									<td class="td_normal" width="30%"><b>Narration</b></td>
									<td class="td_normal" width="10%"><b>Add/Less</b></td>
									<td class="td_normal" width="20%"><b>Percent (%) of Amount</b></td>
									<td class="td_normal" width="10%" align="right"><b>Amount</b></td>
								</tr>';
								for($i=0;$i<count($this->AddLessList);$i++) {
									$row	=	$this->AddLessList[$i];
									$str	=	$str.$row->displayFull();
								}
							$str	=	$str.'</table>
						</td>
					</tr>';
				}
			$str	=	$str.'</table>';

			return $str;
		}
	};

?>