<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Oct 16, 2017
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class gen_purchaseorder_items {
		/**
		 * @Field		OrderID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $OrderID = 0;

		/**
		 * @Field		ItemID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $ItemID = 0;

		/**
		 * @Field		ItemName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $ItemName = "";

		/**
		 * @Field		SerialNo
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $SerialNo = 0;

		/**
		 * @Field		Quantity
		 * @Type		double
		 * @Access	Protected
		 */
		protected $Quantity = 0;

		/**
		 * @Field		Rate
		 * @Type		decimal(15,5)
		 * @Access	Protected
		 */
		protected $Rate = 0;

		/**
		 * @Field		DiscPer
		 * @Type		decimal(5,2)
		 * @Access	Protected
		 */
		protected $DiscPer = 0;

		/**
		 * @Field		Discount
		 * @Type		decimal(10,2)
		 * @Access	Protected
		 */
		protected $Discount = 0;

		/**
		 * @Field		Amount
		 * @Type		decimal(12,2)
		 * @Access	Protected
		 */
		protected $Amount = 0;

		/**
		 * @Field		IGSTRate
		 * @Type		decimal(5,2)
		 * @Access	Protected
		 */
		protected $IGSTRate = 0;

		/**
		 * @Field		IGST
		 * @Type		decimal(12,2)
		 * @Access	Protected
		 */
		protected $IGST = 0;

		/**
		 * @Field		CGSTRate
		 * @Type		decimal(5,2)
		 * @Access	Protected
		 */
		protected $CGSTRate = 0;

		/**
		 * @Field		CGST
		 * @Type		decimal(12,2)
		 * @Access	Protected
		 */
		protected $CGST = 0;

		/**
		 * @Field		SGSTRate
		 * @Type		decimal(5,2)
		 * @Access	Protected
		 */
		protected $SGSTRate = 0;

		/**
		 * @Field		SGST
		 * @Type		decimal(12,2)
		 * @Access	Protected
		 */
		protected $SGST = 0;

		/**
		 * @Field		TotalAmount
		 * @Type		decimal(12,2)
		 * @Access	Protected
		 */
		protected $TotalAmount = 0;

		/**
		 * @Field		AccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $AccountID = 0;

		/**
		 * @Field		AccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $AccountName = "";

		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->OrderID = (int)$this->OrderID;
			$this->ItemID = (int)$this->ItemID;
			$this->SerialNo = (int)$this->SerialNo;
			$this->Quantity = (double)$this->Quantity;
			$this->Rate = (double)$this->Rate;
			$this->DiscPer = (double)$this->DiscPer;
			$this->Discount = (double)$this->Discount;
			$this->Amount = (double)$this->Amount;
			$this->IGSTRate = (double)$this->IGSTRate;
			$this->IGST = (double)$this->IGST;
			$this->CGSTRate = (double)$this->CGSTRate;
			$this->CGST = (double)$this->CGST;
			$this->SGSTRate = (double)$this->SGSTRate;
			$this->SGST = (double)$this->SGST;
			$this->TotalAmount = (double)$this->TotalAmount;
			$this->AccountID = (int)$this->AccountID;
		}

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getOrderID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->OrderID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->OrderID;
			} else {
				return $this->OrderID;
			}
		}

		public function getItemID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ItemID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ItemID;
			} else {
				return $this->ItemID;
			}
		}

		public function getItemName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ItemName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ItemName;
			} else {
				return stripslashes($this->ItemName);
			}
		}

		public function getSerialNo($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->SerialNo,2,'.',',');
			} else if($formatted=='asis') {
				return $this->SerialNo;
			} else {
				return $this->SerialNo;
			}
		}

		public function getQuantity($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->Quantity,2,'.',',');
			} else if($formatted=='asis') {
				return $this->Quantity;
			} else {
				return $this->Quantity;
			}
		}

		public function getRate($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->Rate,2,'.',',');
			} else if($formatted=='asis') {
				return $this->Rate;
			} else {
				return $this->Rate;
			}
		}

		public function getDiscPer($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->DiscPer,2,'.',',');
			} else if($formatted=='asis') {
				return $this->DiscPer;
			} else {
				return $this->DiscPer;
			}
		}

		public function getDiscount($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->Discount,2,'.',',');
			} else if($formatted=='asis') {
				return $this->Discount;
			} else {
				return $this->Discount;
			}
		}

		public function getAmount($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->Amount,2,'.',',');
			} else if($formatted=='asis') {
				return $this->Amount;
			} else {
				return $this->Amount;
			}
		}

		public function getIGSTRate($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->IGSTRate,2,'.',',');
			} else if($formatted=='asis') {
				return $this->IGSTRate;
			} else {
				return $this->IGSTRate;
			}
		}

		public function getIGST($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->IGST,2,'.',',');
			} else if($formatted=='asis') {
				return $this->IGST;
			} else {
				return $this->IGST;
			}
		}

		public function getCGSTRate($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CGSTRate,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CGSTRate;
			} else {
				return $this->CGSTRate;
			}
		}

		public function getCGST($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CGST,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CGST;
			} else {
				return $this->CGST;
			}
		}

		public function getSGSTRate($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->SGSTRate,2,'.',',');
			} else if($formatted=='asis') {
				return $this->SGSTRate;
			} else {
				return $this->SGSTRate;
			}
		}

		public function getSGST($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->SGST,2,'.',',');
			} else if($formatted=='asis') {
				return $this->SGST;
			} else {
				return $this->SGST;
			}
		}

		public function getTotalAmount($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->TotalAmount,2,'.',',');
			} else if($formatted=='asis') {
				return $this->TotalAmount;
			} else {
				return $this->TotalAmount;
			}
		}

		public function getAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->AccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->AccountID;
			} else {
				return $this->AccountID;
			}
		}

		public function getAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->AccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->AccountName;
			} else {
				return stripslashes($this->AccountName);
			}
		}

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setOrderID($arg) {
			$this->OrderID = (int)$arg;
		}

		public function setItemID($arg) {
			$this->ItemID = (int)$arg;
		}

		public function setItemName($arg) {
			$this->ItemName = addslashes($arg);
		}

		public function setSerialNo($arg) {
			$this->SerialNo = (int)$arg;
		}

		public function setQuantity($arg) {
			$this->Quantity = (double)$arg;
		}

		public function setRate($arg) {
			$this->Rate = (double)$arg;
		}

		public function setDiscPer($arg) {
			$this->DiscPer = (double)$arg;
		}

		public function setDiscount($arg) {
			$this->Discount = (double)$arg;
		}

		public function setAmount($arg) {
			$this->Amount = (double)$arg;
		}

		public function setIGSTRate($arg) {
			$this->IGSTRate = (double)$arg;
		}

		public function setIGST($arg) {
			$this->IGST = (double)$arg;
		}

		public function setCGSTRate($arg) {
			$this->CGSTRate = (double)$arg;
		}

		public function setCGST($arg) {
			$this->CGST = (double)$arg;
		}

		public function setSGSTRate($arg) {
			$this->SGSTRate = (double)$arg;
		}

		public function setSGST($arg) {
			$this->SGST = (double)$arg;
		}

		public function setTotalAmount($arg) {
			$this->TotalAmount = (double)$arg;
		}

		public function setAccountID($arg) {
			$this->AccountID = (int)$arg;
		}

		public function setAccountName($arg) {
			$this->AccountName = addslashes($arg);
		}

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `gen_purchaseorder_items` (`OrderID`, `ItemID`, `SerialNo`, `Quantity`, `Rate`, `DiscPer`, `Discount`, `Amount`, `IGSTRate`, `IGST`, `CGSTRate`, `CGST`, `SGSTRate`, `SGST`, `TotalAmount`, `AccountID`) VALUES(";
			$sql	=	$sql."'".$this->getOrderID('asis')."', ";
			$sql	=	$sql."'".$this->getItemID('asis')."', ";
			$sql	=	$sql."'".$this->getSerialNo('asis')."', ";
			$sql	=	$sql."'".$this->getQuantity('asis')."', ";
			$sql	=	$sql."'".$this->getRate('asis')."', ";
			$sql	=	$sql."'".$this->getDiscPer('asis')."', ";
			$sql	=	$sql."'".$this->getDiscount('asis')."', ";
			$sql	=	$sql."'".$this->getAmount('asis')."', ";
			$sql	=	$sql."'".$this->getIGSTRate('asis')."', ";
			$sql	=	$sql."'".$this->getIGST('asis')."', ";
			$sql	=	$sql."'".$this->getCGSTRate('asis')."', ";
			$sql	=	$sql."'".$this->getCGST('asis')."', ";
			$sql	=	$sql."'".$this->getSGSTRate('asis')."', ";
			$sql	=	$sql."'".$this->getSGST('asis')."', ";
			$sql	=	$sql."'".$this->getTotalAmount('asis')."', ";
			$sql	=	$sql."'".$this->getAccountID('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `gen_purchaseorder_items` SET ";
			$sql	=	$sql."`SerialNo` = '".$this->getSerialNo('asis')."', ";
			$sql	=	$sql."`Quantity` = '".$this->getQuantity('asis')."', ";
			$sql	=	$sql."`Rate` = '".$this->getRate('asis')."', ";
			$sql	=	$sql."`DiscPer` = '".$this->getDiscPer('asis')."', ";
			$sql	=	$sql."`Discount` = '".$this->getDiscount('asis')."', ";
			$sql	=	$sql."`Amount` = '".$this->getAmount('asis')."', ";
			$sql	=	$sql."`IGSTRate` = '".$this->getIGSTRate('asis')."', ";
			$sql	=	$sql."`IGST` = '".$this->getIGST('asis')."', ";
			$sql	=	$sql."`CGSTRate` = '".$this->getCGSTRate('asis')."', ";
			$sql	=	$sql."`CGST` = '".$this->getCGST('asis')."', ";
			$sql	=	$sql."`SGSTRate` = '".$this->getSGSTRate('asis')."', ";
			$sql	=	$sql."`SGST` = '".$this->getSGST('asis')."', ";
			$sql	=	$sql."`TotalAmount` = '".$this->getTotalAmount('asis')."', ";
			$sql	=	$sql."`AccountID` = '".$this->getAccountID('asis')."' ";
			$sql	=	$sql." WHERE `OrderID` = '".$this->getOrderID('asis')."'";
			$sql	=	$sql." AND `ItemID` = '".$this->getItemID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `gen_purchaseorder_items` ";
			$sql	=	$sql." WHERE `OrderID` = '".$this->getOrderID('asis')."'";
			$sql	=	$sql." AND `ItemID` = '".$this->getItemID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$OrderID <= 0) $chk	=	false;
			if((int)$ItemID <= 0) $chk	=	false;

			return $chk;
		}

		public function displayFull() {		

			$str	=	'
				<tr bgcolor="#ffffff">
					<td class="td_normal">'.$this->getItemName('yes').'</td>
					<td class="td_normal" align="center">'.$this->getQuantity('yes').'</td>
					<td class="td_normal" align="center">'.$this->getRate('yes').'</td>
					<td class="td_normal" align="center">'.$this->getDiscPer('yes').'</td>
					<td class="td_normal" align="right">'.$this->getDiscount('yes').'</td>
					<td class="td_normal" align="right">'.$this->getAmount('yes').'</td>
					<td class="td_normal" align="center">'.$this->getIGSTRate('yes').'</td>
					<td class="td_normal" align="right">'.$this->getIGST('yes').'</td>
					<td class="td_normal" align="center">'.$this->getCGSTRate('yes').'</td>
					<td class="td_normal" align="right">'.$this->getCGST('yes').'</td>
					<td class="td_normal" align="center">'.$this->getSGSTRate('yes').'</td>
					<td class="td_normal" align="right">'.$this->getSGST('yes').'</td>
					<td class="td_normal" align="right">'.$this->getTotalAmount('yes').'</td>
				</tr>
			';

			return $str;
		}
	};

?>