<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Jan 01, 2016
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class gen_purchasereturn {
		/**
		 * @Field		ReturnID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $ReturnID = 0;

		/**
		 * @Field		CompanyID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyID = 0;

		/**
		 * @Field		CompanyName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyName = "";

		/**
		 * @Field		ReturnDate
		 * @Type		date
		 * @Access	Protected
		 */
		protected $ReturnDate = "1900-01-01";

		/**
		 * @Field		FinYear
		 * @Type		varchar(10)
		 * @Access	Protected
		 */
		protected $FinYear = "";

		/**
		 * @Field		ReturnNo
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $ReturnNo = 0;

		/**
		 * @Field		PMotherAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $PMotherAccountID = 0;

		/**
		 * @Field		PMotherAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $PMotherAccountName = "";

		/**
		 * @Field		PAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $PAccountID = 0;

		/**
		 * @Field		PAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $PAccountName = "";

		/**
		 * @Field		SupplierID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $SupplierID = 0;

		/**
		 * @Field		SupplierName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $SupplierName = "";

		/**
		 * @Field		StoreID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $StoreID = 0;

		/**
		 * @Field		StoreName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $StoreName = "";

		/**
		 * @Field		ItemCategoryID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ItemCategoryID = 0;

		/**
		 * @Field		ItemCategoryName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ItemCategoryName = "";

		/**
		 * @Field		ItemTotal
		 * @Type		decimal(12,2)
		 * @Access	Protected
		 */
		protected $ItemTotal = 0;
		
		/**
		 * @Field		IGST
		 * @Type		decimal(12,2)
		 * @Access	Protected
		 */
		protected $IGST = 0;

		/**
		 * @Field		CGST
		 * @Type		decimal(12,2)
		 * @Access	Protected
		 */
		protected $CGST = 0;

		/**
		 * @Field		SGST
		 * @Type		decimal(12,2)
		 * @Access	Protected
		 */
		protected $SGST = 0;

		/**
		 * @Field		DiscountTotal
		 * @Type		decimal(12,2)
		 * @Access	Protected
		 */
		protected $DiscountTotal = 0;		

		/**
		 * @Field		AddLessTotal
		 * @Type		decimal(12,2)
		 * @Access	Protected
		 */
		protected $AddLessTotal = 0;

		/**
		 * @Field		NetTotal
		 * @Type		decimal(12,2)
		 * @Access	Protected
		 */
		protected $NetTotal = 0;

		/**
		 * @Field		DOE
		 * @Type		text
		 * @Access	Protected
		 */
		protected $DOE = "";
		
		/**
		 * @Field		StockEntry
		 * @Type		enum('YES','NO')
		 * @Access	Protected
		 */
		protected $StockEntry = "YES";		
		
		/**
		 * @Field		ItemList
		 * @Type		Array()
		 * @Access	Private
		 */
		var $ItemList = array();
		
		/**
		 * @Field		AddLessList
		 * @Type		Array()
		 * @Access	Private
		 */
		var $AddLessList = array();
		
		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->ReturnID = (int)$this->ReturnID;
			$this->CompanyID = (int)$this->CompanyID;
			$this->FinYear = addslashes($this->FinYear);
			$this->ReturnNo = (int)$this->ReturnNo;
			$this->PMotherAccountID = (int)$this->PMotherAccountID;
			$this->PAccountID = (int)$this->PAccountID;
			$this->SupplierID = (int)$this->SupplierID;
			$this->StoreID = (int)$this->StoreID;
			$this->ItemCategoryID = (int)$this->ItemCategoryID;
			$this->ItemTotal = (double)$this->ItemTotal;
			$this->IGST = (double)$this->IGST;
			$this->CGST = (double)$this->CGST;
			$this->SGST = (double)$this->SGST;
			$this->DiscountTotal = (double)$this->DiscountTotal;
			$this->AddLessTotal = (double)$this->AddLessTotal;
			$this->NetTotal = (double)$this->NetTotal;
			$this->DOE = addslashes($this->DOE);
			$this->StockEntry = addslashes($this->StockEntry);
		}		

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getReturnID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ReturnID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ReturnID;
			} else {
				return $this->ReturnID;
			}
		}

		public function getCompanyID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CompanyID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CompanyID;
			} else {
				return $this->CompanyID;
			}
		}

		public function getCompanyName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CompanyName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CompanyName;
			} else {
				return stripslashes($this->CompanyName);
			}
		}

		public function getReturnDate($formatted='no') {
			if($formatted == 'yes') {
				return FormatSQLDateToIndianDate($this->ReturnDate);
			} else if($formatted=='asis') {
				return $this->ReturnDate;
			} else {
				return stripslashes($this->ReturnDate);
			}
		}

		public function getFinYear($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->FinYear),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->FinYear;
			} else {
				return stripslashes($this->FinYear);
			}
		}

		public function getReturnNo($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ReturnNo,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ReturnNo;
			} else {
				return $this->ReturnNo;
			}
		}

		public function getPMotherAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->PMotherAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->PMotherAccountID;
			} else {
				return $this->PMotherAccountID;
			}
		}

		public function getPMotherAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->PMotherAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->PMotherAccountName;
			} else {
				return stripslashes($this->PMotherAccountName);
			}
		}

		public function getPAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->PAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->PAccountID;
			} else {
				return $this->PAccountID;
			}
		}

		public function getPAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->PAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->PAccountName;
			} else {
				return stripslashes($this->PAccountName);
			}
		}

		public function getSupplierID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->SupplierID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->SupplierID;
			} else {
				return $this->SupplierID;
			}
		}

		public function getSupplierName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->SupplierName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->SupplierName;
			} else {
				return stripslashes($this->SupplierName);
			}
		}

		public function getStoreID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->StoreID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->StoreID;
			} else {
				return $this->StoreID;
			}
		}

		public function getStoreName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->StoreName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->StoreName;
			} else {
				return stripslashes($this->StoreName);
			}
		}

		public function getItemCategoryID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ItemCategoryID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ItemCategoryID;
			} else {
				return $this->ItemCategoryID;
			}
		}

		public function getItemCategoryName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ItemCategoryName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ItemCategoryName;
			} else {
				return stripslashes($this->ItemCategoryName);
			}
		}

		public function getItemTotal($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ItemTotal,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ItemTotal;
			} else {
				return $this->ItemTotal;
			}
		}
		
		public function getIGST($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->IGST,2,'.',',');
			} else if($formatted=='asis') {
				return $this->IGST;
			} else {
				return $this->IGST;
			}
		}

		public function getCGST($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CGST,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CGST;
			} else {
				return $this->CGST;
			}
		}

		public function getSGST($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->SGST,2,'.',',');
			} else if($formatted=='asis') {
				return $this->SGST;
			} else {
				return $this->SGST;
			}
		}

		public function getDiscountTotal($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->DiscountTotal,2,'.',',');
			} else if($formatted=='asis') {
				return $this->DiscountTotal;
			} else {
				return $this->DiscountTotal;
			}
		}		

		public function getAddLessTotal($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->AddLessTotal,2,'.',',');
			} else if($formatted=='asis') {
				return $this->AddLessTotal;
			} else {
				return $this->AddLessTotal;
			}
		}

		public function getNetTotal($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->NetTotal,2,'.',',');
			} else if($formatted=='asis') {
				return $this->NetTotal;
			} else {
				return $this->NetTotal;
			}
		}

		public function getDOE($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DOE),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DOE;
			} else {
				return stripslashes($this->DOE);
			}
		}
		
		public function getStockEntry($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->StockEntry),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->StockEntry;
			} else {
				return stripslashes($this->StockEntry);
			}
		}		
		
		function getItemList() {
			return $this->ItemList;
		}
		
		function getAddLessList() {
			return $this->AddLessList;
		}		

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setReturnID($arg) {
			$this->ReturnID = (int)$arg;
		}

		public function setCompanyID($arg) {
			$this->CompanyID = (int)$arg;
		}

		public function setCompanyName($arg) {
			$this->CompanyName = addslashes($arg);
		}

		public function setReturnDate($arg) {
			$this->ReturnDate = FormatIndianDateToSQLDate($arg);
		}

		public function setFinYear($arg) {
			$this->FinYear = addslashes($arg);
		}

		public function setReturnNo($arg) {
			$this->ReturnNo = (int)$arg;
		}

		public function setPMotherAccountID($arg) {
			$this->PMotherAccountID = (int)$arg;
		}

		public function setPMotherAccountName($arg) {
			$this->PMotherAccountName = addslashes($arg);
		}

		public function setPAccountID($arg) {
			$this->PAccountID = (int)$arg;
		}

		public function setPAccountName($arg) {
			$this->PAccountName = addslashes($arg);
		}

		public function setSupplierID($arg) {
			$this->SupplierID = (int)$arg;
		}

		public function setSupplierName($arg) {
			$this->SupplierName = addslashes($arg);
		}

		public function setStoreID($arg) {
			$this->StoreID = (int)$arg;
		}

		public function setStoreName($arg) {
			$this->StoreName = addslashes($arg);
		}

		public function setItemCategoryID($arg) {
			$this->ItemCategoryID = (int)$arg;
		}

		public function setItemCategoryName($arg) {
			$this->ItemCategoryName = addslashes($arg);
		}

		public function setItemTotal($arg) {
			$this->ItemTotal = (double)$arg;
		}
		
		public function setIGST($arg) {
			$this->IGST = (double)$arg;
		}

		public function setCGST($arg) {
			$this->CGST = (double)$arg;
		}

		public function setSGST($arg) {
			$this->SGST = (double)$arg;
		}

		public function setDiscountTotal($arg) {
			$this->DiscountTotal = (double)$arg;
		}		

		public function setAddLessTotal($arg) {
			$this->AddLessTotal = (double)$arg;
		}

		public function setNetTotal($arg) {
			$this->NetTotal = (double)$arg;
		}

		public function setDOE($arg) {
			$this->DOE = addslashes($arg);
		}
		
		public function setStockEntry($arg) {
			$this->StockEntry = addslashes($arg);
		}		
		
		function setItemList($arg) {
			$this->ItemList = $arg;
		}
		
		function setAddLessList($arg) {
			$this->AddLessList = $arg;
		}		

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `gen_purchasereturn` (`ReturnID`, `CompanyID`, `ReturnDate`, `FinYear`, `ReturnNo`, `PMotherAccountID`, `PAccountID`, `SupplierID`, `StoreID`, `ItemCategoryID`, `ItemTotal`, `IGST`, `CGST`, `SGST`, `DiscountTotal`, `AddLessTotal`, `NetTotal`, `DOE`, `StockEntry`) VALUES(";
			$sql	=	$sql."'".$this->getReturnID('asis')."', ";
			$sql	=	$sql."'".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."'".$this->getReturnDate('asis')."', ";
			$sql	=	$sql."'".$this->getFinYear('asis')."', ";
			$sql	=	$sql."'".$this->getReturnNo('asis')."', ";
			$sql	=	$sql."'".$this->getPMotherAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getPAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getSupplierID('asis')."', ";
			$sql	=	$sql."'".$this->getStoreID('asis')."', ";
			$sql	=	$sql."'".$this->getItemCategoryID('asis')."', ";
			$sql	=	$sql."'".$this->getItemTotal('asis')."', ";
			$sql	=	$sql."'".$this->getIGST('asis')."', ";
			$sql	=	$sql."'".$this->getCGST('asis')."', ";
			$sql	=	$sql."'".$this->getSGST('asis')."', ";
			$sql	=	$sql."'".$this->getDiscountTotal('asis')."', ";
			$sql	=	$sql."'".$this->getAddLessTotal('asis')."', ";
			$sql	=	$sql."'".$this->getNetTotal('asis')."', ";
			$sql	=	$sql."'".$this->getDOE('asis')."', ";
			$sql	=	$sql."'".$this->getStockEntry('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `gen_purchasereturn` SET ";
			$sql	=	$sql."`CompanyID` = '".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."`ReturnDate` = '".$this->getReturnDate('asis')."', ";
			$sql	=	$sql."`FinYear` = '".$this->getFinYear('asis')."', ";
			$sql	=	$sql."`ReturnNo` = '".$this->getReturnNo('asis')."', ";
			$sql	=	$sql."`PMotherAccountID` = '".$this->getPMotherAccountID('asis')."', ";
			$sql	=	$sql."`PAccountID` = '".$this->getPAccountID('asis')."', ";
			$sql	=	$sql."`SupplierID` = '".$this->getSupplierID('asis')."', ";
			$sql	=	$sql."`StoreID` = '".$this->getStoreID('asis')."', ";
			$sql	=	$sql."`ItemCategoryID` = '".$this->getItemCategoryID('asis')."', ";
			$sql	=	$sql."`ItemTotal` = '".$this->getItemTotal('asis')."', ";
			$sql	=	$sql."`IGST` = '".$this->getIGST('asis')."', ";
			$sql	=	$sql."`CGST` = '".$this->getCGST('asis')."', ";
			$sql	=	$sql."`SGST` = '".$this->getSGST('asis')."', ";
			$sql	=	$sql."`DiscountTotal` = '".$this->getDiscountTotal('asis')."', ";
			$sql	=	$sql."`AddLessTotal` = '".$this->getAddLessTotal('asis')."', ";
			$sql	=	$sql."`NetTotal` = '".$this->getNetTotal('asis')."', ";
			$sql	=	$sql."`DOE` = '".$this->getDOE('asis')."', ";
			$sql	=	$sql."`StockEntry` = '".$this->getStockEntry('asis')."' ";
			$sql	=	$sql." WHERE `ReturnID` = '".$this->getReturnID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `gen_purchasereturn` ";
			$sql	=	$sql." WHERE `ReturnID` = '".$this->getReturnID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$ReturnID <= 0) $chk	=	false;

			return $chk;
		}

		public function displayFull() {		

			$str	=	'<br />
			<table cellpadding="4" cellspacing="1" bgcolor="#cccccc" width="96%" align="center">
				<tr bgcolor="#f4f4f4">
					<td class="td_normal_large" width="150px">PURCHASE RETURN DETAIL</td>
					<td class="td_normal_large" align="right"></td>
				</tr>
				<tr bgcolor="#ffffff">
					<td class="td_normal">Return#</td>
					<td class="td_normal">'.$this->getReturnNo("no").'/'.$this->getFinYear("yes").'</td>
				</tr>
				<tr bgcolor="#ffffff">
					<td class="td_normal">Purchase Date</td>
					<td class="td_normal">'.$this->getReturnDate('yes').'</td>
				</tr>
				<tr bgcolor="#ffffff">
					<td class="td_normal">Purchase Account</td>
					<td class="td_normal">'.$this->getPAccountName("yes").'</td>
				</tr>
				<tr bgcolor="#ffffff">
					<td class="td_normal">Supplier</td>
					<td class="td_normal">'.$this->getSupplierName("yes").'</td>
				</tr>
				<tr bgcolor="#ffffff">
					<td class="td_normal">Store</td>
					<td class="td_normal">'.$this->getStoreName("yes").'</td>
				</tr>
				<tr bgcolor="#ffffff">
					<td class="td_normal">Discount Total</td>
					<td class="td_normal">'.$this->getDiscountTotal("yes").'</td>
				</tr>				
				<tr bgcolor="#ffffff">
					<td class="td_normal">Item Total</td>
					<td class="td_normal">'.$this->getItemTotal("yes").'</td>
				</tr>
				<tr bgcolor="#ffffff">
					<td class="td_normal">IGST</td>
					<td class="td_normal">'.$this->getIGST("yes").'</td>
				</tr>
				<tr bgcolor="#ffffff">
					<td class="td_normal">CGST</td>
					<td class="td_normal">'.$this->getCGST("yes").'</td>
				</tr>
				<tr bgcolor="#ffffff">
					<td class="td_normal">SGST</td>
					<td class="td_normal">'.$this->getSGST("yes").'</td>
				</tr>												
				<tr bgcolor="#ffffff">
					<td class="td_normal">Add/Less Total</td>
					<td class="td_normal">'.$this->getAddLessTotal("yes").'</td>
				</tr>
				<tr bgcolor="#ffffff">
					<td class="td_normal">Net Total</td>
					<td class="td_normal">'.$this->getNetTotal("yes").'</td>
				</tr>';
				if(count($this->ItemList)>0) {
					$str	=	$str.'<tr>
						<td colspan="2">
							<table cellpadding="4" cellspacing="1" bgcolor="#cccccc" width="100%" align="center">
								<tr><td colspan="13" class="td_normal_large" bgcolor="#f4f4f4">PRODUCTS RETURNED</td></tr>
								<tr bgcolor="#D6E3F3">
									<td class="td_normal" width="20%"><b>Item</b></td>
									<td class="td_normal" width="6%" align="center"><b>Quantity</b></td>
									<td class="td_normal" width="6%" align="center"><b>Rate</b></td>
									<td class="td_normal" width="6%" align="center"><b>Disc%</b></td>
									<td class="td_normal" width="8%" align="center"><b>Discount</b></td>
									<td class="td_normal" width="8%" align="right"><b>Amount</b></td>
									<td class="td_normal" width="6%" align="center"><b>IGST%</b></td>
									<td class="td_normal" width="6%" align="right"><b>IGST</b></td>
									<td class="td_normal" width="6%" align="center"><b>CGST%</b></td>
									<td class="td_normal" width="6%" align="right"><b>CGST</b></td>
									<td class="td_normal" width="6%" align="center"><b>SGST%</b></td>
									<td class="td_normal" width="6%" align="right"><b>SGST</b></td>
									<td class="td_normal" width="10%" align="right"><b>Net Amount</b></td>
								</tr>';
								for($i=0;$i<count($this->ItemList);$i++) {
									$row	=	$this->ItemList[$i];
									$str	=	$str.$row->displayFull();
								}
							$str	=	$str.'</table>
						</td>
					</tr>';
				}
				if(count($this->AddLessList)>0) {
					$str	=	$str.'<tr>
						<td colspan="2">
							<table cellpadding="4" cellspacing="1" bgcolor="#cccccc" width="100%" align="center">
								<tr><td colspan="7" class="td_normal_large" bgcolor="#f4f4f4">ADD/LESS LIST</td></tr>
								<tr bgcolor="#D6E3F3">
									<td class="td_normal" width="10%"><b>Serial</b></td>
									<td class="td_normal" width="20%"><b>Account Name</b></td>
									<td class="td_normal" width="30%"><b>Narration</b></td>
									<td class="td_normal" width="10%"><b>Add/Less</b></td>
									<td class="td_normal" width="20%"><b>Percent (%) of Amount</b></td>
									<td class="td_normal" width="10%" align="right"><b>Amount</b></td>
								</tr>';
								for($i=0;$i<count($this->AddLessList);$i++) {
									$row	=	$this->AddLessList[$i];
									$str	=	$str.$row->displayFull();
								}
							$str	=	$str.'</table>
						</td>
					</tr>';
				}
			$str	=	$str.'</table>';

			return $str;
		}
	};

?>