<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - May 04, 2015
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class gen_stockjournal {
		/**
		 * @Field		StockJournalID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $StockJournalID = 0;
		
		/**
		 * @Field		CompanyID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyID = 0;

		/**
		 * @Field		CompanyName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyName = "";		

		/**
		 * @Field		DOT
		 * @Type		date
		 * @Access	Protected
		 */
		protected $DOT = "1900-01-01";

		/**
		 * @Field		StoreID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $StoreID = 0;

		/**
		 * @Field		StoreName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $StoreName = "";

		/**
		 * @Field		ItemCategoryID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ItemCategoryID = 0;

		/**
		 * @Field		ItemCategoryName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ItemCategoryName = "";
		
		/**
		 * @Field		INItemList
		 * @Type		Array()
		 * @Access	Private
		 */
		var $INItemList = array();
		
		/**
		 * @Field		OUTItemList
		 * @Type		Array()
		 * @Access	Private
		 */
		var $OUTItemList = array();				

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getStockJournalID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->StockJournalID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->StockJournalID;
			} else {
				return $this->StockJournalID;
			}
		}
		
		public function getCompanyID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CompanyID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CompanyID;
			} else {
				return $this->CompanyID;
			}
		}

		public function getCompanyName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CompanyName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CompanyName;
			} else {
				return stripslashes($this->CompanyName);
			}
		}		

		public function getDOT($formatted='no') {
			if($formatted == 'yes') {
				return FormatSQLDateToIndianDate($this->DOT);
			} else if($formatted=='asis') {
				return $this->DOT;
			} else {
				return stripslashes($this->DOT);
			}
		}

		public function getStoreID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->StoreID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->StoreID;
			} else {
				return $this->StoreID;
			}
		}

		public function getStoreName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->StoreName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->StoreName;
			} else {
				return stripslashes($this->StoreName);
			}
		}

		public function getItemCategoryID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ItemCategoryID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ItemCategoryID;
			} else {
				return $this->ItemCategoryID;
			}
		}

		public function getItemCategoryName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ItemCategoryName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ItemCategoryName;
			} else {
				return stripslashes($this->ItemCategoryName);
			}
		}
		
		function getINItemList() {
			return $this->INItemList;
		}
		
		function getOUTItemList() {
			return $this->OUTItemList;
		}				

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setStockJournalID($arg) {
			$this->StockJournalID = (int)$arg;
		}
		
		public function setCompanyID($arg) {
			$this->CompanyID = (int)$arg;
		}

		public function setCompanyName($arg) {
			$this->CompanyName = addslashes($arg);
		}		

		public function setDOT($arg) {
			$this->DOT = FormatIndianDateToSQLDate($arg);
		}

		public function setStoreID($arg) {
			$this->StoreID = (int)$arg;
		}

		public function setStoreName($arg) {
			$this->StoreName = addslashes($arg);
		}

		public function setItemCategoryID($arg) {
			$this->ItemCategoryID = (int)$arg;
		}

		public function setItemCategoryName($arg) {
			$this->ItemCategoryName = addslashes($arg);
		}
		
		function setINItemList($arg) {
			$this->INItemList = $arg;
		}
		
		function setOUTItemList($arg) {
			$this->OUTItemList = $arg;
		}				

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `gen_stockjournal` (`StockJournalID`, `CompanyID`, `DOT`, `StoreID`, `ItemCategoryID`) VALUES(";
			$sql	=	$sql."'".$this->getStockJournalID('asis')."', ";
			$sql	=	$sql."'".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."'".$this->getDOT('asis')."', ";
			$sql	=	$sql."'".$this->getStoreID('asis')."', ";
			$sql	=	$sql."'".$this->getItemCategoryID('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `gen_stockjournal` SET ";
			$sql	=	$sql."`CompanyID` = '".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."`DOT` = '".$this->getDOT('asis')."', ";
			$sql	=	$sql."`StoreID` = '".$this->getStoreID('asis')."', ";
			$sql	=	$sql."`ItemCategoryID` = '".$this->getItemCategoryID('asis')."' ";
			$sql	=	$sql." WHERE `StockJournalID` = '".$this->getStockJournalID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `gen_stockjournal` ";
			$sql	=	$sql." WHERE `StockJournalID` = '".$this->getStockJournalID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$StockJournalID <= 0) $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">StockJournalID</div>
				<div style="float:left;">: '.$this->getStockJournalID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DOT</div>
				<div style="float:left;">: '.$this->getDOT('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">StoreID</div>
				<div style="float:left;">: '.$this->getStoreID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ItemCategoryID</div>
				<div style="float:left;">: '.$this->getItemCategoryID('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>