<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - Apr 11, 2015
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class gen_stocktransfer {
		/**
		 * @Field		StockTransferID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $StockTransferID = 0;
		
		/**
		 * @Field		CompanyID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyID = 0;

		/**
		 * @Field		CompanyName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyName = "";		

		/**
		 * @Field		DOT
		 * @Type		date
		 * @Access	Protected
		 */
		protected $DOT = "1900-01-01";

		/**
		 * @Field		FromStoreID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $FromStoreID = 0;

		/**
		 * @Field		FromStoreName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $FromStoreName = "";

		/**
		 * @Field		ToStoreID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ToStoreID = 0;

		/**
		 * @Field		ToStoreName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ToStoreName = "";
		
		/**
		 * @Field		ItemCategoryID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ItemCategoryID = 0;

		/**
		 * @Field		ItemCategoryName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ItemCategoryName = "";
		
		/**
		 * @Field		DebitMotherAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $DebitMotherAccountID = 0;

		/**
		 * @Field		DebitMotherAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $DebitMotherAccountName = "";

		/**
		 * @Field		DebitAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $DebitAccountID = 0;

		/**
		 * @Field		DebitAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $DebitAccountName = "";
		
		/**
		 * @Field		CreditMotherAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CreditMotherAccountID = 0;

		/**
		 * @Field		CreditMotherAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CreditMotherAccountName = "";

		/**
		 * @Field		CreditAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CreditAccountID = 0;

		/**
		 * @Field		CreditAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CreditAccountName = "";
		
		/**
		 * @Field		Purpose
		 * @Type		varchar(200)
		 * @Access	Protected
		 */
		protected $Purpose = "";
		
		/**
		 * @Field		RelatedID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $RelatedID = 0;		
		
		/**
		 * @Field		ItemList
		 * @Type		Array()
		 * @Access	Private
		 */
		var $ItemList = array();		

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getStockTransferID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->StockTransferID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->StockTransferID;
			} else {
				return $this->StockTransferID;
			}
		}
		
		public function getCompanyID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CompanyID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CompanyID;
			} else {
				return $this->CompanyID;
			}
		}

		public function getCompanyName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CompanyName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CompanyName;
			} else {
				return stripslashes($this->CompanyName);
			}
		}		

		public function getDOT($formatted='no') {
			if($formatted == 'yes') {
				return FormatSQLDateToIndianDate($this->DOT);
			} else if($formatted=='asis') {
				return $this->DOT;
			} else {
				return stripslashes($this->DOT);
			}
		}

		public function getFromStoreID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->FromStoreID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->FromStoreID;
			} else {
				return $this->FromStoreID;
			}
		}

		public function getFromStoreName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->FromStoreName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->FromStoreName;
			} else {
				return stripslashes($this->FromStoreName);
			}
		}

		public function getToStoreID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ToStoreID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ToStoreID;
			} else {
				return $this->ToStoreID;
			}
		}

		public function getToStoreName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ToStoreName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ToStoreName;
			} else {
				return stripslashes($this->ToStoreName);
			}
		}
		
		public function getItemCategoryID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ItemCategoryID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ItemCategoryID;
			} else {
				return $this->ItemCategoryID;
			}
		}

		public function getItemCategoryName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ItemCategoryName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ItemCategoryName;
			} else {
				return stripslashes($this->ItemCategoryName);
			}
		}
		
		public function getDebitMotherAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->DebitMotherAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->DebitMotherAccountID;
			} else {
				return $this->DebitMotherAccountID;
			}
		}

		public function getDebitMotherAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DebitMotherAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DebitMotherAccountName;
			} else {
				return stripslashes($this->DebitMotherAccountName);
			}
		}

		public function getDebitAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->DebitAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->DebitAccountID;
			} else {
				return $this->DebitAccountID;
			}
		}

		public function getDebitAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DebitAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DebitAccountName;
			} else {
				return stripslashes($this->DebitAccountName);
			}
		}
		
		public function getCreditMotherAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CreditMotherAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CreditMotherAccountID;
			} else {
				return $this->CreditMotherAccountID;
			}
		}

		public function getCreditMotherAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CreditMotherAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CreditMotherAccountName;
			} else {
				return stripslashes($this->CreditMotherAccountName);
			}
		}

		public function getCreditAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CreditAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CreditAccountID;
			} else {
				return $this->CreditAccountID;
			}
		}

		public function getCreditAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CreditAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CreditAccountName;
			} else {
				return stripslashes($this->CreditAccountName);
			}
		}
		
		public function getPurpose($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Purpose),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Purpose;
			} else {
				return stripslashes($this->Purpose);
			}
		}
		
		public function getRelatedID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->RelatedID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->RelatedID;
			} else {
				return $this->RelatedID;
			}
		}		
		
		function getItemList() {
			return $this->ItemList;
		}		

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setStockTransferID($arg) {
			$this->StockTransferID = (int)$arg;
		}
		
		public function setCompanyID($arg) {
			$this->CompanyID = (int)$arg;
		}

		public function setCompanyName($arg) {
			$this->CompanyName = addslashes($arg);
		}		

		public function setDOT($arg) {
			$this->DOT = FormatIndianDateToSQLDate($arg);
		}

		public function setFromStoreID($arg) {
			$this->FromStoreID = (int)$arg;
		}

		public function setFromStoreName($arg) {
			$this->FromStoreName = addslashes($arg);
		}

		public function setToStoreID($arg) {
			$this->ToStoreID = (int)$arg;
		}

		public function setToStoreName($arg) {
			$this->ToStoreName = addslashes($arg);
		}
		
		public function setItemCategoryID($arg) {
			$this->ItemCategoryID = (int)$arg;
		}

		public function setItemCategoryName($arg) {
			$this->ItemCategoryName = addslashes($arg);
		}
		
		public function setDebitMotherAccountID($arg) {
			$this->DebitMotherAccountID = (int)$arg;
		}

		public function setDebitMotherAccountName($arg) {
			$this->DebitMotherAccountName = addslashes($arg);
		}

		public function setDebitAccountID($arg) {
			$this->DebitAccountID = (int)$arg;
		}

		public function setDebitAccountName($arg) {
			$this->DebitAccountName = addslashes($arg);
		}

		public function setCreditMotherAccountID($arg) {
			$this->CreditMotherAccountID = (int)$arg;
		}

		public function setCreditMotherAccountName($arg) {
			$this->CreditMotherAccountName = addslashes($arg);
		}

		public function setCreditAccountID($arg) {
			$this->CreditAccountID = (int)$arg;
		}

		public function setCreditAccountName($arg) {
			$this->CreditAccountName = addslashes($arg);
		}
		
		public function setPurpose($arg) {
			$this->Purpose = addslashes($arg);
		}
		
		public function setRelatedID($arg) {
			$this->RelatedID = (int)$arg;
		}		
		
		function setItemList($arg) {
			$this->ItemList = $arg;
		}		

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `gen_stocktransfer` (`StockTransferID`, `CompanyID`, `DOT`, `FromStoreID`, `ToStoreID`, `ItemCategoryID`, `DebitMotherAccountID`, `DebitAccountID`, `CreditMotherAccountID`, `CreditAccountID`, `Purpose`, `RelatedID`) VALUES(";
			$sql	=	$sql."'".$this->getStockTransferID('asis')."', ";
			$sql	=	$sql."'".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."'".$this->getDOT('asis')."', ";
			$sql	=	$sql."'".$this->getFromStoreID('asis')."', ";
			$sql	=	$sql."'".$this->getToStoreID('asis')."', ";
			$sql	=	$sql."'".$this->getItemCategoryID('asis')."', ";
			$sql	=	$sql."'".$this->getDebitMotherAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getDebitAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getCreditMotherAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getCreditAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getPurpose('asis')."', ";
			$sql	=	$sql."'".$this->getRelatedID('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `gen_stocktransfer` SET ";
			$sql	=	$sql."`CompanyID` = '".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."`DOT` = '".$this->getDOT('asis')."', ";
			$sql	=	$sql."`FromStoreID` = '".$this->getFromStoreID('asis')."', ";
			$sql	=	$sql."`ToStoreID` = '".$this->getToStoreID('asis')."', ";
			$sql	=	$sql."`ItemCategoryID` = '".$this->getItemCategoryID('asis')."', ";
			$sql	=	$sql."`DebitMotherAccountID` = '".$this->getDebitMotherAccountID('asis')."', ";
			$sql	=	$sql."`DebitAccountID` = '".$this->getDebitAccountID('asis')."', ";
			$sql	=	$sql."`CreditMotherAccountID` = '".$this->getCreditMotherAccountID('asis')."', ";
			$sql	=	$sql."`CreditAccountID` = '".$this->getCreditAccountID('asis')."', ";
			$sql	=	$sql."`Purpose` = '".$this->getPurpose('asis')."', ";
			$sql	=	$sql."`RelatedID` = '".$this->getRelatedID('asis')."' ";
			$sql	=	$sql." WHERE `StockTransferID` = '".$this->getStockTransferID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `gen_stocktransfer` ";
			$sql	=	$sql." WHERE `StockTransferID` = '".$this->getStockTransferID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$StockTransferID <= 0) $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">StockTransferID</div>
				<div style="float:left;">: '.$this->getStockTransferID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DOT</div>
				<div style="float:left;">: '.$this->getDOT('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">FromStoreID</div>
				<div style="float:left;">: '.$this->getFromStoreID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ToStoreID</div>
				<div style="float:left;">: '.$this->getToStoreID('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>