<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - May 19, 2017
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class gen_transferissue {
		/**
		 * @Field		BookingID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $BookingID = 0;

		/**
		 * @Field		CompanyID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyID = 0;

		/**
		 * @Field		CompanyName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $CompanyName = "";

		/**
		 * @Field		BookingDate
		 * @Type		date
		 * @Access	Protected
		 */
		protected $BookingDate = "1900-01-01";

		/**
		 * @Field		FinYear
		 * @Type		varchar(10)
		 * @Access	Protected
		 */
		protected $FinYear = "";

		/**
		 * @Field		BookingNo
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $BookingNo = 0;

		/**
		 * @Field		FromStoreID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $FromStoreID = 0;

		/**
		 * @Field		FromStoreName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $FromStoreName = "";

		/**
		 * @Field		ToStoreID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ToStoreID = 0;

		/**
		 * @Field		ToStoreName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ToStoreName = "";

		/**
		 * @Field		ItemCategoryID
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ItemCategoryID = 0;

		/**
		 * @Field		ItemCategoryName
		 * @Type		smallint(6)
		 * @Access	Protected
		 */
		protected $ItemCategoryName = "";

		/**
		 * @Field		DebitMotherAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $DebitMotherAccountID = 0;

		/**
		 * @Field		DebitMotherAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $DebitMotherAccountName = "";

		/**
		 * @Field		DebitAccountID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $DebitAccountID = 0;

		/**
		 * @Field		DebitAccountName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $DebitAccountName = "";

		/**
		 * @Field		Purpose
		 * @Type		varchar(200)
		 * @Access	Protected
		 */
		protected $Purpose = "";

		/**
		 * @Field		DOE
		 * @Type		text
		 * @Access	Protected
		 */
		protected $DOE = "";
		
		/**
		 * @Field		StockTransferID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $StockTransferID = 0;
		
		/**
		 * @Field		IssueID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $IssueID = 0;				
		
		/**
		 * @Field		ItemList
		 * @Type		Array()
		 * @Access	Private
		 */
		var $ItemList = array();		

		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->BookingID = (int)$this->BookingID;
			$this->CompanyID = (int)$this->CompanyID;
			$this->FinYear = addslashes($this->FinYear);
			$this->BookingNo = (int)$this->BookingNo;
			$this->FromStoreID = (int)$this->FromStoreID;
			$this->ToStoreID = (int)$this->ToStoreID;
			$this->ItemCategoryID = (int)$this->ItemCategoryID;
			$this->DebitMotherAccountID = (int)$this->DebitMotherAccountID;
			$this->DebitAccountID = (int)$this->DebitAccountID;
			$this->Purpose = addslashes($this->Purpose);
			$this->DOE = addslashes($this->DOE);
			$this->StockTransferID = (int)$this->StockTransferID;
			$this->IssueID = (int)$this->IssueID;			
		}

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getBookingID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->BookingID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->BookingID;
			} else {
				return $this->BookingID;
			}
		}

		public function getCompanyID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->CompanyID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->CompanyID;
			} else {
				return $this->CompanyID;
			}
		}

		public function getCompanyName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->CompanyName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->CompanyName;
			} else {
				return stripslashes($this->CompanyName);
			}
		}

		public function getBookingDate($formatted='no') {
			if($formatted == 'yes') {
				return FormatSQLDateToIndianDate($this->BookingDate);
			} else if($formatted=='asis') {
				return $this->BookingDate;
			} else {
				return stripslashes($this->BookingDate);
			}
		}

		public function getFinYear($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->FinYear),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->FinYear;
			} else {
				return stripslashes($this->FinYear);
			}
		}

		public function getBookingNo($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->BookingNo,2,'.',',');
			} else if($formatted=='asis') {
				return $this->BookingNo;
			} else {
				return $this->BookingNo;
			}
		}

		public function getFromStoreID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->FromStoreID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->FromStoreID;
			} else {
				return $this->FromStoreID;
			}
		}

		public function getFromStoreName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->FromStoreName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->FromStoreName;
			} else {
				return stripslashes($this->FromStoreName);
			}
		}

		public function getToStoreID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ToStoreID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ToStoreID;
			} else {
				return $this->ToStoreID;
			}
		}

		public function getToStoreName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ToStoreName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ToStoreName;
			} else {
				return stripslashes($this->ToStoreName);
			}
		}

		public function getItemCategoryID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ItemCategoryID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ItemCategoryID;
			} else {
				return $this->ItemCategoryID;
			}
		}

		public function getItemCategoryName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ItemCategoryName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ItemCategoryName;
			} else {
				return stripslashes($this->ItemCategoryName);
			}
		}

		public function getDebitMotherAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->DebitMotherAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->DebitMotherAccountID;
			} else {
				return $this->DebitMotherAccountID;
			}
		}

		public function getDebitMotherAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DebitMotherAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DebitMotherAccountName;
			} else {
				return stripslashes($this->DebitMotherAccountName);
			}
		}

		public function getDebitAccountID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->DebitAccountID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->DebitAccountID;
			} else {
				return $this->DebitAccountID;
			}
		}

		public function getDebitAccountName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DebitAccountName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DebitAccountName;
			} else {
				return stripslashes($this->DebitAccountName);
			}
		}

		public function getPurpose($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->Purpose),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->Purpose;
			} else {
				return stripslashes($this->Purpose);
			}
		}

		public function getDOE($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->DOE),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->DOE;
			} else {
				return stripslashes($this->DOE);
			}
		}
		
		public function getStockTransferID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->StockTransferID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->StockTransferID;
			} else {
				return $this->StockTransferID;
			}
		}
		
		public function getIssueID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->IssueID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->IssueID;
			} else {
				return $this->IssueID;
			}
		}				
		
		function getItemList() {
			return $this->ItemList;
		}		

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setBookingID($arg) {
			$this->BookingID = (int)$arg;
		}

		public function setCompanyID($arg) {
			$this->CompanyID = (int)$arg;
		}

		public function setCompanyName($arg) {
			$this->CompanyName = addslashes($arg);
		}

		public function setBookingDate($arg) {
			$this->BookingDate = FormatIndianDateToSQLDate($arg);
		}

		public function setFinYear($arg) {
			$this->FinYear = addslashes($arg);
		}

		public function setBookingNo($arg) {
			$this->BookingNo = (int)$arg;
		}

		public function setFromStoreID($arg) {
			$this->FromStoreID = (int)$arg;
		}

		public function setFromStoreName($arg) {
			$this->FromStoreName = addslashes($arg);
		}

		public function setToStoreID($arg) {
			$this->ToStoreID = (int)$arg;
		}

		public function setToStoreName($arg) {
			$this->ToStoreName = addslashes($arg);
		}

		public function setItemCategoryID($arg) {
			$this->ItemCategoryID = (int)$arg;
		}

		public function setItemCategoryName($arg) {
			$this->ItemCategoryName = addslashes($arg);
		}

		public function setDebitMotherAccountID($arg) {
			$this->DebitMotherAccountID = (int)$arg;
		}

		public function setDebitMotherAccountName($arg) {
			$this->DebitMotherAccountName = addslashes($arg);
		}

		public function setDebitAccountID($arg) {
			$this->DebitAccountID = (int)$arg;
		}

		public function setDebitAccountName($arg) {
			$this->DebitAccountName = addslashes($arg);
		}

		public function setPurpose($arg) {
			$this->Purpose = addslashes($arg);
		}

		public function setDOE($arg) {
			$this->DOE = addslashes($arg);
		}
		
		public function setStockTransferID($arg) {
			$this->StockTransferID = (int)$arg;
		}
		
		public function setIssueID($arg) {
			$this->IssueID = (int)$arg;
		}				
		
		function setItemList($arg) {
			$this->ItemList = $arg;
		}		

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `gen_transferissue` (`BookingID`, `CompanyID`, `BookingDate`, `FinYear`, `BookingNo`, `FromStoreID`, `ToStoreID`, `ItemCategoryID`, `DebitMotherAccountID`, `DebitAccountID`, `Purpose`, `DOE`, `StockTransferID`, `IssueID`) VALUES(";
			$sql	=	$sql."'".$this->getBookingID('asis')."', ";
			$sql	=	$sql."'".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."'".$this->getBookingDate('asis')."', ";
			$sql	=	$sql."'".$this->getFinYear('asis')."', ";
			$sql	=	$sql."'".$this->getBookingNo('asis')."', ";
			$sql	=	$sql."'".$this->getFromStoreID('asis')."', ";
			$sql	=	$sql."'".$this->getToStoreID('asis')."', ";
			$sql	=	$sql."'".$this->getItemCategoryID('asis')."', ";
			$sql	=	$sql."'".$this->getDebitMotherAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getDebitAccountID('asis')."', ";
			$sql	=	$sql."'".$this->getPurpose('asis')."', ";
			$sql	=	$sql."'".$this->getDOE('asis')."', ";
			$sql	=	$sql."'".$this->getStockTransferID('asis')."', ";
			$sql	=	$sql."'".$this->getIssueID('asis')."')";			

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `gen_transferissue` SET ";
			$sql	=	$sql."`CompanyID` = '".$this->getCompanyID('asis')."', ";
			$sql	=	$sql."`BookingDate` = '".$this->getBookingDate('asis')."', ";
			$sql	=	$sql."`FinYear` = '".$this->getFinYear('asis')."', ";
			$sql	=	$sql."`BookingNo` = '".$this->getBookingNo('asis')."', ";
			$sql	=	$sql."`FromStoreID` = '".$this->getFromStoreID('asis')."', ";
			$sql	=	$sql."`ToStoreID` = '".$this->getToStoreID('asis')."', ";
			$sql	=	$sql."`ItemCategoryID` = '".$this->getItemCategoryID('asis')."', ";
			$sql	=	$sql."`DebitMotherAccountID` = '".$this->getDebitMotherAccountID('asis')."', ";
			$sql	=	$sql."`DebitAccountID` = '".$this->getDebitAccountID('asis')."', ";
			$sql	=	$sql."`Purpose` = '".$this->getPurpose('asis')."', ";
			$sql	=	$sql."`DOE` = '".$this->getDOE('asis')."', ";
			$sql	=	$sql."`StockTransferID` = '".$this->getStockTransferID('asis')."', ";
			$sql	=	$sql."`IssueID` = '".$this->getIssueID('asis')."' ";
			$sql	=	$sql." WHERE `BookingID` = '".$this->getBookingID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `gen_transferissue` ";
			$sql	=	$sql." WHERE `BookingID` = '".$this->getBookingID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$BookingID <= 0) $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">BookingID</div>
				<div style="float:left;">: '.$this->getBookingID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">CompanyID</div>
				<div style="float:left;">: '.$this->getCompanyID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">BookingDate</div>
				<div style="float:left;">: '.$this->getBookingDate('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">FinYear</div>
				<div style="float:left;">: '.$this->getFinYear('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">BookingNo</div>
				<div style="float:left;">: '.$this->getBookingNo('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">FromStoreID</div>
				<div style="float:left;">: '.$this->getFromStoreID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ToStoreID</div>
				<div style="float:left;">: '.$this->getToStoreID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ItemCategoryID</div>
				<div style="float:left;">: '.$this->getItemCategoryID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DebitMotherAccountID</div>
				<div style="float:left;">: '.$this->getDebitMotherAccountID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DebitAccountID</div>
				<div style="float:left;">: '.$this->getDebitAccountID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Purpose</div>
				<div style="float:left;">: '.$this->getPurpose('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">DOE</div>
				<div style="float:left;">: '.$this->getDOE('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>