<?php

	/**
	 * Author - Subhashis Pandey (psubho@gmail.com). Written - May 19, 2017
	 */

	/**
	 * (c) 2011 Swastika Systems, All Rights Reserved.
	 */

	class gen_transferissue_items {
		/**
		 * @Field		BookingID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $BookingID = 0;

		/**
		 * @Field		ItemID
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $ItemID = 0;

		/**
		 * @Field		ItemName
		 * @Type		int(11)
		 * @Access	Protected
		 */
		protected $ItemName = "";

		/**
		 * @Field		Quantity
		 * @Type		double
		 * @Access	Protected
		 */
		protected $Quantity = 0;

		/**
		 * @Field		Rate
		 * @Type		decimal(15,5)
		 * @Access	Protected
		 */
		protected $Rate = 0;

		/**
		 * Constructor, particularly for PHP PDO
		 */
		public function __construct() {
			$this->BookingID = (int)$this->BookingID;
			$this->ItemID = (int)$this->ItemID;
			$this->Quantity = (double)$this->Quantity;
			$this->Rate = (double)$this->Rate;
		}

		/**
		 * Getter Methods to retrive the values of the Variables of the Class
		 */
		public function getBookingID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->BookingID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->BookingID;
			} else {
				return $this->BookingID;
			}
		}

		public function getItemID($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->ItemID,2,'.',',');
			} else if($formatted=='asis') {
				return $this->ItemID;
			} else {
				return $this->ItemID;
			}
		}

		public function getItemName($formatted='no') {
			if($formatted == 'yes') {
				return htmlspecialchars(stripslashes($this->ItemName),ENT_QUOTES);
			} else if($formatted=='asis') {
				return $this->ItemName;
			} else {
				return stripslashes($this->ItemName);
			}
		}

		public function getQuantity($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->Quantity,2,'.',',');
			} else if($formatted=='asis') {
				return $this->Quantity;
			} else {
				return $this->Quantity;
			}
		}

		public function getRate($formatted='no') {
			if($formatted == 'yes') {
				return number_format($this->Rate,2,'.',',');
			} else if($formatted=='asis') {
				return $this->Rate;
			} else {
				return $this->Rate;
			}
		}

		/**
		 * Setter Methods to set the values of the Variables of the Class
		 */
		public function setBookingID($arg) {
			$this->BookingID = (int)$arg;
		}

		public function setItemID($arg) {
			$this->ItemID = (int)$arg;
		}

		public function setItemName($arg) {
			$this->ItemName = addslashes($arg);
		}

		public function setQuantity($arg) {
			$this->Quantity = (double)$arg;
		}

		public function setRate($arg) {
			$this->Rate = (double)$arg;
		}

		public function getInsertSQL() {		

			$sql	=	"INSERT INTO `gen_transferissue_items` (`BookingID`, `ItemID`, `Quantity`, `Rate`) VALUES(";
			$sql	=	$sql."'".$this->getBookingID('asis')."', ";
			$sql	=	$sql."'".$this->getItemID('asis')."', ";
			$sql	=	$sql."'".$this->getQuantity('asis')."', ";
			$sql	=	$sql."'".$this->getRate('asis')."')";

			return $sql;
		}

		public function getUpdateSQL() {		

			$sql	=	"UPDATE `gen_transferissue_items` SET ";
			$sql	=	$sql."`Quantity` = '".$this->getQuantity('asis')."', ";
			$sql	=	$sql."`Rate` = '".$this->getRate('asis')."' ";
			$sql	=	$sql." WHERE `BookingID` = '".$this->getBookingID('asis')."'";
			$sql	=	$sql." AND `ItemID` = '".$this->getItemID('asis')."'";

			return $sql;
		}

		public function getDeleteSQL() {		

			$sql	=	"DELETE FROM `gen_transferissue_items` ";
			$sql	=	$sql." WHERE `BookingID` = '".$this->getBookingID('asis')."'";
			$sql	=	$sql." AND `ItemID` = '".$this->getItemID('asis')."'";
			$sql	=	$sql." LIMIT 1";

			return $sql;
		}

		public function validateFields() {		

			$chk	=	true;
			if((int)$BookingID <= 0) $chk	=	false;
			if((int)$ItemID <= 0) $chk	=	false;

			return $chk;
		}

		public function getHTMLRepresentation() {		

			$str	=	'
				<div style="float:left;width:150px;">BookingID</div>
				<div style="float:left;">: '.$this->getBookingID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">ItemID</div>
				<div style="float:left;">: '.$this->getItemID('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Quantity</div>
				<div style="float:left;">: '.$this->getQuantity('yes').'</div>
				<div style="clear:both;"></div>
				<div style="float:left;width:150px;">Rate</div>
				<div style="float:left;">: '.$this->getRate('yes').'</div>
				<div style="clear:both;"></div>
			';

			return $str;
		}
	};

?>