<?php

	class saledb {

		protected $host			= SS_DB_HOST;
		protected $user			= SS_DB_USER;
		protected $password	= SS_DB_PASSWORD;
		protected $dbname		= SS_DB_DBNAME;
		protected $conn			= null;

		public function __construct($dbType = '') {
			
			if (!extension_loaded('pdo')) {
				die (SS_DB_ERR_101);
			}
			
			if($dbType == "REPORT") {
				$this->user 		= SS_RPT_USER;
				$this->password	= SS_RPT_PASSWORD;
			} else if($dbType == "DATA") {
				$this->user 		= SS_DBA_USER;
				$this->password	= SS_DBA_PASSWORD;			
			}
			
			try {
				$this->conn = new PDO("mysql:host=".$this->host.";dbname=".$this->dbname, $this->user, $this->password);
				$this->conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
			} catch(PDOException $e) {
				die('DB connection error '.$e->getMessage());
			}			
				
		}
		
		public function __destruct() {
			$this->conn	= null;
		}
		
		private function ExecuteQuery($sql00) {
		
			$res	= false;

			try {
				
				$res	= $this->conn->query($sql00);
				
			} catch(PDOException $e) {
				$err	= 'saledb ExecuteQuery (line 30) '.$e->getMessage();
				_errorLog($err);
			}
			
			return $res;
			
		}

		private function getRecordsetExecutingQuery($sql00) {
		
			$rows		= array();
		
			try {
				
				$result	= $this->conn->query($sql00);
				while($row = $result->fetch()) {
					$rows[]	=	$row;
				}
				
			} catch(PDOException $e) {
				$err	= 'saledb getRecordsetExecutingQuery (line 53) '.$e->getMessage();
				_errorLog($err);
			}		
		
			return $rows;
			
		}
		
		private function getResultExecutingQuery($sql00) {
		
			$rows		= array();
			$res		= "";
		
			try {
				
				$result	= $this->conn->query($sql00);
				if($row = $result->fetch()) {
					$res	=	$row[0];
				}
				
			} catch(PDOException $e) {
				$err	= 'saledb getResultExecutingQuery (line 77) '.$e->getMessage();
				_errorLog($err);
			}		
		
			return $res;
			
		}
		
		public function getNextID($tblName, $colName) {
			
			if(strpos($tblName, "'") !== false) return false;
			if(strpos($colName, "'") !== false) return false;
			
			if(strpos($tblName, '"') !== false) return false;
			if(strpos($colName, '"') !== false) return false;
			
			$maxid			=	1;
			$sql				=	"SELECT `MaxID` FROM `asys_tablemaxrows` WHERE `TableName`='$tblName' ORDER BY `MaxID` DESC LIMIT 1";
			$usql				= "UPDATE `asys_tablemaxrows` SET `MaxID`=`MaxID`+1 WHERE `TableName`='$tblName'";

			try {
				
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch()) {
					$maxid 	= $row[0];
					$this->conn->exec($usql);
				} else {
					$sql		= "INSERT INTO `asys_tablemaxrows` (`TableName`, `MaxID`) VALUES ('$tblName', '2');";
					$this->conn->exec($sql);
				}
					
			} catch(PDOException $e) {
				$err	= 'voucherdb getNextID '.$e->getMessage();
				_errorLog($err);
			}

			return $maxid;
			
		}

		function getUnitNameByUnitID($UnitID) {
			$sql		=	"SELECT `UnitName` FROM `gen_unit` WHERE `UnitID`='$UnitID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getItemCategoryNameByItemCategoryID($ItemCategoryID) {
			$sql		=	"SELECT `ItemCategoryName` FROM `gen_itemcategory` WHERE `ItemCategoryID`='$ItemCategoryID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getItemCategoryByItemID($ItemID) {
			$sql		=	"SELECT `ItemCategoryID` FROM `gen_items` WHERE `ItemID`='$ItemID'";
			return $this->getResultExecutingQuery($sql);			
		}
		
		function getItemNameByItemID($ItemID) {
			$sql		=	"SELECT `ItemName` FROM `gen_items` WHERE `ItemID`='$ItemID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getAccountNameByAccountID($AccountID) {
			$sql		=	"SELECT `AccountName` FROM `asys_accounts` WHERE `AccountID`='$AccountID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getBaseGroupNameByBaseGroupID($BGID) {
			$BGID		= (int)$BGID;
			$sql		=	"SELECT `GroupName` FROM `asys_base_group` WHERE `BGID`='$BGID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getGroupNameByGroupID($GroupID) {
			$GroupID	= (int)$GroupID;
			$sql			=	"SELECT `GroupName` FROM `asys_groups` WHERE `GroupID`='$GroupID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getStoreNameByStoreID($StoreID) {
			$sql		=	"SELECT `StoreName` FROM `asys_stores` WHERE `StoreID`='$StoreID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getCompanyNameByCompanyID($CompanyID) {
			$CompanyID		= (int)$CompanyID;
			$sql		=	"SELECT `CompanyName` FROM `asys_companies` WHERE `CompanyID`='$CompanyID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getUTByState($State){
		
			$State		= addslashes($State);
			$sql			= "SELECT `UT` FROM `asys_cities` WHERE `State`='$State'";
			return $this->getResultExecutingQuery($sql);
		
		}
		
		function getMaxVoucherNo($VoucherType, $FinYear, $CompanyID) {
			$CompanyID		= (int)$CompanyID;
			$VoucherType	= (int)$VoucherType;
			$FinYear			= addslashes($FinYear);
			$maxid				=	0;
			$sql					=	"SELECT MAX(`VoucherNo`) FROM `asys_voucher_entry` WHERE `VoucherType`='$VoucherType' AND `FinYear`='$FinYear' AND `CompanyID`='$CompanyID'";
			$maxid				= $this->getResultExecutingQuery($sql);
			$maxid++;
			return $maxid;
			
		}
		
		function getMaxDayWiseVoucherNo($VoucherType, $DOV, $CompanyID) {
			$CompanyID		= (int)$CompanyID;
			$VoucherType	= (int)$VoucherType;
			$DOV					= addslashes($DOV);
			$maxid				=	0;
			$sql					=	"SELECT MAX(`DayWiseNo`) FROM `asys_voucher_entry` WHERE `VoucherType`='$VoucherType' AND `DOV`='$DOV' AND `CompanyID`='$CompanyID'";
			$maxid				= $this->getResultExecutingQuery($sql);
			$maxid++;
			return $maxid;
			
		}
		
		function getAccountDetail($AccountID) {
			$AccountID	= (int)$AccountID;
			$cclass			=	new asys_accounts();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_accounts` WHERE `AccountID`='$AccountID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_accounts');
				if($row 	= $result->fetch()) {
					$cclass	= $row;
					$cclass->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$cclass->setGroupName($this->getGroupNameByGroupID($cclass->getGroupID()));
					$cclass->setBGName($this->getBaseGroupNameByBaseGroupID($cclass->getBGID()));
				}
				
			} catch(PDOException $e) {
				$err	= 'saledb getAccountDetail (line 222) '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}
		
		function getStoreDetail($StoreID) {
			$StoreID	= (int)$StoreID;
			$cclass			=	new asys_stores();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_stores` WHERE `StoreID`='$StoreID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_stores');
				if($row 	= $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccountID()));
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));					
					$cclass	= $row;
				}

			} catch(PDOException $e) {
				$err	= 'masterdb getStoreDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}		
		
		function getVoucherNoByRelatedID($VoucherType, $TxnType, $RelatedID, $CompanyID) {
			$CompanyID		= (int)$CompanyID;
			$VoucherType	= (int)$VoucherType;
			$TxnType			= (int)$TxnType;
			$RelatedID		= (int)$RelatedID;
			$sql	= "SELECT `VoucherNo` FROM `asys_voucher_entry` WHERE `VoucherType`='".$VoucherType."' AND `TxnType`='".$TxnType."' AND `RelatedID`='".$RelatedID."' AND `CompanyID`='".$CompanyID."'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getDayWiseNoByRelatedID($VoucherType, $TxnType, $RelatedID, $CompanyID) {
			$CompanyID		= (int)$CompanyID;
			$VoucherType	= (int)$VoucherType;
			$TxnType			= (int)$TxnType;
			$RelatedID		= (int)$RelatedID;
			$sql	= "SELECT `DayWiseNo` FROM `asys_voucher_entry` WHERE `VoucherType`='".$VoucherType."' AND `TxnType`='".$TxnType."' AND `RelatedID`='".$RelatedID."' AND `CompanyID`='".$CompanyID."'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getCompanyIDByTransaction($tblName, $colName, $colID) {
			$tblName	= addslashes($tblName);
			$colName	= addslashes($colName);
			$colID		= (int)$colID;
			$sql				= "SELECT `CompanyID` FROM `$tblName` WHERE `$colName`='".$colID."'";
			return $this->getResultExecutingQuery($sql);
		}
		
		
		
		/*---------------------------------------------------------------*/
		/*********************** QUOTATION METHODS ***********************/
		
		function getNextQuotationNo($FinYear, $CompanyID) {
			if(strpos($FinYear, "'") !== false) return false;
			$CompanyID	= (int)$CompanyID;
			
			$maxid			=	0;
			$sql				=	"SELECT MAX(`SaleNo`) FROM `gen_quote` WHERE `FinYear`='$FinYear' AND `CompanyID`='$CompanyID'";

			try {
				
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch())
					$maxid 	= $row[0];

			} catch(PDOException $e) {
				$err	= 'saledb getNextQuotationNo '.$e->getMessage();
				_errorLog($err);
			}

			$maxid++;
			return $maxid;
		}

		function getQuotationDetail($SaleID) {
			$SaleID			= (int)$SaleID;
			$cclass			=	new gen_quote();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_quote` WHERE `SaleID`='$SaleID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_quote');
				if($row 	= $result->fetch()) { 
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setSaleAccountName($this->getAccountNameByAccountID($row->getSaleAccountID()));
					$row->setCustomerName($this->getAccountNameByAccountID($row->getCustomerID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setConsigneeName($this->getAccountNameByAccountID($row->getConsigneeID()));
					$row->setItemList($this->getQuotationItemList($row->getSaleID()));
					$row->setAddLessList($this->getQuotationAddLessList($row->getSaleID()));
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'saledb getQuotationDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getQuotationList($CompanyID) {
			$CompanyID	= (int)$CompanyID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_quote` WHERE `CompanyID`='$CompanyID' ORDER BY `SaleNo`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_quote');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setSaleAccountName($this->getAccountNameByAccountID($row->getSaleAccountID()));
					$row->setCustomerName($this->getAccountNameByAccountID($row->getCustomerID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setConsigneeName($this->getAccountNameByAccountID($row->getConsigneeID()));
					$row->setItemList($this->getQuotationItemList($row->getSaleID()));
					$row->setAddLessList($this->getQuotationAddLessList($row->getSaleID()));
					$arr[]	= $row;
				}

			} catch(PDOException $e) {
				$err	= 'saledb getQuotationList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getNumberOfQuotation($DateFrom, $DateTo, $SaleNo, $CustomerID, $StoreID, $CompanyID) {
		
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$SaleNo			= (int)$SaleNo;
			$CustomerID	= (int)$CustomerID;
			$StoreID		= (int)$StoreID;
			$CompanyID	= (int)$CompanyID;
		
			$sql	=	"SELECT COUNT(*) FROM `gen_quote` WHERE `CompanyID`='$CompanyID'";
			if($DateFrom != '1900-01-01')
				$sql	=	$sql." AND `DOS`>='$DateFrom'";
			if($DateTo != '1900-01-01')
				$sql	=	$sql." AND `DOS`<='$DateTo'";
			if($SaleNo > 0)
				$sql	=	$sql." AND `SaleNo`='$SaleNo'";
			if($CustomerID > 0)
				$sql	=	$sql." AND `CustomerID`='$CustomerID'";
			if($StoreID > 0)
				$sql	=	$sql." AND `StoreID`='$StoreID'";
			
			return $this->getResultExecutingQuery($sql);
		}

		function getQuotationListPaged($sRec, $nRec, $DateFrom, $DateTo, $SaleNo, $CustomerID, $StoreID, $CompanyID) {
		
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$SaleNo			= (int)$SaleNo;
			$CustomerID	= (int)$CustomerID;
			$StoreID		= (int)$StoreID;
			$CompanyID	= (int)$CompanyID;
			$sRec				= (int)$sRec;
			$nRec				= (int)$nRec;
		
			$sql	=	"SELECT * FROM `gen_quote` WHERE `CompanyID`='$CompanyID'";
			if($DateFrom != '1900-01-01')
				$sql	=	$sql." AND `DOS`>='$DateFrom'";
			if($DateTo != '1900-01-01')
				$sql	=	$sql." AND `DOS`<='$DateTo'";
			if($SaleNo > 0)
				$sql	=	$sql." AND `SaleNo`='$SaleNo'";
			if($CustomerID > 0)
				$sql	=	$sql." AND `CustomerID`='$CustomerID'";
			if($StoreID > 0)
				$sql	=	$sql." AND `StoreID`='$StoreID'";
			
			$sql			=	$sql." ORDER BY `FinYear` DESC, `SaleNo` DESC LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_quote');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setSaleAccountName($this->getAccountNameByAccountID($row->getSaleAccountID()));
					$row->setCustomerName($this->getAccountNameByAccountID($row->getCustomerID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setConsigneeName($this->getAccountNameByAccountID($row->getConsigneeID()));
					$row->setItemList($this->getQuotationItemList($row->getSaleID()));
					$row->setAddLessList($this->getQuotationAddLessList($row->getSaleID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'saledb getQuotationListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getQuotationItemList($SaleID) {
			$SaleID	= (int)$SaleID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_quote_items` WHERE `SaleID`='$SaleID' ORDER BY `SerialNo`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_quote_items');
				while($row = $result->fetch()) {
					$row->setItemName($this->getItemNameByItemID($row->getItemID()));
					$row->setAccountName( $this->getAccountNameByAccountID( $row->getAccountID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'saledb getQuotationItemList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getQuotationAddLessList($SaleID) {
			$SaleID			= (int)$SaleID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_quote_addless` WHERE `SaleID`='$SaleID' ORDER BY `SerialNo`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_quote_addless');
				while($row = $result->fetch()) {
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'saledb getQuotationAddLessList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function CreateQuotation($scls) {
			
			$pdt		= $scls->getDOS();
			$cmpid	= $scls->getCompanyID();
			$finyr	= getFinancialYear($pdt);
			$scls->setFinYear($finyr);
			$scls->setSaleNo($this->getNextQuotationNo($finyr, $cmpid));
			
				
			try {
			
				$this->conn->beginTransaction();
				
				$scls->setSaleID($this->getNextID("gen_quote","SaleID"));
				$sid		= $scls->getSaleID();
				
				$itmList	= $scls->getItemList();
				for($i=0;$i<count($itmList);$i++) {
					$icls	=	$itmList[$i];
					$icls->setSaleID($sid);
					$icls->setSerialNo($i+1);

					$sql		= $icls->getInsertSQL();
					$this->conn->exec($sql);			
				}
								
				
				$alList	= $scls->getAddLessList();
				for($j=0;$j<count($alList);$j++) {
					$acls	=	$alList[$j];
					$acls->setSaleID($sid);
					$acls->setSerialNo($j+1);

					$sql		= $acls->getInsertSQL();
					$this->conn->exec($sql);
					
				}
				
				$sql	= $scls->getInsertSQL();
				$this->conn->exec($sql);
			
				$this->conn->commit();
				
			} catch(Exception $er) {
					
				$this->conn->rollBack();
				$err	= 'saledb CreateQuotation (line 949) '.$er->getMessage();
				_errorLog($err);
				$sid	= -1;
				
			}


			return $sid;
			
		}
		
		function deleteQuotation($scls) {
		
			$pkey				= $scls->getSaleID();
			$cmpid			= $scls->getCompanyID();
			$ret				= true;		
		
				
			try {
			
				$this->conn->beginTransaction();
				
				$this->conn->exec("DELETE FROM `gen_quote_addless` WHERE `SaleID`='$pkey'");
				$this->conn->exec("DELETE FROM `gen_quote_items` WHERE `SaleID`='$pkey'");
				
				$sql	= $scls->getDeleteSQL();
				$this->conn->exec($sql);
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				$err	= 'saledb deleteQuotation (line 990) '.$er->getMessage();
				_errorLog($err);
				$ret	= false;
				$this->conn->rollBack();
				
			}
				
		
			return $ret;

		}	
		
		function UpdateQuotation($scls) {
			
			$sid		= $scls->getSaleID();
			$pdt		= $scls->getDOS();
			$cmpid	= $scls->getCompanyID();
			$finyr	= getFinancialYear($pdt);

				
			try {
			
				$this->conn->beginTransaction();
				
				$this->conn->exec("DELETE FROM `gen_quote_addless` WHERE `SaleID`='$sid'");
				$this->conn->exec("DELETE FROM `gen_quote_items` WHERE `SaleID`='$sid'");				
				
				$itmList	= $scls->getItemList();
				for($i=0;$i<count($itmList);$i++) {
					$icls	=	$itmList[$i];
					$icls->setSaleID($sid);
					$icls->setSerialNo($i+1);

					$sql		= $icls->getInsertSQL();
					$this->conn->exec($sql);
					
				}
				
				$alList	= $scls->getAddLessList();
				for($j=0;$j<count($alList);$j++) {
					$acls	=	$alList[$j];
					$acls->setSaleID($sid);
					$acls->setSerialNo($j+1);

					$sql		= $acls->getInsertSQL();
					$this->conn->exec($sql);
					
				}
				
				$sql	= $scls->getUpdateSQL();
				$this->conn->exec($sql);
			
				$this->conn->commit();
				
			} catch(Exception $er) {
					
				$this->conn->rollBack();
				$err	= 'saledb UpdateQuotation (line 1199) '.$er->getMessage();
				_errorLog($err);
				$sid	= -1;
				
			}


			return $sid;
			
		}
		
		
		
		/*----------------------------------------------------------*/
		/*********************** SALE METHODS ***********************/
		
		function getNextSaleNo($FinYear, $CompanyID) {
			if(strpos($FinYear, "'") !== false) return false;
			$CompanyID	= (int)$CompanyID;
			
			$maxid			=	0;
			$sql				=	"SELECT MAX(`SaleNo`) FROM `gen_sale` WHERE `FinYear`='$FinYear' AND `CompanyID`='$CompanyID'";

			try {
				
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch())
					$maxid 	= $row[0];

			} catch(PDOException $e) {
				$err	= 'saledb getNextSaleNo '.$e->getMessage();
				_errorLog($err);
			}

			$maxid++;
			return $maxid;
		}

		function getSaleDetail($SaleID) {
			$SaleID	= (int)$SaleID;
			$cclass			=	new gen_sale();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_sale` WHERE `SaleID`='$SaleID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_sale');
				if($row 	= $result->fetch()) { 
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setSaleAccountName($this->getAccountNameByAccountID($row->getSaleAccountID()));
					$row->setCustomerName($this->getAccountNameByAccountID($row->getCustomerID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setConsigneeName($this->getAccountNameByAccountID($row->getConsigneeID()));
					$row->setItemList($this->getSaleItemList($row->getSaleID()));
					$row->setAddLessList($this->getSaleAddLessList($row->getSaleID()));
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'saledb getSaleDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getSaleList($CompanyID) {
			$CompanyID	= (int)$CompanyID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_sale` WHERE `CompanyID`='$CompanyID' ORDER BY `SaleNo`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_sale');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setSaleAccountName($this->getAccountNameByAccountID($row->getSaleAccountID()));
					$row->setCustomerName($this->getAccountNameByAccountID($row->getCustomerID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setConsigneeName($this->getAccountNameByAccountID($row->getConsigneeID()));
					$row->setItemList($this->getSaleItemList($row->getSaleID()));
					$row->setAddLessList($this->getSaleAddLessList($row->getSaleID()));
					$arr[]	= $row;
				}

			} catch(PDOException $e) {
				$err	= 'saledb getSaleList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getCustomerWiseSaleList($CompanyID, $CustomerID) {
			$CompanyID	= (int)$CompanyID;
			$CustomerID	= (int)$CustomerID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_sale` WHERE `CompanyID`='$CompanyID' AND `CustomerID`='$CustomerID' ORDER BY `SaleNo`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_sale');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setSaleAccountName($this->getAccountNameByAccountID($row->getSaleAccountID()));
					$row->setCustomerName($this->getAccountNameByAccountID($row->getCustomerID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setConsigneeName($this->getAccountNameByAccountID($row->getConsigneeID()));
					$row->setItemList($this->getSaleItemList($row->getSaleID()));
					$row->setAddLessList($this->getSaleAddLessList($row->getSaleID()));
					$arr[]	= $row;
				}

			} catch(PDOException $e) {
				$err	= 'saledb getSaleList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}		

		function getSaleListBySQL($sql) {
			$arr				=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_sale');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setSaleAccountName($this->getAccountNameByAccountID($row->getSaleAccountID()));
					$row->setCustomerName($this->getAccountNameByAccountID($row->getCustomerID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setConsigneeName($this->getAccountNameByAccountID($row->getConsigneeID()));
					$row->setItemList($this->getSaleItemList($row->getSaleID()));
					$row->setAddLessList($this->getSaleAddLessList($row->getSaleID()));
					$arr[]	= $row;
				}

			} catch(PDOException $e) {
				$err	= 'saledb getSaleListBySQL '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getSaleListReport($CompanyID, $DateFrom, $DateTo) {
			$CompanyID	= (int)$CompanyID;
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_sale` WHERE `CompanyID`='$CompanyID'";
				if($DateFrom != "" && $DateFrom != "1900-01-01")
					$sql		= $sql." AND `DOS`>='$DateFrom'";
				if($DateTo != "" && $DateTo != "1900-01-01")
					$sql		= $sql." AND `DOS`<='$DateTo'";
				$sql			= $sql." ORDER BY `DOS`, `SaleNo`";				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_sale');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setSaleAccountName($this->getAccountNameByAccountID($row->getSaleAccountID()));
					$row->setCustomerName($this->getAccountNameByAccountID($row->getCustomerID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setConsigneeName($this->getAccountNameByAccountID($row->getConsigneeID()));
					$row->setItemList($this->getSaleItemList($row->getSaleID()));
					$row->setAddLessList($this->getSaleAddLessList($row->getSaleID()));
					$arr[]	= $row;
				}

			} catch(PDOException $e) {
				$err	= 'saledb getSaleListReport '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getNumberOfSale($DateFrom, $DateTo, $SaleNo, $CustomerID, $StoreID, $CompanyID) {
		
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$SaleNo			= (int)$SaleNo;
			$CustomerID	= (int)$CustomerID;
			$StoreID		= (int)$StoreID;
			$CompanyID	= (int)$CompanyID;
		
			$sql	=	"SELECT COUNT(*) FROM `gen_sale` WHERE `CompanyID`='$CompanyID'";
			if($DateFrom != '1900-01-01')
				$sql	=	$sql." AND `DOS`>='$DateFrom'";
			if($DateTo != '1900-01-01')
				$sql	=	$sql." AND `DOS`<='$DateTo'";
			if($SaleNo > 0)
				$sql	=	$sql." AND `SaleNo`='$SaleNo'";
			if($CustomerID > 0)
				$sql	=	$sql." AND `CustomerID`='$CustomerID'";
			if($StoreID > 0)
				$sql	=	$sql." AND `StoreID`='$StoreID'";
			
			return $this->getResultExecutingQuery($sql);
		}

		function getSaleListPaged($sRec, $nRec, $DateFrom, $DateTo, $SaleNo, $CustomerID, $StoreID, $CompanyID) {
		
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$SaleNo			= (int)$SaleNo;
			$CustomerID	= (int)$CustomerID;
			$StoreID		= (int)$StoreID;
			$CompanyID	= (int)$CompanyID;
			$sRec				= (int)$sRec;
			$nRec				= (int)$nRec;
		
			$sql	=	"SELECT * FROM `gen_sale` WHERE `CompanyID`='$CompanyID'";
			if($DateFrom != '1900-01-01')
				$sql	=	$sql." AND `DOS`>='$DateFrom'";
			if($DateTo != '1900-01-01')
				$sql	=	$sql." AND `DOS`<='$DateTo'";
			if($SaleNo > 0)
				$sql	=	$sql." AND `SaleNo`='$SaleNo'";
			if($CustomerID > 0)
				$sql	=	$sql." AND `CustomerID`='$CustomerID'";
			if($StoreID > 0)
				$sql	=	$sql." AND `StoreID`='$StoreID'";
			
			$sql			=	$sql." ORDER BY `FinYear` DESC, `SaleNo` DESC LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_sale');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setSaleAccountName($this->getAccountNameByAccountID($row->getSaleAccountID()));
					$row->setCustomerName($this->getAccountNameByAccountID($row->getCustomerID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setConsigneeName($this->getAccountNameByAccountID($row->getConsigneeID()));
					$row->setItemList($this->getSaleItemList($row->getSaleID()));
					$row->setAddLessList($this->getSaleAddLessList($row->getSaleID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'saledb getSaleListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getSaleItemList($SaleID) {
			$SaleID	= (int)$SaleID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_sale_items` WHERE `SaleID`='$SaleID' ORDER BY `SerialNo`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_sale_items');
				while($row = $result->fetch()) {
					$row->setItemName($this->getItemNameByItemID($row->getItemID()));
					$row->setAccountName( $this->getAccountNameByAccountID( $row->getAccountID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'saledb getSaleItemList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getSaleAddLessList($SaleID) {
			$SaleID	= (int)$SaleID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_sale_addless` WHERE `SaleID`='$SaleID' ORDER BY `SerialNo`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_sale_addless');
				while($row = $result->fetch()) {
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'saledb getSaleAddLessList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function CreateSale($scls) {
				
			$tuser	=	unserialize($_SESSION["ssEUser"]);
			$tcmp		=	unserialize($_SESSION["ssECmp"]);
			$pdt		= $scls->getDOS();
			$cmpid	= $scls->getCompanyID();
			$finyr	= getFinancialYear($pdt);
			$scls->setFinYear($finyr);
			$scls->setSaleNo($this->getNextSaleNo($finyr, $cmpid));
			
			$itot				=	0;
			$gtot				= 0;
			$atot				=	0;
			$ntot				=	0;
			
			$vtyp				= CREDIT_SALE_VOUCHER;
			if($scls->getCashSale() == "YES")
				$vtyp			= CASH_SALE_VOUCHER;
			
			$totval			= 0;
			$narr				= 'SALE# '.$scls->getSaleNo().'/'.$finyr;
				
			try {
			
				$this->conn->beginTransaction();
				
				$scls->setSaleID($this->getNextID("gen_sale","SaleID"));
				$sid		= $scls->getSaleID();
				
				$sql	= $scls->getInsertSQL();
				$this->conn->exec($sql);
				
				$itmList	= $scls->getItemList();
				for($i=0;$i<count($itmList);$i++) {
					$icls	=	$itmList[$i];
					$icls->setSaleID($sid);
					$icls->setSerialNo($i+1);

					$sql		= $icls->getInsertSQL();
					$this->conn->exec($sql);
					
					if($scls->getStockEntry() == "YES") {
						/* Stock entries */
					
						$lcqty	= $this->getLastStockClosingQuantity($cmpid, $scls->getStoreID(), $icls->getItemID(), $pdt);
						$lcval	= $this->getLastStockClosingValue($cmpid, $scls->getStoreID(), $icls->getItemID(), $pdt);
						$lbald	= $this->getLastBalanceDetail($cmpid, $scls->getStoreID(), $icls->getItemID(), $pdt);
					
						$cqty		= $lcqty - $icls->getQuantity();
						$cval		= 0;
					
						$bald			= "";
						$bqty			= 0;
						$val			= 0;
						$Quantity	= $icls->getQuantity();
						$tmp1			= explode(",", $lbald);
						for($ii=0;$ii<count($tmp1);$ii++) {
							$tmp2		= $tmp1[$ii];
							if($tmp2 == "") continue;
							$tmp		= explode("=", $tmp2);
							$sqty		= (double)$tmp[0];
							$sprc		= (double)$tmp[1];
							if($sqty > $Quantity) {
								$bqty	= $sqty - $Quantity;
								$val	= $val + ($Quantity * $sprc);
								break;
							} else {
								$Quantity	= $Quantity - $sqty;
								$val			= $val + ($sqty * $sprc);
							}
						}
					
						for($j=$ii;$j<count($tmp1);$j++) {
							$tmp2		= $tmp1[$j];
							if($tmp2 == "") continue;
							$tmp		= explode("=", $tmp2);
							$sqty		= (double)$tmp[0];
							$sprc		= (double)$tmp[1];
							if($j == $ii) {
								if($bqty > 0) $sqty = $bqty;
							}
						
							if($bald != "") $bald = $bald.",";
							$bald		= $bald.$sqty.'='.$sprc;
						}
					
						/* Closing Value */
						$tmp1			= explode(",", $bald);
						for($ii=0;$ii<count($tmp1);$ii++) {
							$tmp2		= $tmp1[$ii];
							if($tmp2 == "") continue;
							$tmp		= explode("=", $tmp2);
							$sqty		= (double)$tmp[0];
							$sprc		= (double)$tmp[1];
						
							$cval		= $cval	+ ($sqty * $sprc);
						}
						/* Closing value ends here */
					
						$totval		= $totval + $val;										
					
						$stcls		= new asys_stock_voucher();
						$stcls->setSVoucherID($this->getNextID("asys_stock_voucher","SVoucherID"));
						$stcls->setCompanyID($scls->getCompanyID());
						$stcls->setStoreID($scls->getStoreID());
						$stcls->setModuleID(SALE);
						$stcls->setFinYear($scls->getFinYear());
						$stcls->setRelatedID($sid);
						$stcls->setDOT($scls->getDOS('yes'));
						$stcls->setTOT(time());
						$stcls->setItemID($icls->getItemID());
						$stcls->setItemCategoryID($this->getItemCategoryByItemID($icls->getItemID()));
						$stcls->setQuantity($icls->getQuantity());
						$stcls->setUnitPrice($val/$icls->getQuantity());
						$stcls->setStockInOut(STOCK_OUT);
						$stcls->setClosingQty($cqty);
						$stcls->setClosingValue($cval);
						$stcls->setBatchNo("");
						$stcls->setNarration('SALE# '.$scls->getSaleNo().'/'.$scls->getFinYear());
						$stcls->setBalanceDetail($bald);
					
						$sql		= $stcls->getInsertSQL();
						$this->conn->exec($sql);

						/* Stock entry ends here */
					}
					
				}
				
				$vclsArr		= [];
				$VoucherNo	= $this->getMaxVoucherNo($vtyp, $finyr, $cmpid);
				$DayWiseNo	= $this->getMaxDayWiseVoucherNo($vtyp, $pdt, $cmpid);				
				
				$alList	= $scls->getAddLessList();
				for($j=0;$j<count($alList);$j++) {
					$acls	=	$alList[$j];
					$acls->setSaleID($sid);
					$acls->setSerialNo($j+1);
					
					$amt		= $acls->getAmount();
					if($scls->getExport() == "YES")
						$amt	= $amt * $scls->getConversion();

					$sql		= $acls->getInsertSQL();
					$this->conn->exec($sql);					
					
					$aDet		= $this->getAccountDetail($acls->getAccountID());
					
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($j+6);
					$vcls->setCompanyID($cmpid);
					$vcls->setVoucherType($vtyp);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($VoucherNo);
					$vcls->setDayWiseNo($DayWiseNo);
					$vcls->setDOV($scls->getDOS('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($sid);
					$vcls->setTxnType(SALE);
					if($acls->getAddLess() == 'ADD')
						$vcls->setDrCr(CREDIT);
					else
						$vcls->setDrCr(DEBIT);
					$vcls->setAmount($amt);
					$vcls->setNarration('ADD/LESS FOR SALE# '.$scls->getSaleNo().'/'.$finyr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
					
				}
				
				/* Voucher Entries */				
				
				$aDet		= $this->getAccountDetail($scls->getCustomerID());
				
				$namt		= $scls->getNetTotal();
				if($scls->getExport() == "YES")
					$namt	= $namt * $scls->getConversion();				

				$vcls		=	new asys_voucher_entry();
				$vcls->setSerialID(1);
				$vcls->setCompanyID($scls->getCompanyID());
				$vcls->setVoucherType($vtyp);
				$vcls->setFinYear($finyr);
				$vcls->setVoucherNo($VoucherNo);
				$vcls->setDayWiseNo($DayWiseNo);
				$vcls->setDOV($scls->getDOS('yes'));
				$vcls->setMotherAccount($aDet->getMotherAccount());
				$vcls->setAccountID($aDet->getAccountID());
				$vcls->setRelatedID($sid);
				$vcls->setTxnType(SALE);
				$vcls->setDrCr(DEBIT);
				$vcls->setAmount($namt);
				$vcls->setNarration('SALE# '.$scls->getSaleNo().'/'.$finyr);
				$vcls->setUserID($tuser->getUserID());
				$vcls->setDOE(date('d-m-Y'));
			
				$vclsArr[] = $vcls;
				
				$samt		= $scls->getItemTotal() - ($scls->getIGST() + $scls->getSGST() + $scls->getCGST());
				if($scls->getExport() == "YES")
					$samt	= $samt * $scls->getConversion();				

				$aDet		= $this->getAccountDetail($scls->getSaleAccountID());
				$vcls		=	new asys_voucher_entry();
				$vcls->setSerialID(2);
				$vcls->setCompanyID($scls->getCompanyID());
				$vcls->setVoucherType($vtyp);
				$vcls->setFinYear($finyr);
				$vcls->setVoucherNo($VoucherNo);
				$vcls->setDayWiseNo($DayWiseNo);
				$vcls->setDOV($scls->getDOS('yes'));
				$vcls->setMotherAccount($aDet->getMotherAccount());
				$vcls->setAccountID($aDet->getAccountID());
				$vcls->setRelatedID($sid);
				$vcls->setTxnType(SALE);
				$vcls->setDrCr(CREDIT);
				$vcls->setAmount($samt);
				$vcls->setNarration('SALE# '.$scls->getSaleNo().'/'.$finyr);
				$vcls->setUserID($tuser->getUserID());
				$vcls->setDOE(date('d-m-Y'));
			
				$vclsArr[] = $vcls;
				
				$kk		= 3;
				if($scls->getIGST() > 0) {
					$aDet		= $this->getAccountDetail($tcmp->getIGSTAccountID());
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($kk);
					$vcls->setCompanyID($scls->getCompanyID());
					$vcls->setVoucherType($vtyp);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($VoucherNo);
					$vcls->setDayWiseNo($DayWiseNo);
					$vcls->setDOV($scls->getDOS('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($sid);
					$vcls->setTxnType(SALE);
					$vcls->setDrCr(CREDIT);
					$vcls->setAmount($scls->getIGST());
					$vcls->setNarration('IGST for SALE# '.$scls->getSaleNo().'/'.$finyr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
					$kk++;
				}
				
				if($scls->getCGST() > 0) {
					$aDet		= $this->getAccountDetail($tcmp->getCGSTAccountID());
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($kk);
					$vcls->setCompanyID($scls->getCompanyID());
					$vcls->setVoucherType($vtyp);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($VoucherNo);
					$vcls->setDayWiseNo($DayWiseNo);
					$vcls->setDOV($scls->getDOS('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($sid);
					$vcls->setTxnType(SALE);
					$vcls->setDrCr(CREDIT);
					$vcls->setAmount($scls->getCGST());
					$vcls->setNarration('CGST for SALE# '.$scls->getSaleNo().'/'.$finyr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
					$kk++;
				}
				
				if($scls->getSGST() > 0) {
					$aDet			= $this->getAccountDetail($tcmp->getSGSTAccountID());
					$sdet			= $this->getAccountDetail($scls->getCustomerID());
					
					if($this->getUTByState($sdet->getState()) == "YES")
						$aDet		= $this->getAccountDetail($tcmp->getUGSTAccountID());
						
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($kk);
					$vcls->setCompanyID($scls->getCompanyID());
					$vcls->setVoucherType($vtyp);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($VoucherNo);
					$vcls->setDayWiseNo($DayWiseNo);
					$vcls->setDOV($scls->getDOS('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($sid);
					$vcls->setTxnType(SALE);
					$vcls->setDrCr(CREDIT);
					$vcls->setAmount($scls->getSGST());
					$vcls->setNarration('SGST/UGST for SALE# '.$scls->getSaleNo().'/'.$finyr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
					$kk++;
				}
				
				$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
				for($ii=0; $ii<count($vclsArr); $ii++) {
					$vcls		= $vclsArr[$ii];
					$vcls->setVoucherID($vid);
					$this->conn->exec($vcls->getInsertSQL());					
				}
				
				/* Voucher Entry ends here */
				
				if($scls->getStockEntry() == "YES" && $totval > 0) {
					/* Voucher entry for Store */
				
					$VoucherNo	= $this->getMaxVoucherNo(JOURNAL_VOUCHER, $finyr, $cmpid);
					$DayWiseNo	= $this->getMaxDayWiseVoucherNo(JOURNAL_VOUCHER, $pdt, $cmpid);
				
					$storeDet		= $this->getStoreDetail($scls->getStoreID());
					if($storeDet->getAccountID() != 0)
						$aDet		= $this->getAccountDetail($storeDet->getAccountID());
					else
						$aDet		= $this->getAccountDetail($storeDet->getMotherAccountID());

					$vcls1		=	new asys_voucher_entry();
					$vcls1->setSerialID(1);
					$vcls1->setCompanyID($cmpid);
					$vcls1->setVoucherType(JOURNAL_VOUCHER);
					$vcls1->setFinYear($finyr);
					$vcls1->setVoucherNo($VoucherNo);
					$vcls1->setDayWiseNo($DayWiseNo);
					$vcls1->setDOV($scls->getDOS('yes'));
					$vcls1->setMotherAccount($aDet->getMotherAccount());
					$vcls1->setAccountID($aDet->getAccountID());
					$vcls1->setRelatedID($sid);
					$vcls1->setTxnType(SALE);
					$vcls1->setDrCr(CREDIT);
					$vcls1->setAmount($totval);
					$vcls1->setNarration($narr);
					$vcls1->setUserID($tuser->getUserID());
					$vcls1->setDOE(date('d-m-Y'));
				
				
					$aDet		= $this->getAccountDetail($storeDet->getOppositeAccountID());
				
					$vcls2		=	new asys_voucher_entry();
					$vcls2->setSerialID(2);
					$vcls2->setCompanyID($cmpid);
					$vcls2->setVoucherType(JOURNAL_VOUCHER);
					$vcls2->setFinYear($finyr);
					$vcls2->setVoucherNo($VoucherNo);
					$vcls2->setDayWiseNo($DayWiseNo);
					$vcls2->setDOV($scls->getDOS('yes'));
					$vcls2->setMotherAccount($aDet->getMotherAccount());
					$vcls2->setAccountID($aDet->getAccountID());
					$vcls2->setRelatedID($sid);
					$vcls2->setTxnType(SALE);
					$vcls2->setDrCr(DEBIT);
					$vcls2->setAmount($totval);
					$vcls2->setNarration($narr);
					$vcls2->setUserID($tuser->getUserID());
					$vcls2->setDOE(date('d-m-Y'));
			
			
					$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
					$vcls1->setVoucherID($vid);
					$vcls2->setVoucherID($vid);
					$this->conn->exec($vcls1->getInsertSQL());
					$this->conn->exec($vcls2->getInsertSQL());	
				
					/* Voucher entry for Store ends here */
				}
			
				$this->conn->commit();
				
			} catch(Exception $er) {
					
				$this->conn->rollBack();
				$err	= 'saledb CreateSale (line 949) '.$er->getMessage();
				_errorLog($err);
				$sid	= -1;
				
			}


			return $sid;
			
		}
		
		function deleteSale($scls) {
		
			$pkey				= $scls->getSaleID();
			$cmpid			= $scls->getCompanyID();
			$ret				= true;
			
			$vtyp				= CREDIT_SALE_VOUCHER;
			if($scls->getCashSale() == "YES")
				$vtyp			= CASH_SALE_VOUCHER;			
		
				
			try {
			
				$this->conn->beginTransaction();
				
				$this->conn->exec("DELETE FROM `gen_sale_addless` WHERE `SaleID`='$pkey'");
				$this->conn->exec("DELETE FROM `gen_sale_items` WHERE `SaleID`='$pkey'");
				$this->conn->exec("DELETE FROM `asys_voucher_entry` WHERE `RelatedID`='$pkey' AND `TxnType`='".SALE."' AND `CompanyID`='".$cmpid."'");
				$this->conn->exec("DELETE FROM `asys_stock_voucher` WHERE `RelatedID`='$pkey' AND `ModuleID`='".SALE."' AND `CompanyID`='".$cmpid."'");
				
				$sql	= $scls->getDeleteSQL();
				$this->conn->exec($sql);
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				$err	= 'saledb deleteSale (line 990) '.$er->getMessage();
				_errorLog($err);
				$ret	= false;
				$this->conn->rollBack();
				
			}
				
		
			return $ret;

		}
		
		function getDOSBySaleID($SaleID) {
			$SaleID	= (int)$SaleID;
			$sql	= "SELECT `DOS` FROM `gen_sale` WHERE `SaleID`='".$SaleID."'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getCashSaleBySaleID($SaleID) {
			$SaleID	= (int)$SaleID;
			$sql	= "SELECT `CashSale` FROM `gen_sale` WHERE `SaleID`='".$SaleID."'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function UpdateSale($scls) {
				
			$tuser	=	unserialize($_SESSION["ssEUser"]);
			$tcmp		= unserialize($_SESSION["ssECmp"]);
			$sid		= $scls->getSaleID();
			$pdt		= $scls->getDOS();
			$cmpid	= $scls->getCompanyID();
			$finyr	= getFinancialYear($pdt);
			
			$ovtyp			= CREDIT_SALE_VOUCHER;
			if($this->getCashSaleBySaleID($sid) == "YES")
				$ovtyp		= CASH_SALE_VOUCHER;			
			
			$vtyp				= CREDIT_SALE_VOUCHER;
			if($scls->getCashSale() == "YES")
				$vtyp			= CASH_SALE_VOUCHER;
			
			$vno		= $this->getVoucherNoByRelatedID($vtyp, SALE, $sid, $cmpid);
			if($pdt == $this->getDOSBySaleID($sid))
				$dwn	= $this->getDayWiseNoByRelatedID($vtyp, SALE, $sid, $cmpid);
			else
				$dwn	= $this->getMaxDayWiseVoucherNo($vtyp, $pdt, $cmpid);
				
			$itot				=	0;
			$gtot				= 0;
			$atot				=	0;
			$ntot				=	0;

			$totval			= 0;
			$narr				= 'SALE# '.$scls->getSaleNo().'/'.$finyr;
				
			try {
			
				$this->conn->beginTransaction();
				
				$this->conn->exec("DELETE FROM `gen_sale_addless` WHERE `SaleID`='$sid'");
				$this->conn->exec("DELETE FROM `gen_sale_items` WHERE `SaleID`='$sid'");
				$this->conn->exec("DELETE FROM `asys_voucher_entry` WHERE `RelatedID`='$sid' AND `TxnType`='".SALE."' AND `CompanyID`='".$cmpid."'");
				
				$delsql4	= "DELETE FROM `asys_stock_voucher` WHERE `RelatedID`='$sid' AND `ModuleID`='".SALE."' AND `CompanyID`='".$cmpid."'";
				
				$stkcls		= array();				
				
				$itmList	= $scls->getItemList();
				for($i=0;$i<count($itmList);$i++) {
					$icls	=	$itmList[$i];
					$icls->setSaleID($sid);
					$icls->setSerialNo($i+1);

					$sql		= $icls->getInsertSQL();
					$this->conn->exec($sql);
					
					
					if($scls->getStockEntry() == "YES") {
						/* Stock entries */
					
						$lcqty	= $this->getLastStockClosingQuantityForUpdate($cmpid, $scls->getStoreID(), $icls->getItemID(), $pdt, SALE, $sid);
						$lcval	= $this->getLastStockClosingValueForUpdate($cmpid, $scls->getStoreID(), $icls->getItemID(), $pdt, SALE, $sid);
						$lbald	= $this->getLastBalanceDetailForUpdate($cmpid, $scls->getStoreID(), $icls->getItemID(), $pdt, SALE, $sid);
					
						$cqty		= $lcqty - $icls->getQuantity();
						$cval		= 0;
					
						$bald			= "";
						$bqty			= 0;
						$val			= 0;
						$Quantity	= $icls->getQuantity();
						$tmp1			= explode(",", $lbald);
						for($ii=0;$ii<count($tmp1);$ii++) {
							$tmp2		= $tmp1[$ii];
							if($tmp2 == "") continue;
							$tmp		= explode("=", $tmp2);
							$sqty		= (double)$tmp[0];
							$sprc		= (double)$tmp[1];
							if($sqty > $Quantity) {
								$bqty	= $sqty - $Quantity;
								$val	= $val + ($Quantity * $sprc);
								break;
							} else {
								$Quantity	= $Quantity - $sqty;
								$val			= $val + ($sqty * $sprc);
							}
						}
					
						for($j=$ii;$j<count($tmp1);$j++) {
							$tmp2		= $tmp1[$j];
							if($tmp2 == "") continue;
							$tmp		= explode("=", $tmp2);
							$sqty		= (double)$tmp[0];
							$sprc		= (double)$tmp[1];
							if($j == $ii) {
								if($bqty > 0) $sqty = $bqty;
							}
						
							if($bald != "") $bald = $bald.",";
							$bald		= $bald.$sqty.'='.$sprc;
						}
					
						/* Closing Value */
						$tmp1			= explode(",", $bald);
						for($ii=0;$ii<count($tmp1);$ii++) {
							$tmp2		= $tmp1[$ii];
							if($tmp2 == "") continue;
							$tmp		= explode("=", $tmp2);
							$sqty		= (double)$tmp[0];
							$sprc		= (double)$tmp[1];
						
							$cval		= $cval	+ ($sqty * $sprc);
						}
						/* Closing value ends here */
					
						$totval		= $totval + $val;						
					
						$stcls		= new asys_stock_voucher();
						$stcls->setCompanyID($scls->getCompanyID());
						$stcls->setStoreID($scls->getStoreID());
						$stcls->setModuleID(SALE);
						$stcls->setFinYear($scls->getFinYear());
						$stcls->setRelatedID($sid);
						$stcls->setDOT($scls->getDOS('yes'));
						$stcls->setTOT(time());
						$stcls->setItemID($icls->getItemID());
						$stcls->setItemCategoryID($this->getItemCategoryByItemID($icls->getItemID()));
						$stcls->setQuantity($icls->getQuantity());
						$stcls->setUnitPrice($val/$icls->getQuantity());
						$stcls->setStockInOut(STOCK_OUT);
						$stcls->setClosingQty($cqty);
						$stcls->setClosingValue($cval);
						$stcls->setBatchNo("");
						$stcls->setNarration('SALE# '.$scls->getSaleNo().'/'.$scls->getFinYear());
						$stcls->setBalanceDetail($bald);
					
						$stkcls[]	= $stcls;
					
						/* Stock entry ends here */
						
					}
										
				}
				
				$this->conn->exec($delsql4);
				if($scls->getStockEntry() == "YES") {
					for($i=0;$i<count($stkcls);$i++) {
						$stcls		= $stkcls[$i];
						$stcls->setSVoucherID($this->getNextID("asys_stock_voucher","SVoucherID"));
						$this->conn->exec($stcls->getInsertSQL());
					}
				}
				
				$vclsArr		= [];
				
				$alList	= $scls->getAddLessList();
				for($j=0;$j<count($alList);$j++) {
					$acls	=	$alList[$j];
					$acls->setSaleID($sid);
					$acls->setSerialNo($j+1);
					
					$amt		= $acls->getAmount();
					if($scls->getExport() == "YES")
						$amt	= $amt * $scls->getConversion();

					$sql		= $acls->getInsertSQL();
					$this->conn->exec($sql);					
					
					$aDet		= $this->getAccountDetail($acls->getAccountID());
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($j+6);
					$vcls->setCompanyID($cmpid);
					$vcls->setVoucherType($vtyp);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($vno);
					$vcls->setDayWiseNo($dwn);
					$vcls->setDOV($scls->getDOS('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($sid);
					$vcls->setTxnType(SALE);
					if($acls->getAddLess() == 'ADD')
						$vcls->setDrCr(CREDIT);
					else
						$vcls->setDrCr(DEBIT);
					$vcls->setAmount($amt);
					$vcls->setNarration('ADD/LESS FOR SALE# '.$scls->getSaleNo().'/'.$finyr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
					
				}
				
				$sql	= $scls->getUpdateSQL();
				$this->conn->exec($sql);
				
				/* Voucher Entries */
				
				$aDet		= $this->getAccountDetail($scls->getCustomerID());
				
				$namt		= $scls->getNetTotal();
				if($scls->getExport() == "YES")
					$namt	= $namt * $scls->getConversion();				

				$vcls		=	new asys_voucher_entry();
				$vcls->setSerialID(1);
				$vcls->setCompanyID($scls->getCompanyID());
				$vcls->setVoucherType($vtyp);
				$vcls->setFinYear($finyr);
				$vcls->setVoucherNo($vno);
				$vcls->setDayWiseNo($dwn);
				$vcls->setDOV($scls->getDOS('yes'));
				$vcls->setMotherAccount($aDet->getMotherAccount());
				$vcls->setAccountID($aDet->getAccountID());
				$vcls->setRelatedID($sid);
				$vcls->setTxnType(SALE);
				$vcls->setDrCr(DEBIT);
				$vcls->setAmount($namt);
				$vcls->setNarration('SALE# '.$scls->getSaleNo().'/'.$finyr);
				$vcls->setUserID($tuser->getUserID());
				$vcls->setDOE(date('d-m-Y'));
			
				$vclsArr[] = $vcls;
				
				$samt		= $scls->getItemTotal() - ($scls->getIGST() + $scls->getSGST() + $scls->getCGST());
				if($scls->getExport() == "YES")
					$samt	= $samt * $scls->getConversion();				

				$aDet		= $this->getAccountDetail($scls->getSaleAccountID());
				$vcls		=	new asys_voucher_entry();
				$vcls->setSerialID(2);
				$vcls->setCompanyID($scls->getCompanyID());
				$vcls->setVoucherType($vtyp);
				$vcls->setFinYear($finyr);
				$vcls->setVoucherNo($vno);
				$vcls->setDayWiseNo($dwn);
				$vcls->setDOV($scls->getDOS('yes'));
				$vcls->setMotherAccount($aDet->getMotherAccount());
				$vcls->setAccountID($aDet->getAccountID());
				$vcls->setRelatedID($sid);
				$vcls->setTxnType(SALE);
				$vcls->setDrCr(CREDIT);
				$vcls->setAmount($samt);
				$vcls->setNarration('SALE# '.$scls->getSaleNo().'/'.$finyr);
				$vcls->setUserID($tuser->getUserID());
				$vcls->setDOE(date('d-m-Y'));
			
				$vclsArr[] = $vcls;
				
				$kk		= 3;
				if($scls->getIGST() > 0) {
					$aDet		= $this->getAccountDetail($tcmp->getIGSTAccountID());
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($kk);
					$vcls->setCompanyID($scls->getCompanyID());
					$vcls->setVoucherType($vtyp);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($vno);
					$vcls->setDayWiseNo($dwn);
					$vcls->setDOV($scls->getDOS('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($sid);
					$vcls->setTxnType(SALE);
					$vcls->setDrCr(CREDIT);
					$vcls->setAmount($scls->getIGST());
					$vcls->setNarration('IGST for SALE# '.$scls->getSaleNo().'/'.$finyr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
					$kk++;
				}
				
				if($scls->getCGST() > 0) {
					$aDet		= $this->getAccountDetail($tcmp->getCGSTAccountID());
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($kk);
					$vcls->setCompanyID($scls->getCompanyID());
					$vcls->setVoucherType($vtyp);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($vno);
					$vcls->setDayWiseNo($dwn);
					$vcls->setDOV($scls->getDOS('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($sid);
					$vcls->setTxnType(SALE);
					$vcls->setDrCr(CREDIT);
					$vcls->setAmount($scls->getCGST());
					$vcls->setNarration('CGST for SALE# '.$scls->getSaleNo().'/'.$finyr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
					$kk++;
				}
				
				if($scls->getSGST() > 0) {
					$aDet			= $this->getAccountDetail($tcmp->getSGSTAccountID());
					$sdet			= $this->getAccountDetail($scls->getCustomerID());
					
					if($this->getUTByState($sdet->getState()) == "YES")
						$aDet		= $this->getAccountDetail($tcmp->getUGSTAccountID());
						
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($kk);
					$vcls->setCompanyID($scls->getCompanyID());
					$vcls->setVoucherType($vtyp);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($vno);
					$vcls->setDayWiseNo($dwn);
					$vcls->setDOV($scls->getDOS('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($sid);
					$vcls->setTxnType(SALE);
					$vcls->setDrCr(CREDIT);
					$vcls->setAmount($scls->getSGST());
					$vcls->setNarration('SGST/UGST for SALE# '.$scls->getSaleNo().'/'.$finyr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
					$kk++;
				}
				
				$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
				for($ii=0; $ii<count($vclsArr); $ii++) {
					$vcls		= $vclsArr[$ii];
					$vcls->setVoucherID($vid);
					$this->conn->exec($vcls->getInsertSQL());					
				}				
				
				/* Voucher Entry ends here */
				
				
				if($scls->getStockEntry() == "YES" && $totval > 0) {
					/* Voucher entry for Store */
				
					$VoucherNo	= $this->getMaxVoucherNo(JOURNAL_VOUCHER, $finyr, $cmpid);
					$DayWiseNo	= $this->getMaxDayWiseVoucherNo(JOURNAL_VOUCHER, $pdt, $cmpid);
				
					$storeDet		= $this->getStoreDetail($scls->getStoreID());
					if($storeDet->getAccountID() != 0)
						$aDet		= $this->getAccountDetail($storeDet->getAccountID());
					else
						$aDet		= $this->getAccountDetail($storeDet->getMotherAccountID());

					$vcls1		=	new asys_voucher_entry();
					$vcls1->setSerialID(1);
					$vcls1->setCompanyID($cmpid);
					$vcls1->setVoucherType(JOURNAL_VOUCHER);
					$vcls1->setFinYear($finyr);
					$vcls1->setVoucherNo($VoucherNo);
					$vcls1->setDayWiseNo($DayWiseNo);
					$vcls1->setDOV($scls->getDOS('yes'));
					$vcls1->setMotherAccount($aDet->getMotherAccount());
					$vcls1->setAccountID($aDet->getAccountID());
					$vcls1->setRelatedID($sid);
					$vcls1->setTxnType(SALE);
					$vcls1->setDrCr(CREDIT);
					$vcls1->setAmount($totval);
					$vcls1->setNarration($narr);
					$vcls1->setUserID($tuser->getUserID());
					$vcls1->setDOE(date('d-m-Y'));
				
				
					$aDet		= $this->getAccountDetail($storeDet->getOppositeAccountID());
				
					$vcls2		=	new asys_voucher_entry();
					$vcls2->setSerialID(2);
					$vcls2->setCompanyID($cmpid);
					$vcls2->setVoucherType(JOURNAL_VOUCHER);
					$vcls2->setFinYear($finyr);
					$vcls2->setVoucherNo($VoucherNo);
					$vcls2->setDayWiseNo($DayWiseNo);
					$vcls2->setDOV($scls->getDOS('yes'));
					$vcls2->setMotherAccount($aDet->getMotherAccount());
					$vcls2->setAccountID($aDet->getAccountID());
					$vcls2->setRelatedID($sid);
					$vcls2->setTxnType(SALE);
					$vcls2->setDrCr(DEBIT);
					$vcls2->setAmount($totval);
					$vcls2->setNarration($narr);
					$vcls2->setUserID($tuser->getUserID());
					$vcls2->setDOE(date('d-m-Y'));
			
					$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
					$vcls1->setVoucherID($vid);
					$vcls2->setVoucherID($vid);
					$this->conn->exec($vcls1->getInsertSQL());
					$this->conn->exec($vcls2->getInsertSQL());								
				
					/* Voucher entry for Store ends here */
					
				}
			
				$this->conn->commit();
				
			} catch(Exception $er) {
					
				$this->conn->rollBack();
				$err	= 'saledb UpdateSale (line 1199) '.$er->getMessage();
				_errorLog($err);
				$sid	= -1;
				
			}


			return $sid;
			
		}
		
		function getSlabwiseTaxableValue($SaleID, $TaxType) {
			$SaleID		= (int)$SaleID;
			$TaxType	= addslashes($TaxType);
			
			if($TaxType == "State") {
				$sql		= "SELECT SUM(`Amount` - `Discount`) AS `Amount`, `CGSTRate`*2 AS `Rate` FROM `gen_sale_items` WHERE `SaleID`='$SaleID' GROUP BY `CGSTRate`";
			} else {
				$sql		= "SELECT SUM(`Amount` - `Discount`) AS `Amount`, `IGSTRate` AS `Rate` FROM `gen_sale_items` WHERE `SaleID`='$SaleID' GROUP BY `IGSTRate`";
			}
			
			return $this->getRecordsetExecutingQuery($sql);
		}
		
		
		
		/*-----------------------------------------------------------------*/
		/*********************** SALE RETURN METHODS ***********************/
		
		function getNextSaleReturnNo($FinYear, $CompanyID) {
			if(strpos($FinYear, "'") !== false) return false;
			$CompanyID	= (int)$CompanyID;
			
			$maxid			=	0;
			$sql				=	"SELECT MAX(`ReturnNo`) FROM `gen_salereturn` WHERE `FinYear`='$FinYear' AND `CompanyID`='$CompanyID'";

			try {
				
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch())
					$maxid 	= $row[0];
					
			} catch(PDOException $e) {
				$err	= 'saledb getNextSaleReturnNo '.$e->getMessage();
				_errorLog($err);
			}

			$maxid++;
			return $maxid;
		}

		function getSaleReturnDetail($ReturnID) {
			$ReturnID	= (int)$ReturnID;
			$cclass			=	new gen_salereturn();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_salereturn` WHERE `ReturnID`='$ReturnID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_salereturn');
				if($row 	= $result->fetch()) { 
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setSaleAccountName($this->getAccountNameByAccountID($row->getSaleAccountID()));
					$row->setCustomerName($this->getAccountNameByAccountID($row->getCustomerID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemList($this->getSaleReturnItemList($row->getReturnID()));
					$row->setAddLessList($this->getSaleReturnAddLessList($row->getReturnID()));
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'saledb getSaleReturnDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getSaleReturnList($CompanyID) {
			$CompanyID	= (int)$CompanyID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_salereturn` WHERE `CompanyID`='$CompanyID' ORDER BY `ReturnNo`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_salereturn');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setSaleAccountName($this->getAccountNameByAccountID($row->getSaleAccountID()));
					$row->setCustomerName($this->getAccountNameByAccountID($row->getCustomerID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemList($this->getSaleReturnItemList($row->getReturnID()));
					$row->setAddLessList($this->getSaleReturnAddLessList($row->getReturnID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'saledb getSaleReturnList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getSaleReturnListReport($CompanyID, $DateFrom, $DateTo) {
			$CompanyID	= (int)$CompanyID;
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_salereturn` WHERE `CompanyID`='$CompanyID'";
				if($DateFrom != "" && $DateFrom != "1900-01-01")
					$sql		= $sql." AND `DOR`>='$DateFrom'";
				if($DateTo != "" && $DateTo != "1900-01-01")
					$sql		= $sql." AND `DOR`<='$DateTo'";
				$sql			= $sql." ORDER BY `DOR`, `ReturnNo`";				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_salereturn');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setSaleAccountName($this->getAccountNameByAccountID($row->getSaleAccountID()));
					$row->setCustomerName($this->getAccountNameByAccountID($row->getCustomerID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemList($this->getSaleReturnItemList($row->getReturnID()));
					$row->setAddLessList($this->getSaleReturnAddLessList($row->getReturnID()));
					$arr[]	= $row;
				}

			} catch(PDOException $e) {
				$err	= 'saledb getSaleReturnListReport '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}		
		
		function getNumberOfSaleReturn($DateFrom, $DateTo, $ReturnNo, $CustomerID, $StoreID, $CompanyID) {
		
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$ReturnNo			= (int)$ReturnNo;
			$CustomerID	= (int)$CustomerID;
			$StoreID		= (int)$StoreID;
			$CompanyID	= (int)$CompanyID;
		
			$sql	=	"SELECT COUNT(*) FROM `gen_salereturn` WHERE `CompanyID`='$CompanyID'";
			if($DateFrom != '1900-01-01')
				$sql	=	$sql." AND `DOR`>='$DateFrom'";
			if($DateTo != '1900-01-01')
				$sql	=	$sql." AND `DOR`<='$DateTo'";
			if($ReturnNo > 0)
				$sql	=	$sql." AND `ReturnNo`='$ReturnNo'";
			if($CustomerID > 0)
				$sql	=	$sql." AND `CustomerID`='$CustomerID'";
			if($StoreID > 0)
				$sql	=	$sql." AND `StoreID`='$StoreID'";
			
			return $this->getResultExecutingQuery($sql);
		}

		function getSaleReturnListPaged($sRec, $nRec, $DateFrom, $DateTo, $ReturnNo, $CustomerID, $StoreID, $CompanyID) {
		
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$ReturnNo			= (int)$ReturnNo;
			$CustomerID	= (int)$CustomerID;
			$StoreID		= (int)$StoreID;
			$CompanyID	= (int)$CompanyID;
			$sRec				= (int)$sRec;
			$nRec				= (int)$nRec;
		
			$sql	=	"SELECT * FROM `gen_salereturn` WHERE `CompanyID`='$CompanyID'";
			if($DateFrom != '1900-01-01')
				$sql	=	$sql." AND `DOR`>='$DateFrom'";
			if($DateTo != '1900-01-01')
				$sql	=	$sql." AND `DOR`<='$DateTo'";
			if($ReturnNo > 0)
				$sql	=	$sql." AND `ReturnNo`='$ReturnNo'";
			if($CustomerID > 0)
				$sql	=	$sql." AND `CustomerID`='$CustomerID'";
			if($StoreID > 0)
				$sql	=	$sql." AND `StoreID`='$StoreID'";
			
			$sql			=	$sql." ORDER BY `FinYear` DESC, `ReturnNo` DESC LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_salereturn');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setSaleAccountName($this->getAccountNameByAccountID($row->getSaleAccountID()));
					$row->setCustomerName($this->getAccountNameByAccountID($row->getCustomerID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemList($this->getSaleReturnItemList($row->getReturnID()));
					$row->setAddLessList($this->getSaleReturnAddLessList($row->getReturnID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'saledb getSaleReturnListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getSaleReturnItemList($ReturnID) {
			$ReturnID	= (int)$ReturnID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_salereturn_items` WHERE `ReturnID`='$ReturnID' ORDER BY `SerialNo`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_salereturn_items');
				while($row = $result->fetch()) {
					$row->setItemName($this->getItemNameByItemID($row->getItemID()));
					$row->setAccountName( $this->getAccountNameByAccountID( $row->getAccountID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'saledb getReturnItemList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getSaleReturnAddLessList($ReturnID) {
			$ReturnID	= (int)$ReturnID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_salereturn_addless` WHERE `ReturnID`='$ReturnID' ORDER BY `SerialNo`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_salereturn_addless');
				while($row = $result->fetch()) {
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'saledb getReturnAddLessList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function CreateSaleReturn($scls) {
				
			$tuser	=	unserialize($_SESSION["ssEUser"]);
			$tcmp		= unserialize($_SESSION["ssECmp"]);
			$pdt		= $scls->getDOR();
			$cmpid	= $scls->getCompanyID();
			$finyr	= getFinancialYear($pdt);
			$scls->setFinYear($finyr);
			$scls->setReturnNo($this->getNextSaleReturnNo($finyr, $cmpid));
			
			$narr		= 'SALE RETURN# '.$scls->getReturnNo().'/'.$finyr;
			
			$itot				=	0;
			$gtot				= 0;
			$atot				=	0;
			$ntot				=	0;

			$totval			= 0;	
				
			try {
			
				$this->conn->beginTransaction();
				
				$scls->setReturnID($this->getNextID("gen_salereturn","ReturnID"));
				$sid		= $scls->getReturnID();
				
				$sql	= $scls->getInsertSQL();
				$this->conn->exec($sql);	
				
				$totQty		= 0;
				$xtraPerUnit	= 0;
				
				$itmList	= $scls->getItemList();
				
				for($i=0;$i<count($itmList);$i++) {
					$icls		=	$itmList[$i];
					$totQty	= $totQty + $icls->getQuantity();
				}							
				
				for($i=0;$i<count($itmList);$i++) {
					$icls	=	$itmList[$i];
					$icls->setReturnID($sid);
					$icls->setSerialNo($i+1);

					$sql		= $icls->getInsertSQL();
					$this->conn->exec($sql);
					
					
					if($scls->getStockEntry() == "YES") {
					
						$lcqty	= $this->getLastStockClosingQuantity($cmpid, $scls->getStoreID(), $icls->getItemID(), $pdt);
						$lcval	= $this->getLastStockClosingValue($cmpid, $scls->getStoreID(), $icls->getItemID(), $pdt);
						$lbald	= $this->getLastBalanceDetail($cmpid, $scls->getStoreID(), $icls->getItemID(), $pdt);
					
						$iamt		= $icls->getTotalAmount() - ($icls->getIGST() + $icls->getSGST() + $icls->getCGST());
						$cqty		= $lcqty + $icls->getQuantity();
						$cval		= $lcval + $icls->getTotalAmount();
						$bald		= $lbald;
						if($bald != "") $bald = $bald.",";
						$bald		= $bald.$icls->getQuantity()."=".($icls->getTotalAmount()/$icls->getQuantity());
					
						$totval		= $totval + $iamt;
					
						$stcls		= new asys_stock_voucher();
						$stcls->setSVoucherID($this->getNextID("asys_stock_voucher","SVoucherID"));
						$stcls->setCompanyID($scls->getCompanyID());
						$stcls->setStoreID($scls->getStoreID());
						$stcls->setModuleID(SALE_RETURN);
						$stcls->setFinYear($scls->getFinYear());
						$stcls->setRelatedID($sid);
						$stcls->setDOT($scls->getDOR('yes'));
						$stcls->setTOT(time());
						$stcls->setItemID($icls->getItemID());
						$stcls->setItemCategoryID($this->getItemCategoryByItemID($icls->getItemID()));
						$stcls->setQuantity($icls->getQuantity());
						$stcls->setUnitPrice($iamt/$icls->getQuantity() + $xtraPerUnit);
						$stcls->setStockInOut(STOCK_IN);
						$stcls->setClosingQty($cqty);
						$stcls->setClosingValue($cval);						
						$stcls->setBatchNo("");
						$stcls->setNarration($narr);
						$stcls->setBalanceDetail($bald);
					
						$sql		= $stcls->getInsertSQL();
						$this->conn->exec($sql);
					
						/* Stock entry ends here */
						
					}
				
				}
				
				$vclsArr		= [];
				$VoucherNo	= $this->getMaxVoucherNo(SALE_RETURN_VOUCHER, $finyr, $cmpid);
				$DayWiseNo	= $this->getMaxDayWiseVoucherNo(SALE_RETURN_VOUCHER, $pdt, $cmpid);				
				
				$alList	= $scls->getAddLessList();
				for($j=0;$j<count($alList);$j++) {
					$acls	=	$alList[$j];
					$acls->setReturnID($sid);
					$acls->setSerialNo($j+1);
					
					if($acls->getAddLess('asis') == "ADD")
						$atot	=	$atot + $acls->getAmount('asis');
					else
						$atot	=	$atot - $acls->getAmount('asis');

					$sql		= $acls->getInsertSQL();
					$this->conn->exec($sql);
					
					
					$aDet		= $this->getAccountDetail($acls->getAccountID());
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($j+6);
					$vcls->setCompanyID($cmpid);
					$vcls->setVoucherType(SALE_RETURN_VOUCHER);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($VoucherNo);
					$vcls->setDayWiseNo($DayWiseNo);
					$vcls->setDOV($scls->getDOR('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($sid);
					$vcls->setTxnType(SALE_RETURN);
					if($acls->getAddLess() == 'ADD')
						$vcls->setDrCr(DEBIT);
					else
						$vcls->setDrCr(CREDIT);
					$vcls->setAmount($acls->getAmount());
					$vcls->setNarration('SALE RETURN# '.$scls->getReturnNo().'/'.$finyr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
					
				}
				
				
				/* Voucher Entries */
				
				$aDet		= $this->getAccountDetail($scls->getCustomerID());

				$vcls		=	new asys_voucher_entry();
				$vcls->setSerialID(1);
				$vcls->setCompanyID($scls->getCompanyID());
				$vcls->setVoucherType(SALE_RETURN_VOUCHER);
				$vcls->setFinYear($finyr);
				$vcls->setVoucherNo($VoucherNo);
				$vcls->setDayWiseNo($DayWiseNo);
				$vcls->setDOV($scls->getDOR('yes'));
				$vcls->setMotherAccount($aDet->getMotherAccount());
				$vcls->setAccountID($aDet->getAccountID());
				$vcls->setRelatedID($sid);
				$vcls->setTxnType(SALE_RETURN);
				$vcls->setDrCr(CREDIT);
				$vcls->setAmount($scls->getNetTotal());
				$vcls->setNarration('SALE RETURN# '.$scls->getReturnNo().'/'.$finyr);
				$vcls->setUserID($tuser->getUserID());
				$vcls->setDOE(date('d-m-Y'));
			
				$vclsArr[] = $vcls;

				$aDet		= $this->getAccountDetail($scls->getSaleAccountID());
				$vcls		=	new asys_voucher_entry();
				$vcls->setSerialID(2);
				$vcls->setCompanyID($scls->getCompanyID());
				$vcls->setVoucherType(SALE_RETURN_VOUCHER);
				$vcls->setFinYear($finyr);
				$vcls->setVoucherNo($VoucherNo);
				$vcls->setDayWiseNo($DayWiseNo);
				$vcls->setDOV($scls->getDOR('yes'));
				$vcls->setMotherAccount($aDet->getMotherAccount());
				$vcls->setAccountID($aDet->getAccountID());
				$vcls->setRelatedID($sid);
				$vcls->setTxnType(SALE_RETURN);
				$vcls->setDrCr(DEBIT);
				$vcls->setAmount($scls->getItemTotal() - ($scls->getIGST() + $scls->getSGST() + $scls->getCGST()));
				$vcls->setNarration('SALE RETURN# '.$scls->getReturnNo().'/'.$finyr);
				$vcls->setUserID($tuser->getUserID());
				$vcls->setDOE(date('d-m-Y'));
			
				$vclsArr[] = $vcls;
				
				$kk		= 3;
				if($scls->getIGST() > 0) {
					$aDet		= $this->getAccountDetail($tcmp->getIGSTAccountID());
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($kk);
					$vcls->setCompanyID($scls->getCompanyID());
					$vcls->setVoucherType(SALE_RETURN_VOUCHER);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($VoucherNo);
					$vcls->setDayWiseNo($DayWiseNo);
					$vcls->setDOV($scls->getDOR('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($sid);
					$vcls->setTxnType(SALE_RETURN);
					$vcls->setDrCr(DEBIT);
					$vcls->setAmount($scls->getIGST());
					$vcls->setNarration('IGST for SALE RETURN# '.$scls->getReturnNo().'/'.$finyr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
					$kk++;
				}
				
				if($scls->getCGST() > 0) {
					$aDet		= $this->getAccountDetail($tcmp->getCGSTAccountID());
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($kk);
					$vcls->setCompanyID($scls->getCompanyID());
					$vcls->setVoucherType(SALE_RETURN_VOUCHER);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($VoucherNo);
					$vcls->setDayWiseNo($DayWiseNo);
					$vcls->setDOV($scls->getDOR('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($sid);
					$vcls->setTxnType(SALE_RETURN);
					$vcls->setDrCr(DEBIT);
					$vcls->setAmount($scls->getCGST());
					$vcls->setNarration('CGST for SALE RETURN# '.$scls->getReturnNo().'/'.$finyr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
					$kk++;
				}
				
				if($scls->getSGST() > 0) {
					$aDet			= $this->getAccountDetail($tcmp->getSGSTAccountID());
					$sdet			= $this->getAccountDetail($scls->getCustomerID());
					
					if($this->getUTByState($sdet->getState()) == "YES")
						$aDet		= $this->getAccountDetail($tcmp->getUGSTAccountID());
						
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($kk);
					$vcls->setCompanyID($scls->getCompanyID());
					$vcls->setVoucherType(SALE_RETURN_VOUCHER);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($VoucherNo);
					$vcls->setDayWiseNo($DayWiseNo);
					$vcls->setDOV($scls->getDOR('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($sid);
					$vcls->setTxnType(SALE_RETURN);
					$vcls->setDrCr(DEBIT);
					$vcls->setAmount($scls->getSGST());
					$vcls->setNarration('SGST for SALE RETURN# '.$scls->getReturnNo().'/'.$finyr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
					$kk++;
				}
				
				$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
				for($ii=0; $ii<count($vclsArr); $ii++) {
					$vcls		= $vclsArr[$ii];
					$vcls->setVoucherID($vid);
					$this->conn->exec($vcls->getInsertSQL());					
				}				
				
				/* Voucher Entry ends here */
				
				
				if($scls->getStockEntry() == "YES" && $totval > 0) {
					/* Voucher entry for Store */
				
					$VoucherNo	= $this->getMaxVoucherNo(JOURNAL_VOUCHER, $finyr, $cmpid);
					$DayWiseNo	= $this->getMaxDayWiseVoucherNo(JOURNAL_VOUCHER, $pdt, $cmpid);
				
					$storeDet		= $this->getStoreDetail($scls->getStoreID());
					if($storeDet->getAccountID() != 0)
						$aDet		= $this->getAccountDetail($storeDet->getAccountID());
					else
						$aDet		= $this->getAccountDetail($storeDet->getMotherAccountID());

					$vcls1		=	new asys_voucher_entry();
					$vcls1->setSerialID(1);
					$vcls1->setCompanyID($cmpid);
					$vcls1->setVoucherType(JOURNAL_VOUCHER);
					$vcls1->setFinYear($finyr);
					$vcls1->setVoucherNo($VoucherNo);
					$vcls1->setDayWiseNo($DayWiseNo);
					$vcls1->setDOV($scls->getDOR('yes'));
					$vcls1->setMotherAccount($aDet->getMotherAccount());
					$vcls1->setAccountID($aDet->getAccountID());
					$vcls1->setRelatedID($sid);
					$vcls1->setTxnType(SALE_RETURN);
					$vcls1->setDrCr(DEBIT);
					$vcls1->setAmount($totval);
					$vcls1->setNarration($narr);
					$vcls1->setUserID($tuser->getUserID());
					$vcls1->setDOE(date('d-m-Y'));
				
				
					$aDet		= $this->getAccountDetail($storeDet->getOppositeAccountID());
				
					$vcls2		=	new asys_voucher_entry();
					$vcls2->setSerialID(2);
					$vcls2->setCompanyID($cmpid);
					$vcls2->setVoucherType(JOURNAL_VOUCHER);
					$vcls2->setFinYear($finyr);
					$vcls2->setVoucherNo($VoucherNo);
					$vcls2->setDayWiseNo($DayWiseNo);
					$vcls2->setDOV($scls->getDOR('yes'));
					$vcls2->setMotherAccount($aDet->getMotherAccount());
					$vcls2->setAccountID($aDet->getAccountID());
					$vcls2->setRelatedID($sid);
					$vcls2->setTxnType(SALE_RETURN);
					$vcls2->setDrCr(CREDIT);
					$vcls2->setAmount($totval);
					$vcls2->setNarration($narr);
					$vcls2->setUserID($tuser->getUserID());
					$vcls2->setDOE(date('d-m-Y'));
			
					$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
					$vcls1->setVoucherID($vid);
					$vcls2->setVoucherID($vid);
					$this->conn->exec($vcls1->getInsertSQL());
					$this->conn->exec($vcls2->getInsertSQL());							
				
					/* Voucher entry for Store ends here */
					
				}
			
				$this->conn->commit();
				
			} catch(Exception $er) {
					
				$this->conn->rollBack();
				$err	= 'saledb CreateSaleReturn '.$er->getMessage();
				_errorLog($err);
				$sid	= -1;
				
			}


			return $sid;
			
		}
		
		function deleteSaleReturn($scls) {
		
			$pkey				= $scls->getReturnID();
			$cmpid			= $scls->getCompanyID();
			$ret				= true;			

				
			try {
			
				$this->conn->beginTransaction();
				
				$this->conn->exec("DELETE FROM `gen_salereturn_addless` WHERE `ReturnID`='$pkey'");
				$this->conn->exec("DELETE FROM `gen_salereturn_items` WHERE `ReturnID`='$pkey'");
				$this->conn->exec("DELETE FROM `asys_voucher_entry` WHERE `RelatedID`='$pkey' AND `TxnType`='".SALE_RETURN."' AND `CompanyID`='".$cmpid."'");
				$this->conn->exec("DELETE FROM `asys_stock_voucher` WHERE `RelatedID`='$pkey' AND `ModuleID`='".SALE_RETURN."' AND `CompanyID`='".$cmpid."'");
				
				$sql	= $scls->getDeleteSQL();
				$this->conn->exec($sql);
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				$err	= 'saledb deleteReturn (line 990) '.$er->getMessage();
				_errorLog($err);
				$ret	= false;
				$this->conn->rollBack();
				
			}

		
			return $ret;

		}
		
		function getDORByReturnID($ReturnID) {
			$ReturnID	= (int)$ReturnID;
			$sql	= "SELECT `DOR` FROM `gen_salereturn` WHERE `ReturnID`='".$ReturnID."'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function UpdateSaleReturn($scls) {
				
			$tuser	=	unserialize($_SESSION["ssEUser"]);
			$tcmp		= unserialize($_SESSION["ssECmp"]);
			$sid		= $scls->getReturnID();
			$pdt		= $scls->getDOR();
			$cmpid	= $scls->getCompanyID();
			$finyr	= getFinancialYear($pdt);
			
			$vno		= $this->getVoucherNoByRelatedID(SALE_RETURN_VOUCHER, SALE, $sid, $cmpid);
			if($pdt == $this->getDORByReturnID($sid))
				$dwn	= $this->getDayWiseNoByRelatedID(SALE_RETURN_VOUCHER, SALE, $sid, $cmpid);
			else
				$dwn	= $this->getMaxDayWiseVoucherNo(SALE_RETURN_VOUCHER, $pdt, $cmpid);
				
			$narr		= 'SALE RETURN# '.$scls->getReturnNo().'/'.$finyr;
				
			$itot				=	0;
			$gtot				= 0;
			$atot				=	0;
			$ntot				=	0;

			$totval			= 0;
				
			try {
			
				$this->conn->beginTransaction();
				
				$this->conn->exec("DELETE FROM `gen_salereturn_addless` WHERE `ReturnID`='$sid'");
				$this->conn->exec("DELETE FROM `gen_salereturn_items` WHERE `ReturnID`='$sid'");
				$this->conn->exec("DELETE FROM `asys_voucher_entry` WHERE `RelatedID`='$sid' AND `TxnType`='".SALE_RETURN."' AND `CompanyID`='".$cmpid."'");
				
				$delsql4	= "DELETE FROM `asys_stock_voucher` WHERE `RelatedID`='$sid' AND `ModuleID`='".SALE_RETURN."' AND `CompanyID`='".$cmpid."'";
				
				$stkcls		= array();
				
				$totQty		= 0;
				$xtraPerUnit	= 0;
				
				$itmList	= $scls->getItemList();
				
				for($i=0;$i<count($itmList);$i++) {
					$icls		=	$itmList[$i];
					$totQty	= $totQty + $icls->getQuantity();
				}				
				

				for($i=0;$i<count($itmList);$i++) {
					$icls	=	$itmList[$i];
					$icls->setReturnID($sid);
					$icls->setSerialNo($i+1);

					$sql		= $icls->getInsertSQL();
					$this->conn->exec($sql);
					
					
					if($scls->getStockEntry() == "YES") {
						/* Stock entries */
					
						$lcqty	= $this->getLastStockClosingQuantityForUpdate($cmpid, $scls->getStoreID(), $icls->getItemID(), $pdt, SALE_RETURN, $sid);
						$lcval	= $this->getLastStockClosingValueForUpdate($cmpid, $scls->getStoreID(), $icls->getItemID(), $pdt, SALE_RETURN, $sid);
						$lbald	= $this->getLastBalanceDetailForUpdate($cmpid, $scls->getStoreID(), $icls->getItemID(), $pdt, SALE_RETURN, $sid);
					
						$iamt		= $icls->getTotalAmount() - ($icls->getIGST() + $icls->getSGST() + $icls->getCGST());
						$cqty		= $lcqty + $icls->getQuantity();
						$cval		= $lcval + $icls->getTotalAmount();
						$bald		= $lbald;
						if($bald != "") $bald = $bald.",";
						$bald		= $bald.$icls->getQuantity()."=".($icls->getTotalAmount()/$icls->getQuantity());
					
						$totval		= $totval + $iamt;
					
						$stcls		= new asys_stock_voucher();
						$stcls->setCompanyID($scls->getCompanyID());
						$stcls->setStoreID($scls->getStoreID());
						$stcls->setModuleID(SALE_RETURN);
						$stcls->setFinYear($scls->getFinYear());
						$stcls->setRelatedID($sid);
						$stcls->setDOT($scls->getDOR('yes'));
						$stcls->setTOT(time());
						$stcls->setItemID($icls->getItemID());
						$stcls->setItemCategoryID($this->getItemCategoryByItemID($icls->getItemID()));
						$stcls->setQuantity($icls->getQuantity());
						$stcls->setUnitPrice($iamt/$icls->getQuantity() + $xtraPerUnit);
						$stcls->setStockInOut(STOCK_IN);
						$stcls->setClosingQty($cqty);
						$stcls->setClosingValue($cval);						
						$stcls->setBatchNo("");
						$stcls->setNarration($narr);
						$stcls->setBalanceDetail($bald);
					
						$stkcls[]	= $stcls;
					
						/* Stock entry ends here */
						
					}

				}
				
				$this->conn->exec($delsql4);
				if($scls->getStockEntry() == "YES") {
					for($i=0;$i<count($stkcls);$i++) {
						$stcls		= $stkcls[$i];
						$stcls->setSVoucherID($this->getNextID("asys_stock_voucher","SVoucherID"));
						$this->conn->exec($stcls->getInsertSQL());
					}
				}
				
				$vclsArr		= [];
				
				$alList	= $scls->getAddLessList();
				for($j=0;$j<count($alList);$j++) {
					$acls	=	$alList[$j];
					$acls->setReturnID($sid);
					$acls->setSerialNo($j+1);
					
					if($acls->getAddLess('asis') == "ADD")
						$atot	=	$atot + $acls->getAmount('asis');
					else
						$atot	=	$atot - $acls->getAmount('asis');

					$sql		= $acls->getInsertSQL();
					$this->conn->exec($sql);
					
					
					$aDet		= $this->getAccountDetail($acls->getAccountID());
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($j+6);
					$vcls->setCompanyID($cmpid);
					$vcls->setVoucherType(JOURNAL_VOUCHER);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($vno);
					$vcls->setDayWiseNo($dwn);
					$vcls->setDOV($scls->getDOR('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($sid);
					$vcls->setTxnType(SALE_RETURN);
					if($acls->getAddLess() == 'ADD')
						$vcls->setDrCr(DEBIT);
					else
						$vcls->setDrCr(CREDIT);
					$vcls->setAmount($acls->getAmount());
					$vcls->setNarration('SALE RETURN# '.$scls->getReturnNo().'/'.$finyr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
					
					$vclsArr[] = $vcls;
				}
				
				$sql	= $scls->getUpdateSQL();
				$this->conn->exec($sql);
				
				/* Voucher Entries */
				
				$aDet		= $this->getAccountDetail($scls->getCustomerID());

				$vcls		=	new asys_voucher_entry();
				$vcls->setSerialID(1);
				$vcls->setCompanyID($scls->getCompanyID());
				$vcls->setVoucherType(SALE_RETURN_VOUCHER);
				$vcls->setFinYear($finyr);
				$vcls->setVoucherNo($vno);
				$vcls->setDayWiseNo($dwn);
				$vcls->setDOV($scls->getDOR('yes'));
				$vcls->setMotherAccount($aDet->getMotherAccount());
				$vcls->setAccountID($aDet->getAccountID());
				$vcls->setRelatedID($sid);
				$vcls->setTxnType(SALE_RETURN);
				$vcls->setDrCr(CREDIT);
				$vcls->setAmount($scls->getNetTotal());
				$vcls->setNarration('SALE RETURN# '.$scls->getReturnNo().'/'.$finyr);
				$vcls->setUserID($tuser->getUserID());
				$vcls->setDOE(date('d-m-Y'));
			
				$vclsArr[] = $vcls;

				$aDet		= $this->getAccountDetail($scls->getSaleAccountID());
				$vcls		=	new asys_voucher_entry();
				$vcls->setSerialID(2);
				$vcls->setCompanyID($scls->getCompanyID());
				$vcls->setVoucherType(SALE_RETURN_VOUCHER);
				$vcls->setFinYear($finyr);
				$vcls->setVoucherNo($vno);
				$vcls->setDayWiseNo($dwn);
				$vcls->setDOV($scls->getDOR('yes'));
				$vcls->setMotherAccount($aDet->getMotherAccount());
				$vcls->setAccountID($aDet->getAccountID());
				$vcls->setRelatedID($sid);
				$vcls->setTxnType(SALE_RETURN);
				$vcls->setDrCr(DEBIT);
				$vcls->setAmount($scls->getItemTotal() - ($scls->getIGST() + $scls->getSGST() + $scls->getCGST()));
				$vcls->setNarration('SALE RETURN# '.$scls->getReturnNo().'/'.$finyr);
				$vcls->setUserID($tuser->getUserID());
				$vcls->setDOE(date('d-m-Y'));
			
				$vclsArr[] = $vcls;
				
				$kk		= 3;
				if($scls->getIGST() > 0) {
					$aDet		= $this->getAccountDetail($tcmp->getIGSTAccountID());
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($kk);
					$vcls->setCompanyID($scls->getCompanyID());
					$vcls->setVoucherType(SALE_RETURN_VOUCHER);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($vno);
					$vcls->setDayWiseNo($dwn);
					$vcls->setDOV($scls->getDOR('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($sid);
					$vcls->setTxnType(SALE_RETURN);
					$vcls->setDrCr(DEBIT);
					$vcls->setAmount($scls->getIGST());
					$vcls->setNarration('IGST for SALE RETURN# '.$scls->getReturnNo().'/'.$finyr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
					$kk++;
				}
				
				if($scls->getCGST() > 0) {
					$aDet		= $this->getAccountDetail($tcmp->getCGSTAccountID());
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($kk);
					$vcls->setCompanyID($scls->getCompanyID());
					$vcls->setVoucherType(SALE_RETURN_VOUCHER);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($vno);
					$vcls->setDayWiseNo($dwn);
					$vcls->setDOV($scls->getDOR('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($sid);
					$vcls->setTxnType(SALE_RETURN);
					$vcls->setDrCr(DEBIT);
					$vcls->setAmount($scls->getCGST());
					$vcls->setNarration('CGST for SALE RETURN# '.$scls->getReturnNo().'/'.$finyr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
					$kk++;
				}
				
				if($scls->getSGST() > 0) {
					$aDet			= $this->getAccountDetail($tcmp->getSGSTAccountID());
					$sdet			= $this->getAccountDetail($scls->getCustomerID());
					
					if($this->getUTByState($sdet->getState()) == "YES")
						$aDet		= $this->getAccountDetail($tcmp->getUGSTAccountID());
						
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($kk);
					$vcls->setCompanyID($scls->getCompanyID());
					$vcls->setVoucherType(SALE_RETURN_VOUCHER);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($vno);
					$vcls->setDayWiseNo($dwn);
					$vcls->setDOV($scls->getDOR('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($sid);
					$vcls->setTxnType(SALE_RETURN);
					$vcls->setDrCr(DEBIT);
					$vcls->setAmount($scls->getSGST());
					$vcls->setNarration('SGST for SALE RETURN# '.$scls->getReturnNo().'/'.$finyr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
					$kk++;
				}
				
				$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
				for($ii=0; $ii<count($vclsArr); $ii++) {
					$vcls		= $vclsArr[$ii];
					$vcls->setVoucherID($vid);
					$this->conn->exec($vcls->getInsertSQL());					
				}
				
				/* Voucher Entry ends here */
				
				
				if($scls->getStockEntry() == "YES" && $totval > 0) {
					/* Voucher entry for Store */
				
					$VoucherNo	= $this->getMaxVoucherNo(JOURNAL_VOUCHER, $finyr, $cmpid);
					$DayWiseNo	= $this->getMaxDayWiseVoucherNo(JOURNAL_VOUCHER, $pdt, $cmpid);
				
					$storeDet		= $this->getStoreDetail($scls->getStoreID());
					if($storeDet->getAccountID() != 0)
						$aDet		= $this->getAccountDetail($storeDet->getAccountID());
					else
						$aDet		= $this->getAccountDetail($storeDet->getMotherAccountID());

					$vcls1		=	new asys_voucher_entry();
					$vcls1->setSerialID(1);
					$vcls1->setCompanyID($cmpid);
					$vcls1->setVoucherType(JOURNAL_VOUCHER);
					$vcls1->setFinYear($finyr);
					$vcls1->setVoucherNo($VoucherNo);
					$vcls1->setDayWiseNo($DayWiseNo);
					$vcls1->setDOV($scls->getDOR('yes'));
					$vcls1->setMotherAccount($aDet->getMotherAccount());
					$vcls1->setAccountID($aDet->getAccountID());
					$vcls1->setRelatedID($sid);
					$vcls1->setTxnType(SALE_RETURN);
					$vcls1->setDrCr(DEBIT);
					$vcls1->setAmount($totval);
					$vcls1->setNarration($narr);
					$vcls1->setUserID($tuser->getUserID());
					$vcls1->setDOE(date('d-m-Y'));
				
				
					$aDet		= $this->getAccountDetail($storeDet->getOppositeAccountID());
				
					$vcls2		=	new asys_voucher_entry();
					$vcls2->setSerialID(2);
					$vcls2->setCompanyID($cmpid);
					$vcls2->setVoucherType(JOURNAL_VOUCHER);
					$vcls2->setFinYear($finyr);
					$vcls2->setVoucherNo($VoucherNo);
					$vcls2->setDayWiseNo($DayWiseNo);
					$vcls2->setDOV($scls->getDOR('yes'));
					$vcls2->setMotherAccount($aDet->getMotherAccount());
					$vcls2->setAccountID($aDet->getAccountID());
					$vcls2->setRelatedID($sid);
					$vcls2->setTxnType(SALE_RETURN);
					$vcls2->setDrCr(CREDIT);
					$vcls2->setAmount($totval);
					$vcls2->setNarration($narr);
					$vcls2->setUserID($tuser->getUserID());
					$vcls2->setDOE(date('d-m-Y'));
			
					$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
					$vcls1->setVoucherID($vid);
					$vcls2->setVoucherID($vid);
					$this->conn->exec($vcls1->getInsertSQL());
					$this->conn->exec($vcls2->getInsertSQL());								
				
					/* Voucher entry for Store ends here */
					
				}
			
				$this->conn->commit();
				
			} catch(Exception $er) {
					
				$this->conn->rollBack();
				$err	= 'saledb UpdateSaleReturn '.$er->getMessage();
				_errorLog($err);
				$sid	= -1;
				
			}


			return $sid;
			
		}
		
		

		/*-------------------------------------------------------------------*/
		/*********************** STOCK CLOSING METHODS ***********************/		
		
		function getLastStockClosingQuantity($CompanyID, $StoreID, $ItemID, $DateAsOn) {
			$CompanyID	= (int)$CompanyID;
			$StoreID		= (int)$StoreID;
			$ItemID			= (int)$ItemID;
			$DateAsOn		= addslashes($DateAsOn);
			if($DateAsOn == "")
				$DateAsOn = "3000-01-01";
			$qty				= 0;
			
			try {	
			
				
				$sql	=	"SELECT `ClosingQty` FROM `asys_stock_voucher` WHERE `CompanyID`='".$CompanyID."' AND `StoreID`='".$StoreID."' AND `ItemID`='".$ItemID."' AND `DOT`<='".$DateAsOn."' ORDER BY `DOT` DESC, `StockInOut`, `ModuleID` DESC, `RelatedID` DESC LIMIT 1";
				
				$result1	= $this->conn->query($sql);
				if($row1 = $result1->fetch()) {
					$qty	=	$row1[0];
				}

				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}				

			return $qty;
		}
		
		function getLastStockClosingQuantityForUpdate($CompanyID, $StoreID, $ItemID, $DateAsOn, $ModuleID = 0, $RelatedID = 0) {
			$CompanyID	= (int)$CompanyID;
			$StoreID		= (int)$StoreID;
			$ItemID			= (int)$ItemID;
			$ModuleID		= (int)$ModuleID;
			$RelatedID	= (int)$RelatedID;			
			$DateAsOn		= addslashes($DateAsOn);
			if($DateAsOn == "")
				$DateAsOn = "3000-01-01";
			$qty				= 0;
			$chk				= 0;
			
			try {		
			
				
				$sql	=	"SELECT `ModuleID`, `RelatedID`, `ClosingQty` FROM `asys_stock_voucher` WHERE `CompanyID`='".$CompanyID."' AND `StoreID`='".$StoreID."' AND `ItemID`='".$ItemID."' AND `DOT`<='".$DateAsOn."' ORDER BY `DOT` DESC, `StockInOut`, `ModuleID` DESC, `RelatedID` DESC";
				
				$result1	= $this->conn->query($sql);
				while($row1 = $result1->fetch()) {

					$mid	= $row1[0];
					$rid	= $row1[1];					
					$qty	=	$row1[2];

					if($chk == 1) break;

					if($mid == $ModuleID && $rid == $RelatedID) $chk = 1;
					$qty	= 0;					
				}

				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}				

			return $qty;
		}
		
		function getLastStockClosingValue($CompanyID, $StoreID, $ItemID, $DateAsOn) {
			$CompanyID	= (int)$CompanyID;
			$StoreID		= (int)$StoreID;
			$ItemID			= (int)$ItemID;
			$DateAsOn		= addslashes($DateAsOn);
			if($DateAsOn == "")
				$DateAsOn = "3000-01-01";
			$val				= 0;
			
			try {		
			
				
				$sql	=	"SELECT `ClosingValue` FROM `asys_stock_voucher` WHERE `CompanyID`='".$CompanyID."' AND `StoreID`='".$StoreID."' AND `ItemID`='".$ItemID."' AND `DOT`<='".$DateAsOn."' ORDER BY `DOT` DESC, `StockInOut`, `ModuleID` DESC, `RelatedID` DESC LIMIT 1";
				
				$result1	= $this->conn->query($sql);
				if($row1 = $result1->fetch()) {
					$val	=	$row1[0];
				}

				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}				

			return $val;
		}
		
		function getLastStockClosingValueForUpdate($CompanyID, $StoreID, $ItemID, $DateAsOn, $ModuleID = 0, $RelatedID = 0) {
			$CompanyID	= (int)$CompanyID;
			$StoreID		= (int)$StoreID;
			$ItemID			= (int)$ItemID;
			$ModuleID		= (int)$ModuleID;
			$RelatedID	= (int)$RelatedID;			
			$DateAsOn		= addslashes($DateAsOn);
			if($DateAsOn == "")
				$DateAsOn = "3000-01-01";
			$val				= 0;
			$chk				= 0;
			
			try {	
			
				
				$sql	=	"SELECT `ModuleID`, `RelatedID`, `ClosingValue` FROM `asys_stock_voucher` WHERE `CompanyID`='".$CompanyID."' AND `StoreID`='".$StoreID."' AND `ItemID`='".$ItemID."' AND `DOT`<='".$DateAsOn."' ORDER BY `DOT` DESC, `StockInOut`, `ModuleID` DESC, `RelatedID` DESC";
				
				$result1	= $this->conn->query($sql);
				while($row1 = $result1->fetch()) {
					$mid	= $row1[0];
					$rid	= $row1[1];				
					$val	=	$row1[2];
					
					if($chk == 1)  break;
					
					if($mid == $ModuleID && $rid == $RelatedID) $chk = 1;
					$val	= 0;
				}

				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}				

			return $val;
		}
		
		function getLastBalanceDetail($CompanyID, $StoreID, $ItemID, $DateAsOn) {
			$CompanyID	= (int)$CompanyID;
			$StoreID		= (int)$StoreID;
			$ItemID			= (int)$ItemID;
			$DateAsOn		= addslashes($DateAsOn);
			if($DateAsOn == "")
				$DateAsOn = "3000-01-01";
			$bald				= "";
			
			try {
			
				
				$sql	=	"SELECT `BalanceDetail` FROM `asys_stock_voucher` WHERE `CompanyID`='".$CompanyID."' AND `StoreID`='".$StoreID."' AND `ItemID`='".$ItemID."' AND `DOT`<='".$DateAsOn."' ORDER BY `DOT` DESC, `StockInOut`, `ModuleID` DESC, `RelatedID` DESC LIMIT 1";
				
				$result1	= $this->conn->query($sql);
				if($row1 = $result1->fetch()) {
					$bald	=	$row1[0];
				}

				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}				

			return $bald;
		}
		
		function getLastBalanceDetailForUpdate($CompanyID, $StoreID, $ItemID, $DateAsOn, $ModuleID = 0, $RelatedID = 0) {
			$CompanyID	= (int)$CompanyID;
			$StoreID		= (int)$StoreID;
			$ItemID			= (int)$ItemID;
			$ModuleID		= (int)$ModuleID;
			$RelatedID	= (int)$RelatedID;			
			$DateAsOn		= addslashes($DateAsOn);
			if($DateAsOn == "")
				$DateAsOn = "3000-01-01";
			$bald				= "";
			$chk				= 0;
			
			try {
			
				
				$sql	=	"SELECT `ModuleID`, `RelatedID`, `BalanceDetail` FROM `asys_stock_voucher` WHERE `CompanyID`='".$CompanyID."' AND `StoreID`='".$StoreID."' AND `ItemID`='".$ItemID."' AND `DOT`<='".$DateAsOn."' ORDER BY `DOT` DESC, `StockInOut`, `ModuleID` DESC, `RelatedID` DESC";
				
				$result1	= $this->conn->query($sql);
				while($row1 = $result1->fetch()) {
					$mid	= $row1[0];
					$rid	= $row1[1];
					$bald	=	$row1[2];
					
					if($chk == 1) break;
					
					if($mid == $ModuleID && $rid == $RelatedID) $chk = 1;
					$bald	= "";
				}

				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}				

			return $bald;
		}
		
		
		
		/*------------------------------------------------------------*/
		/*********************** REPORT METHODS ***********************/
		
		function getOutwardTaxableValueAll($CompanyID, $Date1, $Date2) {
			$CompanyID	= (int)$CompanyID;
			$Date1			= addslashes($Date1);
			$Date2			= addslashes($Date2);
			
			$sql				= "
				SELECT SUM(`a`.`Amount` - `a`.`Discount`) FROM `gen_sale_items` `a` 
				INNER JOIN `gen_sale` `b` ON `a`.`SaleID`=`b`.`SaleID`
				INNER JOIN `gen_items` `c` ON `a`.`ItemID`=`c`.`ItemID`
				WHERE `c`.`NilRated` = 'NO' AND `c`.`NonGST` = 'NO' AND `c`.`GSTRate`!='0'
				AND `b`.`Export` = 'NO'
				AND `b`.`CompanyID` = '$CompanyID'
				AND `b`.`DOS` >= '$Date1' AND `b`.`DOS` <= '$Date2'
			";
			return $this->getResultExecutingQuery($sql);
			
		}
		
		function getOutwardTaxAll($CompanyID, $Date1, $Date2, $TaxType) {
			$CompanyID	= (int)$CompanyID;
			$Date1			= addslashes($Date1);
			$Date2			= addslashes($Date2);
			$TaxType		= addslashes($TaxType);
			
			$sql				= "
				SELECT SUM(`a`.`$TaxType`) FROM `gen_sale_items` `a` 
				INNER JOIN `gen_sale` `b` ON `a`.`SaleID`=`b`.`SaleID`
				INNER JOIN `gen_items` `c` ON `a`.`ItemID`=`c`.`ItemID`
				WHERE `c`.`NilRated` = 'NO' AND `c`.`NonGST` = 'NO' AND `c`.`GSTRate`!='0'
				AND `b`.`Export` = 'NO'
				AND `b`.`CompanyID` = '$CompanyID'
				AND `b`.`DOS` >= '$Date1' AND `b`.`DOS` <= '$Date2'
			";
			return $this->getResultExecutingQuery($sql);
			
		}
		
		function getOutwardTaxableValueZeroRated($CompanyID, $Date1, $Date2) {
			$CompanyID	= (int)$CompanyID;
			$Date1			= addslashes($Date1);
			$Date2			= addslashes($Date2);
			
			$sql				= "
				SELECT SUM(`a`.`Amount` - `a`.`Discount`) FROM `gen_sale_items` `a` 
				INNER JOIN `gen_sale` `b` ON `a`.`SaleID`=`b`.`SaleID`
				INNER JOIN `gen_items` `c` ON `a`.`ItemID`=`c`.`ItemID`
				WHERE `c`.`NilRated` = 'NO' AND `c`.`NonGST` = 'NO' AND `c`.`GSTRate`='0'
				AND `b`.`Export` = 'NO' AND `b`.`OnlineSale` = 'NO'
				AND `b`.`CompanyID` = '$CompanyID'
				AND `b`.`DOS` >= '$Date1' AND `b`.`DOS` <= '$Date2'
			";
			return $this->getResultExecutingQuery($sql);
			
		}
		
		function getOutwardTaxableValueNilExempted($CompanyID, $Date1, $Date2) {
			$CompanyID	= (int)$CompanyID;
			$Date1			= addslashes($Date1);
			$Date2			= addslashes($Date2);
			
			$sql				= "
				SELECT SUM(`a`.`Amount` - `a`.`Discount`) FROM `gen_sale_items` `a` 
				INNER JOIN `gen_sale` `b` ON `a`.`SaleID`=`b`.`SaleID`
				INNER JOIN `gen_items` `c` ON `a`.`ItemID`=`c`.`ItemID`
				WHERE ((`c`.`NilRated` = 'YES' AND `c`.`NonGST` = 'NO'))
				AND `b`.`CompanyID` = '$CompanyID'
				AND `b`.`DOS` >= '$Date1' AND `b`.`DOS` <= '$Date2'
			";
			$s1	= $this->getResultExecutingQuery($sql);
			
			$sql				= "
				SELECT SUM(`a`.`Amount` * `b`.`Conversion`) FROM `gen_sale_items` `a` 
				INNER JOIN `gen_sale` `b` ON `a`.`SaleID`=`b`.`SaleID`
				INNER JOIN `gen_items` `c` ON `a`.`ItemID`=`c`.`ItemID`
				WHERE `b`.`Export` = 'YES'
				AND `b`.`CompanyID` = '$CompanyID'
				AND `b`.`DOS` >= '$Date1' AND `b`.`DOS` <= '$Date2'
			";
			$s2	= $this->getResultExecutingQuery($sql);
			
			return ($s1 + $s2);
		}
		
		function getOutwardTaxableValueNonGST($CompanyID, $Date1, $Date2) {
			$CompanyID	= (int)$CompanyID;
			$Date1			= addslashes($Date1);
			$Date2			= addslashes($Date2);
			
			$sql				= "
				SELECT SUM(`a`.`Amount` - `a`.`Discount`) FROM `gen_sale_items` `a` 
				INNER JOIN `gen_sale` `b` ON `a`.`SaleID`=`b`.`SaleID`
				INNER JOIN `gen_items` `c` ON `a`.`ItemID`=`c`.`ItemID`
				WHERE `c`.`NilRated` = 'NO' AND `c`.`NonGST` = 'YES'
				AND `b`.`CompanyID` = '$CompanyID'
				AND `b`.`DOS` >= '$Date1' AND `b`.`DOS` <= '$Date2'
			";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getOutwardTaxableValueUnregistered($CompanyID, $State, $Date1, $Date2) {
			$CompanyID	= (int)$CompanyID;
			$State			= addslashes($State);
			$Date1			= addslashes($Date1);
			$Date2			= addslashes($Date2);
			
			$sql				= "
				SELECT `c`.`State`, SUM(`a`.`Amount` - `a`.`Discount`) FROM `gen_sale_items` `a` 
				INNER JOIN `gen_sale` `b` ON `a`.`SaleID`=`b`.`SaleID`
				INNER JOIN `asys_accounts` `c` ON `b`.`CustomerID`=`c`.`AccountID`
				WHERE `c`.`GST` = '' AND `c`.`State` != '$State'
				AND `b`.`CompanyID` = '$CompanyID'
				AND `b`.`Export` = 'NO'
				AND `b`.`DOS` >= '$Date1' AND `b`.`DOS` <= '$Date2'
				GROUP BY `c`.`State`
			";
			return $this->getRecordsetExecutingQuery($sql);			
		}
		
		function getIGSTValueUnregistered($CompanyID, $State, $Date1, $Date2) {
			$CompanyID	= (int)$CompanyID;
			$State			= addslashes($State);
			$Date1			= addslashes($Date1);
			$Date2			= addslashes($Date2);
			
			$sql				= "
				SELECT SUM(`a`.`IGST`) FROM `gen_sale_items` `a` 
				INNER JOIN `gen_sale` `b` ON `a`.`SaleID`=`b`.`SaleID`
				INNER JOIN `asys_accounts` `c` ON `b`.`CustomerID`=`c`.`AccountID`
				WHERE `c`.`GST` = '' AND `c`.`State` != '$State'
				AND `b`.`CompanyID` = '$CompanyID'
				AND `b`.`Export` = 'NO'
				AND `b`.`DOS` >= '$Date1' AND `b`.`DOS` <= '$Date2'
				GROUP BY `c`.`State`
			";
			return $this->getRecordsetExecutingQuery($sql);			
		}
					
	};
		
?>