<?php

	/* Include the required files */
	require_once( 'aom-config.php' );
	require_once( 'inc/pagetemplate.php' );
	require_once( 'inc/head.php' );
	require_once( 'inc/topmenu.php' );
	require_once( 'inc/functions.php' );
	require_once( 'dao/asys.user.php' );
	require_once( 'dao/asys.logindb.php' );
	require_once( 'dao/asys.genericdb.php' );
	require_once( 'dao/asys.log.php' );

	$tuser		=	new asys_users();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}

	if($tuser->getUserStatus() < ADMIN_USER) {
		echo 'Only Admin Users can view/open this Page. <a href="home.php">Click here to go back.</a>';
		exit;
	}

	$ldb			=	new logindb();
	$gdb			=	new genericdb();
	$ulist		=	$ldb->getUserList();

	/* Ready to create the page */
	$iPage	=	new asys_pages(APP_TITLE);
	/* Start writting the page */
	$iPage->startPage();
	$iPage->startHeader();
	/* Add links and Scripts as required */
	$iPage->addLink("css/asys.css");
	$iPage->addLink("css/menu.css");
	$iPage->addLink("css/superTables.css");
	$iPage->addScript("js/common.js");
	$iPage->addScript("js/superTables.js");

?>

<script language="javaScript">



		var userData = [
		<?php
			$j	=	0;
			for($i=0;$i<count($ulist);$i++) {
				$row	=	$ulist[$i];
				if($row->getUserStatus() <= ADMIN_USER) {
					if($j != 0) echo ',';
					if($row->getUserStatus() > $tuser->getUserStatus() || $row->getUserID() == $tuser->getUserID()) {
		?>
					[
					'<?php echo $row->getUserID()?>',
					'<?php echo addcslashes($row->getUserName(),"'")?>',
					'<?php echo getDateFromTime($row->getLastLogin())?>',
					'<?php echo $row->getIsEnabled()?>',
					''
					]
		<?php
					} else {
						$tmp	=	'Enable';
						if($row->getIsEnabled() == "YES")
							$tmp	=	'Disable';
		?>
					[
					'<?php echo $row->getUserID()?>',
					'<?php echo addcslashes($row->getUserName(),"'")?>',
					'<?php echo getDateFromTime($row->getLastLogin())?>',
					'<?php echo $row->getIsEnabled()?>',
					'<a class="nav" href="javaScript:_ajaxEDUser(\'<?php echo $row->getUserID()?>\',\'<?php echo $tmp?>\')"><?php echo $tmp?></a>'
					]
		<?php
					}
					$j++;
				}
			}
		?>
		];


</script>

<?php

	$iPage->endHeader();
	$iPage->startBody();
	outputHeader($tuser);

?>

	<?php include('inc/menuHome.php')?>

	<div id="pagehead">&nbsp;ENABLE/DISABLE SYSTEM USERS</div>
	<div style="height:10px;"></div>
	
	<table cellspacing="0" border="0" width="980px" align="center">
		<tr><td bgcolor="#D6E3F3" class="td_normal_large blue bold" style="padding:4px;">
			<div style="float:left"><b>Enable/Disable User</b></div>
		</td></tr>
	</table>
	
	<div style="height:5px;"></div>
	
	<div id="rptDiv" class="fakeContainer">

		<table cellspacing="1" cellpadding="2" border="0" width="970px" align="center" id="vTable">
			<thead>
				<tr>
					<th width="150px" align="left">User ID</th>
					<th width="470px" align="left">Name</th>
					<th width="150px" align="left">Last Login</th>
					<th width="80px">Enabled?</th>
					<th width="50px">Change</th>
				</tr>
			</thead>
			<tbody>
		<?php

			for($i=0;$i<count($ulist);$i++) {
				$row	=	$ulist[$i];
				if($row->getUserStatus() <= ADMIN_USER) {
		?>			
				<tr>
					<td class="td_view" title="<?php echo $row->getUserID()?>"><?php echo $row->getUserID()?></td>
					<td class="td_view" title="<?php echo $row->getUserName()?>"><?php echo $row->getUserName('yes')?></td>
					<td class="td_view"><?php echo getDateFromTime($row->getLastLogin()) ?></td>
					<td class="td_view" align="center"><?php echo $row->getIsEnabled() ?></td>
					
					
		<?php if($row->getUserStatus() > $tuser->getUserStatus() || $row->getUserID() == $tuser->getUserID()) { ?>
					<td class="td_view" align="center">&nbsp;</td>
		<?php } else { ?>
		<?php
						$tmp	=	'Enable';
						if($row->getIsEnabled() == "YES")
							$tmp	=	'Disable';		
		?>
					<td class="td_view" align="center"><a class="nav" href="javaScript:_ajaxEDUser('<?php echo $row->getUserID()?>','<?php echo $tmp?>')"><?php echo $tmp?></a></td>		
		<?php } ?>
				</tr>
					<?php } ?>
				<?php } ?>
			</tbody>
		</table>

	</div>
	
	<div style="height:10px;"></div>

<?php 

	$iPage->endBody();
	$iPage->endPage();

?>


<script language="javaScript">

	var div	=	document.getElementById('rptDiv');

	div.style.height	=	 (window.innerHeight - 180) + "px";
	div.style.width		=	 "980px";

	//<![CDATA[	
	(function() {
		var mySt = new superTable("vTable", {
			cssSkin 		: "sSky",
			fixedCols 	: 0,
			headerRows 	: 1
		});
	})();
	//]]>
	
	function _ajaxEDUser(uid, stat){
	
		var x = (window.ActiveXObject) ? new ActiveXObject("Microsoft.XMLHTTP") : new XMLHttpRequest();
		if (x){
			x.onreadystatechange = function(){
				if (x.readyState == 4 && x.status == 200){
					var fr	= x.responseText;
					if(fr == "0") {
						alert("Fail to " + stat + ", try again");
					} else if(fr == "-1") {
						alert("Session timed out - please relogin");
					} else if(fr == "-2") {
						alert("Not enough permission to Enable/Disble User");					
					} else {
						alert("User " + stat + "d successfully");
						var newURL = window.location.protocol + "//" + window.location.host + window.location.pathname;
						window.location.replace(newURL);
					}
				}
			};
			x.open("GET", "ajax/updateUserStat.php?uid=" + uid + "&stat=" + stat, true);
			x.send(null);
		}else{
			alert('AJAX not supported in your Browser.');
		}
	}	

</script>