<?php

	/* Include the required files */
	require_once( 'aom-config.php' );
	require_once( 'inc/pagetemplate.php' );
	require_once( 'inc/head.php' );
	require_once( 'inc/topmenu.php' );
	require_once( 'inc/functions.php' );
	require_once( 'dao/asys.user.php' );
	require_once( 'dao/asys.module.php' );
	require_once( 'dao/asys.company.php' );
	require_once( 'dao/asys.genericdb.php' );
	require_once( 'dao/asys.masterdb.php' );
	require_once( 'dao/asys.companydb.php' );
	require_once( 'dao/asys.log.php' );
	require_once( 'dao/asys.logindb.php' );
	require_once( 'dao/asys.userpermission.php' );	

	$tuser		=	new asys_users();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}	
	
	$ModuleID			= 8;

	$gdb					=	new genericdb();
	$mdb					=	new masterdb();
	$ldb					= new logindb();
	$cdb					= new companydb();
	$cclass				= new asys_modules();
	$cmpList			= $cdb->getCompanyList();
	
	if($tuser->getUserStatus() != HIDDEN_USER) {
		echo 'Only System Architect can view this page. <a href="home.php">Click here</a> to go back.';
		exit;
	}
							
			
	$ModuleID	=	"";
	$ModuleName	=	"";
	$MenuText	=	"";
	$CompanyID	=	"";
	$DepartmentID	=	"";
	$ModuleType	=	"";
	$CreationTime	=	"";
	$CreatedBy	=	"";
	$Modifications	=	"";
	$CreateFile	=	"";
	$EditFile	=	"";
	$DeleteFile	=	"";
	$ViewFile	=	"";
	$DetailFile	=	"";
	$ReportPanelFile	=	"";
	$ReportFiles	=	"";


	$pkey					=	"";
	$rmsg					=	"";
	$msg					=	"Please enter all the fields correctly.";
	$pagen				=	"";

	$fcss					=	 array();
	for($i=0;$i<15;$i++)
		$fcss[$i]		=	"input";

	extract($_REQUEST);	
	
	$pKey	= (int)$pKey;
	
	$cclass				= $mdb->getModuleDetail($pKey);
	
	if($pagen == "process") {
		/* Check for valid input */		
		
		if(trim($ModuleName) == "") {
			$fcss[1]	=	"err_input";
			if($rmsg != "") $rmsg = $rmsg.",";
			$rmsg	=	$rmsg."Module Name";
		}
		
		if(trim($MenuText) == "") {
			$fcss[2]	=	"err_input";
			if($rmsg != "") $rmsg = $rmsg.",";
			$rmsg	=	$rmsg."Menu Text";
		}		

		if((int)$CompanyID <= 0) {
			$fcss[2]	=	"err_input";
			if($rmsg != "") $rmsg = $rmsg.",";
			$rmsg	=	$rmsg."Company ";
		}

		if(trim($ModuleType) == "") {
			$fcss[4]	=	"err_input";
			if($rmsg != "") $rmsg = $rmsg.",";
			$rmsg	=	$rmsg."Module Type";
		}


		$cclass->setModuleID($pKey);
		$cclass->setModuleName($ModuleName);
		$cclass->setMenuText($MenuText);
		$cclass->setCompanyID($CompanyID);
		$cclass->setDepartmentID($DepartmentID);
		$cclass->setModuleType($ModuleType);
		//$cclass->setCreationTime($CreationTime);
		//$cclass->setCreatedBy($CreatedBy);
		$cclass->setModifications($cclass->getModifications().', '.time());
		$cclass->setCreateFile($CreateFile);
		$cclass->setEditFile($EditFile);
		$cclass->setDeleteFile($DeleteFile);
		$cclass->setViewFile($ViewFile);
		$cclass->setDetailFile($DetailFile);
		$cclass->setReportPanelFile($ReportPanelFile);
		$cclass->setReportFiles($ReportFiles);	

		if($rmsg == "") {
			if($gdb->UpdateObjectInDB($cclass)) {
				$msg	=	"<font class='blue'>Module #".$cclass->getModuleID()." updated successfully</font>";
				$log	=	new asys_user_log();
				$log->setLogID($gdb->getNextID("asys_user_log", "LogID"));
				$log->setUserID($tuser->getUserID());
				$log->setModuleID(-3);
				$log->setRelatedID($cclass->getModuleID());				
				$log->setActivity("Updated existing Module - ".$pKey);
				$log->setClassName('asys_modules');
				$log->setModuleSnapshot(serialize($cclass));
				$gdb->SaveObjectToDB($log);	
				
				$cclass				= $mdb->getModuleDetail($pKey);		
			} else {
				$msg	=	"<font class='red'>Module ID/Name already exist, try with a different ID/Name</font>";
			}
		} else {
			$msg	=	"<font class='red'>The following fields are mandatory: ".$rmsg."</font>";
		}
	}

	
	/* Ready to create the page */
	$iPage	=	new asys_pages(APP_TITLE);
	/* Start writting the page */
	$iPage->startPage();
	$iPage->startHeader();
	/* Add links and Scripts as required */
	$iPage->addLink("css/asys.css");
	$iPage->addLink("css/menu.css");
	$iPage->addLink("extjs/resources/css/ext-all.css");
	$iPage->addScript("js/common.js");
	$iPage->addScript("extjs/adapter/ext/ext-base.js");
	$iPage->addScript("extjs/ext-all.js");	
	$iPage->addScript("js/nlbFade.js");
	$iPage->endHeader();
	$iPage->startBody();
	
	outputHeader($tuser);	
	
?>

	<?php include('inc/menuHome.php')?>	

	<div id="pagehead">&nbsp;MODIFY EXISTING MODULE</div>
	<div style="height:4px;"></div>
	<div style="border:#99BBE8 1px solid;width:980px;margin:0px auto">
	<form name="hfrm" id="hfrm" method="post" action="">
	<input type="hidden" name="pagen" value="process">
	<input type="hidden" name="pKey" value="<?php echo $pKey?>">
	<table cellpadding="2" cellspacing="0" border="0" width="980px" align="center" bgcolor="#ffffff">
		<tr bgcolor="#D6E3F3"><td colspan="3" class="td_normal blue bold">
			<div id="dhead" style="float:left;width:900px;padding:5px;"><?php echo $msg?></div>
			<div style="float:right;padding:5px;"><a href="viewModule.php"><img src="images/columns.gif" title="View Module List"></a></div>
		</td></tr>
		<tr style="height:1px" bgcolor="#99BBE8"><td colspan="3"></td></tr>
		<tr style="height:4px"><td colspan="3"></td></tr>	
		
		<tr>
			<td class="td_normal" width="170px;">&nbsp;ModuleID</td>
			<td class="td_normal" width="10px;">:</td>
			<td class="td_normal"><input type="text" class="<?php echo $fcss[0]?>" name="ModuleID" id="ModuleID" value="<?php echo $cclass->getModuleID('no')?>" style="width:80px" readOnly="true" /></td>
		</tr>
		<tr style="height:4px"><td colspan="3"></td></tr>		
			
		<tr>
			<td class="td_normal" width="170px;">&nbsp;Module Name</td>
			<td class="td_normal" width="10px;">:</td>
			<td class="td_normal"><input type="text" class="<?php echo $fcss[1]?>" name="ModuleName" id="ModuleName" value="<?php echo $cclass->getModuleName('yes')?>" style="width:500px" maxLength="250" onFocus="this.className='input_focus'" onBlur="this.className='<?php echo $fcss[1]?>'" /></td>
		</tr>
		<tr style="height:4px"><td colspan="3"></td></tr>	
		
		<tr>
			<td class="td_normal">&nbsp;Menu Text</td>
			<td class="td_normal">:</td>
			<td class="td_normal"><input type="text" class="<?php echo $fcss[2]?>" name="MenuText" id="MenuText" value="<?php echo $cclass->getMenuText('yes')?>" style="width:100px" maxLength="30" onFocus="this.className='input_focus'" onBlur="this.className='<?php echo $fcss[2]?>'" /></td>
		</tr>
		<tr style="height:4px"><td colspan="3"></td></tr>		
				
		<tr>
			<td class="td_normal">&nbsp;Company</td>
			<td class="td_normal">:</td>
			<td class="td_normal" id="_jsontd2">
				<input type="text" class="<?php echo $fcss[2]?>" name="txtCompanyID" id="txtCompanyID" value="<?php echo $mdb->getCompanyNameByCompanyID($cclass->getCompanyID('no'))?>" style="width:200px" />
			</td>
		</tr>
		<tr style="height:4px"><td colspan="3"></td></tr>	
				
		<tr>
			<td class="td_normal">&nbsp;Module Type</td>
			<td class="td_normal">:</td>
			<td class="td_normal">
				<select name="ModuleType" id="ModuleType" class="select" >
					<option value="">-Select-</option>
					<option value="Master" <?php  if($cclass->getModuleType('yes') == "Master") echo 'selected' ?>>Master</option>
					<option value="Transaction" <?php  if($cclass->getModuleType('yes') == "Transaction") echo 'selected' ?>>Transaction</option>
					<option value="Report" <?php  if($cclass->getModuleType('yes') == "Report") echo 'selected' ?>>Report</option>
					<option value="Voucher" <?php  if($cclass->getModuleType('yes') == "Voucher") echo 'selected' ?>>Voucher</option>
				</select>
			</td>
		</tr>
		<tr style="height:4px"><td colspan="3"></td></tr>
				
		<tr>
			<td class="td_normal">&nbsp;Create File Name</td>
			<td class="td_normal">:</td>
			<td class="td_normal"><input type="text" class="<?php echo $fcss[8]?>" name="CreateFile" id="CreateFile" value="<?php echo $cclass->getCreateFile('yes')?>" style="width:200px" maxLength="50" onFocus="this.className='input_focus'" onBlur="this.className='<?php echo $fcss[8]?>'" /></td>
		</tr>
		<tr style="height:4px"><td colspan="3"></td></tr>	
				
		<tr>
			<td class="td_normal">&nbsp;Edit File Name</td>
			<td class="td_normal">:</td>
			<td class="td_normal"><input type="text" class="<?php echo $fcss[9]?>" name="EditFile" id="EditFile" value="<?php echo $cclass->getEditFile('yes')?>" style="width:200px" maxLength="50" onFocus="this.className='input_focus'" onBlur="this.className='<?php echo $fcss[9]?>'" /></td>
		</tr>
		<tr style="height:4px"><td colspan="3"></td></tr>	
				
		<tr>
			<td class="td_normal">&nbsp;Delete File Name</td>
			<td class="td_normal">:</td>
			<td class="td_normal"><input type="text" class="<?php echo $fcss[10]?>" name="DeleteFile" id="DeleteFile" value="<?php echo $cclass->getDeleteFile('yes')?>" style="width:200px" maxLength="50" onFocus="this.className='input_focus'" onBlur="this.className='<?php echo $fcss[10]?>'" /></td>
		</tr>
		<tr style="height:4px"><td colspan="3"></td></tr>	
				
		<tr>
			<td class="td_normal">&nbsp;View File Name</td>
			<td class="td_normal">:</td>
			<td class="td_normal"><input type="text" class="<?php echo $fcss[11]?>" name="ViewFile" id="ViewFile" value="<?php echo $cclass->getViewFile('yes')?>" style="width:200px" maxLength="50" onFocus="this.className='input_focus'" onBlur="this.className='<?php echo $fcss[11]?>'" /></td>
		</tr>
		<tr style="height:4px"><td colspan="3"></td></tr>	
				
		<tr>
			<td class="td_normal">&nbsp;Detail File Name</td>
			<td class="td_normal">:</td>
			<td class="td_normal"><input type="text" class="<?php echo $fcss[12]?>" name="DetailFile" id="DetailFile" value="<?php echo $cclass->getDetailFile('yes')?>" style="width:200px" maxLength="50" onFocus="this.className='input_focus'" onBlur="this.className='<?php echo $fcss[12]?>'" /></td>
		</tr>
		<tr style="height:4px"><td colspan="3"></td></tr>	
				
		<tr>
			<td class="td_normal">&nbsp;Report Panel File Name</td>
			<td class="td_normal">:</td>
			<td class="td_normal"><input type="text" class="<?php echo $fcss[13]?>" name="ReportPanelFile" id="ReportPanelFile" value="<?php echo $cclass->getReportPanelFile('yes')?>" style="width:200px" maxLength="50" onFocus="this.className='input_focus'" onBlur="this.className='<?php echo $fcss[13]?>'" /></td>
		</tr>
		<tr style="height:4px"><td colspan="3"></td></tr>	
				
		<tr>
			<td class="td_normal">&nbsp;Report Files Name</td>
			<td class="td_normal">:</td>
			<td class="td_normal"><input type="text" class="<?php echo $fcss[14]?>" name="ReportFiles" id="ReportFiles" value="<?php echo $cclass->getReportFiles('yes')?>" style="width:400px" maxLength="500" onFocus="this.className='input_focus'" onBlur="this.className='<?php echo $fcss[14]?>'" /></td>
		</tr>
		<tr style="height:4px"><td colspan="3"></td></tr>
						
		<tr style="height:1px" bgcolor="#99BBE8"><td colspan="3"></td></tr>
		<tr bgcolor="#D6E3F3">
			<td colspan="3" align="center">
				<input type="button" id="btnS" class="red_button" value=" Update (S) " AccessKey="S" onClick="submitForm('hfrm')" />
				<input type="button" class="red_button" value=" Go Back (G) " AccessKey="G" onClick="goBack()" />
			</td>
		</tr>
	</table>
	</form>
	</div>
	
	<br /><br />
	
<?php
	$iPage->endBody();
	$iPage->endPage();
?>	
		
<script language="javaScript">

	var cmpList		= new Array();
	
	cmpList[0] 		= new Array();
	cmpList[0][0] = "";
	cmpList[0][1] = "-Generic (All Companies)-";
	
	<?php
		$k		= 1;
		for($i=0;$i<count($cmpList);$i++){
			$cb	= $cmpList[$i];
	?>
				cmpList[<?php echo $k?>] 			= new Array();
				cmpList[<?php echo $k?>][0] 	= "<?php echo $cb->getCompanyID()?>";
				cmpList[<?php echo $k++?>][1] = "<?php echo formatJScriptString($cb->getCompanyName())?>";
	<?php } ?>

	window.onload	=	function() {
		NLBfadeBg('dhead','#ffff00','#D6E3F3','3000');
		EBD('ModuleName').focus(); 
	};

	Ext.onReady(function(){
		
		new Ext.form.ComboBox({
			store: cmpList,
			typeAhead: true,
			mode: 'local',
			width:400,
			listWidth:400,
			forceSelection: true,
			triggerAction: 'all',
			selectOnFocus:true,
			applyTo: 'txtCompanyID',
			hiddenName: 'CompanyID'
		});
		
		EBD('CompanyID').value	= "<?php echo $cclass->getCompanyID()?>";
		
	});
	
	function goBack() {
		location = "viewModule.php?schStr=<?php echo $schStr?>&pno=<?php echo $pno?>";
	}	

</script>