<?php

	/* Include the required files */
	require_once( 'aom-config.php' );
	require_once( 'inc/pagetemplate.php' );
	require_once( 'inc/head.php' );
	require_once( 'inc/topmenu.php' );
	require_once( 'inc/functions.php' );
	require_once( 'dao/asys.user.php' );
	require_once( 'dao/asys.company.php' );
	require_once( 'dao/asys.companydb.php' );

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	unset($_SESSION['ssECmp']);
	
	$cdb					=	new companydb();
	$cmpList			= $cdb->getCompanyListByType('BRANCH');
	$hcls					= $cdb->getCompanyDetail(1);
	
	$wdth		= 100;
	if(count($cmpList) > 0) $wdth	= (int)(100 / count($cmpList));
	$wdt		= 100 - ($wdth * 0.5) * 2;

	/* Ready to create the page */
	$iPage	=	new asys_pages(APP_TITLE);
	/* Start writting the page */
	$iPage->startPage();
	$iPage->startHeader();
	/* Add links and Scripts as required */
	$iPage->addLink("css/asys.css");
	$iPage->addLink("css/menu.css");
	$iPage->addScript("js/common.js");	
	$iPage->endHeader();
	$iPage->startBody();
	
	$url 		= $_SERVER['REQUEST_URI'];
	$pnm 		= pathinfo($url, PATHINFO_FILENAME);

?>

	<div id="topbanner">
		<div style="float:left;width:220px;text-align:left;">
			<img src="./images/asysLogo.png" height="65">
		</div>
		<div style="float:left;padding-top:8px;text-align:center;">
			<?php echo $tuser->getUserName() ?>, <?php echo  getIndianDateFromTime($tuser->getLastLogin()) ?> (<?php echo $tuser->getLastLoginIP() ?>) | <a href="cpwd.php" >Change Password</a> | <a href="logout.php" title="Quit the System" >Sign out</a>
		</div>
		<div style="float:right;padding-top:1px;">
			<img src="./images/adapSys.png" height="65" />
		</div>
	</div>
	
	<?php include('inc/menuHome.php')?>
	
	<div style="height:5px;"></div>
	
  <table cellpadding="1" cellspacing="2" width="100%" style="border:0px;">
  	<tr>
  		<td align="center" colspan="<?php echo count($cmpList)?>">
  			<?php if( $cdb->getUserCompanyStat($tuser->getUserID(), 1) ) { ?>
  				<a class="home" href="selectCompany.php?cid=1" title="Click to select Head Office as Company"><div class="ocircle">HO<br /><?php echo $hcls->getCompanyName()?></div></a>
  			<?php } else { ?>
  				<div class="ocircle" title="No Permission">HO</div>
  			<?php } ?>
				<br />
				<img src="images/line1.gif" height="1" width="<?php echo $wdt?>%"/>  			
  		</td>
  	</tr>
  	
  	<tr>
  	
			<?php
				for($i=0;$i<count($cmpList);$i++) {
					$ccls			= $cmpList[$i];
					$scmpList	= $cdb->getSubCompanyList($ccls->getCompanyID());
					
					$wdth2		= 100;
					$wdt2			= 0;
					if(count($scmpList) > 0) $wdth2	= (int)(100 / count($scmpList));
					$wdt2		= 100 - ($wdth2 * 0.5) * 2;					
			?>  	
  	
  		<td align="center" width="<?php echo $wdth ?>%" valign="top">
			
					<table cellpadding="1" cellspacing="2" width="100%" style="border:0px;">
  					<tr>
  						<td colspan="<?php echo count($scmpList)?>" align="center">
								<?php if( $cdb->getUserCompanyStat($tuser->getUserID(), $ccls->getCompanyID()) ) { ?>
									<a class="home" href="selectCompany.php?cid=<?php echo $ccls->getCompanyID()?>" title="Click to select <?php echo $ccls->getCompanyName()?> as Company"><div class="ocircle"><?php echo $ccls->getCompanyName()?></div></a>
								<?php } else { ?>
									<div class="ocircle" title="No Permission"><?php echo $ccls->getCompanyName()?></div>
								<?php } ?>  						
								
								<?php if(count($scmpList) > 0) { ?>
								<br />
								<img src="images/line1.gif" height="1" width="<?php echo $wdt2?>%" />
								<?php } ?>
							</td>
						</tr>
						
						<tr>
						
						<?php
							for($j=0;$j<count($scmpList);$j++) {
								$sccls			= $scmpList[$j];
						?>
								
									<td align="center">
										<?php if( $cdb->getUserCompanyStat($tuser->getUserID(), $sccls->getCompanyID()) ) { ?>
											<a class="home" href="selectCompany.php?cid=<?php echo $sccls->getCompanyID()?>" title="Click to select <?php echo $sccls->getCompanyName()?> as Company"><div class="ocircle"><?php echo $sccls->getCompanyName()?></div></a>
										<?php } else { ?>
											<div class="ocircle" title="No Permission"><?php echo $sccls->getCompanyName()?></div>
										<?php } ?>
									</td>
													
						<?php } ?>						
						
						</tr>	
					</table>

  		</td>
  		
  		<?php } ?>
  		
  	</tr>
  </table>

<?php

	$iPage->endBody();
	$iPage->endPage();

?>