<?php

	/**
	 * Input format yyyy-mm-dd
	 * Output format dd-mm-yyyy
	**/
	function FormatSQLDateToIndianDate($myDate) {
		if($myDate == "")
			return "";
		if($myDate == "0000-00-00" || $myDate == "1900-01-01")
			return "";
			
		$yy	= substr($myDate,0,4);
		$mm	= substr($myDate,5,2);
		$dd	= substr($myDate,8,2);
		$formatedDate	= $dd.DATE_SEPERATOR.$mm.DATE_SEPERATOR.$yy;
		return $formatedDate;
	}
	
	/**
	 * Input format yyyy-mm-dd
	 * Output format Day Month Year (In Words)
	**/
	function FormatSQLDateToWord($myDate) {
		if($myDate == "")
			return "";
		if($myDate == "0000-00-00" || $myDate == "1900-01-01")
			return "";
			
		$yy	= (int)substr($myDate,0,4);
		$mm	= (int)substr($myDate,5,2);
		$dd	= (int)substr($myDate,8,2);
		
		$mntArray	= array("", "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December" );
		
		$wdate	= getWordRepresentationOfNumber($dd).' '.$mntArray[$mm].', '.getWordRepresentationOfNumber($yy);
		
		return $wdate;
	}
	
	/**
	 * Input format yyyy-mm-dd
	 * Output format dd-mm-yyyy
	**/
	function FormatSQLDateToVoucherPrintFormat($myDate) {
		if($myDate == "")
			return "";
		if($myDate == "0000-00-00" || $myDate == "1900-01-01")
			return "";
			
		$yy	= substr($myDate,0,4);
		$mm	= substr($myDate,5,2);
		$dd	= substr($myDate,8,2);
		$formatedDate	= $yy.$mm.$dd;
		return $formatedDate;
	}
	
	/**
	 * Input format yyyy-mm-dd
	 * Output format mm-dd-yyyy
	**/
	function FormatSQLDateToUSDate($myDate) {
		if($myDate == "")
			return "";
		if($myDate == "0000-00-00" || $myDate == "1900-01-01")
			return "";
			
		$yy	= substr($myDate,0,4);
		$mm	= substr($myDate,5,2);
		$dd	= substr($myDate,8,2);
		$formatedDate	= $mm.DATE_SEPERATOR.$dd.DATE_SEPERATOR.$yy;
		return $formatedDate;
	}

	/**
	 * Input format dd-mm-yyyy
	 * Output format yyyy-mm-dd
	 */
	function FormatIndianDateToSQLDate($myDate) {
		if($myDate == "")
			return "1900-01-01";
		if($myDate == "0000-00-00")
			return "1900-01-01";
		if (!preg_match("/^(0[1-9]|[1-2][0-9]|3[0-1])-(0[1-9]|1[0-2])-[0-9]{4}$/",$myDate))	
			return "1900-01-01";
			
		$yy	= substr($myDate,6,4);
		$mm	= substr($myDate,3,2);
		$dd	= substr($myDate,0,2);
		if(checkDate((int)$mm,(int)$dd,(int)$yy)){
			$formatedDate	= $yy."-".$mm."-".$dd;
			return $formatedDate;
		}
		return "1900-01-01";
	}
	
	/**
	 * Input format mm-dd-yyyy
	 * Output format yyyy-mm-dd
	 */
	function FormatUSDateToSQLDate($myDate) {
		if($myDate == "")
			return "1900-01-01";
		if($myDate == "0000-00-00")
			return "1900-01-01";
		if (!preg_match("/^(0[1-9]|1[0-2])-(0[1-9]|[1-2][0-9]|3[0-1])-[0-9]{4}$/",$myDate))	
			return "1900-01-01";
			
		$yy	= substr($myDate,6,4);
		$dd	= substr($myDate,3,2);
		$mm	= substr($myDate,0,2);
		if(checkDate((int)$mm,(int)$dd,(int)$yy)){
			$formatedDate	= $yy."-".$mm."-".$dd;
			return $formatedDate;
		}
		return "1900-01-01";
	}

	/**
	 * Input format yyyy-mm-dd
	 * Output format MMM dd, yyyy
	 */
	function bwtFormatDateIntl($myDate) {
		$mon[0]		=	"";
		$mon[1]		=	"January";
		$mon[2]		=	"February";
		$mon[3]		=	"March";
		$mon[4]		=	"April";
		$mon[5]		=	"May";
		$mon[6]		=	"June";
		$mon[7]		=	"July";
		$mon[8]		=	"August";
		$mon[9]		=	"September";
		$mon[10]	=	"October";
		$mon[11]	=	"November";
		$mon[12]	=	"December";

		if($myDate == "")
			return "";
		if($myDate == "0000-00-00")
			return "";
			
		$yy		= substr($myDate,0,4);
		$mm		= substr($myDate,5,2);
		$dd		= substr($myDate,8,2);
		$formatedDate	= $mon[(int)$mm]." ".$dd.", ".$yy;
		return $formatedDate;
	}

	/**
	 * This function takes an Image as Input (gif or jpg)
	 * and then re-sizes the image with the new Height/Width
	 * saves the new image replacing the old one.
	 */
 	function ResizeImage($file_name, $newWidth, $newHeight) {
		if($file_name!="") {
			$ar=getimagesize($file_name);

			if($ar[2] == 2) $srcImage = ImageCreateFromJPEG( $file_name );  	/*-- "JPG" --*/
			if($ar[2] == 1) $srcImage = ImageCreateFromGIF( $file_name );     /*-- "GIF" --*/

			$srcWidth 	= ImageSX( $srcImage );
			$srcHeight	= ImageSY( $srcImage );

			$destWidth 	= $newWidth;
			$destHeight = $newHeight;
			$destImage 	= imagecreatetruecolor( $destWidth, $destHeight);

			ImageCopyResampled( $destImage, $srcImage, 0, 0, 0, 0, $destWidth, $destHeight, $srcWidth, $srcHeight);

			if($ar[2] == 1) ImageGif($destImage,$file_name);			/*-- "GIF" --*/
			if($ar[2] == 2) ImageJpeg($destImage,$file_name,70);	/*-- "JPG" --*/
		}
 	}

	/**
	 * This function takes two dates as Input (yyyy-mm-dd)
	 * and then calculates the difference
	 * and returns the value in terms of days
	 */
	function count_days( $a, $b ){
		$days = (strtotime($b) - strtotime($a)) / (60 * 60 * 24);
		return $days;
	}

	/**
	 * This function takes a number (amount)
	 * and returns the value in terms of words
	 */
	function numToWord($money, $fraction) {
		return setRupeePaise(number_format($money, 2, '.', ''), $fraction);
	}

	function setRupeePaise($money, $fraction='Paise') {
	
		if($money == 0) {
			return "Zero";
		}
	
		$Num			= $money;
		$Digit		= array();
		$Tenth		= array();
		$Excp			= array();
		$HTLC			= array();
		$NumLen		= 0;
		$RsPart		= "";
		$PsPart		= "";
		$RsLen		= 0;
		$PsLen		= 0;
		$PsStr		= "";
		$RsStr		= "";
		$a				= 0;
		$b				= 0;
		$LoopLen	= 0;
		$MainStr	= "";
		$strBreak	= "";

		$Digit[0]	= "";
		$Digit[1]	= "One";
		$Digit[2]	= "Two";
		$Digit[3]	= "Three";
		$Digit[4]	= "Four";
		$Digit[5]	= "Five";
		$Digit[6]	= "Six";
		$Digit[7]	= "Seven";
		$Digit[8]	= "Eight";
		$Digit[9]	= "Nine";

		$Tenth[0]	= "";
		$Tenth[1]	= "Ten";
		$Tenth[2]	= "Twenty";
		$Tenth[3]	= "Thirty";
		$Tenth[4]	= "Forty";
		$Tenth[5]	= "Fifty";
		$Tenth[6]	= "Sixty";
		$Tenth[7]	= "Seventy";
		$Tenth[8]	= "Eighty";
		$Tenth[9]	= "Ninety";

		$Excp[0]		= "";
		$Excp[1]		= "Eleven";
		$Excp[2]		= "Twelve";
		$Excp[3]		= "Thirteen";
		$Excp[4]		= "Forteen";
		$Excp[5]		= "Fifteen";
		$Excp[6]		= "Sixteen";
		$Excp[7]		= "Seventeen";
		$Excp[8]		= "Eighten";
		$Excp[9]		= "Nineteen";

		$HTLC[0]		= "";
		$HTLC[1]		= "Hundred";
		$HTLC[2]		= "Thousand";
		$HTLC[3]		= "Lakh";
		$HTLC[4]		= "Crore";

		$NumLen 	= strlen((string)$Num);
		$RsPart 	= substr($Num, 0, $NumLen - 3);
		$PsPart 	= substr($Num, $NumLen-2, $NumLen);
		$RsLen 		= strlen((string)$RsPart);
		$PsLen 		= strlen((string)$PsPart);
		$LoopLen 	= $RsLen;
		while($LoopLen != 0) {
			switch($LoopLen) {
				case 1:
					$a 				= (int)substr($RsPart, $RsLen-1, 1);
					$RsStr 		= $RsStr." ".$Digit[$a];
					$LoopLen 	= 0;
					break;
				case 2:
					$a = (int)substr($RsPart, $RsLen - 2, 1);
					if($a == 1) {
						$b = (int)substr($RsPart, $RsLen-1, 1);
						if($b == 0)
								$RsStr = $RsStr." ".$Tenth[$a];
						else
								$RsStr = $RsStr." ".$Excp[$b];
						$LoopLen	= 0;
					} else {
						$RsStr 		= $RsStr." ".$Tenth[$a];
						$LoopLen 	= 1;
					}
					break;
				case 3:
					$a = (int)substr($RsPart, $RsLen - 3, 1);
					$RsStr = $RsStr." ".$Digit[$a]." ";
					if($a != 0)
						$RsStr = $RsStr.$HTLC[1];
					$LoopLen = 2;
					break;
				case 4:
					$a = (int)substr($RsPart, $RsLen - 4, 1);
					$RsStr = $RsStr." ".$Digit[$a];
					if($a == 0) {
						$b = (int)substr($RsPart, $RsLen - 5, 1);
						if($b != 0)
							$RsStr = $RsStr." ".$HTLC[2];
					}	else
							$RsStr = $RsStr." ".$HTLC[2];
					$LoopLen = 3;
					break;
				case 5:
					$a = (int)substr($RsPart, $RsLen - 5, 1);
					if($a == 1) {
						$b = (int)substr($RsPart, $RsLen - 4, 1);
						if($b == 0)
								$RsStr = $RsStr." ".$Tenth[$a]." ".$HTLC[2];
						else
								$RsStr = $RsStr." ".$Excp[$b]." ".$HTLC[2];
						$LoopLen = 3;
					} else {
						$RsStr = $RsStr." ".$Tenth[$a];
						$LoopLen = 4;
					}
					break;
				case 6:
					$a = (int)substr($RsPart, $RsLen - 6, 1);
					$RsStr = $RsStr." ".$Digit[$a];
					if($a == 0) {
						$b = (int)substr($RsPart, $RsLen - 7, 1);
						if($b != 0)
							$RsStr = $RsStr." ".$HTLC[3];
					} else
							$RsStr = $RsStr." ".$HTLC[3];
					$LoopLen = 5;
					break;
				case 7:
					$a = (int)substr($RsPart, $RsLen - 7, 1);
					if($a == 1) {
						$b = (int)substr($RsPart, $RsLen - 6, 1);
						if($b == 0)
							$RsStr = $RsStr." ".$Tenth[$a]." ".$HTLC[3];
						else
							$RsStr = $RsStr." ".$Excp[$b]." ".$HTLC[3];
						$LoopLen = 5;
					} else {
						$RsStr = $RsStr." ".$Tenth[$a];
						$LoopLen = 6;
					}
					break;
				case 8:
					$a = (int)substr($RsPart, $RsLen - 8, 1);
					$RsStr = $RsStr." ".$Digit[$a];
					if($a == 0) {
						$b = (int)substr($RsPart, $RsLen - 9, 1);
						if($b != 0)
							$RsStr = $RsStr." ".$HTLC[4];
					} else
						$RsStr = $RsStr." ".$HTLC[4];
					$LoopLen = 7;
					break;
				case 9:
					$a = (int)substr($RsPart, $RsLen - 9, 1);
					if($a == 1) {
						$b = (int)substr($RsPart, $RsLen - 8, 1);
						if($b == 0)
							$RsStr = $RsStr." ".$Tenth[$a]." ".$HTLC[4];
						else
							$RsStr = $RsStr." ".$Excp[$b]." ".$HTLC[4];
						$LoopLen = 7;
					} else {
						$RsStr = $RsStr." ".$Tenth[$a];
						$LoopLen = 8;
					}
					break;
				case 10:
					$a = (int)substr($RsPart, $RsLen - 10, 1);
					$b = (int)substr($RsPart, $RsLen - 9, 1);
					$c = (int)substr($RsPart, $RsLen - 8, 1);
					if($b == 0 && $c == 0) {
						$RsStr = $RsStr." ".$Digit[$a]." ".$HTLC[1]." ".$HTLC[4];
						$LoopLen = 8;
					} else {
						$RsStr = $RsStr." ".$Digit[$a]." ".$HTLC[1];
						$LoopLen = 9;
					}
					break;
				default:
					$LoopLen	= 0;
			}
		}

		$LoopLen = $PsLen;
		while($LoopLen != 0) {
			switch($LoopLen) {
				case 1:
					$a 				= (int)substr($PsPart, $PsLen-1, 1);
					$PsStr 		= $PsStr." ".$Digit[$a];
					$LoopLen 	= 0;
					break;
				case 2:
					$a = (int)substr($PsPart, $PsLen - 2, 1);
					if($a == 1) {
						$b = (int)substr($PsPart, $PsLen-1, 1);
						if($b == 0)
							$PsStr = $PsStr." ".$Tenth[$a];
						else
							$PsStr = $PsStr." ".$Excp[$b];
						$LoopLen=0;
					} else {
						$PsStr = $PsStr." ".$Tenth[$a];
						$LoopLen = 1;
					}
					break;
				default:
					$LoopLen	= 0;
			}
		}

		$MainStr = $RsStr;
		if((int)($PsPart) != 0)
			$MainStr = $MainStr." and ".$fraction." ".$PsStr." Only";
		else
			$MainStr = $MainStr." Only";

		return($MainStr);
	}

	/**
	 * This function finds out the IP of the Site visitor
	 * and returns the value as a string
	 */
	function getClientIP() {
		global $HTTP_SERVER_VARS;

		if (isset($HTTP_SERVER_VARS)) {
			if (isset($HTTP_SERVER_VARS['HTTP_X_FORWARDED_FOR'])) {
				$ip = $HTTP_SERVER_VARS['HTTP_X_FORWARDED_FOR'];
			} elseif (isset($HTTP_SERVER_VARS['HTTP_CLIENT_IP'])) {
				$ip = $HTTP_SERVER_VARS['HTTP_CLIENT_IP'];
			} else {
				$ip = $HTTP_SERVER_VARS['REMOTE_ADDR'];
			}
		} else {
			if (getenv('HTTP_X_FORWARDED_FOR')) {
				$ip = getenv('HTTP_X_FORWARDED_FOR');
			} elseif (getenv('HTTP_CLIENT_IP')) {
				$ip = getenv('HTTP_CLIENT_IP');
			} else {
				$ip = getenv('REMOTE_ADDR');
			}
		}

		return $ip;
	}

	/**
	 * This function takes a timestamp as input
	 * and returns the timestamp as Date Time
	 */
	function getDateFromTime($tt) {
		$tt		=	(int)$tt;
		if($tt == 0)
			return "";
		$ct		=	getdate($tt);
		$mm 	= $ct['month'];
		$dd 	= $ct['mday'];
		$yy 	= $ct['year'];
		$hh 	= $ct['hours'];
		$min 	= $ct['minutes'];
		$sec 	= $ct['seconds'];

		return $mm.' '.$dd.', '.$yy.' '.$hh.':'.$min.':'.$sec;
	}
	
	/**
	 * This function takes a timestamp as input
	 * and returns the timestamp as Date Time
	 */
	function getIndianDateFromTime($tt) {
		$tt		=	(int)$tt;
		if($tt == 0)
			return "";
		$ct		=	getdate($tt);
		$mm 	= $ct['mon'];
		$dd 	= $ct['mday'];
		$yy 	= $ct['year'];
		$hh 	= $ct['hours'];
		$min 	= $ct['minutes'];
		$sec 	= $ct['seconds'];
		
		if($dd < 10 ) $dd	= "0".$dd;
		if($mm < 10 ) $mm	= "0".$mm;
		if($hh < 10 ) $hh	= "0".$hh;
		if($min < 10 ) $min	= "0".$min;

		return $dd.'.'.$mm.'.'.$yy.' / '.$hh.':'.$min;
	}
	
	/**
	 * This function takes a timestamp as input
	 * and returns the timestamp as Date Time
	 */
	function getIndianDateFromTimeForSMS($tt) {
		$tt		=	(int)$tt;
		if($tt == 0)
			return "";
		$ct		=	getdate($tt);
		$mm 	= $ct['mon'];
		$dd 	= $ct['mday'];
		$yy 	= $ct['year'];
		$hh 	= $ct['hours'];
		$min 	= $ct['minutes'];
		$sec 	= $ct['seconds'];
		
		if($dd < 10 ) $dd	= "0".$dd;
		if($mm < 10 ) $mm	= "0".$mm;
		if($hh < 10 ) $hh	= "0".$hh;
		if($min < 10 ) $min	= "0".$min;

		return $dd.'/'.$mm.'/'.$yy.' '.$hh.':'.$min;
	}

	/**
	 * This function takes a string as input
	 * and returns a string removing single
	 * quote, double quote and back slash
	 */
	function formatJScriptString($str) {
		$str	=	str_replace("'","",$str);
		$str	=	str_replace('"','',$str);
		$str	=	str_replace('\\','',$str);
		return $str;
	}

	/**
	 * This function takes a string as input
	 * and returns a string after removing
	 * trailing spaces and slashes.
	 */
	function formatSQLString($str) {
		$str	=	trim($str);
		$tmp	=	substr($str,-1);
		if($tmp == "\\") {
			$n	=	strlen($str);
			return substr($str,0,$n-1);
		}
		return $str;
	}

	/**
	 * This function takes a Date (yyyy-mm-dd) as input
	 * calculates and returns the Financial Year
	 * Input format yyyy-mm-dd
	 * Output format yy-(yy++) OR (yy--)-yy
	 */
	function getFinancialYear($myDate) {
		$finyear	=	"";

		if($myDate=="")
			$myDate	=	date("Y-m-d");
		if($myDate=="00-00-0000")
			$myDate	=	date("Y-m-d");
		$yy	= substr($myDate,0,4);
		$mm	= substr($myDate,5,2);
		$dd	= substr($myDate,8,2);

		$ny	=	$yy;
		if($mm>=1 && $mm<=3)
			$yy--;
		else
			$ny++;

		$finyear	=	substr($yy,2,2)."-".substr($ny,2,2);
		return $finyear;
	}
	
	/**
	 * This function takes a Date (yyyy-mm-dd) as input
	 * calculates and returns the Financial Year (4 digit)
	 * Input format yyyy-mm-dd
	 * Output format yyyy-(yyyy++) OR (yyyy--)-yyyy
	 */
	function getFullFinancialYear($myDate) {
		$finyear	=	"";

		if($myDate == "")
			$myDate	=	date("Y-m-d");
		if($myDate == "00-00-0000")
			$myDate	=	date("Y-m-d");
		$yy	= substr($myDate,0,4);
		$mm	= substr($myDate,5,2);
		$dd	= substr($myDate,8,2);

		$ny	=	$yy;
		if($mm>=1 && $mm<=3)
			$yy--;
		else
			$ny++;

		$finyear	=	$yy."-".$ny;
		return $finyear;
	}

	/**
	 * This function
	 * calculates and returns the First Financial Date
	 * for example 2008-04-01
	 * Output format yyyy-mm-dd
	 */
	function getFirstFinancialDate($myDate = '') {
		$fdate	=	"2008-04-01";
		if($myDate == '')
			$myDate	=	date('Y-m-d');
		$yy			= substr($myDate,0,4);
		$mm			= substr($myDate,5,2);

		if($mm>=1 && $mm<=3)
			$yy--;

		$fdate	=	$yy."-04-01";
		return $fdate;
	}

	/**
	 * This function
	 * calculates and returns the Last Financial Date
	 * for example 2009-03-31
	 * Output format yyyy-mm-dd
	 */
	function getLastFinancialDate($myDate = '') {
		$fdate	=	"2009-03-31";

		if($myDate == '')
			$myDate	=	date('Y-m-d');
		$yy			= substr($myDate,0,4);
		$mm			= substr($myDate,5,2);

		if($mm>=4 && $mm<=12)
			$yy++;

		$fdate	=	$yy."-03-31";
		return $fdate;
	}

	/**
	 * Check the current host and match it with the supplied host
	 *
	 * @return bool True if URl matches, false if not.
	 */
	function init_component() {
		$s12		=	$_SERVER['HTTP_HOST'];
		$o12		=	"";
		$o13		=	"";
		$o14		=	"";
		$o15		=	"";
		$o16		=	"localhost";

		if($s12 == $o12)
			return true;
		if($s12 == $o13)
			return true;
		if($s12 == $o14)
			return true;
		if($s12 == $o15)
			return true;
		if($s12 == $o16)
			return true;
		return false;
	}

	/**
	 * Determine if SSL is used.
	 *
	 * @return bool True if SSL, false if not used.
	 */
	function is_ssl() {
		return ( isset($_SERVER['HTTPS']) && 'on' == strtolower($_SERVER['HTTPS']) ) ? true : false;
	}

	/**
	 * This function takes a SQL query as String
	 * Then opens/creates a .sql file in the form Y-m-d.sql
	 * The file is opened in the append mode
	 * The SQL String is written back to the disk file.
	 *
	 * This is a datewise dump of every database transactions
	 *
	 * This function will dump only INSERT/UPDATE queries
	 * queries starting with SELECT will be ignored
	 */
	function queryLog($sql) {
		/*$start		=	strtolower(substr($sql,0,6));
		if($start == 'select')
			return false;*/
		$sql			=	$sql.";\n\n";
		$fpath		=	ABSPATH."/mysqlDump/".date('Y-m-d').".sql";
		$sqlFile 	= fopen ($fpath,"a+");
		fwrite($sqlFile,$sql);
		fclose($sqlFile);
	}

	/**
	 * This function takes a date as input
	 * The Date input format is yyyy-mm-dd
	 * It then finds the Date Next to the input date
	 * The function then returns the Next Date
	 *
	 * Return Date format is yyyy-mm-dd
	 */
	function getNextDate($mdate) {
		$yy	= substr($mdate,0,4);
		$mm	= substr($mdate,5,2);
		$dd	= substr($mdate,8,2);
		$mm	= $mm+0;

		$dayOfMonth1	= array();
		$dayOfMonth1[1]=31;
		if($yy%4==0)
			$dayOfMonth1[2]=29;
		else
			$dayOfMonth1[2]=28;
		$dayOfMonth1[3]=31;
		$dayOfMonth1[4]=30;
		$dayOfMonth1[5]=31;
		$dayOfMonth1[6]=30;
		$dayOfMonth1[7]=31;
		$dayOfMonth1[8]=31;
		$dayOfMonth1[9]=30;
		$dayOfMonth1[10]=31;
		$dayOfMonth1[11]=30;
		$dayOfMonth1[12]=31;

		$dd	= $dd+1;
		if($dd>$dayOfMonth1[$mm]){
			$dd=1;
			$mm++;
			if($mm>12){
				$yy++;
				$mm=1;
			}
		}

		if($mm<10)
			$mm	= "0".$mm;
		if($dd<10)
			$dd	= "0".$dd;

		return $yy."-".$mm."-".$dd;
	}


	/**
	 * This function takes a date as input
	 * The Date input format is yyyy-mm-dd
	 * It then finds the Date Previous to the input date
	 * The function then returns the Previous Date
	 *
	 * Return Date format is yyyy-mm-dd
	 */
	function getPreviousDate($mdate) {
		$yy	= substr($mdate,0,4);
		$mm	= substr($mdate,5,2);
		$dd	= substr($mdate,8,2);
		$mm	= $mm + 0;

		$dayOfMonth1			= array();
		$dayOfMonth1[1]		= 31;
		if($yy % 4 == 0)
			$dayOfMonth1[2]	= 29;
		else
			$dayOfMonth1[2]	= 28;
		$dayOfMonth1[3]		= 31;
		$dayOfMonth1[4]		= 30;
		$dayOfMonth1[5]		= 31;
		$dayOfMonth1[6]		= 30;
		$dayOfMonth1[7]		= 31;
		$dayOfMonth1[8]		= 31;
		$dayOfMonth1[9]		= 30;
		$dayOfMonth1[10]	= 31;
		$dayOfMonth1[11]	= 30;
		$dayOfMonth1[12]	= 31;

		$dd--;
		if($dd < 1){
			$mm--;
			if($mm < 1){
				$yy--;
				$mm = 12;
			}
			$dd	=	$dayOfMonth1[$mm];
		}

		if($mm < 10)
			$mm	= "0".$mm;
		if($dd < 10)
			$dd	= "0".$dd;

		return $yy."-".$mm."-".$dd;
	}
	
	
	/**
	 * Formats the current page url.
	 *
	 * Returns the Page URL in readable format (string).
	 */
	function getCurrentPageURL() {
		$pageURL = 'http';
		if (isset($_SERVER['HTTPS']) && 'on' == strtolower($_SERVER['HTTPS'])) $pageURL .= "s";
		$pageURL .= "://";
		$pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
		return $pageURL;
	}
	
	
	/**
	 * Takes a number as input, please note decimal numbers are converted to int
	 *
	 * Returns the string representation of the number
	 */	
	function getWordRepresentationOfNumber($inum) {
	
		if($inum == 0) {
			return "";
		}
	
		$Num			= (int)$inum;
		
		$Digit		= array();
		$Tenth		= array();
		$Excp			= array();
		$HTLC			= array();
		
		$NumLen		= 0;
		$LoopLen	= 0;
		$MainStr	= "";
		$strBreak	= "";

		$Digit[0]	= "";
		$Digit[1]	= "One";
		$Digit[2]	= "Two";
		$Digit[3]	= "Three";
		$Digit[4]	= "Four";
		$Digit[5]	= "Five";
		$Digit[6]	= "Six";
		$Digit[7]	= "Seven";
		$Digit[8]	= "Eight";
		$Digit[9]	= "Nine";

		$Tenth[0]	= "";
		$Tenth[1]	= "Ten";
		$Tenth[2]	= "Twenty";
		$Tenth[3]	= "Thirty";
		$Tenth[4]	= "Forty";
		$Tenth[5]	= "Fifty";
		$Tenth[6]	= "Sixty";
		$Tenth[7]	= "Seventy";
		$Tenth[8]	= "Eighty";
		$Tenth[9]	= "Ninety";

		$Excp[0]	= "";
		$Excp[1]	= "Eleven";
		$Excp[2]	= "Twelve";
		$Excp[3]	= "Thirteen";
		$Excp[4]	= "Forteen";
		$Excp[5]	= "Fifteen";
		$Excp[6]	= "Sixteen";
		$Excp[7]	= "Seventeen";
		$Excp[8]	= "Eighten";
		$Excp[9]	= "Nineteen";

		$HTLC[0]	= "";
		$HTLC[1]	= "Hundred";
		$HTLC[2]	= "Thousand";
		$HTLC[3]	= "Lakh";
		$HTLC[4]	= "Crore";

		$NumLen 	= strlen((string)$Num);
		$NumPart 	= substr($Num, 0);
		$LoopLen 	= $NumLen;
		
		while($LoopLen != 0) {
			switch($LoopLen) {
				case 1:
					$a 							= (int)substr($NumPart, $NumLen - 1, 1);
					$MainStr 				= $MainStr." ".$Digit[$a];
					$LoopLen 				= 0;
					break;
				case 2:
					$a 							= (int)substr($NumPart, $NumLen - 2, 1);
					if($a == 1) {
						$b 						= (int)substr($NumPart, $NumLen - 1, 1);
						if($b == 0)
								$MainStr 	= $MainStr." ".$Tenth[$a];
						else
								$MainStr 	= $MainStr." ".$Excp[$b];
						$LoopLen			= 0;
					} else {
						$MainStr 			= $MainStr." ".$Tenth[$a];
						$LoopLen 			= 1;
					}
					break;
				case 3:
					$a 							= (int)substr($NumPart, $NumLen - 3, 1);
					$MainStr 				= $MainStr." ".$Digit[$a]." ";
					if($a != 0)
						$MainStr 			= $MainStr.$HTLC[1];
					$LoopLen 				= 2;
					break;
				case 4:
					$a = (int)substr($NumPart, $NumLen - 4, 1);
					$MainStr 				= $MainStr." ".$Digit[$a];
					if($a == 0) {
						$b 						= (int)substr($NumPart, $NumLen - 5, 1);
						if($b != 0)
							$MainStr 		= $MainStr." ".$HTLC[2];
					}	else
							$MainStr 		= $MainStr." ".$HTLC[2];
					$LoopLen = 3;
					break;
				case 5:
					$a 							= (int)substr($NumPart, $NumLen - 5, 1);
					if($a == 1) {
						$b 						= (int)substr($NumPart, $NumLen - 4, 1);
						if($b == 0)
								$MainStr 	= $MainStr." ".$Tenth[$a]." ".$HTLC[2];
						else
								$MainStr 	= $MainStr." ".$Excp[$b]." ".$HTLC[2];
						$LoopLen 			= 3;
					} else {
						$MainStr 			= $MainStr." ".$Tenth[$a];
						$LoopLen 			= 4;
					}
					break;
				default:
					$LoopLen				= 0;
			}
		}

		return($MainStr);
	}
	
	
	/**
	 * This function takes a date as input
	 * The Date input format is yyyy-mm-dd
	 * It then converts the date in word form
	 * The function then returns date in Text format
	 *
	 * Return Date format is dd, mm yyyy
	 */
	function getTextFromDate($mdate) {
		$yy	= (int)substr($mdate,0,4);
		$mm	= (int)substr($mdate,5,2);
		$dd	= (int)substr($mdate,8,2);
		$ret	= "";
		
		$ddStr	= array(
			1 	=> "First",
			2 	=> "Second",
			3 	=> "Third",
			4 	=> "Fourth",
			5		=> "Fifth",
			6		=> "Sixth",
			7		=> "Seventh",
			8		=> "Eighth",
			9		=> "Nineth",
			10	=> "Tenth",
			11	=> "Eleventh",
			12	=> "Twelveth",
			13	=> "Thirteenth",
			14	=> "Fourteenth",
			15	=> "Fifteenth",
			16	=> "Sixteenth",
			17	=> "Seventeenth",
			18	=> "Eighteenth",
			19	=> "Nineteenth",
			20 	=> "Twenty",
			21 	=> "Twenty One",
			22 	=> "Twenty Two",
			23 	=> "Twenty Three",
			24 	=> "Twenty Four",
			25 	=> "Twenty Five",
			26 	=> "Twenty Six",
			27 	=> "Twenty Seven",
			28 	=> "Twenty Eight",
			29 	=> "Twenty Nine",
			30 	=> "Thirty",
			31 	=> "Thirty One"
		);
		
		$mmStr	= array(
			1 	=> "January",
			2 	=> "February",
			3 	=> "March",
			4 	=> "April",
			5		=> "May",
			6		=> "June",
			7		=> "July",
			8		=> "August",
			9		=> "September",
			10	=> "October",
			11	=> "November",
			12	=> "December"
		);
		
		$ret	= $ddStr[$dd].' '.$mmStr[$mm].' '.number_to_word($yy);
		
		return $ret;

	}
	
	function number_to_word( $num = '' ) {
		$num	= ( string ) ( ( int ) $num );
	
		if( ( int ) ( $num ) && ctype_digit( $num ) ) {
			$words	= array( );
		
			$num	= str_replace( array( ',' , ' ' ) , '' , trim( $num ) );
		
			$list1	= array('','one','two','three','four','five','six','seven',
				'eight','nine','ten','eleven','twelve','thirteen','fourteen',
				'fifteen','sixteen','seventeen','eighteen','nineteen');
		
			$list2	= array('','ten','twenty','thirty','forty','fifty','sixty',
				'seventy','eighty','ninety','hundred');
		
			$list3	= array('','thousand','million','billion','trillion',
				'quadrillion','quintillion','sextillion','septillion',
				'octillion','nonillion','decillion','undecillion',
				'duodecillion','tredecillion','quattuordecillion',
				'quindecillion','sexdecillion','septendecillion',
				'octodecillion','novemdecillion','vigintillion');
		
			$num_length	= strlen( $num );
			$levels	= ( int ) ( ( $num_length + 2 ) / 3 );
			$max_length	= $levels * 3;
			$num	= substr( '00'.$num , -$max_length );
			$num_levels	= str_split( $num , 3 );
		
			foreach( $num_levels as $num_part ) {
				$levels--;
				$hundreds	= ( int ) ( $num_part / 100 );
				$hundreds	= ( $hundreds ? ' ' . $list1[$hundreds] . ' Hundred' . ( $hundreds == 1 ? '' : 's' ) . ' ' : '' );
				$tens		= ( int ) ( $num_part % 100 );
				$singles	= '';
			
				if( $tens < 20 ) {
					$tens	= ( $tens ? ' ' . $list1[$tens] . ' ' : '' );
				} else {
					$tens	= ( int ) ( $tens / 10 );
					$tens	= ' ' . $list2[$tens] . ' ';
					$singles	= ( int ) ( $num_part % 10 );
					$singles	= ' ' . $list1[$singles] . ' ';
				}
				$words[]	= $hundreds . $tens . $singles . ( ( $levels && ( int ) ( $num_part ) ) ? ' ' . $list3[$levels] . ' ' : '' );
			}
		
			$commas	= count( $words );
		
			if( $commas > 1 ) {
				$commas	= $commas - 1;
			}
		
			$words	= implode( ', ' , $words );
		
			/*Some Finishing Touch*/
			/*Replacing multiples of spaces with one space*/
			$words	= trim( str_replace( ' ,' , ',' , trim( ucwords( $words ) ) ) , ', ' );
			if( $commas ) {
				$words	= str_replace( ',' , ' and' , $words );
			}
		
			return $words;
		} else if( ! ( ( int ) $num ) ) {
			return 'Zero';
		}
		return '';
	}
	
	function getGSTStateCode($State) {
		$scode		= "";
		if($State == "Andaman and Nicobar")
			$scode	= "35";
		else if($State == "Andhra Pradesh")
			$scode	= "28";
		else if($State == "Andhra Pradesh (New)")
			$scode	= "37";			
		else if($State == "Arunachal Pradesh")
			$scode	= "12";
		else if($State == "Assam")
			$scode	= "18";
		else if($State == "Bihar")
			$scode	= "10";
		else if($State == "Chandigarh")
			$scode	= "04";
		else if($State == "Chhattisgarh")
			$scode	= "22";
		else if($State == "Dadra and Nagar Haveli")
			$scode	= "26";
		else if($State == "Daman and Diu")
			$scode	= "26";
		else if($State == "Delhi")
			$scode	= "07";
		else if($State == "Goa")
			$scode	= "30";
		else if($State == "Gujarat")
			$scode	= "24";
		else if($State == "Haryana")
			$scode	= "06";
		else if($State == "Himachal Pradesh")
			$scode	= "02";
		else if($State == "Jammu and Kashmir")
			$scode	= "01";
		else if($State == "Jharkhand")
			$scode	= "20";
		else if($State == "Karnataka")
			$scode	= "29";
		else if($State == "Kerala")
			$scode	= "32";
		else if($State == "Ladakh")
			$scode	= "38";			
		else if($State == "Lakshadweep")
			$scode	= "31";
		else if($State == "Madhya Pradesh")
			$scode	= "23";
		else if($State == "Maharashtra")
			$scode	= "27";
		else if($State == "Manipur")
			$scode	= "14";
		else if($State == "Meghalaya")
			$scode	= "17";
		else if($State == "Mizoram")
			$scode	= "15";
		else if($State == "Nagaland")
			$scode	= "13";
		else if($State == "Odisha")
			$scode	= "21";
		else if($State == "Puducherry")
			$scode	= "34";
		else if($State == "Punjab")
			$scode	= "03";
		else if($State == "Rajasthan")
			$scode	= "08";
		else if($State == "Sikkim")
			$scode	= "11";
		else if($State == "Tamil Nadu")
			$scode	= "33";
		else if($State == "Telangana")
			$scode	= "36";
		else if($State == "Tripura")
			$scode	= "16";
		else if($State == "Uttar Pradesh")
			$scode	= "09";
		else if($State == "Uttarakhand")
			$scode	= "05";
		else if($State == "West Bengal")
			$scode	= "19";
			
		return $scode;
	}
	
	/**
	 * Input format int 1-12
	 * Output format January - December
	**/
	function getMonthFromInt($mm) {
		if($mm>12) 	$mm	=	12;
		if($mm<1)		$mm	=	1;
		$month	=	array(1=>"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");
		return $month[$mm];
	}
	
	
	function generateEAN($number) {
		$code 			= '387' . str_pad($number, 9, '0', STR_PAD_LEFT);
		$weightflag = true;
		$sum 				= 0;
		// Weight for a digit in the checksum is 3, 1, 3.. starting from the last digit. 
		// loop backwards to make the loop length-agnostic. The same basic functionality 
		// will work for codes of different lengths.
		for ($i = strlen($code) - 1; $i >= 0; $i--) {
			$sum += (int)$code[$i] * ($weightflag?3:1);
			$weightflag = !$weightflag;
		}
		$code .= (10 - ($sum % 10)) % 10;
		return $code;
	}	

?>