<?php

	/* Include the required files */
	require_once( 'aom-config.php' );
	require_once( 'inc/pagetemplate.php' );
	require_once( 'inc/head.php' );
	require_once( 'inc/topmenu.php' );
	require_once( 'inc/functions.php' );
	require_once( 'dao/asys.user.php' );
	require_once( 'dao/asys.logindb.php' );
	require_once( 'dao/asys.genericdb.php' );
	require_once( 'dao/asys.log.php' );

	$tuser		=	new asys_users();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}

	if($tuser->getUserStatus() < ADMIN_USER) {
		echo 'Only Admin Users can view/open this Page. <a href="home.php">Click here to go back.</a>';
		exit;
	}

	$ldb			=	new logindb();
	$gdb			=	new genericdb();
	$ulist		=	$ldb->getUserList();

	/* Ready to create the page */
	$iPage	=	new asys_pages(APP_TITLE);
	/* Start writting the page */
	$iPage->startPage();
	$iPage->startHeader();
	/* Add links and Scripts as required */
	$iPage->addLink("css/asys.css");
	$iPage->addLink("css/menu.css");
	$iPage->addLink("css/select2.css");
	$iPage->addLink("css/datepicker.css");
	$iPage->addScript("js/common.js");
	$iPage->addScript("js/jquery.js");
	$iPage->addScript("js/select2.js");
	$iPage->addScript("js/datepicker.js");

	$iPage->endHeader();
	$iPage->startBody();
	
	outputHeader($tuser);	

?>

	<?php include('inc/menuHome.php')?>

	<div id="pagehead">&nbsp;USER LOG</div>
	
	<div style="height:10px;"></div>
	
	<table cellspacing="0" border="0" width="980px" align="center" bgcolor="#99BBE8">
		<tr><td bgcolor="#D6E3F3" class="td_normal_large red bold" style="padding:2px;">
			User Activity Log - reports
		</td></tr>
		<tr><td style="border-top: 1px solid #99BBE8;"></td></tr>
		<tr>
			<td bgcolor="#ffffff" class="td_normal" style="padding:4px;">	
				<form method="post" action="logreport.php" target="_blank">
				<div style="float:left;padding-top:3px;width:100px;">
					&nbsp;select user &nbsp;
				</div>
				<div style="float:left;width:350px;">
					<select name="UserID" id="UserID" style="width:98%">
						<option value="">--</option>
				<?php
					for($i=0;$i<count($ulist);$i++){
						$ub	= $ulist[$i];
						if($ub->getUserStatus() > $tuser->getUserStatus()) continue;
				?>				
					<option value="<?php echo $ub->getUserID()?>"><?php echo $ub->getUserName()?></option>
				<?php } ?>
					</select>
				</div>
				<div style="float:left;width:100px;">
					<input data-toggle="datepicker" type="text" name="dtf" id="dtf" value="<?php echo date('d-m-Y')?>" style="width:80px;" class="input" maxLength="10">
				</div>
				<div style="float:left;width:100px;">
					<input data-toggle="datepicker" type="text" name="dtt" id="dtt" value="<?php echo date('d-m-Y')?>" style="width:80px;" class="input" maxLength="10">
				</div>	
				<div style="float:left">
					&nbsp;&nbsp;<input type="submit" class="red_button" value="&nbsp;Get Report&nbsp;">
				</div>
				</form>
			</td>
		</tr>
	</table>
	
	<br />
	

<?php

	$iPage->endBody();
	$iPage->endPage();

?>


<script language="javaScript">

	$(function () {
		$("select").select2();
	});
	
	$('[data-toggle="datepicker"]').datepicker({
		format: 'dd-mm-yyyy',
		autoHide: 'yes'
	});
		
	
	/*$('#dtf').on('pick.datepicker', function (e) {
		alert($('#dtf').datepicker('getDate', true));
	});*/
	
</script>