<?php

	/* Include the required files */
	require_once( 'aom-config.php' );
	require_once( 'inc/pagetemplate.php' );
	require_once( 'inc/head.php' );
	require_once( 'inc/topmenu.php' );
	require_once( 'inc/functions.php' );
	require_once( 'dao/asys.user.php' );
	require_once( 'dao/asys.company.php' );
	require_once( 'dao/asys.logindb.php' );
	require_once( 'dao/asys.genericdb.php' );
	require_once( 'dao/asys.log.php' );

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}

	if($tuser->getUserStatus() < ADMIN_USER) {
		echo 'Only Admin Users can view/open this Page. <a href="home.php">Click here to go back.</a>';
		exit;
	}

	$ldb			=	new logindb();

	$UserID		=	'';
	$dtf			=	'';
	$dtt			=	'';
	
	$hdr			= "";

	extract($_REQUEST);
	
	$sql			=	"SELECT * FROM `asys_user_log` WHERE `LTime` > 0";

	if($UserID != ''){
		$sql	=	$sql." AND `UserID`='$UserID'";
		$hdr	=	' of user '.$UserID;
	}

	if(FormatIndianDateToSQLDate($dtf) != '1900-01-01'){
		$sql	=	$sql." AND `LDate`>='".FormatIndianDateToSQLDate($dtf)."'";
		$hdr	=	$hdr.' From '.$dtf;
	}
	
	if(FormatIndianDateToSQLDate($dtt) != '1900-01-01'){
		$sql	=	$sql." AND `LDate`<='".FormatIndianDateToSQLDate($dtt)."'";
		$hdr	=	$hdr.' To '.$dtt;
	}	

	$logList	=	$ldb->getLogListBySQL($sql);
	
	
	/* Ready to create the page */
	$iPage	=	new asys_pages(APP_TITLE);
	/* Start writting the page */
	$iPage->startPage();
	$iPage->startHeader();
	/* Add links and Scripts as required */
	$iPage->addLink("css/asys.css");
	$iPage->addLink("css/menu.css");
	$iPage->addLink("extjs/resources/css/ext-all.css");
	$iPage->addScript("js/common.js");
	$iPage->addScript("extjs/adapter/ext/ext-base.js");
	$iPage->addScript("extjs/ext-all.js");	


	$iPage->endHeader();
	$iPage->startBody();
	
	outputHeader($tuser);	

?>


	<?php include('inc/menuHome.php')?>

	<div id="pagehead">&nbsp;USER LOG</div>
	
	<div style="font-family:verdana;" align="center">

		<div style="text-align:center; font-size:15px; font-weight:bold; letter-spacing:1pt;height:50px;">
			<br>Log Report <?php echo $hdr?><br />
		</div>
		<div style="font-size:10px; font-weight:bold;">
			<table cellSpacing='0' cellPadding='4' width='90%' border='0'>
				<tr>
					<td width='5%' class="rpt">
						Log#
					</td>
					<td width='15%' class="rpt">
						Date + Time
					</td>
					<td width='15%' class="rpt">
						Recorded IP
					</td>					
					<td width='20%' class="rpt">
						User
					</td>
					<td width='10%' class="rpt" align="center">
						Snapshot
					</td>					
					<td width='35%' class="rpt">
						Activity
					</td>
				</tr>

			<?php
				for($i=0;$i<count($logList);$i++){
					$row		=	$logList[$i];
					$pos		=	strripos($row->getActivity(), "delete");
					$cls		=	"rpt_normal";
					if($pos !== false)
						$cls	= "rpt_normal red";
			?>
				<tr>
					<td class="rpt_normal">
						<?php echo $row->getLogID()?>
					</td>
					<td class="rpt_normal">
						<?php echo getDateFromTime($row->getLTime())?>
					</td>
					<td class="rpt_normal">
						<?php echo $row->getUserIP()?>
					</td>					
					<td class="rpt_normal">
						<?php echo $row->getUserID()?>
					</td>
					<td class="rpt_normal" align="center">
						<?php if($row->getModuleID() > 0) { ?>
							<a id="a<?php echo $row->getLogID()?>" href="javaScript:viewSnapshot(<?php echo $row->getLogID()?>, <?php echo $row->getModuleID()?>, <?php echo $row->getRelatedID()?>)">Snapshot</a>
						<?php } ?>
					</td>
					<td class="<?php echo $cls?>">
						<?php echo $row->getActivity('yes')?>
					</td>
				</tr>
			<?php
				}
			?>
			</table>
		</div>
	</div>
	
	<br /><br />
	
	<div id="prev_win"  class="x-hidden">
		<div class="x-window-header">Module Snapshot</div>
		<div id="edit-tabs1" style="overflow:auto;">
			<div id="acc_content" style="padding:2px;overflow:auto;background:#ffffff;"><br />&nbsp;Loading snapshot, please wait ...</div>
		</div>
	</div>	
	
<?php

	$iPage->endBody();
	$iPage->endPage();

?>

<script language="javaScript">

	var pWin;
	var imCont	=	"";

	function viewSnapshot(lid, mid, rid) {

		EBD('acc_content').innerHTML = "";

		var button = Ext.get('a' + lid);

		if(!pWin){
			pWin = new Ext.Window({
				applyTo     : 'prev_win',
				layout      : 'fit',
				width       : 800,
				height			: 500,
				closeAction :'hide',
				plain       : true,
				items       : new Ext.BoxComponent ({
					applyTo		: 'edit-tabs1'
				}),
				buttons: [
				{
					text     : 'Close',
					handler  : function(){
						pWin.hide();
					}
				}]
			});
		}

		pWin.alignTo(button, "bl", [-600,0]);
		pWin.show(button);

		var x = (window.ActiveXObject) ? new ActiveXObject("Microsoft.XMLHTTP") : new XMLHttpRequest();
		if (x) {
			x.onreadystatechange = function() {
				if (x.readyState == 4 && x.status == 200) {
					imCont	= x.responseText;
					EBD('acc_content').innerHTML	=	imCont;
				}
			}

			x.open("POST", "Module" + mid + "Detail.php?mid=" + rid, true);
			x.send(null);

		} else {
			alert("This Browser does not support AJAX, please use IE 5.0 or above, Firefox 1.0 or above or other browser that supports AJAX and Advanced Javascript");
			return;
		}
	}
	
</script>