<?php

	/* Include the required files */
	require_once( 'aom-config.php' );
	require_once( 'inc/pagetemplate.php' );
	require_once( 'inc/head.php' );
	require_once( 'inc/topmenu.php' );
	require_once( 'inc/functions.php' );
	require_once( 'dao/asys.user.php' );
	require_once( 'dao/asys.config.php' );
	require_once( 'dao/asys.company.php' );
	require_once( 'dao/asys.genericdb.php' );
	require_once( 'dao/asys.masterdb.php' );
	require_once( 'dao/asys.companydb.php' );
	require_once( 'dao/asys.log.php' );
	require_once( 'dao/asys.logindb.php' );
	require_once( 'dao/asys.userpermission.php' );	

	$tuser		=	new asys_users();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	$ModuleID			= -2;	

	$gdb					=	new genericdb();
	$mdb					=	new masterdb();
	$ldb					= new logindb();
	$cdb					= new companydb();
	$cclass				= new asys_config();
	
	if($tuser->getUserStatus() < ADMIN_USER) {
		echo 'Only Admin Users can view/open this Page. <a href="home.php">Click here to go back.</a>';
		exit;
	}	
							
			
	$CompanyID	=	"";
	$ConfigID		=	"";
	$ConfigName	=	"";
	$ConfigValue	=	"";


	$rmsg					=	"";
	$msg					=	"Please enter all the fields correctly.";
	$pagen				=	"";

	$fcss					=	 array();
	for($i=0;$i<4;$i++)
		$fcss[$i]		=	"input";

	extract($_REQUEST);
	
	if($pagen == "process") {
		/* Check for valid input */		
		
		if((int)$CompanyID <= 0) {
			$fcss[0]	=	"err_input";
			if($rmsg != "") $rmsg = $rmsg.",";
			$rmsg	=	$rmsg."Company";
		}

		/*if((int)$ConfigID <= 0) {
			$fcss[1]	=	"err_input";
			if($rmsg != "") $rmsg = $rmsg.",";
			$rmsg	=	$rmsg."ConfigID";
		}*/

		if(trim($ConfigName) == "") {
			$fcss[2]	=	"err_input";
			if($rmsg != "") $rmsg = $rmsg.",";
			$rmsg	=	$rmsg."Config Name";
		}

		if(trim($ConfigValue) == "") {
			$fcss[3]	=	"err_input";
			if($rmsg != "") $rmsg = $rmsg.",";
			$rmsg	=	$rmsg."Config Value";
		}

		$cclass->setCompanyID($CompanyID);
		$cclass->setConfigID($gdb->getNextID("asys_config","ConfigID"));
		$cclass->setConfigName($ConfigName);
		$cclass->setConfigValue($ConfigValue);	

		if($rmsg == "") {
			if($gdb->SaveObjectToDB($cclass)) {
				$msg	=	"<font class='blue'>Config created successfully</font>";
				$log	=	new asys_user_log();
				$log->setLogID($gdb->getNextID("asys_user_log", "LogID"));
				$log->setUserID($tuser->getUserID());
				$log->setModuleID($ModuleID);
				$log->setRelatedID($cclass->getConfigID());
				$log->setActivity("Added new Config - ".$ConfigName);
				$log->setClassName('asys_config');
				$log->setModuleSnapshot(serialize($cclass));
				$gdb->SaveObjectToDB($log);	
				
				$cclass				= new asys_config();		
			} else {
				$msg	=	"<font class='red'>Config ID/Name already exist, try with a different ID/Name</font>";
			}
		} else {
			$msg	=	"<font class='red'>The following fields are mandatory: ".$rmsg."</font>";
		}
	}

	
	/* Ready to create the page */
	$iPage	=	new asys_pages(APP_TITLE);
	/* Start writting the page */
	$iPage->startPage();
	$iPage->startHeader();
	/* Add links and Scripts as required */
	$iPage->addLink("css/asys.css");
	$iPage->addLink("css/menu.css");
	$iPage->addLink("css/select2.css");
	$iPage->addScript("js/common.js");
	$iPage->addScript("js/jquery.js");
	$iPage->addScript("js/select2.js");	
	$iPage->addScript("js/nlbFade.js");
	$iPage->endHeader();
	$iPage->startBody();
	
	outputHeader($tuser);	
	
?>	

	<?php include('inc/menuHome.php')?>

	<div id="pagehead">&nbsp;CREATE NEW SYSTEM CONFIGURATION</div>
	<div style="height:10px;"></div>
	
	<div style="width:980px;margin:0px auto">
	<form name="hfrm" id="hfrm" method="post" action="">
	<input type="hidden" name="pagen" value="process">
	<table cellpadding="1" cellspacing="0" border="0" width="980px" align="center" bgcolor="#ffffff">
		<tr bgcolor="#D6E3F3"><td colspan="3" class="td_normal blue bold">
			<div id="dhead" style="float:left;width:900px;padding:5px;"><?php echo $msg?></div>
			<div style="float:right;padding:5px;"><a href="viewConfig.php"><img src="images/columns.gif" title="View Config List"></a></div>
		</td></tr>
		<tr style="height:1px" bgcolor="#99BBE8"><td colspan="3"></td></tr>	
			
		<tr>
			<td class="td_normal" width="170px;">&nbsp;Company</td>
			<td class="td_normal" width="6px;">:</td>
			<td class="td_normal">
				<select name="CompanyID" id="CompanyID" style="width:400px;"></select>
			</td>
		</tr>
				
		<tr>
			<td class="td_normal">&nbsp;Config Name</td>
			<td class="td_normal">:</td>
			<td class="td_normal"><input type="text" class="<?php echo $fcss[2]?>" name="ConfigName" id="ConfigName" value="<?php echo $cclass->getConfigName('yes')?>" style="width:300px" maxLength="50" onFocus="this.className='input_focus'" onBlur="this.className='<?php echo $fcss[2]?>'" /></td>
		</tr>	
				
		<tr>
			<td class="td_normal">&nbsp;Config Value</td>
			<td class="td_normal">:</td>
			<td class="td_normal"><input type="text" class="<?php echo $fcss[3]?>" name="ConfigValue" id="ConfigValue" value="<?php echo $cclass->getConfigValue('yes')?>" style="width:400px" maxLength="100" onFocus="this.className='input_focus'" onBlur="this.className='<?php echo $fcss[3]?>'" /></td>
		</tr>
						
		<tr style="height:1px" bgcolor="#99BBE8"><td colspan="3"></td></tr>
		<tr bgcolor="#D6E3F3">
			<td colspan="3" align="center">
				<input type="button" id="btnS" class="red_button" value=" Create (S) " AccessKey="S" onClick="submitForm('hfrm')" />
			</td>
		</tr>
	</table>
	</form>
	</div>
	
	<br /><br />
	
<?php
	$iPage->endBody();
	$iPage->endPage();
?>	
		
<script language="javaScript">
		
	$(function () {
		$("select").select2();
		NLBfadeBg('dhead','#ffff00','#D6E3F3','3000');
		getCompanyList();
	});
	
	function getCompanyList() {
    $('#CompanyID').empty();
    $('#CompanyID').append('<option value="0">--</option>');
    var cid		= <?php echo $cclass->getCompanyID()?>;
    
    $.ajax({
			type: "POST",
			url: "json/getCompanyList.php",
			success: function(data){

				var opts = $.parseJSON(data);
				$.each(opts, function(i, d) {
					$('#CompanyID').append('<option value="' + d.CompanyID + '">' + d.CompanyName + '</option>');
				});
				$("#CompanyID").val(cid).change();
				
			}
    });		
	}	
				
</script>