<?php

	/* Include the required files */
	require_once( 'checkLogin.php' );
	require_once( 'dao/asys.account.php' );
	require_once( 'dao/asys.store.php' );
	require_once( 'dao/asys.voucher.php' );
	require_once( 'dao/asys.stockvoucher.php' );
	require_once( 'dao/class.gen_items.php' );
	require_once( 'dao/class.gen_grn.php' );
	require_once( 'dao/class.gen_grn_items.php' );
	require_once( 'dao/class.purchasedb.php' );
	
	
	$ModuleID			= 18;	

	$gdb					=	new genericdb();
	$mdb					=	new masterdb();
	$ldb					= new logindb();
	$pdb					= new purchasedb();
	$cclass				= new gen_grn();
	$itmList			= $mdb->getItemList('', 0, $tcmp->getCompanyID());
	$strList			= $mdb->getStoreList($tcmp->getCompanyID());
	$cusList			=	$mdb->getSupplierListJSON($tcmp->getCompanyID());
	
	if($ldb->getCreatePermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:accessDenied.php");
		exit;
	}	
							
			
	$GRNID					=	"";
	$GRNDate				=	"";
	$FinYear				=	"";
	$GRNNo					=	"";
	$SupplierID			=	"";
	$StoreID				=	"";
	$ItemCategoryID	=	"";
	$DOE						=	"";
	$ItemTotal			=	"";
	$ChallanNo			=	"";
	$ChallanDate		=	"";

	$rmsg				=	"";
	$msg				=	"Please enter all the fields correctly.";
	$pagen			=	"";
	$numOfRows1	= 1;

	$fcss				=	 array();
	for($i=0;$i<8;$i++)
		$fcss[$i]	=	"input";

	extract($_REQUEST);
	
	if($pagen == "process") {
		/* Check for valid input */

		if(FormatIndianDateToSQLDate($GRNDate) == "1900-01-01") {
			$fcss[1]	=	"err_input";
			if($rmsg != "") $rmsg = $rmsg.",";
			$rmsg	=	$rmsg."Invalid GRN Date";
		}

		if((int)$SupplierID <= 0) {
			$fcss[4]	=	"err_input";
			if($rmsg != "") $rmsg = $rmsg.",";
			$rmsg	=	$rmsg."Supplier";
		}
		
		if((int)$StoreID <= 0) {
			$fcss[5]	=	"err_input";
			if($rmsg != "") $rmsg = $rmsg.",";
			$rmsg	=	$rmsg."Store";
		}		

		$tdf						= $tcmp->getTxnDateFrom();
		$tdt						= $tcmp->getTxnDateTo();
		$txnDate				= FormatIndianDateToSQLDate($GRNDate);
		if($txnDate < $tdf || $txnDate > $tdt) {
			if($rmsg != "") $rmsg	=	$rmsg.", ";
			$rmsg			=	$rmsg."Transaction date outside allowed date range";			
		}
		
		if($tcmp->getCompanyID() != $mdb->getCompanyIDByTransaction('asys_accounts', 'AccountID', $SupplierID)) {
			echo 'This data does not belong to the Company selected.';
			echo '<a href="home.php">Click Here</a> to go to Home';
			exit;
		}		
		
		if($tcmp->getCompanyID() != $mdb->getCompanyIDByTransaction('asys_stores', 'StoreID', $StoreID)) {
			echo 'This data does not belong to the Company selected.';
			echo '<a href="home.php">Click Here</a> to go to Home';
			exit;
		}
		
		
		$ItemTotal	= 0;
		$prodList	=	array();
		for($i=1;$i<=$numOfRows1;$i++){
			$icls	=	new gen_grn_items();
			
			$iid	= (int)$_REQUEST["ItemID$i"];
			$qty	= (double)$_REQUEST["Quantity$i"];
			$amt	= (double)$_REQUEST["Amount$i"];
			
			if($tcmp->getCompanyID() != $mdb->getCompanyIDByTransaction('gen_items', 'ItemID', $iid)) {
				echo 'This data does not belong to the Company selected.';
				echo '<a href="home.php">Click Here</a> to go to Home';
				exit;
			}			
			
			if($iid > 0 && $qty > 0 && $amt > 0) {

				$prc	= $amt / $qty;
			
				$icls->setGRNID(0);
				$icls->setItemID($iid);
				$icls->setQuantity($qty);
				$icls->setRate($prc);
				$icls->setAmount($amt);
				
				$ItemTotal		= $ItemTotal + $amt;
			
				$prodList[]	=	$icls;
			}
		}
		$cclass->setItemList($prodList);
		
		if(count($prodList) == 0) {
			if($rmsg != "") $rmsg = $rmsg.",";
			$rmsg	=	$rmsg."No Item selected";		
		}

		$cclass->setGRNID($gdb->getNextID("gen_grn","GRNID"));
		$cclass->setCompanyID($tcmp->getCompanyID());
		$cclass->setGRNDate($GRNDate);
		$cclass->setFinYear($FinYear);
		$cclass->setGRNNo($GRNNo);
		$cclass->setSupplierID($SupplierID);
		$cclass->setStoreID($StoreID);
		$cclass->setItemCategoryID($ItemCategoryID);
		$cclass->setDOE(date('d-m-Y').' - '.$tuser->getUserID());
		$cclass->setItemTotal($ItemTotal);
		$cclass->setChallanNo($ChallanNo);
		$cclass->setChallanDate($ChallanDate);		

		if($rmsg == "") {
			if($pdb->CreateGRN($cclass) > 0) {
				$msg	=	"<font class='blue'>GRN created successfully</font>";
				$log	=	new asys_user_log();
				$log->setLogID($gdb->getNextID("asys_user_log", "LogID"));
				$log->setUserID($tuser->getUserID());
				$log->setCompanyID($tcmp->getCompanyID());
				$log->setModuleID($ModuleID);
				$log->setRelatedID($cclass->getGRNID());				
				$log->setActivity("Added new GRN - ".$cclass->getGRNNo().'/'.$cclass->getFinYear());
				$log->setClassName('gen_grn');
				$log->setModuleSnapshot(serialize($cclass));
				$gdb->SaveObjectToDB($log);	
				
				$cclass				= new gen_grn();	
				$numOfRows1		= 1;	
			} else {
				$msg	=	"<font class='red'>GRN ID/Name already exist, try with a different ID/Name</font>";
			}
		} else {
			$msg	=	"<font class='red'>The following fields are mandatory: ".$rmsg."</font>";
		}
	}

	
	/* Ready to create the page */
	$iPage	=	new asys_pages(APP_TITLE);
	/* Start writting the page */
	$iPage->startPage();
	$iPage->startHeader();
	/* Add links and Scripts as required */
	$iPage->addLink("css/asys.css");
	$iPage->addLink("css/menu.css");
	$iPage->addLink("css/superTables.css");
	$iPage->addLink("css/select2.css");
	$iPage->addLink("css/modal.css");
	$iPage->addLink("css/datepicker.css");
	$iPage->addScript("js/common.js");
	$iPage->addScript("js/superTables.js");	
	$iPage->addScript("js/jquery.js");
	$iPage->addScript("js/select2.js");
	$iPage->addScript("js/modal.js");
	$iPage->addScript("js/datepicker.js");
	$iPage->addScript("js/nlbFade.js");
	$iPage->endHeader();
	$iPage->startBody();
	
	outputHeader($tuser, $tcmp);
	outputMenu($tuser);	
	
	if(count($cclass->getItemList()) != 0)	$numOfRows1			=	count($cclass->getItemList());
	
?>	

	<div id="pagehead">&nbsp;CREATE NEW GRN</div>
	<div style="height:10px;"></div>
	
	<div style="width:980px;margin:0px auto">
	<form name="hfrm" id="hfrm" method="post" action="">
	<input type="hidden" name="pagen" value="process">
	<input type="hidden" name="numOfRows1" id="numOfRows1" value="<?php echo $numOfRows1?>">
	<table cellpadding="1" cellspacing="0" border="0" width="980px" align="center" bgcolor="#ffffff">
		<tr bgcolor="#D6E3F3"><td colspan="3" class="td_normal blue bold">
			<div id="dhead" style="float:left;width:900px;padding:5px;"><?php echo $msg?></div>
			<div style="float:right;padding:5px;"><a href="viewGRN.php"><img src="images/columns.gif" title="View GRN List" /></a></div>
		</td></tr>
		<tr style="height:1px"><td colspan="3" style="border-top:#99BBE8 1px solid;"></td></tr>
		<tr style="height:2px"><td colspan="3"></td></tr>	
				
		<tr>
			<td class="td_normal" width="170px;">&nbsp;GRN Date</td>
			<td class="td_normal" width="10px;">:</td>
			<td class="td_normal"><input data-toggle="datepicker" type="text" class="<?php echo $fcss[1]?>" name="GRNDate" id="GRNDate" value="<?php echo $cclass->getGRNDate('yes')?>" style="width:80px" maxLength="10" onFocus="this.className='input_focus'" onBlur="this.className='<?php echo $fcss[1]?>'" /></td>
		</tr>		
				
		<tr>
			<td class="td_normal">&nbsp;Supplier</td>
			<td class="td_normal">:</td>
			<td class="td_normal" id="_jsontd4">
				<select name="SupplierID" id="SupplierID" style="width:400px">
					<option value="0">--</option>
				<?php	
					for($i=0;$i<count($cusList);$i++) {
						$cb	= $cusList[$i];
						$tmp	= "";
						if($cclass->getSupplierID() == $cb[0]) $tmp = "selected";
				?>
						<option value="<?php echo $cb[0]?>" <?php echo $tmp?>><?php echo $cb[1]?></option>
				<?php } ?>
				</select>
			</td>
		</tr>
		
		<tr>
			<td class="td_normal">&nbsp;Store</td>
			<td class="td_normal">:</td>
			<td class="td_normal" id="_jsontd6">
				<select name="StoreID" id="StoreID" style="width:400px">
					<option value="0">--</option>
				<?php	
					for($i=0;$i<count($strList);$i++) {
						$cb	= $strList[$i];
						$tmp	= "";
						if($cclass->getStoreID() == $cb->getStoreID()) $tmp = "selected";
				?>
						<option value="<?php echo $cb->getStoreID()?>" <?php echo $tmp?>><?php echo $cb->getStoreName()?></option>
				<?php } ?>
				</select>
			</td>
		</tr>
		
		<tr>
			<td class="td_normal">&nbsp;Challan No.</td>
			<td class="td_normal">:</td>
			<td class="td_normal">
				<input type="text" class="input" name="ChallanNo" id="ChallanNo" value="<?php echo $cclass->getChallanNo('yes')?>" style="width:200px" maxLength="30" onFocus="this.className='input_focus'" onBlur="this.className='input'" />
				&nbsp;Challan Date
				<input data-toggle="datepicker" type="text" class="input" name="ChallanDate" id="ChallanDate" value="<?php echo $cclass->getChallanDate('yes')?>" style="width:80px" maxLength="10" onFocus="this.className='input_focus'" onBlur="this.className='input'" />
			</td>
		</tr>
		<tr style="height:4px"><td colspan="3"></td></tr>		
		
		<!---------- ITEMS STARTS HERE ---------->
		<tr>
			<td colspan="3">	
	
				<table style="border:0px;" cellpadding="0" cellspacing="0" width="100%">
					<tr>
						<th width="5%" style="border-left: 1px solid #99BBE8;">SN</th>
						<th width="35%">Item</th>
						<th width="10%">Unit</th>						
						<th width="15%">Quantity</th>
						<th width="15%">Amount</th>
						<th width="15%">Rate</th>
						<th width="5%" align="center">
							<input type="button" class="red_button" value="—" onClick="pdelRow()" />
						</th>
					</tr>
				</table>
			</td>
		</tr>
		
		<tr>
			<td colspan="3">
				<table style="border:0px;" cellpadding="0" cellspacing="1" width="100%" id="ptTable">
				
				<?php if(count($cclass->getItemList()) == 0) { ?>
				
					<tr>
						<td width="5%" style="padding:2px;">
							<input type="button" class="red_button" style="width:25px;" value="1" onClick="iclearItem(1)" id="msn1">
						</td>
						<td  width="35%" style="padding:2px;" id="_jsontd11" class="td_normal">
							<select name="ItemID1" id="ItemID1" style="width:320px">
								<option value="0">--</option>
							<?php	
								for($i=0;$i<count($itmList);$i++) {
									$cb	= $itmList[$i];
									$tmp	= "";
							?>
									<option value="<?php echo $cb->getItemID()?>" <?php echo $tmp?>><?php echo $cb->getItemName()?></option>
							<?php } ?>
							</select>
						</td>
						<td  width="10%" style="padding:2px;">
							<input type="text" class="input" name="Unit1" id="Unit1" value="" style="width:80px" readOnly="true" />
						</td>						
						<td width="15%" style="padding:2px;">
							<input type="text" class="input" name="Quantity1" id="Quantity1" value="" style="width:80px" maxLength="10" onFocus="this.className='input_focus'" onBlur="this.className='input'" onChange="calcTot()" />
						</td>
						<td width="15%" style="padding:2px;">
							<input type="text" class="input" name="Amount1" id="Amount1" value="" style="width:80px" maxLength="15" onFocus="this.className='input_focus'" onBlur="this.className='input'" onChange="calcTot()" />
						</td>
						<td  width="15%" style="padding:2px;" id="_jsontd41">
							<input type="text" class="input" name="Rate1" id="Rate1" value="" style="width:80px" maxLength="15" readOnly="true" />
						</td>
						<td width="5%" style="padding:2px;" align="center">
							<input type="button" class="red_button" id="pbtnAS1" value="+" onClick="paddRow()">
						</td>
					</tr>
				
				<?php } else { ?>
				<?php
					$pitm	=	$cclass->getItemList();
					for($i=0;$i<count($pitm);$i++){
						$icls	=	$pitm[$i];
				?>
				
					<tr>
						<td width="5%" style="padding:2px;">
							<input type="button" class="red_button" style="width:25px;" value="<?php echo ($i+1)?>" onClick="iclearItem(<?php echo ($i+1)?>)" id="msn<?php echo ($i+1)?>">
						</td>
						<td  width="35%" style="padding:2px;" class="td_normal">
							<select name="ItemID<?php echo ($i+1)?>" id="ItemID<?php echo ($i+1)?>" style="width:320px">
								<option value="0">--</option>
							<?php	
								for($ii=0;$ii<count($itmList);$ii++) {
									$cb	= $itmList[$ii];
									$tmp	= "";
									if($icls->getItemID() == $cb->getItemID()) $tmp = "selected";
							?>
									<option value="<?php echo $cb->getItemID()?>" <?php echo $tmp?>><?php echo $cb->getItemName()?></option>
							<?php } ?>
							</select>
						</td>
						<td  width="10%" style="padding:2px;" id="_jsontd5<?php echo ($i+1)?>">
							<input type="text" class="input" name="Unit<?php echo ($i+1)?>" id="Unit<?php echo ($i+1)?>" value="" style="width:80px" readOnly="true" />
						</td>						
						<td width="15%" style="padding:2px;">
							<input type="text" class="input" name="Quantity<?php echo ($i+1)?>" id="Quantity<?php echo ($i+1)?>" value="<?php echo $icls->getQuantity('no')?>" style="width:80px" maxLength="10" onFocus="this.className='input_focus'" onBlur="this.className='input'" onChange="calcTot()" />
						</td>
						<td width="15%" style="padding:2px;">
							<input type="text" class="input" name="Amount<?php echo ($i+1)?>" id="Amount<?php echo ($i+1)?>" value="<?php echo $icls->getAmount('no')?>" style="width:80px" maxLength="15" onFocus="this.className='input_focus'" onBlur="this.className='input'" onChange="calcTot()" />
						</td>
						<td  width="15%" style="padding:2px;" id="_jsontd4<?php echo ($i+1)?>">
							<input type="text" class="input" name="Rate<?php echo ($i+1)?>" id="Rate<?php echo ($i+1)?>" value="<?php echo $icls->getRate('no')?>" style="width:80px" maxLength="15" readOnly="true" />
						</td>
						<td width="5%" style="padding:2px;" align="center">
							<input type="button" class="red_button" id="pbtnAS<?php echo ($i+1)?>" value="+" onClick="paddRow()">
						</td>
					</tr>
				
				<?php } } ?>
				
				</table>
			</td>
		</tr>
		
		<tr style="height:4px"><td colspan="3" style="border-bottom:#e6b800 1px solid;"></td></tr>
		<tr bgcolor="#F5F579">
			<td colspan="3">
				<table style="border:0px;" cellpadding="0" cellspacing="0" width="100%">
					<tr bgcolor="#F5F579">
						<td width="65%" style="padding:2px;" class="td_normal">
							&nbsp;Item Total
						</td>
						<td width="15%" style="padding:2px;" align="left">
							<input type="text" class="input" value="<?php echo $cclass->getItemTotal()?>" name="ItemTotal" id="ItemTotal" maxLength="12" style="width:80px" readOnly="true">
						</td>
						<td width="20%" style="padding:2px;" align="right" colspan="2">
							&nbsp;
						</td>
					</tr>
				</table>
			</td>
		</tr>
		<tr style="height:4px"><td colspan="3" style="border-top:#e6b800 1px solid;"></td></tr>
		<!---------- ITEM ENDS HERE ---------->	
						
						
		<tr style="height:1px"><td colspan="3" style="border-bottom:#99BBE8 1px solid;"></td></tr>
		<tr bgcolor="#D6E3F3">
			<td colspan="3" align="center">
				<input type="button" id="btnS" class="red_button" value=" Create (S) " AccessKey="S" onClick="saveRec()" />
			</td>
		</tr>
	</table>
	</form>
	</div>
	
	<br />
	
<?php
	$iPage->endBody();
	$iPage->endPage();
?>	
		
<script language="javaScript">

	var numRows1	= "<?php echo $numOfRows1?>";
	var itmList		= new Array();
	
	<?php	for($i=0;$i<count($itmList);$i++) { ?>
	<?php		$ab	= $itmList[$i]; ?>
			itmList[<?php echo $i?>] 			= new Array();
			itmList[<?php echo $i?>][0] 	= "<?php echo $ab->getItemID()?>";
			itmList[<?php echo $i?>][1] 	= "<?php echo formatJScriptString($ab->getItemName())?>";
	<?php } ?>	

	$(function () {
		NLBfadeBg('dhead','#ffff00','#D6E3F3','3000');
		
		$("#SupplierID").select2();
		$("#StoreID").select2();
		
		for(var i=1; i<=numRows1; i++) {
			$("#ItemID" + i).select2({dropdownCssClass : 'drop400'});
			
			$("#ItemID" + i).on("change", function (e) {
      	var nm		= $(this).attr('name');
      	var param	= nm.substring(6);
      	fetchUnit(param);
			});			
		}		
		
	});	

	$('[data-toggle="datepicker"]').datepicker({
		format: 'dd-mm-yyyy',
		autoHide: 'yes'
	});								
				
		
	function calcTot() {
		
		var tot	= 0;
		
		for(i=1;i<=numRows1;i++) {
		
			if(EBD('Rate' + i).value == "") EBD('Rate' + i).value						=	"0";
			if(isNaN(EBD('Rate' + i).value)) EBD('Rate' + i).value					=	"0";
			if(EBD('Quantity' + i).value == "") EBD('Quantity' + i).value		=	"0";
			if(isNaN(EBD('Quantity' + i).value)) EBD('Quantity' + i).value	=	"0";
			
			var qty		=	parseFloat(EBD('Quantity' + i).value);
			var amt		=	parseFloat(EBD('Amount' + i).value);
			var prc		= 0;
			if(qty > 0)
				prc		= amt / qty;
			EBD('Rate' + i).value	= prc;
			
			tot				= tot + amt;
		}
		
		EBD('ItemTotal').value	= setMoneyFormat(tot);
				
	}	
	
	function iclearItem(param) {
		if(confirm('Click OK to proceed with Item removal, please click Save/Update button to make final changes') == false) return;
		
		EBD('txtItemID' + param).value	=	"";
		EBD('ItemID' + param).value			=	"";
		EBD('Amount' + param).value			=	"";
		EBD('Quantity' + param).value		=	"";
		EBD('Rate' + param).value				=	"";
	}	
	
	function paddRow()	{
		var rTable	= EBD("ptTable");
		var iRow		= rTable.insertRow(numRows1);
		
		numRows1++;
		var iCell;
		
		iCell								= iRow.insertCell(0);
		iCell.style.padding	=	"2px";
		iCell.innerHTML			= '<input type="button" class="red_button" style="width:25px;" value="' + numRows1 + '" onClick="iclearItem(' + numRows1 + ')" id="msn' + numRows1 + '">';

		iCell								= iRow.insertCell(1);
		iCell.style.padding	=	"2px";
		iCell.className			= "td_normal";
		iCell.id						=	"_jsontd1"+numRows1;
		iCell.innerHTML			= '<select name="ItemID' + numRows1 + '" id="ItemID' + numRows1 + '" style="width:320px;"></select>';
		
		iCell								= iRow.insertCell(2);
		iCell.style.padding	=	"2px";
		iCell.innerHTML			= '<input type="text" class="input" name="Unit' + numRows1 + '" id="Unit' + numRows1 + '" value="" style="width:80px" readOnly="true" />';		

		iCell								= iRow.insertCell(3);
		iCell.style.padding	=	"2px";
		iCell.innerHTML			= '<input type="text" class="input" name="Quantity' + numRows1 + '" id="Quantity' + numRows1 + '" value="" style="width:80px" maxLength="10" onFocus="this.className=\'input_focus\'" onBlur="this.className=\'input\'" onChange="calcTot()" />';

		iCell								= iRow.insertCell(4);
		iCell.style.padding	=	"2px";
		iCell.innerHTML			= '<input type="text" class="input" name="Amount' + numRows1 + '" id="Amount' + numRows1 + '" value="" style="width:80px" maxLength="15" onFocus="this.className=\'input_focus\'" onBlur="this.className=\'input\'" onChange="calcTot()" />';

		iCell								= iRow.insertCell(5);
		iCell.style.padding	=	"2px";
		iCell.innerHTML			= '<input type="text" class="input" name="Rate' + numRows1 + '" id="Rate' + numRows1 + '" value="" style="width:80px" maxLength="15" readOnly="true" />';

		iCell 							= iRow.insertCell(6);
		iCell.align					= "center";
		iCell.style.padding	=	"2px";
		iCell.innerHTML			= '<input type="button" class="red_button" id="pbtnAS' + numRows1 + '" value="+" onClick="paddRow()">';

		$("#ItemID" + numRows1).select2({dropdownCssClass : 'drop400'});	
		$('#ItemID' + numRows1).append('<option value="0">--</option>');	
		
		for(var ii=0;ii<itmList.length;ii++){
			$('#ItemID' + numRows1).append('<option value="' + itmList[ii][0] + '">' + itmList[ii][1] + '</option>');
		}
		
		$("#ItemID" + numRows1).on("change", function (e) {
      var nm		= $(this).attr('name');
      var param	= nm.substring(6);
      fetchUnit(param);
		});
	}

	function pdelRow()	{
		if(numRows1 > 1)	{
			var rTable	= EBD("ptTable");
			var iRow		= rTable.deleteRow(numRows1 - 1);
			numRows1--;
		}
		
		calcTot();
	}
	
	function saveRec() {
		
		if(checkForValidInput('GRNDate','Date','Please enter GRN Date') == false) return;
		if(EBD('SupplierID').value == 0) {
			alert('Please select Supplier');
			EBD('SupplierID').focus();
			return;
		}

		var chk	= 0;
		for(i=1;i<=numRows1;i++) {
			if(checkForValidInput('Quantity'+i,'NonNegative','Quantity cannot be Negative, can enter Zero') == false) return;
			if(checkForValidInput('Amount'+i,'NonNegative','Amount cannot be Negative, zero allowed') == false) return;
		}	

		EBD("numOfRows1").value	= numRows1;	

		if(confirm("SURE!!! SAVE GRN RECORD") == false) return;

		var fm	= EBD('hfrm');
		fm.submit();
	}
	
	function fetchUnit(param) {
	
		var iid										= EBD('ItemID' + param).value;
		
		EBD('Unit' + param).value =	'';
	
		var x = (window.ActiveXObject) ? new ActiveXObject("Microsoft.XMLHTTP") : new XMLHttpRequest();
		if (x) {
			x.onreadystatechange = function() {
				if (x.readyState == 4 && x.status == 200) {
					var fr	= x.responseText;
					if(fr != "-1") {
						EBD('Unit' + param).value = fr;
					}
				}
			}
			x.open("GET", "ajax/getItemUnit.php?iid=" + iid, true);
			x.send(null);
		}		
	}					

</script>