<?php

	/* Include the required files */
	require_once( 'checkLogin.php' );
	require_once( 'dao/asys.account.php' );
	require_once( 'dao/asys.store.php' );
	require_once( 'dao/asys.voucher.php' );
	require_once( 'dao/asys.stockvoucher.php' );
	require_once( 'dao/class.gen_items.php' );
	require_once( 'dao/class.gen_stockjournal.php' );
	require_once( 'dao/class.gen_stockjournal_in.php' );
	require_once( 'dao/class.gen_stockjournal_out.php' );
	require_once( 'dao/class.purchasedb.php' );
	
	
	$ModuleID			= 24;	

	$gdb					=	new genericdb();
	$mdb					=	new masterdb();
	$ldb					= new logindb();
	$pdb					= new purchasedb();
	$cclass				= new gen_stockjournal();
	$itmList			= $mdb->getItemList('', 0, $tcmp->getCompanyID());
	$strList			= $mdb->getStoreList($tcmp->getCompanyID());
	
	if($ldb->getCreatePermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:accessDenied.php");
		exit;
	}	
							
			
	$StockJournalID	=	"";
	$DOT	=	"";
	$StoreID	=	"";
	$ItemCategoryID	=	"";


	$rmsg				=	"";
	$msg				=	"Please enter all the fields correctly.";
	$pagen			=	"";
	$numOfRows1	= 1;

	$fcss				=	 array();
	for($i=0;$i<8;$i++)
		$fcss[$i]	=	"input";

	extract($_REQUEST);
	
	if($pagen == "process") {
		/* Check for valid input */

		if(FormatIndianDateToSQLDate($DOT) == "1900-01-01") {
			$fcss[1]	=	"err_input";
			if($rmsg != "") $rmsg = $rmsg.",";
			$rmsg	=	$rmsg."Invalid Journal Date";
		}
		
		if((int)$StoreID <= 0) {
			$fcss[5]	=	"err_input";
			if($rmsg != "") $rmsg = $rmsg.",";
			$rmsg	=	$rmsg." Store";
		}
		
		if((int)$_REQUEST["ItemIDi1"] <= 0) {
			if($rmsg != "") $rmsg = $rmsg.",";
			$rmsg	=	$rmsg." In (Final) Item not selected";		
		}
		
		if((int)$_REQUEST["Quantityi1"] <= 0) {
			if($rmsg != "") $rmsg = $rmsg.",";
			$rmsg	=	$rmsg." In Quantity not entered";		
		}
		
		$tdf						= $tcmp->getTxnDateFrom();
		$tdt						= $tcmp->getTxnDateTo();
		$txnDate				= FormatIndianDateToSQLDate($DOT);
		if($txnDate < $tdf || $txnDate > $tdt) {
			if($rmsg != "") $rmsg	=	$rmsg.", ";
			$rmsg			=	$rmsg."Transaction date outside allowed date range";			
		}		
		
		$outList	=	array();
		$inList		= array();
		for($i=1;$i<=$numOfRows1;$i++){
			$icls	=	new gen_stockjournal_out();
			if((int)$_REQUEST["ItemID$i"] > 0 && (double)$_REQUEST["Quantity$i"] > 0) {
			
				$iid	= (int)$_REQUEST["ItemID$i"];
			
				$icls->setStockJournalID(0);
				$icls->setItemID($_REQUEST["ItemID$i"]);
				$icls->setQuantity($_REQUEST["Quantity$i"]);
				$icls->setRate(0);	
			
				$outList[]	=	$icls;
			}
		}
		$cclass->setOUTItemList($outList);
		
		if(count($outList) == 0) {
			if($rmsg != "") $rmsg = $rmsg.",";
			$rmsg	=	$rmsg."No Item selected";		
		}
		
		
		$iicls	=	new gen_stockjournal_in();
		
		$iicls->setStockJournalID(0);
		$iicls->setItemID($_REQUEST["ItemIDi1"]);
		$iicls->setQuantity($_REQUEST["Quantityi1"]);
		$iicls->setRate(0);		
		
		$inList[]	=	$iicls;
		
		$cclass->setINItemList($inList);
		
		$cclass->setCompanyID($tcmp->getCompanyID());
		$cclass->setDOT($DOT);
		$cclass->setStoreID($StoreID);
		$cclass->setItemCategoryID($ItemCategoryID);
	

		if($rmsg == "") {
			if($pdb->CreateStockJournal($cclass) > 0) {
				$msg	=	"<font class='blue'>Stock Journal created successfully</font>";
				$log	=	new asys_user_log();
				$log->setLogID($gdb->getNextID("asys_user_log", "LogID"));
				$log->setUserID($tuser->getUserID());
				$log->setCompanyID($tcmp->getCompanyID());
				$log->setModuleID($ModuleID);
				$log->setRelatedID($cclass->getStockJournalID());				
				$log->setActivity("Added new Stock Journal - ".$cclass->getStockJournalID());
				$log->setClassName('gen_stockjournal');
				$log->setModuleSnapshot(serialize($cclass));
				$gdb->SaveObjectToDB($log);	
				
				$cclass				= new gen_stockjournal();	
				$numOfRows1		= 1;	
			} else {
				$msg	=	"<font class='red'>Journal ID/Name already exist, try with a different ID/Name</font>";
			}
		} else {
			$msg	=	"<font class='red'>The following fields are mandatory: ".$rmsg."</font>";
		}
	}

	
	/* Ready to create the page */
	$iPage	=	new asys_pages(APP_TITLE);
	/* Start writting the page */
	$iPage->startPage();
	$iPage->startHeader();
	/* Add links and Scripts as required */
	$iPage->addLink("css/asys.css");
	$iPage->addLink("css/menu.css");
	$iPage->addLink("css/superTables.css");
	$iPage->addLink("css/select2.css");
	$iPage->addLink("css/modal.css");
	$iPage->addLink("css/datepicker.css");
	$iPage->addScript("js/common.js");
	$iPage->addScript("js/superTables.js");	
	$iPage->addScript("js/jquery.js");
	$iPage->addScript("js/select2.js");
	$iPage->addScript("js/modal.js");
	$iPage->addScript("js/datepicker.js");
	$iPage->addScript("js/nlbFade.js");
	$iPage->endHeader();
	$iPage->startBody();
	
	outputHeader($tuser, $tcmp);
	outputMenu($tuser);	
	
	if(count($cclass->getOUTItemList()) != 0)	$numOfRows1			=	count($cclass->getOUTItemList());
	
?>	

	<div id="pagehead">&nbsp;CREATE NEW STOCK JOURNAL (Conversion of Item)</div>
	<div style="height:10px;"></div>
	
	<div style="width:980px;margin:0px auto">
	<form name="hfrm" id="hfrm" method="post" action="">
	<input type="hidden" name="pagen" value="process" />
	<input type="hidden" name="numOfRows1" id="numOfRows1" value="<?php echo $numOfRows1?>" />
	<table cellpadding="1" cellspacing="0" border="0" width="980px" align="center" bgcolor="#ffffff">
		<tr bgcolor="#D6E3F3"><td colspan="3" class="td_normal blue bold">
			<div id="dhead" style="float:left;width:900px;padding:5px;"><?php echo $msg?></div>
			<div style="float:right;padding:5px;"><a href="viewStockJournal.php"><img src="images/columns.gif" title="View Stock Journal List" /></a></div>
		</td></tr>
		<tr style="height:1px" bgcolor="#99BBE8"><td colspan="3"></td></tr>
		<tr style="height:2px"><td colspan="3"></td></tr>	
				
		<tr>
			<td class="td_normal">&nbsp;Journal Date</td>
			<td class="td_normal">:</td>
			<td class="td_normal"><input data-toggle="datepicker" type="text" class="<?php echo $fcss[1]?>" name="DOT" id="DOT" value="<?php echo $cclass->getDOT('yes')?>" style="width:80px" maxLength="10" onFocus="this.className='input_focus'" onBlur="this.className='<?php echo $fcss[1]?>'" /></td>
		</tr>	
				
		<tr>
			<td class="td_normal">&nbsp;Store </td>
			<td class="td_normal">:</td>
			<td class="td_normal" id="_jsontd2">
				<select name="StoreID" id="StoreID" style="width:400px">
					<option value="0">--</option>
				<?php	
					for($i=0;$i<count($strList);$i++) {
						$cb	= $strList[$i];
						$tmp	= "";
						if($cclass->getStoreID() == $cb->getStoreID()) $tmp = "selected";
				?>
						<option value="<?php echo $cb->getStoreID()?>" <?php echo $tmp?>><?php echo $cb->getStoreName()?></option>
				<?php } ?>
				</select>
			</td>
		</tr>	
		
		<tr>
			<td class="td_normal" colspan="3">
				<br />
				&nbsp;System supports <b>One-to-One</b> and <b>Many-to-One</b> Item conversion in the same Store.
				<br />
				&nbsp;Select <b>STOCK OUT</b> items below.
			</td>
		</tr>	
		<tr style="height:2px"><td colspan="3"></td></tr>						
		
		<!---------- OUT ITEMS STARTS HERE ---------->
		<tr>
			<td colspan="3">	
	
				<table style="border:0px;" cellpadding="0" cellspacing="0" width="100%">
					<tr>
						<th width="5%" style="border-left: 1px solid #99BBE8;">SN</th>
						<th width="45%">Item</th>
						<th width="15%">Unit</th>						
						<th width="15%">Quantity</th>
						<th width="15%">Closing</th>
						<th width="5%" align="center">
							<input type="button" class="red_button" value="—" onClick="pdelRow()" />
						</th>
					</tr>
				</table>
			</td>
		</tr>
		
		<tr>
			<td colspan="3">
				<table style="border:0px;" cellpadding="0" cellspacing="1" width="100%" id="ptTable">
				
				<?php if(count($cclass->getOUTItemList()) == 0) { ?>
				
					<tr>
						<td width="5%" style="padding:2px;">
							<input type="button" class="red_button" style="width:25px;" value="1" onClick="iclearItem(1)" id="msn1" />
						</td>
						<td  width="45%" style="padding:2px;" id="_jsontd11" class="td_normal">
							<select name="ItemID1" id="ItemID1" style="width:420px">
								<option value="0">--</option>
							<?php	
								for($ii=0;$ii<count($itmList);$ii++) {
									$cb	= $itmList[$ii];
									$tmp	= "";
							?>
									<option value="<?php echo $cb->getItemID()?>" <?php echo $tmp?>><?php echo $cb->getItemName()?></option>
							<?php } ?>
							</select>
						</td>
						<td width="15%" style="padding:2px;">
							<input type="text" class="input" name="Unit1" id="Unit1" value="" style="width:80px" readOnly="true" />
						</td>						
						<td width="15%" style="padding:2px;">
							<input type="text" class="input" name="Quantity1" id="Quantity1" value="" style="width:80px" maxLength="10" onFocus="this.className='input_focus'" onBlur="this.className='input'" />
						</td>
						<td width="15%" style="padding:2px;">
							<input type="text" class="input" name="CBal1" id="CBal1" value="" style="width:80px" maxLength="15" readOnly="true" />
						</td>
						<td width="5%" style="padding:2px;" align="center">
							<input type="button" class="red_button" id="pbtnAS1" value="+" onClick="paddRow()" />
						</td>
					</tr>
				
				<?php } else { ?>
				<?php
					$pitm	=	$cclass->getOUTItemList();
					for($i=0;$i<count($pitm);$i++){
						$icls	=	$pitm[$i];
				?>
				
					<tr>
						<td width="5%" style="padding:2px;">
							<input type="button" class="red_button" style="width:25px;" value="<?php echo ($i+1)?>" onClick="iclearItem(<?php echo ($i+1)?>)" id="msn<?php echo ($i+1)?>" />
						</td>
						<td  width="45%" style="padding:2px;" id="_jsontd1<?php echo ($i+1)?>" class="td_normal">
							<select name="ItemID<?php echo ($i+1)?>" id="ItemID<?php echo ($i+1)?>" style="width:420px">
								<option value="0">--</option>
							<?php	
								for($ii=0;$ii<count($itmList);$ii++) {
									$cb	= $itmList[$ii];
									$tmp	= "";
									if($icls->getItemID() == $cb->getItemID()) $tmp = "selected";
							?>
									<option value="<?php echo $cb->getItemID()?>" <?php echo $tmp?>><?php echo $cb->getItemName()?></option>
							<?php } ?>
							</select>
						</td>
						<td width="15%" style="padding:2px;" id="_jsontd5<?php echo ($i+1)?>">
							<input type="text" class="input" name="Unit<?php echo ($i+1)?>" id="Unit<?php echo ($i+1)?>" value="" style="width:80px" readOnly="true" />
						</td>						
						<td width="15%" style="padding:2px;">
							<input type="text" class="input" name="Quantity<?php echo ($i+1)?>" id="Quantity<?php echo ($i+1)?>" value="<?php echo $icls->getQuantity('no')?>" style="width:80px" maxLength="10" onFocus="this.className='input_focus'" onBlur="this.className='input'" />
						</td>
						<td width="15%" style="padding:2px;">
							<input type="text" class="input" name="CBal<?php echo ($i+1)?>" id="CBal<?php echo ($i+1)?>" value="<?php echo $icls->getRate('no')?>" style="width:80px" maxLength="15" readOnly="true" />
						</td>
						<td width="5%" style="padding:2px;" align="center">
							<input type="button" class="red_button" id="pbtnAS<?php echo ($i+1)?>" value="+" onClick="paddRow()" />
						</td>
					</tr>
				
				<?php } } ?>
				
				</table>
			</td>
		</tr>
	
		<!---------- OUT ITEM ENDS HERE ---------->
		
		
		<tr>
			<td class="td_normal" colspan="3">
				<br />&nbsp;Select <b>STOCK IN (FINAL)</b> item below.
			</td>
		</tr>			
		<tr style="height:2px"><td colspan="3"></td></tr>
		
		<!---------- IN ITEMS STARTS HERE ---------->
		<tr>
			<td colspan="3">	
	
				<table style="border:0px;" cellpadding="0" cellspacing="0" width="100%">
					<tr>
						<th width="5%" style="border-left: 1px solid #99BBE8;">SN</th>
						<th width="45%">Item</th>
						<th width="15%">Unit</th>						
						<th width="15%">Quantity</th>
						<th width="15%">Closing</th>
						<th width="5%" align="center"></th>
					</tr>
				</table>
			</td>
		</tr>
		
		<tr>
			<td colspan="3">
				<table border="0" cellpadding="0" cellspacing="1" width="100%">
				
				<?php if(count($cclass->getINItemList()) == 0) { ?>
				
					<tr>
						<td width="5%" style="padding:2px;">
							<input type="button" class="red_button" style="width:25px;" value="1" id="msni1" />
						</td>
						<td  width="45%" style="padding:2px;" id="_jsontdi11" class="td_normal">
							<select name="ItemIDi1" id="ItemIDi1" style="width:420px">
								<option value="0">--</option>
							<?php	
								for($ii=0;$ii<count($itmList);$ii++) {
									$cb	= $itmList[$ii];
									$tmp	= "";
							?>
									<option value="<?php echo $cb->getItemID()?>" <?php echo $tmp?>><?php echo $cb->getItemName()?></option>
							<?php } ?>
							</select>
						</td>
						<td width="15%" style="padding:2px;">
							<input type="text" class="input" name="Uniti1" id="Uniti1" value="" style="width:80px" readOnly="true" />
						</td>						
						<td width="15%" style="padding:2px;">
							<input type="text" class="input" name="Quantityi1" id="Quantityi1" value="" style="width:80px" maxLength="10" onFocus="this.className='input_focus'" onBlur="this.className='input'" />
						</td>
						<td width="15%" style="padding:2px;">
							<input type="text" class="input" name="CBali1" id="CBali1" value="" style="width:80px" maxLength="15" readOnly="true" />
						</td>
						<td width="5%" style="padding:2px;" align="right">
							&nbsp;
						</td>
					</tr>
				
				<?php } else { ?>
				<?php
					$pitm	=	$cclass->getINItemList();
					for($i=0;$i<count($pitm);$i++){
						$icls	=	$pitm[$i];
				?>
				
					<tr>
						<td width="5%" style="padding:2px;">
							<input type="button" class="red_button" style="width:25px;" value="<?php echo ($i+1)?>" id="msni<?php echo ($i+1)?>" />
						</td>
						<td  width="45%" style="padding:2px;" id="_jsontdi1<?php echo ($i+1)?>" class="td_normal">
							<select name="ItemIDi<?php echo ($i+1)?>" id="ItemIDi<?php echo ($i+1)?>" style="width:420px">
								<option value="0">--</option>
							<?php	
								for($ii=0;$ii<count($itmList);$ii++) {
									$cb	= $itmList[$ii];
									$tmp	= "";
									if($icls->getItemID() == $cb->getItemID()) $tmp = "selected";
							?>
									<option value="<?php echo $cb->getItemID()?>" <?php echo $tmp?>><?php echo $cb->getItemName()?></option>
							<?php } ?>
							</select>
						</td>
						<td width="15%" style="padding:2px;">
							<input type="text" class="input" name="Uniti<?php echo ($i+1)?>" id="Uniti<?php echo ($i+1)?>" value="" style="width:80px" readOnly="true" />
						</td>						
						<td width="15%" style="padding:2px;">
							<input type="text" class="input" name="Quantityi<?php echo ($i+1)?>" id="Quantityi<?php echo ($i+1)?>" value="<?php echo $icls->getQuantity('no')?>" style="width:80px" maxLength="10" onFocus="this.className='input_focus'" onBlur="this.className='input'" />
						</td>
						<td width="15%" style="padding:2px;">
							<input type="text" class="input" name="CBali<?php echo ($i+1)?>" id="CBali<?php echo ($i+1)?>" value="<?php echo $icls->getRate('no')?>" style="width:80px" maxLength="15" readOnly="true" />
						</td>
						<td width="5%" style="padding:2px;" align="right">
							&nbsp;
						</td>
					</tr>
				
				<?php } } ?>
				
				</table>
			</td>
		</tr>
	
		<!---------- IN ITEM ENDS HERE ---------->		
						
						
		<tr style="height:1px" bgcolor="#99BBE8"><td colspan="3"></td></tr>
		<tr bgcolor="#D6E3F3">
			<td colspan="3" align="center">
				<input type="button" id="btnS" class="red_button" value=" Create (S) " AccessKey="S" onClick="saveRec()" />
			</td>
		</tr>
	</table>
	</form>
	</div>
	
	<br /><br />
	
<?php
	$iPage->endBody();
	$iPage->endPage();
?>	
		
<script language="javaScript">

	var itmList		= new Array();

	<?php	for($i=0;$i<count($itmList);$i++) { ?>
	<?php		$ab	= $itmList[$i]; ?>
			itmList[<?php echo $i?>] 			= new Array();
			itmList[<?php echo $i?>][0] 	= "<?php echo $ab->getItemID()?>";
			itmList[<?php echo $i?>][1] 	= "<?php echo formatJScriptString($ab->getItemName())?>";
	<?php } ?>

	var numRows1	= "<?php echo $numOfRows1?>";

	$(function () {
		NLBfadeBg('dhead','#ffff00','#D6E3F3','3000');
		
		$("#StoreID").select2();
		$("#ItemIDi1").select2();
		$("#ItemIDi1").on("change", function (e) {
			var nm		= $(this).attr('name');
			var param	= nm.substring(6);
			fetchUniti(1);
		});		
		
		for(var i=1; i<=numRows1; i++) {
			$("#ItemID" + i).select2();
			
			$("#ItemID" + i).on("change", function (e) {
      	var nm		= $(this).attr('name');
      	var param	= nm.substring(6);
      	fetchUnit(param);
			});			
		}		
		
	});	

	$('[data-toggle="datepicker"]').datepicker({
		format: 'dd-mm-yyyy',
		autoHide: 'yes'
	});
	
	function iclearItem(param) {
		if(confirm('Click OK to proceed with Item removal, please click Save/Update button to make final changes') == false) return;
		
		EBD('txtItemID' + param).value	=	"";
		EBD('ItemID' + param).value			=	"";
		EBD('Quantity' + param).value		=	"";
		EBD('CBal' + param).value				=	"";
	}	
	
	function paddRow()	{
		var rTable	= EBD("ptTable");
		var iRow		= rTable.insertRow(numRows1);
		
		numRows1++;
		var iCell;
		
		iCell								= iRow.insertCell(0);
		iCell.style.padding	=	"2px";
		iCell.innerHTML			= '<input type="button" class="red_button" style="width:25px;" value="' + numRows1 + '" onClick="iclearItem(' + numRows1 + ')" id="msn' + numRows1 + '">';

		iCell								= iRow.insertCell(1);
		iCell.style.padding	=	"2px";
		iCell.className			= "td_normal";
		iCell.id						=	"_jsontd1"+numRows1;
		iCell.innerHTML			= '<select name="ItemID' + numRows1 + '" id="ItemID' + numRows1 + '" style="width:420px;"></select>';
		
		iCell								= iRow.insertCell(2);
		iCell.style.padding	=	"2px";
		iCell.innerHTML			= '<input type="text" class="input" name="Unit' + numRows1 + '" id="Unit' + numRows1 + '" value="" style="width:80px" readOnly="true" />';		

		iCell								= iRow.insertCell(3);
		iCell.style.padding	=	"2px";
		iCell.innerHTML			= '<input type="text" class="input" name="Quantity' + numRows1 + '" id="Quantity' + numRows1 + '" value="" style="width:80px" maxLength="10" onFocus="this.className=\'input_focus\'" onBlur="this.className=\'input\'" />';

		iCell								= iRow.insertCell(4);
		iCell.style.padding	=	"2px";
		iCell.innerHTML			= '<input type="text" class="input" name="CBal' + numRows1 + '" id="CBal' + numRows1 + '" value="" style="width:80px" maxLength="15" readOnly="true" />';

		iCell 							= iRow.insertCell(5);
		iCell.align					= "center";
		iCell.style.padding	=	"2px";
		iCell.innerHTML			= '<input type="button" class="red_button" id="pbtnAS' + numRows1 + '" value="+" onClick="paddRow()">';

		$("#ItemID" + numRows1).select2();	
		$('#ItemID' + numRows1).append('<option value="0">--</option>');	
		
		for(var ii=0;ii<itmList.length;ii++){
			$('#ItemID' + numRows1).append('<option value="' + itmList[ii][0] + '">' + itmList[ii][1] + '</option>');
		}
		
		$("#ItemID" + numRows1).on("change", function (e) {
      var nm		= $(this).attr('name');
      var param	= nm.substring(6);
      fetchUnit(param);
		});
	}

	function pdelRow()	{
		if(numRows1 > 1)	{
			var rTable	= EBD("ptTable");
			var iRow		= rTable.deleteRow(numRows1 - 1);
			numRows1--;
		}
	}
	
	function saveRec() {
		
		if(checkForValidInput('DOT','Date','Please enter GRN Date') == false) return;

		var chk	= 0;
		for(i=1;i<=numRows1;i++) {
			if(checkForValidInput('Quantity'+i,'NonNegative','Quantity cannot be Negative, can enter Zero') == false) return;
			
			var qty 	= 0;
			var cbal	= 0;
			if(EBD('Quantity' + i).value != '') {
				try {
					qty			= parseFloat(EBD('Quantity' + i).value);
				} catch(e) { }
			}
			if(EBD('CBal' + i).value != "") {
				try {
					cbal			= parseFloat(EBD('CBal' + i).value);
				} catch(e) { }
			}

			if(qty > cbal) {
				alert('This will make stock quantity negative');
				EBD('Quantity' + i).focus();
				return;
			}
		}

		EBD("numOfRows1").value	= numRows1;	

		if(confirm("SURE!!! SAVE STOCK JOURNAL RECORD") == false) return;

		var fm	= EBD('hfrm');
		fm.submit();
	}
	
	function fetchUnit(param) {
	
		var iid										= EBD('ItemID' + param).value;
		var sid										= EBD('StoreID').value;
		var dt										= EBD('DOT').value;
		
		EBD('Unit' + param).value =	'';
		EBD('CBal' + param).value =	'';
	
		var x = (window.ActiveXObject) ? new ActiveXObject("Microsoft.XMLHTTP") : new XMLHttpRequest();
		if (x) {
			x.onreadystatechange = function() {
				if (x.readyState == 4 && x.status == 200) {
					var fr	= x.responseText;
					if(fr != "-1") {
						EBD('Unit' + param).value = fr;
					}
				}
			}
			x.open("GET", "ajax/getItemUnit.php?iid=" + iid, true);
			x.send(null);
		}
		
		var y = (window.ActiveXObject) ? new ActiveXObject("Microsoft.XMLHTTP") : new XMLHttpRequest();
		if (y) {
			y.onreadystatechange = function() {
				if (y.readyState == 4 && y.status == 200) {
					var fr	= y.responseText;
					if(fr != "-1") {
						EBD('CBal' + param).value = fr;
					}
				}
			}
			y.open("GET", "ajax/getItemClosingBalance.php?sid=" + sid + "&iid=" + iid + "&dt=" + dt, true);
			y.send(null);
		}				
	}		
	
	function fetchUniti() {
	
		var iid										= EBD('ItemIDi1').value;
		var sid										= EBD('StoreID').value;
		
		EBD('Uniti1').value =	'';
		EBD('CBali1').value =	'';
	
		var x = (window.ActiveXObject) ? new ActiveXObject("Microsoft.XMLHTTP") : new XMLHttpRequest();
		if (x) {
			x.onreadystatechange = function() {
				if (x.readyState == 4 && x.status == 200) {
					var fr	= x.responseText;
					if(fr != "-1") {
						EBD('Uniti1').value = fr;
					}
				}
			}
			x.open("GET", "ajax/getItemUnit.php?iid=" + iid, true);
			x.send(null);
		}
		
		var y = (window.ActiveXObject) ? new ActiveXObject("Microsoft.XMLHTTP") : new XMLHttpRequest();
		if (y) {
			y.onreadystatechange = function() {
				if (y.readyState == 4 && y.status == 200) {
					var fr	= y.responseText;
					if(fr != "-1") {
						EBD('CBali1').value = fr;
					}
				}
			}
			y.open("GET", "ajax/getItemClosingBalance.php?sid=" + sid + "&iid=" + iid, true);
			y.send(null);
		}				
	}				

</script>