<?php

	/* Include the required files */
	require_once( '../inc/functions.php' );
	require_once( '../aom-config.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/asys.voucherdb.php' );
	require_once( '../dao/asys.drcr.php' );
	require_once( '../dao/asys.group.php' );
	require_once( '../dao/asys.voucher.php' );
	require_once( '../dao/asys.vouchertag.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 34;

	$db			=	new masterdb("REPORT");
	$vdb		=	new voucherdb("REPORT");
	$ldb		= new logindb("REPORT");
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}		

	$aid		= 0;
	$fdate	=	getFirstFinancialDate();

	extract($_REQUEST);

	$aid		=	(int)$aid;
	$df			= FormatIndianDateToSQLDate($fdate);
	$ndt		= getNextDate($df);

	if($aid == 0) {
		echo "Sorry!!! Direct Access not allowed here, please select Cash Account";
		exit;
	}

	$accDet		= $db->getAccountDetail($aid);
	$bal			= $accDet->getOBal();
	$balt			= $accDet->getOBalType();

	$clbal		=	$db->getClosingBalanceByAccountID($aid, $ndt, "YES");
	$bal			=	$clbal[0];
	$balt			=	$clbal[1];
	
	$bpvList	= $vdb->getUnclearedBPVList($df, $tcmp->getCompanyID(), $aid);
	$brvList	= $vdb->getUnclearedBRVList($df, $tcmp->getCompanyID(), $aid);
	
	$totUBP		= 0;
	$totUBR		= 0;
	$balc			= 0;
	$cbalt		= 0;

?>


<!DOCTYPE html>
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html;charset=utf-8"/>
		<title>Bank Reconciliation Statement</title>
		<link href="../css/rpt.css" type="text/css" rel="stylesheet">
		<script src="../js/common.js"></script>
	</head>
<body style="background-color:#ffffff">
	<div style="font-family:verdana;width:900px;margin:0px auto;" align="center">
		<div style="font-size:10px;">
			<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC" id="main_table">
			
				<tr bgcolor="#FFFFFF">
					<td colspan="5" align="center">
						<div style="font-size:18px; letter-spacing:1pt;">
							<b><?php echo $tcmp->getCompanyName()?><br /></b>
						</div>
						<div style="font-size:15px; letter-spacing:1pt;">
							<?php echo nl2br($tcmp->getCompanyAddress())?>
						</div>
						<div style="font-size:15px; letter-spacing:1pt;">
							<b><br /><?php echo $accDet->getAccountName()?></b>
						</div>
						<div style="font-size:13px;">
							<b><br />Bank Reconciliation Statement AS ON : <?php echo $fdate?></b>
						</div>					
					</td>
				<tr>			
			
				<tr bgcolor="#F4F4F4">
					<td width='10%' class="td_normal bold">DATE</td>
					<td width='25%' class="td_normal bold">CHEQUE NO &amp; DATE</td>
					<td width='35%' class="td_normal bold">PARTICULARS</td>
					<td width='15%' class="td_normal bold" align='right'>AMOUNT</td>
					<td width='15%' class="td_normal bold" align='right'>BALANCE</td>
				</tr>

				<tr bgcolor="#FFFFFF">
					<td class="td_normal bold" colspan="4">Balance as per Bank Book</td>
					<td class="td_normal bold" align='right'><?php echo number_format($bal, 2)?> <?php echo getDrCr($balt)?></td>
				</tr>
				
				<tr bgcolor="#FFFFFF">
					<td class="td_normal bold" colspan="5">Add : Cheques issued but not presented to bank</td>
				</tr>

				<?php
					$nRec			= count($bpvList);
					for($i=0;$i<$nRec;$i++) {
						$veb		=	$bpvList[$i];
						$totUBP = $totUBP + $veb->getAmount();
						$olist	=	$vdb->getOppositeVoucher($veb->getVoucherID(), $aid);
						$oveb	=	$olist[0];
				?>
						<tr bgcolor="#FFFFFF">
							<td width='10%' class="td_normal"><?php echo $veb->getDOV('yes')?></td>
							<td width='25%' class="td_normal"><?php echo $oveb->getChequeNo('yes')?> dt: <?php echo $oveb->getChqDate('yes')?></td>
							<td width='35%' class="td_normal"><?php echo $veb->getNarration('yes')?></td>
							<td width='15%' class="td_normal" align='right'><?php echo $veb->getAmount('yes')?></td>
							<?php if($i == $nRec - 1) { ?>
								<td width='15%' class="td_normal" align='right'><?php echo number_format($totUBP, 2)?></td>
							<?php } else { ?>
								<td width='15%' class="td_normal" align='right'>&nbsp;</td>
							<?php } ?>
						</tr>
				
				<?php
						for($j=0;$j<count($olist);$j++) {
							$ovch	=	$olist[$j];
							$tmp	=	"#f4f4f4";
							if($j%2==0)
								$tmp	=	"#e4e4e4";
				?>
							<tr bgcolor="#FFFFFF">
								<td>&nbsp;</td>
								<td>&nbsp;</td>
								<td bgcolor="<?php echo $tmp?>">
									<font style='font-family:verdana; font-size:10px'><?php echo $ovch->getAccountName('yes')?> - <?php echo $ovch->getAmount('yes')?> (<?php echo getDrCr($ovch->getDrCr())?>)</font>
								</td>
								<td>&nbsp;</td>
								<td>&nbsp;</td>
							</tr>
				<?php
						}
				?>
				
				<?php } ?>				
				
				<tr bgcolor="#FFFFFF">
					<td class="td_normal bold" colspan="5">Less : Cheques deposited but not yet cleared</td>
				</tr>				

				<?php
					$nRec			= count($brvList);
					for($i=0;$i<$nRec;$i++) {
						$veb		=	$brvList[$i];
						$totUBR = $totUBR + $veb->getAmount();
						$olist	=	$vdb->getOppositeVoucher($veb->getVoucherID(), $aid);
						$oveb	=	$olist[0];
				?>
						<tr bgcolor="#FFFFFF">
							<td width='10%' class="td_normal"><?php echo $veb->getDOV('yes')?></td>
							<td width='25%' class="td_normal"><?php echo $oveb->getChequeNo('yes')?> dt: <?php echo $oveb->getChqDate('yes')?></td>
							<td width='35%' class="td_normal"><?php echo $veb->getNarration('yes')?></td>
							<td width='15%' class="td_normal" align='right'><?php echo $veb->getAmount('yes')?></td>
							<?php if($i == $nRec - 1) { ?>
								<td width='15%' class="td_normal" align='right'><?php echo number_format($totUBR, 2)?></td>
							<?php } else { ?>
								<td width='15%' class="td_normal" align='right'>&nbsp;</td>
							<?php } ?>
						</tr>
						
				<?php
						for($j=0;$j<count($olist);$j++) {
							$ovch	=	$olist[$j];
							$tmp	=	"#f4f4f4";
							if($j%2==0)
								$tmp	=	"#e4e4e4";
				?>
							<tr bgcolor="#FFFFFF">
								<td>&nbsp;</td>
								<td>&nbsp;</td>
								<td bgcolor="<?php echo $tmp?>">
									<font style='font-family:verdana; font-size:10px'><?php echo $ovch->getAccountName('yes')?> - <?php echo $ovch->getAmount('yes')?> (<?php echo getDrCr($ovch->getDrCr())?>)</font>
								</td>
								<td>&nbsp;</td>
								<td>&nbsp;</td>
							</tr>
				<?php
						}
				?>						
						
				<?php } ?>
				
				<?php
					if($balt == DEBIT)
						$balc	= $bal + $totUBP - $totUBR;
					else
						$balc	= $totUBP - $totUBR - $bal;
						
					$cbalt = DEBIT;
					if($balc < 0) {
						$balc = abs($balc);
						$cbalt = CREDIT;
					}
				?>
				
				<tr bgcolor="#FFFFFF">
					<td class="td_normal bold" colspan="4">Balance as per Bank Statement</td>
					<td class="td_normal bold" align='right'><?php echo number_format($balc, 2)?> <?php echo getDrCr($cbalt)?></td>
				</tr>								
				
			</table>
		</div>
		
	<br />
	<div style="text-align:center"><input type="button" value="Export to Excel" onClick="ExportToExcel()" class="red_button" /></div>
	<br />		

	</div>
</body>
</html>

<script type="text/javascript">

	function ExportToExcel(){
		 var tbl		= document.getElementById('main_table');
		 var html 	= tbl.outerHTML;
		 window.open('data:application/vnd.ms-excel,' + encodeURIComponent(html));
	}
	
</script>