<?php

	/* Include the required files */
	require_once( '../inc/functions.php' );
	require_once( '../aom-config.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/asys.voucherdb.php' );
	require_once( '../dao/asys.drcr.php' );
	require_once( '../dao/asys.group.php' );
	require_once( '../dao/asys.voucher.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/asys.store.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );	

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 42;

	$mdb			=	new masterdb("REPORT");
	$vdb			=	new voucherdb("REPORT");
	$ldb			= new logindb("REPORT");
	
	$strList	= $mdb->getStoreList($tcmp->getCompanyID());
	$oppList	= $mdb->getStoreOppositeAccountList($tcmp->getCompanyID());
	
	$vdb->updateGroupSubgroup();
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}		

	$fdate		=	getFirstFinancialDate();
	$tdate		=	getLastFinancialDate();

	extract($_REQUEST);

	$df				=	FormatIndianDateToSQLDate($fdate);
	$dt				=	FormatIndianDateToSQLDate($tdate);

	if($df == '1900-01-01' || $dt == '1900-01-01'){
		echo 'Invalid input Date format, try again';
		exit;
	}
	
	$cmpid		= $tcmp->getCompanyID();
	$ndt			=	getNextDate($dt);
	$ndtf			=	getNextDate($df);
	
	/**********************************************************
	**         Trading Account 
	***********************************************************/
	
	$stkOp		= 0;
	$stkCl		= 0;
	for($i=0;$i<count($strList);$i++) {
		$scls		= $strList[$i];
		$aid		= 0;
		if($scls->getAccountID() != 0)
			$aid	= $scls->getAccountID();
		else
			$aid	= $scls->getMotherAccountID();
			
		$cbal		= $mdb->getClosingBalanceByAccountID($aid, $ndt, 'YES');
			
		if($cbal[1] == DEBIT)
			$stkCl	= $stkCl + $cbal[0];
		else
			$stkCl	= $stkCl - $cbal[0];
			
		$cbal		= $mdb->getClosingBalanceByAccountID($aid, $ndtf, '');
			
		if($cbal[1] == DEBIT)
			$stkOp	= $stkOp + $cbal[0];
		else
			$stkOp	= $stkOp - $cbal[0];			
	}
	
	$oppTot		= 0;
	for($i=0;$i<count($oppList);$i++) {
		$row		= $oppList[$i];
		$aid		= $row[0];
		$cbal		= $mdb->getClosingBalanceByAccountID($aid, $ndt, 'YES');
		
		if($cbal[1] == CREDIT)
			$oppTot	= $oppTot + $cbal[0];
		else
			$oppTot	= $oppTot - $cbal[0];		
	}	
	
	$deTot		= $mdb->getClosingBalanceByBGID($cmpid, 13, $ndt, 'YES');
	$puTot		= $mdb->getClosingBalanceByBGID($cmpid, 19, $ndt, 'YES');
	
	$diTot		= $mdb->getClosingBalanceByBGID($cmpid, 20, $ndt, 'YES');
	$saTot		= $mdb->getClosingBalanceByBGID($cmpid, 18, $ndt, 'YES');
	
	$taProfit	= 0;
	$tcrSide	= 0;
	$tdrSide	= 0;
	$tcrCnt		= 0;
	$tdrCnt		= 0;
	
	if($diTot[1] == CREDIT)
		$tcrSide	= $diTot[0];
	else
		$tcrSide	= -$diTot[0];
	
	if($saTot[1] == CREDIT)
		$tcrSide 	= bcadd($tcrSide, $saTot[0], 2);
	else
		$tcrSide 	= bcsub($tcrSide, $saTot[0], 2);
		
	$tcrSide 		= bcadd($tcrSide, $stkCl, 2);		
		
	if($deTot[1] == DEBIT)
		$tdrSide 	= $deTot[0] + $oppTot;
	else
		$tdrSide 	= -$deTot[0] + $oppTot;
		
	if($puTot[1] == DEBIT)
		$tdrSide 	= bcadd($tdrSide, $puTot[0], 2);
	else
		$tdrSide 	= bcsub($tdrSide, $puTot[0], 2);
		
	$tdrSide		= bcadd($tdrSide, $stkOp, 2);

	$taProfit		= number_format( $tcrSide - $tdrSide, 2, '.', '');
	
	/**********************************************************
	**         Trading Account ends here
	***********************************************************/
	
	
	/**********************************************************
	**         PL Account 
	***********************************************************/
	
	$plProfit	= 0;
	$pcrSide	= 0;
	$pdrSide	= 0;
	$pcrCnt		= 0;
	$pdrCnt		= 0;
	
	$ieTot		= $mdb->getClosingBalanceByBGID($cmpid, 14, $ndt, 'YES');
	$meTot		= $mdb->getClosingBalanceByBGID($cmpid, 15, $ndt, 'YES');
	
	$iiTot		= $mdb->getClosingBalanceByBGID($cmpid, 17, $ndt, 'YES');
	
	if($ieTot[1] == DEBIT)
		$pdrSide = $ieTot[0];
	else
		$pdrSide = -$ieTot[0];
		
	if($meTot[1] == DEBIT)
		$pdrSide = bcadd($pdrSide, $meTot[0], 2);
	else
		$pdrSide = bcsub($pdrSide, $meTot[0], 2);
		
	if($iiTot[1] == CREDIT)
		$pcrSide = $iiTot[0];
	else
		$pcrSide = -$iiTot[0];				
	
	if($taProfit > 0)
		$plProfit	= number_format( $taProfit + $pcrSide - $pdrSide, 2, '.', '');
	else
		$plProfit	= number_format( $pcrSide - ($pdrSide - $taProfit), 2, '.', '');
	
	/**********************************************************
	**         PL Account ends here
	***********************************************************/
	
	$bcrSide	= 0;
	$bdrSide	= 0;	
	
	$bsl1			= $mdb->getClosingBalanceByBGID($cmpid, 1, $ndt, 'YES');
	$bsl2			= $mdb->getClosingBalanceByBGID($cmpid, 2, $ndt, 'YES');
	$bsl3			= $mdb->getClosingBalanceByBGID($cmpid, 3, $ndt, 'YES');
	$bsl4			= $mdb->getClosingBalanceByBGID($cmpid, 4, $ndt, 'YES');
	$bsl5			= $mdb->getClosingBalanceByBGID($cmpid, 5, $ndt, 'YES');
	$bsl16		= $mdb->getClosingBalanceByBGID($cmpid, 16, $ndt, 'YES');
	$bsl22		= $mdb->getClosingBalanceByBGID($cmpid, 22, $ndt, 'YES');
	
	if($bsl1[1] == CREDIT)
		$bcrSide = $bsl1[0];
	else
		$bcrSide = -$bsl1[0];	
		
	if($bsl2[1] == CREDIT)
		$bcrSide = bcadd($bcrSide, $bsl2[0], 2);
	else
		$bcrSide = bcsub($bcrSide, $bsl2[0], 2);
		
	if($bsl3[1] == CREDIT)
		$bcrSide = bcadd($bcrSide, $bsl3[0], 2);
	else
		$bcrSide = bcsub($bcrSide, $bsl3[0], 2);
		
	if($bsl4[1] == CREDIT)
		$bcrSide = bcadd($bcrSide, $bsl4[0], 2);
	else
		$bcrSide = bcsub($bcrSide, $bsl4[0], 2);
		
	if($bsl5[1] == CREDIT)
		$bcrSide = bcadd($bcrSide, $bsl5[0], 2);
	else
		$bcrSide = bcsub($bcrSide, $bsl5[0], 2);
		
	if($bsl16[1] == CREDIT)
		$bcrSide = bcadd($bcrSide, $bsl16[0], 2);
	else
		$bcrSide = bcsub($bcrSide, $bsl16[0], 2);		
		
	if($bsl22[1] == CREDIT)
		$bcrSide = bcadd($bcrSide, $bsl22[0], 2);
	else
		$bcrSide = bcsub($bcrSide, $bsl22[0], 2);
	
	$bsa6			= $mdb->getClosingBalanceByBGID($cmpid, 6, $ndt, 'YES');
	$bsa7			= $mdb->getClosingBalanceByBGID($cmpid, 7, $ndt, 'YES');
	$bsa8			= $mdb->getClosingBalanceByBGID($cmpid, 8, $ndt, 'YES');
	$bsa9			= $mdb->getClosingBalanceByBGID($cmpid, 9, $ndt, 'YES');
	$bsa10		= $mdb->getClosingBalanceByBGID($cmpid, 10, $ndt, 'YES');
	$bsa11		= $mdb->getClosingBalanceByBGID($cmpid, 11, $ndt, 'YES');
	$bsa12		= $mdb->getClosingBalanceByBGID($cmpid, 12, $ndt, 'YES');
	$bsa21		= $mdb->getClosingBalanceByBGID($cmpid, 21, $ndt, 'YES');
	$bsa23		= $mdb->getClosingBalanceByBGID($cmpid, 23, $ndt, 'YES');
	$bsa24		= $mdb->getClosingBalanceByBGID($cmpid, 24, $ndt, 'YES');
	
	if($bsa6[1] == DEBIT)
		$bdrSide = $bsa6[0];
	else
		$bdrSide = -$bsa6[0];	
		
	if($bsa7[1] == DEBIT)
		$bdrSide = bcadd($bdrSide, $bsa7[0], 2);
	else
		$bdrSide = bcsub($bdrSide, $bsa7[0], 2);
		
	if($bsa8[1] == DEBIT)
		$bdrSide = bcadd($bdrSide, $bsa8[0], 2);
	else
		$bdrSide = bcsub($bdrSide, $bsa8[0], 2);
		
	if($bsa9[1] == DEBIT)
		$bdrSide = bcadd($bdrSide, $bsa9[0], 2);
	else
		$bdrSide = bcsub($bdrSide, $bsa9[0], 2);
		
	if($bsa10[1] == DEBIT)
		$bdrSide = bcadd($bdrSide, $bsa10[0], 2);
	else
		$bdrSide = bcsub($bdrSide, $bsa10[0], 2);
		
	if($bsa11[1] == DEBIT)
		$bdrSide = bcadd($bdrSide, $bsa11[0], 2);
	else
		$bdrSide = bcsub($bdrSide, $bsa11[0], 2);
		
	if($bsa12[1] == DEBIT)
		$bdrSide = bcadd($bdrSide, $bsa12[0], 2);
	else
		$bdrSide = bcsub($bdrSide, $bsa12[0], 2);
		
	if($bsa21[1] == DEBIT)
		$bdrSide = bcadd($bdrSide, $bsa21[0], 2);
	else
		$bdrSide = bcsub($bdrSide, $bsa21[0], 2);
		
	if($bsa23[1] == DEBIT)
		$bdrSide = bcadd($bdrSide, $bsa23[0], 2);
	else
		$bdrSide = bcsub($bdrSide, $bsa23[0], 2);
		
	if($bsa24[1] == DEBIT)
		$bdrSide = bcadd($bdrSide, $bsa24[0], 2);
	else
		$bdrSide = bcsub($bdrSide, $bsa24[0], 2);
	
	$bslAct1	= $mdb->getShortMotherAccountListBGWise($cmpid, 1);
	$bslAct2	= $mdb->getShortMotherAccountListBGWise($cmpid, 2);
	$bslAct3	= $mdb->getShortMotherAccountListBGWise($cmpid, 3);
	$bslAct4	= $mdb->getShortMotherAccountListBGWise($cmpid, 4);
	$bslAct5	= $mdb->getShortMotherAccountListBGWise($cmpid, 5);
	$bslAct16	= $mdb->getShortMotherAccountListBGWise($cmpid, 16);
	$bslAct22	= $mdb->getShortMotherAccountListBGWise($cmpid, 22);
	
	$bsaAct6	= $mdb->getShortMotherAccountListBGWise($cmpid, 6);
	$bsaAct7	= $mdb->getShortMotherAccountListBGWise($cmpid, 7);
	$bsaAct8	= $mdb->getShortMotherAccountListBGWise($cmpid, 8);
	$bsaAct9	= $mdb->getShortMotherAccountListBGWise($cmpid, 9);
	$bsaAct10	= $mdb->getShortMotherAccountListBGWise($cmpid, 10);
	$bsaAct11	= $mdb->getShortMotherAccountListBGWise($cmpid, 11);
	$bsaAct12	= $mdb->getShortMotherAccountListBGWise($cmpid, 12);
	$bsaAct21	= $mdb->getShortMotherAccountListBGWise($cmpid, 21);
	$bsaAct23	= $mdb->getShortMotherAccountListBGWise($cmpid, 23);
	$bsaAct24	= $mdb->getShortMotherAccountListBGWise($cmpid, 24);

?>


<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html;charset=utf-8"/>
		<title>Balance Sheet</title>
		<link href="../css/rpt.css" type=text/css rel=stylesheet>
		<script src="../js/common.js"></script>
	</head>
<body style="background-color:#ffffff">
	<div style="font-family:verdana;width:1000px;margin:0px auto;" align="center">

		<div style="font-size:9px;">
			<table cellSpacing='0' cellPadding='0' width='100%' style="border-collapse: collapse;border:#CCCCCC 1px solid" id="main_table">
			
				<tr bgcolor="#FFFFFF">
					<td align="center" colspan="2">
						<div style="font-size:18px; letter-spacing:1pt;">
							<b><?php echo $tcmp->getCompanyName()?><br /></b>
						</div>
						<div style="font-size:15px; letter-spacing:1pt;">
							<?php echo nl2br($tcmp->getCompanyAddress())?>
						</div>
						<div style="font-size:13px;">
							<b><br />Balance Sheet from <?php echo $fdate?> to <?php echo $tdate?></b>
						</div>					
					</td>
				<tr>			
			
				<tr>
					<td width="50%" valign="top">
						<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
							<tr bgcolor="#f4f4f4">
								<td width='60%'>
									<font style='font-family:arial; font-size:12px'><b>PARTICULARS</b></font>
								</td>
								<td width='20%' align='right'>
									<font style='font-family:arial; font-size:12px'>&nbsp;</font>
								</td>
								<td width='20%' align='right'>
									<font style='font-family:arial; font-size:12px'>&nbsp;</font>
								</td>
							</tr>
							
							<?php if($bsl1[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td><b>Capital</b></td>
									<td align='right'>&nbsp;</td>
									<?php if($bsl1[1] == CREDIT) { ?>
										<td align='right'><b><?php echo number_format($bsl1[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$bsl1[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($bslAct1);$i++) {
										$acls	= $bslAct1[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, 'YES');
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == DEBIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><a href="rptMainLedger.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Ledger" target="_blank"><?php echo $acls->getPrnName() ?></a></td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccount($tcmp->getCompanyID(), $acls->getAccountID(), $ndt, 'YES');
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == DEBIT) $tmpamt = -$tmpamt;										
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<a href="rptSubTrial.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Sub Trial" target="_blank">+</a>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($bsl2[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td><b>Loans</b></td>
									<td align='right'>&nbsp;</td>
									<?php if($bsl2[1] == CREDIT) { ?>
										<td align='right'><b><?php echo number_format($bsl2[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$bsl2[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($bslAct2);$i++) {
										$acls	= $bslAct2[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, 'YES');
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == DEBIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><a href="rptMainLedger.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Ledger" target="_blank"><?php echo $acls->getPrnName() ?></a></td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccount($tcmp->getCompanyID(), $acls->getAccountID(), $ndt, 'YES');
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == DEBIT) $tmpamt = -$tmpamt;										
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<a href="rptSubTrial.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Sub Trial" target="_blank">+</a>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($bsl3[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td><b>Sundry Creditors</b></td>
									<td align='right'>&nbsp;</td>
									<?php if($bsl3[1] == CREDIT) { ?>
										<td align='right'><b><?php echo number_format($bsl3[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$bsl3[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($bslAct3);$i++) {
										$acls	= $bslAct3[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, 'YES');
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == DEBIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><a href="rptMainLedger.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Ledger" target="_blank"><?php echo $acls->getPrnName() ?></a></td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccount($tcmp->getCompanyID(), $acls->getAccountID(), $ndt, 'YES');
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == DEBIT) $tmpamt = -$tmpamt;										
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<a href="rptSubTrial.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Sub Trial" target="_blank">+</a>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($bsl4[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td><b>Reserves</b></td>
									<td align='right'>&nbsp;</td>
									<?php if($bsl4[1] == CREDIT) { ?>
										<td align='right'><b><?php echo number_format($bsl4[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$bsl4[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($bslAct4);$i++) {
										$acls	= $bslAct4[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, 'YES');
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == DEBIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><a href="rptMainLedger.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Ledger" target="_blank"><?php echo $acls->getPrnName() ?></a></td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccount($tcmp->getCompanyID(), $acls->getAccountID(), $ndt, 'YES');
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == DEBIT) $tmpamt = -$tmpamt;										
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<a href="rptSubTrial.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Sub Trial" target="_blank">+</a>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($bsl5[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td><b>Provision</b></td>
									<td align='right'>&nbsp;</td>
									<?php if($bsl5[1] == CREDIT) { ?>
										<td align='right'><b><?php echo number_format($bsl5[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$bsl5[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($bslAct5);$i++) {
										$acls	= $bslAct5[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, 'YES');
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == DEBIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><a href="rptMainLedger.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Ledger" target="_blank"><?php echo $acls->getPrnName() ?></a></td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccount($tcmp->getCompanyID(), $acls->getAccountID(), $ndt, 'YES');
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == DEBIT) $tmpamt = -$tmpamt;										
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<a href="rptSubTrial.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Sub Trial" target="_blank">+</a>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($bsl16[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td><b>Duties &amp; Taxes</b></td>
									<td align='right'>&nbsp;</td>
									<?php if($bsl16[1] == CREDIT) { ?>
										<td align='right'><b><?php echo number_format($bsl16[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$bsl16[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($bslAct16);$i++) {
										$acls	= $bslAct16[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, 'YES');
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == DEBIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><a href="rptMainLedger.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Ledger" target="_blank"><?php echo $acls->getPrnName() ?></a></td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccount($tcmp->getCompanyID(), $acls->getAccountID(), $ndt, 'YES');
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == DEBIT) $tmpamt = -$tmpamt;										
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<a href="rptSubTrial.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Sub Trial" target="_blank">+</a>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>							
							
							<?php if($bsl22[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td><b>Current Liabilities</b></td>
									<td align='right'>&nbsp;</td>
									<?php if($bsl22[1] == CREDIT) { ?>
										<td align='right'><b><?php echo number_format($bsl22[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$bsl22[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($bslAct22);$i++) {
										$acls	= $bslAct22[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, 'YES');
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == DEBIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><a href="rptMainLedger.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Ledger" target="_blank"><?php echo $acls->getPrnName() ?></a></td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else { ?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccount($tcmp->getCompanyID(), $acls->getAccountID(), $ndt, 'YES');
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == DEBIT) $tmpamt = -$tmpamt;										
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<a href="rptSubTrial.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Sub Trial" target="_blank">+</a>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>							
							
							<?php if($plProfit > 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td><b>Profit &amp; Loss A/c</b></td>
									<td align='right'>&nbsp;</td>
									<td align='right'><b><?php echo number_format($plProfit, 2, '.', '') ?></b></td>
								</tr>
							<?php } ?>																					
							
						</table>
					</td>
					<td width="50%" valign="top">
						<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
							<tr bgcolor="#f4f4f4">
								<td width='60%'>
									<font style='font-family:arial; font-size:12px'><b>PARTICULARS</b></font>
								</td>
								<td width='20%' align='right'>
									<font style='font-family:arial; font-size:12px'>&nbsp;</font>
								</td>
								<td width='20%' align='right'>
									<font style='font-family:arial; font-size:12px'>&nbsp;</font>
								</td>
							</tr>
							
							<?php if($bsa6[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td><b>Fixed Asset</b></td>
									<td align='right'>&nbsp;</td>
									<?php if($bsa6[1] == DEBIT) { ?>
										<td align='right'><b><?php echo number_format($bsa6[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$bsa6[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($bsaAct6);$i++) {
										$acls	= $bsaAct6[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, 'YES');
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><a href="rptMainLedger.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Ledger" target="_blank"><?php echo $acls->getPrnName() ?></a></td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccount($tcmp->getCompanyID(), $acls->getAccountID(), $ndt, 'YES');
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;										
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<a href="rptSubTrial.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Sub Trial" target="_blank">+</a>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($bsa7[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td><b>Investment</b></td>
									<td align='right'>&nbsp;</td>
									<?php if($bsa7[1] == DEBIT) { ?>
										<td align='right'><b><?php echo number_format($bsa7[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$bsa7[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($bsaAct7);$i++) {
										$acls	= $bsaAct7[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, 'YES');
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><a href="rptMainLedger.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Ledger" target="_blank"><?php echo $acls->getPrnName() ?></a></td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccount($tcmp->getCompanyID(), $acls->getAccountID(), $ndt, 'YES');
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<a href="rptSubTrial.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Sub Trial" target="_blank">+</a>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($bsa8[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td><b>Loan &amp; Advances</b></td>
									<td align='right'>&nbsp;</td>
									<?php if($bsa8[1] == DEBIT) { ?>
										<td align='right'><b><?php echo number_format($bsa8[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$bsa8[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($bsaAct8);$i++) {
										$acls	= $bsaAct8[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, 'YES');
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><a href="rptMainLedger.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Ledger" target="_blank"><?php echo $acls->getPrnName() ?></a></td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccount($tcmp->getCompanyID(), $acls->getAccountID(), $ndt, 'YES');
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<a href="rptSubTrial.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Sub Trial" target="_blank">+</a>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($bsa9[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td><b>Cash</b></td>
									<td align='right'>&nbsp;</td>
									<?php if($bsa9[1] == DEBIT) { ?>
										<td align='right'><b><?php echo number_format($bsa9[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$bsa9[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($bsaAct9);$i++) {
										$acls	= $bsaAct9[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, 'YES');
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><a href="rptMainLedger.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Ledger" target="_blank"><?php echo $acls->getPrnName() ?></a></td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccount($tcmp->getCompanyID(), $acls->getAccountID(), $ndt, 'YES');
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<a href="rptSubTrial.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Sub Trial" target="_blank">+</a>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($bsa10[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td><b>Bank</b></td>
									<td align='right'>&nbsp;</td>
									<?php if($bsa10[1] == DEBIT) { ?>
										<td align='right'><b><?php echo number_format($bsa10[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$bsa10[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($bsaAct10);$i++) {
										$acls	= $bsaAct10[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, 'YES');
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><a href="rptMainLedger.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Ledger" target="_blank"><?php echo $acls->getPrnName() ?></a></td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccount($tcmp->getCompanyID(), $acls->getAccountID(), $ndt, 'YES');
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<a href="rptSubTrial.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Sub Trial" target="_blank">+</a>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($bsa11[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td><b>Sundry Debtors</b></td>
									<td align='right'>&nbsp;</td>
									<?php if($bsa11[1] == DEBIT) { ?>
										<td align='right'><b><?php echo number_format($bsa11[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$bsa11[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($bsaAct11);$i++) {
										$acls	= $bsaAct11[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, 'YES');
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><a href="rptMainLedger.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Ledger" target="_blank"><?php echo $acls->getPrnName() ?></a></td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccount($tcmp->getCompanyID(), $acls->getAccountID(), $ndt, 'YES');
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<a href="rptSubTrial.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Sub Trial" target="_blank">+</a>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($bsa12[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td><b>Stock</b></td>
									<td align='right'>&nbsp;</td>
									<?php if($bsa12[1] == DEBIT) { ?>
										<td align='right'><b><?php echo number_format($bsa12[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$bsa12[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($bsaAct12);$i++) {
										$acls	= $bsaAct12[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, 'YES');
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><a href="rptMainLedger.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Ledger" target="_blank"><?php echo $acls->getPrnName() ?></a></td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccount($tcmp->getCompanyID(), $acls->getAccountID(), $ndt, 'YES');
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<a href="rptSubTrial.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Sub Trial" target="_blank">+</a>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($bsa21[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td><b>Current Asset</b></td>
									<td align='right'>&nbsp;</td>
									<?php if($bsa21[1] == DEBIT) { ?>
										<td align='right'><b><?php echo number_format($bsa21[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$bsa21[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>								
								
								<?php
									for($i=0;$i<count($bsaAct21);$i++) {
										$acls	= $bsaAct21[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, 'YES');
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><a href="rptMainLedger.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Ledger" target="_blank"><?php echo $acls->getPrnName() ?></a></td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccount($tcmp->getCompanyID(), $acls->getAccountID(), $ndt, 'YES');
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<a href="rptSubTrial.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Sub Trial" target="_blank">+</a>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($bsa23[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td><b>Deposits</b></td>
									<td align='right'>&nbsp;</td>
									<?php if($bsa23[1] == DEBIT) { ?>
										<td align='right'><b><?php echo number_format($bsa23[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$bsa23[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($bsaAct23);$i++) {
										$acls	= $bsaAct23[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, 'YES');
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><a href="rptMainLedger.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Ledger" target="_blank"><?php echo $acls->getPrnName() ?></a></td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccount($tcmp->getCompanyID(), $acls->getAccountID(), $ndt, 'YES');
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<a href="rptSubTrial.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Sub Trial" target="_blank">+</a>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($bsa24[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td><b>Branch/Divisions</b></td>
									<td align='right'>&nbsp;</td>
									<?php if($bsa24[1] == DEBIT) { ?>
										<td align='right'><b><?php echo number_format($bsa24[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$bsa24[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($bsaAct24);$i++) {
										$acls	= $bsaAct24[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, 'YES');
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><a href="rptMainLedger.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Ledger" target="_blank"><?php echo $acls->getPrnName() ?></a></td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccount($tcmp->getCompanyID(), $acls->getAccountID(), $ndt, 'YES');
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<a href="rptSubTrial.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Sub Trial" target="_blank">+</a>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($plProfit < 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td><b>Profit &amp; Loss A/c</b></td>
									<td align='right'>&nbsp;</td>
									<td align='right'><b><?php echo number_format(-$plProfit, 2, '.', '') ?></b></td>
								</tr>
							<?php } ?>							
																					
						</table>
					</td>					
				</tr>

				<?php if($plProfit > 0) { ?>
				
					<tr>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>TOTAL</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'><b><?php echo number_format($bcrSide + $plProfit, 2, '.', '')?></b></td>					
								</tr>
							</table>
						</td>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>TOTAL</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'><b><?php echo number_format($bdrSide, 2, '.', '')?></b></td>					
								</tr>
							</table>
						</td>
					</tr>	
					
				<?php } else { ?>
				
					<tr>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>TOTAL</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'><b><?php echo number_format($bcrSide, 2, '.', '')?></b></td>					
								</tr>
							</table>
						</td>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>TOTAL</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'><b><?php echo number_format($bdrSide - $plProfit, 2, '.', '')?></b></td>					
								</tr>
							</table>
						</td>
					</tr>				
				
				<?php } ?>
				
			</table>
		</div>
		
	<br />
	<div style="text-align:center"><input type="button" value="Export to Excel" onClick="ExportToExcel()" class="red_button" /></div>
	<br />		
		
	</div>
</body>
</html>

<script type="text/javascript">

	function ExportToExcel(){
		 var tbl		= document.getElementById('main_table');
		 var html 	= tbl.outerHTML;
		 window.open('data:application/vnd.ms-excel,' + encodeURIComponent(html));
	}
	
</script>