<?php

	/* Include the required files */
	require_once( '../inc/functions.php' );
	require_once( '../aom-config.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/asys.voucherdb.php' );
	require_once( '../dao/asys.drcr.php' );
	require_once( '../dao/asys.group.php' );
	require_once( '../dao/asys.voucher.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );	

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 39;

	$db			=	new masterdb("REPORT");
	$vdb		=	new voucherdb("REPORT");
	$ldb		= new logindb("REPORT");
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}
	
	$yr			= "";
	
	extract($_REQUEST);
	
	$yr			= (int)$yr;

	$fdt		= $yr."-04-01";
	$tdt		= ($yr+1)."-03-31";
	if($tdt > date('Y-m-d'))
		$tdt	= date('Y-m-d');
		
	$cmpid	= $tcmp->getCompanyID();
	$totIF	= 0;
	$totOF	= 0;
	
	$df			= $yr."-04-01";
	$dt			= $yr."-04-30";
	$aprIF	= $vdb->getMonthlyInFlow($cmpid, $df, $dt);
	$aprOF	= $vdb->getMonthlyOutFlow($cmpid, $df, $dt);
	
	$df			= $yr."-05-01";
	$dt			= $yr."-05-31";
	$mayIF	= $vdb->getMonthlyInFlow($cmpid, $df, $dt);
	$mayOF	= $vdb->getMonthlyOutFlow($cmpid, $df, $dt);
	
	$df			= $yr."-06-01";
	$dt			= $yr."-06-30";
	$junIF	= $vdb->getMonthlyInFlow($cmpid, $df, $dt);
	$junOF	= $vdb->getMonthlyOutFlow($cmpid, $df, $dt);
	
	$df			= $yr."-07-01";
	$dt			= $yr."-07-31";
	$julIF	= $vdb->getMonthlyInFlow($cmpid, $df, $dt);
	$julOF	= $vdb->getMonthlyOutFlow($cmpid, $df, $dt);
	
	$df			= $yr."-08-01";
	$dt			= $yr."-08-31";
	$augIF	= $vdb->getMonthlyInFlow($cmpid, $df, $dt);
	$augOF	= $vdb->getMonthlyOutFlow($cmpid, $df, $dt);
	
	$df			= $yr."-09-01";
	$dt			= $yr."-09-30";
	$sepIF	= $vdb->getMonthlyInFlow($cmpid, $df, $dt);
	$sepOF	= $vdb->getMonthlyOutFlow($cmpid, $df, $dt);
	
	$df			= $yr."-10-01";
	$dt			= $yr."-10-31";
	$octIF	= $vdb->getMonthlyInFlow($cmpid, $df, $dt);
	$octOF	= $vdb->getMonthlyOutFlow($cmpid, $df, $dt);
	
	$df			= $yr."-11-01";
	$dt			= $yr."-11-30";
	$novIF	= $vdb->getMonthlyInFlow($cmpid, $df, $dt);
	$novOF	= $vdb->getMonthlyOutFlow($cmpid, $df, $dt);
	
	$df			= $yr."-12-01";
	$dt			= $yr."-12-31";
	$decIF	= $vdb->getMonthlyInFlow($cmpid, $df, $dt);
	$decOF	= $vdb->getMonthlyOutFlow($cmpid, $df, $dt);
	
	$df			= ($yr+1)."-01-01";
	$dt			= ($yr+1)."-01-30";
	$janIF	= $vdb->getMonthlyInFlow($cmpid, $df, $dt);
	$janOF	= $vdb->getMonthlyOutFlow($cmpid, $df, $dt);
	
	$df			= ($yr+1)."-02-01";
	$dt			= ($yr+1)."-02-29";
	$febIF	= $vdb->getMonthlyInFlow($cmpid, $df, $dt);
	$febOF	= $vdb->getMonthlyOutFlow($cmpid, $df, $dt);
	
	$df			= ($yr+1)."-03-01";
	$dt			= ($yr+1)."-03-31";
	$marIF	= $vdb->getMonthlyInFlow($cmpid, $df, $dt);
	$marOF	= $vdb->getMonthlyOutFlow($cmpid, $df, $dt);
	
	$totIF	= $aprIF + $mayIF + $junIF + $julIF + $augIF + $sepIF + $octIF + $novIF + $decIF + $janIF + $febIF + $marIF;
	
	$totOF	= $aprOF + $mayOF + $junOF + $julOF + $augOF + $sepOF + $octOF + $novOF + $decOF + $janOF + $febOF + $marOF;

?>


<!DOCTYPE html>
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html;charset=utf-8"/>
		<title>Cash Flow</title>
		<link href="../css/rpt.css" type="text/css" rel="stylesheet">
		<script src="../js/common.js"></script>
	</head>
<body style="background-color:#ffffff">
	<div style="font-family:verdana; width:800px; margin:0px auto;" align="center">
		<div style="text-align:center; font-size:18px; font-weight:bold; letter-spacing:1pt;">
			<br /><?php echo $tcmp->getCompanyName()?>
		</div>
		<div style="text-align:center; font-size:15px; font-weight:normal; letter-spacing:1pt;">
			<?php echo nl2br($tcmp->getCompanyAddress())?>
		</div>
		<div style="text-align:center; font-size:13px; font-weight:bold;">
			<br />Cash Flow from <?php echo FormatSQLDateToIndianDate($fdt)?> to <?php echo FormatSQLDateToIndianDate($tdt)?><br /><br />
		</div>
		
		<div style="font-size:10px; font-weight:bold;">
			<table cellSpacing='1' cellPadding='4' width='100%' bgcolor='#CCCCCC'>
				<tr bgcolor="#F4F4F4">
					<td width='50%' class="td_normal bold">MONTH</td>
					<td width='15%' class="td_normal bold" align="right">INFLOW</td>
					<td width='15%' class="td_normal bold" align="right">OUTFLOW</td>
					<td width='20%' class="td_normal bold" align="right">NET FLOW</td>
				</tr>
				
				<tr bgcolor="#FFFFFF">
					<td class="td_normal"><a href="rptCFS.php?yr=<?php echo $yr?>&mnt=4" target="_blank" title="Cash Flow Summary - April <?php echo $yr?>">APRIL</a></td>
					<td class="td_normal" align="right"><?php echo number_format($aprIF, 2,'.', '')?></td>
					<td class="td_normal" align="right"><?php echo number_format($aprOF, 2, '.', '')?></td>
					<td class="td_normal" align="right"><?php echo number_format(($aprIF - $aprOF), 2, '.', '')?></td>
				</tr>
				<tr bgcolor="#FFFFFF">
					<td class="td_normal"><a href="rptCFS.php?yr=<?php echo $yr?>&mnt=5" target="_blank" title="Cash Flow Summary - May <?php echo $yr?>">MAY</a></td>
					<td class="td_normal" align="right"><?php echo number_format($mayIF, 2,'.', '')?></td>
					<td class="td_normal" align="right"><?php echo number_format($mayOF, 2, '.', '')?></td>
					<td class="td_normal" align="right"><?php echo number_format(($mayIF - $mayOF), 2, '.', '')?></td>
				</tr>
				<tr bgcolor="#FFFFFF">
					<td class="td_normal"><a href="rptCFS.php?yr=<?php echo $yr?>&mnt=6" target="_blank" title="Cash Flow Summary - June <?php echo $yr?>">JUNE</a></td>
					<td class="td_normal" align="right"><?php echo number_format($junIF, 2,'.', '')?></td>
					<td class="td_normal" align="right"><?php echo number_format($junOF, 2, '.', '')?></td>
					<td class="td_normal" align="right"><?php echo number_format(($junIF - $junOF), 2, '.', '')?></td>
				</tr>
				<tr bgcolor="#FFFFFF">
					<td class="td_normal"><a href="rptCFS.php?yr=<?php echo $yr?>&mnt=7" target="_blank" title="Cash Flow Summary - July <?php echo $yr?>">JULY</a></td>
					<td class="td_normal" align="right"><?php echo number_format($julIF, 2,'.', '')?></td>
					<td class="td_normal" align="right"><?php echo number_format($julOF, 2, '.', '')?></td>
					<td class="td_normal" align="right"><?php echo number_format(($julIF - $julOF), 2, '.', '')?></td>
				</tr>
				<tr bgcolor="#FFFFFF">
					<td class="td_normal"><a href="rptCFS.php?yr=<?php echo $yr?>&mnt=8" target="_blank" title="Cash Flow Summary - August <?php echo $yr?>">AUGUST</a></td>
					<td class="td_normal" align="right"><?php echo number_format($augIF, 2,'.', '')?></td>
					<td class="td_normal" align="right"><?php echo number_format($augOF, 2, '.', '')?></td>
					<td class="td_normal" align="right"><?php echo number_format(($augIF - $augOF), 2, '.', '')?></td>
				</tr>
				<tr bgcolor="#FFFFFF">
					<td class="td_normal"><a href="rptCFS.php?yr=<?php echo $yr?>&mnt=9" target="_blank" title="Cash Flow Summary - September <?php echo $yr?>">SEPTEMBER</a></td>
					<td class="td_normal" align="right"><?php echo number_format($sepIF, 2,'.', '')?></td>
					<td class="td_normal" align="right"><?php echo number_format($sepOF, 2, '.', '')?></td>
					<td class="td_normal" align="right"><?php echo number_format(($sepIF - $sepOF), 2, '.', '')?></td>
				</tr>
				<tr bgcolor="#FFFFFF">
					<td class="td_normal"><a href="rptCFS.php?yr=<?php echo $yr?>&mnt=10" target="_blank" title="Cash Flow Summary - October <?php echo $yr?>">OCTOBER</a></td>
					<td class="td_normal" align="right"><?php echo number_format($octIF, 2,'.', '')?></td>
					<td class="td_normal" align="right"><?php echo number_format($octOF, 2, '.', '')?></td>
					<td class="td_normal" align="right"><?php echo number_format(($octIF - $octOF), 2, '.', '')?></td>
				</tr>
				<tr bgcolor="#FFFFFF">
					<td class="td_normal"><a href="rptCFS.php?yr=<?php echo $yr?>&mnt=11" target="_blank" title="Cash Flow Summary - November <?php echo $yr?>">NOVEMBER</a></td>
					<td class="td_normal" align="right"><?php echo number_format($novIF, 2,'.', '')?></td>
					<td class="td_normal" align="right"><?php echo number_format($novOF, 2, '.', '')?></td>
					<td class="td_normal" align="right"><?php echo number_format(($novIF - $novOF), 2, '.', '')?></td>
				</tr>
				<tr bgcolor="#FFFFFF">
					<td class="td_normal"><a href="rptCFS.php?yr=<?php echo $yr?>&mnt=12" target="_blank" title="Cash Flow Summary - December <?php echo $yr?>">DECEMBER</a></td>
					<td class="td_normal" align="right"><?php echo number_format($decIF, 2,'.', '')?></td>
					<td class="td_normal" align="right"><?php echo number_format($decOF, 2, '.', '')?></td>
					<td class="td_normal" align="right"><?php echo number_format(($decIF - $decOF), 2, '.', '')?></td>
				</tr>
				<tr bgcolor="#FFFFFF">
					<td class="td_normal"><a href="rptCFS.php?yr=<?php echo ($yr+1)?>&mnt=1" target="_blank" title="Cash Flow Summary - January <?php echo ($yr+1)?>">JANUARY</a></td>
					<td class="td_normal" align="right"><?php echo number_format($janIF, 2,'.', '')?></td>
					<td class="td_normal" align="right"><?php echo number_format($janOF, 2, '.', '')?></td>
					<td class="td_normal" align="right"><?php echo number_format(($janIF - $janOF), 2, '.', '')?></td>
				</tr>
				<tr bgcolor="#FFFFFF">
					<td class="td_normal"><a href="rptCFS.php?yr=<?php echo ($yr+1)?>&mnt=2" target="_blank" title="Cash Flow Summary - February <?php echo ($yr+1)?>">FEBRUARY</a></td>
					<td class="td_normal" align="right"><?php echo number_format($febIF, 2,'.', '')?></td>
					<td class="td_normal" align="right"><?php echo number_format($febOF, 2, '.', '')?></td>
					<td class="td_normal" align="right"><?php echo number_format(($febIF - $febOF), 2, '.', '')?></td>
				</tr>
				<tr bgcolor="#FFFFFF">
					<td class="td_normal"><a href="rptCFS.php?yr=<?php echo ($yr+1)?>&mnt=2" target="_blank" title="Cash Flow Summary - March <?php echo ($yr+1)?>">MARCH</a></td>
					<td class="td_normal" align="right"><?php echo number_format($marIF, 2,'.', '')?></td>
					<td class="td_normal" align="right"><?php echo number_format($marOF, 2, '.', '')?></td>
					<td class="td_normal" align="right"><?php echo number_format(($marIF - $marOF), 2, '.', '')?></td>
				</tr>
				
				<tr bgcolor="#FFFFFF">
					<td class="td_normal bold">GRAND TOTAL</td>
					<td class="td_normal bold" align="right"><?php echo number_format($totIF, 2,'.', '')?></td>
					<td class="td_normal bold" align="right"><?php echo number_format($totOF, 2, '.', '')?></td>
					<td class="td_normal bold" align="right"><?php echo number_format(($totIF - $totOF), 2, '.', '')?></td>
				</tr>								
			</table>
		</div>
	</div>
</body>
</html>