<?php

	/* Include the required files */
	require_once( '../inc/functions.php' );
	require_once( '../aom-config.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/asys.voucherdb.php' );
	require_once( '../dao/asys.drcr.php' );
	require_once( '../dao/asys.group.php' );
	require_once( '../dao/asys.voucher.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );	

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 39;

	$db			=	new masterdb("REPORT");
	$vdb		=	new voucherdb("REPORT");
	$ldb		= new logindb("REPORT");	
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}
	
	$yr			= "";
	$mnt		= "";
	
	extract($_REQUEST);
	
	$yr			= (int)$yr;
	$mnt		= (int)$mnt;
	if($mnt < 10)
		$mnt	= "0".$mnt;
		
	$cmpid	= $tcmp->getCompanyID();
	$totIF	= 0;
	$totOF	= 0;		
		
	$fdt		= $yr."-".$mnt."-01";
	$tdt		= date($yr.'-'.$mnt.'-t');
	
	$igList	= $vdb->getDistinctInFlowGroup($cmpid, $fdt, $tdt);
	$ogList	= $vdb->getDistinctOutFlowGroup($cmpid, $fdt, $tdt);
	
	$iCnt		= count($igList);
	$oCnt		= count($ogList);
	
	$rarr		= array();
	
	for($i=0;$i<$iCnt;$i++) {
		$row	= $igList[$i];
		$bgid	= $row[0];
		$rarr[$i][0]	= $db->getBaseGroupNameByBaseGroupID($bgid);
		$rarr[$i][1]	= $vdb->getGroupWiseMonthlyInFlow($cmpid, $fdt, $tdt, $bgid);
		$rarr[$i][2]	= "";
		$rarr[$i][3]	= 0;
		
		$totIF	= $totIF + $rarr[$i][1];
	}
	
	for($i=0;$i<$oCnt;$i++) {
		$row	= $ogList[$i];
		$bgid	= $row[0];
		$rarr[$i][2]	= $db->getBaseGroupNameByBaseGroupID($bgid);
		$rarr[$i][3]	= $vdb->getGroupWiseMonthlyOutFlow($cmpid, $fdt, $tdt, $bgid);
		if($i > $iCnt - 1) {
			$rarr[$i][0]	= "";
			$rarr[$i][1]	= 0;			
		}
		
		$totOF	= $totOF + $rarr[$i][3];
	}	

?>


<!DOCTYPE html>
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html;charset=utf-8"/>
		<title>Cash Flow Summary</title>
		<link href="../css/rpt.css" type="text/css" rel="stylesheet">
		<script src="../js/common.js"></script>
	</head>
<body style="background-color:#ffffff">
	<div style="font-family:verdana; width:800px; margin:0px auto;" align="center">
		<div style="text-align:center; font-size:18px; font-weight:bold; letter-spacing:1pt;">
			<br /><?php echo $tcmp->getCompanyName()?>
		</div>
		<div style="text-align:center; font-size:15px; font-weight:normal; letter-spacing:1pt;">
			<?php echo nl2br($tcmp->getCompanyAddress())?>
		</div>
		<div style="text-align:center; font-size:13px; font-weight:bold;">
			<br />Cash Flow Summary from <?php echo FormatSQLDateToIndianDate($fdt)?> to <?php echo FormatSQLDateToIndianDate($tdt)?><br /><br />
		</div>
		<div style="font-size:10px; font-weight:bold;">
			<table cellSpacing='1' cellPadding='4' width='100%' bgcolor='#CCCCCC'>
				
				<tr bgcolor="#F4F4F4">
					<td width='50%' colspan="2" class="td_normal bold">INFLOW</td>
					<td width='50%' colspan="2" class="td_normal bold">OUTFLOW</td>
				</tr>
				<tr bgcolor="#F4F4F4">
					<td width='35%' class="td_normal bold">GROUP</td>
					<td width='15%' class="td_normal bold" align="right">AMOUNT</td>
					<td width='35%' class="td_normal bold">GROUP</td>
					<td width='15%' class="td_normal bold" align="right">AMOUNT</td>
				</tr>
				
				<?php
					for($i=0;$i<count($rarr);$i++) {
				?>
				<tr bgcolor="#FFFFFF">
					<td class="td_normal"><?php echo $rarr[$i][0]?></td>
					<td class="td_normal" align="right"><?php if($rarr[$i][1] > 0) echo number_format($rarr[$i][1], 2,'.', '')?></td>
					<td class="td_normal"><?php echo $rarr[$i][2]?></td>
					<td class="td_normal" align="right"><?php if($rarr[$i][3] > 0) echo number_format($rarr[$i][3], 2,'.', '')?></td>
				</tr>
				<?php } ?>
				
				<tr bgcolor="#FFFFFF">
					<td class="td_normal bold">TOTAL</td>
					<td class="td_normal bold" align="right"><?php echo number_format($totIF, 2,'.', '')?></td>
					<td class="td_normal bold" align="right">TOTAL</td>
					<td class="td_normal bold" align="right"><?php echo number_format($totOF, 2, '.', '')?></td>
				</tr>
				
				<?php if($totIF - $totOF > 0) {?>
					<tr bgcolor="#CCFFCC">
						<td colspan="4" class="td_normal bold" align="center">Net Inflow = <?php echo number_format(($totIF - $totOF), 2, '.', '')?></td>
					</tr>
				<?php } else { ?>
					<tr bgcolor="#FFCCCC">
						<td colspan="4" class="td_normal bold" align="center">Net Outflow = <?php echo number_format(($totOF - $totIF), 2, '.', '')?></td>
					</tr>				
				<?php } ?>
				
			</table>
		</div>
	</div>
</body>
</html>