<?php

	/* Include the required files */
	require_once( '../inc/functions.php' );
	require_once( '../aom-config.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/asys.voucherdb.php' );
	require_once( '../dao/asys.drcr.php' );
	require_once( '../dao/asys.group.php' );
	require_once( '../dao/asys.voucher.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );	

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 35;

	$db			=	new masterdb("REPORT");
	$vdb		=	new voucherdb("REPORT");
	$ldb		= new logindb("REPORT");
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}		

	$accid	= 0;
	$fdate	=	getFirstFinancialDate();
	$tdate	=	getLastFinancialDate();

	extract($_REQUEST);

	$accid		=	(int)$accid;
	$df				=	FormatIndianDateToSQLDate($fdate);
	$dt				=	FormatIndianDateToSQLDate($tdate);
	$ndt			=	getNextDate($df);	

	if($accid == 0) {
		echo "Sorry!!! Direct Access not allowed here, please select Cash Account";
		exit;
	}

	$accDet		= $db->getAccountDetail($accid);
	$bal			= $accDet->getOBal();
	$balt			= $accDet->getOBalType();

	$clbal		=	$db->getClosingBalanceByAccountID($accid, $ndt);
	$bal			=	$clbal[0];
	$balt			=	$clbal[1];

	$alDet		= $vdb->getConsolidatedAccountVoucher($accid, $df, $dt);

	$totcr		= 0;
	$totdr		= 0;
	if($balt == DEBIT)
		$totdr	=	$bal;
	else
		$totcr	= $bal;

?>


<!DOCTYPE html>
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html;charset=utf-8"/>
		<title>Ledger of <?php echo $accDet->getAccountName()?></title>
		<link href="../css/rpt.css" type="text/css" rel="stylesheet">
		<script src="../js/common.js"></script>
	</head>
<body style="background-color:#ffffff">
	<div style="font-family:verdana;margin:0px auto;width:900px;font-size:12px;">

		<div style="font-size:10px;">
			<table cellSpacing='1' cellPadding='4' width='100%' bgcolor="#CCCCCC" id="main_table">
			
				<tr bgcolor="#FFFFFF">
					<td colspan="6" align="center">
						<div style="font-size:18px; letter-spacing:1pt;">
							<b><?php echo $tcmp->getCompanyName()?><br /></b>
						</div>
						<div style="font-size:15px; letter-spacing:1pt;">
							<?php echo nl2br($tcmp->getCompanyAddress())?>
						</div>
						<div style="font-size:15px; letter-spacing:1pt;">
							<b><br /><?php echo $accDet->getAccountName()?></b>
						</div>
						<div style="font-size:13px;">
							<b><?php echo $fdate?> - <?php echo $tdate?></b>
						</div>					
					</td>
				<tr>			
			
				<tr bgcolor="#f4f4f4">
					<td width='10%'">
						<font style='font-family:arial; font-size:11px'>DATE</font>
					</td>
					<td width='14%'">
						<font style='font-family:arial; font-size:11px'>DOC NO</font>
					</td>
					<td width='35%'>
						<font style='font-family:arial; font-size:11px'>PARTICULARS</font>
					</td>
					<td width='12%' align='right'>
						<font style='font-family:arial; font-size:11px'>DEBIT</font>
					</td>
					<td width='12%' align='right'>
						<font style='font-family:arial; font-size:11px'>CREDIT</font>
					</td>
					<td width='15%' align='right'>
						<font style='font-family:arial; font-size:11px'>BALANCE</font>
					</td>
				</tr>

				<tr bgcolor="#ffffff">
					<td width='10%'>
						&nbsp;
					</td>
					<td width='14%'>
						&nbsp;
					</td>
					<td width='35%'>
						<font style='font-family:arial; font-size:10px'><b>By Opening Balance</b></font>
					</td>
					<?php
						if($balt == DEBIT) {
					?>
						<td width='12%' align='right'>
							<font style='font-family:arial; font-size:10px'><b><?php echo number_format($bal,2)?></b></font>
						</td>
						<td width='12%' align='right'>
							<font style='font-family:arial; font-size:10px'><b>0.00</b></font>
						</td>
					<?php } else {
					?>
						<td width='12%' align='right'>
							<font style='font-family:arial; font-size:10px'><b>0.00</b></font>
						</td>
						<td width='12%' align='right'>
							<font style='font-family:arial; font-size:10px'><b><?php echo number_format($bal,2)?></b></font>
						</td>
					<?php } ?>
					<td width='15%' align='right'>
						<font style='font-family:arial; font-size:10px'><b><?php echo number_format($bal,2)?> <?php echo getDrCr($balt)?></b></font>
					</td>
				</tr>
			<?php
				for($i=0;$i<count($alDet);$i++) {
					$veb	=	$alDet[$i];
					
			?>
			
				<tr bgcolor="#ffffff">
					<td width='10%' valign="top">
						<font style='font-family:arial; font-size:10px'><?php echo FormatSQLDateToIndianDate($veb["DOV"])?></font>
					</td>
					<td width='14%' valign="top" onMouseOver="this.className='td_hover'" onMouseOut="this.className='td_normal'">&nbsp;</td>
					<td width='35%' valign="top">
						<font style='font-family:arial; font-size:10px'>
						<?php 
							if($veb["TxnType"] == PURCHASE) {
								echo "<a href='rptCashBookDetail.php?accid=".$accid."&txntype=".PURCHASE."&fdate=".$fdate."&tdate=".$tdate."' target='_blank'>PURCHASE</a>";
							} else if($veb["TxnType"] == PURCHASE_RETURN) {
								echo "<a href='rptCashBookDetail.php?accid=".$accid."&txntype=".PURCHASE_RETURN."&fdate=".$fdate."&tdate=".$tdate."' target='_blank'>PUIRCHASE RETURN</a>"; 
							} else if($veb["TxnType"] == SALE) { 
								echo "<a href='rptCashBookDetail.php?accid=".$accid."&txntype=".SALE."&fdate=".$fdate."&tdate=".$tdate."' target='_blank'>SALE</a>";
							} else if($veb["TxnType"] == SALE_RETURN) { 
								echo "<a href='rptCashBookDetail.php?accid=".$accid."&txntype=".SALE_RETURN."&fdate=".$fdate."&tdate=".$tdate."' target='_blank'>SALE RETURN</a>";
							} else {
								if($veb["VoucherType"] == CASH_RECEIPT_VOUCHER)
									echo "CASH RECEIPT";
								else if($veb["VoucherType"] == CASH_PAYMENT_VOUCHER)
									echo "CASH PAYMENT";
								else if($veb["VoucherType"] == CONTRA_VOUCHER)
									echo "CONTRA";
							}
						?>
						</font>
					</td>
					<?php
						if($veb["DrCr"] == DEBIT) {
							$totdr+=$veb["Amount"];
							if($balt == DEBIT)
								$bal+=$veb["Amount"];
							else
								$bal-=$veb["Amount"];
							if($bal < 0) {
								$bal=-$bal;
								$balt	=	DEBIT;
							}
					?>
						<td width='12%' align='right' valign="top">
							<font style='font-family:arial; font-size:10px'><?php echo number_format($veb["Amount"],2)?></font>
						</td>
						<td width='12%' align='right' valign="top">
							<font style='font-family:arial; font-size:10px'>0.00</font>
						</td>
					<?php
						} else {
							$totcr+=$veb["Amount"];
							if($balt == CREDIT)
								$bal+=$veb["Amount"];
							else
								$bal-=$veb["Amount"];
							if($bal < 0) {
								$bal=-$bal;
								$balt	=	CREDIT;
							}
					?>
						<td width='12%' align='right' valign="top">
							<font style='font-family:arial; font-size:10px'>0.00</font>
						</td>
						<td width='12%' align='right' valign="top">
							<font style='font-family:arial; font-size:10px'><?php echo number_format($veb["Amount"],2)?></font>
						</td>
					<?php } ?>
					<td width='15%' align='right' valign="top">
						<font style='font-family:arial; font-size:10px'><?php echo number_format($bal,2)?> <?php echo getDrCr($balt)?></font>
					</td>
				</tr>

			<?php
				}
			?>

				<tr bgcolor="#ffffff">
					<td width='10%'>
						<font style='font-family:arial; font-size:10px'>&nbsp;</font>
					</td>
					<td width='14%'>
						<font style='font-family:arial; font-size:10px'>&nbsp;</font>
					</td>
					<td width='35%'>
						<font style='font-family:arial; font-size:10px'><b>CURRENT TOTAL ***</b></font>
					</td>
					<td width='12%' align='right'>
						<font style='font-family:arial; font-size:10px'><b><?php echo number_format($totdr,2)?></b></font>
					</td>
					<td width='12%' align='right'>
						<font style='font-family:arial; font-size:10px'><b><?php echo number_format($totcr,2)?></b></font>
					</td>
					<td width='15%' align='right'>
						<font style='font-family:arial; font-size:10px'><b><?php echo number_format($bal,2)?> <?php echo getDrCr($balt)?></b></font>
					</td>
				</tr>
			</table>
		</div>
		
		<div style="font-size:11px; font-weight:bold; text-align:left">
			<br>CLOSING TOTAL: <?php echo CURRENCY_WORD?> <?php echo numToWord($bal,'Paise')?>
		</div>
		
	<br />
	<div style="text-align:center"><input type="button" value="Export to Excel" onClick="ExportToExcel()" class="red_button" /></div>
	<br />		
		
	</div>
</body>
</html>

<script type="text/javascript">

	function ExportToExcel(){
		 var tbl		= document.getElementById('main_table');
		 var html 	= tbl.outerHTML;
		 window.open('data:application/vnd.ms-excel,' + encodeURIComponent(html));
	}
	
</script>