<?php

	/* Include the required files */
	require_once( '../inc/functions.php' );
	require_once( '../aom-config.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/asys.voucherdb.php' );
	require_once( '../dao/class.purchasedb.php' );
	require_once( '../dao/asys.drcr.php' );
	require_once( '../dao/asys.group.php' );
	require_once( '../dao/asys.voucher.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 35;

	$db			=	new masterdb("REPORT");
	$vdb		=	new voucherdb("REPORT");
	$pdb		=	new purchasedb("REPORT");
	$ldb		= new logindb("REPORT");
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}		

	$accid		= 0;
	$vtype		= 0;
	$fdate		=	getFirstFinancialDate();
	$tdate		=	getLastFinancialDate();
	$expand		=	'no';

	extract($_REQUEST);

	$accid		=	(int)$accid;
	$vtype		=	(int)$vtype;
	$df				=	FormatIndianDateToSQLDate($fdate);
	$dt				=	FormatIndianDateToSQLDate($tdate);
	$ndt			=	getNextDate($df);	

	if($accid == 0 || $vtype == 0) {
		echo "Sorry!!! Direct Access not allowed here";
		exit;
	}

	$accDet		= $db->getAccountDetail($accid);
	$bal			= $accDet->getOBal();
	$balt			= $accDet->getOBalType();

	$clbal		=	$db->getClosingBalanceByAccountID($accid, $ndt);
	$bal			=	$clbal[0];
	$balt			=	$clbal[1];

	$alDet		= $vdb->getAccountVoucherTypeWise($accid, $vtype, $df, $dt);

	$totcr		= 0;
	$totdr		= 0;
	if($balt == DEBIT)
		$totdr	=	$bal;
	else
		$totcr	= $bal;

?>


<!DOCTYPE html>
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html;charset=utf-8"/>
		<title>Ledger of <?php echo $accDet->getAccountName()?></title>
		<link href="../css/rpt.css" type="text/css" rel="stylesheet">
		<script src="../js/common.js"></script>
	</head>
<body style="background-color:#ffffff">
	<div style="font-family:verdana;margin:0px auto;width:900px;font-size:12px;">

		<div style="font-size:10px; font-weight:bold;">
			<table cellSpacing='1' cellPadding='4' width='100%' bgcolor="#CCCCCC" id="main_table">
			
				<tr bgcolor="#FFFFFF">
					<td colspan="6" align="center">
						<div style="font-size:18px; letter-spacing:1pt;">
							<b><?php echo $tcmp->getCompanyName()?><br /></b>
						</div>
						<div style="font-size:15px; letter-spacing:1pt;">
							<?php echo nl2br($tcmp->getCompanyAddress())?>
						</div>
						<div style="font-size:15px; letter-spacing:1pt;">
							<b><br /><?php echo $accDet->getAccountName()?></b>
						</div>
						<div style="font-size:13px;">
							<b><?php echo $fdate?> - <?php echo $tdate?></b>
						</div>					
					</td>
				<tr>			
			
				<tr bgcolor="#f4f4f4">
					<td width='10%'>
						<font style='font-family:arial; font-size:11px'>DATE</font>
					</td>
					<td width='14%'>
						<font style='font-family:arial; font-size:11px'>DOC NO</font>
					</td>
					<td width='35%'>
						<font style='font-family:arial; font-size:11px'>PARTICULARS</font>
					</td>
					<td width='12%' align='right'>
						<font style='font-family:arial; font-size:11px'>DEBIT</font>
					</td>
					<td width='12%' align='right'>
						<font style='font-family:arial; font-size:11px'>CREDIT</font>
					</td>
					<td width='15%' align='right'>
						<font style='font-family:arial; font-size:11px'>BALANCE</font>
					</td>
				</tr>

				<tr bgcolor="#ffffff">
					<td>&nbsp;</td>
					<td>&nbsp;</td>
					<td>
						<font style='font-family:arial; font-size:10px'><b>By Opening Balance</b></font>
					</td>
					<?php
						if($balt == DEBIT) {
					?>
						<td align='right'>
							<font style='font-family:arial; font-size:10px'><b><?php echo number_format($bal,2)?></b></font>
						</td>
						<td align='right'>
							<font style='font-family:arial; font-size:10px'><b>0.00</b></font>
						</td>
					<?php } else {
					?>
						<td align='right'>
							<font style='font-family:arial; font-size:10px'><b>0.00</b></font>
						</td>
						<td align='right'>
							<font style='font-family:arial; font-size:10px'><b><?php echo number_format($bal,2)?></b></font>
						</td>
					<?php } ?>
					<td align='right'>
						<font style='font-family:arial; font-size:10px'><b><?php echo number_format($bal,2)?> <?php echo getDrCr($balt)?></b></font>
					</td>
				</tr>
			<?php
				for($i=0;$i<count($alDet);$i++) {
					$veb	=	$alDet[$i];
					if($expand == 'yes') {
						$vt		=	$veb->getVoucherType();
						$fy		=	$veb->getFinYear();
						$vid	=	$veb->getVoucherID();
						$olist=	$vdb->getOppositeVoucher($vt, $fy, $vid, $accid);
					}
			?>
				<tr bgcolor="#ffffff">
					<td valign="top">
						<font style='font-family:arial; font-size:10px'><?php echo $veb->getDOV('yes')?></font>
					</td>
					<td valign="top" onMouseOver="this.className='td_hover'" onMouseOut="this.className='td_normal'">
						<font style='font-family:arial; font-size:10px'>&nbsp;<?php echo getShortVoucherType($veb->getVoucherType()).'/'.FormatSQLDateToVoucherPrintFormat($veb->getDOV()).'/'.$veb->getDayWiseNo()?></font>
					</td>
					<td valign="top">
						<font style='font-family:arial; font-size:10px'>
						<?php 
							$narr		= $veb->getNarration();
							
							echo $narr;
						?>
						</font>
					</td>
					<?php
						if($veb->getDrCr() == DEBIT) {
							$totdr+=$veb->getAmount();
							if($balt == DEBIT)
								$bal+=$veb->getAmount();
							else
								$bal-=$veb->getAmount();
							if($bal < 0) {
								$bal=-$bal;
								$balt	=	DEBIT;
							}
					?>
						<td align='right'>
							<font style='font-family:arial; font-size:10px'><?php echo number_format($veb->getAmount(),2)?></font>
						</td>
						<td align='right'>
							<font style='font-family:arial; font-size:10px'>0.00</font>
						</td>
					<?php
						} else {
							$totcr+=$veb->getAmount();
							if($balt == CREDIT)
								$bal+=$veb->getAmount();
							else
								$bal-=$veb->getAmount();
							if($bal < 0) {
								$bal=-$bal;
								$balt	=	CREDIT;
							}
					?>
						<td align='right'>
							<font style='font-family:arial; font-size:10px'>0.00</font>
						</td>
						<td align='right' valign="top">
							<font style='font-family:arial; font-size:10px'><?php echo number_format($veb->getAmount(),2)?></font>
						</td>
					<?php } ?>
					<td align='right' valign="top">
						<font style='font-family:arial; font-size:10px'><?php echo number_format($bal,2)?> <?php echo getDrCr($balt)?></font>
					</td>
				</tr>
			<?php
					if($expand == 'yes') {
						for($j=0;$j<count($olist);$j++) {
							$ovch	=	$olist[$j];
							$tmp	=	"#f4f4f4";
							if($j%2==0)
								$tmp	=	"#e4e4e4";
			?>
							<tr bgcolor="#ffffff">
								<td>&nbsp;</td>
								<td>&nbsp;</td>
								<td bgcolor="<?php echo $tmp?>">
									<font style='font-family:verdana; font-size:10px'><?php echo $ovch->getAccountName('yes')?> - <?php echo $ovch->getAmount('yes')?> (<?php echo getDrCr($ovch->getDrCr())?>)</font>
								</td>
								<td>&nbsp;</td>
								<td>&nbsp;</td>
								<td>&nbsp;</td>
							</tr>
			<?php
						}
					}
				}
			?>

				<tr bgcolor="#ffffff">
					<td>&nbsp;</td>
					<td>&nbsp;</td>
					<td>
						<font style='font-family:arial; font-size:10px'><b>CURRENT TOTAL ***</b></font>
					</td>
					<td align='right'>
						<font style='font-family:arial; font-size:10px'><b><?php echo number_format($totdr,2)?></b></font>
					</td>
					<td align='right'>
						<font style='font-family:arial; font-size:10px'><b><?php echo number_format($totcr,2)?></b></font>
					</td>
					<td align='right'>
						<font style='font-family:arial; font-size:10px'><b><?php echo number_format($bal,2)?> <?php echo getDrCr($balt)?></b></font>
					</td>
				</tr>
			</table>
		</div>
		<div style="font-size:11px; font-weight:bold; text-align:left">
			<br>CLOSING TOTAL: <?php echo CURRENCY_WORD?> <?php echo numToWord($bal,'Paise')?>
		</div>
		
	<br />
	<div style="text-align:center"><input type="button" value="Export to Excel" onClick="ExportToExcel()" class="red_button" /></div>
	<br />		
		
	</div>
</body>
</html>

<script type="text/javascript">

	function ExportToExcel(){
		 var tbl		= document.getElementById('main_table');
		 var html 	= tbl.outerHTML;
		 window.open('data:application/vnd.ms-excel,' + encodeURIComponent(html));
	}
	
</script>