<?php

	/* Include the required files */
	require_once( '../inc/functions.php' );
	require_once( '../aom-config.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/asys.voucherdb.php' );
	require_once( '../dao/asys.drcr.php' );
	require_once( '../dao/asys.group.php' );
	require_once( '../dao/asys.voucher.php' );
	require_once( '../dao/asys.vouchertag.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 38;

	$db			=	new masterdb("REPORT");
	$vdb		=	new voucherdb("REPORT");
	$ldb		= new logindb("REPORT");
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}		

	$fdate		=	getFirstFinancialDate();

	extract($_REQUEST);

	$df				= FormatIndianDateToSQLDate($fdate);

	$jrnList	= $vdb->getAllVoucherList($df, $tcmp->getCompanyID());
	$totcr		= 0;
	$totdr		= 0;
	
?>


<!DOCTYPE html>
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html;charset=utf-8"/>
		<title>Day Book <?php echo $fdate?></title>
		<link href="../css/rpt.css" type="text/css" rel="stylesheet">
		<script src="../js/common.js"></script>
	</head>
<body style="background-color:#ffffff">
	<div style="font-family:verdana;margin:0px auto;width:900px;font-size:12px;">

		<div style="font-size:10px; font-weight:bold;">
			<table cellSpacing='1' cellPadding='4' width='950' border='0' bgcolor="#cccccc" id="main_table">
			
				<tr bgcolor="#FFFFFF">
					<td colspan="6" align="center">
						<div style="font-size:18px; letter-spacing:1pt;">
							<b><?php echo $tcmp->getCompanyName()?><br /></b>
						</div>
						<div style="font-size:15px; letter-spacing:1pt;">
							<?php echo nl2br($tcmp->getCompanyAddress())?>
						</div>
						<div style="font-size:13px;">
							<b>Day Book as on <?php echo $fdate?></b>
						</div>					
					</td>
				<tr>			
			
				<tr bgcolor="#E4E4E4">
					<td width='15%' class="td_normal bold">VOUCHER #</td>
					<td width='5%'>NO.</td>
					<td width='40%' class="td_normal bold">LEDGER</td>
					<td width='20%' class="td_normal bold">SUB LEDGER</td>										
					<td width='10%' class="td_normal bold" align='right'>DEBIT</td>
					<td width='10%' class="td_normal bold" align='right'>CREDIT</td>
				</tr>

			<?php
				$prev_vid	=	0;
				$vtype		= 0;
				$totvtdr	= 0;
				$totvtcr	= 0;
				for($i=0;$i<count($jrnList);$i++) {
					$veb		=	$jrnList[$i];
					
					if($vtype != $veb->getVoucherType()) {
						
						if($i != 0) {
			?>
						<tr bgcolor="#f4f4f4">					
							<td width='80%' colspan="4" class="td_normal bold"><?php echo strtoupper(getVoucherType($vtype)) ?> TOTAL ***</td>
							<td width='10%' align='right' class="td_normal bold"><?php echo number_format($totvtdr,2)?></td>
							<td width='10%' align='right' class="td_normal bold"><?php echo number_format($totvtcr,2)?></td>
						</tr>
						<tr bgcolor="#FFFFFF"><td colspan="6">&nbsp;</td></tr>
			<?php			
						}
						$vtype	= $veb->getVoucherType();
						$totvtdr	= 0;
						$totvtcr	= 0;						
			?>
						<tr bgcolor="#ffff99">
							<td colspan="6" class="td_normal bold"><?php echo strtoupper(getVoucherType($vtype)) ?></td>
						</tr>
			<?php
					}
					
					if($prev_vid != $veb->getVoucherID()) { 
						$prev_vid	=	$veb->getVoucherID();
			?>

						<tr bgcolor="#ffffff">
							<td width='15%' valign="top" class="td_normal">
								<?php echo getShortVoucherType($veb->getVoucherType()).'/'.FormatSQLDateToVoucherPrintFormat($veb->getDOV()).'/'.$veb->getDayWiseNo()?>
							</td>	
							
			<?php } else {?>		
			
				<tr bgcolor="#ffffff">
					<td width='15%' valign="top" class="td_normal">
						&nbsp;
					</td>
				<?php } ?>

					<td width='5%' valign="top" class="td_normal"><?php echo $veb->getSerialID()?></td>
							
				<?php	if($veb->getMotherAccount() != 0) { ?>				
					<td width='40%' valign="top" class="td_normal"><?php echo $veb->getMotherAccountName()?></td>
					<td width='20%' valign="top" class="td_normal"><?php echo $veb->getAccountName()?></td>
				<?php } else { ?>
					<td width='40%' valign="top" class="td_normal"><?php echo $veb->getAccountName()?></td>
					<td width='20%' valign="top">&nbsp;</td>				
				<?php } ?>
															
					<?php
						if($veb->getDrCr() == DEBIT) {
							$totdr+=$veb->getAmount();
							$totvtdr+=$veb->getAmount();
					?>
						<td width='10%' align='right' valign="top" class="td_normal"><?php echo number_format($veb->getAmount(),2)?></td>
						<td width='10%' align='right' valign="top" class="td_normal">0.00</td>
					<?php
						} else {
							$totcr+=$veb->getAmount();
							$totvtcr+=$veb->getAmount();
					?>
						<td width='10%' align='right' valign="top" class="td_normal">0.00</td>
						<td width='10%' align='right' valign="top" class="td_normal"><?php echo number_format($veb->getAmount(),2)?></td>
					<?php } ?>
				</tr>

			<?php
				}
			?>

				<tr bgcolor="#f4f4f4">					
					<td colspan="4" width='80%' class="td_normal bold"><?php echo strtoupper(getVoucherType($vtype)) ?> TOTAL ***</td>
					<td width='10%' align='right' class="td_normal bold"><?php echo number_format($totvtdr,2)?></td>
					<td width='10%' align='right' class="td_normal bold"><?php echo number_format($totvtcr,2)?></td>
				</tr>
				<tr bgcolor="#FFFFFF"><td colspan="6">&nbsp;</td></tr>			
				<tr bgcolor="#f4f4f4">					
					<td colspan="4" width='80%' class="td_normal bold">CURRENT TOTAL ***</td>
					<td width='10%' align='right' class="td_normal bold"><?php echo number_format($totdr,2)?></td>
					<td width='10%' align='right' class="td_normal bold"><?php echo number_format($totcr,2)?></td>
				</tr>
			</table>
		</div>
		
	<br />
	<div style="text-align:center"><input type="button" value="Export to Excel" onClick="ExportToExcel()" class="red_button" /></div>
	<br />		
		
	</div>
</body>
</html>

<script type="text/javascript">

	function ExportToExcel(){
		 var tbl		= document.getElementById('main_table');
		 var html 	= tbl.outerHTML;
		 window.open('data:application/vnd.ms-excel,' + encodeURIComponent(html));
	}
	
</script>