<?php

	/* Include the required files */
	require_once( '../aom-config.php' );
	require_once( '../inc/functions.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/class.gen_grn.php' );
	require_once( '../dao/class.gen_grn_items.php' );	
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/class.purchasedb.php' );	
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );	

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 44;
	
	$mdb		=	new masterdb("REPORT");
	$pdb		= new purchasedb("REPORT");
	$ldb		= new logindb("REPORT");
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}	
	
	
	$fdate				= "";
	$tdate				= "";
	$sid					= 0;
	
	extract($_REQUEST);
	
	$dt1					= FormatIndianDateToSQLDate($fdate);
	$dt2					= FormatIndianDateToSQLDate($tdate);
	$sid					= (int)$sid;
	$sdet					= $mdb->getAccountDetail($sid);
	
	$grnList			= $pdb->getGRNListReport($tcmp->getCompanyID(), $dt1, $dt2, $sid);
	
?>

<!DOCTYPE html>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<meta http-equiv="Content-Type" content="text/html; charset=utf8">
<title></title>
</head>

<body topmargin="0" leftmargin="0" rightmargin="0" bottommargin="0" marginwidth="0" marginheight="0">

<div align="center">

<table border="0" width="900" cellspacing="0" cellpadding="0">
	<tr>
		<td height="60">
		<p align="center" style="margin-top: 0; margin-bottom: 0"><b>
		<font size="6" face="Arial"><?php echo $tcmp->getCompanyName()?></font></b></td>
	</tr>
	<tr>
		<td height="24">
		<p align="center" style="margin-top: 0; margin-bottom: 0"><b>
		<font face="Arial" size="2">GRN - SUPPLIER WISE</font></b></td>
	</tr>
	<tr>
		<td height="24">
		<p align="center">
		<b><font face="Arial" size="2">Date : <?php echo $fdate?> - <?php echo $tdate?> <?php if($sid != 0) echo ', '.$sdet->getAccountName()?></font></b></td>
	</tr>
	<tr>
		<td>
		<table border="1" width="100%" cellpadding="4" style="border-collapse: collapse" bordercolor="#808080">
			<tr>
				<td align="center" width="10%"><b><font face="Arial" style="font-size: 11pt">Sl. No.</font></b></td>
				<td align="center" width="15%"><b><font face="Arial" style="font-size: 11pt">GRN No.</font></b></td>
				<td align="center" width="15%"><b><font face="Arial" style="font-size: 11pt">GRN Date</font></b></td>
				<td align="center" width="25%"><b><font face="Arial" style="font-size: 11pt">Supplier</font></b></td>
				<td align="center" width="20%"><b><font face="Arial" style="font-size: 11pt">Store</font></b></td>
				<td align="center" width="15%"><b><font face="Arial" style="font-size: 11pt">Amount</font></b></td>
			</tr>
			
			<?php
				$cnt		= 0;
				for($i=0;$i<count($grnList);$i++) {
					$row	= $grnList[$i];
			?>
			
			<tr>
				<td align="left" width="10%"><b><font face="Arial" style="font-size: 11pt"><?php echo ($i+1)?></font></b></td>
				<td align="center" width="15%"><b><font face="Arial" style="font-size: 11pt"><?php echo $row->getGRNNo().'/'.$row->getFinYear()?></font></b></td>
				<td align="center" width="15%"><b><font face="Arial" style="font-size: 11pt"><?php echo $row->getGRNDate('yes')?></font></b></td>
				<td align="left" width="25%"><b><font face="Arial" style="font-size: 11pt"><?php echo $row->getSupplierName()?></font></b></td>
				<td align="left" width="20%"><b><font face="Arial" style="font-size: 11pt"><?php echo $row->getStoreName()?></font></b></td>
				<td align="right" width="15%"><b><font face="Arial" style="font-size: 11pt"><?php echo $row->getItemTotal('yes')?></font></b></td>
			</tr>

			<?php } ?>

			</table>
		</td>
	</tr>
	<tr>
		<td>
		&nbsp;</td>
	</tr>
	</table>

</div>

</body>

</html>
