<?php

	/* Include the required files */
	require_once( '../aom-config.php' );
	require_once( '../inc/functions.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/class.gen_grn.php' );
	require_once( '../dao/class.gen_grn_items.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/class.purchasedb.php' );	
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );	

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 44;
	
	$mdb		=	new masterdb("REPORT");
	$pdb		= new purchasedb("REPORT");
	$ldb		= new logindb("REPORT");
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}	
	
	
	$fdate				= "";
	$tdate				= "";
	$sid					= 0;
	
	extract($_REQUEST);
	
	$dt1					= FormatIndianDateToSQLDate($fdate);
	$dt2					= FormatIndianDateToSQLDate($tdate);
	$sid					= (int)$sid;
	$sdet					= $mdb->getAccountDetail($sid);
	
	$grnList			= $pdb->getGRNItemQuantity($tcmp->getCompanyID(), $dt1, $dt2, $sid);
	
?>

<!DOCTYPE html>
<html>

<head>
<meta http-equiv="Content-Language" content="en">
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title></title>
</head>

<body topmargin="0" leftmargin="0" rightmargin="0" bottommargin="0" marginwidth="0" marginheight="0">

<div align="center">
	<table border="0" width="800" cellspacing="0" cellpadding="0">
		<tr>
			<td height="60">
			<p align="center" style="margin-top: 0; margin-bottom: 0"><b>
			<font size="6" face="Arial"><?php echo $tcmp->getCompanyName()?></font></b></td>
		</tr>
		<tr>
			<td height="30">
				<p align="center"><b><font face="Arial">GRN Summary Report - <?php if($sid != 0) echo ', '.$sdet->getAccountName()?></font></b>
			</td>
		</tr>
		<tr>
			<td height="30">
				<p align="center"><font size="2" face="Arial"><b>Date : <?php echo $fdate?> - <?php echo $tdate?></b></font>
			</td>
		</tr>
		<tr>
			<td>
				<table border="1" width="100%" cellpadding="4" style="border-collapse: collapse" bordercolor="#333333">
					<tr bgcolor="#E8E8E8">
						<td width="10%" align="center"><b><font face="Arial" size="2">Sl. No.</font></b></td>
						<td align="center" width="60%"><b><font face="Arial" size="2">Item Name</font></b></td>
						<td align="center" width="15%"><b><font face="Arial" size="2">Total Qty.</font></b></td>
						<td align="center" width="15%"><b><font face="Arial" size="2">Total Value</font></b></td>
					</tr>
					<?php
						$tot			= 0;
						for($i=0;$i<count($grnList);$i++) {
							$row		= $grnList[$i];
							$tot		= $tot + $row[2];
					?>								
						<tr>
							<td><font face="Arial" size="2"><?php echo ($i+1)?></font></td>
							<td width="60%"><font face="Arial" size="2"><?php echo $mdb->getItemNameByItemID($row[0])?></font></td>
							<td align="right" width="15%"><font face="Arial" size="2"><?php echo $row[1]?></font></td>
							<td align="right" width="15%"><font face="Arial" size="2"><?php echo $row[2]?></font></td>
						</tr>
					<?php } ?>			
					<tr>
						<td colspan="3" align="right"><b><font face="Arial" size="2">Total Value</font></b></td>
						<td align="right" width="15%" height="30"><font face="Arial" size="2"><?php echo $tot?></font></td>
					</tr>
				</table>
			</td>
		</tr>
		<tr>
			<td>&nbsp;</td>
		</tr>
	</table>
</div>

<p align="center">&nbsp;</p>

</body>

</html>

