<?php

	/* Include the required files */
	require_once( '../aom-config.php' );
	require_once( '../inc/functions.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/class.gen_items.php' );
	require_once( '../dao/class.gen_sale.php' );
	require_once( '../dao/class.gen_sale_items.php' );
	require_once( '../dao/class.gen_sale_addless.php' );	
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/class.purchasedb.php' );
	require_once( '../dao/class.saledb.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );	

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 51;
	
	$mdb		=	new masterdb("REPORT");
	$ldb		= new logindb("REPORT");
	$sdb		=	new saledb("REPORT");
	$pdb		=	new purchasedb("REPORT");
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}

	$mntArr			= array("", "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");	
	
	$fdate			= "";
	$tdate			= "";
	
	extract($_REQUEST);
	
	$df					= FormatIndianDateToSQLDate($fdate);
	$dt					= FormatIndianDateToSQLDate($tdate);
	
	$cid				= $tcmp->getCompanyID();
	
	$totigst		= $sdb->getOutwardTaxAll($cid, $df, $dt, 'IGST');
	$totcgst		= $sdb->getOutwardTaxAll($cid, $df, $dt, 'CGST');
	$totsgst		= $sdb->getOutwardTaxAll($cid, $df, $dt, 'SGST');
	
	$itcval			= $pdb->getAllOtherITCTaxableValue($cid, $df, $dt);
	$itcigst		= $pdb->getAllOtherITCTax($cid, $df, $dt, 'IGST');
	$itccgst		= $pdb->getAllOtherITCTax($cid, $df, $dt, 'CGST');
	$itcsgst		= $pdb->getAllOtherITCTax($cid, $df, $dt, 'SGST');
	
	$itcvalr		= $pdb->getAllOtherITCReverseValue($cid, $df, $dt);
	$itcigstr		= $pdb->getAllOtherITCReverse($cid, $df, $dt, 'IGST');
	$itccgstr		= $pdb->getAllOtherITCReverse($cid, $df, $dt, 'CGST');
	$itcsgstr		= $pdb->getAllOtherITCReverse($cid, $df, $dt, 'SGST');
	
	$itcvalr_ks		= $pdb->getAllOtherITCReverseValueStore($cid, $df, $dt, 3);
	$itcigstr_ks	= $pdb->getAllOtherITCReverseStore($cid, $df, $dt, 'IGST', 3);
	$itccgstr_ks	= $pdb->getAllOtherITCReverseStore($cid, $df, $dt, 'CGST', 3);
	$itcsgstr_ks	= $pdb->getAllOtherITCReverseStore($cid, $df, $dt, 'SGST', 3);	
	
?>

<!DOCTYPE html>
<html>

<head>
	<meta http-equiv="Content-Language" content="en" />
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<title>GST 3B</title>
</head>

<body topmargin="20" leftmargin="0" rightmargin="0" bottommargin="0" marginwidth="0" marginheight="0">

<div align="center">
	<table border="1" width="900" cellspacing="0" cellpadding="0" style="border-collapse: collapse" bordercolor="#666666" id="main_table">
		<tr>
			<td>
			<div align="left">
			<table border="0" width="99%" cellpadding="0" cellspacing="0">
				<tr>
					<td height="50" colspan="2" align="center">
						<font face="Arial"><b><span style="font-size: 11pt">Form GSTR - 3B</span><br /></b><span style="font-size: 11pt">[See Rule 61 (5)]</span></font>
					</td>
				</tr>
				<tr>
					<td width="5%">
					<p align="right">
					<font face="Arial" style="font-size: 11pt; font-weight: 700">
					1.</font></td>
					<td width="95%">
					<table border="0" width="100%" cellpadding="2">
						<tr>
							<td width="75%"><font face="Arial">
							<font style="font-size: 11pt">GST # 
							</font><b><font style="font-size: 11pt"><?php echo $tcmp->getGST()?></font></b></font></td>
							<td width="25%">
							<p align="right"><font face="Arial"><font style="font-size: 11pt">Year 
							: </font><b><font style="font-size: 11pt"></font></b></font></td>
						</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td width="5%">
					<p align="right">
					<font face="Arial" style="font-size: 11pt; font-weight: 700">
					2.</font></td>
					<td width="95%">
					<table border="0" width="100%" cellpadding="2">
						<tr>
							<td width="75%"><font face="Arial">
							<font style="font-size: 11pt">Name of Taxable Person/Company :
							</font><b><font style="font-size: 11pt"><?php echo $tcmp->getCompanyName()?></font></b></font></td>
							<td width="25%" align="right">
								<font face="Arial"><font style="font-size: 11pt">From 
							: </font><b><font style="font-size: 11pt"><?php echo $fdate ?> To <?php echo $tdate ?></font></b></font></td>
						</tr>
					</table>
					</td>
				</tr>
				<tr>
					<td width="5%" height="30" bgcolor="#E6E6E6">
					<p align="right"><font face="Arial">
							<span style="font-size: 11pt; font-weight:700">3.1.</span></font></td>
					<td width="95%" height="30" bgcolor="#E6E6E6">
					<table border="0" width="100%" cellpadding="2">
						<tr>
							<td width="100%">
							<font face="Arial">
							<span style="font-size: 11pt; font-weight:700">Details of 
							Outward Supplies and inward supplies liable to 
							reverse charge</span></font></td>
						</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td width="5%">&nbsp;</td>
					<td width="95%">
					<table border="1" width="100%" cellpadding="2" style="border-collapse: collapse" bordercolor="#666666">
						<tr>
							<td align="center" width="40%">
							<p align="left">
							<font face="Arial" style="font-size: 11pt; font-weight: 700">
							Name of Supplies</font></td>
							<td align="center" width="12%">
							<font face="Arial" style="font-size: 11pt; font-weight: 700">
							Taxable<br>
							Value</font></td>
							<td align="center" width="12%">
							<font face="Arial" style="font-size: 11pt; font-weight: 700">
							Integrated<br>
							Tax</font></td>
							<td align="center" width="12%">
							<font face="Arial" style="font-size: 11pt; font-weight: 700">
							Central<br>
							Tax</font></td>
							<td align="center" width="12%">
							<font face="Arial" style="font-size: 11pt; font-weight: 700">
							State/UT<br>
							Tax</font></td>
							<td align="center" width="12%">
							<font face="Arial" style="font-size: 11pt; font-weight: 700">
							Cess</font></td>
						</tr>
						<tr>
							<td width="40%">
							<font face="Arial" style="font-size: 11pt">(a) 
							Outward taxable supplies<br>
							(other than zero rated, nil rated and exempted)</font></td>
							<td width="12%" align="right">
							<font face="Arial" style="font-size: 11pt"><?php echo number_format($sdb->getOutwardTaxableValueAll($cid, $df, $dt), 2)?></font></td>
							<td width="12%" align="right">
							<font face="Arial" style="font-size: 11pt"><?php echo number_format($sdb->getOutwardTaxAll($cid, $df, $dt, 'IGST'), 2)?></font></td>
							<td width="12%" align="right">
							<font face="Arial" style="font-size: 11pt"><?php echo number_format($sdb->getOutwardTaxAll($cid, $df, $dt, 'CGST'), 2)?></font></td>
							<td width="12%" align="right">
							<font face="Arial" style="font-size: 11pt"><?php echo number_format($sdb->getOutwardTaxAll($cid, $df, $dt, 'SGST'), 2)?></font></td>
							<td width="12%" align="right">
							<font face="Arial" style="font-size: 11pt">0.00</font></td>
						</tr>
						<tr>
							<td width="40%" height="30">
							<font face="Arial" style="font-size: 11pt">(b) Outward Taxable supplies (zero rated) </font></td>
							<td width="12%" align="right" height="30"> <font face="Arial" style="font-size: 11pt"><?php echo number_format($sdb->getOutwardTaxableValueZeroRated($cid, $df, $dt), 2)?></font></td>
							<td width="12%" align="right" height="30"> <font face="Arial" style="font-size: 11pt"></font></td>
							<td width="12%" align="right" height="30"> <font face="Arial" style="font-size: 11pt"></font></td>
							<td width="12%" align="right" height="30"> <font face="Arial" style="font-size: 11pt"></font></td>
							<td width="12%" align="right" height="30"> <font face="Arial" style="font-size: 11pt">0.00</font></td>
						</tr>
						<tr>
							<td width="40%" height="30"> <font face="Arial" style="font-size: 11pt">(c) Other outward supplies (Nil rated, exempted) </font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php echo number_format($sdb->getOutwardTaxableValueNilExempted($cid, $df, $dt), 2)?></font></td>
							<td width="12%" align="right" height="30"> <font face="Arial" style="font-size: 11pt"></font></td>
							<td width="12%" align="right" height="30"> <font face="Arial" style="font-size: 11pt"></font></td>
							<td width="12%" align="right" height="30"> <font face="Arial" style="font-size: 11pt"></font></td>
							<td width="12%" align="right" height="30"> <font face="Arial" style="font-size: 11pt"></font></td>
						</tr>
						<tr>
							<td width="40%" height="30"><font face="Arial" style="font-size: 11pt">(d) Inward supplies (liable to reverse charge)</font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php echo number_format($pdb->getInwardTaxableValueReverseCharge($cid, $df, $dt), 2)?></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php echo number_format($pdb->getInwardTaxReverseCharge($cid, $df, $dt, 'IGST'), 2)?></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php echo number_format($pdb->getInwardTaxReverseCharge($cid, $df, $dt, 'CGST'), 2)?></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php echo number_format($pdb->getInwardTaxReverseCharge($cid, $df, $dt, 'SGST'), 2)?></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt">0.00</font></td>
						</tr>
						<tr>
							<td width="40%" height="30"><font face="Arial" style="font-size: 11pt">(e) Non-GST outward supplies</font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php echo number_format($sdb->getOutwardTaxableValueNonGST($cid, $df, $dt), 2)?></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"></font></td>
						</tr>
					</table>
					</td>
				</tr>
				<tr>
					<td width="5%" height="30" bgcolor="#E6E6E6">
					<p align="right"><font face="Arial">
							<span style="font-size: 11pt; font-weight:700">3.2.</span></font></td>
					<td width="95%" height="30" bgcolor="#E6E6E6">
					<table border="0" width="100%" cellpadding="2">
						<tr>
							<td width="100%">
							<font face="Arial">
							<span style="font-size: 11pt; font-weight:700">Of 
							the supplies shown in 3.1 (a) above, details of 
							Inter-state supplies made to unregistered persons.<br>
							Composition taxable persons and UIN holders</span></font></td>
						</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td width="5%">&nbsp;</td>
					<td width="95%">
					<table border="1" width="100%" cellpadding="2" style="border-collapse: collapse" bordercolor="#666666">
						<tr>
							<td align="left" width="40%"><font face="Arial" style="font-size: 11pt; font-weight: 700">Details</font></td>
							<td align="center" width="20%"><font face="Arial" style="font-size: 11pt; font-weight: 700">Place of Supply<br />State / UT</font></td>
							<td align="center" width="20%"><font face="Arial" style="font-size: 11pt; font-weight: 700">Taxable<br />Value</font></td>
							<td align="center" width="20%"><font face="Arial" style="font-size: 11pt; font-weight: 700">Integrated<br />Tax</font></td>
						</tr>
						
						<?php
							$urValue	= $sdb->getOutwardTaxableValueUnregistered($cid, $tcmp->getState(), $df, $dt);
							$urIGST		= $sdb->getIGSTValueUnregistered($cid, $tcmp->getState(), $df, $dt);

							for($i=0;$i<count($urValue);$i++) {
								$row	= $urValue[$i];
								$row2	= $urIGST[$i];
						?>
						<tr>
							<?php if($i == 0) { ?>
							<td width="40%" height="30" valign="top" rowspan="<?php echo count($urValue)?>"><font face="Arial" style="font-size: 11pt">Supplies made to unregistered Person</font></td>
							<?php } ?>
							<td width="20%" align="center" height="30"><font face="Arial" style="font-size: 11pt"><?php echo $row[0]?></font></td>
							<td width="20%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php echo $row[1]?></font></td>
							<td width="20%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php echo $row2[0]?></font></td>
						</tr>
						<?php } ?>
						
						<?php if(count($urValue) == 0) { ?>
						<tr>
							<td width="40%" height="30" valign="top" rowspan="<?php echo count($urValue)?>"><font face="Arial" style="font-size: 11pt">Supplies made to unregistered Person</font></td>
							<td width="20%" align="center" height="30"><font face="Arial" style="font-size: 11pt">-</font></td>
							<td width="20%" align="right" height="30"><font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="20%" align="right" height="30"><font face="Arial" style="font-size: 11pt">0.00</font></td>
						</tr>						
						<?php } ?>
						
						<tr>
							<td width="40%" height="30"><font face="Arial" style="font-size: 11pt">Supplies made to Composition Taxable Persons</font></td>
							<td width="20%" align="center" height="30">-</td>
							<td width="20%" align="right" height="30"><font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="20%" align="right" height="30"><font face="Arial" style="font-size: 11pt">0.00</font></td>
						</tr>
						
						<tr>
							<td width="40%" height="30"><font face="Arial" style="font-size: 11pt">Supplies made to UIN Holder</font></td>
							<td width="20%" align="center" height="30">-</td>
							<td width="20%" align="right" height="30"><font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="20%" align="right" height="30"><font face="Arial" style="font-size: 11pt">0.00</font></td>
						</tr>
						
					</table>
					</td>
				</tr>
				<tr>
					<td width="5%" height="30" bgcolor="#E6E6E6">
					<p align="right"><font face="Arial">
					<span style="font-size: 11pt; font-weight:700">4.</span></font></td>
					<td width="95%" height="30" bgcolor="#E6E6E6">
					<table border="0" width="100%" cellpadding="2">
						<tr>
							<td width="100%">
							<font face="Arial">
							<span style="font-size: 11pt; font-weight:700">
							Eligible ITC</span></font></td>
						</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td width="5%">&nbsp;</td>
					<td width="95%">
					<table border="1" width="100%" cellpadding="2" style="border-collapse: collapse" bordercolor="#666666">
						<tr>
							<td align="left" width="40%"><font face="Arial" style="font-size: 11pt; font-weight: 700">(A) ITC available (Whether in full or part)</font></td>
							<td align="center" width="12%"><font face="Arial" style="font-size: 11pt; font-weight: 700">Taxable<br />Value</font></td>
							<td align="center" width="12%"><font face="Arial" style="font-size: 11pt; font-weight: 700">Integrated<br />Tax</font></td>
							<td align="center" width="12%"><font face="Arial" style="font-size: 11pt; font-weight: 700">Central<br />Tax</font></td>
							<td align="center" width="12%"><font face="Arial" style="font-size: 11pt; font-weight: 700">State/UT<br />Tax</font></td>
							<td align="center" width="12%"><font face="Arial" style="font-size: 11pt; font-weight: 700">Cess</font></td>
						</tr>
						<tr>
							<td width="40%" height="30"><font face="Arial" style="font-size: 11pt">(1) Import of Goods</font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php echo number_format($pdb->getTotalImportOfGoods($cid, $df, $dt), 2)?></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt">0.00</font></td>
						</tr>
						<tr>
							<td width="40%" height="30"><font face="Arial" style="font-size: 11pt">(2) Import of Services </font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php echo number_format($pdb->getTotalImportOfServices($cid, $df, $dt), 2)?></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt">0.00</font></td>
						</tr>
						<tr>
							<td width="40%" height="30"><font face="Arial" style="font-size: 11pt">(3) Inward supplies liable to reverse charge<br />(other than 1 &amp; 2 above)</font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php echo number_format($pdb->getInwardTaxableValueReverseCharge($cid, $df, $dt), 2)?></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php echo number_format($pdb->getInwardTaxReverseCharge($cid, $df, $dt, 'IGST'), 2)?></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php echo number_format($pdb->getInwardTaxReverseCharge($cid, $df, $dt, 'CGST'), 2)?></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php echo number_format($pdb->getInwardTaxReverseCharge($cid, $df, $dt, 'SGST'), 2)?></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt">0.00</font></td>
						</tr>
						<tr>
							<td width="40%" height="30">
							<font face="Arial" style="font-size: 11pt">(4) Inward supplies from ISD </font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"></font></td>
						</tr>
						<tr>
							<td width="40%" height="30"><font face="Arial" style="font-size: 11pt">(5) All other ITC</font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php echo number_format($itcval, 2)?></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php echo number_format($itcigst, 2)?></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php echo number_format($itccgst, 2)?></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php echo number_format($itcsgst, 2)?></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt">0.00</font></td>
						</tr>
					</table>
					</td>
				</tr>
				<tr>
					<td width="5%">&nbsp;</td>
					<td width="95%">&nbsp;</td>
				</tr>
				<tr>
					<td width="5%">&nbsp;</td>
					<td width="95%">
					<table border="1" width="100%" cellpadding="2" style="border-collapse: collapse" bordercolor="#666666">
						<tr>
							<td align="left" width="40%"><font face="Arial" style="font-size: 11pt; font-weight: 700">(B) ITC Reversed</font></td>
							<td align="center" width="12%"><font face="Arial" style="font-size: 11pt; font-weight: 700">Taxable<br />Value</font></td>
							<td align="center" width="12%"><font face="Arial" style="font-size: 11pt; font-weight: 700">Integrated<br />Tax</font></td>
							<td align="center" width="12%"><font face="Arial" style="font-size: 11pt; font-weight: 700">Central<br />Tax</font></td>
							<td align="center" width="12%"><font face="Arial" style="font-size: 11pt; font-weight: 700">State/UT<br />Tax</font></td>
							<td align="center" width="12%"><font face="Arial" style="font-size: 11pt; font-weight: 700">Cess</font></td>
						</tr>
						<tr>
							<td width="40%" height="30"><font face="Arial" style="font-size: 11pt">(1) As Per rules 42 &amp; 43 of CGST Rules</font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt">0.00</font></td>
						</tr>
						<tr>
							<td width="40%" height="30"><font face="Arial" style="font-size: 11pt">(2) Others </font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php echo number_format($itcvalr, 2)?></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php echo number_format($itcigstr, 2)?></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php echo number_format($itccgstr, 2)?></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php echo number_format($itcsgstr, 2)?></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt">0.00</font></td>
						</tr>
						<tr>
							<td width="40%" height="30"><font face="Arial" style="font-size: 11pt; font-weight: 700">(C) Net ITC Available (A) - (B)</font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php echo number_format($itcval - ($itcvalr), 2)?></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php echo number_format($itcigst - ($itcigstr), 2)?></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php echo number_format($itccgst - ($itccgstr), 2)?></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php echo number_format($itcsgst - ($itcsgstr), 2)?></font></td>
							<td width="12%" align="right" height="30"><font face="Arial" style="font-size: 11pt; font-weight: 700">0.00</font></td>
						</tr>
						<tr>
							<td width="100%" height="30" colspan="6"><font face="Arial" style="font-size: 11pt; font-weight: 700">(D) Ineligible ITC</font></td>
						</tr>
						<tr>
							<td width="40%" height="30"><font face="Arial" style="font-size: 11pt">(1) As per Section 17(5)</font></td>
							<td width="12%" align="right" height="30"> <font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="12%" align="right" height="30"> <font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="12%" align="right" height="30"> <font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="12%" align="right" height="30"> <font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="12%" align="right" height="30"> <font face="Arial" style="font-size: 11pt">0.00</font></td>
						</tr>
						<tr>
							<td width="40%" height="30"><font face="Arial" style="font-size: 11pt">(2) Others</font></td>
							<td width="12%" align="right" height="30"> <font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="12%" align="right" height="30"> <font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="12%" align="right" height="30"> <font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="12%" align="right" height="30"> <font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="12%" align="right" height="30"> <font face="Arial" style="font-size: 11pt">0.00</font></td>
						</tr>
					</table>
					</td>
				</tr>
				<tr>
					<td width="5%" height="30" bgcolor="#E6E6E6">
					<p align="right"><font face="Arial">
					<span style="font-size: 11pt; font-weight:700">5.</span></font></td>
					<td width="95%" height="30" bgcolor="#E6E6E6">
					<table border="0" width="100%" cellpadding="2">
						<tr>
							<td width="100%">
							<font face="Arial">
							<span style="font-size: 11pt; font-weight:700">
							Values of exempt, Nil-rated and Non-GST inward 
							supplies</span></font></td>
						</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td width="5%">&nbsp;</td>
					<td width="95%">
					<table border="1" width="100%" cellpadding="2" style="border-collapse: collapse" bordercolor="#666666">
						<tr>
							<td align="center" width="60%">
							<p align="left">
							<font face="Arial" style="font-size: 11pt; font-weight: 700">
							Nature of Supplies</font></td>
							<td align="center" width="20%">
							<span style="font-weight: 700">
							<font face="Arial" style="font-size: 11pt">Inter 
							State<br>
							Supplies</font></span></td>
							<td align="center" width="20%">
							<span style="font-weight: 700">
							<font face="Arial" style="font-size: 11pt">Intra 
							State<br>
							Supplies</font></span></td>
						</tr>
						<tr>
							<td width="60%" height="30">
							<font face="Arial" style="font-size: 11pt">From a 
							supplier under composition scheme, Exempt and Nil 
							rated supply</font></td>
							<td width="20%" align="right" height="30">
							<font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="20%" align="right" height="30">
							<font face="Arial" style="font-size: 11pt">0.00</font></td>
						</tr>
						<tr>
							<td width="60%" height="30">
							<font face="Arial" style="font-size: 11pt">Non GST 
							Supply </font></td>
							<td width="20%" align="right" height="30">
							<font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="20%" align="right" height="30">
							<font face="Arial" style="font-size: 11pt">0.00</font></td>
						</tr>
					</table>
					</td>
				</tr>
				<tr>
					<td width="5%" height="30" bgcolor="#E6E6E6">
					<p align="right"><font face="Arial">
					<span style="font-size: 11pt; font-weight:700">6.1.</span></font></td>
					<td width="95%" height="30" bgcolor="#E6E6E6">
					<table border="0" width="100%" cellpadding="2">
						<tr>
							<td width="100%">
							<font face="Arial">
							<span style="font-size: 11pt; font-weight:700">
							Payment of Tax</span></font></td>
						</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td width="5%">&nbsp;</td>
					<td width="95%">
					<table border="1" width="100%" cellpadding="2" style="border-collapse: collapse" bordercolor="#666666">
						<tr>
							<td align="center" width="36%" rowspan="2">
							<p align="left">
							<font face="Arial" style="font-size: 11pt; font-weight: 700">
							Description</font></td>
							<td align="center" width="8%" rowspan="2">
							<font face="Arial" style="font-size: 11pt; font-weight: 700">
							Tax<br>
							Payable</font></td>
							<td align="center" width="24%" colspan="3">
							<font face="Arial" style="font-size: 11pt; font-weight: 700">
							Paid Through ITC</font></td>
							<td align="center" width="8%" rowspan="2">
							<font face="Arial" style="font-size: 11pt; font-weight: 700">
							Tax Paid<br>
							TDS/TCS</font></td>
							<td align="center" width="8%" rowspan="2">
							<font face="Arial" style="font-size: 11pt; font-weight: 700">
							Tax/Cess<br>
							Paid in Cash</font></td>
							<td align="center" width="8%" rowspan="2">
							<span style="font-weight: 700">
							<font face="Arial" style="font-size: 11pt">Interest</font></span></td>
							<td align="center" width="8%" rowspan="2">
							<span style="font-weight: 700">
							<font face="Arial" style="font-size: 11pt">Late<br>
							Fee</font></span></td>
						</tr>
						<tr>
							<td align="center" width="8%">
							<span style="font-weight: 700">
							<font face="Arial" style="font-size: 11pt">IGST</font></span></td>
							<td align="center" width="8%">
							<font face="Arial" style="font-size: 11pt; font-weight: 700">
							CGST</font></td>
							<td align="center" width="8%">
							<font face="Arial" style="font-size: 11pt; font-weight: 700">
							S/U GST</font></td>
						</tr>
						
						<?php 
							$tbal	= $itcigst - ($itcigstr);
							if($totigst > 0) {
								if($totigst > $tbal)
									$tbal	= 0;
								else
									$tbal	= $tbal - $totigst;
							}
						 ?>						
						
						<tr>
							<td width="36%" height="30"><font face="Arial" style="font-size: 11pt">Integrated Tax</font></td>
							<td width="8%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php echo number_format($totigst, 2)?></font></td>
							<td width="8%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php if($totigst > 0) echo number_format($itcigst - ($itcigstr), 2)?></font></td>
							<td width="8%" align="right" height="30"><font face="Arial" style="font-size: 11pt"></font></td>
							<td width="8%" align="right" height="30"><font face="Arial" style="font-size: 11pt"></font></td>
							<td width="8%" align="right" height="30"><font face="Arial" style="font-size: 11pt"></font></td>
							<td width="8%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php if($totigst > 0) echo number_format($totigst - ($itcigst - ($itcigstr)), 2)?></font></td>
							<td width="8%" align="right" height="30"><font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="8%" align="right" height="30"><font face="Arial" style="font-size: 11pt">0.00</font></td>
						</tr>
						
						<?php 
							$tbal2		= 0;
							if($tbal > $totcgst) {
								$tbal2	= $tbal - $totcgst;
							}
						 ?>						
						
						<tr>
							<td width="36%" height="30"><font face="Arial" style="font-size: 11pt">Central  Tax </font></td>
							<td width="8%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php echo number_format($totcgst, 2)?></font></td>
							<td width="8%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php if($totcgst > 0) echo number_format($tbal, 2)?></font></td>
							<td width="8%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php if($totcgst > 0) echo number_format($itccgst - ($itccgstr), 2)?></font></td>
							<td width="8%" align="right" height="30"><font face="Arial" style="font-size: 11pt"></font></td>
							<td width="8%" align="right" height="30"><font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="8%" align="right" height="30"><font face="Arial" style="font-size: 11pt"><?php if($totcgst > 0) echo number_format($totcgst - ($itccgst + $tbal - ($itccgstr )), 2)?></font></td>
							<td width="8%" align="right" height="30"><font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="8%" align="right" height="30"><font face="Arial" style="font-size: 11pt">0.00</font></td>
						</tr>
						<tr>
							<td width="36%" height="30">
							<font face="Arial" style="font-size: 11pt">State / 
							UT Tax </font></td>
							<td width="8%" align="right" height="30">
							<font face="Arial" style="font-size: 11pt"><?php echo number_format($totsgst, 2)?></font></td>
							<td width="8%" align="right" height="30">
							<font face="Arial" style="font-size: 11pt"><?php if($totsgst > 0) echo number_format($tbal2, 2)?></font></td>
							<td width="8%" align="right" height="30">
							<font face="Arial" style="font-size: 11pt"></font></td>
							<td width="8%" align="right" height="30">
							<font face="Arial" style="font-size: 11pt"><?php echo number_format($itcsgst - ($itcsgstr), 2)?></font></td>
							<td width="8%" align="right" height="30">
							<font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="8%" align="right" height="30">
							<font face="Arial" style="font-size: 11pt"><?php echo number_format($totsgst - ($itcsgst + $tbal2 - ($itcsgstr)), 2)?></font></td>
							<td width="8%" align="right" height="30">
							<font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="8%" align="right" height="30">
							<font face="Arial" style="font-size: 11pt">0.00</font></td>
						</tr>
						<tr>
							<td width="36%" height="30">
							<font face="Arial" style="font-size: 11pt">Cess</font></td>
							<td width="8%" align="right" height="30">
							<font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="8%" align="right" height="30">
							<font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="8%" align="right" height="30">
							<font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="8%" align="right" height="30">
							<font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="8%" align="right" height="30">
							<font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="8%" align="right" height="30">
							<font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="8%" align="right" height="30">
							<font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="8%" align="right" height="30">
							<font face="Arial" style="font-size: 11pt">0.00</font></td>
						</tr>
					</table>
					</td>
				</tr>
				<tr>
					<td width="5%" height="30" bgcolor="#E6E6E6">
					<p align="right"><font face="Arial">
					<span style="font-size: 11pt; font-weight:700">6.2.</span></font></td>
					<td width="95%" height="30" bgcolor="#E6E6E6">
					<table border="0" width="100%" cellpadding="2">
						<tr>
							<td width="100%">
							<font face="Arial">
							<span style="font-size: 11pt; font-weight:700">TDS / 
							TCS Credit</span></font></td>
						</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td width="5%">&nbsp;</td>
					<td width="95%">
					<table border="1" width="100%" cellpadding="2" style="border-collapse: collapse" bordercolor="#666666">
						<tr>
							<td align="center" width="40%">
							<p align="left">
							<font face="Arial" style="font-size: 11pt; font-weight: 700">
							Details</font></td>
							<td align="center" width="20%">
							<font face="Arial" style="font-size: 11pt; font-weight: 700">
							Integrated<br>
							Tax</font></td>
							<td align="center" width="20%">
							<font face="Arial" style="font-size: 11pt; font-weight: 700">
							Central<br>
							Tax</font></td>
							<td align="center" width="20%">
							<font face="Arial" style="font-size: 11pt; font-weight: 700">
							State/UT<br>
							Tax</font></td>
						</tr>
						<tr>
							<td width="40%" height="30">
							<font face="Arial" style="font-size: 11pt">TDS</font></td>
							<td width="20%" align="right" height="30">
							<font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="20%" align="right" height="30">
							<font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="20%" align="right" height="30">
							<font face="Arial" style="font-size: 11pt">0.00</font></td>
						</tr>
						<tr>
							<td width="40%" height="30">
							<font face="Arial" style="font-size: 11pt">TCS</font></td>
							<td width="20%" align="right" height="30">
							<font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="20%" align="right" height="30">
							<font face="Arial" style="font-size: 11pt">0.00</font></td>
							<td width="20%" align="right" height="30">
							<font face="Arial" style="font-size: 11pt">0.00</font></td>
						</tr>
					</table>
					</td>
				</tr>
				<tr>
					<td width="5%">&nbsp;</td>
					<td width="95%"><font face="Arial" size="1">End of Report</font></td>
				</tr>
				</table>
			</div>
			</td>
		</tr>
	</table>
	<p>&nbsp;</div>
	
	<br />
	<div style="text-align:center"><input type="button" value="Export to Excel" onClick="ExportToExcel()" class="red_button" /></div>
	<br />	

</body>

</html>


<script type="text/javascript">

	function ExportToExcel(){
		 var tbl		= document.getElementById('main_table');
		 var html 	= tbl.outerHTML;
		 window.open('data:application/vnd.ms-excel,' + encodeURIComponent(html));
	}
	
</script>