<?php

	/* Include the required files */
	require_once( '../aom-config.php' );
	require_once( '../inc/functions.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/class.gen_items.php' );
	require_once( '../dao/class.gen_purchase.php' );
	require_once( '../dao/class.gen_purchase_items.php' );
	require_once( '../dao/class.gen_purchase_addless.php' );	
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/class.purchasedb.php' );	
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );	

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 51;
	
	$mdb		=	new masterdb("REPORT");
	$ldb		= new logindb("REPORT");
	$pdb		=	new purchasedb("REPORT");
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}
	
	$fdate				= "";
	$tdate				= "";
	
	extract($_REQUEST);
	
	$dt1					= FormatIndianDateToSQLDate($fdate);
	$dt2					= FormatIndianDateToSQLDate($tdate);
	
	$purList			= $pdb->getPurchaseReportList($tcmp->getCompanyID(), $dt1, $dt2);
	
?>

<!DOCTYPE html>
<html>

<head>
	<meta http-equiv="Content-Language" content="en-us">
	<meta http-equiv="Content-Type" content="text/html; charset=utf8">
	<title>GST Purchase Register</title>
	<link rel="stylesheet" href="../css/rpt.css" type="text/css" />
</head>

<body topmargin="0" leftmargin="0" rightmargin="0" bottommargin="0" marginwidth="0" marginheight="0" bgcolor="#FFFFFF">

<div align="center">

<table border="0" width="1000" cellspacing="0" cellpadding="0" id="main_table">
	<tr>
		<td height="60" bgcolor="#FFFFFF">
		<p align="center" style="margin-top: 0; margin-bottom: 0"><b>
		<font size="6" face="Arial"><?php echo $tcmp->getCompanyName()?></font></b></td>
	</tr>
	<tr>
		<td height="24" bgcolor="#FFFFFF">
		<p align="center" style="margin-top: 0; margin-bottom: 0"><b>
		<font face="Arial" size="2">GST PURCHASE REGISTER</font></b></td>
	</tr>
	<tr>
		<td height="24" bgcolor="#FFFFFF">
		<p align="center">
		<b><font face="Arial" size="2">Date : <?php echo $fdate?> - <?php echo $tdate?></font></b></td>
	</tr>
	<tr>
		<td bgcolor="#FFFFFF">
		<table border="1" width="100%" cellpadding="4" style="border-collapse: collapse" bordercolor="#808080">
			<tr bgcolor="#d4d4d4">
				<td class="td_normal_small">Date</td>
				<td class="td_normal_small">Doc.</td>
				<td class="td_normal_small">Ref.</td>
				<td class="td_normal_small">Ref<br />Date</td>
				<td class="td_normal_small">Party</td>
				<td class="td_normal_small">GSTIN</td>
				<td class="td_normal_small" align="center">State Name &amp; State Code</td>
				<td class="td_normal_small">Product</td>
				<td class="td_normal_small" align="center">HSN<br />/SAC</td>
				<td class="td_normal_small" align="center">GST<br />Rate</td>
				<td class="td_normal_small" align="right">Taxable Value</td>
				<td class="td_normal_small" align="right">IGST</td>
				<td class="td_normal_small" align="right">CGST</td>
				<td class="td_normal_small" align="right">SGST/<br />UGST</td>
				<td class="td_normal_small" align="right">Line Total</td>
			</tr>
			
			<?php
				
				$tottaxamt		= 0;
				$totigst			= 0;
				$totsgst			= 0;
				$totcgst			= 0;
				$totamt				= 0;
			
				for($i=0;$i<count($purList);$i++) {
					$pcls			= $purList[$i];
					$itmList	= $pcls->getItemList();
					$sid			= $pcls->getSupplierID();
					$snm			= $pcls->getSupplierName();
					if($snm == "") {
						$snm		= $pcls->getSMotherAccountName();
						$sid		= $pcls->getSMotherAccountID();
					}
					$supDet		= $mdb->getAccountDetail($sid);
					
					$tottaxamt	= $tottaxamt + $pcls->getItemTotal() - ($pcls->getIGST() + $pcls->getCGST() + $pcls->getSGST());
					$totigst	= $totigst + $pcls->getIGST();
					$totcgst	= $totcgst + $pcls->getCGST();
					$totsgst	= $totsgst + $pcls->getSGST();
					$totamt		= $totamt + $pcls->getNetTotal();
					
					$icls			= $itmList[0];
					$iid			= $icls->getItemID();
					$idet			= $mdb->getItemDetail($iid);
			?>
			
				<tr bgcolor="#FFFFFF">
					<td class="td_normal_small" rowspan="<?php echo count($itmList)?>" valign="top"><?php echo $pcls->getPurchaseDate('yes')?></td>
					<td class="td_normal_small" rowspan="<?php echo count($itmList)?>" valign="top"><?php echo $pcls->getPurchaseNo()?>/<?php echo $pcls->getFinYear()?></td>
					<td class="td_normal_small" rowspan="<?php echo count($itmList)?>" valign="top"><?php echo $pcls->getSupplierBillNo()?></td>
					<td class="td_normal_small" rowspan="<?php echo count($itmList)?>" valign="top"><?php echo $pcls->getSupplierBillDate('yes')?></td>
					<td class="td_normal_small" rowspan="<?php echo count($itmList)?>" valign="top"><?php echo $snm?></td>
					<td class="td_normal_small" rowspan="<?php echo count($itmList)?>" valign="top"><?php echo $supDet->getGST()?></td>
					<td class="td_normal_small" align="center" rowspan="<?php echo count($itmList)?>" valign="top"><?php echo $supDet->getState()?> <?php echo getGSTStateCode($supDet->getState())?></td>
					<td class="td_normal_small"><?php echo $icls->getItemName()?></td>
					<td class="td_normal_small" align="center"><?php echo $idet->getHSN()?></td>
					<td class="td_normal_small" align="center"><?php echo $idet->getGSTRate()?></td>
					<td class="td_normal_small" align="right"><?php echo $icls->getAmount() - $icls->getDiscount()?></td>
					<td class="td_normal_small" align="right"><?php echo $icls->getIGST()?></td>
					<td class="td_normal_small" align="right"><?php echo $icls->getCGST()?></td>
					<td class="td_normal_small" align="right"><?php echo $icls->getSGST()?></td>
					<td class="td_normal_small" align="right"><?php echo $icls->getTotalAmount()?></td>
				</tr>
				
				<?php
					for($ii=1;$ii<count($itmList);$ii++) {
						$icls			= $itmList[$ii];
						$iid			= $icls->getItemID();
						$idet			= $mdb->getItemDetail($iid);
				?>
				
					<tr bgcolor="#FFFFFF">
						<td class="td_normal_small"><?php echo $icls->getItemName()?></td>
						<td class="td_normal_small" align="center"><?php echo $idet->getHSN()?></td>
						<td class="td_normal_small" align="center"><?php echo $idet->getGSTRate()?></td>
						<td class="td_normal_small" align="right"><?php echo $icls->getAmount() - $icls->getDiscount()?></td>
						<td class="td_normal_small" align="right"><?php echo $icls->getIGST()?></td>
						<td class="td_normal_small" align="right"><?php echo $icls->getCGST()?></td>
						<td class="td_normal_small" align="right"><?php echo $icls->getSGST()?></td>
						<td class="td_normal_small" align="right"><?php echo $icls->getTotalAmount()?></td>
					</tr>				
				
				<?php } ?>

			<?php } ?>
			
				<tr bgcolor="#FFFFFF">
					<td colspan="10" class="td_normal_small"><b>GRAND TOTAL</b></td>
					<td class="td_normal_small" align="right"><b><?php echo $tottaxamt?></b></td>
					<td class="td_normal_small" align="right"><b><?php echo $totigst?></b></td>
					<td class="td_normal_small" align="right"><b><?php echo $totcgst?></b></td>
					<td class="td_normal_small" align="right"><b><?php echo $totsgst?></b></td>
					<td class="td_normal_small" align="right"><b><?php echo $totamt?></b></td>
				</tr>			

			</table>
		</td>
	</tr>
	<tr>
		<td bgcolor="#FFFFFF">&nbsp;</td>
	</tr>
	</table>

</div>

	<br />
	<div style="text-align:center"><input type="button" value="Export to Excel" onClick="ExportToExcel()" class="red_button" /></div>
	<br />

</body>

</html>

<script type="text/javascript">

	function ExportToExcel(){
		 var tbl		= document.getElementById('main_table');
		 var html 	= tbl.outerHTML;
		 window.open('data:application/vnd.ms-excel,' + encodeURIComponent(html));
	}
	
</script>