<?php

	/* Include the required files */
	require_once( '../aom-config.php' );
	require_once( '../inc/functions.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/class.gen_items.php' );
	require_once( '../dao/class.gen_sale.php' );
	require_once( '../dao/class.gen_sale_items.php' );
	require_once( '../dao/class.gen_sale_addless.php' );	
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/class.saledb.php' );	
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );		

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 51;
	
	$mdb		=	new masterdb("REPORT");
	$ldb		= new logindb("REPORT");
	$pdb		=	new saledb("REPORT");	
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}
	
	$fdate				= "";
	$tdate				= "";
	
	extract($_REQUEST);
	
	$dt1					= FormatIndianDateToSQLDate($fdate);
	$dt2					= FormatIndianDateToSQLDate($tdate);
	
	$purList			= $pdb->getSaleListReport($tcmp->getCompanyID(), $dt1, $dt2);
	
?>

<!DOCTYPE html>
<html>

<head>
	<meta http-equiv="Content-Language" content="en">
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>GSTR1 - HSN</title>
</head>

<body topmargin="20" leftmargin="0" rightmargin="0" bottommargin="0" marginwidth="0" marginheight="0">

<div align="center">
	<table border="1" width="950" cellspacing="0" cellpadding="0" style="border-collapse: collapse" bordercolor="#666666" id="main_table">
		<tr>
			<td>
			<div align="left">
			<table border="0" width="100%" cellpadding="0" cellspacing="0">
				<tr>
					<td height="50" align="center"><font face="Arial" style="font-size: 11pt"><b>Form GSTR - HSN Code Wise Details &amp; Summary (With Return)</font></b></td>
				</tr>
				<tr>
					<td width="95%">
					<table border="0" width="100%" cellpadding="2">
						<tr>
							<td width="75%"><font face="Arial" style="font-size: 11pt">GST #<b><?php echo $tcmp->getGST()?></b></font></td>
							<td width="25%">&nbsp;</td>
						</tr>
					</table>
					</td>
				</tr>
				<tr>
					<td width="95%">
					<table border="0" width="100%" cellpadding="2">
						<tr>
							<td width="75%"><font face="Arial" style="font-size: 11pt">Name of Taxable Person/Company : <b><?php echo $tcmp->getCompanyName()?></b></font></td>
							<td width="25%" align="right"><font face="Arial" style="font-size: 11pt">From : <b><?php echo $fdate?> to <?php echo $tdate?></b></font></td>
						</tr>
						<tr>
							<td width="100%" colspan="2" align="center"><b><font face="Arial" style="font-size: 11pt">HSN Code Wise Details</font></b></td>
						</tr>
					</table>
					</td>
				</tr>
				<tr>
					<td width="95%">
					<table border="1" width="100%" cellpadding="2" style="border-collapse: collapse" bordercolor="#666666">
					
						<tr bgcolor="#CCCCCC">
							<td align="center" width="18%" height="40"><span style="font-weight: 700"><font face="Arial" size="2">Invoice No. &amp; Date</font></span></td>
							<td align="center" width="7%" height="40"><span style="font-weight: 700"><font face="Arial" size="2">HSN</font></span></td>
							<td align="center" width="5%" height="40"><span style="font-weight: 700"><font face="Arial" size="2">Unit</font></span></td>
							<td align="center" width="5%" height="40"><span style="font-weight: 700"><font face="Arial" size="2">Total<br />Qty.</font></span></td>
							<td align="center" width="8%" height="40"><span style="font-weight: 700"><font face="Arial" size="2">Total <br />Value</font></span></td>
							<td align="center" width="8%" height="40"><b><font face="Arial" size="2">Taxable<br />Value</font></b></td>
							<td align="center" width="8%" height="40"><b><font face="Arial" size="2">IGST</font></b></td>
							<td align="center" width="8%" height="40"><b><font face="Arial" size="2">CGST</font></b></td>
							<td align="center" width="8%" height="40"><b><font face="Arial" size="2">SGST</font></b></td>
							<td align="center" width="8%" height="40"><b><font face="Arial" size="2">Cess</font></b></td>
						</tr>
						
					<?php
					
						$hsnArr			= array();
						for($i=0;$i<count($purList);$i++) {
							$pcls			= $purList[$i];
							$itmList	= $pcls->getItemList();
					
							$icls			= $itmList[0];
							$iid			= $icls->getItemID();
							$idet			= $mdb->getItemDetail($iid);
							
							$hsn			= $idet->getHSN();
							$unit			= $idet->getUnitName();
							$tqty			= $icls->getQuantity();
							$tval			= $icls->getTotalAmount();
							$taxval		= $icls->getAmount();
							$igst			= $icls->getIGST();
							$cgst			= $icls->getCGST();
							$sgst			= $icls->getSGST();
							$cess			= 0;
							$chk			= 0;
							
							for($ijk=0;$ijk<count($hsnArr);$ijk++) {
								$tmp		= $hsnArr[$ijk];
								if($tmp[0] == $hsn) {
									$tmp[2]	= $tmp[2] + $tqty;
									$tmp[3]	= $tmp[3] + $tval;
									$tmp[4]	= $tmp[4] + $taxval;
									$tmp[5]	= $tmp[5] + $igst;
									$tmp[6]	= $tmp[6] + $cgst;
									$tmp[7]	= $tmp[7] + $sgst;
									$tmp[8]	= $tmp[8] + $cess;
									$chk		= 1;
									$hsnArr[$ijk]		= $tmp;
									break;
								}
							}
							
							if($chk == 0) {
								$tmp		= array();
								$tmp[0]	= $hsn;
								$tmp[1]	= $unit;
								$tmp[2]	= $tqty;
								$tmp[3]	= $tval;
								$tmp[4]	= $taxval;
								$tmp[5]	= $igst;
								$tmp[6]	= $cgst;
								$tmp[7]	= $sgst;
								$tmp[8]	= $cess;
								
								$hsnArr[]	= $tmp;
							}
							
					?>
						
						<tr>
							<td align="left"><font face="Arial" size="2"><?php echo $pcls->getSaleNo()?>/<?php echo $pcls->getFinYear()?>, <?php echo $pcls->getDOS('yes')?></font></td>
							<td align="center"><font face="Arial" size="2"><?php echo $idet->getHSN()?></font></td>
							<td align="center"><font face="Arial" size="2"><?php echo $idet->getUnitName()?></font></td>
							<td align="center"><font face="Arial" size="2"><?php echo $icls->getQuantity()?></font></td>
							<td align="right"><font face="Arial" size="2"><?php echo $icls->getTotalAmount()?></font></td>
							<td align="right"><font face="Arial" size="2"><?php echo $icls->getAmount()?></font></td>
							<td align="right"><font face="Arial" size="2"><?php echo $icls->getIGST()?></font></td>
							<td align="right"><font face="Arial" size="2"><?php echo $icls->getCGST()?></font></td>
							<td align="right"><font face="Arial" size="2"><?php echo $icls->getSGST()?></font></td>
							<td align="right"><font face="Arial" size="2">00.00</font></td>
						</tr>
						
				<?php
					
					for($ii=1;$ii<count($itmList);$ii++) {
						$icls			= $itmList[$ii];
						$iid			= $icls->getItemID();
						$idet			= $mdb->getItemDetail($iid);
						
						$hsn			= $idet->getHSN();
						$unit			= $idet->getUnitName();
						$tqty			= $icls->getQuantity();
						$tval			= $icls->getTotalAmount();
						$taxval		= $icls->getAmount();
						$igst			= $icls->getIGST();
						$cgst			= $icls->getCGST();
						$sgst			= $icls->getSGST();
						$cess			= 0;
						$chk			= 0;
						
						for($ijk=0;$ijk<count($hsnArr);$ijk++) {
							$tmp		= $hsnArr[$ijk];
							if($tmp[0] == $hsn) {
								$tmp[2]	= $tmp[2] + $tqty;
								$tmp[3]	= $tmp[3] + $tval;
								$tmp[4]	= $tmp[4] + $taxval;
								$tmp[5]	= $tmp[5] + $igst;
								$tmp[6]	= $tmp[6] + $cgst;
								$tmp[7]	= $tmp[7] + $sgst;
								$tmp[8]	= $tmp[8] + $cess;
								$chk		= 1;
								$hsnArr[$ijk]		= $tmp;
								break;
							}
						}
						
						if($chk == 0) {
							$tmp		= array();
							$tmp[0]	= $hsn;
							$tmp[1]	= $unit;
							$tmp[2]	= $tqty;
							$tmp[3]	= $tval;
							$tmp[4]	= $taxval;
							$tmp[5]	= $igst;
							$tmp[6]	= $cgst;
							$tmp[7]	= $sgst;
							$tmp[8]	= $cess;
							
							$hsnArr[]	= $tmp;
						}
						
				?>
				
						<tr>
							<td align="left"><font face="Arial" size="2"><?php echo $pcls->getSaleNo()?>/<?php echo $pcls->getFinYear()?>, <?php echo $pcls->getDOS('yes')?></font></td>
							<td align="center"><font face="Arial" size="2"><?php echo $idet->getHSN()?></font></td>
							<td align="center"><font face="Arial" size="2"><?php echo $idet->getUnitName()?></font></td>
							<td align="center"><font face="Arial" size="2"><?php echo $icls->getQuantity()?></font></td>
							<td align="right"><font face="Arial" size="2"><?php echo $icls->getTotalAmount()?></font></td>
							<td align="right"><font face="Arial" size="2"><?php echo $icls->getAmount()?></font></td>
							<td align="right"><font face="Arial" size="2"><?php echo $icls->getIGST()?></font></td>
							<td align="right"><font face="Arial" size="2"><?php echo $icls->getCGST()?></font></td>
							<td align="right"><font face="Arial" size="2"><?php echo $icls->getSGST()?></font></td>
							<td align="right"><font face="Arial" size="2">00.00</font></td>
						</tr>				
				
				<?php } ?>

			<?php } ?>										

					</table>
					</td>
				</tr>
				<tr>
					<td width="95%">&nbsp;</td>
				</tr>
				<tr>
					<td width="95%" height="30" align="center"><b><font face="Arial" style="font-size: 11pt">HSN Code Wise Summery</font></b></td>
				</tr>
				<tr>
					<td width="95%">
					<table border="1" width="100%" cellpadding="2" style="border-collapse: collapse" bordercolor="#666666">
						
						<tr bgcolor="#CCCCCC">
							<td align="center" width="7%" height="40"><span style="font-weight: 700"><font face="Arial" size="2">HSN</font></span></td>
							<td align="center" width="5%" height="40"><span style="font-weight: 700"><font face="Arial" size="2">Unit</font></span></td>
							<td align="center" width="5%" height="40"><span style="font-weight: 700"><font face="Arial" size="2">Total<br />Qty.</font></span></td>
							<td align="center" width="8%" height="40"><span style="font-weight: 700"><font face="Arial" size="2">Total <br />Value</font></span></td>
							<td align="center" width="8%" height="40"><b><font face="Arial" size="2">Taxable<br />Value</font></b></td>
							<td align="center" width="8%" height="40"><b><font face="Arial" size="2">IGST</font></b></td>
							<td align="center" width="8%" height="40"><b><font face="Arial" size="2">CGST</font></b></td>
							<td align="center" width="8%" height="40"><b><font face="Arial" size="2">SGST</font></b></td>
							<td align="center" width="8%" height="40"><b><font face="Arial" size="2">Cess</font></b></td>
						</tr>
						
						<?php
							for($i=0;$i<count($hsnArr);$i++) {
								$tmp		= $hsnArr[$i];
						?>
						<tr>
							<td align="center"><font face="Arial" size="2"><?php echo $tmp[0]?></font></td>
							<td align="center"><font face="Arial" size="2"><?php echo $tmp[1]?></font></td>
							<td align="center"><font face="Arial" size="2"><?php echo $tmp[2]?></font></td>
							<td align="right"><font face="Arial" size="2"><?php echo $tmp[3]?></font></td>
							<td align="right"><font face="Arial" size="2"><?php echo $tmp[4]?></font></td>
							<td align="right"><font face="Arial" size="2"><?php echo $tmp[5]?></font></td>
							<td align="right"><font face="Arial" size="2"><?php echo $tmp[6]?></font></td>
							<td align="right"><font face="Arial" size="2"><?php echo $tmp[7]?></font></td>
							<td align="right"><font face="Arial" size="2"><?php echo $tmp[8]?></font></td>
						</tr>
						<?php } ?>
						
						</table>
					</td>
				</tr>
				<tr>
					<td width="95%"><font face="Arial" size="1">End of Report</font></td>
				</tr>
				</table>
			</div>
			</td>
		</tr>
	</table>
	<p>&nbsp;</div>
	
	<br />
	<div style="text-align:center"><input type="button" value="Export to Excel" onClick="ExportToExcel()" class="red_button" /></div>
	<br />	

</body>

</html>

<script type="text/javascript">

	function ExportToExcel(){
		 var tbl		= document.getElementById('main_table');
		 var html 	= tbl.outerHTML;
		 window.open('data:application/vnd.ms-excel,' + encodeURIComponent(html));
	}
	
</script>
