<?php

	/* Include the required files */
	require_once( '../aom-config.php' );
	require_once( '../inc/functions.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );		
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/class.gen_sale.php' );
	require_once( '../dao/class.gen_sale_items.php' );
	require_once( '../dao/class.gen_sale_addless.php' );
	require_once( '../dao/class.gen_salereturn.php' );
	require_once( '../dao/class.gen_salereturn_items.php' );
	require_once( '../dao/class.gen_salereturn_addless.php' );
	require_once( '../dao/class.saledb.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])) {
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])) {
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;
	}
	
	$ModuleID			= 51;
	
	$mdb		=	new masterdb("REPORT");
	$ldb		= new logindb("REPORT");
	$pdb		=	new saledb("REPORT");
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}
	
	$fdate	= "";
	$tdate	= "";
	
	extract($_REQUEST);
	
	$dt1		= FormatIndianDateToSQLDate($fdate);
	$dt2		= FormatIndianDateToSQLDate($tdate);
	
	$salList			= $pdb->getSaleListReport($tcmp->getCompanyID(), $dt1, $dt2);
	$retList			= $pdb->getSaleReturnListReport($tcmp->getCompanyID(), $dt1, $dt2);
	
	$start				= "";
	$end					= "";
	$retStr				= "";
	if(count($salList) > 0) {
		$scls				= $salList[0];
		$start			= $scls->getSaleNo();
		
		$scls				= $salList[count($salList) - 1];
		$end				= $scls->getSaleNo();
	}
	
	for($i=0;$i<count($retList);$i++) {
		$rcls				= $retList[0];
		if($retStr != "") $retStr = $retStr.",";
		$retStr			= $retStr.$rcls->getReturnNo();
	}
	
	$saleCnt			= count($salList);
	$retCnt				= count($retList);	

?>


<html>

<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>GSTR1 - 13, Documents Issued</title>
</head>

<body>

<div align="center">

<b><font face="Arial">Form GSTR1 - 13, Document Issue </font></b>
<p><b><font face="Arial">GST#<?php echo $tcmp->getGST()?>, <?php echo $tcmp->getCompanyName()?></font></b></p>
<p><b><font face="Arial">Date : <?php echo $fdate?> - <?php echo $tdate?></font></b></p>

<table border="1" cellpadding="2" width="900" style="border-collapse:
 collapse;" height="35" bordercolor="#C0C0C0">
 
	<tr height="20" style="height:15.0pt">
		<td align="center" bgcolor="#E8E8E8" style="height: 35px">
		<b><font face="Arial" size="2">Nature of Document</font></b></td>
		<td align="center" bgcolor="#E8E8E8" style="height: 35px">
		<b><font face="Arial" size="2">Sr. No. From</font></b></td>
		<td align="center" bgcolor="#E8E8E8" style="height: 35px">
		<b><font face="Arial" size="2">Sr. No. To</font></b></td>
		<td align="center" bgcolor="#E8E8E8" style="height: 35px">
		<b><font face="Arial" size="2">Total Number</font></b></td>
		<td align="center" bgcolor="#E8E8E8" style="height: 35px">
		<b><font face="Arial" size="2">Cancelled</font></b></td>
	</tr>
	
	<?php if($saleCnt - $retCnt > 0) { ?>
	<tr>
		<td height="35">
		<b><font face="Arial" size="2">Invoices for outward supply</font></b></td>
		<td height="35" align="center">
		<b><font face="Arial" size="2">
		<?php echo $start?></font></b></td>
		<td height="35" align="center">
		<b><font face="Arial" size="2">
		<?php echo $end?></font></b></td>
		<td height="35" align="right">
		<b><font face="Arial" size="2">
		<?php if($retCnt > 0) echo $retStr.', ('.$retCnt.')' ?></font></b></td>
		<td height="35" align="right">
		<b><font face="Arial" size="2">
		<?php echo ($saleCnt - $retCnt) ?></font></b></td>
	</tr>
	<?php } ?>

</table>

</div>

</body>

</html>