<?php

	/* Include the required files */
	require_once( '../aom-config.php' );
	require_once( '../inc/functions.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/class.gen_items.php' );
	require_once( '../dao/class.gen_sale.php' );
	require_once( '../dao/class.gen_sale_items.php' );
	require_once( '../dao/class.gen_sale_addless.php' );		
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/class.saledb.php' );	
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 51;
	
	$mdb		=	new masterdb("REPORT");
	$ldb		= new logindb("REPORT");
	$pdb		=	new saledb("REPORT");
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}
	
	$fdate				= "";
	$tdate				= "";
	
	extract($_REQUEST);
	
	$dt1					= FormatIndianDateToSQLDate($fdate);
	$dt2					= FormatIndianDateToSQLDate($tdate);
	
	$purList			= $pdb->getSaleListReport($tcmp->getCompanyID(), $dt1, $dt2);
	
?>

<!DOCTYPE html>
<html>

<head>
	<meta http-equiv="Content-Language" content="en-us">
	<meta http-equiv="Content-Type" content="text/html; charset=utf8">
	<title>Form GSTR1 - 5A, 5B - B2B (Large) Invoices</title>
	<link rel="stylesheet" href="../css/rpt.css" type="text/css" />
</head>

<body topmargin="0" leftmargin="0" rightmargin="0" bottommargin="0" marginwidth="0" marginheight="0" bgcolor="#FFFFFF">

<div align="center">

<table border="0" width="1000" cellspacing="0" cellpadding="0" id="main_table">

	<tr>
		<td height="24" bgcolor="#FFFFFF" align="center"><b><font face="Arial" size="2">Form GSTR1 - 
		5A, 5B - B2B (Large) Invoices </font></b></td>
	</tr>
	<tr>
		<td height="60" bgcolor="#FFFFFF" align="center"><b><font style="font-size:16px;" face="Arial">GST#<?php echo $tcmp->getGST()?>, <?php echo $tcmp->getCompanyName()?></font></b></td>
	</tr>	
	<tr>
		<td height="24" bgcolor="#FFFFFF" align="center"><b><font face="Arial" size="2">Date : <?php echo $fdate?> - <?php echo $tdate?></font></b></td>
	</tr>
	<tr>
		<td bgcolor="#FFFFFF">
		<table border="1" width="100%" cellpadding="4" style="border-collapse: collapse" bordercolor="#808080">
			
			<tr bgcolor="#d4d4d4">
				<td align="center" width="13%" class="td_normal_small bold">GST / UIN of<br />Recipient</td>
				<td align="center" width="25%" class="td_normal_small bold">Receiver Name</td>
				<td align="center" width="13%" class="td_normal_small bold">Invoice<br />Number</td>
				<td align="center" width="12%" class="td_normal_small bold">Invoice<br />Date</td>
				<td align="center" width="12%" class="td_normal_small bold">Invoice<br />Value</td>
				<td align="center" width="15%" class="td_normal_small bold">Place of<br />Supply</td>
				<td align="center" width="5%" class="td_normal_small bold">Rev. Charges</td>
				<td align="center" width="8%" class="td_normal_small bold">Invoice<br />Type</td>
				<td align="center" width="8%" class="td_normal_small bold">E-Commerce<br />GSTIN</td>
				<td align="center" width="5%" class="td_normal_small bold">Tax Rate</td>
				<td align="center" width="12%" class="td_normal_small bold">Taxable<br />Value</td>
				<td align="center" width="8%" class="td_normal_small bold">Cess<br />Amount</td>
			</tr>			
			
			<?php
			
				for($i=0;$i<count($purList);$i++) {
					$pcls			= $purList[$i];
					$itmList	= $pcls->getItemList();
					
					if($pcls->getCashSale() == "YES") continue;
					if($pcls->getNetTotal() < 250000) continue;

					$sid			= $pcls->getCustomerID();
					$snm			= $pcls->getCustomerName();
					$supDet		= $mdb->getAccountDetail($sid);
					
					if($supDet->getGST() == "") continue;
					
					$ttyp			= "State";
					if($tcmp->getState() != $supDet->getState()) $ttyp = "Integrated";					
					
					$taxslabs	= $pdb->getSlabwiseTaxableValue($pcls->getSaleID(), $ttyp);
					
					$ityp			= "Regular";
					if($pcls->getOnlineSale() == "YES") $ityp = "Online";
					if($pcls->getExport() == "YES") $ityp = "Export";
					
					for($ii=0;$ii<count($taxslabs);$ii++) {
						$row		= $taxslabs[$ii];

			?>
			
				<tr bgcolor="#FFFFFF">
					<?php if($ii == 0) { ?>
					<td align="center" class="td_normal_small"><?php echo $supDet->getGST()?></td>
					<td class="td_normal_small"><?php echo $snm?></td>
					<td align="center" class="td_normal_small"><?php echo $pcls->getSaleNo()?>/<?php echo $pcls->getFinYear()?></td>
					<td align="center" class="td_normal_small"><?php echo $pcls->getDOS('yes')?></td>
					<td align="right" class="td_normal_small"><?php echo $pcls->getNetTotal()?></td>
					<?php } else { ?>
					<td align="center" class="td_normal_small" colspan="5">&nbsp;</td>
					<?php } ?>
					<td align="center" class="td_normal_small"><?php echo getGSTStateCode($supDet->getState()).'-'.$supDet->getState()?></td>
					<td align="center" class="td_normal_small">N</td>
					<td align="center" class="td_normal_small"><?php echo $ityp?></td>
					<td align="center" class="td_normal_small">&nbsp;</td>
					<td align="center" class="td_normal_small"><?php echo $row[1]?></td>
					<td align="right" class="td_normal_small"><?php echo $row[0] ?></td>
					<td align="right" class="td_normal_small">&nbsp;</td>
				</tr>
				
				<?php } ?>

			<?php } ?>			

			</table>
		</td>
	</tr>
	<tr>
		<td bgcolor="#FFFFFF">&nbsp;</td>
	</tr>
	</table>

</div>

	<br />
	<div style="text-align:center"><input type="button" value="Export to Excel" onClick="ExportToExcel()" class="red_button" /></div>
	<br />

</body>

</html>

<script type="text/javascript">

	function ExportToExcel(){
		 var tbl		= document.getElementById('main_table');
		 var html 	= tbl.outerHTML;
		 window.open('data:application/vnd.ms-excel,' + encodeURIComponent(html));
	}
	
</script>