<?php

	/* Include the required files */
	require_once( '../aom-config.php' );
	require_once( '../inc/functions.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/class.gen_items.php' );
	require_once( '../dao/class.gen_sale.php' );
	require_once( '../dao/class.gen_sale_items.php' );
	require_once( '../dao/class.gen_sale_addless.php' );
	require_once( '../dao/class.gen_salereturn.php' );
	require_once( '../dao/class.gen_salereturn_items.php' );
	require_once( '../dao/class.gen_salereturn_addless.php' );	
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/class.saledb.php' );	
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );	

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 51;
	
	$mdb					=	new masterdb("REPORT");
	$ldb					= new logindb("REPORT");
	$pdb					=	new saledb("REPORT");
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}
	
	$fdate				= "";
	$tdate				= "";
	
	extract($_REQUEST);
	
	$dt1					= FormatIndianDateToSQLDate($fdate);
	$dt2					= FormatIndianDateToSQLDate($tdate);
	
	$salList			= $pdb->getSaleListReport($tcmp->getCompanyID(), $dt1, $dt2);
	$retList			= $pdb->getSaleReturnListReport($tcmp->getCompanyID(), $dt1, $dt2);
	
	$start				= "";
	$end					= "";
	$retStr				= "";
	if(count($salList) > 0) {
		$scls				= $salList[0];
		$start			= $scls->getSaleNo();
		
		$scls				= $salList[count($salList) - 1];
		$end				= $scls->getSaleNo();
	}
	
	for($i=0;$i<count($retList);$i++) {
		$rcls				= $retList[0];
		if($retStr != "") $retStr = $retStr.",";
		$retStr			= $retStr.$rcls->getReturnNo();
	}
	
	$saleCnt			= count($salList);
	$retCnt				= count($retList);
	
?>

<!DOCTYPE html>
<html>

<head>
	<meta http-equiv="Content-Language" content="en" />
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<title>GSTR1 Document</title>
</head>

<body topmargin="20" leftmargin="0" rightmargin="0" bottommargin="0" marginwidth="0" marginheight="0">

<div align="center">
	<table border="1" width="990" cellspacing="0" cellpadding="0" style="border-collapse: collapse" bordercolor="#666666" id="main_table">
		<tr>
			<td>
			<div align="left">
			<table border="0" width="100%" cellpadding="0" cellspacing="0">
				<tr>
					<td height="50">
					<p align="center"><font face="Arial"><b><span style="font-size: 11pt">Form GSTR - 
					1 (Document Issue)</span></b></font></td>
				</tr>
				<tr>
					<td width="95%">
					<table border="0" width="100%" cellpadding="2">
						<tr>
							<td width="75%"><font face="Arial">
							<font style="font-size: 11pt">GST # 
							</font><b><font style="font-size: 11pt"><?php echo $tcmp->getGST()?></font></b></font></td>
							<td width="25%"></td>
						</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td width="95%">
					<table border="0" width="100%" cellpadding="2">
						<tr>
							<td width="75%"><font face="Arial">
							<font style="font-size: 11pt">Name of Taxable Person/Company :
							</font><b><font style="font-size: 11pt"><?php echo $tcmp->getCompanyName()?></font></b></font></td>
							<td width="25%">
							<p align="right">
							<font face="Arial" style="font-size: 11pt">From</font><font face="Arial"><font style="font-size: 11pt"> 
							: </font><b><font style="font-size: 11pt"><?php echo $fdate?> to <?php echo $tdate?></font></b></font></td>
						</tr>
					</table>
					</td>
				</tr>
				<tr>
					<td width="95%">
					<table border="1" width="100%" cellpadding="2" style="border-collapse: collapse" bordercolor="#666666">
						<tr>
							<td align="center" width="20%" height="40" bgcolor="#CCCCCC">
							<span style="font-weight: 700">
							<font face="Arial" size="2">From Bill No.</font></span></td>
							<td align="center" width="20%" height="40" bgcolor="#CCCCCC">
							<span style="font-weight: 700">
							<font face="Arial" size="2">To Bill No.</font></span></td>
							<td align="center" width="20%" height="40" bgcolor="#CCCCCC">
							<span style="font-weight: 700">
							<font face="Arial" size="2">Return / Cancel Bill No.</font></span></td>
							<td align="center" width="20%" height="40" bgcolor="#CCCCCC">
							<span style="font-weight: 700">
							<font face="Arial" size="2">Net Issue</font></span></td>
						</tr>
						<tr>
							<td width="20%" height="30">
							<p align="right"><font face="Arial" size="2"><?php echo $start?></font></td>
							<td width="20%" height="30">
							<p align="right"><font face="Arial" size="2"><?php echo $end?></font></td>
							<td width="20%" height="30">
							<p align="right"><font face="Arial" size="2"><?php if($retCnt > 0) echo $retStr.', ('.$retCnt.')' ?></font></td>
							<td width="20%" align="right" height="30">
							<font face="Arial" size="2"><?php echo ($saleCnt - $retCnt) ?></font></td>
						</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td width="95%"><font face="Arial" size="1">End of Report</font></td>
				</tr>
				</table>
			</div>
			</td>
		</tr>
	</table>
	<p>&nbsp;</div>
	
	<br />
	<div style="text-align:center"><input type="button" value="Export to Excel" onClick="ExportToExcel()" class="red_button" /></div>
	<br />	

</body>

</html>

<script type="text/javascript">

	function ExportToExcel(){
		 var tbl		= document.getElementById('main_table');
		 var html 	= tbl.outerHTML;
		 window.open('data:application/vnd.ms-excel,' + encodeURIComponent(html));
	}
	
</script>
