<?php

	/* Include the required files */
	require_once( '../aom-config.php' );
	require_once( '../inc/functions.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/class.gen_items.php' );
	require_once( '../dao/class.gen_sale.php' );
	require_once( '../dao/class.gen_sale_items.php' );
	require_once( '../dao/class.gen_sale_addless.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/class.saledb.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 51;
	
	$mdb		=	new masterdb("REPORT");
	$ldb		= new logindb("REPORT");
	$pdb		=	new saledb("REPORT");
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}
	
	$fdate				= "";
	$tdate				= "";
	
	extract($_REQUEST);
	
	$dt1					= FormatIndianDateToSQLDate($fdate);
	$dt2					= FormatIndianDateToSQLDate($tdate);
	
	$purList			= $pdb->getSaleListReport($tcmp->getCompanyID(), $dt1, $dt2);
	
?>

<!DOCTYPE html>
<html>

<head>
	<meta http-equiv="Content-Language" content="en-us">
	<meta http-equiv="Content-Type" content="text/html; charset=utf8">
	<title>GST Sale Register</title>
	<link rel="stylesheet" href="../css/rpt.css" type="text/css" />
</head>

<body topmargin="0" leftmargin="0" rightmargin="0" bottommargin="0" marginwidth="0" marginheight="0" bgcolor="#FFFFFF">

<div align="center">

<table border="0" width="1200" cellspacing="0" cellpadding="0" id="main_table">
	<tr>
		<td height="60" bgcolor="#FFFFFF">
		<p align="center" style="margin-top: 0; margin-bottom: 0"><b>
		<font size="6" face="Arial"><?php echo $tcmp->getCompanyName()?></font></b></td>
	</tr>
	<tr>
		<td height="24" bgcolor="#FFFFFF">
		<p align="center" style="margin-top: 0; margin-bottom: 0"><b>
		<font face="Arial" size="2">GST SALE REGISTER</font></b></td>
	</tr>
	<tr>
		<td height="24" bgcolor="#FFFFFF">
		<p align="center">
		<b><font face="Arial" size="2">Date : <?php echo $fdate?> - <?php echo $tdate?></font></b></td>
	</tr>
	<tr>
		<td bgcolor="#FFFFFF">
		<table border="1" width="100%" cellpadding="4" style="border-collapse: collapse" bordercolor="#808080">
			<tr bgcolor="#d4d4d4">
				<td class="td_normal_small" width="20%" align="center"><b><font face="Arial" size="2">Party</font></b></td>
				<td class="td_normal_small" width="10%" align="center"><b><font face="Arial" size="2">GSTIN</font></b></td>
				<td class="td_normal_small" align="center" width="8%"><b><font face="Arial" size="2">State<br>&amp; Code</font></b></td>
				<td class="td_normal_small" align="center" width="8%"><b><font face="Arial" size="2">POS</font></b></td>
				<td class="td_normal_small" width="5%" align="center"><b><font face="Arial" size="2">Bill<br>No.</font></b></td>
				<td class="td_normal_small" width="5%" align="center"><b><font face="Arial" size="2">Date</font></b></td>
				<td class="td_normal_small" align="center" width="5%"><b><font face="Arial" size="2">Bill Total</font></b></td>
				<td class="td_normal_small" align="center" width="5%"><b><font face="Arial" size="2">HSN</font></b></td>
				<td class="td_normal_small" width="14%" align="center"><b><font face="Arial" size="2">Product</font></b></td>
				<td class="td_normal_small" align="center" width="5%"><b><font face="Arial" size="2">Taxable Value</font></b></td>
				<td class="td_normal_small" align="center" width="5%"><b><font face="Arial" size="2">Qty</font></b></td>
				<td class="td_normal_small" align="center" width="5%"><b><font face="Arial" size="2">UOM</font></b></td>
				<td class="td_normal_small" align="center" width="5%"><b><font face="Arial" size="2">GST%</font></b></td>
				<td class="td_normal_small" align="center" width="5%"><b><font face="Arial" size="2">IGST</font></b></td>
				<td class="td_normal_small" align="center" width="5%"><b><font face="Arial" size="2">GST%</font></b></td>
				<td class="td_normal_small" align="center" width="5%"><b><font face="Arial" size="2">CGST</font></b></td>
				<td class="td_normal_small" align="center" width="5%"><b><font face="Arial" size="2">GST%</font></b></td>
				<td class="td_normal_small" align="center" width="5%"><b><font face="Arial" size="2">SGST/<br />UGST</font></b></td>
				<td class="td_normal_small" align="center" width="5%"><b><font face="Arial" size="2">Line Total</font></b></td>
				<td class="td_normal_small" align="center" width="5%"><b><font face="Arial" size="2">Add<br>/Less</font></b></td>
				
			</tr>
			
			<?php
				
				$tottaxamt		= 0;
				$totigst			= 0;
				$totsgst			= 0;
				$totcgst			= 0;
				$totamt				= 0;
				$totaddless		= 0;
				$totbill			= 0;
			
				for($i=0;$i<count($purList);$i++) {
					$pcls				= $purList[$i];
					$itmList		= $pcls->getItemList();
					$sid				= $pcls->getCustomerID();
					$snm				= $pcls->getCustomerName();
					$supDet			= $mdb->getAccountDetail($sid);
					
					$tottaxamt	= $tottaxamt + $pcls->getItemTotal() - ($pcls->getIGST() + $pcls->getCGST() + $pcls->getSGST());
					$totigst		= $totigst + $pcls->getIGST();
					$totcgst		= $totcgst + $pcls->getCGST();
					$totsgst		= $totsgst + $pcls->getSGST();
					$totaddless	= $totaddless + $pcls->getAddLessTotal();
					$totbill		= $totbill + $pcls->getNetTotal();					
					
					$icls				= $itmList[0];
					$iid				= $icls->getItemID();
					$idet				= $mdb->getItemDetail($iid);
					$totamt			= $totamt + $icls->getTotalAmount();
			?>
			
				<tr bgcolor="#FFFFFF">
					<td class="td_normal_small" rowspan="<?php echo count($itmList)?>" valign="top"><font face="Arial" size="2"><?php echo $snm?></font></td>
					<td class="td_normal_small" rowspan="<?php echo count($itmList)?>" valign="top"><font face="Arial" size="1"><?php echo $supDet->getGST()?></font></td>
					<td class="td_normal_small" align="center" rowspan="<?php echo count($itmList)?>" valign="top"><font face="Arial" size="1"><?php echo $supDet->getState()?> <?php echo getGSTStateCode($supDet->getState())?></font></td>
					<td class="td_normal_small" align="center" rowspan="<?php echo count($itmList)?>" valign="top"><font face="Arial" size="1">&nbsp;</font></td>
					<td class="td_normal_small" rowspan="<?php echo count($itmList)?>" valign="top"><font face="Arial" size="2"><?php echo $pcls->getSaleNo()?>/<?php echo $pcls->getFinYear()?></font></td>
					<td class="td_normal_small" rowspan="<?php echo count($itmList)?>" valign="top"><font face="Arial" size="2"><?php echo $pcls->getDOS('yes')?></font></td>
					<td class="td_normal_small" align="right" rowspan="<?php echo count($itmList)?>"><font face="Arial" size="2"><?php echo number_format($pcls->getNetTotal(), 2)?></font></td>
					<td class="td_normal_small" align="right"><font face="Arial" size="1"><?php echo $idet->getHSN()?></font></td>
					<td class="td_normal_small"><font face="Arial" size="2"><?php echo $icls->getItemName()?></font></td>
					<td class="td_normal_small" align="right"><font face="Arial" size="2"><?php echo number_format($icls->getAmount() - $icls->getDiscount(), 2)?></font></td>
					<td class="td_normal_small" align="right"><font face="Arial" size="1"><?php echo $icls->getQuantity()?></font></td>
					<td class="td_normal_small" align="right"><font face="Arial" size="1"><?php echo $idet->getUnitName()?></font></td>
					<td class="td_normal_small" align="right"><font face="Arial" size="1"><?php if($icls->getIGST() > 0) echo $idet->getGSTRate()?></font></td>
					<td class="td_normal_small" align="right"><font face="Arial" size="2"><?php echo number_format($icls->getIGST(), 2)?></font></td>
					<td class="td_normal_small" align="right"><font face="Arial" size="1"><?php if($icls->getCGST() > 0) echo $idet->getGSTRate()/2?></font></td>
					<td class="td_normal_small" align="right"><font face="Arial" size="2"><?php echo number_format($icls->getCGST(), 2)?></font></td>
					<td class="td_normal_small" align="right"><font face="Arial" size="1"><?php if($icls->getSGST() > 0) echo $idet->getGSTRate()/2?></font></td>
					<td class="td_normal_small" align="right"><font face="Arial" size="2"><?php echo number_format($icls->getSGST(), 2)?></font></td>
					<td class="td_normal_small" align="right"><font face="Arial" size="2"><?php echo number_format($icls->getTotalAmount(), 2)?></font></td>
					<td class="td_normal_small" align="right" rowspan="<?php echo count($itmList)?>"><font face="Arial" size="2"><?php echo number_format($pcls->getAddLessTotal(), 2)?></font></td>
					
				</tr>
				
				<?php
					for($ii=1;$ii<count($itmList);$ii++) {
						$icls			= $itmList[$ii];
						$iid			= $icls->getItemID();
						$idet			= $mdb->getItemDetail($iid);
						$totamt		= $totamt + $icls->getTotalAmount();
				?>
				
					<tr bgcolor="#FFFFFF">
						<td class="td_normal_small" align="right"><font face="Arial" size="1"><?php echo $idet->getHSN()?></font></td>
						<td class="td_normal_small"><font face="Arial" size="2"><?php echo $icls->getItemName()?></font></td>
						<td class="td_normal_small" align="right"><font face="Arial" size="2"><?php echo number_format($icls->getAmount() - $icls->getDiscount(), 2)?></font></td>
						<td class="td_normal_small" align="right"><font face="Arial" size="1"><?php echo $icls->getQuantity()?></font></td>
						<td class="td_normal_small" align="right"><font face="Arial" size="1"><?php echo $idet->getUnitName()?></font></td>
						<td class="td_normal_small" align="right"><font face="Arial" size="1"><?php if($icls->getIGST() > 0) echo $idet->getGSTRate()?></font></td>						
						<td class="td_normal_small" align="right"><font face="Arial" size="2"><?php echo number_format($icls->getIGST(), 2)?></font></td>
						<td class="td_normal_small" align="right"><font face="Arial" size="1"><?php if($icls->getCGST() > 0) echo $idet->getGSTRate()/2?></font></td>
						<td class="td_normal_small" align="right"><font face="Arial" size="2"><?php echo number_format($icls->getCGST(), 2)?></font></td>
						<td class="td_normal_small" align="right"><font face="Arial" size="1"><?php if($icls->getSGST() > 0) echo $idet->getGSTRate()/2?></font></td>
						<td class="td_normal_small" align="right"><font face="Arial" size="2"><?php echo number_format($icls->getSGST(), 2)?></font></td>
						<td class="td_normal_small" align="right"><font face="Arial" size="2"><?php echo number_format($icls->getTotalAmount(), 2)?></font></td>
					</tr>				
				
				<?php } ?>

			<?php } ?>
			
				<tr bgcolor="#FFFFFF">
					<td colspan="6" class="td_normal_small"><font face="Arial" size="2"><b>GRAND TOTAL</b></font></td>
					<td class="td_normal_small" align="right"><b><font face="Arial" size="2"><?php echo number_format($totbill, 2)?></font></b></td>
					<td>&nbsp;</td>
					<td>&nbsp;</td>
					<td class="td_normal_small" align="right"><b><font face="Arial" size="2"><?php echo number_format($tottaxamt, 2)?></font></b></td>
					<td>&nbsp;</td>
					<td>&nbsp;</td>
					<td>&nbsp;</td>
					<td class="td_normal_small" align="right"><b><font face="Arial" size="2"><?php echo number_format($totigst, 2)?></font></b></td>
					<td>&nbsp;</td>
					<td class="td_normal_small" align="right"><b><font face="Arial" size="2"><?php echo number_format($totcgst, 2)?></font></b></td>
					<td>&nbsp;</td>
					<td class="td_normal_small" align="right"><b><font face="Arial" size="2"><?php echo number_format($totsgst, 2)?></font></b></td>
					<td class="td_normal_small" align="right"><b><font face="Arial" size="2"><?php echo number_format($totamt, 2)?></font></b></td>
					<td class="td_normal_small" align="right"><b><font face="Arial" size="2"><?php echo number_format($totaddless, 2)?></font></b></td>
					
				</tr>			

			</table>
		</td>
	</tr>
	<tr>
		<td bgcolor="#FFFFFF">&nbsp;</td>
	</tr>
	</table>

</div>

	<br />
	<div style="text-align:center"><input type="button" value="Export to Excel" onClick="ExportToExcel()" class="red_button" /></div>
	<br />

</body>

</html>

<script type="text/javascript">

	function ExportToExcel(){
		 var tbl		= document.getElementById('main_table');
		 var html 	= tbl.outerHTML;
		 window.open('data:application/vnd.ms-excel,' + encodeURIComponent(html));
	}
	
</script>