<?php

	/* Include the required files */
	require_once( '../inc/functions.php' );
	require_once( '../aom-config.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/asys.voucherdb.php' );
	require_once( '../dao/asys.drcr.php' );
	require_once( '../dao/asys.group.php' );
	require_once( '../dao/asys.voucher.php' );
	require_once( '../dao/asys.vouchertag.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 37;

	$mdb		=	new masterdb("REPORT");
	$vdb		=	new voucherdb("REPORT");
	$ldb		= new logindb("REPORT");
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}		

	$fdate	=	getFirstFinancialDate();
	$tdate	=	getLastFinancialDate();

	extract($_REQUEST);

	$df			= FormatIndianDateToSQLDate($fdate);
	$dt			= FormatIndianDateToSQLDate($tdate);

	$jrnList	= $vdb->getJournalVoucherListConsolidated($df, $dt, $tcmp->getCompanyID());
	$totcr		= 0;
	$totdr		= 0;
	
?>


<!DOCTYPE html>
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html;charset=utf-8"/>
		<title>Journal Vouchers from <?php echo $fdate?> to <?php echo $tdate?></title>
		<link href="../css/rpt.css" type="text/css" rel="stylesheet">
		<script src="../js/common.js"></script>
	</head>
<body style="background-color:#ffffff">
	<div style="font-family:verdana;margin:0px auto;width:900px;">

		<div style="font-size:10px;">
			<table cellSpacing='1' cellPadding='4' width='100%' bgcolor="#CCCCCC" id="main_table">
			
				<tr bgcolor="#FFFFFF">
					<td colspan="4" align="center">
						<div style="font-size:18px; letter-spacing:1pt;">
							<b><?php echo $tcmp->getCompanyName()?><br /></b>
						</div>
						<div style="font-size:15px; letter-spacing:1pt;">
							<?php echo nl2br($tcmp->getCompanyAddress())?>
						</div>
						<div style="font-size:13px;">
							<b>Journal Book <?php echo $fdate?> - <?php echo $tdate?></b>
						</div>					
					</td>
				<tr>			
			
				<tr bgcolor="#f4f4f4">
					<td>
						<font style='font-family:arial; font-size:11px'>LEDGER</font>
					</td>
					<td>
						<font style='font-family:arial; font-size:11px'>SUB LEDGER</font>
					</td>										
					<td align='right'>
						<font style='font-family:arial; font-size:11px'>DEBIT</font>
					</td>
					<td align='right'>
						<font style='font-family:arial; font-size:11px'>CREDIT</font>
					</td>
				</tr>

			<?php
				$prev_vid	=	0;
				for($i=0;$i<count($jrnList);$i++) {
					$veb		=	$jrnList[$i];
					
			?>
				<tr bgcolor="#F4F4F4">		
				<?php	if($veb['MotherAccount'] != 0){ ?>				
					<td valign="top">
						<font style='font-family:arial; font-size:10px'><?php echo $mdb->getAccountNameByAccountID($veb['MotherAccount']) ?></font>
					</td>
					<td valign="top">
						<font style='font-family:arial; font-size:10px'><?php echo $mdb->getAccountNameByAccountID($veb['AccountID'])?></font>
					</td>
				<?php } else{ ?>
					<td valign="top">
						<font style='font-family:arial; font-size:10px'><?php echo $mdb->getAccountNameByAccountID($veb['AccountID'])?></font>
					</td>
					<td valign="top">
						&nbsp;
					</td>				
				<?php } ?>
															
					<?php
						if($veb['DrCr'] == DEBIT) {
							$totdr+=$veb['Amount'];
					?>
						<td align='right' valign="top">
							<font style='font-family:arial; font-size:10px'><?php echo number_format($veb['Amount'],2)?></font>
						</td>
						<td align='right' valign="top">
							<font style='font-family:arial; font-size:10px'>0.00</font>
						</td>
					<?php
						} else {
							$totcr+=$veb['Amount'];
					?>
						<td align='right' valign="top">
							<font style='font-family:arial; font-size:10px'>0.00</font>
						</td>
						<td align='right' valign="top">
							<font style='font-family:arial; font-size:10px'><?php echo number_format($veb['Amount'],2)?></font>
						</td>
					<?php } ?>
				</tr>

			<?php
				}
			?>

				<tr bgcolor="#ffffff">					
					<td colspan="2">
						<font style='font-family:arial; font-size:10px'><b>CURRENT TOTAL ***</b></font>
					</td>
					<td align='right'>
						<font style='font-family:arial; font-size:10px'><b><?php echo number_format($totdr,2)?></b></font>
					</td>
					<td align='right'>
						<font style='font-family:arial; font-size:10px'><b><?php echo number_format($totcr,2)?></b></font>
					</td>
				</tr>
			</table>
		</div>
		
		<br />
		<div style="text-align:center"><input type="button" value="Export to Excel" onClick="ExportToExcel()" class="red_button" /></div>
		<br />		
		
	</div>
</body>
</html>

<script type="text/javascript">

	function ExportToExcel(){
		 var tbl		= document.getElementById('main_table');
		 var html 	= tbl.outerHTML;
		 window.open('data:application/vnd.ms-excel,' + encodeURIComponent(html));
	}
	
</script>