<?php

	/* Include the required files */
	require_once( '../inc/functions.php' );
	require_once( '../aom-config.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/asys.voucherdb.php' );
	require_once( '../dao/asys.drcr.php' );
	require_once( '../dao/asys.group.php' );
	require_once( '../dao/asys.voucher.php' );
	require_once( '../dao/asys.vouchertag.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userledger.php' );
	require_once( '../dao/asys.userpermission.php' );	

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 31;

	$db			=	new masterdb("REPORT");
	$vdb		=	new voucherdb("REPORT");
	$ldb		= new logindb("REPORT");
	$uaDet	= $ldb->getUserLedgerDetail($tuser->getUserID());
	$uacc			= $uaDet->getAccounts();
	$uacList	= explode(",", $uacc);	
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}		

	$accid		= 0;
	$fdate		=	getFirstFinancialDate();
	$tdate		=	getLastFinancialDate();
	$expand		=	'no';

	extract($_REQUEST);
	
	$df				=	FormatIndianDateToSQLDate($fdate);
	$dt				=	FormatIndianDateToSQLDate($tdate);
	$ndt			=	getNextDate($df);

	$accid		=	(int)$accid;
	
	if($tuser->getUserStatus() < ADMIN_USER) {
		if(!in_array($accid, $uacList)) {
			header("Location:../accessDenied.php");
			exit;			
		}
	}	

	if($accid == 0) {
		echo "Sorry!!! Direct Access not allowed here";
		exit;
	}

	$accDet		= $db->getAccountDetail($accid);
	$bal			= $accDet->getOBal();
	$balt			= $accDet->getOBalType();

	$clbal		=	$db->getClosingBalanceByAccountID($accid, $df);
	$bal			=	$clbal[0];
	$balt			=	$clbal[1];

	$alDet		= $vdb->getAccountVoucher($accid, FormatIndianDateToSQLDate($fdate), FormatIndianDateToSQLDate($tdate));

	$totcr		= 0;
	$totdr		= 0;
	if($balt == DEBIT)
		$totdr	=	$bal;
	else
		$totcr	= $bal;
	
	

	$html	= '

<body style="background-color:#ffffff">
	<div style="font-family:verdana;margin:0px auto;width:900px;">
		<div style="text-align:center; font-size:18px; font-weight:bold; letter-spacing:1pt;">
			<br>'.$tcmp->getCompanyName().'
		</div>
		<div style="text-align:center; font-size:15px; font-weight:normal; letter-spacing:1pt;">
			'.$tcmp->getCompanyAddress().'
		</div>
		<div style="text-align:center; font-size:15px; font-weight:bold; letter-spacing:1pt;">
			<br>'.$accDet->getAccountName().'
		</div>
		<div style="text-align:center; font-size:13px; font-weight:bold;">
			<br />'.$fdate.' - '.$tdate.'
		</div>
		<div style="font-size:12px;">
			<table cellSpacing="1" cellPadding="4" width="100%" bgcolor="#CCCCCC">
				<tr bgcolor="#F4F4F4">
					<td width="10%">DATE</td>
					<td width="14%">DOC NO</td>
					<td width="37%">PARTICULARS</td>
					<td width="12%" align="right">DEBIT</td>
					<td width="12%" align="right">CREDIT</td>
					<td width="15%" align="right">BALANCE</td>
				</tr>

				<tr bgcolor="#FFFFFF">
					<td>&nbsp;</td>
					<td>&nbsp;</td>
					<td><b>By Opening Balance</b></td>';

						if($balt == DEBIT) {
							$html = $html.'
								<td align="right"><b>'.number_format($bal,2).'</b></td>
								<td align="right"><b>0.00</b></td>';
						} else {
							$html = $html.'
								<td align="right"><b>0.00</b></td>
								<td align="right"><b>'.number_format($bal,2).'</b></td>';
						}
					$html = $html.'
					<td align="right"><b>'.number_format($bal,2).' '.getDrCr($balt).'</b></td>
				</tr>';

				for($i=0;$i<count($alDet);$i++) {
					$veb	=	$alDet[$i];
					if($expand == "yes") {
						$vt		=	$veb->getVoucherType();
						$fy		=	$veb->getFinYear();
						$vid	=	$veb->getVoucherID();
						$olist=	$vdb->getOppositeVoucher($vid, $accid);
					}
				$html = $html.'
				<tr bgcolor="#FFFFFF">
					<td>'.$veb->getDOV('yes').'</td>
					<td>'.getShortVoucherType($veb->getVoucherType()).'/'.FormatSQLDateToVoucherPrintFormat($veb->getDOV()).'/'.$veb->getDayWiseNo().'
					</td>
					<td>';

								$narr	= $veb->getNarration();
								$html = $html.$narr;
				$html = $html.'		
					</td>';
					
						if($veb->getDrCr() == DEBIT) {
							$totdr+=$veb->getAmount();
							if($balt == DEBIT)
								$bal+=$veb->getAmount();
							else
								$bal-=$veb->getAmount();
							if($bal < 0) {
								$bal=-$bal;
								$balt	=	DEBIT;
							}
					$html = $html.'
						<td align="right">'.number_format($veb->getAmount(),2).'</td>
						<td align="right">0.00</td>';
					
						} else {
							$totcr+=$veb->getAmount();
							if($balt == CREDIT)
								$bal+=$veb->getAmount();
							else
								$bal-=$veb->getAmount();
							if($bal < 0) {
								$bal=-$bal;
								$balt	=	CREDIT;
							}
					$html = $html.'
						<td align="right">0.00</td>
						<td align="right">'.number_format($veb->getAmount(),2).'</td>';
					}
					$html = $html.'
					<td align="right">'.number_format($bal,2).' '.getDrCr($balt).'</td>
				</tr>';
			
					if($expand == 'yes') {
						for($j=0;$j<count($olist);$j++) {
							$ovch	=	$olist[$j];
							$tmp	=	"#f4f4f4";
							if($j%2==0)
								$tmp	=	"#e4e4e4";
			$html = $html.'
							<tr bgcolor="#FFFFFF">
								<td>&nbsp;</td>
								<td>&nbsp;</td>
								<td bgcolor="<?php echo $tmp?>">
									<font style="font-family:verdana; font-size:10px">'.$ovch->getAccountName('yes').' - '. $ovch->getAmount('yes').' ('.getDrCr($ovch->getDrCr()).')</font>
								</td>
								<td>&nbsp;</td>
								<td>&nbsp;</td>
								<td>&nbsp;</td>
							</tr>';

						}
					}
				}

	$html = $html.'
				<tr bgcolor="#FFFFFF">
					<td>&nbsp;</td>
					<td>&nbsp;</td>
					<td><b>CURRENT TOTAL ***</b></td>
					<td align="right"><b>'.number_format($totdr,2).'</b></td>
					<td align="right"><b>'.number_format($totcr,2).'</b></td>
					<td align="right"><b>'.number_format($bal,2).' '.getDrCr($balt).'</b></td>
				</tr>
			</table>
		</div>
		<div style="font-size:11px; font-weight:bold; text-align:left">
			<br>CLOSING TOTAL: '.CURRENCY_WORD.' '.numToWord($bal,'Paise').'
		</div>
	</div>
</body>';


header('Content-type: application/excel');
$filename = 'rptMainLedgerExcel.xls';
header('Content-Disposition: attachment; filename='.$filename);

$data = '<html xmlns:x="urn:schemas-microsoft-com:office:excel">
<head>
    <!--[if gte mso 9]>
    <xml>
        <x:ExcelWorkbook>
            <x:ExcelWorksheets>
                <x:ExcelWorksheet>
                    <x:Name>Sheet 1</x:Name>
                    <x:WorksheetOptions>
                        <x:Print>
                            <x:ValidPrinterInfo/>
                        </x:Print>
                    </x:WorksheetOptions>
                </x:ExcelWorksheet>
            </x:ExcelWorksheets>
        </x:ExcelWorkbook>
    </xml>
    <![endif]-->
</head>

'.$html.'</html>';

echo $data;	exit;