<?php

	/* Include the required files */
	require_once( '../inc/functions.php' );
	require_once( '../aom-config.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/asys.voucherdb.php' );
	require_once( '../dao/asys.drcr.php' );
	require_once( '../dao/asys.group.php' );
	require_once( '../dao/asys.voucher.php' );
	require_once( '../dao/asys.vouchertag.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/asys.store.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userledger.php' );
	require_once( '../dao/asys.userpermission.php' );		

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 43;

	$db			=	new masterdb("REPORT");
	$vdb		=	new voucherdb("REPORT");
	$ldb		= new logindb("REPORT");
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}
	

	$accid		= 0;
	$fdate		=	getFirstFinancialDate();
	$tdate		=	getLastFinancialDate();
	$expand		=	'yes';
	$sid			= 0;

	extract($_REQUEST);
	
	$df				=	FormatIndianDateToSQLDate($fdate);
	$dt				=	FormatIndianDateToSQLDate($tdate);
	$ndt			=	getNextDate($df);	

	$accid		=	(int)$accid;
	$sid			= (int)$sid;

	if($accid == 0) {
		echo "Sorry!!! Direct Access not allowed here";
		exit;
	}

	$accDet		= $db->getAccountDetail($accid);
	$strDet		= $db->getStoreDetail($sid);
	$sacid		= $strDet->getAccountID();

	$alDet		= $vdb->getAccountVoucher($accid, FormatIndianDateToSQLDate($fdate), FormatIndianDateToSQLDate($tdate));

	$totcr		= 0;
	$totdr		= 0;

?>


<!DOCTYPE html>
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html;charset=utf-8"/>
		<title>Ledger of <?php echo $accDet->getAccountName()?></title>
		<link href="../css/rpt.css" type="text/css" rel="stylesheet">
		<script src="../js/common.js"></script>
	</head>
<body style="background-color:#ffffff">
	<div style="font-family:verdana;margin:0px auto;width:900px;">

		<div style="font-size:12px;">
			<table cellSpacing='1' cellPadding='4' width='100%' bgcolor="#CCCCCC" id="main_table">
			
				<tr bgcolor="#FFFFFF">
					<td colspan="5" align="center">
						<div style="font-size:18px; letter-spacing:1pt;">
							<b><?php echo $tcmp->getCompanyName()?><br /></b>
						</div>
						<div style="font-size:15px; letter-spacing:1pt;">
							<?php echo nl2br($tcmp->getCompanyAddress())?>
						</div>
						<div style="font-size:15px; letter-spacing:1pt;">
							<b><br /><?php echo $accDet->getAccountName()?> (Store - <?php echo $strDet->getStoreName()?>)</b>
						</div>
						<div style="font-size:13px;">
							<b><?php echo $fdate?> - <?php echo $tdate?></b>
						</div>					
					</td>
				<tr>
			
				<tr bgcolor="#F4F4F4">
					<td width='10%'>DATE</td>
					<td width='14%'>DOC NO</td>
					<td width='37%'>PARTICULARS</td>
					<td width='12%' align='right'>DEBIT</td>
					<td width='12%' align='right'>CREDIT</td>
				</tr>

			<?php
				for($i=0;$i<count($alDet);$i++) {
					$veb	=	$alDet[$i];

					$vt		=	$veb->getVoucherType();
					$fy		=	$veb->getFinYear();
					$vid	=	$veb->getVoucherID();
					$olist=	$vdb->getOppositeVoucher($vid, $accid);
					
					$chk	= 0;
					for($j=0;$j<count($olist);$j++) {
						$ovch	=	$olist[$j];
						if($ovch->getAccountID() == $sacid) {
							$chk = 1;
							break;
						}
					}
					
					if($chk == 0) continue;

			?>
				<tr bgcolor="#FFFFFF">
					<td><?php echo $veb->getDOV('yes')?></td>
					<td onMouseOver="this.className='td_hover'" onMouseOut="this.className='td_normal'">
						<a href="../printvoucher.php?vid=<?php echo $veb->getVoucherID()?>" target="_blank"><?php echo getShortVoucherType($veb->getVoucherType()).'/'.FormatSQLDateToVoucherPrintFormat($veb->getDOV()).'/'.$veb->getDayWiseNo()?></a>
					</td>
					<td>
						<?php
								$narr	= $veb->getNarration();
								echo $narr;
						?>
					</td>
					<?php
						if($veb->getDrCr() == DEBIT) {
							$totdr+=$veb->getAmount();
					?>
						<td align='right'><?php echo number_format($veb->getAmount(),2)?></td>
						<td align='right'>0.00</td>
					<?php
						} else {
							$totcr+=$veb->getAmount();
					?>
						<td align='right'>0.00</td>
						<td align='right'><?php echo number_format($veb->getAmount(),2)?></td>
					<?php } ?>
				</tr>
			<?php
					for($j=0;$j<count($olist);$j++) {
						$ovch	=	$olist[$j];
						$tmp	=	"#f4f4f4";
						if($j%2==0)
							$tmp	=	"#e4e4e4";
			?>
							<tr bgcolor="#FFFFFF">
								<td>&nbsp;</td>
								<td>&nbsp;</td>
								<td bgcolor="<?php echo $tmp?>">
									<font style='font-family:verdana; font-size:10px'><?php echo $ovch->getAccountName('yes')?> - <?php echo $ovch->getAmount('yes')?> (<?php echo getDrCr($ovch->getDrCr())?>)</font>
								</td>
								<td>&nbsp;</td>
								<td>&nbsp;</td>
							</tr>
			<?php
					}
				}
			?>

				<tr bgcolor="#FFFFFF">
					<td>&nbsp;</td>
					<td>&nbsp;</td>
					<td><b>CURRENT TOTAL ***</b></td>
					<td align='right'><b><?php echo number_format($totdr,2)?></b></td>
					<td align='right'><b><?php echo number_format($totcr,2)?></b></td>
				</tr>
			</table>
		</div>
		
		<br />
		<div style="text-align:center"><input type="button" value="Export to Excel" onClick="ExportToExcel()" class="red_button" /></div>
		<br />		
		
	</div>
</body>
</html>

<script type="text/javascript">

	function ExportToExcel(){
		 var tbl		= document.getElementById('main_table');
		 var html 	= tbl.outerHTML;
		 window.open('data:application/vnd.ms-excel,' + encodeURIComponent(html));
	}
	
</script>