<?php

	/* Include the required files */
	require_once( '../inc/functions.php' );
	require_once( '../aom-config.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/asys.voucherdb.php' );
	require_once( '../dao/asys.drcr.php' );
	require_once( '../dao/asys.group.php' );
	require_once( '../dao/asys.basegroup.php' );
	require_once( '../dao/asys.basesubgroup.php' );	
	require_once( '../dao/asys.voucher.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );	

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 46;

	$mdb			=	new masterdb("REPORT");
	$vdb			=	new voucherdb("REPORT");
	$ldb			= new logindb("REPORT");
	
	$vdb->updateGroupSubgroup();
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}		

	$fdate		=	getFirstFinancialDate();
	$tdate		=	getLastFinancialDate();
	$cmp			= "";
	$cid			= "";	

	extract($_REQUEST);

	$df				=	FormatIndianDateToSQLDate($fdate);
	$dt				=	FormatIndianDateToSQLDate($tdate);
	$cid			= $tcmp->getCompanyID();
	if($cmp != "") {
		$tmparr		= explode(",", $cmp);
		for($i=0;$i<count($tmparr);$i++) {
			$cid	= $cid.','.(int)$tmparr[$i];
		}
	}	

	if($df == '1900-01-01' || $dt == '1900-01-01'){
		echo 'Invalid input Date format, try again';
		exit;
	}
	
	$ndt			=	getNextDate($dt);
	
	/**********************************************************
	**         Trading Account 
	***********************************************************/
	
	$deTot		= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 13, $ndt, "YES");
	$puTot		= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 19, $ndt, "YES");
	
	$diTot		= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 20, $ndt, "YES");
	$saTot		= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 18, $ndt, "YES");
	
	$taProfit	= 0;
	$tcrSide	= 0;
	$tdrSide	= 0;
	$tcrCnt		= 0;
	$tdrCnt		= 0;
	
	if($diTot[1] == CREDIT)
		$tcrSide	= $diTot[0];
	else
		$tcrSide	= -$diTot[0];
	
	if($saTot[1] == CREDIT)
		$tcrSide = bcadd($tcrSide, $saTot[0], 2);
	else
		$tcrSide = bcsub($tcrSide, $saTot[0], 2);
		
	if($deTot[1] == DEBIT)
		$tdrSide = $deTot[0];
	else
		$tdrSide = -$deTot[0];
		
	if($puTot[1] == DEBIT)
		$tdrSide = bcadd($tdrSide, $puTot[0], 2);
	else
		$tdrSide = bcsub($tdrSide, $puTot[0], 2);
	
	$taProfit	= number_format( $tcrSide - $tdrSide, 2, '.', '');
	
	/**********************************************************
	**         Trading Account ends here
	***********************************************************/
	
	
	/**********************************************************
	**         PL Account 
	***********************************************************/
	
	$plProfit	= 0;
	$pcrSide	= 0;
	$pdrSide	= 0;
	$pcrCnt		= 0;
	$pdrCnt		= 0;
	
	$ieTot		= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 14, $ndt, "YES");
	$meTot		= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 15, $ndt, "YES");
	$dtTot		= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 16, $ndt, "YES");
	
	$iiTot		= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 17, $ndt, "YES");
	
	if($ieTot[1] == DEBIT)
		$pdrSide = $ieTot[0];
	else
		$pdrSide = -$ieTot[0];
		
	if($meTot[1] == DEBIT)
		$pdrSide = bcadd($pdrSide, $meTot[0], 2);
	else
		$pdrSide = bcsub($pdrSide, $meTot[0], 2);
		
	if($dtTot[1] == DEBIT)
		$pdrSide = bcadd($pdrSide, $dtTot[0], 2);
	else
		$pdrSide = bcsub($pdrSide, $dtTot[0], 2);
		
	if($iiTot[1] == CREDIT)
		$pcrSide = $iiTot[0];
	else
		$pcrSide = -$iiTot[0];				
	
	if($taProfit > 0)
		$plProfit	= number_format( $taProfit + $pcrSide - $pdrSide, 2, '.', '');
	else
		$plProfit	= number_format( $pcrSide - ($pdrSide - $taProfit), 2, '.', '');
	
	/**********************************************************
	**         PL Account ends here
	***********************************************************/
	
	$bcrSide	= 0;
	$bdrSide	= 0;	
	
	$bsl1			= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 1, $ndt, "YES");
	$bsl2			= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 2, $ndt, "YES");
	$bsl3			= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 3, $ndt, "YES");
	$bsl4			= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 4, $ndt, "YES");
	$bsl5			= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 5, $ndt, "YES");
	$bsl22		= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 22, $ndt, "YES");
	
	if($bsl1[1] == CREDIT)
		$bcrSide = $bsl1[0];
	else
		$bcrSide = -$bsl1[0];	
		
	if($bsl2[1] == CREDIT)
		$bcrSide = bcadd($bcrSide, $bsl2[0], 2);
	else
		$bcrSide = bcsub($bcrSide, $bsl2[0], 2);
		
	if($bsl3[1] == CREDIT)
		$bcrSide = bcadd($bcrSide, $bsl3[0], 2);
	else
		$bcrSide = bcsub($bcrSide, $bsl3[0], 2);
		
	if($bsl4[1] == CREDIT)
		$bcrSide = bcadd($bcrSide, $bsl4[0], 2);
	else
		$bcrSide = bcsub($bcrSide, $bsl4[0], 2);
		
	if($bsl5[1] == CREDIT)
		$bcrSide = bcadd($bcrSide, $bsl5[0], 2);
	else
		$bcrSide = bcsub($bcrSide, $bsl5[0], 2);
		
	if($bsl22[1] == CREDIT)
		$bcrSide = bcadd($bcrSide, $bsl22[0], 2);
	else
		$bcrSide = bcsub($bcrSide, $bsl22[0], 2);										

	
	$bsa6			= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 6, $ndt, "YES");
	$bsa7			= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 7, $ndt, "YES");
	$bsa8			= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 8, $ndt, "YES");
	$bsa9			= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 9, $ndt, "YES");
	$bsa10		= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 10, $ndt, "YES");
	$bsa11		= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 11, $ndt, "YES");
	$bsa12		= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 12, $ndt, "YES");
	$bsa21		= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 21, $ndt, "YES");
	$bsa23		= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 23, $ndt, "YES");
	$bsa24		= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 24, $ndt, "YES");
	
	if($bsa6[1] == DEBIT)
		$bdrSide = $bsa6[0];
	else
		$bdrSide = -$bsa6[0];	
		
	if($bsa7[1] == DEBIT)
		$bdrSide = bcadd($bdrSide, $bsa7[0], 2);
	else
		$bdrSide = bcsub($bdrSide, $bsa7[0], 2);
		
	if($bsa8[1] == DEBIT)
		$bdrSide = bcadd($bdrSide, $bsa8[0], 2);
	else
		$bdrSide = bcsub($bdrSide, $bsa8[0], 2);
		
	if($bsa9[1] == DEBIT)
		$bdrSide = bcadd($bdrSide, $bsa9[0], 2);
	else
		$bdrSide = bcsub($bdrSide, $bsa9[0], 2);
		
	if($bsa10[1] == DEBIT)
		$bdrSide = bcadd($bdrSide, $bsa10[0], 2);
	else
		$bdrSide = bcsub($bdrSide, $bsa10[0], 2);
		
	if($bsa11[1] == DEBIT)
		$bdrSide = bcadd($bdrSide, $bsa11[0], 2);
	else
		$bdrSide = bcsub($bdrSide, $bsa11[0], 2);
		
	if($bsa12[1] == DEBIT)
		$bdrSide = bcadd($bdrSide, $bsa12[0], 2);
	else
		$bdrSide = bcsub($bdrSide, $bsa12[0], 2);
		
	if($bsa21[1] == DEBIT)
		$bdrSide = bcadd($bdrSide, $bsa21[0], 2);
	else
		$bdrSide = bcsub($bdrSide, $bsa21[0], 2);
		
	if($bsa23[1] == DEBIT)
		$bdrSide = bcadd($bdrSide, $bsa23[0], 2);
	else
		$bdrSide = bcsub($bdrSide, $bsa23[0], 2);
		
	if($bsa24[1] == DEBIT)
		$bdrSide = bcadd($bdrSide, $bsa24[0], 2);
	else
		$bdrSide = bcsub($bdrSide, $bsa24[0], 2);																
	
	$bslAct1	= $mdb->getShortMotherAccountListBGWiseMultipleCompany($cid, 1);
	$bslAct2	= $mdb->getShortMotherAccountListBGWiseMultipleCompany($cid, 2);
	$bslAct3	= $mdb->getShortMotherAccountListBGWiseMultipleCompany($cid, 3);
	$bslAct4	= $mdb->getShortMotherAccountListBGWiseMultipleCompany($cid, 4);
	$bslAct5	= $mdb->getShortMotherAccountListBGWiseMultipleCompany($cid, 5);
	$bslAct22	= $mdb->getShortMotherAccountListBGWiseMultipleCompany($cid, 22);
	
	$bsaAct6	= $mdb->getShortMotherAccountListBGWiseMultipleCompany($cid, 6);
	$bsaAct7	= $mdb->getShortMotherAccountListBGWiseMultipleCompany($cid, 7);
	$bsaAct8	= $mdb->getShortMotherAccountListBGWiseMultipleCompany($cid, 8);
	$bsaAct9	= $mdb->getShortMotherAccountListBGWiseMultipleCompany($cid, 9);
	$bsaAct10	= $mdb->getShortMotherAccountListBGWiseMultipleCompany($cid, 10);
	$bsaAct11	= $mdb->getShortMotherAccountListBGWiseMultipleCompany($cid, 11);
	$bsaAct12	= $mdb->getShortMotherAccountListBGWiseMultipleCompany($cid, 12);
	$bsaAct21	= $mdb->getShortMotherAccountListBGWiseMultipleCompany($cid, 21);
	$bsaAct23	= $mdb->getShortMotherAccountListBGWiseMultipleCompany($cid, 23);
	$bsaAct24	= $mdb->getShortMotherAccountListBGWiseMultipleCompany($cid, 24);

?>


<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html;charset=utf-8"/>
		<title>Balance Sheet</title>
		<link href="../css/rpt.css" type=text/css rel=stylesheet>
		<script src="../js/common.js"></script>
	</head>
<body style="background-color:#ffffff">
	<div style="font-family:verdana;width:1100px;margin:0px auto;" align="center">

		<div style="font-size:9px;">
			<table cellSpacing='0' cellPadding='0' width='100%' style="border-collapse: collapse;border:#CCCCCC 1px solid" id="main_table">
			
				<tr bgcolor="#FFFFFF">
					<td colspan="3" style="text-align:center; letter-spacing:1pt;">
						<br /><font style="font-size:18px; font-weight:bold;"><?php echo $tcmp->getCompanyName()?></font><br />
						<font style="font-size:15px; font-weight:normal;"><?php echo nl2br($tcmp->getCompanyAddress())?><br /><br />
						<b>Merged Balance Sheet from <?php echo $fdate?> to <?php echo $tdate?></b></font>
					</td>
				</tr>			
			
				<tr>
					<td width="50%" valign="top">
						<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
							<tr bgcolor="#f4f4f4">
								<td width='55%'>
									<font style='font-family:arial; font-size:12px'><b>PARTICULARS</b></font>
								</td>
								<td width='20%' align='right'>
									<font style='font-family:arial; font-size:12px'>&nbsp;</font>
								</td>
								<td width='25%' align='right'>
									<font style='font-family:arial; font-size:12px'>&nbsp;</font>
								</td>
							</tr>
							
							<?php if($bsl1[0] != 0) { ?>
								<tr bgcolor="#FFFF66">
									<td class="td_normal_large"><b>Capital</b></td>
									<td class="td_normal_large" align='right'>&nbsp;</td>
									<?php if($bsl1[1] == CREDIT) { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format($bsl1[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format(-$bsl1[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									$psgid		= 0;
									$padleft	= 15;								
									for($i=0;$i<count($bslAct1);$i++) {
										$acls	= $bslAct1[$i];
										
										if($acls->getSubgroupID() != 0) {
											if($psgid == 0 || $psgid != $acls->getSubgroupID()) {
												$pbgid	= $acls->getBGID();
												$psgid 	= $acls->getSubgroupID();
												$gTot		= $mdb->getClosingBalanceBySubgroupIDMultipleCompany($cid, $pbgid, $psgid, $ndt, "YES");
												$padleft	= 15;
				
												if($gTot[0] != 0) {
													$sgdet	= $mdb->getSubgroupDetail($psgid);
													if($gTot[1] == DEBIT) {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
														<td align="right">&nbsp;</td>
													</tr>
									<?php
													} else {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td align="right">&nbsp;</td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
													</tr>
									<?php
													}
													$padleft	= 30;
												}
											}
										} else {
											$padleft = 15;
										}										
										
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, "YES");
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == DEBIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccountMultipleCompany($cid, $acls->getAccountID(), $ndt, "YES");
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == DEBIT) $tmpamt = -$tmpamt;										
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($bsl2[0] != 0) { ?>
								<tr bgcolor="#FFFF66">
									<td class="td_normal_large"><b>Loans</b></td>
									<td class="td_normal_large" align='right'>&nbsp;</td>
									<?php if($bsl2[1] == CREDIT) { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format($bsl2[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format(-$bsl2[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									$psgid		= 0;
									$padleft	= 15;								
									for($i=0;$i<count($bslAct2);$i++) {
										$acls	= $bslAct2[$i];
										
										if($acls->getSubgroupID() != 0) {
											if($psgid == 0 || $psgid != $acls->getSubgroupID()) {
												$pbgid	= $acls->getBGID();
												$psgid 	= $acls->getSubgroupID();
												$gTot		= $mdb->getClosingBalanceBySubgroupIDMultipleCompany($cid, $pbgid, $psgid, $ndt, "YES");
												$padleft	= 15;
				
												if($gTot[0] != 0) {
													$sgdet	= $mdb->getSubgroupDetail($psgid);
													if($gTot[1] == DEBIT) {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
														<td align="right">&nbsp;</td>
													</tr>
									<?php
													} else {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td align="right">&nbsp;</td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
													</tr>
									<?php
													}
													$padleft	= 30;
												}
											}
										} else {
											$padleft = 15;
										}										
										
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, "YES");
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == DEBIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccountMultipleCompany($cid, $acls->getAccountID(), $ndt, "YES");
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == DEBIT) $tmpamt = -$tmpamt;										
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($bsl3[0] != 0) { ?>
								<tr bgcolor="#FFFF66">
									<td class="td_normal_large"><b>Sundry Creditors</b></td>
									<td class="td_normal_large" align='right'>&nbsp;</td>
									<?php if($bsl3[1] == CREDIT) { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format($bsl3[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format(-$bsl3[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									$psgid		= 0;
									$padleft	= 15;								
									for($i=0;$i<count($bslAct3);$i++) {
										$acls	= $bslAct3[$i];
										
										if($acls->getSubgroupID() != 0) {
											if($psgid == 0 || $psgid != $acls->getSubgroupID()) {
												$pbgid	= $acls->getBGID();
												$psgid 	= $acls->getSubgroupID();
												$gTot		= $mdb->getClosingBalanceBySubgroupIDMultipleCompany($cid, $pbgid, $psgid, $ndt, "YES");
												$padleft	= 15;
				
												if($gTot[0] != 0) {
													$sgdet	= $mdb->getSubgroupDetail($psgid);
													if($gTot[1] == DEBIT) {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
														<td align="right">&nbsp;</td>
													</tr>
									<?php
													} else {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td align="right">&nbsp;</td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
													</tr>
									<?php
													}
													$padleft	= 30;
												}
											}
										} else {
											$padleft = 15;
										}										
										
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, "YES");
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == DEBIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccountMultipleCompany($cid, $acls->getAccountID(), $ndt, "YES");
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == DEBIT) $tmpamt = -$tmpamt;										
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($bsl4[0] != 0) { ?>
								<tr bgcolor="#FFFF66">
									<td class="td_normal_large"><b>Reserves</b></td>
									<td class="td_normal_large" align='right'>&nbsp;</td>
									<?php if($bsl4[1] == CREDIT) { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format($bsl4[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format(-$bsl4[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									$psgid		= 0;
									$padleft	= 15;								
									for($i=0;$i<count($bslAct4);$i++) {
										$acls	= $bslAct4[$i];
										
										if($acls->getSubgroupID() != 0) {
											if($psgid == 0 || $psgid != $acls->getSubgroupID()) {
												$pbgid	= $acls->getBGID();
												$psgid 	= $acls->getSubgroupID();
												$gTot		= $mdb->getClosingBalanceBySubgroupIDMultipleCompany($cid, $pbgid, $psgid, $ndt, "YES");
												$padleft	= 15;
				
												if($gTot[0] != 0) {
													$sgdet	= $mdb->getSubgroupDetail($psgid);
													if($gTot[1] == DEBIT) {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
														<td align="right">&nbsp;</td>
													</tr>
									<?php
													} else {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td align="right">&nbsp;</td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
													</tr>
									<?php
													}
													$padleft	= 30;
												}
											}
										} else {
											$padleft = 15;
										}										
										
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, "YES");
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == DEBIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccountMultipleCompany($cid, $acls->getAccountID(), $ndt, "YES");
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == DEBIT) $tmpamt = -$tmpamt;										
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($bsl5[0] != 0) { ?>
								<tr bgcolor="#FFFF66">
									<td class="td_normal_large"><b>Provision</b></td>
									<td class="td_normal_large" align='right'>&nbsp;</td>
									<?php if($bsl5[1] == CREDIT) { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format($bsl5[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format(-$bsl5[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									$psgid		= 0;
									$padleft	= 15;								
									for($i=0;$i<count($bslAct5);$i++) {
										$acls	= $bslAct5[$i];
										
										if($acls->getSubgroupID() != 0) {
											if($psgid == 0 || $psgid != $acls->getSubgroupID()) {
												$pbgid	= $acls->getBGID();
												$psgid 	= $acls->getSubgroupID();
												$gTot		= $mdb->getClosingBalanceBySubgroupIDMultipleCompany($cid, $pbgid, $psgid, $ndt, "YES");
												$padleft	= 15;
				
												if($gTot[0] != 0) {
													$sgdet	= $mdb->getSubgroupDetail($psgid);
													if($gTot[1] == DEBIT) {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
														<td align="right">&nbsp;</td>
													</tr>
									<?php
													} else {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td align="right">&nbsp;</td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
													</tr>
									<?php
													}
													$padleft	= 30;
												}
											}
										} else {
											$padleft = 15;
										}										
										
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, "YES");
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == DEBIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccountMultipleCompany($cid, $acls->getAccountID(), $ndt, "YES");
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == DEBIT) $tmpamt = -$tmpamt;										
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($bsl22[0] != 0) { ?>
								<tr bgcolor="#FFFF66">
									<td class="td_normal_large"><b>Current Liabilities</b></td>
									<td class="td_normal_large" align='right'>&nbsp;</td>
									<?php if($bsl22[1] == CREDIT) { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format($bsl22[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format(-$bsl22[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									$psgid		= 0;
									$padleft	= 15;								
									for($i=0;$i<count($bslAct22);$i++) {
										$acls	= $bslAct22[$i];
										
										if($acls->getSubgroupID() != 0) {
											if($psgid == 0 || $psgid != $acls->getSubgroupID()) {
												$pbgid	= $acls->getBGID();
												$psgid 	= $acls->getSubgroupID();
												$gTot		= $mdb->getClosingBalanceBySubgroupIDMultipleCompany($cid, $pbgid, $psgid, $ndt, "YES");
												$padleft	= 15;
				
												if($gTot[0] != 0) {
													$sgdet	= $mdb->getSubgroupDetail($psgid);
													if($gTot[1] == DEBIT) {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
														<td align="right">&nbsp;</td>
													</tr>
									<?php
													} else {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td align="right">&nbsp;</td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
													</tr>
									<?php
													}
													$padleft	= 30;
												}
											}
										} else {
											$padleft = 15;
										}										
										
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, "YES");
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == DEBIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccountMultipleCompany($cid, $acls->getAccountID(), $ndt, "YES");
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == DEBIT) $tmpamt = -$tmpamt;										
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($plProfit > 0) { ?>
								<tr bgcolor="#FFFF66">
									<td class="td_normal_large"><b>Profit &amp; Loss A/c</b></td>
									<td class="td_normal_large" align='right'>&nbsp;</td>
									<td class="td_normal_large" align='right'><b><?php echo number_format($plProfit, 2, '.', '') ?></b></td>
								</tr>
							<?php } ?>																					
							
						</table>
					</td>
					<td width="50%" valign="top">
						<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
							<tr bgcolor="#f4f4f4">
								<td width='55%'>
									<font style='font-family:arial; font-size:12px'><b>PARTICULARS</b></font>
								</td>
								<td width='20%' align='right'>
									<font style='font-family:arial; font-size:12px'>&nbsp;</font>
								</td>
								<td width='25%' align='right'>
									<font style='font-family:arial; font-size:12px'>&nbsp;</font>
								</td>
							</tr>
							
							<?php if($bsa6[0] != 0) { ?>
								<tr bgcolor="#FFFF66">
									<td class="td_normal_large"><b>Fixed Asset</b></td>
									<td class="td_normal_large" align='right'>&nbsp;</td>
									<?php if($bsa6[1] == DEBIT) { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format($bsa6[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format(-$bsa6[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									$psgid		= 0;
									$padleft	= 15;								
									for($i=0;$i<count($bsaAct6);$i++) {
										$acls	= $bsaAct6[$i];
										
										if($acls->getSubgroupID() != 0) {
											if($psgid == 0 || $psgid != $acls->getSubgroupID()) {
												$pbgid	= $acls->getBGID();
												$psgid 	= $acls->getSubgroupID();
												$gTot		= $mdb->getClosingBalanceBySubgroupIDMultipleCompany($cid, $pbgid, $psgid, $ndt, "YES");
												$padleft	= 15;
				
												if($gTot[0] != 0) {
													$sgdet	= $mdb->getSubgroupDetail($psgid);
													if($gTot[1] == DEBIT) {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
														<td align="right">&nbsp;</td>
													</tr>
									<?php
													} else {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td align="right">&nbsp;</td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
													</tr>
									<?php
													}
													$padleft	= 30;
												}
											}
										} else {
											$padleft = 15;
										}										
										
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, "YES");
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccountMultipleCompany($cid, $acls->getAccountID(), $ndt, "YES");
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;										
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($bsa7[0] != 0) { ?>
								<tr bgcolor="#FFFF66">
									<td class="td_normal_large"><b>Investment</b></td>
									<td class="td_normal_large" align='right'>&nbsp;</td>
									<?php if($bsa7[1] == DEBIT) { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format($bsa7[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format(-$bsa7[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									$psgid		= 0;
									$padleft	= 15;								
									for($i=0;$i<count($bsaAct7);$i++) {
										$acls	= $bsaAct7[$i];
										
										if($acls->getSubgroupID() != 0) {
											if($psgid == 0 || $psgid != $acls->getSubgroupID()) {
												$pbgid	= $acls->getBGID();
												$psgid 	= $acls->getSubgroupID();
												$gTot		= $mdb->getClosingBalanceBySubgroupIDMultipleCompany($cid, $pbgid, $psgid, $ndt, "YES");
												$padleft	= 15;
				
												if($gTot[0] != 0) {
													$sgdet	= $mdb->getSubgroupDetail($psgid);
													if($gTot[1] == DEBIT) {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
														<td align="right">&nbsp;</td>
													</tr>
									<?php
													} else {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td align="right">&nbsp;</td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
													</tr>
									<?php
													}
													$padleft	= 30;
												}
											}
										} else {
											$padleft = 15;
										}										
										
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, "YES");
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccountMultipleCompany($cid, $acls->getAccountID(), $ndt, "YES");
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;										
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($bsa8[0] != 0) { ?>
								<tr bgcolor="#FFFF66">
									<td class="td_normal_large"><b>Loan &amp; Advances</b></td>
									<td class="td_normal_large" align='right'>&nbsp;</td>
									<?php if($bsa8[1] == DEBIT) { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format($bsa8[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format(-$bsa8[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									$psgid		= 0;
									$padleft	= 15;								
									for($i=0;$i<count($bsaAct8);$i++) {
										$acls	= $bsaAct8[$i];
										
										if($acls->getSubgroupID() != 0) {
											if($psgid == 0 || $psgid != $acls->getSubgroupID()) {
												$pbgid	= $acls->getBGID();
												$psgid 	= $acls->getSubgroupID();
												$gTot		= $mdb->getClosingBalanceBySubgroupIDMultipleCompany($cid, $pbgid, $psgid, $ndt, "YES");
												$padleft	= 15;
				
												if($gTot[0] != 0) {
													$sgdet	= $mdb->getSubgroupDetail($psgid);
													if($gTot[1] == DEBIT) {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
														<td align="right">&nbsp;</td>
													</tr>
									<?php
													} else {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td align="right">&nbsp;</td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
													</tr>
									<?php
													}
													$padleft	= 30;
												}
											}
										} else {
											$padleft = 15;
										}										
										
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, "YES");
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccountMultipleCompany($cid, $acls->getAccountID(), $ndt, "YES");
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;										
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($bsa9[0] != 0) { ?>
								<tr bgcolor="#FFFF66">
									<td class="td_normal_large"><b>Cash</b></td>
									<td class="td_normal_large" align='right'>&nbsp;</td>
									<?php if($bsa9[1] == DEBIT) { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format($bsa9[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format(-$bsa9[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									$psgid		= 0;
									$padleft	= 15;								
									for($i=0;$i<count($bsaAct9);$i++) {
										$acls	= $bsaAct9[$i];
										
										if($acls->getSubgroupID() != 0) {
											if($psgid == 0 || $psgid != $acls->getSubgroupID()) {
												$pbgid	= $acls->getBGID();
												$psgid 	= $acls->getSubgroupID();
												$gTot		= $mdb->getClosingBalanceBySubgroupIDMultipleCompany($cid, $pbgid, $psgid, $ndt, "YES");
												$padleft	= 15;
				
												if($gTot[0] != 0) {
													$sgdet	= $mdb->getSubgroupDetail($psgid);
													if($gTot[1] == DEBIT) {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
														<td align="right">&nbsp;</td>
													</tr>
									<?php
													} else {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td align="right">&nbsp;</td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
													</tr>
									<?php
													}
													$padleft	= 30;
												}
											}
										} else {
											$padleft = 15;
										}										
										
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, "YES");
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccountMultipleCompany($cid, $acls->getAccountID(), $ndt, "YES");
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;										
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($bsa10[0] != 0) { ?>
								<tr bgcolor="#FFFF66">
									<td class="td_normal_large"><b>Bank</b></td>
									<td class="td_normal_large" align='right'>&nbsp;</td>
									<?php if($bsa10[1] == DEBIT) { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format($bsa10[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format(-$bsa10[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									$psgid		= 0;
									$padleft	= 15;								
									for($i=0;$i<count($bsaAct10);$i++) {
										$acls	= $bsaAct10[$i];
										
										if($acls->getSubgroupID() != 0) {
											if($psgid == 0 || $psgid != $acls->getSubgroupID()) {
												$pbgid	= $acls->getBGID();
												$psgid 	= $acls->getSubgroupID();
												$gTot		= $mdb->getClosingBalanceBySubgroupIDMultipleCompany($cid, $pbgid, $psgid, $ndt, "YES");
												$padleft	= 15;
				
												if($gTot[0] != 0) {
													$sgdet	= $mdb->getSubgroupDetail($psgid);
													if($gTot[1] == DEBIT) {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
														<td align="right">&nbsp;</td>
													</tr>
									<?php
													} else {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td align="right">&nbsp;</td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
													</tr>
									<?php
													}
													$padleft	= 30;
												}
											}
										} else {
											$padleft = 15;
										}										
										
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, "YES");
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccountMultipleCompany($cid, $acls->getAccountID(), $ndt, "YES");
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;										
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($bsa11[0] != 0) { ?>
								<tr bgcolor="#FFFF66">
									<td class="td_normal_large"><b>Sundry Debtors</b></td>
									<td class="td_normal_large" align='right'>&nbsp;</td>
									<?php if($bsa11[1] == DEBIT) { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format($bsa11[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format(-$bsa11[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									$psgid		= 0;
									$padleft	= 15;								
									for($i=0;$i<count($bsaAct11);$i++) {
										$acls	= $bsaAct11[$i];
										
										if($acls->getSubgroupID() != 0) {
											if($psgid == 0 || $psgid != $acls->getSubgroupID()) {
												$pbgid	= $acls->getBGID();
												$psgid 	= $acls->getSubgroupID();
												$gTot		= $mdb->getClosingBalanceBySubgroupIDMultipleCompany($cid, $pbgid, $psgid, $ndt, "YES");
												$padleft	= 15;
				
												if($gTot[0] != 0) {
													$sgdet	= $mdb->getSubgroupDetail($psgid);
													if($gTot[1] == DEBIT) {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
														<td align="right">&nbsp;</td>
													</tr>
									<?php
													} else {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td align="right">&nbsp;</td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
													</tr>
									<?php
													}
													$padleft	= 30;
												}
											}
										} else {
											$padleft = 15;
										}										
										
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, "YES");
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccountMultipleCompany($cid, $acls->getAccountID(), $ndt, "YES");
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;									
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($bsa12[0] != 0) { ?>
								<tr bgcolor="#FFFF66">
									<td class="td_normal_large"><b>Stock</b></td>
									<td class="td_normal_large" align='right'>&nbsp;</td>
									<?php if($bsa12[1] == DEBIT) { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format($bsa12[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format(-$bsa12[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									$psgid		= 0;
									$padleft	= 15;								
									for($i=0;$i<count($bsaAct12);$i++) {
										$acls	= $bsaAct12[$i];
										
										if($acls->getSubgroupID() != 0) {
											if($psgid == 0 || $psgid != $acls->getSubgroupID()) {
												$pbgid	= $acls->getBGID();
												$psgid 	= $acls->getSubgroupID();
												$gTot		= $mdb->getClosingBalanceBySubgroupIDMultipleCompany($cid, $pbgid, $psgid, $ndt, "YES");
												$padleft	= 15;
				
												if($gTot[0] != 0) {
													$sgdet	= $mdb->getSubgroupDetail($psgid);
													if($gTot[1] == DEBIT) {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
														<td align="right">&nbsp;</td>
													</tr>
									<?php
													} else {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td align="right">&nbsp;</td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
													</tr>
									<?php
													}
													$padleft	= 30;
												}
											}
										} else {
											$padleft = 15;
										}										
										
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, "YES");
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccountMultipleCompany($cid, $acls->getAccountID(), $ndt, "YES");
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;										
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($bsa21[0] != 0) { ?>
								<tr bgcolor="#FFFF66">
									<td class="td_normal_large"><b>Current Asset</b></td>
									<td class="td_normal_large" align='right'>&nbsp;</td>
									<?php if($bsa21[1] == DEBIT) { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format($bsa21[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format(-$bsa21[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									$psgid		= 0;
									$padleft	= 15;								
									for($i=0;$i<count($bsaAct21);$i++) {
										$acls	= $bsaAct21[$i];
										
										if($acls->getSubgroupID() != 0) {
											if($psgid == 0 || $psgid != $acls->getSubgroupID()) {
												$pbgid	= $acls->getBGID();
												$psgid 	= $acls->getSubgroupID();
												$gTot		= $mdb->getClosingBalanceBySubgroupIDMultipleCompany($cid, $pbgid, $psgid, $ndt, "YES");
												$padleft	= 15;
				
												if($gTot[0] != 0) {
													$sgdet	= $mdb->getSubgroupDetail($psgid);
													if($gTot[1] == DEBIT) {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
														<td align="right">&nbsp;</td>
													</tr>
									<?php
													} else {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td align="right">&nbsp;</td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
													</tr>
									<?php
													}
													$padleft	= 30;
												}
											}
										} else {
											$padleft = 15;
										}										
										
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, "YES");
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccountMultipleCompany($cid, $acls->getAccountID(), $ndt, "YES");
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;										
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($bsa23[0] != 0) { ?>
								<tr bgcolor="#FFFF66">
									<td class="td_normal_large"><b>Deposits</b></td>
									<td class="td_normal_large" align='right'>&nbsp;</td>
									<?php if($bsa23[1] == DEBIT) { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format($bsa23[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format(-$bsa23[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									$psgid		= 0;
									$padleft	= 15;								
									for($i=0;$i<count($bsaAct23);$i++) {
										$acls	= $bsaAct23[$i];
										
										if($acls->getSubgroupID() != 0) {
											if($psgid == 0 || $psgid != $acls->getSubgroupID()) {
												$pbgid	= $acls->getBGID();
												$psgid 	= $acls->getSubgroupID();
												$gTot		= $mdb->getClosingBalanceBySubgroupIDMultipleCompany($cid, $pbgid, $psgid, $ndt, "YES");
												$padleft	= 15;
				
												if($gTot[0] != 0) {
													$sgdet	= $mdb->getSubgroupDetail($psgid);
													if($gTot[1] == DEBIT) {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
														<td align="right">&nbsp;</td>
													</tr>
									<?php
													} else {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td align="right">&nbsp;</td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
													</tr>
									<?php
													}
													$padleft	= 30;
												}
											}
										} else {
											$padleft = 15;
										}										
										
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, "YES");
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccountMultipleCompany($cid, $acls->getAccountID(), $ndt, "YES");
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;										
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($bsa24[0] != 0) { ?>
								<tr bgcolor="#FFFF66">
									<td class="td_normal_large"><b>Branch/Divisions</b></td>
									<td class="td_normal_large" align='right'>&nbsp;</td>
									<?php if($bsa24[1] == DEBIT) { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format($bsa24[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format(-$bsa24[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									$psgid		= 0;
									$padleft	= 15;								
									for($i=0;$i<count($bsaAct24);$i++) {
										$acls	= $bsaAct24[$i];
										
										if($acls->getSubgroupID() != 0) {
											if($psgid == 0 || $psgid != $acls->getSubgroupID()) {
												$pbgid	= $acls->getBGID();
												$psgid 	= $acls->getSubgroupID();
												$gTot		= $mdb->getClosingBalanceBySubgroupIDMultipleCompany($cid, $pbgid, $psgid, $ndt, "YES");
												$padleft	= 15;
				
												if($gTot[0] != 0) {
													$sgdet	= $mdb->getSubgroupDetail($psgid);
													if($gTot[1] == DEBIT) {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
														<td align="right">&nbsp;</td>
													</tr>
									<?php
													} else {
									?>
													<tr bgcolor="#FFFFC0">
														<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
														<td align="right">&nbsp;</td>
														<td class="td_normal" align="right"><b><?php echo number_format($gTot[0],2,'.','') ?></b></td>
													</tr>
									<?php
													}
													$padleft	= 30;
												}
											}
										} else {
											$padleft = 15;
										}										
										
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, "YES");
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else {?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccountMultipleCompany($cid, $acls->getAccountID(), $ndt, "YES");
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;										
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:<?php echo $padleft?>px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>																	
									<?php } ?>						
								<?php } ?>
							<?php } ?>
							
							<?php if($plProfit < 0) { ?>
								<tr bgcolor="#FFFF66">
									<td class="td_normal_large"><b>Profit &amp; Loss A/c</b></td>
									<td align='right'>&nbsp;</td>
									<td class="td_normal_large" align='right'><b><?php echo number_format(-$plProfit, 2, '.', '') ?></b></td>
								</tr>
							<?php } ?>							
																					
						</table>
					</td>					
				</tr>

				<?php if($plProfit > 0) { ?>
				
					<tr>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td class="td_normal_large" width="55%"><b>TOTAL</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<td class="td_normal_large" width="25%" align='right'><b><?php echo number_format($bcrSide + $plProfit, 2, '.', '')?></b></td>					
								</tr>
							</table>
						</td>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td class="td_normal_large" width="55%"><b>TOTAL</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<td class="td_normal_large" width="25%" align='right'><b><?php echo number_format($bdrSide, 2, '.', '')?></b></td>					
								</tr>
							</table>
						</td>
					</tr>	
					
				<?php } else { ?>
				
					<tr>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td class="td_normal_large" width="55%"><b>TOTAL</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<td class="td_normal_large" width="25%" align='right'><b><?php echo number_format($bcrSide, 2, '.', '')?></b></td>					
								</tr>
							</table>
						</td>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td class="td_normal_large" width="55%"><b>TOTAL</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<td class="td_normal_large" width="25%" align='right'><b><?php echo number_format($bdrSide - $plProfit, 2, '.', '')?></b></td>					
								</tr>
							</table>
						</td>
					</tr>				
				
				<?php } ?>
				
			</table>
		</div>
		
	<br />
	<div style="text-align:center"><input type="button" value="Export to Excel" onClick="ExportToExcel()" class="red_button" /></div>
	<br />		
		
	</div>
</body>
</html>

<script type="text/javascript">

	function ExportToExcel(){
		 var tbl		= document.getElementById('main_table');
		 var html 	= tbl.outerHTML;
		 window.open('data:application/vnd.ms-excel,' + encodeURIComponent(html));
	}
	
</script>