<?php

	/* Include the required files */
	require_once( '../inc/functions.php' );
	require_once( '../aom-config.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/asys.voucherdb.php' );
	require_once( '../dao/asys.drcr.php' );
	require_once( '../dao/asys.group.php' );
	require_once( '../dao/asys.voucher.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 46;

	$mdb			=	new masterdb("REPORT");
	$vdb			=	new voucherdb("REPORT");
	$ldb			= new logindb("REPORT");
	
	$vdb->updateGroupSubgroup();
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}		

	$fdate		=	getFirstFinancialDate();
	$tdate		=	getLastFinancialDate();
	$cmp			= "";
	$cid			= "";	

	extract($_REQUEST);

	$df				=	FormatIndianDateToSQLDate($fdate);
	$dt				=	FormatIndianDateToSQLDate($tdate);
	$cid			= $tcmp->getCompanyID();
	if($cmp != "") {
		$tmparr		= explode(",", $cmp);
		for($i=0;$i<count($tmparr);$i++) {
			$cid	= $cid.','.(int)$tmparr[$i];
		}
	}	

	if($df == '1900-01-01' || $dt == '1900-01-01'){
		echo 'Invalid input Date format, try again';
		exit;
	}
	
	$ndt			=	getNextDate($dt);
	
	/**********************************************************
	**         Trading Account 
	***********************************************************/
	
	$deTot		= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 13, $ndt, "YES");
	$puTot		= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 19, $ndt, "YES");
	
	$diTot		= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 20, $ndt, "YES");
	$saTot		= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 18, $ndt, "YES");
	
	$taProfit	= 0;
	$tcrSide	= 0;
	$tdrSide	= 0;
	$tcrCnt		= 0;
	$tdrCnt		= 0;
	
	if($diTot[1] == CREDIT)
		$tcrSide	= $diTot[0];
	else
		$tcrSide	= -$diTot[0];
	
	if($saTot[1] == CREDIT)
		$tcrSide = bcadd($tcrSide, $saTot[0], 2);
	else
		$tcrSide = bcsub($tcrSide, $saTot[0], 2);
		
	if($deTot[1] == DEBIT)
		$tdrSide = $deTot[0];
	else
		$tdrSide = -$deTot[0];
		
	if($puTot[1] == DEBIT)
		$tdrSide = bcadd($tdrSide, $puTot[0], 2);
	else
		$tdrSide = bcsub($tdrSide, $puTot[0], 2);

	$taProfit	= number_format( $tcrSide - $tdrSide, 2, '.', '');
	
	/**********************************************************
	**         Trading Account ends here
	***********************************************************/
	
	
	/**********************************************************
	**         PL Account 
	***********************************************************/
	
	$plProfit	= 0;
	$pcrSide	= 0;
	$pdrSide	= 0;
	$pcrCnt		= 0;
	$pdrCnt		= 0;
	
	$ieTot		= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 14, $ndt, "YES");
	$meTot		= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 15, $ndt, "YES");
	$dtTot		= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 16, $ndt, "YES");
	
	$iiTot		= $mdb->getClosingBalanceByBGIDMultipleCompany($cid, 17, $ndt, "YES");
	
	if($ieTot[1] == DEBIT)
		$pdrSide = $ieTot[0];
	else
		$pdrSide = -$ieTot[0];
		
	if($meTot[1] == DEBIT)
		$pdrSide = bcadd($pdrSide, $meTot[0], 2);
	else
		$pdrSide = bcsub($pdrSide, $meTot[0], 2);
		
	if($dtTot[1] == DEBIT)
		$pdrSide = bcadd($pdrSide, $dtTot[0], 2);
	else
		$pdrSide = bcsub($pdrSide, $dtTot[0], 2);
		
	if($iiTot[1] == CREDIT)
		$pcrSide = $iiTot[0];
	else
		$pcrSide = -$iiTot[0];				
	
	if($taProfit > 0)
		$plProfit	= number_format( $taProfit + $pcrSide - $pdrSide, 2, '.', '');
	else
		$plProfit	= number_format( $pcrSide - ($pdrSide - $taProfit), 2, '.', '');
	
	/**********************************************************
	**         PL Account ends here
	***********************************************************/	
	
	$deAct1		= $mdb->getShortMotherAccountListBGWiseMultipleCompany($cid, 13);
	$deAct2		= $mdb->getShortMotherAccountListBGWiseMultipleCompany($cid, 19);
	$diAct1		= $mdb->getShortMotherAccountListBGWiseMultipleCompany($cid, 18);
	$diAct2		= $mdb->getShortMotherAccountListBGWiseMultipleCompany($cid, 20);
	
	$ieAct1		= $mdb->getShortMotherAccountListBGWiseMultipleCompany($cid, 14);
	$meAct1		= $mdb->getShortMotherAccountListBGWiseMultipleCompany($cid, 15);
	$dtAct1		= $mdb->getShortMotherAccountListBGWiseMultipleCompany($cid, 16);
	$iiAct1		= $mdb->getShortMotherAccountListBGWiseMultipleCompany($cid, 17);

?>


<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html;charset=utf-8"/>
		<title>Profit &amp; Loss A/c</title>
		<link href="../css/rpt.css" type=text/css rel=stylesheet>
		<script src="../js/common.js"></script>
	</head>
<body style="background-color:#ffffff">
	<div style="font-family:verdana;width:1000px;margin:0px auto;" align="center">

		<div style="font-size:9px;">
			<table cellSpacing='0' cellPadding='0' width='100%' style="border-collapse: collapse;border:#CCCCCC 1px solid" id="main_table">
			
				<tr bgcolor="#FFFFFF">
					<td colspan="3" style="text-align:center; letter-spacing:1pt;">
						<br /><font style="font-size:18px; font-weight:bold;"><?php echo $tcmp->getCompanyName()?></font><br />
						<font style="font-size:15px; font-weight:normal;"><?php echo nl2br($tcmp->getCompanyAddress())?><br /><br />
						<b>Merged Profit &amp; Loss A/c from <?php echo $fdate?> to <?php echo $tdate?></b></font>
					</td>
				</tr>			
			
				<tr>
					<td width="50%" valign="top">
						<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
							<tr bgcolor="#f4f4f4">
								<td width='60%'>
									<font style='font-family:arial; font-size:12px'><b>PARTICULARS</b></font>
								</td>
								<td width='20%' align='right'>
									<font style='font-family:arial; font-size:12px'>&nbsp;</font>
								</td>
								<td width='20%' align='right'>
									<font style='font-family:arial; font-size:12px'>&nbsp;</font>
								</td>
							</tr>
							
							<?php if($deTot[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td><b>Direct Expenses</b></td>
									<td align='right'>&nbsp;</td>
									<?php if($deTot[1] == DEBIT) { ?>
										<td align='right'><b><?php echo number_format($deTot[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$deTot[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($deAct1);$i++) {
										$acls	= $deAct1[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, "YES");
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else { ?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccountMultipleCompany($cid, $acls->getAccountID(), $ndt, "YES");
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } ?>
								<?php } ?>
							<?php } ?>
							
							<?php if($puTot[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td><b>Purchases</b></td>
									<td align='right'>&nbsp;</td>
									<?php if($deTot[1] == DEBIT) { ?>
										<td align='right'><b><?php echo number_format($puTot[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$puTot[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($deAct2);$i++) {
										$acls	= $deAct2[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, "YES");
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo $tamt ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else { ?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccountMultipleCompany($cid, $acls->getAccountID(), $ndt, "YES");
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } ?>
								<?php } ?>
							<?php } ?>
							
						</table>
					</td>
					<td width="50%" valign="top">
						<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
							<tr bgcolor="#f4f4f4">
								<td width='60%'>
									<font style='font-family:arial; font-size:12px'><b>PARTICULARS</b></font>
								</td>
								<td width='20%' align='right'>
									<font style='font-family:arial; font-size:12px'>&nbsp;</font>
								</td>
								<td width='20%' align='right'>
									<font style='font-family:arial; font-size:12px'>&nbsp;</font>
								</td>
							</tr>
							
							<?php if($diTot[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td><b>Direct Incomes</b></td>
									<td align='right'>&nbsp;</td>
									<?php if($diTot[1] == CREDIT) { ?>
										<td align='right'><b><?php echo number_format($diTot[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$diTot[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($diAct2);$i++) {
										$acls	= $diAct2[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, "YES");
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == DEBIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else { ?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccountMultipleCompany($cid, $acls->getAccountID(), $ndt, "YES");
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == DEBIT) $tmpamt = -$tmpamt;
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } ?>
								<?php } ?>
							<?php } ?>
							
							<?php if($saTot[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td><b>Sales</b></td>
									<td align='right'>&nbsp;</td>
									<?php if($saTot[1] == CREDIT) { ?>
										<td align='right'><b><?php echo number_format($saTot[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$saTot[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($diAct1);$i++) {
										$acls	= $diAct1[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, "YES");
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == DEBIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else { ?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccountMultipleCompany($cid, $acls->getAccountID(), $ndt, "YES");
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == DEBIT) $tmpamt = -$tmpamt;
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } ?>
								<?php } ?>
							<?php } ?>							
																					
						</table>
					</td>					
				</tr>
				
				<?php if($taProfit > 0) { ?>
				
					<tr>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>Gross Profit c/o</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'><b><?php echo $taProfit ?></b></td>
								</tr>
							</table>
						</td>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%">&nbsp;</td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'>&nbsp;</td>
								</tr>
							</table>
						</td>
					</tr>
					<tr><td colspan="2">&nbsp;</td></tr>
					<tr>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%">&nbsp;</td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'>&nbsp;</td>
								</tr>
							</table>
						</td>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>Gross Profit b/f</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'><b><?php echo $taProfit ?></b></td>
								</tr>
							</table>
						</td>
					</tr>
				
				<?php } else { ?>
				
					<tr>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%">&nbsp;</td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'>&nbsp;</td>
								</tr>
							</table>
						</td>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>Gross Loss c/o</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'><b><?php echo number_format(-$taProfit, 2, '.', '') ?></b></td>
								</tr>
							</table>
						</td>
					</tr>
					<tr><td colspan="2">&nbsp;</td></tr>
					<tr>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>Gross Loss b/f</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'><b><?php echo number_format(-$taProfit, 2, '.', '') ?></b></td>
								</tr>
							</table>
						</td>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%">&nbsp;</td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'>&nbsp;</td>
								</tr>
							</table>
						</td>
					</tr>				
				
				<?php } ?>
				
				<tr>
					<td valign="top">
						<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">

							<?php if($ieTot[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>Indirect Expenses</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<?php if($ieTot[1] == DEBIT) { ?>
										<td align='right'><b><?php echo number_format($ieTot[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$ieTot[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($ieAct1);$i++) {
										$acls	= $ieAct1[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, "YES");
											$tamt	= $amt[0];
										
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else { ?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccountMultipleCompany($cid, $acls->getAccountID(), $ndt, "YES");
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } ?>
								<?php } ?>
							<?php } ?>
							
							<?php if($meTot[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>Miscellaneous Expenses</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<?php if($meTot[1] == DEBIT) { ?>
										<td align='right'><b><?php echo number_format($meTot[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$meTot[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($meAct1);$i++) {
										$acls	= $meAct1[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, "YES");
											$tamt	= $amt[0];
										
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else { ?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccountMultipleCompany($cid, $acls->getAccountID(), $ndt, "YES");
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } ?>
								<?php } ?>
							<?php } ?>
							
							<?php if($dtTot[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>Duties &amp; Taxes</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<?php if($dtTot[1] == DEBIT) { ?>
										<td align='right'><b><?php echo number_format($dtTot[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$dtTot[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($dtAct1);$i++) {
										$acls	= $dtAct1[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, "YES");
											$tamt	= $amt[0];
										
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else { ?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccountMultipleCompany($cid, $acls->getAccountID(), $ndt, "YES");
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } ?>
								<?php } ?>
							<?php } ?>							

						</table>
					</td>
					<td valign="top">
						<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
							
							<?php if($iiTot[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>Indirect Incomes</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<?php if($iiTot[1] == CREDIT) { ?>
										<td align='right'><b><?php echo number_format($iiTot[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$iiTot[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($iiAct1);$i++) {
										$acls	= $iiAct1[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, "YES");
											$tamt	= $amt[0];
										
											if($tamt == 0) continue;
											if($amt[1] == DEBIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else { ?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccountMultipleCompany($cid, $acls->getAccountID(), $ndt, "YES");
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == DEBIT) $tmpamt = -$tmpamt;
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<?php echo $acls->getCompanyCode()?>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } ?>
								<?php } ?>
							<?php } ?>							
																					
						</table>
					</td>
				</tr>
				
				<?php if($plProfit > 0) { ?>
				
					<tr>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>Net Profit</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'><b><?php echo $plProfit ?></b></td>
								</tr>
							</table>
						</td>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%">&nbsp;</td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'>&nbsp;</td>
								</tr>
							</table>
						</td>
					</tr>
				
					<tr>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>TOTAL</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'><b><?php echo number_format($plProfit + $pdrSide, 2, '.', '')?></b></td>
								</tr>
							</table>
						</td>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>TOTAL</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'><b><?php echo number_format($pcrSide + $taProfit, 2, '.', '')?></b></td>
								</tr>
							</table>
						</td>
					</tr>
					
				<?php } else { ?>
				
					<tr>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%">&nbsp;</td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'>&nbsp;</td>
								</tr>
							</table>
						</td>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>Net Loss</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'><b><?php echo number_format(-$plProfit, 2, '.', '') ?></b></td>
								</tr>
							</table>
						</td>
					</tr>
				
					<tr>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>TOTAL</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'><b><?php echo number_format($pdrSide - $taProfit, 2, '.', '')?></b></td>
								</tr>
							</table>
						</td>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>TOTAL</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'><b><?php echo number_format($pcrSide - $plProfit, 2, '.', '')?></b></td>
								</tr>
							</table>
						</td>
					</tr>				
				
				<?php } ?>
				
			</table>
		</div>
		
	<br />
	<div style="text-align:center"><input type="button" value="Export to Excel" onClick="ExportToExcel()" class="red_button" /></div>
	<br />
		
	</div>
</body>
</html>

<script type="text/javascript">

	function ExportToExcel(){
		 var tbl		= document.getElementById('main_table');
		 var html 	= tbl.outerHTML;
		 window.open('data:application/vnd.ms-excel,' + encodeURIComponent(html));
	}
	
</script>