<?php

	/* Include the required files */
	require_once( '../inc/functions.php' );
	require_once( '../aom-config.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/asys.voucherdb.php' );
	require_once( '../dao/asys.drcr.php' );
	require_once( '../dao/asys.group.php' );
	require_once( '../dao/asys.voucher.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );	

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 46;

	$db				=	new masterdb("REPORT");
	$vdb			=	new voucherdb("REPORT");
	$ldb			= new logindb("REPORT");
	
	$vdb->updateGroupSubgroup();
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}		

	$fdate		=	getFirstFinancialDate();
	$tdate		=	getLastFinancialDate();
	$cmp			= "";
	$cid			= "";

	extract($_REQUEST);

	$df				=	FormatIndianDateToSQLDate($fdate);
	$dt				=	FormatIndianDateToSQLDate($tdate);
	$cid			= $tcmp->getCompanyID();
	if($cmp != "") {
		$tmparr		= explode(",", $cmp);
		for($i=0;$i<count($tmparr);$i++) {
			$cid	= $cid.','.(int)$tmparr[$i];
		}
	}

	if($df == '1900-01-01' || $dt == '1900-01-01'){
		echo 'Invalid input Date format, try again';
		exit;
	}

	$ndt			=	getNextDate($dt);

	$accList	=	$db->getShortMotherAccountListMultipleCompany($cid);

?>


<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
		<title>Merged Trial Balance</title>
		<link href="../css/rpt.css" type="text/css" rel="stylesheet" />
		<script src="../js/common.js"></script>
	</head>
<body style="background-color:#ffffff">
	<div style="font-family:verdana;margin:0px auto;width:900px;" align="center">

		<div style="font-size:12px;font-family:arial;">
			<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC" id="main_table">
				<tr bgcolor="#FFFFFF">
					<td colspan="3" style="text-align:center; letter-spacing:1pt;">
						<br /><font style="font-size:18px; font-weight:bold;"><?php echo $tcmp->getCompanyName()?></font><br />
						<font style="font-size:15px; font-weight:normal;"><?php echo nl2br($tcmp->getCompanyAddress())?><br /><br />
						<b>Merged Trial Balance from <?php echo $fdate?> to <?php echo $tdate?></b></font>
					</td>
				</tr>				
				<tr bgcolor="#F4F4F4">
					<td width='70%'><b>PARTICULARS</b></td>
					<td width='15%' align='right'><b>DEBIT</b></td>
					<td width='15%' align='right'><b>CREDIT</b></td>
				</tr>

<?php
	$totdr		=	0;
	$totcr		=	0;
	$pbgid		= 0;
	for($i=0;$i<count($accList);$i++) {
		$acc		=	$accList[$i];
		$adet		= $db->getAccountDetail($acc->getAccountID());
		
		if($acc->getContainsSubLedger() == "NO") {
			$clbal	=	$db->getClosingBalanceByAccountID($acc->getAccountID(), $ndt, "YES");
			$camt		=	number_format($clbal[0],2,'.','');
			$ctype	=	$clbal[1];
			if($clbal[0] != 0) {
?>						

				<tr bgcolor="#FFFFFF">
					<td>
						<a href="rptMainLedger.php?accid=<?php echo $acc->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Ledger" target="_blank"><?php echo $acc->getPrnName() ?> (<?php echo $acls->getCompanyCode()?>)</a>
					</td>
<?php
				if($ctype == DEBIT) {
						$totdr+=$clbal[0];
?>
						<td align="right"><?php echo number_format($camt, 2, '.', '') ?></td>
						<td align="right">&nbsp;</td>
					</tr>
<?php
				} else {
						$totcr+=$clbal[0];
?>
						<td align="right">&nbsp;</td>
						<td align="right"><?php echo number_format($camt, 2, '.', '') ?></td>
					</tr>
<?php
				}

			}
		} else {
		
			$clbal		= $db->getClosingBalanceByMotherAccount($adet->getCompanyID(), $acc->getAccountID(), $ndt, 'YES');

			if($clbal[0] > 0) {
?>
					<tr bgcolor="#FFFFFF">
						<td valign="top">
							<?php echo $acc->getPrnName() ?> (<?php echo $acls->getCompanyCode()?>) (<a href="rptSubTrial.php?accid=<?php echo $acc->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Sub Trial" target="_blank">+</a>)
						</td>
<?php
				if($clbal[1] == DEBIT) {
					$totdr+=$clbal[0];
?>
							<td align="right"><?php echo number_format($clbal[0],2,".",'') ?></td>
							<td align="right">&nbsp;</td>
						</tr>
<?php
				} else {
					$totcr+=$clbal[0];
?>
							<td align="right">&nbsp;</td>
							<td align="right"><?php echo number_format($clbal[0],2,".",'') ?></td>
						</tr>
<?php
				}

			}
		}
	}
?>			

				<tr bgcolor="#F4F4F4">
					<td width='70%'><b>CURRENT TOTAL ***</b></td>
					<td width='15%' align='right'><b><?php echo number_format($totdr,2, '.','')?></b></td>
					<td width='15%' align='right'><b><?php echo number_format($totcr,2,'.','')?></b></td>
				</tr>

		<?php
			if($totdr - $totcr > 0) {
		?>

				<tr bgcolor="#F4F4F4">
					<td width='70%'><b>CLOSING/DIFFERENCE ***</b></td>
					<td width='15%' align='right'><b><?php echo number_format($totdr-$totcr,2,'.','')?></b></td>
					<td width='15%' align='right'><b>&nbsp;</b></td>
				</tr>

		<?php
			} else if($totdr-$totcr < 0) {
		?>

				<tr bgcolor="#F4F4F4">
					<td width='70%'><b>CLOSING/DIFFERENCE ***</b></td>
					<td width='15%' align='right'><b>&nbsp;</b></td>
					<td width='15%' align='right'><b><?php echo number_format($totcr-$totdr,2,'.','')?></b></td>
				</tr>

		<?php } ?>
	
			</table>
		</div>		
		
	</div>
	
	<br />
	<div style="text-align:center"><input type="button" value="Export to Excel" onClick="ExportToExcel()" class="red_button" /></div>
	<br />
	
</body>
</html>

<script type="text/javascript">

	function ExportToExcel(){
		 var tbl		= document.getElementById('main_table');
		 var html 	= tbl.outerHTML;
		 window.open('data:application/vnd.ms-excel,' + encodeURIComponent(html));
	}
	
</script>