<?php

	/* Include the required files */
	require_once( '../inc/functions.php' );
	require_once( '../aom-config.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/asys.voucherdb.php' );
	require_once( '../dao/asys.drcr.php' );
	require_once( '../dao/asys.group.php' );
	require_once( '../dao/asys.voucher.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );		

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 33;

	$db			=	new masterdb("REPORT");
	$vdb		=	new voucherdb("REPORT");
	$ldb		= new logindb("REPORT");
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}		

	$accid	= 0;
	$fdate	=	getFirstFinancialDate();
	$tdate	=	getLastFinancialDate();
	$expand	=	'yes';

	extract($_REQUEST);

	$accid	=	(int)$accid;

	if($accid == 0) {
		echo "Sorry!!! Direct Access not allowed here";
		exit;
	}
	
	$df				= FormatIndianDateToSQLDate($fdate);
	$dt				= FormatIndianDateToSQLDate($tdate);

	$accDet		= $db->getAccountDetail($accid);

?>

<!DOCTYPE html>
<html>

<head>
	<style type="text/css">
		.auto-style22 {
			text-align: right;
		}
		.auto-style21 {
			text-align: center;
		}
		.auto-style23 {
			text-align: right;
			font-family: Arial, Helvetica, sans-serif;
			font-size: small;
		}
		.auto-style24 {
			text-align: center;
			font-family: Arial, Helvetica, sans-serif;
			font-size: small;
		}
		.auto-style25 {
			font-family: Arial, Helvetica, sans-serif;
			font-size: small;
			border-width: 1px;
			background-color: #FFFFFF;
		}
		.auto-style26 {
			text-align: right;
			font-family: Arial, Helvetica, sans-serif;
			font-size: small;
			border-width: 1px;
			background-color: #FFFFFF;
		}
		.auto-style27 {
			font-family: Arial, Helvetica, sans-serif;
			font-size: small;
		}
	</style>
</head>


<body style="background-color:#ffffff">
	<div style="font-family:verdana;margin:0px auto;width:900px;">
		<div style="text-align:center; font-size:18px; font-weight:bold; letter-spacing:1pt;">
			<br><?php echo $tcmp->getCompanyName()?>
		</div>
		<div style="text-align:center; font-size:15px; font-weight:normal; letter-spacing:1pt;">
			<?php echo nl2br($tcmp->getCompanyAddress())?>
		</div>
		<div style="text-align:center; font-size:15px; font-weight:bold; letter-spacing:1pt;">
			<br>Negative Balance ON A/c <?php echo $accDet->getAccountName()?>
		</div>
		<div style="text-align:center; font-size:13px; font-weight:bold;">
			<br /><?php echo $fdate?> - <?php echo $tdate?>
		</div>
		<div style="font-size:12px;">
			<table cellSpacing='1' cellPadding='4' width='100%' bgcolor="#CCCCCC">
				<tr bgcolor="#F4F4F4">
					<td width='50%'>DATE</td>
					<td width='50%' align='right'>CLOSING BALANCE</td>
				</tr>

			<?php
			
				while(true) {
				
					$clbal		=	$db->getClosingBalanceByAccountID($accid, $df, "YES");
					$bal			=	$clbal[0];
					$balt			=	$clbal[1];
					
					if($balt == CREDIT) {
			?>
			
						<tr bgcolor="#FFFFFF">
							<td><?php echo FormatSQLDateToIndianDate($df)?></td>
							<td align='right'><?php echo number_format($bal,2)?> <?php echo getDrCr($balt)?></td>
						</tr>

			<?php
					}
			
					$df		= getNextDate($df);
					if($df > $dt) break;
				}
			?>

			</table>
		</div>

	</div>
</body>
</html>