<?php

	/* Include the required files */
	require_once( '../inc/functions.php' );
	require_once( '../aom-config.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/asys.voucherdb.php' );
	require_once( '../dao/asys.drcr.php' );
	require_once( '../dao/asys.group.php' );
	require_once( '../dao/asys.voucher.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/asys.store.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 41;

	$mdb			=	new masterdb("REPORT");
	$vdb			=	new voucherdb("REPORT");
	$ldb			= new logindb("REPORT");
	
	$strList	= $mdb->getStoreList($tcmp->getCompanyID());
	$oppList	= $mdb->getStoreOppositeAccountList($tcmp->getCompanyID());
	
	$vdb->updateGroupSubgroup();
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}		

	$fdate		=	getFirstFinancialDate();
	$tdate		=	getLastFinancialDate();

	extract($_REQUEST);

	$df				=	FormatIndianDateToSQLDate($fdate);
	$dt				=	FormatIndianDateToSQLDate($tdate);

	if($df == '1900-01-01' || $dt == '1900-01-01'){
		echo 'Invalid input Date format, try again';
		exit;
	}
	
	$cmpid		= $tcmp->getCompanyID();
	$ndt			=	getNextDate($dt);
	$ndtf			=	getNextDate($df);
	
	/**********************************************************
	**         Trading Account 
	***********************************************************/
	
	$stkOp		= 0;
	$stkCl		= 0;
	for($i=0;$i<count($strList);$i++) {
		$scls		= $strList[$i];
		$aid		= 0;
		if($scls->getAccountID() != 0)
			$aid	= $scls->getAccountID();
		else
			$aid	= $scls->getMotherAccountID();
			
		$cbal		= $mdb->getClosingBalanceByAccountID($aid, $ndt, 'YES');
			
		if($cbal[1] == DEBIT)
			$stkCl	= $stkCl + $cbal[0];
		else
			$stkCl	= $stkCl - $cbal[0];
			
		$cbal		= $mdb->getClosingBalanceByAccountID($aid, $ndtf, '');
			
		if($cbal[1] == DEBIT)
			$stkOp	= $stkOp + $cbal[0];
		else
			$stkOp	= $stkOp - $cbal[0];			
	}
	
	$oppTot		= 0;
	for($i=0;$i<count($oppList);$i++) {
		$row		= $oppList[$i];
		$aid		= $row[0];
		$cbal		= $mdb->getClosingBalanceByAccountID($aid, $ndt, 'YES');
		
		if($cbal[1] == CREDIT)
			$oppTot	= $oppTot + $cbal[0];
		else
			$oppTot	= $oppTot - $cbal[0];		
	}	
	
	$deTot		= $mdb->getClosingBalanceByBGID($cmpid, 13, $ndt, 'YES');
	$puTot		= $mdb->getClosingBalanceByBGID($cmpid, 19, $ndt, 'YES');
	
	$diTot		= $mdb->getClosingBalanceByBGID($cmpid, 20, $ndt, 'YES');
	$saTot		= $mdb->getClosingBalanceByBGID($cmpid, 18, $ndt, 'YES');
	
	$taProfit	= 0;
	$tcrSide	= 0;
	$tdrSide	= 0;
	$tcrCnt		= 0;
	$tdrCnt		= 0;
	
	if($diTot[1] == CREDIT)
		$tcrSide	= $diTot[0];
	else
		$tcrSide	= -$diTot[0];
	
	if($saTot[1] == CREDIT)
		$tcrSide 	= bcadd($tcrSide, $saTot[0], 2);
	else
		$tcrSide 	= bcsub($tcrSide, $saTot[0], 2);
		
	$tcrSide 		= bcadd($tcrSide, $stkCl, 2);		
		
	if($deTot[1] == DEBIT)
		$tdrSide 	= $deTot[0] + $oppTot;
	else
		$tdrSide 	= -$deTot[0] + $oppTot;
		
	if($puTot[1] == DEBIT)
		$tdrSide 	= bcadd($tdrSide, $puTot[0], 2);
	else
		$tdrSide 	= bcsub($tdrSide, $puTot[0], 2);
		
	$tdrSide		= bcadd($tdrSide, $stkOp, 2);

	$taProfit		= number_format( $tcrSide - $tdrSide, 2, '.', '');
	
	/**********************************************************
	**         Trading Account ends here
	***********************************************************/
	
	
	/**********************************************************
	**         PL Account 
	***********************************************************/
	
	$plProfit	= 0;
	$pcrSide	= 0;
	$pdrSide	= 0;
	$pcrCnt		= 0;
	$pdrCnt		= 0;
	
	$ieTot		= $mdb->getClosingBalanceByBGID($cmpid, 14, $ndt, 'YES');
	$meTot		= $mdb->getClosingBalanceByBGID($cmpid, 15, $ndt, 'YES');
	
	$iiTot		= $mdb->getClosingBalanceByBGID($cmpid, 17, $ndt, 'YES');
	
	if($ieTot[1] == DEBIT)
		$pdrSide = $ieTot[0];
	else
		$pdrSide = -$ieTot[0];
		
	if($meTot[1] == DEBIT)
		$pdrSide = bcadd($pdrSide, $meTot[0], 2);
	else
		$pdrSide = bcsub($pdrSide, $meTot[0], 2);
		
	if($iiTot[1] == CREDIT)
		$pcrSide = $iiTot[0];
	else
		$pcrSide = -$iiTot[0];				
	
	if($taProfit > 0)
		$plProfit	= number_format( $taProfit + $pcrSide - $pdrSide, 2, '.', '');
	else
		$plProfit	= number_format( $pcrSide - ($pdrSide - $taProfit), 2, '.', '');
	
	/**********************************************************
	**         PL Account ends here
	***********************************************************/	
	
	$deAct1		= $mdb->getShortMotherAccountListBGWise($cmpid, 13);
	$deAct2		= $mdb->getShortMotherAccountListBGWise($cmpid, 19);
	$diAct1		= $mdb->getShortMotherAccountListBGWise($cmpid, 18);
	$diAct2		= $mdb->getShortMotherAccountListBGWise($cmpid, 20);
	
	$ieAct1		= $mdb->getShortMotherAccountListBGWise($cmpid, 14);
	$meAct1		= $mdb->getShortMotherAccountListBGWise($cmpid, 15);
	$dtAct1		= $mdb->getShortMotherAccountListBGWise($cmpid, 16);
	$iiAct1		= $mdb->getShortMotherAccountListBGWise($cmpid, 17);

?>


<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html;charset=utf-8"/>
		<title>Profit &amp; Loss A/c</title>
		<link href="../css/rpt.css" type=text/css rel=stylesheet>
		<script src="../js/common.js"></script>
	</head>
<body style="background-color:#ffffff">
	<div style="font-family:verdana;width:1000px;margin:0px auto;" align="center">

		<div style="font-size:9px;">
			<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC" id="main_table">
			
				<tr bgcolor="#FFFFFF">
					<td colspan="2" align="center">
						<div style="font-size:18px; letter-spacing:1pt;">
							<b><?php echo $tcmp->getCompanyName()?><br /></b>
						</div>
						<div style="font-size:15px; letter-spacing:1pt;">
							<?php echo nl2br($tcmp->getCompanyAddress())?>
						</div>
						<div style="font-size:13px;">
							<b>Profit &amp; Loss A/c from <?php echo $fdate?> to <?php echo $tdate?></b>
						</div>					
					</td>
				</tr>			
			
				<tr>
					<td width="50%" valign="top">
						<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
							<tr bgcolor="#f4f4f4">
								<td width='60%'>
									<font style='font-family:arial; font-size:12px'><b>PARTICULARS</b></font>
								</td>
								<td width='20%' align='right'>
									<font style='font-family:arial; font-size:12px'>&nbsp;</font>
								</td>
								<td width='20%' align='right'>
									<font style='font-family:arial; font-size:12px'>&nbsp;</font>
								</td>
							</tr>
							
							<?php if($stkOp != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td class="td_normal_large"><b>Opening Stock</b></td>
									<td class="td_normal_large" align='right'>&nbsp;</td>
									<td class="td_normal_large" align='right'><b><?php echo number_format($stkOp, 2, '.', '') ?></b></td>
								</tr>
							<?php } ?>							
							
							<?php if($deTot[0] - abs($oppTot) != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td class="td_normal_large"><b>Direct Expense</b></td>
									<td class="td_normal_large" align='right'>&nbsp;</td>
									<?php if($deTot[1] == DEBIT) { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format($deTot[0] - abs($oppTot), 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td class="td_normal_large" align='right'><b><?php echo number_format(-$deTot[0] + $oppTot, 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($deAct1);$i++) {
										$acls	= $deAct1[$i];
										if($mdb->doLedgerExistsInOpposite($acls->getAccountID())) continue;
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, 'YES');
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><a href="rptMainLedger.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Ledger" target="_blank"><?php echo $acls->getPrnName() ?></a></td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else { ?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccount($tcmp->getCompanyID(), $acls->getAccountID(), $ndt, 'YES');
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<a href="rptSubTrial.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Sub Trial" target="_blank">+</a>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } ?>
								<?php } ?>
							<?php } ?>
							
							<?php if($puTot[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td><b>Purchases</b></td>
									<td align='right'>&nbsp;</td>
									<?php if($puTot[1] == DEBIT) { ?>
										<td align='right'><b><?php echo number_format($puTot[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$puTot[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($deAct2);$i++) {
										$acls	= $deAct2[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, 'YES');
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><a href="rptMainLedger.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Ledger" target="_blank"><?php echo $acls->getPrnName() ?></a></td>
												<td align='right'><?php echo $tamt ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else { ?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccount($tcmp->getCompanyID(), $acls->getAccountID(), $ndt, 'YES');
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<a href="rptSubTrial.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Sub Trial" target="_blank">+</a>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } ?>
								<?php } ?>
							<?php } ?>
							
						</table>
					</td>
					<td width="50%" valign="top">
						<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
							<tr bgcolor="#f4f4f4">
								<td width='60%'>
									<font style='font-family:arial; font-size:12px'><b>PARTICULARS</b></font>
								</td>
								<td width='20%' align='right'>
									<font style='font-family:arial; font-size:12px'>&nbsp;</font>
								</td>
								<td width='20%' align='right'>
									<font style='font-family:arial; font-size:12px'>&nbsp;</font>
								</td>
							</tr>
							
							<?php if($diTot[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td><b>Direct Incomes</b></td>
									<td align='right'>&nbsp;</td>
									<?php if($diTot[1] == CREDIT) { ?>
										<td align='right'><b><?php echo number_format($diTot[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$diTot[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($diAct2);$i++) {
										$acls	= $diAct2[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, 'YES');
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == DEBIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><a href="rptMainLedger.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Ledger" target="_blank"><?php echo $acls->getPrnName() ?></a></td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else { ?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccount($tcmp->getCompanyID(), $acls->getAccountID(), $ndt, 'YES');
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == DEBIT) $tmpamt = -$tmpamt;
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<a href="rptSubTrial.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Sub Trial" target="_blank">+</a>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } ?>
								<?php } ?>
							<?php } ?>
							
							<?php if($saTot[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td><b>Sales</b></td>
									<td align='right'>&nbsp;</td>
									<?php if($saTot[1] == CREDIT) { ?>
										<td align='right'><b><?php echo number_format($saTot[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$saTot[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($diAct1);$i++) {
										$acls	= $diAct1[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, 'YES');
											$tamt	= $amt[0];
											
											if($tamt == 0) continue;
											if($amt[1] == DEBIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><a href="rptMainLedger.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Ledger" target="_blank"><?php echo $acls->getPrnName() ?></a></td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else { ?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccount($tcmp->getCompanyID(), $acls->getAccountID(), $ndt, 'YES');
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == DEBIT) $tmpamt = -$tmpamt;
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<a href="rptSubTrial.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Sub Trial" target="_blank">+</a>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } ?>
								<?php } ?>
							<?php } ?>
							
							<?php if($stkCl != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td><b>Closing Stock</b></td>
									<td align='right'>&nbsp;</td>
									<td align='right'><b><?php echo number_format($stkCl, 2, '.', '') ?></b></td>
								</tr>
							<?php } ?>
																					
						</table>
					</td>					
				</tr>
				
				<?php if($taProfit > 0) { ?>
				
					<tr>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>Gross Profit c/o</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'><b><?php echo number_format($taProfit, 2, '.', '') ?></b></td>
								</tr>
							</table>
						</td>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%">&nbsp;</td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'>&nbsp;</td>
								</tr>
							</table>
						</td>
					</tr>
					<tr bgcolor="#FFFFFF"><td colspan="2">&nbsp;</td></tr>
					<tr>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%">&nbsp;</td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'>&nbsp;</td>
								</tr>
							</table>
						</td>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>Gross Profit b/f</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'><b><?php echo number_format($taProfit, 2, '.', '') ?></b></td>
								</tr>
							</table>
						</td>
					</tr>
				
				<?php } else { ?>
				
					<tr>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%">&nbsp;</td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'>&nbsp;</td>
								</tr>
							</table>
						</td>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>Gross Loss c/o</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'><b><?php echo number_format(-$taProfit, 2, '.', '') ?></b></td>
								</tr>
							</table>
						</td>
					</tr>
					<tr bgcolor="#FFFFFF"><td colspan="2">&nbsp;</td></tr>
					<tr>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>Gross Loss b/f</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'><b><?php echo number_format(-$taProfit, 2, '.', '') ?></b></td>
								</tr>
							</table>
						</td>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%">&nbsp;</td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'>&nbsp;</td>
								</tr>
							</table>
						</td>
					</tr>				
				
				<?php } ?>
				
				<tr>
					<td valign="top">
						<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">

							<?php if($ieTot[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>Indirect Expenses</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<?php if($ieTot[1] == DEBIT) { ?>
										<td align='right'><b><?php echo number_format($ieTot[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$ieTot[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($ieAct1);$i++) {
										$acls	= $ieAct1[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, 'YES');
											$tamt	= $amt[0];
										
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><a href="rptMainLedger.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Ledger" target="_blank"><?php echo $acls->getPrnName() ?></a></td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else { ?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccount($tcmp->getCompanyID(), $acls->getAccountID(), $ndt, 'YES');
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<a href="rptSubTrial.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Sub Trial" target="_blank">+</a>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } ?>
								<?php } ?>
							<?php } ?>
							
							<?php if($meTot[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>Miscellaneous Expenses</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<?php if($meTot[1] == DEBIT) { ?>
										<td align='right'><b><?php echo number_format($meTot[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$meTot[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($meAct1);$i++) {
										$acls	= $meAct1[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, 'YES');
											$tamt	= $amt[0];
										
											if($tamt == 0) continue;
											if($amt[1] == CREDIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><a href="rptMainLedger.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Ledger" target="_blank"><?php echo $acls->getPrnName() ?></a></td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else { ?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccount($tcmp->getCompanyID(), $acls->getAccountID(), $ndt, 'YES');
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == CREDIT) $tmpamt = -$tmpamt;
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<a href="rptSubTrial.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Sub Trial" target="_blank">+</a>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } ?>
								<?php } ?>
							<?php } ?>						

						</table>
					</td>
					<td valign="top">
						<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
							
							<?php if($iiTot[0] != 0) { ?>
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>Indirect Incomes</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<?php if($iiTot[1] == CREDIT) { ?>
										<td align='right'><b><?php echo number_format($iiTot[0], 2, '.', '') ?></b></td>
									<?php } else { ?>
										<td align='right'><b><?php echo number_format(-$iiTot[0], 2, '.', '') ?></b></td>
									<?php } ?>
								</tr>
								<?php
									for($i=0;$i<count($iiAct1);$i++) {
										$acls	= $iiAct1[$i];
										if($acls->getContainsSubLedger() == "NO") {
											$amt	= $mdb->getClosingBalanceByAccountID($acls->getAccountID(), $ndt, 'YES');
											$tamt	= $amt[0];
										
											if($tamt == 0) continue;
											if($amt[1] == DEBIT) $tamt = -$tamt;
								?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><a href="rptMainLedger.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Ledger" target="_blank"><?php echo $acls->getPrnName() ?></a></td>
												<td align='right'><?php echo number_format($tamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } else { ?>
									<?php
										$clbal		= $mdb->getClosingBalanceByMotherAccount($tcmp->getCompanyID(), $acls->getAccountID(), $ndt, 'YES');
										$tmpamt	= $clbal[0];
										
										if($tmpamt == 0) continue;
										if($clbal[1] == DEBIT) $tmpamt = -$tmpamt;
									?>
											<tr bgcolor="#FFFFFF">
												<td style="padding-left:10px;"><?php echo $acls->getPrnName()?> (<a href="rptSubTrial.php?accid=<?php echo $acls->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Sub Trial" target="_blank">+</a>)</td>
												<td align='right'><?php echo number_format($tmpamt, 2, '.', '') ?></td>
												<td align='right'>&nbsp;</td>
											</tr>
									<?php } ?>
								<?php } ?>
							<?php } ?>							
																					
						</table>
					</td>
				</tr>
				
				<?php if($plProfit > 0) { ?>
				
					<tr>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>Net Profit</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'><b><?php echo number_format($plProfit, 2, '.', '') ?></b></td>
								</tr>
							</table>
						</td>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%">&nbsp;</td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'>&nbsp;</td>
								</tr>
							</table>
						</td>
					</tr>
				
					<tr>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>TOTAL</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'><b><?php echo number_format($plProfit + $pdrSide, 2, '.', '')?></b></td>
								</tr>
							</table>
						</td>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>TOTAL</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'><b><?php echo number_format($pcrSide + $taProfit, 2, '.', '')?></b></td>
								</tr>
							</table>
						</td>
					</tr>
					
				<?php } else { ?>
				
					<tr>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%">&nbsp;</td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'>&nbsp;</td>
								</tr>
							</table>
						</td>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>Net Loss</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'><b><?php echo number_format(-$plProfit, 2, '.', '') ?></b></td>
								</tr>
							</table>
						</td>
					</tr>
				
					<tr>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>TOTAL</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'><b><?php echo number_format($pdrSide - $taProfit, 2, '.', '')?></b></td>
								</tr>
							</table>
						</td>
						<td width="50%" valign="top">
							<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC">
								<tr bgcolor="#FFFFFF">
									<td width="60%"><b>TOTAL</b></td>
									<td width="20%" align='right'>&nbsp;</td>
									<td width="20%" align='right'><b><?php echo number_format($pcrSide - $plProfit, 2, '.', '')?></b></td>
								</tr>
							</table>
						</td>
					</tr>				
				
				<?php } ?>
				
			</table>
		</div>
		
		<br />
		<div style="text-align:center"><input type="button" value="Export to Excel" onClick="ExportToExcel()" class="red_button" /></div>
		<br />
		
	</div>
</body>
</html>

<script type="text/javascript">

	function ExportToExcel(){
		 var tbl		= document.getElementById('main_table');
		 var html 	= tbl.outerHTML;
		 window.open('data:application/vnd.ms-excel,' + encodeURIComponent(html));
	}
	
</script>