<?php

	/* Include the required files */
	require_once( '../aom-config.php' );
	require_once( '../inc/functions.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/class.purchasedb.php' );	
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );	

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 44;
	
	$mdb		=	new masterdb("REPORT");
	$ldb		= new logindb("REPORT");
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}	
	
	$accList			= $mdb->getSupplierListJSON($tcmp->getCompanyID());
	
	$fdate				= "";
	$tdate				= "";
	
	extract($_REQUEST);
	
	$dt1					= FormatIndianDateToSQLDate($fdate);
	$dt2					= FormatIndianDateToSQLDate($tdate);
	
?>

<!DOCTYPE html>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<meta http-equiv="Content-Type" content="text/html; charset=utf8">
<title></title>
</head>

<body topmargin="0" leftmargin="0" rightmargin="0" bottommargin="0" marginwidth="0" marginheight="0">

<div align="center">

<table border="0" width="800" cellspacing="0" cellpadding="0">
	<tr>
		<td height="60">
		<p align="center" style="margin-top: 0; margin-bottom: 0"><b>
		<font size="6" face="Arial"><?php echo $tcmp->getCompanyName()?></font></b></td>
	</tr>
	<tr>
		<td height="24">
		<p align="center" style="margin-top: 0; margin-bottom: 0"><b>
		<font face="Arial" size="2">PURCHASE - SUPPLIER WISE</font></b></td>
	</tr>
	<tr>
		<td height="24">
		<p align="center">
		<b><font face="Arial" size="2">Date : <?php echo $fdate?> - <?php echo $tdate?></font></b></td>
	</tr>
	<tr>
		<td>
		<table border="1" width="100%" cellpadding="4" style="border-collapse: collapse" bordercolor="#808080">
			<tr>
				<td align="center" height="30" width="10%">
				<p style="margin-top: 0; margin-bottom: 0"><b>
				<font face="Arial" style="font-size: 11pt">Sl. No.</font></b></td>
				<td align="center" height="30" width="44%">
				<p style="margin-top: 0; margin-bottom: 0"><b>
				<font face="Arial" style="font-size: 11pt">Supplier Name</font></b></td>
				<td align="center" height="30" width="23%">
				<b><font face="Arial" style="font-size: 11pt">Monthly Purchase</font></b></td>
				<td align="center" height="30" width="23%">
				<p style="margin-top: 0; margin-bottom: 0"><b>
				<font face="Arial" style="font-size: 11pt">Closing Balance</font></b></td>
			</tr>
			
			<?php
				$cnt		= 0;
				for($i=0;$i<count($accList);$i++) {
					$row	= $accList[$i];
					$aid	= $row[0];
					
					$clbal			=	$mdb->getClosingBalanceByAccountID($aid, getNextDate($dt2));
					$damt				= $mdb->getTotalCreditAmountByAccountID($aid, $dt1, $dt2);
					if($damt == "") $damt	= 0;
					
					if($clbal[0] == 0 && $damt == 0) continue;
					
					$cnt++;
			?>
			
			<tr>
				<td align="center" width="10%">
				<p style="margin-top: 0; margin-bottom: 0; margin-right:2px" align="right">
				<font face="Arial" style="font-size: 11pt"><?php echo $cnt?></font></td>
				<td align="center" width="44%">
				<p style="margin-top: 0; margin-bottom: 0; margin-left:2px" align="left">
				<font face="Arial" style="font-size: 11pt"><?php echo $row[1]?></font></td>
				<td align="right" width="23%">
				<p style="margin-right: 2px">
				<font face="Arial" style="font-size: 11pt">
				<?php echo number_format($damt, 2)?></font></td>
				<td align="right" width="23%">
				<p style="margin-top: 0; margin-bottom: 0; margin-right:2px">
				<font face="Arial" style="font-size: 11pt"><?php echo number_format($clbal[0], 2)?> (<?php if( $clbal[1] == DEBIT) echo 'Dr'; else echo 'Cr';?>)</font></td>
			</tr>

			<?php } ?>

			</table>
		</td>
	</tr>
	<tr>
		<td>
		&nbsp;</td>
	</tr>
	</table>

</div>

</body>

</html>
