<?php

	/* Include the required files */
	require_once( '../aom-config.php' );
	require_once( '../inc/functions.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/class.gen_purchase.php' );
	require_once( '../dao/class.gen_purchase_items.php' );
	require_once( '../dao/class.gen_purchase_addless.php' );	
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/class.purchasedb.php' );	
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );	

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 44;
	
	$mdb		=	new masterdb("REPORT");
	$ldb		= new logindb("REPORT");
	$pdb		=	new purchasedb("REPORT");
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}
	
	$fdate				= "";
	$tdate				= "";
	
	extract($_REQUEST);
	
	$dt1					= FormatIndianDateToSQLDate($fdate);
	$dt2					= FormatIndianDateToSQLDate($tdate);
	
	$purList			= $pdb->getPurchaseReportList($tcmp->getCompanyID(), $dt1, $dt2);
	
?>

<!DOCTYPE html>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<meta http-equiv="Content-Type" content="text/html; charset=utf8">
<title>Purchase Register</title>
</head>

<body topmargin="0" leftmargin="0" rightmargin="0" bottommargin="0" marginwidth="0" marginheight="0" bgcolor="#FFFFFF">

<div align="center">

<table border="0" width="900" cellspacing="0" cellpadding="0" id="main_table">
	<tr>
		<td height="60" bgcolor="#FFFFFF">
		<p align="center" style="margin-top: 0; margin-bottom: 0"><b>
		<font size="6" face="Arial"><?php echo $tcmp->getCompanyName()?></font></b></td>
	</tr>
	<tr>
		<td height="24" bgcolor="#FFFFFF">
		<p align="center" style="margin-top: 0; margin-bottom: 0"><b>
		<font face="Arial" size="2">PURCHASE REGISTER</font></b></td>
	</tr>
	<tr>
		<td height="24" bgcolor="#FFFFFF">
		<p align="center">
		<b><font face="Arial" size="2">Date : <?php echo $fdate?> - <?php echo $tdate?></font></b></td>
	</tr>
	<tr>
		<td bgcolor="#FFFFFF">
		<table border="1" width="100%" cellpadding="4" style="border-collapse: collapse" bordercolor="#808080">
			<tr>
				<td align="center" height="30" width="4%"><b><font face="Arial" size="2">Sl.<br />No.</font></b></td>
				<td align="center" height="30" width="10%"><b><font face="Arial" size="2">Date</font></b></td>
				<td align="center" height="30" width="9%"><b><font face="Arial" size="2">Purchase<br />Bill No.</font></b></td>
				<td align="center" height="30" width="26%"><b><font face="Arial" size="2">Sundry Creditors</font></b></td>
				<td align="center" height="30" width="12%"><b><font face="Arial" size="2">Party Bill No.<br />Date</font></b></td>
				<td align="center" height="30" width="6%"><b><font face="Arial" size="2">Taxable<br />Amt.</font></b></td>
				<td align="center" height="30" width="6%"><b><font face="Arial" size="2">IGST</font></b></td>
				<td align="center" height="30" width="6%"><b><font face="Arial" size="2">CGST</font></b></td>
				<td align="center" height="30" width="6%"><b><font face="Arial" size="2">SGST</font></b></td>
				<td align="center" height="30" width="6%"><b><font face="Arial" size="2">Add <br />
				Less</font></b></td>
				<td align="center" height="30" width="11%"><b><font face="Arial" size="2">Total<br />Bill Amount</font></b></td>
			</tr>
			
			<?php
				$itot		= 0;
				$gsti		= 0;
				$gstc		= 0;
				$gsts		= 0;
				$altot	= 0;
				$ntot		= 0;
				for($i=0;$i<count($purList);$i++) {
					$pcls	= $purList[$i];
					$snm	= $pcls->getSupplierName();
					if($snm == "")
						$snm	= $pcls->getSMotherAccountName();
						
					$itot	= $itot + $pcls->getItemTotal() - ($pcls->getIGST() + $pcls->getCGST() + $pcls->getSGST());
					$gsti	= $gsti + $pcls->getIGST();
					$gstc	= $gstc + $pcls->getCGST();
					$gsts	= $gsts + $pcls->getSGST();
					$altot= $altot + $pcls->getAddLessTotal();
					$ntot	= $ntot + $pcls->getNetTotal();
			?>
			
			<tr>
				<td align="right"><font face="Arial" size="2"><?php echo ($i+1)?></font></td>
				<td align="center"><font face="Arial" size="2"><?php echo $pcls->getPurchaseDate('yes')?></font></td>
				<td align="right"><font face="Arial" size="2"><?php echo $pcls->getPurchaseNo().'/'.$pcls->getFinYear()?></font></td>
				<td align="left"><font face="Arial" size="2"><?php echo $snm?></font></td>
				<td align="right"><font face="Arial" size="2"><?php echo $pcls->getSupplierBillNo().'<br />'.$pcls->getSupplierBillDate('yes')?></font></td>
				<td align="right"><font face="Arial" size="2"><?php echo $pcls->getItemTotal() -  ($pcls->getIGST() + $pcls->getCGST() + $pcls->getSGST())?></font></td>
				<td align="right"><font face="Arial" size="2"><?php echo $pcls->getIGST('yes')?></font></td>
				<td align="right"><font face="Arial" size="2"><?php echo $pcls->getCGST('yes')?></font></td>
				<td align="right"><font face="Arial" size="2"><?php echo $pcls->getSGST('yes')?></font></td>
				<td align="right"><font face="Arial" size="2"><?php echo $pcls->getAddLessTotal('yes')?></font></td>
				<td align="right"><font face="Arial" size="2"><?php echo $pcls->getNetTotal('yes')?></font></td>
			</tr>

			<?php } ?>

			<tr>
				<td align="right" colspan="5"><b><font face="Arial" size="2">Total</font></b></td>
				<td align="right"><b><font face="Arial" size="2"><?php echo $itot?></font></b></td>
				<td align="right"><b><font face="Arial" size="2"><?php echo $gsti?></font></b></td>
				<td align="right"><b><font face="Arial" size="2"><?php echo $gstc?></font></b></td>
				<td align="right"><b><font face="Arial" size="2"><?php echo $gsts?></font></b></td>
				<td align="right"><b><font face="Arial" size="2"><?php echo $altot?></font></b></td>
				<td align="right"><b><font face="Arial" size="2"><?php echo $ntot?></font></b></td>
			</tr>

			</table>
		</td>
	</tr>
	<tr>
		<td bgcolor="#FFFFFF">&nbsp;</td>
	</tr>
	</table>

</div>

	<br />
	<div style="text-align:center"><input type="button" value="Export to Excel" onClick="ExportToExcel()" class="red_button" /></div>
	<br />

</body>

</html>

<script type="text/javascript">

	function ExportToExcel(){
		 var tbl		= document.getElementById('main_table');
		 var html 	= tbl.outerHTML;
		 window.open('data:application/vnd.ms-excel,' + encodeURIComponent(html));
	}
	
</script>