<?php

	/* Include the required files */
	require_once( '../inc/functions.php' );
	require_once( '../aom-config.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/asys.voucherdb.php' );
	require_once( '../dao/class.purchasedb.php' );
	require_once( '../dao/asys.drcr.php' );
	require_once( '../dao/asys.group.php' );
	require_once( '../dao/asys.voucher.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );	
	require_once( '../dao/class.gen_items.php' );
	require_once( '../dao/asys.store.php' );
	require_once( '../dao/asys.stockvoucher.php' );	

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 47;

	$db			=	new masterdb("REPORT");
	$vdb		=	new voucherdb("REPORT");
	$pdb		=	new purchasedb("REPORT");
	$ldb		= new logindb("REPORT");
	
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}		

	$maccid	= 0;
	$caccid	= 0;
	$fdate	=	"2017-01-01";
	$cmpid	= $tcmp->getCompanyID();
	$stList	= $db->getStoreList($cmpid);

	extract($_REQUEST);

	if($fdate == "")
		$fdate	=	"2017-01-01";

	$df				=	FormatIndianDateToSQLDate($fdate);
	
	if($df == '1900-01-01'){
		echo 'Invalid input Date format, try again';
		exit;
	}


?>


<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html;charset=utf-8"/>
		<title>Stock Value comparison</title>
		<link href="../css/rpt.css" type=text/css rel=stylesheet>
		<script src="../js/common.js"></script>
	</head>
<body topmargin="0" leftmargin="0" rightmargin="0" bottommargin="0" marginwidth="0" marginheight="0">

<div align="center">

<table border="0" width="800" cellspacing="0" cellpadding="0">
	<tr>
		<td height="60">
		<p align="center" style="margin-top: 0; margin-bottom: 0"><b>
		<font size="6" face="Arial"><?php echo $tcmp->getCompanyName()?></font></b></td>
	</tr>
	<tr>
		<td height="24">
		<p align="center"><b><font face="Arial" size="2">ALL STORE</font></b></td>
	</tr>
	<tr>
		<td height="24">
		<p align="center"><b><font face="Arial" size="2">CLOSING BALANCE OF STOCK 
		(Ledger/Store)</font></b></td>
	</tr>
	<tr>
		<td height="24">
		<p align="center">
		<b><font face="Arial" size="2">Date : <?php echo $fdate?></font></b></td>
	</tr>
	<tr>
		<td>
		<table border="1" width="100%" cellspacing="0" cellpadding="2" style="border-collapse: collapse" bordercolor="#808080">
			<tr>
				<td align="center" height="30" width="20%">
				<p align="left" style="margin-left: 2px; margin-top: 0; margin-bottom: 0">
				<b><font face="Arial" size="2">Store</font></b></td>
				<td align="center" height="30" width="20%">
				<b><font face="Arial" size="2">As Per Ledger</font></b></td>
				<td align="center" height="30" width="20%">
				<b><font face="Arial" size="2">As Per Store</font></b></td>
				<td align="center" height="30" width="20%">
				<b><font face="Arial" size="2">Difference</font></b></td>	
			</tr>
			
			<?php
				for($i=0;$i<count($stList);$i++) {
					$strDet		= $stList[$i];
					$maccDet	= $db->getAccountDetail($strDet->getMotherAccountID());
					$accDet		= $db->getAccountDetail($strDet->getAccountID());
					$maccid		=	$strDet->getMotherAccountID();
					$caccid		=	$strDet->getAccountID();
					$sid			= $strDet->getStoreID();
					
					$clbal		=	$db->getClosingBalanceByAccountID($caccid, getNextDate($df), "YES");

					$cltot		= $pdb->getTotalStockClosingValueCategoryWise($cmpid, $sid, 0, $df);
			?>
			
			<tr>
				<td valign="top"><?php echo $strDet->getStoreName()?></td>
				<td valign="top" align="right"><?php echo $clbal[0]?></td>
				<td valign="top" align="right"><?php echo round($cltot, 2)?></td>
				<td valign="top" align="right"><?php echo round($clbal[0] - $cltot, 2)?></td>
			</tr>

			<?php } ?>
			
		</table>
		</td>
	</tr>
	<tr>
		<td>
		&nbsp;</td>
	</tr>
	</table>

</div>

</body>

</html>