<?php

	/* Include the required files */
	require_once( '../inc/functions.php' );
	require_once( '../aom-config.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/asys.voucherdb.php' );
	require_once( '../dao/class.purchasedb.php' );
	require_once( '../dao/asys.drcr.php' );
	require_once( '../dao/asys.group.php' );
	require_once( '../dao/asys.voucher.php' );
	require_once( '../dao/asys.vouchertag.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );	
	require_once( '../dao/class.gen_items.php' );
	require_once( '../dao/asys.store.php' );
	require_once( '../dao/asys.stockvoucher.php' );
	require_once( '../dao/class.gen_grn.php' );
	require_once( '../dao/class.gen_grn_items.php' );
	require_once( '../dao/class.gen_stockjournal.php' );
	require_once( '../dao/class.gen_stockjournal_in.php' );
	require_once( '../dao/class.gen_stockjournal_out.php' );
	require_once( '../dao/class.gen_stocktransfer.php' );
	require_once( '../dao/class.gen_stocktransfer_items.php' );
	require_once( '../dao/class.gen_issue.php' );
	require_once( '../dao/class.gen_issue_items.php' );

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 47;

	$db			=	new masterdb("REPORT");
	$vdb		=	new voucherdb("REPORT");
	$pdb		=	new purchasedb("REPORT");
	$ldb		= new logindb("REPORT");
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}		

	$maccid	= 0;
	$caccid	= 0;
	$fdate	=	"2001-01-01";
	$tdate	=	getLastFinancialDate();
	$sid		=	0;
	$cid		= 0;
	$cmpid	= $tcmp->getCompanyID();

	extract($_REQUEST);

	if($fdate == "")
		$fdate	=	"2001-01-01";

	$maccid	=	(int)$maccid;
	$caccid	=	(int)$caccid;
	$sid		= (int)$sid;
	$cid		= (int)$cid;

	if($maccid == 0 || $caccid == 0) {
		echo "Sorry!!! Direct Access not allowed here";
		exit;
	}

	$maccDet	= $db->getAccountDetail($maccid);
	$accDet		= $db->getAccountDetail($caccid);
	$bal			= $accDet->getOBal();
	$balt			= $accDet->getOBalType();
	$ndt			= getNextDate(FormatIndianDateToSQLDate($fdate));
	
	$clbal		=	$db->getClosingBalanceByAccountID($caccid, $ndt);
	$bal			=	$clbal[0];
	$balt			=	$clbal[1];

	$alDet		= $vdb->getAccountVoucher($caccid, FormatIndianDateToSQLDate($fdate), FormatIndianDateToSQLDate($tdate));

	$totcr		= 0;
	$totdr		= 0;
	if($balt==DEBIT)
		$totdr	=	$bal;
	else
		$totcr	= $bal;		

	$df				=	FormatIndianDateToSQLDate($fdate);
	$dt				=	FormatIndianDateToSQLDate($tdate);
	$pdt			= getPreviousDate($df);
	
	if($df == '1900-01-01' || $dt == '1900-01-01' || $sid <= 0){
		echo 'Invalid input Date format OR no Store selected, try again';
		exit;
	}
	
	$strDet		= $db->getStoreDetail($sid);
	if($cid != "")
		$itmList	= $db->getItemListByCategoryJSON($cid, $cmpid);
	else
		$itmList	= $db->getItemListJSON($cmpid);

?>


<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html;charset=utf-8"/>
		<title>Stock Value Analysis</title>
		<link href="../css/rpt.css" type=text/css rel=stylesheet>
		<script src="../js/common.js"></script>
	</head>
<body topmargin="0" leftmargin="0" rightmargin="0" bottommargin="0" marginwidth="0" marginheight="0">

<div align="center">

<table border="0" width="800" cellspacing="0" cellpadding="0">
	<tr>
		<td height="60">
		<p align="center" style="margin-top: 0; margin-bottom: 0"><b>
		<font size="6" face="Arial"><?php echo $tcmp->getCompanyName()?></font></b></td>
	</tr>
	<tr>
		<td height="24">
		<p align="center"><b><font face="Arial" size="2">Difference Analysis of <?php echo $strDet->getStoreName()?> for <?php echo $fdate?></font></b></td>
	</tr>
	<tr>
		<td>
		<table border="1" width="100%" cellspacing="0" cellpadding="2" style="border-collapse: collapse" bordercolor="#808080">
			<tr>
				<td align="left" width="15%"><b><font face="Arial" size="2">Item</font></b></td>
				<td align="center" width="15%"><b><font face="Arial" size="2">Prev Day Cl</font></b></td>
				<td align="center" width="15%"><b><font face="Arial" size="2">Stock IN</font></b></td>
				<td align="center" width="15%"><b><font face="Arial" size="2">Stock OUT</font></b></td>
				<td align="center" width="15%"><b><font face="Arial" size="2">Next Day Cl</font></b></td>
				<td align="center" width="15%"><b><font face="Arial" size="2">Stock Cl</font></b></td>				
				<td align="center" width="10%"><b><font face="Arial" size="2">Difference</font></b></td>			
			</tr>
			
			<?php

					$totdiff		= 0;
					$tstr				= "";
					$arrCnt			= 0;
					$marr				= array();
					$parr				= array();					
					for($i=0;$i<count($itmList);$i++) {
						$row			= $itmList[$i];
						$iid			= $row[0];
						
						$pobal		= $pdb->getLastStockClosingQuantity($cmpid, $sid, $iid, $pdt);
						$poval		= $pdb->getLastStockClosingValue($cmpid, $sid, $iid, $pdt, $pobal);
						
						$stockin	= $pdb->getStockINTotal($df, $df, $sid, $iid, $cmpid);
						$stockout	= $pdb->getStockOUTTotal($df, $df, $sid, $iid, $cmpid);
						
						$obal			= $pdb->getLastStockClosingQuantity($cmpid, $sid, $iid, $df);
						$oval			= $pdb->getLastStockClosingValue($cmpid, $sid, $iid, $df, $obal);
						
						$totdiff	= $totdiff + round(($poval + $stockin[1] - $stockout[1]) - $oval, 2);
						
						$totSV		= 0;
						$totSV2		= round($poval - $oval, 2);
						
						if($obal == $pobal) continue;
						
						$bgclr	= "#FFFFFF";
						if( abs(($poval + $stockin[1] - $stockout[1]) - $oval) > 1 ) $bgclr = '#FFDDDD';
						if( round(($pobal + $stockin[0] - $stockout[0]) - $obal, 2) < 0 ) $bgclr = '#FF8888';
			?>
			
			<tr bgcolor="<?php echo $bgclr?>">
				<td valign="top" class="td_normal"><?php echo $row[1]?></td>
				<td valign="top" class="td_normal"><?php echo $pobal ?> [<?php echo round($poval, 2) ?>]</td>
				<td valign="top" class="td_normal"><?php echo $stockin[0] ?> [<?php echo round($stockin[1], 2) ?>]</td>
				<td valign="top" class="td_normal"><?php echo $stockout[0] ?> [<?php echo round($stockout[1], 2) ?>]</td>
				<td valign="top" class="td_normal"><?php echo round($pobal + $stockin[0] - $stockout[0], 2) ?> [<?php echo round($poval + $stockin[1] - $stockout[1], 2) ?>]</td>
				<td valign="top" class="td_normal" align="right"><?php echo $obal ?> [<?php echo round($oval, 2) ?>]</td>
				<?php if(abs(($poval + $stockin[1] - $stockout[1]) - $oval) > 1) { ?>
					<td valign="top" class="td_normal" align="right"><a href="rptStockLedgerSingle.php?fdate=<?php echo FormatSQLDateToIndianDate(getFirstFinancialDate($df))?>&tdate=<?php echo $fdate?>&sid=<?php echo $sid?>&iid=<?php echo $iid?>" target="_blank"><?php echo round(($pobal + $stockin[0] - $stockout[0]) - $obal, 2)?> [<?php echo round(($poval + $stockin[1] - $stockout[1]) - $oval, 2)?>]</a></td>
				<?php } else {?>
					<td valign="top" class="td_normal" align="right"><?php echo round(($pobal + $stockin[0] - $stockout[0]) - $obal, 2)?> [<?php echo round(($poval + $stockin[1] - $stockout[1]) - $oval, 2)?>]</td>
				<?php } ?>
			</tr>			
			
			<?php } ?>
			
			<tr>
				<td valign="top" class="td_normal">&nbsp;</td>
				<td valign="top" class="td_normal">&nbsp;</td>
				<td valign="top" class="td_normal">&nbsp;</td>
				<td valign="top" class="td_normal">&nbsp;</td>
				<td valign="top" class="td_normal">&nbsp;</td>
				<td valign="top" class="td_normal">&nbsp;</td>
				<td valign="top" class="td_normal bold" align="right"><?php echo $totdiff ?></td>
			</tr>			
			
		</table>
		</td>
	</tr>
	</table>
	
	<br />
	
	<?php for($kk=0; $kk<count($marr); $kk++) { ?>
		<div class="td_normal"><?php echo $marr[$kk]?> = <?php echo $parr[$kk]?></div>
	<?php } ?>
	
	<br />
	
	
	<div style="font-size:10px; font-weight:bold;">
		<table cellSpacing='0' cellPadding='4' width='800' border='0'>
			<tr>
				<td width='10%' bgcolor="#f4f4f4" style="border:#cccccc 1px solid">
					<font style='font-family:arial; font-size:11px'>DATE</font>
				</td>

				<td width='14%' bgcolor="#f4f4f4" style="border:#cccccc 1px solid">
					<font style='font-family:arial; font-size:11px'>DOC NO</font>
				</td>

				<td width='35%' bgcolor="#f4f4f4" style="border:#cccccc 1px solid">
					<font style='font-family:arial; font-size:11px'>PARTICULARS</font>
				</td>
				<td width='12%' align='right' bgcolor="#f4f4f4" style="border:#cccccc 1px solid">
					<font style='font-family:arial; font-size:11px'>DEBIT</font>
				</td>
				<td width='12%' align='right' bgcolor="#f4f4f4" style="border:#cccccc 1px solid">
					<font style='font-family:arial; font-size:11px'>CREDIT</font>
				</td>
				<td width='15%' align='right' bgcolor="#f4f4f4" style="border:#cccccc 1px solid">
					<font style='font-family:arial; font-size:11px'>BALANCE</font>
				</td>
			</tr>
		</table>
	</div>
	<div style="font-size:10px;">
		<table cellSpacing='0' cellPadding='2' width='800'>
			<tr>
				<td width='10%' bgcolor="#ffffff">
					&nbsp;
				</td>

				<td width='14%' bgcolor="#ffffff">
					&nbsp;
				</td>

				<td width='35%' bgcolor="#ffffff">
					<font style='font-family:arial; font-size:10px'><b>By Opening Balance</b></font>
				</td>
				<?php
					if($balt == DEBIT) {
				?>
					<td width='12%' align='right' bgcolor="#ffffff">
						<font style='font-family:arial; font-size:10px'><b><?php echo number_format($bal,2)?></b></font>
					</td>
					<td width='12%' align='right' bgcolor="#ffffff">
						<font style='font-family:arial; font-size:10px'><b>0.00</b></font>
					</td>
				<?php } else {
				?>
					<td width='12%' align='right' bgcolor="#ffffff">
						<font style='font-family:arial; font-size:10px'><b>0.00</b></font>
					</td>
					<td width='12%' align='right' bgcolor="#ffffff">
						<font style='font-family:arial; font-size:10px'><b><?php echo number_format($bal,2)?></b></font>
					</td>
				<?php } ?>
				<td width='15%' align='right' bgcolor="#ffffff">
					<font style='font-family:arial; font-size:10px'><b><?php echo number_format($bal,2)?> <?php echo getDrCr($balt)?></b></font>
				</td>
			</tr>
		<?php
			for($i=0;$i<count($alDet);$i++) {
				$veb	=	$alDet[$i];
				$rcls	=	"td_normal_green";
				/*if($veb->getIsHidden() == 'YES')
					$rcls	=	"td_normal_red";*/

				$vt		=	$veb->getVoucherType();
				$fy		=	$veb->getFinYear();
				$vid	=	$veb->getVoucherID();
				$olist=	$vdb->getOppositeVoucher($vid, $caccid);

		?>
			<tr class="td_normal">
				<td width='10%' valign="top">
					<font style='font-family:arial; font-size:10px'><?php echo $veb->getDOV('yes')?></font>
				</td>

				<td width='14%' valign="top" onClick="prnVoucher('<?php echo $veb->getVoucherType()?>','<?php echo $veb->getFinYear()?>','<?php echo $veb->getVoucherID()?>','<?php echo $veb->getTxnType()?>','<?php echo $veb->getRelatedID()?>')" style="cursor:hand" onMouseOver="this.className='td_hover'" onMouseOut="this.className='td_normal'">
					<font style='font-family:arial; font-size:10px'>&nbsp;<?php echo getShortVoucherType($veb->getVoucherType()).'/'.FormatSQLDateToVoucherPrintFormat($veb->getDOV()).'/'.$veb->getDayWiseNo()?></font>
				</td>


				<td width='35%' valign="top">
					<font style='font-family:arial; font-size:10px'>
					<?php 
						$narr		= $veb->getNarration();
						if($veb->getTxnType() == ISSUE) {
							$isdet	= $pdb->getIssueDetail($veb->getRelatedID());
							if($isdet->getpurpose() != '') $narr = $narr.', '.$isdet->getpurpose();
						}
						echo $narr;
					?>
					</font>
				</td>
				<?php
					if($veb->getDrCr() == DEBIT) {
						$totdr+=$veb->getAmount();
						if($balt == DEBIT)
							$bal+=$veb->getAmount();
						else
							$bal-=$veb->getAmount();
						if($bal < 0) {
							$bal=-$bal;
							$balt	=	DEBIT;
						}
				?>
					<td class="td_normal_green'" width='12%' align='right' valign="top">
						<font style='font-family:arial; font-size:10px'><?php echo number_format($veb->getAmount(),2)?></font>
					</td>
					<td width='12%' align='right' valign="top">
						<font style='font-family:arial; font-size:10px'>0.00</font>
					</td>
				<?php
					} else {
						$totcr+=$veb->getAmount();
						if($balt == CREDIT)
							$bal+=$veb->getAmount();
						else
							$bal-=$veb->getAmount();
						if($bal < 0) {
							$bal=-$bal;
							$balt	=	CREDIT;
						}
				?>
					<td class="<?php echo $rcls; ?>" width='12%' align='right' valign="top">
						<font style='font-family:arial; font-size:10px'>0.00</font>
					</td>
					<td width='12%' align='right' valign="top">
						<font style='font-family:arial; font-size:10px'><?php echo number_format($veb->getAmount(),2)?></font>
					</td>
				<?php } ?>
				<td width='15%' align='right' valign="top">
					<font style='font-family:arial; font-size:10px'><?php echo number_format($bal,2)?> <?php echo getDrCr($balt)?></font>
				</td>
			</tr>
		<?php

				for($j=0;$j<count($olist);$j++) {
					$ovch	=	$olist[$j];
					$tmp	=	"#f4f4f4";
					if($j%2==0)
						$tmp	=	"#e4e4e4";
		?>
						<tr>
							<td>&nbsp;</td>
							<td>&nbsp;</td>
							<td bgcolor="<?php echo $tmp?>">
								<font style='font-family:verdana; font-size:10px'><?php echo $ovch->getAccountName('yes')?> - <?php echo $ovch->getAmount('yes')?> (<?php echo getDrCr($ovch->getDrCr())?>)</font>
							</td>
							<td>&nbsp;</td>
							<td>&nbsp;</td>
							<td>&nbsp;</td>
						</tr>
		<?php
				}
			}
		?>
		</table>
	</div>
	<div style="font-size:10px; font-weight:bold;">
		<table cellSpacing='0' cellPadding='4' width='800' border='0'>
			<tr>
				<td width='10%' style="border:#cccccc 1px solid">
					<font style='font-family:arial; font-size:10px'>&nbsp;</font>
				</td>

				<td width='14%' style="border:#cccccc 1px solid">
					<font style='font-family:arial; font-size:10px'>&nbsp;</font>
				</td>

				<td width='35%' style="border:#cccccc 1px solid">
					<font style='font-family:arial; font-size:10px'><b>CURRENT TOTAL ***</b></font>
				</td>
				<td width='12%' align='right' style="border:#cccccc 1px solid">
					<font style='font-family:arial; font-size:10px'><b><?php echo number_format($totdr,2)?></b></font>
				</td>
				<td width='12%' align='right' style="border:#cccccc 1px solid">
					<font style='font-family:arial; font-size:10px'><b><?php echo number_format($totcr,2)?></b></font>
				</td>
				<td width='15%' align='right' style="border:#cccccc 1px solid">
					<font style='font-family:arial; font-size:10px'><b><?php echo number_format($bal,2)?> <?php echo getDrCr($balt)?></b></font>
				</td>
			</tr>
		</table>
	</div>
	
	<br />

</div>

</body>

</html>