<?php

	/* Include the required files */
	require_once( '../inc/functions.php' );
	require_once( '../aom-config.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/class.purchasedb.php' );
	require_once( '../dao/class.gen_itemcategory.php' );
	require_once( '../dao/class.gen_items.php' );
	require_once( '../dao/asys.store.php' );
	require_once( '../dao/asys.stockvoucher.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );	

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 43;

	$mdb			=	new masterdb("REPORT");
	$pdb			=	new purchasedb("REPORT");
	$ldb			= new logindb("REPORT");
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}		

	$fdate		=	getFirstFinancialDate();
	$tdate		=	getLastFinancialDate();
	$sid			= 0;
	$cid			= 0;
	$zeros		= "";
	$catw			= "NO";

	extract($_REQUEST);

	$df				=	FormatIndianDateToSQLDate($fdate);
	$dt				=	FormatIndianDateToSQLDate($tdate);
	$sid			= (int)$sid;
	$cid			= (int)$cid;
	$zeros		= addslashes($zeros);
	$catw			= addslashes($catw);

	if($df == '1900-01-01' || $dt == '1900-01-01' || $sid <= 0){
		echo 'Invalid input Date format OR no Store selected, try again';
		exit;
	}
	
	$strDet		= $mdb->getStoreDetail($sid);
	$catDet		= $mdb->getItemCategoryDetail($cid);
	
	$icatList	= $mdb->getItemCategoryListJSON($tcmp->getCompanyID());
	
	$itmList	= $mdb->getItemListByCategoryJSON($cid, $tcmp->getCompanyID());

?>


<!DOCTYPE html>
<html>

<head>
	<meta http-equiv="Content-Type" content="text/html;charset=utf-8"/>
	<title>Item Stock Ledger</title>
	<link href="../css/rpt.css" type=text/css rel=stylesheet>
	
	<style>

		#rpt-header {
			position: fixed;
			top: 0;
			left: 0;
			width: 100%;
			background-color:#FFFFFF;
		}

		#rpt-content {
			width: 100%;
			margin: 0 auto;
			font-size: 1.4em;
			overflow: auto;
		}

	</style>	
</head>

<body topmargin="0" leftmargin="0" rightmargin="0" bottommargin="0" marginwidth="0" marginheight="0">

<div align="center">


		<table border="0" width="1200" cellspacing="0" cellpadding="0" id="main_table">
			<tr>
				<td align="center">
					<b><font size="6" face="Arial"><?php echo $tcmp->getCompanyName()?></font></b>
				</td>
			</tr>
			<tr>
				<td align="center">
					<b><font face="Arial" size="2"><?php echo $strDet->getStoreName()?></font></b>
				</td>
			</tr>
			<tr>
				<td>
					<div style="float:left;"><b><font face="Arial" size="2">STOCK LEDGER <?php echo $catDet->getItemCategoryName()?></font></b></div>
					<div style="float:right;"><b><font face="Arial" size="2">Date : <?php echo $fdate?> to <?php echo $tdate?></font></b></div>
				</td>
			</tr>
			<tr>
				<td>
					<table border="1" width="100%" cellpadding="2" style="border-collapse: collapse" bordercolor="#808080">
						<tr>
							<td align="center" height="30" width="20%">
							<p align="left" style="margin-left: 2px; margin-top: 0; margin-bottom: 0">
							<b>
							<font face="Arial" size="2">Item Name</font></b></td>
							<td align="center" height="30" width="6%">
							<p align="left" style="margin-left: 2px; margin-top: 0; margin-bottom: 0">
							<b>
							<font face="Arial" size="2">Unit</font></b></td>				
							<td align="center" height="30" width="14%" colspan="2">
							<b>
							<font face="Arial" size="2">Opening Stock</font></b></td>
							<td align="center" height="30" width="14%" colspan="2">
							<b>
							<font face="Arial" size="2">Stock Received</font></b></td>
							<td align="center" height="30" width="14%" colspan="2">
							<b>
							<font face="Arial" size="2">Stock Total</font></b></td>
							<td align="center" height="30" width="14%" colspan="2">
							<b>
							<font face="Arial" size="2">Issue + Transfer + Sale</font></b></td>
							<td align="center" height="30" width="18%" colspan="2">
							<b>
							<font face="Arial" size="2">Closing Stock</font></b></td>
						</tr>
						<tr>
							<td align="left" height="24" width="20%">
							<p style="margin-left: 2px; margin-top: 0; margin-bottom: 0">
							&nbsp;</td>
							<td align="center" height="30" width="6%">
							<p align="left" style="margin-left: 2px; margin-top: 0; margin-bottom: 0">
							<b>
							<font face="Arial" size="2">&nbsp;</font></b></td>				
							<td align="center" height="24" width="7%">
							<p style="margin-right: 2px; margin-top: 0; margin-bottom: 0">
							<b>
							<font face="Arial" size="2">Qty</font></b></td>
							<td align="right" height="24" width="7%">
							<p style="margin-right: 2px; margin-top: 0; margin-bottom: 0" align="center">
							<b>
							<font face="Arial" size="2">Value</font></b></td>
							<td align="center" height="24" width="7%">
							<p style="margin-right: 2px; margin-top: 0; margin-bottom: 0">
							<b>
							<font face="Arial" size="2">Qty</font></b></td>
							<td align="right" height="24" width="7%">
							<p style="margin-right: 2px; margin-top: 0; margin-bottom: 0" align="center">
							<b>
							<font face="Arial" size="2">Value</font></b></td>
							<td align="center" height="24" width="7%">
							<p style="margin-right: 2px; margin-top: 0; margin-bottom: 0">
							<b>
							<font face="Arial" size="2">Qty</font></b></td>
							<td align="right" height="24" width="7%">
							<p style="margin-right: 2px; margin-top: 0; margin-bottom: 0" align="center">
							<b>
							<font face="Arial" size="2">Value</font></b></td>
							<td align="center" height="24" width="7%">
							<p style="margin-right: 2px; margin-top: 0; margin-bottom: 0">
							<b>
							<font face="Arial" size="2">Qty</font></b></td>
							<td align="center" height="24" width="7%">
							<p style="margin-right: 2px; margin-top: 0; margin-bottom: 0">
							<b>
							<font face="Arial" size="2">Value</font></b></td>
							<td align="right" height="24" width="7%">
							<p style="margin-right: 2px; margin-top: 0; margin-bottom: 0" align="center">
							<b>
							<font face="Arial" size="2">Qty</font></b></td>
							<td align="right" height="24" width="11%">
							<p style="margin-right: 2px; margin-top: 0; margin-bottom: 0" align="center">
							<b>
							<font face="Arial" size="2">Value | (Rate / Item</font>) </b></td>
						</tr>
					</table>
				</td>
			</tr>

			<tr>
				<td>
					<table border="1" width="100%" cellpadding="2" style="border-collapse: collapse" bordercolor="#808080">
			
			<?php
				$optot			= 0;
				$intot			= 0;
				$sttot			= 0;
				$outot			= 0;
				$cltot			= 0;
				$tot				= 0;
				
				if($catw == "YES" && $cid == 0) {

					for($j=0;$j<count($icatList);$j++) {
						$rr		= $icatList[$j];
						$cid	= $rr[0];
						
						$catoptot			= 0;
						$catintot			= 0;
						$catsttot			= 0;
						$catoutot			= 0;
						$catcltot			= 0;
						$cattot				= 0;						
						
				?>
					<tr bgcolor="FFFF66">
						<td colspan="12"><?php echo $rr[1]?></td>
					</tr>
				<?php
						
						$itmList	= $mdb->getItemListByCategoryJSON($cid, $tcmp->getCompanyID());

						for($i=0;$i<count($itmList);$i++) {
					
							$row			= $itmList[$i];
							$iid			= $row[0];
							if($row[2] != $cid && $cid != 0) continue;
							$itmDet		= $mdb->getItemDetail($iid);
					
							$obal			= $pdb->getLastStockClosingQuantity($tcmp->getCompanyID(), $sid, $iid, getPreviousDate($df));
							$oval			= $pdb->getLastStockClosingValue($tcmp->getCompanyID(), $sid, $iid, getPreviousDate($df));					
					
					
							$arr			= $pdb->getStockINTotal($df, $dt, $sid, $iid, $tcmp->getCompanyID());
							$inqty		= $arr[0];
							$inval		= round($arr[1], 2);
					
					
							$stkqty		= $obal + $inqty;
							$stkval		= $oval + $inval;
					
					
							$uprc			= 0;
							if($stkqty > 0)
								$uprc		= $stkval / $stkqty;
					
							$arr2			= $pdb->getStockOUTTotal($df, $dt, $sid, $iid, $tcmp->getCompanyID());
							$outqty		= $arr2[0];
							$outval		= round($arr2[1], 2);
					
					
							if($zeros == "" || $zeros == "ALL") {
								/* */
							} else if($zeros == "NOZERO") {
								if($obal == 0 && $inqty == 0 && $outqty == 0) continue;
							} else {
								if($obal != 0 || $inqty != 0 || $outqty != 0) continue;
							}
					
							$optot		= $optot + $oval;
							$intot		= $intot + $inval;
							$sttot		= $sttot + $stkval;
							$outot		= $outot + $outval;
							
							if($zeros == "" || $zeros == "ALL") {
								/* */
							} else if($zeros == "NOZERO") {
								if($obal == 0 && $inqty == 0 && $outqty == 0) continue;
							} else {
								if($obal != 0 || $inqty != 0 || $outqty != 0) continue;
							}							
					
							$cbal			= $stkqty - $outqty;
							$cval			= $stkval - $outval;
							$cltot		= $cltot + $cval;
					
							$tot			= $tot + $cval;
							
							/* Category Wise */
							
							$catoptot		= $catoptot + $oval;
							$catintot		= $catintot + $inval;
							$catsttot		= $catsttot + $stkval;
							$catoutot		= $catoutot + $outval;
					
							$catcltot		= $catcltot + $cval;
							$cattot			= $cattot + $cval;							
							
							/* category ends here */
					
							$rate			= 0;
							if($cbal != 0)
								$rate		= round($cval / $cbal, 2);
			?>			
			
						<tr>
							<td align="left" height="24" width="20%">
							<p style="margin-left: 2px; margin-top: 0; margin-bottom: 0">
							<font face="Arial" size="2"><?php echo $itmDet->getItemName()?> (<?php echo $itmDet->getItemNo()?>)</font></td>
							<td align="left" height="24" width="6%">
							<p style="margin-left: 2px; margin-top: 0; margin-bottom: 0">
							<font face="Arial" size="2"><?php echo $itmDet->getUnitName()?></font></td>				
							<td align="right" height="24" width="7%"><font face="Arial" size="2"><?php echo round($obal, 3)?></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"><?php echo round($oval, 2)?></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"><?php echo round($inqty, 3)?></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"><?php echo round($inval, 2)?></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"><?php echo round($stkqty, 3)?></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"><?php echo round($stkval, 2)?></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"><?php echo round($outqty, 3)?></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"><?php echo round($outval, 2)?></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"><?php echo round($cbal, 3)?></font></td>
							<td align="right" height="24" width="11%"><font face="Arial" size="2">
							<p style="margin-right: 2px; margin-top: 0; margin-bottom: 0"><?php echo round($cval, 2)?> (<?php echo round($rate, 3)?>)</font></td>
						</tr>
			
				<?php } ?>

						<tr bgcolor="#FFFFC0">
							<td align="left" height="24" width="26%" colspan="2">
							<p style="margin-left: 2px; margin-top: 0; margin-bottom: 0">
							<font face="Arial" size="2"><b><?php echo $rr[1]?> TOTAL</b></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"><b><?php echo round($catoptot, 2)?></b></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"><b><?php echo round($catintot, 2)?></b></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"><b><?php echo round($catsttot, 2)?></b></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"><b><?php echo round($catoutot, 2)?></b></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"></font></td>
							<td align="right" height="24" width="11%"><font face="Arial" size="2">
							<p style="margin-right: 2px; margin-top: 0; margin-bottom: 0"><b><?php echo round($catcltot, 2)?></b></font></td>
						</tr>	
				<?php						
						
					}
				
				} else {
				
					for($i=0;$i<count($itmList);$i++) {
					
						$row			= $itmList[$i];
						$iid			= $row[0];
						if($row[2] != $cid && $cid != 0) continue;
						$itmDet		= $mdb->getItemDetail($iid);
					
						$obal			= $pdb->getLastStockClosingQuantity($tcmp->getCompanyID(), $sid, $iid, getPreviousDate($df));
						$oval			= $pdb->getLastStockClosingValue($tcmp->getCompanyID(), $sid, $iid, getPreviousDate($df));					
					
					
						$arr			= $pdb->getStockINTotal($df, $dt, $sid, $iid, $tcmp->getCompanyID());
						$inqty		= $arr[0];
						$inval		= round($arr[1], 2);
					
					
						$stkqty		= $obal + $inqty;
						$stkval		= $oval + $inval;
					
					
						$uprc			= 0;
						if($stkqty > 0)
							$uprc		= $stkval / $stkqty;
					
						$arr2			= $pdb->getStockOUTTotal($df, $dt, $sid, $iid, $tcmp->getCompanyID());
						$outqty		= $arr2[0];
						$outval		= round($arr2[1], 2);
					
					
						if($zeros == "" || $zeros == "ALL") {
							/* */
						} else if($zeros == "NOZERO") {
							if($obal == 0 && $inqty == 0 && $outqty == 0) continue;
						} else {
							if($obal != 0 || $inqty != 0 || $outqty != 0) continue;
						}
					
						$optot		= $optot + $oval;
						$intot		= $intot + $inval;
						$sttot		= $sttot + $stkval;
						$outot		= $outot + $outval;
					
						$cbal			= $stkqty - $outqty;
						$cval			= $stkval - $outval;
						$cltot		= $cltot + $cval;
					
						$tot			= $tot + $cval;
					
						$rate			= 0;
						if($cbal != 0)
							$rate		= round($cval / $cbal, 2);
			?>			
			
						<tr>
							<td align="left" height="24" width="20%">
							<p style="margin-left: 2px; margin-top: 0; margin-bottom: 0">
							<font face="Arial" size="2"><?php echo $itmDet->getItemName()?> (<?php echo $itmDet->getItemNo()?>)</font></td>
							<td align="left" height="24" width="6%">
							<p style="margin-left: 2px; margin-top: 0; margin-bottom: 0">
							<font face="Arial" size="2"><?php echo $itmDet->getUnitName()?></font></td>				
							<td align="right" height="24" width="7%"><font face="Arial" size="2"><?php echo round($obal, 3)?></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"><?php echo round($oval, 2)?></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"><?php echo round($inqty, 3)?></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"><?php echo round($inval, 2)?></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"><?php echo round($stkqty, 3)?></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"><?php echo round($stkval, 2)?></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"><?php echo round($outqty, 3)?></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"><?php echo round($outval, 2)?></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"><?php echo round($cbal, 3)?></font></td>
							<td align="right" height="24" width="11%"><font face="Arial" size="2">
							<p style="margin-right: 2px; margin-top: 0; margin-bottom: 0"><?php echo round($cval, 2)?> (<?php echo round($rate, 3)?>)</font></td>
						</tr>
			
				<?php } ?>
				
			<?php } ?>
			
						<tr>
							<td align="left" height="24" width="26%" colspan="2">
							<p style="margin-left: 2px; margin-top: 0; margin-bottom: 0">
							<font face="Arial" size="2">TOTAL</font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"><?php echo round($optot, 2)?></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"><?php echo round($intot, 2)?></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"><?php echo round($sttot, 2)?></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"><?php echo round($outot, 2)?></font></td>
							<td align="right" height="24" width="7%"><font face="Arial" size="2"></font></td>
							<td align="right" height="24" width="11%"><font face="Arial" size="2">
							<p style="margin-right: 2px; margin-top: 0; margin-bottom: 0"><?php echo round($cltot, 2)?></font></td>
						</tr>			

					</table>
				</td>
			</tr>
			<tr><td>&nbsp;</td></tr>
		</table>


	
		<br />
		<div style="text-align:center"><input type="button" value="Export to Excel" onClick="ExportToExcel()" class="red_button" /></div>
		<br />	

</div>

</body>

</html>


<script language="javaScript">
	
	window.onload	=	function(){
		/*var hgt	=	document.getElementById('rpt-header').clientHeight;
		var div	=	document.getElementById('rpt-content');

		div.style.paddingTop	=	hgt + "px";*/
	}
	
	function ExportToExcel(){
		 var tbl		= document.getElementById('main_table');
		 var html 	= tbl.outerHTML;
		 window.open('data:application/vnd.ms-excel,' + encodeURIComponent(html));
	}	
	
</script>