<?php

	/* Include the required files */
	require_once( '../inc/functions.php' );
	require_once( '../aom-config.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/class.purchasedb.php' );
	require_once( '../dao/class.gen_itemcategory.php' );
	require_once( '../dao/class.gen_items.php' );
	require_once( '../dao/asys.store.php' );
	require_once( '../dao/asys.stockvoucher.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );	

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 43;

	$mdb			=	new masterdb("REPORT");
	$pdb			=	new purchasedb("REPORT");
	$ldb			= new logindb("REPORT");
	$mntArr		= array("", "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}		

	$fdate		=	getFirstFinancialDate();
	$tdate		=	getLastFinancialDate();
	$sid			= 0;
	$cid			= 0;
	$cmpid		= $tcmp->getCompanyID();

	extract($_REQUEST);

	$df				=	FormatIndianDateToSQLDate($fdate);
	$yr				= substr($df, 0, 4);
	$pdt			=	$yr."-03-31";
	$sid			= (int)$sid;
	$cid			= (int)$cid;

	if($sid <= 0){
		echo 'Invalid input Date format OR no Store selected, try again';
		exit;
	}
	
	$strDet		= $mdb->getStoreDetail($sid);
	$catDet		= $mdb->getItemCategoryDetail($cid);
	
	$obalq		= $pdb->getCategoryWiseLastStockClosingQuantity($cmpid, $sid, $cid, $pdt);
	$obalv		= $pdb->getCategoryWiseLastStockClosingValue($cmpid, $sid, $cid, $pdt);
	$obalv		= round($obalv, 2);

?>


<!DOCTYPE html>
<html>

<head>
	<meta http-equiv="Content-Type" content="text/html;charset=utf-8"/>
	<title>Category Wise Stock report</title>
	<link href="../css/rpt.css" type=text/css rel=stylesheet>	
</head>

<body topmargin="0" leftmargin="0" rightmargin="0" bottommargin="0" marginwidth="0" marginheight="0">

<div align="center">

		<table border="0" width="1200" cellspacing="0" cellpadding="0" id="main_table">
			<tr>
				<td align="center">
					<b><font size="6" face="Arial"><?php echo $tcmp->getCompanyName()?></font></b>
				</td>
			</tr>
			<tr>
				<td align="center">
					<b><font face="Arial" size="2"><?php echo $strDet->getStoreName()?></font></b>
				</td>
			</tr>
			<tr>
				<td>
					<div style="float:left;"><b><font face="Arial" size="2">MONTHLY STOCK DETAIL</font></b></div>
					<div style="float:right;"><b><font face="Arial" size="2"><?php echo $catDet->getItemcategoryName()?><?php if($cid == 0) echo 'ALL CATEGORY';?></font></b></div>
				</td>
			</tr>
			<tr>
				<td>
					<table border="1" width="100%" cellpadding="2" style="border-collapse: collapse" bordercolor="#808080">
						<tr>
							<td align="left" height="30" width="28%" rowspan="2"><b><font face="Arial" size="2">Particulars</font></b></td>
							<td align="center" height="30" width="24%" colspan="2"><b><font face="Arial" size="2">Inwards</font></b></td>
							<td align="center" height="30" width="24%" colspan="2"><b><font face="Arial" size="2">Outwards</font></b></td>							
							<td align="center" height="30" width="24%" colspan="2"><b><font face="Arial" size="2">Closing Balance</font></b></td>
						</tr>
						<tr>
							<td align="center" height="30" width="10%"><b><font face="Arial" size="2">Quantity</font></b></td>
							<td align="center" height="30" width="14%"><b><font face="Arial" size="2">Value</font></b></td>
							<td align="center" height="30" width="10%"><b><font face="Arial" size="2">Quantity</font></b></td>
							<td align="center" height="30" width="14%"><b><font face="Arial" size="2">Value</font></b></td>
							<td align="center" height="30" width="10%"><b><font face="Arial" size="2">Quantity</font></b></td>
							<td align="center" height="30" width="14%"><b><font face="Arial" size="2">Value</font></b></td>														
						</tr>
						
						
						<tr>
							<td align="left"><b><font face="Arial" size="2">Opening Balance</font></b></td>
							<td align="right"><b><font face="Arial" size="2"></font></b></td>
							<td align="right"><b><font face="Arial" size="2"></font></b></td>
							<td align="right"><b><font face="Arial" size="2"></font></b></td>
							<td align="right"><b><font face="Arial" size="2"></font></b></td>
							<td align="right"><b><font face="Arial" size="2"><?php echo $obalq ?></font></b></td>
							<td align="right"><b><font face="Arial" size="2"><?php echo $obalv ?></font></b></td>														
						</tr>						

			
			<?php
				$iqtytot			= 0;
				$ivaltot			= 0;
				$oqtytot			= 0;
				$ovaltot			= 0;
				$cqtytot			= $obalq;
				$cvaltot			= $obalv;
				
				for($i=4;$i<=12;$i++) {
					
					$mn		= $i;
					if($i < 10) $mn = "0".$i;
					$df		= $yr."-".$mn."-01";
					$dt		= $yr."-".$mn."-".cal_days_in_month(CAL_GREGORIAN, $i, $yr);
					
					$stkin		= $pdb->getCategoryWiseStockINTotal($df, $dt, $sid, $cid, $cmpid);
					$stkout		= $pdb->getCategoryWiseStockOUTTotal($df, $dt, $sid, $cid, $cmpid);
					
					$iqty			= $stkin[0];
					$ival			= round($stkin[1], 2);
					$oqty			= $stkout[0];
					$oval			= round($stkout[1], 2);
					$cqty			= $cqtytot + $iqty - $oqty;
					$cval			= $cvaltot + $ival - $oval;
					
					$iqtytot			= $iqtytot + $iqty;
					$ivaltot			= $ivaltot + $ival;
					$oqtytot			= $oqtytot + $oqty;
					$ovaltot			= $ovaltot + $oval;
					$cqtytot			= $cqtytot + $iqty - $oqty;
					$cvaltot			= $cvaltot + $ival - $oval;				

			?>			

						<tr>
							<td align="left"><b><font face="Arial" size="2"><a href="rptStockLedger.php?fdate=<?php echo FormatSQLDateToIndianDate($df)?>&tdate=<?php echo FormatSQLDateToIndianDate($dt)?>&sid=<?php echo $sid?>&cid=<?php echo $cid?>&zeros=NOZERO&catw=YES" target="_blank"><?php echo $mntArr[$i]?> <?php echo $yr?></a></font></b></td>
							<td align="right"><b><font face="Arial" size="2"><?php echo $iqty?></font></b></td>
							<td align="right"><b><font face="Arial" size="2"><?php echo $ival?></font></b></td>
							<td align="right"><b><font face="Arial" size="2"><?php echo $oqty?></font></b></td>
							<td align="right"><b><font face="Arial" size="2"><?php echo $oval?></font></b></td>
							<td align="right"><b><font face="Arial" size="2"><?php echo $cqty?></font></b></td>
							<td align="right"><b><font face="Arial" size="2"><?php echo $cval?></font></b></td>														
						</tr>
			
			<?php } ?>
			<?php
				$yr++;
				for($i=1;$i<=3;$i++) {
					
					$mn = "0".$i;
					$df		= $yr."-".$mn."-01";
					$dt		= $yr."-".$mn."-".cal_days_in_month(CAL_GREGORIAN, $i, $yr);
					
					$stkin		= $pdb->getCategoryWiseStockINTotal($df, $dt, $sid, $cid, $cmpid);
					$stkout		= $pdb->getCategoryWiseStockOUTTotal($df, $dt, $sid, $cid, $cmpid);
					
					$iqty			= $stkin[0];
					$ival			= round($stkin[1], 2);
					$oqty			= $stkout[0];
					$oval			= round($stkout[1], 2);
					$cqty			= $cqtytot + $iqty - $oqty;
					$cval			= $cvaltot + $ival - $oval;
					
					$iqtytot			= $iqtytot + $iqty;
					$ivaltot			= $ivaltot + $ival;
					$oqtytot			= $oqtytot + $oqty;
					$ovaltot			= $ovaltot + $oval;
					$cqtytot			= $cqtytot + $iqty - $oqty;
					$cvaltot			= $cvaltot + $ival - $oval;										

			?>			

						<tr>
							<td align="left"><b><font face="Arial" size="2"><a href="rptStockLedger.php?fdate=<?php echo FormatSQLDateToIndianDate($df)?>&tdate=<?php echo FormatSQLDateToIndianDate($dt)?>&sid=<?php echo $sid?>&cid=<?php echo $cid?>&zeros=NOZERO&catw=YES" target="_blank"><?php echo $mntArr[$i]?> <?php echo $yr?></a></font></b></td>
							<td align="right"><b><font face="Arial" size="2"><?php echo $iqty?></font></b></td>
							<td align="right"><b><font face="Arial" size="2"><?php echo $ival?></font></b></td>
							<td align="right"><b><font face="Arial" size="2"><?php echo $oqty?></font></b></td>
							<td align="right"><b><font face="Arial" size="2"><?php echo $oval?></font></b></td>
							<td align="right"><b><font face="Arial" size="2"><?php echo $cqty?></font></b></td>
							<td align="right"><b><font face="Arial" size="2"><?php echo $cval?></font></b></td>														
						</tr>
			
			<?php } ?>
			
						<tr>
							<td align="left"><b><font face="Arial" size="2">Grand Total</font></b></td>
							<td align="right"><b><font face="Arial" size="2"><?php echo $iqtytot?></font></b></td>
							<td align="right"><b><font face="Arial" size="2"><?php echo $ivaltot?></font></b></td>
							<td align="right"><b><font face="Arial" size="2"><?php echo $oqtytot?></font></b></td>
							<td align="right"><b><font face="Arial" size="2"><?php echo $ovaltot?></font></b></td>
							<td align="right"><b><font face="Arial" size="2"><?php echo $cqtytot?></font></b></td>
							<td align="right"><b><font face="Arial" size="2"><?php echo $cvaltot?></font></b></td>														
						</tr>		

					</table>
				</td>
			</tr>
			<tr><td>&nbsp;</td></tr>
		</table>

	
		<br />
		<div style="text-align:center"><input type="button" value="Export to Excel" onClick="ExportToExcel()" class="red_button" /></div>
		<br />	

</div>

</body>

</html>


<script language="javaScript">
	
	function ExportToExcel(){
		 var tbl		= document.getElementById('main_table');
		 var html 	= tbl.outerHTML;
		 window.open('data:application/vnd.ms-excel,' + encodeURIComponent(html));
	}	
	
</script>