<?php

	/* Include the required files */
	require_once( '../inc/functions.php' );
	require_once( '../aom-config.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/asys.voucherdb.php' );
	require_once( '../dao/asys.drcr.php' );
	require_once( '../dao/asys.group.php' );
	require_once( '../dao/asys.voucher.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/class.gen_itemcategory.php' );
	require_once( '../dao/class.gen_items.php' );
	require_once( '../dao/asys.store.php' );
	require_once( '../dao/asys.stockvoucher.php' );	
	require_once( '../dao/class.purchasedb.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userledger.php' );
	require_once( '../dao/asys.userpermission.php' );		

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 43;

	$db			=	new masterdb("REPORT");
	$vdb		=	new voucherdb("REPORT");
	$ldb		= new logindb("REPORT");
	$pdb		= new purchasedb("REPORT");
	$cmpid	= $tcmp->getCompanyID();

	$mntArr	= array("", "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}		

	$sid			= 0;
	$fdate		=	getFirstFinancialDate();
	$tdate		=	getLastFinancialDate();

	extract($_REQUEST);
	
	$df				=	FormatIndianDateToSQLDate($fdate);
	$dt				=	FormatIndianDateToSQLDate($tdate);
	$sid			=	(int)$sid;	

	if($sid == 0) {
		echo "Sorry!!! Direct Access not allowed here";
		exit;
	}
	
	$strDet		= $db->getStoreDetail($sid);

?>


<!DOCTYPE html>
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html;charset=utf-8"/>
		<title>Monthly Issue/Transfer</title>
		<link href="../css/rpt.css" type="text/css" rel="stylesheet">
		<script src="../js/common.js"></script>
	</head>
<body style="background-color:#ffffff">
	<div style="font-family:verdana;margin:0px auto;width:900px;">

		<div style="font-size:12px;">
			<table cellSpacing='1' cellPadding='4' width='100%' bgcolor="#CCCCCC" id="main_table">
			
				<tr bgcolor="#FFFFFF">
					<td colspan="2" align="center">
						<div style="font-size:18px; letter-spacing:1pt;">
							<b><?php echo $tcmp->getCompanyName()?><br /></b>
						</div>
						<div style="font-size:15px; letter-spacing:1pt;">
							<?php echo nl2br($tcmp->getCompanyAddress())?>
						</div>
						<div style="font-size:13px;">
							<?php echo $strDet->getStoreName()?>, <?php echo $fdate?> - <?php echo $tdate?>
						</div>
					</td>
				</tr>
			
				<tr bgcolor="#F4F4F4">
					<td width='49%'>PARTICULARS</td>
					<td width='17%' align='right'>DEBIT AMOUNT</td>
				</tr>

			<?php
				$totdr	= 0;
				$accList	= $pdb->getDebitAccountListFromIssue($sid, $df, $dt);
				for($j=0;$j<count($accList);$j++) {
					$rr		= $accList[$j];
					if($rr[0] == 0) continue;
					$aDet	= $db->getAccountDetail($rr[0]);
					$dr		= 0;
					$dr		= $dr + $db->getTotalDebitAmountByAccountIDIssue($rr[0], $df, $dt, $sid);
					$dr		= $dr + $db->getTotalDebitAmountByAccountIDTransferIssue($rr[0], $df, $dt, $sid);
					$dr		= $dr + $db->getTotalDebitAmountByAccountIDModuleID($rr[0], $df, $dt, $sid, 67);
					$dr		= $dr + $db->getTotalDebitAmountByAccountIDModuleID($rr[0], $df, $dt, $sid, 68);
					$dr		= $dr + $db->getTotalDebitAmountByAccountIDModuleID($rr[0], $df, $dt, $sid, 69);
					
					$totdr+= $dr;	
					
			?>
				<tr bgcolor="#FFFFFF">
					<td>
						<a href="rptMainLedgerSpecific.php?accid=<?php echo $rr[0]?>&fdate=<?php echo $fdate?>&tdate=<?php echo $tdate?>&expand=yes&sid=<?php echo $sid?>" target="_blank"><?php echo $aDet->getAccountName()?></a>
					</td>
					<td align='right'><?php echo number_format($dr, 2)?></td>
				</tr>
			<?php
				}
			?>
			

				<tr bgcolor="#FFFFFF">
					<td><b>CURRENT TOTAL ***</b></td>
					<td align='right'><b><?php echo number_format($totdr, 2)?></b></td>
				</tr>
			</table>
		</div>
		
		<br />
		<div style="text-align:center"><input type="button" value="Export to Excel" onClick="ExportToExcel()" class="red_button" /></div>
		<br />		
		
	</div>
</body>
</html>

<script type="text/javascript">

	function ExportToExcel(){
		 var tbl		= document.getElementById('main_table');
		 var html 	= tbl.outerHTML;
		 window.open('data:application/vnd.ms-excel,' + encodeURIComponent(html));
	}
	
</script>