<?php

	/* Include the required files */
	require_once( '../inc/functions.php' );
	require_once( '../aom-config.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/class.purchasedb.php' );
	require_once( '../dao/class.gen_items.php' );
	require_once( '../dao/asys.store.php' );
	require_once( '../dao/asys.stockvoucher.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );	

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 43;

	$mdb			=	new masterdb("REPORT");
	$pdb			=	new purchasedb("REPORT");
	$ldb			= new logindb("REPORT");
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}		

	$fdate		=	getFirstFinancialDate();
	$tdate		=	getLastFinancialDate();
	$sid			= 0;
	$iid			= 0;

	extract($_REQUEST);

	$df				=	FormatIndianDateToSQLDate($fdate);
	$dt				=	FormatIndianDateToSQLDate($tdate);
	$sid			= (int)$sid;
	$iid			= (int)$iid;

	if($df == '1900-01-01' || $dt == '1900-01-01' || $sid <= 0 || $iid <= 0){
		echo 'Invalid input Date format OR no Store selected OR no Item selected, try again';
		exit;
	}
	
	$strDet		= $mdb->getStoreDetail($sid);
	$itmDet		= $mdb->getItemDetail($iid);
	
	$stkList	= $pdb->getStockVoucherList($df, $dt, $sid, $iid, $tcmp->getCompanyID());
	
	$obal			= $pdb->getLastStockClosingQuantity($tcmp->getCompanyID(), $sid, $iid, getPreviousDate($df));
	$oval			= $pdb->getLastStockClosingValue($tcmp->getCompanyID(), $sid, $iid, getPreviousDate($df));
	
	/*$obal			= $pdb->getStockClosing($tcmp->getCompanyID(), $sid, $iid, getPreviousDate($df));
	$oval			= $pdb->getStockClosingValue($tcmp->getCompanyID(), $sid, $iid, getPreviousDate($df), $obal);*/
	$uprc			= 0;
	if($obal > 0)
		$uprc		= $oval / $obal;

?>


<!DOCTYPE html>
<html>

<head>
	<meta http-equiv="Content-Type" content="text/html;charset=utf-8"/>
	<title>Individual Item Stock Ledger</title>
	<link href="../css/rpt.css" type=text/css rel=stylesheet>
	<script src="../js/common.js"></script>
</head>

<body style="background-color:#ffffff">
	
	<div style="font-family:verdana;" align="center">
	
	<table border="1" width="95%" cellspacing="0" cellpadding="2" style="border-collapse: collapse" bordercolor="#C0C0C0" id="main_table">
		<tr>
			<td width="100%" height="30" colspan="9">
			<table border="0" width="100%" cellpadding="2">
				<tr>
					<td align="center">
						<b><font size="6" face="Arial"><?php echo $tcmp->getCompanyName()?></font></b>
					</td>
				</tr>
				<tr>
					<td height="30"><b><font face="Arial"><?php echo $itmDet->getItemName()?> (<?php echo $itmDet->getItemNo()?>) in Store - <?php echo $strDet->getStoreName()?></font></b></td>
				</tr>
				<tr>
					<td height="30">
					<p align="right" style="margin-right: 2px">
					<font face="Arial" size="2">Date : <?php echo $fdate?> to <?php echo $tdate?></font></td>
				</tr>
			</table>
			</td>
		</tr>
		<tr>
			<td width="10%" align="center"><b><font face="Arial" size="2">Date</font></b></td>
			<td width="20%"><b><font face="Arial" size="2">Description</font></b></td>
			<td width="10%" align="center"><b><font face="Arial" size="2">IN</font></b></td>
			<td width="10%" align="right" ><b><font face="Arial" size="2">Unit Price</font></b></td>
			<td width="10%" align="center"><b><font face="Arial" size="2">OUT</font></b></td>
			<td width="10%" align="right"><b><font face="Arial" size="2">Unit Price</font></b></td>
			<td width="10%" align="center"><b><font face="Arial" size="2">Closing Qty</font></b></td>
			<td width="10%" align="right"><b><font face="Arial" size="2">Value</font></b></td>
			<?php if($tuser->getUserStatus() >= HIDDEN_USER) { ?>
			<td width="10%" align="right"><b><font face="Arial" size="2">Balance Detail</font></b></td>
			<?php } ?>
		</tr>
		
		<tr>
			<td align="center">&nbsp;</td>
			<td align="left"><font face="Arial" size="2">By Opening Balance</font></td>		
			<td align="center">&nbsp;</td>
			<td align="right">&nbsp;</td>
			<td align="center">&nbsp;</td>
			<td align="right">&nbsp;</td>
			<td align="center"><font face="Arial" size="2"><?php echo $obal?></font></td>
			<td align="right"><font face="Arial" size="2"><?php echo round($oval,2)?></font></td>
			<?php if($tuser->getUserStatus() >= HIDDEN_USER) { ?>
			<td align="right">&nbsp;</td>
			<?php } ?>
		</tr>			
		
		<?php
			$cbal	= $obal;
			$cval	= $oval;
			$in		= 0;
			$out	= 0;
			for($i=0;$i<count($stkList);$i++) {
				$scls	= $stkList[$i];
		?>

		<tr>
			<td align="center">
				<font face="Arial" size="2"><?php echo $scls->getDOT('yes')?></font>
			</td>
			<td align="left">
				<font face="Arial" size="2"><?php echo $scls->getNarration('yes')?></font>
			</td>
			<?php 
				if($scls->getStockInOut() == STOCK_IN){
					$in			= $in + $scls->getQuantity();
					$cbal		= $scls->getClosingQty();
					$cval		= $scls->getClosingValue();
					$bald		= $scls->getBalanceDetail();
			?>
				
				<td align="center"><font face="Arial" size="2"><?php echo $scls->getQuantity()?></font></td>
				<td align="right"><font face="Arial" size="2"><?php echo $scls->getUnitPrice()?></font></td>
				<td align="center"><font face="Arial" size="2">--</font></td>
				<td align="right"><font face="Arial" size="2">--</font></td>
			
			<?php 
				} else {
					$out		= $out + $scls->getQuantity();
					$cbal		= $scls->getClosingQty();
					$cval		= $scls->getClosingValue();
					$bald		= $scls->getBalanceDetail();
			?>
			
				<td align="center"><font face="Arial" size="2">--</font></td>
				<td align="right"><font face="Arial" size="2">--</font></td>
				<td align="center"><font face="Arial" size="2"><?php echo $scls->getQuantity()?></font></td>
				<td align="right"><font face="Arial" size="2"><?php echo $scls->getUnitPrice()?></font></td>
				
			<?php } ?>			
			
			<td align="center"><font face="Arial" size="2"><?php echo $cbal?></font></td>
			<td align="right"><font face="Arial" size="2"><?php echo round($cval,2)?></font></td>
			<?php if($tuser->getUserStatus() >= HIDDEN_USER) { ?>
			<td align="left"><font face="Arial" size="2"><?php echo $bald?></font></td>
			<?php } ?>
		</tr>
	
		<?php } ?>
		
		<tr>
			<td align="center"><b><font face="Arial" size="2">&nbsp;</font></b></td>
			<td><b><font face="Arial" size="2">&nbsp;</font></b></td>
			<td align="center"><b><font face="Arial" size="2"><?php echo $in?></font></b></td>
			<td align="right" ><b><font face="Arial" size="2">&nbsp;</font></b></td>
			<td align="center"><b><font face="Arial" size="2"><?php echo $out?></font></b></td>
			<td align="right"><b><font face="Arial" size="2">&nbsp;</font></b></td>
			<td align="center"><b><font face="Arial" size="2">&nbsp;</font></b></td>
			<td align="right"><b><font face="Arial" size="2">&nbsp;</font></b></td>
			<?php if($tuser->getUserStatus() >= HIDDEN_USER) { ?>
			<td align="left"><font face="Arial" size="2">&nbsp;</font></td>
			<?php } ?>
		</tr>
		
	</table>
	
	<br />
	<div style="text-align:center"><input type="button" value="Export to Excel" onClick="ExportToExcel()" class="red_button" /></div>
	<br />		
		
	</div>
</body>
</html>

<script type="text/javascript">

	function ExportToExcel(){
		 var tbl		= document.getElementById('main_table');
		 var html 	= tbl.outerHTML;
		 window.open('data:application/vnd.ms-excel,' + encodeURIComponent(html));
	}
	
</script>