<?php

	/* Include the required files */
	require_once( '../inc/functions.php' );
	require_once( '../aom-config.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/asys.voucherdb.php' );
	require_once( '../dao/class.purchasedb.php' );
	require_once( '../dao/asys.drcr.php' );
	require_once( '../dao/asys.group.php' );
	require_once( '../dao/asys.voucher.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );	
	require_once( '../dao/class.gen_items.php' );
	require_once( '../dao/asys.store.php' );
	require_once( '../dao/asys.stockvoucher.php' );
	require_once( '../dao/class.gen_issue.php' );
	require_once( '../dao/class.gen_issue_items.php' );
	require_once( '../dao/class.gen_stocktransfer.php' );
	require_once( '../dao/class.gen_stocktransfer_items.php' );	

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 48;

	$db			=	new masterdb("REPORT");
	$vdb		=	new voucherdb("REPORT");
	$pdb		=	new purchasedb("REPORT");
	$ldb		= new logindb("REPORT");
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}		

	$maccid	= 0;
	$caccid	= 0;
	$fdate	=	"2001-01-01";
	$tdate	=	getLastFinancialDate();

	extract($_REQUEST);

	if($fdate == "")
		$fdate	=	"2001-01-01";

	$maccid	=	(int)$maccid;
	$caccid	=	(int)$caccid;

	if($maccid == 0 || $caccid == 0) {
		echo "Sorry!!! Direct Access not allowed here";
		exit;
	}

	$maccDet	= $db->getAccountDetail($maccid);
	$accDet		= $db->getAccountDetail($caccid);

	$df				=	FormatIndianDateToSQLDate($fdate);
	$dt				=	FormatIndianDateToSQLDate($tdate);
	
	if($df == '1900-01-01' || $dt == '1900-01-01'){
		echo 'Invalid input Date format, try again';
		exit;
	}
	
	$varr			= $vdb->getStockIssueTransferVoucherList($df, $dt, $caccid);

?>

<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html;charset=utf-8"/>
	<title>Stock Issue/Transfer Report</title>
	<link href="../css/rpt.css" type=text/css rel=stylesheet>
	<script src="../js/common.js"></script>
</head>

<body topmargin="0" leftmargin="0" rightmargin="0" bottommargin="0" marginwidth="0" marginheight="0">

<div align="center">

<table border="0" width="700" cellspacing="0" cellpadding="0">
	<tr>
		<td height="60">
		<p align="center" style="margin-top: 0; margin-bottom: 0"><b>
		<font size="6" face="Arial"><?php echo $tcmp->getCompanyName()?></font></b></td>
	</tr>
	<tr>
		<td height="24">
		<p align="center"><b><font face="Arial" size="2"><?php echo $maccDet->getAccountName()?> (<?php echo $accDet->getAccountName()?>)</font></b></td>
	</tr>
	<tr>
		<td height="24">
		<p align="center"><b><font face="Arial" size="2">STOCK OUT REPORT LEDGER 
		WISE</font></b></td>
	</tr>
	<tr>
		<td height="24">
		<p align="center">
		<b><font face="Arial" size="2">Date : <?php echo $fdate?> TO <?php echo $tdate?></font></b></td>
	</tr>
	<tr>
		<td>
		<table border="1" width="100%" cellspacing="0" cellpadding="0" style="border-collapse: collapse" bordercolor="#808080">
			<tr>
				<td align="center" height="30" width="40%">
				<p style="margin-left: 2px; margin-top: 0; margin-bottom: 0">
				<b><font face="Arial" size="2">Ledger Name / Items</font></b></td>
				<td align="center" height="30" width="20%">
				<b>
				<font face="Arial" size="2">Quantity</font></b></td>
				<td align="center" height="30" width="20%">
				<b>
				<font face="Arial" size="2">Rate</font></b></td>
				<td align="center" height="30" width="20%">
				<b>
				<font face="Arial" size="2">Value</font></b></td>
			</tr>
					
			<?php
				$prevaid	= 0;
				$atot			= 0;
				for($j=0;$j<count($varr);$j++) {
					$veb		= $varr[$j];
					$isno		= "";
					$fy			= "";
					$dot		= "";
					$typ		= "";
					
					if($j == 0)
						$prevaid = $veb->getAccountID();
					
					if($veb->getTxnType() == STOCK_TRANSFER) {
						$scls			= $pdb->getStockTransferDetail($veb->getRelatedID());
						$isno			= $scls->getStockTransferID();
						$dot			= $scls->getDOT('yes');
						$typ			= "Stock Transfer";
						$itemList	= $scls->getItemList();
					} else {
						$icls			= $pdb->getIssueDetail($veb->getRelatedID());
						$isno			= $icls->getIssueNo();
						$fy				= $icls->getFinYear();
						$dot			= $icls->getIssueDate('yes');
						$typ			= "Issue";
						$itemList	= $icls->getItemList();
					}
					
					if($prevaid != $veb->getAccountID()) { 
					
				?>

						<tr bgcolor="#bbffbb">
							<td align="left" height="24" width="80%" colspan="3">
							<p style="margin-left: 2px; margin-top: 0; margin-bottom: 0"><b>
							<font face="Arial" size="2"><?php echo $db->getAccountNameByAccountID($prevaid)?></font></b></td>
							<td align="right" height="24" width="20%">
							<p style="margin-right: 2px; margin-top: 0; margin-bottom: 0">
							<b><font face="Arial" size="2"><?php echo $atot?></font></b></td>
						</tr>	
						<tr><td colspan="4">&nbsp;</td></tr>				
				
				<?php
						$prevaid 	= $veb->getAccountID(); 
						$atot			= 0;						
					 } 
				?>
										
						<tr>
							<td align="left" height="24" width="100%" colspan="4">
							<p style="margin-left: 2px; margin-top: 0; margin-bottom: 0">
							<font face="Arial" size="2"><?php echo $dot?> &nbsp;&nbsp;&nbsp;&nbsp;<?php echo $typ?> <?php echo $isno?><?php if($fy != "") echo '/'.$fy; ?></font></td>
						</tr>						
						
						<?php
						
							for($k=0;$k<count($itemList);$k++) {
								$itmcls	= $itemList[$k];
								$iid		= $itmcls->getItemID();
								$itmDet	= $db->getItemDetail($iid);
								$qty		= $itmcls->getQuantity();
								if($typ == "Issue")
									$rate		= $pdb->getUnitPriceOfIssuedItem( $icls->getIssueID(), $itmcls->getItemID());
								else
									$rate		= $pdb->getUnitPriceOfTransferredItem( $scls->getStockTransferID(), $itmcls->getItemID());
								$val		= round($qty * $rate, 2);
							
								$atot		= $atot + $val;
						
					?>
			
								<tr>
									<td align="left" height="24" width="40%">
									<p align="right" style="margin-right: 2px; margin-top: 0; margin-bottom: 0">
									<font face="Arial" size="2"><?php echo $itmDet->getItemName()?></font></td>
									<td align="right" height="24" width="20%">
									<p style="margin-right: 2px; margin-top: 0; margin-bottom: 0">
									<font face="Arial" size="2"><?php echo $qty?> <?php echo $itmDet->getUnitName()?></font></td>
									<td align="right" height="24" width="20%">
									<p style="margin-right: 2px; margin-top: 0; margin-bottom: 0">
									<font face="Arial" size="2"><?php echo $rate?></font></td>
									<td align="right" height="24" width="20%">
									<p style="margin-right: 2px; margin-top: 0; margin-bottom: 0">
									<font face="Arial" size="2"><?php echo $val?></font></td>
								</tr>
						
						<?php } ?>
								
					<?php } ?>
					
			<tr bgcolor="#bbffbb">
				<td align="left" height="24" width="80%" colspan="3">
				<p style="margin-left: 2px; margin-top: 0; margin-bottom: 0"><b>
				<font face="Arial" size="2"><?php echo $db->getAccountNameByAccountID($prevaid)?></font></b></td>
				<td align="right" height="24" width="20%">
				<p style="margin-right: 2px; margin-top: 0; margin-bottom: 0">
				<b><font face="Arial" size="2"><?php echo $atot?></font></b></td>
			</tr>	
			<tr><td colspan="4">&nbsp;</td></tr>					
			
			<tr>
				<td align="left" height="10" width="100%" colspan="4">
				</td>
			</tr>
			

		</table>
		</td>
	</tr>
	<tr>
		<td>
		&nbsp;</td>
	</tr>
	</table>

</div>

</body>

</html>