<?php

	/* Include the required files */
	require_once( '../inc/functions.php' );
	require_once( '../aom-config.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/asys.voucherdb.php' );
	require_once( '../dao/asys.drcr.php' );
	require_once( '../dao/asys.group.php' );
	require_once( '../dao/asys.voucher.php' );
	require_once( '../dao/asys.vouchertag.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userledger.php' );
	require_once( '../dao/asys.userpermission.php' );	

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 32;

	$db			=	new masterdb("REPORT");
	$vdb		=	new voucherdb("REPORT");
	$ldb		= new logindb("REPORT");
	$uaDet	= $ldb->getUserLedgerDetail($tuser->getUserID());
	$uacc			= $uaDet->getAccounts();
	$uacList	= explode(",", $uacc);	
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}		

	$maccid	= 0;
	$caccid	= 0;
	$fdate	=	"2001-01-01";
	$tdate	=	getLastFinancialDate();
	$expand	=	'no';

	extract($_REQUEST);

	if($fdate == "")
		$fdate	=	"2001-01-01";

	$maccid	=	(int)$maccid;
	$caccid	=	(int)$caccid;
	
	if($tuser->getUserStatus() < ADMIN_USER) {
		if(!in_array($caccid, $uacList)) {
			header("Location:../accessDenied.php");
			exit;			
		}
	}	

	if($maccid == 0 || $caccid == 0) {
		echo "Sorry!!! Direct Access not allowed here";
		exit;
	}
	
	$df				=	FormatIndianDateToSQLDate($fdate);
	$dt				=	FormatIndianDateToSQLDate($tdate);
	$ndt			=	getNextDate($df);	

	$maccDet	= $db->getAccountDetail($maccid);
	$accDet		= $db->getAccountDetail($caccid);
	$bal			= $accDet->getOBal();
	$balt			= $accDet->getOBalType();

	$clbal		=	$db->getClosingBalanceByAccountID($caccid, $ndt);
	
	$bal			=	$clbal[0];
	$balt			=	$clbal[1];

	$alDet		= $vdb->getAccountVoucher($caccid, $df, $dt);

	$totcr		= 0;
	$totdr		= 0;
	if($balt==DEBIT)
		$totdr	=	$bal;
	else
		$totcr	= $bal;

?>


<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html;charset=utf-8"/>
		<title>Ledger of <?php echo $accDet->getAccountName()?></title>
		<link href="../css/rpt.css" type=text/css rel=stylesheet>
		<script src="../js/common.js"></script>
	</head>
<body style="background-color:#ffffff">
	<div style="font-family:verdana;width:900px;margin:0px auto;" align="center">

		<div >
			<table cellSpacing='1' cellPadding='4' width='100%' bgcolor="#CCCCCC" id="main_table">
				
				<tr bgcolor="#FFFFFF">
					<td colspan="6" align="center">
						<div style="font-size:18px; letter-spacing:1pt;">
							<b><?php echo $tcmp->getCompanyName()?><br /></b>
						</div>
						<div style="font-size:15px; letter-spacing:1pt;">
							<?php echo nl2br($tcmp->getCompanyAddress())?>
						</div>
						<div style="font-size:15px; letter-spacing:1pt;">
							<b><br /><?php echo $accDet->getMotherAccountName()?> >> <?php echo $accDet->getAccountName()?></b>
						</div>
						<div style="font-size:13px;">
							Sub Ledger from <?php echo $fdate?> to <?php echo $tdate?>
						</div>
					</td>
				</tr>
				
				<tr bgcolor="#F4F4F4">
					<td width='10%'><b><font style='font-family:arial; font-size:12px'>DATE</font></b></td>
					<td width='14%'>
						<b><font style='font-family:arial; font-size:12px'>DOC NO</font></b>
					</td>
					<td width='35%'>
						<b><font style='font-family:arial; font-size:12px'>PARTICULARS</font></b>
					</td>
					<td width='12%'>
						<b><font style='font-family:arial; font-size:12px'>DEBIT</font></b>
					</td>
					<td width='12%'>
						<b><font style='font-family:arial; font-size:12px'>CREDIT</font></b>
					</td>
					<td width='15%'>
						<b><font style='font-family:arial; font-size:12px'>BALANCE</font></b>
					</td>
				</tr>

				<tr bgcolor="#FFFFFF">
					<td>&nbsp;</td>
					<td>&nbsp;</td>
					<td>
						<font style='font-family:arial; font-size:12px'><b>By Opening Balance</b></font>
					</td>
					<?php
						if($balt == DEBIT) {
					?>
						<td align='right'>
							<font style='font-family:arial; font-size:12px'><b><?php echo number_format($bal,2)?></b></font>
						</td>
						<td align='right'>
							<font style='font-family:arial; font-size:12px'><b>0.00</b></font>
						</td>
					<?php } else {
					?>
						<td align='right'>
							<font style='font-family:arial; font-size:12px'><b>0.00</b></font>
						</td>
						<td align='right'>
							<font style='font-family:arial; font-size:12px'><b><?php echo number_format($bal,2)?></b></font>
						</td>
					<?php } ?>
					<td align='right'>
						<font style='font-family:arial; font-size:12px'><b><?php echo number_format($bal,2)?> <?php echo getDrCr($balt)?></b></font>
					</td>
				</tr>
			<?php
				for($i=0;$i<count($alDet);$i++) {
					$veb	=	$alDet[$i];
					$rcls	=	"td_normal_green";

					$vt		=	$veb->getVoucherType();
					$fy		=	$veb->getFinYear();
					$vid	=	$veb->getVoucherID();
					$olist=	$vdb->getOppositeVoucher($vid, $caccid);

			?>
				<tr bgcolor="#FFFFFF" class="td_normal">
					<td valign="top">
						<font style='font-family:arial; font-size:12px'><?php echo $veb->getDOV('yes')?></font>
					</td>
					<td valign="top">
						<font style='font-family:arial; font-size:12px'>&nbsp;
							<a href="../printvoucher.php?vid=<?php echo $veb->getVoucherID()?>" target="_blank"><?php echo getShortVoucherType($veb->getVoucherType()).'/'.FormatSQLDateToVoucherPrintFormat($veb->getDOV()).'/'.$veb->getDayWiseNo()?></a>
						</font>
					</td>

					<td valign="top">
						<font style='font-family:arial; font-size:12px'><?php echo $veb->getNarration()?></font>
					</td>
					<?php
						if($veb->getDrCr() == DEBIT) {
							$totdr+=$veb->getAmount();
							if($balt == DEBIT)
								$bal+=$veb->getAmount();
							else
								$bal-=$veb->getAmount();
							if($bal < 0) {
								$bal=-$bal;
								$balt	=	DEBIT;
							}
					?>
						<td class="<?php if($expand=='yes') echo $rcls; else echo 'td_normal';?>" align='right' valign="top">
							<font style='font-family:arial; font-size:12px'><?php echo number_format($veb->getAmount(),2)?></font>
						</td>
						<td align='right' valign="top">
							<font style='font-family:arial; font-size:12px'>0.00</font>
						</td>
					<?php
						} else {
							$totcr+=$veb->getAmount();
							if($balt == CREDIT)
								$bal+=$veb->getAmount();
							else
								$bal-=$veb->getAmount();
							if($bal < 0) {
								$bal=-$bal;
								$balt	=	CREDIT;
							}
					?>
						<td class="<?php if($expand=='yes') echo $rcls; else echo 'td_normal';?>" align='right' valign="top">
							<font style='font-family:arial; font-size:12px'>0.00</font>
						</td>
						<td align='right' valign="top">
							<font style='font-family:arial; font-size:12px'><?php echo number_format($veb->getAmount(),2)?></font>
						</td>
					<?php } ?>
					<td align='right' valign="top">
						<font style='font-family:arial; font-size:12px'><?php echo number_format($bal,2)?> <?php echo getDrCr($balt)?></font>
					</td>
				</tr>
			<?php
					for($j=0;$j<count($olist);$j++) {
						$ovch	=	$olist[$j];
						$tmp	=	"#f4f4f4";
						if($j%2==0)
							$tmp	=	"#e4e4e4";
			?>
							<tr bgcolor="#FFFFFF">
								<td>&nbsp;</td>
								<td>&nbsp;</td>
								<td bgcolor="<?php echo $tmp?>">
									<font style='font-family:verdana; font-size:12px'><?php echo $ovch->getAccountName('yes')?> - <?php echo $ovch->getAmount('yes')?> (<?php echo getDrCr($ovch->getDrCr())?>)</font>
								</td>
								<td>&nbsp;</td>
								<td>&nbsp;</td>
								<td>&nbsp;</td>
							</tr>
			<?php
					}
				}
			?>

				<tr bgcolor="#FFFFFF">
					<td>
						<font style='font-family:arial; font-size:10px'>&nbsp;</font>
					</td>
					<td>
						<font style='font-family:arial; font-size:10px'>&nbsp;</font>
					</td>
					<td>
						<font style='font-family:arial; font-size:12px'><b>CURRENT TOTAL ***</b></font>
					</td>
					<td align="right">
						<font style='font-family:arial; font-size:12px'><b><?php echo number_format($totdr,2)?></b></font>
					</td>
					<td align="right">
						<font style='font-family:arial; font-size:12px'><b><?php echo number_format($totcr,2)?></b></font>
					</td>
					<td align="right">
						<font style='font-family:arial; font-size:12px'><b><?php echo number_format($bal,2)?> <?php echo getDrCr($balt)?></b></font>
					</td>
				</tr>
				
				<tr bgcolor="#FFFFFF">
					<td colspan="6"><br><b>CLOSING TOTAL: <?php echo CURRENCY_WORD?> <?php echo numToWord($bal,'Paise')?></b></td>
				</tr>
				
			</table>
		</div>
		
		<br />
		<div style="text-align:center"><input type="button" value="Export to Excel" onClick="ExportToExcel()" class="red_button" /></div>
		<br />		
		
	</div>
</body>
</html>

<script language="javascript">

	function ExportToExcel(){
		 var tbl		= document.getElementById('main_table');
		 var html 	= tbl.outerHTML;
		 window.open('data:application/vnd.ms-excel,' + encodeURIComponent(html));
	}

</script>