<?php

	/* Include the required files */
	require_once( '../inc/functions.php' );
	require_once( '../aom-config.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/asys.voucherdb.php' );
	require_once( '../dao/asys.drcr.php' );
	require_once( '../dao/asys.group.php' );
	require_once( '../dao/asys.voucher.php' );
	require_once( '../dao/asys.vouchertag.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userledger.php' );
	require_once( '../dao/asys.userpermission.php' );		

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 32;

	$db			=	new masterdb("REPORT");
	$vdb		=	new voucherdb("REPORT");
	$ldb		= new logindb("REPORT");
	$uaDet	= $ldb->getUserLedgerDetail($tuser->getUserID());
	$uacc			= $uaDet->getAccounts();
	$uacList	= explode(",", $uacc);	
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}		

	$accid		= 0;
	$fdate		=	getFirstFinancialDate();
	$tdate		=	getLastFinancialDate();
	$expand		=	'no';

	extract($_REQUEST);
	
	$df				=	FormatIndianDateToSQLDate($fdate);
	$dt				=	FormatIndianDateToSQLDate($tdate);
	$ndt			=	getNextDate($df);	

	$accid		=	(int)$accid;
	
	if($tuser->getUserStatus() < ADMIN_USER) {
		if(!in_array($accid, $uacList)) {
			header("Location:../accessDenied.php");
			exit;			
		}
	}	

	if($accid == 0) {
		echo "Sorry!!! Direct Access not allowed here";
		exit;
	}

	$accDet		= $db->getAccountDetail($accid);
	$bal			= $accDet->getOBal();
	$balt			= $accDet->getOBalType();

	$clbal		=	$db->getClosingBalanceByAccountID($accid, $ndt);
	$bal			=	$clbal[0];
	$balt			=	$clbal[1];

	$alDet		= $vdb->getConsolidatedAccountVoucher2($accid, $df, $dt);
	
	$totcr		= 0;
	$totdr		= 0;
	if($balt == DEBIT)
		$totdr	=	$bal;
	else
		$totcr	= $bal;	

?>


<!DOCTYPE html>
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html;charset=utf-8"/>
		<title>Consolidated Ledger of <?php echo $accDet->getAccountName()?></title>
		<link href="../css/rpt.css" type="text/css" rel="stylesheet">
		<script src="../js/common.js"></script>
	</head>
<body style="background-color:#ffffff">
	<div style="font-family:verdana;margin:0px auto;width:900px;">

		<div style="font-size:12px;">
			<table cellSpacing='1' cellPadding='4' width='100%' bgcolor="#CCCCCC" id="main_table">
				
				<tr bgcolor="#FFFFFF">
					<td colspan="5" align="center">
						<div style="font-size:18px; letter-spacing:1pt;">
							<b><?php echo $tcmp->getCompanyName()?><br /></b>
						</div>
						<div style="font-size:15px; letter-spacing:1pt;">
							<?php echo nl2br($tcmp->getCompanyAddress())?>
						</div>
						<div style="font-size:15px; letter-spacing:1pt;">
							<b><br /><?php echo $accDet->getMotherAccountName()?> >> <?php echo $accDet->getAccountName()?></b>
						</div>
						<div style="font-size:13px;">
							Concise Sub Ledger from <?php echo $fdate?> to <?php echo $tdate?>
						</div>
					</td>
				</tr>
				
				<tr bgcolor="#F4F4F4">
					<td width='19%'>DATE RANGE</td>
					<td width='40%'>PARTICULARS</td>
					<td width='13%' align='right'>DEBIT</td>
					<td width='13%' align='right'>CREDIT</td>
					<td width='15%' align='right'>BALANCE</td>
				</tr>

				<tr bgcolor="#FFFFFF">
					<td>&nbsp;</td>
					<td><b>By Opening Balance</b></td>
					<?php
						if($balt == DEBIT) {
					?>
						<td align='right'><b><?php echo number_format($bal,2)?></b></td>
						<td align='right'><b>0.00</b></td>
					<?php } else {
					?>
						<td align='right'><b>0.00</b></td>
						<td align='right'><b><?php echo number_format($bal,2)?></b></td>
					<?php } ?>
					<td align='right'><b><?php echo number_format($bal,2)?> <?php echo getDrCr($balt)?></b></td>
				</tr>
			<?php
				for($i=0;$i<count($alDet);$i++) {
					$veb	=	$alDet[$i];
			?>
				<tr bgcolor="#FFFFFF">
					<td><?php echo $fdate ?> - <?php echo $tdate?></td>
					<td>
						<?php
								if($veb["TxnType"] == PURCHASE) {
									$narr	= 'PURCHASE';
								} else if($veb["TxnType"] == PURCHASE_RETURN) {
									$narr	= 'PUIRCHASE RETURN'; 
								} else if($veb["TxnType"] == SALE) { 
									$narr	= 'SALE';
								} else if($veb["TxnType"] == SALE_RETURN) { 
									$narr	= 'SALE RETURN';
								} else if($veb["TxnType"] == ROOM_BOOKING) { 
									$narr	= 'GUEST HOUSE BOOKING';
								} else if($veb["TxnType"] == FOOD_SALE) { 
									$narr	= 'BHOJAN PRASAD';									
								} else if($veb["TxnType"] == STOCK_TRANSFER) { 
									$narr	= 'STOCK TRANSFER';
								} else if($veb["TxnType"] == STOCK_JOURNAL) { 
									$narr	= 'STOCK JOURNAL';
								} else if($veb["TxnType"] == ISSUE) { 
									$narr	= 'ISSUE/CONSUMPTION';
								} else if($veb["TxnType"] == 62) { 
									$narr	= 'CLOAK ROOM ENTRY';
								} else if($veb["TxnType"] == 63) { 
									$narr	= 'RAM KRISHNA JHAKI';
								} else if($veb["TxnType"] == 67) { 
									$narr	= 'PRASAD SEWA';
								} else if($veb["TxnType"] == 68) { 
									$narr	= 'YATRI SEWA PRAKALP';
								} else if($veb["TxnType"] == 69) { 
									$narr	= 'DONATION';
								} else if($veb["TxnType"] == 71) { 
									$narr	= 'MANAV SEWA';
								} else if($veb["TxnType"] == 72) { 
									$narr	= 'GAU SEWA';
								} else if($veb["TxnType"] == 74) { 
									$narr	= 'GAU CHARAN LEELA';										
								} else {
									if($veb["VoucherType"] == CASH_RECEIPT_VOUCHER)
										$narr	= 'CASH RECEIPT';
									else if($veb["VoucherType"] == CASH_PAYMENT_VOUCHER)
										$narr	= 'CASH PAYMENT';
									else if($veb["VoucherType"] == CONTRA_VOUCHER)
										$narr	= 'CONTRA';
									else if($veb["VoucherType"] == BANK_RECEIPT_VOUCHER)
										$narr	= 'BANK RECEIPT';
									else if($veb["VoucherType"] == BANK_PAYMENT_VOUCHER)
										$narr	= 'BANK PAYMENT';										
								}
								echo $narr;
						?>
					</td>
					<?php
						if($veb["DrCr"] == DEBIT) {
							$totdr+=$veb["Amount"];
							if($balt == DEBIT)
								$bal+=$veb["Amount"];
							else
								$bal-=$veb["Amount"];
							if($bal < 0) {
								$bal=-$bal;
								$balt	=	DEBIT;
							}
					?>
						<td align='right'><?php echo number_format($veb["Amount"],2)?></td>
						<td align='right'>0.00</td>
					<?php
						} else {
							$totcr+=$veb["Amount"];
							if($balt == CREDIT)
								$bal+=$veb["Amount"];
							else
								$bal-=$veb["Amount"];
							if($bal < 0) {
								$bal=-$bal;
								$balt	=	CREDIT;
							}
					?>
						<td align='right'>0.00</td>
						<td align='right'><?php echo number_format($veb["Amount"],2)?></td>
					<?php } ?>
					<td align='right'><?php echo number_format($bal,2)?> <?php echo getDrCr($balt)?></td>
				</tr>
			<?php
				}
			?>

				<tr bgcolor="#FFFFFF">
					<td>&nbsp;</td>
					<td><b>CURRENT TOTAL ***</b></td>
					<td align='right'><b><?php echo number_format($totdr,2)?></b></td>
					<td align='right'><b><?php echo number_format($totcr,2)?></b></td>
					<td align='right'><b><?php echo number_format($bal,2)?> <?php echo getDrCr($balt)?></b></td>
				</tr>
			</table>
		</div>
		<div style="font-size:11px; font-weight:bold; text-align:left">
			<br>CLOSING TOTAL: <?php echo CURRENCY_WORD?> <?php echo numToWord($bal,'Paise')?>
		</div>
		
		<br />
		<div style="text-align:center"><input type="button" value="Export to Excel" onClick="ExportToExcel()" class="red_button" /></div>
		<br />		
		
	</div>
</body>
</html>

<script type="text/javascript">

	function ExportToExcel(){
		 var tbl		= document.getElementById('main_table');
		 var html 	= tbl.outerHTML;
		 window.open('data:application/vnd.ms-excel,' + encodeURIComponent(html));
	}
	
</script>