<?php

	/* Include the required files */
	require_once( '../inc/functions.php' );
	require_once( '../aom-config.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/asys.voucherdb.php' );
	require_once( '../dao/asys.drcr.php' );
	require_once( '../dao/asys.group.php' );
	require_once( '../dao/asys.voucher.php' );
	require_once( '../dao/asys.vouchertag.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userledger.php' );
	require_once( '../dao/asys.userpermission.php' );	

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 32;

	$db			=	new masterdb("REPORT");
	$vdb		=	new voucherdb("REPORT");
	$ldb		= new logindb("REPORT");
	$uaDet	= $ldb->getUserLedgerDetail($tuser->getUserID());
	$uacc			= $uaDet->getAccounts();
	$uacList	= explode(",", $uacc);	
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}		

	$maccid	= 0;
	$caccid	= 0;
	$fdate	=	"2001-01-01";
	$tdate	=	getLastFinancialDate();
	$expand	=	'no';

	extract($_REQUEST);

	if($fdate == "")
		$fdate	=	"2001-01-01";

	$maccid	=	(int)$maccid;
	$caccid	=	(int)$caccid;
	
	if($tuser->getUserStatus() < ADMIN_USER) {
		if(!in_array($caccid, $uacList)) {
			header("Location:../accessDenied.php");
			exit;			
		}
	}	

	if($maccid == 0 || $caccid == 0) {
		echo "Sorry!!! Direct Access not allowed here";
		exit;
	}
	
	$df				=	FormatIndianDateToSQLDate($fdate);
	$dt				=	FormatIndianDateToSQLDate($tdate);
	$ndt			=	getNextDate($df);	

	$maccDet	= $db->getAccountDetail($maccid);
	$accDet		= $db->getAccountDetail($caccid);
	$bal			= $accDet->getOBal();
	$balt			= $accDet->getOBalType();

	$clbal		=	$db->getClosingBalanceByAccountID($caccid, $ndt);
	
	$bal			=	$clbal[0];
	$balt			=	$clbal[1];

	$alDet		= $vdb->getAccountVoucher($caccid, FormatIndianDateToSQLDate($fdate), FormatIndianDateToSQLDate($tdate));

	$totcr		= 0;
	$totdr		= 0;
	if($balt==DEBIT)
		$totdr	=	$bal;
	else
		$totcr	= $bal;


$html	= '

<body style="background-color:#ffffff">
	<div style="font-family:verdana;width:900px;margin:0px auto;" align="center">
		<div style="text-align:center; font-size:18px; font-weight:bold; letter-spacing:1pt;">
			<br />'.$tcmp->getCompanyName().'
		</div>
		<div style="text-align:center; font-size:15px; font-weight:normal; letter-spacing:1pt;">
			'.$tcmp->getCompanyAddress().'
		</div>
		<div style="text-align:center; font-size:13px; font-weight:bold; letter-spacing:1pt;">
			<br />'.$accDet->getMotherAccountName().' >> '.$accDet->getAccountName().'
		</div>
		<div style="text-align:right; font-size:13px; font-weight:bold;">
			<br />';
			if($fdate!="2001-01-01") $html = $html.$fdate.' - '.$tdate;
		$html = $html.'
		</div>
		<div style="font-size:10px; font-weight:bold;">
			<table cellSpacing="0" cellPadding="4" width="100%" border="0">
				<tr>
					<td width="10%" bgcolor="#f4f4f4" style="border:#cccccc 1px solid">
						<font style="font-family:arial; font-size:11px">DATE</font>
					</td>';
					if($expand == "yes") {
					$html = $html.'
					<td width="14%" bgcolor="#f4f4f4" style="border:#cccccc 1px solid">
						<font style="font-family:arial; font-size:11px">DOC NO</font>
					</td>';
					}
					$html = $html.'
					<td width="35%" bgcolor="#f4f4f4" style="border:#cccccc 1px solid">
						<font style="font-family:arial; font-size:11px">PARTICULARS</font>
					</td>
					<td width="12%" align="right" bgcolor="#f4f4f4" style="border:#cccccc 1px solid">
						<font style="font-family:arial; font-size:11px">DEBIT</font>
					</td>
					<td width="12%" align="right" bgcolor="#f4f4f4" style="border:#cccccc 1px solid">
						<font style="font-family:arial; font-size:11px">CREDIT</font>
					</td>
					<td width="15%" align="right" bgcolor="#f4f4f4" style="border:#cccccc 1px solid">
						<font style="font-family:arial; font-size:11px">BALANCE</font>
					</td>
				</tr>
			</table>
		</div>
		<div style="font-size:10px;">
			<table cellSpacing="0" cellPadding="2" width="100%">
				<tr>
					<td width="10%" bgcolor="#ffffff">
						&nbsp;
					</td>';
					if($expand=='yes'){
					$html = $html.'
					<td width="14%" bgcolor="#ffffff">
						&nbsp;
					</td>';
					}
					$html = $html.'
					<td width="35%" bgcolor="#ffffff">
						<font style="font-family:arial; font-size:10px"><b>By Opening Balance</b></font>
					</td>';
					
						if($balt == DEBIT) {
					$html = $html.'
						<td width="12%" align="right" bgcolor="#ffffff">
							<font style="font-family:arial; font-size:10px"><b>'. number_format($bal,2).'</b></font>
						</td>
						<td width="12%" align="right" bgcolor="#ffffff">
							<font style="font-family:arial; font-size:10px"><b>0.00</b></font>
						</td>';
					} else {
					$html = $html.'
						<td width="12%" align="right" bgcolor="#ffffff">
							<font style="font-family:arial; font-size:10px"><b>0.00</b></font>
						</td>
						<td width="12%" align="right" bgcolor="#ffffff">
							<font style="font-family:arial; font-size:10px"><b>'.number_format($bal,2).'</b></font>
						</td>';
					}
					$html = $html.'
					<td width="15%" align="right" bgcolor="#ffffff">
						<font style="font-family:arial; font-size:10px"><b>'.number_format($bal,2).' '.getDrCr($balt).'</b></font>
					</td>
				</tr>';
			
				for($i=0;$i<count($alDet);$i++) {
					$veb	=	$alDet[$i];
					$rcls	=	"td_normal_green";
					/*if($veb->getIsHidden() == 'YES')
						$rcls	=	"td_normal_red";*/

					if($expand == 'no')
						continue;
					if($expand == 'yes'){
						$vt		=	$veb->getVoucherType();
						$fy		=	$veb->getFinYear();
						$vid	=	$veb->getVoucherID();
						$olist=	$vdb->getOppositeVoucher($vid, $caccid);
					}
			$html = $html.'
				<tr class="td_normal">
					<td width="10%" valign="top">
						<font style="font-family:arial; font-size:10px">'.$veb->getDOV('yes').'</font>
					</td>';
					if($expand=='yes'){ 
					$html = $html.'
					<td width="14%" valign="top">
						<font style="font-family:arial; font-size:10px">&nbsp;'.getShortVoucherType($veb->getVoucherType()).'/'.FormatSQLDateToVoucherPrintFormat($veb->getDOV()).'/'.$veb->getDayWiseNo().'</font>
					</td>';
					}
				$html = $html.'
					<td width="35%" valign="top">
						<font style="font-family:arial; font-size:10px">'.$veb->getNarration().'</font>
					</td>';
				
						if($veb->getDrCr() == DEBIT) {
							$totdr+=$veb->getAmount();
							if($balt == DEBIT)
								$bal+=$veb->getAmount();
							else
								$bal-=$veb->getAmount();
							if($bal < 0) {
								$bal=-$bal;
								$balt	=	DEBIT;
							}
					$html = $html.'
						<td width="12%" align="right" valign="top">
							<font style="font-family:arial; font-size:10px">'.number_format($veb->getAmount(),2).'</font>
						</td>
						<td width="12%" align="right" valign="top">
							<font style="font-family:arial; font-size:10px">0.00</font>
						</td>';

						} else {
							$totcr+=$veb->getAmount();
							if($balt == CREDIT)
								$bal+=$veb->getAmount();
							else
								$bal-=$veb->getAmount();
							if($bal < 0) {
								$bal=-$bal;
								$balt	=	CREDIT;
							}
					$html = $html.'
						<td width="12%" align="right" valign="top">
							<font style="font-family:arial; font-size:10px">0.00</font>
						</td>
						<td width="12%" align="right" valign="top">
							<font style="font-family:arial; font-size:10px">'.number_format($veb->getAmount(),2).'</font>
						</td>';
					}
					$html = $html.'
					<td width="15%" align="right" valign="top">
						<font style="font-family:arial; font-size:10px">'.number_format($bal,2).' '.getDrCr($balt).'</font>
					</td>
				</tr>';
			
					if($expand=='yes') {
						for($j=0;$j<count($olist);$j++) {
							$ovch	=	$olist[$j];
							$tmp	=	"#f4f4f4";
							if($j%2==0)
								$tmp	=	"#e4e4e4";
			$html = $html.'
							<tr>
								<td>&nbsp;</td>
								<td>&nbsp;</td>
								<td>
									<font style="font-family:verdana; font-size:10px">'.$ovch->getAccountName('yes').' - '. $ovch->getAmount('yes').' ('.getDrCr($ovch->getDrCr()).')</font>
								</td>
								<td>&nbsp;</td>
								<td>&nbsp;</td>
								<td>&nbsp;</td>
							</tr>';

						}
					}
				}

	$html = $html.'
			</table>
		</div>
		<div style="font-size:10px; font-weight:bold;">
			<table cellSpacing="0" cellPadding="4" width="100%" border="0">
				<tr>
					<td width="10%" style="border:#cccccc 1px solid">
						<font style="font-family:arial; font-size:10px">&nbsp;</font>
					</td>';
					if($expand == 'yes'){ 
					$html = $html.'
					<td width="14%" style="border:#cccccc 1px solid">
						<font style="font-family:arial; font-size:10px">&nbsp;</font>
					</td>';
					}
					$html = $html.'
					<td width="35%" style="border:#cccccc 1px solid">
						<font style="font-family:arial; font-size:10px"><b>CURRENT TOTAL ***</b></font>
					</td>
					<td width="12%" align="right" style="border:#cccccc 1px solid">
						<font style="font-family:arial; font-size:10px"><b>'.number_format($totdr,2).'</b></font>
					</td>
					<td width="12%" align="right" style="border:#cccccc 1px solid">
						<font style="font-family:arial; font-size:10px"><b>'. number_format($totcr,2).'</b></font>
					</td>
					<td width="15%" align="right" style="border:#cccccc 1px solid">
						<font style="font-family:arial; font-size:10px"><b>'.number_format($bal,2).' '.getDrCr($balt).'</b></font>
					</td>
				</tr>
			</table>
		</div>';
		if($expand == 'yes'){
		$html = $html.'
		<div style="font-size:11px; font-weight:bold; text-align:left">
			<br>CLOSING TOTAL: '.CURRENCY_WORD.' '.numToWord($bal,'Paise').'
		</div>';
		} 
	$html = $html.'
	</div>
</body>';



header('Content-type: application/excel');
$filename = 'rptSubLedgerLedgerExcel.xls';
header('Content-Disposition: attachment; filename='.$filename);

$data = '<html xmlns:x="urn:schemas-microsoft-com:office:excel">
<head>
    <!--[if gte mso 9]>
    <xml>
        <x:ExcelWorkbook>
            <x:ExcelWorksheets>
                <x:ExcelWorksheet>
                    <x:Name>Sheet 1</x:Name>
                    <x:WorksheetOptions>
                        <x:Print>
                            <x:ValidPrinterInfo/>
                        </x:Print>
                    </x:WorksheetOptions>
                </x:ExcelWorksheet>
            </x:ExcelWorksheets>
        </x:ExcelWorkbook>
    </xml>
    <![endif]-->
</head>

'.$html.'</html>';

echo $data;	exit;

?>