<?php

	/* Include the required files */
	require_once( '../inc/functions.php' );
	require_once( '../aom-config.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/asys.voucherdb.php' );
	require_once( '../dao/asys.drcr.php' );
	require_once( '../dao/asys.group.php' );
	require_once( '../dao/asys.voucher.php' );
	require_once( '../dao/asys.vouchertag.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userledger.php' );
	require_once( '../dao/asys.userpermission.php' );		

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 32;

	$db			=	new masterdb("REPORT");
	$vdb		=	new voucherdb("REPORT");
	$ldb		= new logindb("REPORT");
	$uaDet	= $ldb->getUserLedgerDetail($tuser->getUserID());
	$uacc			= $uaDet->getAccounts();
	$uacList	= explode(",", $uacc);
	$mntArr		= array("", "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}		

	$accid		= 0;
	$fdate		=	getFirstFinancialDate();
	$tdate		=	getLastFinancialDate();

	extract($_REQUEST);
	
	$df				=	FormatIndianDateToSQLDate($fdate);
	$yr				= substr($df, 0, 4);
	$ndt			=	$yr."-04-01";	

	$accid		=	(int)$accid;
	
	if($tuser->getUserStatus() < ADMIN_USER) {
		if(!in_array($accid, $uacList)) {
			header("Location:../accessDenied.php");
			exit;			
		}
	}	

	if($accid == 0) {
		echo "Sorry!!! Direct Access not allowed here";
		exit;
	}

	$accDet		= $db->getAccountDetail($accid);
	$bal			= $accDet->getOBal();
	$balt			= $accDet->getOBalType();

	$clbal		=	$db->getClosingBalanceByAccountID($accid, $ndt);
	$bal			=	$clbal[0];
	$balt			=	$clbal[1];
	
	$totcr		= 0;
	$totdr		= 0;
	if($balt == DEBIT)
		$totdr	=	$bal;
	else
		$totcr	= $bal;	

?>


<!DOCTYPE html>
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html;charset=utf-8"/>
		<title>Monthly Ledger of <?php echo $accDet->getAccountName()?></title>
		<link href="../css/rpt.css" type="text/css" rel="stylesheet">
		<script src="../js/common.js"></script>
	</head>
<body style="background-color:#ffffff">
	<div style="font-family:verdana;margin:0px auto;width:900px;">

		<div style="font-size:12px;">
			<table cellSpacing='1' cellPadding='4' width='100%' bgcolor="#CCCCCC" id="main_table">
				
				<tr bgcolor="#FFFFFF">
					<td colspan="4" align="center">
						<div style="font-size:18px; letter-spacing:1pt;">
							<b><?php echo $tcmp->getCompanyName()?><br /></b>
						</div>
						<div style="font-size:15px; letter-spacing:1pt;">
							<?php echo nl2br($tcmp->getCompanyAddress())?>
						</div>
						<div style="font-size:15px; letter-spacing:1pt;">
							<b><br /><?php echo $accDet->getMotherAccountName()?> >> <?php echo $accDet->getAccountName()?></b>
						</div>
						<div style="font-size:13px;">
							Sub Ledger Monthly Summary from <?php echo $fdate?> to <?php echo $tdate?>
						</div>
					</td>
				</tr>
				
				<tr bgcolor="#F4F4F4">
					<td width='49%'>PARTICULARS</td>
					<td width='17%' align='right'>DEBIT</td>
					<td width='17%' align='right'>CREDIT</td>
					<td width='17%' align='right'>BALANCE</td>
				</tr>

				<tr bgcolor="#FFFFFF">
					<td><b>By Opening Balance</b></td>
					<?php
						if($balt == DEBIT) {
					?>
						<td align='right'><b><?php echo number_format($bal,2)?></b></td>
						<td align='right'><b>0.00</b></td>
					<?php } else {
					?>
						<td align='right'><b>0.00</b></td>
						<td align='right'><b><?php echo number_format($bal,2)?></b></td>
					<?php } ?>
					<td align='right'><b><?php echo number_format($bal,2)?> <?php echo getDrCr($balt)?></b></td>
				</tr>
			<?php
				for($i=4;$i<13;$i++) {
					$mn		= $i;
					if($i < 10) $mn = "0".$i;
					$df		= $yr."-".$mn."-01";
					$dt		= $yr."-".$mn."-".cal_days_in_month(CAL_GREGORIAN, $i, $yr);
					$dr		= $db->getTotalDebitAmountByAccountID($accid, $df, $dt);
					$cr		= $db->getTotalCreditAmountByAccountID($accid, $df, $dt);
					
					$totdr+= $dr;
					$totcr+= $cr;
					
					if($balt == DEBIT) {
						$bal = $bal + $dr - $cr;
						if($bal < 0) {
							$bal=-$bal;
							$balt	=	CREDIT;
						}
					} else {
						$bal = $bal - $dr + $cr;
						if($bal < 0) {
							$bal=-$bal;
							$balt	=	DEBIT;
						}						
					}
			?>
				<tr bgcolor="#FFFFFF">
					<td>
						<a href="rptSubLedgerCon.php?accid=<?php echo $accid?>&fdate=<?php echo FormatSQLDateToIndianDate($df)?>&tdate=<?php echo FormatSQLDateToIndianDate($dt)?>" target="_blank">Month Total of <b><?php echo $mntArr[$i] ?> <?php echo $yr?></b></a>
					</td>
						<td align='right'><?php echo number_format($dr,2)?></td>
						<td align='right'><?php echo number_format($cr,2)?></td>
					<td align='right'><?php echo number_format($bal,2)?> <?php echo getDrCr($balt)?></td>
				</tr>
			<?php
				}
			?>
			
			<?php
				$yr++;
				for($i=1;$i<4;$i++) {
					$mn		= $i;
					if($i < 10) $mn = "0".$i;
					$df		= $yr."-".$mn."-01";
					$dt		= $yr."-".$mn."-".cal_days_in_month(CAL_GREGORIAN, $i, $yr);
					$dr		= $db->getTotalDebitAmountByAccountID($accid, $df, $dt);
					$cr		= $db->getTotalCreditAmountByAccountID($accid, $df, $dt);
					
					$totdr+= $dr;
					$totcr+= $cr;
					
					if($balt == DEBIT) {
						$bal = $bal + $dr - $cr;
						if($bal < 0) {
							$bal=-$bal;
							$balt	=	CREDIT;
						}
					} else {
						$bal = $bal - $dr + $cr;
						if($bal < 0) {
							$bal=-$bal;
							$balt	=	DEBIT;
						}						
					}
			?>
				<tr bgcolor="#FFFFFF">
					<td>
						<a href="rptSubLedgerCon.php?accid=<?php echo $accid?>&fdate=<?php echo FormatSQLDateToIndianDate($df)?>&tdate=<?php echo FormatSQLDateToIndianDate($dt)?>" target="_blank">Month Total of <b><?php echo $mntArr[$i] ?> <?php echo $yr?></b></a>
					</td>
						<td align='right'><?php echo number_format($dr,2)?></td>
						<td align='right'><?php echo number_format($cr,2)?></td>
					<td align='right'><?php echo number_format($bal,2)?> <?php echo getDrCr($balt)?></td>
				</tr>
			<?php
				}
			?>			

				<tr bgcolor="#FFFFFF">
					<td><b>CURRENT TOTAL ***</b></td>
					<td align='right'><b><?php echo number_format($totdr, 2)?></b></td>
					<td align='right'><b><?php echo number_format($totcr, 2)?></b></td>
					<td align='right'><b><?php echo number_format($bal, 2)?> <?php echo getDrCr($balt)?></b></td>
				</tr>
			</table>
		</div>
		<div style="font-size:11px; font-weight:bold; text-align:left">
			<br>CLOSING TOTAL: <?php echo CURRENCY_WORD?> <?php echo numToWord($bal, 'Paise')?>
		</div>
		
		<br />
		<div style="text-align:center"><input type="button" value="Export to Excel" onClick="ExportToExcel()" class="red_button" /></div>
		<br />		
		
	</div>
</body>
</html>

<script type="text/javascript">

	function ExportToExcel(){
		 var tbl		= document.getElementById('main_table');
		 var html 	= tbl.outerHTML;
		 window.open('data:application/vnd.ms-excel,' + encodeURIComponent(html));
	}
	
</script>