<?php

	/* Include the required files */
	require_once( '../inc/functions.php' );
	require_once( '../aom-config.php' );
	require_once( '../dao/asys.user.php' );
	require_once( '../dao/asys.company.php' );
	require_once( '../dao/asys.masterdb.php' );
	require_once( '../dao/asys.voucherdb.php' );
	require_once( '../dao/asys.drcr.php' );
	require_once( '../dao/asys.group.php' );
	require_once( '../dao/asys.basegroup.php' );
	require_once( '../dao/asys.basesubgroup.php' );
	require_once( '../dao/asys.voucher.php' );
	require_once( '../dao/asys.account.php' );
	require_once( '../dao/asys.logindb.php' );
	require_once( '../dao/asys.userpermission.php' );	

	$tuser		=	new asys_users();
	$tcmp			= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}	
	
	$ModuleID			= 40;

	$db				=	new masterdb("REPORT");
	$vdb			=	new voucherdb("REPORT");
	$ldb			= new logindb("REPORT");
	
	$vdb->updateGroupSubgroup();
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:../accessDenied.php");
		exit;
	}		

	$fdate		=	getFirstFinancialDate();
	$tdate		=	getLastFinancialDate();
	$chk2			= "";

	extract($_REQUEST);

	$df				=	FormatIndianDateToSQLDate($fdate);
	$dt				=	FormatIndianDateToSQLDate($tdate);
	$chk2			= addslashes($chk2);

	if($df == '1900-01-01' || $dt == '1900-01-01'){
		echo 'Invalid input Date format, try again';
		exit;
	}

	$cmpid		= $tcmp->getCompanyID();
	$ndt			=	getNextDate($dt);

	$accList	=	$db->getShortMotherAccountList2($tcmp->getCompanyID());

?>


<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
		<title>Trial Balance With Opening + During the Period Group Wise</title>
		<link href="../css/rpt.css" type="text/css" rel="stylesheet" />
	</head>
<body style="background-color:#ffffff">
	<div style="font-family:verdana;margin:0px auto;width:900px;" align="center">

		<div style="font-size:12px;font-family:arial;">
			<table cellSpacing='1' cellPadding='4' width='100%' border='0' bgcolor="#CCCCCC" id="main_table">
			
				<tr bgcolor="#FFFFFF">
					<td colspan="7" align="center">
						<div style="font-size:18px; letter-spacing:1pt;">
							<b><?php echo $tcmp->getCompanyName()?><br /></b>
						</div>
						<div style="font-size:15px; letter-spacing:1pt;">
							<?php echo nl2br($tcmp->getCompanyAddress())?>
						</div>
						<div style="font-size:13px;">
							Trial Balance from <?php echo $fdate?> to <?php echo $tdate?>
						</div>
					</td>
				</tr>
			
				<tr bgcolor="#F4F4F4">
					<td width='40%' rowspan="2"><b>PARTICULARS</b></td>
					<td width='20%' colspan="2" align='center'><b>OPENING</b></td>
					<td width='20%' colspan="2" align='center'><b>DURING THE PERIOD</b></td>
					<td width='20%' colspan="2" align='center'><b>CLOSING</b></td>
				</tr>
				<tr bgcolor="#F4F4F4">
					<td width='10%' align='right'><b>DEBIT</b></td>
					<td width='10%' align='right'><b>CREDIT</b></td>
					<td width='10%' align='right'><b>DEBIT</b></td>
					<td width='10%' align='right'><b>CREDIT</b></td>
					<td width='10%' align='right'><b>DEBIT</b></td>
					<td width='10%' align='right'><b>CREDIT</b></td>										
				</tr>

<?php
	$ototdr		=	0;
	$ototcr		=	0;
	$dtotdr		=	0;
	$dtotcr		=	0;
	$ctotdr		=	0;
	$ctotcr		=	0;
	
	$pbgid		= 0;
	$psgid		= 0;
	$padleft	= 15;
	for($i=0;$i<count($accList);$i++) {
		$acc		=	$accList[$i];
		
		if($pbgid == 0 || $pbgid != $acc->getBGID()) {
			$pbgid 	= $acc->getBGID();
			
			$ogTot	= $db->getClosingBalanceByBGID($cmpid, $pbgid, getNextDate($df));
			$ogamt	=	number_format($ogTot[0], 2, '.', '');
			$ogtype	=	$ogTot[1];
			
			$gdramt	= $db->getTotalDebitAmountByBGID($cmpid, $pbgid, $df, $dt);
			$gcramt	= $db->getTotalCreditAmountByBGID($cmpid, $pbgid, $df, $dt);
			
			$cgTot	= $db->getClosingBalanceByBGID($cmpid, $pbgid, $ndt, 'YES');
			$cgamt	=	number_format($cgTot[0], 2, '.', '');
			$cgtype	=	$cgTot[1];
			
			$bgdet	= $db->getBaseGroupDetail($pbgid);

?>

				<tr bgcolor="#FFFF66">
					<td class="td_normal_large"><b><?php echo $bgdet->getGroupName() ?></b></td>
									
<?php
				if($ogtype == DEBIT) {
?>
						<td align="right"><?php echo number_format($ogamt, 2, '.', '') ?></td>
						<td align="right">&nbsp;</td>
<?php
				} else {
?>
						<td align="right">&nbsp;</td>
						<td align="right"><?php echo number_format($ogamt, 2, '.', '') ?></td>
<?php
				}
?>

						<td align="right"><?php echo number_format($gdramt, 2, '.', '') ?></td>
						<td align="right"><?php echo number_format($gcramt, 2, '.', '') ?></td>

<?php
				if($cgtype == DEBIT) {
?>
						<td align="right"><?php echo number_format($cgamt, 2, '.', '') ?></td>
						<td align="right">&nbsp;</td>
<?php
				} else {
?>
						<td align="right">&nbsp;</td>
						<td align="right"><?php echo number_format($cgamt, 2, '.', '') ?></td>
<?php
				}
?>

				</tr>


<?php				
				}
			

		
		if($acc->getSubgroupID() != 0) {
			if($psgid == 0 || $psgid != $acc->getSubgroupID()) {
				$psgid 	= $acc->getSubgroupID();
				
				$ogTot	= $db->getClosingBalanceBySubgroupID($cmpid, $pbgid, $psgid, getNextDate($df));
				$ogamt	=	number_format($ogTot[0], 2, '.', '');
				$ogtype	=	$ogTot[1];
			
				$gdramt	= $db->getTotalDebitAmountBySubgroupID($cmpid, $pbgid, $psgid, $df, $dt);
				$gcramt	= $db->getTotalCreditAmountBySubgroupID($cmpid, $pbgid, $psgid, $df, $dt);				
				
				$cgTot		= $db->getClosingBalanceBySubgroupID($cmpid, $pbgid, $psgid, $ndt, 'YES');
				$cgamt	=	number_format($cgTot[0], 2, '.', '');
				$cgtype	=	$cgTot[1];
							
				$padleft	= 15;
				

				$sgdet	= $db->getSubgroupDetail($psgid);

	?>
					<tr bgcolor="#FFFFC0">
						<td class="td_normal" style="padding-left:<?php echo $padleft?>px;"><b><?php echo $sgdet->getSubgroupName() ?></b></td>
					
<?php
				if($ogtype == DEBIT) {
?>
						<td align="right"><?php echo number_format($ogamt, 2, '.', '') ?></td>
						<td align="right">&nbsp;</td>
<?php
				} else {
?>
						<td align="right">&nbsp;</td>
						<td align="right"><?php echo number_format($ogamt, 2, '.', '') ?></td>
<?php
				}
?>

						<td align="right"><?php echo number_format($gdramt, 2, '.', '') ?></td>
						<td align="right"><?php echo number_format($gcramt, 2, '.', '') ?></td>

<?php
				if($cgtype == DEBIT) {
?>
						<td align="right"><?php echo number_format($cgamt, 2, '.', '') ?></td>
						<td align="right">&nbsp;</td>
<?php
				} else {
?>
						<td align="right">&nbsp;</td>
						<td align="right"><?php echo number_format($cgamt, 2, '.', '') ?></td>
<?php
				}
?>

				</tr>

	<?php				

					$padleft	= 30;

			}
		} else {
			$padleft = 15;
		}
		
		
		
		if($acc->getContainsSubLedger() == "NO") {
			
			$olbal	=	$db->getClosingBalanceByAccountID($acc->getAccountID(), getNextDate($df));
			$oamt		=	number_format($olbal[0], 2, '.', '');
			$otype	=	$olbal[1];
			
			$dramt	= (double)$db->getTotalDebitAmountByAccountID($acc->getAccountID(), $df, $dt);
			$cramt	= (double)$db->getTotalCreditAmountByAccountID($acc->getAccountID(), $df, $dt);
			
			$dtotdr	= $dtotdr + $dramt;
			$dtotcr	= $dtotcr + $cramt;
		
			$clbal	=	$db->getClosingBalanceByAccountID($acc->getAccountID(), $ndt, 'YES');
			$camt		=	number_format($clbal[0], 2, '.', '');
			$ctype	=	$clbal[1];
			
			if((double)$oamt == 0 && (double)$dramt == 0 && (double)$cramt == 0 && (double)$camt == 0 && $chk2 == "NO") continue;			

?>						

				<tr bgcolor="#FFFFFF">
					<td style="padding-left:<?php echo $padleft?>px;">
						<a href="rptMainLedger.php?accid=<?php echo $acc->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Ledger" target="_blank"><?php echo $acc->getPrnName() ?></a>
					</td>

<?php
				if($otype == DEBIT) {
						$ototdr+=$oamt;
?>
						<td align="right"><?php echo number_format($oamt, 2, '.', '') ?></td>
						<td align="right">&nbsp;</td>
<?php
				} else {
						$ototcr+=$oamt;
?>
						<td align="right">&nbsp;</td>
						<td align="right"><?php echo number_format($oamt, 2, '.', '') ?></td>
<?php
				}
?>

						<td align="right"><?php echo number_format($dramt, 2, '.', '') ?></td>
						<td align="right"><?php echo number_format($cramt, 2, '.', '') ?></td>

<?php
				if($ctype == DEBIT) {
						$ctotdr+=$camt;
?>
						<td align="right"><?php echo number_format($camt, 2, '.', '') ?></td>
						<td align="right">&nbsp;</td>
<?php
				} else {
						$ctotcr+=$camt;
?>
						<td align="right">&nbsp;</td>
						<td align="right"><?php echo number_format($camt, 2, '.', '') ?></td>
<?php
				}
?>

			</tr>

<?php

		} else {
		
			$olbal	=	$db->getClosingBalanceByMotherAccount($tcmp->getCompanyID(), $acc->getAccountID(), getNextDate($df));
			$oamt		=	number_format($olbal[0], 2, '.', '');
			$otype	=	$olbal[1];
			
			$dramt	= (double)$db->getTotalDebitAmountByMotherAccountID($acc->getAccountID(), $df, $dt);
			$cramt	= (double)$db->getTotalCreditAmountByMotherAccountID($acc->getAccountID(), $df, $dt);
			
			$dtotdr	= $dtotdr + $dramt;
			$dtotcr	= $dtotcr + $cramt;			
		
			$clbal		= $db->getClosingBalanceByMotherAccount($tcmp->getCompanyID(), $acc->getAccountID(), $ndt, 'YES');
			$camt		=	number_format($clbal[0], 2, '.', '');
			$ctype	=	$clbal[1];
			
			if((double)$oamt == 0 && (double)$dramt == 0 && (double)$cramt == 0 && (double)$camt == 0 && $chk2 == "NO") continue;		
		
?>
					<tr bgcolor="#FFFFFF">
						<td valign="top" style="padding-left:<?php echo $padleft?>px;">
							<?php echo $acc->getPrnName() ?> (<a href="rptSubTrial.php?accid=<?php echo $acc->getAccountID() ?>&fdate=<?php echo $fdate ?>&tdate=<?php echo $tdate ?>" title="Click to view Sub Trial" target="_blank">+</a>)
						</td>

<?php
				if($otype == DEBIT) {
						$ototdr+=$oamt;
?>
						<td align="right"><?php echo number_format($oamt, 2, '.', '') ?></td>
						<td align="right">&nbsp;</td>
<?php
				} else {
						$ototcr+=$oamt;
?>
						<td align="right">&nbsp;</td>
						<td align="right"><?php echo number_format($oamt, 2, '.', '') ?></td>
<?php
				}
?>

						<td align="right"><?php echo number_format($dramt, 2, '.', '') ?></td>
						<td align="right"><?php echo number_format($cramt, 2, '.', '') ?></td>

<?php
				if($ctype == DEBIT) {
						$ctotdr+=$camt;
?>
						<td align="right"><?php echo number_format($camt, 2, '.', '') ?></td>
						<td align="right">&nbsp;</td>
<?php
				} else {
						$ctotcr+=$camt;
?>
						<td align="right">&nbsp;</td>
						<td align="right"><?php echo number_format($camt, 2, '.', '') ?></td>
<?php
				}
?>

				</tr>

<?php
		}
	}
?>

				<tr bgcolor="#F4F4F4">
					<td class="td_normal_large" width='40%'><b>CURRENT TOTAL ***</b></td>
					<td class="td_normal_large" width='10%' align='right'><b><?php echo number_format($ototdr, 2,  '.', '')?></b></td>
					<td class="td_normal_large" width='10%' align='right'><b><?php echo number_format($ototcr, 2, '.', '')?></b></td>
					<td class="td_normal_large" width='10%' align='right'><b><?php echo number_format($dtotdr, 2,  '.', '')?></b></td>
					<td class="td_normal_large" width='10%' align='right'><b><?php echo number_format($dtotcr, 2, '.', '')?></b></td>
					<td class="td_normal_large" width='10%' align='right'><b><?php echo number_format($ctotdr, 2,  '.', '')?></b></td>
					<td class="td_normal_large" width='10%' align='right'><b><?php echo number_format($ctotcr, 2, '.', '')?></b></td>										
				</tr>

		<?php
			if($ctotdr - $ctotcr > 0) {
		?>

				<tr bgcolor="#F4F4F4">
					<td class="td_normal_large" width='80%' colspan="5"><b>CLOSING/DIFFERENCE ***</b></td>
					<td class="td_normal_large" width='10%' align='right'><b><?php echo number_format($ctotdr-$ctotcr,2,'.','')?></b></td>
					<td class="td_normal_large" width='10%' align='right'><b>&nbsp;</b></td>
				</tr>

		<?php
			} else if($ctotdr-$ctotcr < 0) {
		?>

				<tr bgcolor="#F4F4F4">
					<td class="td_normal_large" width='80%' colspan="5"><b>CLOSING/DIFFERENCE ***</b></td>
					<td class="td_normal_large" width='10%' align='right'><b>&nbsp;</b></td>
					<td class="td_normal_large" width='10%' align='right'><b><?php echo number_format($ctotcr-$ctotdr,2,'.','')?></b></td>
				</tr>

		<?php } ?>
	
			</table>
		</div>		
		
	</div>
	
	<br />
	<div style="text-align:center"><input type="button" value="Export to Excel" onClick="ExportToExcel()" class="red_button" /></div>
	<br />
	
</body>
</html>

<script type="text/javascript">

	function ExportToExcel(){
		 var tbl		= document.getElementById('main_table');
		 var html 	= tbl.outerHTML;
		 window.open('data:application/vnd.ms-excel,' + encodeURIComponent(html));
	}
	
</script>