<?php

	ini_set('max_execution_time', 30000);

	/* Include the required files */
	require_once( 'checkLogin.php' );
	require_once( 'dao/asys.account.php' );
	require_once( 'dao/asys.store.php' );
	require_once( 'dao/asys.voucher.php' );
	require_once( 'dao/asys.stockvoucher.php' );
	require_once( 'dao/class.gen_items.php' );
	require_once( 'dao/class.gen_sale.php' );
	require_once( 'dao/class.gen_sale_items.php' );
	require_once( 'dao/class.gen_sale_addless.php' );	
	require_once( 'dao/class.gen_purchase.php' );
	require_once( 'dao/class.gen_purchase_items.php' );
	require_once( 'dao/class.gen_purchase_addless.php' );	
	require_once( 'dao/class.gen_stockjournal.php' );
	require_once( 'dao/class.gen_stockjournal_in.php' );
	require_once( 'dao/class.gen_stockjournal_out.php' );
	require_once( 'dao/class.gen_stocktransfer.php' );
	require_once( 'dao/class.gen_stocktransfer_items.php' );
	require_once( 'dao/class.gen_issue.php' );
	require_once( 'dao/class.gen_issue_items.php' );
	require_once( 'dao/class.gen_transferissue.php' );
	require_once( 'dao/class.gen_transferissue_items.php' );
	require_once( 'dao/class.purchasedb.php' );
	require_once( 'dao/class.saledb.php' );
	
	$gdb		=	new genericdb();
	$mdb		=	new masterdb();
	$ldb		= new logindb();
	$pdb		= new purchasedb();
	$sdb		= new saledb();
	
	if($ldb->getEditPermission($tuser->getUserID(), 30, 0) != "YES") {
		header("Location:accessDenied.php");
		exit;
	}	
	
	
	$df			= "2015-04-01";
	$dt			= "2015-04-30";
	$cmpid	= $tcmp->getCompanyID();
	
	$fdate	= "";
	$tdate	= "";
	$sid		= 0;
	$typ		= "";
	
	extract($_REQUEST);
	
	$df			= FormatIndianDateToSQLDate($fdate);
	$dt			= FormatIndianDateToSQLDate($tdate);
	$sid		= (int)$sid;
	$typ		= addslashes($typ);
	
	if($df == "1900-01-01" || $dt == "1900-01-01") {
		echo 'Invalid input parameters (dates)';
		exit;
	}
	
	$nod		= count_days($df, $dt);
	
	//if($nod <= 5) {
	
		while(true) {
		
			if($typ == "Purchase") {
				$sql	= "SELECT * FROM `gen_purchase` WHERE `PurchaseDate`='$df' AND `CompanyID`='$cmpid' ORDER BY `PurchaseID`";
				$list1	= $pdb->getPurchaseListBySQL($sql);

				for($i=0;$i<count($list1);$i++) {
					$icls	=	$list1[$i];
					$pdb->UpdatePurchase($icls);
				}
			} else if($typ == "Transfer") {
				$sql	= "SELECT * FROM `gen_stocktransfer` WHERE `DOT`='$df' AND `CompanyID`='$cmpid' ORDER BY `StockTransferID`";
				$list1	= $pdb->getStockTransferListBySQL($sql);
				
				for($i=0;$i<count($list1);$i++) {
					$icls	=	$list1[$i];
					$pdb->UpdateStockTransferForRecalculation($icls);
				}
			} else if($typ == "Issue") {
				$sql	= "SELECT * FROM `gen_issue` WHERE `IssueDate`='$df' AND `CompanyID`='$cmpid' AND `StoreID`='$sid' ORDER BY `IssueID`";
				$list3	= $pdb->getIssueListBySQL($sql);

				for($i=0;$i<count($list3);$i++) {
					$icls	=	$list3[$i];
					$pdb->UpdateIssueForRecalculation($icls);
				}
			} else if($typ == "Journal") {
				$sql	= "SELECT * FROM `gen_stockjournal` WHERE `DOT`='$df' AND `CompanyID`='$cmpid' AND `StoreID`='$sid' ORDER BY `StockJournalID`";
				$list4	= $pdb->getStockJournalListBySQL($sql);
				
				for($i=0;$i<count($list4);$i++) {
					$icls	=	$list4[$i];
					$pdb->UpdateStockJournal($icls);
				}
			} else if($typ == "Sale") {
				$sql	= "SELECT * FROM `gen_sale` WHERE `DOS`='$df' AND `CompanyID`='$cmpid' AND `StoreID`='$sid' ORDER BY `SaleID`";
				$list5	= $sdb->getSaleListBySQL($sql);
				
				for($i=0;$i<count($list5);$i++) {
					$icls	=	$list5[$i];
					$sdb->UpdateSale($icls);
				}
			} else if($typ == "Manual") {
				$sql	= "SELECT * FROM `asys_stock_voucher` WHERE `DOT`='$df' AND `CompanyID`='$cmpid' AND `StoreID`='$sid' AND `RelatedID`='0' ORDER BY `StockInOut` DESC";
				$list6	= $pdb->getStockVoucherBySQL($sql);
				
				for($i=0;$i<count($list6);$i++) {
					$icls	=	$list6[$i];
					if($icls->getStockInOut() == STOCK_IN)
						$pdb->UpdateManualStockIN($icls);
					else
						$pdb->UpdateManualStockOUT($icls);
				}			
			}
		
			$df		= getNextDate($df);
			if($df > $dt) break;
		}
		
		echo 'Entries updated.';
		exit;
	//} else {	
	
		/* Ready to create the page */
		$iPage	=	new asys_pages(APP_TITLE);
		/* Start writting the page */
		$iPage->startPage();
		$iPage->startHeader();
		/* Add links and Scripts as required */
		$iPage->addLink("css/asys.css");
		$iPage->addLink("css/menu.css");
		$iPage->addScript("js/common.js");

		$iPage->endHeader();
		$iPage->startBody();
	
		?>
	
		<table border="0" width="800" cellspacing="1" cellpadding="2" align="center" bgcolor="#CCCCCC">
			<tr bgcolor="#E4E4E4">
				<td class="td_normal_large">Date</td>
				<td class="td_normal_large">Type</td>
				<td class="td_normal_large" align="center">Transaction No.</td>
				<td class="td_normal_large" align="center">Re-generate</td>
			</tr>
	
		<?php
	
		while(true) {
			$sql	= "SELECT * FROM `gen_stocktransfer` WHERE `DOT`='$df' AND `CompanyID`='$cmpid'";
			$list	= $pdb->getStockTransferListBySQL($sql);
			for($i=0;$i<count($list);$i++) {
				$icls	=	$list[$i];
				?>
					<tr bgcolor="#FFFFFF">
						<td class="td_normal"><?php echo $icls->getDOT('yes')?></td>
						<td class="td_normal">Stock Transfer</td>
						<td class="td_normal" align="center"><?php echo $icls->getStockTransferID()?></td>
						<td class="td_normal" align="center"><a href="updateStockTransaction.php?type=TRANSFER&sid=<?php echo $icls->getStockTransferID()?>" target="_blank">Update</a></td>
					</tr>			
				<?php
			}

			$sql	= "SELECT * FROM `gen_issue` WHERE `IssueDate`='$df' AND `CompanyID`='$cmpid'";
			$list	= $pdb->getIssueListBySQL($sql);
			for($i=0;$i<count($list);$i++) {
				$icls	=	$list[$i];
				?>
					<tr bgcolor="#FFFFFF">
						<td class="td_normal"><?php echo $icls->getIssueDate('yes')?></td>
						<td class="td_normal">Stock Issue</td>
						<td class="td_normal" align="center"><?php echo $icls->getIssueNo()?>/<?php echo $icls->getFinYear()?></td>
						<td class="td_normal" align="center"><a href="updateStockTransaction.php?type=ISSUE&sid=<?php echo $icls->getIssueID()?>" target="_blank">Update</a></td>
					</tr>			
				<?php
			}

			$sql	= "SELECT * FROM `gen_stockjournal` WHERE `DOT`='$df' AND `CompanyID`='$cmpid'";
			$list	= $pdb->getStockJournalListBySQL($sql);
			for($i=0;$i<count($list);$i++) {
				$icls	=	$list[$i];
				?>
					<tr bgcolor="#FFFFFF">
						<td class="td_normal"><?php echo $icls->getDOT('yes')?></td>
						<td class="td_normal">Stock Journal</td>
						<td class="td_normal" align="center"><?php echo $icls->getStockJournalID()?></td>
						<td class="td_normal" align="center"><a href="updateStockTransaction.php?type=JOURNAL&sid=<?php echo $icls->getStockJournalID()?>" target="_blank">Update</a></td>
					</tr>			
				<?php
			}
		
			$df		= getNextDate($df);
			if($df > $dt) break;
		}
	
		$iPage->endBody();
		$iPage->endPage();
	
	//}
	
?>