<?php

	/* Include the required files */
	require_once( 'aom-config.php' );
	require_once( 'inc/pagetemplate.php' );
	require_once( 'inc/head.php' );
	require_once( 'inc/topmenu.php' );
	require_once( 'inc/functions.php' );
	require_once( 'dao/asys.module.php' );
	require_once( 'dao/asys.user.php' );
	require_once( 'dao/asys.company.php' );
	require_once( 'dao/asys.usercompany.php' );
	require_once( 'dao/asys.logindb.php' );
	require_once( 'dao/asys.masterdb.php' );
	require_once( 'dao/asys.companydb.php' );

	$tuser		=	new asys_users();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if($tuser->getUserStatus() < ADMIN_USER) {
		echo 'Only Admin Users can view/open this Page. <a href="home.php">Click here to go back.</a>';
		exit;
	}	
	
	
	$ldb			= new logindb();
	$mdb			= new masterdb();
	$cdb			= new companydb();
	$usrList	= $ldb->getUserList();
	$cmpList	= $cdb->getCompanyList();
	
	$UserID			= "";
	
	extract($_REQUEST);
	
	if($UserID != "") {
		$UserID		= addslashes($UserID);
		$usrDet		= $ldb->getUserDetail($UserID);
		
		/*if($tuser->getUserID() == $UserID) {
			if($tuser->getUserStatus() != HIDDEN_USER) {
				echo 'Good try!! keep trying on. <a href="home.php">Click here to go back.</a>';
				exit;				
			}
		}*/
		
	}
	
	/* Ready to create the page */
	$iPage	=	new asys_pages(APP_TITLE);
	/* Start writting the page */
	$iPage->startPage();
	$iPage->startHeader();
	/* Add links and Scripts as required */
	$iPage->addLink("css/asys.css");
	$iPage->addLink("css/menu.css");
	$iPage->addLink("css/select2.css");
	$iPage->addScript("js/common.js");
	$iPage->addScript("js/jquery.js");
	$iPage->addScript("js/select2.js");
		
	$iPage->endHeader();
	$iPage->startBody();
	
	outputHeader($tuser);

?>

	<?php include('inc/menuHome.php')?>

	<div id="pagehead">&nbsp;USER ACCESS TO COMPANIES</div>
	<div style="height:10px;"></div>
	
	<table cellspacing="0" border="0" width="980px" align="center" bgcolor="#99BBE8">
		<tr><td bgcolor="#D6E3F3" class="td_normal_large red bold" style="padding:2px;">
			Select User
		</td></tr>
		<tr><td style="border-top: 1px solid #99BBE8;"></td></tr>
		<tr>
			<td bgcolor="#ffffff" class="td_normal" style="padding:4px;">	
				<form method="post" action="">
				<div style="float:left;padding-top:3px;width:80px;">
					&nbsp;Select User &nbsp;
				</div>
				<div style="float:left;width:400px;">
					<select name="UserID" id="UserID" style="width:100%">
						<option value="">--</option>
				<?php
					for($i=0;$i<count($usrList);$i++){
						$ub	= $usrList[$i];
						if($ub->getUserStatus() > $tuser->getUserStatus()) continue;
						$tmp	= "";
						if($UserID == $ub->getUserID()) $tmp = "selected";
				?>				
					<option value="<?php echo $ub->getUserID()?>" <?php echo $tmp?>><?php echo $ub->getUserName()?></option>
				<?php } ?>
					</select>
				</div>					
				<div style="float:left">
					&nbsp;
					<input type="submit" class="red_button" value="Show Access">
				</div>
				</form>
			</td>
		</tr>
	</table>
	
	<div style="height:5px;"></div>
	
	<?php if($UserID != "") { ?>
	
	<table cellspacing="0" border="0" width="970px" align="center" bgcolor="#99BBE8">
		<tr><td bgcolor="#D6E3F3" class="td_normal_large red bold" style="padding:2px;">
			Company assignment for user <?php echo $usrDet->getUserName()?>
		</td></tr>
		<tr><td style="border-top: 1px solid #99BBE8;"></td></tr>
		<tr>
			<td bgcolor="#ffffff" class="td_normal" style="padding:4px;">	
				<table cellspacing="1" style="border:0px;" width="970px" align="center" bgcolor="#CCCCCC">
					<tr bgcolor="#E4E4E4">
						<td class="td_normal_large" align="left">Company Name <input type="hidden" name="cmpCount" id="cmpCount" value="<?php echo count($cmpList)?>" /></td>
						<td class="td_normal_large" align="center">Access</td>
					</tr>
					<?php 
						for($i=0;$i<count($cmpList);$i++) { 
							$ccls	=	$cmpList[$i];
					?>
					<tr bgcolor="#FFFFFF">
						<td class="td_normal">
							[<?php echo $ccls->getCompanyID()?>] <?php echo $ccls->getCompanyName()?>
							<input type="hidden" id="cid<?php echo ($i+1)?>" name="cid<?php echo ($i+1)?>" value="<?php echo $ccls->getCompanyID()?>" />
						</td>
						<td class="td_normal" style="text-align:center"><input type="checkbox" name="cc<?php echo ($i+1)?>" id="cc<?php echo ($i+1)?>" <?php if($cdb->getUserCompanyStat($UserID, $ccls->getCompanyID()) == "YES") echo 'checked'; ?> onChange="chgAccess('cc', <?php echo ($i+1)?>)" /></td>
					</tr>					
					<?php } ?>
					
				</table>
			</td>
		</tr>
	</table>
	
	<br /><br />	

	<?php } ?>

<?php
	$iPage->endBody();
	$iPage->endPage();
?>

<script language="javaScript">

	$(function () {
		$("select").select2();
	});
	
	function chgAccess(method, param) {
		var cid		=	EBD('cid' + param).value;
		
		var x = (window.ActiveXObject) ? new ActiveXObject("Microsoft.XMLHTTP") : new XMLHttpRequest();
		if (x){
			x.onreadystatechange = function(){
				if (x.readyState == 4 && x.status == 200){
					var fr	= x.responseText;
					if(fr == "0") {
						alert("Fail to update, try again");
						if(yn == "NO")
							EBD(method + param).checked = true;
						else
							EBD(method + param).checked = false;
					} else if(fr == "-1") {
						alert("Session timed out - please relogin");
						location	=	"index.php";
					} else if(fr == "-2") {
						alert("Not enough permission to set Role");
						if(yn == "NO")
							EBD(method + param).checked = true;
						else
							EBD(method + param).checked = false;				
					} else {
						/* Do nothing */
					}
				}
			};
			x.open("GET", "ajax/updateUserCompany.php?uid=<?php echo $UserID?>&cid=" + cid, true);
			x.send(null);
		} else {
			alert('AJAX not supported in your Browser.');
		}		
	}
	
</script>