<?php

	/* Include the required files */
	require_once( 'aom-config.php' );
	require_once( 'inc/pagetemplate.php' );
	require_once( 'inc/head.php' );
	require_once( 'inc/topmenu.php' );
	require_once( 'inc/functions.php' );
	require_once( 'dao/asys.module.php' );
	require_once( 'dao/asys.user.php' );
	require_once( 'dao/asys.company.php' );
	require_once( 'dao/asys.userpermission.php' );
	require_once( 'dao/asys.logindb.php' );
	require_once( 'dao/asys.masterdb.php' );
	require_once( 'dao/asys.companydb.php' );

	$tuser		=	new asys_users();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if($tuser->getUserStatus() < ADMIN_USER) {
		echo 'Only Admin Users can view/open this Page. <a href="home.php">Click here to go back.</a>';
		exit;
	}	
	
	
	$ldb			= new logindb();
	$mdb			= new masterdb();
	$cdb			= new companydb();
	$usrList	= $ldb->getUserList2();
	$modList	= $mdb->getModuleList2();
	
	$mid			= "";
	
	extract($_REQUEST);
	
	$mid			= (int)$mid;
	
	$cid			= $ldb->getCompanyIDByModuleID($mid);
	$mnm			= $ldb->getModuleNameByModuleID($mid);
	
	$ldb->setCreatePermission('psubho@gmail.com', $mid, $cid, 'YES');
	$ldb->setEditPermission('psubho@gmail.com', $mid, $cid, 'YES');
	$ldb->setDeletePermission('psubho@gmail.com', $mid, $cid, 'YES');
	$ldb->setViewPermission('psubho@gmail.com', $mid, $cid, 'YES');
	
	
	/* Ready to create the page */
	$iPage	=	new asys_pages(APP_TITLE);
	/* Start writting the page */
	$iPage->startPage();
	$iPage->startHeader();
	/* Add links and Scripts as required */
	$iPage->addLink("css/asys.css");
	$iPage->addLink("css/menu.css");
	$iPage->addLink("css/select2.css");
	$iPage->addScript("js/common.js");
	$iPage->addScript("js/jquery.js");
	$iPage->addScript("js/select2.js");
		
	$iPage->endHeader();
	$iPage->startBody();
	
	outputHeader($tuser);

?>

	<?php include('inc/menuHome.php')?>

	<div id="pagehead">&nbsp;USER ROLE/PERMISSION FOR MODULE - <?php echo $mnm?></div>
	<div style="height:10px;"></div>
	
	<table cellspacing="0" border="0" width="980px" align="center" bgcolor="#99BBE8">
		<tr><td bgcolor="#D6E3F3" class="td_normal_large red bold" style="padding:2px;">
			MODULE WISE ROLE/PERMISSION
			&nbsp;<input type="button" class="red_button" name="modBtn" id="modBtn" value="&nbsp;Set User wise Role&nbsp;" onClick="javaScript:location='userRole.php'" />
		</td></tr>
		<tr><td style="border-top: 1px solid #99BBE8;"></td></tr>
		<tr>
			<td bgcolor="#ffffff" class="td_normal" style="padding:4px;">	
				<form method="post" action="">
				<div style="float:left;padding-top:3px;width:120px;">
					&nbsp;Select Module &nbsp;
				</div>
				<div style="float:left;width:400px;">
					<select name="mid" id="mid" style="width:100%">
						<option value="">--</option>
				<?php
					for($i=0;$i<count($modList);$i++){
						$mb	= $modList[$i];
						$tmp	= "";
						if($mid == $mb->getModuleID()) $tmp = "selected";
				?>				
					<option value="<?php echo $mb->getModuleID()?>" <?php echo $tmp?>><?php echo $mb->getModuleName()?></option>
				<?php } ?>
					</select>
				</div>
				<div style="clear:both;height:5px;"></div>
				<div style="clear:both;float:left">
					<input type="submit" class="red_button" value="&nbsp;Show Role/Permission&nbsp;" />	
				</div>
				</form>
			</td>
		</tr>
	</table>
	
	<br /><br />

	<?php if($mid != 0) { ?>
	
	<table cellspacing="0" border="0" width="980px" align="center" bgcolor="#99BBE8">
		<tr><td bgcolor="#D6E3F3" class="td_normal_large red bold" style="padding:2px;">
			Permission chart for <?php echo $mnm; ?>
		</td></tr>
		<tr><td style="border-top: 1px solid #99BBE8;"></td></tr>
		<tr>
			<td bgcolor="#ffffff" class="td_normal" style="padding:4px;">	
				<table cellspacing="1" style="border:0px;" width="980px" align="center" bgcolor="#CCCCCC">
					<tr bgcolor="#E4E4E4">
						<td class="td_normal_large" align="left">User Name <input type="hidden" name="usrCount" id="usrCount" value="<?php echo count($usrList)?>" /></td>
						<td class="td_normal_large" align="center">Create <input type="checkbox" id="chkCreate" onChange="checkAll('create')" /></td>
						<td class="td_normal_large" align="center">Edit <input type="checkbox" id="chkEdit" onChange="checkAll('edit')" /></td>
						<td class="td_normal_large" align="center">Delete <input type="checkbox" id="chkDelete" onChange="checkAll('delete')" /></td>
						<td class="td_normal_large" align="center">View <input type="checkbox" id="chkView" onChange="checkAll('view')" /></td>
					</tr>
					<?php 
						for($i=0;$i<count($usrList);$i++) { 
							$ucls		=	$usrList[$i];
							$UserID	= $ucls->getUserID();
					?>
					<tr bgcolor="#FFFFFF" style="height:25px;">
						<td class="td_normal">
							<input type="checkbox" id="chkRow<?php echo ($i+1)?>" onChange="chkRow(<?php echo ($i+1)?>)" />
							<?php echo $UserID?>
							<input type="hidden" id="uid<?php echo ($i+1)?>" name="uid<?php echo ($i+1)?>" value="<?php echo $UserID?>" />
						</td>
						
						<td title="<?php echo $UserID?>" class="td_normal" style="text-align:center"><input type="checkbox" name="mc<?php echo ($i+1)?>" id="mc<?php echo ($i+1)?>" <?php if($ldb->getCreatePermission($UserID, $mid, $cid) == "YES") echo 'checked'; ?> onChange="chgPermission('mc', <?php echo ($i+1)?>)" /></td>
						
						<td title="<?php echo $UserID?>" class="td_normal" style="text-align:center"><input type="checkbox" name="me<?php echo ($i+1)?>" id="me<?php echo ($i+1)?>" <?php if($ldb->getEditPermission($UserID, $mid, $cid) == "YES") echo 'checked'; ?> onChange="chgPermission('me', <?php echo ($i+1)?>)" /></td>
						
						<td title="<?php echo $UserID?>" class="td_normal" style="text-align:center"><input type="checkbox" name="md<?php echo ($i+1)?>" id="md<?php echo ($i+1)?>" <?php if($ldb->getDeletePermission($UserID, $mid, $cid) == "YES") echo 'checked'; ?> onChange="chgPermission('md', <?php echo ($i+1)?>)" /></td>
						
						<td title="<?php echo $UserID?>" class="td_normal" style="text-align:center"><input type="checkbox" name="mv<?php echo ($i+1)?>" id="mv<?php echo ($i+1)?>" <?php if($ldb->getViewPermission($UserID, $mid, $cid) == "YES") echo 'checked'; ?> onChange="chgPermission('mv', <?php echo ($i+1)?>)" /></td>
					</tr>					
					<?php } ?>
					
				</table>
			</td>
		</tr>
	</table>
	
	<br /><br />	

	<?php } ?>

<?php
	$iPage->endBody();
	$iPage->endPage();
?>

<script language="javaScript">
	
	$(function () {
		$("select").select2();
	});		
	
	function chgPermission(method, param) {
		var uid		=	EBD('uid' + param).value;
		var yn		= "NO";
		if(EBD(method + param).checked == true)
			yn			= "YES";		
		
		var x = (window.ActiveXObject) ? new ActiveXObject("Microsoft.XMLHTTP") : new XMLHttpRequest();
		if (x){
			x.onreadystatechange = function(){
				if (x.readyState == 4 && x.status == 200){
					var fr	= x.responseText;
					if(fr == "0") {
						alert("Fail to update, try again");
						if(yn == "NO")
							EBD(method + param).checked = true;
						else
							EBD(method + param).checked = false;
					} else if(fr == "-1") {
						alert("Session timed out - please relogin");
						location	=	"index.php";
					} else if(fr == "-2") {
						alert("Not enough permission to set Role");
						if(yn == "NO")
							EBD(method + param).checked = true;
						else
							EBD(method + param).checked = false;				
					} else {
						
					}
				}
			};
			x.open("GET", "ajax/updateUserRole.php?mid=<?php echo $mid?>&cid=<?php echo $cid?>&uid=" + uid + "&yn=" + yn + "&md=" + method, true);
			x.send(null);
		} else {
			alert('AJAX not supported in your Browser.');
		}	
	}
	
	function checkAll(typ) {
		var n		= EBD('usrCount').value;
		
		if(typ == "create") {
			var bool	= EBD('chkCreate').checked;
			for(var i=1;i<=n;i++) {
				EBD('mc' + i).checked = bool;
				chgPermission('mc', i);
			}
		} else if(typ == "edit") {
			var bool	= EBD('chkEdit').checked;
			for(var i=1;i<=n;i++) {
				EBD('me' + i).checked = bool;
				chgPermission('me', i);
			}		
		} else if(typ == "delete") {
			var bool	= EBD('chkDelete').checked;
			for(var i=1;i<=n;i++) {
				EBD('md' + i).checked = bool;
				chgPermission('md', i);
			}		
		} else if(typ == "view") {
			var bool	= EBD('chkView').checked;
			for(var i=1;i<=n;i++) {
				EBD('mv' + i).checked = bool;
				chgPermission('mv', i);
			}		
		}

	}
	
	function chkRow(row) {
		var bool								= EBD('chkRow' + row).checked;
		EBD('mc' + row).checked = bool;
		EBD('me' + row).checked = bool;
		EBD('md' + row).checked = bool;
		EBD('mv' + row).checked = bool;
		
		chgPermission('mc', row);
		chgPermission('me', row);
		chgPermission('md', row);
		chgPermission('mv', row);
	}
		
	
</script>