<?php

	/* Include the required files */
	require_once( 'aom-config.php' );
	require_once( 'inc/pagetemplate.php' );
	require_once( 'inc/head.php' );
	require_once( 'inc/topmenu.php' );
	require_once( 'inc/functions.php' );
	require_once( 'dao/asys.user.php' );
	require_once( 'dao/asys.company.php' );
	require_once( 'dao/asys.genericdb.php' );
	require_once( 'dao/asys.masterdb.php' );
	require_once( 'dao/asys.companydb.php' );
	require_once( 'dao/asys.log.php' );
	require_once( 'dao/asys.logindb.php' );
	require_once( 'dao/asys.userpermission.php' );	

	$tuser		=	new asys_users();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}	
	
	$ModuleID			= -2;

	$gdb					=	new genericdb();
	$mdb					=	new masterdb();
	$cdb					=	new companydb();
	$ldb					= new logindb();
	
	if($tuser->getUserStatus() < ADMIN_USER) {
		echo 'Only Admin Users can view/open this Page. <a href="home.php">Click here to go back.</a>';
		exit;
	}	
	
	$schStr		= "";
	$pno			= 0;
	$sRec			= 0;
	$rCnt			= 0;
	$nRec			= 25; /* Number of Records per page */
	
	extract($_REQUEST);

	$pno			=	(int)$pno;
	if($pno < 0)
		$pno		=	0;

	$schStr		=	addslashes($schStr);

	$rCnt			= $cdb->getNumberOfCompany($schStr);
	if( ceil(($rCnt) / $nRec) < $pno + 1  && $rCnt != 0)
		$pno		=	ceil(($rCnt)/$nRec) - 1;
	$sRec			= $pno * $nRec;

	$arr			=	$cdb->getCompanyListPaged($sRec, $nRec, $schStr);		
							
	
	/* Ready to create the page */
	$iPage	=	new asys_pages(APP_TITLE);
	/* Start writting the page */
	$iPage->startPage();
	$iPage->startHeader();
	/* Add links and Scripts as required */
	$iPage->addLink("css/asys.css");
	$iPage->addLink("css/menu.css");
	$iPage->addLink("css/superTables.css");
	$iPage->addLink("css/select2.css");
	$iPage->addScript("js/common.js");
	$iPage->addScript("js/superTables.js");	
	$iPage->addScript("js/jquery.js");
	$iPage->addScript("js/select2.js");	
	
	
	$iPage->endHeader();
	$iPage->startBody();
	
	outputHeader($tuser);
	
?>

	<?php include('inc/menuHome.php')?>	

	<div id="pagehead">&nbsp;VIEW COMPANY</div>
	<div style="height:10px;"></div>
	
	<table cellspacing="0" border="0" width="980px" align="center" bgcolor="#99BBE8">
		<tr><td bgcolor="#D6E3F3" class="td_normal_large blue bold" style="padding:4px;">
			<div style="float:left"><a href="newCompany.php" class="nav"><b>Company</b></a></div>
			<div style="float:right;height:20px;" class="td_normal">
				<?php echo $rCnt?> records found |
				<?php if($pno>0) { ?><a class="nav" href="javaScript:gotoPage(<?php echo $pno-1?>)">Previous</a>   <?php } ?>
				Page <input type="text" class="input" name="ppno2" id="ppno2" value="<?php echo ($pno+1)?>" style="width:30px;height:13px;text-align:center" maxLength="3" onFocus="clrF(2)" onBlur="fillF(2)" /> of <?php echo ceil(($rCnt)/$nRec)?>
				<?php if(ceil(($rCnt)/$nRec)>$pno+1) { ?>  <a class="nav" href="javaScript:gotoPage(<?php echo $pno+1?>)">Next</a> <?php } ?>
			</div>
		</td></tr>
		<tr><td style="border-top: 1px solid #99BBE8;"></td></tr>
		<tr>
			<td bgcolor="#ffffff" class="td_normal" style="padding:4px;">
				Search: <input type="text" class="input" name="schStr" id="schStr" value="<?php echo $schStr?>"  onFocus="this.className='input_focus'" onBlur="this.className='input'" style="width:200px;" />
				<input type="button" class="red_button" value="Search »" id="btnS" onClick="srcR()" />
			</td>
		</tr>
	</table>
	
	<div style="height:5px;"></div>
	
	<div id="rptDiv" class="fakeContainer">	
	
		<table cellspacing="1" cellpadding="2" border="0" width="970px" align="center" id="vTable">
			<thead>
				<tr>
					<th width="280px" align="left">Mother Company</th>
					<th width="280px" align="left">Company Name</th>
					<th width="120px" align="left">Company Code</th>
					<th width="120px" align="center">Company Type</th>
					<th width="50px">Edit</th>
					<th width="50px">Delete</th>
				</tr>
			</thead>
			<tbody>
		<?php

			for($i=0;$i<count($arr);$i++) {
				$row		=	$arr[$i];
		?>			
				<tr>
					<td class="td_view" title="<?php echo $row->getMotherCompanyName('yes')?>"><?php echo $row->getMotherCompanyName('yes')?></td>
					<td class="td_view" title="<?php echo $row->getCompanyName('yes')?>"><?php echo $row->getCompanyName('yes')?></td>
					<td class="td_view" title="<?php echo $row->getCompanyCode('yes')?>"><?php echo $row->getCompanyCode('yes')?></td>
					<td class="td_view"><?php echo $row->getCompanyType('yes')?></td>
					
					<td class="td_view" align="center"><a href="editCompany.php?pKey=<?php echo $row->getCompanyID()?>&schStr=<?php echo $schStr?>&pno=<?php echo $pno?>"><img src="images/edit.png" title="EDIT - <?php echo formatJScriptString($row->getCompanyName())?>" /></a></td>
					<td class="td_view" align="center"><a href="javaScript:deleteRec('<?php echo $row->getCompanyID()?>','<?php echo formatJScriptString($row->getCompanyName())?>')"><img src="images/delete.png" title="DELETE - <?php echo formatJScriptString($row->getCompanyName())?>" /></a></td>
				</tr>
				<?php } ?>
			</tbody>
		</table>

	</div>
	
	<div style="height:10px;"></div>	

<?php
	$iPage->endBody();
	$iPage->endPage();
?>

<script language="javaScript">
	
	$(function () {
		$("#schStr").focus();
	});
	
	var div	=	document.getElementById('rptDiv');

	div.style.height	=	 (window.innerHeight - 220) + "px";
	div.style.width		=	 "980px";

	//<![CDATA[	
	(function() {
		var mySt = new superTable("vTable", {
			cssSkin 		: "sSky",
			fixedCols 	: 0,
			headerRows 	: 1
		});
	})();
	//]]>	

	var dept_IE4	=	(document.all)? true:false;
	var dept_NS4	=	(document.layers);

	if (dept_NS4) EBD('ppno2').captureEvents(Event.KEYPRESS);

	EBD('ppno2').onkeypress = function(e){
		var whichASC;
		if(dept_IE4)
			whichASC	=	window.event.keyCode;
		else
			whichASC	=	e.which;

		if(whichASC == 13){
			var pno	= EBD('ppno2').value - 1;
			gotoPage(pno);
		}
	};
	
	function srcR() {
		var schStr	=	EBD('schStr').value;

		location		=	"viewCompany.php?pno=0&schStr="+schStr;
	}

	function gotoPage(n) {
		location		=	"viewCompany.php?pno=" + n + "&schStr=<?php echo $schStr?>";
	}

	function clrF(n){
		EBD('ppno'+n).value	=	'';
	}

	function fillF(n){
		EBD('ppno'+n).value	=	"<?php echo $pno+1?>";
	}
	
	function deleteRec(pkey, nm) {
		if(confirm("Click OK to delete " + nm) == false) return;
		
		if(pkey == 1) {
			alert('Head Office cannot be deleted.');
			return;
		}
		
		location =	"deleteCompany.php?pkey=" + pkey + "&schStr=<?php echo $schStr?>&pno=<?php echo $pno?>";
	}

</script>