<?php

	/* Include the required files */
	require_once( 'aom-config.php' );
	require_once( 'inc/pagetemplate.php' );
	require_once( 'inc/head.php' );
	require_once( 'inc/topmenu.php' );
	require_once( 'inc/functions.php' );
	require_once( 'dao/asys.user.php' );
	require_once( 'dao/asys.company.php' );
	require_once( 'dao/asys.drcr.php' );
	require_once( 'dao/asys.account.php' );	
	require_once( 'dao/class.gen_branchjournal.php' );
	require_once( 'dao/asys.genericdb.php' );
	require_once( 'dao/asys.masterdb.php' );
	require_once( 'dao/asys.log.php' );
	require_once( 'dao/asys.logindb.php' );
	require_once( 'dao/asys.voucherdb.php' );
	require_once( 'dao/asys.userpermission.php' );	

	$tuser		=	new asys_users();
	$tcmp		= new asys_companies();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}
	
	if(isset($_SESSION["ssECmp"])){
		$tcmp	=	unserialize($_SESSION["ssECmp"]);
	}
	
	if($tcmp->getCompanyID() <= 0) {
		header("Location:home.php");
		exit;	
	}		
	
	$ModuleID			= 52;

	$gdb					=	new genericdb();
	$mdb					=	new masterdb();
	$tdb					=	new voucherdb();
	$ldb					= new logindb();
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:accessDenied.php");
		exit;
	}	
	
	$DateFrom	= "";
	$DateTo		= "";
	$pno			= 0;
	$sRec			= 0;
	$rCnt			= 0;
	$nRec			= 25; /* Number of Records per page */
	
	extract($_REQUEST);

	$pno			=	(int)$pno;
	if($pno < 0)
		$pno		=	0;

	$DateFrom	=	FormatIndianDateToSQLDate($DateFrom);
	$DateTo		=	FormatIndianDateToSQLDate($DateTo);

	$rCnt			= $tdb->getNumberOfC2C($tcmp->getCompanyID(), $DateFrom, $DateTo);
	if( ceil(($rCnt) / $nRec) < $pno + 1  && $rCnt != 0)
		$pno		=	ceil(($rCnt)/$nRec) - 1;
	$sRec			= $pno * $nRec;

	$arr			=	$tdb->getC2CListPaged($sRec, $nRec, $tcmp->getCompanyID(), $DateFrom, $DateTo);		
							
	
	/* Ready to create the page */
	$iPage	=	new asys_pages(APP_TITLE);
	/* Start writting the page */
	$iPage->startPage();
	$iPage->startHeader();
	/* Add links and Scripts as required */
	$iPage->addLink("css/asys.css");
	$iPage->addLink("css/menu.css");
	$iPage->addLink("css/superTables.css");
	$iPage->addLink("css/datepicker.css");
	$iPage->addScript("js/common.js");
	$iPage->addScript("js/superTables.js");	
	$iPage->addScript("js/jquery.js");
	$iPage->addScript("js/datepicker.js");	
		
	
	$iPage->endHeader();
	$iPage->startBody();
	
	outputHeader($tuser, $tcmp);
	outputMenu($tuser);	
	
?>	

	<div id="pagehead">&nbsp;VIEW COMPANY TO COMPANY JOURNAL VOUCHER</div>
	<div style="height:10px;"></div>
	
	<table cellspacing="0" border="0" width="980px" align="center" bgcolor="#99BBE8">
		<tr><td bgcolor="#D6E3F3" class="td_normal_large blue bold" style="padding:4px;">
			<div style="float:left"><a href="newCompanyVoucher.php" class="nav"><b>Company to Company Voucher</b></a></div>
			<div style="float:right;height:20px;" class="td_normal">
				<?php echo $rCnt?> records found |
				<?php if($pno>0) { ?><a class="nav" href="javaScript:gotoPage(<?php echo $pno-1?>)">Previous</a>   <?php } ?>
				Page <input type="text" class="input" name="ppno2" id="ppno2" value="<?php echo ($pno+1)?>" style="width:30px;height:13px;text-align:center" maxLength="3" onFocus="clrF(2)" onBlur="fillF(2)" /> of <?php echo ceil(($rCnt)/$nRec)?>
				<?php if(ceil(($rCnt)/$nRec)>$pno+1) { ?>  <a class="nav" href="javaScript:gotoPage(<?php echo $pno+1?>)">Next</a> <?php } ?>
			</div>
		</td></tr>
		<tr><td style="border-top: 1px solid #99BBE8;"></td></tr>
		<tr>
			<td bgcolor="#ffffff" class="td_normal" style="padding:4px;">
				<div style="float:left;">
					<input data-toggle="datepicker" type="text" class="input" name="DateFrom" id="DateFrom" value="<?php echo FormatSQLDateToIndianDate($DateFrom)?>" style="width:80px;" maxLength="10" />
				</div>
				<div style="float:left;">&nbsp;-&nbsp;</div>
				<div style="float:left;">
					<input data-toggle="datepicker" type="text" class="input" name="DateTo" id="DateTo" value="<?php echo FormatSQLDateToIndianDate($DateTo)?>" style="width:80px;" maxLength="10" />
				</div>
				<div style="float:left;">				
					&nbsp;<input type="button" class="red_button" value="Search »" id="btnS" onClick="srcR()" />
				</div>
			</td>
		</tr>
	</table>
	
	<div style="height:5px;"></div>
	
	<div id="rptDiv" class="fakeContainer">

		<table cellspacing="0" cellpadding="2" border="0" width="970px" align="center" id="vTable">
			<thead>
				<tr>
					<th width="80px" align="left">#</th>
					<th width="80px" align="left">Date</th>
					<th width="200px" align="left">Narration</th>
					<th width="200px" align="left">Branch</th>
					<th width="100px" align="left">Amount</th>
					<th width="30px">Edt</th>
					<th width="30px">Del</th>
				</tr>
			</thead>
			<tbody>
		<?php

			for($i=0;$i<count($arr);$i++) {
				$row		=	$arr[$i];
		?>			
				<tr>
					<td class="td_view"><?php echo $row->getBookingNo()?>/<?php echo $row->getFinYear('yes')?></td>
					<td class="td_view"><?php echo $row->getBookingDate('yes')?></td>
					<td class="td_view" title="<?php echo $row->getNarration()?>"><?php echo $row->getNarration('yes')?></td>
					<td class="td_view" title="<?php echo $row->getToCompanyName()?>"><?php echo $row->getToCompanyName('yes')?></td>
					<td class="td_view"><?php echo $row->getAmount('yes')?></td>
					
					<td class="td_view" align="center"><a href="editCompanyVoucher.php?pKey=<?php echo $row->getBookingID()?>&DateFrom=<?php echo FormatSQLDateToIndianDate($DateFrom)?>&DateTo=<?php echo FormatSQLDateToIndianDate($DateTo)?>&pno=<?php echo $pno?>"><img src="images/edit.png" title="EDIT - <?php echo formatJScriptString($row->getBookingID())?>" /></a></td>
					<td class="td_view" align="center"><a href="javaScript:deleteRec('<?php echo $row->getBookingID()?>','<?php echo formatJScriptString($row->getBookingID())?>')"><img src="images/delete.png" title="DELETE - <?php echo formatJScriptString($row->getBookingID())?>" /></a></td>
				</tr>
				<?php } ?>
			</tbody>
		</table>

	</div>
	
	<div style="height:10px;"></div>
	

<?php
	$iPage->endBody();
	$iPage->endPage();
?>

<script language="javaScript">

	$('[data-toggle="datepicker"]').datepicker({
		format: 'dd-mm-yyyy',
		autoHide: 'yes'
	});
	
	var div	=	document.getElementById('rptDiv');

	div.style.height	=	 (window.innerHeight - 230) + "px";
	div.style.width		=	 "980px";

	//<![CDATA[	
	(function() {
		var mySt = new superTable("vTable", {
			cssSkin 		: "sSky",
			fixedCols 	: 0,
			headerRows 	: 1
		});
	})();
	//]]>
	

	var dept_IE4	=	(document.all)? true:false;
	var dept_NS4	=	(document.layers);

	if (dept_NS4) EBD('ppno2').captureEvents(Event.KEYPRESS);

	EBD('ppno2').onkeypress = function(e){
		var whichASC;
		if(dept_IE4)
			whichASC	=	window.event.keyCode;
		else
			whichASC	=	e.which;

		if(whichASC == 13){
			var pno	= EBD('ppno2').value - 1;
			gotoPage(pno);
		}
	};
	
	function srcR() {
		var df		=	EBD('DateFrom').value;
		var dt		=	EBD('DateTo').value;

		location	=	"viewCompanyVoucher.php?pno=0&DateFrom=" + df + "&DateTo=" + dt;
	}

	function gotoPage(n) {
		location		=	"viewCompanyVoucher.php?pno=" + n + "&DateFrom=<?php echo FormatSQLDateToIndianDate($DateFrom) ?>&DateTo=<?php echo FormatSQLDateToIndianDate($DateTo) ?>";
	}

	function clrF(n){
		EBD('ppno'+n).value	=	'';
	}

	function fillF(n){
		EBD('ppno'+n).value	=	"<?php echo $pno+1?>";
	}
	
	function deleteRec(pkey, nm) {
		if(confirm("Click OK to delete " + nm) == false) return;
		
		location =	"deleteCompanyVoucher.php?pkey=" + pkey + "&DateFrom=<?php echo FormatSQLDateToIndianDate($DateFrom)?>&DateTo=<?php echo FormatSQLDateToIndianDate($DateTo)?>&pno=<?php echo $pno?>";
	}

</script>