<?php

	/* Include the required files */
	require_once( 'checkLogin.php' );
	require_once( 'dao/asys.drcr.php' );
	require_once( 'dao/asys.group.php' );
	require_once( 'dao/asys.voucher.php' );
	require_once( 'dao/asys.vouchertag.php' );
	require_once( 'dao/asys.account.php' );
	require_once( 'dao/asys.vouchertype.php' );
	require_once( 'dao/asys.voucherdb.php' );

	
	$ModuleID			= 11;		

	$db					=	new masterdb();
	$vdb				=	new voucherdb();
	$ldb				= new logindb();
	
	if($ldb->getViewPermission($tuser->getUserID(), $ModuleID, 0) != "YES") {
		header("Location:accessDenied.php");
		exit;
	}	

	$vtid				= JOURNAL_VOUCHER;
	$DateFrom		=	date('01-m-Y');
	$DateTo			=	date('d-m-Y');
	$AccountID	=	0;
	$pno				= 0;
	$sRec				= 0;
	$rCnt				= 0;
	$nRec				= 25; /* Number of Records per page */

	extract($_REQUEST);

	$pno			=	(int)$pno;
	if($pno<0)
		$pno	=	0;

	$vtid				=	(int)$vtid;
	$DateFrom		=	addslashes($DateFrom);
	$DateTo			=	addslashes($DateTo);
	$AccountID	=	(int)$AccountID;

	$dtf				=	FormatIndianDateToSQLDate($DateFrom);
	$dtt				=	FormatIndianDateToSQLDate($DateTo);

	$rCnt				= $vdb->getNumberOfVoucher($vtid, $dtf, $dtt, $AccountID, $tcmp->getCompanyID());
	if(ceil(($rCnt)/$nRec)<$pno+1  && $rCnt!=0)
		$pno	=	ceil(($rCnt)/$nRec) - 1;
	$sRec			= $pno*$nRec;

	$vchList		=	$vdb->getVoucherListPaged($vtid, $dtf, $dtt, $AccountID, $tcmp->getCompanyID(), $sRec, $nRec);
	$accList		=	$db->getAccountList($tcmp->getCompanyID());

	/* Ready to create the page */
	$iPage	=	new asys_pages(APP_TITLE);
	/* Start writting the page */
	$iPage->startPage();
	$iPage->startHeader();
	/* Add links and Scripts as required */
	$iPage->addLink("css/asys.css");
	$iPage->addLink("css/menu.css");
	$iPage->addLink("css/superTables.css");
	$iPage->addLink("css/datepicker.css");
	$iPage->addLink("css/select2.css");
	$iPage->addScript("js/common.js");
	$iPage->addScript("js/superTables.js");	
	$iPage->addScript("js/jquery.js");
	$iPage->addScript("js/datepicker.js");
	$iPage->addScript("js/select2.js");

	$iPage->endHeader();
	$iPage->startBody();
	
	outputHeader($tuser, $tcmp);
	outputMenu($tuser);

?>
	<div id="pagehead">&nbsp;VIEW <?php echo getVoucherType($vtid)?></div>
	<div style="height:10px;"></div>
	
	<table cellspacing="0" border="0" width="980px" align="center" bgcolor="#99BBE8">
		<tr><td bgcolor="#D6E3F3" class="td_normal_large blue bold" style="padding:4px;">
			<div style="float:left"><a href="newJRN.php" class="nav"><b><?php echo getVoucherType($vtid)?></b></a></div>
			<div style="float:right;height:20px;" class="td_normal">
				<?php echo $rCnt?> records found | 
				<?php if($pno>0) { ?><a class="nav" href="javaScript:gotoPage(<?php echo $pno-1?>)">Previous</a>&nbsp;&nbsp; <?php } ?>
				Page <input type="text" class="input" name="ppno2" id="ppno2" value="<?php echo ($pno+1)?>" style="width:30px;height:13px;text-align:center" maxLength="3" onFocus="clrF(2)" onBlur="fillF(2)" />&nbsp;of <?php echo ceil(($rCnt)/$nRec)?>
				<?php if(ceil(($rCnt)/$nRec)>$pno+1) { ?>&nbsp;&nbsp;<a class="nav" href="javaScript:gotoPage(<?php echo $pno+1?>)">Next</a> <?php } ?>
			</div>
		</td></tr>
		<tr><td style="border-top: 1px solid #99BBE8;"></td></tr>
		<tr>
			<td bgcolor="#ffffff" class="td_normal" style="padding:4px;">
				<div style="float:left">&nbsp;Date:</div>
				<div style="float:left"><input data-toggle="datepicker" type="text" name="dtfrom" id="dtfrom" value="<?php echo $DateFrom?>" style="width:80px;" class="input" maxLength="10" /></div>
				<div style="float:left">&nbsp;-&nbsp;</div>
				<div style="float:left"><input data-toggle="datepicker" type="text" name="dtto" id="dtto" value="<?php echo $DateTo?>" style="width:80px;" class="input" maxLength="10" /></div>
				<div style="float:left">&nbsp;Account:&nbsp;</div>
				<div style="float:left">
					<select name="accid" id="accid" style="width:400px;"></select>
				</div>
				<div style="float:left">
				&nbsp;&nbsp;<input type="button" class="button" value="Search &raquo;" id="btnS" onClick="srcR()" />
				</div>
			</td>
		</tr>
	</table>
	
	<div style="height:5px;"></div>
	
	<div id="rptDiv" class="fakeContainer">

		<table cellspacing="0" cellpadding="2" border="0" width="960px" align="center" id="vTable">
			<thead>
				<tr>
					<th width="100px" align="left">#</th>
					<th width="20px">SN</th>
					<th width="70px" align="left">Date</th>
					<th width="180px" align="left">Ledger</th>
					<th width="140px" align="left">Sub-ledger</th>
					<th width="80px" align="right">Amount</th>
					<th width="30px">Prn</th>
					<th width="30px">Edt</th>
					<th width="30px">Del</th>
				</tr>
			</thead>
			<tbody>
		<?php
			$prev_vid	=	0;
			for($i=0;$i<count($vchList);$i++) {
				$row		=	$vchList[$i];
		?>			
				<tr>
					<td class="td_view">
						<?php if($prev_vid!=$row->getVoucherID()){ ?>
							<?php echo getShortVoucherType($row->getVoucherType()).'/'.FormatSQLDateToVoucherPrintFormat($row->getDOV()).'/'.$row->getDayWiseNo()?>
						<?php } ?>
					</td>
					<td class="td_view" align="center"><?php echo $row->getSerialID('no')?></td>
					<td class="td_view">
						<?php if($prev_vid != $row->getVoucherID()){ ?>
							<?php echo $row->getDOV('yes')?>
						<?php } ?>
					</td>
					<td class="td_view" title="<?php if($row->getMotherAccount()!=0) echo $row->getMotherAccountName('yes'); else echo $row->getAccountName('yes');?>">
					<?php if($row->getMotherAccount()!=0) echo $row->getMotherAccountName('yes'); else echo $row->getAccountName('yes');?>
					</td>
					<td class="td_view" title="<?php if($row->getMotherAccount() != 0) echo $row->getAccountName('yes');?>"><?php if($row->getMotherAccount() != 0) echo $row->getAccountName('yes');?></td>
					<td class="td_view" align="right"><?php echo $row->getAmount('yes')?></td>
					
					<?php
							if($row->getTxnType() != 0) {
					?>
						<td class="td_view"></td>
						<td class="td_view"></td>
						<td class="td_view"></td>
						<td class="td_view"></td>
					<?php } else { ?>
					
					<td class="td_view" align="center">
						<?php if($prev_vid != $row->getVoucherID()){ ?>
						<a href="printvoucher.php?vid=<?php echo $row->getVoucherID()?>" target="_blank"><img src="images/print.gif" title="Print Details of #<?php echo formatJScriptString($row->getVoucherID())?>" /></a>
						<?php } ?>
					</td>
					<td class="td_view" align="center">
						<?php if($prev_vid != $row->getVoucherID()){ ?>
						<a href="editJRN.php?vid=<?php echo $row->getVoucherID('no')?>&DateFrom=<?php echo $DateFrom?>&DateTo=<?php echo $DateTo?>&AccountID=<?php echo $AccountID?>"><img src="images/edit.png" title="EDIT - #<?php echo formatJScriptString($row->getVoucherID())?>" /></a>
						<?php } ?>
					</td>
					<td class="td_view" align="center">
						<?php if($prev_vid != $row->getVoucherID()){ ?>
						<a href="javaScript:deleteVoucher(<?php echo $row->getVoucherID('no')?>)"><img src="images/delete.png" title="DELETE - #<?php echo formatJScriptString($row->getVoucherID())?>" /></a>
						<?php } ?>
					</td>
					<?php } ?>
				</tr>
					<?php $prev_vid	=	$row->getVoucherID(); ?>
				<?php } ?>
			</tbody>
		</table>

	</div>
	
	<div style="height:10px;"></div>

<?php
	$iPage->endBody();
	$iPage->endPage();
?>

<script language="javaScript">
	
	$(function () {
		$("#accid").select2();
		fetchAccount();
	});
	
	$('[data-toggle="datepicker"]').datepicker({
		format: 'dd-mm-yyyy',
		autoHide: 'yes'
	});
	
	var div	=	document.getElementById('rptDiv');

	div.style.height	=	 (window.innerHeight - 230) + "px";
	div.style.width		=	 "980px";

	//<![CDATA[	
	(function() {
		var mySt = new superTable("vTable", {
			cssSkin 		: "sSky",
			fixedCols 	: 0,
			headerRows 	: 1
		});
	})();
	//]]>	
	
	function fetchAccount() {
	
    $('#accid').empty();
    $('#accid').append('<option value="0">--</option>');
    var cid		= <?php echo $tcmp->getCompanyID()?>;
    var gid		= "<?php echo $AccountID?>";
    
    $.ajax({
			type: "POST",
			url: "json/getAccountListCompanyWise.php",
			data:{"cid": cid},
			success: function(data){

				var opts = $.parseJSON(data);
				$.each(opts, function(i, d) {
					$('#accid').append('<option value="' + d.AccountID + '">' + d.AccountName + '</option>');
				});
				$("#accid").val(gid).change();
				
			}
    });	
		
	}

	var dept_IE4	=	(document.all)? true:false;
	var dept_NS4	=	(document.layers);

	if (dept_NS4) EBD('ppno2').captureEvents(Event.KEYPRESS);

	EBD('ppno2').onkeypress = function(e){
		var whichASC;
		if(dept_IE4)
			whichASC	=	window.event.keyCode;
		else
			whichASC	=	e.which;

		if(whichASC == 13){
			var pno	= EBD('ppno2').value - 1;
			gotoPage(pno);
		}
	};
	
	function srcR() {
		var dtf		=	EBD('dtfrom').value;
		var dtt		=	EBD('dtto').value;
		var aid		=	EBD('accid').value;

		if(checkForValidInput('dtfrom','Date','Please enter From date properly')==false) 	return;
		if(checkForValidInput('dtto','Date','Please enter Upto date properly')==false) 		return;

		location		=	"viewJRN.php?DateFrom="+dtf+"&DateTo="+dtt+"&AccountID="+aid;
	}

	function gotoPage(n) {
		location		=	"viewJRN.php?DateFrom=<?php echo $DateFrom?>&DateTo=<?php echo $DateTo?>&AccountID=<?php echo $AccountID?>&pno="+n;
	}

	function clrF(n){
		EBD('ppno'+n).value	=	'';
	}

	function fillF(n){
		EBD('ppno'+n).value	=	"<?php echo $pno+1?>";
	}	
	
	function deleteVoucher(vid) {
		if(confirm('Click OK to delete the Voucher') == false) return;
		
		location = "deleteVoucher.php?dtf=<?php echo $DateFrom?>&dtt=<?php echo $DateTo?>&accid=<?php echo $AccountID?>&vid=" + vid;
	}	

</script>