<?php

	/* Include the required files */
	require_once( 'aom-config.php' );
	require_once( 'inc/pagetemplate.php' );
	require_once( 'inc/head.php' );
	require_once( 'inc/topmenu.php' );
	require_once( 'inc/functions.php' );
	require_once( 'dao/asys.user.php' );
	require_once( 'dao/asys.module.php' );
	require_once( 'dao/asys.modulesubmodule.php' );
	require_once( 'dao/asys.modulecolumn.php' );
	require_once( 'dao/asys.modulecolumnevent.php' );
	require_once( 'dao/asys.modulestockconfig.php' );
	require_once( 'dao/asys.modulevoucherconfig.php' );
	require_once( 'dao/asys.moduleview.php' );
	require_once( 'dao/asys.moduleviewsearch.php' );
	require_once( 'dao/asys.moduleviewfield.php' );
	require_once( 'dao/asys.module.php' );
	require_once( 'dao/asys.genericdb.php' );
	require_once( 'dao/asys.masterdb.php' );
	require_once( 'dao/asys.log.php' );
	require_once( 'dao/asys.logindb.php' );
	require_once( 'dao/asys.userpermission.php' );	

	$tuser		=	new asys_users();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}

	$gdb					=	new genericdb();
	$mdb					=	new masterdb();
	$ldb					= new logindb();
	

	if($tuser->getUserStatus() != HIDDEN_USER) {
		echo 'no, not allowed';
		exit;
	}
	
	
	$ModuleID		= 0;
	$ModuleName	= "";
	$ModuleType	= "";
	$pno				= 0;
	$sRec				= 0;
	$rCnt				= 0;
	$nRec				= 30; /* Number of Records per page */
	
	extract($_REQUEST);

	$pno			=	(int)$pno;
	if($pno < 0)
		$pno		=	0;

	$ModuleName		=	addslashes($ModuleName);

	$rCnt			= $mdb->getNumberOfModule($ModuleID, $ModuleName, $ModuleType);
	if( ceil(($rCnt) / $nRec) < $pno + 1  && $rCnt != 0)
		$pno		=	ceil(($rCnt)/$nRec) - 1;
	$sRec			= $pno * $nRec;

	$arr			=	$mdb->getModuleListPaged($sRec, $nRec, $ModuleID, $ModuleName, $ModuleType);		
							
	
	/* Ready to create the page */
	$iPage	=	new asys_pages(APP_TITLE);
	/* Start writting the page */
	$iPage->startPage();
	$iPage->startHeader();
	/* Add links and Scripts as required */
	$iPage->addLink("css/asys.css");
	$iPage->addLink("css/menu.css");
	$iPage->addLink("css/superTables.css");
	$iPage->addLink("css/select2.css");
	$iPage->addScript("js/common.js");
	$iPage->addScript("js/superTables.js");	
	$iPage->addScript("js/jquery.js");
	$iPage->addScript("js/select2.js");	
	
	$iPage->endHeader();
	$iPage->startBody();
	
	outputHeader($tuser);	
	
?>

	<?php include('inc/menuHome.php')?>	

	<div id="pagehead">&nbsp;VIEW MODULE</div>
	<div style="height:10px;"></div>
	
	<table cellspacing="0" border="0" width="980px" align="center" bgcolor="#99BBE8">
		<tr><td bgcolor="#D6E3F3" class="td_normal_large blue bold" style="padding:4px;">
			<div style="float:left"><a href="newModule.php" class="nav"><b>Module</b></a></div>
			<div style="float:right;height:20px;" class="td_normal">
				<?php echo $rCnt?> records found |
				<?php if($pno>0) { ?><a class="nav" href="javaScript:gotoPage(<?php echo $pno-1?>)">Previous</a>   <?php } ?>
				Page <input type="text" class="input" name="ppno2" id="ppno2" value="<?php echo ($pno+1)?>" style="width:30px;height:13px;text-align:center" maxLength="3" onFocus="clrF(2)" onBlur="fillF(2)" /> of <?php echo ceil(($rCnt)/$nRec)?>
				<?php if(ceil(($rCnt)/$nRec)>$pno+1) { ?>  <a class="nav" href="javaScript:gotoPage(<?php echo $pno+1?>)">Next</a> <?php } ?>
			</div>
		</td></tr>
		<tr><td style="border-top: 1px solid #99BBE8;"></td></tr>
		<tr>
			<td bgcolor="#ffffff" class="td_normal" style="padding:4px;">
				Module # <input type="text" class="input" name="ModuleID" id="ModuleID" value="<?php if($ModuleID != 0) echo $ModuleID?>"  onFocus="this.className='input_focus'" onBlur="this.className='input'" style="width:50px;" />
				Module Name: <input type="text" class="input" name="ModuleName" id="ModuleName" value="<?php echo $ModuleName?>"  onFocus="this.className='input_focus'" onBlur="this.className='input'" style="width:200px;" />
				Module Type:
				<select name="ModuleType" id="ModuleType" class="select">
					<option value="">--</option>
					<option value="Master" <?php if($ModuleType=="Master") echo 'selected'; ?>>Master</option>
					<option value="Transaction" <?php if($ModuleType=="Transaction") echo 'selected'; ?>>Transaction</option>
					<option value="Report" <?php if($ModuleType=="Report") echo 'selected'; ?>>Report</option>
					<option value="Submodule" <?php if($ModuleType=="Submodule") echo 'selected'; ?>>Submodule</option>
				</select>
				<input type="button" class="red_button" value="Search »" id="btnS" onClick="srcR()" />
			</td>
		</tr>
	</table>
	
	<div style="height:5px;"></div>
	
	<div id="rptDiv" class="fakeContainer">

		<table cellspacing="1" cellpadding="2" border="0" width="970px" align="center" id="vTable">
			<thead>
				<tr>
					<th width="80px" align="left">Module ID</th>
					<th width="220px" align="left">Module Name</th>
					<th width="220px" align="left">Company Name</th>
					<th width="80px" align="center">Type</th>
					<th width="80px" align="center">Financials?</th>
					<th width="80px" align="center">Inventory?</th>
					<th width="50px">Edit</th>
					<th width="50px">Delete</th>
				</tr>
			</thead>
			<tbody>
		<?php

			for($i=0;$i<count($arr);$i++) {
				$row		=	$arr[$i];
		?>			
				<tr>
					<td class="td_view"><?php echo $row->getModuleID()?></td>
					<td class="td_view" title="<?php echo $row->getModuleName('yes')?>"><?php echo $row->getModuleName('yes')?></td>
					<td class="td_view" title="<?php echo $row->getCompanyName('yes')?>"><?php echo $row->getCompanyName('yes')?></td>
					<td class="td_view"><?php echo $row->getModuleType('yes')?></td>
					<td class="td_view"><?php echo $row->getStockFlow('yes')?></td>
					<td class="td_view"><?php echo $row->getAccountVoucher('yes')?></td>
					
					<td class="td_view" align="center"><a href="editModule.php?pKey=<?php echo $row->getModuleID()?>&mid=<?php echo $ModuleID?>&ModuleName=<?php echo $ModuleName?>&ModuleType=<?php echo $ModuleType?>&pno=<?php echo $pno?>"><img src="images/edit.png" title="EDIT - <?php echo formatJScriptString($row->getModuleName())?>" /></a></td>
					<td class="td_view" align="center"><a href="javaScript:deleteRec('<?php echo $row->getModuleID()?>','<?php echo formatJScriptString($row->getModuleName())?>')"><img src="images/delete.png" title="DELETE - <?php echo formatJScriptString($row->getModuleName())?>" /></a></td>
				</tr>
				<?php } ?>
			</tbody>
		</table>

	</div>
	
	<div style="height:10px;"></div>	

<?php
	$iPage->endBody();
	$iPage->endPage();
?>

<script language="javaScript">
	
	$(function () {
		$("select").select2();
		
		$("#ModuleID").focus();
	});
	
	var div	=	document.getElementById('rptDiv');

	div.style.height	=	 (window.innerHeight - 230) + "px";
	div.style.width		=	 "980px";

	//<![CDATA[	
	(function() {
		var mySt = new superTable("vTable", {
			cssSkin 		: "sSky",
			fixedCols 	: 0,
			headerRows 	: 1
		});
	})();
	//]]>	

	var dept_IE4	=	(document.all)? true:false;
	var dept_NS4	=	(document.layers);

	if (dept_NS4) EBD('ppno2').captureEvents(Event.KEYPRESS);

	EBD('ppno2').onkeypress = function(e){
		var whichASC;
		if(dept_IE4)
			whichASC	=	window.event.keyCode;
		else
			whichASC	=	e.which;

		if(whichASC == 13){
			var pno	= EBD('ppno2').value - 1;
			gotoPage(pno);
		}
	};
	
	function srcR() {
		var mid			=	EBD('ModuleID').value;
		var mnm			=	EBD('ModuleName').value;
		var mtp			=	EBD('ModuleType').value;

		location		=	"viewModule.php?pno=0&ModuleID=" + mid + "&ModuleName=" + mnm + "&ModuleType=" + mtp;
	}

	function gotoPage(n) {
		location		=	"viewModule.php?pno=" + n + "&ModuleID=<?php echo $ModuleID?>&ModuleName=<?php echo $ModuleName?>&ModuleType=<?php echo $ModuleType?>";
	}

	function clrF(n){
		EBD('ppno'+n).value	=	'';
	}

	function fillF(n){
		EBD('ppno'+n).value	=	"<?php echo $pno+1?>";
	}
	
	function deleteRec(pkey, nm) {
		if(confirm("Click OK to delete module - " + nm) == false) return;
		
		location =	"deleteModule.php?pkey=" + pkey + "&mid=<?php echo $ModuleID?>&ModuleName=<?php echo $ModuleName?>&ModuleType=<?php echo $ModuleType?>&pno=<?php echo $pno?>";
	}

</script>