<?php

	/* Include the required files */
	require_once( 'aom-config.php' );
	require_once( 'inc/pagetemplate.php' );
	require_once( 'inc/head.php' );
	require_once( 'inc/topmenu.php' );
	require_once( 'inc/functions.php' );
	require_once( 'dao/asys.user.php' );
	require_once( 'dao/asys.company.php' );
	require_once( 'dao/asys.basesubgroup.php' );
	require_once( 'dao/asys.genericdb.php' );
	require_once( 'dao/asys.masterdb.php' );
	require_once( 'dao/asys.log.php' );
	require_once( 'dao/asys.logindb.php' );
	require_once( 'dao/asys.userpermission.php' );	

	$tuser		=	new asys_users();

	if(isset($_SESSION["ssEUser"])){
		$tuser	=	unserialize($_SESSION["ssEUser"]);
	}

	if($tuser->getUserID() == "") {
		header("Location:logout.php");
		exit;
	}		
	
	$ModuleID			= -3;

	$gdb					=	new genericdb();
	$mdb					=	new masterdb();
	$ldb					= new logindb();
	
	if($tuser->getUserStatus() < ADMIN_USER) {
		echo 'Only Admin Users can view/open this Page. <a href="home.php">Click here to go back.</a>';
		exit;
	}
	
	$bgid			= 0;
	$schStr		= "";
	$pno			= 0;
	$sRec			= 0;
	$rCnt			= 0;
	$nRec			= 25; /* Number of Records per page */
	
	extract($_REQUEST);

	$pno			=	(int)$pno;
	if($pno < 0)
		$pno		=	0;

	$bgid			= (int)$bgid;
	$schStr		=	addslashes($schStr);

	$rCnt			= $mdb->getNumberOfSubgroup($bgid, $schStr);
	if( ceil(($rCnt) / $nRec) < $pno + 1  && $rCnt != 0)
		$pno		=	ceil(($rCnt)/$nRec) - 1;
	$sRec			= $pno * $nRec;

	$arr			=	$mdb->getSubgroupListPaged($sRec, $nRec, $bgid, $schStr);		
							
	
	/* Ready to create the page */
	$iPage	=	new asys_pages(APP_TITLE);
	/* Start writting the page */
	$iPage->startPage();
	$iPage->startHeader();
	/* Add links and Scripts as required */
	$iPage->addLink("css/asys.css");
	$iPage->addLink("css/menu.css");
	$iPage->addLink("css/superTables.css");
	$iPage->addLink("css/select2.css");
	$iPage->addScript("js/common.js");
	$iPage->addScript("js/superTables.js");	
	$iPage->addScript("js/jquery.js");
	$iPage->addScript("js/select2.js");
	
	
	$iPage->endHeader();
	$iPage->startBody();
	
	outputHeader($tuser);	
	
?>	

	<?php include('inc/menuHome.php')?>

	<div id="pagehead">&nbsp;VIEW SUB-GROUP</div>
	<div style="height:10px;"></div>
	
	<table cellspacing="0" border="0" width="980px" align="center" bgcolor="#99BBE8">
		<tr><td bgcolor="#D6E3F3" class="td_normal_large blue bold" style="padding:4px;">
			<div style="float:left"><a href="newSubgroup.php" class="nav"><b>Sub group</b></a></div>
			<div style="float:right;height:20px;" class="td_normal">
				<?php echo $rCnt?> records found |
				<?php if($pno>0) { ?><a class="nav" href="javaScript:gotoPage(<?php echo $pno-1?>)">Previous</a>   <?php } ?>
				Page <input type="text" class="input" name="ppno2" id="ppno2" value="<?php echo ($pno+1)?>" style="width:30px;height:13px;text-align:center" maxLength="3" onFocus="clrF(2)" onBlur="fillF(2)" /> of <?php echo ceil(($rCnt)/$nRec)?>
				<?php if(ceil(($rCnt)/$nRec)>$pno+1) { ?>  <a class="nav" href="javaScript:gotoPage(<?php echo $pno+1?>)">Next</a> <?php } ?>
			</div>
		</td></tr>
		<tr><td style="border-top: 1px solid #99BBE8;"></td></tr>
		<tr>
			<td bgcolor="#ffffff" class="td_normal" style="padding:4px;">
				<div style="float:left;width:300px;">
					<select name="BGID" id="BGID" style="width:100%"></select>
				</div>
				<div style="float:left;">
					&nbsp;
					<input type="text" class="input" name="schStr" id="schStr" value="<?php echo $schStr?>"  onFocus="this.className='input_focus'" onBlur="this.className='input'" style="width:200px;" />
					<input type="button" class="red_button" value="Search »" id="btnS" onClick="srcR()" />
				</div>
			</td>
		</tr>
	</table>
	
	<div style="height:5px;"></div>
	
	<div id="rptDiv" class="fakeContainer">

		<table cellspacing="1" cellpadding="2" border="0" width="970px" align="center" id="vTable">
			<thead>
				<tr>
					<th width="100px" align="left">Subgroup ID</th>
					<th width="300px" align="left">Base Group Name</th>
					<th width="300px" align="left">Subgroup Name</th>
					<th width="50px">Edit</th>
					<th width="50px">Delete</th>
				</tr>
			</thead>
			<tbody>
		<?php

			for($i=0;$i<count($arr);$i++) {
				$row		=	$arr[$i];
		?>			
				<tr>
					<td class="td_view"><?php echo $row->getSubgroupID()?></td>
					<td class="td_view" title="<?php echo $row->getBGName('yes')?>"><?php echo $row->getBGName('yes')?></td>
					<td class="td_view" title="<?php echo $row->getSubgroupName()?>"><?php echo $row->getSubgroupName('yes')?></td>
					
					<td class="td_view" align="center"><a href="editSubgroup.php?pKey=<?php echo $row->getSubgroupID()?>&schStr=<?php echo $schStr?>&pno=<?php echo $pno?>&bid=<?php echo $bgid?>"><img src="images/edit.png" title="EDIT - <?php echo formatJScriptString($row->getSubgroupName())?>" /></a></td>
					<td class="td_view" align="center"><a href="javaScript:deleteRec('<?php echo $row->getSubgroupID()?>','<?php echo formatJScriptString($row->getSubgroupName())?>')"><img src="images/delete.png" title="DELETE - <?php echo formatJScriptString($row->getSubgroupName())?>" /></a></td>
				</tr>
				<?php } ?>
			</tbody>
		</table>

	</div>
	
	<div style="height:10px;"></div>	
	

<?php
	$iPage->endBody();
	$iPage->endPage();
?>

<script language="javaScript">
	
	$(function () {
		$("select").select2();
		$("#schStr").focus();
		fetchBGID();
	});
	
	var div	=	document.getElementById('rptDiv');

	div.style.height	=	 (window.innerHeight - 230) + "px";
	div.style.width		=	 "980px";

	//<![CDATA[	
	(function() {
		var mySt = new superTable("vTable", {
			cssSkin 		: "sSky",
			fixedCols 	: 0,
			headerRows 	: 1
		});
	})();
	//]]>	
	
	function fetchBGID() {
    $('#BGID').empty();
    $('#BGID').append('<option value="0">--</option>');
    var bid		= "<?php echo $bgid?>";
    
    $.ajax({
			type: "POST",
			url: "json/getBaseGroupList.php",
			success: function(data){

				var opts = $.parseJSON(data);
				$.each(opts, function(i, d) {
					$('#BGID').append('<option value="' + d.BGID + '">' + d.GroupName + '</option>');
				});
				$("#BGID").val(bid).change();
				
			}
    });		
	}		
		

	var dept_IE4	=	(document.all)? true:false;
	var dept_NS4	=	(document.layers);

	if (dept_NS4) EBD('ppno2').captureEvents(Event.KEYPRESS);

	EBD('ppno2').onkeypress = function(e){
		var whichASC;
		if(dept_IE4)
			whichASC	=	window.event.keyCode;
		else
			whichASC	=	e.which;

		if(whichASC == 13){
			var pno	= EBD('ppno2').value - 1;
			gotoPage(pno);
		}
	};
	
	function srcR() {
		var schStr	=	EBD('schStr').value;
		var bgid		=	EBD('bgid').value;

		location		=	"viewSubgroup.php?pno=0&schStr=" + schStr + "&bgid=" + bgid;
	}

	function gotoPage(n) {
		location		=	"viewSubgroup.php?pno=" + n + "&schStr=<?php echo $schStr?>&bgid=<?php echo $bgid?>";
	}

	function clrF(n){
		EBD('ppno'+n).value	=	'';
	}

	function fillF(n){
		EBD('ppno'+n).value	=	"<?php echo $pno+1?>";
	}
	
	function deleteRec(pkey, nm) {
		if(confirm("Click OK to delete " + nm) == false) return;
		
		location =	"deleteSubgroup.php?pkey=" + pkey + "&schStr=<?php echo $schStr?>&pno=<?php echo $pno?>&bgid=<?php echo $bgid?>";
	}

</script>