<?php

	class moduledb {

		protected $host			= SS_DB_HOST;
		protected $user			= SS_DB_USER;
		protected $password	= SS_DB_PASSWORD;
		protected $dbname		= SS_DB_DBNAME;
		protected $conn			= null;

		public function __construct($dbType = '') {
			
			if (!extension_loaded('pdo')) {
				die (SS_DB_ERR_101);
			}
			
			if($dbType == "REPORT") {
				$this->user 		= SS_RPT_USER;
				$this->password	= SS_RPT_PASSWORD;
			} else if($dbType == "DATA") {
				$this->user 		= SS_DBA_USER;
				$this->password	= SS_DBA_PASSWORD;			
			}
			
			try {
				$this->conn = new PDO("mysql:host=".$this->host.";dbname=".$this->dbname, $this->user, $this->password);
				$this->conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
			} catch(PDOException $e) {
				die('DB connection error '.$e->getMessage());
			}			
				
		}
		
		public function __destruct() {
			$this->conn	= null;
		}
		
		private function ExecuteQuery($sql00) {
		
			$res	= false;

			try {
				
				$res	= $this->conn->query($sql00);
				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}
			
			return $res;
			
		}

		private function getRecordsetExecutingQuery($sql00) {
		
			$rows		= array();
		
			try {
				
				$result	= $this->conn->query($sql00);
				while($row = $result->fetch()) {
					$rows[]	=	$row;
				}
				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}		
		
			return $rows;
			
		}
		
		private function getResultExecutingQuery($sql00) {
		
			$rows		= array();
			$res		= "";
		
			try {
				
				$result	= $this->conn->query($sql00);
				if($row = $result->fetch()) {
					$res	=	$row[0];
				}
				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}
		
			return $res;
			
		}
		
		function getCompanyNameByCompanyID($CompanyID) {
			$CompanyID	= (int)$CompanyID;
			$sql				=	"SELECT `CompanyName` FROM `asys_companies` WHERE `CompanyID`='$CompanyID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		public function getNextID($tblName, $colName) {
			if(strpos($tblName, "'") !== false) return false;
			if(strpos($colName, "'") !== false) return false;
			
			if(strpos($tblName, '"') !== false) return false;
			if(strpos($colName, '"') !== false) return false;
			
			$maxid			=	0;
			$sql				=	"SELECT MAX(`$colName`) FROM `$tblName`";

			try {
				
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch())
					$maxid 	= $row[0];
					
			} catch(PDOException $e) {
				/*echo $e->getMessage();
				_queryLog($sql);
				return false;*/
			}

			$maxid++;
			return $maxid;
			
		}
				
		

		/*-----------------------------------------------------------------*/
		/***********************  SYSTEM LOG METHODS ***********************/

		function getSystemLogListBySQL($sql) {
			$sql				= addslashes($sql);
			$arr				=	array();
			
			try {
				
				/*$sql			=	"SELECT * FROM `asys_system_log` WHERE ``='$'";*/
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_system_log');
				while($row 	= $result->fetch()) { 
					$row->setModuleName($this->getModuleNameByModuleID($row->getModuleID()));
					$arr[]		= $row;
				}
				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}

			return $cclass;
		}

				

		/*------------------------------------------------------------*/
		/*********************** MODULE METHODS ***********************/

		function getModuleDetail($ModuleID) {
			$ModuleID	= (int)$ModuleID;
			$cclass			=	new asys_modules();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_modules` WHERE `ModuleID`='$ModuleID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_modules');
				if($row 	= $result->fetch()) { 
					$row->setCompanyName( $this->getCompanyNameByCompanyID( $row->getCompanyID()));
					$row->setColumnList($this->getModuleColumnList($row->getModuleID()));
					$row->setVoucherConfigList($this->getModuleVoucherConfigList($row->getModuleID()));
					$row->setStockConfigList($this->getModuleStockConfigList($row->getModuleID()));
					$row->setSubmoduleList($this->getModuleSubModuleList($row->getModuleID()));
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}

			return $cclass;
		}
		
		function getModuleColumnList($ModuleID) {
			$ModuleID		= (int)$ModuleID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_module_columns` WHERE `ModuleID`='$ModuleID' ORDER BY `SerialNo`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_module_columns');
				while($row = $result->fetch()) {
					$row->setEventList($this->getModuleColumnEventList($row->getModuleID(), $row->getColumnName()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}

			return $arr;
		}
		
		function getModuleColumnDetail($ModuleID, $ColumnName) {
			$ModuleID		= (int)$ModuleID;
			$ColumnName	= addslashes($ColumnName);
			$cls				=	new asys_module_columns();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_module_columns` WHERE `ModuleID`='$ModuleID' AND `ColumnName`='$ColumnName'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_module_columns');
				while($row = $result->fetch()) {
					$row->setEventList($this->getModuleColumnEventList($row->getModuleID(), $row->getColumnName()));
					$cls		= $row;
				}
				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}

			return $cls;
		}
		
		function getModuleColumnEventList($ModuleID, $ColumnName) {
			$ModuleID		= (int)$ModuleID;
			$ColumnName	= addslashes($ColumnName);
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_module_column_events` WHERE `ModuleID`='$ModuleID' AND `ColumnName`='$ColumnName' ORDER BY `EventName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_module_column_events');
				while($row = $result->fetch()) {
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}

			return $arr;
		}
		
		function getModuleVoucherConfigList($ModuleID) {
			$ModuleID		= (int)$ModuleID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_module_voucher_config` WHERE `ModuleID`='$ModuleID' ORDER BY `VoucherConfigID`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_module_voucher_config');
				while($row = $result->fetch()) {
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}

			return $arr;
		}
		
		function getModuleStockConfigList($ModuleID) {
			$ModuleID		= (int)$ModuleID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_module_stock_config` WHERE `ModuleID`='$ModuleID' ORDER BY `StockConfigID`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_module_stock_config');
				while($row = $result->fetch()) {
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}

			return $arr;
		}
		
		function getModuleSubModuleList($ModuleID) {
			$ModuleID		= (int)$ModuleID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_module_submodules` WHERE `ModuleID`='$ModuleID' ORDER BY `SubmoduleID`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_module_submodules');
				while($row = $result->fetch()) {
					$arr[]	= $row;				
				}
				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}

			return $arr;
		}
		
		function getModuleViewDetail($ModuleID) {
			$ModuleID		= (int)$ModuleID;
			$cclass			=	new asys_module_views();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_module_views` WHERE `ModuleID`='$ModuleID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_module_views');
				if($row 	= $result->fetch()) {
					$row->setFieldList($this->getModuleViewFieldList($row->getModuleID()));
					$row->setSearchList($this->getModuleViewSearchList($row->getModuleID())); 	
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}

			return $cclass;
		}
		
		function getModuleViewFieldList($ModuleID) {
			$ModuleID	= (int)$ModuleID;
			$arr			=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_module_view_fields` WHERE `ModuleID`='$ModuleID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_module_view_fields');
				while($row = $result->fetch()) {
					$arr[]	= $row;				
				}
				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}

			return $arr;
		}
		
		function getModuleViewSearchList($ModuleID) {
			$ModuleID	= (int)$ModuleID;
			$arr			=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_module_view_search` WHERE `ModuleID`='$ModuleID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_module_view_search');
				while($row = $result->fetch()) {
					$arr[]	= $row;				
				}
				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}

			return $arr;
		}
		
		function getModuleList() {
			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_modules` ORDER BY `ModuleType`, `ModuleName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_modules');
				while($row = $result->fetch()) {
					$row->setCompanyName( $this->getCompanyNameByCompanyID( $row->getCompanyID()));
					$row->setColumnList($this->getModuleColumnList($row->getModuleID()));
					$row->setVoucherConfigList($this->getModuleVoucherConfigList($row->getModuleID()));
					$row->setStockConfigList($this->getModuleStockConfigList($row->getModuleID()));
					$row->setSubmoduleList($this->getModuleSubModuleList($row->getModuleID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}

			return $arr;
		}
		
		function getCompanyWiseModuleList($CompanyID) {
			$CompanyID	= (int)$CompanyID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_modules` WHERE `CompanyID`='$CompanyID' AND `ShowInMenu`='YES' AND `ModuleType`!='Submodule' ORDER BY `ModuleType`, `ModuleName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_modules');
				while($row = $result->fetch()) {
					$row->setCompanyName( $this->getCompanyNameByCompanyID( $row->getCompanyID()));
					$row->setColumnList($this->getModuleColumnList($row->getModuleID()));
					$row->setVoucherConfigList($this->getModuleVoucherConfigList($row->getModuleID()));
					$row->setStockConfigList($this->getModuleStockConfigList($row->getModuleID()));
					$row->setSubmoduleList($this->getModuleSubModuleList($row->getModuleID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}

			return $arr;
		}
		
		function getCompanyTypeWiseModuleList($CompanyID, $ModuleType) {
			$CompanyID	= (int)$CompanyID;
			$ModuleType	= addslashes($ModuleType);
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_modules` WHERE `CompanyID`='$CompanyID' AND `ModuleType`='$ModuleType' AND `ShowInMenu` = 'YES' ORDER BY `ModuleID`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_modules');
				while($row = $result->fetch()) {
					$row->setCompanyName( $this->getCompanyNameByCompanyID( $row->getCompanyID()));
					$row->setColumnList($this->getModuleColumnList($row->getModuleID()));
					$row->setVoucherConfigList($this->getModuleVoucherConfigList($row->getModuleID()));
					$row->setStockConfigList($this->getModuleStockConfigList($row->getModuleID()));
					$row->setSubmoduleList($this->getModuleSubModuleList($row->getModuleID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}

			return $arr;
		}
		
		function getRelatableModuleListJSON($CompanyID) {
			$CompanyID	= (int)$CompanyID;
				
			if($CompanyID != 0)
				$sql			=	"SELECT `TableName`, `ModuleName` FROM `asys_modules` WHERE `CompanyID` IN(0, $CompanyID) AND `ModuleType` IN('Master') ORDER BY `ModuleType`, `ModuleName`";
			else
				$sql			=	"SELECT `TableName`, `ModuleName` FROM `asys_modules` WHERE `CompanyID`='0' AND `ModuleType` IN('Master') ORDER BY `ModuleType`, `ModuleName`";

			return $this->getRecordsetExecutingQuery($sql);

		}
		
		function getModulesWithRelatedTable($RelatedTable) {
			$RelatedTable	= addslashes($RelatedTable);
			
			$sql			=	"SELECT `asys_module_columns`.`ModuleID`, `asys_module_columns`.`ColumnName` FROM `asys_module_columns` INNER JOIN `asys_modules` ON `asys_module_columns`.`ModuleID`=`asys_modules`.`ModuleID` WHERE `asys_module_columns`.`RelatedTable`='$RelatedTable' AND `asys_modules`.`ModuleType` != 'Submodule'";

			return $this->getRecordsetExecutingQuery($sql);		
		}
		
		function getModuleListJSON(){
		
			$sql		= "SELECT `ModuleID`, `ModuleName` FROM `asys_modules` ORDER BY `ModuleName`";
			return $this->getRecordsetExecutingQuery($sql);
		
		}
		
		function getCompanyWiseModuleListJSON($CompanyID){
		
			$CompanyID	= (int)$CompanyID;
			$sql				= "SELECT `ModuleID`, `ModuleName` FROM `asys_modules` WHERE `CompanyID`='$CompanyID' ORDER BY `ModuleName`";
			return $this->getRecordsetExecutingQuery($sql);
		
		}
		
		function getCompanyWiseSubModuleListJSON($CompanyID){
		
			$CompanyID	= (int)$CompanyID;
			$sql				= "SELECT `ModuleID`, `ModuleName` FROM `asys_modules` WHERE `CompanyID`='$CompanyID' AND `ModuleType`='Submodule' ORDER BY `ModuleName`";
			return $this->getRecordsetExecutingQuery($sql);
		
		}
		
		function getNumberOfModule($ModuleID, $ModuleName, $ModuleType) {
			$ModuleID			= (int)$ModuleID;
			$ModuleName		= addslashes($ModuleName);
			$ModuleType		= addslashes($ModuleType);
			
			$sql			=	"SELECT COUNT(*) FROM `asys_modules` WHERE 1=1";
			if($ModuleID != 0)
				$sql		= $sql." AND `ModuleID`='$ModuleID'";
			if($ModuleName != "")
				$sql		= $sql." AND `ModuleName` LIKE '%$ModuleName%'";
			if($ModuleType != "")
				$sql		= $sql." AND `ModuleType`='$ModuleType'";

			
			return $this->getResultExecutingQuery($sql);
		}

		function getModuleListPaged($sRec, $nRec, $ModuleID, $ModuleName, $ModuleType) {
			$sRec					= (int)$sRec;
			$nRec					= (int)$nRec;
			$ModuleID			= (int)$ModuleID;
			$ModuleName		= addslashes($ModuleName);
			$ModuleType		= addslashes($ModuleType);
			
			$sql			=	"SELECT * FROM `asys_modules` WHERE 1=1";
			if($ModuleID != 0)
				$sql		= $sql." AND `ModuleID`='$ModuleID'";
			if($ModuleName != "")
				$sql		= $sql." AND `ModuleName` LIKE '%$ModuleName%'";
			if($ModuleType != "")
				$sql		= $sql." AND `ModuleType`='$ModuleType'";			
			
			$sql			=	$sql." ORDER BY `ModuleName` LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_modules');
				while($row = $result->fetch()) {
					$row->setCompanyName( $this->getCompanyNameByCompanyID( $row->getCompanyID()));
					$row->setColumnList($this->getModuleColumnList($row->getModuleID()));
					$row->setVoucherConfigList($this->getModuleVoucherConfigList($row->getModuleID()));
					$row->setStockConfigList($this->getModuleStockConfigList($row->getModuleID()));
					$row->setSubmoduleList($this->getModuleSubModuleList($row->getModuleID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}

			return $arr;
		}

		function getModuleNameByModuleID($ModuleID) {
			$ModuleID	= (int)$ModuleID;
			$sql			=	"SELECT `ModuleName` FROM `asys_modules` WHERE `ModuleID`='$ModuleID'";
			return $this->getResultExecutingQuery($sql);
		}

		function deleteModule($lcls) {
		
			$pkey				= $lcls->getModuleID();
			$ret				= false;
		
				
			try {
			
				$this->conn->beginTransaction();
			

				$sql		= $lcls->getDeleteSQL();
				$this->conn->query($sql);
				
				$sql		= "DELETE FROM `asys_module_columns` WHERE `ModuleID` = '".$pkey."'";
				$this->conn->query($sql);
				$sql		= "DELETE FROM `asys_module_column_events` WHERE `ModuleID` = '".$pkey."'";
				$this->conn->query($sql);
				$sql		= "DELETE FROM `asys_module_stock_config` WHERE `ModuleID` = '".$pkey."'";
				$this->conn->query($sql);
				$sql		= "DELETE FROM `asys_module_voucher_config` WHERE `ModuleID` = '".$pkey."'";
				$this->conn->query($sql);
				$sql		= "DELETE FROM `asys_module_submodules` WHERE `ModuleID` = '".$pkey."'";
				$this->conn->query($sql);
				$sql		= "DELETE FROM `asys_module_views` WHERE `ModuleID` = '".$pkey."'";
				$this->conn->query($sql);
				$sql		= "DELETE FROM `asys_module_view_search` WHERE `ModuleID` = '".$pkey."'";
				$this->conn->query($sql);
				$sql		= "DELETE FROM `asys_module_view_fields` WHERE `ModuleID` = '".$pkey."'";
				$this->conn->query($sql);
				$sql		= "DELETE FROM `asys_user_permission` WHERE `ModuleID` = '".$pkey."'";
				$this->conn->query($sql);
				
				$sql		= "DROP TABLE `gen_module".$pkey."`";
				$this->conn->query($sql);			
				
				$ret	= true;
				
				
				/* Delete related files */
				$mid		= $pkey;
				
				$tblname		= "gen_module".$mid;
				$fpath			=	ABSPATH."/dao/class.".$tblname.".php";
				@unlink($fpath);
				
				$smlList		= $lcls->getSubmoduleList();
				for($i=0;$i<count($smlList);$i++) {
					$scls			=	$smlList[$i];
					$tblname	= "gen_module".$mid."_submodule".($i+1);
					$fpath		=	ABSPATH."/dao/class.".$tblname.".php";
					@unlink($fpath);
					
					$sql		= "DROP TABLE `gen_module".$pkey."_submodule".($i+1)."`";
					$this->conn->query($sql);						
				}
				
				$tblname		= "moduledb".$mid;
				$fpath			=	ABSPATH."/dao/class.".$tblname.".php";
				@unlink($fpath);
				
				$tblname		= "newModule".$mid;
				$fpath			=	ABSPATH."/".$tblname.".php";
				@unlink($fpath);
				
				$tblname		= "editModule".$mid;
				$fpath			=	ABSPATH."/".$tblname.".php";
				@unlink($fpath);

				$tblname		= "viewModule".$mid;
				$fpath			=	ABSPATH."/".$tblname.".php";
				@unlink($fpath);
				
				$tblname		= "deleteModule".$mid;
				$fpath			=	ABSPATH."/".$tblname.".php";
				@unlink($fpath);
				
				if($lcls->getModuleType() == "Master") {
					$tblname		= "getModule".$mid."List";
					$fpath			=	ABSPATH."/json/".$tblname.".php";
					@unlink($fpath);
				}
				
				$tblname		= "Module".$mid."Detail";
				$fpath			=	ABSPATH."/".$tblname.".php";
				@unlink($fpath);					
				/* File deletion ends here */
				
				
				$this->conn->commit();
			
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				echo $er->getMessage();
				$mid	= -1;
				
			}

		
			return $ret;
		}
		
		function createModule($mcls, $viewcls) {
			
			$mcls->setModuleID($this->getNextID("asys_modules","ModuleID"));
			$mid					= $mcls->getModuleID();
			$viewcls->setModuleID($mid);
			$logSQL				= "";
			
				
			try {
			
				$this->conn->beginTransaction();
				
				$csql			= "CREATE TABLE `gen_module".$mid."` (\n";
				$pkey			= array();
				$ukey			= array();
				
				$clmList	= $mcls->getColumnList();
				for($i=0;$i<count($clmList);$i++) {
					$ccls		=	$clmList[$i];
					$ccls->setModuleID($mid);
					$ccls->setSerialNo($i+1);

					$sql		= $ccls->getInsertSQL();
					$this->conn->exec($sql);
					if($logSQL != "") $logSQL = $logSQL.";\n";
					$logSQL	= $logSQL.$sql;
					
					if($ccls->getPrimaryKey() == "YES") {
						$pkey[]	= $ccls->getColumnName();
						if($ccls->getColumnLength() > 0) {
							if($ccls->getColumnLength() > 255)
								$ccls->setColumnLength(255);
						}							
					}
					if($ccls->getUniqueKey() == "YES") {
						$ukey[]	= $ccls->getColumnName();
						if($ccls->getColumnLength() > 0) {
							if($ccls->getColumnLength() > 255)
								$ccls->setColumnLength(255);
						}
					}
						
					if($i > 0) $csql	= $csql.",\n";
					
					if($ccls->getInputType() == "checkbox") {
						$csql		= $csql."`".$ccls->getColumnName()."` enum('YES','NO') COLLATE utf8_unicode_ci NOT NULL DEFAULT 'YES'";
					} else {
						$csql		= $csql."`".$ccls->getColumnName()."` ".$ccls->getColumnDataType();
						if($ccls->getColumnLength() > 0) $csql	= $csql."(".$ccls->getColumnLength().")";
						if($ccls->getColumnDataType() == "varchar" || $ccls->getColumnDataType() == "text" || $ccls->getColumnDataType() == "enum")
							$csql	= $csql." COLLATE utf8_unicode_ci ";
						$csql		= $csql." NOT NULL";
					}
				}
				$csql			= $csql.") ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;\n\n";
				
				if(count($pkey) > 0) {
					$csql	= $csql."ALTER TABLE `gen_module".$mid."`\n";
					$csql	= $csql."ADD PRIMARY KEY (";
					for($k=0;$k<count($pkey);$k++) {
						if($k > 0) $csql	= $csql.",";
						$csql	= $csql."`".$pkey[$k]."`";
					}
					$csql	= $csql.")\n";
					if(count($ukey) > 0) {
						$csql	= $csql.",\nADD UNIQUE (";
						for($k=0;$k<count($ukey);$k++) {
							if($k > 0) $csql	= $csql.",";
							$csql	= $csql."`".$ukey[$k]."`";
						}
						$csql	= $csql.")";
					}
					$csql	= $csql.";\n";
				} else {
					if(count($ukey) > 0) {
						$csql	= $csql."ALTER TABLE `gen_module".$mid."`\n";
						$csql	= $csql."ADD UNIQUE (";
						for($k=0;$k<count($ukey);$k++) {
							if($k > 0) $csql	= $csql.",";
							$csql	= $csql."`".$ukey[$k]."`";
						}
						$csql	= $csql.");\n";
					}
				}
				
				
				$vid			= $this->getNextID("asys_module_voucher_config", "VoucherConfigID");
				$vcfList	= $mcls->getVoucherConfigList();
				for($i=0;$i<count($vcfList);$i++) {
					$vcls	=	$vcfList[$i];
					$vcls->setModuleID($mid);
					$vcls->setVoucherConfigID($vid);

					$sql		= $vcls->getInsertSQL();
					$this->conn->exec($sql);
					if($logSQL != "") $logSQL = $logSQL.";\n";
					$logSQL	= $logSQL.$sql;
					
					$vid++;
				}
				
				$sid			= $this->getNextID("asys_module_stock_config", "StockConfigID");
				$scfList	= $mcls->getStockConfigList();
				for($i=0;$i<count($scfList);$i++) {
					$scls	=	$scfList[$i];
					$scls->setModuleID($mid);
					$scls->setStockConfigID($sid);

					$sql		= $scls->getInsertSQL();
					$this->conn->exec($sql);
					if($logSQL != "") $logSQL = $logSQL.";\n";
					$logSQL	= $logSQL.$sql;
					
					$sid++;
				}
				
				$msql			= array();
				$smlList	= $mcls->getSubmoduleList();
				for($i=0;$i<count($smlList);$i++) {
					$scls	=	$smlList[$i];
					$scls->setModuleID($mid);
					
					$_smdet		= $this->getModuleDetail($scls->getSubmoduleID());
					$smcsql		= "\nCREATE TABLE `gen_module".$mid."_submodule".($i+1)."` (\n";
					$smpkey		= array();
					$smukey		= array();
				
					$clmList	= $_smdet->getColumnList();
					for($j=0;$j<count($clmList);$j++) {
						$ccls	=	$clmList[$j];
					
						if($ccls->getPrimaryKey() == "YES") {
							$smpkey[]	= $ccls->getColumnName();
							if($ccls->getColumnLength() > 0) {
								if($ccls->getColumnLength() > 255)
									$ccls->setColumnLength(255);
							}
						}
						if($ccls->getUniqueKey() == "YES") {
							$smukey[]	= $ccls->getColumnName();
							if($ccls->getColumnLength() > 0) {
								if($ccls->getColumnLength() > 255)
									$ccls->setColumnLength(255);
							}								
						}
						
						if($j > 0) $smcsql	= $smcsql.",\n";
					
						if($ccls->getInputType() == "checkbox") {
							$smcsql		= $smcsql."`".$ccls->getColumnName()."` enum('YES','NO') COLLATE utf8_unicode_ci NOT NULL DEFAULT 'YES'";
						} else {
							$smcsql		= $smcsql."`".$ccls->getColumnName()."` ".$ccls->getColumnDataType();
							if($ccls->getColumnLength() > 0) $smcsql	= $smcsql."(".$ccls->getColumnLength().")";
							if($ccls->getColumnDataType() == "varchar" || $ccls->getColumnDataType() == "text" || $ccls->getColumnDataType() == "enum")
								$smcsql	= $smcsql." COLLATE utf8_unicode_ci ";
							$smcsql		= $smcsql." NOT NULL";
						}
					}
					$smcsql			= $smcsql.") ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;\n\n";
				
					if(count($smpkey) > 0) {
						$smcsql	= $smcsql."ALTER TABLE `gen_module".$mid."_submodule".($i+1)."`\n";
						$smcsql	= $smcsql."ADD PRIMARY KEY (";
						for($k=0;$k<count($smpkey);$k++) {
							if($k > 0) $smcsql	= $smcsql.",";
							$smcsql	= $smcsql."`".$smpkey[$k]."`";
						}
						$smcsql	= $smcsql.")\n";
						if(count($smukey) > 0) {
							$smcsql	= $smcsql.",\nADD UNIQUE (";
							for($k=0;$k<count($smukey);$k++) {
								if($k > 0) $smcsql	= $smcsql.",";
								$smcsql	= $smcsql."`".$smukey[$k]."`";
							}
							$smcsql	= $smcsql.");\n";
						}
					} else {
						if(count($smukey) > 0) {
							$smcsql	= $smcsql."ALTER TABLE `gen_module".$mid."_submodule".($i+1)."`\n";
							$smcsql	= $smcsql."ADD UNIQUE (";
							for($k=0;$k<count($smukey);$k++) {
								if($k > 0) $smcsql	= $smcsql.",";
								$smcsql	= $smcsql."`".$smukey[$k]."`";
							}
							$smcsql	= $smcsql.")";
						}
						$smcsql	= $smcsql.";\n";
					}
					$msql[]	= $smcsql;

					$sql		= $scls->getInsertSQL();
					$this->conn->exec($sql);
					if($logSQL != "") $logSQL = $logSQL.";\n";
					$logSQL	= $logSQL.$sql;						
				}
				
				$mcls->setTableName("gen_module".$mid);
				$sql	= $mcls->getInsertSQL();
				$this->conn->exec($sql);
				if($logSQL != "") $logSQL = $logSQL.";\n";
				$logSQL	= $logSQL.$sql;
				
				
				/* view / Search */
				$sql	= $viewcls->getInsertSQL();
				$this->conn->exec($sql);
				if($logSQL != "") $logSQL = $logSQL.";\n";
				$logSQL	= $logSQL.$sql;
				
				$vfList	= $viewcls->getFieldList();
				for($i=0;$i<count($vfList);$i++) {
					$fcls	=	$vfList[$i];
					$fcls->setModuleID($mid);

					$sql		= $fcls->getInsertSQL();
					$this->conn->exec($sql);
					if($logSQL != "") $logSQL = $logSQL.";\n";
					$logSQL	= $logSQL.$sql;
				}
				
				$vsList	= $viewcls->getSearchList();
				for($i=0;$i<count($vsList);$i++) {
					$scls	=	$vsList[$i];
					$scls->setModuleID($mid);

					$sql		= $scls->getInsertSQL();
					$this->conn->exec($sql);
					if($logSQL != "") $logSQL = $logSQL.";\n";
					$logSQL	= $logSQL.$sql;
				}
				

				/* Create the database tables for the module */
				if($mcls->getModuleType() == "Master" || $mcls->getModuleType() == "Transaction") {
					$this->conn->exec($csql);
					if($logSQL != "") $logSQL = $logSQL.";\n";
					$logSQL	= $logSQL.$csql;
					
					for($i=0;$i<count($msql);$i++) {
						$sql	= $msql[$i];
						$this->conn->exec($sql);
						if($logSQL != "") $logSQL = $logSQL.";\n";
						$logSQL	= $logSQL.$sql;
					}
				}
				/* Table creation ends here */
				
				$this->conn->commit();
				
				
				/* Write SQL related to Module to file  */
				$fpath		=	ABSPATH."/mysqlDump/Module".$mid.".sql";
				$sqlFile 	= fopen ($fpath,"a+");
				fwrite($sqlFile, $logSQL);
				fclose($sqlFile);
				/* Written to File */
				
				
				/* Generate the files */
				if($mcls->getModuleType() == "Master" || $mcls->getModuleType() == "Transaction") {
					$tblname		= "gen_module".$mid;
					$cstr				= $this->getClassCodePHP($mcls);
					$fpath			=	ABSPATH."/dao/class.".$tblname.".php";
					$codeFile 	= fopen ($fpath, "a+");
					fwrite($codeFile, $cstr);
					fclose($codeFile);
				
					$smlList		= $mcls->getSubmoduleList();
					for($i=0;$i<count($smlList);$i++) {
						$scls			=	$smlList[$i];
						$smid			= $scls->getSubmoduleID();
						$tmpcls		= $this->getModuleDetail($smid);
						$tblname	= "gen_module".$mid."_submodule".($i+1);
						$cstr			= $this->getClassCodePHP($tmpcls, $tblname);
						$fpath		=	ABSPATH."/dao/class.".$tblname.".php";
						$codeFile = fopen ($fpath, "a+");
						fwrite($codeFile, $cstr);
						fclose($codeFile);
					}
				
					$tblname		= "moduledb".$mid;
					$cstr				= $this->getDBCodePHP($mcls, $viewcls);
					$fpath			=	ABSPATH."/dao/class.".$tblname.".php";
					$codeFile 	= fopen ($fpath, "a+");
					fwrite($codeFile, $cstr);
					fclose($codeFile);
				
					$tblname		= "newModule".$mid;
					$cstr				= $this->getNewCodePHP($mcls);
					$fpath			=	ABSPATH."/".$tblname.".php";
					$codeFile 	= fopen ($fpath, "a+");
					fwrite($codeFile, $cstr);
					fclose($codeFile);
				
					$tblname		= "editModule".$mid;
					$cstr				= $this->getEditCodePHP($mcls, $viewcls);
					$fpath			=	ABSPATH."/".$tblname.".php";
					$codeFile 	= fopen ($fpath, "a+");
					fwrite($codeFile, $cstr);
					fclose($codeFile);

					$tblname		= "viewModule".$mid;
					$cstr				= $this->getViewCodePHP($mcls, $viewcls);
					$fpath			=	ABSPATH."/".$tblname.".php";
					$codeFile 	= fopen ($fpath, "a+");
					fwrite($codeFile, $cstr);
					fclose($codeFile);
				
					$tblname		= "deleteModule".$mid;
					$cstr				= $this->getDeleteCodePHP($mcls, $viewcls);
					$fpath			=	ABSPATH."/".$tblname.".php";
					$codeFile 	= fopen ($fpath, "a+");
					fwrite($codeFile, $cstr);
					fclose($codeFile);
				
				}
				/* File generation ends here */
				
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				echo $er->getMessage();
				$mid	= -1;
				
			}

			
			return $mid;
			
		}
		
		function getValueFieldsFromTable($tblName) {
			$tblName	= addslashes($tblName);
			$sql			= "DESC ".$tblName;
			$fields		=	$this->getRecordSetExecutingQuery($sql);
			$n				= count($fields);
			$arr			= array();
			
			for($i=0;$i<$n;$i++) {
				$row		=	$fields[$i];
				if($row[3] == "PRI") {
					$arr[]	= $row;
					break;
				}
			}

			return $arr;
		}
		
		function getDisplayFieldsFromTable($tblName) {
			$tblName	= addslashes($tblName);
			$sql			= "DESC ".$tblName;
			$fields		=	$this->getRecordSetExecutingQuery($sql);

			return $fields;
		}
		
		
		
		/************************************************
		 * This method creates the Class (new)
		 * with getter, setter, Save, Update and Display
		 ************************************************/
		 
		function getClassCodePHP($mcls, $tblname = '') {
			if($tblname == '')
				$tblname	= "gen_module".$mcls->getModuleID();
			$NoSM			= count($mcls->getSubmoduleList());
			
			$clmList	= $mcls->getColumnList();
			$n				= count($clmList);
			$pKey			=	"";

			$rMsg	=	"<?php";
			$rMsg	=	$rMsg."\n\n\t/**";
			$rMsg	=	$rMsg."\n\t * Author - adapSys code generator. Generated on - ".date("M d, Y");
			$rMsg	=	$rMsg."\n\t */\n";
			$rMsg	=	$rMsg."\n\t/**";
			$rMsg	=	$rMsg."\n\t * (c) 2018 Swastika Systems (adapSys), All Rights Reserved.";
			$rMsg	=	$rMsg."\n\t */\n";
			$rMsg	= $rMsg."\n\tclass ".$tblname." {";
			
			for($i=0;$i<$n;$i++) {
				$row	=	$clmList[$i];
				if($row->getPrimaryKey() == "YES") $pKey	=	$row->getColumnName();
				
				$rMsg	=	$rMsg."\n\t\t/**";
				$rMsg	=	$rMsg."\n\t\t * @Field\t\t".$row->getColumnName();
				$rMsg	=	$rMsg."\n\t\t * @Type\t\t".$row->getColumnDataType();
				$rMsg	=	$rMsg."\n\t\t * @Access\tProtected";
				$rMsg	=	$rMsg."\n\t\t */";
				$rMsg	=	$rMsg."\n\t\tprotected $".$row->getColumnName()." = ";
				if($row->getColumnDataType() == "varchar" || $row->getColumnDataType() == "text")
					$rMsg	=	$rMsg."\"\";\n";
				else if($row->getColumnDataType() == "date")
					$rMsg	=	$rMsg."\"\";\n";
				else
					$rMsg	= $rMsg."0;\n";
					
				if( $row->getRelatedTable() != "") {
					$rMsg	=	$rMsg."\n\t\t/**";
					$rMsg	=	$rMsg."\n\t\t * @Field\t\t".$row->getColumnName()."Name";
					$rMsg	=	$rMsg."\n\t\t * @Type\t\t".$row->getColumnDataType();
					$rMsg	=	$rMsg."\n\t\t * @Access\tProtected";
					$rMsg	=	$rMsg."\n\t\t */";
					$rMsg	=	$rMsg."\n\t\tprotected $".$row->getColumnName()."Name = \"\";\n";
				}
			}
			
			for($i=1;$i<=$NoSM;$i++) {
				$rMsg	=	$rMsg."\n\t\t/**";
				$rMsg	=	$rMsg."\n\t\t * @Field\tSubmoduleList".$i;
				$rMsg	=	$rMsg."\n\t\t * @Type\t\tArray()";
				$rMsg	=	$rMsg."\n\t\t * @Access\tProtected";
				$rMsg	=	$rMsg."\n\t\t */";
				$rMsg	=	$rMsg."\n\t\tprotected $"."SubmoduleList".$i." = array();\n";
			}
			
			$rMsg	=	$rMsg."\n\t\t/**";
			$rMsg	=	$rMsg."\n\t\t * Constructor, particularly for PHP PDO";
			$rMsg	=	$rMsg."\n\t\t */";
			
			$rMsg	=	$rMsg."\n\t\tpublic function __construct() {";
			
			for($i=0;$i<$n;$i++) {
				$row	=	$clmList[$i];
				if($row->getColumnDataType() == "varchar" || $row->getColumnDataType() == "text" || $row->getColumnDataType() == "date")
					$rMsg	=	$rMsg."\n\t\t\t$"."this->".$row->getColumnName()." = addslashes($"."this->".$row->getColumnName().");";
				else if($row->getColumnDataType() == "bigint" || $row->getColumnDataType() == "int" || $row->getColumnDataType() == "smallint" || $row->getColumnDataType() == "tinyint" || $row->getColumnDataType() == "mediumint")
					$rMsg	=	$rMsg."\n\t\t\t$"."this->".$row->getColumnName()." = (int)$"."this->".$row->getColumnName().";";
				else if($row->getColumnDataType() == "float" || $row->getColumnDataType() == "double" || $row->getColumnDataType() == "decimal")
					$rMsg	=	$rMsg."\n\t\t\t$"."this->".$row->getColumnName()." = (double)$"."this->".$row->getColumnName().";";			
			}
			$rMsg	=	$rMsg."\n\t\t}\n";
			
			
			

			$rMsg	=	$rMsg."\n\t\t/**";
			$rMsg	=	$rMsg."\n\t\t * Getter Methods to retrive the values of the Variables of the Class";
			$rMsg	=	$rMsg."\n\t\t */";

			for($i=0;$i<$n;$i++) {
				$row	=	$clmList[$i];
				$rMsg	=	$rMsg."\n\t\tpublic function get".$row->getColumnName()."($"."formatted='no') {";
				$rMsg	=	$rMsg."\n\t\t\tif($"."formatted == 'yes') {";

				if($row->getColumnDataType() == "varchar" || $row->getColumnDataType() == "text")
					$rMsg	=	$rMsg."\n\t\t\t\treturn htmlspecialchars(stripslashes($"."this->".$row->getColumnName()."),ENT_QUOTES);";
				else if($row->getColumnDataType() == "date")
					$rMsg	=	$rMsg."\n\t\t\t\treturn FormatSQLDateToIndianDate($"."this->".$row->getColumnName().");";
				else if($row->getColumnDataType() == "bigint" || $row->getColumnDataType() == "int" || $row->getColumnDataType() == "smallint" || $row->getColumnDataType() == "tinyint" || $row->getColumnDataType() == "mediumint" || $row->getColumnDataType() == "float" || $row->getColumnDataType() == "double" || $row->getColumnDataType() == "decimal")
					$rMsg	=	$rMsg."\n\t\t\t\treturn number_format($"."this->".$row->getColumnName().",2,'.',',');";
				
				$rMsg	=	$rMsg."\n\t\t\t} else if($"."formatted=='asis') {";
				$rMsg	=	$rMsg."\n\t\t\t\treturn $"."this->".$row->getColumnName().";";
				$rMsg	=	$rMsg."\n\t\t\t} else {";
				if($row->getColumnDataType() == "varchar" || $row->getColumnDataType() == "text" || $row->getColumnDataType() == "date")
					$rMsg	=	$rMsg."\n\t\t\t\treturn stripslashes($"."this->".$row->getColumnName().");";
				else
					$rMsg	=	$rMsg."\n\t\t\t\treturn $"."this->".$row->getColumnName().";";
				$rMsg	=	$rMsg."\n\t\t\t}";
				$rMsg	=	$rMsg."\n\t\t}\n";
				
				if( $row->getRelatedTable() != "") {
					$rMsg	=	$rMsg."\n\t\tpublic function get".$row->getColumnName()."Name($"."formatted='no') {";
					$rMsg	=	$rMsg."\n\t\t\tif($"."formatted == 'yes') {";	
					$rMsg	=	$rMsg."\n\t\t\t\treturn htmlspecialchars(stripslashes($"."this->".$row->getColumnName()."Name),ENT_QUOTES);";
					$rMsg	=	$rMsg."\n\t\t\t} else if($"."formatted=='asis') {";
					$rMsg	=	$rMsg."\n\t\t\t\treturn $"."this->".$row->getColumnName()."Name;";
					$rMsg	=	$rMsg."\n\t\t\t} else {";
					$rMsg	=	$rMsg."\n\t\t\t\treturn stripslashes($"."this->".$row->getColumnName()."Name);";
					$rMsg	=	$rMsg."\n\t\t\t}";
					$rMsg	=	$rMsg."\n\t\t}\n";
				}
			}
			
			for($i=1;$i<=$NoSM;$i++) {
				$rMsg	=	$rMsg."\n\t\tpublic function getSubmoduleList".$i."() {";
				$rMsg	=	$rMsg."\n\t\t\treturn $"."this->SubmoduleList".$i.";";	
				$rMsg	=	$rMsg."\n\t\t}\n";
			}			

			$rMsg	=	$rMsg."\n\t\t/**";
			$rMsg	=	$rMsg."\n\t\t * Setter Methods to set the values of the Variables of the Class";
			$rMsg	=	$rMsg."\n\t\t */";

			for($i=0;$i<$n;$i++) {
				$row	=	$clmList[$i];
				$rMsg	=	$rMsg."\n\t\tpublic function set".$row->getColumnName()."($"."arg) {";
				if($row->getColumnDataType() == "varchar" || $row->getColumnDataType() == "text" )
					$rMsg	=	$rMsg."\n\t\t\t$"."this->".$row->getColumnName()." = addslashes($"."arg);";
				else if($row->getColumnDataType() == "date")	
					$rMsg	=	$rMsg."\n\t\t\t$"."this->".$row->getColumnName()." = FormatIndianDateToSQLDate($"."arg);";
				else if($row->getColumnDataType() == "bigint" || $row->getColumnDataType() == "int" || $row->getColumnDataType() == "smallint" || $row->getColumnDataType() == "tinyint" || $row->getColumnDataType() == "mediumint")
					$rMsg	=	$rMsg."\n\t\t\t$"."this->".$row->getColumnName()." = (int)$"."arg;";
				else if($row->getColumnDataType() == "float" || $row->getColumnDataType() == "double" || $row->getColumnDataType() == "decimal")
					$rMsg	=	$rMsg."\n\t\t\t$"."this->".$row->getColumnName()." = (double)$"."arg;";
				$rMsg	=	$rMsg."\n\t\t}\n";
				
				if( $row->getRelatedTable() != "") {
					$rMsg	=	$rMsg."\n\t\tpublic function set".$row->getColumnName()."Name($"."arg) {";
					$rMsg	=	$rMsg."\n\t\t\t$"."this->".$row->getColumnName()."Name = addslashes($"."arg);";
					$rMsg	=	$rMsg."\n\t\t}\n";
				}
			}
			
			for($i=1;$i<=$NoSM;$i++) {
				$rMsg	=	$rMsg."\n\t\tpublic function setSubmoduleList".$i."($"."arg) {";
				$rMsg	=	$rMsg."\n\t\t\t$"."this->SubmoduleList".$i." = $"."arg;";
				$rMsg	=	$rMsg."\n\t\t}\n";
			}
			
			/***********************/
			/* Function Insert SQL */
			/***********************/

			$rMsg	=	$rMsg."\n\t\tpublic function getInsertSQL() {";
			$addCode	= "\n\n\t\t\t$"."sql	=	\"INSERT INTO `".$tblname."` (";

			for($i=0;$i<$n;$i++) {
				$row	=	$clmList[$i];
				if($i>0)
					$addCode	=	$addCode.", ";
				$addCode	=	$addCode."`".$row->getColumnName()."`";
			}
			$addCode	=	$addCode.") VALUES(\";";
			for($i=0;$i<$n;$i++) {
				$row	=	$clmList[$i];

				if($i<$n-1)
					$addCode	=	$addCode."\n\t\t\t$"."sql	=	$"."sql.\"'\".$"."this->get".$row->getColumnName()."('asis').\"', \";";
				else
					$addCode	=	$addCode."\n\t\t\t$"."sql	=	$"."sql.\"'\".$"."this->get".$row->getColumnName()."('asis').\"')\";";
			}

			$rMsg	=	$rMsg."\t\t".$addCode;
			$rMsg	=	$rMsg."\n\n\t\t\treturn $"."sql;";
			$rMsg	=	$rMsg."\n\t\t}";


			/***********************/
			/* Function Update SQL */
			/***********************/

			$rMsg	=	$rMsg."\n\n\t\tpublic function getUpdateSQL() {";
			$addCode	= "\n\n\t\t\t$"."sql	=	\"UPDATE `".$tblname."` SET \";";

			for($i=0;$i<$n;$i++) {
				$row	=	$clmList[$i];
				if($row->getPrimaryKey() != "YES") {
					if($i < $n-1)
						$addCode	=	$addCode."\n\t\t\t$"."sql	=	$"."sql.\"`".$row->getColumnName()."` = '\".$"."this->get".$row->getColumnName()."('asis').\"', \";";
					else
						$addCode	=	$addCode."\n\t\t\t$"."sql	=	$"."sql.\"`".$row->getColumnName()."` = '\".$"."this->get".$row->getColumnName()."('asis').\"' \";";
				}
			}
			
			for($i=0;$i<$n;$i++) {
				$row	=	$clmList[$i];
				if($row->getPrimaryKey() == "YES") {
					if($i == 0)
						$addCode	=	$addCode."\n\t\t\t$"."sql	=	$"."sql.\" WHERE "."`".$row->getColumnName()."` = '\".$"."this->get".$row->getColumnName()."('asis').\"'\";";
					else
						$addCode	=	$addCode."\n\t\t\t$"."sql	=	$"."sql.\" AND "."`".$row->getColumnName()."` = '\".$"."this->get".$row->getColumnName()."('asis').\"'\";";
				}
			}

			$rMsg	=	$rMsg."\t\t".$addCode;
			$rMsg	=	$rMsg."\n\n\t\t\treturn $"."sql;";
			$rMsg	=	$rMsg."\n\t\t}";
			
			
			/***********************/
			/* Function Delete SQL */
			/***********************/
			
			$rMsg	=	$rMsg."\n\n\t\tpublic function getDeleteSQL() {";
			$addCode	= "\n\n\t\t\t$"."sql	=	\"DELETE FROM `".$tblname."` \";";
			
			for($i=0;$i<$n;$i++) {
				$row	=	$clmList[$i];
				if($row->getPrimaryKey() == "YES") {
					if($i == 0)
						$addCode	=	$addCode."\n\t\t\t$"."sql	=	$"."sql.\" WHERE "."`".$row->getColumnName()."` = '\".$"."this->get".$row->getColumnName()."('asis').\"'\";";
					else
						$addCode	=	$addCode."\n\t\t\t$"."sql	=	$"."sql.\" AND "."`".$row->getColumnName()."` = '\".$"."this->get".$row->getColumnName()."('asis').\"'\";";
				}
			}
			
			$addCode	=	$addCode."\n\t\t\t$"."sql	=	$"."sql.\" LIMIT 1\";";

			$rMsg	=	$rMsg."\t\t".$addCode;
			$rMsg	=	$rMsg."\n\n\t\t\treturn $"."sql;";
			$rMsg	=	$rMsg."\n\t\t}";
			
			
			/****************************/
			/* Function Validate Fields */
			/****************************/
			
			$rMsg	=	$rMsg."\n\n\t\tpublic function validateFields() {";
			$addCode	= "\n\n\t\t\t$"."chk	=	true;";

			for($i=0;$i<$n;$i++) {
				$row	=	$clmList[$i];
				if($row->getPrimaryKey() == "YES" || $row->getIsMandatory() == "YES") {
					if(
						$row->getColumnDataType() == "int" ||
						$row->getColumnDataType() == "tinyint" ||
						$row->getColumnDataType() == "smallint" ||
						$row->getColumnDataType() == "mediumint" ||
						$row->getColumnDataType() == "bigint"
					) {
						$addCode	=	$addCode."\n\t\t\tif((int)$".$row->getColumnName()." <= 0) $"."chk	=	false;";
					} else if(
						$row->getColumnDataType() == "varchar" ||
						$row->getColumnDataType() == "text"
					) {
						$addCode	=	$addCode."\n\t\t\tif(trim($".$row->getColumnName().") == \"\") $"."chk	=	false;";
					}
					
				}
			}

			$rMsg	=	$rMsg."\t\t".$addCode;
			$rMsg	=	$rMsg."\n\n\t\t\treturn $"."chk;";
			$rMsg	=	$rMsg."\n\t\t}";
			
			
			/********************************/
			/* Function HTML representation */
			/********************************/
			
			$rMsg	=	$rMsg."\n\n\t\tpublic function getHTMLRepresentation() {";
			$addCode	= "\n\n\t\t\t$"."str	=	'";

			for($i=0;$i<$n;$i++) {
				$row	=	$clmList[$i];

				$addCode	=	$addCode."\n\t\t\t\t<div style=\"float:left;width:150px;\">".$row->getColumnLabel()."</div>";
				$addCode	=	$addCode."\n\t\t\t\t<div style=\"float:left;\">: '.$"."this->get".$row->getColumnName()."('yes').'</div>";
				$addCode	=	$addCode."\n\t\t\t\t<div style=\"clear:both;\"></div>";
			
			}
			$addCode	=	$addCode."\n\t\t\t';";

			$rMsg	=	$rMsg."\t\t".$addCode;
			$rMsg	=	$rMsg."\n\n\t\t\treturn $"."str;";
			$rMsg	=	$rMsg."\n\t\t}";
			
			
			$rMsg	=	$rMsg."\n\t};";
			$rMsg	=	$rMsg."\n\n?>";
			return $rMsg;
		}
		
		
		
		/*******************************************************
		 * This is the code to generate a php code that handles 
		 * the create code in HTML and PHP (New)
		 *******************************************************/                                    

		function getNewCodePHP($mcls) {
		
			$mid			= $mcls->getModuleID();
			$tblname		= "gen_module".$mid;
			$smlList	= $mcls->getSubmoduleList();
			$clmList	= $mcls->getColumnList();
			$n				= count($smlList);
			$cCnt			= count($clmList);
			
			$rMsg			= "<?php

	/* Include the required files */
	require_once( 'checkLogin.php' );
	require_once( 'dao/class.".$tblname.".php' );";
	
	for($i=0;$i<count($smlList);$i++) {
		$smname	= "gen_module".$mid."_submodule".($i+1);
		$rMsg		= $rMsg."
	require_once( 'dao/class.".$smname.".php' );";
	}
	
	$rMsg			= $rMsg."
	require_once( 'dao/class.moduledb".$mid.".php' );
	
	$"."ModuleID			= ".$mid.";

	$"."gdb					=	new genericdb();
	$"."mdb					=	new masterdb();
	$"."ldb					= new logindb();
	$"."mddb					=	new moduledb".$mid."();
	$"."cclass				= new ".$tblname."();
	
	if($"."ldb->getCreatePermission($"."tuser->getUserID(), $"."ModuleID, $"."tcmp->getCompanyID()) != \"YES\") {
		header(\"Location:accessDenied.php\");
		exit;
	}
							
			";
			
			for($i=0;$i<$cCnt;$i++) {
				$scls		=	$clmList[$i];
				if($i == 0)
					$rMsg	=	$rMsg."\n\t$".$scls->getColumnName()."	=	\"\";\n";
				else
					$rMsg	=	$rMsg."\t$".$scls->getColumnName()."	=	\"\";\n";
			}

			$rMsg = $rMsg."

	$"."rmsg					=	\"\";
	$"."msg					=	\"Please enter all the fields correctly.\";
	$"."pagen				=	\"\";";
	
	for($i=0;$i<$n;$i++) {
		$rMsg = $rMsg."
	$"."numSubModule".($i+1)."				=	\"\";
	$"."SubModuleArr".($i+1)."				= array();
		";
	}
	
	
	$rMsg = $rMsg."

	$"."fcss					=	 array();
	for($"."i=0;$"."i<".$cCnt.";$"."i++)
		$"."fcss[$"."i]		=	\"input\";";
	for($i=0;$i<$cCnt;$i++) {
		$scls		=	$clmList[$i];
		if($scls->getInputType() == "select") {
			$rMsg = $rMsg."
	$"."fcss[".$i."]		=	\"select\";";
		}
	}

	$rMsg = $rMsg."
	
	extract($"."_REQUEST);
	
	if($"."pagen == \"process\") {
		/* Check for valid input */
		";
		
			/* Check those fields for which Mandatory is set to YES */
			for($i=0;$i<$cCnt;$i++) {
				$scls		=	$clmList[$i];
				if($scls->getIsMandatory() == "YES") {
					if( $scls->getColumnDataType() == "int" ||
							$scls->getColumnDataType() == "tinyint" ||
							$scls->getColumnDataType() == "smallint" ||
							$scls->getColumnDataType() == "mediumint" ||
							$scls->getColumnDataType() == "bigint"
					) {
							$rMsg	= $rMsg."\n\t\tif((int)$".$scls->getColumnName()." <= 0) {";
							if($scls->getInputType() == "select") {
								$rMsg	= $rMsg."\n\t\t\t$"."fcss[".$i."]	=	\"err_select\";";
							} else {
								$rMsg	= $rMsg."\n\t\t\t$"."fcss[".$i."]	=	\"err_input\";";
							}
							$rMsg	= $rMsg."\n\t\t\tif($"."rmsg != \"\") $"."rmsg = $"."rmsg.\",\";";
							$rMsg	= $rMsg."\n\t\t\t$"."rmsg	=	$"."rmsg.\"".$scls->getColumnLabel()."\";";
							$rMsg	= $rMsg."\n\t\t}\n";
					} else if(
							$scls->getColumnDataType() == "decimal" ||
							$scls->getColumnDataType() == "float" ||
							$scls->getColumnDataType() == "double"
					) {
							$rMsg	= $rMsg."\n\t\tif((double)$".$scls->getColumnName()." <= 0) {";
							if($scls->getInputType() == "select") {
								$rMsg	= $rMsg."\n\t\t\t$"."fcss[".$i."]	=	\"err_select\";";
							} else {
								$rMsg	= $rMsg."\n\t\t\t$"."fcss[".$i."]	=	\"err_input\";";
							}
							$rMsg	= $rMsg."\n\t\t\tif($"."rmsg != \"\") $"."rmsg = $"."rmsg.\",\";";
							$rMsg	= $rMsg."\n\t\t\t$"."rmsg	=	$"."rmsg.\"".$scls->getColumnLabel()."\";";
							$rMsg	= $rMsg."\n\t\t}\n";
					} else if(
							$scls->getColumnDataType() == "varchar" ||
							$scls->getColumnDataType() == "enum" ||
							$scls->getColumnDataType() == "char" ||
							$scls->getColumnDataType() == "blob" ||
							$scls->getColumnDataType() == "tinyblob" ||
							$scls->getColumnDataType() == "mediumblob" ||
							$scls->getColumnDataType() == "longblob" ||
							$scls->getColumnDataType() == "text" ||
							$scls->getColumnDataType() == "tinytext" ||
							$scls->getColumnDataType() == "mediumtext" ||
							$scls->getColumnDataType() == "longtext"
					) {
							$rMsg	= $rMsg."\n\t\tif(trim($".$scls->getColumnName().") == \"\") {";
							if($scls->getInputType() == "select") {
								$rMsg	= $rMsg."\n\t\t\t$"."fcss[".$i."]	=	\"err_select\";";
							} else {
								$rMsg	= $rMsg."\n\t\t\t$"."fcss[".$i."]	=	\"err_input\";";
							}
							$rMsg	= $rMsg."\n\t\t\tif($"."rmsg != \"\") $"."rmsg = $"."rmsg.\",\";";
							$rMsg	= $rMsg."\n\t\t\t$"."rmsg	=	$"."rmsg.\"".$scls->getColumnLabel()."\";";
							$rMsg	= $rMsg."\n\t\t}\n";
					} else if($scls->getColumnDataType() == "date") {
							$rMsg	= $rMsg."\n\t\tif(FormatIndianDateToSQLDate($".$scls->getColumnName().") == \"1900-01-01\") {";
							$rMsg	= $rMsg."\n\t\t\t$"."fcss[".$i."]	=	\"err_input\";";
							$rMsg	= $rMsg."\n\t\t\tif($"."rmsg != \"\") $"."rmsg = $"."rmsg.\",\";";
							$rMsg	= $rMsg."\n\t\t\t$"."rmsg	=	$"."rmsg.\"Invalid Date ".$scls->getColumnLabel()."\";";
							$rMsg	= $rMsg."\n\t\t}\n";
					}
				}
			}
			/* Mandatory fields check / Form validation ends here */
			
			/* For check-boxes set YES/NO accordingly */
			for($i=0;$i<$cCnt;$i++) {
				$scls		=	$clmList[$i];
				if($scls->getInputType() == "checkbox") {
					$rMsg		=	$rMsg."\n\t\tif(isset($"."_REQUEST[\"".$scls->getColumnName()."\"]))";
					$rMsg		=	$rMsg."\n\t\t\t$".$scls->getColumnName()."	= \"YES\";";
					$rMsg		=	$rMsg."\n\t\telse";
					$rMsg		=	$rMsg."\n\t\t\t$".$scls->getColumnName()."	= \"NO\";\n";
				}
			}
			/* Check-box entry correction ends here */
		
			/* Feed the module class variables */
			for($i=0;$i<$cCnt;$i++) {
				$scls		=	$clmList[$i];
				$rMsg	= $rMsg."\n\t\t$"."cclass->set".$scls->getColumnName()."($".$scls->getColumnName().");";
			}
			/* module main class variable feeding ends here */
			
			$rMsg		=	$rMsg."\n";
			
			/* Handle the submodules */
			for($i=0;$i<$n;$i++) {
				$scls			= $smlList[$i];
				$smdet		= $this->getModuleDetail($scls->getSubmoduleID());
				$sclmList	= $smdet->getColumnList();
				
				$rMsg		=	$rMsg."\n\t\tfor($"."i=1;$"."i<=$"."numSubModule".($i+1).";$"."i++) {";
				
				/* SUB MODULE Check those fields for which Mandatory is set to YES */
				for($j=0;$j<count($sclmList);$j++) {
					$scls		=	$sclmList[$j];
					if($scls->getIsMandatory() == "YES") {
						if( $scls->getColumnDataType() == "int" ||
								$scls->getColumnDataType() == "tinyint" ||
								$scls->getColumnDataType() == "smallint" ||
								$scls->getColumnDataType() == "mediumint" ||
								$scls->getColumnDataType() == "bigint"
						) {
								$rMsg	= $rMsg."\n\t\t\tif((int)$"."_REQUEST[\"".$scls->getColumnName()."$"."i\"] <= 0) {";
								$rMsg	= $rMsg."\n\t\t\t\tif($"."rmsg != \"\") $"."rmsg = $"."rmsg.\",\";";
								$rMsg	= $rMsg."\n\t\t\t\t$"."rmsg	=	$"."rmsg.\"".$scls->getColumnLabel()."\";";
								$rMsg	= $rMsg."\n\t\t\t}\n";
						} else if(
								$scls->getColumnDataType() == "decimal" ||
								$scls->getColumnDataType() == "float" ||
								$scls->getColumnDataType() == "double"
						) {
								$rMsg	= $rMsg."\n\t\t\tif((double)$"."_REQUEST[\"".$scls->getColumnName()."$"."i\"] <= 0) {";
								$rMsg	= $rMsg."\n\t\t\t\tif($"."rmsg != \"\") $"."rmsg = $"."rmsg.\",\";";
								$rMsg	= $rMsg."\n\t\t\t\t$"."rmsg	=	$"."rmsg.\"".$scls->getColumnLabel()."\";";
								$rMsg	= $rMsg."\n\t\t\t}\n";
						} else if(
								$scls->getColumnDataType() == "varchar" ||
								$scls->getColumnDataType() == "enum" ||
								$scls->getColumnDataType() == "char" ||
								$scls->getColumnDataType() == "blob" ||
								$scls->getColumnDataType() == "tinyblob" ||
								$scls->getColumnDataType() == "mediumblob" ||
								$scls->getColumnDataType() == "longblob" ||
								$scls->getColumnDataType() == "text" ||
								$scls->getColumnDataType() == "tinytext" ||
								$scls->getColumnDataType() == "mediumtext" ||
								$scls->getColumnDataType() == "longtext"
						) {
								$rMsg	= $rMsg."\n\t\t\tif(trim($"."_REQUEST[\"".$scls->getColumnName()."$"."i\"]) == \"\") {";
								$rMsg	= $rMsg."\n\t\t\t\tif($"."rmsg != \"\") $"."rmsg = $"."rmsg.\",\";";
								$rMsg	= $rMsg."\n\t\t\t\t$"."rmsg	=	$"."rmsg.\"".$scls->getColumnLabel()."\";";
								$rMsg	= $rMsg."\n\t\t\t}\n";
						} else if($scls->getColumnDataType() == "date") {
								$rMsg	= $rMsg."\n\t\t\tif(FormatIndianDateToSQLDate($"."_REQUEST[\"".$scls->getColumnName()."$"."i\"]) == \"1900-01-01\") {";
								$rMsg	= $rMsg."\n\t\t\t\tif($"."rmsg != \"\") $"."rmsg = $"."rmsg.\",\";";
								$rMsg	= $rMsg."\n\t\t\t\t$"."rmsg	=	$"."rmsg.\"Invalid Date ".$scls->getColumnLabel()."\";";
								$rMsg	= $rMsg."\n\t\t\t}\n";
						}
					}
				}
				/* SUB MODULE Mandatory fields check / Form validation ends here */
				
				/* SUB MODULE Feed the class variables */
				$rMsg		=	$rMsg."\n\t\t\t$"."smcls	= new gen_module".$mid."_submodule".($i+1)."();";
				for($j=0;$j<count($sclmList);$j++) {
					$smccls	= $sclmList[$j];
					if($smccls->getInputType() == "checkbox") {
						$rMsg		=	$rMsg."\n\t\t\tif(isset($"."_REQUEST[\"".$smccls->getColumnName()."$"."i\"]))";
						$rMsg		=	$rMsg."\n\t\t\t\t$"."smcls->set".$smccls->getColumnName()."(\"YES\");";
						$rMsg		=	$rMsg."\n\t\t\telse";
						$rMsg		=	$rMsg."\n\t\t\t\t$"."smcls->set".$smccls->getColumnName()."(\"NO\");";
					} else {
						$rMsg	= $rMsg."\n\t\t\t$"."smcls->set".$smccls->getColumnName()."($"."_REQUEST[\"".$smccls->getColumnName()."$"."i\"]);";
					}
				}
				/* SUB MODULE class variable feeding ends here */
				$rMsg		=	$rMsg."\n\t\t\t$"."SubModuleArr".($i+1)."[] = $"."smcls;";
				
				$rMsg		=	$rMsg."\n\t\t}";
				$rMsg		=	$rMsg."\n\t\t$"."cclass->setSubModuleList".($i+1)."($"."SubModuleArr".($i+1).");";
				
			}
			/* Submodule handling ends here */
			
			$scls		=	$clmList[0];
			$rMsg	= $rMsg."

		if($"."rmsg == \"\") {
			if($"."mddb->CreateModule".$mid."($"."cclass)) {
				$"."msg	=	\"<font class='blue'>".$mcls->getModuleName()." created successfully</font>\";
				$"."log	=	new asys_user_log();
				$"."log->setUserID($"."tuser->getUserID());
				$"."log->setCompanyID($"."tcmp->getCompanyID());
				$"."log->setModuleID($"."ModuleID);
				$"."log->setRelatedID($"."cclass->get".$scls->getColumnName()."());
				$"."log->setActivity(\"Added new ".$mcls->getModuleName()." - \".$".$scls->getColumnName().");
				$"."log->setClassName('".$tblname."');
				$"."log->setModuleSnapshot(serialize($"."cclass));
				$"."log->setLogID($"."gdb->getNextID(\"asys_user_log\", \"LogID\"));
				$"."gdb->SaveObjectToDB($"."log);
				
				$"."cclass				= new ".$tblname."();";

	for($i=0;$i<$n;$i++) {
		$rMsg = $rMsg."
				$"."numSubModule".($i+1)."				=	1;
				$"."SubModuleArr".($i+1)."				= array();
		";
	}
				
			$rMsg	= $rMsg."
				
			} else {
				$"."msg	=	\"<font class='red'>Failed to save record, try again</font>\";
			}
		} else {
			$"."msg	=	\"<font class='red'>The following fields are mandatory: \".$"."rmsg.\"</font>\";
		}
	}

	
	/* Ready to create the page */
	$"."iPage	=	new asys_pages(APP_TITLE);
	/* Start writting the page */
	$"."iPage->startPage();
	$"."iPage->startHeader();
	/* Add links and Scripts as required */
	$"."iPage->addLink(\"css/asys.css\");
	$"."iPage->addLink(\"css/menu.css\");
	$"."iPage->addLink(\"css/superTables.css\");
	$"."iPage->addLink(\"css/select2.css\");
	$"."iPage->addLink(\"css/modal.css\");
	$"."iPage->addLink(\"css/datepicker.css\");
	$"."iPage->addScript(\"js/common.js\");
	$"."iPage->addScript(\"js/superTables.js\");	
	$"."iPage->addScript(\"js/jquery.js\");
	$"."iPage->addScript(\"js/select2.js\");
	$"."iPage->addScript(\"js/modal.js\");
	$"."iPage->addScript(\"js/datepicker.js\");
	$"."iPage->addScript(\"js/nlbFade.js\");
	$"."iPage->endHeader();
	$"."iPage->startBody();
	
	outputHeader($"."tuser, $"."tcmp);
	outputMenu($"."tuser);
	
?>	

	<div id=\"pagehead\">&nbsp;CREATE NEW ".strtoupper($mcls->getModuleName())."</div>
	<div style=\"height:10px;\"></div>
	
	<div style=\"width:980px;margin:0px auto\">
	<form name=\"hfrm\" id=\"hfrm\" method=\"post\" action=\"\" enctype=\"multipart/form-data\">
	<input type=\"hidden\" name=\"pagen\" value=\"process\" />";
	
	for($i=0;$i<$n;$i++) {
		$rMsg	= $rMsg."
	<input type=\"hidden\" name=\"numSubModule".($i+1)."\" id=\"numSubModule".($i+1)."\" value=\"<?php echo $"."numSubModule".($i+1)."?>\" />
		";
	}	
	
	
	$rMsg	= $rMsg."
	
	<table cellpadding=\"1\" cellspacing=\"0\" border=\"0\" width=\"980px\" align=\"center\" bgcolor=\"#ffffff\">
		<tr bgcolor=\"#D6E3F3\"><td colspan=\"3\" class=\"td_normal blue bold\">
			<div id=\"dhead\" style=\"float:left;width:900px;padding:5px;\"><?php echo $"."msg?></div>
			<div style=\"float:right;padding:5px;\"><a href=\"viewModule".$mid.".php\"><img src=\"images/columns.gif\" title=\"View ".$mcls->getModuleName()." List\" /></a></div>
		</td></tr>
		<tr style=\"height:1px\" bgcolor=\"#99BBE8\"><td colspan=\"3\"></td></tr>
		<tr style=\"height:2px\"><td colspan=\"3\"></td></tr>
		
			";

			$cnt			= 0;
			for($i=0;$i<$cCnt;$i++) {
				$scls		= $clmList[$i];
				
				if($scls->getDisplayInForm() != "YES") continue;
				$cnt++;
				
				if($cnt == 1) {
					$rMsg	=	$rMsg."
		<tr>
			<td class=\"td_normal\" width=\"170px;\" valign=\"top\">&nbsp;".$scls->getColumnLabel()."</td>
			<td class=\"td_normal\" width=\"10px;\" valign=\"top\">:</td>";
				} else {
					$rMsg	=	$rMsg."
		<tr>
			<td class=\"td_normal\" valign=\"top\">&nbsp;".$scls->getColumnLabel()."</td>
			<td class=\"td_normal\" valign=\"top\">:</td>";
				}
			
				switch($scls->getInputType()) {
					case 'text':
						if($scls->getColumnDataType() == "varchar") {
							$rMsg	=	$rMsg."
			<td class=\"td_normal\"><input type=\"text\" class=\"<?php echo $"."fcss[$i]?>\" name=\"".$scls->getColumnName()."\" id=\"".$scls->getColumnName()."\" value=\"<?php echo $"."cclass->get".$scls->getColumnName()."('yes')?>\" style=\"width:".$scls->getInputLength()."px\" maxLength=\"".$scls->getColumnLength()."\" onFocus=\"this.className='input_focus'\" onBlur=\"this.className='<?php echo $"."fcss[$i]?>'\" /></td>";
						} else if($scls->getColumnDataType() == "date") {
							$rMsg	=	$rMsg."
			<td class=\"td_normal\"><input data-toggle=\"datepicker\" type=\"text\" class=\"<?php echo $"."fcss[$i]?>\" name=\"".$scls->getColumnName()."\" id=\"".$scls->getColumnName()."\" value=\"<?php echo $"."cclass->get".$scls->getColumnName()."('yes')?>\" style=\"width:80px\" maxLength=\"10\" onFocus=\"this.className='input_focus'\" onBlur=\"this.className='<?php echo $"."fcss[$i]?>'\" /></td>";
						} else {
							$rMsg	=	$rMsg."
			<td class=\"td_normal\"><input type=\"text\" class=\"<?php echo $"."fcss[$i]?>\" name=\"".$scls->getColumnName()."\" id=\"".$scls->getColumnName()."\" value=\"<?php if($"."cclass->get".$scls->getColumnName()."() != 0) echo $"."cclass->get".$scls->getColumnName()."('no')?>\" style=\"width:80px\" maxLength=\"15\" onFocus=\"this.className='input_focus'\" onBlur=\"this.className='<?php echo $"."fcss[$i]?>'\" /></td>";
						}
						break;
					case 'select':
						if($scls->getSelectValues() != "") {
							$tmp	= explode(",", $scls->getSelectValues());
							$rMsg	=	$rMsg."
			<td class=\"td_normal\">
				<select class=\"<?php echo $"."fcss[$i]?>\" name=\"".$scls->getColumnName()."\" id=\"".$scls->getColumnName()."\">
					<option value=\"\">--</option>";
					for($k=0;$k<count($tmp);$k++) {
						$str	= $tmp[$k];
						$rMsg	=	$rMsg."
					<option value=\"".$str."\" <?php if($"."cclass->get".$scls->getColumnName()."() == \"".$str."\") echo 'selected'; ?>>".$str."</option>";
					}
					$rMsg	=	$rMsg."
				</select>
			</td>";
						} else {
							$rMsg	=	$rMsg."
			<td class=\"td_normal\"><select name=\"".$scls->getColumnName()."\" id=\"".$scls->getColumnName()."\" style=\"width:".$scls->getInputLength()."px\" ></select></td>";
						}
						break;
					case 'checkbox':
						$rMsg	=	$rMsg."
			<td class=\"td_normal\"><input type=\"checkbox\" class=\"<?php echo $"."fcss[$i]?>\" name=\"".$scls->getColumnName()."\" id=\"".$scls->getColumnName()."\" <?php if($"."cclass->get".$scls->getColumnName()."() == \"YES\") echo 'checked'; ?> /></td>
					";
						break;
					case 'textarea':
						$ilen	= $scls->getInputLength();
						$wd		= 600;
						$ht		= 100;
						if(strpos($ilen, ",") !== false) {
							$tmp	= explode(",", $ilen);
							$wd		= $tmp[0];
							$ht		= $tmp[1];
						}
						$rMsg	=	$rMsg."
			<td class=\"td_normal\"><textarea class=\"<?php echo $"."fcss[$i]?>\" name=\"".$scls->getColumnName()."\" id=\"".$scls->getColumnName()."\" style=\"width:".$wd."px;height:".$ht."px;\" onFocus=\"this.className='input_focus'\" onBlur=\"this.className='<?php echo $"."fcss[$i]?>'\" /><?php echo $"."cclass->get".$scls->getColumnName()."() ?></textarea></td>";
						break;
					case 'file':
						$rMsg	=	$rMsg."
			<td class=\"td_normal\"><input type=\"file\" class=\"<?php echo $"."fcss[$i]?>\" name=\"".$scls->getColumnName()."\" id=\"".$scls->getColumnName()."\" style=\"width:300px;\" /></td>
					";
						break;
					case 'date':
							$rMsg	=	$rMsg."
			<td class=\"td_normal\"><input data-toggle=\"datepicker\" type=\"text\" class=\"<?php echo $"."fcss[$i]?>\" name=\"".$scls->getColumnName()."\" id=\"".$scls->getColumnName()."\" value=\"<?php echo $"."cclass->get".$scls->getColumnName()."('yes')?>\" style=\"width:80px\" maxLength=\"10\" onFocus=\"this.className='input_focus'\" onBlur=\"this.className='<?php echo $"."fcss[$i]?>'\" /></td>";					
						break;
					case 'html':
						$rMsg	=	$rMsg."
			<td class=\"td_normal\" valign=\"top\"><textarea id=\"".$scls->getColumnName()."\" name=\"".$scls->getColumnName()."\" style=\"width:95%\"></textarea></td>";
						break;
					default:
					
				}
			
				$rMsg	=	$rMsg."
		</tr>
		";
				
			}			
			
			
			/* Handle the submodules */
			for($i=0;$i<$n;$i++) {
				
				$smcls		=	$smlList[$i];
				$smdet		= $this->getModuleDetail($smcls->getSubmoduleID());
				$sclmList	= $smdet->getColumnList();
				
				$rMsg			= $rMsg."
				
		<tr style=\"height:2px\"><td colspan=\"3\"></td></tr>
		<tr><td colspan=\"3\" style=\"border-bottom:#99BBE8 1px solid;\"></td></tr>
		<tr bgcolor=\"#D6E3F3\">
			<td colspan=\"3\" class=\"td_normal_large bold red\">
				&nbsp;".$mcls->getModuleName()." 
				<input type=\"button\" class=\"red_button\" value=\"+\" onClick=\"addSubModuleRow".($i+1)."()\" />
				<input type=\"button\" class=\"red_button\" value=\"—\" onClick=\"deleteSubModuleRow".($i+1)."()\" />
			</td>
		</tr>
		<tr><td colspan=\"3\" style=\"border-top:#99BBE8 1px solid;\"></td></tr>
		<tr style=\"height:2px\"><td colspan=\"3\"></td></tr>				
				
		<tr>
			<td colspan=\"3\">	
	
				<table style=\"border:0px;\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\">
			<tr>
				<th width=\"50px\" style=\"border-left: 1px solid #99BBE8;\">SN</th>
	";
	
				for($j=0;$j<count($sclmList);$j++) {
					$scls		= $sclmList[$j];
					if($scls->getInputLength() == 0) $scls->setInputLength(50);
					
					if($scls->getDisplayInForm() != "YES") continue;
					
					$rMsg			= $rMsg."
				<th width=\"".$scls->getInputLength()."px\">".$scls->getColumnLabel()."</th>";
				}
				
				$rMsg			= $rMsg."
			</tr>
		</table>
		
			</td>
		</tr>	
	
		<tr>
			<td colspan=\"3\">		
		
		<table style=\"border:0px;\" cellpadding=\"0\" cellspacing=\"1\" width=\"100%\" id=\"submTbl".($i+1)."\">
			<tr>
				<td width=\"50px\" style=\"padding:2px;\">
					<input type=\"button\" class=\"red_button\" style=\"width:25px;\" value=\"1\" onClick=\"clearRowOfSubModule".($i+1)."(1)\" />
				</td>
				";
				

				for($j=0;$j<count($sclmList);$j++) {
					$scls		= $sclmList[$j];
				
					if($scls->getDisplayInForm() != "YES") continue;
			
					switch($scls->getInputType()) {
						case 'text':
							if($scls->getColumnDataType() == "varchar") {
								$rMsg	=	$rMsg."
				<td width=\"".$scls->getInputLength()."px\" style=\"padding:2px;\"><input type=\"text\" class=\"input\" name=\"".$scls->getColumnName()."1\" id=\"".$scls->getColumnName()."1\" value=\"\" style=\"width:".$scls->getInputLength()."px\" maxLength=\"".$scls->getColumnLength()."\" onFocus=\"this.className='input_focus'\" onBlur=\"this.className='input'\" /></td>";
							} else if($scls->getColumnDataType() == "date") {
								$rMsg	=	$rMsg."
				<td width=\"80px\" style=\"padding:2px;\"><input data-toggle=\"datepicker\" type=\"text\" class=\"input\" name=\"".$scls->getColumnName()."1\" id=\"".$scls->getColumnName()."1\" value=\"\" style=\"width:80px\" maxLength=\"10\" onFocus=\"this.className='input_focus'\" onBlur=\"this.className='input'\" /></td>";
							} else {
								$rMsg	=	$rMsg."
				<td width=\"80px\" style=\"padding:2px;\"><input type=\"text\" class=\"input\" name=\"".$scls->getColumnName()."1\" id=\"".$scls->getColumnName()."1\" value=\"\" style=\"width:80px\" maxLength=\"15\" onFocus=\"this.className='input_focus'\" onBlur=\"this.className='input'\" /></td>";
							}
							break;
						case 'select':
							if($scls->getSelectValues() != "") {
								$tmp	= explode(",", $scls->getSelectValues());
								$rMsg	=	$rMsg."
				<td width=\"".$scls->getInputLength()."px\" style=\"padding:2px;\">
					<select class=\"select\" name=\"".$scls->getColumnName()."1\" id=\"".$scls->getColumnName()."1\">
						<option value=\"\">--</option>";
							for($k=0;$k<count($tmp);$k++) {
								$str	= $tmp[$k];
								$rMsg	=	$rMsg."
						<option value=\"".$str."\" >".$str."</option>";
							}
							$rMsg	=	$rMsg."
					</select>
				</td>";
							} else {
								$rMsg	=	$rMsg."
				<td width=\"".$scls->getInputLength()."px\" style=\"padding:2px;\"><select name=\"".$scls->getColumnName()."1\" id=\"".$scls->getColumnName()."1\" style=\"width:".$scls->getInputLength()."px\"></select></td>";
							}
							break;
						case 'checkbox':
							$rMsg	=	$rMsg."
				<td width=\"".$scls->getInputLength()."px\" style=\"padding:2px;\"><input type=\"checkbox\" class=\"input\" name=\"".$scls->getColumnName()."1\" id=\"".$scls->getColumnName()."1\" /></td>
						";
							break;
						case 'textarea':
							$ilen	= $scls->getInputLength();
							$wd		= 600;
							$ht		= 100;
							if(strpos($ilen, ",") !== false) {
								$tmp	= explode(",", $ilen);
								$wd		= $tmp[0];
								$ht		= $tmp[1];
							}
							$rMsg	=	$rMsg."
				<td width=\"".$scls->getInputLength()."px\" style=\"padding:2px;\"><textarea class=\"input\" name=\"".$scls->getColumnName()."1\" id=\"".$scls->getColumnName()."1\" style=\"width:".$wd."px;height:".$ht."px;\" onFocus=\"this.className='input_focus'\" onBlur=\"this.className='input'\" /></textarea></td>";
							break;
						case 'file':
							$rMsg	=	$rMsg."
				<td width=\"".$scls->getInputLength()."px\" style=\"padding:2px;\"><input type=\"file\" class=\"input\" name=\"".$scls->getColumnName()."1\" id=\"".$scls->getColumnName()."1\" style=\"width:".$scls->getInputLength()."px;\" /></td>
						";
							break;
						case 'date':
								$rMsg	=	$rMsg."
				<td width=\"".$scls->getInputLength()."px\" style=\"padding:2px;\"><input data-toggle=\"datepicker\" type=\"text\" class=\"<?php echo $"."fcss[$i]?>\" name=\"".$scls->getColumnName()."1\" id=\"".$scls->getColumnName()."1\" value=\"<?php echo $"."cclass->get".$scls->getColumnName()."('yes')?>\" style=\"width:80px\" maxLength=\"10\" onFocus=\"this.className='input_focus'\" onBlur=\"this.className='<?php echo $"."fcss[$i]?>'\" /></td>";					
							break;
						case 'html':
							$rMsg	=	$rMsg."
				<td width=\"".$scls->getInputLength()."px\" style=\"padding:2px;\" valign=\"top\">
					<textarea id=\"".$scls->getColumnName()."\" name=\"".$scls->getColumnName()."\" style=\"width:95%\"></textarea>
				</td>";
							break;							
						default:
					
					}
				
				}
				
				$rMsg			= $rMsg."
			</tr>
		</table>
		
		
			</td>
		</tr>
	<!-- Sub-Module ".($i+1)." entries ends here -->
	";	
				
			}


			$rMsg	=	$rMsg."

		<tr style=\"height:1px\" bgcolor=\"#99BBE8\"><td colspan=\"3\"></td></tr>
		<tr bgcolor=\"#D6E3F3\">
			<td colspan=\"3\" align=\"center\">
				<input type=\"button\" id=\"btnS\" class=\"red_button\" value=\" Create (S) \" AccessKey=\"S\" onClick=\"saveRec()\" />
			</td>
		</tr>
	</table>
	</form>
	</div>
	
	<br /><br />
	
<?php
	$"."iPage->endBody();
	$"."iPage->endPage();
?>
		
<script language=\"javaScript\">";

	for($i=0;$i<$n;$i++) {
		$rMsg	= $rMsg."
		
	var numSubModule".($i+1)." = \"<?php echo $"."numSubModule".($i+1)." ?>\";
		";
	}

	$rMsg	= $rMsg."

	$(function () {
		NLBfadeBg('dhead','#ffff00','#D6E3F3','3000');
	";
	
	$cnt	= 0;
	for($i=0;$i<$cCnt;$i++) {
		$scls		=	$clmList[$i];
		if($scls->getDisplayInForm() != "YES") continue;

		if($scls->getInputType() == "select") {
		
			$rMsg	=	$rMsg."\n\t\t$(\"#".$scls->getColumnName()."\").select2();";
		}

	}		
	
	$rMsg	= $rMsg."
	});
	
	";
	
	$cnt	= 0;
	for($i=0;$i<$cCnt;$i++) {
		$scls		=	$clmList[$i];
		if($scls->getDisplayInForm() != "YES") continue;

		if($scls->getInputType() == "select" && $scls->getSelectValues() == "") {
			
			$rMsg	=	$rMsg."\n\tfetch".$scls->getColumnName()."For".$mid."('".$scls->getRelatedTable()."','".$scls->getValueField()."','".$scls->getDisplayFields()."','".$scls->getDataFetchSQL()."', 'yes'); ";
		}

	}	

	$rMsg	= $rMsg."
	
	$('[data-toggle=\"datepicker\"]').datepicker({
		format: 'dd-mm-yyyy',
		autoHide: 'yes'
	});
	
	";

	
	for($i=0;$i<$cCnt;$i++) {
		$scls		=	$clmList[$i];

		if($scls->getInputType() == "select" && $scls->getSelectValues() == "") {
		
			$rMsg	=	$rMsg."
				
	function fetch".$scls->getColumnName()."For".$mid."(tblname, fld1, fld2, condn, fc) {
	
    $('#".$scls->getColumnName()."').empty();
    $('#".$scls->getColumnName()."').append('<option value=\"0\">--</option>');
    var iid		= \"<?php echo $"."cclass->get".$scls->getColumnName()."()?>\";
    
    $.ajax({
			type: \"POST\",
			url: \"json/getGenericDataForJSON.php\",
			data: {\"tblName\": tblname, \"fld1\": fld1, \"fld2\": fld2, \"condn\": \"\"},
			success: function(data){

				var opts = $.parseJSON(data);
				$.each(opts, function(i, d) {
					$('#".$scls->getColumnName()."').append('<option value=\"' + d.".$scls->getValueField()." + '\">' + d.".$scls->getDisplayFields()." + '</option>');
				});
				$(\"#".$scls->getColumnName()."\").val(iid).change();
				
			}
    });

	}
				
			";
		}
			
	}
	
	
			/* Handle the submodules */
			for($i=0;$i<count($smlList);$i++) {
				
				$smcls		=	$smlList[$i];
				$smdet		= $this->getModuleDetail($smcls->getSubmoduleID());
				$sclmList	= $smdet->getColumnList();
				
				$rMsg			= $rMsg."

	function addSubModuleRow".($i+1)."()	{
		
		var rTable	= EBD(\"submTbl".($i+1)."\");
		var iRow		= rTable.insertRow(numSubModule".($i+1).");

		numSubModule".($i+1)."++;
		var iCell;
		
		iCell								= iRow.insertCell(0);
		iCell.style.padding	=	\"2px\";
		iCell.innerHTML			= '<input type=\"button\" class=\"red_button\" style=\"width:25px;\" value=\"' + numSubModule".($i+1)." + '\" onClick=\"clearRowOfSubModule".($i+1)."(' + numSubModule".($i+1)." + ')\" />';
	";

				$jcnt		= 1;
				for($j=0;$j<count($sclmList);$j++) {
					$scls		= $sclmList[$j];
				
					if($scls->getDisplayInForm() != "YES") continue;
			
					switch($scls->getInputType()) {
						case 'text':
							if($scls->getColumnDataType() == "varchar") {
								$rMsg	=	$rMsg."
		iCell								= iRow.insertCell(".$jcnt.");
		iCell.style.padding	=	\"2px\";
		iCell.innerHTML			= '<input type=\"text\" class=\"input\" name=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" id=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" value=\"\" style=\"width:".$scls->getInputLength()."px\" maxLength=\"".$scls->getColumnLength()."\" onFocus=\"this.className=\'input_focus\'\" onBlur=\"this.className=\'input\'\" title=\"".$scls->getColumnName()."\" />';
					";
							} else if($scls->getColumnDataType() == "date") {
								$rMsg	=	$rMsg."
		iCell								= iRow.insertCell(".$jcnt.");
		iCell.style.padding	=	\"2px\";
		iCell.innerHTML			= '<input data-toggle=\"datepicker\" type=\"text\" class=\"input\" name=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" id=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" value=\"\" style=\"width:80px\" maxLength=\"10\" onFocus=\"this.className=\'input_focus\'\" onBlur=\"this.className=\'input\'\" title=\"".$scls->getColumnName()."\" />';	
		";
							} else {
								$rMsg	=	$rMsg."
		iCell								= iRow.insertCell(".$jcnt.");
		iCell.style.padding	=	\"2px\";
		iCell.innerHTML			= '<input type=\"text\" class=\"input\" name=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" id=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" value=\"\" style=\"width:80px\" maxLength=\"15\" onFocus=\"this.className=\'input_focus\'\" onBlur=\"this.className=\'input\'\" title=\"".$scls->getColumnName()."\" />';
					";
							}
							break;
						case 'select':
							if($scls->getSelectValues() != "") {
								$tmp	= explode(",", $scls->getSelectValues());
								$rMsg	=	$rMsg."
		iCell								= iRow.insertCell(".$jcnt.");
		iCell.style.padding	=	\"2px\";
		iCell.innerHTML			= '<select class=\"select\" name=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" id=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\">\
		<option value=\"\">--</option>\
		";
							for($k=0;$k<count($tmp);$k++) {
								$str	= $tmp[$k];
								$rMsg	=	$rMsg."<option value=\"".$str."\" >".$str."</option>\
								";
							}
							
							$rMsg	=	$rMsg."
						</select>';
					";

							} else {
								$rMsg	=	$rMsg."
		iCell								= iRow.insertCell(".$jcnt.");
		iCell.style.padding	=	\"2px\";
		iCell.innerHTML			= '<select name=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" id=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" style=\"width:".$scls->getInputLength()."px\"></select>';
					";
							}
							break;
						case 'checkbox':
							$rMsg	=	$rMsg."
		iCell								= iRow.insertCell(".$jcnt.");
		iCell.style.padding	=	\"2px\";
		iCell.innerHTML			= '<input type=\"checkbox\" class=\"input\" name=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" id=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" />';
						";
							break;
						case 'textarea':
							$ilen	= $scls->getInputLength();
							$wd		= 600;
							$ht		= 100;
							if(strpos($ilen, ",") !== false) {
								$tmp	= explode(",", $ilen);
								$wd		= $tmp[0];
								$ht		= $tmp[1];
							}
							$rMsg	=	$rMsg."
		iCell								= iRow.insertCell(".$jcnt.");
		iCell.style.padding	=	\"2px\";
		iCell.innerHTML			= '<textarea class=\"input\" name=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" id=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" style=\"width:".$wd."px;height:".$ht."px;\" onFocus=\"this.className=\'input_focus\'\" onBlur=\"this.className=\'input\'\" /></textarea>';
		";
							break;
						case 'file':
							$rMsg	=	$rMsg."
		iCell								= iRow.insertCell(".$jcnt.");
		iCell.style.padding	=	\"2px\";
		iCell.innerHTML			= '<input type=\"file\" class=\"input\" name=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" id=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" style=\"width:".$scls->getInputLength()."px;\" />';
						";
							break;
						default:
					
					}
					$jcnt++;
				}
				
	for($j=0;$j<count($sclmList);$j++) {
		$scls		= $sclmList[$j];
		
		if($scls->getColumnDataType() == "date" && $scls->getDisplayInForm() == "YES") {
						$rMsg	=	$rMsg."
						
			$('#".$scls->getColumnName()."').datepicker({
				format: 'dd-mm-yyyy',
				autoHide: 'yes'
			});
				";		
		}		
		
		if($scls->getInputType() == "select" && $scls->getSelectValues() != "") {
				$rMsg			= $rMsg."
				$('#".$scls->getColumnName()."').select2();
		fetch".$scls->getColumnName()."For".$mid."('".$scls->getRelatedTable()."','".$scls->getValueField()."','".$scls->getDisplayFields()."','".$scls->getDataFetchSQL()."', 'no');
	";
		}
		
	}
				
				$rMsg			= $rMsg."
		
	}
	
	function deleteSubModuleRow".($i+1)."()	{
		if(numSubModule".($i+1)." > 1)	{
			var rTable	= EBD(\"submTbl".($i+1)."\");
			var iRow		= rTable.deleteRow(numSubModule".($i+1)." - 1);
			numSubModule".($i+1)."--;
		}
	}";
	
	}
	
	$rMsg			= $rMsg."
	
	function saveRec() {
		";
		
		
	for($i=0;$i<$cCnt;$i++) {
		$scls		=	$clmList[$i];
		if($scls->getIsMandatory() == "YES") {
			if( $scls->getColumnDataType() == "int" ||
					$scls->getColumnDataType() == "tinyint" ||
					$scls->getColumnDataType() == "smallint" ||
					$scls->getColumnDataType() == "mediumint" ||
					$scls->getColumnDataType() == "bigint" ||
					$scls->getColumnDataType() == "decimal" ||
					$scls->getColumnDataType() == "float" ||
					$scls->getColumnDataType() == "double"
			) {
				$rMsg	= $rMsg."\n\t\tif(checkForValidInput('".$scls->getColumnName()."','Positive','Please enter ".$scls->getColumnLabel()."') == false) return;";
			} else if(
					$scls->getColumnDataType() == "varchar" ||
					$scls->getColumnDataType() == "enum" ||
					$scls->getColumnDataType() == "char" ||
					$scls->getColumnDataType() == "blob" ||
					$scls->getColumnDataType() == "tinyblob" ||
					$scls->getColumnDataType() == "mediumblob" ||
					$scls->getColumnDataType() == "longblob" ||
					$scls->getColumnDataType() == "text" ||
					$scls->getColumnDataType() == "tinytext" ||
					$scls->getColumnDataType() == "mediumtext" ||
					$scls->getColumnDataType() == "longtext"
			) {
				$rMsg	= $rMsg."\n\t\tif(checkForValidInput('".$scls->getColumnName()."','Text','Please enter ".$scls->getColumnLabel()."') == false) return;";
			} else if($scls->getColumnDataType() == "date") {
				$rMsg	= $rMsg."\n\t\tif(checkForValidInput('".$scls->getColumnName()."','Date','Please enter ".$scls->getColumnLabel()."') == false) return;";
			}
		}

	}
	
			
	for($i=0;$i<count($smlList);$i++) {
		$smcls		= $smlList[$i];
		$smdet		= $this->getModuleDetail($smcls->getSubmoduleID());
		$sclmList	= $smdet->getColumnList();
		
		$rMsg	= $rMsg."\n
		for(var i=1;i<=numSubModule".($i+1).";i++) {
		";
	
		for($j=0;$j<count($sclmList);$j++) {
			$scls		= $sclmList[$j];
		
			if($scls->getIsMandatory() == "YES") {
				if( $scls->getColumnDataType() == "int" ||
						$scls->getColumnDataType() == "tinyint" ||
						$scls->getColumnDataType() == "smallint" ||
						$scls->getColumnDataType() == "mediumint" ||
						$scls->getColumnDataType() == "bigint" ||
						$scls->getColumnDataType() == "decimal" ||
						$scls->getColumnDataType() == "float" ||
						$scls->getColumnDataType() == "double"
				) {
					$rMsg	= $rMsg."\n\t\t\tif(checkForValidInput('".$scls->getColumnName()."','Positive','Please enter ".$scls->getColumnLabel()."') == false) return;";
				} else if(
						$scls->getColumnDataType() == "varchar" ||
						$scls->getColumnDataType() == "enum" ||
						$scls->getColumnDataType() == "char" ||
						$scls->getColumnDataType() == "blob" ||
						$scls->getColumnDataType() == "tinyblob" ||
						$scls->getColumnDataType() == "mediumblob" ||
						$scls->getColumnDataType() == "longblob" ||
						$scls->getColumnDataType() == "text" ||
						$scls->getColumnDataType() == "tinytext" ||
						$scls->getColumnDataType() == "mediumtext" ||
						$scls->getColumnDataType() == "longtext"
				) {
					$rMsg	= $rMsg."\n\t\t\tif(checkForValidInput('".$scls->getColumnName()."','Text','Please enter ".$scls->getColumnLabel()."') == false) return;";
				} else if($scls->getColumnDataType() == "date") {
					$rMsg	= $rMsg."\n\t\t\tif(checkForValidInput('".$scls->getColumnName()."','Date','Please enter ".$scls->getColumnLabel()."') == false) return;";
				}
			}
			
		}
		
		$rMsg	= $rMsg."\n
		}\n\n
		";
		
		}
		
		
		for($i=0;$i<count($smlList);$i++) {
			$rMsg	= $rMsg."\n\t\tEBD('numSubModule".($i+1)."').value		= numSubModule".($i+1).";";
		}
		
		$rMsg	= $rMsg."\n\t\tEBD('hfrm').submit();

		";
		
	
	
		$rMsg			= $rMsg."
	}
	
	";
						
	
	
	$rMsg	= $rMsg."

</script>";

			return $rMsg;
		}
		


		/*******************************************************
		 * This is the code to generate a php code that handles 
		 * the modify code in HTML and PHP
		 *******************************************************/                                    

		function getEditCodePHP($mcls, $viewcls) {
		
			$mid			= $mcls->getModuleID();
			$tblname		= "gen_module".$mid;
			$smlList	= $mcls->getSubmoduleList();
			$clmList	= $mcls->getColumnList();
			$n				= count($smlList);
			$cCnt			= count($clmList);
			$pkey			= "";
			$pkStr		= "";
			$srcStr		= "";
			
			$srcList	= $viewcls->getSearchList();
			
			$rMsg			= "<?php

	/* Include the required files */
	require_once( 'checkLogin.php' );
	require_once( 'dao/class.".$tblname.".php' );";
	
	for($i=0;$i<count($smlList);$i++) {
		$smname	= "gen_module".$mid."_submodule".($i+1);
		$rMsg		= $rMsg."
	require_once( 'dao/class.".$smname.".php' );";
	}
	
	$rMsg			= $rMsg."
	require_once( 'dao/class.moduledb".$mid.".php' );
	
	$"."ModuleID			= ".$mid.";

	$"."gdb					=	new genericdb();
	$"."mdb					=	new masterdb();
	$"."ldb					= new logindb();
	$"."mddb					=	new moduledb".$mid."();
	$"."cclass				= new ".$tblname."();
	
	if($"."ldb->getEditPermission($"."tuser->getUserID(), $"."ModuleID, $"."tcmp->getCompanyID()) != \"YES\") {
		header(\"Location:accessDenied.php\");
		exit;
	}
							
			";
			
			for($i=0;$i<count($clmList);$i++) {
				$scls		=	$clmList[$i];
				if($i == 0)
					$rMsg	=	$rMsg."\n\t$".$scls->getColumnName()."	=	\"\";\n";
				else
					$rMsg	=	$rMsg."\t$".$scls->getColumnName()."	=	\"\";\n";
					
				if($scls->getPrimaryKey() == "YES") {
					if($pkey != "") $pkey = $pkey.", ";
					$pkey	= $pkey."$"."pk".$scls->getColumnName();
				}
			}
			
			$rMsg	=	$rMsg."\n";
			for($i=0;$i<count($clmList);$i++) {
				$scls		=	$clmList[$i];
				if($scls->getPrimaryKey() == "YES") {
					$rMsg	=	$rMsg."\t$"."pk".$scls->getColumnName()."	=	\"\";\n";
				}
			}
			
			$rMsg	=	$rMsg."\n";
			for($i=0;$i<count($srcList);$i++) {
				$scls		=	$srcList[$i];
				$rMsg	=	$rMsg."\t$"."src".$scls->getColumnName().($i+1)."	=	\"\";\n";
				
				$srcStr		= $srcStr."&src".$scls->getColumnName().($i+1)."=<?php echo $"."src".$scls->getColumnName().($i+1)." ?>";
			}

			$rMsg = $rMsg."
	$"."pno					= 0;

	$"."rmsg					=	\"\";
	$"."msg					=	\"Please enter all the fields correctly.\";
	$"."pagen				=	\"\";";
	
	for($i=0;$i<count($smlList);$i++) {
		$rMsg = $rMsg."
	$"."numSubModule".($i+1)."				=	\"\";
	$"."SubModuleArr".($i+1)."				= array();
		";
	}
	
	
	$rMsg = $rMsg."

	$"."fcss					=	 array();
	for($"."i=0;$"."i<".count($clmList).";$"."i++)
		$"."fcss[$"."i]		=	\"input\";";
	for($i=0;$i<count($clmList);$i++) {
		$scls		=	$clmList[$i];
		if($scls->getInputType() == "select") {
			$rMsg = $rMsg."
	$"."fcss[".$i."]		=	\"select\";";
		}
	}

	$rMsg = $rMsg."
	
	extract($"."_REQUEST);
	
	";
	
	for($i=0;$i<count($srcList);$i++) {
		$scls		=	$srcList[$i];
		$rMsg	=	$rMsg."
	$"."src".$scls->getColumnName().($i+1)."	=	addslashes($"."src".$scls->getColumnName().($i+1).");";
	}	
			
	$rMsg = $rMsg."
	
	$"."cclass			= $"."mddb->getModule".$mid."Detail(".$pkey.");
	
	if($"."pagen == \"process\") {
		/* Check for valid input */
		";
		
			/* Check those fields for which Mandatory is set to YES */
			for($i=0;$i<count($clmList);$i++) {
				$scls		=	$clmList[$i];
				
				if($scls->getIsMandatory() == "YES") {
					if( $scls->getColumnDataType() == "int" ||
							$scls->getColumnDataType() == "tinyint" ||
							$scls->getColumnDataType() == "smallint" ||
							$scls->getColumnDataType() == "mediumint" ||
							$scls->getColumnDataType() == "bigint"
					) {
							$rMsg	= $rMsg."\n\t\tif((int)$".$scls->getColumnName()." <= 0) {";
							if($scls->getInputType() == "select") {
								$rMsg	= $rMsg."\n\t\t\t$"."fcss[".$i."]	=	\"err_select\";";
							} else {
								$rMsg	= $rMsg."\n\t\t\t$"."fcss[".$i."]	=	\"err_input\";";
							}
							$rMsg	= $rMsg."\n\t\t\tif($"."rmsg != \"\") $"."rmsg = $"."rmsg.\",\";";
							$rMsg	= $rMsg."\n\t\t\t$"."rmsg	=	$"."rmsg.\"".$scls->getColumnLabel()."\";";
							$rMsg	= $rMsg."\n\t\t}\n";
					} else if(
							$scls->getColumnDataType() == "decimal" ||
							$scls->getColumnDataType() == "float" ||
							$scls->getColumnDataType() == "double"
					) {
							$rMsg	= $rMsg."\n\t\tif((double)$".$scls->getColumnName()." <= 0) {";
							if($scls->getInputType() == "select") {
								$rMsg	= $rMsg."\n\t\t\t$"."fcss[".$i."]	=	\"err_select\";";
							} else {
								$rMsg	= $rMsg."\n\t\t\t$"."fcss[".$i."]	=	\"err_input\";";
							}
							$rMsg	= $rMsg."\n\t\t\tif($"."rmsg != \"\") $"."rmsg = $"."rmsg.\",\";";
							$rMsg	= $rMsg."\n\t\t\t$"."rmsg	=	$"."rmsg.\"".$scls->getColumnLabel()."\";";
							$rMsg	= $rMsg."\n\t\t}\n";
					} else if(
							$scls->getColumnDataType() == "varchar" ||
							$scls->getColumnDataType() == "enum" ||
							$scls->getColumnDataType() == "char" ||
							$scls->getColumnDataType() == "blob" ||
							$scls->getColumnDataType() == "tinyblob" ||
							$scls->getColumnDataType() == "mediumblob" ||
							$scls->getColumnDataType() == "longblob" ||
							$scls->getColumnDataType() == "text" ||
							$scls->getColumnDataType() == "tinytext" ||
							$scls->getColumnDataType() == "mediumtext" ||
							$scls->getColumnDataType() == "longtext"
					) {
							$rMsg	= $rMsg."\n\t\tif(trim($".$scls->getColumnName().") == \"\") {";
							if($scls->getInputType() == "select") {
								$rMsg	= $rMsg."\n\t\t\t$"."fcss[".$i."]	=	\"err_select\";";
							} else {
								$rMsg	= $rMsg."\n\t\t\t$"."fcss[".$i."]	=	\"err_input\";";
							}
							$rMsg	= $rMsg."\n\t\t\tif($"."rmsg != \"\") $"."rmsg = $"."rmsg.\",\";";
							$rMsg	= $rMsg."\n\t\t\t$"."rmsg	=	$"."rmsg.\"".$scls->getColumnLabel()."\";";
							$rMsg	= $rMsg."\n\t\t}\n";
					} else if($scls->getColumnDataType() == "date") {
							$rMsg	= $rMsg."\n\t\tif(FormatIndianDateToSQLDate($".$scls->getColumnName().") == \"1900-01-01\") {";
							$rMsg	= $rMsg."\n\t\t\t$"."fcss[".$i."]	=	\"err_input\";";
							$rMsg	= $rMsg."\n\t\t\tif($"."rmsg != \"\") $"."rmsg = $"."rmsg.\",\";";
							$rMsg	= $rMsg."\n\t\t\t$"."rmsg	=	$"."rmsg.\"Invalid Date ".$scls->getColumnLabel()."\";";
							$rMsg	= $rMsg."\n\t\t}\n";
					}
				}
			}
			/* Mandatory fields check / Form validation ends here */
			
			/* For check-boxes set YES/NO accordingly */
			for($i=0;$i<count($clmList);$i++) {
				$scls		=	$clmList[$i];
				if($scls->getInputType() == "checkbox") {
					$rMsg		=	$rMsg."\n\t\tif(isset($"."_REQUEST[\"".$scls->getColumnName()."\"]))";
					$rMsg		=	$rMsg."\n\t\t\t$".$scls->getColumnName()."	= \"YES\";";
					$rMsg		=	$rMsg."\n\t\telse";
					$rMsg		=	$rMsg."\n\t\t\t$".$scls->getColumnName()."	= \"NO\";\n";
				}
			}
			/* Check-box entry correction ends here */
		
			/* Feed the module class variables */
			for($i=0;$i<count($clmList);$i++) {
				$scls		=	$clmList[$i];
				if($scls->getPrimaryKey() == "YES") continue;
				if($scls->getDisplayInForm() == "NO") continue;
				$rMsg	= $rMsg."\n\t\t$"."cclass->set".$scls->getColumnName()."($".$scls->getColumnName().");";
			}
			/* module main class variable feeding ends here */
			
			/* Handle the submodules */
			for($i=0;$i<count($smlList);$i++) {
				$scls			= $smlList[$i];
				$smdet		= $this->getModuleDetail($scls->getSubmoduleID());
				$sclmList	= $smdet->getColumnList();
				
				$rMsg		=	$rMsg."\n\t\tfor($"."i=1;$"."i<=$"."numSubModule".($i+1).";$"."i++) {";
				
				/* SUB MODULE Check those fields for which Mandatory is set to YES */
				for($j=0;$j<count($sclmList);$j++) {
					$scls		=	$sclmList[$j];
					if($scls->getIsMandatory() == "YES") {
						if( $scls->getColumnDataType() == "int" ||
								$scls->getColumnDataType() == "tinyint" ||
								$scls->getColumnDataType() == "smallint" ||
								$scls->getColumnDataType() == "mediumint" ||
								$scls->getColumnDataType() == "bigint"
						) {
								$rMsg	= $rMsg."\n\t\t\tif((int)$"."_REQUEST[\"".$scls->getColumnName()."$"."i\"] <= 0) {";
								$rMsg	= $rMsg."\n\t\t\t\tif($"."rmsg != \"\") $"."rmsg = $"."rmsg.\",\";";
								$rMsg	= $rMsg."\n\t\t\t\t$"."rmsg	=	$"."rmsg.\"".$scls->getColumnLabel()."\";";
								$rMsg	= $rMsg."\n\t\t\t}\n";
						} else if(
								$scls->getColumnDataType() == "decimal" ||
								$scls->getColumnDataType() == "float" ||
								$scls->getColumnDataType() == "double"
						) {
								$rMsg	= $rMsg."\n\t\t\tif((double)$"."_REQUEST[\"".$scls->getColumnName()."$"."i\"] <= 0) {";
								$rMsg	= $rMsg."\n\t\t\t\tif($"."rmsg != \"\") $"."rmsg = $"."rmsg.\",\";";
								$rMsg	= $rMsg."\n\t\t\t\t$"."rmsg	=	$"."rmsg.\"".$scls->getColumnLabel()."\";";
								$rMsg	= $rMsg."\n\t\t\t}\n";
						} else if(
								$scls->getColumnDataType() == "varchar" ||
								$scls->getColumnDataType() == "enum" ||
								$scls->getColumnDataType() == "char" ||
								$scls->getColumnDataType() == "blob" ||
								$scls->getColumnDataType() == "tinyblob" ||
								$scls->getColumnDataType() == "mediumblob" ||
								$scls->getColumnDataType() == "longblob" ||
								$scls->getColumnDataType() == "text" ||
								$scls->getColumnDataType() == "tinytext" ||
								$scls->getColumnDataType() == "mediumtext" ||
								$scls->getColumnDataType() == "longtext"
						) {
								$rMsg	= $rMsg."\n\t\t\tif(trim($"."_REQUEST[\"".$scls->getColumnName()."$"."i\"]) == \"\") {";
								$rMsg	= $rMsg."\n\t\t\t\tif($"."rmsg != \"\") $"."rmsg = $"."rmsg.\",\";";
								$rMsg	= $rMsg."\n\t\t\t\t$"."rmsg	=	$"."rmsg.\"".$scls->getColumnLabel()."\";";
								$rMsg	= $rMsg."\n\t\t\t}\n";
						} else if($scls->getColumnDataType() == "date") {
								$rMsg	= $rMsg."\n\t\t\tif(FormatIndianDateToSQLDate($"."_REQUEST[\"".$scls->getColumnName()."$"."i\"]) == \"1900-01-01\") {";
								$rMsg	= $rMsg."\n\t\t\t\tif($"."rmsg != \"\") $"."rmsg = $"."rmsg.\",\";";
								$rMsg	= $rMsg."\n\t\t\t\t$"."rmsg	=	$"."rmsg.\"Invalid Date ".$scls->getColumnLabel()."\";";
								$rMsg	= $rMsg."\n\t\t\t}\n";
						}
					}
				}
				/* SUB MODULE Mandatory fields check / Form validation ends here */
				
				/* SUB MODULE Feed the class variables */
				$rMsg		=	$rMsg."\n\t\t\t$"."smcls	= new gen_module".$mid."_submodule".($i+1)."()";
				for($j=0;$j<count($sclmList);$j++) {
					$smccls	= $sclmList[$j];
					if($smccls->getInputType() == "checkbox") {
						$rMsg		=	$rMsg."\n\t\t\tif(isset($"."_REQUEST[\"".$scls->getColumnName()."$"."i\"]))";
						$rMsg."\n\t\t\t\t$"."smcls->set".$smccls->getColumnName()."(\"YES\");";
						$rMsg		=	$rMsg."\n\t\telse";
						$rMsg		=	$rMsg."\n\t\t\t\t$"."smcls->set".$smccls->getColumnName()."(\"NO\");";
					} else {
						$rMsg	= $rMsg."\n\t\t\t$"."smcls->set".$smccls->getColumnName()."($"."_REQUEST[\"".$smccls->getColumnName()."$"."i\"]);";
					}
				}
				/* SUB MODULE class variable feeding ends here */
				$rMsg		=	$rMsg."\n\t\t\t$"."SubModuleArr".($i+1)."[] = $"."smcls;";
				
				$rMsg		=	$rMsg."\n\t\t}";
				$rMsg		=	$rMsg."\n\t\t$"."cclass->setSubModuleList".($i+1)."($"."SubModuleArr".($i+1).");";
				
			}
			/* Submodule handling ends here */
			
			$scls		=	$clmList[0];
			$rMsg	= $rMsg."

		if($"."rmsg == \"\") {
			if($"."mddb->UpdateModule".$mid."($"."cclass)) {
				$"."msg	=	\"<font class='blue'>".$mcls->getModuleName()." updated successfully</font>\";
				$"."log	=	new asys_user_log();
				$"."log->setUserID($"."tuser->getUserID());
				$"."log->setCompanyID($"."tcmp->getCompanyID());
				$"."log->setModuleID($"."ModuleID);
				$"."log->setRelatedID($"."cclass->get".$scls->getColumnName()."());
				$"."log->setActivity(\"Modified ".$mcls->getModuleName()." - \".$".$scls->getColumnName().");
				$"."log->setClassName('".$tblname."');
				$"."log->setModuleSnapshot(serialize($"."cclass));
				$"."log->setLogID($"."gdb->getNextID(\"asys_user_log\", \"LogID\"));
				$"."gdb->SaveObjectToDB($"."log);
				
				$"."cclass			= $"."mddb->getModule".$mid."Detail(".$pkey.");
			} else {
				$"."msg	=	\"<font class='red'>Failed to save record, try again</font>\";
			}
		} else {
			$"."msg	=	\"<font class='red'>The following fields are mandatory: \".$"."rmsg.\"</font>\";
		}
	}

	
	/* Ready to create the page */
	$"."iPage	=	new asys_pages(APP_TITLE);
	/* Start writting the page */
	$"."iPage->startPage();
	$"."iPage->startHeader();
	/* Add links and Scripts as required */
	$"."iPage->addLink(\"css/asys.css\");
	$"."iPage->addLink(\"css/menu.css\");
	$"."iPage->addLink(\"css/superTables.css\");
	$"."iPage->addLink(\"css/select2.css\");
	$"."iPage->addLink(\"css/modal.css\");
	$"."iPage->addLink(\"css/datepicker.css\");
	$"."iPage->addScript(\"js/common.js\");
	$"."iPage->addScript(\"js/superTables.js\");	
	$"."iPage->addScript(\"js/jquery.js\");
	$"."iPage->addScript(\"js/select2.js\");
	$"."iPage->addScript(\"js/modal.js\");
	$"."iPage->addScript(\"js/datepicker.js\");
	$"."iPage->addScript(\"js/nlbFade.js\");
	$"."iPage->endHeader();
	$"."iPage->startBody();
	
	outputHeader($"."tuser, $"."tcmp);
	outputMenu($"."tuser);
	
?>	

	<div id=\"pagehead\">&nbsp;MODIFY ".$mcls->getModuleName()." #<?php echo $"."cclass->get".$scls->getColumnName()."()?></div>
	<div style=\"height:10px;\"></div>
	
	<div style=\"width:980px;margin:0px auto\">
	<form name=\"hfrm\" id=\"hfrm\" method=\"post\" action=\"\" enctype=\"multipart/form-data\">
	<input type=\"hidden\" name=\"pagen\" value=\"process\" />
	<input type=\"hidden\" name=\"pno\" value=\"<?php echo $"."pno?>\" />";
	
	for($i=0;$i<count($clmList);$i++) {
		$scls		=	$clmList[$i];
		if($scls->getPrimaryKey() == "YES") {
			$rMsg	=	$rMsg."\n\t<input type=\"hidden\" name=\"pk".$scls->getColumnName()."\" value=\"<?php echo $"."pk".$scls->getColumnName()."?>\" />";
		}
	}	
	
	for($i=0;$i<count($srcList);$i++) {
		$scls		=	$srcList[$i];
		$rMsg	=	$rMsg."\n\t<input type=\"hidden\" name=\"src".$scls->getColumnName().($i+1)."\" value=\"<?php echo $"."src".$scls->getColumnName().($i+1)."?>\" />";
	}	
	
	for($i=0;$i<count($smlList);$i++) {
		$rMsg	= $rMsg."\n\t<input type=\"hidden\" name=\"numSubModule".($i+1)."\" id=\"numSubModule".($i+1)."\" value=\"<?php echo $"."numSubModule".($i+1)."?>\" />";
	}
	
	$rMsg	= $rMsg."
	
	<table cellpadding=\"1\" cellspacing=\"0\" border=\"0\" width=\"980px\" align=\"center\" bgcolor=\"#ffffff\">
		<tr bgcolor=\"#D6E3F3\"><td colspan=\"3\" class=\"td_normal blue bold\">
			<div id=\"dhead\" style=\"float:left;width:900px;padding:5px;\"><?php echo $"."msg?></div>
			<div style=\"float:right;padding:5px;\"><a href=\"viewModule".$mid.".php\"><img src=\"images/columns.gif\" title=\"View ".$mcls->getModuleName()." List\" /></a></div>
		</td></tr>
		<tr style=\"height:1px\" bgcolor=\"#99BBE8\"><td colspan=\"3\"></td></tr>
		<tr style=\"height:2px\"><td colspan=\"3\"></td></tr>
			";

			$cnt			= 0;
			for($i=0;$i<count($clmList);$i++) {
				$scls		= $clmList[$i];
				
				if($scls->getDisplayInForm() != "YES") continue;
				$cnt++;
				
				if($cnt == 1) {
					$rMsg	=	$rMsg."
		<tr>
			<td class=\"td_normal\" width=\"170px;\">&nbsp;".$scls->getColumnLabel()."</td>
			<td class=\"td_normal\" width=\"10px;\">:</td>";
				} else {
					$rMsg	=	$rMsg."
		<tr>
			<td class=\"td_normal\" valign=\"top\">&nbsp;".$scls->getColumnLabel()."</td>
			<td class=\"td_normal\" valign=\"top\">:</td>";
				}
			
				switch($scls->getInputType()) {
					case 'text':
						if($scls->getColumnDataType() == "varchar") {
							$rMsg	=	$rMsg."
			<td class=\"td_normal\"><input type=\"text\" class=\"<?php echo $"."fcss[$i]?>\" name=\"".$scls->getColumnName()."\" id=\"".$scls->getColumnName()."\" value=\"<?php echo $"."cclass->get".$scls->getColumnName()."('yes')?>\" style=\"width:".$scls->getInputLength()."px\" maxLength=\"".$scls->getColumnLength()."\" onFocus=\"this.className='input_focus'\" onBlur=\"this.className='<?php echo $"."fcss[$i]?>'\" /></td>";
						} else if($scls->getColumnDataType() == "date") {
							$rMsg	=	$rMsg."
			<td class=\"td_normal\"><input data-type=\"datepicker\" type=\"text\" class=\"<?php echo $"."fcss[$i]?>\" name=\"".$scls->getColumnName()."\" id=\"".$scls->getColumnName()."\" value=\"<?php echo $"."cclass->get".$scls->getColumnName()."('yes')?>\" style=\"width:80px\" maxLength=\"10\" onFocus=\"this.className='input_focus'\" onBlur=\"this.className='<?php echo $"."fcss[$i]?>'\" /></td>";
						} else {
							$rMsg	=	$rMsg."
			<td class=\"td_normal\"><input type=\"text\" class=\"<?php echo $"."fcss[$i]?>\" name=\"".$scls->getColumnName()."\" id=\"".$scls->getColumnName()."\" value=\"<?php if($"."cclass->get".$scls->getColumnName()."() != 0) echo $"."cclass->get".$scls->getColumnName()."('no')?>\" style=\"width:80px\" maxLength=\"15\" onFocus=\"this.className='input_focus'\" onBlur=\"this.className='<?php echo $"."fcss[$i]?>'\" /></td>";
						}
						break;
					case 'select':
						if($scls->getSelectValues() != "") {
							$tmp	= explode(",", $scls->getSelectValues());
							$rMsg	=	$rMsg."
			<td class=\"td_normal\">
				<select class=\"<?php echo $"."fcss[$i]?>\" name=\"".$scls->getColumnName()."\" id=\"".$scls->getColumnName()."\">
					<option value=\"\">--</option>";
					for($k=0;$k<count($tmp);$k++) {
						$str	= $tmp[$k];
						$rMsg	=	$rMsg."
						<option value=\"".$str."\" <?php if($"."cclass->get".$scls->getColumnName()."() == \"".$str."\") echo 'selected'; ?>>".$str."</option>";
					}
					$rMsg	=	$rMsg."
				</select>
			</td>";
						} else {
							$rMsg	=	$rMsg."
			<td class=\"td_normal\"><select name=\"".$scls->getColumnName()."\" id=\"".$scls->getColumnName()."\" style=\"width:300px\"></select></td>";
						}
						break;
					case 'checkbox':
						$rMsg	=	$rMsg."
			<td class=\"td_normal\"><input type=\"checkbox\" class=\"<?php echo $"."fcss[$i]?>\" name=\"".$scls->getColumnName()."\" id=\"".$scls->getColumnName()."\" <?php if($"."cclass->get".$scls->getColumnName()."() == \"YES\") echo 'checked'; ?> /></td>
					";
						break;
					case 'textarea':
						$ilen	= $scls->getInputLength();
						$wd		= 600;
						$ht		= 100;
						if(strpos($ilen, ",") !== false) {
							$tmp	= explode(",", $ilen);
							$wd		= $tmp[0];
							$ht		= $tmp[1];
						}
						$rMsg	=	$rMsg."
			<td class=\"td_normal\"><textarea class=\"<?php echo $"."fcss[$i]?>\" name=\"".$scls->getColumnName()."\" id=\"".$scls->getColumnName()."\" style=\"width:".$wd."px;height:".$ht."px;\" onFocus=\"this.className='input_focus'\" onBlur=\"this.className='<?php echo $"."fcss[$i]?>'\" /><?php echo $"."cclass->get".$scls->getColumnName()."() ?></textarea></td>";
						break;
					case 'file':
						$rMsg	=	$rMsg."
			<td class=\"td_normal\"><input type=\"file\" class=\"<?php echo $"."fcss[$i]?>\" name=\"".$scls->getColumnName()."\" id=\"".$scls->getColumnName()."\" style=\"width:300px;\" /></td>
					";
						break;
					default:
					
				}
			
				$rMsg	=	$rMsg."
		</tr>
		";
				
			}
			
			
			/* Handle the submodules */
			for($i=0;$i<count($smlList);$i++) {
				
				$smcls		=	$smlList[$i];
				$smdet		= $this->getModuleDetail($smcls->getSubmoduleID());
				$sclmList	= $smdet->getColumnList();
				
				$rMsg			= $rMsg."
	
		<tr style=\"height:2px\"><td colspan=\"3\"></td></tr>
		<tr><td colspan=\"3\" style=\"border-bottom:#99BBE8 1px solid;\"></td></tr>
		<tr bgcolor=\"#D6E3F3\">
			<td colspan=\"3\" class=\"td_normal_large bold red\">
				&nbsp;".$mcls->getModuleName()." 
				<input type=\"button\" class=\"red_button\" value=\"+\" onClick=\"addSubModuleRow".($i+1)."()\" />
				<input type=\"button\" class=\"red_button\" value=\"—\" onClick=\"deleteSubModuleRow".($i+1)."()\" />
			</td>
		</tr>
		<tr><td colspan=\"3\" style=\"border-top:#99BBE8 1px solid;\"></td></tr>
		<tr style=\"height:2px\"><td colspan=\"3\"></td></tr>				
				
		<tr>
			<td colspan=\"3\">
	
		<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\">
			<tr class=\"table_head2\">
			
				<th width=\"50px\" style=\"border-left: 1px solid #99BBE8;\">SN</th>
	";
	
				for($j=0;$j<count($sclmList);$j++) {
					$scls		= $sclmList[$j];
					if($scls->getInputLength() == 0) $scls->setInputLength(50);
					
					if($scls->getDisplayInForm() != "YES") continue;
					
					$rMsg			= $rMsg."
				<th width=\"".$scls->getInputLength()."px\">".$scls->getColumnLabel()."</th>";
				}
				
				$rMsg			= $rMsg."
			</tr>
		</table>
		
			</td>
		</tr>	
	
		<tr>
			<td colspan=\"3\">		
		
		<table style=\"border:0px;\" cellpadding=\"0\" cellspacing=\"1\" width=\"100%\" id=\"submTbl".($i+1)."\">";
		
		
			$rMsg			= $rMsg."
			
			<?php
				$"."smList	=	$"."cclass->getSubmoduleList".($i+1)."();
				for($"."i=0;$"."i<count($"."smList);$"."i++){
					$"."smcls	=	$"."smList[$"."i];
			?>			
			
			<tr>
				<td width=\"50px\" style=\"padding:2px;\">
					<input type=\"button\" class=\"red_button\" style=\"width:25px;\" value=\"<?php echo ($"."i+1)?>\" onClick=\"clearRowOfSubModule".($i+1)."(<?php echo ($"."i+1)?>)\" />
				</td>
				";
				

				for($j=0;$j<count($sclmList);$j++) {
					$scls		= $sclmList[$j];
				
					if($scls->getDisplayInForm() != "YES") continue;
			
					switch($scls->getInputType()) {
						case 'text':
							if($scls->getColumnDataType() == "varchar") {
								$rMsg	=	$rMsg."
				<td width=\"".$scls->getInputLength()."px\" style=\"padding:2px;\"><input type=\"text\" class=\"input\" name=\"".$scls->getColumnName()."<?php echo ($"."i+1)?>\" id=\"".$scls->getColumnName()."<?php echo ($"."i+1)?>\" value=\"<?php echo $"."smcls->get".$scls->getColumnName()."('yes')?>\" style=\"width:".$scls->getInputLength()."px\" maxLength=\"".$scls->getColumnLength()."\" onFocus=\"this.className='input_focus'\" onBlur=\"this.className='input'\" /></td>";
							} else if($scls->getColumnDataType() == "date") {
								$rMsg	=	$rMsg."
				<td width=\"80px\" style=\"padding:2px;\"><input data-toggle=\"datepicker\" type=\"text\" class=\"input\" name=\"".$scls->getColumnName()."<?php echo ($"."i+1)?>\" id=\"".$scls->getColumnName()."<?php echo ($"."i+1)?>\" value=\"<?php echo $"."smcls->get".$scls->getColumnName()."('yes')?>\" style=\"width:80px\" maxLength=\"10\" onFocus=\"this.className='input_focus'\" onBlur=\"this.className='input'\" /></td>";
							} else {
								$rMsg	=	$rMsg."
				<td width=\"80px\" style=\"padding:2px;\"><input type=\"text\" class=\"input\" name=\"".$scls->getColumnName()."<?php echo ($"."i+1)?>\" id=\"".$scls->getColumnName()."<?php echo ($"."i+1)?>\" value=\"<?php if($"."smcls->get".$scls->getColumnName()."() != 0) echo $"."smcls->get".$scls->getColumnName()."('no')?>\" style=\"width:80px\" maxLength=\"15\" onFocus=\"this.className='input_focus'\" onBlur=\"this.className='input'\" /></td>";
							}
							break;
						case 'select':
							if($scls->getSelectValues() != "") {
								$tmp	= explode(",", $scls->getSelectValues());
								$rMsg	=	$rMsg."
				<td class=\"td_normal\">
					<select class=\"select\" name=\"".$scls->getColumnName()."<?php echo ($"."i+1)?>\" id=\"".$scls->getColumnName()."<?php echo ($"."i+1)?>\">
						<option value=\"\">--</option>";
							for($k=0;$k<count($tmp);$k++) {
								$str	= $tmp[$k];
								$rMsg	=	$rMsg."
						<option value=\"".$str."\" <?php if($"."smcls->get".$scls->getColumnName()."() == \"".$str."\") echo 'selected'; ?>>".$str."</option>";
							}
							$rMsg	=	$rMsg."
					</select>
				</td>";
							} else {
								$rMsg	=	$rMsg."
				<td class=\"td_normal\"><select name=\"".$scls->getColumnName()."<?php echo ($"."i+1)?>\" id=\"".$scls->getColumnName()."<?php echo ($"."i+1)?>\" style=\"width:".$scls->getInputLength()."px\"></select></td>";
							}
							break;
						case 'checkbox':
							$rMsg	=	$rMsg."
				<td class=\"td_normal\"><input type=\"checkbox\" class=\"input\" name=\"".$scls->getColumnName()."<?php echo ($"."i+1)?>\" id=\"".$scls->getColumnName()."<?php echo ($"."i+1)?>\" <?php if($"."smcls->get".$scls->getColumnName()."() == \"YES\") echo 'checked'; ?> /></td>
						";
							break;
						case 'textarea':
							$ilen	= $scls->getInputLength();
							$wd		= 600;
							$ht		= 100;
							if(strpos($ilen, ",") !== false) {
								$tmp	= explode(",", $ilen);
								$wd		= $tmp[0];
								$ht		= $tmp[1];
							}
							$rMsg	=	$rMsg."
				<td class=\"td_normal\"><textarea class=\"input\" name=\"".$scls->getColumnName()."<?php echo ($"."i+1)?>\" id=\"".$scls->getColumnName()."<?php echo ($"."i+1)?>\" style=\"width:".$wd."px;height:".$ht."px;\" onFocus=\"this.className='input_focus'\" onBlur=\"this.className='input'\" /><?php echo $"."smcls->get".$scls->getColumnName()."() ?></textarea></td>";
							break;
						case 'file':
							$rMsg	=	$rMsg."
				<td class=\"td_normal\"><input type=\"file\" class=\"input\" name=\"".$scls->getColumnName()."<?php echo ($"."i+1)?>\" id=\"".$scls->getColumnName()."<?php echo ($"."i+1)?>\" style=\"width:".$scls->getInputLength()."px;\" /></td>
						";
							break;
						default:
					
					}
				
				}
				
				$rMsg			= $rMsg."
			</tr>
			
			<?php } ?>			
			
		</table>
		
			</td>
		</tr>
		<tr style=\"height:4px\"><td colspan=\"3\" style=\"border-top:#e6b800 1px solid;\"></td></tr>
	<!-- Sub-Module ".($i+1)." entries ends here -->
	";	
				
			}
			
				


			$rMsg	=	$rMsg."
		<tr style=\"height:1px\" bgcolor=\"#99BBE8\"><td colspan=\"3\"></td></tr>
		<tr bgcolor=\"#D6E3F3\">
			<td colspan=\"3\" align=\"center\">
				<input type=\"button\" id=\"btnS\" class=\"red_button\" value=\" Update (S) \" AccessKey=\"S\" onClick=\"saveRec()\" />
				<input type=\"button\" class=\"red_button\" value=\" Go Back (G) \" AccessKey=\"G\" onClick=\"goBack()\" />
			</td>
		</tr>
	</table>
	</form>
	</div>
	
	<br /><br />
	
<?php
	$"."iPage->endBody();
	$"."iPage->endPage();
?>
		
<script language=\"javaScript\">";

	for($i=0;$i<$n;$i++) {
		$rMsg	= $rMsg."
		
	var numSubModule".($i+1)." = \"<?php echo $"."numSubModule".($i+1)." ?>\";
		";
	}

	$rMsg	= $rMsg."

	$(function () {
		NLBfadeBg('dhead','#ffff00','#D6E3F3','3000');
	";
	
	$cnt	= 0;
	for($i=0;$i<$cCnt;$i++) {
		$scls		=	$clmList[$i];
		if($scls->getDisplayInForm() != "YES") continue;

		if($scls->getInputType() == "select") {
		
			$rMsg	=	$rMsg."\n\t\t$(\"#".$scls->getColumnName()."\").select2();";
		}

	}		
	
	$rMsg	= $rMsg."
	});
	
	";
	
	$cnt	= 0;
	for($i=0;$i<$cCnt;$i++) {
		$scls		=	$clmList[$i];
		if($scls->getDisplayInForm() != "YES") continue;

		if($scls->getInputType() == "select" && $scls->getSelectValues() == "") {
			
			$rMsg	=	$rMsg."\n\tfetch".$scls->getColumnName()."For".$mid."('".$scls->getRelatedTable()."','".$scls->getValueField()."','".$scls->getDisplayFields()."','".$scls->getDataFetchSQL()."', 'yes'); ";
		}

	}	

	$rMsg	= $rMsg."
	
	$('[data-toggle=\"datepicker\"]').datepicker({
		format: 'dd-mm-yyyy',
		autoHide: 'yes'
	});
	
	";

	
	for($i=0;$i<$cCnt;$i++) {
		$scls		=	$clmList[$i];

		if($scls->getInputType() == "select" && $scls->getSelectValues() == "") {
		
			$rMsg	=	$rMsg."
				
	function fetch".$scls->getColumnName()."For".$mid."(tblname, fld1, fld2, condn, fc) {
	
    $('#".$scls->getColumnName()."').empty();
    $('#".$scls->getColumnName()."').append('<option value=\"0\">--</option>');
    var iid		= \"<?php echo $"."cclass->get".$scls->getColumnName()."()?>\";
    
    $.ajax({
			type: \"POST\",
			url: \"json/getGenericDataForJSON.php\",
			data: {\"tblName\": tblname, \"fld1\": fld1, \"fld2\": fld2, \"condn\": \"\"},
			success: function(data){

				var opts = $.parseJSON(data);
				$.each(opts, function(i, d) {
					$('#".$scls->getColumnName()."').append('<option value=\"' + d.".$scls->getValueField()." + '\">' + d.".$scls->getDisplayFields()." + '</option>');
				});
				$(\"#".$scls->getColumnName()."\").val(iid).change();
				
			}
    });

	}
				
			";
		}
			
	}
	
	
			/* Handle the submodules */
			for($i=0;$i<count($smlList);$i++) {
				
				$smcls		=	$smlList[$i];
				$smdet		= $this->getModuleDetail($smcls->getSubmoduleID());
				$sclmList	= $smdet->getColumnList();
				
				$rMsg			= $rMsg."

	function addSubModuleRow".($i+1)."()	{
		
		var rTable	= EBD(\"submTbl".($i+1)."\");
		var iRow		= rTable.insertRow(numSubModule".($i+1).");

		numSubModule".($i+1)."++;
		var iCell;
		
		iCell								= iRow.insertCell(0);
		iCell.style.padding	=	\"2px\";
		iCell.innerHTML			= '<input type=\"button\" class=\"red_button\" style=\"width:25px;\" value=\"' + numSubModule".($i+1)." + '\" onClick=\"clearRowOfSubModule".($i+1)."(' + numSubModule".($i+1)." + ')\" />';
	";

				$jcnt		= 1;
				for($j=0;$j<count($sclmList);$j++) {
					$scls		= $sclmList[$j];
				
					if($scls->getDisplayInForm() != "YES") continue;
			
					switch($scls->getInputType()) {
						case 'text':
							if($scls->getColumnDataType() == "varchar") {
								$rMsg	=	$rMsg."
		iCell								= iRow.insertCell(".$jcnt.");
		iCell.style.padding	=	\"2px\";
		iCell.innerHTML			= '<input type=\"text\" class=\"input\" name=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" id=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" value=\"\" style=\"width:".$scls->getInputLength()."px\" maxLength=\"".$scls->getColumnLength()."\" onFocus=\"this.className=\'input_focus\'\" onBlur=\"this.className=\'input\'\" title=\"".$scls->getColumnName()."\" />';
					";
							} else if($scls->getColumnDataType() == "date") {
								$rMsg	=	$rMsg."
		iCell								= iRow.insertCell(".$jcnt.");
		iCell.style.padding	=	\"2px\";
		iCell.innerHTML			= '<input data-toggle=\"datepicker\" type=\"text\" class=\"input\" name=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" id=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" value=\"\" style=\"width:80px\" maxLength=\"10\" onFocus=\"this.className=\'input_focus\'\" onBlur=\"this.className=\'input\'\" title=\"".$scls->getColumnName()."\" />';	
		";
							} else {
								$rMsg	=	$rMsg."
		iCell								= iRow.insertCell(".$jcnt.");
		iCell.style.padding	=	\"2px\";
		iCell.innerHTML			= '<input type=\"text\" class=\"input\" name=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" id=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" value=\"\" style=\"width:80px\" maxLength=\"15\" onFocus=\"this.className=\'input_focus\'\" onBlur=\"this.className=\'input\'\" title=\"".$scls->getColumnName()."\" />';
					";
							}
							break;
						case 'select':
							if($scls->getSelectValues() != "") {
								$tmp	= explode(",", $scls->getSelectValues());
								$rMsg	=	$rMsg."
		iCell								= iRow.insertCell(".$jcnt.");
		iCell.style.padding	=	\"2px\";
		iCell.innerHTML			= '<select class=\"select\" name=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" id=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\">\
		<option value=\"\">--</option>\
		";
							for($k=0;$k<count($tmp);$k++) {
								$str	= $tmp[$k];
								$rMsg	=	$rMsg."<option value=\"".$str."\" >".$str."</option>\
								";
							}
							
							$rMsg	=	$rMsg."
						</select>';
					";

							} else {
								$rMsg	=	$rMsg."
		iCell								= iRow.insertCell(".$jcnt.");
		iCell.style.padding	=	\"2px\";
		iCell.innerHTML			= '<select name=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" id=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" style=\"width:".$scls->getInputLength()."px\"></select>';
					";
							}
							break;
						case 'checkbox':
							$rMsg	=	$rMsg."
		iCell								= iRow.insertCell(".$jcnt.");
		iCell.style.padding	=	\"2px\";
		iCell.innerHTML			= '<input type=\"checkbox\" class=\"input\" name=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" id=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" />';
						";
							break;
						case 'textarea':
							$ilen	= $scls->getInputLength();
							$wd		= 600;
							$ht		= 100;
							if(strpos($ilen, ",") !== false) {
								$tmp	= explode(",", $ilen);
								$wd		= $tmp[0];
								$ht		= $tmp[1];
							}
							$rMsg	=	$rMsg."
		iCell								= iRow.insertCell(".$jcnt.");
		iCell.style.padding	=	\"2px\";
		iCell.innerHTML			= '<textarea class=\"input\" name=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" id=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" style=\"width:".$wd."px;height:".$ht."px;\" onFocus=\"this.className=\'input_focus\'\" onBlur=\"this.className=\'input\'\" /></textarea>';
		";
							break;
						case 'file':
							$rMsg	=	$rMsg."
		iCell								= iRow.insertCell(".$jcnt.");
		iCell.style.padding	=	\"2px\";
		iCell.innerHTML			= '<input type=\"file\" class=\"input\" name=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" id=\"".$scls->getColumnName()."' + numSubModule".($i+1)." + '\" style=\"width:".$scls->getInputLength()."px;\" />';
						";
							break;
						default:
					
					}
					$jcnt++;
				}
				
	for($j=0;$j<count($sclmList);$j++) {
		$scls		= $sclmList[$j];
		
		if($scls->getColumnDataType() == "date" && $scls->getDisplayInForm() == "YES") {
						$rMsg	=	$rMsg."
						
			$('#".$scls->getColumnName()."').datepicker({
				format: 'dd-mm-yyyy',
				autoHide: 'yes'
			});
				";		
		}		
		
		if($scls->getInputType() == "select" && $scls->getSelectValues() != "") {
				$rMsg			= $rMsg."
				$('#".$scls->getColumnName()."').select2();
		fetch".$scls->getColumnName()."For".$mid."('".$scls->getRelatedTable()."','".$scls->getValueField()."','".$scls->getDisplayFields()."','".$scls->getDataFetchSQL()."', 'no');
	";
		}
		
	}
				
				$rMsg			= $rMsg."
		
	}
	
	function deleteSubModuleRow".($i+1)."()	{
		if(numSubModule".($i+1)." > 1)	{
			var rTable	= EBD(\"submTbl".($i+1)."\");
			var iRow		= rTable.deleteRow(numSubModule".($i+1)." - 1);
			numSubModule".($i+1)."--;
		}
	}";
	
	}
	
	$rMsg			= $rMsg."
	
	function saveRec() {
		";
		
		
	for($i=0;$i<$cCnt;$i++) {
		$scls		=	$clmList[$i];
		if($scls->getIsMandatory() == "YES") {
			if( $scls->getColumnDataType() == "int" ||
					$scls->getColumnDataType() == "tinyint" ||
					$scls->getColumnDataType() == "smallint" ||
					$scls->getColumnDataType() == "mediumint" ||
					$scls->getColumnDataType() == "bigint" ||
					$scls->getColumnDataType() == "decimal" ||
					$scls->getColumnDataType() == "float" ||
					$scls->getColumnDataType() == "double"
			) {
				$rMsg	= $rMsg."\n\t\tif(checkForValidInput('".$scls->getColumnName()."','Positive','Please enter ".$scls->getColumnLabel()."') == false) return;";
			} else if(
					$scls->getColumnDataType() == "varchar" ||
					$scls->getColumnDataType() == "enum" ||
					$scls->getColumnDataType() == "char" ||
					$scls->getColumnDataType() == "blob" ||
					$scls->getColumnDataType() == "tinyblob" ||
					$scls->getColumnDataType() == "mediumblob" ||
					$scls->getColumnDataType() == "longblob" ||
					$scls->getColumnDataType() == "text" ||
					$scls->getColumnDataType() == "tinytext" ||
					$scls->getColumnDataType() == "mediumtext" ||
					$scls->getColumnDataType() == "longtext"
			) {
				$rMsg	= $rMsg."\n\t\tif(checkForValidInput('".$scls->getColumnName()."','Text','Please enter ".$scls->getColumnLabel()."') == false) return;";
			} else if($scls->getColumnDataType() == "date") {
				$rMsg	= $rMsg."\n\t\tif(checkForValidInput('".$scls->getColumnName()."','Date','Please enter ".$scls->getColumnLabel()."') == false) return;";
			}
		}

	}
	
			
	for($i=0;$i<count($smlList);$i++) {
		$smcls		= $smlList[$i];
		$smdet		= $this->getModuleDetail($smcls->getSubmoduleID());
		$sclmList	= $smdet->getColumnList();
		
		$rMsg	= $rMsg."\n
		for(var i=1;i<=numSubModule".($i+1).";i++) {
		";
	
		for($j=0;$j<count($sclmList);$j++) {
			$scls		= $sclmList[$j];
		
			if($scls->getIsMandatory() == "YES") {
				if( $scls->getColumnDataType() == "int" ||
						$scls->getColumnDataType() == "tinyint" ||
						$scls->getColumnDataType() == "smallint" ||
						$scls->getColumnDataType() == "mediumint" ||
						$scls->getColumnDataType() == "bigint" ||
						$scls->getColumnDataType() == "decimal" ||
						$scls->getColumnDataType() == "float" ||
						$scls->getColumnDataType() == "double"
				) {
					$rMsg	= $rMsg."\n\t\t\tif(checkForValidInput('".$scls->getColumnName()."','Positive','Please enter ".$scls->getColumnLabel()."') == false) return;";
				} else if(
						$scls->getColumnDataType() == "varchar" ||
						$scls->getColumnDataType() == "enum" ||
						$scls->getColumnDataType() == "char" ||
						$scls->getColumnDataType() == "blob" ||
						$scls->getColumnDataType() == "tinyblob" ||
						$scls->getColumnDataType() == "mediumblob" ||
						$scls->getColumnDataType() == "longblob" ||
						$scls->getColumnDataType() == "text" ||
						$scls->getColumnDataType() == "tinytext" ||
						$scls->getColumnDataType() == "mediumtext" ||
						$scls->getColumnDataType() == "longtext"
				) {
					$rMsg	= $rMsg."\n\t\t\tif(checkForValidInput('".$scls->getColumnName()."','Text','Please enter ".$scls->getColumnLabel()."') == false) return;";
				} else if($scls->getColumnDataType() == "date") {
					$rMsg	= $rMsg."\n\t\t\tif(checkForValidInput('".$scls->getColumnName()."','Date','Please enter ".$scls->getColumnLabel()."') == false) return;";
				}
			}
			
		}
		
		$rMsg	= $rMsg."\n
		}\n\n
		";
		
		}
		
		
		for($i=0;$i<count($smlList);$i++) {
			$rMsg	= $rMsg."\n\t\tEBD('numSubModule".($i+1)."').value		= numSubModule".($i+1).";";
		}
		
		$rMsg	= $rMsg."\n\t\tEBD('hfrm').submit();

		";
		
	
	
		$rMsg			= $rMsg."
	}
	
	
	function goBack() {
		location = \"viewModule".$mid.".php?pno=<?php echo $"."pno?>".$srcStr."\";
	}	
	

</script>";

			return $rMsg;
				
		
		}
		
		
		
		/*******************************************************
		 * This is the code to generate a php code that handles 
		 * the view code in HTML and PHP
		 *******************************************************/                                    

		function getViewCodePHP($mcls, $viewcls) {

			$mid			= $mcls->getModuleID();
			$tblname	= "gen_module".$mid;
			$smlList	= $mcls->getSubmoduleList();
			$clmList	= $mcls->getColumnList();
			$n				= count($smlList);
			$pkey			= "";
			$pkeyStr	= "";
			$pkeyStr2	= "";
			$pknm			= "";
			
			$srcList	= $viewcls->getSearchList();
			$src			= "";
			$srcStr		= "";
			$fldList	= $viewcls->getFieldList();
			
			$rMsg			= "<?php

	/* Include the required files */
	require_once( 'checkLogin.php' );
	require_once( 'dao/class.".$tblname.".php' );";
	
	for($i=0;$i<count($smlList);$i++) {
		$smname	= "gen_module".$mid."_submodule".($i+1);
		$rMsg		= $rMsg."
	require_once( 'dao/class.".$smname.".php' );";
	}
	
	$rMsg			= $rMsg."
	require_once( 'dao/class.moduledb".$mid.".php' );		
	
	$"."ModuleID			= ".$mid.";

	$"."gdb					=	new genericdb();
	$"."mdb					=	new masterdb();
	$"."ldb					= new logindb();
	$"."mddb					=	new moduledb".$mid."();
	
	if($"."ldb->getViewPermission($"."tuser->getUserID(), $"."ModuleID, $"."tcmp->getCompanyID()) != \"YES\") {
		header(\"Location:accessDenied.php\");
		exit;
	}
							
	";
	
			for($i=0;$i<count($clmList);$i++) {
				$scls		= $clmList[$i];
				if($scls->getPrimaryKey() == "YES") {
					$pknm			= $scls->getColumnName();
					if($pkey != "") $pkey = $pkey.", ";
					$pkey			= $pkey."$"."pk".$scls->getColumnName();
					
					$pkeyStr	= $pkeyStr."&pk".$scls->getColumnName()."=<?php echo $"."row->get".$scls->getColumnName()."() ?>";
					$pkeyStr2	= $pkeyStr2."&pk".$scls->getColumnName()."=\"+pkey+\"";
				}
			}	
			
			$rMsg	=	$rMsg."\n";
			for($i=0;$i<count($srcList);$i++) {
				$scls		=	$srcList[$i];
				$rMsg	=	$rMsg."\t$"."src".$scls->getColumnName().($i+1)."	=	\"\";\n";
				
				if($src != "") $src = $src.", ";
				$src	= $src."$"."src".$scls->getColumnName().($i+1);
				
				$srcStr		= $srcStr."&src".$scls->getColumnName().($i+1)."=<?php echo $"."src".$scls->getColumnName().($i+1)." ?>";
			}	
	
	$rMsg			= $rMsg."
	
	$"."pno			= 0;
	$"."sRec			= 0;
	$"."rCnt			= 0;
	$"."nRec			= ".$viewcls->getNoR().";
	
	extract($"."_REQUEST);

	$"."pno			=	(int)$"."pno;
	if($"."pno < 0)
		$"."pno		=	0;\n";

	$rMsg	=	$rMsg."\n";
	for($i=0;$i<count($srcList);$i++) {
		$scls		=	$srcList[$i];
		$cnm		= $scls->getColumnName();
		$mclDet	= $this->getModuleColumnDetail($mid, $cnm);
		$cdt		= $mclDet->getColumnDataType();
		
		if($cdt == "date")
			$rMsg	=	$rMsg."\t$"."src".$scls->getColumnName().($i+1)."	=	FormatIndianDateToSQLDate($"."src".$scls->getColumnName().($i+1).");\n";
		else if($cdt == "bigint" || $cdt == "int" || $cdt == "smallint" || $cdt == "tinyint")
			$rMsg	=	$rMsg."\t$"."src".$scls->getColumnName().($i+1)."	=	(int)$"."src".$scls->getColumnName().($i+1).";\n";
		else if($cdt == "float" || $cdt == "double" || $cdt == "decimal")
			$rMsg	=	$rMsg."\t$"."src".$scls->getColumnName().($i+1)."	=	(double)$"."src".$scls->getColumnName().($i+1).";\n";
		else
			$rMsg	=	$rMsg."\t$"."src".$scls->getColumnName().($i+1)."	=	addslashes($"."src".$scls->getColumnName().($i+1).");\n";
	}	

	$rMsg			= $rMsg."
	$"."rCnt			= $"."mddb->getNumberOfModule".$mid."(".$src.");
	if( ceil(($"."rCnt) / $"."nRec) < $"."pno + 1  && $"."rCnt != 0)
		$"."pno		=	ceil(($"."rCnt)/$"."nRec) - 1;
	$"."sRec			= $"."pno * $"."nRec;

	$"."arr			=	$"."mddb->getModule".$mid."ListPaged($"."sRec, $"."nRec, ".$src.");\n\n";
	

	for($i=0;$i<count($srcList);$i++) {
		$scls		=	$srcList[$i];
		$cnm		= $scls->getColumnName();
		$mclDet	= $this->getModuleColumnDetail($mid, $cnm);
		$cdt		= $mclDet->getColumnDataType();
		
		if($cdt == "date")
			$rMsg	=	$rMsg."\t$"."src".$scls->getColumnName().($i+1)."	=	FormatSQLDateToIndianDate($"."src".$scls->getColumnName().($i+1).");\n";
	}	
	
	
	$rMsg			= $rMsg."
	
	/* Ready to create the page */
	$"."iPage	=	new asys_pages(APP_TITLE);
	/* Start writting the page */
	$"."iPage->startPage();
	$"."iPage->startHeader();
	/* Add links and Scripts as required */
	$"."iPage->addLink(\"css/asys.css\");
	$"."iPage->addLink(\"css/menu.css\");
	$"."iPage->addLink(\"css/superTables.css\");
	$"."iPage->addLink(\"css/datepicker.css\");
	$"."iPage->addLink(\"css/select2.css\");
	$"."iPage->addScript(\"js/common.js\");
	$"."iPage->addScript(\"js/superTables.js\");	
	$"."iPage->addScript(\"js/jquery.js\");
	$"."iPage->addScript(\"js/datepicker.js\");
	$"."iPage->addScript(\"js/select2.js\");
	
	$"."iPage->endHeader();
	$"."iPage->startBody();
	
	outputHeader($"."tuser, $"."tcmp);
	outputMenu($"."tuser);
	
?>

	<div id=\"pagehead\">&nbsp;".strtoupper($mcls->getModuleName())."</div>
	<div style=\"height:10px;\"></div>
	
	<table cellspacing=\"0\" border=\"0\" width=\"980px\" align=\"center\" bgcolor=\"#99BBE8\">
		<tr><td bgcolor=\"#D6E3F3\" class=\"td_normal_large blue bold\" style=\"padding:4px;\">
			<div style=\"float:left\"><a href=\"newModule".$mid.".php\" class=\"nav\"><b>".$viewcls->getPageHeading()."</b></a></div>
			<div style=\"float:right;height:20px;\" class=\"td_normal\">
				<?php echo $"."rCnt?> records found |
				<?php if($"."pno>0) { ?><a class=\"nav\" href=\"javaScript:gotoPage(<?php echo $"."pno-1?>)\">Previous</a>&nbsp;&nbsp; <?php } ?>
				Page <input type=\"text\" class=\"input\" name=\"ppno2\" id=\"ppno2\" value=\"<?php echo ($"."pno+1)?>\" style=\"width:30px;height:13px;text-align:center\" maxLength=\"3\" onFocus=\"clrF(2)\" onBlur=\"fillF(2)\">&nbsp;of <?php echo ceil(($"."rCnt)/$"."nRec)?>
				<?php if(ceil(($"."rCnt)/$"."nRec)>$"."pno+1) { ?>&nbsp;&nbsp;<a class=\"nav\" href=\"javaScript:gotoPage(<?php echo $"."pno+1?>)\">Next</a> <?php } ?>
			</div>
		</td></tr>
		<tr><td style=\"border-top: 1px solid #99BBE8;\"></td></tr>

		<tr>
			<td bgcolor=\"#ffffff\" class=\"td_normal\" style=\"padding:4px;\">";
			
			for($i=0;$i<count($srcList);$i++) {
				$scls		=	$srcList[$i];
				$cnm		= $scls->getColumnName();
				$mclDet	= $this->getModuleColumnDetail($mid, $cnm);
				
				$rMsg		= $rMsg."
				<div style=\"float:left;\">&nbsp;".$mclDet->getColumnLabel()."&nbsp;</div>
				";
				
				switch($mclDet->getInputType()) {
					case 'text':
						if($mclDet->getColumnDataType() == "varchar") {
							$rMsg	=	$rMsg."
				<div style=\"float:left;\"><input type=\"text\" class=\"input\" name=\"src".$mclDet->getColumnName().($i+1)."\" id=\"src".$mclDet->getColumnName().($i+1)."\" value=\"<?php echo $"."src".$mclDet->getColumnName().($i+1)."?>\" style=\"width:".$mclDet->getInputLength()."px\" maxLength=\"".$mclDet->getColumnLength()."\" onFocus=\"this.className='input_focus'\" onBlur=\"this.className='input'\" /></div>";
						} else if($mclDet->getColumnDataType() == "date") {
							$rMsg	=	$rMsg."
				<div style=\"float:left;\"><input data-toggle=\"datepicker\" type=\"text\" class=\"input\" name=\"src".$mclDet->getColumnName().($i+1)."\" id=\"src".$mclDet->getColumnName().($i+1)."\" value=\"<?php echo $"."src".$mclDet->getColumnName().($i+1)."?>\" style=\"width:80px\" maxLength=\"10\" onFocus=\"this.className='input_focus'\" onBlur=\"this.className='input'\" /></div>";
						} else {
							$rMsg	=	$rMsg."
				<div style=\"float:left;\"><input type=\"text\" class=\"input\" name=\"src".$mclDet->getColumnName().($i+1)."\" id=\"src".$mclDet->getColumnName().($i+1)."\" value=\"<?php echo $"."src".$mclDet->getColumnName().($i+1)."?>\" style=\"width:80px\" maxLength=\"15\" onFocus=\"this.className='input_focus'\" onBlur=\"this.className='input'\" /></div>";
						}
						break;
					case 'select':
						if($mclDet->getSelectValues() != "") {
							$tmp	= explode(",", $mclDet->getSelectValues());
							$rMsg	=	$rMsg."
				<div style=\"float:left;\">
					<select class=\"select\" name=\"src".$mclDet->getColumnName().($i+1)."\" id=\"src".$mclDet->getColumnName().($i+1)."\">
						<option value=\"\">--</option>";
						for($k=0;$k<count($tmp);$k++) {
							$str	= $tmp[$k];
							$rMsg	=	$rMsg."<option value=\"".$str."\" <?php if($"."src".$mclDet->getColumnName().($i+1)." == \"".$str."\") echo 'selected'; ?>>".$str."</option>";
						}
						$rMsg	=	$rMsg."
					</select>
				</div>";
						} else {
							$rMsg	=	$rMsg."
				<div style=\"float:left;\"><select name=\"src".$mclDet->getColumnName().($i+1)."\" id=\"src".$mclDet->getColumnName().($i+1)."\" style=\"width:".$mclDet->getInputLength()."px\"></select></div>";
						}
						break;
					case 'checkbox':
						$rMsg	=	$rMsg."
				<div style=\"float:left;\"><input type=\"checkbox\" class=\"input\" name=\"src".$mclDet->getColumnName().($i+1)."\" id=\"src".$mclDet->getColumnName().($i+1)."\" /></div>
					";
						break;
					default:
						
				}				
				
			}
				
				$rMsg		= $rMsg."
				<div style=\"clear:all\">
					&nbsp;&nbsp;<input type=\"button\" class=\"red_button\" value=\"Search &raquo;\" id=\"btnS\" onClick=\"srcR()\" />
				</div>
				
			</td>
		</tr>
	</table>
	
	<div style=\"height:5px;\"></div>
	
	<div id=\"rptDiv\" class=\"fakeContainer\">

		<table cellspacing=\"1\" cellpadding=\"2\" border=\"0\" width=\"970px\" align=\"center\" id=\"vTable\">
			<thead>
				<tr>
				";
				
				for($i=0;$i<count($fldList);$i++) {
					$row	=	$fldList[$i];
					
					$cnm		= $row->getColumnName();
					$mclDet	= $this->getModuleColumnDetail($mid, $cnm);	
					
					$rMsg		= $rMsg."
					<th width=\"".$row->getCWidth()."\" align=\"left\">".$mclDet->getColumnLabel()."</th>";
				}
				
				if($viewcls->getMView() == "YES") {
					$rMsg		= $rMsg."
					<th width=\"30px\" align=\"center\">View</th>";
				}				
				
				if($viewcls->getMPrint() == "YES") {
					$rMsg		= $rMsg."
					<th width=\"30px\" align=\"center\">Prn</th>";
				}
				
				if($viewcls->getMEdit() == "YES") {
					$rMsg		= $rMsg."
					<th width=\"30px\" align=\"center\">Edt</th>";
				}
				
				if($viewcls->getMDelete() == "YES") {
					$rMsg		= $rMsg."
					<th width=\"30px\" align=\"center\">Del</th>";
				}				
				
				$rMsg		= $rMsg."
					
				</tr>
			</thead>
			<tbody>
			
		<?php

			for($"."i=0;$"."i<count($"."arr);$"."i++) {
				$"."row		=	$"."arr[$"."i];
		?>
		
				<tr>";
					
				for($i=0;$i<count($fldList);$i++) {
					$fcls		=	$fldList[$i];
					$cnm		= $fcls->getColumnName();
					$mclDet	= $this->getModuleColumnDetail($mid, $cnm);
					if( $mclDet->getInputType() == "select" && $mclDet->getSelectValues() == "") {
					
						$rMsg		= $rMsg."
					<td class=\"td_view\"><?php echo $"."row->get".$fcls->getColumnName()."Name('yes')?></td>";
					} else {
						$rMsg		= $rMsg."
					<td class=\"td_view\"><?php echo $"."row->get".$fcls->getColumnName()."('yes')?></td>";					
					}
				}
				
				if($viewcls->getMView() == "YES") {
					$rMsg		= $rMsg."
					<td class=\"td_view\" align=\"center\"><a id=\"a<?php echo $"."row->get".$pknm."()?>\" href=\"javaScript:viewRec(\'<?php echo $"."row->get".$pknm."()?>\')\"><img src=\"images/view.png\" title=\"View Details of <?php echo formatJScriptString($"."row->get".$pknm."())?>\" /></a></td>";
				}				
				
				if($viewcls->getMPrint() == "YES") {
					$rMsg		= $rMsg."
					<td class=\"td_view\" align=\"center\"><a href=\"prnModule".$mid.".php?".$pkeyStr."\" target=\"_blank\"><img src=\"images/print.gif\" title=\"EDIT - <?php echo formatJScriptString($"."row->get".$pknm."())?>\" /></a></td>";
				}
				
				if($viewcls->getMEdit() == "YES") {
					$rMsg		= $rMsg."
					<td class=\"td_view\" align=\"center\"><a href=\"editModule".$mid.".php?pno=<?php echo $"."pno?>".$pkeyStr.$srcStr."\"><img src=\"images/edit.png\" title=\"EDIT # <?php echo formatJScriptString($"."row->get".$pknm."())?>\" /></a></td>";
				}
				
				if($viewcls->getMDelete() == "YES") {
					$rMsg		= $rMsg."
					<td class=\"td_view\" align=\"center\"><a href=\"javaScript:deleteRec('<?php echo $"."row->get".$pknm."()?>','<?php echo formatJScriptString($"."row->get".$pknm."())?>')\"><img src=\"images/delete.png\" title=\"DELETE - <?php echo formatJScriptString($"."row->get".$pknm."())?>\" /></a></td>";
				}				
				
				$rMsg		= $rMsg."
				</tr>
				<?php } ?>
				
			</tbody>
		</table>

	</div>
	
	<div style=\"height:10px;\"></div>
	";
	
	if($viewcls->getMView() == "YES") {
		$rMsg		= $rMsg."
		
	<div id=\"ex1\" class=\"modal\" style=\"height:500px;\"></div>
	
		";
	}
	
	$rMsg		= $rMsg."

<?php
	$"."iPage->endBody();
	$"."iPage->endPage();
?>

<script language=\"javaScript\">
	";
	
	$rMsg	= $rMsg."

	$(function () {
	";
	
	$cnt	= 0;
	for($i=0;$i<count($srcList);$i++) {
		$scls		=	$srcList[$i];
		$cnm		= $scls->getColumnName();
		$mclDet	= $this->getModuleColumnDetail($mid, $cnm);		
		if($mclDet->getDisplayInForm() != "YES") continue;

		if($mclDet->getInputType() == "select") {
		
			$rMsg	=	$rMsg."\n\t\t$(\"#src".$scls->getColumnName()."\").select2();";
		}

	}		
	
	$rMsg	= $rMsg."
	});
	
	
	$('[data-toggle=\"datepicker\"]').datepicker({
		format: 'dd-mm-yyyy',
		autoHide: 'yes'
	});	
	
	
	var div	=	document.getElementById('rptDiv');

	div.style.height	=	 (window.innerHeight - 230) + \"px\";
	div.style.width		=	 \"980px\";

	//<![CDATA[	
	(function() {
		var mySt = new superTable(\"vTable\", {
			cssSkin 		: \"sSky\",
			fixedCols 	: 0,
			headerRows 	: 1
		});
	})();
	//]]>	
	
	";
	
	
	for($i=0;$i<count($srcList);$i++) {
		$scls		=	$srcList[$i];
		$cnm		= $scls->getColumnName();
		$mclDet	= $this->getModuleColumnDetail($mid, $cnm);

		if($mclDet->getInputType() == "select" && $mclDet->getSelectValues() == "") {
			$rMsg	=	$rMsg."\n\tfetch".$cnm."For".$mid."('no'); ";
		}

	}			

	
	for($i=0;$i<count($srcList);$i++) {
		$scls		=	$srcList[$i];
		$cnm		= $scls->getColumnName();
		$mclDet	= $this->getModuleColumnDetail($mid, $cnm);
		$mid2		= 0;
		if (strpos($mclDet->getRelatedTable(), 'gen_module') !== false) {
			$mid2	= (int)substr($mclDet->getRelatedTable(), 10);
		} else {
			$mid2	= (int)substr($mclDet->getRelatedTable(), 11);
		}

		if($mclDet->getInputType() == "select" && $mclDet->getSelectValues() == "") {
		
			$rMsg	=	$rMsg."
				
	function fetch".$cnm."For".$mid."(fc) {
	
    $('#src".$cnm.($i+1)."').empty();
    $('#src".$cnm.($i+1)."').append('<option value=\"0\">--</option>');
    var iid		= \"<?php echo $src".$cnm.($i+1)." ?>\";
    
    $.ajax({
			type: \"POST\",
			url: \"json/getGenericDataForJSON.php\",
			data: {\"tblName\": '".$mclDet->getRelatedTable()."', \"fld1\": '".$mclDet->getValueField()."', \"fld2\": '".$mclDet->getDisplayFields()."', \"condn\": \"\"},
			success: function(data){

				var opts = $.parseJSON(data);
				$.each(opts, function(i, d) {
					$('#src".$cnm.($i+1)."').append('<option value=\"' + d.".$mclDet->getValueField()." + '\">' + d.".$mclDet->getDisplayFields()." + '</option>');
				});
				$(\"#src".$cnm.($i+1)."\").val(iid).change();
				
			}
    });

	}
				
			";
		}
			
	}
		
		
		
		$rMsg	= $rMsg."

 	$(\"#ppno2\" ).on( \"keydown\", function(event) {
		if(event.which == 13) {
			var pno	= $('#ppno2').val() - 1;
			gotoPage(pno);
		}
  });
	
	function srcR() {";
	
	$jstr			= "";
	for($i=0;$i<count($srcList);$i++) {
		$scls		=	$srcList[$i];
		$cnm		= $scls->getColumnName();	
	
		$rMsg			= $rMsg."	
		var src".($i+1)."	=	$('#src".$cnm.($i+1)."').val();
		";
		if($jstr != "") $jstr = $jstr." + \"";
		$jstr			= $jstr."&src".$cnm.($i+1)."=\" + src".($i+1);
	}
	
	$rMsg		= $rMsg."	
		location		=	\"viewModule".$mid.".php?pno=0".$jstr.";
	}

	function gotoPage(n) {
		location		=	\"viewModule".$mid.".php?pno=\" + n + \"".$srcStr."\";
	}

	function clrF(n){
		$('#ppno' + n).val('');
	}

	function fillF(n){
		$('#ppno' + n).val(\"<?php echo $"."pno+1?>\");
	}
	
	function deleteRec(pkey, nm) {
		if(confirm(\"Click OK to delete \" + nm) == false) return;
		
		location =	\"deleteModule".$mid.".php?pno=<?php echo $"."pno?>".$pkeyStr2.$srcStr."\";
	}";
	
	if($viewcls->getMView() == "YES") {
	
	$rMsg		= $rMsg."	
	
	function viewRec(aid) {

		$('#ex1')[0].innerHTML	= '';

    $.ajax({
			type: \"POST\",
			url: \"Module".$mid."Detail.php\",
			data: {\"aid\": aid},
			success: function(data){

				$('#ex1')[0].innerHTML	= data;
				$('#ex1').modal({
					fadeDuration: 250,
					showClose: false
				});
				
			}
    });

	}	
	
	";
	
	}
	
	$rMsg		= $rMsg."	

</script>";

			return $rMsg;
		}
		
		
		
		/*******************************************************
		 * This is the code to generate a php code that handles 
		 * the delete code in HTML and PHP
		 *******************************************************/                                    

		function getDeleteCodePHP($mcls, $viewcls) {

			$mid			= $mcls->getModuleID();
			$tblname	= "gen_module".$mid;
			$smlList	= $mcls->getSubmoduleList();
			$clmList	= $mcls->getColumnList();
			$n				= count($smlList);
			$pkey			= "";
			$url			= "";
			
			$srcList	= $viewcls->getSearchList();
			
			$rMsg			= "<?php

	/* Include the required files */
	require_once( 'checkLogin.php' );
	require_once( 'dao/class.".$tblname.".php' );";
	
	for($i=0;$i<count($smlList);$i++) {
		$smname	= "gen_module".$mid."_submodule".($i+1);
		$rMsg		= $rMsg."
	require_once( 'dao/class.".$smname.".php' );";
	}
	
	$rMsg			= $rMsg."
	require_once( 'dao/class.moduledb".$mid.".php' );
	
	$"."ModuleID			= ".$mid.";

	$"."gdb					=	new genericdb();
	$"."mdb					=	new masterdb();
	$"."ldb					= new logindb();
	$"."mddb					=	new moduledb".$mid."();
	
	if($"."ldb->getDeletePermission($"."tuser->getUserID(), $"."ModuleID, $"."tcmp->getCompanyID()) != \"YES\") {
		header(\"Location:accessDenied.php\");
		exit;
	}
	";
	
	for($i=0;$i<count($clmList);$i++) {
		$ccls	=	$clmList[$i];
		if($ccls->getPrimaryKey() == "YES") {
			$rMsg			= $rMsg."
	$"."pk".$ccls->getColumnName()."					=	\"\";";
			
			if($pkey != "") $pkey = $pkey.", ";
			$pkey	= $pkey."$"."pk".$ccls->getColumnName();
			
		}
	}
	
	for($i=0;$i<count($srcList);$i++) {
		$scls		= $srcList[$i];
		$rMsg		= $rMsg."
	$"."src".$scls->getColumnName().($i+1)."					=	\"\";";
		if($url != "") $url = $url."&";
		$url	= $url."src".$scls->getColumnName().($i+1)."=$"."src".$scls->getColumnName().($i+1);
	}
	
	$rMsg			= $rMsg."
	
	$"."pno					= 0;
	
	extract($"."_REQUEST);";
	
	$rMsg			= $rMsg."\n";
	for($i=0;$i<count($clmList);$i++) {
		$ccls	=	$clmList[$i];
		if($ccls->getPrimaryKey() == "YES") {
			$rMsg			= $rMsg."
	$"."pk".$ccls->getColumnName()."					=	addslashes($"."pk".$ccls->getColumnName().");";
		}
	}
	
	for($i=0;$i<count($srcList);$i++) {
		$scls		= $srcList[$i];
		$rMsg		= $rMsg."
	$"."src".$scls->getColumnName().($i+1)."					=	addslashes($"."src".$scls->getColumnName().($i+1).");";		
	}	

	$rMsg			= $rMsg."
	
	$"."pno					=	(int)$"."pno;
	
	$"."det					=	$"."mddb->getModule".$mid."Detail(".$pkey.");
	
	if($"."mddb->deleteModule".$mid."($"."det)) {
		$"."log	=	new asys_user_log();
		$"."log->setLogID($"."gdb->getNextID(\"asys_user_log\", \"LogID\"));
		$"."log->setUserID($"."tuser->getUserID());
		$"."log->setCompanyID($"."tcmp->getCompanyID());
		$"."log->setModuleID($"."ModuleID);
		$"."log->setRelatedID(".$pkey.");
		$"."log->setActivity(\"Deleted Module ".$mid." - data\");
		$"."log->setClassName('".$tblname."');
		$"."log->setModuleSnapshot(serialize($"."det));
		$"."gdb->SaveObjectToDB($"."log);
	}
	
	header(\"Location:viewModule".$mid.".php?pno=$"."pno&".$url."\");

?>";

			return $rMsg;
		}
		
		
		
		/*******************************************************
		 * This is the code to generate a php code that handles 
		 * the JSON code in PHP
		 *******************************************************/                                    

		function getJSONCodePHP($mcls) {
			
			$mid			= $mcls->getModuleID();
			$tblname	= "getModule".$mid."";
			$clmList	= $mcls->getColumnList();
			$n				= count($clmList);
			$pkey			= "";
			
			for($i=0;$i<$n;$i++) {
				$ccls		= $clmList[$i];
				if($ccls->getPrimaryKey() == "YES") {
					$pkey	= $ccls->getColumnName();
					break;
				}
			}
			
			$rMsg			= "<?php

	require_once('../aom-config.php');
	require_once('../dao/class.moduledb".$mid.".php');

	if(!isset($"."_SESSION[\"ssEUser\"])) {
		print(\"-1\");
		exit;
	}

	$"."mdb			= new moduledb".$mid."();
	$"."oList		= $"."mdb->getModule".$mid."ListJSON();

	$"."jsonStr	=	'{\"totalCount\":\"'.count($"."oList).'\",\"".$pkey."\":'.json_encode($"."oList).'}';

	print($"."jsonStr);

?>";
			return $rMsg;
		}
		
		
		
		/*******************************************************
		 * This is the code to generate a php code that handles 
		 * the DB code in HTML and PHP
		 *******************************************************/                                    

		function getDBCodePHP($mcls, $viewcls) {
		
			$mid			= $mcls->getModuleID();
			$tblname	= "gen_module".$mid;
			$smlList	= $mcls->getSubmoduleList();
			$clmList	= $mcls->getColumnList();
			$n				= count($smlList);
			$pkey			= "";
			$uname		= "";
			$pkeyStr	= "";
			
			$srcList	= $viewcls->getSearchList();
			$src			= "";
			$srcStr		= "";
			$cndnStr	= "";
			$sclmStr	= "";
			$scdtStr	= "";
			$fldList	= $viewcls->getFieldList();
			
			for($i=0;$i<count($clmList);$i++) {
				$cls		= $clmList[$i];
				if($cls->getPrimaryKey() == "YES") {
					$pkey			= $cls->getColumnName();
					if($pkeyStr != "") $pkeyStr = $pkeyStr.", ";
					$pkeyStr	= $pkeyStr."$"."".$cls->getColumnName();
				}
			}
			
			
			$prevcname	= "";
			$cnmCnt			= 1;
			for($i=0;$i<count($srcList);$i++) {
				$scls		=	$srcList[$i];
				$mclDet	= $this->getModuleColumnDetail($mid, $scls->getColumnName());
				
				if($srcStr != "") $srcStr = $srcStr.", ";
				if($prevcname == $scls->getColumnName()) {
					$srcStr	= $srcStr."$"."".$scls->getColumnName().$cnmCnt;
					$cnmCnt++;
				} else {
					$prevcname	= $scls->getColumnName();
					$cnmCnt			= 1;
					$srcStr	= $srcStr."$"."".$scls->getColumnName();
				}
				
				if($scdtStr != "") $scdtStr = $scdtStr.", ";
				$scdtStr	= $scdtStr.$mclDet->getColumnDataType();
				
				if($sclmStr != "") $sclmStr = $sclmStr.", ";
				$sclmStr	= $sclmStr.$scls->getColumnName();
				
				if($cndnStr != "") $cndnStr = $cndnStr.", ";
				$cndnStr	= $cndnStr.$scls->getSearchCondition();
			}
			
			$rMsg			= "<?php

	class moduledb".$mid." {

		protected $"."host			= SS_DB_HOST;
		protected $"."user			= SS_DB_USER;
		protected $"."password	= SS_DB_PASSWORD;
		protected $"."dbname		= SS_DB_DBNAME;
		protected $"."conn			= null;

		public function __construct($"."dbType = '') {
			
			if (!extension_loaded('pdo')) {
				die (SS_DB_ERR_101);
			}
			
			if($"."dbType == \"REPORT\") {
				$"."this->user 		= SS_RPT_USER;
				$"."this->password	= SS_RPT_PASSWORD;
			} else if($"."dbType == \"DATA\") {
				$"."this->user 		= SS_DBA_USER;
				$"."this->password	= SS_DBA_PASSWORD;			
			}
			
			try {
				$"."this->conn = new PDO(\"mysql:host=\".$"."this->host.\";dbname=\".$"."this->dbname.\";charset=utf8\", $"."this->user, $"."this->password);
				$"."this->conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
			} catch(PDOException $"."e) {
				die('DB connection error '.$"."e->getMessage());
			}			
				
		}
		
		public function __destruct() {
			$"."this->conn	= null;
		}		
		
		private function ExecuteQuery($"."sql00) {
		
			$"."res	= false;

			try {
				
				$"."res	= $"."this->conn->query($"."sql00);
				
			} catch(PDOException $"."e) {
				$"."err	= 'moduledb".$mid." ExecuteQuery ('.$"."sql00.') '.$"."e->getMessage();
				_errorLog($"."err);
			}
			
			return $"."res;
			
		}

		private function getRecordsetExecutingQuery($"."sql00) {
		
			$"."rows		= array();
		
			try {
				
				$"."result	= $"."this->conn->query($"."sql00);
				while($"."row = $"."result->fetch()) {
					$"."rows[]	=	$"."row;
				}
				
			} catch(PDOException $"."e) {
				$"."err	= 'moduledb".$mid." getRecordsetExecutingQuery ('.$"."sql00.') '.$"."e->getMessage();
				_errorLog($"."err);
			}		
		
			return $"."rows;
			
		}
		
		private function getResultExecutingQuery($"."sql00) {
		
			$"."rows		= array();
			$"."res		= \"\";
		
			try {
				
				$"."result	= $"."this->conn->query($"."sql00);
				if($"."row = $"."result->fetch()) {
					$"."res	=	$"."row[0];
				}
				
			} catch(PDOException $"."e) {
				$"."err	= 'moduledb".$mid." getResultExecutingQuery ('.$"."sql00.') '.$"."e->getMessage();
				_errorLog($"."err);
			}		
		
			return $"."res;
			
		}
		
		public function getNextID($"."tblName, $"."colName) {
			
			if(strpos($"."tblName, \"'\") !== false) return false;
			if(strpos($"."colName, \"'\") !== false) return false;
			
			if(strpos($"."tblName, '\"') !== false) return false;
			if(strpos($"."colName, '\"') !== false) return false;
			
			$"."maxid			=	1;
			$"."sql				=	\"SELECT `MaxID` FROM `asys_tablemaxrows` WHERE `TableName`='$"."tblName' ORDER BY `MaxID` DESC LIMIT 1\";
			$"."usql				= \"UPDATE `asys_tablemaxrows` SET `MaxID`=`MaxID`+1 WHERE `TableName`='$"."tblName'\";

			try {
				
				$"."result		= $"."this->conn->query($"."sql);
				if($"."row 	= $"."result->fetch()) {
					$"."maxid 	= $"."row[0];
					$"."this->conn->exec($"."usql);
				} else {
					$"."sql		= \"INSERT INTO `asys_tablemaxrows` (`TableName`, `MaxID`) VALUES ('$"."tblName', '2');\";
					$"."this->conn->exec($"."sql);
				}
					
			} catch(PDOException $"."e) {
				$"."err	= 'voucherdb getNextID '.$"."e->getMessage();
				_errorLog($"."err);
			}

			return $"."maxid;
			
		}
		
		function getNextNo($"."tblName, $"."colName, $"."FinYear, $"."CompanyID = 0) {
			if(strpos($"."FinYear, \"'\") !== false) return false;
			$"."CompanyID	= (int)$"."CompanyID;
			$"."tblName		= addslashes($"."tblName);
			$"."colName		= addslashes($"."colName);
			
			$"."maxid			=	0;
			if($"."CompanyID == 0)
				$"."sql				=	\"SELECT MAX(`$"."colName`) FROM `$"."tblName` WHERE `FinYear`='$"."FinYear'\";
			else
				$"."sql				=	\"SELECT MAX(`$"."colName`) FROM `$"."tblName` WHERE `FinYear`='$"."FinYear' AND `CompanyID`='$"."CompanyID'\";

			try {
				
				$"."result		= $"."this->conn->query($"."sql);
				if($"."row 	= $"."result->fetch())
					$"."maxid 	= $"."row[0];
				
			} catch(PDOException $"."e) {
				$"."err	= 'moduledb".$mid." getNextNo ('.$"."sql.') '.$"."e->getMessage();
				_errorLog($"."err);
			}

			$"."maxid++;
			return $"."maxid;
		}
		
		function getMaxVoucherNo($"."VoucherType, $"."FinYear, $"."CompanyID) {
			$"."CompanyID		= (int)$"."CompanyID;
			$"."VoucherType	= (int)$"."VoucherType;
			$"."FinYear			= addslashes($"."FinYear);
			$"."maxid				=	0;
			$"."sql					=	\"SELECT MAX(`VoucherNo`) FROM `asys_voucher_entry` WHERE `VoucherType`='$"."VoucherType' AND `FinYear`='$"."FinYear' AND `CompanyID`='$"."CompanyID'\";
			$"."maxid				= $"."this->getResultExecutingQuery($"."sql);
			$"."maxid++;
			return $"."maxid;
		}
		
		function getMaxDayWiseVoucherNo($"."VoucherType, $"."DOV, $"."CompanyID) {
			$"."CompanyID		= (int)$"."CompanyID;
			$"."VoucherType	= (int)$"."VoucherType;
			$"."DOV					= addslashes($"."DOV);
			$"."maxid				=	0;
			$"."sql					=	\"SELECT MAX(`DayWiseNo`) FROM `asys_voucher_entry` WHERE `VoucherType`='$"."VoucherType' AND `DOV`='$"."DOV' AND `CompanyID`='$"."CompanyID'\";
			$"."maxid				= $"."this->getResultExecutingQuery($"."sql);
			$"."maxid++;
			return $"."maxid;
		}
		
		function getAccountDetail($"."AccountID) {
			$"."AccountID	= (int)$"."AccountID;
			$"."cclass			=	new asys_accounts();
			
			try {
				
				$"."sql			=	\"SELECT * FROM `asys_accounts` WHERE `AccountID`='$"."AccountID'\";
				$"."result		= $"."this->conn->query($"."sql, PDO::FETCH_CLASS, 'asys_accounts');
				if($"."row 	= $"."result->fetch()) {
					$"."cclass	= $"."row;
				$"."cclass->setCompanyName($"."this->getCompanyNameByCompanyID($"."row->getCompanyID()));
					$"."cclass->setGroupName($"."this->getGroupNameByGroupID($"."cclass->getGroupID()));
					$"."cclass->setBGName($"."this->getBaseGroupNameByBaseGroupID($"."cclass->getBGID()));
				}
				
			} catch(PDOException $"."e) {
				$"."err	= 'moduledb".$mid." getAccountDetail '.$"."e->getMessage();
				_errorLog($"."err);
			}

			return $"."cclass;
		}
		
		function getUnitNameByUnitID($"."UnitID) {
			$"."UnitID		= (int)$"."UnitID;
			$"."sql				=	\"SELECT `UnitName` FROM `gen_unit` WHERE `UnitID`='$"."UnitID'\";
			return $"."this->getResultExecutingQuery($"."sql);
		}
		
		function getItemCategoryNameByItemCategoryID($"."ItemCategoryID) {
			$"."ItemCategoryID	= (int)$"."ItemCategoryID;
			$"."sql							=	\"SELECT `ItemCategoryName` FROM `gen_itemcategory` WHERE `ItemCategoryID`='$"."ItemCategoryID'\";
			return $"."this->getResultExecutingQuery($"."sql);
		}
		
		function getItemNameByItemID($"."ItemID) {
			$"."ItemID		= (int)$"."ItemID;
			$"."sql				=	\"SELECT `ItemName` FROM `gen_items` WHERE `ItemID`='$"."ItemID'\";
			return $"."this->getResultExecutingQuery($"."sql);
		}
		
		function getAccountNameByAccountID($"."AccountID) {
			$"."AccountID		= (int)$"."AccountID;
			$"."sql					=	\"SELECT `AccountName` FROM `asys_accounts` WHERE `AccountID`='$"."AccountID'\";
			return $"."this->getResultExecutingQuery($"."sql);
		}
		
		function getBaseGroupNameByBaseGroupID($"."BGID) {
			$"."BGID		= (int)$"."BGID;
			$"."sql			=	\"SELECT `GroupName` FROM `asys_base_group` WHERE `BGID`='$"."BGID'\";
			return $"."this->getResultExecutingQuery($"."sql);
		}
		
		function getGroupNameByGroupID($"."GroupID) {
			$"."GroupID	= (int)$"."GroupID;
			$"."sql			=	\"SELECT `GroupName` FROM `asys_groups` WHERE `GroupID`='$"."GroupID'\";
			return $"."this->getResultExecutingQuery($"."sql);
		}
		
		function getStoreNameByStoreID($"."StoreID) {
			$"."StoreID	= (int)$"."StoreID;
			$"."sql			=	\"SELECT `StoreName` FROM `asys_stores` WHERE `StoreID`='$"."StoreID'\";
			return $"."this->getResultExecutingQuery($"."sql);
		}
		
		function getCompanyNameByCompanyID($"."CompanyID) {
			$"."CompanyID		= (int)$"."CompanyID;
			$"."sql					=	\"SELECT `CompanyName` FROM `asys_companies` WHERE `CompanyID`='$"."CompanyID'\";
			return $"."this->getResultExecutingQuery($"."sql);
		}
		
		function getNameByID($"."tblName, $"."NameField, $"."IdField, $"."IdValue) {
			$"."tblName			= addslashes($"."tblName);
			$"."NameField		= addslashes($"."NameField);
			$"."IdField			= addslashes($"."IdField);
			$"."IdValue			= addslashes($"."IdValue);
			$"."sql					=	\"SELECT `$"."NameField` FROM `$"."tblName` WHERE `$"."IdField`='$"."IdValue'\";
			return $"."this->getResultExecutingQuery($"."sql);
		}
		
		function getDataForJSON($"."tblName, $"."fld1, $"."fld2, $"."condn) {
			$"."tblName	= addslashes($"."tblName);
			$"."fld1			= addslashes($"."fld1);
			$"."fld2			= addslashes($"."fld2);
	
			$"."n					= count($"."condn);
			$"."iarr			= array();
	
			for($"."i=0; $"."i<$"."n; $"."i++) {
				$"."iarr		= addslashes($"."condn[$"."i]);
			}
	
			$"."sql				= \"SELECT `$"."fld1`, `$"."fld2` FROM `$"."tblName` WHERE 1\";
			for($"."i=0; $"."i<$"."n; $"."i++) {
				$"."sql			= $"."sql.\" AND \".$"."iarr[$"."i];
			}
			return $"."this->getRecordsetExecutingQuery($"."sql);
		}
		
		function getLastStockClosingQuantity($"."CompanyID, $"."StoreID, $"."ItemID, $"."DateAsOn) {
			$"."CompanyID	= (int)$"."CompanyID;
			$"."StoreID		= (int)$"."StoreID;
			$"."ItemID			= (int)$"."ItemID;
			$"."DateAsOn		= addslashes($"."DateAsOn);
			if($"."DateAsOn == \"\")
				$"."DateAsOn = \"3000-01-01\";
			$"."qty				= 0;
			
			try {	
			
				
				$"."sql	=	\"SELECT `ClosingQty` FROM `asys_stock_voucher` WHERE `CompanyID`='\".$"."CompanyID.\"' AND `StoreID`='\".$"."StoreID.\"' AND `ItemID`='\".$"."ItemID.\"' AND `DOT`<='\".$"."DateAsOn.\"' ORDER BY `DOT` DESC, `StockInOut`, `ModuleID` DESC, `RelatedID` DESC LIMIT 1\";
				
				$"."result1	= $"."this->conn->query($"."sql);
				if($"."row1 = $"."result1->fetch()) {
					$"."qty	=	$"."row1[0];
				}

				
			} catch(PDOException $"."e) {
				echo $"."e->getMessage();
			}				

			return $"."qty;
		}
		
		function getLastStockClosingQuantityForUpdate($"."CompanyID, $"."StoreID, $"."ItemID, $"."DateAsOn, $"."ModuleID = 0, $"."RelatedID = 0) {
			$"."CompanyID	= (int)$"."CompanyID;
			$"."StoreID		= (int)$"."StoreID;
			$"."ItemID			= (int)$"."ItemID;
			$"."ModuleID		= (int)$"."ModuleID;
			$"."RelatedID	= (int)$"."RelatedID;			
			$"."DateAsOn		= addslashes($"."DateAsOn);
			if($"."DateAsOn == \"\")
				$"."DateAsOn = \"3000-01-01\";
			$"."qty				= 0;
			$"."chk				= 0;
			
			try {		
			
				
				$"."sql	=	\"SELECT `ModuleID`, `RelatedID`, `ClosingQty` FROM `asys_stock_voucher` WHERE `CompanyID`='\".$"."CompanyID.\"' AND `StoreID`='\".$"."StoreID.\"' AND `ItemID`='\".$"."ItemID.\"' AND `DOT`<='\".$"."DateAsOn.\"' ORDER BY `DOT` DESC, `StockInOut`, `ModuleID` DESC, `RelatedID` DESC\";
				
				$"."result1	= $"."this->conn->query($"."sql);
				while($"."row1 = $"."result1->fetch()) {

					$"."mid	= $"."row1[0];
					$"."rid	= $"."row1[1];					
					$"."qty	=	$"."row1[2];

					if($"."chk == 1) break;

					if($"."mid == $"."ModuleID && $"."rid == $"."RelatedID) $"."chk = 1;
					$"."qty	= 0;					
				}

				
			} catch(PDOException $"."e) {
				echo $"."e->getMessage();
			}				

			return $"."qty;
		}
		
		function getLastStockClosingValue($"."CompanyID, $"."StoreID, $"."ItemID, $"."DateAsOn) {
			$"."CompanyID	= (int)$"."CompanyID;
			$"."StoreID		= (int)$"."StoreID;
			$"."ItemID			= (int)$"."ItemID;
			$"."DateAsOn		= addslashes($"."DateAsOn);
			if($"."DateAsOn == \"\")
				$"."DateAsOn = \"3000-01-01\";
			$"."val				= 0;
			
			try {		
			
				
				$"."sql	=	\"SELECT `ClosingValue` FROM `asys_stock_voucher` WHERE `CompanyID`='\".$"."CompanyID.\"' AND `StoreID`='\".$"."StoreID.\"' AND `ItemID`='\".$"."ItemID.\"' AND `DOT`<='\".$"."DateAsOn.\"' ORDER BY `DOT` DESC, `StockInOut`, `ModuleID` DESC, `RelatedID` DESC LIMIT 1\";
				
				$"."result1	= $"."this->conn->query($"."sql);
				if($"."row1 = $"."result1->fetch()) {
					$"."val	=	$"."row1[0];
				}

				
			} catch(PDOException $"."e) {
				echo $"."e->getMessage();
			}				

			return $"."val;
		}	
		
		function getLastStockClosingValueForUpdate($"."CompanyID, $"."StoreID, $"."ItemID, $"."DateAsOn, $"."ModuleID = 0, $"."RelatedID = 0) {
			$"."CompanyID	= (int)$"."CompanyID;
			$"."StoreID		= (int)$"."StoreID;
			$"."ItemID			= (int)$"."ItemID;
			$"."ModuleID		= (int)$"."ModuleID;
			$"."RelatedID	= (int)$"."RelatedID;			
			$"."DateAsOn		= addslashes($"."DateAsOn);
			if($"."DateAsOn == \"\")
				$"."DateAsOn = \"3000-01-01\";
			$"."val				= 0;
			$"."chk				= 0;
			
			try {	
			
				
				$"."sql	=	\"SELECT `ModuleID`, `RelatedID`, `ClosingValue` FROM `asys_stock_voucher` WHERE `CompanyID`='\".$"."CompanyID.\"' AND `StoreID`='\".$"."StoreID.\"' AND `ItemID`='\".$"."ItemID.\"' AND `DOT`<='\".$"."DateAsOn.\"' ORDER BY `DOT` DESC, `StockInOut`, `ModuleID` DESC, `RelatedID` DESC\";
				
				$"."result1	= $"."this->conn->query($"."sql);
				while($"."row1 = $"."result1->fetch()) {
					$"."mid	= $"."row1[0];
					$"."rid	= $"."row1[1];				
					$"."val	=	$"."row1[2];
					
					if($"."chk == 1)  break;
					
					if($"."mid == $"."ModuleID && $"."rid == $"."RelatedID) $"."chk = 1;
					$"."val	= 0;
				}

				
			} catch(PDOException $"."e) {
				echo $"."e->getMessage();
			}				

			return $"."val;
		}
		
		function getLastBalanceDetail($"."CompanyID, $"."StoreID, $"."ItemID, $"."DateAsOn) {
			$"."CompanyID	= (int)$"."CompanyID;
			$"."StoreID		= (int)$"."StoreID;
			$"."ItemID			= (int)$"."ItemID;
			$"."DateAsOn		= addslashes($"."DateAsOn);
			if($"."DateAsOn == \"\")
				$"."DateAsOn = \"3000-01-01\";
			$"."bald				= \"\";
			
			try {
			
				
				$"."sql	=	\"SELECT `BalanceDetail` FROM `asys_stock_voucher` WHERE `CompanyID`='\".$"."CompanyID.\"' AND `StoreID`='\".$"."StoreID.\"' AND `ItemID`='\".$"."ItemID.\"' AND `DOT`<='\".$"."DateAsOn.\"' ORDER BY `DOT` DESC, `StockInOut`, `ModuleID` DESC, `RelatedID` DESC LIMIT 1\";
				
				$"."result1	= $"."this->conn->query($"."sql);
				if($"."row1 = $"."result1->fetch()) {
					$"."bald	=	$"."row1[0];
				}

				
			} catch(PDOException $"."e) {
				echo $"."e->getMessage();
			}				

			return $"."bald;
		}
		
		function getLastBalanceDetailForUpdate($"."CompanyID, $"."StoreID, $"."ItemID, $"."DateAsOn, $"."ModuleID = 0, $"."RelatedID = 0) {
			$"."CompanyID	= (int)$"."CompanyID;
			$"."StoreID		= (int)$"."StoreID;
			$"."ItemID			= (int)$"."ItemID;
			$"."ModuleID		= (int)$"."ModuleID;
			$"."RelatedID	= (int)$"."RelatedID;			
			$"."DateAsOn		= addslashes($"."DateAsOn);
			if($"."DateAsOn == \"\")
				$"."DateAsOn = \"3000-01-01\";
			$"."bald				= \"\";
			$"."chk				= 0;
			
			try {
			
				
				$"."sql	=	\"SELECT `ModuleID`, `RelatedID`, `BalanceDetail` FROM `asys_stock_voucher` WHERE `CompanyID`='\".$"."CompanyID.\"' AND `StoreID`='\".$"."StoreID.\"' AND `ItemID`='\".$"."ItemID.\"' AND `DOT`<='\".$"."DateAsOn.\"' ORDER BY `DOT` DESC, `StockInOut`, `ModuleID` DESC, `RelatedID` DESC\";
				
				$"."result1	= $"."this->conn->query($"."sql);
				while($"."row1 = $"."result1->fetch()) {
					$"."mid	= $"."row1[0];
					$"."rid	= $"."row1[1];
					$"."bald	=	$"."row1[2];
					
					if($"."chk == 1) break;
					
					if($"."mid == $"."ModuleID && $"."rid == $"."RelatedID) $"."chk = 1;
					$"."bald	= \"\";
				}

				
			} catch(PDOException $"."e) {
				echo $"."e->getMessage();
			}				

			return $"."bald;
		}	



		function getModule".$mid."Detail(".$pkeyStr.") {
		";
		
			for($i=0;$i<count($clmList);$i++) {
				$scls		= $clmList[$i];
				$cdt		= $scls->getColumnDataType();
				if($scls->getPrimaryKey() == "YES") {
					if($cdt == "bigint" || $cdt == "int" || $cdt == "smallint" || $cdt == "tinyint") {
						$rMsg			= $rMsg."
			$".$scls->getColumnName()."	= (int)$".$scls->getColumnName().";";
					} else if($cdt == "float" || $cdt == "double" || $cdt == "decimal") {
						$rMsg			= $rMsg."
			$".$scls->getColumnName()."	= (double)$".$scls->getColumnName().";";					
					} else if($cdt == "varchar" || $cdt == "date" || $cdt == "text") {
						$rMsg			= $rMsg."
			$".$scls->getColumnName()."	= addslashes($".$scls->getColumnName().");";					
					}
				}
			}
			$rMsg			= $rMsg."
			$"."cclass			=	new ".$tblname."();
			
			try {
				
				$"."sql			=	\"SELECT * FROM `".$tblname."`";
				$tmp				= explode(", ", $pkeyStr);
				for($i=0;$i<count($tmp);$i++) {
					$pk				= $tmp[$i];
					if($i == 0) {
						$rMsg				= $rMsg." WHERE `".substr($pk, 1)."`='".$pk."'";
					} else {
						$rMsg				= $rMsg." AND `".substr($pk, 1)."`='".$pk."'";
					}
				}
				$rMsg				= $rMsg."\";";
				
				$rMsg				= $rMsg."
				$"."result		= $"."this->conn->query($"."sql, PDO::FETCH_CLASS, '".$tblname."');
				if($"."row 	= $"."result->fetch()) { ";
					
			for($i=0;$i<count($clmList);$i++) {
				$scls	=	$clmList[$i];
				if( $scls->getInputType() == "select" && $scls->getSelectValues() == "") {
					$rMsg			= $rMsg."\n\t\t\t\t\t$"."row->set".$scls->getColumnName()."Name($"."this->getNameByID('".$scls->getRelatedTable()."', '".$scls->getDisplayFields()."', '".$scls->getValueField()."', $"."row->get".$scls->getColumnName()."()));";
				}
			}
			
			for($i=0;$i<count($smlList);$i++) {
				$rMsg			= $rMsg."\n\t\t\t\t\t$"."row->setSubmoduleList".($i+1)."($"."this->getSubmoduleList".($i+1)."OfModule".$mid."($"."row->get".$pkey."()));";
			}
			
			
			$rMsg			= $rMsg."
					$"."cclass	= $"."row;
				}
				
			} catch(PDOException $"."e) {
				$"."err	= 'moduledb".$mid." getModule".$mid."Detail '.$"."e->getMessage();
				_errorLog($"."err);
			}

			return $"."cclass;
		}

		function getModule".$mid."List() {
			$"."arr	=	array();
			
			try {
				
				$"."sql			=	\"SELECT * FROM `".$tblname."` ORDER BY `".$pkey."`\";
				$"."result		= $"."this->conn->query($"."sql, PDO::FETCH_CLASS, '".$tblname."');
				while($"."row = $"."result->fetch()) {";
			
			for($i=0;$i<count($clmList);$i++) {
				$scls	=	$clmList[$i];
				if( $scls->getInputType() == "select" && $scls->getSelectValues() == "") {
					$rMsg			= $rMsg."\n\t\t\t\t\t$"."row->set".$scls->getColumnName()."Name($"."this->getNameByID('".$scls->getRelatedTable()."', '".$scls->getDisplayFields()."', '".$scls->getValueField()."', $"."row->get".$scls->getColumnName()."()));";
				}
			}
			
			for($i=0;$i<count($smlList);$i++) {
				$rMsg			= $rMsg."\n\t\t\t\t\t$"."row->setSubmoduleList".($i+1)."($"."this->getSubmoduleList".($i+1)."OfModule".$mid."($"."row->get".$pkey."()));";
			}			
			
			$rMsg			= $rMsg."
					$"."arr[]	= $"."row;
				}
				
			} catch(PDOException $"."e) {
				$"."err	= 'moduledb".$mid." getModule".$mid."List '.$"."e->getMessage();
				_errorLog($"."err);
			}

			return $"."arr;
		}";
		
		
		for($i=0;$i<count($smlList);$i++) {
			$scls		= $smlList[$i];
			$smDet	= $this->getModuleDetail($scls->getSubmoduleID());
			$smclmList	= $smDet->getColumnList();
			
		$rMsg			= $rMsg."
		
		function getSubmoduleList".($i+1)."OfModule".$mid."($".$pkey.") {
			$".$pkey."	= addslashes($".$pkey.");
			$"."arr	=	array();
			
			try {
				
				$"."sql			=	\"SELECT * FROM `gen_module".$mid."_submodule".($i+1)."` WHERE `".$pkey."` = '$".$pkey."'\";
				$"."result		= $"."this->conn->query($"."sql, PDO::FETCH_CLASS, 'gen_module".$mid."_submodule".($i+1)."');
				while($"."row = $"."result->fetch()) {";
			
			for($j=0;$j<count($smclmList);$j++) {
				$ccls	=	$smclmList[$j];
				if( $ccls->getInputType() == "select" && $ccls->getSelectValues() == "") {
					$rMsg."\n\t\t\t\t\t$"."row->set".$ccls->getColumnName()."Name($"."this->getNameByID('".$ccls->getRelatedTable()."', '".$ccls->getDisplayFields()."', '".$ccls->getValueField()."', $"."row->get".$ccls->getColumnName()."()));";
				}
			}
			
			$rMsg			= $rMsg."
					$"."arr[]	= $"."row;
				}
				
			} catch(PDOException $"."e) {
				$"."err	= 'moduledb".$mid." getSubmoduleList".($i+1)."OfModule".$mid." '.$"."e->getMessage();
				_errorLog($"."err);
			}

			return $"."arr;
		}
		";
		
		}
		
		$rMsg			= $rMsg."
		
		function getModule".$mid."ListJSON(){
		
			$"."sql		= \"SELECT `".$pkey."`, `".substr($pkey, 0, -2)."Name` FROM `".$tblname."` ORDER BY `".substr($pkey, 0, -2)."Name`\";
			return $"."this->getRecordsetExecutingQuery($"."sql);
		
		}
		
		function getNumberOfModule".$mid."(".$srcStr.") {";

			$tmp				= explode(", ", $srcStr);
			$tmp2				= explode(", ", $sclmStr);
			$tmp3				= explode(", ", $scdtStr);
			
			for($i=0;$i<count($tmp);$i++) {
				$pk				= $tmp[$i];
				$cdt			= $tmp3[$i];
				if($cdt == "bigint" || $cdt == "int" || $cdt == "smallint" || $cdt == "tinyint")
					$rMsg			= $rMsg."
			".$pk."	= (int)".$pk.";";
				else if($cdt == "float" || $cdt == "double" || $cdt == "decimal")
					$rMsg			= $rMsg."
			".$pk."	= (double)".$pk.";";
				else
					$rMsg			= $rMsg."
			".$pk."	= addslashes(".$pk.");";
			}

			$rMsg				= $rMsg."
			$"."sql	=	\"SELECT COUNT(*) FROM `".$tblname."` WHERE 1\";";
			$tmp				= explode(", ", $srcStr);
			$tmp1				= explode(", ", $cndnStr);
			for($i=0;$i<count($tmp);$i++) {
				$pk				= $tmp[$i];
				$cn				= $tmp1[$i];
				$clm			= $tmp2[$i];
				$cdt			= $tmp3[$i];
				
				if($cdt == "bigint" || $cdt == "int" || $cdt == "smallint" || $cdt == "tinyint" || $cdt == "float" || $cdt == "double" || $cdt == "decimal")
					$rMsg			= $rMsg."
			if(".$pk." != \"0\")
				$"."sql		= $"."sql.\" AND ";
				else if($cdt == "date")
					$rMsg			= $rMsg."
			if(".$pk." != \"\" && ".$pk." != \"1900-01-01\")
				$"."sql		= $"."sql.\" AND ";
				else
					$rMsg			= $rMsg."
			if(".$pk." != \"\")
				$"."sql		= $"."sql.\" AND ";
				
				if($cn == "LIKE")
					$rMsg				= $rMsg." `".$clm."` ".$cn." '%".$pk."%'\";";
				else
					$rMsg				= $rMsg." `".$clm."` ".$cn." '".$pk."'\";";
			}
			$rMsg				= $rMsg."
			
			return $"."this->getResultExecutingQuery($"."sql);
		}

		function getModule".$mid."ListPaged($"."sRec, $"."nRec, ".$srcStr.") {
			$"."sRec		= (int)$"."sRec;
			$"."nRec		= (int)$"."nRec;";
			
			$tmp				= explode(", ", $srcStr);
			$tmp2				= explode(", ", $sclmStr);
			$tmp3				= explode(", ", $scdtStr);
			
			for($i=0;$i<count($tmp);$i++) {
				$pk				= $tmp[$i];
				$cdt			= $tmp3[$i];
				if($cdt == "bigint" || $cdt == "int" || $cdt == "smallint" || $cdt == "tinyint")
					$rMsg			= $rMsg."
			".$pk."	= (int)".$pk.";";
				else if($cdt == "float" || $cdt == "double" || $cdt == "decimal")
					$rMsg			= $rMsg."
			".$pk."	= (double)".$pk.";";
				else
					$rMsg			= $rMsg."
			".$pk."	= addslashes(".$pk.");";
			}
			
			$rMsg				= $rMsg."
			$"."sql	=	\"SELECT * FROM `".$tblname."` WHERE 1\";";
			$tmp				= explode(", ", $srcStr);
			$tmp1				= explode(", ", $cndnStr);
			for($i=0;$i<count($tmp);$i++) {
				$pk				= $tmp[$i];
				$cn				= $tmp1[$i];
				$clm			= $tmp2[$i];
				$cdt			= $tmp3[$i];

				if($cdt == "bigint" || $cdt == "int" || $cdt == "smallint" || $cdt == "tinyint" || $cdt == "float" || $cdt == "double" || $cdt == "decimal")
					$rMsg			= $rMsg."
			if(".$pk." != \"0\")
				$"."sql		= $"."sql.\" AND ";
				else if($cdt == "date")
					$rMsg			= $rMsg."
			if(".$pk." != \"\" && ".$pk." != \"1900-01-01\")
				$"."sql		= $"."sql.\" AND ";
				else
					$rMsg			= $rMsg."
			if(".$pk." != \"\")
				$"."sql		= $"."sql.\" AND ";
				

				
				if($cn == "LIKE")
					$rMsg				= $rMsg." `".$clm."` ".$cn." '%".$pk."%'\";";
				else
					$rMsg				= $rMsg." `".$clm."` ".$cn." '".$pk."'\";";				
				$rMsg			= $rMsg."
				";
			}
			
			if($viewcls->getSortColumn1() != "") {
				$rMsg				= $rMsg."
			$"."sql		= $"."sql.\" ORDER BY `".$viewcls->getSortColumn1()."`\";";
				if($viewcls->getSortColumn2() != "") {
					$rMsg				= $rMsg."
			$"."sql		= $"."sql.\" , `".$viewcls->getSortColumn2()."`\";";
				}
			} else if($viewcls->getSortColumn2() != "") {
				$rMsg				= $rMsg."
			$"."sql		= $"."sql.\" ORDER BY `".$viewcls->getSortColumn2()."`\";";
			}
			$rMsg				= $rMsg."
			$"."sql		= $"."sql.\" LIMIT $"."sRec, $"."nRec\";

			$"."arr	=	array();
			
			try {
				
				$"."result		= $"."this->conn->query($"."sql, PDO::FETCH_CLASS, '".$tblname."');
				while($"."row = $"."result->fetch()) {";

			for($i=0;$i<count($clmList);$i++) {
				$scls	=	$clmList[$i];
				if( $scls->getInputType() == "select" && $scls->getSelectValues() == "") {
					$rMsg			= $rMsg."\n\t\t\t\t\t$"."row->set".$scls->getColumnName()."Name($"."this->getNameByID('".$scls->getRelatedTable()."', '".$scls->getDisplayFields()."', '".$scls->getValueField()."', $"."row->get".$scls->getColumnName()."()));";
				}
			}
			
			for($i=0;$i<count($smlList);$i++) {
				$rMsg			= $rMsg."\n\t\t\t\t\t$"."row->setSubmoduleList".($i+1)."($"."this->getSubmoduleList".($i+1)."OfModule".$mid."($"."row->get".$pkey."()));";
			}			
			
			$rMsg			= $rMsg."
					$"."arr[]	= $"."row;
				}
				
			} catch(PDOException $"."e) {
				$"."err	= 'moduledb".$mid." getModule".$mid."ListPaged '.$"."e->getMessage();
				_errorLog($"."err);
			}

			return $"."arr;
		}

		function getModule".$mid."NameByID($".$pkey.") {
			$".$pkey."	= (int)$".$pkey.";
			$"."sql		=	\"SELECT `".substr($pkey, 0, -2)."Name` FROM `".$tblname."` WHERE `".$pkey."`='$".$pkey."'\";
			return $"."this->getResultExecutingQuery($"."sql);
		}

		function deleteModule".$mid."($"."lcls) {
		
			$"."pkey		= $"."lcls->get".$pkey."();
			$"."ret			= false;
			$"."chk			= 0;
		
				
			try {
			
				$"."this->conn->beginTransaction();				
			";
			
			
			
			$rmList		= $this->getModulesWithRelatedTable("gen_module".$mid);
			for($i=0;$i<count($rmList);$i++) {
				$row		= $rmList[$i];
				$rMsg			= $rMsg."
				$"."sql			=	\"SELECT * FROM `".$row[0]."` WHERE `".$row[1]."`='$"."pkey'\";
				$"."result		= $"."this->conn->query($"."sql);
				if($"."row 	= $"."result->fetch()) {
					$"."chk		= 1;
				}
				";
			}
			
			for($i=0;$i<count($smlList);$i++) {
				$scls		= $smlList[$i];
				$rMsg			= $rMsg."
				$"."sql			=	\"DELETE FROM `gen_module".$mid."_submodule".($i+1)."` WHERE `".$pkey."`='$"."pkey'\";	
				$"."this->conn->query($"."sql);
				";				
			}
			
			if($mcls->getStockFlow() == "YES") {
				$rMsg			= $rMsg."
				$"."sql			=	\"DELETE FROM `asys_stock_voucher` WHERE `RelatedID`='$"."pkey' AND `ModuleID`='".$mid."'\";	
				$"."this->conn->query($"."sql);
				";				
			}
			
			if($mcls->getAccountVoucher() == "YES") {
				$rMsg			= $rMsg."
				$"."sql			=	\"DELETE FROM `asys_voucher_entry` WHERE `RelatedID`='$"."pkey' AND `TxnType`='".$mid."'\";	
				$"."this->conn->query($"."sql);
				";				
			}				
			

			$rMsg			= $rMsg."\n
				if($"."chk == 0 ) {
					$"."sql		= $"."lcls->getDeleteSQL();
					$"."ret		= $"."this->conn->query($"."sql);
				}	
			
				$"."this->conn->commit();
				
			} catch(Exception $"."er) {
				
				$"."this->conn->rollBack();
				$"."err	= 'moduledb".$mid." deleteModule".$mid." '.$"."er->getMessage();
				_errorLog($"."err);
				
			}
		
			return $"."ret;
		}
		
		
		function CreateModule".$mid."($"."mcls) {
			
			$"."tuser		=	unserialize($"."_SESSION[\"ssEUser\"]);
			$"."tcmp		=	unserialize($"."_SESSION[\"ssECmp\"]);
			$"."cmpid		= $"."tcmp->getCompanyID();
			$"."pkey		= 0;
			";
			
			
			$rMsg			= $rMsg."
				
			try {
			
				$"."this->conn->beginTransaction();

				 ";
				 
			$fyclm		= "";
			$pkset		= 0;
			for($i=0;$i<count($clmList);$i++) {			
				$ccls		= $clmList[$i];
				if($ccls->getIncremental() == "YES") {
					$rMsg			= $rMsg."
				$"."mcls->set".$ccls->getColumnName()."($"."this->getNextID(\"".$tblname."\", \"".$ccls->getColumnName()."\"));	
			
				$"."pkey		= $"."mcls->get".$ccls->getColumnName()."();
					";
					$pkset	= 1;
				}
				if($ccls->getSetFinancialYear() == "YES") {
					$rMsg			= $rMsg."
				$"."mcls->set".$ccls->getColumnName()."( getFinancialYear($"."mcls->get".$ccls->getFYDateField()."()));
				$"."finyr		= $"."mcls->get".$ccls->getColumnName()."();
					";
					$fyclm	= $ccls->getColumnName();
				}
				if($ccls->getSetMaxFYBasis() == "YES") {
					$rMsg			= $rMsg."
				$"."mcls->set".$ccls->getColumnName()."($"."this->getNextNo(\"".$tblname."\", '".$ccls->getColumnName()."', $"."finyr, $"."cmpid));
					";
				}
				
			}
			
			$rMsg			= $rMsg."
				$"."this->conn->exec($"."mcls->getInsertSQL());
			";
			
			if($pkset == 0) {
				for($i=0;$i<count($clmList);$i++) {			
					$ccls		= $clmList[$i];	
					if($ccls->getPrimaryKey() == "YES") {
						$rMsg			= $rMsg."
				$"."pkey		= $"."mcls->get".$ccls->getColumnName()."();
						";
					}
				}		
			}				 
				
				for($i=0;$i<count($smlList);$i++) {
					$smcls	= $smlList[$i];
					$smDet	= $this->getModuleDetail($smcls->getSubmoduleID());
					
					$rMsg			= $rMsg."
					
				$"."submList	= $"."mcls->getSubmoduleList".($i+1)."();
				for($"."i=0;$"."i<count($"."submList);$"."i++) {
					$"."smcls	=	$"."submList[$"."i];
					$"."smcls->set".$pkey."($"."pkey);

					$"."sql		= $"."smcls->getInsertSQL();
					$"."this->conn->exec($"."sql);
					";
					
					if($smDet->getStockFlow() == "YES") {
					
						$scList		= $smDet->getStockConfigList();
						
						for($j=0;$j<count($scList);$j++) {
							$scls		= $scList[$j];
							
							if($scls->getStoreIN() != 0 || $scls->getRunTimeStockIN() == "YES") {
							
								$rMsg			= $rMsg."
								
					$"."lcqty	= $"."this->getLastStockClosingQuantity($"."cmpid, $"."pcls->getStoreID(), $"."smcls->getItemID(), $"."mcls->getBookingDate('yes'));
					$"."lcval	= $"."this->getLastStockClosingValue($"."cmpid, $"."pcls->getStoreID(), $"."smcls->getItemID(), $"."mcls->getBookingDate('yes'));
					$"."lbald	= $"."this->getLastBalanceDetail($"."cmpid, $"."pcls->getStoreID(), $"."smcls->getItemID(), $"."mcls->getBookingDate('yes'));
					
					$iamt		= $icls->getTotalAmount() - ($icls->getIGST() + $icls->getSGST() + $icls->getCGST());						
				
					$"."cqty		= $"."lcqty + $"."smcls->getQuantity();
					$"."cval		= $"."lcval + $"."iamt;
					$"."bald		= $"."lbald;
					if($"."bald != \"\") $"."bald = $"."bald.\",\";
					$"."bald		= $"."bald.$"."smcls->getQuantity().\"=\".$"."iamt/$"."smcls->getQuantity();								
							
					/* Stock entries */
					
					$"."scls		= new asys_stock_voucher();
					$"."scls->setSVoucherID($"."this->getNextID(\"asys_stock_voucher\",\"SVoucherID\"));
					$"."scls->setCompanyID($"."cmpid);";
					if($scls->getRunTimeStockIN() == "YES")
						$rMsg			= $rMsg."$"."scls->setStoreID($"."smcls->get".$scls->getInColumnName()."());";
					else
						$rMsg			= $rMsg."$"."scls->setStoreID(".$scls->getStoreIN().");";	
					$rMsg			= $rMsg."
					$"."scls->setModuleID(".$mid.");
					$"."scls->setFinYear($"."mcls->getFinYear());
					$"."scls->setRelatedID($"."pkey);
					$"."scls->setDOT($"."mcls->getBookingDate('yes'));
					$"."scls->setItemID($"."smcls->getItemID());
					$"."scls->setQuantity($"."smcls->getQuantity());
					$"."scls->setUnitPrice($"."iamt/$"."smcls->getQuantity());
					$"."scls->setStockInOut(STOCK_IN);
					$"."scls->setClosingQty($"."cqty);
					$"."scls->setClosingValue($"."cval);						
					$"."scls->setBatchNo(\"\");
					$"."scls->setNarration('".$mcls->getModuleName()."# '.$"."mcls->getBookingNo().'/'.$"."mcls->getFinYear());
					$"."scls->setBalanceDetail($"."bald);
					
					$"."sql		= $"."scls->getInsertSQL();
					$"."this->conn->exec($"."sql);
					
					/* Stock entry ends here */
					
					";
					
							}
							
							if($scls->getStoreOUT() != 0 || $scls->getRunTimeStockOUT() == "YES") {
							
								$rMsg			= $rMsg."
							
					/* Stock entries */
					
					$"."scls		= new asys_stock_voucher();
					$"."scls->setSVoucherID($"."this->getNextID(\"asys_stock_voucher\",\"SVoucherID\"));
					$"."scls->setCompanyID($"."cmpid);";
					if($scls->getRunTimeStockOUT() == "YES")
						$rMsg			= $rMsg."$"."scls->setStoreID($"."smcls->get".$scls->getOutColumnName()."());";
					else
						$rMsg			= $rMsg."$"."scls->setStoreID(".$scls->getStoreOUT().");";	
					$rMsg			= $rMsg."
					$"."scls->setModuleID(".$mid.");
					$"."scls->setFinYear($"."mcls->getFinYear());
					$"."scls->setRelatedID($"."pkey);
					$"."scls->setDOT($"."mcls->getBookingDate('yes'));
					$"."scls->setItemID($"."smcls->getItemID());
					$"."scls->setQuantity($"."smcls->getQuantity());
					$"."scls->setUnitPrice();
					$"."scls->setStockInOut(STOCK_OUT);
					$"."scls->setBatchNo(\"\");
					$"."scls->setNarration('".$mcls->getModuleName()."# '.$"."mcls->getBookingNo().'/'.$"."mcls->getFinYear());
					
					$"."sql		= $"."scls->getInsertSQL();
					$"."this->conn->exec($"."sql);
					
					/* Stock entry ends here */
					
					";
					
							}								
							
						}
					
					}
					
					if($smDet->getAccountVoucher() == "YES") {
					
						$vcList		= $smDet->getVoucherConfigList();
						
						for($j=0;$j<count($vcList);$j++) {
							$vcls		= $vcList[$j];
					
						$rMsg			= $rMsg."
						
					/* Voucher Entries */
					
					$"."finyr		= getFinancialYear($"."mcls->get".$vcls->getDateField()."());
					$"."vdt			= $"."mcls->get".$vcls->getDateField()."();
					$"."vdtf			= $"."mcls->get".$vcls->getDateField()."('yes');

					$"."VoucherNo	= $"."this->getMaxVoucherNo(".$vcls->getVoucherType().", $"."finyr, $"."cmpid);
					$"."DayWiseNo	= $"."this->getMaxDayWiseVoucherNo(".$vcls->getVoucherType().", $"."vdt, $"."cmpid);
				
				";
				
						if($vcls->getRunTimeCreditAccount() == "YES") {
							$rMsg			= $rMsg."$"."aDet		= $"."this->getAccountDetail($"."mcls->get".$vcls->getCrColumnName()."());";
						} else {
							if($vcls->getCreditAccount() != 0)
								$rMsg			= $rMsg."$"."aDet		= $"."this->getAccountDetail(".$vcls->getCreditAccount().");";
							else
								$rMsg			= $rMsg."$"."aDet		= $"."this->getAccountDetail(".$vcls->getCreditMotherAccount().");";
						}
						
				
						$rMsg			= $rMsg."

					$"."vcls1		=	new asys_voucher_entry();
					$"."vcls1->setSerialID(1);
					$"."vcls1->setCompanyID($"."cmpid);
					$"."vcls1->setVoucherType(".$vcls->getVoucherType().");
					$"."vcls1->setFinYear($"."finyr);
					$"."vcls1->setVoucherNo($"."VoucherNo);
					$"."vcls1->setDayWiseNo($"."DayWiseNo);
					$"."vcls1->setDOV($"."vdtf);
					$"."vcls1->setMotherAccount($"."aDet->getMotherAccount());
					$"."vcls1->setAccountID($"."aDet->getAccountID());
					$"."vcls1->setRelatedID($"."pkey);
					$"."vcls1->setTxnType(".$mid.");
					$"."vcls1->setDrCr(CREDIT);
					$"."vcls1->setAmount($"."mcls->get".$vcls->getAmountField()."());
					$"."vcls1->setNarration('".$mcls->getModuleName()."# '.$"."mcls->get".$pkey."().'/'.$"."finyr);
					$"."vcls1->setUserID($"."tuser->getUserID());
					$"."vcls1->setDOE(date('d-m-Y'));
					

				";
				
						if($vcls->getRunTimeDebitAccount() == "YES") {
							$rMsg			= $rMsg."$"."aDet		= $"."this->getAccountDetail($"."mcls->get".$vcls->getDrColumnName()."());";
						} else {
							if($vcls->getDebitAccount() != 0)
								$rMsg			= $rMsg."$"."aDet		= $"."this->getAccountDetail(".$vcls->getDebitAccount().");";
							else
								$rMsg			= $rMsg."$"."aDet		= $"."this->getAccountDetail(".$vcls->getDebitMotherAccount().");";
						}
						
				
						$rMsg			= $rMsg."
					
					$"."vcls2		=	new asys_voucher_entry();
					$"."vcls2->setSerialID(2);
					$"."vcls2->setCompanyID($"."cmpid);
					$"."vcls2->setVoucherType(".$vcls->getVoucherType().");
					$"."vcls2->setFinYear($"."finyr);
					$"."vcls2->setVoucherNo($"."VoucherNo);
					$"."vcls2->setDayWiseNo($"."DayWiseNo);
					$"."vcls2->setDOV($"."vdtf);
					$"."vcls2->setMotherAccount($"."aDet->getMotherAccount());
					$"."vcls2->setAccountID($"."aDet->getAccountID());
					$"."vcls2->setRelatedID($"."pkey);
					$"."vcls2->setTxnType(".$mid.");
					$"."vcls2->setDrCr(DEBIT);
					$"."vcls2->setAmount($"."mcls->get".$vcls->getAmountField()."());
					$"."vcls2->setNarration('".$mcls->getModuleName()."# '.$"."mcls->get".$pkey."().'/'.$"."finyr);
					$"."vcls2->setUserID($"."tuser->getUserID());
					$"."vcls2->setDOE(date('d-m-Y'));
					
					$"."_vid			= $"."this->getNextID(\"asys_voucher_entry\", \"VoucherID\");
					$"."vcls1->setVoucherID($"."_vid);
					$"."vcls2->setVoucherID($"."_vid);
					$"."this->conn->exec($"."vcls1->getInsertSQL());
					$"."this->conn->exec($"."vcls2->getInsertSQL());
				
					/* Voucher Entry ends here */
					
					";
					
						}
					
					}
					
					$rMsg			= $rMsg."
					
				}
					";
				}
				
				
					if($mcls->getAccountVoucher() == "YES") {
					
						$vcList		= $mcls->getVoucherConfigList();
						
						for($j=0;$j<count($vcList);$j++) {
							$vcls		= $vcList[$j];
					
						$rMsg			= $rMsg."
						
				/* Voucher Entries */
				
				$"."finyr		= getFinancialYear($"."mcls->get".$vcls->getDateField()."());
				$"."vdt			= $"."mcls->get".$vcls->getDateField()."();
				$"."vdtf			= $"."mcls->get".$vcls->getDateField()."('yes');

				$"."VoucherNo	= $"."this->getMaxVoucherNo(".$vcls->getVoucherType().", $"."finyr, $"."cmpid);
				$"."DayWiseNo	= $"."this->getMaxDayWiseVoucherNo(".$vcls->getVoucherType().", $"."vdt, $"."cmpid);
			
				";
				
						if($vcls->getRunTimeCreditAccount() == "YES") {
							$rMsg			= $rMsg."$"."aDet		= $"."this->getAccountDetail($"."mcls->get".$vcls->getCrColumnName()."());";
						} else {
							if($vcls->getCreditAccount() != 0)
								$rMsg			= $rMsg."$"."aDet		= $"."this->getAccountDetail(".$vcls->getCreditAccount().");";
							else
								$rMsg			= $rMsg."$"."aDet		= $"."this->getAccountDetail(".$vcls->getCreditMotherAccount().");";
						}
						
				
						$rMsg			= $rMsg."

				$"."vcls1		=	new asys_voucher_entry();
				$"."vcls1->setSerialID(1);
				$"."vcls1->setCompanyID($"."cmpid);
				$"."vcls1->setVoucherType(".$vcls->getVoucherType().");
				$"."vcls1->setFinYear($"."finyr);
				$"."vcls1->setVoucherNo($"."VoucherNo);
				$"."vcls1->setDayWiseNo($"."DayWiseNo);
				$"."vcls1->setDOV($"."vdtf);
				$"."vcls1->setMotherAccount($"."aDet->getMotherAccount());
				$"."vcls1->setAccountID($"."aDet->getAccountID());
				$"."vcls1->setRelatedID($"."pkey);
				$"."vcls1->setTxnType(".$mid.");
				$"."vcls1->setDrCr(CREDIT);
				$"."vcls1->setAmount($"."mcls->get".$vcls->getAmountField()."());
				$"."vcls1->setNarration('".$mcls->getModuleName()."# '.$"."mcls->get".$pkey."().'/'.$"."finyr);
				$"."vcls1->setUserID($"."tuser->getUserID());
				$"."vcls1->setDOE(date('d-m-Y'));

				";
				
						if($vcls->getRunTimeDebitAccount() == "YES") {
							$rMsg			= $rMsg."$"."aDet		= $"."this->getAccountDetail($"."mcls->get".$vcls->getDrColumnName()."());";
						} else {
							if($vcls->getDebitAccount() != 0)
								$rMsg			= $rMsg."$"."aDet		= $"."this->getAccountDetail(".$vcls->getDebitAccount().");";
							else
								$rMsg			= $rMsg."$"."aDet		= $"."this->getAccountDetail(".$vcls->getDebitMotherAccount().");";
						}
						
				
						$rMsg			= $rMsg."
				
				$"."vcls2		=	new asys_voucher_entry();
				$"."vcls2->setSerialID(2);
				$"."vcls2->setCompanyID($"."cmpid);
				$"."vcls2->setVoucherType(".$vcls->getVoucherType().");
				$"."vcls2->setFinYear($"."finyr);
				$"."vcls2->setVoucherNo($"."VoucherNo);
				$"."vcls2->setDayWiseNo($"."DayWiseNo);
				$"."vcls2->setDOV($"."vdtf);
				$"."vcls2->setMotherAccount($"."aDet->getMotherAccount());
				$"."vcls2->setAccountID($"."aDet->getAccountID());
				$"."vcls2->setRelatedID($"."pkey);
				$"."vcls2->setTxnType(".$mid.");
				$"."vcls2->setDrCr(DEBIT);
				$"."vcls2->setAmount($"."mcls->get".$vcls->getAmountField()."());
				$"."vcls2->setNarration('".$mcls->getModuleName()."# '.$"."mcls->get".$pkey."().'/'.$"."finyr);
				$"."vcls2->setUserID($"."tuser->getUserID());
				$"."vcls2->setDOE(date('d-m-Y'));
		
				$"."_vid			= $"."this->getNextID(\"asys_voucher_entry\", \"VoucherID\");
				$"."vcls1->setVoucherID($"."_vid);
				$"."vcls2->setVoucherID($"."_vid);
				$"."this->conn->exec($"."vcls1->getInsertSQL());
				$"."this->conn->exec($"."vcls2->getInsertSQL());
			
				/* Voucher Entry ends here */
					
				";
					
						}
					
					}					
				
				
					if($mcls->getStockFlow() == "YES") {
					
						$scList		= $mcls->getStockConfigList();
						
						for($j=0;$j<count($scList);$j++) {
							$scls		= $scList[$j];
							
							if($scls->getStoreIN() != 0 || $scls->getRunTimeStockIN() == "YES") {
							
								$rMsg			= $rMsg."
							
				/* Stock entries */
				
				$"."scls		= new asys_stock_voucher();
				$"."scls->setSVoucherID($"."this->getNextID(\"asys_stock_voucher\",\"SVoucherID\"));
				$"."scls->setCompanyID($"."cmpid);";
				if($scls->getRunTimeStockIN() == "YES")
					$rMsg			= $rMsg."$"."scls->setStoreID($"."mcls->get".$scls->getInColumnName()."());";
				else
					$rMsg			= $rMsg."$"."scls->setStoreID(".$scls->getStoreIN().");";	
				$rMsg			= $rMsg."
				$"."scls->setModuleID(".$mid.");
				$"."scls->setFinYear($"."mcls->getFinYear());
				$"."scls->setRelatedID($"."pkey);
				$"."scls->setDOT($"."mcls->getBookingDate('yes'));
				$"."scls->setItemID($"."smcls->getItemID());
				$"."scls->setQuantity($"."smcls->getQuantity());
				$"."scls->setUnitPrice();
				$"."scls->setStockInOut(STOCK_IN);
				$"."scls->setBatchNo(\"\");
				$"."scls->setNarration('".$mcls->getModuleName()."# '.$"."mcls->getBookingNo().'/'.$"."mcls->getFinYear());
				
				$"."sql		= $"."scls->getInsertSQL();
				$"."this->conn->exec($"."sql);
				
				
				/* Stock entry ends here */
					
					";
					
							}
							
							if($scls->getStoreOUT() != 0 || $scls->getRunTimeStockOUT() == "YES") {
							
								$rMsg			= $rMsg."
							
				/* Stock entries */
				
				$"."scls		= new asys_stock_voucher();
				$"."scls->setSVoucherID($"."this->getNextID(\"asys_stock_voucher\",\"SVoucherID\"));
				$"."scls->setCompanyID($"."cmpid);";
				if($scls->getRunTimeStockOUT() == "YES")
					$rMsg			= $rMsg."$"."scls->setStoreID($"."mcls->get".$scls->getOutColumnName()."());";
				else
					$rMsg			= $rMsg."$"."scls->setStoreID(".$scls->getStoreOUT().");";	
				$rMsg			= $rMsg."
				$"."scls->setModuleID(".$mid.");
				$"."scls->setFinYear($"."mcls->getFinYear());
				$"."scls->setRelatedID($"."pkey);
				$"."scls->setDOT($"."mcls->getBookingDate('yes'));
				$"."scls->setItemID($"."smcls->getItemID());
				$"."scls->setQuantity($"."smcls->getQuantity());
				$"."scls->setUnitPrice();
				$"."scls->setStockInOut(STOCK_OUT);
				$"."scls->setBatchNo(\"\");
				$"."scls->setNarration('".$mcls->getModuleName()."# '.$"."mcls->getBookingNo().'/'.$"."mcls->getFinYear());
				
				$"."sql		= $"."scls->getInsertSQL();
				$"."this->conn->exec($"."sql);

				
				/* Stock entry ends here */
					
					";
					
							}								
							
						}
					
					}					
				
				
				$rMsg			= $rMsg."
			
				$"."this->conn->commit();
				
			} catch(Exception $"."er) {
				
				$"."this->conn->rollBack();
				$"."err	= 'moduledb".$mid." CreateModule".$mid." '.$"."er->getMessage();
				_errorLog($"."err);
				$"."pkey	= -1;
				
			}


			return $"."pkey;
			
		}
		
		
		function UpdateModule".$mid."($"."mcls) {
			
			$"."tuser		=	unserialize($"."_SESSION[\"ssEUser\"]);
			$"."tcmp		=	unserialize($"."_SESSION[\"ssECmp\"]);
			$"."cmpid		= $"."tcmp->getCompanyID();
			
			";
			
			$fyclm		= "";
			$pkset		= 0;
			for($i=0;$i<count($clmList);$i++) {			
				$ccls		= $clmList[$i];
				if($ccls->getIncremental() == "YES") {
					$rMsg			= $rMsg."
			$"."pkey		= $"."mcls->get".$ccls->getColumnName()."();
					";
					$pkset	= 1;
				}
				if($ccls->getSetFinancialYear() == "YES") {
					$fyclm	= $ccls->getColumnName();
				}
				
			}
			
			if($pkset == 0) {
				for($i=0;$i<count($clmList);$i++) {			
					$ccls		= $clmList[$i];	
					if($ccls->getPrimaryKey() == "YES") {
						$rMsg			= $rMsg."
			$"."pkey		= $"."mcls->get".$ccls->getColumnName()."();
						";
					}
				}		
			}			
			
			$rMsg			= $rMsg."
			
				
			try {
			
				$"."this->conn->beginTransaction();

				";
				
				for($i=0;$i<count($smlList);$i++) {
					$scls		= $smlList[$i];
					$rMsg			= $rMsg."
				$"."sql			=	\"DELETE FROM `gen_module".$mid."_submodule".($i+1)."` WHERE `".$pkey."`='$"."pkey'\";	
				$"."this->conn->query($"."sql);
					";				
				}
				
				if($mcls->getStockFlow() == "YES") {
					$rMsg			= $rMsg."
				$"."sql			=	\"DELETE FROM `asys_stock_voucher` WHERE `RelatedID`='$"."pkey' AND `ModuleID`='".$mid."'\";	
				$"."this->conn->query($"."sql);
					";				
				}
			
				if($mcls->getAccountVoucher() == "YES") {
					$rMsg			= $rMsg."
				$"."sql			=	\"DELETE FROM `asys_voucher_entry` WHERE `RelatedID`='$"."pkey' AND `TxnType`='".$mid."'\";	
				$"."this->conn->query($"."sql);
					";				
				}					
				
				for($i=0;$i<count($smlList);$i++) {
					$smcls	= $smlList[$i];
					$smDet	= $this->getModuleDetail($smcls->getSubmoduleID());
					
					$rMsg			= $rMsg."
					
				$"."submList	= $"."mcls->getSubmoduleList".($i+1)."();
				for($"."i=0;$"."i<count($"."submList);$"."i++) {
					$"."smcls	=	$"."submList[$"."i];
					$"."smcls->set".$pkey."($"."pkey);

					$"."sql		= $"."smcls->getInsertSQL();
					$"."this->conn->exec($"."sql);
					";
					
					if($smDet->getStockFlow() == "YES") {
					
						$scList		= $smDet->getStockConfigList();
						
						for($j=0;$j<count($scList);$j++) {
							$scls		= $scList[$j];
							
							if($scls->getStoreIN() != 0 || $scls->getRunTimeStockIN() == "YES") {
							
								$rMsg			= $rMsg."
								
					$lcqty	= $this->getLastStockClosingQuantity($cmpid, $pcls->getStoreID(), $icls->getItemID(), $pdt);
					$lcval	= $this->getLastStockClosingValue($cmpid, $pcls->getStoreID(), $icls->getItemID(), $pdt);
					$lbald	= $this->getLastBalanceDetail($cmpid, $pcls->getStoreID(), $icls->getItemID(), $pdt);
					
					$iamt		= $icls->getTotalAmount() - ($icls->getIGST() + $icls->getSGST() + $icls->getCGST());
					if($pcls->getImport() == \"YES\")
						$iamt	= $iamt * $pcls->getConversion();						
				
					$cqty		= $lcqty + $icls->getQuantity();
					$cval		= $lcval + ($iamt + $xtraPerUnit);
					$bald		= $lbald;
					if($bald != \"\") $bald = $bald.\",\";
					$bald		= $bald.$icls->getQuantity().\"=\".($iamt/$icls->getQuantity() + $xtraPerUnit);								
							
					/* Stock entries */
					
					$"."scls		= new asys_stock_voucher();
					$"."scls->setSVoucherID($"."this->getNextID(\"asys_stock_voucher\",\"SVoucherID\"));
					$"."scls->setCompanyID($"."cmpid);";
					if($scls->getRunTimeStockIN() == "YES")
						$rMsg			= $rMsg."$"."scls->setStoreID($"."smcls->get".$scls->getInColumnName()."());";
					else
						$rMsg			= $rMsg."$"."scls->setStoreID(".$scls->getStoreIN().");";	
					$rMsg			= $rMsg."
					$"."scls->setModuleID(".$mid.");
					$"."scls->setFinYear($"."mcls->getFinYear());
					$"."scls->setRelatedID($"."pkey);
					$"."scls->setDOT($"."mcls->getBookingDate('yes'));
					$"."scls->setItemID($"."smcls->getItemID());
					$"."scls->setQuantity($"."smcls->getQuantity());
					$"."scls->setUnitPrice();
					$"."scls->setStockInOut(STOCK_IN);
					$"."scls->setBatchNo(\"\");
					$"."scls->setNarration('".$mcls->getModuleName()."# '.$"."mcls->getBookingNo().'/'.$"."mcls->getFinYear());
					
					$"."sql		= $"."scls->getInsertSQL();
					$"."this->conn->exec($"."sql);
					
					/* Stock entry ends here */
					
					";
					
							}
							
							if($scls->getStoreOUT() != 0 || $scls->getRunTimeStockOUT() == "YES") {
							
								$rMsg			= $rMsg."
							
					/* Stock entries */
					
					$"."scls		= new asys_stock_voucher();
					$"."scls->setSVoucherID($"."this->getNextID(\"asys_stock_voucher\",\"SVoucherID\"));
					$"."scls->setCompanyID($"."cmpid);";
					if($scls->getRunTimeStockOUT() == "YES")
						$rMsg			= $rMsg."$"."scls->setStoreID($"."smcls->get".$scls->getOutColumnName()."());";
					else
						$rMsg			= $rMsg."$"."scls->setStoreID(".$scls->getStoreOUT().");";	
					$rMsg			= $rMsg."
					$"."scls->setModuleID(".$mid.");
					$"."scls->setFinYear($"."mcls->getFinYear());
					$"."scls->setRelatedID($"."pkey);
					$"."scls->setDOT($"."mcls->getBookingDate('yes'));
					$"."scls->setItemID($"."smcls->getItemID());
					$"."scls->setQuantity($"."smcls->getQuantity());
					$"."scls->setUnitPrice();
					$"."scls->setStockInOut(STOCK_OUT);
					$"."scls->setBatchNo(\"\");
					$"."scls->setNarration('".$mcls->getModuleName()."# '.$"."mcls->getBookingNo().'/'.$"."mcls->getFinYear());
					
					$"."sql		= $"."scls->getInsertSQL();
					$"."this->conn->exec($"."sql);
					
					/* Stock entry ends here */
					
					";
					
							}								
							
						}
					
					}
					
					if($smDet->getAccountVoucher() == "YES") {
					
						$vcList		= $smDet->getVoucherConfigList();
						
						for($j=0;$j<count($vcList);$j++) {
							$vcls		= $vcList[$j];
					
						$rMsg			= $rMsg."
						
					/* Voucher Entries */
					
					$"."finyr		= getFinancialYear($"."mcls->get".$vcls->getDateField()."());
					$"."vdt			= $"."mcls->get".$vcls->getDateField()."();
					$"."vdtf			= $"."mcls->get".$vcls->getDateField()."('yes');

					
					$"."VoucherNo	= $"."this->getMaxVoucherNo(".$vcls->getVoucherType().", $"."finyr, $"."cmpid);
					$"."DayWiseNo	= $"."this->getMaxDayWiseVoucherNo(".$vcls->getVoucherType().", $"."vdt, $"."cmpid);
				
					";
				
						if($vcls->getRunTimeCreditAccount() == "YES") {
							$rMsg			= $rMsg."$"."aDet		= $"."this->getAccountDetail($"."mcls->get".$vcls->getCrColumnName()."());";
						} else {
							if($vcls->getCreditAccount() != 0)
								$rMsg			= $rMsg."$"."aDet		= $"."this->getAccountDetail(".$vcls->getCreditAccount().");";
							else
								$rMsg			= $rMsg."$"."aDet		= $"."this->getAccountDetail(".$vcls->getCreditMotherAccount().");";
						}
						
				
						$rMsg			= $rMsg."

					$"."vcls1		=	new asys_voucher_entry();
					$"."vcls1->setSerialID(1);
					$"."vcls1->setCompanyID($"."cmpid);
					$"."vcls1->setVoucherType(".$vcls->getVoucherType().");
					$"."vcls1->setFinYear($"."finyr);
					$"."vcls1->setVoucherNo($"."VoucherNo);
					$"."vcls1->setDayWiseNo($"."DayWiseNo);
					$"."vcls1->setDOV($"."vdtf);
					$"."vcls1->setMotherAccount($"."aDet->getMotherAccount());
					$"."vcls1->setAccountID($"."aDet->getAccountID());
					$"."vcls1->setRelatedID($"."pkey);
					$"."vcls1->setTxnType(".$mid.");
					$"."vcls1->setDrCr(CREDIT);
					$"."vcls1->setAmount($"."mcls->get".$vcls->getAmountField()."());
					$"."vcls1->setNarration('".$mcls->getModuleName()."# '.$"."mcls->get".$pkey."().'/'.$"."finyr);
					$"."vcls1->setUserID($"."tuser->getUserID());
					$"."vcls1->setDOE(date('d-m-Y'));
			
					";
				
						if($vcls->getRunTimeDebitAccount() == "YES") {
							$rMsg			= $rMsg."$"."aDet		= $"."this->getAccountDetail($"."mcls->get".$vcls->getDrColumnName()."());";
						} else {
							if($vcls->getDebitAccount() != 0)
								$rMsg			= $rMsg."$"."aDet		= $"."this->getAccountDetail(".$vcls->getDebitAccount().");";
							else
								$rMsg			= $rMsg."$"."aDet		= $"."this->getAccountDetail(".$vcls->getDebitMotherAccount().");";
						}
						
				
						$rMsg			= $rMsg."
					
					$"."vcls2		=	new asys_voucher_entry();
					$"."vcls2->setSerialID(2);
					$"."vcls2->setCompanyID($"."cmpid);
					$"."vcls2->setVoucherType(".$vcls->getVoucherType().");
					$"."vcls2->setFinYear($"."finyr);
					$"."vcls2->setVoucherNo($"."VoucherNo);
					$"."vcls2->setDayWiseNo($"."DayWiseNo);
					$"."vcls2->setDOV($"."vdtf);
					$"."vcls2->setMotherAccount($"."aDet->getMotherAccount());
					$"."vcls2->setAccountID($"."aDet->getAccountID());
					$"."vcls2->setRelatedID($"."pkey);
					$"."vcls2->setTxnType(".$mid.");
					$"."vcls2->setDrCr(DEBIT);
					$"."vcls2->setAmount($"."mcls->get".$vcls->getAmountField()."());
					$"."vcls2->setNarration('".$mcls->getModuleName()."# '.$"."mcls->get".$pkey."().'/'.$"."finyr);
					$"."vcls2->setUserID($"."tuser->getUserID());
					$"."vcls2->setDOE(date('d-m-Y'));
					
					$"."_vid			= $"."this->getNextID(\"asys_voucher_entry\", \"VoucherID\");
					$"."vcls1->setVoucherID($"."_vid);
					$"."vcls2->setVoucherID($"."_vid);
					$"."this->conn->exec($"."vcls1->getInsertSQL());
					$"."this->conn->exec($"."vcls2->getInsertSQL());
				
					/* Voucher Entry ends here */
					
					";
					
						}
					
					}
					
					$rMsg			= $rMsg."
					
				}
					";
				}
				
				
					if($mcls->getAccountVoucher() == "YES") {
					
						$vcList		= $mcls->getVoucherConfigList();
						
						for($j=0;$j<count($vcList);$j++) {
							$vcls		= $vcList[$j];
					
						$rMsg			= $rMsg."
						
				/* Voucher Entries */
				
				$"."finyr		= getFinancialYear($"."mcls->get".$vcls->getDateField()."());
				$"."vdt			= $"."mcls->get".$vcls->getDateField()."();
				$"."vdtf			= $"."mcls->get".$vcls->getDateField()."('yes');

				$"."VoucherNo	= $"."this->getMaxVoucherNo(".$vcls->getVoucherType().", $"."finyr, $"."cmpid);
				$"."DayWiseNo	= $"."this->getMaxDayWiseVoucherNo(".$vcls->getVoucherType().", $"."vdt, $"."cmpid);
			
				";
				
						if($vcls->getRunTimeCreditAccount() == "YES") {
							$rMsg			= $rMsg."$"."aDet		= $"."this->getAccountDetail($"."mcls->get".$vcls->getCrColumnName()."());";
						} else {
							if($vcls->getCreditAccount() != 0)
								$rMsg			= $rMsg."$"."aDet		= $"."this->getAccountDetail(".$vcls->getCreditAccount().");";
							else
								$rMsg			= $rMsg."$"."aDet		= $"."this->getAccountDetail(".$vcls->getCreditMotherAccount().");";
						}
						
				
						$rMsg			= $rMsg."

				$"."vcls1		=	new asys_voucher_entry();
				$"."vcls1->setSerialID(1);
				$"."vcls1->setCompanyID($"."cmpid);
				$"."vcls1->setVoucherType(".$vcls->getVoucherType().");
				$"."vcls1->setFinYear($"."finyr);
				$"."vcls1->setVoucherNo($"."VoucherNo);
				$"."vcls1->setDayWiseNo($"."DayWiseNo);
				$"."vcls1->setDOV($"."vdtf);
				$"."vcls1->setMotherAccount($"."aDet->getMotherAccount());
				$"."vcls1->setAccountID($"."aDet->getAccountID());
				$"."vcls1->setRelatedID($"."pkey);
				$"."vcls1->setTxnType(".$mid.");
				$"."vcls1->setDrCr(CREDIT);
				$"."vcls1->setAmount(".$vcls->getAmountField().");
				$"."vcls1->setNarration('".$mcls->getModuleName()."# '.$"."mcls->get".$pkey."().'/'.$"."finyr);
				$"."vcls1->setUserID($"."tuser->getUserID());
				$"."vcls1->setDOE(date('d-m-Y'));
		
				";
				
						if($vcls->getRunTimeDebitAccount() == "YES") {
							$rMsg			= $rMsg."$"."aDet		= $"."this->getAccountDetail($"."mcls->get".$vcls->getDrColumnName()."());";
						} else {
							if($vcls->getDebitAccount() != 0)
								$rMsg			= $rMsg."$"."aDet		= $"."this->getAccountDetail(".$vcls->getDebitAccount().");";
							else
								$rMsg			= $rMsg."$"."aDet		= $"."this->getAccountDetail(".$vcls->getDebitMotherAccount().");";
						}
						
				
						$rMsg			= $rMsg."
				
				$"."vcls2		=	new asys_voucher_entry();
				$"."vcls2->setSerialID(2);
				$"."vcls2->setCompanyID($"."cmpid);
				$"."vcls2->setVoucherType(".$vcls->getVoucherType().");
				$"."vcls2->setFinYear($"."finyr);
				$"."vcls2->setVoucherNo($"."VoucherNo);
				$"."vcls2->setDayWiseNo($"."DayWiseNo);
				$"."vcls2->setDOV($"."vdtf);
				$"."vcls2->setMotherAccount($"."aDet->getMotherAccount());
				$"."vcls2->setAccountID($"."aDet->getAccountID());
				$"."vcls2->setRelatedID($"."pkey);
				$"."vcls2->setTxnType(".$mid.");
				$"."vcls2->setDrCr(DEBIT);
				$"."vcls2->setAmount(".$vcls->getAmountField().");
				$"."vcls2->setNarration('".$mcls->getModuleName()."# '.$"."mcls->get".$pkey."().'/'.$"."finyr);
				$"."vcls2->setUserID($"."tuser->getUserID());
				$"."vcls2->setDOE(date('d-m-Y'));
		
		
				$"."_vid			= $"."this->getNextID(\"asys_voucher_entry\", \"VoucherID\");
				$"."vcls1->setVoucherID($"."_vid);
				$"."vcls2->setVoucherID($"."_vid);
				$"."this->conn->exec($"."vcls1->getInsertSQL());
				$"."this->conn->exec($"."vcls2->getInsertSQL());
			
				/* Voucher Entry ends here */
					
					";
					
						}
					
					}					
				
				
					if($mcls->getStockFlow() == "YES") {
					
						$scList		= $mcls->getStockConfigList();
						
						for($j=0;$j<count($scList);$j++) {
							$scls		= $scList[$j];
							
							if($scls->getStoreIN() != 0 || $scls->getRunTimeStockIN() == "YES") {
							
								$rMsg			= $rMsg."
							
				/* Stock entries */
				
				$"."scls		= new asys_stock_voucher();
				$"."scls->setSVoucherID($"."this->getNextID(\"asys_stock_voucher\",\"SVoucherID\"));
				$"."scls->setCompanyID($"."cmpid);";
				if($scls->getRunTimeStockIN() == "YES")
					$rMsg			= $rMsg."$"."scls->setStoreID($"."smcls->get".$scls->getInColumnName()."());";
				else
					$rMsg			= $rMsg."$"."scls->setStoreID(".$scls->getStoreIN().");";	
				$rMsg			= $rMsg."
				$"."scls->setModuleID(".$mid.");
				$"."scls->setFinYear($"."mcls->getFinYear());
				$"."scls->setRelatedID($"."pkey);
				$"."scls->setDOT($"."mcls->getBookingDate('yes'));
				$"."scls->setItemID($"."mcls->getItemID());
				$"."scls->setQuantity($"."mcls->getQuantity());
				$"."scls->setUnitPrice();
				$"."scls->setStockInOut(STOCK_IN);
				$"."scls->setBatchNo(\"\");
				$"."scls->setNarration('".$mcls->getModuleName()."# '.$"."mcls->getBookingNo().'/'.$"."mcls->getFinYear());
				
				$"."sql		= $"."scls->getInsertSQL();
				$"."this->conn->exec($"."sql);
				
				/* Stock entry ends here */
					
					";
					
							}
							
							if($scls->getStoreOUT() != 0 || $scls->getRunTimeStockOUT() == "YES") {
							
								$rMsg			= $rMsg."
							
				/* Stock entries */
				
				$"."scls		= new asys_stock_voucher();
				$"."scls->setSVoucherID($"."this->getNextID(\"asys_stock_voucher\",\"SVoucherID\"));
				$"."scls->setCompanyID($"."cmpid);";
				if($scls->getRunTimeStockOUT() == "YES")
					$rMsg			= $rMsg."$"."scls->setStoreID($"."smcls->get".$scls->getOutColumnName()."());";
				else
					$rMsg			= $rMsg."$"."scls->setStoreID(".$scls->getStoreOUT().");";	
				$rMsg			= $rMsg."
				$"."scls->setModuleID(".$mid.");
				$"."scls->setFinYear($"."mcls->getFinYear());
				$"."scls->setRelatedID($"."pkey);
				$"."scls->setDOT($"."mcls->getBookingDate('yes'));
				$"."scls->setItemID($"."mcls->getItemID());
				$"."scls->setQuantity($"."mcls->getQuantity());
				$"."scls->setUnitPrice();
				$"."scls->setStockInOut(STOCK_OUT);
				$"."scls->setBatchNo(\"\");
				$"."scls->setNarration('".$mcls->getModuleName()."# '.$"."mcls->getBookingNo().'/'.$"."mcls->getFinYear());
				
				$"."sql		= $"."scls->getInsertSQL();
				$"."this->conn->exec($"."sql);
				
				/* Stock entry ends here */
					
					";
					
							}								
							
						}
					
					}					
				
				
				$rMsg			= $rMsg."
				
				$"."sql	= $"."mcls->getUpdateSQL();
				$"."this->conn->exec($"."sql);
			
				$"."this->conn->commit();
				
			} catch(Exception $"."er) {
				
				$"."this->conn->rollBack();
				$"."err	= 'moduledb".$mid." UpdateModule".$mid." '.$"."er->getMessage();
				_errorLog($"."err);
				$"."pkey	= -1;
				
			}


			return $"."pkey;
			
		}
		
	};
		
?>";

			return $rMsg;
		}
		
		
		
		/*******************************************************
		 * This is the code to generate a php code that handles 
		 * the Detail code in PHP
		 *******************************************************/                                    

		function getDetailCodePHP($mcls) {
			
			$mid			= $mcls->getModuleID();
			$smlList	= $mcls->getSubmoduleList();
			
			$rMsg			= "<?php

	/* Include the required files */
	require_once( 'aom-config.php' );
	require_once( 'inc/pagetemplate.php' );
	require_once( 'inc/head.php' );
	require_once( 'inc/topmenu.php' );
	require_once( 'inc/functions.php' );
	require_once( 'dao/asys.user.php' );
	require_once( 'dao/asys.company.php' );
	require_once( 'dao/class.gen_module".$mid.".php' );";
	
	for($i=0;$i<count($smlList);$i++) {
		$smname	= "gen_module".$mid."_submodule".($i+1);
		$rMsg		= $rMsg."
	require_once( 'dao/class.".$smname.".php' );";
	}
	
	$rMsg			= $rMsg."	
	require_once( 'dao/asys.genericdb.php' );
	require_once( 'dao/asys.masterdb.php' );
	require_once( 'dao/asys.log.php' );
	require_once( 'dao/asys.logindb.php' );
	require_once( 'dao/asys.userpermission.php' );
	require_once( 'dao/class.moduledb".$mid.".php' );

	$"."tuser		=	new asys_users();
	$"."tcmp			= new asys_companies();

	if(isset($"."_SESSION[\"ssEUser\"])){
		$"."tuser	=	unserialize($"."_SESSION[\"ssEUser\"]);
	}

	if($"."tuser->getUserID() == \"\") {
		header(\"Location:logout.php\");
		exit;
	}
	
	if(isset($"."_SESSION[\"ssECmp\"])){
		$"."tcmp	=	unserialize($"."_SESSION[\"ssECmp\"]);
	}
	
	if($"."tcmp->getCompanyID() <= 0) {
		header(\"Location:home.php\");
		exit;	
	}		

	$"."gdb					=	new genericdb();
	$"."mddb					=	new moduledb".$mid."();

	$"."pkey			=	\"\";
	
	extract($"."_REQUEST);
	
	if(trim($"."pkey) == \"\") {
		echo 'Sorry!! Direct access denied';
		exit;
	}

	$"."cls			=	$"."mddb->getModule".$mid."Detail($"."pkey);

	/* Ready to create the page */
	$"."iPage	=	new asys_pages(APP_TITLE);
	/* Start writting the page */
	$"."iPage->startPage();
	$"."iPage->startHeader();
	/* Add links and Scripts as required */
	$"."iPage->addLink(\"css/asys.css\");
	$"."iPage->endHeader();
	$"."iPage->startBody('style=\"background:#ffffff\"');
	echo $"."cls->getHTMLRepresentation();
	$"."iPage->endBody();
	$"."iPage->endPage();

?>";
			return $rMsg;
		}


	};


?>