<?php

	class purchasedb {

		protected $host			= SS_DB_HOST;
		protected $user			= SS_DB_USER;
		protected $password	= SS_DB_PASSWORD;
		protected $dbname		= SS_DB_DBNAME;
		protected $conn			= null;

		public function __construct($dbType = '') {
			
			if (!extension_loaded('pdo')) {
				die (SS_DB_ERR_101);
			}
			
			if($dbType == "REPORT") {
				$this->user 		= SS_RPT_USER;
				$this->password	= SS_RPT_PASSWORD;
			} else if($dbType == "DATA") {
				$this->user 		= SS_DBA_USER;
				$this->password	= SS_DBA_PASSWORD;			
			}
			
			try {
				$this->conn = new PDO("mysql:host=".$this->host.";dbname=".$this->dbname, $this->user, $this->password);
				$this->conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
			} catch(PDOException $e) {
				die('DB connection error '.$e->getMessage());
			}
				
		}
		
		public function __destruct() {
			$this->conn	= null;
		}
		
		private function ExecuteQuery($sql00) {
		
			$res	= false;

			try {
				
				$res	= $this->conn->query($sql00);
				
			} catch(PDOException $e) {
				$err	= 'purchasedb ExecuteQuery ('.$sql00.') '.$e->getMessage();
				_errorLog($err);
			}
			
			return $res;
			
		}

		private function getRecordsetExecutingQuery($sql00) {
		
			$rows		= array();
		
			try {

				$result	= $this->conn->query($sql00);
				while($row = $result->fetch()) {
					$rows[]	=	$row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getRecordsetExecutingQuery ('.$sql00.') '.$e->getMessage();
				_errorLog($err);
			}
		
			return $rows;
			
		}
		
		private function getResultExecutingQuery($sql00) {
		
			$rows		= array();
			$res		= "";
		
			try {

				$result	= $this->conn->query($sql00);
				if($row = $result->fetch()) {
					$res	=	$row[0];
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getResultExecutingQuery ('.$sql00.') '.$e->getMessage();
				_errorLog($err);
			}
		
			return $res;
			
		}
		
		public function getNextID($tblName, $colName) {
			
			if(strpos($tblName, "'") !== false) return false;
			if(strpos($colName, "'") !== false) return false;
			
			if(strpos($tblName, '"') !== false) return false;
			if(strpos($colName, '"') !== false) return false;
			
			$maxid			=	1;
			$sql				=	"SELECT `MaxID` FROM `asys_tablemaxrows` WHERE `TableName`='$tblName' ORDER BY `MaxID` DESC LIMIT 1";
			$usql				= "UPDATE `asys_tablemaxrows` SET `MaxID`=`MaxID`+1 WHERE `TableName`='$tblName'";

			try {
				
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch()) {
					$maxid 	= $row[0];
					$this->conn->exec($usql);
				} else {
					$sql		= "INSERT INTO `asys_tablemaxrows` (`TableName`, `MaxID`) VALUES ('$tblName', '2');";
					$this->conn->exec($sql);
				}
					
			} catch(PDOException $e) {
				$err	= 'voucherdb getNextID '.$e->getMessage();
				_errorLog($err);
			}

			return $maxid;
			
		}

		function getUnitNameByUnitID($UnitID) {
			$sql		=	"SELECT `UnitName` FROM `gen_unit` WHERE `UnitID`='$UnitID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getItemCategoryNameByItemCategoryID($ItemCategoryID) {
			$sql		=	"SELECT `ItemCategoryName` FROM `gen_itemcategory` WHERE `ItemCategoryID`='$ItemCategoryID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getItemCategoryByItemID($ItemID) {
			$sql		=	"SELECT `ItemCategoryID` FROM `gen_items` WHERE `ItemID`='$ItemID'";
			return $this->getResultExecutingQuery($sql);			
		}
		
		function getItemNameByItemID($ItemID) {
			$sql		=	"SELECT `ItemName` FROM `gen_items` WHERE `ItemID`='$ItemID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getAccountNameByAccountID($AccountID) {
			$sql		=	"SELECT `AccountName` FROM `asys_accounts` WHERE `AccountID`='$AccountID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getBaseGroupNameByBaseGroupID($BGID) {
			$BGID		= (int)$BGID;
			$sql		=	"SELECT `GroupName` FROM `asys_base_group` WHERE `BGID`='$BGID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getGroupNameByGroupID($GroupID) {
			$GroupID	= (int)$GroupID;
			$sql			=	"SELECT `GroupName` FROM `asys_groups` WHERE `GroupID`='$GroupID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getStoreNameByStoreID($StoreID) {
			$sql		=	"SELECT `StoreName` FROM `asys_stores` WHERE `StoreID`='$StoreID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getCompanyNameByCompanyID($CompanyID) {
			$CompanyID		= (int)$CompanyID;
			$sql		=	"SELECT `CompanyName` FROM `asys_companies` WHERE `CompanyID`='$CompanyID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getUTByState($State){
		
			$State		= addslashes($State);
			$sql			= "SELECT `UT` FROM `asys_cities` WHERE `State`='$State'";
			return $this->getResultExecutingQuery($sql);
		
		}
		
		function getMaxVoucherNo($VoucherType, $FinYear, $CompanyID) {
			$CompanyID		= (int)$CompanyID;
			$VoucherType	= (int)$VoucherType;
			$FinYear			= addslashes($FinYear);
			$maxid				=	0;
			$sql					=	"SELECT MAX(`VoucherNo`) FROM `asys_voucher_entry` WHERE `VoucherType`='$VoucherType' AND `FinYear`='$FinYear' AND `CompanyID`='$CompanyID'";
			$maxid				= $this->getResultExecutingQuery($sql);
			$maxid++;
			return $maxid;
		}
		
		function getMaxDayWiseVoucherNo($VoucherType, $DOV, $CompanyID) {
			$CompanyID		= (int)$CompanyID;
			$VoucherType	= (int)$VoucherType;
			$DOV					= addslashes($DOV);
			$maxid				=	0;
			$sql					=	"SELECT MAX(`DayWiseNo`) FROM `asys_voucher_entry` WHERE `VoucherType`='$VoucherType' AND `DOV`='$DOV' AND `CompanyID`='$CompanyID'";
			$maxid				= $this->getResultExecutingQuery($sql);
			$maxid++;
			return $maxid;
		}

		function getConfigDetail($ConfigID) {
			$ConfigID	= (int)$ConfigID;
			$cclass			=	new asys_config();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_config` WHERE `ConfigID`='$ConfigID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_config');
				if($row 	= $result->fetch()) { 
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getConfigDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}
		
		function getAccountDetail($AccountID) {
			$AccountID	= (int)$AccountID;
			$cclass			=	new asys_accounts();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_accounts` WHERE `AccountID`='$AccountID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_accounts');
				if($row 	= $result->fetch()) {
					$cclass	= $row;
					$cclass->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$cclass->setGroupName($this->getGroupNameByGroupID($cclass->getGroupID()));
					$cclass->setBGName($this->getBaseGroupNameByBaseGroupID($cclass->getBGID()));
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getAccountDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}
		
		function getStoreDetail($StoreID) {
			$StoreID	= (int)$StoreID;
			$cclass			=	new asys_stores();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_stores` WHERE `StoreID`='$StoreID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_stores');
				if($row 	= $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setMotherAccountName( $this->getAccountNameByAccountID( $row->getMotherAccountID()));
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));					
					$cclass	= $row;
				}

			} catch(PDOException $e) {
				$err	= 'masterdb getStoreDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}
		
		function getItemDetail($ItemID) {
			$ItemID	= (int)$ItemID;
			$cclass			=	new gen_items();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_items` WHERE `ItemID`='$ItemID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_items');
				if($row 	= $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setItemCategoryName( $this->getItemCategoryNameByItemCategoryID( $row->getItemCategoryID()));
					$row->setUnitName($this->getUnitNameByUnitID($row->getUnitID()));
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'masterdb getItemDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}
		
		function getVoucherNoByRelatedID($VoucherType, $TxnType, $RelatedID, $CompanyID) {
			$CompanyID		= (int)$CompanyID;
			$VoucherType	= (int)$VoucherType;
			$TxnType			= (int)$TxnType;
			$RelatedID		= (int)$RelatedID;
			$sql	= "SELECT `VoucherNo` FROM `asys_voucher_entry` WHERE `VoucherType`='".$VoucherType."' AND `TxnType`='".$TxnType."' AND `RelatedID`='".$RelatedID."' AND `CompanyID`='".$CompanyID."'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getDayWiseNoByRelatedID($VoucherType, $TxnType, $RelatedID, $CompanyID) {
			$CompanyID		= (int)$CompanyID;
			$VoucherType	= (int)$VoucherType;
			$TxnType			= (int)$TxnType;
			$RelatedID		= (int)$RelatedID;
			$sql	= "SELECT `DayWiseNo` FROM `asys_voucher_entry` WHERE `VoucherType`='".$VoucherType."' AND `TxnType`='".$TxnType."' AND `RelatedID`='".$RelatedID."' AND `CompanyID`='".$CompanyID."'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getCompanyIDByTransaction($tblName, $colName, $colID) {
			$tblName	= addslashes($tblName);
			$colName	= addslashes($colName);
			$colID		= (int)$colID;
			$sql				= "SELECT `CompanyID` FROM `$tblName` WHERE `$colName`='".$colID."'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getNameByID($tblName, $NameField, $IdField, $IdValue) {
			$tblName			= addslashes($tblName);
			$NameField		= addslashes($NameField);
			$IdField			= addslashes($IdField);
			$IdValue			= addslashes($IdValue);
			$sql					=	"SELECT `$NameField` FROM `$tblName` WHERE `$IdField`='$IdValue'";
			return $this->getResultExecutingQuery($sql);
		}

		
		
		/*--------------------------------------------------------------------*/
		/*********************** PURCHASE ORDER METHODS ***********************/
		
		function getNextPurchaseOrderNo($FinYear, $CompanyID) {
			if(strpos($FinYear, "'") !== false) return false;
			$CompanyID	= (int)$CompanyID;
			
			$maxid			=	0;
			$sql				=	"SELECT MAX(`PurchaseNo`) FROM `gen_purchaseorder` WHERE `FinYear`='$FinYear' AND `CompanyID`='$CompanyID'";

			try {
				
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch())
					$maxid 	= $row[0];
					
			} catch(PDOException $e) {
				$err	= 'purchasedb getNextPurchaseOrderNo '.$e->getMessage();
				_errorLog($err);
			}

			$maxid++;
			return $maxid;
		}

		function getPurchaseOrderDetail($OrderID) {
			$OrderID		= (int)$OrderID;
			$cclass			=	new gen_purchaseorder();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_purchaseorder` WHERE `OrderID`='$OrderID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_purchaseorder');
				if($row 	= $result->fetch()) { 
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setSupplierName($this->getAccountNameByAccountID($row->getSupplierID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemList($this->getPurchaseOrderItemList($row->getOrderID()));
					$row->setAddLessList($this->getPurchaseOrderAddLessList($row->getOrderID()));
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getPurchaseOrderDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getPurchaseOrderList($CompanyID) {
			$arr				=	array();
			$CompanyID	= (int)$CompanyID;
			
			try {
				
				$sql			=	"SELECT * FROM `gen_purchaseorder` WHERE `CompanyID`='$CompanyID' ORDER BY `OrderNo`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_purchaseorder');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setSupplierName($this->getAccountNameByAccountID($row->getSupplierID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemList($this->getPurchaseOrderItemList($row->getOrderID()));
					$row->setAddLessList($this->getPurchaseOrderAddLessList($row->getOrderID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getPurchaseOrderList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getNumberOfPurchaseOrder($DateFrom, $DateTo, $OrderNo, $SupplierID, $CompanyID) {
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$OrderNo		= (int)$OrderNo;
			$SupplierID	= (int)$SupplierID;
			$CompanyID	= (int)$CompanyID;
			
			$sql	=	"SELECT COUNT(*) FROM `gen_purchaseorder` WHERE `CompanyID`='$CompanyID'";
			if($DateFrom != '1900-01-01')
				$sql	=	$sql." AND `OrderDate`>='$DateFrom'";
			if($DateTo != '1900-01-01')
				$sql	=	$sql." AND `OrderDate`<='$DateTo'";
			if($OrderNo > 0)
				$sql	=	$sql." AND `PurchaseNo`='$OrderNo'";
			if($SupplierID > 0)
				$sql	=	$sql." AND `SupplierID`='$SupplierID'";
			
			return $this->getResultExecutingQuery($sql);
		}

		function getPurchaseOrderListPaged($sRec, $nRec, $DateFrom, $DateTo, $OrderNo, $SupplierID, $CompanyID) {
			$sRec				= (int)$sRec;
			$nRec				= (int)$nRec;
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$OrderNo		= (int)$OrderNo;
			$SupplierID	= (int)$SupplierID;
			$CompanyID	= (int)$CompanyID;
			
			$sql	=	"SELECT * FROM `gen_purchaseorder` WHERE `CompanyID`='$CompanyID'";
			if($DateFrom != '1900-01-01')
				$sql	=	$sql." AND `OrderDate`>='$DateFrom'";
			if($DateTo != '1900-01-01')
				$sql	=	$sql." AND `OrderDate`<='$DateTo'";
			if($OrderNo > 0)
				$sql	=	$sql." AND `PurchaseNo`='$OrderNo'";
			if($SupplierID > 0)
				$sql	=	$sql." AND `SupplierID`='$SupplierID'";
			
			$sql			=	$sql." ORDER BY `FinYear` DESC, `PurchaseNo` DESC LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_purchaseorder');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setSupplierName($this->getAccountNameByAccountID($row->getSupplierID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemList($this->getPurchaseOrderItemList($row->getOrderID()));
					$row->setAddLessList($this->getPurchaseOrderAddLessList($row->getOrderID()));
					$arr[]	= $row;
				}

			} catch(PDOException $e) {
				$err	= 'purchasedb getPurchaseOrderListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getPurchaseOrderItemList($OrderID) {
			$OrderID		= (int)$OrderID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_purchaseorder_items` WHERE `OrderID`='$OrderID' ORDER BY `SerialNo`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_purchaseorder_items');
				while($row = $result->fetch()) {
					$row->setItemName($this->getItemNameByItemID($row->getItemID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getPurchaseOrderItemList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getPurchaseOrderAddLessList($OrderID) {
			$OrderID	= (int)$OrderID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_purchaseorder_addless` WHERE `OrderID`='$OrderID' ORDER BY `SerialNo`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_purchaseorder_addless');
				while($row = $result->fetch()) {
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getPurchaseOrderAddLessList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}			

		function CreatePurchaseOrder($pcls) {
				
			$tuser	=	unserialize($_SESSION["ssEUser"]);
			$tcmp		= unserialize($_SESSION["ssECmp"]);
			$pdt		= $pcls->getPurchaseDate();
			$cmpid	= $pcls->getCompanyID();
			$finyr	= getFinancialYear($pdt);
			$pcls->setFinYear($finyr);
			$pcls->setPurchaseNo($this->getNextPurchaseOrderNo($finyr, $cmpid));
			
			$narr		= 'PUR# '.$pcls->getPurchaseNo().'/'.$finyr.', '.$pcls->getSupplierBillNo().', '.$pcls->getNarration();
			

			try {
			
				$this->conn->beginTransaction();
				
				$pcls->setOrderID($this->getNextID("gen_purchaseorder","OrderID"));
				$pid		= $pcls->getOrderID();
				
				$itmList	= $pcls->getItemList();
				
				for($i=0;$i<count($itmList);$i++) {
					$icls	=	$itmList[$i];
					$icls->setOrderID($pid);
					$icls->setSerialNo($i+1);

					$sql		= $icls->getInsertSQL();
					$this->conn->exec($sql);
				}
				
				$sql	= $pcls->getInsertSQL();
				$this->conn->exec($sql);
				
				$alList	= $pcls->getAddLessList();
				for($i=0;$i<count($alList);$i++) {
					$acls	=	$alList[$i];
					$acls->setOrderID($pid);
					$acls->setSerialNo($i+1);

					$sql		= $acls->getInsertSQL();
					$this->conn->exec($sql);
				}				
				
				/* Voucher Entry ends here */
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'purchasedb CreatePurchaseOrder '.$er->getMessage();
				_errorLog($err);
				$pid	= -1;
				
			}

			return $pid;
			
		}
		
		function deletePurchaseOrder($pcls) {
		
			$pkey				= $pcls->getOrderID();
			$ret				= true;
		

			try {
			
				$this->conn->beginTransaction();
				
				$this->conn->exec("DELETE FROM `gen_purchaseorder_items` WHERE `OrderID`='$pkey'");
				$this->conn->exec("DELETE FROM `gen_purchaseorder_addless` WHERE `OrderID`='$pkey'");
				
				$sql	= $pcls->getDeleteSQL();
				$this->conn->exec($sql);
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				$err	= 'purchasedb deletePurchaseOrder '.$er->getMessage();
				_errorLog($err);
				$ret	= false;
				$this->conn->rollBack();
				
			}

		
			return $ret;

		}
		
		function UpdatePurchaseOrder($pcls) {
				
			$tuser	=	unserialize($_SESSION["ssEUser"]);
			$tcmp		= unserialize($_SESSION["ssECmp"]);
			$pid		= $pcls->getOrderID();
			$pdt		= $pcls->getPurchaseDate();
			$cmpid	= $pcls->getCompanyID();
			$finyr	= getFinancialYear($pdt);
			
			$narr		= 'PUR# '.$pcls->getPurchaseNo().'/'.$finyr.', '.$pcls->getSupplierBillNo().', '.$pcls->getNarration();
			
			try {
			
				$this->conn->beginTransaction();
				
				$delsql1	= "DELETE FROM `gen_purchaseorder_addless` WHERE `OrderID`='$pid'";
				$delsql2	= "DELETE FROM `gen_purchaseorder_items` WHERE `OrderID`='$pid'";
				$this->conn->exec($delsql1);
				$this->conn->exec($delsql2);
				
				$itmList	= $pcls->getItemList();					
				
				for($i=0;$i<count($itmList);$i++) {
					$icls	=	$itmList[$i];
					$icls->setOrderID($pid);
					$icls->setSerialNo($i+1);

					$sql		= $icls->getInsertSQL();
					$this->conn->exec($sql);
				}
				
				$sql	= $pcls->getUpdateSQL();
				$this->conn->exec($sql);

				$alList	= $pcls->getAddLessList();
				for($i=0;$i<count($alList);$i++) {
					$acls	=	$alList[$i];
					$acls->setOrderID($pid);
					$acls->setSerialNo($i+1);

					$sql		= $acls->getInsertSQL();
					$this->conn->exec($sql);
				}				
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'purchasedb UpdatePurchaseOrder '.$er->getMessage();
				_errorLog($err);
				$pid	= -1;
				
			}


			return $pid;
			
		}
		
		function getPurchaseOrderListJSON($CompanyID){
			$CompanyID	= (int)$CompanyID;
			$sql		= "SELECT `OrderID`, CONCAT(`OrderNo`,'/',`FinYear`) AS `OrderName` FROM `gen_purchaseorder` WHERE `CompanyID`='$CompanyID' ORDER BY `OrderID`";
			return $this->getRecordsetExecutingQuery($sql);
		}
		
		function getPurchaseOrderNameByOrderID($OrderID) {
			$OrderID	= (int)$OrderID;
			$sql		=	"SELECT CONCAT(`OrderNo`,'/',`FinYear`) FROM `gen_purchaseorder` WHERE `OrderID`='$OrderID'";
			return $this->getResultExecutingQuery($sql);
		}
		
		

		/*--------------------------------------------------------------*/
		/*********************** PURCHASE METHODS ***********************/
		
		function getNextPurchaseNo($FinYear, $CompanyID) {
			if(strpos($FinYear, "'") !== false) return false;
			$CompanyID	= (int)$CompanyID;
			
			$maxid			=	0;
			$sql				=	"SELECT MAX(`PurchaseNo`) FROM `gen_purchase` WHERE `FinYear`='$FinYear' AND `CompanyID`='$CompanyID'";

			try {
				
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch())
					$maxid 	= $row[0];
					
			} catch(PDOException $e) {
				$err	= 'purchasedb getNextPurchaseNo '.$e->getMessage();
				_errorLog($err);
			}

			$maxid++;
			return $maxid;
		}

		function getPurchaseDetail($PurchaseID) {
			$PurchaseID	= (int)$PurchaseID;
			$cclass			=	new gen_purchase();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_purchase` WHERE `PurchaseID`='$PurchaseID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_purchase');
				if($row 	= $result->fetch()) { 
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setPMotherAccountName( $this->getAccountNameByAccountID( $row->getPMotherAccountID()));
					$row->setPAccountName($this->getAccountNameByAccountID($row->getPAccountID()));
					$row->setSMotherAccountName( $this->getAccountNameByAccountID( $row->getSMotherAccountID()));
					$row->setSupplierName($this->getAccountNameByAccountID($row->getSupplierID()));
					$row->setJVMotherAccountName( $this->getAccountNameByAccountID( $row->getJVMotherAccountID()));
					$row->setJVAccountName($this->getAccountNameByAccountID($row->getJVAccountID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemList($this->getPurchaseItemList($row->getPurchaseID()));
					$row->setAddLessList($this->getPurchaseAddLessList($row->getPurchaseID()));
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getPurchaseDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getPurchaseList($CompanyID) {
			$CompanyID	= (int)$CompanyID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_purchase` WHERE `CompanyID`='$CompanyID' ORDER BY `PurchaseNo`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_purchase');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setPMotherAccountName( $this->getAccountNameByAccountID( $row->getPMotherAccountID()));
					$row->setPAccountName($this->getAccountNameByAccountID($row->getPAccountID()));
					$row->setSMotherAccountName( $this->getAccountNameByAccountID( $row->getSMotherAccountID()));
					$row->setSupplierName($this->getAccountNameByAccountID($row->getSupplierID()));
					$row->setJVAccountName($this->getAccountNameByAccountID($row->getJVAccountID()));
					$row->setJVMotherAccountName( $this->getAccountNameByAccountID( $row->getJVMotherAccountID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemList($this->getPurchaseItemList($row->getPurchaseID()));
					$row->setAddLessList($this->getPurchaseAddLessList($row->getPurchaseID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getPurchaseList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getSupplierWisePurchaseList($CompanyID, $SupplierID) {
			$CompanyID	= (int)$CompanyID;
			$SupplierID	= (int)$SupplierID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_purchase` WHERE `CompanyID`='$CompanyID' AND (`SupplierID`='$SupplierID' OR `SMotherAccountID`='$SupplierID') ORDER BY `PurchaseNo`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_purchase');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setPMotherAccountName( $this->getAccountNameByAccountID( $row->getPMotherAccountID()));
					$row->setPAccountName($this->getAccountNameByAccountID($row->getPAccountID()));
					$row->setSMotherAccountName( $this->getAccountNameByAccountID( $row->getSMotherAccountID()));
					$row->setSupplierName($this->getAccountNameByAccountID($row->getSupplierID()));
					$row->setJVAccountName($this->getAccountNameByAccountID($row->getJVAccountID()));
					$row->setJVMotherAccountName( $this->getAccountNameByAccountID( $row->getJVMotherAccountID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemList($this->getPurchaseItemList($row->getPurchaseID()));
					$row->setAddLessList($this->getPurchaseAddLessList($row->getPurchaseID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getSupplierWisePurchaseList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getPurchaseListBySQL($sql) {
			$arr				=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_purchase');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setPMotherAccountName( $this->getAccountNameByAccountID( $row->getPMotherAccountID()));
					$row->setPAccountName($this->getAccountNameByAccountID($row->getPAccountID()));
					$row->setSMotherAccountName( $this->getAccountNameByAccountID( $row->getSMotherAccountID()));
					$row->setSupplierName($this->getAccountNameByAccountID($row->getSupplierID()));
					$row->setJVAccountName($this->getAccountNameByAccountID($row->getJVAccountID()));
					$row->setJVMotherAccountName( $this->getAccountNameByAccountID( $row->getJVMotherAccountID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemList($this->getPurchaseItemList($row->getPurchaseID()));
					$row->setAddLessList($this->getPurchaseAddLessList($row->getPurchaseID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getPurchaseListBySQL '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}		
		
		function getPurchaseReportList($CompanyID, $DateFrom, $DateTo) {
			$CompanyID	= (int)$CompanyID;
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_purchase` WHERE `CompanyID`='$CompanyID'";
				if($DateFrom != "" && $DateFrom != "1900-01-01")
					$sql		= $sql." AND `PurchaseDate`>='$DateFrom'";
				if($DateTo != "" && $DateTo != "1900-01-01")
					$sql		= $sql." AND `PurchaseDate`<='$DateTo'";
				$sql			= $sql." ORDER BY `PurchaseDate`";
					
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_purchase');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setPMotherAccountName( $this->getAccountNameByAccountID( $row->getPMotherAccountID()));
					$row->setPAccountName($this->getAccountNameByAccountID($row->getPAccountID()));
					$row->setSMotherAccountName( $this->getAccountNameByAccountID( $row->getSMotherAccountID()));
					$row->setSupplierName($this->getAccountNameByAccountID($row->getSupplierID()));
					$row->setJVAccountName($this->getAccountNameByAccountID($row->getJVAccountID()));
					$row->setJVMotherAccountName( $this->getAccountNameByAccountID( $row->getJVMotherAccountID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemList($this->getPurchaseItemList($row->getPurchaseID()));
					$row->setAddLessList($this->getPurchaseAddLessList($row->getPurchaseID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getPurchaseReportList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}		
		
		function getNumberOfPurchase($DateFrom, $DateTo, $PurchaseNo, $SupplierID, $StoreID, $CompanyID) {
		
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$PurchaseNo	= (int)$PurchaseNo;
			$SupplierID	= (int)$SupplierID;
			$StoreID		= (int)$StoreID;
			$CompanyID	= (int)$CompanyID;
		
			$sql	=	"SELECT COUNT(*) FROM `gen_purchase` WHERE `CompanyID`='$CompanyID'";
			if($DateFrom != '1900-01-01')
				$sql	=	$sql." AND `PurchaseDate`>='$DateFrom'";
			if($DateTo != '1900-01-01')
				$sql	=	$sql." AND `PurchaseDate`<='$DateTo'";
			if($PurchaseNo > 0)
				$sql	=	$sql." AND `PurchaseNo`='$PurchaseNo'";
			if($SupplierID > 0)
				$sql	=	$sql." AND `SupplierID`='$SupplierID'";
			if($StoreID > 0)
				$sql	=	$sql." AND `StoreID`='$StoreID'";
			
			return $this->getResultExecutingQuery($sql);
		}

		function getPurchaseListPaged($sRec, $nRec, $DateFrom, $DateTo, $PurchaseNo, $SupplierID, $StoreID, $CompanyID) {
		
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$PurchaseNo	= (int)$PurchaseNo;
			$SupplierID	= (int)$SupplierID;
			$StoreID		= (int)$StoreID;
			$CompanyID	= (int)$CompanyID;
			$sRec				= (int)$sRec;
			$nRec				= (int)$nRec;
		
			$sql	=	"SELECT * FROM `gen_purchase` WHERE `CompanyID`='$CompanyID'";
			if($DateFrom != '1900-01-01')
				$sql	=	$sql." AND `PurchaseDate`>='$DateFrom'";
			if($DateTo != '1900-01-01')
				$sql	=	$sql." AND `PurchaseDate`<='$DateTo'";
			if($PurchaseNo > 0)
				$sql	=	$sql." AND `PurchaseNo`='$PurchaseNo'";
			if($SupplierID > 0)
				$sql	=	$sql." AND `SupplierID`='$SupplierID'";
			if($StoreID > 0)
				$sql	=	$sql." AND `StoreID`='$StoreID'";
			
			$sql			=	$sql." ORDER BY `FinYear` DESC, `PurchaseNo` DESC LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_purchase');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setPMotherAccountName( $this->getAccountNameByAccountID( $row->getPMotherAccountID()));
					$row->setPAccountName($this->getAccountNameByAccountID($row->getPAccountID()));
					$row->setSMotherAccountName( $this->getAccountNameByAccountID( $row->getSMotherAccountID()));
					$row->setSupplierName($this->getAccountNameByAccountID($row->getSupplierID()));
					$row->setJVAccountName($this->getAccountNameByAccountID($row->getJVAccountID()));
					$row->setJVMotherAccountName( $this->getAccountNameByAccountID( $row->getJVMotherAccountID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemList($this->getPurchaseItemList($row->getPurchaseID()));
					$row->setAddLessList($this->getPurchaseAddLessList($row->getPurchaseID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getPurchaseListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getPurchaseItemList($PurchaseID) {
			$PurchaseID	= (int)$PurchaseID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_purchase_items` WHERE `PurchaseID`='$PurchaseID' ORDER BY `SerialNo`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_purchase_items');
				while($row = $result->fetch()) {
					$row->setItemName($this->getItemNameByItemID($row->getItemID()));
					$row->setAccountName( $this->getAccountNameByAccountID( $row->getAccountID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getPurchaseItemList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getPurchaseAddLessList($PurchaseID) {
			$PurchaseID	= (int)$PurchaseID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_purchase_addless` WHERE `PurchaseID`='$PurchaseID' ORDER BY `SerialNo`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_purchase_addless');
				while($row = $result->fetch()) {
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getPurchaseAddLessList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function CreatePurchase($pcls) {
				
			$tuser	=	unserialize($_SESSION["ssEUser"]);
			$tcmp		= unserialize($_SESSION["ssECmp"]);
			$pdt		= $pcls->getPurchaseDate();
			$cmpid	= $pcls->getCompanyID();
			$finyr	= getFinancialYear($pdt);
			$pcls->setFinYear($finyr);
			$pcls->setPurchaseNo($this->getNextPurchaseNo($finyr, $cmpid));
			
			$narr		= 'PUR# '.$pcls->getPurchaseNo().'/'.$finyr.', '.$pcls->getSupplierBillNo().', '.$pcls->getNarration();
			

			try {
			
				$this->conn->beginTransaction();
				
				$pcls->setPurchaseID($this->getNextID("gen_purchase","PurchaseID"));
				$pid		= $pcls->getPurchaseID();
				
				$sql	= $pcls->getInsertSQL();
				$this->conn->exec($sql);
				
				$totQty		= 0;
				$xtraPerUnit	= 0;
				
				$itmList	= $pcls->getItemList();
				
				for($i=0;$i<count($itmList);$i++) {
					$icls		=	$itmList[$i];
					$totQty	= $totQty + $icls->getQuantity();
				}
				
				/*if($pcls->getAddLessTotal() != 0) {
					$altot				= $pcls->getAddLessTotal();
					if($pcls->getImport() == "YES")
						$altot			= $altot * $pcls->getConversion();
					$xtraPerUnit	= $altot / $totQty;
				}*/
				
				for($i=0;$i<count($itmList);$i++) {
					$icls	=	$itmList[$i];
					$icls->setPurchaseID($pid);
					$icls->setSerialNo($i+1);

					$sql		= $icls->getInsertSQL();
					$this->conn->exec($sql);
					
					/* Stock entries */
					
					if($tcmp->getStockEntry() == "PURCHASE" && $pcls->getStockEntry() == "YES") {
					
						$lcqty	= $this->getLastStockClosingQuantity($cmpid, $pcls->getStoreID(), $icls->getItemID(), $pdt);
						$lcval	= $this->getLastStockClosingValue($cmpid, $pcls->getStoreID(), $icls->getItemID(), $pdt);
						$lbald	= $this->getLastBalanceDetail($cmpid, $pcls->getStoreID(), $icls->getItemID(), $pdt);
						
						$iamt		= $icls->getTotalAmount() - ($icls->getIGST() + $icls->getSGST() + $icls->getCGST());
						if($pcls->getImport() == "YES")
							$iamt	= $iamt * $pcls->getConversion();						
					
						$cqty		= $lcqty + $icls->getQuantity();
						$cval		= $lcval + ($iamt + $xtraPerUnit);
						$bald		= $lbald;
						if($bald != "") $bald = $bald.",";
						$bald		= $bald.$icls->getQuantity()."=".($iamt/$icls->getQuantity() + $xtraPerUnit);
					
						$scls		= new asys_stock_voucher();
						$scls->setSVoucherID($this->getNextID("asys_stock_voucher","SVoucherID"));
						$scls->setCompanyID($pcls->getCompanyID());
						$scls->setStoreID($pcls->getStoreID());
						$scls->setModuleID(PURCHASE);
						$scls->setFinYear($pcls->getFinYear());
						$scls->setRelatedID($pid);
						$scls->setDOT($pcls->getPurchaseDate('yes'));
						$scls->setTOT(time());
						$scls->setItemID($icls->getItemID());
						$scls->setItemCategoryID($this->getItemCategoryByItemID($icls->getItemID()));
						$scls->setQuantity($icls->getQuantity());
						$scls->setUnitPrice($iamt/$icls->getQuantity() + $xtraPerUnit);
						$scls->setStockInOut(STOCK_IN);
						$scls->setClosingQty($cqty);
						$scls->setClosingValue($cval);						
						$scls->setBatchNo("");
						$scls->setNarration($narr);
						$scls->setBalanceDetail($bald);
					
						$sql		= $scls->getInsertSQL();
						$this->conn->exec($sql);
						
					}
					
					/* Stock entry ends here */
					
				}
				
				
				/* Voucher Entries */
				
				$vclsArr		= [];
				$VoucherNo	= $this->getMaxVoucherNo(PURCHASE_VOUCHER, $finyr, $cmpid);
				$DayWiseNo	= $this->getMaxDayWiseVoucherNo(PURCHASE_VOUCHER, $pdt, $cmpid);				
				
				if($pcls->getPAccountID() != 0)
					$aDet		= $this->getAccountDetail($pcls->getPAccountID());
				else
					$aDet		= $this->getAccountDetail($pcls->getPMotherAccountID());
					
				$pamt		= $pcls->getItemTotal() - ($pcls->getIGST() + $pcls->getSGST() + $pcls->getCGST());
				if($pcls->getImport() == "YES")
					$pamt	= $pamt * $pcls->getConversion();

				$vcls		=	new asys_voucher_entry();
				$vcls->setSerialID(1);
				$vcls->setCompanyID($pcls->getCompanyID());
				$vcls->setVoucherType(PURCHASE_VOUCHER);
				$vcls->setFinYear($finyr);
				$vcls->setVoucherNo($VoucherNo);
				$vcls->setDayWiseNo($DayWiseNo);
				$vcls->setDOV($pcls->getPurchaseDate('yes'));
				$vcls->setMotherAccount($aDet->getMotherAccount());
				$vcls->setAccountID($aDet->getAccountID());
				$vcls->setRelatedID($pid);
				$vcls->setTxnType(PURCHASE);
				$vcls->setDrCr(DEBIT);
				$vcls->setAmount($pamt);
				$vcls->setNarration($narr);
				$vcls->setUserID($tuser->getUserID());
				$vcls->setDOE(date('d-m-Y'));
			
				$vclsArr[] = $vcls;
				
				
				if($pcls->getSupplierID() != 0)
					$aDet		= $this->getAccountDetail($pcls->getSupplierID());
				else
					$aDet		= $this->getAccountDetail($pcls->getSMotherAccountID());
					
				$namt		= $pcls->getNetTotal();
				if($pcls->getImport() == "YES")
					$namt	= $namt * $pcls->getConversion();				
				
				$vcls		=	new asys_voucher_entry();
				$vcls->setSerialID(2);
				$vcls->setCompanyID($pcls->getCompanyID());
				$vcls->setVoucherType(PURCHASE_VOUCHER);
				$vcls->setFinYear($finyr);
				$vcls->setVoucherNo($VoucherNo);
				$vcls->setDayWiseNo($DayWiseNo);
				$vcls->setDOV($pcls->getPurchaseDate('yes'));
				$vcls->setMotherAccount($aDet->getMotherAccount());
				$vcls->setAccountID($aDet->getAccountID());
				$vcls->setRelatedID($pid);
				$vcls->setTxnType(PURCHASE);
				$vcls->setDrCr(CREDIT);
				$vcls->setAmount($namt);
				$vcls->setNarration($narr);
				$vcls->setUserID($tuser->getUserID());
				$vcls->setDOE(date('d-m-Y'));
			
				$vclsArr[] = $vcls;
				
				$kk		= 3;
				if($pcls->getIGST() > 0) {
					$aDet		= $this->getAccountDetail($tcmp->getIGSTAccountID());
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($kk++);
					$vcls->setCompanyID($cmpid);
					$vcls->setVoucherType(PURCHASE_VOUCHER);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($VoucherNo);
					$vcls->setDayWiseNo($DayWiseNo);
					$vcls->setDOV($pcls->getPurchaseDate('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($pid);
					$vcls->setTxnType(PURCHASE);
					$vcls->setDrCr(DEBIT);
					$vcls->setAmount($pcls->getIGST());
					$vcls->setNarration('IGST for '.$narr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
				}
				
				if($pcls->getCGST() > 0) {
					$aDet		= $this->getAccountDetail($tcmp->getCGSTAccountID());
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($kk++);
					$vcls->setCompanyID($cmpid);
					$vcls->setVoucherType(PURCHASE_VOUCHER);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($VoucherNo);
					$vcls->setDayWiseNo($DayWiseNo);
					$vcls->setDOV($pcls->getPurchaseDate('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($pid);
					$vcls->setTxnType(PURCHASE);
					$vcls->setDrCr(DEBIT);
					$vcls->setAmount($pcls->getCGST());
					$vcls->setNarration('CGST for '.$narr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
				}
				
				if($pcls->getSGST() > 0) {
					$aDet			= $this->getAccountDetail($tcmp->getSGSTAccountID());
					if($pcls->getSupplierID() != 0)
						$sdet		= $this->getAccountDetail($pcls->getSupplierID());
					else
						$sdet		= $this->getAccountDetail($pcls->getSMotherAccountID());
					
					if($this->getUTByState($sdet->getState()) == "YES")
						$aDet		= $this->getAccountDetail($tcmp->getUGSTAccountID());
						
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($kk++);
					$vcls->setCompanyID($cmpid);
					$vcls->setVoucherType(PURCHASE_VOUCHER);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($VoucherNo);
					$vcls->setDayWiseNo($DayWiseNo);
					$vcls->setDOV($pcls->getPurchaseDate('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($pid);
					$vcls->setTxnType(PURCHASE);
					$vcls->setDrCr(DEBIT);
					$vcls->setAmount($pcls->getSGST());
					$vcls->setNarration('SGST for '.$narr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
				}
				
				$alList	= $pcls->getAddLessList();
				for($i=0;$i<count($alList);$i++) {
					$acls	=	$alList[$i];
					$acls->setPurchaseID($pid);
					$acls->setSerialNo($i+1);
					
					$amt		= $acls->getAmount();
					if($pcls->getImport() == "YES")
						$amt	= $amt * $pcls->getConversion();

					$sql		= $acls->getInsertSQL();
					$this->conn->exec($sql);
					
					
					$aDet		= $this->getAccountDetail($acls->getAccountID());
					
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($kk++);
					$vcls->setCompanyID($cmpid);
					$vcls->setVoucherType(PURCHASE_VOUCHER);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($VoucherNo);
					$vcls->setDayWiseNo($DayWiseNo);
					$vcls->setDOV($pcls->getPurchaseDate('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($pid);
					$vcls->setTxnType(PURCHASE);
					if($acls->getAddLess() == 'ADD')
						$vcls->setDrCr(DEBIT);
					else
						$vcls->setDrCr(CREDIT);
					$vcls->setAmount($amt);
					$vcls->setNarration('PUR# '.$pcls->getPurchaseNo().'/'.$finyr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
					
				}
				
				$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
				for($ii=0; $ii<count($vclsArr); $ii++) {
					$vcls		= $vclsArr[$ii];
					$vcls->setVoucherID($vid);
					$this->conn->exec($vcls->getInsertSQL());					
				}
				
				/* Voucher Entry ends here */
				
				if($tcmp->getStockEntry() == "PURCHASE" && $pcls->getStockEntry() == "YES") {
					/* Voucher entry for Store */
				
					$VoucherNo	= $this->getMaxVoucherNo(JOURNAL_VOUCHER, $finyr, $cmpid);
					$DayWiseNo	= $this->getMaxDayWiseVoucherNo(JOURNAL_VOUCHER, $pdt, $cmpid);
				
					$storeDet		= $this->getStoreDetail($pcls->getStoreID());
					if($storeDet->getAccountID() != 0)
						$aDet		= $this->getAccountDetail($storeDet->getAccountID());
					else
						$aDet		= $this->getAccountDetail($storeDet->getMotherAccountID());				
				
					$pamt		= $pcls->getItemTotal() - ($pcls->getIGST() + $pcls->getSGST() + $pcls->getCGST());
					if($pcls->getImport() == "YES")
						$pamt	= $pamt * $pcls->getConversion();

					$vcls1		=	new asys_voucher_entry();
					$vcls1->setSerialID(1);
					$vcls1->setCompanyID($pcls->getCompanyID());
					$vcls1->setVoucherType(JOURNAL_VOUCHER);
					$vcls1->setFinYear($finyr);
					$vcls1->setVoucherNo($VoucherNo);
					$vcls1->setDayWiseNo($DayWiseNo);
					$vcls1->setDOV($pcls->getPurchaseDate('yes'));
					$vcls1->setMotherAccount($aDet->getMotherAccount());
					$vcls1->setAccountID($aDet->getAccountID());
					$vcls1->setRelatedID($pid);
					$vcls1->setTxnType(PURCHASE);
					$vcls1->setDrCr(DEBIT);
					$vcls1->setAmount($pamt);
					$vcls1->setNarration($narr);
					$vcls1->setUserID($tuser->getUserID());
					$vcls1->setDOE(date('d-m-Y'));
				
				
					$aDet		= $this->getAccountDetail($storeDet->getOppositeAccountID());
				
					$vcls2		=	new asys_voucher_entry();
					$vcls2->setSerialID(2);
					$vcls2->setCompanyID($pcls->getCompanyID());
					$vcls2->setVoucherType(JOURNAL_VOUCHER);
					$vcls2->setFinYear($finyr);
					$vcls2->setVoucherNo($VoucherNo);
					$vcls2->setDayWiseNo($DayWiseNo);
					$vcls2->setDOV($pcls->getPurchaseDate('yes'));
					$vcls2->setMotherAccount($aDet->getMotherAccount());
					$vcls2->setAccountID($aDet->getAccountID());
					$vcls2->setRelatedID($pid);
					$vcls2->setTxnType(PURCHASE);
					$vcls2->setDrCr(CREDIT);
					$vcls2->setAmount($pamt);
					$vcls2->setNarration($narr);
					$vcls2->setUserID($tuser->getUserID());
					$vcls2->setDOE(date('d-m-Y'));
			
					$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
					$vcls1->setVoucherID($vid);
					$vcls2->setVoucherID($vid);
					$this->conn->exec($vcls1->getInsertSQL());
					$this->conn->exec($vcls2->getInsertSQL());							
				
					/* Voucher entry for Store ends here */
				}
				
				/* Journal voucher entry */
				
				if($pcls->getJVAmount() > 0) {
				
					$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
					$VoucherNo	= $this->getMaxVoucherNo(JOURNAL_VOUCHER, $finyr, $cmpid);
					$DayWiseNo	= $this->getMaxDayWiseVoucherNo(JOURNAL_VOUCHER, $pdt, $cmpid);				
				
					$aDet		= $this->getAccountDetail($pcls->getJVAccountID());
				
					$vcls1		=	new asys_voucher_entry();
					$vcls1->setVoucherID($vid);
					$vcls1->setSerialID(1);
					$vcls1->setCompanyID($cmpid);
					$vcls1->setVoucherType(JOURNAL_VOUCHER);
					$vcls1->setFinYear($finyr);
					$vcls1->setVoucherNo($VoucherNo);
					$vcls1->setDayWiseNo($DayWiseNo);
					$vcls1->setDOV($pcls->getPurchaseDate('yes'));
					$vcls1->setMotherAccount($aDet->getMotherAccount());
					$vcls1->setAccountID($aDet->getAccountID());
					$vcls1->setRelatedID($pid);
					$vcls1->setTxnType(PURCHASE);
					if($pcls->getJVAddLess() == 'ADD')
						$vcls->setDrCr(DEBIT);
					else
						$vcls->setDrCr(CREDIT);
					$vcls1->setAmount($pcls->getJVAmount());
					$vcls1->setNarration($narr);
					$vcls1->setUserID($tuser->getUserID());
					$vcls1->setDOE(date('d-m-Y'));
					
					$this->conn->exec($vcls1->getInsertSQL());
		
					if($pcls->getSupplierID() != 0)
						$aDet		= $this->getAccountDetail($pcls->getSupplierID());
					else
						$aDet		= $this->getAccountDetail($pcls->getSMotherAccountID());
				
					$vcls2		=	new asys_voucher_entry();
					$vcls2->setVoucherID($vid);
					$vcls2->setSerialID(2);
					$vcls2->setCompanyID($cmpid);
					$vcls2->setVoucherType(JOURNAL_VOUCHER);
					$vcls2->setFinYear($finyr);
					$vcls2->setVoucherNo($VoucherNo);
					$vcls2->setDayWiseNo($DayWiseNo);
					$vcls2->setDOV($pcls->getPurchaseDate('yes'));
					$vcls2->setMotherAccount($aDet->getMotherAccount());
					$vcls2->setAccountID($aDet->getAccountID());
					$vcls2->setRelatedID($pid);
					$vcls2->setTxnType(PURCHASE);
					if($pcls->getJVAddLess() == 'ADD')
						$vcls->setDrCr(CREDIT);
					else
						$vcls->setDrCr(DEBIT);
					$vcls2->setAmount($pcls->getJVAmount());
					$vcls2->setNarration($narr);
					$vcls2->setUserID($tuser->getUserID());
					$vcls2->setDOE(date('d-m-Y'));
					
					$this->conn->exec($vcls2->getInsertSQL());
			
				}
				
				/* Journal voucher posting ends here */					
				
				/* TDS related voucher entry */
				
				if($pcls->getTDSAmount() > 0) {
				
					$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
					$VoucherNo	= $this->getMaxVoucherNo(JOURNAL_VOUCHER, $finyr, $cmpid);
					$DayWiseNo	= $this->getMaxDayWiseVoucherNo(JOURNAL_VOUCHER, $pdt, $cmpid);				
				
					$aDet		= $this->getAccountDetail($pcls->getTDSAccount());
				
					$vcls1		=	new asys_voucher_entry();
					$vcls1->setVoucherID($vid);
					$vcls1->setSerialID(1);
					$vcls1->setCompanyID($cmpid);
					$vcls1->setVoucherType(JOURNAL_VOUCHER);
					$vcls1->setFinYear($finyr);
					$vcls1->setVoucherNo($VoucherNo);
					$vcls1->setDayWiseNo($DayWiseNo);
					$vcls1->setDOV($pcls->getPurchaseDate('yes'));
					$vcls1->setMotherAccount($aDet->getMotherAccount());
					$vcls1->setAccountID($aDet->getAccountID());
					$vcls1->setRelatedID($pid);
					$vcls1->setTxnType(PURCHASE);
					$vcls1->setDrCr(CREDIT);
					$vcls1->setAmount($pcls->getTDSAmount());
					$vcls1->setNarration($narr);
					$vcls1->setUserID($tuser->getUserID());
					$vcls1->setDOE(date('d-m-Y'));
					
					$this->conn->exec($vcls1->getInsertSQL());
		
					if($pcls->getSupplierID() != 0)
						$aDet		= $this->getAccountDetail($pcls->getSupplierID());
					else
						$aDet		= $this->getAccountDetail($pcls->getSMotherAccountID());
				
					$vcls2		=	new asys_voucher_entry();
					$vcls2->setVoucherID($vid);
					$vcls2->setSerialID(2);
					$vcls2->setCompanyID($cmpid);
					$vcls2->setVoucherType(JOURNAL_VOUCHER);
					$vcls2->setFinYear($finyr);
					$vcls2->setVoucherNo($VoucherNo);
					$vcls2->setDayWiseNo($DayWiseNo);
					$vcls2->setDOV($pcls->getPurchaseDate('yes'));
					$vcls2->setMotherAccount($aDet->getMotherAccount());
					$vcls2->setAccountID($aDet->getAccountID());
					$vcls2->setRelatedID($pid);
					$vcls2->setTxnType(PURCHASE);
					$vcls2->setDrCr(DEBIT);
					$vcls2->setAmount($pcls->getTDSAmount());
					$vcls2->setNarration($narr);
					$vcls2->setUserID($tuser->getUserID());
					$vcls2->setDOE(date('d-m-Y'));
					
					$this->conn->exec($vcls2->getInsertSQL());
			
				}				
				
				/* TDS voucher posting ends here */
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'purchasedb CreatePurchase '.$er->getMessage();
				_errorLog($err);
				$pid	= -1;
				
			}


			return $pid;
			
		}
		
		function deletePurchase($pcls) {
		
			$pkey				= $pcls->getPurchaseID();
			$cmpid			= $pcls->getCompanyID();
			$ret				= true;
		

			try {
			
				$this->conn->beginTransaction();
				
				$this->conn->exec("DELETE FROM `gen_purchase_addless` WHERE `PurchaseID`='$pkey'");
				$this->conn->exec("DELETE FROM `gen_purchase_items` WHERE `PurchaseID`='$pkey'");
				$this->conn->exec("DELETE FROM `asys_voucher_entry` WHERE `RelatedID`='$pkey' AND `TxnType`='".PURCHASE."' AND `CompanyID`='".$cmpid."'");
				$this->conn->exec("DELETE FROM `asys_stock_voucher` WHERE `RelatedID`='$pkey' AND `ModuleID`='".PURCHASE."' AND `CompanyID`='".$cmpid."'");
				
				$sql	= $pcls->getDeleteSQL();
				$this->conn->exec($sql);
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				$err	= 'purchasedb deletePurchase (line 1014) '.$er->getMessage();
				_errorLog($err);
				$ret	= false;
				$this->conn->rollBack();
				
			}
		
			return $ret;

		}
		
		function getPurchaseDateByPurchaseID($PurchaseID) {
			$PurchaseID	= (int)$PurchaseID;
			$sql	= "SELECT `PurchaseDate` FROM `gen_purchase` WHERE `PurchaseID`='".$PurchaseID."'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function UpdatePurchase($pcls) {
				
			$tuser	=	unserialize($_SESSION["ssEUser"]);
			$tcmp		= unserialize($_SESSION["ssECmp"]);
			$pid		= $pcls->getPurchaseID();
			$pdt		= $pcls->getPurchaseDate();
			$cmpid	= $pcls->getCompanyID();
			$finyr	= getFinancialYear($pdt);
			
			$narr		= 'PUR# '.$pcls->getPurchaseNo().'/'.$finyr.', '.$pcls->getSupplierBillNo().', '.$pcls->getNarration();
			
			$vno		= $this->getVoucherNoByRelatedID(PURCHASE_VOUCHER, PURCHASE, $pid, $cmpid);
			if($pdt == $this->getPurchaseDateByPurchaseID($pid))
				$dwn	= $this->getDayWiseNoByRelatedID(PURCHASE_VOUCHER, PURCHASE, $pid, $cmpid);
			else
				$dwn	= $this->getMaxDayWiseVoucherNo(PURCHASE_VOUCHER, $pdt, $cmpid);
			
			
			try {
			
				$this->conn->beginTransaction();
				
				$delsql1	= "DELETE FROM `gen_purchase_addless` WHERE `PurchaseID`='$pid'";
				$delsql2	= "DELETE FROM `gen_purchase_items` WHERE `PurchaseID`='$pid'";
				$this->conn->exec($delsql1);
				$this->conn->exec($delsql2);				
				
				$delsql3	= "DELETE FROM `asys_voucher_entry` WHERE `RelatedID`='$pid' AND `TxnType`='".PURCHASE."' AND `CompanyID`='".$cmpid."'";
				$this->conn->exec($delsql3);
				$delsql4	= "DELETE FROM `asys_stock_voucher` WHERE `RelatedID`='$pid' AND `ModuleID`='".PURCHASE."' AND `CompanyID`='".$cmpid."'";
				
				$stkcls		= array();
				

				$totQty		= 0;
				$xtraPerUnit	= 0;
				
				$itmList	= $pcls->getItemList();
				
				for($i=0;$i<count($itmList);$i++) {
					$icls		=	$itmList[$i];
					$totQty	= $totQty + $icls->getQuantity();
				}
				
				/*if($pcls->getAddLessTotal() != 0) {
					$altot				= $pcls->getAddLessTotal();
					if($pcls->getImport() == "YES")
						$altot			= $altot * $pcls->getConversion();
					$xtraPerUnit	= $altot / $totQty;
				}*/
				
				for($i=0;$i<count($itmList);$i++) {
					$icls	=	$itmList[$i];
					$icls->setPurchaseID($pid);
					$icls->setSerialNo($i+1);

					$sql		= $icls->getInsertSQL();
					$this->conn->exec($sql);
					
					/* Stock entries */
					
					if($tcmp->getStockEntry() == "PURCHASE" && $pcls->getStockEntry() == "YES") {
					
						$lcqty	= $this->getLastStockClosingQuantityForUpdate($cmpid, $pcls->getStoreID(), $icls->getItemID(), $pdt, PURCHASE, $pid);
						$lcval	= $this->getLastStockClosingValueForUpdate($cmpid, $pcls->getStoreID(), $icls->getItemID(), $pdt, PURCHASE, $pid);
						$lbald	= $this->getLastBalanceDetailForUpdate($cmpid, $pcls->getStoreID(), $icls->getItemID(), $pdt, PURCHASE, $pid);
						
						$iamt		= $icls->getTotalAmount() - ($icls->getIGST() + $icls->getSGST() + $icls->getCGST());
						if($pcls->getImport() == "YES")
							$iamt	= $iamt * $pcls->getConversion();						
					
						$cqty		= $lcqty + $icls->getQuantity();
						$cval		= $lcval + ($iamt + $xtraPerUnit);
						$bald		= $lbald;
						if($bald != "") $bald = $bald.",";
						$bald		= $bald.$icls->getQuantity()."=".($iamt/$icls->getQuantity() + $xtraPerUnit);						
					
						$scls		= new asys_stock_voucher();
						$scls->setCompanyID($pcls->getCompanyID());
						$scls->setStoreID($pcls->getStoreID());
						$scls->setModuleID(PURCHASE);
						$scls->setFinYear($pcls->getFinYear());
						$scls->setRelatedID($pid);
						$scls->setDOT($pcls->getPurchaseDate('yes'));
						$scls->setTOT(time());
						$scls->setItemID($icls->getItemID());
						$scls->setItemCategoryID($this->getItemCategoryByItemID($icls->getItemID()));
						$scls->setQuantity($icls->getQuantity());
						$scls->setUnitPrice($iamt/$icls->getQuantity() + $xtraPerUnit);
						$scls->setStockInOut(STOCK_IN);
						$scls->setClosingQty($cqty);
						$scls->setClosingValue($cval);						
						$scls->setBatchNo("");
						$scls->setNarration($narr);
						$scls->setBalanceDetail($bald);
					
						$stkcls[]	= $scls;
						
					}
					
					/* Stock entry ends here */
									
				}
				
				$this->conn->exec($delsql4);
				if($tcmp->getStockEntry() == "PURCHASE" && $pcls->getStockEntry() == "YES") {
					for($i=0;$i<count($stkcls);$i++) {
						$scls		= $stkcls[$i];
						$scls->setSVoucherID($this->getNextID("asys_stock_voucher","SVoucherID"));
						$this->conn->exec($scls->getInsertSQL());
					}
				}
				
				
				$sql	= $pcls->getUpdateSQL();
				$this->conn->exec($sql);
				
				/* Voucher Entries */
				
				$vclsArr		= [];
				
				if($pcls->getPAccountID() != 0)
					$aDet		= $this->getAccountDetail($pcls->getPAccountID());
				else
					$aDet		= $this->getAccountDetail($pcls->getPMotherAccountID());
					
				$pamt		= $pcls->getItemTotal() - ($pcls->getIGST() + $pcls->getSGST() + $pcls->getCGST());
				if($pcls->getImport() == "YES")
					$pamt	= $pamt * $pcls->getConversion();

				$vcls		=	new asys_voucher_entry();
				$vcls->setSerialID(1);
				$vcls->setCompanyID($pcls->getCompanyID());
				$vcls->setVoucherType(PURCHASE_VOUCHER);
				$vcls->setFinYear($finyr);
				$vcls->setVoucherNo($vno);
				$vcls->setDayWiseNo($dwn);
				$vcls->setDOV($pcls->getPurchaseDate('yes'));
				$vcls->setMotherAccount($aDet->getMotherAccount());
				$vcls->setAccountID($aDet->getAccountID());
				$vcls->setRelatedID($pid);
				$vcls->setTxnType(PURCHASE);
				$vcls->setDrCr(DEBIT);
				$vcls->setAmount($pamt);
				$vcls->setNarration($narr);
				$vcls->setUserID($tuser->getUserID());
				$vcls->setDOE(date('d-m-Y'));
			
				$vclsArr[] = $vcls;

				if($pcls->getSupplierID() != 0)
					$aDet		= $this->getAccountDetail($pcls->getSupplierID());
				else
					$aDet		= $this->getAccountDetail($pcls->getSMotherAccountID());
					
				$namt		= $pcls->getNetTotal();
				if($pcls->getImport() == "YES")
					$namt	= $namt * $pcls->getConversion();					
				
				$vcls		=	new asys_voucher_entry();
				$vcls->setSerialID(2);
				$vcls->setCompanyID($pcls->getCompanyID());
				$vcls->setVoucherType(PURCHASE_VOUCHER);
				$vcls->setFinYear($finyr);
				$vcls->setVoucherNo($vno);
				$vcls->setDayWiseNo($dwn);
				$vcls->setDOV($pcls->getPurchaseDate('yes'));
				$vcls->setMotherAccount($aDet->getMotherAccount());
				$vcls->setAccountID($aDet->getAccountID());
				$vcls->setRelatedID($pid);
				$vcls->setTxnType(PURCHASE);
				$vcls->setDrCr(CREDIT);
				$vcls->setAmount($namt);
				$vcls->setNarration($narr);
				$vcls->setUserID($tuser->getUserID());
				$vcls->setDOE(date('d-m-Y'));
			
				$vclsArr[] = $vcls;
				
				
				$kk		= 3;
				if($pcls->getIGST() > 0) {
					$aDet		= $this->getAccountDetail($tcmp->getIGSTAccountID());
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($kk++);
					$vcls->setCompanyID($cmpid);
					$vcls->setVoucherType(PURCHASE_VOUCHER);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($vno);
					$vcls->setDayWiseNo($dwn);
					$vcls->setDOV($pcls->getPurchaseDate('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($pid);
					$vcls->setTxnType(PURCHASE);
					$vcls->setDrCr(DEBIT);
					$vcls->setAmount($pcls->getIGST());
					$vcls->setNarration('IGST for '.$narr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
				}
				
				if($pcls->getCGST() > 0) {
					$aDet		= $this->getAccountDetail($tcmp->getCGSTAccountID());
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($kk++);
					$vcls->setCompanyID($cmpid);
					$vcls->setVoucherType(PURCHASE_VOUCHER);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($vno);
					$vcls->setDayWiseNo($dwn);
					$vcls->setDOV($pcls->getPurchaseDate('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($pid);
					$vcls->setTxnType(PURCHASE);
					$vcls->setDrCr(DEBIT);
					$vcls->setAmount($pcls->getCGST());
					$vcls->setNarration('CGST for '.$narr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
				}
				
				if($pcls->getSGST() > 0) {
					$aDet			= $this->getAccountDetail($tcmp->getSGSTAccountID());
					if($pcls->getSupplierID() != 0)
						$sdet		= $this->getAccountDetail($pcls->getSupplierID());
					else
						$sdet		= $this->getAccountDetail($pcls->getSMotherAccountID());
					
					if($this->getUTByState($sdet->getState()) == "YES")
						$aDet		= $this->getAccountDetail($tcmp->getUGSTAccountID());
					
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($kk++);
					$vcls->setCompanyID($cmpid);
					$vcls->setVoucherType(PURCHASE_VOUCHER);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($vno);
					$vcls->setDayWiseNo($dwn);
					$vcls->setDOV($pcls->getPurchaseDate('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($pid);
					$vcls->setTxnType(PURCHASE);
					$vcls->setDrCr(DEBIT);
					$vcls->setAmount($pcls->getSGST());
					$vcls->setNarration('SGST for '.$narr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
				}
				
				$alList	= $pcls->getAddLessList();
				for($i=0;$i<count($alList);$i++) {
					$acls	=	$alList[$i];
					$acls->setPurchaseID($pid);
					$acls->setSerialNo($i+1);
					
					$amt		= $acls->getAmount();
					if($pcls->getImport() == "YES")
						$amt	= $amt * $pcls->getConversion();

					$sql		= $acls->getInsertSQL();
					$this->conn->exec($sql);
					
					
					$aDet		= $this->getAccountDetail($acls->getAccountID());
					
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($kk++);
					$vcls->setCompanyID($cmpid);
					$vcls->setVoucherType(PURCHASE_VOUCHER);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($VoucherNo);
					$vcls->setDayWiseNo($DayWiseNo);
					$vcls->setDOV($pcls->getPurchaseDate('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($pid);
					$vcls->setTxnType(PURCHASE);
					if($acls->getAddLess() == 'ADD')
						$vcls->setDrCr(DEBIT);
					else
						$vcls->setDrCr(CREDIT);
					$vcls->setAmount($amt);
					$vcls->setNarration('PUR# '.$pcls->getPurchaseNo().'/'.$finyr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
					
					$vclsArr[] = $vcls;
					
				}
				
				$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
				for($ii=0; $ii<count($vclsArr); $ii++) {
					$vcls		= $vclsArr[$ii];
					$vcls->setVoucherID($vid);
					$this->conn->exec($vcls->getInsertSQL());					
				}				
				
				/* Voucher entry ends here */
				
				
				if($tcmp->getStockEntry() == "PURCHASE" && $pcls->getStockEntry() == "YES") {
					/* Voucher entry for Store */
				
					$VoucherNo	= $this->getMaxVoucherNo(JOURNAL_VOUCHER, $finyr, $cmpid);
					$DayWiseNo	= $this->getMaxDayWiseVoucherNo(JOURNAL_VOUCHER, $pdt, $cmpid);
				
					$storeDet		= $this->getStoreDetail($pcls->getStoreID());
					if($storeDet->getAccountID() != 0)
						$aDet		= $this->getAccountDetail($storeDet->getAccountID());
					else
						$aDet		= $this->getAccountDetail($storeDet->getMotherAccountID());				
				
					$pamt		= $pcls->getItemTotal() - ($pcls->getIGST() + $pcls->getSGST() + $pcls->getCGST());
					if($pcls->getImport() == "YES")
						$pamt	= $pamt * $pcls->getConversion();

					$vcls1		=	new asys_voucher_entry();
					$vcls1->setSerialID(1);
					$vcls1->setCompanyID($pcls->getCompanyID());
					$vcls1->setVoucherType(JOURNAL_VOUCHER);
					$vcls1->setFinYear($finyr);
					$vcls1->setVoucherNo($VoucherNo);
					$vcls1->setDayWiseNo($DayWiseNo);
					$vcls1->setDOV($pcls->getPurchaseDate('yes'));
					$vcls1->setMotherAccount($aDet->getMotherAccount());
					$vcls1->setAccountID($aDet->getAccountID());
					$vcls1->setRelatedID($pid);
					$vcls1->setTxnType(PURCHASE);
					$vcls1->setDrCr(DEBIT);
					$vcls1->setAmount($pamt);
					$vcls1->setNarration($narr);
					$vcls1->setUserID($tuser->getUserID());
					$vcls1->setDOE(date('d-m-Y'));
				
				
					$aDet		= $this->getAccountDetail($storeDet->getOppositeAccountID());
				
					$vcls2		=	new asys_voucher_entry();
					$vcls2->setSerialID(2);
					$vcls2->setCompanyID($pcls->getCompanyID());
					$vcls2->setVoucherType(JOURNAL_VOUCHER);
					$vcls2->setFinYear($finyr);
					$vcls2->setVoucherNo($VoucherNo);
					$vcls2->setDayWiseNo($DayWiseNo);
					$vcls2->setDOV($pcls->getPurchaseDate('yes'));
					$vcls2->setMotherAccount($aDet->getMotherAccount());
					$vcls2->setAccountID($aDet->getAccountID());
					$vcls2->setRelatedID($pid);
					$vcls2->setTxnType(PURCHASE);
					$vcls2->setDrCr(CREDIT);
					$vcls2->setAmount($pamt);
					$vcls2->setNarration($narr);
					$vcls2->setUserID($tuser->getUserID());
					$vcls2->setDOE(date('d-m-Y'));
			
					$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
					$vcls1->setVoucherID($vid);
					$vcls2->setVoucherID($vid);
					$this->conn->exec($vcls1->getInsertSQL());
					$this->conn->exec($vcls2->getInsertSQL());								
				
					/* Voucher entry for Store ends here */
				}
				
				
				/* Journal voucher entry */
				
				if($pcls->getJVAmount() > 0) {
				
					$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
					$VoucherNo	= $this->getMaxVoucherNo(JOURNAL_VOUCHER, $finyr, $cmpid);
					$DayWiseNo	= $this->getMaxDayWiseVoucherNo(JOURNAL_VOUCHER, $pdt, $cmpid);				
				
					$aDet		= $this->getAccountDetail($pcls->getJVAccountID());
				
					$vcls1		=	new asys_voucher_entry();
					$vcls1->setVoucherID($vid);
					$vcls1->setSerialID(1);
					$vcls1->setCompanyID($cmpid);
					$vcls1->setVoucherType(JOURNAL_VOUCHER);
					$vcls1->setFinYear($finyr);
					$vcls1->setVoucherNo($VoucherNo);
					$vcls1->setDayWiseNo($DayWiseNo);
					$vcls1->setDOV($pcls->getPurchaseDate('yes'));
					$vcls1->setMotherAccount($aDet->getMotherAccount());
					$vcls1->setAccountID($aDet->getAccountID());
					$vcls1->setRelatedID($pid);
					$vcls1->setTxnType(PURCHASE);
					if($pcls->getJVAddLess() == 'ADD')
						$vcls->setDrCr(DEBIT);
					else
						$vcls->setDrCr(CREDIT);
					$vcls1->setAmount($pcls->getJVAmount());
					$vcls1->setNarration($narr);
					$vcls1->setUserID($tuser->getUserID());
					$vcls1->setDOE(date('d-m-Y'));
					
					$this->conn->exec($vcls1->getInsertSQL());
		
					if($pcls->getSupplierID() != 0)
						$aDet		= $this->getAccountDetail($pcls->getSupplierID());
					else
						$aDet		= $this->getAccountDetail($pcls->getSMotherAccountID());
				
					$vcls2		=	new asys_voucher_entry();
					$vcls2->setVoucherID($vid);
					$vcls2->setSerialID(2);
					$vcls2->setCompanyID($cmpid);
					$vcls2->setVoucherType(JOURNAL_VOUCHER);
					$vcls2->setFinYear($finyr);
					$vcls2->setVoucherNo($VoucherNo);
					$vcls2->setDayWiseNo($DayWiseNo);
					$vcls2->setDOV($pcls->getPurchaseDate('yes'));
					$vcls2->setMotherAccount($aDet->getMotherAccount());
					$vcls2->setAccountID($aDet->getAccountID());
					$vcls2->setRelatedID($pid);
					$vcls2->setTxnType(PURCHASE);
					if($pcls->getJVAddLess() == 'ADD')
						$vcls->setDrCr(CREDIT);
					else
						$vcls->setDrCr(DEBIT);
					$vcls2->setAmount($pcls->getJVAmount());
					$vcls2->setNarration($narr);
					$vcls2->setUserID($tuser->getUserID());
					$vcls2->setDOE(date('d-m-Y'));
					
					$this->conn->exec($vcls2->getInsertSQL());
			
				}
				
				/* Journal voucher posting ends here */	
				
				
				/* TDS related voucher entry */
				
				if($pcls->getTDSAmount() > 0) {
				
					$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
					$VoucherNo	= $this->getMaxVoucherNo(JOURNAL_VOUCHER, $finyr, $cmpid);
					$DayWiseNo	= $this->getMaxDayWiseVoucherNo(JOURNAL_VOUCHER, $pdt, $cmpid);				
				
					$aDet		= $this->getAccountDetail($pcls->getTDSAccount());
				
					$vcls1		=	new asys_voucher_entry();
					$vcls1->setVoucherID($vid);
					$vcls1->setSerialID(1);
					$vcls1->setCompanyID($cmpid);
					$vcls1->setVoucherType(JOURNAL_VOUCHER);
					$vcls1->setFinYear($finyr);
					$vcls1->setVoucherNo($VoucherNo);
					$vcls1->setDayWiseNo($DayWiseNo);
					$vcls1->setDOV($pcls->getPurchaseDate('yes'));
					$vcls1->setMotherAccount($aDet->getMotherAccount());
					$vcls1->setAccountID($aDet->getAccountID());
					$vcls1->setRelatedID($pid);
					$vcls1->setTxnType(PURCHASE);
					$vcls1->setDrCr(CREDIT);
					$vcls1->setAmount($pcls->getTDSAmount());
					$vcls1->setNarration($narr);
					$vcls1->setUserID($tuser->getUserID());
					$vcls1->setDOE(date('d-m-Y'));
					
					$this->conn->exec($vcls1->getInsertSQL());
		
					if($pcls->getSupplierID() != 0)
						$aDet		= $this->getAccountDetail($pcls->getSupplierID());
					else
						$aDet		= $this->getAccountDetail($pcls->getSMotherAccountID());
				
					$vcls2		=	new asys_voucher_entry();
					$vcls2->setVoucherID($vid);
					$vcls2->setSerialID(2);
					$vcls2->setCompanyID($cmpid);
					$vcls2->setVoucherType(JOURNAL_VOUCHER);
					$vcls2->setFinYear($finyr);
					$vcls2->setVoucherNo($VoucherNo);
					$vcls2->setDayWiseNo($DayWiseNo);
					$vcls2->setDOV($pcls->getPurchaseDate('yes'));
					$vcls2->setMotherAccount($aDet->getMotherAccount());
					$vcls2->setAccountID($aDet->getAccountID());
					$vcls2->setRelatedID($pid);
					$vcls2->setTxnType(PURCHASE);
					$vcls2->setDrCr(DEBIT);
					$vcls2->setAmount($pcls->getTDSAmount());
					$vcls2->setNarration($narr);
					$vcls2->setUserID($tuser->getUserID());
					$vcls2->setDOE(date('d-m-Y'));
					
					$this->conn->exec($vcls2->getInsertSQL());
			
				}				
				
				/* TDS voucher posting ends here */				
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'purchasedb UpdatePurchase '.$er->getMessage();
				_errorLog($err);
				$pid	= -1;
				
			}


			return $pid;
			
		}
		
		
		
		/*---------------------------------------------------------------------*/
		/*********************** PURCHASE RETURN METHODS ***********************/
		
		function getNextPurchaseReturnNo($FinYear, $CompanyID) {
			if(strpos($FinYear, "'") !== false) return false;
			$CompanyID	= (int)$CompanyID;
			
			$maxid			=	0;
			$sql				=	"SELECT MAX(`ReturnNo`) FROM `gen_purchasereturn` WHERE `FinYear`='$FinYear' AND `CompanyID`='$CompanyID'";

			try {
				
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch())
					$maxid 	= $row[0];
					
			} catch(PDOException $e) {
				$err	= 'purchasedb getNextPurchaseReturnNo '.$e->getMessage();
				_errorLog($err);
			}

			$maxid++;
			return $maxid;
		}

		function getPurchaseReturnDetail($ReturnID) {
			$ReturnID		= (int)$ReturnID;
			$cclass			=	new gen_purchasereturn();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_purchasereturn` WHERE `ReturnID`='$ReturnID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_purchasereturn');
				if($row 	= $result->fetch()) { 
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setPMotherAccountName( $this->getAccountNameByAccountID( $row->getPMotherAccountID()));
					$row->setPAccountName($this->getAccountNameByAccountID($row->getPAccountID()));
					$row->setSupplierName($this->getAccountNameByAccountID($row->getSupplierID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemList($this->getPurchaseReturnItemList($row->getReturnID()));
					$row->setAddLessList($this->getPurchaseReturnAddLessList($row->getReturnID()));
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getPurchaseReturnDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getPurchaseReturnList($CompanyID) {
			$arr				=	array();
			$CompanyID	= (int)$CompanyID;
			
			try {
				
				$sql			=	"SELECT * FROM `gen_purchasereturn` WHERE `CompanyID`='$CompanyID' ORDER BY `ReturnNo`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_purchasereturn');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setPMotherAccountName( $this->getAccountNameByAccountID( $row->getPMotherAccountID()));
					$row->setPAccountName($this->getAccountNameByAccountID($row->getPAccountID()));
					$row->setSupplierName($this->getAccountNameByAccountID($row->getSupplierID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemList($this->getPurchaseReturnItemList($row->getReturnID()));
					$row->setAddLessList($this->getPurchaseReturnAddLessList($row->getReturnID()));
					$arr[]	= $row;
				}

			} catch(PDOException $e) {
				$err	= 'purchasedb getPurchaseReturnList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getNumberOfPurchaseReturn($DateFrom, $DateTo, $ReturnNo, $SupplierID, $CompanyID) {
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$ReturnNo		= (int)$ReturnNo;
			$SupplierID	= (int)$SupplierID;
			$CompanyID	= (int)$CompanyID;
		
			$sql	=	"SELECT COUNT(*) FROM `gen_purchasereturn` WHERE `CompanyID`='$CompanyID'";
			if($DateFrom != '1900-01-01')
				$sql	=	$sql." AND `ReturnDate`>='$DateFrom'";
			if($DateTo != '1900-01-01')
				$sql	=	$sql." AND `ReturnDate`<='$DateTo'";
			if($ReturnNo > 0)
				$sql	=	$sql." AND `ReturnNo`='$ReturnNo'";
			if($SupplierID > 0)
				$sql	=	$sql." AND `SupplierID`='$SupplierID'";
			
			return $this->getResultExecutingQuery($sql);
		}

		function getPurchaseReturnListPaged($sRec, $nRec, $DateFrom, $DateTo, $ReturnNo, $SupplierID, $CompanyID) {
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$ReturnNo		= (int)$ReturnNo;
			$SupplierID	= (int)$SupplierID;
			$CompanyID	= (int)$CompanyID;
			$sRec				= (int)$sRec;
			$nRec				= (int)$nRec;
		
			$sql	=	"SELECT * FROM `gen_purchasereturn` WHERE `CompanyID`='$CompanyID'";
			if($DateFrom != '1900-01-01')
				$sql	=	$sql." AND `ReturnDate`>='$DateFrom'";
			if($DateTo != '1900-01-01')
				$sql	=	$sql." AND `ReturnDate`<='$DateTo'";
			if($ReturnNo > 0)
				$sql	=	$sql." AND `ReturnNo`='$ReturnNo'";
			if($SupplierID > 0)
				$sql	=	$sql." AND `SupplierID`='$SupplierID'";
			
			$sql			=	$sql." ORDER BY `FinYear` DESC, `ReturnNo` DESC LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_purchasereturn');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setPMotherAccountName( $this->getAccountNameByAccountID( $row->getPMotherAccountID()));
					$row->setPAccountName($this->getAccountNameByAccountID($row->getPAccountID()));
					$row->setSupplierName($this->getAccountNameByAccountID($row->getSupplierID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemList($this->getPurchaseReturnItemList($row->getReturnID()));
					$row->setAddLessList($this->getPurchaseReturnAddLessList($row->getReturnID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getPurchaseReturnListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getPurchaseReturnItemList($ReturnID) {
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_purchasereturn_items` WHERE `ReturnID`='$ReturnID' ORDER BY `SerialNo`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_purchasereturn_items');
				while($row = $result->fetch()) {
					$row->setItemName($this->getItemNameByItemID($row->getItemID()));
					$row->setAccountName( $this->getAccountNameByAccountID( $row->getAccountID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getPurchaseReturnItemList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getPurchaseReturnAddLessList($ReturnID) {
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_purchasereturn_addless` WHERE `ReturnID`='$ReturnID' ORDER BY `SerialNo`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_purchasereturn_addless');
				while($row = $result->fetch()) {
					$row->setAccountName($this->getAccountNameByAccountID($row->getAccountID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getPurchaseReturnItemList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function CreatePurchaseReturn($pcls) {
				
			$tuser	=	unserialize($_SESSION["ssEUser"]);
			$tcmp		= unserialize($_SESSION["ssECmp"]);
			$rdt		= $pcls->getReturnDate();
			$cmpid	= $pcls->getCompanyID();
			$finyr	= getFinancialYear($rdt);
			$pcls->setFinYear($finyr);
			$pcls->setReturnNo($this->getNextPurchaseReturnNo($finyr, $cmpid));
			
			$narr		= 'PUR RET# '.$pcls->getReturnNo().'/'.$finyr;
			
			$totval	= 0;

			try {
			
				$this->conn->beginTransaction();
				
				$pcls->setReturnID($this->getNextID("gen_purchasereturn","ReturnID"));
				$pid		= $pcls->getReturnID();
				
				$sql	= $pcls->getInsertSQL();
				$this->conn->exec($sql);				
				
				$itmList	= $pcls->getItemList();
				for($i=0;$i<count($itmList);$i++) {
					$icls	=	$itmList[$i];
					$icls->setReturnID($pid);
					$icls->setSerialNo($i+1);

					$sql		= $icls->getInsertSQL();
					$this->conn->exec($sql);
					
					
					if($pcls->getStockEntry() == "YES") {
						/* Stock entries */
					
						$lcqty	= $this->getLastStockClosingQuantity($cmpid, $pcls->getStoreID(), $icls->getItemID(), $rdt);
						$lcval	= $this->getLastStockClosingValue($cmpid, $pcls->getStoreID(), $icls->getItemID(), $rdt);
						$lbald	= $this->getLastBalanceDetail($cmpid, $pcls->getStoreID(), $icls->getItemID(), $rdt);
					
						$cqty		= $lcqty - $icls->getQuantity();
						$cval		= 0;
					
						$bald			= "";
						$bqty			= 0;
						$val			= 0;
						$Quantity	= $icls->getQuantity();
						$tmp1			= explode(",", $lbald);
						for($ii=0;$ii<count($tmp1);$ii++) {
							$tmp2		= $tmp1[$ii];
							$tmp		= explode("=", $tmp2);
							$sqty		= (double)$tmp[0];
							$sprc		= (double)$tmp[1];
							if($sqty > $Quantity) {
								$bqty	= $sqty - $Quantity;
								$val	= $val + ($Quantity * $sprc);
								break;
							} else {
								$Quantity	= $Quantity - $sqty;
								$val			= $val + ($sqty * $sprc);
							}
						}
					
						for($j=$ii;$j<count($tmp1);$j++) {
							$tmp2		= $tmp1[$j];
							$tmp		= explode("=", $tmp2);
							$sqty		= (double)$tmp[0];
							$sprc		= (double)$tmp[1];
							if($j == $ii) {
								if($bqty > 0) $sqty = $bqty;
							}
						
							if($bald != "") $bald = $bald.",";
							$bald		= $bald.$sqty.'='.$sprc;
						}
					
						/* Closing Value */
						$tmp1			= explode(",", $bald);
						for($ii=0;$ii<count($tmp1);$ii++) {
							$tmp2		= $tmp1[$ii];
							if($tmp2 == "") continue;
							$tmp		= explode("=", $tmp2);
							$sqty		= (double)$tmp[0];
							$sprc		= (double)$tmp[1];
						
							$cval		= $cval	+ ($sqty * $sprc);
						}
						/* Closing value ends here */
					
						$totval	= $totval + $val;
					
						$scls		= new asys_stock_voucher();
						$scls->setSVoucherID($this->getNextID("asys_stock_voucher","SVoucherID"));
						$scls->setCompanyID($pcls->getCompanyID());
						$scls->setStoreID($pcls->getStoreID());
						$scls->setModuleID(PURCHASE_RETURN);
						$scls->setFinYear($pcls->getFinYear());
						$scls->setRelatedID($pid);
						$scls->setDOT($pcls->getReturnDate('yes'));
						$scls->setTOT(time());
						$scls->setItemID($icls->getItemID());
						$scls->setItemCategoryID($this->getItemCategoryByItemID($icls->getItemID()));
						$scls->setQuantity($icls->getQuantity());
						$scls->setUnitPrice($val/$icls->getQuantity());
						$scls->setStockInOut(STOCK_OUT);
						$scls->setClosingQty($cqty);
						$scls->setClosingValue($cval);
						$scls->setBatchNo("");
						$scls->setNarration('PUR RET# '.$pcls->getReturnNo().'/'.$pcls->getFinYear());
						$scls->setBalanceDetail($bald);
					
						$sql		= $scls->getInsertSQL();
						$this->conn->exec($sql);
					
						/* Stock entry ends here */
					}
										
				}
				
				
				/* Voucher Entries */
				
				$vclsArr		= [];
				$VoucherNo	= $this->getMaxVoucherNo(PURCHASE_RETURN_VOUCHER, $finyr, $cmpid);
				$DayWiseNo	= $this->getMaxDayWiseVoucherNo(PURCHASE_RETURN_VOUCHER, $rdt, $cmpid);
				
				if($pcls->getPAccountID() != 0)
					$aDet		= $this->getAccountDetail($pcls->getPAccountID());
				else
					$aDet		= $this->getAccountDetail($pcls->getPMotherAccountID());				
				
				$vcls		=	new asys_voucher_entry();
				$vcls->setSerialID(1);
				$vcls->setCompanyID($pcls->getCompanyID());
				$vcls->setVoucherType(PURCHASE_RETURN_VOUCHER);
				$vcls->setFinYear($finyr);
				$vcls->setVoucherNo($VoucherNo);
				$vcls->setDayWiseNo($DayWiseNo);
				$vcls->setDOV($pcls->getReturnDate('yes'));
				$vcls->setMotherAccount($aDet->getMotherAccount());
				$vcls->setAccountID($aDet->getAccountID());
				$vcls->setRelatedID($pid);
				$vcls->setTxnType(PURCHASE_RETURN);
				$vcls->setDrCr(CREDIT);
				$vcls->setAmount($pcls->getItemTotal() - ($pcls->getIGST() + $pcls->getSGST() + $pcls->getCGST()));
				$vcls->setNarration('PUR RET# '.$pcls->getReturnNo().'/'.$finyr);
				$vcls->setUserID($tuser->getUserID());
				$vcls->setDOE(date('d-m-Y'));
			
				$vclsArr[] = $vcls;			
				
				if($pcls->getSupplierID() != 0)
					$aDet		= $this->getAccountDetail($pcls->getSupplierID());
				else
					$aDet		= $this->getAccountDetail($pcls->getSMotherAccountID());

				$vcls		=	new asys_voucher_entry();
				$vcls->setSerialID(2);
				$vcls->setCompanyID($pcls->getCompanyID());
				$vcls->setVoucherType(PURCHASE_RETURN_VOUCHER);
				$vcls->setFinYear($finyr);
				$vcls->setVoucherNo($VoucherNo);
				$vcls->setDayWiseNo($DayWiseNo);
				$vcls->setDOV($pcls->getReturnDate('yes'));
				$vcls->setMotherAccount($aDet->getMotherAccount());
				$vcls->setAccountID($aDet->getAccountID());
				$vcls->setRelatedID($pid);
				$vcls->setTxnType(PURCHASE_RETURN);
				$vcls->setDrCr(DEBIT);
				$vcls->setAmount($pcls->getNetTotal());
				$vcls->setNarration('PURCHASE RET# '.$pcls->getReturnNo().'/'.$finyr);
				$vcls->setUserID($tuser->getUserID());
				$vcls->setDOE(date('d-m-Y'));
			
				$vclsArr[] = $vcls;
				
				$kk		= 3;				
				if($pcls->getIGST() > 0) {
					$aDet		= $this->getAccountDetail($tcmp->getIGSTAccountID());
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($kk++);
					$vcls->setCompanyID($cmpid);
					$vcls->setVoucherType(PURCHASE_RETURN_VOUCHER);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($VoucherNo);
					$vcls->setDayWiseNo($DayWiseNo);
					$vcls->setDOV($pcls->getReturnDate('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($pid);
					$vcls->setTxnType(PURCHASE_RETURN);
					$vcls->setDrCr(CREDIT);
					$vcls->setAmount($pcls->getIGST());
					$vcls->setNarration('IGST for '.$narr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
				}
				
				if($pcls->getCGST() > 0) {
					$aDet		= $this->getAccountDetail($tcmp->getCGSTAccountID());
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($kk++);
					$vcls->setCompanyID($cmpid);
					$vcls->setVoucherType(PURCHASE_RETURN_VOUCHER);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($VoucherNo);
					$vcls->setDayWiseNo($DayWiseNo);
					$vcls->setDOV($pcls->getReturnDate('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($pid);
					$vcls->setTxnType(PURCHASE_RETURN);
					$vcls->setDrCr(CREDIT);
					$vcls->setAmount($pcls->getCGST());
					$vcls->setNarration('CGST for '.$narr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
				}
				
				if($pcls->getSGST() > 0) {
					$aDet			= $this->getAccountDetail($tcmp->getSGSTAccountID());
					if($pcls->getSupplierID() != 0)
						$sdet		= $this->getAccountDetail($pcls->getSupplierID());
					else
						$sdet		= $this->getAccountDetail($pcls->getSMotherAccountID());
					
					if($this->getUTByState($sdet->getState()) == "YES")
						$aDet		= $this->getAccountDetail($tcmp->getUGSTAccountID());
						
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($kk++);
					$vcls->setCompanyID($cmpid);
					$vcls->setVoucherType(PURCHASE_RETURN_VOUCHER);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($VoucherNo);
					$vcls->setDayWiseNo($DayWiseNo);
					$vcls->setDOV($pcls->getReturnDate('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($pid);
					$vcls->setTxnType(PURCHASE_RETURN);
					$vcls->setDrCr(CREDIT);
					$vcls->setAmount($pcls->getSGST());
					$vcls->setNarration('SGST/UGST for '.$narr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
				}
				
				$alList	= $pcls->getAddLessList();
				for($i=0;$i<count($alList);$i++) {
					$acls	=	$alList[$i];
					$acls->setReturnID($pid);
					$acls->setSerialNo($i+1);

					$sql		= $acls->getInsertSQL();
					$this->conn->exec($sql);
					
					
					$aDet		= $this->getAccountDetail($acls->getAccountID());
					
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($kk++);
					$vcls->setCompanyID($cmpid);
					$vcls->setVoucherType(PURCHASE_RETURN_VOUCHER);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($VoucherNo);
					$vcls->setDayWiseNo($DayWiseNo);
					$vcls->setDOV($pcls->getReturnDate('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($pid);
					$vcls->setTxnType(PURCHASE_RETURN);
					if($acls->getAddLess() == 'ADD')
						$vcls->setDrCr(CREDIT);
					else
						$vcls->setDrCr(DEBIT);
					$vcls->setAmount($acls->getAmount());
					$vcls->setNarration('PUR RET# '.$pcls->getReturnNo().'/'.$finyr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
					
				}
				
				$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
				for($ii=0; $ii<count($vclsArr); $ii++) {
					$vcls		= $vclsArr[$ii];
					$vcls->setVoucherID($vid);
					$this->conn->exec($vcls->getInsertSQL());					
				}				
				
				/* Voucher Entry ends here */
				
				
				if($pcls->getStockEntry() == "YES" && $totval > 0) {
					/* Voucher entry for Store */
				
					$VoucherNo	= $this->getMaxVoucherNo(JOURNAL_VOUCHER, $finyr, $cmpid);
					$DayWiseNo	= $this->getMaxDayWiseVoucherNo(JOURNAL_VOUCHER, $pdt, $cmpid);
				
					$storeDet		= $this->getStoreDetail($pcls->getStoreID());
					if($storeDet->getAccountID() != 0)
						$aDet		= $this->getAccountDetail($storeDet->getAccountID());
					else
						$aDet		= $this->getAccountDetail($storeDet->getMotherAccountID());

					$vcls1		=	new asys_voucher_entry();
					$vcls1->setSerialID(1);
					$vcls1->setCompanyID($cmpid);
					$vcls1->setVoucherType(JOURNAL_VOUCHER);
					$vcls1->setFinYear($finyr);
					$vcls1->setVoucherNo($VoucherNo);
					$vcls1->setDayWiseNo($DayWiseNo);
					$vcls1->setDOV($pcls->getReturnDate('yes'));
					$vcls1->setMotherAccount($aDet->getMotherAccount());
					$vcls1->setAccountID($aDet->getAccountID());
					$vcls1->setRelatedID($pid);
					$vcls1->setTxnType(PURCHASE_RETURN);
					$vcls1->setDrCr(CREDIT);
					$vcls1->setAmount($totval);
					$vcls1->setNarration($narr);
					$vcls1->setUserID($tuser->getUserID());
					$vcls1->setDOE(date('d-m-Y'));
				
				
					$aDet		= $this->getAccountDetail($storeDet->getOppositeAccountID());
				
					$vcls2		=	new asys_voucher_entry();
					$vcls2->setSerialID(2);
					$vcls2->setCompanyID($cmpid);
					$vcls2->setVoucherType(JOURNAL_VOUCHER);
					$vcls2->setFinYear($finyr);
					$vcls2->setVoucherNo($VoucherNo);
					$vcls2->setDayWiseNo($DayWiseNo);
					$vcls2->setDOV($pcls->getReturnDate('yes'));
					$vcls2->setMotherAccount($aDet->getMotherAccount());
					$vcls2->setAccountID($aDet->getAccountID());
					$vcls2->setRelatedID($pid);
					$vcls2->setTxnType(PURCHASE_RETURN);
					$vcls2->setDrCr(DEBIT);
					$vcls2->setAmount($totval);
					$vcls2->setNarration($narr);
					$vcls2->setUserID($tuser->getUserID());
					$vcls2->setDOE(date('d-m-Y'));
			
					$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
					$vcls1->setVoucherID($vid);
					$vcls2->setVoucherID($vid);
					$this->conn->exec($vcls1->getInsertSQL());
					$this->conn->exec($vcls2->getInsertSQL());								
				
					/* Voucher entry for Store ends here */
				}
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'purchasedb CreatePurchaseReturn '.$er->getMessage();
				_errorLog($err);
				$pid	= -1;
				
			}


			return $pid;
			
		}
		
		function deletePurchaseReturn($pcls) {
		
			$pkey				= $pcls->getReturnID();
			$cmpid			= $pcls->getCompanyID();
			$ret				= true;
		
			try {
			
				$this->conn->beginTransaction();
				
				$this->conn->exec("DELETE FROM `gen_purchasereturn_addless` WHERE `ReturnID`='$pkey'");
				$this->conn->exec("DELETE FROM `gen_purchasereturn_items` WHERE `ReturnID`='$pkey'");
				$this->conn->exec("DELETE FROM `asys_voucher_entry` WHERE `RelatedID`='$pkey' AND `TxnType`='".PURCHASE_RETURN."' AND `CompanyID`='".$cmpid."'");
				$this->conn->exec("DELETE FROM `asys_stock_voucher` WHERE `RelatedID`='$pkey' AND `ModuleID`='".PURCHASE_RETURN."' AND `CompanyID`='".$cmpid."'");
				
				$sql	= $pcls->getDeleteSQL();
				$this->conn->exec($sql);
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				$err	= 'purchasedb deletePurchaseReturn '.$er->getMessage();
				_errorLog($err);
				$ret	= false;
				$this->conn->rollBack();
				
			}
		
			return $ret;

		}
		
		function getReturnDateByReturnID($ReturnID) {
			$ReturnID	= (int)$ReturnID;
			$sql	= "SELECT `ReturnDate` FROM `gen_purchasereturn` WHERE `ReturnID`='".$ReturnID."'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function UpdatePurchaseReturn($pcls) {
			
			$tuser	=	unserialize($_SESSION["ssEUser"]);
			$tcmp		= unserialize($_SESSION["ssECmp"]);
			$pid		= $pcls->getReturnID();
			$cmpid	= $pcls->getCompanyID();
			$rdt		= $pcls->getReturnDate();
			$finyr	= getFinancialYear($rdt);
			$vno		= $this->getVoucherNoByRelatedID(PURCHASE_RETURN_VOUCHER, PURCHASE_RETURN, $pid, $cmpid);
			if($rdt == $this->getReturnDateByReturnID($pid))
				$dwn	= $this->getDayWiseNoByRelatedID(PURCHASE_RETURN_VOUCHER, PURCHASE_RETURN, $pid, $cmpid);
			else
				$dwn	= $this->getMaxDayWiseVoucherNo(PURCHASE_RETURN_VOUCHER, $rdt, $cmpid);
				
			$narr		= 'PUR RET# '.$pcls->getReturnNo().'/'.$finyr;
			
			$totval	= 0;	

			try {
			
				$this->conn->beginTransaction();
				
				$delsql1	= "DELETE FROM `gen_purchasereturn_addless` WHERE `ReturnID`='$pid'";
				$delsql2	= "DELETE FROM `gen_purchasereturn_items` WHERE `ReturnID`='$pid'";
				$this->conn->exec($delsql1);
				$this->conn->exec($delsql2);				
				
				$delsql3	= "DELETE FROM `asys_voucher_entry` WHERE `RelatedID`='$pid' AND `TxnType`='".PURCHASE_RETURN."' AND `CompanyID`='".$cmpid."'";
				$this->conn->exec($delsql3);
				$delsql4	= "DELETE FROM `asys_stock_voucher` WHERE `RelatedID`='$pid' AND `ModuleID`='".PURCHASE_RETURN."' AND `CompanyID`='".$cmpid."'";
				
				$stkcls		= array();
				
				$itmList	= $pcls->getItemList();
				for($i=0;$i<count($itmList);$i++) {
					$icls	=	$itmList[$i];
					$icls->setReturnID($pid);
					$icls->setSerialNo($i+1);

					$sql		= $icls->getInsertSQL();
					$this->conn->exec($sql);
					
					
					if($pcls->getStockEntry() == "YES") {
						/* Stock entries */
					
						$lcqty	= $this->getLastStockClosingQuantityForUpdate($cmpid, $pcls->getStoreID(), $icls->getItemID(), $rdt, PURCHASE_RETURN, $pid);
						$lcval	= $this->getLastStockClosingValueForUpdate($cmpid, $pcls->getStoreID(), $icls->getItemID(), $rdt, PURCHASE_RETURN, $pid);
						$lbald	= $this->getLastBalanceDetailForUpdate($cmpid, $pcls->getStoreID(), $icls->getItemID(), $rdt, PURCHASE_RETURN, $pid);
					
						$cqty		= $lcqty - $icls->getQuantity();
						$cval		= 0;
					
						$bald			= "";
						$bqty			= 0;
						$val			= 0;
						$Quantity	= $icls->getQuantity();
						$tmp1			= explode(",", $lbald);
						for($ii=0;$ii<count($tmp1);$ii++) {
							$tmp2		= $tmp1[$ii];
							$tmp		= explode("=", $tmp2);
							$sqty		= (double)$tmp[0];
							$sprc		= (double)$tmp[1];
							if($sqty > $Quantity) {
								$bqty	= $sqty - $Quantity;
								$val	= $val + ($Quantity * $sprc);
								break;
							} else {
								$Quantity	= $Quantity - $sqty;
								$val			= $val + ($sqty * $sprc);
							}
						}
					
						for($j=$ii;$j<count($tmp1);$j++) {
							$tmp2		= $tmp1[$j];
							$tmp		= explode("=", $tmp2);
							$sqty		= (double)$tmp[0];
							$sprc		= (double)$tmp[1];
							if($j == $ii) {
								if($bqty > 0) $sqty = $bqty;
							}
						
							if($bald != "") $bald = $bald.",";
							$bald		= $bald.$sqty.'='.$sprc;
						}
					
						/* Closing Value */
						$tmp1			= explode(",", $bald);
						for($ii=0;$ii<count($tmp1);$ii++) {
							$tmp2		= $tmp1[$ii];
							if($tmp2 == "") continue;
							$tmp		= explode("=", $tmp2);
							$sqty		= (double)$tmp[0];
							$sprc		= (double)$tmp[1];
						
							$cval		= $cval	+ ($sqty * $sprc);
						}
						/* Closing value ends here */	
					
						$totval	= $totval + $val;					
					
						$scls		= new asys_stock_voucher();
						$scls->setCompanyID($cmpid);
						$scls->setStoreID($pcls->getStoreID());
						$scls->setModuleID(PURCHASE_RETURN);
						$scls->setFinYear($pcls->getFinYear());
						$scls->setRelatedID($pid);
						$scls->setDOT($pcls->getReturnDate('yes'));
						$scls->setTOT(time());
						$scls->setItemID($icls->getItemID());
						$scls->setItemCategoryID($this->getItemCategoryByItemID($icls->getItemID()));
						$scls->setQuantity($icls->getQuantity());
						$scls->setUnitPrice($val/$icls->getQuantity());
						$scls->setStockInOut(STOCK_OUT);
						$scls->setClosingQty($cqty);
						$scls->setClosingValue($cval);						
						$scls->setBatchNo("");
						$scls->setNarration('PUR RET# '.$pcls->getReturnNo().'/'.$pcls->getFinYear());
						$scls->setBalanceDetail($bald);
					
						$stkcls[]		= $scls;
					
						/* Stock entry ends here */
					}
					
				}
				
				if($pcls->getStockEntry() == "YES") {
					$this->conn->exec($delsql4);
					for($i=0;$i<count($stkcls);$i++) {
						$scls		= $stkcls[$i];
						$scls->setSVoucherID($this->getNextID("asys_stock_voucher","SVoucherID"));
						$this->conn->exec($scls->getInsertSQL());
					}
				}
				
				
				$sql	= $pcls->getUpdateSQL();
				$this->conn->exec($sql);
				
				/* Voucher Entries */
				
				$vclsArr		= [];
				$VoucherNo	= $vno;
				$DayWiseNo	= $dwn;
				
				if($pcls->getPAccountID() != 0)
					$aDet		= $this->getAccountDetail($pcls->getPAccountID());
				else
					$aDet		= $this->getAccountDetail($pcls->getPMotherAccountID());				
				
				$vcls		=	new asys_voucher_entry();
				$vcls->setSerialID(1);
				$vcls->setCompanyID($pcls->getCompanyID());
				$vcls->setVoucherType(PURCHASE_RETURN_VOUCHER);
				$vcls->setFinYear($finyr);
				$vcls->setVoucherNo($VoucherNo);
				$vcls->setDayWiseNo($DayWiseNo);
				$vcls->setDOV($pcls->getReturnDate('yes'));
				$vcls->setMotherAccount($aDet->getMotherAccount());
				$vcls->setAccountID($aDet->getAccountID());
				$vcls->setRelatedID($pid);
				$vcls->setTxnType(PURCHASE_RETURN);
				$vcls->setDrCr(CREDIT);
				$vcls->setAmount($pcls->getItemTotal() - ($pcls->getIGST() + $pcls->getSGST() + $pcls->getCGST()));
				$vcls->setNarration('PUR RET# '.$pcls->getReturnNo().'/'.$finyr);
				$vcls->setUserID($tuser->getUserID());
				$vcls->setDOE(date('d-m-Y'));
			
				$vclsArr[] = $vcls;			
				
				if($pcls->getSupplierID() != 0)
					$aDet		= $this->getAccountDetail($pcls->getSupplierID());
				else
					$aDet		= $this->getAccountDetail($pcls->getSMotherAccountID());

				$vcls		=	new asys_voucher_entry();
				$vcls->setSerialID(2);
				$vcls->setCompanyID($pcls->getCompanyID());
				$vcls->setVoucherType(PURCHASE_RETURN_VOUCHER);
				$vcls->setFinYear($finyr);
				$vcls->setVoucherNo($VoucherNo);
				$vcls->setDayWiseNo($DayWiseNo);
				$vcls->setDOV($pcls->getReturnDate('yes'));
				$vcls->setMotherAccount($aDet->getMotherAccount());
				$vcls->setAccountID($aDet->getAccountID());
				$vcls->setRelatedID($pid);
				$vcls->setTxnType(PURCHASE_RETURN);
				$vcls->setDrCr(DEBIT);
				$vcls->setAmount($pcls->getNetTotal());
				$vcls->setNarration('PURCHASE RET# '.$pcls->getReturnNo().'/'.$finyr);
				$vcls->setUserID($tuser->getUserID());
				$vcls->setDOE(date('d-m-Y'));
			
				$vclsArr[] = $vcls;
				
				$kk		= 3;
				if($pcls->getIGST() > 0) {
					$aDet		= $this->getAccountDetail($tcmp->getIGSTAccountID());
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($kk++);
					$vcls->setCompanyID($cmpid);
					$vcls->setVoucherType(PURCHASE_RETURN_VOUCHER);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($VoucherNo);
					$vcls->setDayWiseNo($DayWiseNo);
					$vcls->setDOV($pcls->getReturnDate('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($pid);
					$vcls->setTxnType(PURCHASE_RETURN);
					$vcls->setDrCr(CREDIT);
					$vcls->setAmount($pcls->getIGST());
					$vcls->setNarration('IGST for '.$narr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
				}
				
				if($pcls->getCGST() > 0) {
					$aDet		= $this->getAccountDetail($tcmp->getCGSTAccountID());
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($kk++);
					$vcls->setCompanyID($cmpid);
					$vcls->setVoucherType(PURCHASE_RETURN_VOUCHER);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($VoucherNo);
					$vcls->setDayWiseNo($DayWiseNo);
					$vcls->setDOV($pcls->getReturnDate('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($pid);
					$vcls->setTxnType(PURCHASE_RETURN);
					$vcls->setDrCr(CREDIT);
					$vcls->setAmount($pcls->getCGST());
					$vcls->setNarration('CGST for '.$narr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
				}
				
				if($pcls->getSGST() > 0) {
					$aDet			= $this->getAccountDetail($tcmp->getSGSTAccountID());
					if($pcls->getSupplierID() != 0)
						$sdet		= $this->getAccountDetail($pcls->getSupplierID());
					else
						$sdet		= $this->getAccountDetail($pcls->getSMotherAccountID());
					
					if($this->getUTByState($sdet->getState()) == "YES")
						$aDet		= $this->getAccountDetail($tcmp->getUGSTAccountID());
						
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($kk++);
					$vcls->setCompanyID($cmpid);
					$vcls->setVoucherType(PURCHASE_RETURN_VOUCHER);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($VoucherNo);
					$vcls->setDayWiseNo($DayWiseNo);
					$vcls->setDOV($pcls->getReturnDate('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($pid);
					$vcls->setTxnType(PURCHASE_RETURN);
					$vcls->setDrCr(CREDIT);
					$vcls->setAmount($pcls->getSGST());
					$vcls->setNarration('SGST/UGST for '.$narr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
				}
				
				$alList	= $pcls->getAddLessList();
				for($i=0;$i<count($alList);$i++) {
					$acls	=	$alList[$i];
					$acls->setReturnID($pid);
					$acls->setSerialNo($i+1);

					$sql		= $acls->getInsertSQL();
					$this->conn->exec($sql);
					
					
					$aDet		= $this->getAccountDetail($acls->getAccountID());
					
					$vcls		=	new asys_voucher_entry();
					$vcls->setSerialID($kk++);
					$vcls->setCompanyID($cmpid);
					$vcls->setVoucherType(PURCHASE_RETURN_VOUCHER);
					$vcls->setFinYear($finyr);
					$vcls->setVoucherNo($VoucherNo);
					$vcls->setDayWiseNo($DayWiseNo);
					$vcls->setDOV($pcls->getReturnDate('yes'));
					$vcls->setMotherAccount($aDet->getMotherAccount());
					$vcls->setAccountID($aDet->getAccountID());
					$vcls->setRelatedID($pid);
					$vcls->setTxnType(PURCHASE_RETURN);
					if($acls->getAddLess() == 'ADD')
						$vcls->setDrCr(CREDIT);
					else
						$vcls->setDrCr(DEBIT);
					$vcls->setAmount($acls->getAmount());
					$vcls->setNarration('PUR RET# '.$pcls->getReturnNo().'/'.$finyr);
					$vcls->setUserID($tuser->getUserID());
					$vcls->setDOE(date('d-m-Y'));
			
					$vclsArr[] = $vcls;
					
				}
				
				$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
				for($ii=0; $ii<count($vclsArr); $ii++) {
					$vcls		= $vclsArr[$ii];
					$vcls->setVoucherID($vid);
					$this->conn->exec($vcls->getInsertSQL());					
				}				
				
				/* Voucher Entry ends here */
				
				
				if($pcls->getStockEntry() == "YES" && $totval > 0) {
					/* Voucher entry for Store */
				
					$VoucherNo	= $this->getMaxVoucherNo(JOURNAL_VOUCHER, $finyr, $cmpid);
					$DayWiseNo	= $this->getMaxDayWiseVoucherNo(JOURNAL_VOUCHER, $rdt, $cmpid);
				
					$storeDet		= $this->getStoreDetail($pcls->getStoreID());
					if($storeDet->getAccountID() != 0)
						$aDet		= $this->getAccountDetail($storeDet->getAccountID());
					else
						$aDet		= $this->getAccountDetail($storeDet->getMotherAccountID());				
				
					$vcls1		=	new asys_voucher_entry();
					$vcls1->setSerialID(1);
					$vcls1->setCompanyID($cmpid);
					$vcls1->setVoucherType(JOURNAL_VOUCHER);
					$vcls1->setFinYear($finyr);
					$vcls1->setVoucherNo($VoucherNo);
					$vcls1->setDayWiseNo($DayWiseNo);
					$vcls1->setDOV($pcls->getReturnDate('yes'));
					$vcls1->setMotherAccount($aDet->getMotherAccount());
					$vcls1->setAccountID($aDet->getAccountID());
					$vcls1->setRelatedID($pid);
					$vcls1->setTxnType(PURCHASE_RETURN);
					$vcls1->setDrCr(CREDIT);
					$vcls1->setAmount($totval);
					$vcls1->setNarration($narr);
					$vcls1->setUserID($tuser->getUserID());
					$vcls1->setDOE(date('d-m-Y'));
				
				
					$aDet		= $this->getAccountDetail($storeDet->getOppositeAccountID());
				
					$vcls2		=	new asys_voucher_entry();
					$vcls2->setSerialID(2);
					$vcls2->setCompanyID($cmpid);
					$vcls2->setVoucherType(JOURNAL_VOUCHER);
					$vcls2->setFinYear($finyr);
					$vcls2->setVoucherNo($VoucherNo);
					$vcls2->setDayWiseNo($DayWiseNo);
					$vcls2->setDOV($pcls->getReturnDate('yes'));
					$vcls2->setMotherAccount($aDet->getMotherAccount());
					$vcls2->setAccountID($aDet->getAccountID());
					$vcls2->setRelatedID($pid);
					$vcls2->setTxnType(PURCHASE_RETURN);
					$vcls2->setDrCr(DEBIT);
					$vcls2->setAmount($totval);
					$vcls2->setNarration($narr);
					$vcls2->setUserID($tuser->getUserID());
					$vcls2->setDOE(date('d-m-Y'));
			
					$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
					$vcls1->setVoucherID($vid);
					$vcls2->setVoucherID($vid);
					$this->conn->exec($vcls1->getInsertSQL());	
					$this->conn->exec($vcls2->getInsertSQL());								
				
					/* Voucher entry for Store ends here */
				}
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'purchasedb UpdatePurchaseReturn '.$er->getMessage();
				_errorLog($err);
				$pid	= -1;
				
			}

			return $pid;
			
		}
		
		
		
		/*---------------------------------------------------------*/
		/*********************** GRN METHODS ***********************/
		
		function getNextGRNNo($FinYear, $CompanyID) {
			if(strpos($FinYear, "'") !== false) return false;
			$CompanyID	= (int)$CompanyID;
			
			$maxid			=	0;
			$sql				=	"SELECT MAX(`GRNNo`) FROM `gen_grn` WHERE `FinYear`='$FinYear' AND `CompanyID`='$CompanyID'";

			try {
				
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch())
					$maxid 	= $row[0];
					
			} catch(PDOException $e) {
				$err	= 'purchasedb getNextGRNNo '.$e->getMessage();
				_errorLog($err);
			}

			$maxid++;
			return $maxid;
		}

		function getGRNDetail($GRNID) {
			$GRNID			= (int)$GRNID;
			$cclass			=	new gen_grn();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_grn` WHERE `GRNID`='$GRNID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_grn');
				if($row 	= $result->fetch()) { 
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setSupplierName($this->getAccountNameByAccountID($row->getSupplierID()));	
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemList($this->getGRNItemList($row->getGRNID()));
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getGRNDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getGRNList($CompanyID) {
			$arr				=	array();
			$CompanyID	= (int)$CompanyID;
			
			try {
				
				$sql			=	"SELECT * FROM `gen_grn` WHERE `CompanyID`='$CompanyID' ORDER BY `GRNNo`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_grn');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setSupplierName($this->getAccountNameByAccountID($row->getSupplierID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemList($this->getGRNItemList($row->getGRNID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getGRNList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function getNumberOfGRN($DateFrom, $DateTo, $GRNNo, $SupplierID, $StoreID, $CompanyID) {
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$GRNNo			= (int)$GRNNo;
			$SupplierID	= (int)$SupplierID;
			$StoreID		= (int)$StoreID;
			$CompanyID	= (int)$CompanyID;
			
			$sql	=	"SELECT COUNT(*) FROM `gen_grn` WHERE `CompanyID`='$CompanyID'";
			if($DateFrom != '1900-01-01')
				$sql	=	$sql." AND `GRNDate`>='$DateFrom'";
			if($DateTo != '1900-01-01')
				$sql	=	$sql." AND `GRNDate`<='$DateTo'";
			if($GRNNo > 0)
				$sql	=	$sql." AND `GRNNo`='$GRNNo'";
			if($SupplierID > 0)
				$sql	=	$sql." AND `SupplierID`='$SupplierID'";
			if($StoreID > 0)
				$sql	=	$sql." AND `StoreID`='$StoreID'";
			
			return $this->getResultExecutingQuery($sql);
		}

		function getGRNListPaged($sRec, $nRec, $DateFrom, $DateTo, $GRNNo, $SupplierID, $StoreID, $CompanyID) {
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$GRNNo			= (int)$GRNNo;
			$SupplierID	= (int)$SupplierID;
			$StoreID		= (int)$StoreID;
			$CompanyID	= (int)$CompanyID;
			
			$sql	=	"SELECT * FROM `gen_grn` WHERE `CompanyID`='$CompanyID'";
			if($DateFrom != '1900-01-01')
				$sql	=	$sql." AND `GRNDate`>='$DateFrom'";
			if($DateTo != '1900-01-01')
				$sql	=	$sql." AND `GRNDate`<='$DateTo'";
			if($GRNNo > 0)
				$sql	=	$sql." AND `GRNNo`='$GRNNo'";
			if($SupplierID > 0)
				$sql	=	$sql." AND `SupplierID`='$SupplierID'";
			if($StoreID > 0)
				$sql	=	$sql." AND `StoreID`='$StoreID'";
			
			$sql			=	$sql." ORDER BY `FinYear` DESC, `GRNNo` DESC LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_grn');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setSupplierName($this->getAccountNameByAccountID($row->getSupplierID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemList($this->getGRNItemList($row->getGRNID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getGRNListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getGRNItemList($GRNID) {
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_grn_items` WHERE `GRNID`='$GRNID' ORDER BY `ItemID`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_grn_items');
				while($row = $result->fetch()) {
					$row->setItemName($this->getItemNameByItemID($row->getItemID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getGRNItemList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function CreateGRN($pcls) {
			
			$tuser	=	unserialize($_SESSION["ssEUser"]);
			$pcls->setGRNID($this->getNextID("gen_grn","GRNID"));
			$pid		= $pcls->getGRNID();
			$pdt		= $pcls->getGRNDate();
			$cmpid	= $pcls->getCompanyID();
			$finyr	= getFinancialYear($pdt);			
			$pcls->setFinYear(getFinancialYear($pcls->getGRNDate()));
			$pcls->setGRNNo($this->getNextGRNNo($pcls->getFinYear(), $pcls->getCompanyID()));
			
			$narr		= "GRN# ".$pcls->getGRNNo().'/'.$pcls->getFinYear();
			
			$totval	= 0;
			
			try {
			
				$this->conn->beginTransaction();
				
				$itmList	= $pcls->getItemList();
				for($i=0;$i<count($itmList);$i++) {
					$icls	=	$itmList[$i];
					$icls->setGRNID($pid);

					$sql		= $icls->getInsertSQL();
					$this->conn->exec($sql);
					
					/* Stock entries */
					
					$xtraPerUnit	= 0;
					
					$lcqty	= $this->getLastStockClosingQuantity($cmpid, $pcls->getStoreID(), $icls->getItemID(), $pdt);
					$lcval	= $this->getLastStockClosingValue($cmpid, $pcls->getStoreID(), $icls->getItemID(), $pdt);
					$lbald	= $this->getLastBalanceDetail($cmpid, $pcls->getStoreID(), $icls->getItemID(), $pdt);
				
					$cqty		= $lcqty + $icls->getQuantity();
					$cval		= $lcval + ($icls->getAmount() + $xtraPerUnit);
					$bald		= $lbald;
					if($bald != "") $bald = $bald.",";
					$bald		= $bald.$icls->getQuantity()."=".($icls->getAmount()/$icls->getQuantity() + $xtraPerUnit);
					
					$totval	= $totval + $icls->getAmount();
				
					$scls		= new asys_stock_voucher();
					$scls->setSVoucherID($this->getNextID("asys_stock_voucher","SVoucherID"));
					$scls->setCompanyID($pcls->getCompanyID());
					$scls->setStoreID($pcls->getStoreID());
					$scls->setModuleID(GRN);
					$scls->setFinYear($pcls->getFinYear());
					$scls->setRelatedID($pid);
					$scls->setDOT($pcls->getGRNDate('yes'));
					$scls->setTOT(time());
					$scls->setItemID($icls->getItemID());
					$scls->setItemCategoryID($this->getItemCategoryByItemID($icls->getItemID()));
					$scls->setQuantity($icls->getQuantity());
					$scls->setUnitPrice($icls->getRate());
					$scls->setStockInOut(STOCK_IN);
					$scls->setClosingQty($cqty);
					$scls->setClosingValue($cval);						
					$scls->setBatchNo("");
					$scls->setNarration($narr);
					$scls->setBalanceDetail($bald);
				
					$sql		= $scls->getInsertSQL();
					$this->conn->exec($sql);
					
					/* Stock entry ends here */
				}
				
				$sql	= $pcls->getInsertSQL();
				$this->conn->exec($sql);
				
				/* Voucher entry for Store */
				
				
				$VoucherNo	= $this->getMaxVoucherNo(JOURNAL_VOUCHER, $finyr, $cmpid);
				$DayWiseNo	= $this->getMaxDayWiseVoucherNo(JOURNAL_VOUCHER, $pdt, $cmpid);
				
				$storeDet		= $this->getStoreDetail($pcls->getStoreID());
				if($storeDet->getAccountID() != 0)
					$aDet		= $this->getAccountDetail($storeDet->getAccountID());
				else
					$aDet		= $this->getAccountDetail($storeDet->getMotherAccountID());

				$vcls1		=	new asys_voucher_entry();
				$vcls1->setSerialID(1);
				$vcls1->setCompanyID($cmpid);
				$vcls1->setVoucherType(JOURNAL_VOUCHER);
				$vcls1->setFinYear($finyr);
				$vcls1->setVoucherNo($VoucherNo);
				$vcls1->setDayWiseNo($DayWiseNo);
				$vcls1->setDOV($pcls->getGRNDate('yes'));
				$vcls1->setMotherAccount($aDet->getMotherAccount());
				$vcls1->setAccountID($aDet->getAccountID());
				$vcls1->setRelatedID($pid);
				$vcls1->setTxnType(GRN);
				$vcls1->setDrCr(DEBIT);
				$vcls1->setAmount($totval);
				$vcls1->setNarration($narr);
				$vcls1->setUserID($tuser->getUserID());
				$vcls1->setDOE(date('d-m-Y'));
				
				
				$aDet		= $this->getAccountDetail($storeDet->getOppositeAccountID());
				
				$vcls2		=	new asys_voucher_entry();
				$vcls2->setSerialID(2);
				$vcls2->setCompanyID($cmpid);
				$vcls2->setVoucherType(JOURNAL_VOUCHER);
				$vcls2->setFinYear($finyr);
				$vcls2->setVoucherNo($VoucherNo);
				$vcls2->setDayWiseNo($DayWiseNo);
				$vcls2->setDOV($pcls->getGRNDate('yes'));
				$vcls2->setMotherAccount($aDet->getMotherAccount());
				$vcls2->setAccountID($aDet->getAccountID());
				$vcls2->setRelatedID($pid);
				$vcls2->setTxnType(GRN);
				$vcls2->setDrCr(CREDIT);
				$vcls2->setAmount($totval);
				$vcls2->setNarration($narr);
				$vcls2->setUserID($tuser->getUserID());
				$vcls2->setDOE(date('d-m-Y'));
			
				$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
				$vcls1->setVoucherID($vid);
				$vcls2->setVoucherID($vid);
				$this->conn->exec($vcls1->getInsertSQL());	
				$this->conn->exec($vcls2->getInsertSQL());							
				
				/* Voucher entry for Store ends here */				
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'purchasedb CreateGRN '.$er->getMessage();
				_errorLog($err);
				$pid	= -1;
				
			}


			return $pid;
			
		}
		
		function deleteGRN($pcls) {
		
			$pkey				= $pcls->getGRNID();
			$cmpid			= $pcls->getCompanyID();
			$ret				= true;
		

			try {
			
				$this->conn->beginTransaction();	
				
				$this->conn->exec("DELETE FROM `gen_grn_items` WHERE `GRNID`='$pkey'");
				$this->conn->exec("DELETE FROM `asys_stock_voucher` WHERE `RelatedID`='$pkey' AND `ModuleID`='".GRN."' AND `CompanyID`='".$cmpid."'");
				$this->conn->exec("DELETE FROM `asys_voucher_entry` WHERE `RelatedID`='$pkey' AND `TxnType`='".GRN."' AND `CompanyID`='".$cmpid."'");
				
				$sql	= $pcls->getDeleteSQL();
				$this->conn->exec($sql);
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				$err	= 'purchasedb deleteGRN (line 2205) '.$er->getMessage();
				_errorLog($err);
				$ret	= false;
				$this->conn->rollBack();
				
			}

		
			return $ret;

		}
		
		function UpdateGRN($pcls) {
			
			$tuser	=	unserialize($_SESSION["ssEUser"]);
			$pid		= $pcls->getGRNID();
			$pdt		= $pcls->getGRNDate();
			$cmpid	= $pcls->getCompanyID();
			$finyr	= getFinancialYear($pdt);
			
			$narr		= "GRN# ".$pcls->getGRNNo().'/'.$pcls->getFinYear();
			
			$totval	= 0;			
				
			try {
			
				$this->conn->beginTransaction();
				
				$this->conn->exec("DELETE FROM `gen_grn_items` WHERE `GRNID`='$pid'");
				$delsql4	= "DELETE FROM `asys_stock_voucher` WHERE `RelatedID`='$pid' AND `ModuleID`='".GRN."' AND `CompanyID`='".$cmpid."'";
				$this->conn->exec("DELETE FROM `asys_voucher_entry` WHERE `RelatedID`='$pid' AND `TxnType`='".GRN."' AND `CompanyID`='".$cmpid."'");
				
				$stkcls		= array();

				
				$itmList	= $pcls->getItemList();
				for($i=0;$i<count($itmList);$i++) {
					$icls	=	$itmList[$i];
					$icls->setGRNID($pid);

					$sql		= $icls->getInsertSQL();
					$this->conn->exec($sql);
					
					/* Stock entries */
					
					$xtraPerUnit	= 0;
					
					$lcqty	= $this->getLastStockClosingQuantityForUpdate($cmpid, $pcls->getStoreID(), $icls->getItemID(), $pdt, GRN, $pid);
					$lcval	= $this->getLastStockClosingValueForUpdate($cmpid, $pcls->getStoreID(), $icls->getItemID(), $pdt, GRN, $pid);
					$lbald	= $this->getLastBalanceDetailForUpdate($cmpid, $pcls->getStoreID(), $icls->getItemID(), $pdt, GRN, $pid);
				
					$cqty		= $lcqty + $icls->getQuantity();
					$cval		= $lcval + ($icls->getAmount() + $xtraPerUnit);
					$bald		= $lbald;
					if($bald != "") $bald = $bald.",";
					$bald		= $bald.$icls->getQuantity()."=".($icls->getAmount()/$icls->getQuantity() + $xtraPerUnit);
					
					$totval	= $totval + $icls->getAmount();
				
					$scls		= new asys_stock_voucher();
					$scls->setCompanyID($pcls->getCompanyID());
					$scls->setStoreID($pcls->getStoreID());
					$scls->setModuleID(GRN);
					$scls->setFinYear($pcls->getFinYear());
					$scls->setRelatedID($pid);
					$scls->setDOT($pcls->getGRNDate('yes'));
					$scls->setTOT(time());
					$scls->setItemID($icls->getItemID());
					$scls->setItemCategoryID($this->getItemCategoryByItemID($icls->getItemID()));
					$scls->setQuantity($icls->getQuantity());
					$scls->setUnitPrice($icls->getRate());
					$scls->setStockInOut(STOCK_IN);
					$scls->setClosingQty($cqty);
					$scls->setClosingValue($cval);
					$scls->setBatchNo("");
					$scls->setNarration($narr);
					$scls->setBalanceDetail($bald);
				
					$stkcls[]	= $scls;
					
					/* Stock entry ends here */
				}
				
				$this->conn->exec($delsql4);
				for($i=0;$i<count($stkcls);$i++) {
					$scls		= $stkcls[$i];
					$scls->setSVoucherID($this->getNextID("asys_stock_voucher","SVoucherID"));
					$this->conn->exec($scls->getInsertSQL());
				}				
				
				$sql	= $pcls->getUpdateSQL();
				$this->conn->exec($sql);
				
				/* Voucher entry for Store */
				
				$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
				$VoucherNo	= $this->getMaxVoucherNo(JOURNAL_VOUCHER, $finyr, $cmpid);
				$DayWiseNo	= $this->getMaxDayWiseVoucherNo(JOURNAL_VOUCHER, $pdt, $cmpid);
				
				$storeDet		= $this->getStoreDetail($pcls->getStoreID());
				if($storeDet->getAccountID() != 0)
					$aDet		= $this->getAccountDetail($storeDet->getAccountID());
				else
					$aDet		= $this->getAccountDetail($storeDet->getMotherAccountID());

				$vcls1		=	new asys_voucher_entry();
				$vcls1->setSerialID(1);
				$vcls1->setCompanyID($cmpid);
				$vcls1->setVoucherType(JOURNAL_VOUCHER);
				$vcls1->setFinYear($finyr);
				$vcls1->setVoucherNo($VoucherNo);
				$vcls1->setDayWiseNo($DayWiseNo);
				$vcls1->setDOV($pcls->getGRNDate('yes'));
				$vcls1->setMotherAccount($aDet->getMotherAccount());
				$vcls1->setAccountID($aDet->getAccountID());
				$vcls1->setRelatedID($pid);
				$vcls1->setTxnType(GRN);
				$vcls1->setDrCr(DEBIT);
				$vcls1->setAmount($totval);
				$vcls1->setNarration($narr);
				$vcls1->setUserID($tuser->getUserID());
				$vcls1->setDOE(date('d-m-Y'));
				
				
				$aDet		= $this->getAccountDetail($storeDet->getOppositeAccountID());
				
				$vcls2		=	new asys_voucher_entry();
				$vcls2->setSerialID(2);
				$vcls2->setCompanyID($cmpid);
				$vcls2->setVoucherType(JOURNAL_VOUCHER);
				$vcls2->setFinYear($finyr);
				$vcls2->setVoucherNo($VoucherNo);
				$vcls2->setDayWiseNo($DayWiseNo);
				$vcls2->setDOV($pcls->getGRNDate('yes'));
				$vcls2->setMotherAccount($aDet->getMotherAccount());
				$vcls2->setAccountID($aDet->getAccountID());
				$vcls2->setRelatedID($pid);
				$vcls2->setTxnType(GRN);
				$vcls2->setDrCr(CREDIT);
				$vcls2->setAmount($totval);
				$vcls2->setNarration($narr);
				$vcls2->setUserID($tuser->getUserID());
				$vcls2->setDOE(date('d-m-Y'));
			
				$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
				$vcls1->setVoucherID($vid);
				$vcls2->setVoucherID($vid);
				$this->conn->exec($vcls1->getInsertSQL());	
				$this->conn->exec($vcls2->getInsertSQL());								
				
				/* Voucher entry for Store ends here */				
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'purchasedb UpdateGRN '.$er->getMessage();
				_errorLog($err);
				$pid	= -1;
				
			}


			return $pid;
			
		}
		
		function getGRNListForTagging($CompanyID) {
			$arr				=	array();
			$CompanyID	= (int)$CompanyID;
			
			try {
			
				$sql			= "SELECT GROUP_CONCAT( IF(`GRNs`='', null, `GRNs`) ) FROM `gen_purchase` WHERE `CompanyID`='$CompanyID'";
				$res			= (string)$this->getResultExecutingQuery($sql);
				
				if($res != "")
					$sql			=	"SELECT * FROM `gen_grn` WHERE `CompanyID`='$CompanyID' AND `GRNID` NOT IN(".$res.") ORDER BY `GRNNo`";
				else
					$sql			=	"SELECT * FROM `gen_grn` WHERE `CompanyID`='$CompanyID' ORDER BY `GRNNo`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_grn');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setSupplierName($this->getAccountNameByAccountID($row->getSupplierID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemList($this->getGRNItemList($row->getGRNID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getGRNListForTagging '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getGRNListReport($CompanyID, $From, $To, $SupplierID) {
			$arr				=	array();
			$CompanyID	= (int)$CompanyID;
			$From				= addslashes($From);
			$To					= addslashes($To);
			$SupplierID	= (int)$SupplierID;
			
			try {
				
				$sql			=	"SELECT * FROM `gen_grn` WHERE `CompanyID`='$CompanyID'";
				if($From != "" && $From != "1900-01-01")
					$sql		= $sql." AND `GRNDate`>='$From'";
				if($To != "" && $To != "1900-01-01")
					$sql		= $sql." AND `GRNDate`<='$To'";
				if($SupplierID != 0)
					$sql		= $sql." AND `SupplierID`='$SupplierID'";
				$sql			= $sql." ORDER BY `GRNDate`, `GRNNo`";
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_grn');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setSupplierName($this->getAccountNameByAccountID($row->getSupplierID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemList($this->getGRNItemList($row->getGRNID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getGRNListReport '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getGRNItemQuantity($CompanyID, $From, $To, $SupplierID) {
			$arr				=	array();
			$CompanyID	= (int)$CompanyID;
			$From				= addslashes($From);
			$To					= addslashes($To);
			$SupplierID	= (int)$SupplierID;
			
			try {
				
				$sql			=	"SELECT `a`.`ItemID`, SUM(`a`.`Quantity`), SUM(`a`.`Amount`) FROM `gen_grn_items` `a` INNER JOIN `gen_grn` `b` ON `a`.`GRNID`=`b`.`GRNID` WHERE `b`.`CompanyID`='$CompanyID'";
				if($From != "" && $From != "1900-01-01")
					$sql		= $sql." AND `b`.`GRNDate`>='$From'";
				if($To != "" && $To != "1900-01-01")
					$sql		= $sql." AND `b`.`GRNDate`<='$To'";
				if($SupplierID != 0)
					$sql		= $sql." AND `b`.`SupplierID`='$SupplierID'";
				$sql			= $sql." GROUP BY `a`.`ItemID`";
				
				$result		= $this->conn->query($sql);
				while($row = $result->fetch()) {
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getGRNItemQuantity '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}				
		
		
		
		/*-----------------------------------------------------------*/
		/*********************** STOCK METHODS ***********************/
		
		function getLastStockClosingQuantity($CompanyID, $StoreID, $ItemID, $DateAsOn) {
			$CompanyID	= (int)$CompanyID;
			$StoreID		= (int)$StoreID;
			$ItemID			= (int)$ItemID;
			$DateAsOn		= addslashes($DateAsOn);
			if($DateAsOn == "")
				$DateAsOn = "3000-01-01";
			$qty				= 0;
			
			try {	
			
				
				$sql	=	"SELECT `ClosingQty` FROM `asys_stock_voucher` WHERE `CompanyID`='".$CompanyID."' AND `StoreID`='".$StoreID."' AND `ItemID`='".$ItemID."' AND `DOT`<='".$DateAsOn."' ORDER BY `DOT` DESC, `StockInOut`, `ModuleID` DESC, `RelatedID` DESC LIMIT 1";
				
				$result1	= $this->conn->query($sql);
				if($row1 = $result1->fetch()) {
					$qty	=	$row1[0];
				}

				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}				

			return $qty;
		}
		
		function getCategoryWiseLastStockClosingQuantity($CompanyID, $StoreID, $ItemCategoryID, $DateAsOn) {
			$CompanyID	= (int)$CompanyID;
			$StoreID		= (int)$StoreID;
			$ItemCategoryID		= (int)$ItemCategoryID;
			$DateAsOn		= addslashes($DateAsOn);
			if($DateAsOn == "")
				$DateAsOn = "3000-01-01";
			$qty				= 0;
			
			try {		
			
				
				$sql	=	"SELECT `ClosingQty` FROM `asys_stock_voucher` WHERE `CompanyID`='".$CompanyID."' AND `StoreID`='".$StoreID."' AND `DOT`<='".$DateAsOn."'";
				if($ItemCategoryID > 0)
					$sql	= $sql." AND `ItemCategoryID`='".$ItemCategoryID."'";
					
				$sql		= $sql." ORDER BY `DOT` DESC, `StockInOut`, `ModuleID` DESC, `RelatedID` DESC";
				
				$result1	= $this->conn->query($sql);
				while($row1 = $result1->fetch()) {
					$qty	=	$qty + $row1[0];
				}

				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}				

			return $qty;
		}		
		
		function getLastStockClosingQuantityForUpdate($CompanyID, $StoreID, $ItemID, $DateAsOn, $ModuleID = 0, $RelatedID = 0) {
			$CompanyID	= (int)$CompanyID;
			$StoreID		= (int)$StoreID;
			$ItemID			= (int)$ItemID;
			$ModuleID		= (int)$ModuleID;
			$RelatedID	= (int)$RelatedID;			
			$DateAsOn		= addslashes($DateAsOn);
			if($DateAsOn == "")
				$DateAsOn = "3000-01-01";
			$qty				= 0;
			$chk				= 0;
			
			try {		
			
				
				$sql	=	"SELECT `ModuleID`, `RelatedID`, `ClosingQty` FROM `asys_stock_voucher` WHERE `CompanyID`='".$CompanyID."' AND `StoreID`='".$StoreID."' AND `ItemID`='".$ItemID."' AND `DOT`<='".$DateAsOn."' ORDER BY `DOT` DESC, `StockInOut`, `ModuleID` DESC, `RelatedID` DESC";
				
				$result1	= $this->conn->query($sql);
				while($row1 = $result1->fetch()) {

					$mid	= $row1[0];
					$rid	= $row1[1];					
					$qty	=	$row1[2];

					if($chk == 1) break;

					if($mid == $ModuleID && $rid == $RelatedID) $chk = 1;
					$qty	= 0;					
				}

				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}				

			return $qty;
		}
		
		function getLastStockClosingQuantityForUpdate2($CompanyID, $StoreID, $ItemID, $DateAsOn, $ModuleID = 0, $SVoucherID = 0) {
			$CompanyID	= (int)$CompanyID;
			$StoreID		= (int)$StoreID;
			$ItemID			= (int)$ItemID;
			$ModuleID		= (int)$ModuleID;
			$SVoucherID	= (int)$SVoucherID;			
			$DateAsOn		= addslashes($DateAsOn);
			if($DateAsOn == "")
				$DateAsOn = "3000-01-01";
			$qty				= 0;
			$chk				= 0;
			
			try {		
			
				
				$sql	=	"SELECT `ModuleID`, `SVoucherID`, `ClosingQty` FROM `asys_stock_voucher` WHERE `CompanyID`='".$CompanyID."' AND `StoreID`='".$StoreID."' AND `ItemID`='".$ItemID."' AND `DOT`<='".$DateAsOn."' ORDER BY `DOT` DESC, `StockInOut`, `ModuleID` DESC, `RelatedID` DESC";
				
				$result1	= $this->conn->query($sql);
				while($row1 = $result1->fetch()) {
					$mid	= $row1[0];
					$rid	= $row1[1];					
					$qty	=	$row1[2];
					
					if($chk == 1) break;
					
					if($mid == $ModuleID && $rid == $SVoucherID) $chk = 1;
					$qty	= 0;
				}

				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}				

			return $qty;
		}
		
		function getLastStockClosingValue($CompanyID, $StoreID, $ItemID, $DateAsOn) {
			$CompanyID	= (int)$CompanyID;
			$StoreID		= (int)$StoreID;
			$ItemID			= (int)$ItemID;
			$DateAsOn		= addslashes($DateAsOn);
			if($DateAsOn == "")
				$DateAsOn = "3000-01-01";
			$val				= 0;
			
			try {		
			
				
				$sql	=	"SELECT `ClosingValue` FROM `asys_stock_voucher` WHERE `CompanyID`='".$CompanyID."' AND `StoreID`='".$StoreID."' AND `ItemID`='".$ItemID."' AND `DOT`<='".$DateAsOn."' ORDER BY `DOT` DESC, `StockInOut`, `ModuleID` DESC, `RelatedID` DESC LIMIT 1";
				
				$result1	= $this->conn->query($sql);
				if($row1 = $result1->fetch()) {
					$val	=	$row1[0];
				}

				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}				

			return $val;
		}
		
		function getCategoryWiseLastStockClosingValue($CompanyID, $StoreID, $ItemCategoryID, $DateAsOn) {
			$CompanyID	= (int)$CompanyID;
			$StoreID		= (int)$StoreID;
			$ItemCategoryID		= (int)$ItemCategoryID;
			$DateAsOn		= addslashes($DateAsOn);
			if($DateAsOn == "")
				$DateAsOn = "3000-01-01";
			$val				= 0;
			
			try {		
			
				
				$sql	=	"SELECT `ClosingValue` FROM `asys_stock_voucher` WHERE `CompanyID`='".$CompanyID."' AND `StoreID`='".$StoreID."' AND `DOT`<='".$DateAsOn."'";
				if($ItemCategoryID > 0)
					$sql	= $sql." AND `ItemCategoryID`='".$ItemCategoryID."'";
				$sql		= $sql." ORDER BY `DOT` DESC, `StockInOut`, `ModuleID` DESC, `RelatedID` DESC";
				
				$result1	= $this->conn->query($sql);
				while($row1 = $result1->fetch()) {
					$val	=	$val + $row1[0];
				}
				
				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}				

			return $val;
		}		
		
		function getLastStockClosingValueForUpdate($CompanyID, $StoreID, $ItemID, $DateAsOn, $ModuleID = 0, $RelatedID = 0) {
			$CompanyID	= (int)$CompanyID;
			$StoreID		= (int)$StoreID;
			$ItemID			= (int)$ItemID;
			$ModuleID		= (int)$ModuleID;
			$RelatedID	= (int)$RelatedID;			
			$DateAsOn		= addslashes($DateAsOn);
			if($DateAsOn == "")
				$DateAsOn = "3000-01-01";
			$val				= 0;
			$chk				= 0;
			
			try {	
			
				
				$sql	=	"SELECT `ModuleID`, `RelatedID`, `ClosingValue` FROM `asys_stock_voucher` WHERE `CompanyID`='".$CompanyID."' AND `StoreID`='".$StoreID."' AND `ItemID`='".$ItemID."' AND `DOT`<='".$DateAsOn."' ORDER BY `DOT` DESC, `StockInOut`, `ModuleID` DESC, `RelatedID` DESC";
				
				$result1	= $this->conn->query($sql);
				while($row1 = $result1->fetch()) {
					$mid	= $row1[0];
					$rid	= $row1[1];				
					$val	=	$row1[2];
					
					if($chk == 1)  break;
					
					if($mid == $ModuleID && $rid == $RelatedID) $chk = 1;
					$val	= 0;
				}

				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}				

			return $val;
		}
		
		function getLastStockClosingValueForUpdate2($CompanyID, $StoreID, $ItemID, $DateAsOn, $ModuleID = 0, $SVoucherID = 0) {
			$CompanyID	= (int)$CompanyID;
			$StoreID		= (int)$StoreID;
			$ItemID			= (int)$ItemID;
			$ModuleID		= (int)$ModuleID;
			$SVoucherID	= (int)$SVoucherID;			
			$DateAsOn		= addslashes($DateAsOn);
			if($DateAsOn == "")
				$DateAsOn = "3000-01-01";
			$val				= 0;
			$chk				= 0;
			
			try {		
			
				
				$sql	=	"SELECT `ModuleID`, `SVoucherID`, `ClosingValue` FROM `asys_stock_voucher` WHERE `CompanyID`='".$CompanyID."' AND `StoreID`='".$StoreID."' AND `ItemID`='".$ItemID."' AND `DOT`<='".$DateAsOn."' ORDER BY `DOT` DESC, `StockInOut`, `ModuleID` DESC, `RelatedID` DESC";
				
				$result1	= $this->conn->query($sql);
				while($row1 = $result1->fetch()) {
					$mid	= $row1[0];
					$rid	= $row1[1];				
					$val	=	$row1[2];
					
					if($chk == 1) break;
					
					if($mid == $ModuleID && $rid == $SVoucherID) $chk = 1;
					$val	= 0;
				}

				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}				

			return $val;
		}
		
		function getLastBalanceDetail($CompanyID, $StoreID, $ItemID, $DateAsOn) {
			$CompanyID	= (int)$CompanyID;
			$StoreID		= (int)$StoreID;
			$ItemID			= (int)$ItemID;
			$DateAsOn		= addslashes($DateAsOn);
			if($DateAsOn == "")
				$DateAsOn = "3000-01-01";
			$bald				= "";
			
			try {
			
				
				$sql	=	"SELECT `BalanceDetail` FROM `asys_stock_voucher` WHERE `CompanyID`='".$CompanyID."' AND `StoreID`='".$StoreID."' AND `ItemID`='".$ItemID."' AND `DOT`<='".$DateAsOn."' ORDER BY `DOT` DESC, `StockInOut`, `ModuleID` DESC, `RelatedID` DESC LIMIT 1";
				
				$result1	= $this->conn->query($sql);
				if($row1 = $result1->fetch()) {
					$bald	=	$row1[0];
				}

				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}				

			return $bald;
		}
		
		function getLastBalanceDetailForUpdate($CompanyID, $StoreID, $ItemID, $DateAsOn, $ModuleID = 0, $RelatedID = 0) {
			$CompanyID	= (int)$CompanyID;
			$StoreID		= (int)$StoreID;
			$ItemID			= (int)$ItemID;
			$ModuleID		= (int)$ModuleID;
			$RelatedID	= (int)$RelatedID;			
			$DateAsOn		= addslashes($DateAsOn);
			if($DateAsOn == "")
				$DateAsOn = "3000-01-01";
			$bald				= "";
			$chk				= 0;
			
			try {
			
				
				$sql	=	"SELECT `ModuleID`, `RelatedID`, `BalanceDetail` FROM `asys_stock_voucher` WHERE `CompanyID`='".$CompanyID."' AND `StoreID`='".$StoreID."' AND `ItemID`='".$ItemID."' AND `DOT`<='".$DateAsOn."' ORDER BY `DOT` DESC, `StockInOut`, `ModuleID` DESC, `RelatedID` DESC";
				
				$result1	= $this->conn->query($sql);
				while($row1 = $result1->fetch()) {
					$mid	= $row1[0];
					$rid	= $row1[1];
					$bald	=	$row1[2];
					
					if($chk == 1) break;
					
					if($mid == $ModuleID && $rid == $RelatedID) $chk = 1;
					$bald	= "";
				}

				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}				

			return $bald;
		}
		
		function getLastBalanceDetailForUpdate2($CompanyID, $StoreID, $ItemID, $DateAsOn, $ModuleID = 0, $SVoucherID = 0) {
			$CompanyID	= (int)$CompanyID;
			$StoreID		= (int)$StoreID;
			$ItemID			= (int)$ItemID;
			$ModuleID		= (int)$ModuleID;
			$SVoucherID	= (int)$SVoucherID;			
			$DateAsOn		= addslashes($DateAsOn);
			if($DateAsOn == "")
				$DateAsOn = "3000-01-01";
			$bald				= "";
			$chk				= 0;
			
			try {
			
				
				$sql	=	"SELECT `ModuleID`, `SVoucherID`, `BalanceDetail` FROM `asys_stock_voucher` WHERE `CompanyID`='".$CompanyID."' AND `StoreID`='".$StoreID."' AND `ItemID`='".$ItemID."' AND `DOT`<='".$DateAsOn."' ORDER BY `DOT` DESC, `StockInOut`, `ModuleID` DESC, `RelatedID` DESC";
				
				$result1	= $this->conn->query($sql);
				while($row1 = $result1->fetch()) {
					$mid	= $row1[0];
					$rid	= $row1[1];
					$bald	=	$row1[2];
					
					if($chk == 1) break;
					
					if($mid == $ModuleID && $rid == $SVoucherID) $chk = 1;
					$bald	= "";
				}
				
				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}				

			return $bald;
		}
		
		function reCalculateStockClosingQuantityValueBalance($CompanyID, $StoreID, $DateFrom, $DateTo) {
			
			$CompanyID	= (int)$CompanyID;
			$StoreID		= (int)$StoreID;
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			
			try {

				
				$sql	=	"SELECT DISTINCT(`ItemID`) FROM `asys_stock_voucher` WHERE `CompanyID`='".$CompanyID."' AND `StoreID`='".$StoreID."' AND `DOT`>='".$DateFrom."' AND `DOT`<='".$DateTo."'";
				$resulti		= $this->conn->query($sql);
				while($rowi = $resulti->fetch()) {
					
					$iid	= $rowi[0];
					
					$sql	=	"SELECT * FROM `asys_stock_voucher` WHERE `CompanyID`='".$CompanyID."' AND `StoreID`='".$StoreID."' AND `ItemID`='".$iid."' AND `DOT`>='".$DateFrom."' AND `DOT`<='".$DateTo."' ORDER BY `DOT`, `StockInOut` DESC, `ModuleID`, `RelatedID`, `SVoucherID`";
				
					$pdt				= getPreviousDate($DateFrom);
					$pcqty			= $this->getLastStockClosingQuantity($CompanyID, $StoreID, $iid, $pdt);
					$pcval			= $this->getLastStockClosingValue($CompanyID, $StoreID, $iid, $pdt);
					$pbald			= $this->getLastBalanceDetail($CompanyID, $StoreID, $iid, $pdt);
					$result1		= $this->conn->query($sql);
					while($row1 = $result1->fetch()) {
						$svid			= $row1['SVoucherID'];
						$qty			=	$row1['Quantity'];
						$uprc			= $row1['UnitPrice'];
						$sinout		= $row1['StockInOut'];
					
						$cqty			= 0;
						$cval			= 0;
						$bald			= "";
						$val			= 0;
					
						/* Closing Quantity */
						if($sinout == STOCK_IN)
							$cqty		= $pcqty + $qty;
						else
							$cqty		= $pcqty - $qty;
						/* Closing Quantity ends here */
						
						/* Balance string */
						if($pbald == "") {
					
							if($sinout == STOCK_IN) {
								$bald	= $qty.'='.$uprc;
							} else {
								$bald	= -$qty.'='.$uprc;
							}
						
						} else {
					
							if($sinout == STOCK_IN) {
								$bald	= $pbald.",".$qty.'='.$uprc;
							} else {
							
								$bqty			= 0;
								$Quantity	= $qty;
								$tmp1			= explode(",", $pbald);
								for($i=0;$i<count($tmp1);$i++) {
									$tmp2		= $tmp1[$i];
									$tmp		= explode("=", $tmp2);
									$sqty		= (double)$tmp[0];
									$sprc		= (double)$tmp[1];
									if($sqty > $Quantity) {
										$bqty	= $sqty - $Quantity;
										$val	= $val + ($Quantity * $sprc);
										break;
									} else {
										$Quantity	= $Quantity - $sqty;
										$val			= $val + ($sqty * $sprc);
									}
								}
								
								for($j=$i;$j<count($tmp1);$j++) {
									$tmp2		= $tmp1[$j];
									$tmp		= explode("=", $tmp2);
									$sqty		= (double)$tmp[0];
									$sprc		= (double)$tmp[1];
									if($j == $i) {
										if($bqty > 0) $sqty = $bqty;
									}
									
									if($bald != "") $bald = $bald.",";
									$bald		= $bald.$sqty.'='.$sprc;
								}
								
							} /* Balance string generation ends here */
												
						}
						
						/* Closing Value */
						$tmp1			= explode(",", $bald);
						for($i=0;$i<count($tmp1);$i++) {
							$tmp2		= $tmp1[$i];
							if($tmp2 == "") continue;
							$tmp		= explode("=", $tmp2);
							$sqty		= (double)$tmp[0];
							$sprc		= (double)$tmp[1];
							
							$cval		= $cval	+ ($sqty * $sprc);
						}
						/* Closing value ends here */
					
						$pcqty			= $cqty;
						$pcval			= $cval;
						$pbald			= $bald;
						
						
						/* Update values in DB */
						if($sinout == STOCK_OUT)
							$uprc		= $val/$qty;
						$sql		= "UPDATE `asys_stock_voucher` SET `UnitPrice`='".$uprc."', `ClosingQty`= '".$cqty."', `ClosingValue` = '".$cval."', `BalanceDetail`='".$bald."' WHERE `SVoucherID`='".$svid."'";
						$this->conn->exec($sql);
					
					} /* Inner while loop (stock voucher) ends here */
					
				} /* Outer while loop (item) ends here */

				
			} catch(PDOException $e) {
				echo $e->getMessage();
			}			
		}
		
		function getTotalStockClosingValueCategoryWise($CompanyID, $StoreID, $ItemCategoryID, $DateAsOn) {
			
			$CompanyID			= (int)$CompanyID;
			$StoreID				= (int)$StoreID;
			$ItemCategoryID	= (int)$ItemCategoryID;
			$DateAsOn				= addslashes($DateAsOn);
			if($DateAsOn == "")
				$DateAsOn = "3000-01-01";
				
			$cval				= 0;

			if($ItemCategoryID == 0) {
				$sql		= "SELECT `ItemID`,`ClosingValue` FROM `asys_stock_voucher` WHERE `CompanyID`='".$CompanyID."' AND `StoreID`='".$StoreID."' AND `DOT`<='".$DateAsOn."' ORDER BY `ItemID`, `DOT` DESC, `StockInOut`, `ModuleID` DESC, `RelatedID` DESC, `SVoucherID` DESC";
			} else {
				$sql		= "SELECT `ItemID`,`ClosingValue` FROM `asys_stock_voucher` WHERE `CompanyID`='".$CompanyID."' AND `StoreID`='".$StoreID."' AND `ItemCategoryID`='".$ItemCategoryID."' AND `DOT`<='".$DateAsOn."' ORDER BY `ItemID`, `DOT` DESC, `StockInOut`, `ModuleID` DESC, `RelatedID` DESC, `SVoucherID` DESC";
			}
			
			try {
				
				$result		= $this->conn->query($sql);
				$pid			= 0;
				while($row = $result->fetch()) {
					$iid		= $row[0];
					if($iid == $pid) continue;
					$cval		= $cval + $row[1];
					$pid		= $iid;
					/*echo $row[0].' = '.$row[1].'<br />';*/
				}				
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getTotalStockClosingValueCategoryWise '.$e->getMessage();
				_errorLog($err);
			}							

			return $cval;
		}
		
		function getStockVoucherList($DateFrom, $DateTo, $StoreID, $ItemID, $CompanyID) {
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$StoreID		= (int)$StoreID;
			$ItemID			= (int)$ItemID;
			$CompanyID	= (int)$CompanyID;

			$sql	=	"SELECT * FROM `asys_stock_voucher` WHERE `CompanyID`='$CompanyID'";
			if($DateFrom != '' && $DateFrom != '1900-01-01')
				$sql	=	$sql." AND `DOT` >= '$DateFrom'";
			if($DateTo != '' && $DateTo != '1900-01-01')
				$sql	=	$sql." AND `DOT` <= '$DateTo'";
			if($StoreID > 0)
				$sql	=	$sql." AND `StoreID` = '$StoreID'";
			if($ItemID > 0)
				$sql	=	$sql." AND `ItemID` = '$ItemID'";
				
			$sql			=	$sql." ORDER BY `DOT`, `StockInOut` DESC, `ModuleID`, `RelatedID`";

			$arr	=	array();
			
			try {

				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_stock_voucher');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemName($this->getItemNameByItemID($row->getItemID()));
					$arr[]	= $row;
				}
				

			} catch(PDOException $e) {
				$err	= 'purchasedb getStockVoucherList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getDistinctItemList($DateFrom, $DateTo, $StoreID, $CompanyID) {
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$StoreID		= (int)$StoreID;
			$CompanyID	= (int)$CompanyID;

			$sql	=	"SELECT DISTINCT(`ItemID`) FROM `asys_stock_voucher` WHERE `CompanyID`='$CompanyID'";
			if($DateFrom != '' && $DateFrom != '1900-01-01')
				$sql	=	$sql." AND `DOT` >= '$DateFrom'";
			if($DateTo != '' && $DateTo != '1900-01-01')
				$sql	=	$sql." AND `DOT` <= '$DateTo'";
			if($StoreID > 0)
				$sql	=	$sql." AND `StoreID` = '$StoreID'";
				
			$sql			=	$sql." ORDER BY `ItemID`";

			return $this->getRecordsetExecutingQuery($sql);
		}
		
		function getStockINTotal($DateFrom, $DateTo, $StoreID, $ItemID, $CompanyID) {
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$StoreID		= (int)$StoreID;
			$ItemID			= (int)$ItemID;
			$CompanyID	= (int)$CompanyID;
			
			$sql	=	"SELECT `Quantity`, `UnitPrice` FROM `asys_stock_voucher` WHERE `StockInOut`='".STOCK_IN."' AND `CompanyID`='".$CompanyID."'";
			if($DateFrom != '' && $DateFrom != '1900-01-01')
				$sql	=	$sql." AND `DOT` >= '$DateFrom'";
			if($DateTo != '' && $DateTo != '1900-01-01')
				$sql	=	$sql." AND `DOT` <= '$DateTo'";
			if($StoreID > 0)
				$sql	=	$sql." AND `StoreID` = '$StoreID'";
			if($ItemID > 0)
				$sql	=	$sql." AND `ItemID` = '$ItemID'";
				
			$sql			=	$sql." ORDER BY `DOT`, `SVoucherID`";

			$qty	=	0;
			$val	= 0;
			$arr	= array(0,0);
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_ASSOC);
				while($row = $result->fetch()) {
					$qty	= $qty + $row['Quantity'];
					$val	= $val + ($row['Quantity'] * $row['UnitPrice']);
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getStockINTotal '.$e->getMessage();
				_errorLog($err);
			}
			
			$arr[0] = $qty;
			$arr[1]	= $val;

			return $arr;
		}
		
		function getCategoryWiseStockINTotal($DateFrom, $DateTo, $StoreID, $ItemCategoryID, $CompanyID) {
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$StoreID		= (int)$StoreID;
			$ItemCategoryID			= (int)$ItemCategoryID;
			$CompanyID	= (int)$CompanyID;
			
			$sql	=	"SELECT `Quantity`, `UnitPrice` FROM `asys_stock_voucher` WHERE `StockInOut`='".STOCK_IN."' AND `CompanyID`='".$CompanyID."'";
			if($DateFrom != '' && $DateFrom != '1900-01-01')
				$sql	=	$sql." AND `DOT` >= '$DateFrom'";
			if($DateTo != '' && $DateTo != '1900-01-01')
				$sql	=	$sql." AND `DOT` <= '$DateTo'";
			if($StoreID > 0)
				$sql	=	$sql." AND `StoreID` = '$StoreID'";
			if($ItemCategoryID > 0)
				$sql	=	$sql." AND `ItemCategoryID` = '$ItemCategoryID'";
				
			$sql			=	$sql." ORDER BY `DOT`, `SVoucherID`";

			$qty	=	0;
			$val	= 0;
			$arr	= array(0,0);
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_ASSOC);
				while($row = $result->fetch()) {
					$qty	= $qty + $row['Quantity'];
					$val	= $val + ($row['Quantity'] * $row['UnitPrice']);
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getStockINTotal '.$e->getMessage();
				_errorLog($err);
			}
			
			$arr[0] = $qty;
			$arr[1]	= $val;

			return $arr;
		}
		
		function getStockOUTTotal($DateFrom, $DateTo, $StoreID, $ItemID, $CompanyID) {
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$StoreID		= (int)$StoreID;
			$ItemID			= (int)$ItemID;
			$CompanyID	= (int)$CompanyID;
			
			$sql	=	"SELECT `Quantity`, `UnitPrice` FROM `asys_stock_voucher` WHERE `StockInOut`='".STOCK_OUT."' AND `CompanyID`='$CompanyID'";
			if($DateFrom != '' && $DateFrom != '1900-01-01')
				$sql	=	$sql." AND `DOT` >= '$DateFrom'";
			if($DateTo != '' && $DateTo != '1900-01-01')
				$sql	=	$sql." AND `DOT` <= '$DateTo'";
			if($StoreID > 0)
				$sql	=	$sql." AND `StoreID` = '$StoreID'";
			if($ItemID > 0)
				$sql	=	$sql." AND `ItemID` = '$ItemID'";
				
			$sql			=	$sql." ORDER BY `DOT`, `SVoucherID`";

			$qty	=	0;
			$val	= 0;
			$arr	= array(0,0);
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_ASSOC);
				while($row = $result->fetch()) {
					$qty	= $qty + $row['Quantity'];
					$val	= $val + ($row['Quantity'] * $row['UnitPrice']);
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getStockOUTTotal '.$e->getMessage();
				_errorLog($err);
			}
			
			$arr[0] = $qty;
			$arr[1]	= $val;

			return $arr;
		}
		
		function getCategoryWiseStockOUTTotal($DateFrom, $DateTo, $StoreID, $ItemCategoryID, $CompanyID) {
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$StoreID		= (int)$StoreID;
			$ItemCategoryID			= (int)$ItemCategoryID;
			$CompanyID	= (int)$CompanyID;
			
			$sql	=	"SELECT `Quantity`, `UnitPrice` FROM `asys_stock_voucher` WHERE `StockInOut`='".STOCK_OUT."' AND `CompanyID`='$CompanyID'";
			if($DateFrom != '' && $DateFrom != '1900-01-01')
				$sql	=	$sql." AND `DOT` >= '$DateFrom'";
			if($DateTo != '' && $DateTo != '1900-01-01')
				$sql	=	$sql." AND `DOT` <= '$DateTo'";
			if($StoreID > 0)
				$sql	=	$sql." AND `StoreID` = '$StoreID'";
			if($ItemCategoryID > 0)
				$sql	=	$sql." AND `ItemCategoryID` = '$ItemCategoryID'";
				
			$sql			=	$sql." ORDER BY `DOT`, `SVoucherID`";

			$qty	=	0;
			$val	= 0;
			$arr	= array(0,0);
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_ASSOC);
				while($row = $result->fetch()) {
					$qty	= $qty + $row['Quantity'];
					$val	= $val + ($row['Quantity'] * $row['UnitPrice']);
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getStockOUTTotal '.$e->getMessage();
				_errorLog($err);
			}
			
			$arr[0] = $qty;
			$arr[1]	= $val;

			return $arr;
		}
		
		function getStockVoucherDetail($SVoucherID) {
			$SVoucherID	= (int)$SVoucherID;
			$cclass			=	new asys_stock_voucher();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_stock_voucher` WHERE `SVoucherID`='$SVoucherID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_stock_voucher');
				if($row 	= $result->fetch()) { 
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemName($this->getItemNameByItemID($row->getItemID()));
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getStockVoucherDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}
		
		function getStockVoucherDetailByModule($CompanyID, $ModuleID, $RelatedID, $ItemID) {
			$CompanyID	= (int)$CompanyID;
			$ModuleID		= (int)$ModuleID;
			$RelatedID	= (int)$RelatedID;
			$ItemID			= (int)$ItemID;
			$cclass			=	new asys_stock_voucher();
			
			try {
				
				$sql			=	"SELECT * FROM `asys_stock_voucher` WHERE `CompanyID`='$CompanyID' AND `ModuleID`='$ModuleID' AND `RelatedID`='$RelatedID' AND `ItemID`='$ItemID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_stock_voucher');
				if($row 	= $result->fetch()) { 
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemName($this->getItemNameByItemID($row->getItemID()));
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getStockVoucherDetailByModule '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}
		
		function getNumberOfManualStockIN($DateFrom, $DateTo, $ItemID, $CompanyID) {
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$ItemID			= (int)$ItemID;
			$CompanyID	= (int)$CompanyID;
			
			$sql	=	"SELECT COUNT(*) FROM `asys_stock_voucher` WHERE `ModuleID`='".MANUAL_STOCK_IN."' AND `CompanyID`='$CompanyID'";
			if($DateFrom != '' && $DateFrom != '1900-01-01')
				$sql	=	$sql." AND `DOT` >= '$DateFrom'";
			if($DateTo != '' && $DateTo != '1900-01-01')
				$sql	=	$sql." AND `DOT` <= '$DateTo'";
			if($ItemID > 0)
				$sql	=	$sql." AND `ItemID` = '$ItemID'";
			
			return $this->getResultExecutingQuery($sql);
		}

		function getManualStockINListPaged($DateFrom, $DateTo, $ItemID, $CompanyID, $sRec, $nRec) {
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$ItemID			= (int)$ItemID;
			$CompanyID	= (int)$CompanyID;
			
			$sql	=	"SELECT * FROM `asys_stock_voucher` WHERE `ModuleID`='".MANUAL_STOCK_IN."' AND `CompanyID`='$CompanyID'";
			if($DateFrom != '' && $DateFrom != '1900-01-01')
				$sql	=	$sql." AND `DOT` >= '$DateFrom'";
			if($DateTo != '' && $DateTo != '1900-01-01')
				$sql	=	$sql." AND `DOT` <= '$DateTo'";
			if($ItemID > 0)
				$sql	=	$sql." AND `ItemID` = '$ItemID'";
				
			$sql			=	$sql." ORDER BY `DOT` DESC, `SVoucherID` LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_stock_voucher');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemName($this->getItemNameByItemID($row->getItemID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getManualStockINListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function CreateManualStockIN($scls) {
			$_sid		= 0;
			$cmpid	= $scls->getCompanyID();
			$pdt		= $scls->getDOT();
			$finyr	= getFinancialYear($pdt);	
			$tuser	=	unserialize($_SESSION["ssEUser"]);
				
			try {
			
				$this->conn->beginTransaction();
					
				/* Stock entries */
				
				$lcqty	= $this->getLastStockClosingQuantity($cmpid, $scls->getStoreID(), $scls->getItemID(), $scls->getDOT());
				$lcval	= $this->getLastStockClosingValue($cmpid, $scls->getStoreID(), $scls->getItemID(), $scls->getDOT());
				$lbald	= $this->getLastBalanceDetail($cmpid, $scls->getStoreID(), $scls->getItemID(), $scls->getDOT());
				
				$cqty		= $lcqty + $scls->getQuantity();
				$cval		= $lcval + ($scls->getQuantity() * $scls->getUnitPrice());
				$bald		= $lbald;
				if($bald != "") $bald = $bald.",";
				$bald		= $bald.$scls->getQuantity()."=".$scls->getUnitPrice();
				
				$scls->setSVoucherID($this->getNextID("asys_stock_voucher","SVoucherID"));
				$scls->setTOT(time());
				$scls->setItemCategoryID($this->getItemCategoryByItemID($scls->getItemID()));
				$scls->setClosingQty($cqty);
				$scls->setClosingValue($cval);
				$scls->setBalanceDetail($bald);
				$sql		= $scls->getInsertSQL();
				$this->conn->exec($sql);
				
				$_sid		= $scls->getSVoucherID();
				
				/* Voucher entry for Store */
			
				$VoucherNo	= $this->getMaxVoucherNo(JOURNAL_VOUCHER, $finyr, $cmpid);
				$DayWiseNo	= $this->getMaxDayWiseVoucherNo(JOURNAL_VOUCHER, $pdt, $cmpid);
				
				$narr		= 'MANUAL STOCK IN# '.$_sid.', '.$scls->getNarration();
			
				$storeDet		= $this->getStoreDetail($scls->getStoreID());
				if($storeDet->getAccountID() != 0)
					$aDet		= $this->getAccountDetail($storeDet->getAccountID());
				else
					$aDet		= $this->getAccountDetail($storeDet->getMotherAccountID());				
			
				$pamt		= $scls->getQuantity() * $scls->getUnitPrice();

				$vcls1		=	new asys_voucher_entry();
				$vcls1->setSerialID(1);
				$vcls1->setCompanyID($cmpid);
				$vcls1->setVoucherType(JOURNAL_VOUCHER);
				$vcls1->setFinYear($finyr);
				$vcls1->setVoucherNo($VoucherNo);
				$vcls1->setDayWiseNo($DayWiseNo);
				$vcls1->setDOV($scls->getDOT('yes'));
				$vcls1->setMotherAccount($aDet->getMotherAccount());
				$vcls1->setAccountID($aDet->getAccountID());
				$vcls1->setRelatedID($_sid);
				$vcls1->setTxnType(MANUAL_STOCK_IN);
				$vcls1->setDrCr(DEBIT);
				$vcls1->setAmount($pamt);
				$vcls1->setNarration($narr);
				$vcls1->setUserID($tuser->getUserID());
				$vcls1->setDOE(date('d-m-Y'));
			
			
				$aDet		= $this->getAccountDetail($storeDet->getOppositeAccountID());
			
				$vcls2		=	new asys_voucher_entry();
				$vcls2->setSerialID(2);
				$vcls2->setCompanyID($cmpid);
				$vcls2->setVoucherType(JOURNAL_VOUCHER);
				$vcls2->setFinYear($finyr);
				$vcls2->setVoucherNo($VoucherNo);
				$vcls2->setDayWiseNo($DayWiseNo);
				$vcls2->setDOV($scls->getDOT('yes'));
				$vcls2->setMotherAccount($aDet->getMotherAccount());
				$vcls2->setAccountID($aDet->getAccountID());
				$vcls2->setRelatedID($_sid);
				$vcls2->setTxnType(MANUAL_STOCK_IN);
				$vcls2->setDrCr(CREDIT);
				$vcls2->setAmount($pamt);
				$vcls2->setNarration($narr);
				$vcls2->setUserID($tuser->getUserID());
				$vcls2->setDOE(date('d-m-Y'));
		
				$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
				$vcls1->setVoucherID($vid);
				$vcls2->setVoucherID($vid);
				$this->conn->exec($vcls1->getInsertSQL());
				$this->conn->exec($vcls2->getInsertSQL());							
			
				/* Voucher entry for Store ends here */				
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'purchasedb CreateManualStockIN '.$er->getMessage();
				_errorLog($err);
				$_sid	= -1;
				
			}


			return $_sid;
			
		}
		
		function UpdateManualStockIN($scls) {
			$_sid		= $scls->getSVoucherID();
			$cmpid	= $scls->getCompanyID();
			$pdt		= $scls->getDOT();
			$finyr	= getFinancialYear($pdt);	
			$tuser	=	unserialize($_SESSION["ssEUser"]);			
			
				
			try {
			
				$this->conn->beginTransaction();
				
				$sql	= "DELETE FROM `asys_voucher_entry` WHERE `RelatedID`='".$_sid."' AND `TxnType`='".MANUAL_STOCK_IN."' AND `CompanyID`='".$cmpid."'";
				$this->conn->exec($sql);
					
				/* Stock entries */
				
				$lcqty	= $this->getLastStockClosingQuantityForUpdate2($cmpid, $scls->getStoreID(), $scls->getItemID(), $scls->getDOT(), MANUAL_STOCK_IN, $_sid);
				$lcval	= $this->getLastStockClosingValueForUpdate2($cmpid, $scls->getStoreID(), $scls->getItemID(), $scls->getDOT(), MANUAL_STOCK_IN, $_sid);
				$lbald	= $this->getLastBalanceDetailForUpdate2($cmpid, $scls->getStoreID(), $scls->getItemID(), $scls->getDOT(), MANUAL_STOCK_IN, $_sid);
				
				$cqty		= $lcqty + $scls->getQuantity();
				$cval		= $lcval + ($scls->getQuantity() * $scls->getUnitPrice());
				$bald		= $lbald;
				if($bald != "") $bald = $bald.",";
				$bald		= $bald.$scls->getQuantity()."=".$scls->getUnitPrice();
				
				$scls->setTOT(time());
				$scls->setItemCategoryID($this->getItemCategoryByItemID($scls->getItemID()));
				$scls->setClosingQty($cqty);
				$scls->setClosingValue($cval);
				$scls->setBalanceDetail($bald);
				$sql		= $scls->getUpdateSQL();
				$this->conn->exec($sql);
				
				/* Voucher entry for Store */

				$VoucherNo	= $this->getMaxVoucherNo(JOURNAL_VOUCHER, $finyr, $cmpid);
				$DayWiseNo	= $this->getMaxDayWiseVoucherNo(JOURNAL_VOUCHER, $pdt, $cmpid);
				
				$narr		= 'MANUAL STOCK IN# '.$_sid.', '.$scls->getNarration();
			
				$storeDet		= $this->getStoreDetail($scls->getStoreID());
				if($storeDet->getAccountID() != 0)
					$aDet		= $this->getAccountDetail($storeDet->getAccountID());
				else
					$aDet		= $this->getAccountDetail($storeDet->getMotherAccountID());				
			
				$pamt		= $scls->getQuantity() * $scls->getUnitPrice();

				$vcls1		=	new asys_voucher_entry();
				$vcls1->setSerialID(1);
				$vcls1->setCompanyID($cmpid);
				$vcls1->setVoucherType(JOURNAL_VOUCHER);
				$vcls1->setFinYear($finyr);
				$vcls1->setVoucherNo($VoucherNo);
				$vcls1->setDayWiseNo($DayWiseNo);
				$vcls1->setDOV($scls->getDOT('yes'));
				$vcls1->setMotherAccount($aDet->getMotherAccount());
				$vcls1->setAccountID($aDet->getAccountID());
				$vcls1->setRelatedID($_sid);
				$vcls1->setTxnType(MANUAL_STOCK_IN);
				$vcls1->setDrCr(DEBIT);
				$vcls1->setAmount($pamt);
				$vcls1->setNarration($narr);
				$vcls1->setUserID($tuser->getUserID());
				$vcls1->setDOE(date('d-m-Y'));
			
			
				$aDet		= $this->getAccountDetail($storeDet->getOppositeAccountID());
			
				$vcls2		=	new asys_voucher_entry();
				$vcls2->setSerialID(2);
				$vcls2->setCompanyID($cmpid);
				$vcls2->setVoucherType(JOURNAL_VOUCHER);
				$vcls2->setFinYear($finyr);
				$vcls2->setVoucherNo($VoucherNo);
				$vcls2->setDayWiseNo($DayWiseNo);
				$vcls2->setDOV($scls->getDOT('yes'));
				$vcls2->setMotherAccount($aDet->getMotherAccount());
				$vcls2->setAccountID($aDet->getAccountID());
				$vcls2->setRelatedID($_sid);
				$vcls2->setTxnType(MANUAL_STOCK_IN);
				$vcls2->setDrCr(CREDIT);
				$vcls2->setAmount($pamt);
				$vcls2->setNarration($narr);
				$vcls2->setUserID($tuser->getUserID());
				$vcls2->setDOE(date('d-m-Y'));
		
				$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
				$vcls1->setVoucherID($vid);
				$vcls2->setVoucherID($vid);
				$this->conn->exec($vcls1->getInsertSQL());
				$this->conn->exec($vcls2->getInsertSQL());								
			
				/* Voucher entry for Store ends here */					
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'purchasedb UpdateManualStockIN '.$er->getMessage();
				_errorLog($err);
				$_sid	= -1;
				
			}
				

			return $_sid;
			
		}
		
		function deleteManualStockIN($scls) {
			$_sid		= $scls->getSVoucherID();
			
			
			try {
			
				$this->conn->beginTransaction();
					
				/* Stock entries */
				
				$sql	= "DELETE FROM `asys_voucher_entry` WHERE `RelatedID`='".$_sid."' AND `TxnType`='".MANUAL_STOCK_IN."' AND `CompanyID`='".$scls->getCompanyID()."'";
				$this->conn->exec($sql);				
				
				$sql		= $scls->getDeleteSQL();
				$this->conn->exec($sql);
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				$err	= 'purchasedb deleteManualStockIN '.$er->getMessage();
				_errorLog($err);					
				$this->conn->rollBack();
				$_sid	= 0;
				
			}


			return $_sid;
		}
		
		function getNumberOfManualStockOUT($DateFrom, $DateTo, $ItemID, $CompanyID) {
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$ItemID			= (int)$ItemID;
			$CompanyID	= (int)$CompanyID;
			
			$sql	=	"SELECT COUNT(*) FROM `asys_stock_voucher` WHERE `ModuleID`='".MANUAL_STOCK_OUT."' AND `CompanyID`='$CompanyID'";
			if($DateFrom != '' && $DateFrom != '1900-01-01')
				$sql	=	$sql." AND `DOT` >= '$DateFrom'";
			if($DateTo != '' && $DateTo != '1900-01-01')
				$sql	=	$sql." AND `DOT` <= '$DateTo'";
			if($ItemID > 0)
				$sql	=	$sql." AND `ItemID` = '$ItemID'";
			
			return $this->getResultExecutingQuery($sql);
		}

		function getManualStockOUTListPaged($DateFrom, $DateTo, $ItemID, $CompanyID, $sRec, $nRec) {
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$ItemID			= (int)$ItemID;
			$CompanyID	= (int)$CompanyID;
			
			$sql	=	"SELECT * FROM `asys_stock_voucher` WHERE `ModuleID`='".MANUAL_STOCK_OUT."' AND `CompanyID`='$CompanyID'";
			if($DateFrom != '' && $DateFrom != '1900-01-01')
				$sql	=	$sql." AND `DOT` >= '$DateFrom'";
			if($DateTo != '' && $DateTo != '1900-01-01')
				$sql	=	$sql." AND `DOT` <= '$DateTo'";
			if($ItemID > 0)
				$sql	=	$sql." AND `ItemID` = '$ItemID'";
				
			$sql			=	$sql." ORDER BY `DOT` DESC, `SVoucherID` LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_stock_voucher');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemName($this->getItemNameByItemID($row->getItemID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getManualStockOUTListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function CreateManualStockOUT($scls) {
			$_sid		= 0;
			$cmpid	= $scls->getCompanyID();
			$pdt		= $scls->getDOT();
			$finyr	= getFinancialYear($pdt);	
			$tuser	=	unserialize($_SESSION["ssEUser"]);			
			
			try {
			
				$this->conn->beginTransaction();
					
				/* Stock entries */
				
				$lcqty	= $this->getLastStockClosingQuantity($cmpid, $scls->getStoreID(), $scls->getItemID(), $scls->getDOT());
				$lcval	= $this->getLastStockClosingValue($cmpid, $scls->getStoreID(), $scls->getItemID(), $scls->getDOT());
				$lbald	= $this->getLastBalanceDetail($cmpid, $scls->getStoreID(), $scls->getItemID(), $scls->getDOT());
				
				$cqty		= $lcqty - $scls->getQuantity();
				$cval		= 0;
				
				$bald			= "";
				$bqty			= 0;
				$val			= 0;
				$cval			= 0;
				$Quantity	= $scls->getQuantity();
				$tmp1			= explode(",", $lbald);
				for($i=0;$i<count($tmp1);$i++) {
					$tmp2		= $tmp1[$i];
					if($tmp2 == "") continue;
					$tmp		= explode("=", $tmp2);
					$sqty		= (double)$tmp[0];
					$sprc		= (double)$tmp[1];
					if($sqty > $Quantity) {
						$bqty	= $sqty - $Quantity;
						$val	= $val + ($Quantity * $sprc);
						break;
					} else {
						$Quantity	= $Quantity - $sqty;
						$val			= $val + ($sqty * $sprc);
					}
				}
				
				for($j=$i;$j<count($tmp1);$j++) {
					$tmp2		= $tmp1[$j];
					if($tmp2 == "") continue;
					$tmp		= explode("=", $tmp2);
					$sqty		= (double)$tmp[0];
					$sprc		= (double)$tmp[1];
					if($j == $i) {
						if($bqty > 0) $sqty = $bqty;
					}
					
					if($bald != "") $bald = $bald.",";
					$bald		= $bald.$sqty.'='.$sprc;
				}
				
				/* Closing Value */
				$tmp1			= explode(",", $bald);
				for($i=0;$i<count($tmp1);$i++) {
					$tmp2		= $tmp1[$i];
					if($tmp2 == "") continue;
					$tmp		= explode("=", $tmp2);
					$sqty		= (double)$tmp[0];
					$sprc		= (double)$tmp[1];
					
					$cval		= $cval	+ ($sqty * $sprc);
				}
				/* Closing value ends here */					
				
				$scls->setSVoucherID($this->getNextID("asys_stock_voucher","SVoucherID"));
				$scls->setTOT(time());
				$scls->setItemCategoryID($this->getItemCategoryByItemID($scls->getItemID()));
				$scls->setUnitPrice($val / $scls->getQuantity());
				$scls->setClosingQty($cqty);
				$scls->setClosingValue($cval);
				$scls->setBalanceDetail($bald);
				$sql		= $scls->getInsertSQL();
				$this->conn->exec($sql);
			
				
				$_sid		= $scls->getSVoucherID();
				
				
				/* Voucher entry for Store */
			
				$VoucherNo	= $this->getMaxVoucherNo(JOURNAL_VOUCHER, $finyr, $cmpid);
				$DayWiseNo	= $this->getMaxDayWiseVoucherNo(JOURNAL_VOUCHER, $pdt, $cmpid);
				
				$narr		= 'MANUAL STOCK OUT# '.$_sid.', '.$scls->getNarration();
			
				$storeDet		= $this->getStoreDetail($scls->getStoreID());
				if($storeDet->getAccountID() != 0)
					$aDet		= $this->getAccountDetail($storeDet->getAccountID());
				else
					$aDet		= $this->getAccountDetail($storeDet->getMotherAccountID());				
			
				$pamt		= $val;

				$vcls1		=	new asys_voucher_entry();
				$vcls1->setSerialID(1);
				$vcls1->setCompanyID($cmpid);
				$vcls1->setVoucherType(JOURNAL_VOUCHER);
				$vcls1->setFinYear($finyr);
				$vcls1->setVoucherNo($VoucherNo);
				$vcls1->setDayWiseNo($DayWiseNo);
				$vcls1->setDOV($scls->getDOT('yes'));
				$vcls1->setMotherAccount($aDet->getMotherAccount());
				$vcls1->setAccountID($aDet->getAccountID());
				$vcls1->setRelatedID($_sid);
				$vcls1->setTxnType(MANUAL_STOCK_OUT);
				$vcls1->setDrCr(CREDIT);
				$vcls1->setAmount($pamt);
				$vcls1->setNarration($narr);
				$vcls1->setUserID($tuser->getUserID());
				$vcls1->setDOE(date('d-m-Y'));
			
			
				$aDet		= $this->getAccountDetail($storeDet->getOppositeAccountID());
			
				$vcls2		=	new asys_voucher_entry();
				$vcls2->setSerialID(2);
				$vcls2->setCompanyID($cmpid);
				$vcls2->setVoucherType(JOURNAL_VOUCHER);
				$vcls2->setFinYear($finyr);
				$vcls2->setVoucherNo($VoucherNo);
				$vcls2->setDayWiseNo($DayWiseNo);
				$vcls2->setDOV($scls->getDOT('yes'));
				$vcls2->setMotherAccount($aDet->getMotherAccount());
				$vcls2->setAccountID($aDet->getAccountID());
				$vcls2->setRelatedID($_sid);
				$vcls2->setTxnType(MANUAL_STOCK_OUT);
				$vcls2->setDrCr(DEBIT);
				$vcls2->setAmount($pamt);
				$vcls2->setNarration($narr);
				$vcls2->setUserID($tuser->getUserID());
				$vcls2->setDOE(date('d-m-Y'));
		
				$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
				$vcls1->setVoucherID($vid);
				$vcls2->setVoucherID($vid);
				$this->conn->exec($vcls1->getInsertSQL());
				$this->conn->exec($vcls2->getInsertSQL());								
			
				/* Voucher entry for Store ends here */	
				
				$this->conn->commit();				
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'purchasedb CreateManualStockOUT '.$er->getMessage();
				_errorLog($err);
				$_sid	= -1;
				
			}


			return $_sid;
			
		}
		
		function UpdateManualStockOUT($scls) {
			$_sid		= $scls->getSVoucherID();
			$cmpid	= $scls->getCompanyID();
			$pdt		= $scls->getDOT();
			$finyr	= getFinancialYear($pdt);	
			$tuser	=	unserialize($_SESSION["ssEUser"]);			
			
			try {
			
				$this->conn->beginTransaction();
				
				$sql	= "DELETE FROM `asys_voucher_entry` WHERE `RelatedID`='".$_sid."' AND `TxnType`='".MANUAL_STOCK_OUT."' AND `CompanyID`='".$cmpid."'";
				$this->conn->exec($sql);				
					
				/* Stock entries */
				
				$lcqty	= $this->getLastStockClosingQuantityForUpdate2($cmpid, $scls->getStoreID(), $scls->getItemID(), $scls->getDOT(), MANUAL_STOCK_OUT, $_sid);
				$lcval	= $this->getLastStockClosingValueForUpdate2($cmpid, $scls->getStoreID(), $scls->getItemID(), $scls->getDOT(), MANUAL_STOCK_OUT, $_sid);
				$lbald	= $this->getLastBalanceDetailForUpdate2($cmpid, $scls->getStoreID(), $scls->getItemID(), $scls->getDOT(), MANUAL_STOCK_OUT, $_sid);
				
				$cqty		= $lcqty - $scls->getQuantity();
				$cval		= 0;
				
				$bald			= "";
				$bqty			= 0;
				$val			= 0;
				$cval			= 0;
				$Quantity	= $scls->getQuantity();
				$tmp1			= explode(",", $lbald);
				for($i=0;$i<count($tmp1);$i++) {
					$tmp2		= $tmp1[$i];
					if($tmp2 == "") continue;
					$tmp		= explode("=", $tmp2);
					$sqty		= (double)$tmp[0];
					$sprc		= (double)$tmp[1];
					if($sqty > $Quantity) {
						$bqty	= $sqty - $Quantity;
						$val	= $val + ($Quantity * $sprc);
						break;
					} else {
						$Quantity	= $Quantity - $sqty;
						$val			= $val + ($sqty * $sprc);
					}
				}
				
				for($j=$i;$j<count($tmp1);$j++) {
					$tmp2		= $tmp1[$j];
					if($tmp2 == "") continue;
					$tmp		= explode("=", $tmp2);
					$sqty		= (double)$tmp[0];
					$sprc		= (double)$tmp[1];
					if($j == $i) {
						if($bqty > 0) $sqty = $bqty;
					}
					
					if($bald != "") $bald = $bald.",";
					$bald		= $bald.$sqty.'='.$sprc;
				}
				
				/* Closing Value */
				$tmp1			= explode(",", $bald);
				for($i=0;$i<count($tmp1);$i++) {
					$tmp2		= $tmp1[$i];
					if($tmp2 == "") continue;
					$tmp		= explode("=", $tmp2);
					$sqty		= (double)$tmp[0];
					$sprc		= (double)$tmp[1];
					
					$cval		= $cval	+ ($sqty * $sprc);
				}
				/* Closing value ends here */					
				
				$scls->setSVoucherID($_sid);
				$scls->setTOT(time());
				$scls->setItemCategoryID($this->getItemCategoryByItemID($scls->getItemID()));
				$scls->setUnitPrice($val / $scls->getQuantity());
				$scls->setClosingQty($cqty);
				$scls->setClosingValue($cval);
				$scls->setBalanceDetail($bald);
				$sql		= $scls->getUpdateSQL();
				$this->conn->exec($sql);
				
				
				/* Voucher entry for Store */
				
				$VoucherNo	= $this->getMaxVoucherNo(JOURNAL_VOUCHER, $finyr, $cmpid);
				$DayWiseNo	= $this->getMaxDayWiseVoucherNo(JOURNAL_VOUCHER, $pdt, $cmpid);
				
				$narr		= 'MANUAL STOCK OUT# '.$_sid.', '.$scls->getNarration();
			
				$storeDet		= $this->getStoreDetail($scls->getStoreID());
				if($storeDet->getAccountID() != 0)
					$aDet		= $this->getAccountDetail($storeDet->getAccountID());
				else
					$aDet		= $this->getAccountDetail($storeDet->getMotherAccountID());				
			
				$pamt		= $val;

				$vcls1		=	new asys_voucher_entry();
				$vcls1->setSerialID(1);
				$vcls1->setCompanyID($cmpid);
				$vcls1->setVoucherType(JOURNAL_VOUCHER);
				$vcls1->setFinYear($finyr);
				$vcls1->setVoucherNo($VoucherNo);
				$vcls1->setDayWiseNo($DayWiseNo);
				$vcls1->setDOV($scls->getDOT('yes'));
				$vcls1->setMotherAccount($aDet->getMotherAccount());
				$vcls1->setAccountID($aDet->getAccountID());
				$vcls1->setRelatedID($_sid);
				$vcls1->setTxnType(MANUAL_STOCK_OUT);
				$vcls1->setDrCr(CREDIT);
				$vcls1->setAmount($pamt);
				$vcls1->setNarration($narr);
				$vcls1->setUserID($tuser->getUserID());
				$vcls1->setDOE(date('d-m-Y'));
			
			
				$aDet		= $this->getAccountDetail($storeDet->getOppositeAccountID());
			
				$vcls2		=	new asys_voucher_entry();
				$vcls2->setSerialID(2);
				$vcls2->setCompanyID($cmpid);
				$vcls2->setVoucherType(JOURNAL_VOUCHER);
				$vcls2->setFinYear($finyr);
				$vcls2->setVoucherNo($VoucherNo);
				$vcls2->setDayWiseNo($DayWiseNo);
				$vcls2->setDOV($scls->getDOT('yes'));
				$vcls2->setMotherAccount($aDet->getMotherAccount());
				$vcls2->setAccountID($aDet->getAccountID());
				$vcls2->setRelatedID($_sid);
				$vcls2->setTxnType(MANUAL_STOCK_OUT);
				$vcls2->setDrCr(DEBIT);
				$vcls2->setAmount($pamt);
				$vcls2->setNarration($narr);
				$vcls2->setUserID($tuser->getUserID());
				$vcls2->setDOE(date('d-m-Y'));
		
				
				$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
				$vcls1->setVoucherID($vid);
				$vcls2->setVoucherID($vid);
				$this->conn->exec($vcls1->getInsertSQL());
				$this->conn->exec($vcls2->getInsertSQL());	
			
				/* Voucher entry for Store ends here */				
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'purchasedb UpdateManualStockOUT '.$er->getMessage();
				_errorLog($err);
				$_sid	= -1;
				
			}


			return $_sid;
			
		}
		
		function deleteManualStockOUT($scls) {
			$_sid		= $scls->getSVoucherID();
			
				
			try {
			
				$this->conn->beginTransaction();
					
				/* Stock entries */
				
				$sql	= "DELETE FROM `asys_voucher_entry` WHERE `RelatedID`='".$_sid."' AND `TxnType`='".MANUAL_STOCK_OUT."' AND `CompanyID`='".$scls->getCompanyID()."'";
				$this->conn->exec($sql);
				
				$sql		= $scls->getDeleteSQL();
				$this->conn->exec($sql);
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				$err	= 'purchasedb deleteManualStockOUT '.$er->getMessage();
			_errorLog($err);
				$this->conn->rollBack();
				$_sid	= 0;
				
			}


			return $_sid;
		}
		
		function getStockVoucherBySQL($sql) {

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'asys_stock_voucher');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemName($this->getItemNameByItemID($row->getItemID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getStockVoucherBySQL '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}		



		/*-----------------------------------------------------------*/
		/*********************** ISSUE METHODS ***********************/

		function getIssueDetail($IssueID) {
			$IssueID		= (int)$IssueID;
			$cclass			=	new gen_issue();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_issue` WHERE `IssueID`='$IssueID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_issue');
				if($row 	= $result->fetch()) { 
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemCategoryName( $this->getItemCategoryNameByItemCategoryID( $row->getItemCategoryID() ) );
					$row->setDebitMotherAccountName( $this->getAccountNameByAccountID( $row->getDebitMotherAccountID() ) );
					$row->setDebitAccountName( $this->getAccountNameByAccountID( $row->getDebitAccountID() ) );
					$row->setCreditMotherAccountName( $this->getAccountNameByAccountID( $row->getCreditMotherAccountID() ) );
					$row->setCreditAccountName( $this->getAccountNameByAccountID( $row->getCreditAccountID() ) );
					
					$row->setItemList($this->getIssueItemList($row->getIssueID()));
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getIssueDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getIssueList($CompanyID) {
			$arr	=	array();
			$CompanyID	= (int)$CompanyID;
			
			try {
				
				$sql			=	"SELECT * FROM `gen_issue` WHERE `CompanyID`='$CompanyID' ORDER BY `IssueNo`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_issue');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemCategoryName( $this->getItemCategoryNameByItemCategoryID( $row->getItemCategoryID() ) );
					$row->setDebitMotherAccountName( $this->getAccountNameByAccountID( $row->getDebitMotherAccountID() ) );
					$row->setDebitAccountName( $this->getAccountNameByAccountID( $row->getDebitAccountID() ) );
					$row->setCreditMotherAccountName( $this->getAccountNameByAccountID( $row->getCreditMotherAccountID() ) );
					$row->setCreditAccountName( $this->getAccountNameByAccountID( $row->getCreditAccountID() ) );
					
					$row->setItemList($this->getIssueItemList($row->getIssueID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getIssueList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getIssueListBySQL($sql) {
			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_issue');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemCategoryName( $this->getItemCategoryNameByItemCategoryID( $row->getItemCategoryID() ) );
					$row->setDebitMotherAccountName( $this->getAccountNameByAccountID( $row->getDebitMotherAccountID() ) );
					$row->setDebitAccountName( $this->getAccountNameByAccountID( $row->getDebitAccountID() ) );
					$row->setCreditMotherAccountName( $this->getAccountNameByAccountID( $row->getCreditMotherAccountID() ) );
					$row->setCreditAccountName( $this->getAccountNameByAccountID( $row->getCreditAccountID() ) );
					
					$row->setItemList($this->getIssueItemList($row->getIssueID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getIssueListBySQL '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getIssueItemList($IssueID) {
			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_issue_items` WHERE `IssueID`='$IssueID' ORDER BY `ItemID`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_issue_items');
				while($row = $result->fetch()) {
					$row->setItemName($this->getItemNameByItemID($row->getItemID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getIssueItemList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getIssueListJSON(){
		
			$sql		= "SELECT `IssueID`, `IssueNo` FROM `gen_issue` ORDER BY `IssueName`";
			return $this->getRecordsetExecutingQuery($sql);
		
		}
		
		function getUnitPriceOfIssuedItem($IssueID, $ItemID){
		
			$sql		= "SELECT `UnitPrice` FROM `asys_stock_voucher` WHERE `ModuleID`='".ISSUE."' AND `RelatedID`='".$IssueID."' AND `ItemID`='".$ItemID."'";
			return $this->getResultExecutingQuery($sql);
		
		}
		
		function getNumberOfIssue($IssueNo, $DateFrom, $DateTo, $CompanyID) {
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$IssueNo		= (int)$IssueNo;
			$CompanyID	= (int)$CompanyID;
			$sql		=	"SELECT COUNT(*) FROM `gen_issue` WHERE `CompanyID` = '$CompanyID'";
			if($IssueNo > 0)
				$sql	=	$sql." AND `IssueNo` = '$IssueNo'";
			if($DateFrom != "1900-01-01")
				$sql	=	$sql." AND `IssueDate` >= '$DateFrom'";
			if($DateTo != "1900-01-01")
				$sql	=	$sql." AND `IssueDate` <= '$DateTo'";
			
			return $this->getResultExecutingQuery($sql);
		}

		function getIssueListPaged($sRec, $nRec, $IssueNo, $DateFrom, $DateTo, $CompanyID) {
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$IssueNo		= (int)$IssueNo;
			$CompanyID	= (int)$CompanyID;
			$sql		=	"SELECT * FROM `gen_issue` WHERE `CompanyID` = '$CompanyID'";
			if($IssueNo > 0)
				$sql	=	$sql." AND `IssueNo` = '$IssueNo'";
			if($DateFrom != "1900-01-01")
				$sql	=	$sql." AND `IssueDate` >= '$DateFrom'";
			if($DateTo != "1900-01-01")
				$sql	=	$sql." AND `IssueDate` <= '$DateTo'";

			$sql		=	$sql." ORDER BY `FinYear` DESC, `IssueNo` DESC LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_issue');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemCategoryName( $this->getItemCategoryNameByItemCategoryID( $row->getItemCategoryID() ) );
					$row->setDebitMotherAccountName( $this->getAccountNameByAccountID( $row->getDebitMotherAccountID() ) );
					$row->setDebitAccountName( $this->getAccountNameByAccountID( $row->getDebitAccountID() ) );
					$row->setCreditMotherAccountName( $this->getAccountNameByAccountID( $row->getCreditMotherAccountID() ) );
					$row->setCreditAccountName( $this->getAccountNameByAccountID( $row->getCreditAccountID() ) );
					
					$row->setItemList($this->getIssueItemList($row->getIssueID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getIssueListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function getNextIssueNo($FinYear, $CompanyID) {
			if(strpos($FinYear, "'") !== false) return false;
			$CompanyID	= (int)$CompanyID;
			
			$maxid			=	0;
			$sql				=	"SELECT MAX(`IssueNo`) FROM `gen_issue` WHERE `FinYear`='$FinYear' AND `CompanyID`='$CompanyID'";

			try {
				
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch())
					$maxid 	= $row[0];
					
			} catch(PDOException $e) {
				$err	= 'purchasedb getNextIssueNo '.$e->getMessage();
				_errorLog($err);
			}

			$maxid++;
			return $maxid;
		}
		
		function CreateIssue($iscls) {
				
			$sid			= 0;
			$cmpid		= $iscls->getCompanyID();

			try {
			
				$this->conn->beginTransaction();
				
				$iscls->setIssueID($this->getNextID("gen_issue","IssueID"));
				$sid	= $iscls->getIssueID();
				$iscls->setFinYear(getFinancialYear($iscls->getIssueDate()));
				$iscls->setIssueNo($this->getNextIssueNo($iscls->getFinYear(), $iscls->getCompanyID()));
				
				$sql	= $iscls->getInsertSQL();
				$this->conn->exec($sql);				
				
				$tval			= 0;
				
				$inarr		= $iscls->getPurpose();
				$itmList	= $iscls->getItemList();
				for($i=0;$i<count($itmList);$i++) {
					$icls	=	$itmList[$i];
					$icls->setIssueID($sid);
					$idet	= $this->getItemDetail($icls->getItemID());

					$sql		= $icls->getInsertSQL();
					$this->conn->exec($sql);
					
					if($inarr != "") $inarr = $inarr."<br />";
					$inarr	= $inarr.$this->getItemNameByItemID($icls->getItemID()).' = '.$icls->getQuantity().' '.$idet->getUnitName();
					
					/* Stock entries */
					
					$lcqty	= $this->getLastStockClosingQuantity($cmpid, $iscls->getStoreID(), $icls->getItemID(), $iscls->getIssueDate());
					$lcval	= $this->getLastStockClosingValue($cmpid, $iscls->getStoreID(), $icls->getItemID(), $iscls->getIssueDate());
					$lbald	= $this->getLastBalanceDetail($cmpid, $iscls->getStoreID(), $icls->getItemID(), $iscls->getIssueDate());
					
					$cqty		= $lcqty - $icls->getQuantity();
					$cval		= 0;
					
					$bald			= "";
					$bqty			= 0;
					$val			= 0;
					$Quantity	= $icls->getQuantity();
					$tmp1			= explode(",", $lbald);
					for($ii=0;$ii<count($tmp1);$ii++) {
						$tmp2		= $tmp1[$ii];
						if($tmp2 == "") continue;
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						if($sqty > $Quantity) {
							$bqty	= $sqty - $Quantity;
							$val	= $val + ($Quantity * $sprc);
							break;
						} else {
							$Quantity	= $Quantity - $sqty;
							$val			= $val + ($sqty * $sprc);
						}
					}
					
					for($j=$ii;$j<count($tmp1);$j++) {
						$tmp2		= $tmp1[$j];
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						if($j == $ii) {
							if($bqty > 0) $sqty = $bqty;
						}
						
						if($bald != "") $bald = $bald.",";
						$bald		= $bald.$sqty.'='.$sprc;
					}
					
					/* Closing Value */
					$tmp1			= explode(",", $bald);
					for($ii=0;$ii<count($tmp1);$ii++) {
						$tmp2		= $tmp1[$ii];
						if($tmp2 == "") continue;
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						
						$cval		= $cval	+ ($sqty * $sprc);
					}
					/* Closing value ends here */
					
					$tval		= $tval + $val;
					
					$scls		= new asys_stock_voucher();
					$scls->setSVoucherID($this->getNextID("asys_stock_voucher","SVoucherID"));
					$scls->setCompanyID($iscls->getCompanyID());
					$scls->setStoreID($iscls->getStoreID());
					$scls->setModuleID(ISSUE);
					$scls->setFinYear($iscls->getFinYear());
					$scls->setRelatedID($sid);
					$scls->setDOT($iscls->getIssueDate('yes'));
					$scls->setTOT(time());
					$scls->setItemID($icls->getItemID());
					$scls->setItemCategoryID($this->getItemCategoryByItemID($icls->getItemID()));
					$scls->setQuantity($icls->getQuantity());
					$scls->setUnitPrice($val / $icls->getQuantity());
					$scls->setStockInOut(STOCK_OUT);
					$scls->setClosingQty($cqty);
					$scls->setClosingValue($cval);
					$scls->setBatchNo("");
					$scls->setNarration('Issue# '.$iscls->getIssueNo().'/'.$iscls->getFinYear().'<br />'.$iscls->getPurpose());
					$scls->setBalanceDetail($bald);
					
					$sql		= $scls->getInsertSQL();
					$this->conn->exec($sql);
					
					/* Stock entry ends here */
				}
				
				
				/* Voucher entries */
				
				$tuser	=	unserialize($_SESSION["ssEUser"]);
				$finyr	= $iscls->getFinYear();
				
				$VoucherNo	=	$this->getMaxVoucherNo(JOURNAL_VOUCHER, $finyr, $iscls->getCompanyID());
				$DayWiseNo	= $this->getMaxDayWiseVoucherNo(JOURNAL_VOUCHER, $iscls->getIssueDate(), $iscls->getCompanyID());
				
				if($iscls->getDebitAccountID() != 0)
					$aDet		= $this->getAccountDetail($iscls->getDebitAccountID());
				else
					$aDet		= $this->getAccountDetail($iscls->getDebitMotherAccountID());
					
				$vcls1	=	new asys_voucher_entry();
				$vcls1->setSerialID(1);
				$vcls1->setCompanyID($iscls->getCompanyID());
				$vcls1->setVoucherType(JOURNAL_VOUCHER);
				$vcls1->setFinYear($finyr);
				$vcls1->setVoucherNo($VoucherNo);
				$vcls1->setDayWiseNo($DayWiseNo);
				$vcls1->setDOV($iscls->getIssueDate('yes'));
				$vcls1->setMotherAccount($aDet->getMotherAccount());
				$vcls1->setAccountID($aDet->getAccountID());
				$vcls1->setRelatedID($sid);
				$vcls1->setTxnType(ISSUE);
				$vcls1->setDrCr(DEBIT);
				$vcls1->setAmount($tval);
				$vcls1->setNarration("ISSUE# ".$iscls->getIssueNo().'/'.$iscls->getFinYear().'<br />'.$inarr);
				$vcls1->setUserID($tuser->getUserID());
				$vcls1->setDOE(date('d-m-Y'));
				
				
				if($iscls->getCreditAccountID() != 0)
					$aDet		= $this->getAccountDetail($iscls->getCreditAccountID());
				else
					$aDet		= $this->getAccountDetail($iscls->getCreditMotherAccountID());
					
				$vcls2	=	new asys_voucher_entry();
				$vcls2->setSerialID(2);
				$vcls2->setCompanyID($iscls->getCompanyID());
				$vcls2->setVoucherType(JOURNAL_VOUCHER);
				$vcls2->setFinYear($finyr);
				$vcls2->setVoucherNo($VoucherNo);
				$vcls2->setDayWiseNo($DayWiseNo);
				$vcls2->setDOV($iscls->getIssueDate('yes'));
				$vcls2->setMotherAccount($aDet->getMotherAccount());
				$vcls2->setAccountID($aDet->getAccountID());
				$vcls2->setRelatedID($sid);
				$vcls2->setTxnType(ISSUE);
				$vcls2->setDrCr(CREDIT);
				$vcls2->setAmount($tval);
				$vcls2->setNarration("ISSUE# ".$iscls->getIssueNo().'/'.$iscls->getFinYear().'<br />'.$inarr);
				$vcls2->setUserID($tuser->getUserID());
				$vcls2->setDOE(date('d-m-Y'));
				
				$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
				$vcls1->setVoucherID($vid);
				$vcls2->setVoucherID($vid);
				$this->conn->exec($vcls1->getInsertSQL());
				$this->conn->exec($vcls2->getInsertSQL());
				
				/* Voucher entry ands here */
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'purchasedb CreateIssue '.$er->getMessage();
				_errorLog($err);
				$sid	= -1;
				
			}


			return $sid;
			
		}
		
		function deleteIssue($iscls) {
		
			$pkey				= $iscls->getIssueID();
			$cmpid			= $iscls->getCompanyID();
			$ret				= true;
		

			try {
			
				$this->conn->beginTransaction();	
				
				$this->conn->exec("DELETE FROM `gen_issue_items` WHERE `IssueID`='$pkey'");	
				$this->conn->exec("DELETE FROM `asys_stock_voucher` WHERE `RelatedID`='$pkey' AND `ModuleID`='".ISSUE."' AND `CompanyID`='$cmpid'");
				$this->conn->exec("DELETE FROM `asys_voucher_entry` WHERE `RelatedID`='$pkey' AND `TxnType`='".ISSUE."' AND `CompanyID`='$cmpid'");
				
				$sql	= $iscls->getDeleteSQL();
				$this->conn->exec($sql);
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				$err	= 'purchasedb deleteIssue '.$er->getMessage();
				_errorLog($err);
				$ret	= false;
				$this->conn->rollBack();
				
			}
				
		
			return $ret;
		}
		
		function getIssueDateByIssueID($IssueID) {
			$IssueID	= (int)$IssueID;
			$sql	= "SELECT `IssueDate` FROM `gen_issue` WHERE `IssueID`='".$IssueID."'";
			return $this->getResultExecutingQuery($sql);
		}
		
		function getIssueNoByIssueID($IssueID) {
			$IssueID	= (int)$IssueID;
			$sql	= "SELECT CONCAT(`IssueNo`,'/',`FinYear`) FROM `gen_issue` WHERE `IssueID`='".$IssueID."'";
			return $this->getResultExecutingQuery($sql);
		}		

		function UpdateIssue($iscls) {
			
			$sid			= $iscls->getIssueID();
			$cmpid		= $iscls->getCompanyID();

			$vno		= $this->getVoucherNoByRelatedID(JOURNAL_VOUCHER, ISSUE, $sid, $cmpid);
			if($iscls->getIssueDate() == $this->getIssueDateByIssueID($sid))
				$dwn	= $this->getDayWiseNoByRelatedID(JOURNAL_VOUCHER, ISSUE, $sid, $cmpid);
			else
				$dwn	= $this->getMaxDayWiseVoucherNo(JOURNAL_VOUCHER, $iscls->getIssueDate(), $cmpid);
			

			try {
			
				$this->conn->beginTransaction();
				
				$delsql1	= "DELETE FROM `gen_issue_items` WHERE `IssueID`='$sid'";
				$this->conn->exec($delsql1);
				
				$delsql2	= "DELETE FROM `asys_stock_voucher` WHERE `RelatedID`='$sid' AND `ModuleID`='".ISSUE."' AND `CompanyID`='$cmpid'";
				$delsql3	= "DELETE FROM `asys_voucher_entry` WHERE `RelatedID`='$sid' AND `TxnType`='".ISSUE."' AND `CompanyID`='$cmpid'";
				
				$stkcls		= array();
				
				$tval			= 0;
				
				$inarr		= $iscls->getPurpose();
				$itmList	= $iscls->getItemList();
				for($i=0;$i<count($itmList);$i++) {
					$icls	=	$itmList[$i];
					$icls->setIssueID($sid);
					$idet	= $this->getItemDetail($icls->getItemID());

					$sql		= $icls->getInsertSQL();
					$this->conn->exec($sql);
					
					if($inarr != "") $inarr = $inarr."<br />";
					$inarr	= $inarr.$this->getItemNameByItemID($icls->getItemID()).' = '.$icls->getQuantity().' '.$idet->getUnitName();
					
					/* Stock entries */
					
					$lcqty	= $this->getLastStockClosingQuantityForUpdate($cmpid, $iscls->getStoreID(), $icls->getItemID(), $iscls->getIssueDate(), ISSUE, $sid);
					$lcval	= $this->getLastStockClosingValueForUpdate($cmpid, $iscls->getStoreID(), $icls->getItemID(), $iscls->getIssueDate(), ISSUE, $sid);
					$lbald	= $this->getLastBalanceDetailForUpdate($cmpid, $iscls->getStoreID(), $icls->getItemID(), $iscls->getIssueDate(), ISSUE, $sid);

					$cqty		= $lcqty - $icls->getQuantity();
					$cval		= 0;
					
					$bald			= "";
					$bqty			= 0;
					$val			= 0;
					$Quantity	= $icls->getQuantity();
					$tmp1			= explode(",", $lbald);
					for($ii=0;$ii<count($tmp1);$ii++) {
						$tmp2		= $tmp1[$ii];
						if($tmp2 == "") continue;
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						if($sqty > $Quantity) {
							$bqty	= $sqty - $Quantity;
							$val	= $val + ($Quantity * $sprc);
							break;
						} else {
							$Quantity	= $Quantity - $sqty;
							$val			= $val + ($sqty * $sprc);
						}
					}
					
					for($j=$ii;$j<count($tmp1);$j++) {
						$tmp2		= $tmp1[$j];
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						if($j == $ii) {
							if($bqty > 0) $sqty = $bqty;
						}
						
						if($bald != "") $bald = $bald.",";
						$bald		= $bald.$sqty.'='.$sprc;
					}
					
					/* Closing Value */
					$tmp1			= explode(",", $bald);
					for($ii=0;$ii<count($tmp1);$ii++) {
						$tmp2		= $tmp1[$ii];
						if($tmp2 == "") continue;
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						
						$cval		= $cval	+ ($sqty * $sprc);
					}
					/* Closing value ends here */
					
					$tval		= $tval + $val;
					
					$scls		= new asys_stock_voucher();
					$scls->setCompanyID($iscls->getCompanyID());
					$scls->setStoreID($iscls->getStoreID());
					$scls->setModuleID(ISSUE);
					$scls->setFinYear($iscls->getFinYear());
					$scls->setRelatedID($sid);
					$scls->setDOT($iscls->getIssueDate('yes'));
					$scls->setTOT(time());
					$scls->setItemID($icls->getItemID());
					$scls->setItemCategoryID($this->getItemCategoryByItemID($icls->getItemID()));
					$scls->setQuantity($icls->getQuantity());
					$scls->setUnitPrice($val / $icls->getQuantity());
					$scls->setStockInOut(STOCK_OUT);
					$scls->setClosingQty($cqty);
					$scls->setClosingValue($cval);						
					$scls->setBatchNo("");
					$scls->setNarration('Issue# '.$iscls->getIssueNo().'/'.$iscls->getFinYear().'<br />'.$iscls->getPurpose());
					$scls->setBalanceDetail($bald);
					
					$stkcls[]		= $scls;
					
					/* Stock entry ends here */
				}
				
				
				$this->conn->exec($delsql2);
				$this->conn->exec($delsql3);
				for($i=0;$i<count($stkcls);$i++) {
					$scls		= $stkcls[$i];
					$scls->setSVoucherID($this->getNextID("asys_stock_voucher","SVoucherID"));
					$this->conn->exec($scls->getInsertSQL());
				}				
				
				
				/* Voucher entries */
				
				$tuser	=	unserialize($_SESSION["ssEUser"]);
				$finyr	= $iscls->getFinYear();
				
				if($iscls->getDebitAccountID() != 0)
					$aDet		= $this->getAccountDetail($iscls->getDebitAccountID());
				else
					$aDet		= $this->getAccountDetail($iscls->getDebitMotherAccountID());
					
				$vcls1	=	new asys_voucher_entry();
				$vcls1->setSerialID(1);
				$vcls1->setCompanyID($iscls->getCompanyID());
				$vcls1->setVoucherType(JOURNAL_VOUCHER);
				$vcls1->setFinYear($finyr);
				$vcls1->setVoucherNo($vno);
				$vcls1->setDayWiseNo($dwn);
				$vcls1->setDOV($iscls->getIssueDate('yes'));
				$vcls1->setMotherAccount($aDet->getMotherAccount());
				$vcls1->setAccountID($aDet->getAccountID());
				$vcls1->setRelatedID($sid);
				$vcls1->setTxnType(ISSUE);
				$vcls1->setDrCr(DEBIT);
				$vcls1->setAmount($tval);
				$vcls1->setNarration("ISSUE# ".$iscls->getIssueNo().'/'.$iscls->getFinYear().'<br />'.$inarr);
				$vcls1->setUserID($tuser->getUserID());
				$vcls1->setDOE(date('d-m-Y'));
				
				
				if($iscls->getCreditAccountID() != 0)
					$aDet		= $this->getAccountDetail($iscls->getCreditAccountID());
				else
					$aDet		= $this->getAccountDetail($iscls->getCreditMotherAccountID());
					
				$vcls2	=	new asys_voucher_entry();
				$vcls2->setSerialID(2);
				$vcls2->setCompanyID($iscls->getCompanyID());
				$vcls2->setVoucherType(JOURNAL_VOUCHER);
				$vcls2->setFinYear($finyr);
				$vcls2->setVoucherNo($vno);
				$vcls2->setDayWiseNo($dwn);
				$vcls2->setDOV($iscls->getIssueDate('yes'));
				$vcls2->setMotherAccount($aDet->getMotherAccount());
				$vcls2->setAccountID($aDet->getAccountID());
				$vcls2->setRelatedID($sid);
				$vcls2->setTxnType(ISSUE);
				$vcls2->setDrCr(CREDIT);
				$vcls2->setAmount($tval);
				$vcls2->setNarration("ISSUE# ".$iscls->getIssueNo().'/'.$iscls->getFinYear().'<br />'.$inarr);
				$vcls2->setUserID($tuser->getUserID());
				$vcls2->setDOE(date('d-m-Y'));
				
				$vid		= $this->getNextID("asys_voucher_entry", "VoucherID");
				$vcls1->setVoucherID($vid);
				$vcls2->setVoucherID($vid);
				$this->conn->exec($vcls1->getInsertSQL());
				$this->conn->exec($vcls2->getInsertSQL());
				
				/* Voucher entry ands here */
											
									
				$sql	= $iscls->getUpdateSQL();
				$this->conn->exec($sql);
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'purchasedb UpdateIssue '.$er->getMessage();
				_errorLog($err);
				$sid	= -1;
				
			}
				

			return $sid;
			
		}
		
		function UpdateIssueForRecalculation($iscls) {
		
			$sid			= $iscls->getIssueID();
			$cmpid		= $iscls->getCompanyID();

			try {
			
				$this->conn->beginTransaction();
				
				$tval			= 0;
				
				$itmList	= $iscls->getItemList();
				for($i=0;$i<count($itmList);$i++) {
					$icls	=	$itmList[$i];
					
					/* Stock entries */
					
					$lcqty	= $this->getLastStockClosingQuantityForUpdate($cmpid, $iscls->getStoreID(), $icls->getItemID(), $iscls->getIssueDate(), ISSUE, $sid);
					$lcval	= $this->getLastStockClosingValueForUpdate($cmpid, $iscls->getStoreID(), $icls->getItemID(), $iscls->getIssueDate(), ISSUE, $sid);
					$lbald	= $this->getLastBalanceDetailForUpdate($cmpid, $iscls->getStoreID(), $icls->getItemID(), $iscls->getIssueDate(), ISSUE, $sid);

					$cqty		= $lcqty - $icls->getQuantity();
					$cval		= 0;
					
					$bald			= "";
					$bqty			= 0;
					$val			= 0;
					$Quantity	= $icls->getQuantity();
					$tmp1			= explode(",", $lbald);
					for($ii=0;$ii<count($tmp1);$ii++) {
						$tmp2		= $tmp1[$ii];
						if($tmp2 == "") continue;
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						if($sqty > $Quantity) {
							$bqty	= $sqty - $Quantity;
							$val	= $val + ($Quantity * $sprc);
							break;
						} else {
							$Quantity	= $Quantity - $sqty;
							$val			= $val + ($sqty * $sprc);
						}
					}
					
					for($j=$ii;$j<count($tmp1);$j++) {
						$tmp2		= $tmp1[$j];
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						if($j == $ii) {
							if($bqty > 0) $sqty = $bqty;
						}
						
						if($bald != "") $bald = $bald.",";
						$bald		= $bald.$sqty.'='.$sprc;
					}
					
					/* Closing Value */
					$tmp1			= explode(",", $bald);
					for($ii=0;$ii<count($tmp1);$ii++) {
						$tmp2		= $tmp1[$ii];
						if($tmp2 == "") continue;
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						
						$cval		= $cval	+ ($sqty * $sprc);
					}
					/* Closing value ends here */
					
					$tval		= $tval + $val;
					
					/* Stock entry ends here */
				}			
				
				
				/* Voucher entries */
				
				$sql		= "UPDATE `asys_voucher_entry` SET `Amount`='$tval' WHERE `CompanyID`='$cmpid' AND `TxnType`='".ISSUE."' AND `RelatedID`='$sid' ";
				
				$this->conn->exec($sql);

				
				/* Voucher entry ands here */
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'purchasedb UpdateIssue '.$er->getMessage();
				_errorLog($err);
				$sid	= -1;
				
			}
				

			return $sid;
			
		}		
		
		function getDebitAccountListFromIssue($StoreID, $DateFrom, $DateTo) {
			$StoreID	= (int)$StoreID;
			$DateFrom	= addslashes($DateFrom);
			$DateTo		= addslashes($DateTo);
			
			$sql			= "
			SELECT DISTINCT(`DebitMotherAccountID`) FROM `gen_issue` WHERE `StoreID`='$StoreID' AND `IssueDate`>='$DateFrom' AND `IssueDate`<='$DateTo' 
			UNION 
			SELECT DISTINCT(`DebitAccountID`) FROM `gen_issue` WHERE `StoreID`='$StoreID' AND `IssueDate`>='$DateFrom' AND `IssueDate`<='$DateTo'
			UNION
			SELECT DISTINCT(`DebitMotherAccountID`) FROM `gen_transferissue` WHERE `ToStoreID`='$StoreID' AND `BookingDate`>='$DateFrom' AND `BookingDate`<='$DateTo'
			UNION
			SELECT DISTINCT(`DebitAccountID`) FROM `gen_transferissue` WHERE `ToStoreID`='$StoreID' AND `BookingDate`>='$DateFrom' AND `BookingDate`<='$DateTo'
			";
			return $this->getRecordsetExecutingQuery($sql);
			
		}



		/*--------------------------------------------------------------------*/
		/*********************** STOCK TRANSFER METHODS ***********************/

		function getStockTransferDetail($StockTransferID) {
			$StockTransferID	= (int)$StockTransferID;
			$cclass			=	new gen_stocktransfer();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_stocktransfer` WHERE `StockTransferID`='$StockTransferID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_stocktransfer');
				if($row 	= $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setFromStoreName($this->getStoreNameByStoreID($row->getFromStoreID()));
					$row->setToStoreName($this->getStoreNameByStoreID($row->getToStoreID()));
					$row->setDebitMotherAccountName( $this->getAccountNameByAccountID( $row->getDebitMotherAccountID() ) );
					$row->setDebitAccountName( $this->getAccountNameByAccountID( $row->getDebitAccountID() ) );
					$row->setCreditMotherAccountName( $this->getAccountNameByAccountID( $row->getCreditMotherAccountID() ) );
					$row->setCreditAccountName( $this->getAccountNameByAccountID( $row->getCreditAccountID() ) );
					$row->setItemList($this->getStockTransferItemList($row->getStockTransferID()));
					$cclass	= $row;
				}

			} catch(PDOException $e) {
				$err	= 'purchasedb getStockTransferDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getStockTransferList($CompanyID) {
			$arr	=	array();
			$CompanyID	= (int)$CompanyID;
			
			try {
				
				$sql			=	"SELECT * FROM `gen_stocktransfer` WHERE `CompanyID`='$CompanyID' ORDER BY `DOT`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_stocktransfer');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setFromStoreName($this->getStoreNameByStoreID($row->getFromStoreID()));
					$row->setToStoreName($this->getStoreNameByStoreID($row->getToStoreID()));
					$row->setDebitMotherAccountName( $this->getAccountNameByAccountID( $row->getDebitMotherAccountID() ) );
					$row->setDebitAccountName( $this->getAccountNameByAccountID( $row->getDebitAccountID() ) );
					$row->setCreditMotherAccountName( $this->getAccountNameByAccountID( $row->getCreditMotherAccountID() ) );
					$row->setCreditAccountName( $this->getAccountNameByAccountID( $row->getCreditAccountID() ) );
					$row->setItemList($this->getStockTransferItemList($row->getStockTransferID()));	
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getStockTransferList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getStockTransferListBySQL($sql) {
			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_stocktransfer');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setFromStoreName($this->getStoreNameByStoreID($row->getFromStoreID()));
					$row->setToStoreName($this->getStoreNameByStoreID($row->getToStoreID()));
					$row->setDebitMotherAccountName( $this->getAccountNameByAccountID( $row->getDebitMotherAccountID() ) );
					$row->setDebitAccountName( $this->getAccountNameByAccountID( $row->getDebitAccountID() ) );
					$row->setCreditMotherAccountName( $this->getAccountNameByAccountID( $row->getCreditMotherAccountID() ) );
					$row->setCreditAccountName( $this->getAccountNameByAccountID( $row->getCreditAccountID() ) );
					$row->setItemList($this->getStockTransferItemList($row->getStockTransferID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getStockTransferListBySQL '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getNumberOfStockTransfer($DateFrom, $DateTo, $CompanyID, $StockTransferID) {
			$DateFrom	= addslashes($DateFrom);
			$DateTo		= addslashes($DateTo);
			$CompanyID	= (int)$CompanyID;
			$StockTransferID	= (int)$StockTransferID;
			
			$sql		=	"SELECT COUNT(*) FROM `gen_stocktransfer` WHERE `CompanyID` = '$CompanyID'";
			if($DateFrom != "1900-01-01")
				$sql	=	$sql." AND `DOT`>='$DateFrom'";
			if($DateTo != "1900-01-01")
				$sql	=	$sql." AND `DOT`<='$DateTo'";
			if($StockTransferID != 0)
				$sql	=	$sql." AND `StockTransferID`='$StockTransferID'";
			
			return $this->getResultExecutingQuery($sql);
		}

		function getStockTransferListPaged($sRec, $nRec, $DateFrom, $DateTo, $CompanyID, $StockTransferID) {
			$DateFrom	= addslashes($DateFrom);
			$DateTo		= addslashes($DateTo);
			$CompanyID	= (int)$CompanyID;
			$StockTransferID	= (int)$StockTransferID;
					
			$sql		=	"SELECT * FROM `gen_stocktransfer` WHERE `CompanyID` = '$CompanyID'";
			if($DateFrom != "1900-01-01")
				$sql	=	$sql." AND `DOT`>='$DateFrom'";
			if($DateTo != "1900-01-01")
				$sql	=	$sql." AND `DOT`<='$DateTo'";
			if($StockTransferID != 0)
				$sql	=	$sql." AND `StockTransferID`='$StockTransferID'";
				
			$sql		=	$sql." ORDER BY `DOT` DESC LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_stocktransfer');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setFromStoreName($this->getStoreNameByStoreID($row->getFromStoreID()));
					$row->setToStoreName($this->getStoreNameByStoreID($row->getToStoreID()));
					$row->setDebitMotherAccountName( $this->getAccountNameByAccountID( $row->getDebitMotherAccountID() ) );
					$row->setDebitAccountName( $this->getAccountNameByAccountID( $row->getDebitAccountID() ) );
					$row->setCreditMotherAccountName( $this->getAccountNameByAccountID( $row->getCreditMotherAccountID() ) );
					$row->setCreditAccountName( $this->getAccountNameByAccountID( $row->getCreditAccountID() ) );
					$row->setItemList($this->getStockTransferItemList($row->getStockTransferID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getStockTransferListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function CreateStockTransfer($stcls) {
				
			$sid		= 0;
			
			$_cmpid	= $stcls->getCompanyID();
			

			try {
			
				$this->conn->beginTransaction();
				
				$stcls->setStockTransferID($this->getNextID("gen_stocktransfer", "StockTransferID"));
				$sid	= $stcls->getStockTransferID();
				
				$sql	= $stcls->getInsertSQL();
				$this->conn->exec($sql);				
				
				$tval			= 0;
				
				$inarr		= $stcls->getPurpose();
				$itmList	= $stcls->getItemList();
				for($i=0;$i<count($itmList);$i++) {
					$icls	=	$itmList[$i];
					$icls->setStockTransferID($sid);
					$idet	= $this->getItemDetail($icls->getItemID());
					
					if($inarr != "") $inarr = $inarr."<br />";
					$inarr	= $inarr.$this->getItemNameByItemID($icls->getItemID()).' = '.$icls->getQuantity().' '.$idet->getUnitName();
					
					/* Stock entries */
					
					$lcqty	= $this->getLastStockClosingQuantity($_cmpid, $stcls->getFromStoreID(), $icls->getItemID(), $stcls->getDOT());
					$lcval	= $this->getLastStockClosingValue($_cmpid, $stcls->getFromStoreID(), $icls->getItemID(), $stcls->getDOT());
					$lbald	= $this->getLastBalanceDetail($_cmpid, $stcls->getFromStoreID(), $icls->getItemID(), $stcls->getDOT());
					
					$cqty		= $lcqty - $icls->getQuantity();
					$cval		= 0;
					
					$bald			= "";
					$bqty			= 0;
					$val			= 0;
					$Quantity	= $icls->getQuantity();
					$tmp1			= explode(",", $lbald);
					for($ii=0;$ii<count($tmp1);$ii++) {
						$tmp2		= $tmp1[$ii];
						if($tmp2 == "") continue;
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						if($sqty > $Quantity) {
							$bqty	= $sqty - $Quantity;
							$val	= $val + ($Quantity * $sprc);
							break;
						} else {
							$Quantity	= $Quantity - $sqty;
							$val			= $val + ($sqty * $sprc);
						}
					}
					
					for($j=$ii;$j<count($tmp1);$j++) {
						$tmp2		= $tmp1[$j];
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						if($j == $ii) {
							if($bqty > 0) $sqty = $bqty;
						}
						
						if($bald != "") $bald = $bald.",";
						$bald		= $bald.$sqty.'='.$sprc;
					}
					
					/* Closing Value */
					$tmp1			= explode(",", $bald);
					for($ii=0;$ii<count($tmp1);$ii++) {
						$tmp2		= $tmp1[$ii];
						if($tmp2 == "") continue;
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						
						$cval		= $cval	+ ($sqty * $sprc);
					}
					/* Closing value ends here */
					
					$tval		= $tval + $val;
					
					$icls->setRate($val / $icls->getQuantity());
					$sql		= $icls->getInsertSQL();
					$this->conn->exec($sql);						
					
					$scls		= new asys_stock_voucher();
					$scls->setSVoucherID($this->getNextID("asys_stock_voucher","SVoucherID"));
					$scls->setCompanyID($stcls->getCompanyID());
					$scls->setStoreID($stcls->getFromStoreID());
					$scls->setModuleID(STOCK_TRANSFER);
					$scls->setFinYear('');
					$scls->setRelatedID($sid);
					$scls->setDOT($stcls->getDOT('yes'));
					$scls->setTOT(time());
					$scls->setItemID($icls->getItemID());
					$scls->setItemCategoryID($this->getItemCategoryByItemID($icls->getItemID()));
					$scls->setQuantity($icls->getQuantity());
					$scls->setUnitPrice($val / $icls->getQuantity());
					$scls->setStockInOut(STOCK_OUT);
					$scls->setClosingQty($cqty);
					$scls->setClosingValue($cval);						
					$scls->setBatchNo("");
					$scls->setNarration('Stock Transfer# '.$stcls->getStockTransferID().'<br />'.$stcls->getPurpose());
					$scls->setBalanceDetail($bald);
					
					$sql		= $scls->getInsertSQL();
					$this->conn->exec($sql);
					
					
					$lcqty	= $this->getLastStockClosingQuantity($_cmpid, $stcls->getToStoreID(), $icls->getItemID(), $stcls->getDOT());
					$lcval	= $this->getLastStockClosingValue($_cmpid, $stcls->getToStoreID(), $icls->getItemID(), $stcls->getDOT());
					$lbald	= $this->getLastBalanceDetail($_cmpid, $stcls->getToStoreID(), $icls->getItemID(), $stcls->getDOT());
					
					$cqty		= $lcqty + $icls->getQuantity();
					$cval		= $lcval + ($icls->getQuantity() * ($val / $icls->getQuantity()));
					$bald		= $lbald;
					if($bald != "") $bald = $bald.",";
					$bald		= $bald.$icls->getQuantity()."=".($val / $icls->getQuantity());
					
					$scls		= new asys_stock_voucher();
					$scls->setSVoucherID($this->getNextID("asys_stock_voucher","SVoucherID"));
					$scls->setCompanyID($stcls->getCompanyID());
					$scls->setStoreID($stcls->getToStoreID());
					$scls->setModuleID(STOCK_TRANSFER);
					$scls->setFinYear('');
					$scls->setRelatedID($sid);
					$scls->setDOT($stcls->getDOT('yes'));
					$scls->setTOT(time());
					$scls->setItemID($icls->getItemID());
					$scls->setItemCategoryID($this->getItemCategoryByItemID($icls->getItemID()));
					$scls->setQuantity($icls->getQuantity());
					$scls->setUnitPrice($val / $icls->getQuantity());
					$scls->setStockInOut(STOCK_IN);
					$scls->setClosingQty($cqty);
					$scls->setClosingValue($cval);						
					$scls->setBatchNo("");
					$scls->setNarration('Stock Transfer# '.$stcls->getStockTransferID().'<br />'.$stcls->getPurpose());
					$scls->setBalanceDetail($bald);
					
					$sql		= $scls->getInsertSQL();
					$this->conn->exec($sql);
					
					/* Stock entry ends here */
				}
				
				/* Voucher entries */
				
				$tuser	=	unserialize($_SESSION["ssEUser"]);
				$finyr	= getFinancialYear($stcls->getDOT());
				
				
				$VoucherNo	=	$this->getMaxVoucherNo(JOURNAL_VOUCHER, $finyr, $stcls->getCompanyID());
				$DayWiseNo	= $this->getMaxDayWiseVoucherNo(JOURNAL_VOUCHER, $stcls->getDOT(), $stcls->getCompanyID());
				
				if($stcls->getDebitAccountID() != 0)
					$aDet		= $this->getAccountDetail($stcls->getDebitAccountID());
				else
					$aDet		= $this->getAccountDetail($stcls->getDebitMotherAccountID());
					
				$vcls1	=	new asys_voucher_entry();
				$vcls1->setSerialID(1);
				$vcls1->setCompanyID($stcls->getCompanyID());
				$vcls1->setVoucherType(JOURNAL_VOUCHER);
				$vcls1->setFinYear($finyr);
				$vcls1->setVoucherNo($VoucherNo);
				$vcls1->setDayWiseNo($DayWiseNo);
				$vcls1->setDOV($stcls->getDOT('yes'));
				$vcls1->setMotherAccount($aDet->getMotherAccount());
				$vcls1->setAccountID($aDet->getAccountID());
				$vcls1->setRelatedID($sid);
				$vcls1->setTxnType(STOCK_TRANSFER);
				$vcls1->setDrCr(DEBIT);
				$vcls1->setAmount($tval);
				$vcls1->setNarration("STOCK TRANSFER# ".$stcls->getStockTransferID().'<br />'.$inarr);
				$vcls1->setUserID($tuser->getUserID());
				$vcls1->setDOE(date('d-m-Y'));
				
				
				if($stcls->getCreditAccountID() != 0)
					$aDet		= $this->getAccountDetail($stcls->getCreditAccountID());
				else
					$aDet		= $this->getAccountDetail($stcls->getCreditMotherAccountID());
					
				$vcls2	=	new asys_voucher_entry();
				$vcls2->setSerialID(2);
				$vcls2->setCompanyID($stcls->getCompanyID());
				$vcls2->setVoucherType(JOURNAL_VOUCHER);
				$vcls2->setFinYear($finyr);
				$vcls2->setVoucherNo($VoucherNo);
				$vcls2->setDayWiseNo($DayWiseNo);
				$vcls2->setDOV($stcls->getDOT('yes'));
				$vcls2->setMotherAccount($aDet->getMotherAccount());
				$vcls2->setAccountID($aDet->getAccountID());
				$vcls2->setRelatedID($sid);
				$vcls2->setTxnType(STOCK_TRANSFER);
				$vcls2->setDrCr(CREDIT);
				$vcls2->setAmount($tval);
				$vcls2->setNarration("STOCK TRANSFER# ".$stcls->getStockTransferID().'<br />'.$inarr);
				$vcls2->setUserID($tuser->getUserID());
				$vcls2->setDOE(date('d-m-Y'));
				
				$vid				= $this->getNextID("asys_voucher_entry", "VoucherID");
				$vcls1->setVoucherID($vid);
				$vcls2->setVoucherID($vid);
				$this->conn->exec($vcls1->getInsertSQL());
				$this->conn->exec($vcls2->getInsertSQL());
				
				/* Voucher entry ands here */
				
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'purchasedb CreateStockTransfer '.$er->getMessage();
				_errorLog($err);
				$sid	= -1;
				
			}


			return $sid;
			
		}
		
		function deleteStockTransfer($stcls) {
		
			$pkey				= $stcls->getStockTransferID();
			$cmpid			= $stcls->getCompanyID();
			$ret				= true;
		

			try {
			
				$this->conn->beginTransaction();	
				
				$this->conn->exec("DELETE FROM `gen_stocktransfer_items` WHERE `StockTransferID`='$pkey'");
				$this->conn->exec("DELETE FROM `asys_stock_voucher` WHERE `RelatedID`='$pkey' AND `ModuleID`='".STOCK_TRANSFER."' AND `CompanyID`='$cmpid'");
				$this->conn->exec("DELETE FROM `asys_voucher_entry` WHERE `RelatedID`='$pkey' AND `TxnType`='".STOCK_TRANSFER."' AND `CompanyID`='$cmpid'");
				
				$sql	= $stcls->getDeleteSQL();
				$this->conn->exec($sql);
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				$err	= 'purchasedb deleteStockTransfer '.$er->getMessage();
				_errorLog($err);
				$ret	= false;
				$this->conn->rollBack();
				
			}
				
		
			return $ret;
		}
		
		function getStockTransferDateByTransferID($StockTransferID) {
			$StockTransferID	= (int)$StockTransferID;
			$sql	= "SELECT `DOT` FROM `gen_stocktransfer` WHERE `StockTransferID`='".$StockTransferID."'";
			return $this->getResultExecutingQuery($sql);
		}		

		function UpdateStockTransfer($stcls) {
			
			$sid			= $stcls->getStockTransferID();
			$cmpid		= $stcls->getCompanyID();
			
			$vno		= $this->getVoucherNoByRelatedID(JOURNAL_VOUCHER, STOCK_TRANSFER, $sid, $cmpid);
			if($stcls->getDOT() == $this->getStockTransferDateByTransferID($sid))
				$dwn	= $this->getDayWiseNoByRelatedID(JOURNAL_VOUCHER, STOCK_TRANSFER, $sid, $cmpid);
			else
				$dwn	= $this->getMaxDayWiseVoucherNo(JOURNAL_VOUCHER, $stcls->getDOT(), $cmpid);
			

			try {
			
				$sql		= array();
			
				$this->conn->beginTransaction();
				
				$delsql1	= "DELETE FROM `gen_stocktransfer_items` WHERE `StockTransferID`='$sid'";
				$this->conn->exec($delsql1);
				
				$delsql2	= "DELETE FROM `asys_stock_voucher` WHERE `RelatedID`='$sid' AND `ModuleID`='".STOCK_TRANSFER."' AND `CompanyID`='$cmpid'";
				$delsql3	= "DELETE FROM `asys_voucher_entry` WHERE `RelatedID`='$sid' AND `TxnType`='".STOCK_TRANSFER."' AND `CompanyID`='$cmpid'";
				
				$stkcls		= array();
				
				$tval			= 0;
				
				$inarr		= $stcls->getPurpose();
				$itmList	= $stcls->getItemList();
				for($i=0;$i<count($itmList);$i++) {
					$icls	=	$itmList[$i];
					$icls->setStockTransferID($sid);
					$idet	= $this->getItemDetail($icls->getItemID());

					if($inarr != "") $inarr = $inarr."<br />";
					$inarr	= $inarr.$this->getItemNameByItemID($icls->getItemID()).' = '.$icls->getQuantity().' '.$idet->getUnitName();
					
					/* Stock entries */
					
					$lcqty	= $this->getLastStockClosingQuantityForUpdate($cmpid, $stcls->getFromStoreID(), $icls->getItemID(), $stcls->getDOT(), STOCK_TRANSFER, $sid);
					$lcval	= $this->getLastStockClosingValueForUpdate($cmpid, $stcls->getFromStoreID(), $icls->getItemID(), $stcls->getDOT(), STOCK_TRANSFER, $sid);
					$lbald	= $this->getLastBalanceDetailForUpdate($cmpid, $stcls->getFromStoreID(), $icls->getItemID(), $stcls->getDOT(), STOCK_TRANSFER, $sid);
					
					$cqty		= $lcqty - $icls->getQuantity();
					$cval		= 0;
					
					$bald			= "";
					$bqty			= 0;
					$val			= 0;
					$Quantity	= $icls->getQuantity();
					$tmp1			= explode(",", $lbald);
					for($ii=0;$ii<count($tmp1);$ii++) {
						$tmp2		= $tmp1[$ii];
						if($tmp2 == "") continue;
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						if($sqty > $Quantity) {
							$bqty	= $sqty - $Quantity;
							$val	= $val + ($Quantity * $sprc);
							break;
						} else {
							$Quantity	= $Quantity - $sqty;
							$val			= $val + ($sqty * $sprc);
						}
					}
					
					for($j=$ii;$j<count($tmp1);$j++) {
						$tmp2		= $tmp1[$j];
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						if($j == $ii) {
							if($bqty > 0) $sqty = $bqty;
						}
						
						if($bald != "") $bald = $bald.",";
						$bald		= $bald.$sqty.'='.$sprc;
					}
					
					/* Closing Value */
					$tmp1			= explode(",", $bald);
					for($ii=0;$ii<count($tmp1);$ii++) {
						$tmp2		= $tmp1[$ii];
						if($tmp2 == "") continue;
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						
						$cval		= $cval	+ ($sqty * $sprc);
					}
					/* Closing value ends here */
					
					$tval		= $tval + $val;
					
					$icls->setRate($val / $icls->getQuantity());
					$sql		= $icls->getInsertSQL();
					$this->conn->exec($sql);						
					
					$scls		= new asys_stock_voucher();
					$scls->setCompanyID($stcls->getCompanyID());
					$scls->setStoreID($stcls->getFromStoreID());
					$scls->setModuleID(STOCK_TRANSFER);
					$scls->setFinYear('');
					$scls->setRelatedID($sid);
					$scls->setDOT($stcls->getDOT('yes'));
					$scls->setTOT(time());
					$scls->setItemID($icls->getItemID());
					$scls->setItemCategoryID($this->getItemCategoryByItemID($icls->getItemID()));
					$scls->setQuantity($icls->getQuantity());
					$scls->setUnitPrice($val / $icls->getQuantity());
					$scls->setStockInOut(STOCK_OUT);
					$scls->setClosingQty($cqty);
					$scls->setClosingValue($cval);						
					$scls->setBatchNo("");
					$scls->setNarration('Stock Transfer# '.$stcls->getStockTransferID().'<br />'.$stcls->getPurpose());
					$scls->setBalanceDetail($bald);
					
					$stkcls[]	= $scls;
					
					$lcqty	= $this->getLastStockClosingQuantityForUpdate($cmpid, $stcls->getToStoreID(), $icls->getItemID(), $stcls->getDOT(), STOCK_TRANSFER, $sid);
					$lcval	= $this->getLastStockClosingValueForUpdate($cmpid, $stcls->getToStoreID(), $icls->getItemID(), $stcls->getDOT(), STOCK_TRANSFER, $sid);
					$lbald	= $this->getLastBalanceDetailForUpdate($cmpid, $stcls->getToStoreID(), $icls->getItemID(), $stcls->getDOT(), STOCK_TRANSFER, $sid);
					
					$cqty		= $lcqty + $icls->getQuantity();
					$cval		= $lcval + ($icls->getQuantity() * ($val / $icls->getQuantity()));
					$bald		= $lbald;
					if($bald != "") $bald = $bald.",";
					$bald		= $bald.$icls->getQuantity()."=".($val / $icls->getQuantity());						
					
					$scls		= new asys_stock_voucher();
					$scls->setCompanyID($stcls->getCompanyID());
					$scls->setStoreID($stcls->getToStoreID());
					$scls->setModuleID(STOCK_TRANSFER);
					$scls->setFinYear('');
					$scls->setRelatedID($sid);
					$scls->setDOT($stcls->getDOT('yes'));
					$scls->setTOT(time());
					$scls->setItemID($icls->getItemID());
					$scls->setItemCategoryID($this->getItemCategoryByItemID($icls->getItemID()));
					$scls->setQuantity($icls->getQuantity());
					$scls->setUnitPrice($val / $icls->getQuantity());
					$scls->setStockInOut(STOCK_IN);
					$scls->setClosingQty($cqty);
					$scls->setClosingValue($cval);						
					$scls->setBatchNo("");
					$scls->setNarration('Stock Transfer# '.$stcls->getStockTransferID().'<br />'.$stcls->getPurpose());
					$scls->setBalanceDetail($bald);
					
					$stkcls[]	= $scls;
					
					/* Stock entry ends here */
				}
				
				
				$this->conn->exec($delsql2);
				$this->conn->exec($delsql3);
				for($i=0;$i<count($stkcls);$i++) {
					$scls		= $stkcls[$i];
					$scls->setSVoucherID($this->getNextID("asys_stock_voucher","SVoucherID"));
					$this->conn->exec($scls->getInsertSQL());
				}				
				
				/* Voucher entries */
				
				
				$tuser	=	unserialize($_SESSION["ssEUser"]);
				$finyr	= getFinancialYear($stcls->getDOT());
				
				if($stcls->getDebitAccountID() != 0)
					$aDet		= $this->getAccountDetail($stcls->getDebitAccountID());
				else
					$aDet		= $this->getAccountDetail($stcls->getDebitMotherAccountID());
				
				$vcls1	=	new asys_voucher_entry();
				$vcls1->setSerialID(1);
				$vcls1->setCompanyID($cmpid);
				$vcls1->setVoucherType(JOURNAL_VOUCHER);
				$vcls1->setFinYear($finyr);
				$vcls1->setVoucherNo($vno);
				$vcls1->setDayWiseNo($dwn);
				$vcls1->setDOV($stcls->getDOT('yes'));
				$vcls1->setMotherAccount($aDet->getMotherAccount());
				$vcls1->setAccountID($aDet->getAccountID());
				$vcls1->setRelatedID($sid);
				$vcls1->setTxnType(STOCK_TRANSFER);
				$vcls1->setDrCr(DEBIT);
				$vcls1->setAmount($tval);
				$vcls1->setNarration("STOCK TRANSFER# ".$stcls->getStockTransferID().'<br />'.$inarr);
				$vcls1->setUserID($tuser->getUserID());
				$vcls1->setDOE(date('d-m-Y'));
				
				
				if($stcls->getCreditAccountID() != 0)
					$aDet		= $this->getAccountDetail($stcls->getCreditAccountID());
				else
					$aDet		= $this->getAccountDetail($stcls->getCreditMotherAccountID());
				
				$vcls2	=	new asys_voucher_entry();
				$vcls2->setSerialID(2);
				$vcls2->setCompanyID($cmpid);
				$vcls2->setVoucherType(JOURNAL_VOUCHER);
				$vcls2->setFinYear($finyr);
				$vcls2->setVoucherNo($vno);
				$vcls2->setDayWiseNo($dwn);
				$vcls2->setDOV($stcls->getDOT('yes'));
				$vcls2->setMotherAccount($aDet->getMotherAccount());
				$vcls2->setAccountID($aDet->getAccountID());
				$vcls2->setRelatedID($sid);
				$vcls2->setTxnType(STOCK_TRANSFER);
				$vcls2->setDrCr(CREDIT);
				$vcls2->setAmount($tval);
				$vcls2->setNarration("STOCK TRANSFER# ".$stcls->getStockTransferID().'<br />'.$inarr);
				$vcls2->setUserID($tuser->getUserID());
				$vcls2->setDOE(date('d-m-Y'));
				
				$vid		= $this->getNextID("asys_voucher_entry", "VoucherID");
				$vcls1->setVoucherID($vid);
				$vcls2->setVoucherID($vid);
				$this->conn->exec($vcls1->getInsertSQL());
				$this->conn->exec($vcls2->getInsertSQL());
				
				/* Voucher entry ands here */
									
				$sql	= $stcls->getUpdateSQL();
				$this->conn->exec($sql);
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'purchasedb UpdateStockTransfer '.$er->getMessage();
				_errorLog($err);
				$sid	= -1;
				
			}


			return $sid;
			
		}
		
		function UpdateStockTransferForRecalculation($stcls) {
			
			$sid			= $stcls->getStockTransferID();
			$cmpid		= $stcls->getCompanyID();

			try {
			
				$this->conn->beginTransaction();
				
				$tval			= 0;
				
				$itmList	= $stcls->getItemList();
				for($i=0;$i<count($itmList);$i++) {
					$icls	=	$itmList[$i];
					
					/* Stock entries */
					
					$lcqty	= $this->getLastStockClosingQuantityForUpdate($cmpid, $stcls->getFromStoreID(), $icls->getItemID(), $stcls->getDOT(), STOCK_TRANSFER, $sid);
					$lcval	= $this->getLastStockClosingValueForUpdate($cmpid, $stcls->getFromStoreID(), $icls->getItemID(), $stcls->getDOT(), STOCK_TRANSFER, $sid);
					$lbald	= $this->getLastBalanceDetailForUpdate($cmpid, $stcls->getFromStoreID(), $icls->getItemID(), $stcls->getDOT(), STOCK_TRANSFER, $sid);
					
					$cqty		= $lcqty - $icls->getQuantity();
					$cval		= 0;
					
					$bald			= "";
					$bqty			= 0;
					$val			= 0;
					$Quantity	= $icls->getQuantity();
					$tmp1			= explode(",", $lbald);
					for($ii=0;$ii<count($tmp1);$ii++) {
						$tmp2		= $tmp1[$ii];
						if($tmp2 == "") continue;
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						if($sqty > $Quantity) {
							$bqty	= $sqty - $Quantity;
							$val	= $val + ($Quantity * $sprc);
							break;
						} else {
							$Quantity	= $Quantity - $sqty;
							$val			= $val + ($sqty * $sprc);
						}
					}
					
					for($j=$ii;$j<count($tmp1);$j++) {
						$tmp2		= $tmp1[$j];
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						if($j == $ii) {
							if($bqty > 0) $sqty = $bqty;
						}
						
						if($bald != "") $bald = $bald.",";
						$bald		= $bald.$sqty.'='.$sprc;
					}
					
					/* Closing Value */
					$tmp1			= explode(",", $bald);
					for($ii=0;$ii<count($tmp1);$ii++) {
						$tmp2		= $tmp1[$ii];
						if($tmp2 == "") continue;
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						
						$cval		= $cval	+ ($sqty * $sprc);
					}
					/* Closing value ends here */
					
					$tval		= $tval + $val;
					
					/* Stock entry ends here */
				}				
				
				/* Voucher entries */
				
				$sql		= "UPDATE `asys_voucher_entry` SET `Amount`='$tval' WHERE `CompanyID`='$cmpid' AND `TxnType`='".STOCK_TRANSFER."' AND `RelatedID`='$sid' ";
				
				$this->conn->exec($sql);				
				
				
				/* Voucher entry ands here */
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'purchasedb UpdateStockTransfer '.$er->getMessage();
				_errorLog($err);
				$sid	= -1;
				
			}


			return $sid;
			
		}		
		
		function getStockTransferItemList($StockTransferID) {
			$StockTransferID	= (int)$StockTransferID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_stocktransfer_items` WHERE `StockTransferID`='$StockTransferID'";

				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_stocktransfer_items');
				while($row = $result->fetch()) {
					$row->setItemName($this->getItemNameByItemID($row->getItemID()));
					$arr[]	= $row;
				}

			} catch(PDOException $e) {
				$err	= 'purchasedb getStockTransferItemList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}



		/*-------------------------------------------------------------------*/
		/*********************** STOCK JOURNAL METHODS ***********************/

		function getStockJournalDetail($StockJournalID) {
			$StockJournalID	= (int)$StockJournalID;
			$cclass			=	new gen_stockjournal();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_stockjournal` WHERE `StockJournalID`='$StockJournalID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_stockjournal');
				if($row 	= $result->fetch()) { 
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemCategoryName( $this->getItemCategoryNameByItemCategoryID( $row->getItemCategoryID() ) );
					$row->setINItemList($this->getStockJournalINList($row->getStockJournalID()));
					$row->setOUTItemList($this->getStockJournalOUTList($row->getStockJournalID()));
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getStockJournalDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getStockJournalList($CompanyID) {
			$CompanyID	= (int)$CompanyID;
			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_stockjournal` WHERE `CompanyID`='$CompanyID' ORDER BY `StockJournalName`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_stockjournal');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemCategoryName( $this->getItemCategoryNameByItemCategoryID( $row->getItemCategoryID() ) );
					$row->setINItemList($this->getStockJournalINList($row->getStockJournalID()));
					$row->setOUTItemList($this->getStockJournalOUTList($row->getStockJournalID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getStockJournalList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getStockJournalListBySQL($sql) {
			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_stockjournal');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemCategoryName( $this->getItemCategoryNameByItemCategoryID( $row->getItemCategoryID() ) );
					$row->setINItemList($this->getStockJournalINList($row->getStockJournalID()));
					$row->setOUTItemList($this->getStockJournalOUTList($row->getStockJournalID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getStockJournalListBySQL '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getStockJournalListJSON(){
		
			$sql		= "SELECT `StockJournalID`, `StockJournalName` FROM `gen_stockjournal` ORDER BY `StockJournalName`";
			return $this->getRecordsetExecutingQuery($sql);
		
		}
		
		function getUnitPriceOfTransferredItem($StockTransferID, $ItemID){
		
			$sql		= "SELECT `UnitPrice` FROM `asys_stock_voucher` WHERE `ModuleID`='".STOCK_TRANSFER."' AND `RelatedID`='".$StockTransferID."' AND `ItemID`='".$ItemID."'";
			return $this->getResultExecutingQuery($sql);
		
		}
		
		function getNumberOfStockJournal($StoreID, $DateFrom, $DateTo, $CompanyID, $StockJournalID) {
			$StoreID	= (int)$StoreID;
			$DateFrom	= addslashes($DateFrom);
			$DateTo		= addslashes($DateTo);
			$CompanyID	= (int)$CompanyID;
			$StockJournalID	= (int)$StockJournalID;
			
			$sql		=	"SELECT COUNT(*) FROM `gen_stockjournal` WHERE `CompanyID` = '$CompanyID'";
			if($StoreID != 0)
				$sql	=	$sql." AND `StoreID`='$StoreID'";
			if($DateFrom != "" && $DateFrom != "1900-01-01")
				$sql	=	$sql." AND `DOT`>='$DateFrom'";
			if($DateTo != "" && $DateTo != "1900-01-01")
				$sql	=	$sql." AND `DOT`<='$DateTo'";
			if($StockJournalID != 0)
				$sql	=	$sql." AND `StockJournalID`='$StockJournalID'";
			
			return $this->getResultExecutingQuery($sql);
		}

		function getStockJournalListPaged($sRec, $nRec, $StoreID, $DateFrom, $DateTo, $CompanyID, $StockJournalID) {

			$StoreID	= (int)$StoreID;
			$DateFrom	= addslashes($DateFrom);
			$DateTo		= addslashes($DateTo);
			$CompanyID	= (int)$CompanyID;
			$StockJournalID	= (int)$StockJournalID;

			$sql			=	"SELECT * FROM `gen_stockjournal` WHERE `CompanyID` = '$CompanyID'";
			if($StoreID != 0)
				$sql	=	$sql." AND `StoreID`='$StoreID'";
			if($DateFrom != "" && $DateFrom != "1900-01-01")
				$sql	=	$sql." AND `DOT`>='$DateFrom'";
			if($DateTo != "" && $DateTo != "1900-01-01")
				$sql	=	$sql." AND `DOT`<='$DateTo'";
			if($StockJournalID != 0)
				$sql	=	$sql." AND `StockJournalID`='$StockJournalID'";				

			$sql			=	$sql." ORDER BY `DOT` DESC, `StockJournalID` DESC LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_stockjournal');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setStoreName($this->getStoreNameByStoreID($row->getStoreID()));
					$row->setItemCategoryName( $this->getItemCategoryNameByItemCategoryID( $row->getItemCategoryID() ) );
					$row->setINItemList($this->getStockJournalINList($row->getStockJournalID()));
					$row->setOUTItemList($this->getStockJournalOUTList($row->getStockJournalID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getStockJournalListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function CreateStockJournal($sjcls) {
				
			$sid		= 0;
			$cmpid	= $sjcls->getCompanyID();

			try {
			
				$this->conn->beginTransaction();
				
				$sjcls->setStockJournalID($this->getNextID("gen_stockjournal", "StockJournalID"));
				$sid		= $sjcls->getStockJournalID();
				
				$sql	= $sjcls->getInsertSQL();
				$this->conn->exec($sql);				
				
				$tval			= 0;
				
				$outItemList	= $sjcls->getOUTItemList();
				for($i=0;$i<count($outItemList);$i++) {
					$icls	=	$outItemList[$i];
					$icls->setStockJournalID($sid);
					
					/* Stock entries */
					
					$lcqty	= $this->getLastStockClosingQuantity($cmpid, $sjcls->getStoreID(), $icls->getItemID(), $sjcls->getDOT());
					$lcval	= $this->getLastStockClosingValue($cmpid, $sjcls->getStoreID(), $icls->getItemID(), $sjcls->getDOT());
					$lbald	= $this->getLastBalanceDetail($cmpid, $sjcls->getStoreID(), $icls->getItemID(), $sjcls->getDOT());
					
					$cqty		= $lcqty - $icls->getQuantity();
					$cval		= 0;
					
					$bald			= "";
					$bqty			= 0;
					$val			= 0;
					$Quantity	= $icls->getQuantity();
					$tmp1			= explode(",", $lbald);
					for($ii=0;$ii<count($tmp1);$ii++) {
						$tmp2		= $tmp1[$ii];
						if($tmp2 == "") continue;
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						if($sqty > $Quantity) {
							$bqty	= $sqty - $Quantity;
							$val	= $val + ($Quantity * $sprc);
							break;
						} else {
							$Quantity	= $Quantity - $sqty;
							$val			= $val + ($sqty * $sprc);
						}
					}
					
					for($j=$ii;$j<count($tmp1);$j++) {
						$tmp2		= $tmp1[$j];
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						if($j == $ii) {
							if($bqty > 0) $sqty = $bqty;
						}
						
						if($bald != "") $bald = $bald.",";
						$bald		= $bald.$sqty.'='.$sprc;
					}
					
					/* Closing Value */
					$tmp1			= explode(",", $bald);
					for($ii=0;$ii<count($tmp1);$ii++) {
						$tmp2		= $tmp1[$ii];
						if($tmp2 == "") continue;
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						
						$cval		= $cval	+ ($sqty * $sprc);
					}
					/* Closing value ends here */
					
					$tval		= $tval + $val;
					
					$icls->setRate($val / $icls->getQuantity());
					$sql		= $icls->getInsertSQL();
					$this->conn->exec($sql);						
					
					$scls		= new asys_stock_voucher();
					$scls->setSVoucherID($this->getNextID("asys_stock_voucher","SVoucherID"));
					$scls->setCompanyID($sjcls->getCompanyID());
					$scls->setStoreID($sjcls->getStoreID());
					$scls->setModuleID(STOCK_JOURNAL);
					$scls->setFinYear('');
					$scls->setRelatedID($sid);
					$scls->setDOT($sjcls->getDOT('yes'));
					$scls->setTOT(time());
					$scls->setItemID($icls->getItemID());
					$scls->setItemCategoryID($this->getItemCategoryByItemID($icls->getItemID()));
					$scls->setQuantity($icls->getQuantity());
					$scls->setUnitPrice($val / $icls->getQuantity());
					$scls->setStockInOut(STOCK_OUT);
					$scls->setClosingQty($cqty);
					$scls->setClosingValue($cval);
					$scls->setBatchNo("");
					$scls->setNarration('Stock Journal# '.$sjcls->getStockJournalID());
					$scls->setBalanceDetail($bald);
					
					$sql		= $scls->getInsertSQL();
					$this->conn->exec($sql);
					
					/* Stock entry ends here */
				}
				
				$inItemList	= $sjcls->getINItemList();
				for($i=0;$i<count($inItemList);$i++) {
					$icls	=	$inItemList[$i];
					$icls->setStockJournalID($sid);

					$icls->setRate($tval / $icls->getQuantity());
					$sql		= $icls->getInsertSQL();
					$this->conn->exec($sql);
					
					/* Stock entries */
					
					$lcqty	= $this->getLastStockClosingQuantity($cmpid, $sjcls->getStoreID(), $icls->getItemID(), $sjcls->getDOT());
					$lcval	= $this->getLastStockClosingValue($cmpid, $sjcls->getStoreID(), $icls->getItemID(), $sjcls->getDOT());
					$lbald	= $this->getLastBalanceDetail($cmpid, $sjcls->getStoreID(), $icls->getItemID(), $sjcls->getDOT());
					
					$cqty		= $lcqty + $icls->getQuantity();
					$cval		= $lcval + ($icls->getQuantity() * ($tval / $icls->getQuantity()));
					$bald		= $lbald;
					if($bald != "") $bald = $bald.",";
					$bald		= $bald.$icls->getQuantity()."=".($tval / $icls->getQuantity());						
					
					$scls		= new asys_stock_voucher();
					$scls->setSVoucherID($this->getNextID("asys_stock_voucher","SVoucherID"));
					$scls->setCompanyID($sjcls->getCompanyID());
					$scls->setStoreID($sjcls->getStoreID());
					$scls->setModuleID(STOCK_JOURNAL);
					$scls->setFinYear('');
					$scls->setRelatedID($sid);
					$scls->setDOT($sjcls->getDOT('yes'));
					$scls->setTOT(time());
					$scls->setItemID($icls->getItemID());
					$scls->setItemCategoryID($this->getItemCategoryByItemID($icls->getItemID()));
					$scls->setQuantity($icls->getQuantity());
					$scls->setUnitPrice($tval / $icls->getQuantity());
					$scls->setStockInOut(STOCK_IN);
					$scls->setClosingQty($cqty);
					$scls->setClosingValue($cval);						
					$scls->setBatchNo("");
					$scls->setNarration('Stock Journal# '.$sjcls->getStockJournalID());
					$scls->setBalanceDetail($bald);	
					
					$sql		= $scls->getInsertSQL();
					$this->conn->exec($sql);
					
					/* Stock entry ends here */
				}
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'purchasedb CreateStockJournal (line 4414) '.$er->getMessage();
				_errorLog($err);
				$sid	= -1;
				
			}


			return $sid;
			
		}

		function deleteStockJournal($lcls) {
		
			$pkey		= $lcls->getStockJournalID();
			$cmpid	= $lcls->getCompanyID();
			$ret		= true;
		

			try {
			
				$this->conn->beginTransaction();
			
				$this->conn->exec("DELETE FROM `gen_stockjournal_in` WHERE `StockJournalID`='$pkey'");
				$this->conn->exec("DELETE FROM `gen_stockjournal_out` WHERE `StockJournalID`='$pkey'");
				$this->conn->exec("DELETE FROM `asys_stock_voucher` WHERE `RelatedID`='$pkey' AND `ModuleID`='".STOCK_JOURNAL."' AND `CompanyID`='$cmpid'");
			
				$sql	= $lcls->getDeleteSQL();
				$this->conn->query($sql);
				
				$this->conn->commit();
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'purchasedb deleteStockJournal '.$er->getMessage();
				_errorLog($err);
				$sid	= -1;
				
			}

		
			return $ret;
		}
		
		function UpdateStockJournal($sjcls) {

			$sid	= $sjcls->getStockJournalID();
			$cmpid	= $sjcls->getCompanyID();
			
			
			try {
			
				$this->conn->beginTransaction();
				
				$delsql1	= "DELETE FROM `gen_stockjournal_in` WHERE `StockJournalID`='$sid'";
				$delsql2	= "DELETE FROM `gen_stockjournal_out` WHERE `StockJournalID`='$sid'";
				$this->conn->exec($delsql1);
				$this->conn->exec($delsql2);				
				
				$delsql3	= "DELETE FROM `asys_stock_voucher` WHERE `RelatedID`='$sid' AND `ModuleID`='".STOCK_JOURNAL."' AND `CompanyID`='$cmpid'";
				
				$stkcls		= array();

				$tval			= 0;
				
				$outItemList	= $sjcls->getOUTItemList();
				for($i=0;$i<count($outItemList);$i++) {
					$icls	=	$outItemList[$i];
					$icls->setStockJournalID($sid);
					
					/* Stock entries */
					
					$lcqty	= $this->getLastStockClosingQuantityForUpdate($cmpid, $sjcls->getStoreID(), $icls->getItemID(), $sjcls->getDOT(), STOCK_JOURNAL, $sid);
					$lcval	= $this->getLastStockClosingValueForUpdate($cmpid, $sjcls->getStoreID(), $icls->getItemID(), $sjcls->getDOT(), STOCK_JOURNAL, $sid);
					$lbald	= $this->getLastBalanceDetailForUpdate($cmpid, $sjcls->getStoreID(), $icls->getItemID(), $sjcls->getDOT(), STOCK_JOURNAL, $sid);
					
					$cqty		= $lcqty - $icls->getQuantity();
					$cval		= 0;
					
					$bald			= "";
					$bqty			= 0;
					$val			= 0;
					$Quantity	= $icls->getQuantity();
					$tmp1			= explode(",", $lbald);
					for($ii=0;$ii<count($tmp1);$ii++) {
						$tmp2		= $tmp1[$ii];
						if($tmp2 == "") continue;
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						if($sqty > $Quantity) {
							$bqty	= $sqty - $Quantity;
							$val	= $val + ($Quantity * $sprc);
							break;
						} else {
							$Quantity	= $Quantity - $sqty;
							$val			= $val + ($sqty * $sprc);
						}
					}
					
					for($j=$ii;$j<count($tmp1);$j++) {
						$tmp2		= $tmp1[$j];
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						if($j == $ii) {
							if($bqty > 0) $sqty = $bqty;
						}
						
						if($bald != "") $bald = $bald.",";
						$bald		= $bald.$sqty.'='.$sprc;
					}
					
					/* Closing Value */
					$tmp1			= explode(",", $bald);
					for($ii=0;$ii<count($tmp1);$ii++) {
						$tmp2		= $tmp1[$ii];
						if($tmp2 == "") continue;
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						
						$cval		= $cval	+ ($sqty * $sprc);
					}
					/* Closing value ends here */
					
					$tval		= $tval + $val;
					
					$icls->setRate($val / $icls->getQuantity());
					$sql		= $icls->getInsertSQL();
					$this->conn->exec($sql);						
					
					$scls		= new asys_stock_voucher();
					$scls->setCompanyID($sjcls->getCompanyID());
					$scls->setStoreID($sjcls->getStoreID());
					$scls->setModuleID(STOCK_JOURNAL);
					$scls->setFinYear('');
					$scls->setRelatedID($sid);
					$scls->setDOT($sjcls->getDOT('yes'));
					$scls->setTOT(time());
					$scls->setItemID($icls->getItemID());
					$scls->setItemCategoryID($this->getItemCategoryByItemID($icls->getItemID()));
					$scls->setQuantity($icls->getQuantity());
					$scls->setUnitPrice($val / $icls->getQuantity());
					$scls->setStockInOut(STOCK_OUT);
					$scls->setClosingQty($cqty);
					$scls->setClosingValue($cval);
					$scls->setBatchNo("");
					$scls->setNarration('Stock Journal# '.$sjcls->getStockJournalID());
					$scls->setBalanceDetail($bald);
					
					$stkcls[]	= $scls;
					
					/* Stock entry ends here */
				}
				
				$inItemList	= $sjcls->getINItemList();
				for($i=0;$i<count($inItemList);$i++) {
					$icls	=	$inItemList[$i];
					$icls->setStockJournalID($sid);

					$icls->setRate($tval / $icls->getQuantity());
					$sql		= $icls->getInsertSQL();
					$this->conn->exec($sql);
					
					/* Stock entries */
					
					$lcqty	= $this->getLastStockClosingQuantityForUpdate($cmpid, $sjcls->getStoreID(), $icls->getItemID(), $sjcls->getDOT(), STOCK_JOURNAL, $sid);
					$lcval	= $this->getLastStockClosingValueForUpdate($cmpid, $sjcls->getStoreID(), $icls->getItemID(), $sjcls->getDOT(), STOCK_JOURNAL, $sid);
					$lbald	= $this->getLastBalanceDetailForUpdate($cmpid, $sjcls->getStoreID(), $icls->getItemID(), $sjcls->getDOT(), STOCK_JOURNAL, $sid);
					
					$cqty		= $lcqty + $icls->getQuantity();
					$cval		= $lcval + ($icls->getQuantity() * ($tval / $icls->getQuantity()));
					$bald		= $lbald;
					if($bald != "") $bald = $bald.",";
					$bald		= $bald.$icls->getQuantity()."=".($tval / $icls->getQuantity());						
					
					$scls		= new asys_stock_voucher();
					$scls->setCompanyID($sjcls->getCompanyID());
					$scls->setStoreID($sjcls->getStoreID());
					$scls->setModuleID(STOCK_JOURNAL);
					$scls->setFinYear('');
					$scls->setRelatedID($sid);
					$scls->setDOT($sjcls->getDOT('yes'));
					$scls->setTOT(time());
					$scls->setItemID($icls->getItemID());
					$scls->setItemCategoryID($this->getItemCategoryByItemID($icls->getItemID()));
					$scls->setQuantity($icls->getQuantity());
					$scls->setUnitPrice($tval / $icls->getQuantity());
					$scls->setStockInOut(STOCK_IN);
					$scls->setClosingQty($cqty);
					$scls->setClosingValue($cval);						
					$scls->setBatchNo("");
					$scls->setNarration('Stock Journal# '.$sjcls->getStockJournalID());
					$scls->setBalanceDetail($bald);
					
					$stkcls[]	= $scls;
					
					/* Stock entry ends here */
				}
				

				$this->conn->exec($delsql3);
				for($i=0;$i<count($stkcls);$i++) {
					$scls		= $stkcls[$i];
					$scls->setSVoucherID($this->getNextID("asys_stock_voucher","SVoucherID"));
					$this->conn->exec($scls->getInsertSQL());
				}				
				
				$sql	= $sjcls->getUpdateSQL();
				$this->conn->exec($sql);
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'purchasedb UpdateStockJournal (line 4572) '.$er->getMessage();
				_errorLog($err);
				$sid	= -1;
				
			}


			return $sid;
			
		}
		
		function getStockJournalINList($StockJournalID) {
			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_stockjournal_in` WHERE `StockJournalID`='$StockJournalID' ORDER BY `ItemID`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_stockjournal_in');
				while($row = $result->fetch()) {
					$row->setItemName($this->getItemNameByItemID($row->getItemID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getStockJournalINList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getStockJournalOUTList($StockJournalID) {
			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_stockjournal_out` WHERE `StockJournalID`='$StockJournalID' ORDER BY `ItemID`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_stockjournal_out');
				while($row = $result->fetch()) {
					$row->setItemName($this->getItemNameByItemID($row->getItemID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getStockJournalOUTList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}



		/*----------------------------------------------------------------------------*/
		/*********************** COMPANY STOCK TRANSFER METHODS ***********************/
		
		function getCStockTransferDetail($CStockTransferID) {
			$CStockTransferID	= (int)$CStockTransferID;
			$cclass			=	new gen_cstocktransfer();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_cstocktransfer` WHERE `CStockTransferID`='$CStockTransferID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_cstocktransfer');
				if($row 	= $result->fetch()) {
					$row->setFromCompanyName($this->getCompanyNameByCompanyID($row->getFromCompanyID()));
					$row->setFromStoreName($this->getStoreNameByStoreID($row->getFromStoreID()));
					$row->setToCompanyName($this->getCompanyNameByCompanyID($row->getToCompanyID()));
					$row->setToStoreName($this->getStoreNameByStoreID($row->getToStoreID()));
					$row->setItemList($this->getCStockTransferItemList($row->getCStockTransferID()));
					$cclass	= $row;
				}

			} catch(PDOException $e) {
				$err	= 'purchasedb getCStockTransferDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getCStockTransferList($CompanyID) {
			$CompanyID	= (int)$CompanyID;
			$arr	=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_cstocktransfer` WHERE `FromCompanyID`='$CompanyID' ORDER BY `DOT`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_cstocktransfer');
				while($row = $result->fetch()) {
					$row->setFromCompanyName($this->getCompanyNameByCompanyID($row->getFromCompanyID()));
					$row->setFromStoreName($this->getStoreNameByStoreID($row->getFromStoreID()));
					$row->setToCompanyName($this->getCompanyNameByCompanyID($row->getToCompanyID()));
					$row->setToStoreName($this->getStoreNameByStoreID($row->getToStoreID()));
					$row->setItemList($this->getCStockTransferItemList($row->getCStockTransferID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getCStockTransferList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getNumberOfCStockTransfer($DateFrom, $DateTo, $CompanyID) {
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$CompanyID	= (int)$CompanyID;
			
			$sql		=	"SELECT COUNT(*) FROM `gen_cstocktransfer` WHERE `FromCompanyID` = '$CompanyID'";
			if($DateFrom != "1900-01-01")
				$sql	=	$sql." AND `DOT`>='$DateFrom'";
			if($DateTo != "1900-01-01")
				$sql	=	$sql." AND `DOT`<='$DateTo'";
			
			return $this->getResultExecutingQuery($sql);
		}

		function getCStockTransferListPaged($sRec, $nRec, $DateFrom, $DateTo, $CompanyID) {
			$DateFrom		= addslashes($DateFrom);
			$DateTo			= addslashes($DateTo);
			$CompanyID	= (int)$CompanyID;
					
			$sql		=	"SELECT * FROM `gen_cstocktransfer` WHERE `FromCompanyID` = '$CompanyID'";
			if($DateFrom != "1900-01-01")
				$sql	=	$sql." AND `DOT`>='$DateFrom'";
			if($DateTo != "1900-01-01")
				$sql	=	$sql." AND `DOT`<='$DateTo'";
			$sql		=	$sql." ORDER BY `DOT` DESC LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_cstocktransfer');
				while($row = $result->fetch()) {
					$row->setFromCompanyName($this->getCompanyNameByCompanyID($row->getFromCompanyID()));
					$row->setFromStoreName($this->getStoreNameByStoreID($row->getFromStoreID()));
					$row->setToCompanyName($this->getCompanyNameByCompanyID($row->getToCompanyID()));
					$row->setToStoreName($this->getStoreNameByStoreID($row->getToStoreID()));
					$row->setItemList($this->getCStockTransferItemList($row->getCStockTransferID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getCStockTransferListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}

		function CreateCStockTransfer($stcls) {
				
			$sid		= 0;

			try {
			
				$this->conn->beginTransaction();
				
				$stcls->setCStockTransferID($this->getNextID("gen_cstocktransfer", "CStockTransferID"));
				$sid	= $stcls->getCStockTransferID();				
				
				$sql	= $stcls->getInsertSQL();
				$this->conn->exec($sql);				
				
				$itmList	= $stcls->getItemList();
				for($i=0;$i<count($itmList);$i++) {
					$icls	=	$itmList[$i];
					$icls->setCStockTransferID($sid);
					
					/* Stock entries */
					
					$lcqty	= $this->getLastStockClosingQuantity($stcls->getFromCompanyID(), $stcls->getFromStoreID(), $icls->getItemID(), $stcls->getDOT());
					$lcval	= $this->getLastStockClosingValue($stcls->getFromCompanyID(), $stcls->getFromStoreID(), $icls->getItemID(), $stcls->getDOT());
					$lbald	= $this->getLastBalanceDetail($stcls->getFromCompanyID(), $stcls->getFromStoreID(), $icls->getItemID(), $stcls->getDOT());
					
					$cqty		= $lcqty - $icls->getQuantity();
					$cval		= 0;
					
					$bald			= "";
					$bqty			= 0;
					$val			= 0;
					$Quantity	= $icls->getQuantity();
					$tmp1			= explode(",", $lbald);
					for($ii=0;$ii<count($tmp1);$ii++) {
						$tmp2		= $tmp1[$ii];
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						if($sqty > $Quantity) {
							$bqty	= $sqty - $Quantity;
							$val	= $val + ($Quantity * $sprc);
							break;
						} else {
							$Quantity	= $Quantity - $sqty;
							$val			= $val + ($sqty * $sprc);
						}
					}
					
					for($j=$ii;$j<count($tmp1);$j++) {
						$tmp2		= $tmp1[$j];
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						if($j == $ii) {
							if($bqty > 0) $sqty = $bqty;
						}
						
						if($bald != "") $bald = $bald.",";
						$bald		= $bald.$sqty.'='.$sprc;
					}
					
					/* Closing Value */
					$tmp1			= explode(",", $bald);
					for($ii=0;$ii<count($tmp1);$ii++) {
						$tmp2		= $tmp1[$ii];
						if($tmp2 == "") continue;
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						
						$cval		= $cval	+ ($sqty * $sprc);
					}
					/* Closing value ends here */
					
					$tval		= $tval + $val;
					
					$icls->setRate($val / $icls->getQuantity());
					$sql		= $icls->getInsertSQL();
					$this->conn->exec($sql);						
					
					$scls		= new asys_stock_voucher();
					$scls->setSVoucherID($this->getNextID("asys_stock_voucher","SVoucherID"));
					$scls->setCompanyID($stcls->getFromCompanyID());
					$scls->setStoreID($stcls->getFromStoreID());
					$scls->setModuleID(COMPANY_STOCK_TRANSFER);
					$scls->setFinYear('');
					$scls->setRelatedID($sid);
					$scls->setDOT($stcls->getDOT('yes'));
					$scls->setTOT(time());
					$scls->setItemID($icls->getItemID());
					$scls->setItemCategoryID($this->getItemCategoryByItemID($icls->getItemID()));
					$scls->setQuantity($icls->getQuantity());
					$scls->setUnitPrice($val / $icls->getQuantity());
					$scls->setStockInOut(STOCK_OUT);
					$scls->setClosingQty($cqty);
					$scls->setClosingValue($cval);						
					$scls->setBatchNo("");
					$scls->setNarration('Company-Company Stock Transfer# '.$stcls->getCStockTransferID());
					$scls->setBalanceDetail($bald);
					
					$sql		= $scls->getInsertSQL();
					$this->conn->exec($sql);
					
					
					$lcqty	= $this->getLastStockClosingQuantity($stcls->getToCompanyID(), $stcls->getToStoreID(), $icls->getItemID(), $stcls->getDOT());
					$lcval	= $this->getLastStockClosingValue($stcls->getToCompanyID(), $stcls->getToStoreID(), $icls->getItemID(), $stcls->getDOT());
					$lbald	= $this->getLastBalanceDetail($stcls->getToCompanyID(), $stcls->getToStoreID(), $icls->getItemID(), $stcls->getDOT());
					
					$cqty		= $lcqty + $icls->getQuantity();
					$cval		= $lcval + ($icls->getQuantity() * ($val / $icls->getQuantity()));
					$bald		= $lbald;
					if($bald != "") $bald = $bald.",";
					$bald		= $bald.$icls->getQuantity()."=".($val / $icls->getQuantity());						
					
					$scls		= new asys_stock_voucher();
					$scls->setSVoucherID($this->getNextID("asys_stock_voucher","SVoucherID"));
					$scls->setCompanyID($stcls->getToCompanyID());
					$scls->setStoreID($stcls->getToStoreID());
					$scls->setModuleID(COMPANY_STOCK_TRANSFER);
					$scls->setFinYear('');
					$scls->setRelatedID($sid);
					$scls->setDOT($stcls->getDOT('yes'));
					$scls->setTOT(time());
					$scls->setItemID($icls->getItemID());
					$scls->setItemCategoryID($this->getItemCategoryByItemID($icls->getItemID()));
					$scls->setQuantity($icls->getQuantity());
					$scls->setUnitPrice($val / $icls->getQuantity());
					$scls->setStockInOut(STOCK_IN);
					$scls->setClosingQty($cqty);
					$scls->setClosingValue($cval);						
					$scls->setBatchNo("");
					$scls->setNarration('Company-Company Stock Transfer# '.$stcls->getCStockTransferID());
					$scls->setBalanceDetail($bald);
					
					$sql		= $scls->getInsertSQL();
					$this->conn->exec($sql);
					
					
					/* Stock entry ends here */
				}
				
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'purchasedb CreateCStockTransfer '.$er->getMessage();
				_errorLog($err);
				$sid	= -1;
				
			}


			return $sid;
			
		}
		
		function deleteCStockTransfer($stcls) {
		
			$pkey				= $stcls->getCStockTransferID();
			$fcid				= $stcls->getFromCompanyID();
			$tcid				= $stcls->getToCompanyID();
			$ret				= true;
		

			try {
			
				$this->conn->beginTransaction();
				
				$this->conn->exec("DELETE FROM `gen_cstocktransfer_items` WHERE `CStockTransferID`='$pkey'");	
				$this->conn->exec("DELETE FROM `asys_stock_voucher` WHERE `RelatedID`='$pkey' AND `ModuleID`='".COMPANY_STOCK_TRANSFER."' AND `CompanyID`='$fcid'");
				$this->conn->exec("DELETE FROM `asys_stock_voucher` WHERE `RelatedID`='$pkey' AND `ModuleID`='".COMPANY_STOCK_TRANSFER."' AND `CompanyID`='$tcid'");
				
				$sql	= $stcls->getDeleteSQL();
				$this->conn->exec($sql);
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				$err	= 'purchasedb deleteCStockTransfer '.$er->getMessage();
				_errorLog($err);
				$ret	= false;
				$this->conn->rollBack();
				
			}

		
			return $ret;
		}

		function UpdateCStockTransfer($stcls) {
			
			$sid				= $stcls->getCStockTransferID();
			$fcid				= $stcls->getFromCompanyID();
			$tcid				= $stcls->getToCompanyID();
			
			
			try {
			
				$this->conn->beginTransaction();
				
				$delsql1	= "DELETE FROM `gen_cstocktransfer_items` WHERE `CStockTransferID`='$sid'";
				$this->conn->exec($delsql1);
				
				$delsql2	= "DELETE FROM `asys_stock_voucher` WHERE `RelatedID`='$sid' AND `ModuleID`='".COMPANY_STOCK_TRANSFER."' AND `CompanyID`='$fcid'";
				$delsql3	= "DELETE FROM `asys_stock_voucher` WHERE `RelatedID`='$sid' AND `ModuleID`='".COMPANY_STOCK_TRANSFER."' AND `CompanyID`='$tcid'";
				
				$stkcls		= array();
				
				$itmList	= $stcls->getItemList();
				for($i=0;$i<count($itmList);$i++) {
					$icls	=	$itmList[$i];
					$icls->setCStockTransferID($sid);
					
					/* Stock entries */
					
					$lcqty	= $this->getLastStockClosingQuantityForUpdate($stcls->getFromCompanyID(), $stcls->getFromStoreID(), $icls->getItemID(), $stcls->getDOT(), COMPANY_STOCK_TRANSFER, $sid);
					$lcval	= $this->getLastStockClosingValueForUpdate($stcls->getFromCompanyID(), $stcls->getFromStoreID(), $icls->getItemID(), $stcls->getDOT(), COMPANY_STOCK_TRANSFER, $sid);
					$lbald	= $this->getLastBalanceDetailForUpdate($stcls->getFromCompanyID(), $stcls->getFromStoreID(), $icls->getItemID(), $stcls->getDOT(), COMPANY_STOCK_TRANSFER, $sid);
					
					$cqty		= $lcqty - $icls->getQuantity();
					$cval		= 0;
					
					$bald			= "";
					$bqty			= 0;
					$val			= 0;
					$Quantity	= $icls->getQuantity();
					$tmp1			= explode(",", $lbald);
					for($ii=0;$ii<count($tmp1);$ii++) {
						$tmp2		= $tmp1[$ii];
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						if($sqty > $Quantity) {
							$bqty	= $sqty - $Quantity;
							$val	= $val + ($Quantity * $sprc);
							break;
						} else {
							$Quantity	= $Quantity - $sqty;
							$val			= $val + ($sqty * $sprc);
						}
					}
					
					for($j=$ii;$j<count($tmp1);$j++) {
						$tmp2		= $tmp1[$j];
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						if($j == $ii) {
							if($bqty > 0) $sqty = $bqty;
						}
						
						if($bald != "") $bald = $bald.",";
						$bald		= $bald.$sqty.'='.$sprc;
					}
					
					/* Closing Value */
					$tmp1			= explode(",", $bald);
					for($ii=0;$ii<count($tmp1);$ii++) {
						$tmp2		= $tmp1[$ii];
						if($tmp2 == "") continue;
						$tmp		= explode("=", $tmp2);
						$sqty		= (double)$tmp[0];
						$sprc		= (double)$tmp[1];
						
						$cval		= $cval	+ ($sqty * $sprc);
					}
					/* Closing value ends here */
					
					$tval		= $tval + $val;
					
					$icls->setRate($val / $icls->getQuantity());
					$sql		= $icls->getInsertSQL();
					$this->conn->exec($sql);						
					
					$scls		= new asys_stock_voucher();
					$scls->setCompanyID($stcls->getFromCompanyID());
					$scls->setStoreID($stcls->getFromStoreID());
					$scls->setModuleID(COMPANY_STOCK_TRANSFER);
					$scls->setFinYear('');
					$scls->setRelatedID($sid);
					$scls->setDOT($stcls->getDOT('yes'));
					$scls->setTOT(time());
					$scls->setItemID($icls->getItemID());
					$scls->setItemCategoryID($this->getItemCategoryByItemID($icls->getItemID()));
					$scls->setQuantity($icls->getQuantity());
					$scls->setUnitPrice($val / $icls->getQuantity());
					$scls->setStockInOut(STOCK_OUT);
					$scls->setClosingQty($cqty);
					$scls->setClosingValue($cval);						
					$scls->setBatchNo("");
					$scls->setNarration('Company-Company Stock Transfer# '.$stcls->getCStockTransferID());
					$scls->setBalanceDetail($bald);
					
					$stkcls[]	= $scls;
					
					$lcqty	= $this->getLastStockClosingQuantityForUpdate($stcls->getToCompanyID(), $stcls->getToStoreID(), $icls->getItemID(), $stcls->getDOT(), COMPANY_STOCK_TRANSFER, $sid);
					$lcval	= $this->getLastStockClosingValueForUpdate($stcls->getToCompanyID(), $stcls->getToStoreID(), $icls->getItemID(), $stcls->getDOT(), COMPANY_STOCK_TRANSFER, $sid);
					$lbald	= $this->getLastBalanceDetailForUpdate($stcls->getToCompanyID(), $stcls->getToStoreID(), $icls->getItemID(), $stcls->getDOT(), COMPANY_STOCK_TRANSFER, $sid);
					
					$cqty		= $lcqty + $icls->getQuantity();
					$cval		= $lcval + ($icls->getQuantity() * ($val / $icls->getQuantity()));
					$bald		= $lbald;
					if($bald != "") $bald = $bald.",";
					$bald		= $bald.$icls->getQuantity()."=".($val / $icls->getQuantity());						
					
					$scls		= new asys_stock_voucher();
					$scls->setSVoucherID($_sid);
					$scls->setCompanyID($stcls->getToCompanyID());
					$scls->setStoreID($stcls->getToStoreID());
					$scls->setModuleID(COMPANY_STOCK_TRANSFER);
					$scls->setFinYear('');
					$scls->setRelatedID($sid);
					$scls->setDOT($stcls->getDOT('yes'));
					$scls->setTOT(time());
					$scls->setItemID($icls->getItemID());
					$scls->setItemCategoryID($this->getItemCategoryByItemID($icls->getItemID()));
					$scls->setQuantity($icls->getQuantity());
					$scls->setUnitPrice($val / $icls->getQuantity());
					$scls->setStockInOut(STOCK_IN);
					$scls->setClosingQty($cqty);
					$scls->setClosingValue($cval);						
					$scls->setBatchNo("");
					$scls->setNarration('Company-Company Stock Transfer# '.$stcls->getCStockTransferID());
					$scls->setBalanceDetail($bald);
					
					$stkcls[]	= $scls;
					
					/* Stock entry ends here */
				}
				
				
				$this->conn->exec($delsql2);
				$this->conn->exec($delsql3);
				for($i=0;$i<count($stkcls);$i++) {
					$scls		= $stkcls[$i];
					$scls->setSVoucherID($this->getNextID("asys_stock_voucher","SVoucherID"));
					$this->conn->exec($scls->getInsertSQL());
				}				
									
				$sql	= $stcls->getUpdateSQL();
				$this->conn->exec($sql);
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'purchasedb UpdateCStockTransfer (line 4968) '.$er->getMessage();
				_errorLog($err);
				$sid	= -1;
				
			}
				

			return $sid;
			
		}
		
		function getCStockTransferItemList($CStockTransferID) {
			$CStockTransferID	= (int)$CStockTransferID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_cstocktransfer_items` WHERE `CStockTransferID`='$CStockTransferID'";

				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_cstocktransfer_items');
				while($row = $result->fetch()) {
					$row->setItemName($this->getItemNameByItemID($row->getItemID()));
					$arr[]	= $row;
				}

			} catch(PDOException $e) {
				$err	= 'purchasedb getCStockTransferItemList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		
		
		/*----------------------------------------------------------------------------*/
		/*********************** STOCK TRANSFER + ISSUE METHODS ***********************/

		function getTransferIssueDetail($BookingID) {
			$BookingID	= (int)$BookingID;
			$cclass			=	new gen_transferissue();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_transferissue` WHERE `BookingID`='$BookingID'";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_transferissue');
				if($row 	= $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setFromStoreName($this->getStoreNameByStoreID($row->getFromStoreID()));
					$row->setToStoreName($this->getStoreNameByStoreID($row->getToStoreID()));
					$row->setDebitMotherAccountName( $this->getAccountNameByAccountID( $row->getDebitMotherAccountID() ) );
					$row->setDebitAccountName( $this->getAccountNameByAccountID( $row->getDebitAccountID() ) );
					$row->setItemList($this->getTransferIssueItemList($row->getBookingID()));
					$cclass	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getTransferIssueDetail '.$e->getMessage();
				_errorLog($err);
			}

			return $cclass;
		}

		function getTransferIssueList($CompanyID) {
			$arr				=	array();
			$CompanyID	= (int)$CompanyID;
			
			try {
				
				$sql			=	"SELECT * FROM `gen_transferissue` WHERE `CompanyID`='$CompanyID' ORDER BY `DOT`";
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_transferissue');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setFromStoreName($this->getStoreNameByStoreID($row->getFromStoreID()));
					$row->setToStoreName($this->getStoreNameByStoreID($row->getToStoreID()));
					$row->setDebitMotherAccountName( $this->getAccountNameByAccountID( $row->getDebitMotherAccountID() ) );
					$row->setDebitAccountName( $this->getAccountNameByAccountID( $row->getDebitAccountID() ) );
					$row->setItemList($this->getTransferIssueItemList($row->getBookingID()));	
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getTransferIssueList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getTransferIssueListBySQL($sql) {
			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_transferissue');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setFromStoreName($this->getStoreNameByStoreID($row->getFromStoreID()));
					$row->setToStoreName($this->getStoreNameByStoreID($row->getToStoreID()));
					$row->setDebitMotherAccountName( $this->getAccountNameByAccountID( $row->getDebitMotherAccountID() ) );
					$row->setDebitAccountName( $this->getAccountNameByAccountID( $row->getDebitAccountID() ) );
					$row->setItemList($this->getTransferIssueItemList($row->getBookingID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getTransferIssueListBySQL '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getNumberOfTransferIssue($DateFrom, $DateTo, $CompanyID, $BookingNo) {
			$DateFrom	= addslashes($DateFrom);
			$DateTo		= addslashes($DateTo);
			$CompanyID	= (int)$CompanyID;
			$BookingNo	= (int)$BookingNo;
			
			$sql		=	"SELECT COUNT(*) FROM `gen_transferissue` WHERE `CompanyID` = '$CompanyID'";
			if($DateFrom != "1900-01-01")
				$sql	=	$sql." AND `BookingDate`>='$DateFrom'";
			if($DateTo != "1900-01-01")
				$sql	=	$sql." AND `BookingDate`<='$DateTo'";
			if($BookingNo != 0)
				$sql	=	$sql." AND `BookingNo`='$BookingNo'";
			
			return $this->getResultExecutingQuery($sql);
		}

		function getTransferIssueListPaged($sRec, $nRec, $DateFrom, $DateTo, $CompanyID, $BookingNo) {
			$DateFrom	= addslashes($DateFrom);
			$DateTo		= addslashes($DateTo);
			$CompanyID	= (int)$CompanyID;
			$BookingNo	= (int)$BookingNo;
					
			$sql		=	"SELECT * FROM `gen_transferissue` WHERE `CompanyID` = '$CompanyID'";
			if($DateFrom != "1900-01-01")
				$sql	=	$sql." AND `BookingDate`>='$DateFrom'";
			if($DateTo != "1900-01-01")
				$sql	=	$sql." AND `BookingDate`<='$DateTo'";
			if($BookingNo != 0)
				$sql	=	$sql." AND `BookingNo`='$BookingNo'";
				
			$sql		=	$sql." ORDER BY `BookingDate` DESC LIMIT $sRec, $nRec";

			$arr	=	array();
			
			try {
				
				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_transferissue');
				while($row = $result->fetch()) {
					$row->setCompanyName($this->getCompanyNameByCompanyID($row->getCompanyID()));
					$row->setFromStoreName($this->getStoreNameByStoreID($row->getFromStoreID()));
					$row->setToStoreName($this->getStoreNameByStoreID($row->getToStoreID()));
					$row->setDebitMotherAccountName( $this->getAccountNameByAccountID( $row->getDebitMotherAccountID() ) );
					$row->setDebitAccountName( $this->getAccountNameByAccountID( $row->getDebitAccountID() ) );
					$row->setItemList($this->getTransferIssueItemList($row->getBookingID()));
					$arr[]	= $row;
				}
				
			} catch(PDOException $e) {
				$err	= 'purchasedb getTransferIssueListPaged '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		function getNextTransferIssueNo($FinYear, $CompanyID) {
			if(strpos($FinYear, "'") !== false) return false;
			$CompanyID	= (int)$CompanyID;
			
			$maxid			=	0;
			$sql				=	"SELECT MAX(`BookingNo`) FROM `gen_transferissue` WHERE `FinYear`='$FinYear' AND `CompanyID`='$CompanyID'";

			try {
				
				$result		= $this->conn->query($sql);
				if($row 	= $result->fetch())
					$maxid 	= $row[0];
					
			} catch(PDOException $e) {
				$err	= 'purchasedb getNextTransferIssueNo '.$e->getMessage();
				_errorLog($err);
			}

			$maxid++;
			return $maxid;
		}

		function CreateTransferIssue($stcls) {
		
			$tuser	=	unserialize($_SESSION["ssEUser"]);
				
			$stcls->setBookingID($this->getNextID("gen_transferissue", "BookingID"));
			$sid	= $stcls->getBookingID();
			$stcls->setFinYear(getFinancialYear($stcls->getBookingDate()));
			$stcls->setBookingNo($this->getNextTransferIssueNo($stcls->getFinYear(), $stcls->getCompanyID()));
			
			/* Create Stock Transfer and Issue class */
			$xfrcls		= new gen_stocktransfer();
			$isscls		= new gen_issue();
			
			$fsDet		= $this->getStoreDetail($stcls->getFromStoreID());
			$tsDet		= $this->getStoreDetail($stcls->getToStoreID());
			
			$xfrcls->setStockTransferID(0);
			$xfrcls->setCompanyID($stcls->getCompanyID());
			$xfrcls->setDOT($stcls->getBookingDate('yes'));
			$xfrcls->setFromStoreID($stcls->getFromStoreID());
			$xfrcls->setToStoreID($stcls->getToStoreID());
			$xfrcls->setItemCategoryID($stcls->getItemCategoryID());
			$xfrcls->setDebitMotherAccountID($tsDet->getMotherAccountID());
			$xfrcls->setDebitAccountID($tsDet->getAccountID());
			$xfrcls->setCreditMotherAccountID($fsDet->getMotherAccountID());
			$xfrcls->setCreditAccountID($fsDet->getAccountID());
			$xfrcls->setPurpose($stcls->getPurpose());
			$xfrcls->setRelatedID($sid);
			
			$isscls->setIssueID(0);
			$isscls->setCompanyID($stcls->getCompanyID());
			$isscls->setIssueDate($stcls->getBookingDate('yes'));
			$isscls->setFinYear("");
			$isscls->setIssueNo(0);
			$isscls->setStoreID($stcls->getToStoreID());
			$isscls->setItemCategoryID($stcls->getItemCategoryID());
			$isscls->setDebitMotherAccountID($stcls->getDebitMotherAccountID());
			$isscls->setDebitAccountID($stcls->getDebitAccountID());
			$isscls->setCreditMotherAccountID($tsDet->getMotherAccountID());
			$isscls->setCreditAccountID($tsDet->getAccountID());
			$isscls->setpurpose($stcls->getPurpose());
			$isscls->setDOE(date('d-m-Y').' - '.$tuser->getUserID());			
			$isscls->setRelatedID($sid);
			
			$xiList	=	array();
			$iiList	=	array();
			$itmList	= $stcls->getItemList();
			for($i=0;$i<count($itmList);$i++) {
				$icls	=	$itmList[$i];
				
				$xicls	=	new gen_stocktransfer_items();
				$xicls->setStockTransferID(0);
				$xicls->setItemID($icls->getItemID());
				$xicls->setQuantity($icls->getQuantity());
				$xicls->setRate(0);
				$xiList[]	=	$xicls;
								
				$iicls	=	new gen_issue_items();
				$iicls->setIssueID(0);
				$iicls->setItemID($icls->getItemID());
				$iicls->setQuantity($icls->getQuantity());
				$iicls->setRemark("");
				$iiList[]	=	$iicls;
			}
			$xfrcls->setItemList($xiList);
			$isscls->setItemList($iiList);
			/* Stock Transfer and Issue class creation ends here */
			
			$xfrid	= $this->CreateStockTransfer($xfrcls);
			$issid	= $this->CreateIssue($isscls);
			
			if($xfrid == -1 || $issid == -1) {
			
				/* Something went wrong either in Transfer or in Issue */
				
				if($xfrid != -1) {
					if(!$this->deleteStockTransfer($xfrcls)) {
						/* try again */
						if(!$this->deleteStockTransfer($xfrcls)) {
							/* Give another try */
							$this->deleteStockTransfer($xfrcls);
						}
					}
				}
				
				if($issid != -1) {
					if(!$this->deleteIssue($isscls)) {
						/* try again */
						if(!$this->deleteIssue($isscls)) {
							/* Give another try */
							$this->deleteIssue($isscls);
						}
					}
				}
				
				$sid		= -1;
			
			} else {
				
				try {
				
					$this->conn->beginTransaction();
				
					$stcls->setStockTransferID($xfrid);
					$stcls->setIssueID($issid);
				
					$itmList	= $stcls->getItemList();
					for($i=0;$i<count($itmList);$i++) {
						$icls	=	$itmList[$i];
						$icls->setBookingID($sid);
					
						$sql		= $icls->getInsertSQL();
						$this->conn->exec($sql);
					
					}
				
					$sql	= $stcls->getInsertSQL();
					$this->conn->exec($sql);
			
					$this->conn->commit();
				
				} catch(Exception $er) {
				
					if(!$this->deleteStockTransfer($xfrcls)) {
						/* try again */
						if(!$this->deleteStockTransfer($xfrcls)) {
							/* Give another try */
							$this->deleteStockTransfer($xfrcls);
						}
					}
					if(!$this->deleteIssue($isscls)) {
						/* try again */
						if(!$this->deleteIssue($isscls)) {
							/* Give another try */
							$this->deleteIssue($isscls);
						}
					}
				
					$this->conn->rollBack();
					$err	= 'purchasedb CreateTransferIssue '.$er->getMessage();
					_errorLog($err);
					$sid	= -1;
				
				}
				
			}


			return $sid;
			
		}
		
		function deleteTransferIssue($stcls) {
		
			$pkey				= $stcls->getBookingID();
			$xfrid			= $stcls->getStockTransferID();
			$issid			= $stcls->getIssueID();
			$cmpid			= $stcls->getCompanyID();
			
			$xfrcls			= $this->getStockTransferDetail($xfrid);
			$isscls			= $this->getIssueDetail($issid);
			
			$ret				= true;
			
			
			$this->deleteStockTransfer($xfrcls);
			$this->deleteIssue($isscls);

			try {
			
				$this->conn->beginTransaction();
				
				$this->conn->exec("DELETE FROM `gen_transferissue_items` WHERE `BookingID`='$pkey'");
				
				$sql	= $stcls->getDeleteSQL();
				$this->conn->exec($sql);
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				$err	= 'purchasedb deleteTransferIssue '.$er->getMessage();
				_errorLog($err);
				$ret	= false;
				$this->conn->rollBack();
				
			}
				
		
			return $ret;
		}
		
		function getTransferIssueDateByTransferID($BookingID) {
			$BookingID	= (int)$BookingID;
			$sql	= "SELECT `BookingDate` FROM `gen_transferissue` WHERE `BookingID`='".$BookingID."'";
			return $this->getResultExecutingQuery($sql);
		}

		function UpdateTransferIssue($stcls) {
		
			$tuser	=	unserialize($_SESSION["ssEUser"]);
			
			$sid			= $stcls->getBookingID();
			$xfrid		= $stcls->getStockTransferID();
			$issid		= $stcls->getIssueID();			
			
			/* Create Stock Transfer and Issue class */
			$xfrcls		= new gen_stocktransfer();
			$isscls		= new gen_issue();
			
			$fsDet		= $this->getStoreDetail($stcls->getFromStoreID());
			$tsDet		= $this->getStoreDetail($stcls->getToStoreID());
			
			$xfrcls->setStockTransferID($xfrid);
			$xfrcls->setCompanyID($stcls->getCompanyID());
			$xfrcls->setDOT($stcls->getBookingDate('yes'));
			$xfrcls->setFromStoreID($stcls->getFromStoreID());
			$xfrcls->setToStoreID($stcls->getToStoreID());
			$xfrcls->setItemCategoryID($stcls->getItemCategoryID());
			$xfrcls->setDebitMotherAccountID($tsDet->getMotherAccountID());
			$xfrcls->setDebitAccountID($tsDet->getAccountID());
			$xfrcls->setCreditMotherAccountID($fsDet->getMotherAccountID());
			$xfrcls->setCreditAccountID($fsDet->getAccountID());
			$xfrcls->setPurpose($stcls->getPurpose());
			$xfrcls->setRelatedID($sid);
			
			$isscls->setIssueID($issid);
			$isscls->setCompanyID($stcls->getCompanyID());
			$isscls->setIssueDate($stcls->getBookingDate('yes'));
			$isscls->setFinYear($this->getNameByID('gen_issue', 'FinYear', 'IssueID', $issid));
			$isscls->setIssueNo($this->getNameByID('gen_issue', 'IssueNo', 'IssueID', $issid));
			$isscls->setStoreID($stcls->getToStoreID());
			$isscls->setItemCategoryID($stcls->getItemCategoryID());
			$isscls->setDebitMotherAccountID($stcls->getDebitMotherAccountID());
			$isscls->setDebitAccountID($stcls->getDebitAccountID());
			$isscls->setCreditMotherAccountID($tsDet->getMotherAccountID());
			$isscls->setCreditAccountID($tsDet->getAccountID());
			$isscls->setpurpose($stcls->getPurpose());
			$isscls->setDOE(date('d-m-Y').' - '.$tuser->getUserID());			
			$isscls->setRelatedID($sid);
			
			$xiList	=	array();
			$iiList	=	array();
			$itmList	= $stcls->getItemList();
			for($i=0;$i<count($itmList);$i++) {
				$icls	=	$itmList[$i];
				
				$xicls	=	new gen_stocktransfer_items();
				$xicls->setStockTransferID($xfrid);
				$xicls->setItemID($icls->getItemID());
				$xicls->setQuantity($icls->getQuantity());
				$xicls->setRate(0);
				$xiList[]	=	$xicls;
								
				$iicls	=	new gen_issue_items();
				$iicls->setIssueID($issid);
				$iicls->setItemID($icls->getItemID());
				$iicls->setQuantity($icls->getQuantity());
				$iicls->setRemark("");
				$iiList[]	=	$iicls;
			}
			$xfrcls->setItemList($xiList);
			$isscls->setItemList($iiList);
			/* Stock Transfer and Issue class creation ends here */			

			
			
			$xfrid	= $this->UpdateStockTransfer($xfrcls);
			$issid	= $this->UpdateIssue($isscls);

			if($xfrid == -1 || $issid == -1) {
			
				/* Something went wrong either in Transfer or in Issue */
				
				/*if($xfrid != -1) {
					$this->deleteStockTransfer($xfrcls);
				}
				
				if($issid != -1) {
					$this->deleteIssue($isscls);
				}*/
			
			} else {

				try {
			
					$this->conn->beginTransaction();
				
					$this->conn->exec("DELETE FROM `gen_transferissue_items` WHERE `BookingID`='$sid'");

					for($i=0;$i<count($itmList);$i++) {
						$icls	=	$itmList[$i];
						$icls->setBookingID($sid);
					
						$sql		= $icls->getInsertSQL();
						$this->conn->exec($sql);
					
					}				
									
					$sql	= $stcls->getUpdateSQL();
					$this->conn->exec($sql);
			
					$this->conn->commit();
				
				} catch(Exception $er) {
				
					$this->conn->rollBack();
					$err	= 'purchasedb UpdateTransferIssue '.$er->getMessage();
					_errorLog($err);
					$sid	= -1;
				
				}
				
			}


			return $sid;
			
		}
		
		function UpdateTransferIssueFirstTime($stcls) {
		
			$tuser	=	unserialize($_SESSION["ssEUser"]);
			
			$sid			= $stcls->getBookingID();		
			
			/* Create Stock Transfer and Issue class */
			$xfrcls		= new gen_stocktransfer();
			$isscls		= new gen_issue();
			
			$fsDet		= $this->getStoreDetail($stcls->getFromStoreID());
			$tsDet		= $this->getStoreDetail($stcls->getToStoreID());
			
			$xfrcls->setStockTransferID(0);
			$xfrcls->setCompanyID($stcls->getCompanyID());
			$xfrcls->setDOT($stcls->getBookingDate('yes'));
			$xfrcls->setFromStoreID($stcls->getFromStoreID());
			$xfrcls->setToStoreID($stcls->getToStoreID());
			$xfrcls->setItemCategoryID($stcls->getItemCategoryID());
			$xfrcls->setDebitMotherAccountID($tsDet->getMotherAccountID());
			$xfrcls->setDebitAccountID($tsDet->getAccountID());
			$xfrcls->setCreditMotherAccountID($fsDet->getMotherAccountID());
			$xfrcls->setCreditAccountID($fsDet->getAccountID());
			$xfrcls->setPurpose($stcls->getPurpose());
			$xfrcls->setRelatedID($sid);
			
			$isscls->setIssueID(0);
			$isscls->setCompanyID($stcls->getCompanyID());
			$isscls->setIssueDate($stcls->getBookingDate('yes'));
			$isscls->setFinYear('');
			$isscls->setIssueNo(0);
			$isscls->setStoreID($stcls->getToStoreID());
			$isscls->setItemCategoryID($stcls->getItemCategoryID());
			$isscls->setDebitMotherAccountID($stcls->getDebitMotherAccountID());
			$isscls->setDebitAccountID($stcls->getDebitAccountID());
			$isscls->setCreditMotherAccountID($tsDet->getMotherAccountID());
			$isscls->setCreditAccountID($tsDet->getAccountID());
			$isscls->setpurpose($stcls->getPurpose());
			$isscls->setDOE(date('d-m-Y').' - '.$tuser->getUserID());			
			$isscls->setRelatedID($sid);
			
			$xiList	=	array();
			$iiList	=	array();
			$itmList	= $stcls->getItemList();
			for($i=0;$i<count($itmList);$i++) {
				$icls	=	$itmList[$i];
				
				$xicls	=	new gen_stocktransfer_items();
				$xicls->setStockTransferID(0);
				$xicls->setItemID($icls->getItemID());
				$xicls->setQuantity($icls->getQuantity());
				$xicls->setRate(0);
				$xiList[]	=	$xicls;
								
				$iicls	=	new gen_issue_items();
				$iicls->setIssueID(0);
				$iicls->setItemID($icls->getItemID());
				$iicls->setQuantity($icls->getQuantity());
				$iicls->setRemark("");
				$iiList[]	=	$iicls;
			}
			$xfrcls->setItemList($xiList);
			$isscls->setItemList($iiList);
			/* Stock Transfer and Issue class creation ends here */			

			
			try {
			
				$this->conn->beginTransaction();
				
				$this->conn->exec("DELETE FROM `gen_transferissue_items` WHERE `BookingID`='$sid'");
				
				$xfrid	= $this->CreateStockTransfer($xfrcls);
				$issid	= $this->CreateIssue($isscls);
				
				$stcls->setStockTransferID($xfrid);
				$stcls->setIssueID($issid);					
				

				for($i=0;$i<count($itmList);$i++) {
					$icls	=	$itmList[$i];
					$icls->setBookingID($sid);
					
					$sql		= $icls->getInsertSQL();
					$this->conn->exec($sql);
					
				}				
									
				$sql	= $stcls->getUpdateSQL();
				$this->conn->exec($sql);
			
				$this->conn->commit();
				
			} catch(Exception $er) {
				
				$this->conn->rollBack();
				$err	= 'purchasedb UpdateTransferIssueFirstTime '.$er->getMessage();
				_errorLog($err);
				$sid	= -1;
				
			}


			return $sid;
			
		}
		
		function getTransferIssueItemList($BookingID) {
			$BookingID	= (int)$BookingID;
			$arr				=	array();
			
			try {
				
				$sql			=	"SELECT * FROM `gen_transferissue_items` WHERE `BookingID`='$BookingID'";

				$result		= $this->conn->query($sql, PDO::FETCH_CLASS, 'gen_transferissue_items');
				while($row = $result->fetch()) {
					$row->setItemName($this->getItemNameByItemID($row->getItemID()));
					$arr[]	= $row;
				}

			} catch(PDOException $e) {
				$err	= 'purchasedb getTransferIssueItemList '.$e->getMessage();
				_errorLog($err);
			}

			return $arr;
		}
		
		

		/*------------------------------------------------------------*/
		/*********************** REPORT METHODS ***********************/
		
		function getTotalImportOfGoods($CompanyID, $Date1, $Date2) {
			$CompanyID	= (int)$CompanyID;
			$Date1			= addslashes($Date1);
			$Date2			= addslashes($Date2);
			
			$sql				= "
				SELECT SUM(`a`.`Amount` - `a`.`Discount`) FROM `gen_purchase_items` `a`
				INNER JOIN `gen_purchase` `b` ON `a`.`PurchaseID`=`b`.`PurchaseID`
				INNER JOIN `gen_items` `c` ON `a`.`ItemID`=`c`.`ItemID`
				WHERE `b`.`Import` = 'YES' AND `c`.`GSTCategory`!='Service Product'
				AND `b`.`CompanyID` = '$CompanyID'
				AND `b`.`PurchaseDate` >= '$Date1' AND `b`.`PurchaseDate` <= '$Date2'
			";
			return $this->getResultExecutingQuery($sql);			
		}
		
		function getTotalImportOfServices($CompanyID, $Date1, $Date2) {
			$CompanyID	= (int)$CompanyID;
			$Date1			= addslashes($Date1);
			$Date2			= addslashes($Date2);
			
			$sql				= "
				SELECT SUM(`a`.`Amount` - `a`.`Discount`) FROM `gen_purchase_items` `a`
				INNER JOIN `gen_purchase` `b` ON `a`.`PurchaseID`=`b`.`PurchaseID`
				INNER JOIN `gen_items` `c` ON `a`.`ItemID`=`c`.`ItemID`
				WHERE `b`.`Import` = 'YES' AND `c`.`GSTCategory`='Service Product'
				AND `b`.`CompanyID` = '$CompanyID'
				AND `b`.`PurchaseDate` >= '$Date1' AND `b`.`PurchaseDate` <= '$Date2'
			";
			return $this->getResultExecutingQuery($sql);			
		}		
		
		function getInwardTaxableValueReverseCharge($CompanyID, $Date1, $Date2) {
			$CompanyID	= (int)$CompanyID;
			$Date1			= addslashes($Date1);
			$Date2			= addslashes($Date2);
			
			$sql				= "
				SELECT SUM(`a`.`Amount` - `a`.`Discount`) FROM `gen_purchase_items` `a`
				INNER JOIN `gen_purchase` `b` ON `a`.`PurchaseID`=`b`.`PurchaseID`
				INNER JOIN `gen_items` `c` ON `a`.`ItemID`=`c`.`ItemID`
				WHERE `b`.`Import` = 'NO' AND `b`.`ReverseCharge`='YES'
				AND `b`.`CompanyID` = '$CompanyID'
				AND `b`.`PurchaseDate` >= '$Date1' AND `b`.`PurchaseDate` <= '$Date2'
			";
			return $this->getResultExecutingQuery($sql);			
		}
		
		function getInwardTaxReverseCharge($CompanyID, $Date1, $Date2, $Tax) {
			$CompanyID	= (int)$CompanyID;
			$Date1			= addslashes($Date1);
			$Date2			= addslashes($Date2);
			$Tax				= addslashes($Tax);
			
			$sql				= "
				SELECT SUM(`a`.`$Tax`) FROM `gen_purchase_items` `a`
				INNER JOIN `gen_purchase` `b` ON `a`.`PurchaseID`=`b`.`PurchaseID`
				INNER JOIN `gen_items` `c` ON `a`.`ItemID`=`c`.`ItemID`
				WHERE `b`.`Import` = 'NO' AND `b`.`ReverseCharge`='YES'
				AND `b`.`CompanyID` = '$CompanyID'
				AND `b`.`PurchaseDate` >= '$Date1' AND `b`.`PurchaseDate` <= '$Date2'
			";
			return $this->getResultExecutingQuery($sql);			
		}		
		
		function getAllOtherITCTaxableValue($CompanyID, $Date1, $Date2) {
			$CompanyID	= (int)$CompanyID;
			$Date1			= addslashes($Date1);
			$Date2			= addslashes($Date2);
			
			$sql				= "
				SELECT SUM(`a`.`Amount` - `a`.`Discount`) FROM `gen_purchase_items` `a`
				INNER JOIN `gen_purchase` `b` ON `a`.`PurchaseID`=`b`.`PurchaseID`
				WHERE `b`.`Import` = 'NO' AND `b`.`ReverseCharge`='NO'
				AND `b`.`CompanyID` = '$CompanyID'
				AND `b`.`PurchaseDate` >= '$Date1' AND `b`.`PurchaseDate` <= '$Date2'
			";
			$a1			=  $this->getResultExecutingQuery($sql);
			
			$sql				= "
				SELECT SUM(`a`.`Amount` - `a`.`Discount`) FROM `gen_salereturn_items` `a`
				INNER JOIN `gen_salereturn` `b` ON `a`.`ReturnID`=`b`.`ReturnID`
				WHERE `b`.`CompanyID` = '$CompanyID'
				AND `b`.`DOR` >= '$Date1' AND `b`.`DOR` <= '$Date2'
			";
			$a2			=  $this->getResultExecutingQuery($sql);			
			
			$sql		= "SELECT SUM(`Amount`) FROM `asys_voucher_entry` WHERE `CompanyID`='$CompanyID' AND `DOV`>='$Date1' AND `DOV`<='$Date2' AND `GSTBase`='YES'";
			$a3			=  $this->getResultExecutingQuery($sql);
			
			return ($a1 + $a2 + $a3);
		}		
		
		function getAllOtherITCTax($CompanyID, $Date1, $Date2, $TaxType) {
			$CompanyID	= (int)$CompanyID;
			$Date1			= addslashes($Date1);
			$Date2			= addslashes($Date2);
			$TaxType		= addslashes($TaxType);
			
			$sql				= "
				SELECT SUM(`a`.`$TaxType`) FROM `gen_purchase_items` `a`
				INNER JOIN `gen_purchase` `b` ON `a`.`PurchaseID`=`b`.`PurchaseID`
				WHERE `b`.`Import` = 'NO' AND `b`.`ReverseCharge`='NO'
				AND `b`.`CompanyID` = '$CompanyID'
				AND `b`.`PurchaseDate` >= '$Date1' AND `b`.`PurchaseDate` <= '$Date2'
			";
			$a1			=  $this->getResultExecutingQuery($sql);
			
			$sql				= "
				SELECT SUM(`a`.`$TaxType`) FROM `gen_salereturn_items` `a`
				INNER JOIN `gen_salereturn` `b` ON `a`.`ReturnID`=`b`.`ReturnID`
				WHERE `b`.`CompanyID` = '$CompanyID'
				AND `b`.`DOR` >= '$Date1' AND `b`.`DOR` <= '$Date2'
			";
			$a2			=  $this->getResultExecutingQuery($sql);			
			
			$_cmp		= unserialize($_SESSION["ssECmp"]);
			$aid		= 0;
			if($TaxType == 'IGST')
				$aid	= $_cmp->getIGSTAccountID();
			else if($TaxType == 'CGST')
				$aid	= $_cmp->getCGSTAccountID();
			else
				$aid	= $_cmp->getSGSTAccountID();
			$sql		= "SELECT SUM(`Amount`) FROM `asys_voucher_entry` WHERE `CompanyID`='$CompanyID' AND `DOV`>='$Date1' AND `DOV`<='$Date2' AND `GST`='YES' AND `AccountID` = '$aid' AND `DrCr`='".DEBIT."'";
			$a3			=  $this->getResultExecutingQuery($sql);
			
			return ($a1 + $a2 + $a3);
		}
		
		function getAllOtherITCReverseValue($CompanyID, $Date1, $Date2) {
			$CompanyID	= (int)$CompanyID;
			$Date1			= addslashes($Date1);
			$Date2			= addslashes($Date2);
			
			$sql				= "
				SELECT SUM(`a`.`Amount` - `a`.`Discount`) FROM `gen_purchasereturn_items` `a`
				INNER JOIN `gen_purchasereturn` `b` ON `a`.`ReturnID`=`b`.`ReturnID`
				WHERE `b`.`CompanyID` = '$CompanyID'
				AND `b`.`ReturnDate` >= '$Date1' AND `b`.`ReturnDate` <= '$Date2'
			";
			$a1					=  $this->getResultExecutingQuery($sql);
			
			return $a1;
		}		
		
		function getAllOtherITCReverse($CompanyID, $Date1, $Date2, $TaxType) {
			$CompanyID	= (int)$CompanyID;
			$Date1			= addslashes($Date1);
			$Date2			= addslashes($Date2);
			$TaxType		= addslashes($TaxType);
			
			$sql				= "
				SELECT SUM(`a`.`$TaxType`) FROM `gen_purchasereturn_items` `a`
				INNER JOIN `gen_purchasereturn` `b` ON `a`.`ReturnID`=`b`.`ReturnID`
				WHERE `b`.`CompanyID` = '$CompanyID'
				AND `b`.`ReturnDate` >= '$Date1' AND `b`.`ReturnDate` <= '$Date2'
			";
			$a1					=  $this->getResultExecutingQuery($sql);
			
			return $a1;
		}
		
		function getAllOtherITCReverseValueStore($CompanyID, $Date1, $Date2, $StoreID) {
			$CompanyID	= (int)$CompanyID;
			$Date1			= addslashes($Date1);
			$Date2			= addslashes($Date2);
			$StoreID		= (int)$StoreID;
			
			$sql				= "
				SELECT SUM(`a`.`Amount` - `a`.`Discount`) FROM `gen_purchase_items` `a`
				INNER JOIN `gen_purchase` `b` ON `a`.`PurchaseID`=`b`.`PurchaseID`
				WHERE `b`.`CompanyID` = '$CompanyID'
				AND `b`.`StoreID` = '$StoreID'
				AND `b`.`PurchaseDate` >= '$Date1' AND `b`.`PurchaseDate` <= '$Date2'
			";
			$a1					=  $this->getResultExecutingQuery($sql);
			
			return $a1;
		}		
		
		function getAllOtherITCReverseStore($CompanyID, $Date1, $Date2, $TaxType, $StoreID) {
			$CompanyID	= (int)$CompanyID;
			$Date1			= addslashes($Date1);
			$Date2			= addslashes($Date2);
			$TaxType		= addslashes($TaxType);
			$StoreID		= (int)$StoreID;
			
			$sql				= "
				SELECT SUM(`a`.`$TaxType`) FROM `gen_purchase_items` `a`
				INNER JOIN `gen_purchase` `b` ON `a`.`PurchaseID`=`b`.`PurchaseID`
				WHERE `b`.`CompanyID` = '$CompanyID'
				AND `b`.`StoreID` = '$StoreID'
				AND `b`.`PurchaseDate` >= '$Date1' AND `b`.`PurchaseDate` <= '$Date2'
			";
			$a1					=  $this->getResultExecutingQuery($sql);
			
			return $a1;
		}		
		
	};
		
?>